/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(re){for(var t=[],y=0,F=re.length;y<F;y++)t[y]=be[re[y]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Bt,setPrototypeOf:zt,isFrozen:Jt,getPrototypeOf:Zt,getOwnPropertyDescriptor:ei}=Object;let{freeze:tt,seal:at,create:ti}=Object,{apply:Nt,construct:Ft}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,y,F){return t.apply(y,F)}),tt||(tt=function(t){return t}),at||(at=function(t){return t}),Ft||(Ft=function(t,y){return new t(...y)});const ii=rt(Array.prototype.forEach),jt=rt(Array.prototype.pop),bt=rt(Array.prototype.push),vt=rt(String.prototype.toLowerCase),Pt=rt(String.prototype.toString),ni=rt(String.prototype.match),ht=rt(String.prototype.replace),si=rt(String.prototype.indexOf),ri=rt(String.prototype.trim),st=rt(RegExp.prototype.test),$t=oi(TypeError);function rt(re){return function(t){for(var y=arguments.length,F=new Array(y>1?y-1:0),i=1;i<y;i++)F[i-1]=arguments[i];return Nt(re,t,F)}}function oi(re){return function(){for(var t=arguments.length,y=new Array(t),F=0;F<t;F++)y[F]=arguments[F];return Ft(re,y)}}function Be(re,t,y){var F;y=(F=y)!==null&&F!==void 0?F:vt,zt&&zt(re,null);let i=t.length;for(;i--;){let U=t[i];if(typeof U=="string"){const w=y(U);w!==U&&(Jt(t)||(t[i]=w),U=w)}re[U]=!0}return re}function gt(re){const t=ti(null);for(const[y,F]of Bt(re))t[y]=F;return t}function Dt(re,t){for(;re!==null;){const F=ei(re,t);if(F){if(F.get)return rt(F.get);if(typeof F.value=="function")return rt(F.value)}re=Zt(re)}function y(F){return console.warn("fallback value for",F),null}return y}const Ht=tt(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Ot=tt(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Tt=tt(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),li=tt(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Lt=tt(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),ai=tt(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ut=tt(["#text"]),Wt=tt(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),It=tt(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),_t=tt(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=tt(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),hi=at(/\{\{[\w\W]*|[\w\W]*\}\}/gm),ui=at(/<%[\w\W]*|[\w\W]*%>/gm),ci=at(/\${[\w\W]*}/gm),fi=at(/^data-[\-\w.\u00B7-\uFFFF]/),di=at(/^aria-[\-\w]+$/),qt=at(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),gi=at(/^(?:\w+script|data):/i),mi=at(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Vt=at(/^html$/i);var Kt=Object.freeze({__proto__:null,MUSTACHE_EXPR:hi,ERB_EXPR:ui,TMPLIT_EXPR:ci,DATA_ATTR:fi,ARIA_ATTR:di,IS_ALLOWED_URI:qt,IS_SCRIPT_OR_DATA:gi,ATTR_WHITESPACE:mi,DOCTYPE_NAME:Vt});const bi=()=>typeof window>"u"?null:window,$i=function(t,y){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let F=null;const i="data-tt-policy-suffix";y&&y.hasAttribute(i)&&(F=y.getAttribute(i));const U="dompurify"+(F?"#"+F:"");try{return t.createPolicy(U,{createHTML(w){return w},createScriptURL(w){return w}})}catch{return console.warn("TrustedTypes policy "+U+" could not be created."),null}};function Qt(){let re=arguments.length>0&&arguments[0]!==void 0?arguments[0]:bi();const t=Le=>Qt(Le);if(t.version="3.0.5",t.removed=[],!re||!re.document||re.document.nodeType!==9)return t.isSupported=!1,t;const y=re.document,F=y.currentScript;let{document:i}=re;const{DocumentFragment:U,HTMLTemplateElement:w,Node:D,Element:h,NodeFilter:f,NamedNodeMap:d=re.NamedNodeMap||re.MozNamedAttrMap,HTMLFormElement:T,DOMParser:s,trustedTypes:a}=re,e=h.prototype,u=Dt(e,"cloneNode"),l=Dt(e,"nextSibling"),m=Dt(e,"childNodes"),n=Dt(e,"parentNode");if(typeof w=="function"){const Le=i.createElement("template");Le.content&&Le.content.ownerDocument&&(i=Le.content.ownerDocument)}let r,$="";const{implementation:c,createNodeIterator:o,createDocumentFragment:S,getElementsByTagName:j}=i,{importNode:M}=y;let b={};t.isSupported=typeof Bt=="function"&&typeof n=="function"&&c&&c.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:v,ERB_EXPR:B,TMPLIT_EXPR:z,DATA_ATTR:W,ARIA_ATTR:I,IS_SCRIPT_OR_DATA:N,ATTR_WHITESPACE:J}=Kt;let{IS_ALLOWED_URI:ee}=Kt,ne=null;const ue=Be({},[...Ht,...Ot,...Tt,...Lt,...Ut]);let le=null;const oe=Be({},[...Wt,...It,..._t,...yt]);let me=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Ce=null,Te=null,Pe=!0,de=!0,ie=!1,fe=!0,Y=!1,_=!1,G=!1,E=!1,K=!1,g=!1,p=!1,V=!0,L=!1;const P="user-content-";let O=!0,q=!1,C={},R=null;const A=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let k=null;const H=Be({},["audio","video","img","source","image","track"]);let Q=null;const te=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),se="http://www.w3.org/1998/Math/MathML",ge="http://www.w3.org/2000/svg",we="http://www.w3.org/1999/xhtml";let Ne=we,Ae=!1,ve=null;const Ie=Be({},[se,ge,we],Pt);let Oe;const qe=["application/xhtml+xml","text/html"],ze="text/html";let Me,Ge=null;const Z=i.createElement("form"),ae=function(ce){return ce instanceof RegExp||ce instanceof Function},pe=function(ce){if(!(Ge&&Ge===ce)){if((!ce||typeof ce!="object")&&(ce={}),ce=gt(ce),Oe=qe.indexOf(ce.PARSER_MEDIA_TYPE)===-1?Oe=ze:Oe=ce.PARSER_MEDIA_TYPE,Me=Oe==="application/xhtml+xml"?Pt:vt,ne="ALLOWED_TAGS"in ce?Be({},ce.ALLOWED_TAGS,Me):ue,le="ALLOWED_ATTR"in ce?Be({},ce.ALLOWED_ATTR,Me):oe,ve="ALLOWED_NAMESPACES"in ce?Be({},ce.ALLOWED_NAMESPACES,Pt):Ie,Q="ADD_URI_SAFE_ATTR"in ce?Be(gt(te),ce.ADD_URI_SAFE_ATTR,Me):te,k="ADD_DATA_URI_TAGS"in ce?Be(gt(H),ce.ADD_DATA_URI_TAGS,Me):H,R="FORBID_CONTENTS"in ce?Be({},ce.FORBID_CONTENTS,Me):A,Ce="FORBID_TAGS"in ce?Be({},ce.FORBID_TAGS,Me):{},Te="FORBID_ATTR"in ce?Be({},ce.FORBID_ATTR,Me):{},C="USE_PROFILES"in ce?ce.USE_PROFILES:!1,Pe=ce.ALLOW_ARIA_ATTR!==!1,de=ce.ALLOW_DATA_ATTR!==!1,ie=ce.ALLOW_UNKNOWN_PROTOCOLS||!1,fe=ce.ALLOW_SELF_CLOSE_IN_ATTR!==!1,Y=ce.SAFE_FOR_TEMPLATES||!1,_=ce.WHOLE_DOCUMENT||!1,K=ce.RETURN_DOM||!1,g=ce.RETURN_DOM_FRAGMENT||!1,p=ce.RETURN_TRUSTED_TYPE||!1,E=ce.FORCE_BODY||!1,V=ce.SANITIZE_DOM!==!1,L=ce.SANITIZE_NAMED_PROPS||!1,O=ce.KEEP_CONTENT!==!1,q=ce.IN_PLACE||!1,ee=ce.ALLOWED_URI_REGEXP||qt,Ne=ce.NAMESPACE||we,me=ce.CUSTOM_ELEMENT_HANDLING||{},ce.CUSTOM_ELEMENT_HANDLING&&ae(ce.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(me.tagNameCheck=ce.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ce.CUSTOM_ELEMENT_HANDLING&&ae(ce.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(me.attributeNameCheck=ce.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ce.CUSTOM_ELEMENT_HANDLING&&typeof ce.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(me.allowCustomizedBuiltInElements=ce.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),Y&&(de=!1),g&&(K=!0),C&&(ne=Be({},[...Ut]),le=[],C.html===!0&&(Be(ne,Ht),Be(le,Wt)),C.svg===!0&&(Be(ne,Ot),Be(le,It),Be(le,yt)),C.svgFilters===!0&&(Be(ne,Tt),Be(le,It),Be(le,yt)),C.mathMl===!0&&(Be(ne,Lt),Be(le,_t),Be(le,yt))),ce.ADD_TAGS&&(ne===ue&&(ne=gt(ne)),Be(ne,ce.ADD_TAGS,Me)),ce.ADD_ATTR&&(le===oe&&(le=gt(le)),Be(le,ce.ADD_ATTR,Me)),ce.ADD_URI_SAFE_ATTR&&Be(Q,ce.ADD_URI_SAFE_ATTR,Me),ce.FORBID_CONTENTS&&(R===A&&(R=gt(R)),Be(R,ce.FORBID_CONTENTS,Me)),O&&(ne["#text"]=!0),_&&Be(ne,["html","head","body"]),ne.table&&(Be(ne,["tbody"]),delete Ce.tbody),ce.TRUSTED_TYPES_POLICY){if(typeof ce.TRUSTED_TYPES_POLICY.createHTML!="function")throw $t('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ce.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw $t('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');r=ce.TRUSTED_TYPES_POLICY,$=r.createHTML("")}else r===void 0&&(r=$i(a,F)),r!==null&&typeof $=="string"&&($=r.createHTML(""));tt&&tt(ce),Ge=ce}},De=Be({},["mi","mo","mn","ms","mtext"]),Se=Be({},["foreignobject","desc","title","annotation-xml"]),Re=Be({},["title","style","font","a","script"]),je=Be({},Ot);Be(je,Tt),Be(je,li);const Xe=Be({},Lt);Be(Xe,ai);const Qe=function(ce){let ye=n(ce);(!ye||!ye.tagName)&&(ye={namespaceURI:Ne,tagName:"template"});const Fe=vt(ce.tagName),_e=vt(ye.tagName);return ve[ce.namespaceURI]?ce.namespaceURI===ge?ye.namespaceURI===we?Fe==="svg":ye.namespaceURI===se?Fe==="svg"&&(_e==="annotation-xml"||De[_e]):!!je[Fe]:ce.namespaceURI===se?ye.namespaceURI===we?Fe==="math":ye.namespaceURI===ge?Fe==="math"&&Se[_e]:!!Xe[Fe]:ce.namespaceURI===we?ye.namespaceURI===ge&&!Se[_e]||ye.namespaceURI===se&&!De[_e]?!1:!Xe[Fe]&&(Re[Fe]||!je[Fe]):!!(Oe==="application/xhtml+xml"&&ve[ce.namespaceURI]):!1},Ve=function(ce){bt(t.removed,{element:ce});try{ce.parentNode.removeChild(ce)}catch{ce.remove()}},We=function(ce,ye){try{bt(t.removed,{attribute:ye.getAttributeNode(ce),from:ye})}catch{bt(t.removed,{attribute:null,from:ye})}if(ye.removeAttribute(ce),ce==="is"&&!le[ce])if(K||g)try{Ve(ye)}catch{}else try{ye.setAttribute(ce,"")}catch{}},et=function(ce){let ye,Fe;if(E)ce="<remove></remove>"+ce;else{const nt=ni(ce,/^[\r\n\t ]+/);Fe=nt&&nt[0]}Oe==="application/xhtml+xml"&&Ne===we&&(ce='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ce+"</body></html>");const _e=r?r.createHTML(ce):ce;if(Ne===we)try{ye=new s().parseFromString(_e,Oe)}catch{}if(!ye||!ye.documentElement){ye=c.createDocument(Ne,"template",null);try{ye.documentElement.innerHTML=Ae?$:_e}catch{}}const Je=ye.body||ye.documentElement;return ce&&Fe&&Je.insertBefore(i.createTextNode(Fe),Je.childNodes[0]||null),Ne===we?j.call(ye,_?"html":"body")[0]:_?ye.documentElement:Je},it=function(ce){return o.call(ce.ownerDocument||ce,ce,f.SHOW_ELEMENT|f.SHOW_COMMENT|f.SHOW_TEXT,null,!1)},ft=function(ce){return ce instanceof T&&(typeof ce.nodeName!="string"||typeof ce.textContent!="string"||typeof ce.removeChild!="function"||!(ce.attributes instanceof d)||typeof ce.removeAttribute!="function"||typeof ce.setAttribute!="function"||typeof ce.namespaceURI!="string"||typeof ce.insertBefore!="function"||typeof ce.hasChildNodes!="function")},ut=function(ce){return typeof D=="object"?ce instanceof D:ce&&typeof ce=="object"&&typeof ce.nodeType=="number"&&typeof ce.nodeName=="string"},ct=function(ce,ye,Fe){b[ce]&&ii(b[ce],_e=>{_e.call(t,ye,Fe,Ge)})},Et=function(ce){let ye;if(ct("beforeSanitizeElements",ce,null),ft(ce))return Ve(ce),!0;const Fe=Me(ce.nodeName);if(ct("uponSanitizeElement",ce,{tagName:Fe,allowedTags:ne}),ce.hasChildNodes()&&!ut(ce.firstElementChild)&&(!ut(ce.content)||!ut(ce.content.firstElementChild))&&st(/<[/\w]/g,ce.innerHTML)&&st(/<[/\w]/g,ce.textContent))return Ve(ce),!0;if(!ne[Fe]||Ce[Fe]){if(!Ce[Fe]&&kt(Fe)&&(me.tagNameCheck instanceof RegExp&&st(me.tagNameCheck,Fe)||me.tagNameCheck instanceof Function&&me.tagNameCheck(Fe)))return!1;if(O&&!R[Fe]){const _e=n(ce)||ce.parentNode,Je=m(ce)||ce.childNodes;if(Je&&_e){const nt=Je.length;for(let Ke=nt-1;Ke>=0;--Ke)_e.insertBefore(u(Je[Ke],!0),l(ce))}}return Ve(ce),!0}return ce instanceof h&&!Qe(ce)||(Fe==="noscript"||Fe==="noembed"||Fe==="noframes")&&st(/<\/no(script|embed|frames)/i,ce.innerHTML)?(Ve(ce),!0):(Y&&ce.nodeType===3&&(ye=ce.textContent,ye=ht(ye,v," "),ye=ht(ye,B," "),ye=ht(ye,z," "),ce.textContent!==ye&&(bt(t.removed,{element:ce.cloneNode()}),ce.textContent=ye)),ct("afterSanitizeElements",ce,null),!1)},At=function(ce,ye,Fe){if(V&&(ye==="id"||ye==="name")&&(Fe in i||Fe in Z))return!1;if(!(de&&!Te[ye]&&st(W,ye))){if(!(Pe&&st(I,ye))){if(!le[ye]||Te[ye]){if(!(kt(ce)&&(me.tagNameCheck instanceof RegExp&&st(me.tagNameCheck,ce)||me.tagNameCheck instanceof Function&&me.tagNameCheck(ce))&&(me.attributeNameCheck instanceof RegExp&&st(me.attributeNameCheck,ye)||me.attributeNameCheck instanceof Function&&me.attributeNameCheck(ye))||ye==="is"&&me.allowCustomizedBuiltInElements&&(me.tagNameCheck instanceof RegExp&&st(me.tagNameCheck,Fe)||me.tagNameCheck instanceof Function&&me.tagNameCheck(Fe))))return!1}else if(!Q[ye]){if(!st(ee,ht(Fe,J,""))){if(!((ye==="src"||ye==="xlink:href"||ye==="href")&&ce!=="script"&&si(Fe,"data:")===0&&k[ce])){if(!(ie&&!st(N,ht(Fe,J,"")))){if(Fe)return!1}}}}}}return!0},kt=function(ce){return ce.indexOf("-")>0},Ct=function(ce){let ye,Fe,_e,Je;ct("beforeSanitizeAttributes",ce,null);const{attributes:nt}=ce;if(!nt)return;const Ke={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:le};for(Je=nt.length;Je--;){ye=nt[Je];const{name:ot,namespaceURI:pt}=ye;if(Fe=ot==="value"?ye.value:ri(ye.value),_e=Me(ot),Ke.attrName=_e,Ke.attrValue=Fe,Ke.keepAttr=!0,Ke.forceKeepAttr=void 0,ct("uponSanitizeAttribute",ce,Ke),Fe=Ke.attrValue,Ke.forceKeepAttr||(We(ot,ce),!Ke.keepAttr))continue;if(!fe&&st(/\/>/i,Fe)){We(ot,ce);continue}Y&&(Fe=ht(Fe,v," "),Fe=ht(Fe,B," "),Fe=ht(Fe,z," "));const dt=Me(ce.nodeName);if(At(dt,_e,Fe)){if(L&&(_e==="id"||_e==="name")&&(We(ot,ce),Fe=P+Fe),r&&typeof a=="object"&&typeof a.getAttributeType=="function"&&!pt)switch(a.getAttributeType(dt,_e)){case"TrustedHTML":{Fe=r.createHTML(Fe);break}case"TrustedScriptURL":{Fe=r.createScriptURL(Fe);break}}try{pt?ce.setAttributeNS(pt,ot,Fe):ce.setAttribute(ot,Fe),jt(t.removed)}catch{}}}ct("afterSanitizeAttributes",ce,null)},Mt=function Le(ce){let ye;const Fe=it(ce);for(ct("beforeSanitizeShadowDOM",ce,null);ye=Fe.nextNode();)ct("uponSanitizeShadowNode",ye,null),!Et(ye)&&(ye.content instanceof U&&Le(ye.content),Ct(ye));ct("afterSanitizeShadowDOM",ce,null)};return t.sanitize=function(Le){let ce=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ye,Fe,_e,Je;if(Ae=!Le,Ae&&(Le="<!-->"),typeof Le!="string"&&!ut(Le))if(typeof Le.toString=="function"){if(Le=Le.toString(),typeof Le!="string")throw $t("dirty is not a string, aborting")}else throw $t("toString is not a function");if(!t.isSupported)return Le;if(G||pe(ce),t.removed=[],typeof Le=="string"&&(q=!1),q){if(Le.nodeName){const ot=Me(Le.nodeName);if(!ne[ot]||Ce[ot])throw $t("root node is forbidden and cannot be sanitized in-place")}}else if(Le instanceof D)ye=et("<!---->"),Fe=ye.ownerDocument.importNode(Le,!0),Fe.nodeType===1&&Fe.nodeName==="BODY"||Fe.nodeName==="HTML"?ye=Fe:ye.appendChild(Fe);else{if(!K&&!Y&&!_&&Le.indexOf("<")===-1)return r&&p?r.createHTML(Le):Le;if(ye=et(Le),!ye)return K?null:p?$:""}ye&&E&&Ve(ye.firstChild);const nt=it(q?Le:ye);for(;_e=nt.nextNode();)Et(_e)||(_e.content instanceof U&&Mt(_e.content),Ct(_e));if(q)return Le;if(K){if(g)for(Je=S.call(ye.ownerDocument);ye.firstChild;)Je.appendChild(ye.firstChild);else Je=ye;return(le.shadowroot||le.shadowrootmode)&&(Je=M.call(y,Je,!0)),Je}let Ke=_?ye.outerHTML:ye.innerHTML;return _&&ne["!doctype"]&&ye.ownerDocument&&ye.ownerDocument.doctype&&ye.ownerDocument.doctype.name&&st(Vt,ye.ownerDocument.doctype.name)&&(Ke="<!DOCTYPE "+ye.ownerDocument.doctype.name+`>
`+Ke),Y&&(Ke=ht(Ke,v," "),Ke=ht(Ke,B," "),Ke=ht(Ke,z," ")),r&&p?r.createHTML(Ke):Ke},t.setConfig=function(Le){pe(Le),G=!0},t.clearConfig=function(){Ge=null,G=!1},t.isValidAttribute=function(Le,ce,ye){Ge||pe({});const Fe=Me(Le),_e=Me(ce);return At(Fe,_e,ye)},t.addHook=function(Le,ce){typeof ce=="function"&&(b[Le]=b[Le]||[],bt(b[Le],ce))},t.removeHook=function(Le){if(b[Le])return jt(b[Le])},t.removeHooks=function(Le){b[Le]&&(b[Le]=[])},t.removeAllHooks=function(){b={}},t}var pi=Qt();define("vs/base/browser/dompurify/dompurify",function(){return pi}),define(be[40],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4P=t.$3P=void 0;class y{constructor(w){this.domNode=w,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(w){const D=F(w);this.a!==D&&(this.a=D,this.domNode.style.maxWidth=this.a)}setWidth(w){const D=F(w);this.b!==D&&(this.b=D,this.domNode.style.width=this.b)}setHeight(w){const D=F(w);this.c!==D&&(this.c=D,this.domNode.style.height=this.c)}setTop(w){const D=F(w);this.d!==D&&(this.d=D,this.domNode.style.top=this.d)}setLeft(w){const D=F(w);this.e!==D&&(this.e=D,this.domNode.style.left=this.e)}setBottom(w){const D=F(w);this.f!==D&&(this.f=D,this.domNode.style.bottom=this.f)}setRight(w){const D=F(w);this.g!==D&&(this.g=D,this.domNode.style.right=this.g)}setPaddingTop(w){const D=F(w);this.h!==D&&(this.h=D,this.domNode.style.paddingTop=this.h)}setPaddingLeft(w){const D=F(w);this.i!==D&&(this.i=D,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(w){const D=F(w);this.j!==D&&(this.j=D,this.domNode.style.paddingBottom=this.j)}setPaddingRight(w){const D=F(w);this.k!==D&&(this.k=D,this.domNode.style.paddingRight=this.k)}setFontFamily(w){this.l!==w&&(this.l=w,this.domNode.style.fontFamily=this.l)}setFontWeight(w){this.m!==w&&(this.m=w,this.domNode.style.fontWeight=this.m)}setFontSize(w){const D=F(w);this.n!==D&&(this.n=D,this.domNode.style.fontSize=this.n)}setFontStyle(w){this.o!==w&&(this.o=w,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(w){this.p!==w&&(this.p=w,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(w){this.q!==w&&(this.q=w,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(w){this.r!==w&&(this.r=w,this.domNode.style.textDecoration=this.r)}setLineHeight(w){const D=F(w);this.s!==D&&(this.s=D,this.domNode.style.lineHeight=this.s)}setLetterSpacing(w){const D=F(w);this.t!==D&&(this.t=D,this.domNode.style.letterSpacing=this.t)}setClassName(w){this.u!==w&&(this.u=w,this.domNode.className=this.u)}toggleClassName(w,D){this.domNode.classList.toggle(w,D),this.u=this.domNode.className}setDisplay(w){this.v!==w&&(this.v=w,this.domNode.style.display=this.v)}setPosition(w){this.w!==w&&(this.w=w,this.domNode.style.position=this.w)}setVisibility(w){this.x!==w&&(this.x=w,this.domNode.style.visibility=this.x)}setColor(w){this.y!==w&&(this.y=w,this.domNode.style.color=this.y)}setBackgroundColor(w){this.z!==w&&(this.z=w,this.domNode.style.backgroundColor=this.z)}setLayerHinting(w){this.A!==w&&(this.A=w,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(w){this.C!==w&&(this.C=w,this.domNode.style.boxShadow=w)}setContain(w){this.B!==w&&(this.B=w,this.domNode.style.contain=this.B)}setAttribute(w,D){this.domNode.setAttribute(w,D)}removeAttribute(w){this.domNode.removeAttribute(w)}appendChild(w){this.domNode.appendChild(w.domNode)}removeChild(w){this.domNode.removeChild(w.domNode)}}t.$3P=y;function F(U){return typeof U=="number"?`${U}px`:U}function i(U){return new y(U)}t.$4P=i}),define(be[67],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tO=t.$sO=void 0;let y=!1,F=null;function i(h){if(!h.parent||h.parent===h)return null;try{const f=h.location,d=h.parent.location;if(f.origin!=="null"&&d.origin!=="null"&&f.origin!==d.origin)return y=!0,null}catch{return y=!0,null}return h.parent}class U{static getSameOriginWindowChain(){if(!F){F=[];let f=window,d;do d=i(f),d?F.push({window:f,iframeElement:f.frameElement||null}):F.push({window:f,iframeElement:null}),f=d;while(f)}return F.slice(0)}static hasDifferentOriginAncestor(){return F||this.getSameOriginWindowChain(),y}static getPositionOfChildWindowRelativeToAncestorWindow(f,d){if(!d||f===d)return{top:0,left:0};let T=0,s=0;const a=this.getSameOriginWindowChain();for(const e of a){if(T+=e.window.scrollY,s+=e.window.scrollX,e.window===d||!e.iframeElement)break;const u=e.iframeElement.getBoundingClientRect();T+=u.top,s+=u.left}return{top:T,left:s}}}t.$sO=U;async function w(h,f){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const d=JSON.stringify({parentOrigin:h,salt:f}),s=new TextEncoder().encode(d),a=await crypto.subtle.digest("sha-256",s);return D(a)}t.$tO=w;function D(h){const d=Array.from(new Uint8Array(h)).map(T=>T.toString(16).padStart(2,"0")).join("");return BigInt(`0x${d}`).toString(32).padStart(52,"0")}}),define(be[68],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AQ=t.$zQ=t.$yQ=t.ListDragOverEffect=void 0;var y;(function(U){U[U.Copy=0]="Copy",U[U.Move=1]="Move"})(y||(t.ListDragOverEffect=y={})),t.$yQ={reject(){return{accept:!1}},accept(){return{accept:!0}}};class F extends Error{constructor(w,D){super(`ListError [${w}] ${D}`)}}t.$zQ=F;class i{constructor(){this.c=new WeakMap}getHeight(w){return this.c.get(w)??this.d(w)}setDynamicHeight(w,D){D>0&&this.c.set(w,D)}}t.$AQ=i}),define(be[69],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xQ=void 0;class y{constructor(i){this.a=i}splice(i,U,w){this.a.forEach(D=>D.splice(i,U,w))}}t.$xQ=y}),define(be[41],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9P=void 0;const y=20;class F{constructor(U,w,D,h,f,d){this.a=Math.round(w),this.b=Math.round(D),this.c=Math.round(U),this.d=h,this.e=f,this.f=d,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new F(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(U){const w=Math.round(U);return this.d!==w?(this.d=w,this.m(),!0):!1}setScrollSize(U){const w=Math.round(U);return this.e!==w?(this.e=w,this.m(),!0):!1}setScrollPosition(U){const w=Math.round(U);return this.f!==w?(this.f=w,this.m(),!0):!1}setScrollbarSize(U){this.a=Math.round(U)}setOppositeScrollbarSize(U){this.b=Math.round(U)}static l(U,w,D,h,f){const d=Math.max(0,D-U),T=Math.max(0,d-2*w),s=h>0&&h>D;if(!s)return{computedAvailableSize:Math.round(d),computedIsNeeded:s,computedSliderSize:Math.round(T),computedSliderRatio:0,computedSliderPosition:0};const a=Math.round(Math.max(y,Math.floor(D*T/h))),e=(T-a)/(h-D),u=f*e;return{computedAvailableSize:Math.round(d),computedIsNeeded:s,computedSliderSize:Math.round(a),computedSliderRatio:e,computedSliderPosition:Math.round(u)}}m(){const U=F.l(this.b,this.c,this.d,this.e,this.f);this.g=U.computedAvailableSize,this.h=U.computedIsNeeded,this.i=U.computedSliderSize,this.j=U.computedSliderRatio,this.k=U.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(U){if(!this.h)return 0;const w=U-this.c-this.i/2;return Math.round(w/this.j)}getDesiredScrollPositionFromOffsetPaged(U){if(!this.h)return 0;const w=U-this.c;let D=this.f;return w<this.k?D-=this.d:D+=this.d,D}getDesiredScrollPositionFromDelta(U){if(!this.h)return 0;const w=this.k+U;return Math.round(w/this.j)}}t.$9P=F}),define(be[24],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uS=t.$tS=t.$sS=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var y;(function(h){h[h.Hidden=0]="Hidden",h[h.Visible=1]="Visible",h[h.Recurse=2]="Recurse"})(y||(t.TreeVisibility=y={}));var F;(function(h){h[h.Expanded=0]="Expanded",h[h.Collapsed=1]="Collapsed",h[h.PreserveOrExpanded=2]="PreserveOrExpanded",h[h.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(F||(t.ObjectTreeElementCollapseState=F={}));var i;(function(h){h[h.Unknown=0]="Unknown",h[h.Twistie=1]="Twistie",h[h.Element=2]="Element",h[h.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var U;(function(h){h[h.Down=0]="Down",h[h.Up=1]="Up"})(U||(t.TreeDragOverBubble=U={})),t.$sS={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(h=!1){return{accept:!0,bubble:0,autoExpand:h}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(h=!1){return{accept:!0,bubble:0,effect:0,autoExpand:h}}};class w extends Error{constructor(f,d){super(`TreeError [${f}] ${d}`)}}t.$tS=w;class D{constructor(f){this.a=f,this.b=new WeakMap}map(f){let d=this.b.get(f);return d||(d=this.a(f),this.b.set(f,d)),d}}t.$uS=D}),define(be[70],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function y(u,l,m){const n=F(u,l);if(n!==-1)return u[n]}t.$fb=y;function F(u,l,m=u.length-1){for(let n=m;n>=0;n--){const r=u[n];if(l(r))return n}return-1}t.$gb=F;function i(u,l){const m=U(u,l);return m===-1?void 0:u[m]}t.$hb=i;function U(u,l,m=0,n=u.length){let r=m,$=n;for(;r<$;){const c=Math.floor((r+$)/2);l(u[c])?r=c+1:$=c}return r-1}t.$ib=U;function w(u,l){const m=D(u,l);return m===u.length?void 0:u[m]}t.$jb=w;function D(u,l,m=0,n=u.length){let r=m,$=n;for(;r<$;){const c=Math.floor((r+$)/2);l(u[c])?$=c:r=c+1}return r}t.$kb=D;function h(u,l,m=0,n=u.length){const r=D(u,l,m,n);return r===u.length?-1:r}t.$lb=h;class f{static{this.assertInvariants=!1}constructor(l){this.e=l,this.c=0}findLastMonotonous(l){if(f.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!l(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=l}const m=U(this.e,l,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}t.$mb=f;function d(u,l){if(u.length===0)return;let m=u[0];for(let n=1;n<u.length;n++){const r=u[n];l(r,m)>0&&(m=r)}return m}t.$nb=d;function T(u,l){if(u.length===0)return;let m=u[0];for(let n=1;n<u.length;n++){const r=u[n];l(r,m)>=0&&(m=r)}return m}t.$ob=T;function s(u,l){return d(u,(m,n)=>-l(m,n))}t.$pb=s;function a(u,l){if(u.length===0)return-1;let m=0;for(let n=1;n<u.length;n++){const r=u[n];l(r,u[m])>0&&(m=n)}return m}t.$qb=a;function e(u,l){for(const m of u){const n=l(m);if(n!==void 0)return n}}t.$rb=e}),define(be[71],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$M=t.$L=t.$K=t.$J=void 0;function y(w,D){const h=Object.create(null);for(const f of w){const d=D(f);let T=h[d];T||(T=h[d]=[]),T.push(f)}return h}t.$J=y;function F(w,D){const h=[],f=[];for(const d of w)D.has(d)||h.push(d);for(const d of D)w.has(d)||f.push(d);return{removed:h,added:f}}t.$K=F;function i(w,D){const h=[],f=[];for(const[d,T]of w)D.has(d)||h.push(T);for(const[d,T]of D)w.has(d)||f.push(T);return{removed:h,added:f}}t.$L=i;function U(w,D){const h=new Set;for(const f of D)w.has(f)&&h.add(f);return h}t.$M=U}),define(be[72],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Us=t.$Ts=t.$Ss=t.$Rs=void 0;function y(D,h){const f=Math.pow(10,h);return Math.round(D*f)/f}class F{constructor(h,f,d,T=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=y(Math.max(Math.min(1,T),0),3)}static equals(h,f){return h.r===f.r&&h.g===f.g&&h.b===f.b&&h.a===f.a}}t.$Rs=F;class i{constructor(h,f,d,T){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=y(Math.max(Math.min(1,f),0),3),this.l=y(Math.max(Math.min(1,d),0),3),this.a=y(Math.max(Math.min(1,T),0),3)}static equals(h,f){return h.h===f.h&&h.s===f.s&&h.l===f.l&&h.a===f.a}static fromRGBA(h){const f=h.r/255,d=h.g/255,T=h.b/255,s=h.a,a=Math.max(f,d,T),e=Math.min(f,d,T);let u=0,l=0;const m=(e+a)/2,n=a-e;if(n>0){switch(l=Math.min(m<=.5?n/(2*m):n/(2-2*m),1),a){case f:u=(d-T)/n+(d<T?6:0);break;case d:u=(T-f)/n+2;break;case T:u=(f-d)/n+4;break}u*=60,u=Math.round(u)}return new i(u,l,m,s)}static i(h,f,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?h+(f-h)*6*d:d<1/2?f:d<2/3?h+(f-h)*(2/3-d)*6:h}static toRGBA(h){const f=h.h/360,{s:d,l:T,a:s}=h;let a,e,u;if(d===0)a=e=u=T;else{const l=T<.5?T*(1+d):T+d-T*d,m=2*T-l;a=i.i(m,l,f+1/3),e=i.i(m,l,f),u=i.i(m,l,f-1/3)}return new F(Math.round(a*255),Math.round(e*255),Math.round(u*255),s)}}t.$Ss=i;class U{constructor(h,f,d,T){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=y(Math.max(Math.min(1,f),0),3),this.v=y(Math.max(Math.min(1,d),0),3),this.a=y(Math.max(Math.min(1,T),0),3)}static equals(h,f){return h.h===f.h&&h.s===f.s&&h.v===f.v&&h.a===f.a}static fromRGBA(h){const f=h.r/255,d=h.g/255,T=h.b/255,s=Math.max(f,d,T),a=Math.min(f,d,T),e=s-a,u=s===0?0:e/s;let l;return e===0?l=0:s===f?l=((d-T)/e%6+6)%6:s===d?l=(T-f)/e+2:l=(f-d)/e+4,new U(Math.round(l*60),u,s,h.a)}static toRGBA(h){const{h:f,s:d,v:T,a:s}=h,a=T*d,e=a*(1-Math.abs(f/60%2-1)),u=T-a;let[l,m,n]=[0,0,0];return f<60?(l=a,m=e):f<120?(l=e,m=a):f<180?(m=a,n=e):f<240?(m=e,n=a):f<300?(l=e,n=a):f<=360&&(l=a,n=e),l=Math.round((l+u)*255),m=Math.round((m+u)*255),n=Math.round((n+u)*255),new F(l,m,n,s)}}t.$Ts=U;class w{static fromHex(h){return w.Format.CSS.parseHex(h)||w.red}static equals(h,f){return!h&&!f?!0:!h||!f?!1:h.equals(f)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:U.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof F)this.rgba=h;else if(h instanceof i)this.i=h,this.rgba=i.toRGBA(h);else if(h instanceof U)this.j=h,this.rgba=U.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&F.equals(this.rgba,h.rgba)&&i.equals(this.hsla,h.hsla)&&U.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=w.k(this.rgba.r),f=w.k(this.rgba.g),d=w.k(this.rgba.b),T=.2126*h+.7152*f+.0722*d;return y(T,4)}static k(h){const f=h/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(h){const f=this.getRelativeLuminance(),d=h.getRelativeLuminance();return f>d?(f+.05)/(d+.05):(d+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const f=this.getRelativeLuminance(),d=h.getRelativeLuminance();return f>d}isDarkerThan(h){const f=this.getRelativeLuminance(),d=h.getRelativeLuminance();return f<d}lighten(h){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:f,g:d,b:T,a:s}=this.rgba;return new w(new F(f,d,T,s*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new F(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const f=h.rgba,d=this.rgba.a,T=f.a,s=d+T*(1-d);if(s<1e-6)return w.transparent;const a=this.rgba.r*d/s+f.r*T*(1-d)/s,e=this.rgba.g*d/s+f.g*T*(1-d)/s,u=this.rgba.b*d/s+f.b*T*(1-d)/s;return new w(new F(a,e,u,s))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:f,g:d,b:T,a:s}=this.rgba;return new w(new F(h.rgba.r-s*(h.rgba.r-f),h.rgba.g-s*(h.rgba.g-d),h.rgba.b-s*(h.rgba.b-T),1))}flatten(...h){const f=h.reduceRight((d,T)=>w.o(T,d));return w.o(this,f)}static o(h,f){const d=1-h.rgba.a;return new w(new F(d*f.rgba.r+h.rgba.a*h.rgba.r,d*f.rgba.g+h.rgba.a*h.rgba.g,d*f.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=w.Format.CSS.format(this)),this.u}static getLighterColor(h,f,d){if(h.isLighterThan(f))return h;d=d||.5;const T=h.getRelativeLuminance(),s=f.getRelativeLuminance();return d=d*(s-T)/s,h.lighten(d)}static getDarkerColor(h,f,d){if(h.isDarkerThan(f))return h;d=d||.5;const T=h.getRelativeLuminance(),s=f.getRelativeLuminance();return d=d*(T-s)/T,h.darken(d)}static{this.white=new w(new F(255,255,255,1))}static{this.black=new w(new F(0,0,0,1))}static{this.red=new w(new F(255,0,0,1))}static{this.blue=new w(new F(0,0,255,1))}static{this.green=new w(new F(0,255,0,1))}static{this.cyan=new w(new F(0,255,255,1))}static{this.lightgrey=new w(new F(211,211,211,1))}static{this.transparent=new w(new F(0,0,0,0))}}t.$Us=w,function(D){let h;(function(f){let d;(function(T){function s(o){return o.rgba.a===1?`rgb(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b})`:D.Format.CSS.formatRGBA(o)}T.formatRGB=s;function a(o){return`rgba(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b}, ${+o.rgba.a.toFixed(2)})`}T.formatRGBA=a;function e(o){return o.hsla.a===1?`hsl(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%)`:D.Format.CSS.formatHSLA(o)}T.formatHSL=e;function u(o){return`hsla(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%, ${o.hsla.a.toFixed(2)})`}T.formatHSLA=u;function l(o){const S=o.toString(16);return S.length!==2?"0"+S:S}function m(o){return`#${l(o.rgba.r)}${l(o.rgba.g)}${l(o.rgba.b)}`}T.formatHex=m;function n(o,S=!1){return S&&o.rgba.a===1?D.Format.CSS.formatHex(o):`#${l(o.rgba.r)}${l(o.rgba.g)}${l(o.rgba.b)}${l(Math.round(o.rgba.a*255))}`}T.formatHexA=n;function r(o){return o.isOpaque()?D.Format.CSS.formatHex(o):D.Format.CSS.formatRGBA(o)}T.format=r;function $(o){const S=o.length;if(S===0||o.charCodeAt(0)!==35)return null;if(S===7){const j=16*c(o.charCodeAt(1))+c(o.charCodeAt(2)),M=16*c(o.charCodeAt(3))+c(o.charCodeAt(4)),b=16*c(o.charCodeAt(5))+c(o.charCodeAt(6));return new D(new F(j,M,b,1))}if(S===9){const j=16*c(o.charCodeAt(1))+c(o.charCodeAt(2)),M=16*c(o.charCodeAt(3))+c(o.charCodeAt(4)),b=16*c(o.charCodeAt(5))+c(o.charCodeAt(6)),v=16*c(o.charCodeAt(7))+c(o.charCodeAt(8));return new D(new F(j,M,b,v/255))}if(S===4){const j=c(o.charCodeAt(1)),M=c(o.charCodeAt(2)),b=c(o.charCodeAt(3));return new D(new F(16*j+j,16*M+M,16*b+b))}if(S===5){const j=c(o.charCodeAt(1)),M=c(o.charCodeAt(2)),b=c(o.charCodeAt(3)),v=c(o.charCodeAt(4));return new D(new F(16*j+j,16*M+M,16*b+b,(16*v+v)/255))}return null}T.parseHex=$;function c(o){switch(o){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(d=f.CSS||(f.CSS={}))})(h=D.Format||(D.Format={}))}(w||(t.$Us=w={}))}),define(be[25],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ih=t.$hh=t.$gh=void 0;function y(w){return(D,h,f)=>{let d=null,T=null;if(typeof f.value=="function"?(d="value",T=f.value):typeof f.get=="function"&&(d="get",T=f.get),!T)throw new Error("not supported");f[d]=w(T,h)}}function F(w,D,h){let f=null,d=null;if(typeof h.value=="function"?(f="value",d=h.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(f="get",d=h.get),!d)throw new Error("not supported");const T=`$memoize$${D}`;h[f]=function(...s){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,s)}),this[T]}}t.$gh=F;function i(w,D,h){return y((f,d)=>{const T=`$debounce$${d}`,s=`$debounce$result$${d}`;return function(...a){this[s]||(this[s]=h?h():void 0),clearTimeout(this[T]),D&&(this[s]=D(this[s],...a),a=[this[s]]),this[T]=setTimeout(()=>{f.apply(this,a),this[s]=h?h():void 0},w)}})}t.$hh=i;function U(w,D,h){return y((f,d)=>{const T=`$throttle$timer$${d}`,s=`$throttle$result$${d}`,a=`$throttle$lastRun$${d}`,e=`$throttle$pending$${d}`;return function(...u){if(this[s]||(this[s]=h?h():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),D&&(this[s]=D(this[s],...u)),this[e])return;const l=this[a]+w;l<=Date.now()?(this[a]=Date.now(),f.apply(this,[this[s]]),this[s]=h?h():void 0):(this[e]=!0,this[T]=setTimeout(()=>{this[e]=!1,this[a]=Date.now(),f.apply(this,[this[s]]),this[s]=h?h():void 0},l-Date.now()))}})}t.$ih=U}),define(be[73],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ts=void 0;class y{constructor(i,U,w,D){this.originalStart=i,this.originalLength=U,this.modifiedStart=w,this.modifiedLength=D}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$ts=y}),define(be[6],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class y{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?r.isErrorNoTelemetry(o)?new r(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(S=>{S(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}t.$W=y,t.$X=new y;function F(c){t.$X.setUnexpectedErrorHandler(c)}t.setUnexpectedErrorHandler=F;function i(c){if(!c||typeof c!="object")return!1;const o=c;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}t.$Z=i;function U(c){f(c)||t.$X.onUnexpectedError(c)}t.$1=U;function w(c){f(c)||t.$X.onUnexpectedExternalError(c)}t.$2=w;function D(c){if(c instanceof Error){const{name:o,message:S}=c,j=c.stacktrace||c.stack;return{$isError:!0,name:o,message:S,stack:j,noTelemetry:r.isErrorNoTelemetry(c)}}return c}t.$3=D;const h="Canceled";function f(c){return c instanceof d?!0:c instanceof Error&&c.name===h&&c.message===h}t.$4=f;class d extends Error{constructor(){super(h),this.name=this.message}}t.$5=d;function T(){const c=new Error(h);return c.name=c.message,c}t.$6=T;function s(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}t.$7=s;function a(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}t.$8=a;class e extends TypeError{constructor(o){super(o?`${o} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function u(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}t.$0=u;class l extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}t.$$=l;class m extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}t.$_=m;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=n;class r extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof r)return o;const S=new r;return S.message=o.message,S.stack=o.stack,S}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}t.$bb=r;class $ extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,$.prototype)}}t.$cb=$}),define(be[11],$e([1,0,6,70]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function i(L,P=0){return L[L.length-(1+P)]}t.$sb=i;function U(L){if(L.length===0)throw new Error("Invalid tail call");return[L.slice(0,L.length-1),L[L.length-1]]}t.$tb=U;function w(L,P,O=(q,C)=>q===C){if(L===P)return!0;if(!L||!P||L.length!==P.length)return!1;for(let q=0,C=L.length;q<C;q++)if(!O(L[q],P[q]))return!1;return!0}t.$ub=w;function D(L,P){const O=L.length-1;P<O&&(L[P]=L[O]),L.pop()}t.$vb=D;function h(L,P,O){return f(L.length,q=>O(L[q],P))}t.$wb=h;function f(L,P){let O=0,q=L-1;for(;O<=q;){const C=(O+q)/2|0,R=P(C);if(R<0)O=C+1;else if(R>0)q=C-1;else return C}return-(O+1)}t.$xb=f;function d(L,P,O){if(L=L|0,L>=P.length)throw new TypeError("invalid index");const q=P[Math.floor(P.length*Math.random())],C=[],R=[],A=[];for(const k of P){const H=O(k,q);H<0?C.push(k):H>0?R.push(k):A.push(k)}return L<C.length?d(L,C,O):L<C.length+A.length?A[0]:d(L-(C.length+A.length),R,O)}t.$yb=d;function T(L,P){const O=[];let q;for(const C of L.slice(0).sort(P))!q||P(q[0],C)!==0?(q=[C],O.push(q)):q.push(C);return O}t.$zb=T;function*s(L,P){let O,q;for(const C of L)q!==void 0&&P(q,C)?O.push(C):(O&&(yield O),O=[C]),q=C;O&&(yield O)}t.$Ab=s;function a(L,P){for(let O=0;O<=L.length;O++)P(O===0?void 0:L[O-1],O===L.length?void 0:L[O])}t.$Bb=a;function e(L,P){for(let O=0;O<L.length;O++)P(O===0?void 0:L[O-1],L[O],O+1===L.length?void 0:L[O+1])}t.$Cb=e;function u(L,P,O){const q=[];function C(k,H,Q){if(H===0&&Q.length===0)return;const te=q[q.length-1];te&&te.start+te.deleteCount===k?(te.deleteCount+=H,te.toInsert.push(...Q)):q.push({start:k,deleteCount:H,toInsert:Q})}let R=0,A=0;for(;;){if(R===L.length){C(R,0,P.slice(A));break}if(A===P.length){C(R,L.length-R,[]);break}const k=L[R],H=P[A],Q=O(k,H);Q===0?(R+=1,A+=1):Q<0?(C(R,1,[]),R+=1):Q>0&&(C(R,0,[H]),A+=1)}return q}t.$Db=u;function l(L,P,O){const q=u(L,P,O),C=[],R=[];for(const A of q)C.push(...L.slice(A.start,A.start+A.deleteCount)),R.push(...A.toInsert);return{removed:C,added:R}}t.$Eb=l;function m(L,P,O){if(O===0)return[];const q=L.slice(0,O).sort(P);return r(L,P,q,O,L.length),q}t.top=m;function n(L,P,O,q,C){return O===0?Promise.resolve([]):new Promise((R,A)=>{(async()=>{const k=L.length,H=L.slice(0,O).sort(P);for(let Q=O,te=Math.min(O+q,k);Q<k;Q=te,te=Math.min(te+q,k)){if(Q>O&&await new Promise(se=>setTimeout(se)),C&&C.isCancellationRequested)throw new y.$5;r(L,P,H,Q,te)}return H})().then(R,A)})}t.$Gb=n;function r(L,P,O,q,C){for(const R=O.length;q<C;q++){const A=L[q];if(P(A,O[R-1])<0){O.pop();const k=(0,F.$kb)(O,H=>P(A,H)<0);O.splice(k,0,A)}}}function $(L){return L.filter(P=>!!P)}t.$Hb=$;function c(L){let P=0;for(let O=0;O<L.length;O++)L[O]&&(L[P]=L[O],P+=1);L.length=P}t.$Ib=c;function o(L,P,O){L.splice(O,0,L.splice(P,1)[0])}t.$Jb=o;function S(L){return!Array.isArray(L)||L.length===0}t.$Kb=S;function j(L){return Array.isArray(L)&&L.length>0}t.$Lb=j;function M(L,P=O=>O){const O=new Set;return L.filter(q=>{const C=P(q);return O.has(C)?!1:(O.add(C),!0)})}t.$Mb=M;function b(L){const P=new Set;return O=>{const q=L(O);return P.has(q)?!1:(P.add(q),!0)}}t.$Nb=b;function v(L,P){return L.length>0?L[0]:P}t.$Ob=v;function B(L,P){return L.length>0?L[L.length-1]:P}t.$Pb=B;function z(L,P,O=(q,C)=>q===C){let q=0;for(let C=0,R=Math.min(L.length,P.length);C<R&&O(L[C],P[C]);C++)q++;return q}t.$Qb=z;function W(L){return[].concat(...L)}t.$Rb=W;function I(L,P){let O=typeof P=="number"?L:0;typeof P=="number"?O=L:(O=0,P=L);const q=[];if(O<=P)for(let C=O;C<P;C++)q.push(C);else for(let C=O;C>P;C--)q.push(C);return q}t.$Sb=I;function N(L,P,O){return L.reduce((q,C)=>(q[P(C)]=O?O(C):C,q),Object.create(null))}t.$Tb=N;function J(L,P){return L.push(P),()=>ee(L,P)}t.$Ub=J;function ee(L,P){const O=L.indexOf(P);if(O>-1)return L.splice(O,1),P}t.$Vb=ee;function ne(L,P,O){const q=L.slice(0,P),C=L.slice(P);return q.concat(O,C)}t.$Wb=ne;function ue(L,P){let O;if(typeof P=="number"){let q=P;O=()=>{const C=Math.sin(q++)*179426549;return C-Math.floor(C)}}else O=Math.random;for(let q=L.length-1;q>0;q-=1){const C=Math.floor(O()*(q+1)),R=L[q];L[q]=L[C],L[C]=R}}t.$Xb=ue;function le(L,P){const O=L.indexOf(P);O>-1&&(L.splice(O,1),L.unshift(P))}t.$Yb=le;function oe(L,P){const O=L.indexOf(P);O>-1&&(L.splice(O,1),L.push(P))}t.$Zb=oe;function me(L,P){for(const O of P)L.push(O)}t.$1b=me;function Ce(L,P){return Array.isArray(L)?L.map(P):P(L)}t.$2b=Ce;function Te(L){return Array.isArray(L)?L:[L]}t.$3b=Te;function Pe(L){return L[Math.floor(Math.random()*L.length)]}t.$4b=Pe;function de(L,P,O){const q=fe(L,P),C=L.length,R=O.length;L.length=C+R;for(let A=C-1;A>=q;A--)L[A+R]=L[A];for(let A=0;A<R;A++)L[A+q]=O[A]}t.$5b=de;function ie(L,P,O,q){const C=fe(L,P);let R=L.splice(C,O);return R===void 0&&(R=[]),de(L,C,q),R}t.$6b=ie;function fe(L,P){return P<0?Math.max(P+L.length,0):Math.min(P,L.length)}var Y;(function(L){function P(R){return R<0}L.isLessThan=P;function O(R){return R<=0}L.isLessThanOrEqual=O;function q(R){return R>0}L.isGreaterThan=q;function C(R){return R===0}L.isNeitherLessOrGreaterThan=C,L.greaterThan=1,L.lessThan=-1,L.neitherLessOrGreaterThan=0})(Y||(t.CompareResult=Y={}));function _(L,P){return(O,q)=>P(L(O),L(q))}t.$7b=_;function G(...L){return(P,O)=>{for(const q of L){const C=q(P,O);if(!Y.isNeitherLessOrGreaterThan(C))return C}return Y.neitherLessOrGreaterThan}}t.$8b=G;const E=(L,P)=>L-P;t.$9b=E;const K=(L,P)=>(0,t.$9b)(L?1:0,P?1:0);t.$0b=K;function g(L){return(P,O)=>-L(P,O)}t.$$b=g;class p{constructor(P){this.g=P,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(P){let O=this.c;for(;O<this.g.length&&P(this.g[O]);)O++;const q=O===this.c?null:this.g.slice(this.c,O);return this.c=O,q}takeFromEndWhile(P){let O=this.d;for(;O>=0&&P(this.g[O]);)O--;const q=O===this.d?null:this.g.slice(O+1,this.d+1);return this.d=O,q}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const P=this.g[this.c];return this.c++,P}removeLast(){const P=this.g[this.d];return this.d--,P}takeCount(P){const O=this.g.slice(this.c,this.c+P);return this.c+=P,O}}t.$_b=p;class V{static{this.empty=new V(P=>{})}constructor(P){this.iterate=P}forEach(P){this.iterate(O=>(P(O),!0))}toArray(){const P=[];return this.iterate(O=>(P.push(O),!0)),P}filter(P){return new V(O=>this.iterate(q=>P(q)?O(q):!0))}map(P){return new V(O=>this.iterate(q=>O(P(q))))}some(P){let O=!1;return this.iterate(q=>(O=P(q),!O)),O}findFirst(P){let O;return this.iterate(q=>P(q)?(O=q,!1):!0),O}findLast(P){let O;return this.iterate(q=>(P(q)&&(O=q),!0)),O}findLastMaxBy(P){let O,q=!0;return this.iterate(C=>((q||Y.isGreaterThan(P(C,O)))&&(q=!1,O=C),!0)),O}}t.$ac=V}),define(be[74],$e([1,0,6]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7c=t.$6c=t.$5c=t.$4c=t.ok=void 0;function F(h,f){if(!h)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}t.ok=F;function i(h,f="Unreachable"){throw new Error(f)}t.$4c=i;function U(h){if(!h)throw new y.$cb("Assertion Failed")}t.$5c=U;function w(h){if(!h()){debugger;h(),(0,y.$1)(new y.$cb("Assertion Failed"))}}t.$6c=w;function D(h,f){let d=0;for(;d<h.length-1;){const T=h[d],s=h[d+1];if(!f(T,s))return!1;d++}return!0}t.$7c=D}),define(be[42],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function y(F){const i=this;let U=!1,w;return function(){return U||(U=!0,w=F.apply(i,arguments)),w}}t.$db=y}),define(be[75],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jM=t.$iM=void 0;class y{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.$iM=y,t.$jM=new y("id#")}),define(be[26],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var y;(function(F){function i(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}F.is=i;const U=Object.freeze([]);function w(){return U}F.empty=w;function*D(c){yield c}F.single=D;function h(c){return i(c)?c:D(c)}F.wrap=h;function f(c){return c||U}F.from=f;function*d(c){for(let o=c.length-1;o>=0;o--)yield c[o]}F.reverse=d;function T(c){return!c||c[Symbol.iterator]().next().done===!0}F.isEmpty=T;function s(c){return c[Symbol.iterator]().next().value}F.first=s;function a(c,o){for(const S of c)if(o(S))return!0;return!1}F.some=a;function e(c,o){for(const S of c)if(o(S))return S}F.find=e;function*u(c,o){for(const S of c)o(S)&&(yield S)}F.filter=u;function*l(c,o){let S=0;for(const j of c)yield o(j,S++)}F.map=l;function*m(...c){for(const o of c)for(const S of o)yield S}F.concat=m;function n(c,o,S){let j=S;for(const M of c)j=o(j,M);return j}F.reduce=n;function*r(c,o,S=c.length){for(o<0&&(o+=c.length),S<0?S+=c.length:S>c.length&&(S=c.length);o<S;o++)yield c[o]}F.slice=r;function $(c,o=Number.POSITIVE_INFINITY){const S=[];if(o===0)return[S,c];const j=c[Symbol.iterator]();for(let M=0;M<o;M++){const b=j.next();if(b.done)return[S,F.empty()];S.push(b.value)}return[S,{[Symbol.iterator](){return j}}]}F.consume=$})(y||(t.Iterable=y={}))}),define(be[43],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dq=t.KeyMod=t.KeyCodeUtils=t.$Cq=t.$Bq=t.$Aq=t.$zq=t.$yq=t.ScanCode=t.KeyCode=void 0;var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(y||(t.KeyCode=y={}));var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(F||(t.ScanCode=F={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(u,l){this._keyCodeToStr[u]=l,this._strToKeyCode[l.toLowerCase()]=u}keyCodeToStr(u){return this._keyCodeToStr[u]}strToKeyCode(u){return this._strToKeyCode[u.toLowerCase()]||0}}const U=new i,w=new i,D=new i;t.$yq=new Array(230),t.$zq={};const h=[],f=Object.create(null),d=Object.create(null);t.$Aq={lowerCaseToEnum:e=>d[e]||0,toEnum:e=>f[e]||0,toString:e=>h[e]||"None"},t.$Bq=[],t.$Cq=[];for(let e=0;e<=193;e++)t.$Bq[e]=-1;for(let e=0;e<=132;e++)t.$Cq[e]=-1;(function(){const e="",u=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],l=[],m=[];for(const n of u){const[r,$,c,o,S,j,M,b,v]=n;if(m[$]||(m[$]=!0,h[$]=c,f[c]=$,d[c.toLowerCase()]=$,r&&(t.$Bq[$]=o,o!==0&&o!==3&&o!==5&&o!==4&&o!==6&&o!==57&&(t.$Cq[o]=$))),!l[o]){if(l[o]=!0,!S)throw new Error(`String representation missing for key code ${o} around scan code ${c}`);U.define(o,S),w.define(o,b||S),D.define(o,v||b||S)}j&&(t.$yq[j]=o),M&&(t.$zq[M]=o)}t.$Cq[3]=46})();var T;(function(e){function u(c){return U.keyCodeToStr(c)}e.toString=u;function l(c){return U.strToKeyCode(c)}e.fromString=l;function m(c){return w.keyCodeToStr(c)}e.toUserSettingsUS=m;function n(c){return D.keyCodeToStr(c)}e.toUserSettingsGeneral=n;function r(c){return w.strToKeyCode(c)||D.strToKeyCode(c)}e.fromUserSettings=r;function $(c){if(c>=98&&c<=113)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return U.keyCodeToStr(c)}e.toElectronAccelerator=$})(T||(t.KeyCodeUtils=T={}));var s;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(s||(t.KeyMod=s={}));function a(e,u){const l=(u&65535)<<16>>>0;return(e|l)>>>0}t.$Dq=a}),define(be[76],$e([1,0,6]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kq=t.$Jq=t.$Iq=t.$Hq=t.$Gq=t.$Fq=t.$Eq=void 0;var F;(function(T){T[T.CtrlCmd=2048]="CtrlCmd",T[T.Shift=1024]="Shift",T[T.Alt=512]="Alt",T[T.WinCtrl=256]="WinCtrl",T[T.KeyCode=255]="KeyCode"})(F||(F={}));function i(T,s){if(typeof T=="number"){if(T===0)return null;const a=(T&65535)>>>0,e=(T&4294901760)>>>16;return e!==0?new h([U(a,s),U(e,s)]):new h([U(a,s)])}else{const a=[];for(let e=0;e<T.length;e++)a.push(U(T[e],s));return new h(a)}}t.$Eq=i;function U(T,s){const a=!!(T&2048),e=!!(T&256),u=s===2?e:a,l=!!(T&1024),m=!!(T&512),n=s===2?a:e,r=T&255;return new w(u,l,m,n,r)}t.$Fq=U;class w{constructor(s,a,e,u,l){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=u,this.keyCode=l}equals(s){return s instanceof w&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.keyCode===s.keyCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",u=this.metaKey?"1":"0";return`K${s}${a}${e}${u}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new h([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Gq=w;class D{constructor(s,a,e,u,l){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=u,this.scanCode=l}equals(s){return s instanceof D&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.scanCode===s.scanCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",u=this.metaKey?"1":"0";return`S${s}${a}${e}${u}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Hq=D;class h{constructor(s){if(s.length===0)throw(0,y.$7)("chords");this.chords=s}getHashCode(){let s="";for(let a=0,e=this.chords.length;a<e;a++)a!==0&&(s+=";"),s+=this.chords[a].getHashCode();return s}equals(s){if(s===null||this.chords.length!==s.chords.length)return!1;for(let a=0;a<this.chords.length;a++)if(!this.chords[a].equals(s.chords[a]))return!1;return!0}}t.$Iq=h;class f{constructor(s,a,e,u,l,m){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=u,this.keyLabel=l,this.keyAriaLabel=m}}t.$Jq=f;class d{}t.$Kq=d}),define(be[27],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class y{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=y}),define(be[44],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2c=void 0;class y{static{this.Undefined=new y(void 0)}constructor(U){this.element=U,this.next=y.Undefined,this.prev=y.Undefined}}class F{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let U=this.a;for(;U!==y.Undefined;){const w=U.next;U.prev=y.Undefined,U.next=y.Undefined,U=w}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(U){return this.d(U,!1)}push(U){return this.d(U,!0)}d(U,w){const D=new y(U);if(this.a===y.Undefined)this.a=D,this.b=D;else if(w){const f=this.b;this.b=D,D.prev=f,f.next=D}else{const f=this.a;this.a=D,D.next=f,f.prev=D}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(D))}}shift(){if(this.a!==y.Undefined){const U=this.a.element;return this.e(this.a),U}}pop(){if(this.b!==y.Undefined){const U=this.b.element;return this.e(this.b),U}}e(U){if(U.prev!==y.Undefined&&U.next!==y.Undefined){const w=U.prev;w.next=U.next,U.next.prev=w}else U.prev===y.Undefined&&U.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):U.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):U.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let U=this.a;for(;U!==y.Undefined;)yield U.element,U=U.next}}t.$2c=F}),define(be[31],$e([1,0]),function(re,t){"use strict";var y,F,i;Object.defineProperty(t,"__esModule",{value:!0}),t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function U(n,r,$){let c=n.get(r);return c===void 0&&(c=$,n.set(r,c)),c}t.$xc=U;function w(n){const r=[];return n.forEach(($,c)=>{r.push(`${c} => ${$}`)}),`Map(${n.size}) {${r.join(", ")}}`}t.$yc=w;function D(n){const r=[];return n.forEach($=>{r.push($)}),`Set(${n.size}) {${r.join(", ")}}`}t.$zc=D;class h{constructor(r,$){this.uri=r,this.value=$}}function f(n){return Array.isArray(n)}class d{static{this.a=r=>r.toString()}constructor(r,$){if(this[y]="ResourceMap",r instanceof d)this.b=new Map(r.b),this.c=$??d.a;else if(f(r)){this.b=new Map,this.c=$??d.a;for(const[c,o]of r)this.set(c,o)}else this.b=new Map,this.c=r??d.a}set(r,$){return this.b.set(this.c(r),new h(r,$)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,$){typeof $<"u"&&(r=r.bind($));for(const[c,o]of this.b)r(o.value,o.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}t.$Ac=d;class T{constructor(r,$){this[F]="ResourceSet",!r||typeof r=="function"?this.a=new d(r):(this.a=new d($),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,$){this.a.forEach((c,o)=>r.call($,o,o,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=T;var s;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(s||(t.Touch=s={}));class a{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,$=0){const c=this.a.get(r);if(c)return $!==0&&this.j(c,$),c.value}set(r,$,c=0){let o=this.a.get(r);if(o)o.value=$,c!==0&&this.j(o,c);else{switch(o={key:r,value:$,next:void 0,previous:void 0},c){case 0:this.h(o);break;case 1:this.g(o);break;case 2:this.h(o);break;default:this.h(o);break}this.a.set(r,o),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const $=this.a.get(r);if($)return this.a.delete(r),this.i($),this.d--,$.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,$){const c=this.e;let o=this.b;for(;o;){if($?r.bind($)(o.value,o.key,this):r(o.value,o.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const r=this,$=this.e;let c=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==$)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:c.key,done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return o}values(){const r=this,$=this.e;let c=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==$)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:c.value,done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return o}entries(){const r=this,$=this.e;let c=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==$)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:[c.key,c.value],done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return o}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let $=this.b,c=this.size;for(;$&&c>r;)this.a.delete($.key),$=$.next,c--;this.b=$,this.d=c,$&&($.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const $=r.next,c=r.previous;if(!$||!c)throw new Error("Invalid list");$.previous=c,c.next=$}r.next=void 0,r.previous=void 0,this.e++}j(r,$){if(!this.b||!this.c)throw new Error("Invalid list");if(!($!==1&&$!==2)){if($===1){if(r===this.b)return;const c=r.next,o=r.previous;r===this.c?(o.next=void 0,this.c=o):(c.previous=o,o.next=c),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if($===2){if(r===this.c)return;const c=r.next,o=r.previous;r===this.b?(c.previous=void 0,this.b=c):(c.previous=o,o.next=c),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach(($,c)=>{r.push([c,$])}),r}fromJSON(r){this.clear();for(const[$,c]of r)this.set($,c)}}t.$Cc=a;class e extends a{constructor(r,$=1){super(),this.k=r,this.l=Math.min(Math.max(0,$),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,$=2){return super.get(r,$)}peek(r){return super.get(r,0)}set(r,$){return super.set(r,$,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Dc=e;class u{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let $=this.a.get(r)||0;return $===0?!1:($--,$===0?this.a.delete(r):this.a.set(r,$),!0)}has(r){return this.a.has(r)}}t.$Ec=u;class l{constructor(r){if(this.a=new Map,this.b=new Map,r)for(const[$,c]of r)this.set($,c)}clear(){this.a.clear(),this.b.clear()}set(r,$){this.a.set(r,$),this.b.set($,r)}get(r){return this.a.get(r)}getKey(r){return this.b.get(r)}delete(r){const $=this.a.get(r);return $===void 0?!1:(this.a.delete(r),this.b.delete($),!0)}forEach(r,$){this.a.forEach((c,o)=>{r.call($,c,o,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Fc=l;class m{constructor(){this.a=new Map}add(r,$){let c=this.a.get(r);c||(c=new Set,this.a.set(r,c)),c.add($)}delete(r,$){const c=this.a.get(r);c&&(c.delete($),c.size===0&&this.a.delete(r))}forEach(r,$){const c=this.a.get(r);c&&c.forEach($)}get(r){const $=this.a.get(r);return $||new Set}}t.$Gc=m}),define(be[2],$e([1,0,11,71,31,42,26]),function(re,t,y,F,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=void 0;const D=!1;let h=null;class f{constructor(){this.b=new Map}static{this.a=0}c(N){let J=this.b.get(N);return J||(J={parent:null,source:null,isSingleton:!1,value:N,idx:f.a++},this.b.set(N,J)),J}trackDisposable(N){const J=this.c(N);J.source||(J.source=new Error().stack)}setParent(N,J){const ee=this.c(N);ee.parent=J}markAsDisposed(N){this.b.delete(N)}markAsSingleton(N){this.c(N).isSingleton=!0}f(N,J){const ee=J.get(N);if(ee)return ee;const ne=N.parent?this.f(this.c(N.parent),J):N;return J.set(N,ne),ne}getTrackedDisposables(){const N=new Map;return[...this.b.entries()].filter(([,ee])=>ee.source!==null&&!this.f(ee,N).isSingleton).flatMap(([ee])=>ee)}computeLeakingDisposables(N=10,J){let ee;if(J)ee=J;else{const me=new Map,Ce=[...this.b.values()].filter(Pe=>Pe.source!==null&&!this.f(Pe,me).isSingleton);if(Ce.length===0)return;const Te=new Set(Ce.map(Pe=>Pe.value));if(ee=Ce.filter(Pe=>!(Pe.parent&&Te.has(Pe.parent))),ee.length===0)throw new Error("There are cyclic diposable chains!")}if(!ee)return;function ne(me){function Ce(Pe,de){for(;Pe.length>0&&de.some(ie=>typeof ie=="string"?ie===Pe[0]:Pe[0].match(ie));)Pe.shift()}const Te=me.source.split(`
`).map(Pe=>Pe.trim().replace("at ","")).filter(Pe=>Pe!=="");return Ce(Te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Te.reverse()}const ue=new i.$Gc;for(const me of ee){const Ce=ne(me);for(let Te=0;Te<=Ce.length;Te++)ue.add(Ce.slice(0,Te).join(`
`),me)}ee.sort((0,y.$7b)(me=>me.idx,y.$9b));let le="",oe=0;for(const me of ee.slice(0,N)){oe++;const Ce=ne(me),Te=[];for(let Pe=0;Pe<Ce.length;Pe++){let de=Ce[Pe];de=`(shared with ${ue.get(Ce.slice(0,Pe+1).join(`
`)).size}/${ee.length} leaks) at ${de}`;const fe=ue.get(Ce.slice(0,Pe).join(`
`)),Y=(0,F.$J)([...fe].map(_=>ne(_)[Pe]),_=>_);delete Y[Ce[Pe]];for(const[_,G]of Object.entries(Y))Te.unshift(`    - stacktraces of ${G.length} other leaks continue with ${_}`);Te.unshift(de)}le+=`


==================== Leaking disposable ${oe}/${ee.length}: ${me.value.constructor.name} ====================
${Te.join(`
`)}
============================================================

`}return ee.length>N&&(le+=`


... and ${ee.length-N} more leaking disposables

`),{leaks:ee,details:le}}}t.$Hc=f;function d(I){h=I}if(t.$Ic=d,D){const I="__is_disposable_tracked__";d(new class{trackDisposable(N){const J=new Error("Potentially leaked disposable").stack;setTimeout(()=>{N[I]||console.log(J)},3e3)}setParent(N,J){if(N&&N!==o.None)try{N[I]=!0}catch{}}markAsDisposed(N){if(N&&N!==o.None)try{N[I]=!0}catch{}}markAsSingleton(N){}})}function T(I){return h?.trackDisposable(I),I}t.$Jc=T;function s(I){h?.markAsDisposed(I)}t.$Kc=s;function a(I,N){h?.setParent(I,N)}function e(I,N){if(h)for(const J of I)h.setParent(J,N)}function u(I){return h?.markAsSingleton(I),I}t.$Lc=u;function l(I){return typeof I.dispose=="function"&&I.dispose.length===0}t.$Mc=l;function m(I){if(w.Iterable.is(I)){const N=[];for(const J of I)if(J)try{J.dispose()}catch(ee){N.push(ee)}if(N.length===1)throw N[0];if(N.length>1)throw new AggregateError(N,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}t.$Nc=m;function n(I){for(const N of I)l(N)&&N.dispose();return[]}t.$Oc=n;function r(...I){const N=$(()=>m(I));return e(I,N),N}t.$Pc=r;function $(I){const N=T({dispose:(0,U.$db)(()=>{s(N),I()})});return N}t.$Qc=$;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,T(this)}dispose(){this.g||(s(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(N){if(!N)return N;if(N===this)throw new Error("Cannot register a disposable on itself!");return a(N,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(N),N}delete(N){if(N){if(N===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(N),N.dispose()}}deleteAndLeak(N){N&&this.f.has(N)&&(this.f.delete(N),a(N,null))}}t.$Rc=c;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,T(this),a(this.q,this)}dispose(){s(this),this.q.dispose()}B(N){if(N===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(N)}}t.$Sc=o;class S{constructor(){this.b=!1,T(this)}get value(){return this.b?void 0:this.a}set value(N){this.b||N===this.a||(this.a?.dispose(),N&&a(N,this),this.a=N)}clear(){this.value=void 0}dispose(){this.b=!0,s(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const N=this.a;return this.a=void 0,N&&a(N,null),N}}t.$Tc=S;class j{constructor(N){this.b=N,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Uc=j;class M{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(N){let J=N;return this.unset=()=>J=void 0,this.isset=()=>J!==void 0,this.dispose=()=>{J&&(J(),J=void 0,s(this))},this}}t.$Vc=M;class b{constructor(){this.a=new Map}acquire(N,...J){let ee=this.a.get(N);ee||(ee={counter:0,object:this.b(N,...J)},this.a.set(N,ee));const{object:ne}=ee,ue=(0,U.$db)(()=>{--ee.counter===0&&(this.c(N,ee.object),this.a.delete(N))});return ee.counter++,{object:ne,dispose:ue}}}t.$Wc=b;class v{constructor(N){this.a=N}async acquire(N,...J){const ee=this.a.acquire(N,...J);try{return{object:await ee.object,dispose:()=>ee.dispose()}}catch(ne){throw ee.dispose(),ne}}}t.$Xc=v;class B{constructor(N){this.object=N}dispose(){}}t.$Yc=B;function z(I){const N=new c;try{I(N)}finally{N.dispose()}}t.$Zc=z;class W{constructor(){this.a=new Map,this.b=!1,T(this)}dispose(){s(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(N){return this.a.has(N)}get size(){return this.a.size}get(N){return this.a.get(N)}set(N,J,ee=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),ee||this.a.get(N)?.dispose(),this.a.set(N,J)}deleteAndDispose(N){this.a.get(N)?.dispose(),this.a.delete(N)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$1c=W}),function(re,t){typeof define=="function"&&define.amd?define(be[77],$e([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(re=typeof globalThis<"u"?globalThis:re||self,t(re.marked={}))}(this,function(re){"use strict";function t(P,O){for(var q=0;q<O.length;q++){var C=O[q];C.enumerable=C.enumerable||!1,C.configurable=!0,"value"in C&&(C.writable=!0),Object.defineProperty(P,C.key,C)}}function y(P,O,q){return O&&t(P.prototype,O),q&&t(P,q),Object.defineProperty(P,"prototype",{writable:!1}),P}function F(P,O){if(P){if(typeof P=="string")return i(P,O);var q=Object.prototype.toString.call(P).slice(8,-1);if(q==="Object"&&P.constructor&&(q=P.constructor.name),q==="Map"||q==="Set")return Array.from(P);if(q==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(q))return i(P,O)}}function i(P,O){(O==null||O>P.length)&&(O=P.length);for(var q=0,C=new Array(O);q<O;q++)C[q]=P[q];return C}function U(P,O){var q=typeof Symbol<"u"&&P[Symbol.iterator]||P["@@iterator"];if(q)return(q=q.call(P)).next.bind(q);if(Array.isArray(P)||(q=F(P))||O&&P&&typeof P.length=="number"){q&&(P=q);var C=0;return function(){return C>=P.length?{done:!0}:{done:!1,value:P[C++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function w(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=w();function D(P){re.defaults=P}var h=/[&<>"']/,f=/[&<>"']/g,d=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,s={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},a=function(O){return s[O]};function e(P,O){if(O){if(h.test(P))return P.replace(f,a)}else if(d.test(P))return P.replace(T,a);return P}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(P){return P.replace(u,function(O,q){return q=q.toLowerCase(),q==="colon"?":":q.charAt(0)==="#"?q.charAt(1)==="x"?String.fromCharCode(parseInt(q.substring(2),16)):String.fromCharCode(+q.substring(1)):""})}var m=/(^|[^\[])\^/g;function n(P,O){P=typeof P=="string"?P:P.source,O=O||"";var q={replace:function(R,A){return A=A.source||A,A=A.replace(m,"$1"),P=P.replace(R,A),q},getRegex:function(){return new RegExp(P,O)}};return q}var r=/[^\w:]/g,$=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(P,O,q){if(P){var C;try{C=decodeURIComponent(l(q)).replace(r,"").toLowerCase()}catch{return null}if(C.indexOf("javascript:")===0||C.indexOf("vbscript:")===0||C.indexOf("data:")===0)return null}O&&!$.test(q)&&(q=b(O,q));try{q=encodeURI(q).replace(/%25/g,"%")}catch{return null}return q}var o={},S=/^[^:]+:\/*[^/]*$/,j=/^([^:]+:)[\s\S]*$/,M=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(P,O){o[" "+P]||(S.test(P)?o[" "+P]=P+"/":o[" "+P]=W(P,"/",!0)),P=o[" "+P];var q=P.indexOf(":")===-1;return O.substring(0,2)==="//"?q?O:P.replace(j,"$1")+O:O.charAt(0)==="/"?q?O:P.replace(M,"$1")+O:P+O}var v={exec:function(){}};function B(P){for(var O=1,q,C;O<arguments.length;O++){q=arguments[O];for(C in q)Object.prototype.hasOwnProperty.call(q,C)&&(P[C]=q[C])}return P}function z(P,O){var q=P.replace(/\|/g,function(A,k,H){for(var Q=!1,te=k;--te>=0&&H[te]==="\\";)Q=!Q;return Q?"|":" |"}),C=q.split(/ \|/),R=0;if(C[0].trim()||C.shift(),C.length>0&&!C[C.length-1].trim()&&C.pop(),C.length>O)C.splice(O);else for(;C.length<O;)C.push("");for(;R<C.length;R++)C[R]=C[R].trim().replace(/\\\|/g,"|");return C}function W(P,O,q){var C=P.length;if(C===0)return"";for(var R=0;R<C;){var A=P.charAt(C-R-1);if(A===O&&!q)R++;else if(A!==O&&q)R++;else break}return P.slice(0,C-R)}function I(P,O){if(P.indexOf(O[1])===-1)return-1;for(var q=P.length,C=0,R=0;R<q;R++)if(P[R]==="\\")R++;else if(P[R]===O[0])C++;else if(P[R]===O[1]&&(C--,C<0))return R;return-1}function N(P){P&&P.sanitize&&!P.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function J(P,O){if(O<1)return"";for(var q="";O>1;)O&1&&(q+=P),O>>=1,P+=P;return q+P}function ee(P,O,q,C){var R=O.href,A=O.title?e(O.title):null,k=P[1].replace(/\\([\[\]])/g,"$1");if(P[0].charAt(0)!=="!"){C.state.inLink=!0;var H={type:"link",raw:q,href:R,title:A,text:k,tokens:C.inlineTokens(k)};return C.state.inLink=!1,H}return{type:"image",raw:q,href:R,title:A,text:e(k)}}function ne(P,O){var q=P.match(/^(\s+)(?:```)/);if(q===null)return O;var C=q[1];return O.split(`
`).map(function(R){var A=R.match(/^\s+/);if(A===null)return R;var k=A[0];return k.length>=C.length?R.slice(C.length):R}).join(`
`)}var ue=function(){function P(q){this.options=q||re.defaults}var O=P.prototype;return O.space=function(C){var R=this.rules.block.newline.exec(C);if(R&&R[0].length>0)return{type:"space",raw:R[0]}},O.code=function(C){var R=this.rules.block.code.exec(C);if(R){var A=R[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:R[0],codeBlockStyle:"indented",text:this.options.pedantic?A:W(A,`
`)}}},O.fences=function(C){var R=this.rules.block.fences.exec(C);if(R){var A=R[0],k=ne(A,R[3]||"");return{type:"code",raw:A,lang:R[2]?R[2].trim():R[2],text:k}}},O.heading=function(C){var R=this.rules.block.heading.exec(C);if(R){var A=R[2].trim();if(/#$/.test(A)){var k=W(A,"#");(this.options.pedantic||!k||/ $/.test(k))&&(A=k.trim())}return{type:"heading",raw:R[0],depth:R[1].length,text:A,tokens:this.lexer.inline(A)}}},O.hr=function(C){var R=this.rules.block.hr.exec(C);if(R)return{type:"hr",raw:R[0]}},O.blockquote=function(C){var R=this.rules.block.blockquote.exec(C);if(R){var A=R[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:R[0],tokens:this.lexer.blockTokens(A,[]),text:A}}},O.list=function(C){var R=this.rules.block.list.exec(C);if(R){var A,k,H,Q,te,se,ge,we,Ne,Ae,ve,Ie,Oe=R[1].trim(),qe=Oe.length>1,ze={type:"list",raw:"",ordered:qe,start:qe?+Oe.slice(0,-1):"",loose:!1,items:[]};Oe=qe?"\\d{1,9}\\"+Oe.slice(-1):"\\"+Oe,this.options.pedantic&&(Oe=qe?Oe:"[*+-]");for(var Me=new RegExp("^( {0,3}"+Oe+")((?:[	 ][^\\n]*)?(?:\\n|$))");C&&(Ie=!1,!(!(R=Me.exec(C))||this.rules.block.hr.test(C)));){if(A=R[0],C=C.substring(A.length),we=R[2].split(`
`,1)[0],Ne=C.split(`
`,1)[0],this.options.pedantic?(Q=2,ve=we.trimLeft()):(Q=R[2].search(/[^ ]/),Q=Q>4?1:Q,ve=we.slice(Q),Q+=R[1].length),se=!1,!we&&/^ *$/.test(Ne)&&(A+=Ne+`
`,C=C.substring(Ne.length+1),Ie=!0),!Ie)for(var Ge=new RegExp("^ {0,"+Math.min(3,Q-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Z=new RegExp("^ {0,"+Math.min(3,Q-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ae=new RegExp("^ {0,"+Math.min(3,Q-1)+"}(?:```|~~~)"),pe=new RegExp("^ {0,"+Math.min(3,Q-1)+"}#");C&&(Ae=C.split(`
`,1)[0],we=Ae,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ae.test(we)||pe.test(we)||Ge.test(we)||Z.test(C)));){if(we.search(/[^ ]/)>=Q||!we.trim())ve+=`
`+we.slice(Q);else if(!se)ve+=`
`+we;else break;!se&&!we.trim()&&(se=!0),A+=Ae+`
`,C=C.substring(Ae.length+1)}ze.loose||(ge?ze.loose=!0:/\n *\n *$/.test(A)&&(ge=!0)),this.options.gfm&&(k=/^\[[ xX]\] /.exec(ve),k&&(H=k[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:A,task:!!k,checked:H,loose:!1,text:ve}),ze.raw+=A}ze.items[ze.items.length-1].raw=A.trimRight(),ze.items[ze.items.length-1].text=ve.trimRight(),ze.raw=ze.raw.trimRight();var De=ze.items.length;for(te=0;te<De;te++){this.lexer.state.top=!1,ze.items[te].tokens=this.lexer.blockTokens(ze.items[te].text,[]);var Se=ze.items[te].tokens.filter(function(je){return je.type==="space"}),Re=Se.every(function(je){for(var Xe=je.raw.split(""),Qe=0,Ve=U(Xe),We;!(We=Ve()).done;){var et=We.value;if(et===`
`&&(Qe+=1),Qe>1)return!0}return!1});!ze.loose&&Se.length&&Re&&(ze.loose=!0,ze.items[te].loose=!0)}return ze}},O.html=function(C){var R=this.rules.block.html.exec(C);if(R){var A={type:"html",raw:R[0],pre:!this.options.sanitizer&&(R[1]==="pre"||R[1]==="script"||R[1]==="style"),text:R[0]};if(this.options.sanitize){var k=this.options.sanitizer?this.options.sanitizer(R[0]):e(R[0]);A.type="paragraph",A.text=k,A.tokens=this.lexer.inline(k)}return A}},O.def=function(C){var R=this.rules.block.def.exec(C);if(R){R[3]&&(R[3]=R[3].substring(1,R[3].length-1));var A=R[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:A,raw:R[0],href:R[2],title:R[3]}}},O.table=function(C){var R=this.rules.block.table.exec(C);if(R){var A={type:"table",header:z(R[1]).map(function(ge){return{text:ge}}),align:R[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:R[3]&&R[3].trim()?R[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(A.header.length===A.align.length){A.raw=R[0];var k=A.align.length,H,Q,te,se;for(H=0;H<k;H++)/^ *-+: *$/.test(A.align[H])?A.align[H]="right":/^ *:-+: *$/.test(A.align[H])?A.align[H]="center":/^ *:-+ *$/.test(A.align[H])?A.align[H]="left":A.align[H]=null;for(k=A.rows.length,H=0;H<k;H++)A.rows[H]=z(A.rows[H],A.header.length).map(function(ge){return{text:ge}});for(k=A.header.length,Q=0;Q<k;Q++)A.header[Q].tokens=this.lexer.inline(A.header[Q].text);for(k=A.rows.length,Q=0;Q<k;Q++)for(se=A.rows[Q],te=0;te<se.length;te++)se[te].tokens=this.lexer.inline(se[te].text);return A}}},O.lheading=function(C){var R=this.rules.block.lheading.exec(C);if(R)return{type:"heading",raw:R[0],depth:R[2].charAt(0)==="="?1:2,text:R[1],tokens:this.lexer.inline(R[1])}},O.paragraph=function(C){var R=this.rules.block.paragraph.exec(C);if(R){var A=R[1].charAt(R[1].length-1)===`
`?R[1].slice(0,-1):R[1];return{type:"paragraph",raw:R[0],text:A,tokens:this.lexer.inline(A)}}},O.text=function(C){var R=this.rules.block.text.exec(C);if(R)return{type:"text",raw:R[0],text:R[0],tokens:this.lexer.inline(R[0])}},O.escape=function(C){var R=this.rules.inline.escape.exec(C);if(R)return{type:"escape",raw:R[0],text:e(R[1])}},O.tag=function(C){var R=this.rules.inline.tag.exec(C);if(R)return!this.lexer.state.inLink&&/^<a /i.test(R[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(R[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(R[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(R[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:R[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(R[0]):e(R[0]):R[0]}},O.link=function(C){var R=this.rules.inline.link.exec(C);if(R){var A=R[2].trim();if(!this.options.pedantic&&/^</.test(A)){if(!/>$/.test(A))return;var k=W(A.slice(0,-1),"\\");if((A.length-k.length)%2===0)return}else{var H=I(R[2],"()");if(H>-1){var Q=R[0].indexOf("!")===0?5:4,te=Q+R[1].length+H;R[2]=R[2].substring(0,H),R[0]=R[0].substring(0,te).trim(),R[3]=""}}var se=R[2],ge="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(se);we&&(se=we[1],ge=we[3])}else ge=R[3]?R[3].slice(1,-1):"";return se=se.trim(),/^</.test(se)&&(this.options.pedantic&&!/>$/.test(A)?se=se.slice(1):se=se.slice(1,-1)),ee(R,{href:se&&se.replace(this.rules.inline._escapes,"$1"),title:ge&&ge.replace(this.rules.inline._escapes,"$1")},R[0],this.lexer)}},O.reflink=function(C,R){var A;if((A=this.rules.inline.reflink.exec(C))||(A=this.rules.inline.nolink.exec(C))){var k=(A[2]||A[1]).replace(/\s+/g," ");if(k=R[k.toLowerCase()],!k||!k.href){var H=A[0].charAt(0);return{type:"text",raw:H,text:H}}return ee(A,k,A[0],this.lexer)}},O.emStrong=function(C,R,A){A===void 0&&(A="");var k=this.rules.inline.emStrong.lDelim.exec(C);if(k&&!(k[3]&&A.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var H=k[1]||k[2]||"";if(!H||H&&(A===""||this.rules.inline.punctuation.exec(A))){var Q=k[0].length-1,te,se,ge=Q,we=0,Ne=k[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ne.lastIndex=0,R=R.slice(-1*C.length+Q);(k=Ne.exec(R))!=null;)if(te=k[1]||k[2]||k[3]||k[4]||k[5]||k[6],!!te){if(se=te.length,k[3]||k[4]){ge+=se;continue}else if((k[5]||k[6])&&Q%3&&!((Q+se)%3)){we+=se;continue}if(ge-=se,!(ge>0)){if(se=Math.min(se,se+ge+we),Math.min(Q,se)%2){var Ae=C.slice(1,Q+k.index+se);return{type:"em",raw:C.slice(0,Q+k.index+se+1),text:Ae,tokens:this.lexer.inlineTokens(Ae)}}var ve=C.slice(2,Q+k.index+se-1);return{type:"strong",raw:C.slice(0,Q+k.index+se+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},O.codespan=function(C){var R=this.rules.inline.code.exec(C);if(R){var A=R[2].replace(/\n/g," "),k=/[^ ]/.test(A),H=/^ /.test(A)&&/ $/.test(A);return k&&H&&(A=A.substring(1,A.length-1)),A=e(A,!0),{type:"codespan",raw:R[0],text:A}}},O.br=function(C){var R=this.rules.inline.br.exec(C);if(R)return{type:"br",raw:R[0]}},O.del=function(C){var R=this.rules.inline.del.exec(C);if(R)return{type:"del",raw:R[0],text:R[2],tokens:this.lexer.inlineTokens(R[2])}},O.autolink=function(C,R){var A=this.rules.inline.autolink.exec(C);if(A){var k,H;return A[2]==="@"?(k=e(this.options.mangle?R(A[1]):A[1]),H="mailto:"+k):(k=e(A[1]),H=k),{type:"link",raw:A[0],text:k,href:H,tokens:[{type:"text",raw:k,text:k}]}}},O.url=function(C,R){var A;if(A=this.rules.inline.url.exec(C)){var k,H;if(A[2]==="@")k=e(this.options.mangle?R(A[0]):A[0]),H="mailto:"+k;else{var Q;do Q=A[0],A[0]=this.rules.inline._backpedal.exec(A[0])[0];while(Q!==A[0]);k=e(A[0]),A[1]==="www."?H="http://"+k:H=k}return{type:"link",raw:A[0],text:k,href:H,tokens:[{type:"text",raw:k,text:k}]}}},O.inlineText=function(C,R){var A=this.rules.inline.text.exec(C);if(A){var k;return this.lexer.state.inRawBlock?k=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(A[0]):e(A[0]):A[0]:k=e(this.options.smartypants?R(A[0]):A[0]),{type:"text",raw:A[0],text:k}}},P}(),le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=n(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=n(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=n(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=n(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=n(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=n(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=B({},le),le.gfm=B({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=n(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.gfm.paragraph=n(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",le.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=B({},le.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:n(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=n(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=n(le._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=n(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=n(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=n(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=n(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=n(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=n(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=n(oe.reflink).replace("label",oe._label).replace("ref",le._label).getRegex(),oe.nolink=n(oe.nolink).replace("ref",le._label).getRegex(),oe.reflinkSearch=n(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=B({},oe),oe.pedantic=B({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=B({},oe.normal,{escape:n(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=n(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=B({},oe.gfm,{br:n(oe.br).replace("{2,}","*").getRegex(),text:n(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function me(P){return P.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ce(P){var O="",q,C,R=P.length;for(q=0;q<R;q++)C=P.charCodeAt(q),Math.random()>.5&&(C="x"+C.toString(16)),O+="&#"+C+";";return O}var Te=function(){function P(q){this.tokens=[],this.tokens.links=Object.create(null),this.options=q||re.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var C={block:le.normal,inline:oe.normal};this.options.pedantic?(C.block=le.pedantic,C.inline=oe.pedantic):this.options.gfm&&(C.block=le.gfm,this.options.breaks?C.inline=oe.breaks:C.inline=oe.gfm),this.tokenizer.rules=C}P.lex=function(C,R){var A=new P(R);return A.lex(C)},P.lexInline=function(C,R){var A=new P(R);return A.inlineTokens(C)};var O=P.prototype;return O.lex=function(C){C=C.replace(/\r\n|\r/g,`
`),this.blockTokens(C,this.tokens);for(var R;R=this.inlineQueue.shift();)this.inlineTokens(R.src,R.tokens);return this.tokens},O.blockTokens=function(C,R){var A=this;R===void 0&&(R=[]),this.options.pedantic?C=C.replace(/\t/g,"    ").replace(/^ +$/gm,""):C=C.replace(/^( *)(\t+)/gm,function(ge,we,Ne){return we+"    ".repeat(Ne.length)});for(var k,H,Q,te;C;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ge){return(k=ge.call({lexer:A},C,R))?(C=C.substring(k.raw.length),R.push(k),!0):!1}))){if(k=this.tokenizer.space(C)){C=C.substring(k.raw.length),k.raw.length===1&&R.length>0?R[R.length-1].raw+=`
`:R.push(k);continue}if(k=this.tokenizer.code(C)){C=C.substring(k.raw.length),H=R[R.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+k.raw,H.text+=`
`+k.text,this.inlineQueue[this.inlineQueue.length-1].src=H.text):R.push(k);continue}if(k=this.tokenizer.fences(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.heading(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.hr(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.blockquote(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.list(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.html(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.def(C)){C=C.substring(k.raw.length),H=R[R.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+k.raw,H.text+=`
`+k.raw,this.inlineQueue[this.inlineQueue.length-1].src=H.text):this.tokens.links[k.tag]||(this.tokens.links[k.tag]={href:k.href,title:k.title});continue}if(k=this.tokenizer.table(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.lheading(C)){C=C.substring(k.raw.length),R.push(k);continue}if(Q=C,this.options.extensions&&this.options.extensions.startBlock&&function(){var ge=1/0,we=C.slice(1),Ne=void 0;A.options.extensions.startBlock.forEach(function(Ae){Ne=Ae.call({lexer:this},we),typeof Ne=="number"&&Ne>=0&&(ge=Math.min(ge,Ne))}),ge<1/0&&ge>=0&&(Q=C.substring(0,ge+1))}(),this.state.top&&(k=this.tokenizer.paragraph(Q))){H=R[R.length-1],te&&H.type==="paragraph"?(H.raw+=`
`+k.raw,H.text+=`
`+k.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):R.push(k),te=Q.length!==C.length,C=C.substring(k.raw.length);continue}if(k=this.tokenizer.text(C)){C=C.substring(k.raw.length),H=R[R.length-1],H&&H.type==="text"?(H.raw+=`
`+k.raw,H.text+=`
`+k.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):R.push(k);continue}if(C){var se="Infinite loop on byte: "+C.charCodeAt(0);if(this.options.silent){console.error(se);break}else throw new Error(se)}}return this.state.top=!0,R},O.inline=function(C,R){return R===void 0&&(R=[]),this.inlineQueue.push({src:C,tokens:R}),R},O.inlineTokens=function(C,R){var A=this;R===void 0&&(R=[]);var k,H,Q,te=C,se,ge,we;if(this.tokens.links){var Ne=Object.keys(this.tokens.links);if(Ne.length>0)for(;(se=this.tokenizer.rules.inline.reflinkSearch.exec(te))!=null;)Ne.includes(se[0].slice(se[0].lastIndexOf("[")+1,-1))&&(te=te.slice(0,se.index)+"["+J("a",se[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(se=this.tokenizer.rules.inline.blockSkip.exec(te))!=null;)te=te.slice(0,se.index)+"["+J("a",se[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(se=this.tokenizer.rules.inline.escapedEmSt.exec(te))!=null;)te=te.slice(0,se.index)+"++"+te.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;C;)if(ge||(we=""),ge=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(k=ve.call({lexer:A},C,R))?(C=C.substring(k.raw.length),R.push(k),!0):!1}))){if(k=this.tokenizer.escape(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.tag(C)){C=C.substring(k.raw.length),H=R[R.length-1],H&&k.type==="text"&&H.type==="text"?(H.raw+=k.raw,H.text+=k.text):R.push(k);continue}if(k=this.tokenizer.link(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.reflink(C,this.tokens.links)){C=C.substring(k.raw.length),H=R[R.length-1],H&&k.type==="text"&&H.type==="text"?(H.raw+=k.raw,H.text+=k.text):R.push(k);continue}if(k=this.tokenizer.emStrong(C,te,we)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.codespan(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.br(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.del(C)){C=C.substring(k.raw.length),R.push(k);continue}if(k=this.tokenizer.autolink(C,Ce)){C=C.substring(k.raw.length),R.push(k);continue}if(!this.state.inLink&&(k=this.tokenizer.url(C,Ce))){C=C.substring(k.raw.length),R.push(k);continue}if(Q=C,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Ie=C.slice(1),Oe=void 0;A.options.extensions.startInline.forEach(function(qe){Oe=qe.call({lexer:this},Ie),typeof Oe=="number"&&Oe>=0&&(ve=Math.min(ve,Oe))}),ve<1/0&&ve>=0&&(Q=C.substring(0,ve+1))}(),k=this.tokenizer.inlineText(Q,me)){C=C.substring(k.raw.length),k.raw.slice(-1)!=="_"&&(we=k.raw.slice(-1)),ge=!0,H=R[R.length-1],H&&H.type==="text"?(H.raw+=k.raw,H.text+=k.text):R.push(k);continue}if(C){var Ae="Infinite loop on byte: "+C.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return R},y(P,null,[{key:"rules",get:function(){return{block:le,inline:oe}}}]),P}(),Pe=function(){function P(q){this.options=q||re.defaults}var O=P.prototype;return O.code=function(C,R,A){var k=(R||"").match(/\S*/)[0];if(this.options.highlight){var H=this.options.highlight(C,k);H!=null&&H!==C&&(A=!0,C=H)}return C=C.replace(/\n$/,"")+`
`,k?'<pre><code class="'+this.options.langPrefix+e(k,!0)+'">'+(A?C:e(C,!0))+`</code></pre>
`:"<pre><code>"+(A?C:e(C,!0))+`</code></pre>
`},O.blockquote=function(C){return`<blockquote>
`+C+`</blockquote>
`},O.html=function(C){return C},O.heading=function(C,R,A,k){if(this.options.headerIds){var H=this.options.headerPrefix+k.slug(A);return"<h"+R+' id="'+H+'">'+C+"</h"+R+`>
`}return"<h"+R+">"+C+"</h"+R+`>
`},O.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},O.list=function(C,R,A){var k=R?"ol":"ul",H=R&&A!==1?' start="'+A+'"':"";return"<"+k+H+`>
`+C+"</"+k+`>
`},O.listitem=function(C){return"<li>"+C+`</li>
`},O.checkbox=function(C){return"<input "+(C?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},O.paragraph=function(C){return"<p>"+C+`</p>
`},O.table=function(C,R){return R&&(R="<tbody>"+R+"</tbody>"),`<table>
<thead>
`+C+`</thead>
`+R+`</table>
`},O.tablerow=function(C){return`<tr>
`+C+`</tr>
`},O.tablecell=function(C,R){var A=R.header?"th":"td",k=R.align?"<"+A+' align="'+R.align+'">':"<"+A+">";return k+C+("</"+A+`>
`)},O.strong=function(C){return"<strong>"+C+"</strong>"},O.em=function(C){return"<em>"+C+"</em>"},O.codespan=function(C){return"<code>"+C+"</code>"},O.br=function(){return this.options.xhtml?"<br/>":"<br>"},O.del=function(C){return"<del>"+C+"</del>"},O.link=function(C,R,A){if(C=c(this.options.sanitize,this.options.baseUrl,C),C===null)return A;var k='<a href="'+e(C)+'"';return R&&(k+=' title="'+R+'"'),k+=">"+A+"</a>",k},O.image=function(C,R,A){if(C=c(this.options.sanitize,this.options.baseUrl,C),C===null)return A;var k='<img src="'+C+'" alt="'+A+'"';return R&&(k+=' title="'+R+'"'),k+=this.options.xhtml?"/>":">",k},O.text=function(C){return C},P}(),de=function(){function P(){}var O=P.prototype;return O.strong=function(C){return C},O.em=function(C){return C},O.codespan=function(C){return C},O.del=function(C){return C},O.html=function(C){return C},O.text=function(C){return C},O.link=function(C,R,A){return""+A},O.image=function(C,R,A){return""+A},O.br=function(){return""},P}(),ie=function(){function P(){this.seen={}}var O=P.prototype;return O.serialize=function(C){return C.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},O.getNextSafeSlug=function(C,R){var A=C,k=0;if(this.seen.hasOwnProperty(A)){k=this.seen[C];do k++,A=C+"-"+k;while(this.seen.hasOwnProperty(A))}return R||(this.seen[C]=k,this.seen[A]=0),A},O.slug=function(C,R){R===void 0&&(R={});var A=this.serialize(C);return this.getNextSafeSlug(A,R.dryrun)},P}(),fe=function(){function P(q){this.options=q||re.defaults,this.options.renderer=this.options.renderer||new Pe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new ie}P.parse=function(C,R){var A=new P(R);return A.parse(C)},P.parseInline=function(C,R){var A=new P(R);return A.parseInline(C)};var O=P.prototype;return O.parse=function(C,R){R===void 0&&(R=!0);var A="",k,H,Q,te,se,ge,we,Ne,Ae,ve,Ie,Oe,qe,ze,Me,Ge,Z,ae,pe,De=C.length;for(k=0;k<De;k++){if(ve=C[k],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(pe=this.options.extensions.renderers[ve.type].call({parser:this},ve),pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){A+=pe||"";continue}switch(ve.type){case"space":continue;case"hr":{A+=this.renderer.hr();continue}case"heading":{A+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,l(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{A+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Ne="",we="",te=ve.header.length,H=0;H<te;H++)we+=this.renderer.tablecell(this.parseInline(ve.header[H].tokens),{header:!0,align:ve.align[H]});for(Ne+=this.renderer.tablerow(we),Ae="",te=ve.rows.length,H=0;H<te;H++){for(ge=ve.rows[H],we="",se=ge.length,Q=0;Q<se;Q++)we+=this.renderer.tablecell(this.parseInline(ge[Q].tokens),{header:!1,align:ve.align[Q]});Ae+=this.renderer.tablerow(we)}A+=this.renderer.table(Ne,Ae);continue}case"blockquote":{Ae=this.parse(ve.tokens),A+=this.renderer.blockquote(Ae);continue}case"list":{for(Ie=ve.ordered,Oe=ve.start,qe=ve.loose,te=ve.items.length,Ae="",H=0;H<te;H++)Me=ve.items[H],Ge=Me.checked,Z=Me.task,ze="",Me.task&&(ae=this.renderer.checkbox(Ge),qe?Me.tokens.length>0&&Me.tokens[0].type==="paragraph"?(Me.tokens[0].text=ae+" "+Me.tokens[0].text,Me.tokens[0].tokens&&Me.tokens[0].tokens.length>0&&Me.tokens[0].tokens[0].type==="text"&&(Me.tokens[0].tokens[0].text=ae+" "+Me.tokens[0].tokens[0].text)):Me.tokens.unshift({type:"text",text:ae}):ze+=ae),ze+=this.parse(Me.tokens,qe),Ae+=this.renderer.listitem(ze,Z,Ge);A+=this.renderer.list(Ae,Ie,Oe);continue}case"html":{A+=this.renderer.html(ve.text);continue}case"paragraph":{A+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Ae=ve.tokens?this.parseInline(ve.tokens):ve.text;k+1<De&&C[k+1].type==="text";)ve=C[++k],Ae+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);A+=R?this.renderer.paragraph(Ae):Ae;continue}default:{var Se='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Se);return}else throw new Error(Se)}}}return A},O.parseInline=function(C,R){R=R||this.renderer;var A="",k,H,Q,te=C.length;for(k=0;k<te;k++){if(H=C[k],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(Q=this.options.extensions.renderers[H.type].call({parser:this},H),Q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(H.type))){A+=Q||"";continue}switch(H.type){case"escape":{A+=R.text(H.text);break}case"html":{A+=R.html(H.text);break}case"link":{A+=R.link(H.href,H.title,this.parseInline(H.tokens,R));break}case"image":{A+=R.image(H.href,H.title,H.text);break}case"strong":{A+=R.strong(this.parseInline(H.tokens,R));break}case"em":{A+=R.em(this.parseInline(H.tokens,R));break}case"codespan":{A+=R.codespan(H.text);break}case"br":{A+=R.br();break}case"del":{A+=R.del(this.parseInline(H.tokens,R));break}case"text":{A+=R.text(H.text);break}default:{var se='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return A},P}();function Y(P,O,q){if(typeof P>"u"||P===null)throw new Error("marked(): input parameter is undefined or null");if(typeof P!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(P)+", string expected");if(typeof O=="function"&&(q=O,O=null),O=B({},Y.defaults,O||{}),N(O),q){var C=O.highlight,R;try{R=Te.lex(P,O)}catch(te){return q(te)}var A=function(se){var ge;if(!se)try{O.walkTokens&&Y.walkTokens(R,O.walkTokens),ge=fe.parse(R,O)}catch(we){se=we}return O.highlight=C,se?q(se):q(null,ge)};if(!C||C.length<3||(delete O.highlight,!R.length))return A();var k=0;Y.walkTokens(R,function(te){te.type==="code"&&(k++,setTimeout(function(){C(te.text,te.lang,function(se,ge){if(se)return A(se);ge!=null&&ge!==te.text&&(te.text=ge,te.escaped=!0),k--,k===0&&A()})},0))}),k===0&&A();return}function H(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,O.silent)return"<p>An error occurred:</p><pre>"+e(te.message+"",!0)+"</pre>";throw te}try{var Q=Te.lex(P,O);if(O.walkTokens){if(O.async)return Promise.all(Y.walkTokens(Q,O.walkTokens)).then(function(){return fe.parse(Q,O)}).catch(H);Y.walkTokens(Q,O.walkTokens)}return fe.parse(Q,O)}catch(te){H(te)}}Y.options=Y.setOptions=function(P){return B(Y.defaults,P),D(Y.defaults),Y},Y.getDefaults=w,Y.defaults=re.defaults,Y.use=function(){for(var P=arguments.length,O=new Array(P),q=0;q<P;q++)O[q]=arguments[q];var C=B.apply(void 0,[{}].concat(O)),R=Y.defaults.extensions||{renderers:{},childTokens:{}},A;O.forEach(function(k){if(k.extensions&&(A=!0,k.extensions.forEach(function(Q){if(!Q.name)throw new Error("extension name required");if(Q.renderer){var te=R.renderers?R.renderers[Q.name]:null;te?R.renderers[Q.name]=function(){for(var se=arguments.length,ge=new Array(se),we=0;we<se;we++)ge[we]=arguments[we];var Ne=Q.renderer.apply(this,ge);return Ne===!1&&(Ne=te.apply(this,ge)),Ne}:R.renderers[Q.name]=Q.renderer}if(Q.tokenizer){if(!Q.level||Q.level!=="block"&&Q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");R[Q.level]?R[Q.level].unshift(Q.tokenizer):R[Q.level]=[Q.tokenizer],Q.start&&(Q.level==="block"?R.startBlock?R.startBlock.push(Q.start):R.startBlock=[Q.start]:Q.level==="inline"&&(R.startInline?R.startInline.push(Q.start):R.startInline=[Q.start]))}Q.childTokens&&(R.childTokens[Q.name]=Q.childTokens)})),k.renderer&&function(){var Q=Y.defaults.renderer||new Pe,te=function(we){var Ne=Q[we];Q[we]=function(){for(var Ae=arguments.length,ve=new Array(Ae),Ie=0;Ie<Ae;Ie++)ve[Ie]=arguments[Ie];var Oe=k.renderer[we].apply(Q,ve);return Oe===!1&&(Oe=Ne.apply(Q,ve)),Oe}};for(var se in k.renderer)te(se);C.renderer=Q}(),k.tokenizer&&function(){var Q=Y.defaults.tokenizer||new ue,te=function(we){var Ne=Q[we];Q[we]=function(){for(var Ae=arguments.length,ve=new Array(Ae),Ie=0;Ie<Ae;Ie++)ve[Ie]=arguments[Ie];var Oe=k.tokenizer[we].apply(Q,ve);return Oe===!1&&(Oe=Ne.apply(Q,ve)),Oe}};for(var se in k.tokenizer)te(se);C.tokenizer=Q}(),k.walkTokens){var H=Y.defaults.walkTokens;C.walkTokens=function(Q){var te=[];return te.push(k.walkTokens.call(this,Q)),H&&(te=te.concat(H.call(this,Q))),te}}A&&(C.extensions=R),Y.setOptions(C)})},Y.walkTokens=function(P,O){for(var q=[],C=function(){var H=A.value;switch(q=q.concat(O.call(Y,H)),H.type){case"table":{for(var Q=U(H.header),te;!(te=Q()).done;){var se=te.value;q=q.concat(Y.walkTokens(se.tokens,O))}for(var ge=U(H.rows),we;!(we=ge()).done;)for(var Ne=we.value,Ae=U(Ne),ve;!(ve=Ae()).done;){var Ie=ve.value;q=q.concat(Y.walkTokens(Ie.tokens,O))}break}case"list":{q=q.concat(Y.walkTokens(H.items,O));break}default:Y.defaults.extensions&&Y.defaults.extensions.childTokens&&Y.defaults.extensions.childTokens[H.type]?Y.defaults.extensions.childTokens[H.type].forEach(function(Oe){q=q.concat(Y.walkTokens(H[Oe],O))}):H.tokens&&(q=q.concat(Y.walkTokens(H.tokens,O)))}},R=U(P),A;!(A=R()).done;)C();return q},Y.parseInline=function(P,O){if(typeof P>"u"||P===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof P!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(P)+", string expected");O=B({},Y.defaults,O||{}),N(O);try{var q=Te.lexInline(P,O);return O.walkTokens&&Y.walkTokens(q,O.walkTokens),fe.parseInline(q,O)}catch(C){if(C.message+=`
Please report this to https://github.com/markedjs/marked.`,O.silent)return"<p>An error occurred:</p><pre>"+e(C.message+"",!0)+"</pre>";throw C}},Y.Parser=fe,Y.parser=fe.parse,Y.Renderer=Pe,Y.TextRenderer=de,Y.Lexer=Te,Y.lexer=Te.lex,Y.Tokenizer=ue,Y.Slugger=ie,Y.parse=Y;var _=Y.options,G=Y.setOptions,E=Y.use,K=Y.walkTokens,g=Y.parseInline,p=Y,V=fe.parse,L=Te.lex;re.Lexer=Te,re.Parser=fe,re.Renderer=Pe,re.Slugger=ie,re.TextRenderer=de,re.Tokenizer=ue,re.getDefaults=w,re.lexer=L,re.marked=Y,re.options=_,re.parse=p,re.parseInline=g,re.parser=V,re.setOptions=G,re.use=E,re.walkTokens=K,Object.defineProperty(re,"__esModule",{value:!0})}),define(be[78],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LR=void 0;class y{constructor(i,U=0,w=i.length,D=U-1){this.a=i,this.b=U,this.c=w,this.d=D}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$LR=y}),define(be[79],$e([1,0,78]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NR=t.$MR=void 0;class F{constructor(w=[],D=10){this.h(w),this.b=D,this.d()}getHistory(){return this.j}add(w){this.a.delete(w),this.a.add(w),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(w){return this.a.has(w)}clear(){this.h([]),this.d()}d(){this.f();const w=this.j;this.c=new y.$LR(w,0,w.length,w.length)}f(){const w=this.j;w.length>this.b&&this.h(w.slice(w.length-this.b))}g(){const w=this.c.current();return w?this.j.indexOf(w):-1}h(w){this.a=new Set;for(const D of w)this.a.add(D)}get j(){const w=[];return this.a.forEach(D=>w.push(D)),w}}t.$MR=F;class i{get size(){return this.f}constructor(w,D=10){if(this.g=D,w.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:w[0],previous:void 0,next:void 0},this.a=new Set([w[0]]);for(let h=1;h<w.length;h++)this.add(w[h])}add(w){const D={value:w,previous:this.c,next:void 0};for(this.c.next=D,this.c=D,this.d=this.c,this.f++,this.a.has(w)?this.h(w):this.a.add(w);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(w){if(this.c.value===w)return w;const D=this.c.value;return this.a.delete(D),this.c.value=w,this.a.has(w)?this.h(w):this.a.add(w),D}prepend(w){if(this.f===this.g||this.a.has(w))return;const D={value:w,previous:void 0,next:this.b};this.b.previous=D,this.b=D,this.f++,this.a.add(w)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(w){return this.a.has(w)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let w=this.b;for(;w;)yield w.value,w=w.next}h(w){let D=this.b;for(;D!==this.c;)D.value===w&&(D===this.b?(this.b=this.b.next,this.b.previous=void 0):(D.previous.next=D.next,D.next.previous=D.previous),this.f--),D=D.next}}t.$NR=i}),define(be[45],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ql=t.$Pl=t.$Ol=t.rot=t.$Ml=void 0;function y(D,h,f){return Math.min(Math.max(D,h),f)}t.$Ml=y;function F(D,h){return(h+D%h)%h}t.rot=F;class i{constructor(){this.a=0}getNext(){return this.a++}}t.$Ol=i;class U{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Pl=U;class w{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const f=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Ql=w}),define(be[46],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var y;(function(F){function i(h,f){if(h.start>=f.end||f.start>=h.end)return{start:0,end:0};const d=Math.max(h.start,f.start),T=Math.min(h.end,f.end);return T-d<=0?{start:0,end:0}:{start:d,end:T}}F.intersect=i;function U(h){return h.end-h.start<=0}F.isEmpty=U;function w(h,f){return!U(i(h,f))}F.intersects=w;function D(h,f){const d=[],T={start:h.start,end:Math.min(f.start,h.end)},s={start:Math.max(f.end,h.start),end:h.end};return U(T)||d.push(T),U(s)||d.push(s),d}F.relativeComplement=D})(y||(t.Range=y={}))}),define(be[80],$e([1,0,46]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EQ=t.$DQ=t.$CQ=t.$BQ=void 0;function F(h,f){const d=[];for(const T of f){if(h.start>=T.range.end)continue;if(h.end<T.range.start)break;const s=y.Range.intersect(h,T.range);y.Range.isEmpty(s)||d.push({range:s,size:T.size})}return d}t.$BQ=F;function i({start:h,end:f},d){return{start:h+d,end:f+d}}t.$CQ=i;function U(h){const f=[];let d=null;for(const T of h){const s=T.range.start,a=T.range.end,e=T.size;if(d&&e===d.size){d.range.end=a;continue}d={range:{start:s,end:a},size:e},f.push(d)}return f}t.$DQ=U;function w(...h){return U(h.reduce((f,d)=>f.concat(d),[]))}class D{get paddingTop(){return this.c}set paddingTop(f){this.b=this.b+f-this.c,this.c=f}constructor(f){this.a=[],this.b=0,this.c=0,this.c=f??0,this.b=this.c}splice(f,d,T=[]){const s=T.length-d,a=F({start:0,end:f},this.a),e=F({start:f+d,end:Number.POSITIVE_INFINITY},this.a).map(l=>({range:i(l.range,s),size:l.size})),u=T.map((l,m)=>({range:{start:f+m,end:f+m+1},size:l.size}));this.a=w(a,u,e),this.b=this.c+this.a.reduce((l,m)=>l+m.size*(m.range.end-m.range.start),0)}get count(){const f=this.a.length;return f?this.a[f-1].range.end:0}get size(){return this.b}indexAt(f){if(f<0)return-1;if(f<this.c)return 0;let d=0,T=this.c;for(const s of this.a){const a=s.range.end-s.range.start,e=T+a*s.size;if(f<e)return d+Math.floor((f-T)/s.size);d+=a,T=e}return d}indexAfter(f){return Math.min(this.indexAt(f)+1,this.count)}positionAt(f){if(f<0)return-1;let d=0,T=0;for(const s of this.a){const a=s.range.end-s.range.start,e=T+a;if(f<e)return this.c+d+(f-T)*s.size;d+=a*s.size,T=e}return-1}}t.$EQ=D}),define(be[81],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jd=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(U){return new F(U)}constructor(U){this.c=y&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Jd=F}),define(be[4],$e([1,0,6,42,2,44,81]),function(re,t,y,F,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.Event=void 0;const D=!1,h=!1;var f;(function(W){W.None=()=>i.$Sc.None;function I(R){if(h){const{onDidAddListener:A}=R,k=e.create();let H=0;R.onDidAddListener=()=>{++H===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),k.print()),A?.()}}}function N(R,A){return Pe(R,()=>{},0,void 0,!0,void 0,A)}W.defer=N;function J(R){return(A,k=null,H)=>{let Q=!1,te;return te=R(se=>{if(!Q)return te?te.dispose():Q=!0,A.call(k,se)},null,H),Q&&te.dispose(),te}}W.once=J;function ee(R,A,k){return Ce((H,Q=null,te)=>R(se=>H.call(Q,A(se)),null,te),k)}W.map=ee;function ne(R,A,k){return Ce((H,Q=null,te)=>R(se=>{A(se),H.call(Q,se)},null,te),k)}W.forEach=ne;function ue(R,A,k){return Ce((H,Q=null,te)=>R(se=>A(se)&&H.call(Q,se),null,te),k)}W.filter=ue;function le(R){return R}W.signal=le;function oe(...R){return(A,k=null,H)=>{const Q=(0,i.$Pc)(...R.map(te=>te(se=>A.call(k,se))));return Te(Q,H)}}W.any=oe;function me(R,A,k,H){let Q=k;return ee(R,te=>(Q=A(Q,te),Q),H)}W.reduce=me;function Ce(R,A){let k;const H={onWillAddFirstListener(){k=R(Q.fire,Q)},onDidRemoveLastListener(){k?.dispose()}};A||I(H);const Q=new r(H);return A?.add(Q),Q.event}function Te(R,A){return A instanceof Array?A.push(R):A&&A.add(R),R}function Pe(R,A,k=100,H=!1,Q=!1,te,se){let ge,we,Ne,Ae=0,ve;const Ie={leakWarningThreshold:te,onWillAddFirstListener(){ge=R(qe=>{Ae++,we=A(we,qe),H&&!Ne&&(Oe.fire(we),we=void 0),ve=()=>{const ze=we;we=void 0,Ne=void 0,(!H||Ae>1)&&Oe.fire(ze),Ae=0},typeof k=="number"?(clearTimeout(Ne),Ne=setTimeout(ve,k)):Ne===void 0&&(Ne=0,queueMicrotask(ve))})},onWillRemoveListener(){Q&&Ae>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,ge.dispose()}};se||I(Ie);const Oe=new r(Ie);return se?.add(Oe),Oe.event}W.debounce=Pe;function de(R,A=0,k){return W.debounce(R,(H,Q)=>H?(H.push(Q),H):[Q],A,void 0,!0,void 0,k)}W.accumulate=de;function ie(R,A=(H,Q)=>H===Q,k){let H=!0,Q;return ue(R,te=>{const se=H||!A(te,Q);return H=!1,Q=te,se},k)}W.latch=ie;function fe(R,A,k){return[W.filter(R,A,k),W.filter(R,H=>!A(H),k)]}W.split=fe;function Y(R,A=!1,k=[],H){let Q=k.slice(),te=R(we=>{Q?Q.push(we):ge.fire(we)});H&&H.add(te);const se=()=>{Q?.forEach(we=>ge.fire(we)),Q=null},ge=new r({onWillAddFirstListener(){te||(te=R(we=>ge.fire(we)),H&&H.add(te))},onDidAddFirstListener(){Q&&(A?setTimeout(se):se())},onDidRemoveLastListener(){te&&te.dispose(),te=null}});return H&&H.add(ge),ge.event}W.buffer=Y;function _(R,A){return(H,Q,te)=>{const se=A(new E);return R(function(ge){const we=se.evaluate(ge);we!==G&&H.call(Q,we)},void 0,te)}}W.chain=_;const G=Symbol("HaltChainable");class E{constructor(){this.f=[]}map(A){return this.f.push(A),this}forEach(A){return this.f.push(k=>(A(k),k)),this}filter(A){return this.f.push(k=>A(k)?k:G),this}reduce(A,k){let H=k;return this.f.push(Q=>(H=A(H,Q),H)),this}latch(A=(k,H)=>k===H){let k=!0,H;return this.f.push(Q=>{const te=k||!A(Q,H);return k=!1,H=Q,te?Q:G}),this}evaluate(A){for(const k of this.f)if(A=k(A),A===G)break;return A}}function K(R,A,k=H=>H){const H=(...ge)=>se.fire(k(...ge)),Q=()=>R.on(A,H),te=()=>R.removeListener(A,H),se=new r({onWillAddFirstListener:Q,onDidRemoveLastListener:te});return se.event}W.fromNodeEventEmitter=K;function g(R,A,k=H=>H){const H=(...ge)=>se.fire(k(...ge)),Q=()=>R.addEventListener(A,H),te=()=>R.removeEventListener(A,H),se=new r({onWillAddFirstListener:Q,onDidRemoveLastListener:te});return se.event}W.fromDOMEventEmitter=g;function p(R){return new Promise(A=>J(R)(A))}W.toPromise=p;function V(R){const A=new r;return R.then(k=>{A.fire(k)},()=>{A.fire(void 0)}).finally(()=>{A.dispose()}),A.event}W.fromPromise=V;function L(R,A){return A(void 0),R(k=>A(k))}W.runAndSubscribe=L;function P(R,A){let k=null;function H(te){k?.dispose(),k=new i.$Rc,A(te,k)}H(void 0);const Q=R(te=>H(te));return(0,i.$Qc)(()=>{Q.dispose(),k?.dispose()})}W.runAndSubscribeWithStore=P;class O{constructor(A,k){this._observable=A,this.f=0,this.g=!1;const H={onWillAddFirstListener:()=>{A.addObserver(this)},onDidRemoveLastListener:()=>{A.removeObserver(this)}};k||I(H),this.emitter=new r(H),k&&k.add(this.emitter)}beginUpdate(A){this.f++}handlePossibleChange(A){}handleChange(A,k){this.g=!0}endUpdate(A){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function q(R,A){return new O(R,A).emitter.event}W.fromObservable=q;function C(R){return A=>{let k=0,H=!1;const Q={beginUpdate(){k++},endUpdate(){k--,k===0&&(R.reportChanges(),H&&(H=!1,A()))},handlePossibleChange(){},handleChange(){H=!0}};return R.addObserver(Q),R.reportChanges(),{dispose(){R.removeObserver(Q)}}}}W.fromObservableLight=C})(f||(t.Event=f={}));class d{static{this.all=new Set}static{this.f=0}constructor(I){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${I}_${d.f++}`,d.all.add(this)}start(I){this.g=new w.$Jd,this.listenerCount=I}stop(){if(this.g){const I=this.g.elapsed();this.durations.push(I),this.elapsedOverall+=I,this.invocationCount+=1,this.g=void 0}}}t.$Ld=d;let T=-1;function s(W){const I=T;return T=W,{dispose(){T=I}}}t.$Md=s;class a{constructor(I,N=Math.random().toString(18).slice(2,5)){this.threshold=I,this.name=N,this.g=0}dispose(){this.f?.clear()}check(I,N){const J=this.threshold;if(J<=0||N<J)return;this.f||(this.f=new Map);const ee=this.f.get(I.value)||0;if(this.f.set(I.value,ee+1),this.g-=1,this.g<=0){this.g=J*.5;let ne,ue=0;for(const[le,oe]of this.f)(!ne||ue<oe)&&(ne=le,ue=oe);console.warn(`[${this.name}] potential listener LEAK detected, having ${N} listeners already. MOST frequent listener (${ue}):`),console.warn(ne)}return()=>{const ne=this.f.get(I.value)||0;this.f.set(I.value,ne-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(I){this.value=I}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let u=0;class l{constructor(I){this.value=I,this.id=u++}}const m=2,n=(W,I)=>{if(W instanceof l)I(W);else for(let N=0;N<W.length;N++){const J=W[N];J&&I(J)}};class r{constructor(I){this.w=0,this.f=I,this.g=T>0||this.f?.leakWarningThreshold?new a(this.f?.leakWarningThreshold??T):void 0,this.j=this.f?._profName?new d(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(D){const I=this.t;queueMicrotask(()=>{n(I,N=>N.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(I,N,J)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$Sc.None;if(this.m)return i.$Sc.None;N&&(I=I.bind(N));const ee=new l(I);let ne,ue;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ee.stack=e.create(),ne=this.g.check(ee.stack,this.w+1)),D&&(ee.stack=ue??e.create()),this.t?this.t instanceof l?(this.u??=new c,this.t=[this.t,ee]):this.t.push(ee):(this.f?.onWillAddFirstListener?.(this),this.t=ee,this.f?.onDidAddFirstListener?.(this)),this.w++;const le=(0,i.$Qc)(()=>{ne?.(),this.x(ee)});return J instanceof i.$Rc?J.add(le):Array.isArray(J)&&J.push(le),le},this.q}x(I){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const N=this.t,J=N.indexOf(I);if(J===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,N[J]=void 0;const ee=this.u.current===this;if(this.w*m<=N.length){let ne=0;for(let ue=0;ue<N.length;ue++)N[ue]?N[ne++]=N[ue]:ee&&(this.u.end--,ne<this.u.i&&this.u.i--);N.length=ne}}y(I,N){if(!I)return;const J=this.f?.onListenerError||y.$1;if(!J){I.value(N);return}try{I.value(N)}catch(ee){J(ee)}}z(I){const N=I.current.t;for(;I.i<I.end;)this.y(N[I.i++],I.value);I.reset()}fire(I){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,I);else{const N=this.u;N.enqueue(this,I,this.t.length),this.z(N)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Nd=r;const $=()=>new c;t.$Od=$;class c{constructor(){this.i=-1,this.end=0}enqueue(I,N,J){this.i=0,this.end=J,this.current=I,this.value=N}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class o extends r{async fireAsync(I,N,J){if(this.t)for(this.h||(this.h=new U.$2c),n(this.t,ee=>this.h.push([ee.value,I]));this.h.size>0&&!N.isCancellationRequested;){const[ee,ne]=this.h.shift(),ue=[],le={...ne,token:N,waitUntil:oe=>{if(Object.isFrozen(ue))throw new Error("waitUntil can NOT be called asynchronous");J&&(oe=J(oe,ee)),ue.push(oe)}};try{ee(le)}catch(oe){(0,y.$1)(oe);continue}Object.freeze(ue),await Promise.allSettled(ue).then(oe=>{for(const me of oe)me.status==="rejected"&&(0,y.$1)(me.reason)})}}}t.$Pd=o;class S extends r{get isPaused(){return this.h!==0}constructor(I){super(I),this.h=0,this.s=new U.$2c,this.A=I?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const I=Array.from(this.s);this.s.clear(),super.fire(this.A(I))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(I){this.w&&(this.h!==0?this.s.push(I):super.fire(I))}}t.$Qd=S;class j extends S{constructor(I){super(I),this.k=I.delay??100}fire(I){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(I)}}t.$Rd=j;class M extends r{constructor(I){super(I),this.h=[],this.k=I?.merge}fire(I){this.hasListeners()&&(this.h.push(I),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(N=>super.fire(N)),this.h=[]}))}}t.$Sd=M;class b{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(I){const N={event:I,listener:null};this.h.push(N),this.g&&this.m(N);const J=()=>{this.g&&this.o(N);const ee=this.h.indexOf(N);this.h.splice(ee,1)};return(0,i.$Qc)((0,F.$db)(J))}j(){this.g=!0,this.h.forEach(I=>this.m(I))}k(){this.g=!1,this.h.forEach(I=>this.o(I))}m(I){I.listener=I.event(N=>this.f.fire(N))}o(I){I.listener&&I.listener.dispose(),I.listener=null}dispose(){this.f.dispose()}}t.$Td=b;class v{constructor(I,N,J,ee){this.f=new i.$Rc;const ne=this.f.add(new b),ue=this.f.add(new i.$1c);function le(oe){ue.set(oe,ne.add(ee(oe)))}for(const oe of I)le(oe);this.f.add(N(oe=>{le(oe)})),this.f.add(J(oe=>{ue.deleteAndDispose(oe)})),this.event=ne.event}dispose(){this.f.dispose()}}t.$Ud=v;class B{constructor(){this.f=[]}wrapEvent(I){return(N,J,ee)=>I(ne=>{const ue=this.f[this.f.length-1];ue?ue.push(()=>N.call(J,ne)):N.call(J,ne)},void 0,ee)}bufferEvents(I){const N=[];this.f.push(N);const J=I();return this.f.pop(),N.forEach(ee=>ee()),J}}t.$Vd=B;class z{constructor(){this.f=!1,this.g=f.None,this.h=i.$Sc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(I){this.g=I,this.f&&(this.h.dispose(),this.h=I(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$Wd=z}),define(be[16],$e([1,0,4,2]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qO=t.$pO=t.$oO=t.$nO=t.$mO=t.$lO=t.$kO=t.$jO=t.$iO=t.$hO=t.$gO=t.$fO=t.$eO=t.$dO=t.$cO=t.$bO=t.$aO=t.$_N=void 0;class i{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new y.$Nd,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new i}getZoomLevel(){return this.a}setZoomLevel($){this.a!==$&&(this.a=$)}getZoomFactor(){return this.b}setZoomFactor($){this.b=$}setFullscreen($){this.c!==$&&(this.c=$,this.d.fire())}isFullscreen(){return this.c}}class U extends F.$Sc{constructor(){super(),this.a=this.B(new y.$Nd),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f($){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),$&&this.a.fire()}}class w extends F.$Sc{get value(){return this.b}constructor(){super(),this.a=this.B(new y.$Nd),this.onDidChange=this.a.event,this.b=this.c();const $=this.B(new U);this.B($.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const $=document.createElement("canvas").getContext("2d"),c=window.devicePixelRatio||1,o=$.webkitBackingStorePixelRatio||$.mozBackingStorePixelRatio||$.msBackingStorePixelRatio||$.oBackingStorePixelRatio||$.backingStorePixelRatio||1;return c/o}}class D{constructor(){this.a=null}b(){return this.a||(this.a=(0,F.$Lc)(new w)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function h(r,$){typeof r=="string"&&(r=window.matchMedia(r)),r.addEventListener("change",$)}t.$_N=h,t.$aO=new D;function f(r){i.INSTANCE.setZoomLevel(r)}t.$bO=f;function d(){return i.INSTANCE.getZoomLevel()}t.$cO=d;function T(){return i.INSTANCE.getZoomFactor()}t.$dO=T;function s(r){i.INSTANCE.setZoomFactor(r)}t.$eO=s;function a(r){i.INSTANCE.setFullscreen(r)}t.$fO=a;function e(){return i.INSTANCE.isFullscreen()}t.$gO=e,t.$hO=i.INSTANCE.onDidChangeFullscreen;const u=navigator.userAgent;t.$iO=u.indexOf("Firefox")>=0,t.$jO=u.indexOf("AppleWebKit")>=0,t.$kO=u.indexOf("Chrome")>=0,t.$lO=!t.$kO&&u.indexOf("Safari")>=0,t.$mO=!t.$kO&&!t.$lO&&t.$jO,t.$nO=u.indexOf("Electron/")>=0,t.$oO=u.indexOf("Android")>=0;let l=!1;if(window.matchMedia){const r=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),$=window.matchMedia("(display-mode: fullscreen)");l=r.matches,h(r,({matches:c})=>{l&&$.matches||(l=c)})}function m(){return l}t.$pO=m;function n(){return navigator?.windowControlsOverlay?.visible}t.$qO=n}),define(be[21],$e([1,0,4]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tQ=void 0;class F{get event(){return this.a.event}constructor(U,w,D){const h=f=>this.a.fire(f);this.a=new y.$Nd({onWillAddFirstListener:()=>U.addEventListener(w,h,D),onDidRemoveLastListener:()=>U.removeEventListener(w,h,D)})}dispose(){this.a.dispose()}}t.$tQ=F}),define(be[28],$e([1,0,4]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xd=t.CancellationToken=void 0;const F=Object.freeze(function(D,h){const f=setTimeout(D.bind(h),0);return{dispose(){clearTimeout(f)}}});var i;(function(D){function h(f){return f===D.None||f===D.Cancelled||f instanceof U?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}D.isCancellationToken=h,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(i||(t.CancellationToken=i={}));class U{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new y.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class w{constructor(h){this.f=void 0,this.g=void 0,this.g=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new U),this.f}cancel(){this.f?this.f instanceof U&&this.f.cancel():this.f=i.Cancelled}dispose(h=!1){h&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof U&&this.f.dispose():this.f=i.None}}t.$Xd=w}),define(be[82],$e([1,0,28]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ye=t.$xe=t.$we=void 0;class F{constructor(D){this.b=D,this.a=null}get(){if(this.a)return this.a;const D=new y.$Xd,h=this.b(D.token);return this.a={promise:h,dispose:()=>{this.a=null,D.cancel(),D.dispose()}},this.a}}t.$we=F;class i{constructor(D){this.c=D,this.a=void 0,this.b=void 0}get(D){const h=JSON.stringify(D);return this.b!==h&&(this.b=h,this.a=this.c(D)),this.a}}t.$xe=i;class U{get cachedValues(){return this.a}constructor(D){this.b=D,this.a=new Map}get(D){if(this.a.has(D))return this.a.get(D);const h=this.b(D);return this.a.set(D,h),h}}t.$ye=U}),define(be[47],$e([1,0,4,2]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vr=t.$Ur=t.$Tr=t.$Sr=t.ScrollbarVisibility=void 0;var i;(function(a){a[a.Auto=1]="Auto",a[a.Hidden=2]="Hidden",a[a.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class U{constructor(e,u,l,m,n,r,$){this.c=e,this._scrollStateBrand=void 0,this.c&&(u=u|0,l=l|0,m=m|0,n=n|0,r=r|0,$=$|0),this.rawScrollLeft=m,this.rawScrollTop=$,u<0&&(u=0),m+u>l&&(m=l-u),m<0&&(m=0),n<0&&(n=0),$+n>r&&($=r-n),$<0&&($=0),this.width=u,this.scrollWidth=l,this.scrollLeft=m,this.height=n,this.scrollHeight=r,this.scrollTop=$}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,u){return new U(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,u?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,u?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new U(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,u){const l=this.width!==e.width,m=this.scrollWidth!==e.scrollWidth,n=this.scrollLeft!==e.scrollLeft,r=this.height!==e.height,$=this.scrollHeight!==e.scrollHeight,c=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:u,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:l,scrollWidthChanged:m,scrollLeftChanged:n,heightChanged:r,scrollHeightChanged:$,scrollTopChanged:c}}}t.$Sr=U;class w extends F.$Sc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new y.$Nd),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new U(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,u){const l=this.g.withScrollDimensions(e,u);this.n(l,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const u=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(u,!1)}setScrollPositionSmooth(e,u){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const l=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===l.scrollLeft&&this.h.to.scrollTop===l.scrollTop)return;let m;u?m=new d(this.h.from,l,this.h.startTime,this.h.duration):m=this.h.combine(this.g,l,this.c),this.h.dispose(),this.h=m}else{const l=this.g.withScrollPosition(e);this.h=d.start(this.g,l,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),u=this.g.withScrollPosition(e);if(this.n(u,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,u){const l=this.g;l.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(l,u)))}}t.$Tr=w;class D{constructor(e,u,l){this.scrollLeft=e,this.scrollTop=u,this.isDone=l}}t.$Ur=D;function h(a,e){const u=e-a;return function(l){return a+u*s(l)}}function f(a,e,u){return function(l){return l<u?a(l/u):e((l-u)/(1-u))}}class d{constructor(e,u,l,m){this.from=e,this.to=u,this.duration=m,this.startTime=l,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,u,l){if(Math.abs(e-u)>2.5*l){let n,r;return e<u?(n=e+.75*l,r=u-.75*l):(n=e-.75*l,r=u+.75*l),f(h(e,n),h(r,u),.33)}return h(e,u)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const u=(e-this.startTime)/this.duration;if(u<1){const l=this.c(u),m=this.d(u);return new D(l,m,!1)}return new D(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,u,l){return d.start(e,u,l)}static start(e,u,l){l=l+10;const m=Date.now()-10;return new d(e,u,m,l)}}t.$Vr=d;function T(a){return Math.pow(a,3)}function s(a){return 1-T(1-a)}}),define(be[83],$e([1,0,6,2]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=void 0;function i($){const c=$;return c?typeof c.read=="function":!1}t.$Yd=i;function U($){const c=$;return c?[c.on,c.pause,c.resume,c.destroy].every(o=>typeof o=="function"):!1}t.$Zd=U;function w($){const c=$;return c?U(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}t.$1d=w;function D($,c){return new h($,c)}t.$2d=D;class h{constructor(c,o){this.e=c,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(o=>o(c))}h(c){this.c.error.length===0?(0,y.$1)(c):this.c.error.slice(0).forEach(o=>o(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,o){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(c,o){if(this.a.destroyed)return;let S;switch(c){case"data":S=this.c.data;break;case"end":S=this.c.end;break;case"error":S=this.c.error;break}if(S){const j=S.indexOf(o);j>=0&&S.splice(j,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(S=>S())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f($,c){const o=[];let S;for(;(S=$.read())!==null;)o.push(S);return c(o)}t.$3d=f;function d($,c,o){const S=[];let j;for(;(j=$.read())!==null&&S.length<o;)S.push(j);return j===null&&S.length>0?c(S):{read:()=>{if(S.length>0)return S.shift();if(typeof j<"u"){const M=j;return j=void 0,M}return $.read()}}}t.$4d=d;function T($,c){return new Promise((o,S)=>{const j=[];s($,{onData:M=>{c&&j.push(M)},onError:M=>{c?S(M):o(void 0)},onEnd:()=>{o(c?c(j):void 0)}})})}t.$5d=T;function s($,c,o){$.on("error",S=>{o?.isCancellationRequested||c.onError(S)}),$.on("end",()=>{o?.isCancellationRequested||c.onEnd()}),$.on("data",S=>{o?.isCancellationRequested||c.onData(S)})}t.$6d=s;function a($,c){return new Promise((o,S)=>{const j=new F.$Rc,M=[],b=z=>{if(M.push(z),M.length>c)return j.dispose(),$.pause(),o({stream:$,buffer:M,ended:!1})},v=z=>(j.dispose(),S(z)),B=()=>(j.dispose(),o({stream:$,buffer:M,ended:!0}));j.add((0,F.$Qc)(()=>$.removeListener("error",v))),$.on("error",v),j.add((0,F.$Qc)(()=>$.removeListener("end",B))),$.on("end",B),j.add((0,F.$Qc)(()=>$.removeListener("data",b))),$.on("data",b)})}t.$7d=a;function e($,c){const o=D(c);return o.end($),o}t.$8d=e;function u(){const $=D(()=>{throw new Error("not supported")});return $.end(),$}t.$9d=u;function l($){let c=!1;return{read:()=>c?null:(c=!0,$)}}t.$0d=l;function m($,c,o){const S=D(o);return s($,{onData:j=>S.write(c.data(j)),onError:j=>S.error(c.error?c.error(j):j),onEnd:()=>S.end()}),S}t.$$d=m;function n($,c,o){let S=!1;return{read:()=>{const j=c.read();return S?j:(S=!0,j!==null?o([$,j]):$)}}}t.$_d=n;function r($,c,o){let S=!1;const j=D(o);return s(c,{onData:M=>S?j.write(M):(S=!0,j.write(o([$,M]))),onError:M=>j.error(M),onEnd:()=>{S||(S=!0,j.write($)),j.end()}}),j}t.$ae=r}),define(be[32],$e([1,0,27,83]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=void 0;const i=typeof Buffer<"u",U=new y.$V(()=>new Uint8Array(256));let w,D;class h{static alloc(N){return i?new h(Buffer.allocUnsafe(N)):new h(new Uint8Array(N))}static wrap(N){return i&&!Buffer.isBuffer(N)&&(N=Buffer.from(N.buffer,N.byteOffset,N.byteLength)),new h(N)}static fromString(N,J){return!(J?.dontUseNodeBuffer||!1)&&i?new h(Buffer.from(N)):(w||(w=new TextEncoder),new h(w.encode(N)))}static fromByteArray(N){const J=h.alloc(N.length);for(let ee=0,ne=N.length;ee<ne;ee++)J.buffer[ee]=N[ee];return J}static concat(N,J){if(typeof J>"u"){J=0;for(let ue=0,le=N.length;ue<le;ue++)J+=N[ue].byteLength}const ee=h.alloc(J);let ne=0;for(let ue=0,le=N.length;ue<le;ue++){const oe=N[ue];ee.set(oe,ne),ne+=oe.byteLength}return ee}constructor(N){this.buffer=N,this.byteLength=this.buffer.byteLength}clone(){const N=h.alloc(this.byteLength);return N.set(this),N}toString(){return i?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(N,J){return new h(this.buffer.subarray(N,J))}set(N,J){if(N instanceof h)this.buffer.set(N.buffer,J);else if(N instanceof Uint8Array)this.buffer.set(N,J);else if(N instanceof ArrayBuffer)this.buffer.set(new Uint8Array(N),J);else if(ArrayBuffer.isView(N))this.buffer.set(new Uint8Array(N.buffer,N.byteOffset,N.byteLength),J);else throw new Error("Unknown argument 'array'")}readUInt32BE(N){return s(this.buffer,N)}writeUInt32BE(N,J){a(this.buffer,N,J)}readUInt32LE(N){return e(this.buffer,N)}writeUInt32LE(N,J){u(this.buffer,N,J)}readUInt8(N){return l(this.buffer,N)}writeUInt8(N,J){m(this.buffer,N,J)}indexOf(N,J=0){return f(this.buffer,N instanceof h?N.buffer:N,J)}}t.$be=h;function f(I,N,J=0){const ee=N.byteLength,ne=I.byteLength;if(ee===0)return 0;if(ee===1)return I.indexOf(N[0]);if(ee>ne-J)return-1;const ue=U.value;ue.fill(N.length);for(let Ce=0;Ce<N.length;Ce++)ue[N[Ce]]=N.length-Ce-1;let le=J+N.length-1,oe=le,me=-1;for(;le<ne;)if(I[le]===N[oe]){if(oe===0){me=le;break}le--,oe--}else le+=Math.max(N.length-oe,ue[I[le]]),oe=N.length-1;return me}t.$ce=f;function d(I,N){return I[N+0]<<0>>>0|I[N+1]<<8>>>0}t.$de=d;function T(I,N,J){I[J+0]=N&255,N=N>>>8,I[J+1]=N&255}t.$ee=T;function s(I,N){return I[N]*2**24+I[N+1]*2**16+I[N+2]*2**8+I[N+3]}t.$fe=s;function a(I,N,J){I[J+3]=N,N=N>>>8,I[J+2]=N,N=N>>>8,I[J+1]=N,N=N>>>8,I[J]=N}t.$ge=a;function e(I,N){return I[N+0]<<0>>>0|I[N+1]<<8>>>0|I[N+2]<<16>>>0|I[N+3]<<24>>>0}t.$he=e;function u(I,N,J){I[J+0]=N&255,N=N>>>8,I[J+1]=N&255,N=N>>>8,I[J+2]=N&255,N=N>>>8,I[J+3]=N&255}t.$ie=u;function l(I,N){return I[N]}t.$je=l;function m(I,N,J){I[J]=N}t.$ke=m;function n(I){return F.$3d(I,N=>h.concat(N))}t.$le=n;function r(I){return F.$0d(I)}t.$me=r;function $(I){return F.$5d(I,N=>h.concat(N))}t.$ne=$;async function c(I){return I.ended?h.concat(I.buffer):h.concat([...I.buffer,await $(I.stream)])}t.$oe=c;function o(I){return F.$8d(I,N=>h.concat(N))}t.$pe=o;function S(I){return F.$$d(I,{data:N=>typeof N=="string"?h.fromString(N):h.wrap(N)},N=>h.concat(N))}t.$qe=S;function j(I){return F.$2d(N=>h.concat(N),I)}t.$re=j;function M(I,N){return F.$_d(I,N,J=>h.concat(J))}t.$se=M;function b(I,N){return F.$ae(I,N,J=>h.concat(J))}t.$te=b;function v(I){let N=0,J=0,ee=0;const ne=new Uint8Array(Math.floor(I.length/4*3)),ue=oe=>{switch(J){case 3:ne[ee++]=N|oe,J=0;break;case 2:ne[ee++]=N|oe>>>2,N=oe<<6,J=3;break;case 1:ne[ee++]=N|oe>>>4,N=oe<<4,J=2;break;default:N=oe<<2,J=1}};for(let oe=0;oe<I.length;oe++){const me=I.charCodeAt(oe);if(me>=65&&me<=90)ue(me-65);else if(me>=97&&me<=122)ue(me-97+26);else if(me>=48&&me<=57)ue(me-48+52);else if(me===43||me===45)ue(62);else if(me===47||me===95)ue(63);else{if(me===61)break;throw new SyntaxError(`Unexpected base64 character ${I[oe]}`)}}const le=ee;for(;J>0;)ue(0);return h.wrap(ne).slice(0,le)}t.$ue=v;const B="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",z="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function W({buffer:I},N=!0,J=!1){const ee=J?z:B;let ne="";const ue=I.byteLength%3;let le=0;for(;le<I.byteLength-ue;le+=3){const oe=I[le+0],me=I[le+1],Ce=I[le+2];ne+=ee[oe>>>2],ne+=ee[(oe<<4|me>>>4)&63],ne+=ee[(me<<2|Ce>>>6)&63],ne+=ee[Ce&63]}if(ue===1){const oe=I[le+0];ne+=ee[oe>>>2],ne+=ee[oe<<4&63],N&&(ne+="==")}else if(ue===2){const oe=I[le+0],me=I[le+1];ne+=ee[oe>>>2],ne+=ee[(oe<<4|me>>>4)&63],ne+=ee[me<<2&63],N&&(ne+="=")}return ne}t.$ve=W}),define(be[12],$e([1,0,82,27]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xf=t.$wf=t.$vf=t.$uf=t.GraphemeBreakType=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=t.$Be=void 0;function i(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}t.$Be=i;const U=/{(\d+)}/g;function w(Z,...ae){return ae.length===0?Z:Z.replace(U,function(pe,De){const Se=parseInt(De,10);return isNaN(Se)||Se<0||Se>=ae.length?pe:ae[Se]})}t.$Ce=w;const D=/{([^}]+)}/g;function h(Z,ae){return Z.replace(D,(pe,De)=>ae[De]??pe)}t.$De=h;function f(Z){return Z.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}t.$Ee=f;function d(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Fe=d;function T(Z,ae){let pe=0;const De=ae.charCodeAt(0);for(let Se=Z.length-1;Se>=0;Se--)Z.charCodeAt(Se)===De&&pe++;return pe}t.$Ge=T;function s(Z,ae,pe="\u2026"){return Z.length<=ae?Z:`${Z.substr(0,ae)}${pe}`}t.$He=s;function a(Z,ae=" "){const pe=e(Z,ae);return u(pe,ae)}t.$Ie=a;function e(Z,ae){if(!Z||!ae)return Z;const pe=ae.length;if(pe===0||Z.length===0)return Z;let De=0;for(;Z.indexOf(ae,De)===De;)De=De+pe;return Z.substring(De)}t.$Je=e;function u(Z,ae){if(!Z||!ae)return Z;const pe=ae.length,De=Z.length;if(pe===0||De===0)return Z;let Se=De,Re=-1;for(;Re=Z.lastIndexOf(ae,Se-1),!(Re===-1||Re+pe!==Se);){if(Re===0)return"";Se=Re}return Z.substring(0,Se)}t.$Ke=u;function l(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Le=l;function m(Z){return Z.replace(/\*/g,"")}t.$Me=m;function n(Z,ae,pe={}){if(!Z)throw new Error("Cannot create regex from empty string");ae||(Z=d(Z)),pe.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let De="";return pe.global&&(De+="g"),pe.matchCase||(De+="i"),pe.multiline&&(De+="m"),pe.unicode&&(De+="u"),new RegExp(Z,De)}t.$Ne=n;function r(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}t.$Oe=r;function $(Z){return Z.split(/\r\n|\r|\n/)}t.$Pe=$;function c(Z){for(let ae=0,pe=Z.length;ae<pe;ae++){const De=Z.charCodeAt(ae);if(De!==32&&De!==9)return ae}return-1}t.$Qe=c;function o(Z,ae=0,pe=Z.length){for(let De=ae;De<pe;De++){const Se=Z.charCodeAt(De);if(Se!==32&&Se!==9)return Z.substring(ae,De)}return Z.substring(ae,pe)}t.$Re=o;function S(Z,ae=Z.length-1){for(let pe=ae;pe>=0;pe--){const De=Z.charCodeAt(pe);if(De!==32&&De!==9)return pe}return-1}t.$Se=S;function j(Z,ae,pe){const De=[];let Se=0;for(const Re of Z.matchAll(ae)){if(De.push(Z.slice(Se,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Se=Re.index+Re[0].length,De.push(pe(Re[0],...Re.slice(1),Re.index,Z,Re.groups))}return De.push(Z.slice(Se)),Promise.all(De).then(Re=>Re.join(""))}t.$Te=j;function M(Z,ae){return Z<ae?-1:Z>ae?1:0}t.$Ue=M;function b(Z,ae,pe=0,De=Z.length,Se=0,Re=ae.length){for(;pe<De&&Se<Re;pe++,Se++){const Qe=Z.charCodeAt(pe),Ve=ae.charCodeAt(Se);if(Qe<Ve)return-1;if(Qe>Ve)return 1}const je=De-pe,Xe=Re-Se;return je<Xe?-1:je>Xe?1:0}t.$Ve=b;function v(Z,ae){return B(Z,ae,0,Z.length,0,ae.length)}t.$We=v;function B(Z,ae,pe=0,De=Z.length,Se=0,Re=ae.length){for(;pe<De&&Se<Re;pe++,Se++){let Qe=Z.charCodeAt(pe),Ve=ae.charCodeAt(Se);if(Qe===Ve)continue;if(Qe>=128||Ve>=128)return b(Z.toLowerCase(),ae.toLowerCase(),pe,De,Se,Re);W(Qe)&&(Qe-=32),W(Ve)&&(Ve-=32);const We=Qe-Ve;if(We!==0)return We}const je=De-pe,Xe=Re-Se;return je<Xe?-1:je>Xe?1:0}t.$Xe=B;function z(Z){return Z>=48&&Z<=57}t.$Ye=z;function W(Z){return Z>=97&&Z<=122}t.$Ze=W;function I(Z){return Z>=65&&Z<=90}t.$1e=I;function N(Z,ae){return Z.length===ae.length&&B(Z,ae)===0}t.$2e=N;function J(Z,ae){const pe=ae.length;return ae.length>Z.length?!1:B(Z,ae,0,pe)===0}t.$3e=J;function ee(Z,ae){const pe=Math.min(Z.length,ae.length);let De;for(De=0;De<pe;De++)if(Z.charCodeAt(De)!==ae.charCodeAt(De))return De;return pe}t.$4e=ee;function ne(Z,ae){const pe=Math.min(Z.length,ae.length);let De;const Se=Z.length-1,Re=ae.length-1;for(De=0;De<pe;De++)if(Z.charCodeAt(Se-De)!==ae.charCodeAt(Re-De))return De;return pe}t.$5e=ne;function ue(Z){return 55296<=Z&&Z<=56319}t.$6e=ue;function le(Z){return 56320<=Z&&Z<=57343}t.$7e=le;function oe(Z,ae){return(Z-55296<<10)+(ae-56320)+65536}t.$8e=oe;function me(Z,ae,pe){const De=Z.charCodeAt(pe);if(ue(De)&&pe+1<ae){const Se=Z.charCodeAt(pe+1);if(le(Se))return oe(De,Se)}return De}t.$9e=me;function Ce(Z,ae){const pe=Z.charCodeAt(ae-1);if(le(pe)&&ae>1){const De=Z.charCodeAt(ae-2);if(ue(De))return oe(De,pe)}return pe}class Te{get offset(){return this.e}constructor(ae,pe=0){this.c=ae,this.d=ae.length,this.e=pe}setOffset(ae){this.e=ae}prevCodePoint(){const ae=Ce(this.c,this.e);return this.e-=ae>=65536?2:1,ae}nextCodePoint(){const ae=me(this.c,this.d,this.e);return this.e+=ae>=65536?2:1,ae}eol(){return this.e>=this.d}}t.$0e=Te;class Pe{get offset(){return this.c.offset}constructor(ae,pe=0){this.c=new Te(ae,pe)}nextGraphemeLength(){const ae=Ae.getInstance(),pe=this.c,De=pe.offset;let Se=ae.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Re=pe.offset,je=ae.getGraphemeBreakType(pe.nextCodePoint());if(we(Se,je)){pe.setOffset(Re);break}Se=je}return pe.offset-De}prevGraphemeLength(){const ae=Ae.getInstance(),pe=this.c,De=pe.offset;let Se=ae.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Re=pe.offset,je=ae.getGraphemeBreakType(pe.prevCodePoint());if(we(je,Se)){pe.setOffset(Re);break}Se=je}return De-pe.offset}eol(){return this.c.eol()}}t.$$e=Pe;function de(Z,ae){return new Pe(Z,ae).nextGraphemeLength()}t.$_e=de;function ie(Z,ae){return new Pe(Z,ae).prevGraphemeLength()}t.$af=ie;function fe(Z,ae){ae>0&&le(Z.charCodeAt(ae))&&ae--;const pe=ae+de(Z,ae);return[pe-ie(Z,pe),pe]}t.$bf=fe;function Y(Z){const ae=new Pe(Z);let pe=0;for(;!ae.eol();)pe++,ae.nextGraphemeLength();return pe}t.$cf=Y;let _;function G(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function E(Z){return _||(_=G()),_.test(Z)}t.$df=E;const K=/^[\t\n\r\x20-\x7E]*$/;function g(Z){return K.test(Z)}t.$ef=g,t.$ff=/[\u2028\u2029]/;function p(Z){return t.$ff.test(Z)}t.$gf=p;function V(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}t.$hf=V;function L(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}t.$if=L;function P(Z,ae){if(Z.length<ae)return Z;const pe=/\b/g;let De=0;for(;pe.test(Z)&&!(Z.length-pe.lastIndex<ae);)De=pe.lastIndex,pe.lastIndex+=1;return Z.substring(De).replace(/^\s/,"")}t.$jf=P;const O=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,q=/\x1b\].*?\x07/g;function C(Z){return Z&&(Z=Z.replace(O,"").replace(q,"")),Z}t.$kf=C,t.$lf=String.fromCharCode(65279);function R(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}t.$mf=R;function A(Z){return R(Z)?Z.substr(1):Z}t.$nf=A;function k(Z,ae){if(!Z||!ae||Z.length<ae.length)return!1;const pe=ae.length,De=Z.toLowerCase();let Se=0,Re=-1;for(;Se<pe;){const je=De.indexOf(ae[Se],Re+1);if(je<0)return!1;Re=je,Se++}return!0}t.$of=k;function H(Z,ae=!1){return Z?(ae&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}t.$pf=H;function Q(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}t.$qf=Q;function te(Z,ae=1){if(ae===0)return"";let pe=-1;do pe=Z.indexOf(`
`,pe+1),ae--;while(ae>0&&pe>=0);return pe===-1?Z:(Z[pe-1]==="\r"&&pe--,Z.substr(0,pe))}t.$rf=te;function se(Z){return Z=Z%(2*26),Z<26?String.fromCharCode(97+Z):String.fromCharCode(65+Z-26)}t.$sf=se;function ge(Z){return Ae.getInstance().getGraphemeBreakType(Z)}t.$tf=ge;function we(Z,ae){return Z===0?ae!==5&&ae!==7:Z===2&&ae===3?!1:Z===4||Z===2||Z===3||ae===4||ae===2||ae===3?!0:!(Z===8&&(ae===8||ae===9||ae===11||ae===12)||(Z===11||Z===9)&&(ae===9||ae===10)||(Z===12||Z===10)&&ae===10||ae===5||ae===13||ae===7||Z===1||Z===13&&ae===14||Z===6&&ae===6)}var Ne;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(Ne||(t.GraphemeBreakType=Ne={}));class Ae{static{this.c=null}static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=ve()}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const pe=this.d,De=pe.length/3;let Se=1;for(;Se<=De;)if(ae<pe[3*Se])Se=2*Se;else if(ae>pe[3*Se+1])Se=2*Se+1;else return pe[3*Se+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ie(Z,ae){if(Z===0)return 0;const pe=Oe(Z,ae);if(pe!==void 0)return pe;const De=new Te(ae,Z);return De.prevCodePoint(),De.offset}t.$uf=Ie;function Oe(Z,ae){const pe=new Te(ae,Z);let De=pe.prevCodePoint();for(;qe(De)||De===65039||De===8419;){if(pe.offset===0)return;De=pe.prevCodePoint()}if(!L(De))return;let Se=pe.offset;return Se>0&&pe.prevCodePoint()===8205&&(Se=pe.offset),Se}function qe(Z){return 127995<=Z&&Z<=127999}var ze;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),t.$vf="\xA0";class Me{static{this.c=new F.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new y.$xe(ae=>{function pe(We){const et=new Map;for(let it=0;it<We.length;it+=2)et.set(We[it],We[it+1]);return et}function De(We,et){const it=new Map(We);for(const[ft,ut]of et)it.set(ft,ut);return it}function Se(We,et){if(!We)return et;const it=new Map;for(const[ft,ut]of We)et.has(ft)&&it.set(ft,ut);return it}const Re=this.c.value;let je=ae.filter(We=>!We.startsWith("_")&&We in Re);je.length===0&&(je=["_default"]);let Xe;for(const We of je){const et=pe(Re[We]);Xe=Se(Xe,et)}const Qe=pe(Re._common),Ve=De(Qe,Xe);return new Me(Ve)})}static getInstance(ae){return Me.d.get(Array.from(ae))}static{this.e=new F.$V(()=>Object.keys(Me.c.value).filter(ae=>!ae.startsWith("_")))}static getLocales(){return Me.e.value}constructor(ae){this.f=ae}isAmbiguous(ae){return this.f.has(ae)}getPrimaryConfusable(ae){return this.f.get(ae)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$wf=Me;class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(ae){return Ge.e().has(ae)}static get codePoints(){return Ge.e()}}t.$xf=Ge}),define(be[33],$e([1,0,31,12]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qj=t.$Pj=t.$Oj=t.$Nj=t.FuzzyScore=t.$Mj=t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.$Gj=t.$Fj=t.$Ej=t.$Dj=t.$Cj=t.$Bj=t.or=void 0;function i(...A){return function(k,H){for(let Q=0,te=A.length;Q<te;Q++){const se=A[Q](k,H);if(se)return se}return null}}t.or=i,t.$Bj=U.bind(void 0,!1),t.$Cj=U.bind(void 0,!0);function U(A,k,H){if(!H||H.length<k.length)return null;let Q;return A?Q=F.$3e(H,k):Q=H.indexOf(k)===0,Q?k.length>0?[{start:0,end:k.length}]:[]:null}function w(A,k){const H=k.toLowerCase().indexOf(A.toLowerCase());return H===-1?null:[{start:H,end:H+A.length}]}t.$Dj=w;function D(A,k){return h(A.toLowerCase(),k.toLowerCase(),0,0)}t.$Ej=D;function h(A,k,H,Q){if(H===A.length)return[];if(Q===k.length)return null;if(A[H]===k[Q]){let te=null;return(te=h(A,k,H+1,Q+1))?m({start:Q,end:Q+1},te):null}return h(A,k,H,Q+1)}function f(A){return 97<=A&&A<=122}function d(A){return 65<=A&&A<=90}t.$Fj=d;function T(A){return 48<=A&&A<=57}function s(A){return A===32||A===9||A===10||A===13}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(A=>a.add(A.charCodeAt(0)));function e(A){return s(A)||a.has(A)}function u(A,k){return A===k||e(A)&&e(k)}function l(A){return f(A)||d(A)||T(A)}function m(A,k){return k.length===0?k=[A]:A.end===k[0].start?k[0].start=A.start:k.unshift(A),k}function n(A,k){for(let H=k;H<A.length;H++){const Q=A.charCodeAt(H);if(d(Q)||T(Q)||H>0&&!l(A.charCodeAt(H-1)))return H}return A.length}function r(A,k,H,Q){if(H===A.length)return[];if(Q===k.length)return null;if(A[H]!==k[Q].toLowerCase())return null;{let te=null,se=Q+1;for(te=r(A,k,H+1,Q+1);!te&&(se=n(k,se))<k.length;)te=r(A,k,H+1,se),se++;return te===null?null:m({start:Q,end:Q+1},te)}}function $(A){let k=0,H=0,Q=0,te=0,se=0;for(let ve=0;ve<A.length;ve++)se=A.charCodeAt(ve),d(se)&&k++,f(se)&&H++,l(se)&&Q++,T(se)&&te++;const ge=k/A.length,we=H/A.length,Ne=Q/A.length,Ae=te/A.length;return{upperPercent:ge,lowerPercent:we,alphaPercent:Ne,numericPercent:Ae}}function c(A){const{upperPercent:k,lowerPercent:H}=A;return H===0&&k>.6}function o(A){const{upperPercent:k,lowerPercent:H,alphaPercent:Q,numericPercent:te}=A;return H>.2&&k<.8&&Q>.6&&te<.2}function S(A){let k=0,H=0,Q=0,te=0;for(let se=0;se<A.length;se++)Q=A.charCodeAt(se),d(Q)&&k++,f(Q)&&H++,s(Q)&&te++;return(k===0||H===0)&&te===0?A.length<=30:k<=5}function j(A,k){if(!k||(k=k.trim(),k.length===0)||!S(A)||k.length>60)return null;const H=$(k);if(!o(H)){if(!c(H))return null;k=k.toLowerCase()}let Q=null,te=0;for(A=A.toLowerCase();te<k.length&&(Q=r(A,k,0,te))===null;)te=n(k,te+1);return Q}t.$Gj=j;function M(A,k,H=!1){if(!k||k.length===0)return null;let Q=null,te=0;for(A=A.toLowerCase(),k=k.toLowerCase();te<k.length&&(Q=b(A,k,0,te,H))===null;)te=v(k,te+1);return Q}t.$Hj=M;function b(A,k,H,Q,te){if(H===A.length)return[];if(Q===k.length)return null;if(u(A.charCodeAt(H),k.charCodeAt(Q))){let se=null,ge=Q+1;if(se=b(A,k,H+1,Q+1,te),!te)for(;!se&&(ge=v(k,ge))<k.length;)se=b(A,k,H+1,ge,te),ge++;return se?A.charCodeAt(H)!==k.charCodeAt(Q)?se:m({start:Q,end:Q+1},se):null}else return null}function v(A,k){for(let H=k;H<A.length;H++)if(e(A.charCodeAt(H))||H>0&&e(A.charCodeAt(H-1)))return H;return A.length}const B=i(t.$Cj,j,w),z=i(t.$Cj,j,D),W=new y.$Dc(1e4);function I(A,k,H=!1){if(typeof A!="string"||typeof k!="string")return null;let Q=W.get(A);Q||(Q=new RegExp(F.$Le(A),"i"),W.set(A,Q));const te=Q.exec(k);return te?[{start:te.index,end:te.index+te[0].length}]:H?z(A,k):B(A,k)}t.$Ij=I;function N(A,k){const H=V(A,A.toLowerCase(),0,k,k.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?ee(H):null}t.$Jj=N;function J(A,k,H,Q,te,se){const ge=Math.min(13,A.length);for(;H<ge;H++){const we=V(A,k,H,Q,te,se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,se]}t.$Kj=J;function ee(A){if(typeof A>"u")return[];const k=[],H=A[1];for(let Q=A.length-1;Q>1;Q--){const te=A[Q]+H,se=k[k.length-1];se&&se.end===te?se.end=te+1:k.push({start:te,end:te+1})}return k}t.$Lj=ee;const ne=128;function ue(){const A=[],k=[];for(let H=0;H<=ne;H++)k[H]=0;for(let H=0;H<=ne;H++)A.push(k.slice(0));return A}function le(A){const k=[];for(let H=0;H<=A;H++)k[H]=0;return k}const oe=le(2*ne),me=le(2*ne),Ce=ue(),Te=ue(),Pe=ue(),de=!1;function ie(A,k,H,Q,te){function se(we,Ne,Ae=" "){for(;we.length<Ne;)we=Ae+we;return we}let ge=` |   |${Q.split("").map(we=>se(we,3)).join("|")}
`;for(let we=0;we<=H;we++)we===0?ge+=" |":ge+=`${k[we-1]}|`,ge+=A[we].slice(0,te+1).map(Ne=>se(Ne.toString(),3)).join("|")+`
`;return ge}function fe(A,k,H,Q){A=A.substr(k),H=H.substr(Q),console.log(ie(Te,A,A.length,H,H.length)),console.log(ie(Pe,A,A.length,H,H.length)),console.log(ie(Ce,A,A.length,H,H.length))}function Y(A,k){if(k<0||k>=A.length)return!1;const H=A.codePointAt(k);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$if(H)}}function _(A,k){if(k<0||k>=A.length)return!1;switch(A.charCodeAt(k)){case 32:case 9:return!0;default:return!1}}function G(A,k,H){return k[A]!==H[A]}function E(A,k,H,Q,te,se,ge=!1){for(;k<H&&te<se;)A[k]===Q[te]&&(ge&&(oe[k]=te),k+=1),te+=1;return k===H}t.$Mj=E;var K;(function(A){A[A.Diag=1]="Diag",A[A.Left=2]="Left",A[A.LeftLeft=3]="LeftLeft"})(K||(K={}));var g;(function(A){A.Default=[-100,0];function k(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}A.isDefault=k})(g||(t.FuzzyScore=g={}));class p{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(k,H){this.firstMatchCanBeWeak=k,this.boostFullMatch=H}}t.$Nj=p;function V(A,k,H,Q,te,se,ge=p.default){const we=A.length>ne?ne:A.length,Ne=Q.length>ne?ne:Q.length;if(H>=we||se>=Ne||we-H>Ne-se||!E(k,H,we,te,se,Ne,!0))return;L(we,Ne,H,se,k,te);let Ae=1,ve=1,Ie=H,Oe=se;const qe=[!1];for(Ae=1,Ie=H;Ie<we;Ae++,Ie++){const ae=oe[Ie],pe=me[Ie],De=Ie+1<we?me[Ie+1]:Ne;for(ve=ae-se+1,Oe=ae;Oe<De;ve++,Oe++){let Se=Number.MIN_SAFE_INTEGER,Re=!1;Oe<=pe&&(Se=P(A,k,Ie,H,Q,te,Oe,Ne,se,Ce[Ae-1][ve-1]===0,qe));let je=0;Se!==Number.MAX_SAFE_INTEGER&&(Re=!0,je=Se+Te[Ae-1][ve-1]);const Xe=Oe>ae,Qe=Xe?Te[Ae][ve-1]+(Ce[Ae][ve-1]>0?-5:0):0,Ve=Oe>ae+1&&Ce[Ae][ve-1]>0,We=Ve?Te[Ae][ve-2]+(Ce[Ae][ve-2]>0?-5:0):0;if(Ve&&(!Xe||We>=Qe)&&(!Re||We>=je))Te[Ae][ve]=We,Pe[Ae][ve]=3,Ce[Ae][ve]=0;else if(Xe&&(!Re||Qe>=je))Te[Ae][ve]=Qe,Pe[Ae][ve]=2,Ce[Ae][ve]=0;else if(Re)Te[Ae][ve]=je,Pe[Ae][ve]=1,Ce[Ae][ve]=Ce[Ae-1][ve-1]+1;else throw new Error("not possible")}}if(de&&fe(A,H,Q,se),!qe[0]&&!ge.firstMatchCanBeWeak)return;Ae--,ve--;const ze=[Te[Ae][ve],se];let Me=0,Ge=0;for(;Ae>=1;){let ae=ve;do{const pe=Pe[Ae][ae];if(pe===3)ae=ae-2;else if(pe===2)ae=ae-1;else break}while(ae>=1);Me>1&&k[H+Ae-1]===te[se+ve-1]&&!G(ae+se-1,Q,te)&&Me+1>Ce[Ae][ae]&&(ae=ve),ae===ve?Me++:Me=1,Ge||(Ge=ae),Ae--,ve=ae-1,ze.push(ve)}Ne===we&&ge.boostFullMatch&&(ze[0]+=2);const Z=Ge-we;return ze[0]-=Z,ze}t.$Oj=V;function L(A,k,H,Q,te,se){let ge=A-1,we=k-1;for(;ge>=H&&we>=Q;)te[ge]===se[we]&&(me[ge]=we,ge--),we--}function P(A,k,H,Q,te,se,ge,we,Ne,Ae,ve){if(k[H]!==se[ge])return Number.MIN_SAFE_INTEGER;let Ie=1,Oe=!1;return ge===H-Q?Ie=A[H]===te[ge]?7:5:G(ge,te,se)&&(ge===0||!G(ge-1,te,se))?(Ie=A[H]===te[ge]?7:5,Oe=!0):Y(se,ge)&&(ge===0||!Y(se,ge-1))?Ie=5:(Y(se,ge-1)||_(se,ge-1))&&(Ie=5,Oe=!0),Ie>1&&H===Q&&(ve[0]=!0),Oe||(Oe=G(ge,te,se)||Y(se,ge-1)||_(se,ge-1)),H===Q?ge>Ne&&(Ie-=Oe?3:5):Ae?Ie+=Oe?2:0:Ie+=Oe?0:1,ge+1===we&&(Ie-=Oe?3:5),Ie}function O(A,k,H,Q,te,se,ge){return C(A,k,H,Q,te,se,!0,ge)}t.$Pj=O;function q(A,k,H,Q,te,se,ge){return C(A,k,H,Q,te,se,!1,ge)}t.$Qj=q;function C(A,k,H,Q,te,se,ge,we){let Ne=V(A,k,H,Q,te,se,we);if(Ne&&!ge)return Ne;if(A.length>=3){const Ae=Math.min(7,A.length-1);for(let ve=H+1;ve<Ae;ve++){const Ie=R(A,ve);if(Ie){const Oe=V(Ie,Ie.toLowerCase(),H,Q,te,se,we);Oe&&(Oe[0]-=3,(!Ne||Oe[0]>Ne[0])&&(Ne=Oe))}}}return Ne}function R(A,k){if(k+1>=A.length)return;const H=A[k],Q=A[k+1];if(H!==Q)return A.slice(0,k)+Q+H+A.slice(k+2)}}),define(be[84],$e([1,0,12]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ii=t.$Hi=t.$Gi=t.$Fi=t.$Ei=t.$Di=t.$Ci=void 0;function F(m){return i(m,0)}t.$Ci=F;function i(m,n){switch(typeof m){case"object":return m===null?U(349,n):Array.isArray(m)?h(m,n):f(m,n);case"string":return D(m,n);case"boolean":return w(m,n);case"number":return U(m,n);case"undefined":return U(937,n);default:return U(617,n)}}t.$Di=i;function U(m,n){return(n<<5)-n+m|0}t.$Ei=U;function w(m,n){return U(m?433:863,n)}function D(m,n){n=U(149417,n);for(let r=0,$=m.length;r<$;r++)n=U(m.charCodeAt(r),n);return n}t.$Fi=D;function h(m,n){return n=U(104579,n),m.reduce((r,$)=>i($,r),n)}function f(m,n){return n=U(181387,n),Object.keys(m).sort().reduce((r,$)=>(r=D($,r),i(m[$],r)),n)}class d{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=i(n,this.g),this.g}}t.$Gi=d;var T;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function s(m,n,r=32){const $=r-n,c=~((1<<$)-1);return(m<<n|(c&m)>>>$)>>>0}function a(m,n=0,r=m.byteLength,$=0){for(let c=0;c<r;c++)m[n+c]=$}function e(m,n,r="0"){for(;m.length<n;)m=r+m;return m}function u(m,n=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(r=>r.toString(16).padStart(2,"0")).join(""):e((m>>>0).toString(16),n/4)}t.$Hi=u;class l{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const r=n.length;if(r===0)return;const $=this.p;let c=this.r,o=this.u,S,j;for(o!==0?(S=o,j=-1,o=0):(S=n.charCodeAt(0),j=0);;){let M=S;if(y.$6e(S))if(j+1<r){const b=n.charCodeAt(j+1);y.$7e(b)?(j++,M=y.$8e(S,b)):M=65533}else{o=S;break}else y.$7e(S)&&(M=65533);if(c=this.w($,c,M),j++,j<r)S=n.charCodeAt(j);else break}this.r=c,this.u=o}w(n,r,$){return $<128?n[r++]=$:$<2048?(n[r++]=192|($&1984)>>>6,n[r++]=128|($&63)>>>0):$<65536?(n[r++]=224|($&61440)>>>12,n[r++]=128|($&4032)>>>6,n[r++]=128|($&63)>>>0):(n[r++]=240|($&1835008)>>>18,n[r++]=128|($&258048)>>>12,n[r++]=128|($&4032)>>>6,n[r++]=128|($&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),u(this.h)+u(this.l)+u(this.m)+u(this.n)+u(this.o)}x(){this.p[this.r++]=128,a(this.p,this.r),this.r>56&&(this.y(),a(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=l.g,r=this.q;for(let B=0;B<64;B+=4)n.setUint32(B,r.getUint32(B,!1),!1);for(let B=64;B<320;B+=4)n.setUint32(B,s(n.getUint32(B-12,!1)^n.getUint32(B-32,!1)^n.getUint32(B-56,!1)^n.getUint32(B-64,!1),1),!1);let $=this.h,c=this.l,o=this.m,S=this.n,j=this.o,M,b,v;for(let B=0;B<80;B++)B<20?(M=c&o|~c&S,b=1518500249):B<40?(M=c^o^S,b=1859775393):B<60?(M=c&o|c&S|o&S,b=2400959708):(M=c^o^S,b=3395469782),v=s($,5)+M+j+b+n.getUint32(B*4,!1)&4294967295,j=S,S=o,o=s(c,30),c=$,$=v;this.h=this.h+$&4294967295,this.l=this.l+c&4294967295,this.m=this.m+o&4294967295,this.n=this.n+S&4294967295,this.o=this.o+j&4294967295}}t.$Ii=l}),define(be[85],$e([1,0,73,84]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ws=t.$vs=t.$us=void 0;class i{constructor(s){this.a=s}getElements(){const s=this.a,a=new Int32Array(s.length);for(let e=0,u=s.length;e<u;e++)a[e]=s.charCodeAt(e);return a}}t.$us=i;function U(T,s,a){return new d(new i(T),new i(s)).ComputeDiff(a).changes}t.$vs=U;class w{static Assert(s,a){if(!s)throw new Error(a)}}class D{static Copy(s,a,e,u,l){for(let m=0;m<l;m++)e[u+m]=s[a+m]}static Copy2(s,a,e,u,l){for(let m=0;m<l;m++)e[u+m]=s[a+m]}}var h;(function(T){T[T.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(h||(h={}));class f{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new y.$ts(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.d++}AddModifiedElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class d{constructor(s,a,e=null){this.a=e,this.b=s,this.c=a;const[u,l,m]=d.o(s),[n,r,$]=d.o(a);this.d=m&&$,this.e=u,this.f=l,this.g=n,this.h=r,this.k=[],this.m=[]}static n(s){return s.length>0&&typeof s[0]=="string"}static o(s){const a=s.getElements();if(d.n(a)){const e=new Int32Array(a.length);for(let u=0,l=a.length;u<l;u++)e[u]=(0,F.$Fi)(a[u],0);return[a,e,!0]}return a instanceof Int32Array?[[],a,!1]:[[],new Int32Array(a),!1]}p(s,a){return this.f[s]!==this.h[a]?!1:this.d?this.e[s]===this.g[a]:!0}q(s,a){if(!this.p(s,a))return!1;const e=d.r(this.b,s),u=d.r(this.c,a);return e===u}static r(s,a){return typeof s.getStrictElement=="function"?s.getStrictElement(a):null}s(s,a){return this.f[s]!==this.f[a]?!1:this.d?this.e[s]===this.e[a]:!0}u(s,a){return this.h[s]!==this.h[a]?!1:this.d?this.g[s]===this.g[a]:!0}ComputeDiff(s){return this.v(0,this.f.length-1,0,this.h.length-1,s)}v(s,a,e,u,l){const m=[!1];let n=this.w(s,a,e,u,m);return l&&(n=this.z(n)),{quitEarly:m[0],changes:n}}w(s,a,e,u,l){for(l[0]=!1;s<=a&&e<=u&&this.p(s,e);)s++,e++;for(;a>=s&&u>=e&&this.p(a,u);)a--,u--;if(s>a||e>u){let o;return e<=u?(w.Assert(s===a+1,"originalStart should only be one more than originalEnd"),o=[new y.$ts(s,0,e,u-e+1)]):s<=a?(w.Assert(e===u+1,"modifiedStart should only be one more than modifiedEnd"),o=[new y.$ts(s,a-s+1,e,0)]):(w.Assert(s===a+1,"originalStart should only be one more than originalEnd"),w.Assert(e===u+1,"modifiedStart should only be one more than modifiedEnd"),o=[]),o}const m=[0],n=[0],r=this.y(s,a,e,u,m,n,l),$=m[0],c=n[0];if(r!==null)return r;if(!l[0]){const o=this.w(s,$,e,c,l);let S=[];return l[0]?S=[new y.$ts($+1,a-($+1)+1,c+1,u-(c+1)+1)]:S=this.w($+1,a,c+1,u,l),this.H(o,S)}return[new y.$ts(s,a-s+1,e,u-e+1)]}x(s,a,e,u,l,m,n,r,$,c,o,S,j,M,b,v,B,z){let W=null,I=null,N=new f,J=a,ee=e,ne=j[0]-v[0]-u,ue=-1073741824,le=this.k.length-1;do{const oe=ne+s;oe===J||oe<ee&&$[oe-1]<$[oe+1]?(o=$[oe+1],M=o-ne-u,o<ue&&N.MarkNextChange(),ue=o,N.AddModifiedElement(o+1,M),ne=oe+1-s):(o=$[oe-1]+1,M=o-ne-u,o<ue&&N.MarkNextChange(),ue=o-1,N.AddOriginalElement(o,M+1),ne=oe-1-s),le>=0&&($=this.k[le],s=$[0],J=1,ee=$.length-1)}while(--le>=-1);if(W=N.getReverseChanges(),z[0]){let oe=j[0]+1,me=v[0]+1;if(W!==null&&W.length>0){const Ce=W[W.length-1];oe=Math.max(oe,Ce.getOriginalEnd()),me=Math.max(me,Ce.getModifiedEnd())}I=[new y.$ts(oe,S-oe+1,me,b-me+1)]}else{N=new f,J=m,ee=n,ne=j[0]-v[0]-r,ue=1073741824,le=B?this.m.length-1:this.m.length-2;do{const oe=ne+l;oe===J||oe<ee&&c[oe-1]>=c[oe+1]?(o=c[oe+1]-1,M=o-ne-r,o>ue&&N.MarkNextChange(),ue=o+1,N.AddOriginalElement(o+1,M+1),ne=oe+1-l):(o=c[oe-1],M=o-ne-r,o>ue&&N.MarkNextChange(),ue=o,N.AddModifiedElement(o+1,M+1),ne=oe-1-l),le>=0&&(c=this.m[le],l=c[0],J=1,ee=c.length-1)}while(--le>=-1);I=N.getChanges()}return this.H(W,I)}y(s,a,e,u,l,m,n){let r=0,$=0,c=0,o=0,S=0,j=0;s--,e--,l[0]=0,m[0]=0,this.k=[],this.m=[];const M=a-s+(u-e),b=M+1,v=new Int32Array(b),B=new Int32Array(b),z=u-e,W=a-s,I=s-e,N=a-u,ee=(W-z)%2===0;v[z]=s,B[W]=a,n[0]=!1;for(let ne=1;ne<=M/2+1;ne++){let ue=0,le=0;c=this.J(z-ne,ne,z,b),o=this.J(z+ne,ne,z,b);for(let me=c;me<=o;me+=2){me===c||me<o&&v[me-1]<v[me+1]?r=v[me+1]:r=v[me-1]+1,$=r-(me-z)-I;const Ce=r;for(;r<a&&$<u&&this.p(r+1,$+1);)r++,$++;if(v[me]=r,r+$>ue+le&&(ue=r,le=$),!ee&&Math.abs(me-W)<=ne-1&&r>=B[me])return l[0]=r,m[0]=$,Ce<=B[me]&&1447>0&&ne<=1447+1?this.x(z,c,o,I,W,S,j,N,v,B,r,a,l,$,u,m,ee,n):null}const oe=(ue-s+(le-e)-ne)/2;if(this.a!==null&&!this.a(ue,oe))return n[0]=!0,l[0]=ue,m[0]=le,oe>0&&1447>0&&ne<=1447+1?this.x(z,c,o,I,W,S,j,N,v,B,r,a,l,$,u,m,ee,n):(s++,e++,[new y.$ts(s,a-s+1,e,u-e+1)]);S=this.J(W-ne,ne,W,b),j=this.J(W+ne,ne,W,b);for(let me=S;me<=j;me+=2){me===S||me<j&&B[me-1]>=B[me+1]?r=B[me+1]-1:r=B[me-1],$=r-(me-W)-N;const Ce=r;for(;r>s&&$>e&&this.p(r,$);)r--,$--;if(B[me]=r,ee&&Math.abs(me-z)<=ne&&r<=v[me])return l[0]=r,m[0]=$,Ce>=v[me]&&1447>0&&ne<=1447+1?this.x(z,c,o,I,W,S,j,N,v,B,r,a,l,$,u,m,ee,n):null}if(ne<=1447){let me=new Int32Array(o-c+2);me[0]=z-c+1,D.Copy2(v,c,me,1,o-c+1),this.k.push(me),me=new Int32Array(j-S+2),me[0]=W-S+1,D.Copy2(B,S,me,1,j-S+1),this.m.push(me)}}return this.x(z,c,o,I,W,S,j,N,v,B,r,a,l,$,u,m,ee,n)}z(s){for(let a=0;a<s.length;a++){const e=s[a],u=a<s.length-1?s[a+1].originalStart:this.f.length,l=a<s.length-1?s[a+1].modifiedStart:this.h.length,m=e.originalLength>0,n=e.modifiedLength>0;for(;e.originalStart+e.originalLength<u&&e.modifiedStart+e.modifiedLength<l&&(!m||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!n||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const $=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!$)break;e.originalStart++,e.modifiedStart++}const r=[null];if(a<s.length-1&&this.I(s[a],s[a+1],r)){s[a]=r[0],s.splice(a+1,1),a--;continue}}for(let a=s.length-1;a>=0;a--){const e=s[a];let u=0,l=0;if(a>0){const o=s[a-1];u=o.originalStart+o.originalLength,l=o.modifiedStart+o.modifiedLength}const m=e.originalLength>0,n=e.modifiedLength>0;let r=0,$=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let o=1;;o++){const S=e.originalStart-o,j=e.modifiedStart-o;if(S<u||j<l||m&&!this.s(S,S+e.originalLength)||n&&!this.u(j,j+e.modifiedLength))break;const b=(S===u&&j===l?5:0)+this.G(S,e.originalLength,j,e.modifiedLength);b>$&&($=b,r=o)}e.originalStart-=r,e.modifiedStart-=r;const c=[null];if(a>0&&this.I(s[a-1],s[a],c)){s[a-1]=c[0],s.splice(a,1),a++;continue}}if(this.d)for(let a=1,e=s.length;a<e;a++){const u=s[a-1],l=s[a],m=l.originalStart-u.originalStart-u.originalLength,n=u.originalStart,r=l.originalStart+l.originalLength,$=r-n,c=u.modifiedStart,o=l.modifiedStart+l.modifiedLength,S=o-c;if(m<5&&$<20&&S<20){const j=this.A(n,$,c,S,m);if(j){const[M,b]=j;(M!==u.originalStart+u.originalLength||b!==u.modifiedStart+u.modifiedLength)&&(u.originalLength=M-u.originalStart,u.modifiedLength=b-u.modifiedStart,l.originalStart=M+m,l.modifiedStart=b+m,l.originalLength=r-l.originalStart,l.modifiedLength=o-l.modifiedStart)}}}return s}A(s,a,e,u,l){if(a<l||u<l)return null;const m=s+a-l+1,n=e+u-l+1;let r=0,$=0,c=0;for(let o=s;o<m;o++)for(let S=e;S<n;S++){const j=this.B(o,S,l);j>0&&j>r&&(r=j,$=o,c=S)}return r>0?[$,c]:null}B(s,a,e){let u=0;for(let l=0;l<e;l++){if(!this.p(s+l,a+l))return 0;u+=this.e[s+l].length}return u}C(s){return s<=0||s>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[s])}D(s,a){if(this.C(s)||this.C(s-1))return!0;if(a>0){const e=s+a;if(this.C(e-1)||this.C(e))return!0}return!1}E(s){return s<=0||s>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[s])}F(s,a){if(this.E(s)||this.E(s-1))return!0;if(a>0){const e=s+a;if(this.E(e-1)||this.E(e))return!0}return!1}G(s,a,e,u){const l=this.D(s,a)?1:0,m=this.F(e,u)?1:0;return l+m}H(s,a){const e=[];if(s.length===0||a.length===0)return a.length>0?a:s;if(this.I(s[s.length-1],a[0],e)){const u=new Array(s.length+a.length-1);return D.Copy(s,0,u,0,s.length-1),u[s.length-1]=e[0],D.Copy(a,1,u,s.length,a.length-1),u}else{const u=new Array(s.length+a.length);return D.Copy(s,0,u,0,s.length),D.Copy(a,0,u,s.length,a.length),u}}I(s,a,e){if(w.Assert(s.originalStart<=a.originalStart,"Left change is not less than or equal to right change"),w.Assert(s.modifiedStart<=a.modifiedStart,"Left change is not less than or equal to right change"),s.originalStart+s.originalLength>=a.originalStart||s.modifiedStart+s.modifiedLength>=a.modifiedStart){const u=s.originalStart;let l=s.originalLength;const m=s.modifiedStart;let n=s.modifiedLength;return s.originalStart+s.originalLength>=a.originalStart&&(l=a.originalStart+a.originalLength-s.originalStart),s.modifiedStart+s.modifiedLength>=a.modifiedStart&&(n=a.modifiedStart+a.modifiedLength-s.modifiedStart),e[0]=new y.$ts(u,l,m,n),!0}else return e[0]=null,!1}J(s,a,e,u){if(s>=0&&s<u)return s;const l=e,m=u-e-1,n=a%2===0;if(s<0){const r=l%2===0;return n===r?0:1}else{const r=m%2===0;return n===r?u-1:u-2}}}t.$ws=d}),define(be[48],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kd=void 0,t.$Kd=Symbol("MicrotaskDelay")}),define(be[86],$e([1,0,11,12]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uh=t.$Th=t.$Sh=t.$Rh=t.$Qh=void 0;class i{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const e=a.charCodeAt(0),u=this.b.charCodeAt(this.c);return e-u}value(){return this.b[this.c]}}t.$Qh=i;class U{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,F.$Ve)(a,this.b,0,a.length,this.c,this.d):(0,F.$Xe)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Rh=U;class w{constructor(a=!0,e=!0){this.f=a,this.g=e}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let e=a.length-1;e>=0;e--,this.c--){const u=this.b.charCodeAt(e);if(!(u===47||this.f&&u===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,F.$Ve)(a,this.b,0,a.length,this.d,this.e):(0,F.$Xe)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Sh=w;var D;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(D||(D={}));class h{constructor(a,e){this.f=a,this.g=e,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new w(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(3)),this.g(a)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===1)return(0,F.$We)(a,this.c.scheme);if(this.d[this.e]===2)return(0,F.$We)(a,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(a);if(this.d[this.e]===4)return(0,F.$Ue)(a,this.c.query);if(this.d[this.e]===5)return(0,F.$Ue)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$Th=h;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(d||(d={}));class T{static forUris(a=()=>!1,e=()=>!1){return new T(new h(a,e))}static forPaths(a=!1){return new T(new w(void 0,!a))}static forStrings(){return new T(new i)}static forConfigKeys(){return new T(new U)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,e){if(e){const u=e.slice(0);(0,y.$Xb)(u);for(const l of u)this.set(l,a)}else{const u=a.slice(0);(0,y.$Xb)(u);for(const l of u)this.set(l[0],l[1])}}set(a,e){const u=this.b.reset(a);let l;this.c||(this.c=new f,this.c.segment=u.value());const m=[];for(l=this.c;;){const r=u.cmp(l.segment);if(r>0)l.left||(l.left=new f,l.left.segment=u.value()),m.push([-1,l]),l=l.left;else if(r<0)l.right||(l.right=new f,l.right.segment=u.value()),m.push([1,l]),l=l.right;else if(u.hasNext())u.next(),l.mid||(l.mid=new f,l.mid.segment=u.value()),m.push([0,l]),l=l.mid;else break}const n=l.value;l.value=e,l.key=a;for(let r=m.length-1;r>=0;r--){const $=m[r][1];$.updateHeight();const c=$.balanceFactor();if(c<-1||c>1){const o=m[r][0],S=m[r+1][0];if(o===1&&S===1)m[r][1]=$.rotateLeft();else if(o===-1&&S===-1)m[r][1]=$.rotateRight();else if(o===1&&S===-1)$.right=m[r+1][1]=m[r+1][1].rotateRight(),m[r][1]=$.rotateLeft();else if(o===-1&&S===1)$.left=m[r+1][1]=m[r+1][1].rotateLeft(),m[r][1]=$.rotateRight();else throw new Error;if(r>0)switch(m[r-1][0]){case-1:m[r-1][1].left=m[r][1];break;case 1:m[r-1][1].right=m[r][1];break;case 0:m[r-1][1].mid=m[r][1];break}else this.c=m[0][1]}}return n}get(a){return this.d(a)?.value}d(a){const e=this.b.reset(a);let u=this.c;for(;u;){const l=e.cmp(u.segment);if(l>0)u=u.left;else if(l<0)u=u.right;else if(e.hasNext())e.next(),u=u.mid;else break}return u}has(a){const e=this.d(a);return!(e?.value===void 0&&e?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,e){const u=this.b.reset(a),l=[];let m=this.c;for(;m;){const n=u.cmp(m.segment);if(n>0)l.push([-1,m]),m=m.left;else if(n<0)l.push([1,m]),m=m.right;else if(u.hasNext())u.next(),l.push([0,m]),m=m.mid;else break}if(m){if(e?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const n=this.f(m.right);if(n.key){const{key:r,value:$,segment:c}=n;this.e(n.key,!1),m.key=r,m.value=$,m.segment=c}}else{const n=m.left??m.right;if(l.length>0){const[r,$]=l[l.length-1];switch(r){case-1:$.left=n;break;case 0:$.mid=n;break;case 1:$.right=n;break}}else this.c=n}for(let n=l.length-1;n>=0;n--){const r=l[n][1];r.updateHeight();const $=r.balanceFactor();if($>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),l[n][1]=r.rotateLeft()):$<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),l[n][1]=r.rotateRight()),n>0)switch(l[n-1][0]){case-1:l[n-1][1].left=l[n][1];break;case 1:l[n-1][1].right=l[n][1];break;case 0:l[n-1][1].mid=l[n][1];break}else this.c=l[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const e=this.b.reset(a);let u=this.c,l;for(;u;){const m=e.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(e.hasNext())e.next(),l=u.value||l,u=u.mid;else break}return u&&u.value||l}findSuperstr(a){return this.g(a,!1)}g(a,e){const u=this.b.reset(a);let l=this.c;for(;l;){const m=u.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(u.hasNext())u.next(),l=l.mid;else return l.mid?this.h(l.mid):e?l.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[e,u]of this)a(u,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const e=[];return this.j(a,e),e[Symbol.iterator]()}j(a,e){a&&(a.left&&this.j(a.left,e),a.value&&e.push([a.key,a.value]),a.mid&&this.j(a.mid,e),a.right&&this.j(a.right,e))}_isBalanced(){const a=e=>{if(!e)return!0;const u=e.balanceFactor();return u<-1||u>1?!1:a(e.left)&&a(e.right)};return a(this.c)}}t.$Uh=T}),define(be[7],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=void 0;function y(c){return typeof c=="string"}t.$yf=y;function F(c){return Array.isArray(c)&&c.every(o=>y(o))}t.$zf=F;function i(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}t.$Af=i;function U(c){const o=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof o}t.$Bf=U;function w(c){return typeof c=="number"&&!isNaN(c)}t.$Cf=w;function D(c){return!!c&&typeof c[Symbol.iterator]=="function"}t.$Df=D;function h(c){return c===!0||c===!1}t.$Ef=h;function f(c){return typeof c>"u"}t.$Ff=f;function d(c){return!T(c)}t.$Gf=d;function T(c){return f(c)||c===null}t.$Hf=T;function s(c,o){if(!c)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}t.$If=s;function a(c){if(T(c))throw new Error("Assertion Failed: argument is undefined or null");return c}t.$Jf=a;function e(...c){const o=[];for(let S=0;S<c.length;S++){const j=c[S];if(T(j))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);o.push(j)}return o}t.$Kf=e;const u=Object.prototype.hasOwnProperty;function l(c){if(!i(c))return!1;for(const o in c)if(u.call(c,o))return!1;return!0}t.$Lf=l;function m(c){return typeof c=="function"}t.$Mf=m;function n(...c){return c.length>0&&c.every(m)}t.$Nf=n;function r(c,o){const S=Math.min(c.length,o.length);for(let j=0;j<S;j++)$(c[j],o[j])}t.$Of=r;function $(c,o){if(y(o)){if(typeof c!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(m(o)){try{if(c instanceof o)return}catch{}if(!T(c)&&c.constructor===o||o.length===1&&o.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Pf=$}),define(be[17],$e([1,0,7]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tj=t.$Sj=t.$Rj=void 0;const F=Object.create(null);function i(D,h){if((0,y.$yf)(h)){const f=F[h];if(f===void 0)throw new Error(`${D} references an unknown codicon: ${h}`);h=f}return F[D]=h,{id:D}}function U(){return F}t.$Rj=U;function w(){return Object.values(t.$Tj)}t.$Sj=w,t.$Tj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(be[49],$e([1,0,7]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cn=t.$bn=t.$an=t.$_m=t.$$m=t.$0m=t.$9m=t.$8m=t.$7m=t.$6m=t.$5m=t.$4m=void 0;function F(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const n=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([r,$])=>{n[r]=$&&typeof $=="object"?F($):$}),n}t.$4m=F;function i(m){if(!m||typeof m!="object")return m;const n=[m];for(;n.length>0;){const r=n.shift();Object.freeze(r);for(const $ in r)if(U.call(r,$)){const c=r[$];typeof c=="object"&&!Object.isFrozen(c)&&!(0,y.$Bf)(c)&&n.push(c)}}return m}t.$5m=i;const U=Object.prototype.hasOwnProperty;function w(m,n){return D(m,n,new Set)}t.$6m=w;function D(m,n,r){if((0,y.$Hf)(m))return m;const $=n(m);if(typeof $<"u")return $;if(Array.isArray(m)){const c=[];for(const o of m)c.push(D(o,n,r));return c}if((0,y.$Af)(m)){if(r.has(m))throw new Error("Cannot clone recursive data-structure");r.add(m);const c={};for(const o in m)U.call(m,o)&&(c[o]=D(m[o],n,r));return r.delete(m),c}return m}function h(m,n,r=!0){return(0,y.$Af)(m)?((0,y.$Af)(n)&&Object.keys(n).forEach($=>{$ in m?r&&((0,y.$Af)(m[$])&&(0,y.$Af)(n[$])?h(m[$],n[$],r):m[$]=n[$]):m[$]=n[$]}),m):n}t.$7m=h;function f(m,n){if(m===n)return!0;if(m==null||n===null||n===void 0||typeof m!=typeof n||typeof m!="object"||Array.isArray(m)!==Array.isArray(n))return!1;let r,$;if(Array.isArray(m)){if(m.length!==n.length)return!1;for(r=0;r<m.length;r++)if(!f(m[r],n[r]))return!1}else{const c=[];for($ in m)c.push($);c.sort();const o=[];for($ in n)o.push($);if(o.sort(),!f(c,o))return!1;for(r=0;r<c.length;r++)if(!f(m[c[r]],n[c[r]]))return!1}return!0}t.$8m=f;function d(m){const n=new Set;return JSON.stringify(m,(r,$)=>{if((0,y.$Af)($)||Array.isArray($)){if(n.has($))return"[Circular]";n.add($)}return $})}t.$9m=d;function T(m,n){const r=Object.create(null);return!m||!n||Object.keys(n).forEach(c=>{const o=m[c],S=n[c];f(o,S)||(r[c]=S)}),r}t.$0m=T;function s(m,n){const r=n.toLowerCase(),$=Object.keys(m).find(c=>c.toLowerCase()===r);return $?m[$]:m[n]}t.$$m=s;function a(m,n){const r=Object.create(null);for(const[$,c]of Object.entries(m))n($,c)&&(r[$]=c);return r}t.$_m=a;function e(m){let n=[];for(;Object.prototype!==m;)n=n.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return n}t.$an=e;function u(m){const n=[];for(const r of e(m))typeof m[r]=="function"&&n.push(r);return n}t.$bn=u;function l(m,n){const r=c=>function(){const o=Array.prototype.slice.call(arguments,0);return n(c,o)},$={};for(const c of m)$[c]=r(c);return $}t.$cn=l}),define(be[18],$e([1,0,17]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$Uj=t.ThemeColor=void 0;var F;(function(w){function D(h){return h&&typeof h=="object"&&typeof h.id=="string"}w.isThemeColor=D})(F||(t.ThemeColor=F={}));function i(w){return{id:w}}t.$Uj=i;var U;(function(w){w.iconNameSegment="[A-Za-z0-9]+",w.iconNameExpression="[A-Za-z0-9-]+",w.iconModifierExpression="~[A-Za-z]+",w.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${w.iconNameExpression})(${w.iconModifierExpression})?$`);function h(n){const r=D.exec(n.id);if(!r)return h(y.$Tj.error);const[,$,c]=r,o=["codicon","codicon-"+$];return c&&o.push("codicon-modifier-"+c.substring(1)),o}w.asClassNameArray=h;function f(n){return h(n).join(" ")}w.asClassName=f;function d(n){return"."+h(n).join(".")}w.asCSSSelector=d;function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||F.isThemeColor(n.color))}w.isThemeIcon=T;const s=new RegExp(`^\\$\\((${w.iconNameExpression}(?:${w.iconModifierExpression})?)\\)$`);function a(n){const r=s.exec(n);if(!r)return;const[,$]=r;return{id:$}}w.fromString=a;function e(n){return{id:n}}w.fromId=e;function u(n,r){let $=n.id;const c=$.lastIndexOf("~");return c!==-1&&($=$.substring(0,c)),r&&($=`${$}~${r}`),{id:$}}w.modify=u;function l(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}w.getModifier=l;function m(n,r){return n.id===r.id&&n.color?.id===r.color?.id}w.isEqual=m})(U||(t.ThemeIcon=U={}))}),define(be[34],$e([1,0,33,12,18]),function(re,t,y,F,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1j=t.$Zj=t.$Yj=t.$Xj=t.$Wj=t.$Vj=void 0;const U="$(",w=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${w.source}`,"g");function h(m){return m.replace(D,(n,r)=>r?n:`\\${n}`)}t.$Vj=h;const f=new RegExp(`\\\\${w.source}`,"g");function d(m){return m.replace(f,n=>`\\${n}`)}t.$Wj=d;const T=new RegExp(`(\\s)?(\\\\)?${w.source}(\\s)?`,"g");function s(m){return m.indexOf(U)===-1?m:m.replace(T,(n,r,$,c)=>$?n:r||c||"")}t.$Xj=s;function a(m){return m?m.replace(/\$\((.*?)\)/g,(n,r)=>` ${r} `).trim():""}t.$Yj=a;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(m){e.lastIndex=0;let n="";const r=[];let $=0;for(;;){const c=e.lastIndex,o=e.exec(m),S=m.substring(c,o?.index);if(S.length>0){n+=S;for(let j=0;j<S.length;j++)r.push($)}if(!o)break;$+=o[0].length}return{text:n,iconOffsets:r}}t.$Zj=u;function l(m,n,r=!1){const{text:$,iconOffsets:c}=n;if(!c||c.length===0)return(0,y.$Ij)(m,$,r);const o=(0,F.$Je)($," "),S=$.length-o.length,j=(0,y.$Ij)(m,o,r);if(j)for(const M of j){const b=c[M.start+S]+S;M.start+=b,M.end+=b}return j}t.$1j=l}),define(be[87],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eT=t.$dT=void 0,t.$dT="vscode:contextmenu",t.$eT="vscode:onCloseContextMenu"}),define(be[88],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lT=void 0;class y{constructor(i,U){this.a=i,this.onMessage=U}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$lT=y}),define(be[50],$e([8]),{}),define(be[89],$e([8]),{}),define(be[90],$e([8]),{}),define(be[91],$e([8]),{}),define(be[92],$e([1,0,90,91]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[93],$e([8]),{}),define(be[94],$e([8]),{}),define(be[95],$e([8]),{}),define(be[96],$e([8]),{}),define(be[97],$e([8]),{}),define(be[98],$e([8]),{}),define(be[99],$e([8]),{}),define(be[100],$e([8]),{}),define(be[101],$e([8]),{}),define(be[102],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[103],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[104],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[105],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[106],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[107],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[108],$e([13,10]),function(re,t){return re.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[109],$e([13,10]),function(re,t){return re.create("vs/base/common/actions",t)}),define(be[35],$e([1,0,4,2,109]),function(re,t,y,F,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yi=t.$xi=t.$wi=t.$vi=t.$ui=t.$ti=void 0;class U extends F.$Sc{constructor(s,a="",e="",u=!0,l){super(),this.h=this.B(new y.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=s,this.m=a,this.u=e,this.w=u,this.C=l}get id(){return this.j}get label(){return this.m}set label(s){this.D(s)}D(s){this.m!==s&&(this.m=s,this.h.fire({label:s}))}get tooltip(){return this.n||""}set tooltip(s){this.F(s)}F(s){this.n!==s&&(this.n=s,this.h.fire({tooltip:s}))}get class(){return this.u}set class(s){this.G(s)}G(s){this.u!==s&&(this.u=s,this.h.fire({class:s}))}get enabled(){return this.w}set enabled(s){this.H(s)}H(s){this.w!==s&&(this.w=s,this.h.fire({enabled:s}))}get checked(){return this.z}set checked(s){this.I(s)}I(s){this.z!==s&&(this.z=s,this.h.fire({checked:s}))}async run(s,a){this.C&&await this.C(s)}}t.$ti=U;class w extends F.$Sc{constructor(){super(...arguments),this.f=this.B(new y.$Nd),this.onWillRun=this.f.event,this.m=this.B(new y.$Nd),this.onDidRun=this.m.event}async run(s,a){if(!s.enabled)return;this.f.fire({action:s});let e;try{await this.u(s,a)}catch(u){e=u}this.m.fire({action:s,error:e})}async u(s,a){await s.run(a)}}t.$ui=w;class D{constructor(){this.id=D.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...s){let a=[];for(const e of s)e.length&&(a.length?a=[...a,new D,...e]:a=e);return a}static{this.ID="vs.actions.separator"}async run(){}}t.$vi=D;class h{get actions(){return this.a}constructor(s,a,e,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=s,this.label=a,this.class=u,this.a=e}async run(){}}t.$wi=h;class f extends U{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,i.localize(0,null),void 0,!1)}}t.$xi=f;function d(T){return{id:T.id,label:T.label,class:void 0,enabled:T.enabled??!0,checked:T.checked??!1,run:async(...s)=>T.run(...s),tooltip:T.label}}t.$yi=d}),define(be[110],$e([13,10]),function(re,t){return re.create("vs/base/common/platform",t)}),define(be[5],$e([1,0,110]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$h=t.$g=void 0,t.$g="en";let F=!1,i=!1,U=!1,w=!1,D=!1,h=!1,f=!1,d=!1,T=!1,s=!1,a,e=t.$g,u=t.$g,l,m;t.$h=typeof self=="object"?self:typeof global=="object"?global:{};let n;typeof t.$h.vscode<"u"&&typeof t.$h.vscode.process<"u"?n=t.$h.vscode.process:typeof process<"u"&&(n=process);const r=typeof n?.versions?.electron=="string",$=r&&n?.type==="renderer";if(typeof navigator=="object"&&!$)m=navigator.userAgent,F=m.indexOf("Windows")>=0,i=m.indexOf("Macintosh")>=0,d=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=m.indexOf("Linux")>=0,s=m?.indexOf("Mobi")>=0,h=!0,a=y.getConfiguredDefaultLocale(y.localize(0,null))||t.$g,e=a,u=navigator.language;else if(typeof n=="object"){F=n.platform==="win32",i=n.platform==="darwin",U=n.platform==="linux",w=U&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,f=r,T=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=t.$g,e=t.$g;const z=n.env.VSCODE_NLS_CONFIG;if(z)try{const W=JSON.parse(z),I=W.availableLanguages["*"];a=W.locale,u=W.osLocale,e=I||t.$g,l=W._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var c;(function(z){z[z.Web=0]="Web",z[z.Mac=1]="Mac",z[z.Linux=2]="Linux",z[z.Windows=3]="Windows"})(c||(t.Platform=c={}));function o(z){switch(z){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$i=o;let S=0;i?S=1:F?S=3:U&&(S=2),t.$j=F,t.$k=i,t.$l=U,t.$m=w,t.$n=D,t.$o=f,t.$p=h,t.$q=h&&typeof t.$h.importScripts=="function",t.$r=d,t.$s=s,t.$t=T,t.$u=S,t.$v=m,t.$w=e;var j;(function(z){function W(){return t.$w}z.value=W;function I(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}z.isDefaultVariant=I;function N(){return t.$w==="en"}z.isDefault=N})(j||(t.Language=j={})),t.$x=a,t.$y=u,t.$z=l,t.$A=typeof t.$h.postMessage=="function"&&!t.$h.importScripts,t.$B=(()=>{if(t.$A){const z=[];t.$h.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let N=0,J=z.length;N<J;N++){const ee=z[N];if(ee.id===I.data.vscodeScheduleAsyncWork){z.splice(N,1),ee.callback();return}}});let W=0;return I=>{const N=++W;z.push({id:N,callback:I}),t.$h.postMessage({vscodeScheduleAsyncWork:N},"*")}}return z=>setTimeout(z)})();var M;(function(z){z[z.Windows=1]="Windows",z[z.Macintosh=2]="Macintosh",z[z.Linux=3]="Linux"})(M||(t.OperatingSystem=M={})),t.OS=i||d?2:F?1:3;let b=!0,v=!1;function B(){if(!v){v=!0;const z=new Uint8Array(2);z[0]=1,z[1]=2,b=new Uint16Array(z.buffer)[0]===(2<<8)+1}return b}t.$D=B,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0)}),define(be[111],$e([1,0,16,5]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rO=t.KeyboardSupport=void 0;var i;(function(U){U[U.Always=0]="Always",U[U.FullScreen=1]="FullScreen",U[U.None=2]="None"})(i||(t.KeyboardSupport=i={})),t.$rO={clipboard:{writeText:F.$n||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:F.$n||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>F.$n||y.$pO()?0:navigator.keyboard||y.$lO?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(be[14],$e([1,0,16,43,76,5]),function(re,t,y,F,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zO=t.$yO=t.$xO=void 0;function w(e){if(e.charCode){const l=String.fromCharCode(e.charCode).toUpperCase();return F.KeyCodeUtils.fromString(l)}const u=e.keyCode;if(u===3)return 7;if(y.$iO)switch(u){case 59:return 85;case 60:if(U.$l)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(U.$k)return 57;break}else if(y.$jO){if(U.$k&&u===93)return 57;if(!U.$k&&u===92)return 57}return F.$yq[u]||0}const D=U.$k?256:2048,h=512,f=1024,d=U.$k?2048:256;function T(e){const u=[];return e.ctrlKey&&u.push("ctrl"),e.shiftKey&&u.push("shift"),e.altKey&&u.push("alt"),e.metaKey&&u.push("meta"),`modifiers: [${u.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$xO=T;function s(e){const u=[];return e.ctrlKey&&u.push("ctrl"),e.shiftKey&&u.push("shift"),e.altKey&&u.push("alt"),e.metaKey&&u.push("meta"),`modifiers: [${u.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${F.KeyCodeUtils.toString(e.keyCode)}')`}t.$yO=s;class a{constructor(u){this._standardKeyboardEventBrand=!0;const l=u;this.browserEvent=l,this.target=l.target,this.ctrlKey=l.ctrlKey,this.shiftKey=l.shiftKey,this.altKey=l.altKey,this.metaKey=l.metaKey,this.altGraphKey=l.getModifierState("AltGraph"),this.keyCode=w(l),this.code=l.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(u){return this.a===u}c(){let u=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(u=this.keyCode);let l=0;return this.ctrlKey&&(l|=D),this.altKey&&(l|=h),this.shiftKey&&(l|=f),this.metaKey&&(l|=d),l|=u,l}d(){let u=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(u=this.keyCode),new i.$Gq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,u)}}t.$zO=a}),define(be[19],$e([1,0,16,67,5]),function(re,t,y,F,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wO=t.$vO=t.$uO=void 0;class U{constructor(f){this.timestamp=Date.now(),this.browserEvent=f,this.leftButton=f.button===0,this.middleButton=f.button===1,this.rightButton=f.button===2,this.buttons=f.buttons,this.target=f.target,this.detail=f.detail||1,f.type==="dblclick"&&(this.detail=2),this.ctrlKey=f.ctrlKey,this.shiftKey=f.shiftKey,this.altKey=f.altKey,this.metaKey=f.metaKey,typeof f.pageX=="number"?(this.posx=f.pageX,this.posy=f.pageY):(this.posx=f.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=f.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const d=F.$sO.getPositionOfChildWindowRelativeToAncestorWindow(window,f.view);this.posx-=d.left,this.posy-=d.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$uO=U;class w extends U{constructor(f){super(f),this.dataTransfer=f.dataTransfer}}t.$vO=w;class D{constructor(f,d=0,T=0){if(this.browserEvent=f||null,this.target=f?f.target||f.targetNode||f.srcElement:null,this.deltaY=T,this.deltaX=d,f){const s=f,a=f;if(typeof s.wheelDeltaY<"u")this.deltaY=s.wheelDeltaY/120;else if(typeof a.VERTICAL_AXIS<"u"&&a.axis===a.VERTICAL_AXIS)this.deltaY=-a.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?y.$iO&&!i.$k?this.deltaY=-f.deltaY/3:this.deltaY=-f.deltaY:this.deltaY=-f.deltaY/40}if(typeof s.wheelDeltaX<"u")y.$lO&&i.$j?this.deltaX=-(s.wheelDeltaX/120):this.deltaX=s.wheelDeltaX/120;else if(typeof a.HORIZONTAL_AXIS<"u"&&a.axis===a.HORIZONTAL_AXIS)this.deltaX=-f.detail/3;else if(f.type==="wheel"){const e=f;e.deltaMode===e.DOM_DELTA_LINE?y.$iO&&!i.$k?this.deltaX=-f.deltaX/3:this.deltaX=-f.deltaX:this.deltaX=-f.deltaX/40}this.deltaY===0&&this.deltaX===0&&f.wheelDelta&&(this.deltaY=f.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$wO=D}),define(be[112],$e([1,0,5]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let F;if(typeof y.$h.vscode<"u"&&typeof y.$h.vscode.process<"u"){const i=y.$h.vscode.process;F={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return y.$j?"win32":y.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=F.cwd,t.env=F.env,t.$dc=F.platform,t.$ec=F.arch}),define(be[22],$e([1,0,112]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const F=65,i=97,U=90,w=122,D=46,h=47,f=92,d=58,T=63;class s extends Error{constructor(S,j,M){let b;typeof j=="string"&&j.indexOf("not ")===0?(b="must not be",j=j.replace(/^not /,"")):b="must be";const v=S.indexOf(".")!==-1?"property":"argument";let B=`The "${S}" ${v} ${b} of type ${j}`;B+=`. Received type ${typeof M}`,super(B),this.code="ERR_INVALID_ARG_TYPE"}}function a(o,S){if(o===null||typeof o!="object")throw new s(S,"Object",o)}function e(o,S){if(typeof o!="string")throw new s(S,"string",o)}const u=y.$dc==="win32";function l(o){return o===h||o===f}function m(o){return o===h}function n(o){return o>=F&&o<=U||o>=i&&o<=w}function r(o,S,j,M){let b="",v=0,B=-1,z=0,W=0;for(let I=0;I<=o.length;++I){if(I<o.length)W=o.charCodeAt(I);else{if(M(W))break;W=h}if(M(W)){if(!(B===I-1||z===1))if(z===2){if(b.length<2||v!==2||b.charCodeAt(b.length-1)!==D||b.charCodeAt(b.length-2)!==D){if(b.length>2){const N=b.lastIndexOf(j);N===-1?(b="",v=0):(b=b.slice(0,N),v=b.length-1-b.lastIndexOf(j)),B=I,z=0;continue}else if(b.length!==0){b="",v=0,B=I,z=0;continue}}S&&(b+=b.length>0?`${j}..`:"..",v=2)}else b.length>0?b+=`${j}${o.slice(B+1,I)}`:b=o.slice(B+1,I),v=I-B-1;B=I,z=0}else W===D&&z!==-1?++z:z=-1}return b}function $(o,S){a(S,"pathObject");const j=S.dir||S.root,M=S.base||`${S.name||""}${S.ext||""}`;return j?j===S.root?`${j}${M}`:`${j}${o}${M}`:M}t.$fc={resolve(...o){let S="",j="",M=!1;for(let b=o.length-1;b>=-1;b--){let v;if(b>=0){if(v=o[b],e(v,"path"),v.length===0)continue}else S.length===0?v=y.cwd():(v=y.env[`=${S}`]||y.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==S.toLowerCase()&&v.charCodeAt(2)===f)&&(v=`${S}\\`));const B=v.length;let z=0,W="",I=!1;const N=v.charCodeAt(0);if(B===1)l(N)&&(z=1,I=!0);else if(l(N))if(I=!0,l(v.charCodeAt(1))){let J=2,ee=J;for(;J<B&&!l(v.charCodeAt(J));)J++;if(J<B&&J!==ee){const ne=v.slice(ee,J);for(ee=J;J<B&&l(v.charCodeAt(J));)J++;if(J<B&&J!==ee){for(ee=J;J<B&&!l(v.charCodeAt(J));)J++;(J===B||J!==ee)&&(W=`\\\\${ne}\\${v.slice(ee,J)}`,z=J)}}}else z=1;else n(N)&&v.charCodeAt(1)===d&&(W=v.slice(0,2),z=2,B>2&&l(v.charCodeAt(2))&&(I=!0,z=3));if(W.length>0)if(S.length>0){if(W.toLowerCase()!==S.toLowerCase())continue}else S=W;if(M){if(S.length>0)break}else if(j=`${v.slice(z)}\\${j}`,M=I,I&&S.length>0)break}return j=r(j,!M,"\\",l),M?`${S}\\${j}`:`${S}${j}`||"."},normalize(o){e(o,"path");const S=o.length;if(S===0)return".";let j=0,M,b=!1;const v=o.charCodeAt(0);if(S===1)return m(v)?"\\":o;if(l(v))if(b=!0,l(o.charCodeAt(1))){let z=2,W=z;for(;z<S&&!l(o.charCodeAt(z));)z++;if(z<S&&z!==W){const I=o.slice(W,z);for(W=z;z<S&&l(o.charCodeAt(z));)z++;if(z<S&&z!==W){for(W=z;z<S&&!l(o.charCodeAt(z));)z++;if(z===S)return`\\\\${I}\\${o.slice(W)}\\`;z!==W&&(M=`\\\\${I}\\${o.slice(W,z)}`,j=z)}}}else j=1;else n(v)&&o.charCodeAt(1)===d&&(M=o.slice(0,2),j=2,S>2&&l(o.charCodeAt(2))&&(b=!0,j=3));let B=j<S?r(o.slice(j),!b,"\\",l):"";return B.length===0&&!b&&(B="."),B.length>0&&l(o.charCodeAt(S-1))&&(B+="\\"),M===void 0?b?`\\${B}`:B:b?`${M}\\${B}`:`${M}${B}`},isAbsolute(o){e(o,"path");const S=o.length;if(S===0)return!1;const j=o.charCodeAt(0);return l(j)||S>2&&n(j)&&o.charCodeAt(1)===d&&l(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let S,j;for(let v=0;v<o.length;++v){const B=o[v];e(B,"path"),B.length>0&&(S===void 0?S=j=B:S+=`\\${B}`)}if(S===void 0)return".";let M=!0,b=0;if(typeof j=="string"&&l(j.charCodeAt(0))){++b;const v=j.length;v>1&&l(j.charCodeAt(1))&&(++b,v>2&&(l(j.charCodeAt(2))?++b:M=!1))}if(M){for(;b<S.length&&l(S.charCodeAt(b));)b++;b>=2&&(S=`\\${S.slice(b)}`)}return t.$fc.normalize(S)},relative(o,S){if(e(o,"from"),e(S,"to"),o===S)return"";const j=t.$fc.resolve(o),M=t.$fc.resolve(S);if(j===M||(o=j.toLowerCase(),S=M.toLowerCase(),o===S))return"";let b=0;for(;b<o.length&&o.charCodeAt(b)===f;)b++;let v=o.length;for(;v-1>b&&o.charCodeAt(v-1)===f;)v--;const B=v-b;let z=0;for(;z<S.length&&S.charCodeAt(z)===f;)z++;let W=S.length;for(;W-1>z&&S.charCodeAt(W-1)===f;)W--;const I=W-z,N=B<I?B:I;let J=-1,ee=0;for(;ee<N;ee++){const ue=o.charCodeAt(b+ee);if(ue!==S.charCodeAt(z+ee))break;ue===f&&(J=ee)}if(ee!==N){if(J===-1)return M}else{if(I>N){if(S.charCodeAt(z+ee)===f)return M.slice(z+ee+1);if(ee===2)return M.slice(z+ee)}B>N&&(o.charCodeAt(b+ee)===f?J=ee:ee===2&&(J=3)),J===-1&&(J=0)}let ne="";for(ee=b+J+1;ee<=v;++ee)(ee===v||o.charCodeAt(ee)===f)&&(ne+=ne.length===0?"..":"\\..");return z+=J,ne.length>0?`${ne}${M.slice(z,W)}`:(M.charCodeAt(z)===f&&++z,M.slice(z,W))},toNamespacedPath(o){if(typeof o!="string"||o.length===0)return o;const S=t.$fc.resolve(o);if(S.length<=2)return o;if(S.charCodeAt(0)===f){if(S.charCodeAt(1)===f){const j=S.charCodeAt(2);if(j!==T&&j!==D)return`\\\\?\\UNC\\${S.slice(2)}`}}else if(n(S.charCodeAt(0))&&S.charCodeAt(1)===d&&S.charCodeAt(2)===f)return`\\\\?\\${S}`;return o},dirname(o){e(o,"path");const S=o.length;if(S===0)return".";let j=-1,M=0;const b=o.charCodeAt(0);if(S===1)return l(b)?o:".";if(l(b)){if(j=M=1,l(o.charCodeAt(1))){let z=2,W=z;for(;z<S&&!l(o.charCodeAt(z));)z++;if(z<S&&z!==W){for(W=z;z<S&&l(o.charCodeAt(z));)z++;if(z<S&&z!==W){for(W=z;z<S&&!l(o.charCodeAt(z));)z++;if(z===S)return o;z!==W&&(j=M=z+1)}}}}else n(b)&&o.charCodeAt(1)===d&&(j=S>2&&l(o.charCodeAt(2))?3:2,M=j);let v=-1,B=!0;for(let z=S-1;z>=M;--z)if(l(o.charCodeAt(z))){if(!B){v=z;break}}else B=!1;if(v===-1){if(j===-1)return".";v=j}return o.slice(0,v)},basename(o,S){S!==void 0&&e(S,"ext"),e(o,"path");let j=0,M=-1,b=!0,v;if(o.length>=2&&n(o.charCodeAt(0))&&o.charCodeAt(1)===d&&(j=2),S!==void 0&&S.length>0&&S.length<=o.length){if(S===o)return"";let B=S.length-1,z=-1;for(v=o.length-1;v>=j;--v){const W=o.charCodeAt(v);if(l(W)){if(!b){j=v+1;break}}else z===-1&&(b=!1,z=v+1),B>=0&&(W===S.charCodeAt(B)?--B===-1&&(M=v):(B=-1,M=z))}return j===M?M=z:M===-1&&(M=o.length),o.slice(j,M)}for(v=o.length-1;v>=j;--v)if(l(o.charCodeAt(v))){if(!b){j=v+1;break}}else M===-1&&(b=!1,M=v+1);return M===-1?"":o.slice(j,M)},extname(o){e(o,"path");let S=0,j=-1,M=0,b=-1,v=!0,B=0;o.length>=2&&o.charCodeAt(1)===d&&n(o.charCodeAt(0))&&(S=M=2);for(let z=o.length-1;z>=S;--z){const W=o.charCodeAt(z);if(l(W)){if(!v){M=z+1;break}continue}b===-1&&(v=!1,b=z+1),W===D?j===-1?j=z:B!==1&&(B=1):j!==-1&&(B=-1)}return j===-1||b===-1||B===0||B===1&&j===b-1&&j===M+1?"":o.slice(j,b)},format:$.bind(null,"\\"),parse(o){e(o,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return S;const j=o.length;let M=0,b=o.charCodeAt(0);if(j===1)return l(b)?(S.root=S.dir=o,S):(S.base=S.name=o,S);if(l(b)){if(M=1,l(o.charCodeAt(1))){let J=2,ee=J;for(;J<j&&!l(o.charCodeAt(J));)J++;if(J<j&&J!==ee){for(ee=J;J<j&&l(o.charCodeAt(J));)J++;if(J<j&&J!==ee){for(ee=J;J<j&&!l(o.charCodeAt(J));)J++;J===j?M=J:J!==ee&&(M=J+1)}}}}else if(n(b)&&o.charCodeAt(1)===d){if(j<=2)return S.root=S.dir=o,S;if(M=2,l(o.charCodeAt(2))){if(j===3)return S.root=S.dir=o,S;M=3}}M>0&&(S.root=o.slice(0,M));let v=-1,B=M,z=-1,W=!0,I=o.length-1,N=0;for(;I>=M;--I){if(b=o.charCodeAt(I),l(b)){if(!W){B=I+1;break}continue}z===-1&&(W=!1,z=I+1),b===D?v===-1?v=I:N!==1&&(N=1):v!==-1&&(N=-1)}return z!==-1&&(v===-1||N===0||N===1&&v===z-1&&v===B+1?S.base=S.name=o.slice(B,z):(S.name=o.slice(B,v),S.base=o.slice(B,z),S.ext=o.slice(v,z))),B>0&&B!==M?S.dir=o.slice(0,B-1):S.dir=S.root,S},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(u){const o=/\\/g;return()=>{const S=y.cwd().replace(o,"/");return S.slice(S.indexOf("/"))}}return()=>y.cwd()})();t.$gc={resolve(...o){let S="",j=!1;for(let M=o.length-1;M>=-1&&!j;M--){const b=M>=0?o[M]:c();e(b,"path"),b.length!==0&&(S=`${b}/${S}`,j=b.charCodeAt(0)===h)}return S=r(S,!j,"/",m),j?`/${S}`:S.length>0?S:"."},normalize(o){if(e(o,"path"),o.length===0)return".";const S=o.charCodeAt(0)===h,j=o.charCodeAt(o.length-1)===h;return o=r(o,!S,"/",m),o.length===0?S?"/":j?"./":".":(j&&(o+="/"),S?`/${o}`:o)},isAbsolute(o){return e(o,"path"),o.length>0&&o.charCodeAt(0)===h},join(...o){if(o.length===0)return".";let S;for(let j=0;j<o.length;++j){const M=o[j];e(M,"path"),M.length>0&&(S===void 0?S=M:S+=`/${M}`)}return S===void 0?".":t.$gc.normalize(S)},relative(o,S){if(e(o,"from"),e(S,"to"),o===S||(o=t.$gc.resolve(o),S=t.$gc.resolve(S),o===S))return"";const j=1,M=o.length,b=M-j,v=1,B=S.length-v,z=b<B?b:B;let W=-1,I=0;for(;I<z;I++){const J=o.charCodeAt(j+I);if(J!==S.charCodeAt(v+I))break;J===h&&(W=I)}if(I===z)if(B>z){if(S.charCodeAt(v+I)===h)return S.slice(v+I+1);if(I===0)return S.slice(v+I)}else b>z&&(o.charCodeAt(j+I)===h?W=I:I===0&&(W=0));let N="";for(I=j+W+1;I<=M;++I)(I===M||o.charCodeAt(I)===h)&&(N+=N.length===0?"..":"/..");return`${N}${S.slice(v+W)}`},toNamespacedPath(o){return o},dirname(o){if(e(o,"path"),o.length===0)return".";const S=o.charCodeAt(0)===h;let j=-1,M=!0;for(let b=o.length-1;b>=1;--b)if(o.charCodeAt(b)===h){if(!M){j=b;break}}else M=!1;return j===-1?S?"/":".":S&&j===1?"//":o.slice(0,j)},basename(o,S){S!==void 0&&e(S,"ext"),e(o,"path");let j=0,M=-1,b=!0,v;if(S!==void 0&&S.length>0&&S.length<=o.length){if(S===o)return"";let B=S.length-1,z=-1;for(v=o.length-1;v>=0;--v){const W=o.charCodeAt(v);if(W===h){if(!b){j=v+1;break}}else z===-1&&(b=!1,z=v+1),B>=0&&(W===S.charCodeAt(B)?--B===-1&&(M=v):(B=-1,M=z))}return j===M?M=z:M===-1&&(M=o.length),o.slice(j,M)}for(v=o.length-1;v>=0;--v)if(o.charCodeAt(v)===h){if(!b){j=v+1;break}}else M===-1&&(b=!1,M=v+1);return M===-1?"":o.slice(j,M)},extname(o){e(o,"path");let S=-1,j=0,M=-1,b=!0,v=0;for(let B=o.length-1;B>=0;--B){const z=o.charCodeAt(B);if(z===h){if(!b){j=B+1;break}continue}M===-1&&(b=!1,M=B+1),z===D?S===-1?S=B:v!==1&&(v=1):S!==-1&&(v=-1)}return S===-1||M===-1||v===0||v===1&&S===M-1&&S===j+1?"":o.slice(S,M)},format:$.bind(null,"/"),parse(o){e(o,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return S;const j=o.charCodeAt(0)===h;let M;j?(S.root="/",M=1):M=0;let b=-1,v=0,B=-1,z=!0,W=o.length-1,I=0;for(;W>=M;--W){const N=o.charCodeAt(W);if(N===h){if(!z){v=W+1;break}continue}B===-1&&(z=!1,B=W+1),N===D?b===-1?b=W:I!==1&&(I=1):b!==-1&&(I=-1)}if(B!==-1){const N=v===0&&j?1:v;b===-1||I===0||I===1&&b===B-1&&b===v+1?S.base=S.name=o.slice(N,B):(S.name=o.slice(N,b),S.base=o.slice(N,B),S.ext=o.slice(b,B))}return v>0?S.dir=o.slice(0,v-1):j&&(S.dir="/"),S},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=u?t.$fc.normalize:t.$gc.normalize,t.$ic=u?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=u?t.$fc.join:t.$gc.join,t.$kc=u?t.$fc.resolve:t.$gc.resolve,t.$lc=u?t.$fc.relative:t.$gc.relative,t.$mc=u?t.$fc.dirname:t.$gc.dirname,t.$nc=u?t.$fc.basename:t.$gc.basename,t.$oc=u?t.$fc.extname:t.$gc.extname,t.$pc=u?t.$fc.format:t.$gc.format,t.$qc=u?t.$fc.parse:t.$gc.parse,t.$rc=u?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=u?t.$fc.sep:t.$gc.sep,t.$tc=u?t.$fc.delimiter:t.$gc.delimiter}),define(be[113],$e([1,0,22,5,12,7]),function(re,t,y,F,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=void 0;function w(v){return v===47||v===92}t.$Qf=w;function D(v){return v.replace(/[\\/]/g,y.$gc.sep)}t.$Rf=D;function h(v){return v.indexOf("/")===-1&&(v=D(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}t.$Sf=h;function f(v,B=y.$gc.sep){if(!v)return"";const z=v.length,W=v.charCodeAt(0);if(w(W)){if(w(v.charCodeAt(1))&&!w(v.charCodeAt(2))){let N=3;const J=N;for(;N<z&&!w(v.charCodeAt(N));N++);if(J!==N&&!w(v.charCodeAt(N+1))){for(N+=1;N<z;N++)if(w(v.charCodeAt(N)))return v.slice(0,N+1).replace(/[\\/]/g,B)}}return B}else if(m(W)&&v.charCodeAt(1)===58)return w(v.charCodeAt(2))?v.slice(0,2)+B:v.slice(0,2);let I=v.indexOf("://");if(I!==-1){for(I+=3;I<z;I++)if(w(v.charCodeAt(I)))return v.slice(0,I+1)}return""}t.$Tf=f;function d(v){if(!F.$j||!v||v.length<5)return!1;let B=v.charCodeAt(0);if(B!==92||(B=v.charCodeAt(1),B!==92))return!1;let z=2;const W=z;for(;z<v.length&&(B=v.charCodeAt(z),B!==92);z++);return!(W===z||(B=v.charCodeAt(z+1),isNaN(B)||B===92))}t.$Uf=d;const T=/[\\/:\*\?"<>\|]/g,s=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(v,B=F.$j){const z=B?T:s;return!(!v||v.length===0||/^\s+$/.test(v)||(z.lastIndex=0,z.test(v))||B&&a.test(v)||v==="."||v===".."||B&&v[v.length-1]==="."||B&&v.length!==v.trim().length||v.length>255)}t.$Vf=e;function u(v,B,z){const W=v===B;return!z||W?W:!v||!B?!1:(0,i.$2e)(v,B)}t.$Wf=u;function l(v,B,z,W=y.sep){if(v===B)return!0;if(!v||!B||B.length>v.length)return!1;if(z){if(!(0,i.$3e)(v,B))return!1;if(B.length===v.length)return!0;let N=B.length;return B.charAt(B.length-1)===W&&N--,v.charAt(N)===W}return B.charAt(B.length-1)!==W&&(B+=W),v.indexOf(B)===0}t.$Xf=l;function m(v){return v>=65&&v<=90||v>=97&&v<=122}t.$Yf=m;function n(v,B){return F.$j&&v.endsWith(":")&&(v+=y.sep),(0,y.$ic)(v)||(v=(0,y.$jc)(B,v)),v=(0,y.$hc)(v),F.$j?(v=(0,i.$Ke)(v,y.sep),v.endsWith(":")&&(v+=y.sep)):(v=(0,i.$Ke)(v,y.sep),v||(v=y.sep)),v}t.$Zf=n;function r(v){const B=(0,y.$hc)(v);return F.$j?v.length>3?!1:$(B)&&(v.length===2||B.charCodeAt(2)===92):B===y.$gc.sep}t.$1f=r;function $(v,B=F.$j){return B?m(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}t.$2f=$;function c(v,B=F.$j){return $(v,B)?v[0]:void 0}t.$3f=c;function o(v,B,z){return B.length>v.length?-1:v===B?0:(z&&(v=v.toLowerCase(),B=B.toLowerCase()),v.indexOf(B))}t.$4f=o;function S(v){const B=v.split(":");let z,W,I;for(const N of B){const J=Number(N);(0,U.$Cf)(J)?W===void 0?W=J:I===void 0&&(I=J):z=z?[z,N].join(":"):N}if(!z)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:z,line:W!==void 0?W:void 0,column:I!==void 0?I:W!==void 0?1:void 0}}t.$5f=S;const j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",M="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(v,B,z=8){let W="";for(let N=0;N<z;N++){let J;N===0&&F.$j&&!B&&(z===3||z===4)?J=M:J=j,W+=J.charAt(Math.floor(Math.random()*J.length))}let I;return B?I=`${B}-${W}`:I=W,v?(0,y.$jc)(v,I):I}t.$6f=b}),define(be[114],$e([1,0,22]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rr=t.$Qr=t.$Pr=t.$Or=t.$Nr=void 0,t.$Nr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U(d){const T=(0,y.$oc)(d),s=F[T.toLowerCase()];return s!==void 0?s:w(d)}t.$Or=U;function w(d){const T=(0,y.$oc)(d);return i[T.toLowerCase()]}t.$Pr=w;function D(d){for(const T in i)if(i[T]===d)return T}t.$Qr=D;const h=/^(.+)\/(.+?)(;.+)?$/;function f(d,T){const s=h.exec(d);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:T?void 0:d}t.$Rr=f}),define(be[15],$e([1,0,22,5]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,U=/^\//,w=/^\/\//;function D(M,b){if(!M.scheme&&b)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${M.authority}", path: "${M.path}", query: "${M.query}", fragment: "${M.fragment}"}`);if(M.scheme&&!i.test(M.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(M.path){if(M.authority){if(!U.test(M.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(M.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(M,b){return!M&&!b?"file":M}function f(M,b){switch(M){case"https":case"http":case"file":b?b[0]!==T&&(b=T+b):b=T;break}return b}const d="",T="/",s=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(b){return b instanceof a?!0:b?typeof b.authority=="string"&&typeof b.fragment=="string"&&typeof b.path=="string"&&typeof b.query=="string"&&typeof b.scheme=="string"&&typeof b.fsPath=="string"&&typeof b.with=="function"&&typeof b.toString=="function":!1}constructor(b,v,B,z,W,I=!1){typeof b=="object"?(this.scheme=b.scheme||d,this.authority=b.authority||d,this.path=b.path||d,this.query=b.query||d,this.fragment=b.fragment||d):(this.scheme=h(b,I),this.authority=v||d,this.path=f(this.scheme,B||d),this.query=z||d,this.fragment=W||d,D(this,I))}get fsPath(){return $(this,!1)}with(b){if(!b)return this;let{scheme:v,authority:B,path:z,query:W,fragment:I}=b;return v===void 0?v=this.scheme:v===null&&(v=d),B===void 0?B=this.authority:B===null&&(B=d),z===void 0?z=this.path:z===null&&(z=d),W===void 0?W=this.query:W===null&&(W=d),I===void 0?I=this.fragment:I===null&&(I=d),v===this.scheme&&B===this.authority&&z===this.path&&W===this.query&&I===this.fragment?this:new l(v,B,z,W,I)}static parse(b,v=!1){const B=s.exec(b);return B?new l(B[2]||d,j(B[4]||d),j(B[5]||d),j(B[7]||d),j(B[9]||d),v):new l(d,d,d,d,d)}static file(b){let v=d;if(F.$j&&(b=b.replace(/\\/g,T)),b[0]===T&&b[1]===T){const B=b.indexOf(T,2);B===-1?(v=b.substring(2),b=T):(v=b.substring(2,B),b=b.substring(B)||T)}return new l("file",v,b,d,d)}static from(b,v){return new l(b.scheme,b.authority,b.path,b.query,b.fragment,v)}static joinPath(b,...v){if(!b.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let B;return F.$j&&b.scheme==="file"?B=a.file(y.$fc.join($(b,!0),...v)).path:B=y.$gc.join(b.path,...v),b.with({path:B})}toString(b=!1){return c(this,b)}toJSON(){return this}static revive(b){if(b){if(b instanceof a)return b;{const v=new l(b);return v._formatted=b.external??null,v._fsPath=b._sep===u?b.fsPath??null:null,v}}else return b}}t.URI=a;function e(M){return!M||typeof M!="object"?!1:typeof M.scheme=="string"&&(typeof M.authority=="string"||typeof M.authority>"u")&&(typeof M.path=="string"||typeof M.path>"u")&&(typeof M.query=="string"||typeof M.query>"u")&&(typeof M.fragment=="string"||typeof M.fragment>"u")}t.$vc=e;const u=F.$j?1:void 0;class l extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=$(this,!1)),this._fsPath}toString(b=!1){return b?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const b={$mid:1};return this._fsPath&&(b.fsPath=this._fsPath,b._sep=u),this._formatted&&(b.external=this._formatted),this.path&&(b.path=this.path),this.scheme&&(b.scheme=this.scheme),this.authority&&(b.authority=this.authority),this.query&&(b.query=this.query),this.fragment&&(b.fragment=this.fragment),b}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function n(M,b,v){let B,z=-1;for(let W=0;W<M.length;W++){const I=M.charCodeAt(W);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||b&&I===47||v&&I===91||v&&I===93||v&&I===58)z!==-1&&(B+=encodeURIComponent(M.substring(z,W)),z=-1),B!==void 0&&(B+=M.charAt(W));else{B===void 0&&(B=M.substr(0,W));const N=m[I];N!==void 0?(z!==-1&&(B+=encodeURIComponent(M.substring(z,W)),z=-1),B+=N):z===-1&&(z=W)}}return z!==-1&&(B+=encodeURIComponent(M.substring(z))),B!==void 0?B:M}function r(M){let b;for(let v=0;v<M.length;v++){const B=M.charCodeAt(v);B===35||B===63?(b===void 0&&(b=M.substr(0,v)),b+=m[B]):b!==void 0&&(b+=M[v])}return b!==void 0?b:M}function $(M,b){let v;return M.authority&&M.path.length>1&&M.scheme==="file"?v=`//${M.authority}${M.path}`:M.path.charCodeAt(0)===47&&(M.path.charCodeAt(1)>=65&&M.path.charCodeAt(1)<=90||M.path.charCodeAt(1)>=97&&M.path.charCodeAt(1)<=122)&&M.path.charCodeAt(2)===58?b?v=M.path.substr(1):v=M.path[1].toLowerCase()+M.path.substr(2):v=M.path,F.$j&&(v=v.replace(/\//g,"\\")),v}t.$wc=$;function c(M,b){const v=b?r:n;let B="",{scheme:z,authority:W,path:I,query:N,fragment:J}=M;if(z&&(B+=z,B+=":"),(W||z==="file")&&(B+=T,B+=T),W){let ee=W.indexOf("@");if(ee!==-1){const ne=W.substr(0,ee);W=W.substr(ee+1),ee=ne.lastIndexOf(":"),ee===-1?B+=v(ne,!1,!1):(B+=v(ne.substr(0,ee),!1,!1),B+=":",B+=v(ne.substr(ee+1),!1,!0)),B+="@"}W=W.toLowerCase(),ee=W.lastIndexOf(":"),ee===-1?B+=v(W,!1,!0):(B+=v(W.substr(0,ee),!1,!0),B+=W.substr(ee))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const ee=I.charCodeAt(1);ee>=65&&ee<=90&&(I=`/${String.fromCharCode(ee+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const ee=I.charCodeAt(0);ee>=65&&ee<=90&&(I=`${String.fromCharCode(ee+32)}:${I.substr(2)}`)}B+=v(I,!0,!1)}return N&&(B+="?",B+=v(N,!1,!1)),J&&(B+="#",B+=b?J:n(J,!1,!1)),B}function o(M){try{return decodeURIComponent(M)}catch{return M.length>3?M.substr(0,3)+o(M.substr(3)):M}}const S=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function j(M){return M.match(S)?M.replace(S,b=>o(b)):M}}),define(be[51],$e([1,0,32,15]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lh=t.$kh=t.$jh=void 0;function i(h){return JSON.stringify(h,w)}t.$jh=i;function U(h){let f=JSON.parse(h);return f=D(f),f}t.$kh=U;function w(h,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function D(h,f=0){if(!h||f>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return F.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof y.$be||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let d=0;d<h.length;++d)h[d]=D(h[d],f+1);else for(const d in h)Object.hasOwnProperty.call(h,d)&&(h[d]=D(h[d],f+1))}return h}t.$lh=D}),define(be[29],$e([1,0,6,5,15]),function(re,t,y,F,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.Schemas=void 0;var U;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(U||(t.Schemas=U={})),t.$7f="vscode-tkn",t.$8f="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${U.vscodeRemoteResource}`}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d){this.f=`${d}/${U.vscodeRemoteResource}`}set(d,T,s){this.a[d]=T,this.b[d]=s}setConnectionToken(d,T){this.c[d]=T}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)try{return this.e(d)}catch(l){return y.$1(l),d}const T=d.authority;let s=this.a[T];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const a=this.b[T],e=this.c[T];let u=`path=${encodeURIComponent(d.path)}`;return typeof e=="string"&&(u+=`&${t.$8f}=${encodeURIComponent(e)}`),i.URI.from({scheme:F.$p?this.d:U.vscodeRemoteResource,authority:`${s}:${a}`,path:this.f,query:u})}}t.$9f=new w,t.$0f="vs/../../extensions",t.$$f="vs/../../node_modules",t.$_f="vs/../../node_modules.asar",t.$ag="vs/../../node_modules.asar.unpacked",t.$bg="vscode-app";class D{static{this.a=t.$bg}asBrowserUri(d){const T=this.b(d,re);return this.uriToBrowserUri(T)}uriToBrowserUri(d){return d.scheme===U.vscodeRemote?t.$9f.rewrite(d):d.scheme===U.file&&(F.$n||F.$q&&F.$h.origin===`${U.vscodeFileResource}://${D.a}`)?d.with({scheme:U.vscodeFileResource,authority:d.authority||D.a,query:null,fragment:null}):d}asFileUri(d){const T=this.b(d,re);return this.uriToFileUri(T)}uriToFileUri(d){return d.scheme===U.vscodeFileResource?d.with({scheme:U.file,authority:d.authority!==D.a?d.authority:null,query:null,fragment:null}):d}b(d,T){return i.URI.isUri(d)?d:i.URI.parse(T.toUrl(d))}}t.$cg=new D;var h;(function(f){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(d.get("3"));const T="vscode-coi";function s(e){let u;typeof e=="string"?u=new URL(e).searchParams:e instanceof URL?u=e.searchParams:i.URI.isUri(e)&&(u=new URL(e.toString(!0)).searchParams);const l=u?.get(T);if(l)return d.get(l)}f.getHeadersFromQuery=s;function a(e,u,l){if(!globalThis.crossOriginIsolated)return;const m=u&&l?"3":l?"2":"1";e instanceof URLSearchParams?e.set(T,m):e[T]=m}f.addSearchParam=a})(h||(t.COI=h={}))}),define(be[36],$e([1,0,113,29,22,5,12,15]),function(re,t,y,F,i,U,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fg=t.DataUri=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=t.$rg=t.$qg=t.$pg=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=t.$jg=void 0;function h(a){return(0,D.$wc)(a,!0)}t.$jg=h;class f{constructor(e){this.a=e}compare(e,u,l=!1){return e===u?0:(0,w.$Ue)(this.getComparisonKey(e,l),this.getComparisonKey(u,l))}isEqual(e,u,l=!1){return e===u?!0:!e||!u?!1:this.getComparisonKey(e,l)===this.getComparisonKey(u,l)}getComparisonKey(e,u=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,u,l=!1){if(e.scheme===u.scheme){if(e.scheme===F.Schemas.file)return y.$Xf(h(e),h(u),this.a(e))&&e.query===u.query&&(l||e.fragment===u.fragment);if((0,t.$Ag)(e.authority,u.authority))return y.$Xf(e.path,u.path,this.a(e),"/")&&e.query===u.query&&(l||e.fragment===u.fragment)}return!1}joinPath(e,...u){return D.URI.joinPath(e,...u)}basenameOrAuthority(e){return(0,t.$sg)(e)||e.authority}basename(e){return i.$gc.basename(e.path)}extname(e){return i.$gc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let u;return e.scheme===F.Schemas.file?u=D.URI.file(i.$mc(h(e))).path:(u=i.$gc.dirname(e.path),e.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),u="/")),e.with({path:u})}normalizePath(e){if(!e.path.length)return e;let u;return e.scheme===F.Schemas.file?u=D.URI.file(i.$hc(h(e))).path:u=i.$gc.normalize(e.path),e.with({path:u})}relativePath(e,u){if(e.scheme!==u.scheme||!(0,t.$Ag)(e.authority,u.authority))return;if(e.scheme===F.Schemas.file){const n=i.$lc(h(e),h(u));return U.$j?y.$Rf(n):n}let l=e.path||"/";const m=u.path||"/";if(this.a(e)){let n=0;for(const r=Math.min(l.length,m.length);n<r&&!(l.charCodeAt(n)!==m.charCodeAt(n)&&l.charAt(n).toLowerCase()!==m.charAt(n).toLowerCase());n++);l=m.substr(0,n)+l.substr(n)}return i.$gc.relative(l,m)}resolvePath(e,u){if(e.scheme===F.Schemas.file){const l=D.URI.file(i.$kc(h(e),u));return e.with({authority:l.authority,path:l.path})}return u=y.$Sf(u),e.with({path:i.$gc.resolve(e.path,u)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,u){return e===u||e!==void 0&&u!==void 0&&(0,w.$2e)(e,u)}hasTrailingPathSeparator(e,u=i.sep){if(e.scheme===F.Schemas.file){const l=h(e);return l.length>y.$Tf(l).length&&l[l.length-1]===u}else{const l=e.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,u=i.sep){return(0,t.$Bg)(e,u)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,u=i.sep){let l=!1;if(e.scheme===F.Schemas.file){const m=h(e);l=m!==void 0&&m.length===y.$Tf(m).length&&m[m.length-1]===u}else{u="/";const m=e.path;l=m.length===1&&m.charCodeAt(m.length-1)===47}return!l&&!(0,t.$Bg)(e,u)?e.with({path:e.path+"/"}):e}}t.$kg=f,t.$lg=new f(()=>!1),t.$mg=new f(a=>a.scheme===F.Schemas.file?!U.$l:!0),t.$ng=new f(a=>!0),t.$og=t.$lg.isEqual.bind(t.$lg),t.$pg=t.$lg.isEqualOrParent.bind(t.$lg),t.$qg=t.$lg.getComparisonKey.bind(t.$lg),t.$rg=t.$lg.basenameOrAuthority.bind(t.$lg),t.$sg=t.$lg.basename.bind(t.$lg),t.$tg=t.$lg.extname.bind(t.$lg),t.$ug=t.$lg.dirname.bind(t.$lg),t.$vg=t.$lg.joinPath.bind(t.$lg),t.$wg=t.$lg.normalizePath.bind(t.$lg),t.$xg=t.$lg.relativePath.bind(t.$lg),t.$yg=t.$lg.resolvePath.bind(t.$lg),t.$zg=t.$lg.isAbsolutePath.bind(t.$lg),t.$Ag=t.$lg.isEqualAuthority.bind(t.$lg),t.$Bg=t.$lg.hasTrailingPathSeparator.bind(t.$lg),t.$Cg=t.$lg.removeTrailingPathSeparator.bind(t.$lg),t.$Dg=t.$lg.addTrailingPathSeparator.bind(t.$lg);function d(a,e){const u=[];for(let l=0;l<a.length;l++){const m=e(a[l]);a.some((n,r)=>r===l?!1:(0,t.$pg)(m,e(n)))||u.push(a[l])}return u}t.$Eg=d;var T;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function e(u){const l=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(r=>{const[$,c]=r.split(":");$&&c&&l.set($,c)});const n=u.path.substring(0,u.path.indexOf(";"));return n&&l.set(a.META_DATA_MIME,n),l}a.parseMetaData=e})(T||(t.DataUri=T={}));function s(a,e,u){if(e){let l=a.path;return l&&l[0]!==i.$gc.sep&&(l=i.$gc.sep+l),a.with({scheme:u,authority:e,path:l})}return a.with({scheme:u})}t.$Fg=s}),define(be[9],$e([1,0,28,6,4,2,36,5,48]),function(re,t,y,F,i,U,w,D,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fh=t.$eh=t.$dh=t.Promises=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=void 0;function f(g){return!!g&&typeof g.then=="function"}t.$Gg=f;function d(g){const p=new y.$Xd,V=g(p.token),L=new Promise((P,O)=>{const q=p.token.onCancellationRequested(()=>{q.dispose(),p.dispose(),O(new F.$5)});Promise.resolve(V).then(C=>{q.dispose(),p.dispose(),P(C)},C=>{q.dispose(),p.dispose(),O(C)})});return new class{cancel(){p.cancel()}then(P,O){return L.then(P,O)}catch(P){return this.then(void 0,P)}finally(P){return L.finally(P)}}}t.$Hg=d;function T(g,p,V){return new Promise((L,P)=>{const O=p.onCancellationRequested(()=>{O.dispose(),L(V)});g.then(L,P).finally(()=>O.dispose())})}t.$Ig=T;function s(g,p){return new Promise((V,L)=>{const P=p.onCancellationRequested(()=>{P.dispose(),L(new F.$5)});g.then(V,L).finally(()=>P.dispose())})}t.$Jg=s;async function a(g){let p=-1;const V=g.map((L,P)=>L.then(O=>(p=P,O)));try{return await Promise.race(V)}finally{g.forEach((L,P)=>{P!==p&&L.cancel()})}}t.$Kg=a;function e(g,p,V){let L;const P=setTimeout(()=>{L?.(void 0),V?.()},p);return Promise.race([g.finally(()=>clearTimeout(P)),new Promise(O=>L=O)])}t.$Lg=e;function u(g){return new Promise((p,V)=>{const L=g();f(L)?L.then(p,V):p(L)})}t.$Mg=u;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(p){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=p,!this.b){const V=()=>{if(this.b=null,this.f)return;const L=this.queue(this.d);return this.d=null,L};this.b=new Promise(L=>{this.a.then(V,V).then(L)})}return new Promise((V,L)=>{this.b.then(V,L)})}return this.a=p(),new Promise((V,L)=>{this.a.then(P=>{this.a=null,V(P)},P=>{this.a=null,L(P)})})}dispose(){this.f=!0}}t.$Ng=l;class m{constructor(){this.a=Promise.resolve(null)}queue(p){return this.a=this.a.then(()=>p(),()=>p())}}t.$Og=m;class n{constructor(){this.a=new Map}queue(p,V){const P=(this.a.get(p)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.a.get(p)===P&&this.a.delete(p)});return this.a.set(p,P),P}}t.$Pg=n;const r=(g,p)=>{let V=!0;const L=setTimeout(()=>{V=!1,p()},g);return{isTriggered:()=>V,dispose:()=>{clearTimeout(L),V=!1}}},$=g=>{let p=!0;return queueMicrotask(()=>{p&&(p=!1,g())}),{isTriggered:()=>p,dispose:()=>{p=!1}}};class c{constructor(p){this.defaultDelay=p,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(p,V=this.defaultDelay){this.g=p,this.h(),this.b||(this.b=new Promise((P,O)=>{this.d=P,this.f=O}).then(()=>{if(this.b=null,this.d=null,this.g){const P=this.g;return this.g=null,P()}}));const L=()=>{this.a=null,this.d?.(null)};return this.a=V===h.$Kd?$(L):r(V,L),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Qg=c;class o{constructor(p){this.a=new c(p),this.b=new l}trigger(p,V){return this.a.trigger(()=>this.b.queue(p),V)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Rg=o;class S{constructor(){this.a=!1,this.b=new Promise((p,V)=>{this.d=p})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Sg=S;class j extends S{constructor(p){super(),this.f=setTimeout(()=>this.open(),p)}open(){clearTimeout(this.f),super.open()}}t.$Tg=j;function M(g,p){return p?new Promise((V,L)=>{const P=setTimeout(()=>{O.dispose(),V()},g),O=p.onCancellationRequested(()=>{clearTimeout(P),O.dispose(),L(new F.$5)})}):d(V=>M(g,V))}t.$Ug=M;function b(g,p=0,V){const L=setTimeout(()=>{g(),V&&P.dispose()},p),P=(0,U.$Qc)(()=>{clearTimeout(L),V?.deleteAndLeak(P)});return V?.add(P),P}t.$Vg=b;function v(g){const p=[];let V=0;const L=g.length;function P(){return V<L?g[V++]():null}function O(q){q!=null&&p.push(q);const C=P();return C?C.then(O):Promise.resolve(p)}return Promise.resolve(null).then(O)}t.$Wg=v;function B(g,p=L=>!!L,V=null){let L=0;const P=g.length,O=()=>{if(L>=P)return Promise.resolve(V);const q=g[L++];return Promise.resolve(q()).then(R=>p(R)?Promise.resolve(R):O())};return O()}t.$Xg=B;function z(g,p=L=>!!L,V=null){if(g.length===0)return Promise.resolve(V);let L=g.length;const P=()=>{L=-1;for(const O of g)O.cancel?.()};return new Promise((O,q)=>{for(const C of g)C.then(R=>{--L>=0&&p(R)?(P(),O(R)):L===0&&O(V)}).catch(R=>{--L>=0&&(P(),q(R))})})}t.$Yg=z;class W{constructor(p){this.a=0,this.d=p,this.f=[],this.b=0,this.g=new i.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(p){return this.a++,new Promise((V,L)=>{this.f.push({factory:p,c:V,e:L}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const p=this.f.shift();this.b++;const V=p.factory();V.then(p.c,p.e),V.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$Zg=W;class I extends W{constructor(){super(1)}}t.$1g=I;class N{constructor(){this.a=new Pe,this.b=0}queue(p){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,p())):this.a.run(this.b++,p())}}t.$2g=N;class J{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const p=new fe;return this.b.add(p),p.p}g(){for(const[,p]of this.a)if(p.size>0)return!1;return!0}queueFor(p,V=w.$lg){const L=V.getComparisonKey(p);let P=this.a.get(L);if(!P){P=new I;const O=this.f++,q=i.Event.once(P.onDrained)(()=>{P?.dispose(),this.a.delete(L),this.h(),this.d?.deleteAndDispose(O),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new U.$1c),this.d.set(O,q),this.a.set(L,P)}return P}h(){this.g()&&this.j()}j(){for(const p of this.b)p.complete();this.b.clear()}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$3g=J;class ee{constructor(p,V){this.a=-1,typeof p=="function"&&typeof V=="number"&&this.setIfNotSet(p,V)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(p,V){this.cancel(),this.a=setTimeout(()=>{this.a=-1,p()},V)}setIfNotSet(p,V){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,p()},V))}}t.$4g=ee;class ne{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(p,V){this.cancel(),this.a=setInterval(()=>{p()},V)}}t.$5g=ne;class ue{constructor(p,V){this.b=-1,this.a=p,this.d=V,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(p=this.d){this.cancel(),this.b=setTimeout(this.f,p)}get delay(){return this.d}set delay(p){this.d=p}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$6g=ue;class le{constructor(p,V){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.a=p,this.b=V,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(p=this.b){p%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${p}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(p/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$7g=le;class oe extends ue{constructor(p,V){super(p,V),this.j=[]}work(p){this.j.push(p),this.isScheduled()||this.schedule()}h(){const p=this.j;this.j=[],this.a?.(p)}dispose(){this.j=[],super.dispose()}}t.$8g=oe;class me extends U.$Sc{constructor(p,V){super(),this.g=p,this.h=V,this.a=[],this.b=this.B(new U.$Tc),this.f=!1}get pending(){return this.a.length}work(p){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+p.length>this.g.maxBufferedWork)return!1}else if(this.pending+p.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const V of p)this.a.push(V);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ue(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$9g=me,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.$0g=g=>{(0,D.$B)(()=>{if(p)return;const V=Date.now()+15;g(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let p=!1;return{dispose(){p||(p=!0)}}}:t.$0g=(g,p)=>{const V=requestIdleCallback(g,typeof p=="number"?{timeout:p}:void 0);let L=!1;return{dispose(){L||(L=!0,cancelIdleCallback(V))}}}}();class Ce{constructor(p){this.d=!1,this.a=()=>{try{this.f=p()}catch(V){this.g=V}finally{this.d=!0}},this.b=(0,t.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.$$g=Ce;async function Te(g,p,V){let L;for(let P=0;P<V;P++)try{return await g()}catch(O){L=O,await M(p)}throw L}t.$_g=Te;class Pe{isRunning(p){return typeof p=="number"?this.a?.taskId===p:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(p,V,L){return this.a={taskId:p,cancel:()=>L?.(),promise:V},V.then(()=>this.d(p),()=>this.d(p)),V}d(p){this.a&&p===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const p=this.b;this.b=void 0,p.run().then(p.promiseResolve,p.promiseReject)}}queue(p){if(this.b)this.b.run=p;else{let V,L;const P=new Promise((O,q)=>{V=O,L=q});this.b={run:p,promise:P,promiseResolve:V,promiseReject:L}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$ah=Pe;class de{constructor(p,V=()=>Date.now()){this.d=p,this.f=V,this.a=0,this.b=0}increment(){const p=this.f();return p-this.a>this.d&&(this.a=p,this.b=0),this.b++,this.b}}t.$bh=de;var ie;(function(g){g[g.Resolved=0]="Resolved",g[g.Rejected=1]="Rejected"})(ie||(ie={}));class fe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((p,V)=>{this.a=p,this.b=V})}complete(p){return new Promise(V=>{this.a(p),this.d={outcome:0,value:p},V()})}error(p){return new Promise(V=>{this.b(p),this.d={outcome:1,value:p},V()})}cancel(){return this.error(new F.$5)}}t.$ch=fe;var Y;(function(g){async function p(L){let P;const O=await Promise.all(L.map(q=>q.then(C=>C,C=>{P||(P=C)})));if(typeof P<"u")throw P;return O}g.settled=p;function V(L){return new Promise(async(P,O)=>{try{await L(P,O)}catch(q){O(q)}})}g.withAsyncBody=V})(Y||(t.Promises=Y={}));var _;(function(g){g[g.Initial=0]="Initial",g[g.DoneOK=1]="DoneOK",g[g.DoneError=2]="DoneError"})(_||(_={}));class G{static fromArray(p){return new G(V=>{V.emitMany(p)})}static fromPromise(p){return new G(async V=>{V.emitMany(await p)})}static fromPromises(p){return new G(async V=>{await Promise.all(p.map(async L=>V.emitOne(await L)))})}static merge(p){return new G(async V=>{await Promise.all(p.map(async L=>{for await(const P of L)V.emitOne(P)}))})}static{this.EMPTY=G.fromArray([])}constructor(p){this.a=0,this.b=[],this.d=null,this.f=new i.$Nd,queueMicrotask(async()=>{const V={emitOne:L=>this.g(L),emitMany:L=>this.h(L),reject:L=>this.k(L)};try{await Promise.resolve(p(V)),this.j()}catch(L){this.k(L)}finally{V.emitOne=void 0,V.emitMany=void 0,V.reject=void 0}})}[Symbol.asyncIterator](){let p=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(p<this.b.length)return{done:!1,value:this.b[p++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(p,V){return new G(async L=>{for await(const P of p)L.emitOne(V(P))})}map(p){return G.map(this,p)}static filter(p,V){return new G(async L=>{for await(const P of p)V(P)&&L.emitOne(P)})}filter(p){return G.filter(this,p)}static coalesce(p){return G.filter(p,V=>!!V)}coalesce(){return G.coalesce(this)}static async toPromise(p){const V=[];for await(const L of p)V.push(L);return V}toPromise(){return G.toPromise(this)}g(p){this.a===0&&(this.b.push(p),this.f.fire())}h(p){this.a===0&&(this.b=this.b.concat(p),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(p){this.a===0&&(this.a=2,this.d=p,this.f.fire())}}t.$dh=G;class E extends G{constructor(p,V){super(V),this.l=p}cancel(){this.l.cancel()}}t.$eh=E;function K(g){const p=new y.$Xd,V=g(p.token);return new E(p,async L=>{const P=p.token.onCancellationRequested(()=>{P.dispose(),p.dispose(),L.reject(new F.$5)});try{for await(const O of V){if(p.token.isCancellationRequested)return;L.emitOne(O)}P.dispose(),p.dispose()}catch(O){P.dispose(),p.dispose(),L.reject(O)}})}t.$fh=K}),define(be[3],$e([1,0,16,111,14,19,9,6,4,115,2,29,5,15]),function(re,t,y,F,i,U,w,D,h,f,d,T,s,a){"use strict";var e;Object.defineProperty(t,"__esModule",{value:!0}),t.$XP=t.$WP=t.h=t.$UP=t.$TP=t.$SP=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.DetectedFullscreenMode=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.$wP=t.$=t.Namespace=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.$3O=t.$2O=t.$1O=t.$ZO=t.$YO=t.$XO=t.$WO=t.$VO=t.$UO=t.$TO=t.$SO=t.$RO=t.$QO=t.$PO=t.$OO=t.$NO=t.$MO=t.$LO=t.$KO=t.$JO=t.$IO=t.$HO=t.$GO=t.$FO=t.$EO=t.$DO=t.$CO=t.$BO=t.onDidRegisterWindow=t.getWindows=t.registerWindow=void 0,e=function(){const X=new Set([window]),x=new h.$Nd;return{onDidRegisterWindow:x.event,registerWindow(he){if(X.has(he))return d.$Sc.None;X.add(he);const Ee=new d.$Rc;return Ee.add((0,d.$Qc)(()=>{X.delete(he)})),x.fire({window:he,disposableStore:Ee}),Ee},getWindows(){return X}}}(),t.registerWindow=e.registerWindow,t.getWindows=e.getWindows,t.onDidRegisterWindow=e.onDidRegisterWindow;function u(X){for(;X.firstChild;)X.firstChild.remove()}t.$BO=u;class l{constructor(x,he,Ee,ke){this.f=x,this.g=he,this.d=Ee,this.j=ke||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function m(X,x,he,Ee){return new l(X,x,he,Ee)}t.$CO=m;function n(X){return function(x){return X(new U.$uO(x))}}function r(X){return function(x){return X(new i.$zO(x))}}const $=function(x,he,Ee,ke){let He=Ee;return he==="click"||he==="mousedown"?He=n(Ee):(he==="keydown"||he==="keypress"||he==="keyup")&&(He=r(Ee)),m(x,he,He,ke)};t.$DO=$;const c=function(x,he,Ee){const ke=n(he);return S(x,ke,Ee)};t.$EO=c;const o=function(x,he,Ee){const ke=n(he);return M(x,ke,Ee)};t.$FO=o;function S(X,x,he){return m(X,s.$r&&F.$rO.pointerEvents?t.$lP.POINTER_DOWN:t.$lP.MOUSE_DOWN,x,he)}t.$GO=S;function j(X,x,he){return m(X,s.$r&&F.$rO.pointerEvents?t.$lP.POINTER_MOVE:t.$lP.MOUSE_MOVE,x,he)}t.$HO=j;function M(X,x,he){return m(X,s.$r&&F.$rO.pointerEvents?t.$lP.POINTER_UP:t.$lP.MOUSE_UP,x,he)}t.$IO=M;class b{constructor(x,he=0){this.d=x,this.priority=he,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(x){(0,D.$1)(x)}}static sort(x,he){return he.priority-x.priority}}(function(){let X=[],x=null,he=!1,Ee=!1;const ke=()=>{for(he=!1,x=X,X=[],Ee=!0;x.length>0;)x.sort(b.sort),x.shift().execute();Ee=!1};t.$KO=(He,Ue=0)=>{const Ze=new b(He,Ue);return X.push(Ze),he||(he=!0,requestAnimationFrame(ke)),Ze},t.$JO=(He,Ue)=>{if(Ee){const Ze=new b(He,Ue);return x.push(Ze),Ze}else return(0,t.$KO)(He,Ue)}})();function v(X){return(0,t.$KO)(X,1e4)}t.$LO=v;function B(X){return(0,t.$KO)(X,-1e4)}t.$MO=B;const z=8,W=function(X,x){return x};class I extends d.$Sc{constructor(x,he,Ee,ke=W,He=z){super();let Ue=null,Ze=0;const lt=this.B(new w.$4g),Ye=()=>{Ze=new Date().getTime(),Ee(Ue),Ue=null};this.B(m(x,he,wt=>{Ue=ke(Ue,wt);const St=new Date().getTime()-Ze;St>=He?(lt.cancel(),Ye()):lt.setIfNotSet(Ye,He-St)}))}}function N(X,x,he,Ee,ke){return new I(X,x,he,Ee,ke)}t.$NO=N;function J(X){return X.ownerDocument.defaultView.getComputedStyle(X,null)}t.$OO=J;function ee(X){const x=X.ownerDocument,he=x.defaultView?.window;if(X!==x.body)return new ue(X.clientWidth,X.clientHeight);if(s.$r&&he?.visualViewport)return new ue(he.visualViewport.width,he.visualViewport.height);if(he?.innerWidth&&he.innerHeight)return new ue(he.innerWidth,he.innerHeight);if(x.body&&x.body.clientWidth&&x.body.clientHeight)return new ue(x.body.clientWidth,x.body.clientHeight);if(x.documentElement&&x.documentElement.clientWidth&&x.documentElement.clientHeight)return new ue(x.documentElement.clientWidth,x.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$PO=ee;class ne{static d(x,he){return parseFloat(he)||0}static f(x,he,Ee){const ke=J(x),He=ke?ke.getPropertyValue(he):"0";return ne.d(x,He)}static getBorderLeftWidth(x){return ne.f(x,"border-left-width","borderLeftWidth")}static getBorderRightWidth(x){return ne.f(x,"border-right-width","borderRightWidth")}static getBorderTopWidth(x){return ne.f(x,"border-top-width","borderTopWidth")}static getBorderBottomWidth(x){return ne.f(x,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(x){return ne.f(x,"padding-left","paddingLeft")}static getPaddingRight(x){return ne.f(x,"padding-right","paddingRight")}static getPaddingTop(x){return ne.f(x,"padding-top","paddingTop")}static getPaddingBottom(x){return ne.f(x,"padding-bottom","paddingBottom")}static getMarginLeft(x){return ne.f(x,"margin-left","marginLeft")}static getMarginTop(x){return ne.f(x,"margin-top","marginTop")}static getMarginRight(x){return ne.f(x,"margin-right","marginRight")}static getMarginBottom(x){return ne.f(x,"margin-bottom","marginBottom")}}class ue{static{this.None=new ue(0,0)}constructor(x,he){this.width=x,this.height=he}with(x=this.width,he=this.height){return x!==this.width||he!==this.height?new ue(x,he):this}static is(x){return typeof x=="object"&&typeof x.height=="number"&&typeof x.width=="number"}static lift(x){return x instanceof ue?x:new ue(x.width,x.height)}static equals(x,he){return x===he?!0:!x||!he?!1:x.width===he.width&&x.height===he.height}}t.$QO=ue;function le(X){let x=X.offsetParent,he=X.offsetTop,Ee=X.offsetLeft;for(;(X=X.parentNode)!==null&&X!==X.ownerDocument.body&&X!==X.ownerDocument.documentElement;){he-=X.scrollTop;const ke=O(X)?null:J(X);ke&&(Ee-=ke.direction!=="rtl"?X.scrollLeft:-X.scrollLeft),X===x&&(Ee+=ne.getBorderLeftWidth(X),he+=ne.getBorderTopWidth(X),he+=X.offsetTop,Ee+=X.offsetLeft,x=X.offsetParent)}return{left:Ee,top:he}}t.$RO=le;function oe(X,x,he){typeof x=="number"&&(X.style.width=`${x}px`),typeof he=="number"&&(X.style.height=`${he}px`)}t.$SO=oe;function me(X,x,he,Ee,ke,He="absolute"){typeof x=="number"&&(X.style.top=`${x}px`),typeof he=="number"&&(X.style.right=`${he}px`),typeof Ee=="number"&&(X.style.bottom=`${Ee}px`),typeof ke=="number"&&(X.style.left=`${ke}px`),X.style.position=He}t.$TO=me;function Ce(X){const x=X.getBoundingClientRect();return{left:x.left+(X.ownerDocument.defaultView?.scrollX??0),top:x.top+(X.ownerDocument.defaultView?.scrollY??0),width:x.width,height:x.height}}t.$UO=Ce;function Te(X){let x=X,he=1;do{const Ee=J(x).zoom;Ee!=null&&Ee!=="1"&&(he*=Ee),x=x.parentElement}while(x!==null&&x!==x.ownerDocument.documentElement);return he}t.$VO=Te;function Pe(X){const x=ne.getMarginLeft(X)+ne.getMarginRight(X);return X.offsetWidth+x}t.$WO=Pe;function de(X){const x=ne.getBorderLeftWidth(X)+ne.getBorderRightWidth(X),he=ne.getPaddingLeft(X)+ne.getPaddingRight(X);return X.offsetWidth-x-he}t.$XO=de;function ie(X){const x=ne.getMarginLeft(X)+ne.getMarginRight(X);return X.scrollWidth+x}t.$YO=ie;function fe(X){const x=ne.getBorderTopWidth(X)+ne.getBorderBottomWidth(X),he=ne.getPaddingTop(X)+ne.getPaddingBottom(X);return X.offsetHeight-x-he}t.$ZO=fe;function Y(X){const x=ne.getMarginTop(X)+ne.getMarginBottom(X);return X.offsetHeight+x}t.$1O=Y;function _(X,x){if(X===null)return 0;const he=le(X),Ee=le(x);return he.left-Ee.left}function G(X,x){const he=x.map(ke=>Math.max(ie(ke),Pe(ke))+_(ke,X)||0);return Math.max(...he)}t.$2O=G;function E(X,x){for(;X;){if(X===x)return!0;X=X.parentNode}return!1}t.$3O=E;const K="parentFlowToElementId";function g(X,x){X.dataset[K]=x.id}t.$4O=g;function p(X){const x=X.dataset[K];return typeof x=="string"?X.ownerDocument.getElementById(x):null}function V(X,x){let he=X;for(;he;){if(he===x)return!0;if(he instanceof HTMLElement){const Ee=p(he);if(Ee){he=Ee;continue}}he=he.parentNode}return!1}t.$5O=V;function L(X,x,he){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X.classList.contains(x))return X;if(he){if(typeof he=="string"){if(X.classList.contains(he))return null}else if(X===he)return null}X=X.parentNode}return null}t.$6O=L;function P(X,x,he){return!!L(X,x,he)}t.$7O=P;function O(X){return X&&!!X.host&&!!X.mode}t.$8O=O;function q(X){return!!C(X)}t.$9O=q;function C(X){for(;X.parentNode;){if(X===X.ownerDocument?.body)return null;X=X.parentNode}return O(X)?X:null}t.$0O=C;function R(){let X=A().activeElement;for(;X?.shadowRoot;)X=X.shadowRoot.activeElement;return X}t.$$O=R;function A(){return Array.from((0,t.getWindows)()).map(x=>x.document).find(x=>x.hasFocus())??document}t.$_O=A;function k(){return A().defaultView?.window??window}t.$aP=k;function H(X){const x=X;if(x?.ownerDocument?.defaultView)return x.ownerDocument.defaultView.window;const he=X;return he?.view?he.view.window:window}t.$bP=H;function Q(X){const x=H(X);x!==k()&&x.focus()}t.$cP=Q;function te(X=document.getElementsByTagName("head")[0],x){const he=document.createElement("style");return he.type="text/css",he.media="screen",x?.(he),X.appendChild(he),he}t.$dP=te;function se(X=document.getElementsByTagName("head")[0]){const x=document.createElement("meta");return X.appendChild(x),x}t.$eP=se;let ge=null;function we(){return ge||(ge=te()),ge}function Ne(X){return X?.sheet?.rules?X.sheet.rules:X?.sheet?.cssRules?X.sheet.cssRules:[]}function Ae(X,x,he=we()){!he||!x||he.sheet.insertRule(X+"{"+x+"}",0)}t.$fP=Ae;function ve(X,x=we()){if(!x)return;const he=Ne(x),Ee=[];for(let ke=0;ke<he.length;ke++)he[ke].selectorText.indexOf(X)!==-1&&Ee.push(ke);for(let ke=Ee.length-1;ke>=0;ke--)x.sheet.deleteRule(Ee[ke])}t.$gP=ve;function Ie(X){return X instanceof MouseEvent||X instanceof H(X).MouseEvent}t.$hP=Ie;function Oe(X){return X instanceof KeyboardEvent||X instanceof H(X).KeyboardEvent}t.$iP=Oe;function qe(X){return X instanceof PointerEvent||X instanceof H(X).PointerEvent}t.$jP=qe;function ze(X){return X instanceof DragEvent||X instanceof H(X).DragEvent}t.$kP=ze,t.$lP={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:y.$jO?"webkitAnimationStart":"animationstart",ANIMATION_END:y.$jO?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:y.$jO?"webkitAnimationIteration":"animationiteration"};function Me(X){const x=X;return!!(x&&typeof x.preventDefault=="function"&&typeof x.stopPropagation=="function")}t.$mP=Me,t.$nP={stop:(X,x)=>(X.preventDefault(),x&&X.stopPropagation(),X)};function Ge(X){const x=[];for(let he=0;X&&X.nodeType===X.ELEMENT_NODE;he++)x[he]=X.scrollTop,X=X.parentNode;return x}t.$oP=Ge;function Z(X,x){for(let he=0;X&&X.nodeType===X.ELEMENT_NODE;he++)X.scrollTop!==x[he]&&(X.scrollTop=x[he]),X=X.parentNode}t.$pP=Z;class ae extends d.$Sc{static m(x){if(x instanceof HTMLElement){const he=C(x),Ee=he?he.activeElement:x.ownerDocument.activeElement;return E(Ee,x)}else return E(window.document.activeElement,window.document)}constructor(x){super(),this.f=this.B(new h.$Nd),this.onDidFocus=this.f.event,this.g=this.B(new h.$Nd),this.onDidBlur=this.g.event;let he=ae.m(x),Ee=!1;const ke=()=>{Ee=!1,he||(he=!0,this.f.fire())},He=()=>{he&&(Ee=!0,window.setTimeout(()=>{Ee&&(Ee=!1,he=!1,this.g.fire())},0))};this.j=()=>{ae.m(x)!==he&&(he?He():ke())},this.B(m(x,t.$lP.FOCUS,ke,!0)),this.B(m(x,t.$lP.BLUR,He,!0)),x instanceof HTMLElement&&(this.B(m(x,t.$lP.FOCUS_IN,()=>this.j())),this.B(m(x,t.$lP.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function pe(X){return new ae(X)}t.$qP=pe;function De(X,x){return X.after(x),x}t.$rP=De;function Se(X,...x){if(X.append(...x),x.length===1&&typeof x[0]!="string")return x[0]}t.$sP=Se;function Re(X,x){return X.insertBefore(x,X.firstChild),x}t.$tP=Re;function je(X,...x){X.innerText="",Se(X,...x)}t.$uP=je;const Xe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Qe;(function(X){X.HTML="http://www.w3.org/1999/xhtml",X.SVG="http://www.w3.org/2000/svg"})(Qe||(t.Namespace=Qe={}));function Ve(X,x,he,...Ee){const ke=Xe.exec(x);if(!ke)throw new Error("Bad use of emmet");const He=ke[1]||"div";let Ue;return X!==Qe.HTML?Ue=document.createElementNS(X,He):Ue=document.createElement(He),ke[3]&&(Ue.id=ke[3]),ke[4]&&(Ue.className=ke[4].replace(/\./g," ").trim()),he&&Object.entries(he).forEach(([Ze,lt])=>{typeof lt>"u"||(/^on\w+$/.test(Ze)?Ue[Ze]=lt:Ze==="selected"?lt&&Ue.setAttribute(Ze,"true"):Ue.setAttribute(Ze,lt))}),Ue.append(...Ee),Ue}function We(X,x,...he){return Ve(Qe.HTML,X,x,...he)}t.$=We,We.SVG=function(X,x,...he){return Ve(Qe.SVG,X,x,...he)};function et(X,x){const he=[];return X.forEach((Ee,ke)=>{ke>0&&(x instanceof Node?he.push(x.cloneNode()):he.push(document.createTextNode(x))),he.push(Ee)}),he}t.$wP=et;function it(X,...x){X?ft(...x):ut(...x)}t.$xP=it;function ft(...X){for(const x of X)x.style.display="",x.removeAttribute("aria-hidden")}t.$yP=ft;function ut(...X){for(const x of X)x.style.display="none",x.setAttribute("aria-hidden","true")}t.$zP=ut;function ct(X,x){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X instanceof HTMLElement&&X.hasAttribute(x))return X;X=X.parentNode}return null}function Et(X){!X||!X.hasAttribute("tabIndex")||(X.ownerDocument.activeElement===X&&ct(X.parentElement,"tabIndex")?.focus(),X.removeAttribute("tabindex"))}t.$AP=Et;function At(X){return x=>{x.preventDefault(),x.stopPropagation(),X(x)}}t.$BP=At;function kt(){return new Promise(X=>{document.readyState==="complete"||document&&document.body!==null?X(void 0):window.addEventListener("DOMContentLoaded",X,!1)})}t.$CP=kt;function Ct(X){const x=window.devicePixelRatio*X;return Math.max(1,Math.floor(x))/window.devicePixelRatio}t.$DP=Ct;function Mt(X){window.open(X,"_blank","noopener")}t.$EP=Mt;const Le=780,ce=640;function ye(X){const x=Math.floor(window.screenLeft+window.innerWidth/2-Le/2),he=Math.floor(window.screenTop+window.innerHeight/2-ce/2);window.open(X,"_blank",`width=${Le},height=${ce},top=${he},left=${x}`)}t.$FP=ye;function Fe(X,x=!0){const he=window.open();return he?(x&&(he.opener=null),he.location.href=X,!0):!1}t.$GP=Fe;function _e(X){const x=()=>{X(),he=(0,t.$KO)(x)};let he=(0,t.$KO)(x);return(0,d.$Qc)(()=>he.dispose())}t.$HP=_e,T.$9f.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Je(X){return X?`url('${T.$cg.uriToBrowserUri(X).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$IP=Je;function nt(X){return`'${X.replace(/'/g,"%27")}'`}t.$JP=nt;function Ke(X,x){if(X!==void 0){const he=X.match(/^\s*var\((.+)\)$/);if(he){const Ee=he[1].split(",",2);return Ee.length===2&&(x=Ke(Ee[1].trim(),x)),`var(${Ee[0]}, ${x})`}return X}return x}t.$KP=Ke;function ot(X,x){let he;if(a.URI.isUri(X))he=X.toString(!0);else{const ke=new Blob([X]);he=URL.createObjectURL(ke),setTimeout(()=>URL.revokeObjectURL(he))}const Ee=document.createElement("a");document.body.appendChild(Ee),Ee.download=x,Ee.href=he,Ee.click(),setTimeout(()=>document.body.removeChild(Ee))}t.$LP=ot;function pt(){return new Promise(X=>{const x=document.createElement("input");document.body.appendChild(x),x.type="file",x.multiple=!0,h.Event.once(h.Event.fromDOMEventEmitter(x,"input"))(()=>{X(x.files??void 0)}),x.click(),setTimeout(()=>document.body.removeChild(x))})}t.$MP=pt;var dt;(function(X){X[X.DOCUMENT=1]="DOCUMENT",X[X.BROWSER=2]="BROWSER"})(dt||(t.DetectedFullscreenMode=dt={}));function xt(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:dt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:dt.BROWSER,guess:!1}:(s.$k||s.$l)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:dt.BROWSER,guess:!0}:null}t.$NP=xt;function Gt(X,x=!1){const he=document.createElement("a");return f.addHook("afterSanitizeAttributes",Ee=>{for(const ke of["href","src"])if(Ee.hasAttribute(ke)){const He=Ee.getAttribute(ke);if(ke==="href"&&He.startsWith("#"))continue;if(he.href=He,!X.includes(he.protocol.replace(/:$/,""))){if(x&&ke==="src"&&he.href.startsWith("data:"))continue;Ee.removeAttribute(ke)}}}),(0,d.$Qc)(()=>{f.removeHook("afterSanitizeAttributes")})}t.$OP=Gt;const vi=[T.Schemas.http,T.Schemas.https,T.Schemas.command];t.$PP=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Di=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function yi(X,x){const he=Gt(vi);try{const Ee=f.sanitize(x,Di);X.innerHTML=Ee}finally{he.dispose()}}t.$QP=yi;function Ei(X){const x=new Uint16Array(X.length);for(let ke=0;ke<x.length;ke++)x[ke]=X.charCodeAt(ke);let he="";const Ee=new Uint8Array(x.buffer);for(let ke=0;ke<Ee.length;ke++)he+=String.fromCharCode(Ee[ke]);return he}function Ai(X){return btoa(Ei(X))}t.$RP=Ai;class mt extends h.$Nd{constructor(){super(),this.o=new d.$Rc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(m(window,"keydown",x=>{if(x.defaultPrevented)return;const he=new i.$zO(x);if(!(he.keyCode===6&&x.repeat)){if(x.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(x.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(x.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(x.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(he.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=x.altKey,this.s.ctrlKey=x.ctrlKey,this.s.metaKey=x.metaKey,this.s.shiftKey=x.shiftKey,this.s.lastKeyPressed&&(this.s.event=x,this.fire(this.s))}},!0)),this.o.add(m(window,"keyup",x=>{x.defaultPrevented||(!x.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!x.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!x.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!x.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=x.altKey,this.s.ctrlKey=x.ctrlKey,this.s.metaKey=x.metaKey,this.s.shiftKey=x.shiftKey,this.s.lastKeyReleased&&(this.s.event=x,this.fire(this.s)))},!0)),this.o.add(m(document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),this.o.add(m(document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),this.o.add(m(document.body,"mousemove",x=>{x.buttons&&(this.s.lastKeyPressed=void 0)},!0)),this.o.add(m(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.B(),this.fire(this.s)}B(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return mt.A||(mt.A=new mt),mt.A}dispose(){super.dispose(),this.o.dispose()}}t.$SP=mt;function ki(X){const x=document.cookie.match("(^|[^;]+)\\s*"+X+"\\s*=\\s*([^;]+)");return x?x.pop():void 0}t.$TP=ki;class Ci extends d.$Sc{constructor(x,he){super(),this.j=x,this.m=he,this.f=0,this.g=0,this.n()}n(){this.B(m(this.j,t.$lP.DRAG_ENTER,x=>{this.f++,this.g=x.timeStamp,this.m.onDragEnter(x)})),this.B(m(this.j,t.$lP.DRAG_OVER,x=>{x.preventDefault(),this.m.onDragOver?.(x,x.timeStamp-this.g)})),this.B(m(this.j,t.$lP.DRAG_LEAVE,x=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave(x))})),this.B(m(this.j,t.$lP.DRAG_END,x=>{this.f=0,this.g=0,this.m.onDragEnd(x)})),this.B(m(this.j,t.$lP.DROP,x=>{this.f=0,this.g=0,this.m.onDrop(x)}))}}t.$UP=Ci;const Si=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Ni(X,...x){let he,Ee;Array.isArray(x[0])?(he={},Ee=x[0]):(he=x[0]||{},Ee=x[1]);const ke=Si.exec(X);if(!ke||!ke.groups)throw new Error("Bad use of h");const He=ke.groups.tag||"div",Ue=document.createElement(He);ke.groups.id&&(Ue.id=ke.groups.id);const Ze=[];if(ke.groups.class)for(const Ye of ke.groups.class.split("."))Ye!==""&&Ze.push(Ye);if(he.className!==void 0)for(const Ye of he.className.split("."))Ye!==""&&Ze.push(Ye);Ze.length>0&&(Ue.className=Ze.join(" "));const lt={};if(ke.groups.name&&(lt[ke.groups.name]=Ue),Ee)for(const Ye of Ee)Ye instanceof HTMLElement?Ue.appendChild(Ye):typeof Ye=="string"?Ue.append(Ye):"root"in Ye&&(Object.assign(lt,Ye),Ue.appendChild(Ye.root));for(const[Ye,wt]of Object.entries(he))if(Ye!=="className")if(Ye==="style")for(const[St,Rt]of Object.entries(wt))Ue.style.setProperty(Xt(St),typeof Rt=="number"?Rt+"px":""+Rt);else Ye==="tabIndex"?Ue.tabIndex=wt:Ue.setAttribute(Xt(Ye),wt.toString());return lt.root=Ue,lt}t.h=Ni;function Xt(X){return X.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function Fi(X,x){const he=new h.$Nd,Ee=new MutationObserver(ke=>{for(const He of ke)He.type==="attributes"&&He.attributeName&&he.fire(He.attributeName)});return Ee.observe(X,{attributes:!0,attributeFilter:x}),{onDidChangeAttribute:he.event,dispose:()=>{Ee.disconnect(),he.dispose()}}}function Yt(X,x){for(const{name:he,value:Ee}of X.attributes)x.setAttribute(he,Ee)}t.$WP=Yt;function Pi(X,x,he){const Ee=X.getAttribute(he);Ee?x.setAttribute(he,Ee):x.removeAttribute(he)}function Oi(X,x,he){Yt(X,x);const Ee=Fi(X,he);return(0,d.$Pc)(Ee,Ee.onDidChangeAttribute(ke=>Pi(X,x,ke)))}t.$XP=Oi}),define(be[52],$e([1,0,3,2,114]),function(re,t,y,F,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1P=t.$ZP=t.$YP=void 0;class U extends F.$Sc{constructor(h,f){super(),this.B((0,y.$CO)(h,"dragover",d=>{d.preventDefault(),this.a||(this.a=setTimeout(()=>{f(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(d=>{this.B((0,y.$CO)(h,d,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$YP=U,t.$ZP={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.$Nr.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function w(D,h,f,d,T){const s=document.createElement("div");s.className=f,s.textContent=h,T&&(s.style.color=T),d&&(s.style.background=d),D.dataTransfer&&(document.body.appendChild(s),D.dataTransfer.setDragImage(s,-10,-10),setTimeout(()=>document.body.removeChild(s),0))}t.$1P=w}),define(be[53],$e([1,0,3]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sQ=t.$rQ=t.$qQ=void 0;function F(s,a={}){const e=U(a);return e.textContent=s,e}t.$qQ=F;function i(s,a={}){const e=U(a);return h(e,f(s,!!a.renderCodeSegments),a.actionHandler,a.renderCodeSegments),e}t.$rQ=i;function U(s){const a=s.inline?"span":"div",e=document.createElement(a);return s.className&&(e.className=s.className),e}t.$sQ=U;class w{constructor(a){this.b=a,this.c=0}eos(){return this.c>=this.b.length}next(){const a=this.peek();return this.advance(),a}peek(){return this.b[this.c]}advance(){this.c++}}var D;(function(s){s[s.Invalid=0]="Invalid",s[s.Root=1]="Root",s[s.Text=2]="Text",s[s.Bold=3]="Bold",s[s.Italics=4]="Italics",s[s.Action=5]="Action",s[s.ActionClose=6]="ActionClose",s[s.Code=7]="Code",s[s.NewLine=8]="NewLine"})(D||(D={}));function h(s,a,e,u){let l;if(a.type===2)l=document.createTextNode(a.content||"");else if(a.type===3)l=document.createElement("b");else if(a.type===4)l=document.createElement("i");else if(a.type===7&&u)l=document.createElement("code");else if(a.type===5&&e){const m=document.createElement("a");e.disposables.add(y.$DO(m,"click",n=>{e.callback(String(a.index),n)})),l=m}else a.type===8?l=document.createElement("br"):a.type===1&&(l=s);l&&s!==l&&s.appendChild(l),l&&Array.isArray(a.children)&&a.children.forEach(m=>{h(l,m,e,u)})}function f(s,a){const e={type:1,children:[]};let u=0,l=e;const m=[],n=new w(s);for(;!n.eos();){let r=n.next();const $=r==="\\"&&T(n.peek(),a)!==0;if($&&(r=n.next()),!$&&d(r,a)&&r===n.peek()){n.advance(),l.type===2&&(l=m.pop());const c=T(r,a);if(l.type===c||l.type===5&&c===6)l=m.pop();else{const o={type:c,children:[]};c===5&&(o.index=u,u++),l.children.push(o),m.push(l),l=o}}else if(r===`
`)l.type===2&&(l=m.pop()),l.children.push({type:8});else if(l.type!==2){const c={type:2,content:r};l.children.push(c),m.push(l),l=c}else l.content+=r}return l.type===2&&(l=m.pop()),m.length,e}function d(s,a){return T(s,a)!==0}function T(s,a){switch(s){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return a?7:0;default:return 0}}}),define(be[54],$e([1,0,3,2]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5P=void 0;class i{constructor(){this.a=new F.$Rc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(w,D){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const h=this.c;this.c=null,w&&h&&h(D)}isMonitoring(){return!!this.b}startMonitoring(w,D,h,f,d){this.isMonitoring()&&this.stopMonitoring(!1),this.b=f,this.c=d;let T=w;try{w.setPointerCapture(D),this.a.add((0,F.$Qc)(()=>{try{w.releasePointerCapture(D)}catch{}}))}catch{T=window}this.a.add(y.$CO(T,y.$lP.POINTER_MOVE,s=>{if(s.buttons!==h){this.stopMonitoring(!0);return}s.preventDefault(),this.b(s)})),this.a.add(y.$CO(T,y.$lP.POINTER_UP,s=>this.stopMonitoring(!0)))}}t.$5P=i});var xe=this&&this.__decorate||function(re,t,y,F){var i=arguments.length,U=i<3?t:F===null?F=Object.getOwnPropertyDescriptor(t,y):F,w;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(re,t,y,F);else for(var D=re.length-1;D>=0;D--)(w=re[D])&&(U=(i<3?w(U):i>3?w(t,y,U):w(t,y))||U);return i>3&&U&&Object.defineProperty(t,y,U),U};define(be[23],$e([1,0,3,11,25,2,44]),function(re,t,y,F,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2P=t.EventType=void 0;var D;(function(f){f.Tap="-monaco-gesturetap",f.Change="-monaco-gesturechange",f.Start="-monaco-gesturestart",f.End="-monaco-gesturesend",f.Contextmenu="-monaco-gesturecontextmenu"})(D||(t.EventType=D={}));class h extends U.$Sc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new w.$2c,this.h=new w.$2c,this.m={},this.j=null,this.n=0,this.B(y.$CO(document,"touchstart",d=>this.s(d),{passive:!1})),this.B(y.$CO(document,"touchend",d=>this.u(d))),this.B(y.$CO(document,"touchmove",d=>this.D(d),{passive:!1}))}static addTarget(d){if(!h.isTouchDevice())return U.$Sc.None;h.b||(h.b=(0,U.$Lc)(new h));const T=h.b.g.push(d);return(0,U.$Qc)(T)}static ignoreTarget(d){if(!h.isTouchDevice())return U.$Sc.None;h.b||(h.b=(0,U.$Lc)(new h));const T=h.b.h.push(d);return(0,U.$Qc)(T)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(d){const T=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let s=0,a=d.targetTouches.length;s<a;s++){const e=d.targetTouches.item(s);this.m[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:T,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[T],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const u=this.w(D.Start,e.target);u.pageX=e.pageX,u.pageY=e.pageY,this.z(u)}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}u(d){const T=Date.now(),s=Object.keys(this.m).length;for(let a=0,e=d.changedTouches.length;a<e;a++){const u=d.changedTouches.item(a);if(!this.m.hasOwnProperty(String(u.identifier))){console.warn("move of an UNKNOWN touch",u);continue}const l=this.m[u.identifier],m=Date.now()-l.initialTimeStamp;if(m<h.c&&Math.abs(l.initialPageX-F.$sb(l.rollingPageX))<30&&Math.abs(l.initialPageY-F.$sb(l.rollingPageY))<30){const n=this.w(D.Tap,l.initialTarget);n.pageX=F.$sb(l.rollingPageX),n.pageY=F.$sb(l.rollingPageY),this.z(n)}else if(m>=h.c&&Math.abs(l.initialPageX-F.$sb(l.rollingPageX))<30&&Math.abs(l.initialPageY-F.$sb(l.rollingPageY))<30){const n=this.w(D.Contextmenu,l.initialTarget);n.pageX=F.$sb(l.rollingPageX),n.pageY=F.$sb(l.rollingPageY),this.z(n)}else if(s===1){const n=F.$sb(l.rollingPageX),r=F.$sb(l.rollingPageY),$=F.$sb(l.rollingTimestamps)-l.rollingTimestamps[0],c=n-l.rollingPageX[0],o=r-l.rollingPageY[0],S=[...this.g].filter(j=>l.initialTarget instanceof Node&&j.contains(l.initialTarget));this.C(S,T,Math.abs(c)/$,c>0?1:-1,n,Math.abs(o)/$,o>0?1:-1,r)}this.z(this.w(D.End,l.initialTarget)),delete this.m[u.identifier]}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}w(d,T){const s=document.createEvent("CustomEvent");return s.initEvent(d,!1,!0),s.initialTarget=T,s.tapCount=0,s}z(d){if(d.type===D.Tap){const T=new Date().getTime();let s=0;T-this.n>h.r?s=1:s=2,this.n=T,d.tapCount=s}else(d.type===D.Change||d.type===D.Contextmenu)&&(this.n=0);if(d.initialTarget instanceof Node){for(const T of this.h)if(T.contains(d.initialTarget))return;for(const T of this.g)T.contains(d.initialTarget)&&(T.dispatchEvent(d),this.f=!0)}}C(d,T,s,a,e,u,l,m){this.j=y.$KO(()=>{const n=Date.now(),r=n-T;let $=0,c=0,o=!0;s+=h.a*r,u+=h.a*r,s>0&&(o=!1,$=a*s*r),u>0&&(o=!1,c=l*u*r);const S=this.w(D.Change);S.translationX=$,S.translationY=c,d.forEach(j=>j.dispatchEvent(S)),o||this.C(d,n,s,a,e+$,u,l,m+c)})}D(d){const T=Date.now();for(let s=0,a=d.changedTouches.length;s<a;s++){const e=d.changedTouches.item(s);if(!this.m.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const u=this.m[e.identifier],l=this.w(D.Change,u.initialTarget);l.translationX=e.pageX-F.$sb(u.rollingPageX),l.translationY=e.pageY-F.$sb(u.rollingPageY),l.pageX=e.pageX,l.pageY=e.pageY,this.z(l),u.rollingPageX.length>3&&(u.rollingPageX.shift(),u.rollingPageY.shift(),u.rollingTimestamps.shift()),u.rollingPageX.push(e.pageX),u.rollingPageY.push(e.pageY),u.rollingTimestamps.push(T)}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}}t.$2P=h,xe([i.$gh],h,"isTouchDevice",null)}),define(be[55],$e([1,0,3,89]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wQ=t.$vQ=t.$uQ=void 0;const F=2e4;let i,U,w,D,h;function f(a){i=document.createElement("div"),i.className="monaco-aria-container";const e=()=>{const l=document.createElement("div");return l.className="monaco-alert",l.setAttribute("role","alert"),l.setAttribute("aria-atomic","true"),i.appendChild(l),l};U=e(),w=e();const u=()=>{const l=document.createElement("div");return l.className="monaco-status",l.setAttribute("aria-live","polite"),l.setAttribute("aria-atomic","true"),i.appendChild(l),l};D=u(),h=u(),a.appendChild(i)}t.$uQ=f;function d(a){i&&(U.textContent!==a?(y.$BO(w),s(U,a)):(y.$BO(U),s(w,a)))}t.$vQ=d;function T(a){i&&(D.textContent!==a?(y.$BO(h),s(D,a)):(y.$BO(D),s(h,a)))}t.$wQ=T;function s(a,e){y.$BO(a),e.length>F&&(e=e.substr(0,F)),a.textContent=e,a.style.visibility="hidden",a.style.visibility="visible"}}),define(be[116],$e([1,0,3,18]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VQ=t.$UQ=void 0;const i=new RegExp(`(\\\\)?\\$\\((${F.ThemeIcon.iconNameExpression}(?:${F.ThemeIcon.iconModifierExpression})?)\\)`,"g");function U(D){const h=new Array;let f,d=0,T=0;for(;(f=i.exec(D))!==null;){T=f.index||0,d<T&&h.push(D.substring(d,T)),d=(f.index||0)+f[0].length;const[,s,a]=f;h.push(s?`$(${a})`:w({id:a}))}return d<D.length&&h.push(D.substring(d)),h}t.$UQ=U;function w(D){const h=y.$("span");return h.classList.add(...F.ThemeIcon.asClassNameArray(D)),h}t.$VQ=w}),define(be[117],$e([1,0,3]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FQ=void 0;function F(U){try{U.parentElement?.removeChild(U)}catch{}}class i{constructor(w){this.d=w,this.a=new Map,this.b=new Set,this.c=!1}alloc(w){let D=this.h(w).pop(),h=!1;if(D)h=this.b.has(D.domNode),h&&this.b.delete(D.domNode);else{const f=(0,y.$)(".monaco-list-row"),T=this.i(w).renderTemplate(f);D={domNode:f,templateId:w,templateData:T}}return{row:D,isReusingConnectedDomNode:h}}release(w){w&&this.f(w)}transact(w){if(this.c)throw new Error("Already in transaction");this.c=!0;try{w()}finally{for(const D of this.b)this.g(D);this.b.clear(),this.c=!1}}f(w){const{domNode:D,templateId:h}=w;D&&(this.c?this.b.add(D):this.g(D)),this.h(h).push(w)}g(w){w.classList.remove("scrolling"),F(w)}h(w){let D=this.a.get(w);return D||(D=[],this.a.set(w,D)),D}dispose(){this.a.forEach((w,D)=>{for(const h of w)this.i(D).disposeTemplate(h.templateData),h.templateData=null}),this.a.clear(),this.b.clear()}i(w){const D=this.d.get(w);if(!D)throw new Error(`No renderer found for ${w}`);return D}}t.$FQ=i}),define(be[118],$e([1,0,9,2]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0P=void 0;class i extends F.$Sc{constructor(w,D,h){super(),this.a=w,this.b=D,this.c=h,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new y.$4g)}setVisibility(w){this.a!==w&&(this.a=w,this.s())}setShouldBeVisible(w){this.g=w,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const w=this.r();this.h!==w&&(this.h=w,this.ensureVisibility())}setIsNeeded(w){this.j!==w&&(this.j=w,this.ensureVisibility())}setDomNode(w){this.f=w,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(w){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(w?" fade":"")))}}t.$0P=i}),define(be[119],$e([1,0,3,23,11,4,2,5]),function(re,t,y,F,i,U,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3Q=void 0;class h extends w.$Sc{constructor(d,T,s,a){super(),this.f=0,this.b=a||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new U.$Nd),this.h=s,this.j(),this.setOptions(d,T)}j(){this.B(F.$2P.addTarget(this.a)),[F.EventType.Tap].forEach(d=>{this.B(y.$CO(this.a,d,T=>{this.a.focus()}))}),this.B(y.$DO(this.a,"click",d=>{y.$nP.stop(d,!0)})),this.B(y.$DO(this.a,"change",d=>{this.a.title=d.target.value,this.g.fire({index:d.target.selectedIndex,selected:d.target.value})})),this.B(y.$DO(this.a,"keydown",d=>{let T=!1;D.$k?(d.keyCode===18||d.keyCode===16||d.keyCode===10)&&(T=!0):(d.keyCode===18&&d.altKey||d.keyCode===10||d.keyCode===3)&&(T=!0),T&&d.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(d,T){(!this.c||!i.$ub(this.c,d))&&(this.c=d,this.a.options.length=0,this.c.forEach((s,a)=>{this.a.add(this.m(s.text,a,s.isDisabled))})),T!==void 0&&this.select(T)}select(d){this.c.length===0?this.f=0:d>=0&&d<this.c.length?this.f=d:d>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(d){this.b.ariaLabel=d,this.a.setAttribute("aria-label",d)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(d){this.a.tabIndex=d?0:-1}render(d){d.classList.add("select-container"),d.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(d){this.h=d,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(d,T,s){const a=document.createElement("option");return a.value=d,a.text=d,a.disabled=!!s,a}}t.$3Q=h}),define(be[56],$e([1,0,24,11,9,48,85,4,26]),function(re,t,y,F,i,U,w,D,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xS=t.$wS=t.$vS=void 0;function f(a){return typeof a=="object"&&"visibility"in a&&"data"in a}t.$vS=f;function d(a){switch(a){case!0:return 1;case!1:return 0;default:return a}}t.$wS=d;function T(a){return typeof a.collapsible=="boolean"}class s{constructor(e,u,l,m={}){this.o=e,this.p=u,this.rootRef=[],this.d=new D.$Vd,this.f=new D.$Nd,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new D.$Nd,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new D.$Nd,this.onDidSplice=this.l.event,this.m=new i.$Qg(U.$Kd),this.h=typeof m.collapseByDefault>"u"?!1:m.collapseByDefault,this.j=m.filter,this.k=typeof m.autoExpandSingleChildren>"u"?!1:m.autoExpandSingleChildren,this.c={parent:void 0,element:l,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,u,l=h.Iterable.empty(),m={}){if(e.length===0)throw new y.$tS(this.o,"Invalid tree location");m.diffIdentityProvider?this.q(m.diffIdentityProvider,e,u,l,m):this.s(e,u,l,m)}q(e,u,l,m=h.Iterable.empty(),n,r=n.diffDepth??0){const{parentNode:$}=this.G(u);if(!$.lastDiffIds)return this.s(u,l,m,n);const c=[...m],o=u[u.length-1],S=new w.$ws({getElements:()=>$.lastDiffIds},{getElements:()=>[...$.children.slice(0,o),...c,...$.children.slice(o+l)].map(B=>e.getId(B.element).toString())}).ComputeDiff(!1);if(S.quitEarly)return $.lastDiffIds=void 0,this.s(u,l,c,n);const j=u.slice(0,-1),M=(B,z,W)=>{if(r>0)for(let I=0;I<W;I++)B--,z--,this.q(e,[...j,B,0],Number.MAX_SAFE_INTEGER,c[z].children,n,r-1)};let b=Math.min($.children.length,o+l),v=c.length;for(const B of S.changes.sort((z,W)=>W.originalStart-z.originalStart))M(b,v,b-(B.originalStart+B.originalLength)),b=B.originalStart,v=B.modifiedStart-o,this.s([...j,b],B.originalLength,h.Iterable.slice(c,v,v+B.modifiedLength),n);M(b,v,b)}s(e,u,l=h.Iterable.empty(),{onDidCreateNode:m,onDidDeleteNode:n,diffIdentityProvider:r}){const{parentNode:$,listIndex:c,revealed:o,visible:S}=this.G(e),j=[],M=h.Iterable.map(l,ue=>this.w(ue,$,$.visible?1:0,o,j,m)),b=e[e.length-1],v=$.children.length>0;let B=0;for(let ue=b;ue>=0&&ue<$.children.length;ue--){const le=$.children[ue];if(le.visible){B=le.visibleChildIndex;break}}const z=[];let W=0,I=0;for(const ue of M)z.push(ue),I+=ue.renderNodeCount,ue.visible&&(ue.visibleChildIndex=B+W++);const N=(0,F.$6b)($.children,b,u,z);r?$.lastDiffIds?(0,F.$6b)($.lastDiffIds,b,u,z.map(ue=>r.getId(ue.element).toString())):$.lastDiffIds=$.children.map(ue=>r.getId(ue.element).toString()):$.lastDiffIds=void 0;let J=0;for(const ue of N)ue.visible&&J++;if(J!==0)for(let ue=b+z.length;ue<$.children.length;ue++){const le=$.children[ue];le.visible&&(le.visibleChildIndex-=J)}if($.visibleChildrenCount+=W-J,o&&S){const ue=N.reduce((le,oe)=>le+(oe.visible?oe.renderNodeCount:0),0);this.B($,I-ue),this.p.splice(c,ue,j)}if(N.length>0&&n){const ue=le=>{n(le),le.children.forEach(ue)};N.forEach(ue)}this.l.fire({insertedNodes:z,deletedNodes:N});const ee=$.children.length>0;v!==ee&&this.setCollapsible(e.slice(0,-1),ee);let ne=$;for(;ne;){if(ne.visibility===2){this.m.trigger(()=>this.refilter());break}ne=ne.parent}}rerender(e){if(e.length===0)throw new y.$tS(this.o,"Invalid tree location");const{node:u,listIndex:l,revealed:m}=this.F(e);u.visible&&m&&this.p.splice(l,1,[u])}updateElementHeight(e,u){if(e.length===0)throw new y.$tS(this.o,"Invalid tree location");const{listIndex:l}=this.F(e);this.p.updateElementHeight(l,u)}has(e){return this.D(e)}getListIndex(e){const{listIndex:u,visible:l,revealed:m}=this.F(e);return l&&m?u:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,u){const l=this.E(e);typeof u>"u"&&(u=!l.collapsible);const m={collapsible:u};return this.d.bufferEvents(()=>this.t(e,m))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,u,l){const m=this.E(e);typeof u>"u"&&(u=!m.collapsed);const n={collapsed:u,recursive:l||!1};return this.d.bufferEvents(()=>this.t(e,n))}t(e,u){const{node:l,listIndex:m,revealed:n}=this.F(e),r=this.u(l,m,n,u);if(l!==this.c&&this.k&&r&&!T(u)&&l.collapsible&&!l.collapsed&&!u.recursive){let $=-1;for(let c=0;c<l.children.length;c++)if(l.children[c].visible)if($>-1){$=-1;break}else $=c;$>-1&&this.t([...e,$],u)}return r}u(e,u,l,m){const n=this.v(e,m,!1);if(!l||!e.visible||!n)return n;const r=e.renderNodeCount,$=this.x(e),c=r-(u===-1?0:1);return this.p.splice(u+1,c,$.slice(1)),n}v(e,u,l){let m;if(e===this.c?m=!1:(T(u)?(m=e.collapsible!==u.collapsible,e.collapsible=u.collapsible):e.collapsible?(m=e.collapsed!==u.collapsed,e.collapsed=u.collapsed):m=!1,m&&this.f.fire({node:e,deep:l})),!T(u)&&u.recursive)for(const n of e.children)m=this.v(n,u,!0)||m;return m}expandTo(e){this.d.bufferEvents(()=>{let u=this.E(e);for(;u.parent;)u=u.parent,e=e.slice(0,e.length-1),u.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,u=this.z(this.c);this.p.splice(0,e,u),this.m.cancel()}w(e,u,l,m,n,r){const $={parent:u,element:e.element,children:[],depth:u.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},c=this.C($,l);$.visibility=c,m&&n.push($);const o=e.children||h.Iterable.empty(),S=m&&c!==0&&!$.collapsed;let j=0,M=1;for(const b of o){const v=this.w(b,$,c,S,n,r);$.children.push(v),M+=v.renderNodeCount,v.visible&&(v.visibleChildIndex=j++)}return $.collapsible=$.collapsible||$.children.length>0,$.visibleChildrenCount=j,$.visible=c===2?j>0:c===1,$.visible?$.collapsed||($.renderNodeCount=M):($.renderNodeCount=0,m&&n.pop()),r?.($),$}x(e){const u=e.renderNodeCount,l=[];return this.y(e,l),this.B(e.parent,l.length-u),l}y(e,u){if(e.visible===!1)return 0;if(u.push(e),e.renderNodeCount=1,!e.collapsed)for(const l of e.children)e.renderNodeCount+=this.y(l,u);return this.g.fire(e),e.renderNodeCount}z(e){const u=e.renderNodeCount,l=[];return this.A(e,e.visible?1:0,l),this.B(e.parent,l.length-u),l}A(e,u,l,m=!0){let n;if(e!==this.c){if(n=this.C(e,u),n===0)return e.visible=!1,e.renderNodeCount=0,!1;m&&l.push(e)}const r=l.length;e.renderNodeCount=e===this.c?0:1;let $=!1;if(!e.collapsed||n!==0){let c=0;for(const o of e.children)$=this.A(o,n,l,m&&!e.collapsed)||$,o.visible&&(o.visibleChildIndex=c++);e.visibleChildrenCount=c}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=n===2?$:n===1,e.visibility=n),e.visible?e.collapsed||(e.renderNodeCount+=l.length-r):(e.renderNodeCount=0,m&&l.pop()),this.g.fire(e),e.visible}B(e,u){if(u!==0)for(;e;)e.renderNodeCount+=u,this.g.fire(e),e=e.parent}C(e,u){const l=this.j?this.j.filter(e.element,u):1;return typeof l=="boolean"?(e.filterData=void 0,l?1:0):f(l)?(e.filterData=l.data,d(l.visibility)):(e.filterData=void 0,d(l))}D(e,u=this.c){if(!e||e.length===0)return!0;const[l,...m]=e;return l<0||l>u.children.length?!1:this.D(m,u.children[l])}E(e,u=this.c){if(!e||e.length===0)return u;const[l,...m]=e;if(l<0||l>u.children.length)throw new y.$tS(this.o,"Invalid tree location");return this.E(m,u.children[l])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:u,listIndex:l,revealed:m,visible:n}=this.G(e),r=e[e.length-1];if(r<0||r>u.children.length)throw new y.$tS(this.o,"Invalid tree location");const $=u.children[r];return{node:$,listIndex:l,revealed:m,visible:n&&$.visible}}G(e,u=this.c,l=0,m=!0,n=!0){const[r,...$]=e;if(r<0||r>u.children.length)throw new y.$tS(this.o,"Invalid tree location");for(let c=0;c<r;c++)l+=u.children[c].renderNodeCount;return m=m&&!u.collapsed,n=n&&u.visible,$.length===0?{parentNode:u,listIndex:l,revealed:m,visible:n}:this.G($,u.children[r],l+1,m,n)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const u=[];let l=e;for(;l.parent;)u.push(l.parent.children.indexOf(l)),l=l.parent;return u.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,F.$tb)(e)[0]}getFirstElementChild(e){const u=this.E(e);if(u.children.length!==0)return u.children[0].element}getLastElementAncestor(e=[]){const u=this.E(e);if(u.children.length!==0)return this.H(u)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$xS=s}),define(be[120],$e([1,0,56,24,26]),function(re,t,y,F,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DS=void 0;class U{get size(){return this.d.size}constructor(D,h,f={}){this.k=D,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new y.$xS(D,h,null,f),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,f.sorter&&(this.j={compare(d,T){return f.sorter.compare(d.element,T.element)}}),this.h=f.identityProvider}setChildren(D,h=i.Iterable.empty(),f={}){const d=this.o(D);this.l(d,this.m(h),f)}l(D,h=i.Iterable.empty(),f){const d=new Set,T=new Set,s=e=>{if(e.element===null)return;const u=e;if(d.add(u.element),this.d.set(u.element,u),this.h){const l=this.h.getId(u.element).toString();T.add(l),this.f.set(l,u)}f.onDidCreateNode?.(u)},a=e=>{if(e.element===null)return;const u=e;if(d.has(u.element)||this.d.delete(u.element),this.h){const l=this.h.getId(u.element).toString();T.has(l)||this.f.delete(l)}f.onDidDeleteNode?.(u)};this.c.splice([...D,0],Number.MAX_VALUE,h,{...f,onDidCreateNode:s,onDidDeleteNode:a})}m(D=i.Iterable.empty()){return this.j&&(D=[...D].sort(this.j.compare.bind(this.j))),i.Iterable.map(D,h=>{let f=this.d.get(h.element);if(!f&&this.h){const s=this.h.getId(h.element).toString();f=this.f.get(s)}if(!f){let s;return typeof h.collapsed>"u"?s=void 0:h.collapsed===F.ObjectTreeElementCollapseState.Collapsed||h.collapsed===F.ObjectTreeElementCollapseState.PreserveOrCollapsed?s=!0:h.collapsed===F.ObjectTreeElementCollapseState.Expanded||h.collapsed===F.ObjectTreeElementCollapseState.PreserveOrExpanded?s=!1:s=!!h.collapsed,{...h,children:this.m(h.children),collapsed:s}}const d=typeof h.collapsible=="boolean"?h.collapsible:f.collapsible;let T;return typeof h.collapsed>"u"||h.collapsed===F.ObjectTreeElementCollapseState.PreserveOrCollapsed||h.collapsed===F.ObjectTreeElementCollapseState.PreserveOrExpanded?T=f.collapsed:h.collapsed===F.ObjectTreeElementCollapseState.Collapsed?T=!0:h.collapsed===F.ObjectTreeElementCollapseState.Expanded?T=!1:T=!!h.collapsed,{...h,collapsible:d,collapsed:T,children:this.m(h.children)}})}rerender(D){const h=this.o(D);this.c.rerender(h)}updateElementHeight(D,h){const f=this.o(D);this.c.updateElementHeight(f,h)}resort(D=null,h=!0){if(!this.j)return;const f=this.o(D),d=this.c.getNode(f);this.l(f,this.n(d,h),{})}n(D,h,f=!0){let d=[...D.children];return(h||f)&&(d=d.sort(this.j.compare.bind(this.j))),i.Iterable.map(d,T=>({element:T.element,collapsible:T.collapsible,collapsed:T.collapsed,children:this.n(T,h,!1)}))}getFirstElementChild(D=null){const h=this.o(D);return this.c.getFirstElementChild(h)}getLastElementAncestor(D=null){const h=this.o(D);return this.c.getLastElementAncestor(h)}has(D){return this.d.has(D)}getListIndex(D){const h=this.o(D);return this.c.getListIndex(h)}getListRenderCount(D){const h=this.o(D);return this.c.getListRenderCount(h)}isCollapsible(D){const h=this.o(D);return this.c.isCollapsible(h)}setCollapsible(D,h){const f=this.o(D);return this.c.setCollapsible(f,h)}isCollapsed(D){const h=this.o(D);return this.c.isCollapsed(h)}setCollapsed(D,h,f){const d=this.o(D);return this.c.setCollapsed(d,h,f)}expandTo(D){const h=this.o(D);this.c.expandTo(h)}refilter(){this.c.refilter()}getNode(D=null){if(D===null)return this.c.getNode(this.c.rootRef);const h=this.d.get(D);if(!h)throw new F.$tS(this.k,`Tree element not found: ${D}`);return h}getNodeLocation(D){return D.element}getParentNodeLocation(D){if(D===null)throw new F.$tS(this.k,"Invalid getParentNodeLocation call");const h=this.d.get(D);if(!h)throw new F.$tS(this.k,`Tree element not found: ${D}`);const f=this.c.getNodeLocation(h),d=this.c.getParentNodeLocation(f);return this.c.getNode(d).element}o(D){if(D===null)return[];const h=this.d.get(D);if(!h)throw new F.$tS(this.k,`Tree element not found: ${D}`);return this.c.getNodeLocation(h)}}t.$DS=U}),define(be[20],$e([1,0,3,14,19,23,2]),function(re,t,y,F,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6P=void 0;class D extends w.$Sc{f(f,d){this.B(y.$CO(f,y.$lP.CLICK,T=>d(new i.$uO(T))))}j(f,d){this.B(y.$CO(f,y.$lP.MOUSE_DOWN,T=>d(new i.$uO(T))))}m(f,d){this.B(y.$CO(f,y.$lP.MOUSE_OVER,T=>d(new i.$uO(T))))}u(f,d){this.B(y.$CO(f,y.$lP.MOUSE_LEAVE,T=>d(new i.$uO(T))))}z(f,d){this.B(y.$CO(f,y.$lP.KEY_DOWN,T=>d(new F.$zO(T))))}C(f,d){this.B(y.$CO(f,y.$lP.KEY_UP,T=>d(new F.$zO(T))))}D(f,d){this.B(y.$CO(f,y.$lP.INPUT,d))}F(f,d){this.B(y.$CO(f,y.$lP.BLUR,d))}G(f,d){this.B(y.$CO(f,y.$lP.FOCUS,d))}H(f,d){this.B(y.$CO(f,y.$lP.CHANGE,d))}I(f){return U.$2P.ignoreTarget(f)}}t.$6P=D}),define(be[37],$e([1,0,54,20,9,18,3]),function(re,t,y,F,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8P=t.$7P=void 0,t.$7P=11;class D extends F.$6P{constructor(f){super(),this.a=f.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=f.bgWidth+"px",this.bgDomNode.style.height=f.bgHeight+"px",typeof f.top<"u"&&(this.bgDomNode.style.top="0px"),typeof f.left<"u"&&(this.bgDomNode.style.left="0px"),typeof f.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof f.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=f.className,this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(f.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$7P+"px",this.domNode.style.height=t.$7P+"px",typeof f.top<"u"&&(this.domNode.style.top=f.top+"px"),typeof f.left<"u"&&(this.domNode.style.left=f.left+"px"),typeof f.bottom<"u"&&(this.domNode.style.bottom=f.bottom+"px"),typeof f.right<"u"&&(this.domNode.style.right=f.right+"px"),this.g=this.B(new y.$5P),this.B(w.$DO(this.bgDomNode,w.$lP.POINTER_DOWN,d=>this.h(d))),this.B(w.$DO(this.domNode,w.$lP.POINTER_DOWN,d=>this.h(d))),this.b=this.B(new i.$5g),this.c=this.B(new i.$4g)}h(f){if(!f.target||!(f.target instanceof Element))return;const d=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(d,200),this.g.startMonitoring(f.target,f.pointerId,f.buttons,T=>{},()=>{this.b.cancel(),this.c.cancel()}),f.preventDefault()}}t.$8P=D}),define(be[57],$e([1,0,3,40,54,37,118,20,5]),function(re,t,y,F,i,U,w,D,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$P=void 0;const f=140;class d extends D.$6P{constructor(s){super(),this.g=s.lazyRender,this.a=s.host,this.b=s.scrollable,this.c=s.scrollByPage,this.h=s.scrollbarState,this.n=this.B(new w.$0P(s.visibility,"visible scrollbar "+s.extraScrollbarClassName,"invisible scrollbar "+s.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new i.$5P),this.s=!0,this.domNode=(0,F.$4P)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(y.$CO(this.domNode.domNode,y.$lP.POINTER_DOWN,a=>this.M(a)))}t(s){const a=this.B(new U.$8P(s));this.domNode.domNode.appendChild(a.bgDomNode),this.domNode.domNode.appendChild(a.domNode)}w(s,a,e,u){this.slider=(0,F.$4P)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(s),this.slider.setLeft(a),typeof e=="number"&&this.slider.setWidth(e),typeof u=="number"&&this.slider.setHeight(u),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(y.$CO(this.slider.domNode,y.$lP.POINTER_DOWN,l=>{l.button===0&&(l.preventDefault(),this.O(l))})),this.f(this.slider.domNode,l=>{l.leftButton&&l.stopPropagation()})}y(s){return this.h.setVisibleSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(s){return this.h.setScrollSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(s){return this.h.setScrollPosition(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(s){s.target===this.domNode.domNode&&this.N(s)}delegatePointerDown(s){const a=this.domNode.domNode.getClientRects()[0].top,e=a+this.h.getSliderPosition(),u=a+this.h.getSliderPosition()+this.h.getSliderSize(),l=this.U(s);e<=l&&l<=u?s.button===0&&(s.preventDefault(),this.O(s)):this.N(s)}N(s){let a,e;if(s.target===this.domNode.domNode&&typeof s.offsetX=="number"&&typeof s.offsetY=="number")a=s.offsetX,e=s.offsetY;else{const l=y.$UO(this.domNode.domNode);a=s.pageX-l.left,e=s.pageY-l.top}const u=this.S(a,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(u):this.h.getDesiredScrollPositionFromOffset(u)),s.button===0&&(s.preventDefault(),this.O(s))}O(s){if(!s.target||!(s.target instanceof Element))return;const a=this.U(s),e=this.W(s),u=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(s.target,s.pointerId,s.buttons,l=>{const m=this.W(l),n=Math.abs(m-e);if(h.$j&&n>f){this.P(u.getScrollPosition());return}const $=this.U(l)-a;this.P(u.getDesiredScrollPositionFromDelta($))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(s){const a={};this.writeScrollPosition(a,s),this.b.setScrollPositionNow(a)}updateScrollbarSize(s){this.X(s),this.h.setScrollbarSize(s),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$$P=d}),define(be[121],$e([1,0,19,57,37,41,17]),function(re,t,y,F,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_P=void 0;class D extends F.$$P{constructor(f,d,T){const s=f.getScrollDimensions(),a=f.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:T,scrollbarState:new U.$9P(d.horizontalHasArrows?d.arrowSize:0,d.horizontal===2?0:d.horizontalScrollbarSize,d.vertical===2?0:d.verticalScrollbarSize,s.width,s.scrollWidth,a.scrollLeft),visibility:d.horizontal,extraScrollbarClassName:"horizontal",scrollable:f,scrollByPage:d.scrollByPage}),d.horizontalHasArrows){const e=(d.arrowSize-i.$7P)/2,u=(d.horizontalScrollbarSize-i.$7P)/2;this.t({className:"scra",icon:w.$Tj.scrollbarButtonLeft,top:u,left:e,bottom:void 0,right:void 0,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new y.$wO(null,1,0))}),this.t({className:"scra",icon:w.$Tj.scrollbarButtonRight,top:u,left:void 0,bottom:void 0,right:e,bgWidth:d.arrowSize,bgHeight:d.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new y.$wO(null,-1,0))})}this.w(Math.floor((d.horizontalScrollbarSize-d.horizontalSliderSize)/2),0,void 0,d.horizontalSliderSize)}R(f,d){this.slider.setWidth(f),this.slider.setLeft(d)}Q(f,d){this.domNode.setWidth(f),this.domNode.setHeight(d),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(f){return this.s=this.J(f.scrollWidth)||this.s,this.s=this.L(f.scrollLeft)||this.s,this.s=this.y(f.width)||this.s,this.s}S(f,d){return f}U(f){return f.pageX}W(f){return f.pageY}X(f){this.slider.setHeight(f)}writeScrollPosition(f,d){f.scrollLeft=d}updateOptions(f){this.updateScrollbarSize(f.horizontal===2?0:f.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this.n.setVisibility(f.horizontal),this.c=f.scrollByPage}}t.$_P=D}),define(be[122],$e([1,0,19,57,37,41,17]),function(re,t,y,F,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aQ=void 0;class D extends F.$$P{constructor(f,d,T){const s=f.getScrollDimensions(),a=f.getCurrentScrollPosition();if(super({lazyRender:d.lazyRender,host:T,scrollbarState:new U.$9P(d.verticalHasArrows?d.arrowSize:0,d.vertical===2?0:d.verticalScrollbarSize,0,s.height,s.scrollHeight,a.scrollTop),visibility:d.vertical,extraScrollbarClassName:"vertical",scrollable:f,scrollByPage:d.scrollByPage}),d.verticalHasArrows){const e=(d.arrowSize-i.$7P)/2,u=(d.verticalScrollbarSize-i.$7P)/2;this.t({className:"scra",icon:w.$Tj.scrollbarButtonUp,top:e,left:u,bottom:void 0,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this.a.onMouseWheel(new y.$wO(null,0,1))}),this.t({className:"scra",icon:w.$Tj.scrollbarButtonDown,top:void 0,left:u,bottom:e,right:void 0,bgWidth:d.verticalScrollbarSize,bgHeight:d.arrowSize,onActivate:()=>this.a.onMouseWheel(new y.$wO(null,0,-1))})}this.w(0,Math.floor((d.verticalScrollbarSize-d.verticalSliderSize)/2),d.verticalSliderSize,void 0)}R(f,d){this.slider.setHeight(f),this.slider.setTop(d)}Q(f,d){this.domNode.setWidth(d),this.domNode.setHeight(f),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(f){return this.s=this.J(f.scrollHeight)||this.s,this.s=this.L(f.scrollTop)||this.s,this.s=this.y(f.height)||this.s,this.s}S(f,d){return d}U(f){return f.pageY}W(f){return f.pageX}X(f){this.slider.setWidth(f)}writeScrollPosition(f,d){f.scrollTop=d}updateOptions(f){this.updateScrollbarSize(f.vertical===2?0:f.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(f.vertical),this.c=f.scrollByPage}}t.$aQ=D}),define(be[58],$e([1,0,16,3,40,19,121,122,20,9,4,2,5,47,96]),function(re,t,y,F,i,U,w,D,h,f,d,T,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fQ=t.$eQ=t.$dQ=t.$cQ=t.$bQ=void 0;const e=500,u=50,l=!0;class m{constructor(M,b,v){this.timestamp=M,this.deltaX=b,this.deltaY=v,this.score=0}}class n{static{this.INSTANCE=new n}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let M=1,b=0,v=1,B=this.d;do{const z=B===this.c?M:Math.pow(2,-v);if(M-=z,b+=this.b[B].score*z,B===this.c)break;B=(this.a+B-1)%this.a,v++}while(!0);return b<=.5}acceptStandardWheelEvent(M){const b=window.devicePixelRatio/(0,y.$dO)();s.$j||s.$l?this.accept(Date.now(),M.deltaX/b,M.deltaY/b):this.accept(Date.now(),M.deltaX,M.deltaY)}accept(M,b,v){const B=new m(M,b,v);B.score=this.f(B),this.c===-1&&this.d===-1?(this.b[0]=B,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=B)}f(M){if(Math.abs(M.deltaX)>0&&Math.abs(M.deltaY)>0)return 1;let b=.5;const v=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(M.deltaX)||!this.g(M.deltaY))&&(b+=.25),Math.min(Math.max(b,0),1)}g(M){return Math.abs(Math.round(M)-M)<.01}}t.$bQ=n;class r extends h.$6P{get options(){return this.a}constructor(M,b,v){super(),this.O=this.B(new d.$Nd),this.onScroll=this.O.event,this.P=this.B(new d.$Nd),this.onWillScroll=this.P.event,M.style.overflow="hidden",this.a=S(b),this.b=v,this.B(this.b.onScroll(z=>{this.P.fire(z),this.S(z),this.O.fire(z)}));const B={onMouseWheel:z=>this.R(z),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new D.$aQ(this.b,this.a,B)),this.g=this.B(new w.$_P(this.b,this.a,B)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(M),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,i.$4P)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,i.$4P)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,i.$4P)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,z=>this.Z(z)),this.u(this.t,z=>this.Y(z)),this.L=this.B(new f.$4g),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,T.$Nc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(M){this.c.delegatePointerDown(M)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(M){this.b.setScrollDimensions(M,!1)}updateClassName(M){this.a.className=M,s.$k&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(M){typeof M.handleMouseWheel<"u"&&(this.a.handleMouseWheel=M.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof M.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=M.mouseWheelScrollSensitivity),typeof M.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=M.fastScrollSensitivity),typeof M.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=M.scrollPredominantAxis),typeof M.horizontal<"u"&&(this.a.horizontal=M.horizontal),typeof M.vertical<"u"&&(this.a.vertical=M.vertical),typeof M.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=M.horizontalScrollbarSize),typeof M.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=M.verticalScrollbarSize),typeof M.scrollByPage<"u"&&(this.a.scrollByPage=M.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(M){this.N=M}delegateScrollFromMouseWheelEvent(M){this.R(new U.$wO(M))}Q(M){if(this.w.length>0!==M&&(this.w=(0,T.$Nc)(this.w),M)){const v=B=>{this.R(new U.$wO(B))};this.w.push(F.$CO(this.t,F.$lP.MOUSE_WHEEL,v,{passive:!1}))}}R(M){if(M.browserEvent?.defaultPrevented)return;const b=n.INSTANCE;l&&b.acceptStandardWheelEvent(M);let v=!1;if(M.deltaY||M.deltaX){let z=M.deltaY*this.a.mouseWheelScrollSensitivity,W=M.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&W+z===0?W=z=0:Math.abs(z)>=Math.abs(W)?W=0:z=0),this.a.flipAxes&&([z,W]=[W,z]);const I=!s.$k&&M.browserEvent&&M.browserEvent.shiftKey;(this.a.scrollYToX||I)&&!W&&(W=z,z=0),M.browserEvent&&M.browserEvent.altKey&&(W=W*this.a.fastScrollSensitivity,z=z*this.a.fastScrollSensitivity);const N=this.b.getFutureScrollPosition();let J={};if(z){const ee=u*z,ne=N.scrollTop-(ee<0?Math.floor(ee):Math.ceil(ee));this.c.writeScrollPosition(J,ne)}if(W){const ee=u*W,ne=N.scrollLeft-(ee<0?Math.floor(ee):Math.ceil(ee));this.g.writeScrollPosition(J,ne)}J=this.b.validateScrollPosition(J),(N.scrollLeft!==J.scrollLeft||N.scrollTop!==J.scrollTop)&&(l&&this.a.mouseWheelSmoothScroll&&b.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(J):this.b.setScrollPositionNow(J),v=!0)}let B=v;!B&&this.a.alwaysConsumeMouseWheel&&(B=!0),!B&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(B=!0),B&&(M.preventDefault(),M.stopPropagation())}S(M){this.M=this.g.onDidScroll(M)||this.M,this.M=this.c.onDidScroll(M)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const M=this.b.getCurrentScrollPosition(),b=M.scrollTop>0,v=M.scrollLeft>0,B=v?" left":"",z=b?" top":"",W=v||b?" top-left-corner":"";this.n.setClassName(`shadow${B}`),this.r.setClassName(`shadow${z}`),this.s.setClassName(`shadow${W}${z}${B}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(M){this.J=!1,this.ab()}Z(M){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$cQ=r;class $ extends r{constructor(M,b){b=b||{},b.mouseWheelSmoothScroll=!1;const v=new a.$Tr({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:B=>F.$KO(B)});super(M,b,v),this.B(v)}setScrollPosition(M){this.b.setScrollPositionNow(M)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$dQ=$;class c extends r{constructor(M,b,v){super(M,b,v)}setScrollPosition(M){M.reuseAnimation?this.b.setScrollPositionSmooth(M,M.reuseAnimation):this.b.setScrollPositionNow(M)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$eQ=c;class o extends r{constructor(M,b){b=b||{},b.mouseWheelSmoothScroll=!1;const v=new a.$Tr({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:B=>F.$KO(B)});super(M,b,v),this.B(v),this.cb=M,this.B(this.onScroll(B=>{B.scrollTopChanged&&(this.cb.scrollTop=B.scrollTop),B.scrollLeftChanged&&(this.cb.scrollLeft=B.scrollLeft)})),this.scanDomNode()}setScrollPosition(M){this.b.setScrollPositionNow(M)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$fQ=o;function S(j){const M={lazyRender:typeof j.lazyRender<"u"?j.lazyRender:!1,className:typeof j.className<"u"?j.className:"",useShadows:typeof j.useShadows<"u"?j.useShadows:!0,handleMouseWheel:typeof j.handleMouseWheel<"u"?j.handleMouseWheel:!0,flipAxes:typeof j.flipAxes<"u"?j.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof j.consumeMouseWheelIfScrollbarIsNeeded<"u"?j.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof j.alwaysConsumeMouseWheel<"u"?j.alwaysConsumeMouseWheel:!1,scrollYToX:typeof j.scrollYToX<"u"?j.scrollYToX:!1,mouseWheelScrollSensitivity:typeof j.mouseWheelScrollSensitivity<"u"?j.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof j.fastScrollSensitivity<"u"?j.fastScrollSensitivity:5,scrollPredominantAxis:typeof j.scrollPredominantAxis<"u"?j.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof j.mouseWheelSmoothScroll<"u"?j.mouseWheelSmoothScroll:!0,arrowSize:typeof j.arrowSize<"u"?j.arrowSize:11,listenOnDomNode:typeof j.listenOnDomNode<"u"?j.listenOnDomNode:null,horizontal:typeof j.horizontal<"u"?j.horizontal:1,horizontalScrollbarSize:typeof j.horizontalScrollbarSize<"u"?j.horizontalScrollbarSize:10,horizontalSliderSize:typeof j.horizontalSliderSize<"u"?j.horizontalSliderSize:0,horizontalHasArrows:typeof j.horizontalHasArrows<"u"?j.horizontalHasArrows:!1,vertical:typeof j.vertical<"u"?j.vertical:1,verticalScrollbarSize:typeof j.verticalScrollbarSize<"u"?j.verticalScrollbarSize:10,verticalHasArrows:typeof j.verticalHasArrows<"u"?j.verticalHasArrows:!1,verticalSliderSize:typeof j.verticalSliderSize<"u"?j.verticalSliderSize:0,scrollByPage:typeof j.scrollByPage<"u"?j.scrollByPage:!1};return M.horizontalSliderSize=typeof j.horizontalSliderSize<"u"?j.horizontalSliderSize:M.horizontalScrollbarSize,M.verticalSliderSize=typeof j.verticalSliderSize<"u"?j.verticalSliderSize:M.verticalScrollbarSize,s.$k&&(M.className+=" mac"),M}}),define(be[59],$e([1,0,52,3,21,23,58,11,9,25,4,2,46,47,80,117,6]),function(re,t,y,F,i,U,w,D,h,f,d,T,s,a,e,u,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JQ=t.$IQ=t.$HQ=t.$GQ=void 0;const m={CurrentDragAndDropData:void 0},n={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(M){return[M]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(b){this.d=b}constructor(b){this.elements=b}update(){}getData(){return this.elements}}t.$GQ=r;class ${constructor(b){this.elements=b}update(){}getData(){return this.elements}}t.$HQ=$;class c{constructor(){this.types=[],this.files=[]}update(b){if(b.types&&this.types.splice(0,this.types.length,...b.types),b.files){this.files.splice(0,this.files.length);for(let v=0;v<b.files.length;v++){const B=b.files.item(v);B&&(B.size||B.type)&&this.files.push(B)}}}getData(){return{types:this.types,files:this.files}}}t.$IQ=c;function o(M,b){return Array.isArray(M)&&Array.isArray(b)?(0,D.$ub)(M,b):M===b}class S{constructor(b){b?.getSetSize?this.getSetSize=b.getSetSize.bind(b):this.getSetSize=(v,B,z)=>z,b?.getPosInSet?this.getPosInSet=b.getPosInSet.bind(b):this.getPosInSet=(v,B)=>B+1,b?.getRole?this.getRole=b.getRole.bind(b):this.getRole=v=>"listitem",b?.isChecked?this.isChecked=b.isChecked.bind(b):this.isChecked=v=>{}}}class j{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(b){if(b!==this.O){if(b&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=b,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const v of this.d)this.Y(v);this.V(),this.q.setScrollDimensions({width:(0,F.$XO)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(b,v,B,z=n){if(this.Q=v,this.domId=`list_id_${++j.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new h.$Qg(50),this.v=!1,this.x=T.$Sc.None,this.y=0,this.G=!1,this.J=T.$Sc.None,this.K=T.$Sc.None,this.L=new T.$Rc,this.M=new d.$Nd,this.N=new d.$Nd,this.onDidChangeContentHeight=d.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=d.Event.latch(this.N.event,void 0,this.L),this.O=!1,z.horizontalScrolling&&z.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$EQ(z.paddingTop??0);for(const I of B)this.j.set(I.templateId,I);this.h=this.L.add(new u.$FQ(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof z.mouseSupport=="boolean"?z.mouseSupport:!0),this.O=z.horizontalScrolling??n.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof z.paddingBottom>"u"?0:z.paddingBottom,this.D=new S(z.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(z.transformOptimization??n.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(U.$2P.addTarget(this.o)),this.p=this.L.add(new a.$Tr({forceIntegerValues:!0,smoothScrollDuration:z.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:I=>(0,F.$KO)(I)})),this.q=this.L.add(new w.$eQ(this.o,{alwaysConsumeMouseWheel:z.alwaysConsumeMouseWheel??n.alwaysConsumeMouseWheel,horizontal:1,vertical:z.verticalScrollMode??n.verticalScrollMode,useShadows:z.useShadows??n.useShadows,mouseWheelScrollSensitivity:z.mouseWheelScrollSensitivity,fastScrollSensitivity:z.fastScrollSensitivity,scrollByPage:z.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),b.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,F.$CO)(this.o,U.EventType.Change,I=>this.hb(I))),this.L.add((0,F.$CO)(this.q.getDomNode(),"scroll",I=>I.target.scrollTop=0)),this.L.add((0,F.$CO)(this.domNode,"dragover",I=>this.jb(this.fb(I)))),this.L.add((0,F.$CO)(this.domNode,"drop",I=>this.lb(this.fb(I)))),this.L.add((0,F.$CO)(this.domNode,"dragleave",I=>this.kb(this.fb(I)))),this.L.add((0,F.$CO)(this.domNode,"dragend",I=>this.mb(I))),this.z=z.setRowLineHeight??n.setRowLineHeight,this.A=z.setRowHeight??n.setRowHeight,this.B=z.supportDynamicHeights??n.supportDynamicHeights,this.F=z.dnd??this.L.add(n.dnd),this.layout(z.initialSize?.height,z.initialSize?.width)}updateOptions(b){b.paddingBottom!==void 0&&(this.C=b.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),b.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(b.smoothScrolling?125:0),b.horizontalScrolling!==void 0&&(this.P=b.horizontalScrolling);let v;if(b.scrollByPage!==void 0&&(v={...v??{},scrollByPage:b.scrollByPage}),b.mouseWheelScrollSensitivity!==void 0&&(v={...v??{},mouseWheelScrollSensitivity:b.mouseWheelScrollSensitivity}),b.fastScrollSensitivity!==void 0&&(v={...v??{},fastScrollSensitivity:b.fastScrollSensitivity}),v&&this.q.updateOptions(v),b.paddingTop!==void 0&&b.paddingTop!==this.g.paddingTop){const B=this.sb(this.k,this.m),z=b.paddingTop-this.g.paddingTop;this.g.paddingTop=b.paddingTop,this.W(B,Math.max(0,this.k+z),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(b){this.q.delegateScrollFromMouseWheelEvent(b)}delegateVerticalScrollbarPointerDown(b){this.q.delegateVerticalScrollbarPointerDown(b)}updateElementHeight(b,v,B){if(b<0||b>=this.d.length)return;const z=this.d[b].size;if(typeof v>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[b].lastDynamicHeightWidth=void 0,v=z+this.ub(b)}if(z===v)return;const W=this.sb(this.k,this.m);let I=0;b<W.start||B!==null&&B>b&&B<W.end?I=v-z:I=0,this.g.splice(b,1,[{size:v}]),this.d[b].size=v,this.W(W,Math.max(0,this.k+I),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(b,v,B=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(b,v,B)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(b,v,B=[]){const z=this.sb(this.k,this.m),W={start:b,end:b+v},I=s.Range.intersect(z,W),N=new Map;for(let _=I.end-1;_>=I.start;_--){const G=this.d[_];if(G.dragStartDisposable.dispose(),G.checkedDisposable.dispose(),G.row){let E=N.get(G.templateId);E||(E=[],N.set(G.templateId,E));const K=this.j.get(G.templateId);K&&K.disposeElement&&K.disposeElement(G.element,_,G.row.templateData,G.size),E.push(G.row)}G.row=null}const J={start:b+v,end:this.d.length},ee=s.Range.intersect(J,z),ne=s.Range.relativeComplement(J,z),ue=B.map(_=>({id:String(this.f++),element:_,templateId:this.Q.getTemplateId(_),size:this.Q.getHeight(_),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(_),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:T.$Sc.None,checkedDisposable:T.$Sc.None}));let le;b===0&&v>=this.d.length?(this.g=new e.$EQ(this.g.paddingTop),this.g.splice(0,0,ue),le=this.d,this.d=ue):(this.g.splice(b,v,ue),le=this.d.splice(b,v,...ue));const oe=B.length-v,me=this.sb(this.k,this.m),Ce=(0,e.$CQ)(ee,oe),Te=s.Range.intersect(me,Ce);for(let _=Te.start;_<Te.end;_++)this.Z(this.d[_],_);const Pe=s.Range.relativeComplement(Ce,me);for(const _ of Pe)for(let G=_.start;G<_.end;G++)this.ab(G);const de=ne.map(_=>(0,e.$CQ)(_,oe)),fe=[{start:b,end:b+B.length},...de].map(_=>s.Range.intersect(me,_)),Y=this.vb(fe);for(const _ of fe)for(let G=_.start;G<_.end;G++){const E=this.d[G],g=N.get(E.templateId)?.pop();this.X(G,Y,g)}for(const _ of N.values())for(const G of _)this.h.release(G);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),le.map(_=>_.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,F.$KO)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let b=0;for(const v of this.d)typeof v.width<"u"&&(b=Math.max(b,v.width));this.E=b,this.q.setScrollDimensions({scrollWidth:b===0?0:b+10}),this.N.fire(this.E)}updateWidth(b){if(!this.P||typeof this.E>"u")return;const v=this.d[b];this.Y(v),typeof v.width<"u"&&v.width>this.E&&(this.E=v.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const b of this.d)b.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const b=this.sb(this.k,this.m),v=this.g.positionAt(b.start),B=this.g.positionAt(b.start+1);return B!==-1&&(B-v)/2+v<this.scrollTop?b.start+1:b.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(b){return this.d[b].element}indexOf(b){return this.d.findIndex(v=>v.element===b)}domElement(b){const v=this.d[b].row;return v&&v.domNode}elementHeight(b){return this.d[b].size}elementTop(b){return this.g.positionAt(b)}indexAt(b){return this.g.indexAt(b)}indexAfter(b){return this.g.indexAfter(b)}layout(b,v){const B={height:typeof b=="number"?b:(0,F.$ZO)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,B.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(B),typeof v<"u"&&(this.n=v,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof v=="number"?v:(0,F.$XO)(this.domNode)})}W(b,v,B,z,W,I=!1){const N=this.sb(v,B),J=s.Range.relativeComplement(N,b),ee=s.Range.relativeComplement(b,N),ne=this.vb(J);if(I){const ue=s.Range.intersect(b,N);for(let le=ue.start;le<ue.end;le++)this.Z(this.d[le],le)}this.h.transact(()=>{for(const ue of ee)for(let le=ue.start;le<ue.end;le++)this.ab(le);for(const ue of J)for(let le=ue.start;le<ue.end;le++)this.X(le,ne)}),z!==void 0&&(this.o.style.left=`-${z}px`),this.o.style.top=`-${v}px`,this.P&&W!==void 0&&(this.o.style.width=`${Math.max(W,this.n)}px`),this.k=v,this.m=B}X(b,v,B){const z=this.d[b];let W=!1;if(!z.row)if(B)z.row=B;else{const ne=this.h.alloc(z.templateId);z.row=ne.row,W=ne.isReusingConnectedDomNode}const I=this.D.getRole(z.element)||"listitem";z.row.domNode.setAttribute("role",I);const N=this.D.isChecked(z.element);if(typeof N=="boolean")z.row.domNode.setAttribute("aria-checked",String(!!N));else if(N){const ne=ue=>z.row.domNode.setAttribute("aria-checked",String(!!ue));ne(N.value),z.checkedDisposable=N.onDidChange(ne)}(W||!z.row.domNode.parentElement)&&(v?this.o.insertBefore(z.row.domNode,v):this.o.appendChild(z.row.domNode)),this.Z(z,b);const J=this.j.get(z.templateId);if(!J)throw new Error(`No renderer found for template id ${z.templateId}`);J?.renderElement(z.element,b,z.row.templateData,z.size);const ee=this.F.getDragURI(z.element);z.dragStartDisposable.dispose(),z.row.domNode.draggable=!!ee,ee&&(z.dragStartDisposable=(0,F.$CO)(z.row.domNode,"dragstart",ne=>this.ib(z.element,ee,ne))),this.P&&(this.Y(z),this.U())}Y(b){if(!b.row||!b.row.domNode)return;b.row.domNode.style.width="fit-content",b.width=(0,F.$XO)(b.row.domNode);const v=window.getComputedStyle(b.row.domNode);v.paddingLeft&&(b.width+=parseFloat(v.paddingLeft)),v.paddingRight&&(b.width+=parseFloat(v.paddingRight)),b.row.domNode.style.width=""}Z(b,v){b.row.domNode.style.top=`${this.elementTop(v)}px`,this.A&&(b.row.domNode.style.height=`${b.size}px`),this.z&&(b.row.domNode.style.lineHeight=`${b.size}px`),b.row.domNode.setAttribute("data-index",`${v}`),b.row.domNode.setAttribute("data-last-element",v===this.length-1?"true":"false"),b.row.domNode.setAttribute("data-parity",v%2===0?"even":"odd"),b.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(b.element,v,this.length))),b.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(b.element,v))),b.row.domNode.setAttribute("id",this.getElementDomId(v)),b.row.domNode.classList.toggle("drop-target",b.dropTarget)}ab(b){const v=this.d[b];if(v.dragStartDisposable.dispose(),v.checkedDisposable.dispose(),v.row){const B=this.j.get(v.templateId);B&&B.disposeElement&&B.disposeElement(v.element,b,v.row.templateData,v.size),this.h.release(v.row),v.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(b,v){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:b,reuseAnimation:v})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(b){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:b})}get scrollTop(){return this.getScrollTop()}set scrollTop(b){this.setScrollTop(b)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return d.Event.map(this.L.add(new i.$tQ(this.domNode,"click")).event,b=>this.bb(b),this.L)}get onMouseDblClick(){return d.Event.map(this.L.add(new i.$tQ(this.domNode,"dblclick")).event,b=>this.bb(b),this.L)}get onMouseMiddleClick(){return d.Event.filter(d.Event.map(this.L.add(new i.$tQ(this.domNode,"auxclick")).event,b=>this.bb(b),this.L),b=>b.browserEvent.button===1,this.L)}get onMouseUp(){return d.Event.map(this.L.add(new i.$tQ(this.domNode,"mouseup")).event,b=>this.bb(b),this.L)}get onMouseDown(){return d.Event.map(this.L.add(new i.$tQ(this.domNode,"mousedown")).event,b=>this.bb(b),this.L)}get onMouseOver(){return d.Event.map(this.L.add(new i.$tQ(this.domNode,"mouseover")).event,b=>this.bb(b),this.L)}get onMouseMove(){return d.Event.map(this.L.add(new i.$tQ(this.domNode,"mousemove")).event,b=>this.bb(b),this.L)}get onMouseOut(){return d.Event.map(this.L.add(new i.$tQ(this.domNode,"mouseout")).event,b=>this.bb(b),this.L)}get onContextMenu(){return d.Event.any(d.Event.map(this.L.add(new i.$tQ(this.domNode,"contextmenu")).event,b=>this.bb(b),this.L),d.Event.map(this.L.add(new i.$tQ(this.domNode,U.EventType.Contextmenu)).event,b=>this.eb(b),this.L))}get onTouchStart(){return d.Event.map(this.L.add(new i.$tQ(this.domNode,"touchstart")).event,b=>this.db(b),this.L)}get onTap(){return d.Event.map(this.L.add(new i.$tQ(this.o,U.EventType.Tap)).event,b=>this.eb(b),this.L)}bb(b){const v=this.rb(b.target||null),B=typeof v>"u"?void 0:this.d[v],z=B&&B.element;return{browserEvent:b,index:v,element:z}}db(b){const v=this.rb(b.target||null),B=typeof v>"u"?void 0:this.d[v],z=B&&B.element;return{browserEvent:b,index:v,element:z}}eb(b){const v=this.rb(b.initialTarget||null),B=typeof v>"u"?void 0:this.d[v],z=B&&B.element;return{browserEvent:b,index:v,element:z}}fb(b){const v=this.rb(b.target||null),B=typeof v>"u"?void 0:this.d[v],z=B&&B.element;return{browserEvent:b,index:v,element:z}}gb(b){try{const v=this.sb(this.k,this.m);this.W(v,b.scrollTop,b.height,b.scrollLeft,b.scrollWidth),this.B&&this.tb(b.scrollTop,b.height,b.inSmoothScrolling)}catch(v){throw console.error("Got bad scroll event:",b),v}}hb(b){b.preventDefault(),b.stopPropagation(),this.scrollTop-=b.translationY}ib(b,v,B){if(!B.dataTransfer)return;const z=this.F.getDragElements(b);if(B.dataTransfer.effectAllowed="copyMove",B.dataTransfer.setData(y.$ZP.TEXT,v),B.dataTransfer.setDragImage){let W;this.F.getDragLabel&&(W=this.F.getDragLabel(z,B)),typeof W>"u"&&(W=String(z.length));const I=(0,F.$)(".monaco-drag-image");I.textContent=W;const J=(ee=>{for(;ee&&!ee.classList.contains("monaco-workbench");)ee=ee.parentElement;return ee||document.body})(this.domNode);J.appendChild(I),B.dataTransfer.setDragImage(I,-10,-10),setTimeout(()=>J.removeChild(I),0)}this.domNode.classList.add("dragging"),this.H=new r(z),m.CurrentDragAndDropData=new $(z),this.F.onDragStart?.(this.H,B)}jb(b){if(b.browserEvent.preventDefault(),this.K.dispose(),m.CurrentDragAndDropData&&m.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(b.browserEvent),!b.browserEvent.dataTransfer))return!1;if(!this.H)if(m.CurrentDragAndDropData)this.H=m.CurrentDragAndDropData;else{if(!b.browserEvent.dataTransfer.types)return!1;this.H=new c}const v=this.F.onDragOver(this.H,b.element,b.index,b.browserEvent);if(this.G=typeof v=="boolean"?v:v.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;b.browserEvent.dataTransfer.dropEffect=typeof v!="boolean"&&v.effect===0?"copy":"move";let B;if(typeof v!="boolean"&&v.feedback?B=v.feedback:typeof b.index>"u"?B=[-1]:B=[b.index],B=(0,D.$Mb)(B).filter(z=>z>=-1&&z<this.length).sort((z,W)=>z-W),B=B[0]===-1?[-1]:B,o(this.I,B))return!0;if(this.I=B,this.J.dispose(),B[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,T.$Qc)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const z of B){const W=this.d[z];W.dropTarget=!0,W.row?.domNode.classList.add("drop-target")}this.J=(0,T.$Qc)(()=>{for(const z of B){const W=this.d[z];W.dropTarget=!1,W.row?.domNode.classList.remove("drop-target")}})}return!0}kb(b){this.K.dispose(),this.K=(0,h.$Vg)(()=>this.nb(),100,this.L),this.H&&this.F.onDragLeave?.(this.H,b.element,b.index,b.browserEvent)}lb(b){if(!this.G)return;const v=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,!(!v||!b.browserEvent.dataTransfer)&&(b.browserEvent.preventDefault(),v.update(b.browserEvent.dataTransfer),this.F.drop(v,b.element,b.index,b.browserEvent))}mb(b){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(b)}nb(){this.I=void 0,this.J.dispose(),this.J=T.$Sc.None}ob(b){if(!this.w){const v=(0,F.$RO)(this.domNode).top;this.w=(0,F.$HP)(this.pb.bind(this,v))}this.x.dispose(),this.x=(0,h.$Vg)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.L),this.y=b.pageY}pb(b){if(this.y===void 0)return;const v=this.y-b,B=this.renderHeight-35;v<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(v-35))):v>B&&(this.scrollTop+=Math.min(14,Math.floor(.3*(v-B))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(b){const v=this.q.getDomNode();let B=b;for(;B instanceof HTMLElement&&B!==this.o&&v.contains(B);){const z=B.getAttribute("data-index");if(z){const W=Number(z);if(!isNaN(W))return W}B=B.parentElement}}sb(b,v){return{start:this.g.indexAt(b),end:this.g.indexAfter(b+v-1)}}tb(b,v,B){const z=this.sb(b,v);let W,I;b===this.elementTop(z.start)?(W=z.start,I=0):z.end-z.start>1&&(W=z.start+1,I=this.elementTop(W)-b);let N=0;for(;;){const J=this.sb(b,v);let ee=!1;for(let ne=J.start;ne<J.end;ne++){const ue=this.ub(ne);ue!==0&&this.g.splice(ne,1,[this.d[ne]]),N+=ue,ee=ee||ue!==0}if(!ee){N!==0&&this.S();const ne=s.Range.relativeComplement(z,J);for(const le of ne)for(let oe=le.start;oe<le.end;oe++)this.d[oe].row&&this.ab(oe);const ue=s.Range.relativeComplement(J,z);for(const le of ue)for(let oe=le.start;oe<le.end;oe++){const me=oe+1,Ce=me<this.d.length?this.d[me].row:null,Te=Ce?Ce.domNode:null;this.X(oe,Te)}for(let le=J.start;le<J.end;le++)this.d[le].row&&this.Z(this.d[le],le);if(typeof W=="number"){const le=this.p.getFutureScrollPosition().scrollTop-b,oe=this.elementTop(W)-I+le;this.setScrollTop(oe,B)}this.M.fire(this.contentHeight);return}}}ub(b){const v=this.d[b];if(this.Q.getDynamicHeight){const I=this.Q.getDynamicHeight(v.element);if(I!==null){const N=v.size;return v.size=I,v.lastDynamicHeightWidth=this.n,I-N}}if(!v.hasDynamicHeight||v.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(v.element))return 0;const B=v.size;if(v.row)return v.row.domNode.style.height="",v.size=v.row.domNode.offsetHeight,v.lastDynamicHeightWidth=this.n,v.size-B;const{row:z}=this.h.alloc(v.templateId);z.domNode.style.height="",this.o.appendChild(z.domNode);const W=this.j.get(v.templateId);if(!W)throw new l.$cb("Missing renderer for templateId: "+v.templateId);return W.renderElement(v.element,b,z.templateData,void 0),v.size=z.domNode.offsetHeight,W.disposeElement?.(v.element,b,z.templateData,void 0),this.Q.setDynamicHeight?.(v.element,v.size),v.lastDynamicHeightWidth=this.n,this.o.removeChild(z.domNode),this.h.release(z),v.size-B}vb(b){const v=b[b.length-1];if(!v)return null;const B=this.d[v.end];return!B||!B.row?null:B.row.domNode}getElementDomId(b){return`${this.domId}_${b}`}dispose(){for(const b of this.d)if(b.dragStartDisposable.dispose(),b.checkedDisposable.dispose(),b.row){const v=this.j.get(b.row.templateId);v&&(v.disposeElement?.(b.element,-1,b.row.templateData,void 0),v.disposeTemplate(b.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.L.dispose()}}t.$JQ=j,xe([f.$gh],j.prototype,"onMouseClick",null),xe([f.$gh],j.prototype,"onMouseDblClick",null),xe([f.$gh],j.prototype,"onMouseMiddleClick",null),xe([f.$gh],j.prototype,"onMouseUp",null),xe([f.$gh],j.prototype,"onMouseDown",null),xe([f.$gh],j.prototype,"onMouseOver",null),xe([f.$gh],j.prototype,"onMouseMove",null),xe([f.$gh],j.prototype,"onMouseOut",null),xe([f.$gh],j.prototype,"onContextMenu",null),xe([f.$gh],j.prototype,"onTouchStart",null),xe([f.$gh],j.prototype,"onTap",null)}),define(be[38],$e([1,0,3,21,14,23,55,69,11,9,72,25,4,33,2,45,5,7,68,59,19,95]),function(re,t,y,F,i,U,w,D,h,f,d,T,s,a,e,u,l,m,n,r,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TQ=t.$SQ=t.$RQ=t.$QQ=t.$PQ=t.$OQ=t.$NQ=t.TypeNavigationMode=t.$MQ=t.$LQ=t.$KQ=void 0;class c{constructor(E){this.d=E,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(E){return E}renderElement(E,K,g){const p=this.c.findIndex(V=>V.templateData===g);if(p>=0){const V=this.c[p];this.d.unrender(g),V.index=K}else{const V={index:K,templateData:g};this.c.push(V)}this.d.renderIndex(K,g)}splice(E,K,g){const p=[];for(const V of this.c)V.index<E?p.push(V):V.index>=E+K&&p.push({index:V.index+g-K,templateData:V.templateData});this.c=p}renderIndexes(E){for(const{index:K,templateData:g}of this.c)E.indexOf(K)>-1&&this.d.renderIndex(K,g)}disposeTemplate(E){const K=this.c.findIndex(g=>g.templateData===E);K<0||this.c.splice(K,1)}}class o{get name(){return this.h}get renderer(){return new c(this)}constructor(E){this.h=E,this.c=0,this.d=[],this.f=[],this.g=new s.$Nd,this.onChange=this.g.event}splice(E,K,g){K=Math.max(0,Math.min(K,this.c-E));const p=g.length-K,V=E+K,L=[];let P=0;for(;P<this.f.length&&this.f[P]<E;)L.push(this.f[P++]);for(let q=0;q<g.length;q++)g[q]&&L.push(q+E);for(;P<this.f.length&&this.f[P]>=V;)L.push(this.f[P++]+p);const O=this.c+p;if(this.f.length>0&&L.length===0&&O>0){const q=this.f.find(C=>C>=E)??O-1;L.push(Math.min(q,O-1))}this.renderer.splice(E,K,g.length),this.k(L,L),this.c=O}renderIndex(E,K){K.classList.toggle(this.h,this.contains(E))}unrender(E){E.classList.remove(this.h)}set(E,K){return this.k(E,[...E].sort(de),K)}k(E,K,g){const p=this.d,V=this.f;this.d=E,this.f=K;const L=Te(V,E);return this.renderer.renderIndexes(L),this.g.fire({indexes:E,browserEvent:g}),p}get(){return this.d}contains(E){return(0,h.$wb)(this.f,E,de)>=0}dispose(){(0,e.$Nc)(this.g)}}xe([T.$gh],o.prototype,"renderer",null);class S extends o{constructor(E){super("selected"),this.l=E}renderIndex(E,K){super.renderIndex(E,K),this.l&&(this.contains(E)?K.setAttribute("aria-selected","true"):K.setAttribute("aria-selected","false"))}}class j{constructor(E,K,g){this.c=E,this.d=K,this.f=g}splice(E,K,g){if(!this.f)return this.c.splice(E,K,new Array(g.length).fill(!1));const p=this.c.get().map(P=>this.f.getId(this.d.element(P)).toString());if(p.length===0)return this.c.splice(E,K,new Array(g.length).fill(!1));const V=new Set(p),L=g.map(P=>V.has(this.f.getId(P).toString()));this.c.splice(E,K,L)}}function M(G){return G.tagName==="INPUT"||G.tagName==="TEXTAREA"}t.$KQ=M;function b(G){return G.classList.contains("monaco-editor")?!0:G.classList.contains("monaco-list")||!G.parentElement?!1:b(G.parentElement)}t.$LQ=b;function v(G){return G.tagName==="A"&&G.classList.contains("monaco-button")||G.tagName==="DIV"&&G.classList.contains("monaco-button-dropdown")?!0:G.classList.contains("monaco-list")||!G.parentElement?!1:v(G.parentElement)}t.$MQ=v;class B{get g(){return s.Event.chain(this.c.add(new F.$tQ(this.k.domNode,"keydown")).event,E=>E.filter(K=>!M(K.target)).map(K=>new i.$zO(K)))}constructor(E,K,g){this.h=E,this.k=K,this.c=new e.$Rc,this.d=new e.$Rc,this.f=g.multipleSelectionSupport,this.c.add(this.g(p=>{switch(p.keyCode){case 3:return this.l(p);case 16:return this.o(p);case 18:return this.p(p);case 11:return this.q(p);case 12:return this.s(p);case 9:return this.u(p);case 31:this.f&&(l.$k?p.metaKey:p.ctrlKey)&&this.t(p)}}))}updateOptions(E){E.multipleSelectionSupport!==void 0&&(this.f=E.multipleSelectionSupport)}l(E){E.preventDefault(),E.stopPropagation(),this.h.setSelection(this.h.getFocus(),E.browserEvent)}o(E){E.preventDefault(),E.stopPropagation(),this.h.focusPrevious(1,!1,E.browserEvent);const K=this.h.getFocus()[0];this.h.setAnchor(K),this.h.reveal(K),this.k.domNode.focus()}p(E){E.preventDefault(),E.stopPropagation(),this.h.focusNext(1,!1,E.browserEvent);const K=this.h.getFocus()[0];this.h.setAnchor(K),this.h.reveal(K),this.k.domNode.focus()}q(E){E.preventDefault(),E.stopPropagation(),this.h.focusPreviousPage(E.browserEvent);const K=this.h.getFocus()[0];this.h.setAnchor(K),this.h.reveal(K),this.k.domNode.focus()}s(E){E.preventDefault(),E.stopPropagation(),this.h.focusNextPage(E.browserEvent);const K=this.h.getFocus()[0];this.h.setAnchor(K),this.h.reveal(K),this.k.domNode.focus()}t(E){E.preventDefault(),E.stopPropagation(),this.h.setSelection((0,h.$Sb)(this.h.length),E.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(E){this.h.getSelection().length&&(E.preventDefault(),E.stopPropagation(),this.h.setSelection([],E.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}xe([T.$gh],B.prototype,"g",null);var z;(function(G){G[G.Automatic=0]="Automatic",G[G.Trigger=1]="Trigger"})(z||(t.TypeNavigationMode=z={}));var W;(function(G){G[G.Idle=0]="Idle",G[G.Typing=1]="Typing"})(W||(W={})),t.$NQ=new class{mightProducePrintableCharacter(G){return G.ctrlKey||G.metaKey||G.altKey?!1:G.keyCode>=31&&G.keyCode<=56||G.keyCode>=21&&G.keyCode<=30||G.keyCode>=98&&G.keyCode<=107||G.keyCode>=85&&G.keyCode<=95}};class I{constructor(E,K,g,p,V){this.o=E,this.p=K,this.q=g,this.s=p,this.t=V,this.c=!1,this.d=W.Idle,this.f=z.Automatic,this.g=!1,this.h=-1,this.k=new e.$Rc,this.l=new e.$Rc,this.updateOptions(E.options)}updateOptions(E){E.typeNavigationEnabled??!0?this.u():this.v(),this.f=E.typeNavigationMode??z.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let E=!1;const K=s.Event.chain(this.k.add(new F.$tQ(this.p.domNode,"keydown")).event,V=>V.filter(L=>!M(L.target)).filter(()=>this.f===z.Automatic||this.g).map(L=>new i.$zO(L)).filter(L=>E||this.s(L)).filter(L=>this.t.mightProducePrintableCharacter(L)).forEach(L=>y.$nP.stop(L,!0)).map(L=>L.browserEvent.key)),g=s.Event.debounce(K,()=>null,800,void 0,void 0,void 0,this.k);s.Event.reduce(s.Event.any(K,g),(V,L)=>L===null?null:(V||"")+L,void 0,this.k)(this.x,this,this.k),g(this.w,this,this.k),K(()=>E=!0,void 0,this.k),g(()=>E=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const E=this.o.getFocus();if(E.length>0&&E[0]===this.h){const K=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(E[0]));K&&(0,w.$vQ)(K)}this.h=-1}x(E){if(!E){this.d=W.Idle,this.g=!1;return}const K=this.o.getFocus(),g=K.length>0?K[0]:0,p=this.d===W.Idle?1:0;this.d=W.Typing;for(let V=0;V<this.o.length;V++){const L=(g+V+p)%this.o.length,P=this.q.getKeyboardNavigationLabel(this.p.element(L)),O=P&&P.toString();if(this.o.options.typeNavigationEnabled){if(typeof O<"u"){if((0,a.$Cj)(E,O)){this.h=g,this.o.setFocus([L]),this.o.reveal(L);return}const q=(0,a.$Jj)(E,O);if(q&&q[0].end-q[0].start>1&&q.length===1){this.h=g,this.o.setFocus([L]),this.o.reveal(L);return}}}else if(typeof O>"u"||(0,a.$Cj)(E,O)){this.h=g,this.o.setFocus([L]),this.o.reveal(L);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class N{constructor(E,K){this.d=E,this.f=K,this.c=new e.$Rc;const g=s.Event.chain(this.c.add(new F.$tQ(K.domNode,"keydown")).event,V=>V.filter(L=>!M(L.target)).map(L=>new i.$zO(L)));s.Event.chain(g,V=>V.filter(L=>L.keyCode===2&&!L.ctrlKey&&!L.metaKey&&!L.shiftKey&&!L.altKey))(this.g,this,this.c)}g(E){if(E.target!==this.f.domNode)return;const K=this.d.getFocus();if(K.length===0)return;const g=this.f.domElement(K[0]);if(!g)return;const p=g.querySelector("[tabIndex]");if(!p||!(p instanceof HTMLElement)||p.tabIndex===-1)return;const V=window.getComputedStyle(p);V.visibility==="hidden"||V.display==="none"||(E.preventDefault(),E.stopPropagation(),p.focus())}dispose(){this.c.dispose()}}function J(G){return l.$k?G.browserEvent.metaKey:G.browserEvent.ctrlKey}t.$OQ=J;function ee(G){return G.browserEvent.shiftKey}t.$PQ=ee;function ne(G){return(0,y.$hP)(G)&&G.button===2}const ue={isSelectionSingleChangeEvent:J,isSelectionRangeChangeEvent:ee};class le{constructor(E){this.k=E,this.f=new e.$Rc,this.g=new s.$Nd,this.onPointer=this.g.event,E.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ue),this.d=typeof E.options.mouseSupport>"u"||!!E.options.mouseSupport,this.d&&(E.onMouseDown(this.s,this,this.f),E.onContextMenu(this.t,this,this.f),E.onMouseDblClick(this.v,this,this.f),E.onTouchStart(this.s,this,this.f),this.f.add(U.$2P.addTarget(E.getHTMLElement()))),s.Event.any(E.onMouseClick,E.onMouseMiddleClick,E.onTap)(this.u,this,this.f)}updateOptions(E){E.multipleSelectionSupport!==void 0&&(this.c=void 0,E.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ue))}o(E){return this.c?this.c.isSelectionSingleChangeEvent(E):!1}p(E){return this.c?this.c.isSelectionRangeChangeEvent(E):!1}q(E){return this.o(E)||this.p(E)}s(E){b(E.browserEvent.target)||(0,y.$$O)()!==E.browserEvent.target&&this.k.domFocus()}t(E){if(M(E.browserEvent.target)||b(E.browserEvent.target))return;const K=typeof E.index>"u"?[]:[E.index];this.k.setFocus(K,E.browserEvent)}u(E){if(!this.d||M(E.browserEvent.target)||b(E.browserEvent.target)||E.browserEvent.isHandledByList)return;E.browserEvent.isHandledByList=!0;const K=E.index;if(typeof K>"u"){this.k.setFocus([],E.browserEvent),this.k.setSelection([],E.browserEvent),this.k.setAnchor(void 0);return}if(this.q(E))return this.w(E);this.k.setFocus([K],E.browserEvent),this.k.setAnchor(K),ne(E.browserEvent)||this.k.setSelection([K],E.browserEvent),this.g.fire(E)}v(E){if(M(E.browserEvent.target)||b(E.browserEvent.target)||this.q(E)||E.browserEvent.isHandledByList)return;E.browserEvent.isHandledByList=!0;const K=this.k.getFocus();this.k.setSelection(K,E.browserEvent)}w(E){const K=E.index;let g=this.k.getAnchor();if(this.p(E)){typeof g>"u"&&(g=this.k.getFocus()[0]??K,this.k.setAnchor(g));const p=Math.min(g,K),V=Math.max(g,K),L=(0,h.$Sb)(p,V+1),P=this.k.getSelection(),O=Ce(Te(P,[g]),g);if(O.length===0)return;const q=Te(L,Pe(P,O));this.k.setSelection(q,E.browserEvent),this.k.setFocus([K],E.browserEvent)}else if(this.o(E)){const p=this.k.getSelection(),V=p.filter(L=>L!==K);this.k.setFocus([K]),this.k.setAnchor(K),p.length===V.length?this.k.setSelection([...V,K],E.browserEvent):this.k.setSelection(V,E.browserEvent)}}dispose(){this.f.dispose()}}t.$QQ=le;class oe{constructor(E,K){this.c=E,this.d=K}style(E){const K=this.d&&`.${this.d}`,g=[];E.listBackground&&g.push(`.monaco-list${K} .monaco-list-rows { background: ${E.listBackground}; }`),E.listFocusBackground&&(g.push(`.monaco-list${K}:focus .monaco-list-row.focused { background-color: ${E.listFocusBackground}; }`),g.push(`.monaco-list${K}:focus .monaco-list-row.focused:hover { background-color: ${E.listFocusBackground}; }`)),E.listFocusForeground&&g.push(`.monaco-list${K}:focus .monaco-list-row.focused { color: ${E.listFocusForeground}; }`),E.listActiveSelectionBackground&&(g.push(`.monaco-list${K}:focus .monaco-list-row.selected { background-color: ${E.listActiveSelectionBackground}; }`),g.push(`.monaco-list${K}:focus .monaco-list-row.selected:hover { background-color: ${E.listActiveSelectionBackground}; }`)),E.listActiveSelectionForeground&&g.push(`.monaco-list${K}:focus .monaco-list-row.selected { color: ${E.listActiveSelectionForeground}; }`),E.listActiveSelectionIconForeground&&g.push(`.monaco-list${K}:focus .monaco-list-row.selected .codicon { color: ${E.listActiveSelectionIconForeground}; }`),E.listFocusAndSelectionBackground&&g.push(`
				.monaco-drag-image,
				.monaco-list${K}:focus .monaco-list-row.selected.focused { background-color: ${E.listFocusAndSelectionBackground}; }
			`),E.listFocusAndSelectionForeground&&g.push(`
				.monaco-drag-image,
				.monaco-list${K}:focus .monaco-list-row.selected.focused { color: ${E.listFocusAndSelectionForeground}; }
			`),E.listInactiveFocusForeground&&(g.push(`.monaco-list${K} .monaco-list-row.focused { color:  ${E.listInactiveFocusForeground}; }`),g.push(`.monaco-list${K} .monaco-list-row.focused:hover { color:  ${E.listInactiveFocusForeground}; }`)),E.listInactiveSelectionIconForeground&&g.push(`.monaco-list${K} .monaco-list-row.focused .codicon { color:  ${E.listInactiveSelectionIconForeground}; }`),E.listInactiveFocusBackground&&(g.push(`.monaco-list${K} .monaco-list-row.focused { background-color:  ${E.listInactiveFocusBackground}; }`),g.push(`.monaco-list${K} .monaco-list-row.focused:hover { background-color:  ${E.listInactiveFocusBackground}; }`)),E.listInactiveSelectionBackground&&(g.push(`.monaco-list${K} .monaco-list-row.selected { background-color:  ${E.listInactiveSelectionBackground}; }`),g.push(`.monaco-list${K} .monaco-list-row.selected:hover { background-color:  ${E.listInactiveSelectionBackground}; }`)),E.listInactiveSelectionForeground&&g.push(`.monaco-list${K} .monaco-list-row.selected { color: ${E.listInactiveSelectionForeground}; }`),E.listHoverBackground&&g.push(`.monaco-list${K}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${E.listHoverBackground}; }`),E.listHoverForeground&&g.push(`.monaco-list${K}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${E.listHoverForeground}; }`);const p=(0,y.$KP)(E.listFocusAndSelectionOutline,(0,y.$KP)(E.listSelectionOutline,E.listFocusOutline??""));p&&g.push(`.monaco-list${K}:focus .monaco-list-row.focused.selected { outline: 1px solid ${p}; outline-offset: -1px;}`),E.listFocusOutline&&g.push(`
				.monaco-drag-image,
				.monaco-list${K}:focus .monaco-list-row.focused { outline: 1px solid ${E.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${K}.last-focused .monaco-list-row.focused { outline: 1px solid ${E.listFocusOutline}; outline-offset: -1px; }
			`);const V=(0,y.$KP)(E.listSelectionOutline,E.listInactiveFocusOutline??"");V&&g.push(`.monaco-list${K} .monaco-list-row.focused.selected { outline: 1px dotted ${V}; outline-offset: -1px; }`),E.listSelectionOutline&&g.push(`.monaco-list${K} .monaco-list-row.selected { outline: 1px dotted ${E.listSelectionOutline}; outline-offset: -1px; }`),E.listInactiveFocusOutline&&g.push(`.monaco-list${K} .monaco-list-row.focused { outline: 1px dotted ${E.listInactiveFocusOutline}; outline-offset: -1px; }`),E.listHoverOutline&&g.push(`.monaco-list${K} .monaco-list-row:hover { outline: 1px dashed ${E.listHoverOutline}; outline-offset: -1px; }`),E.listDropBackground&&g.push(`
				.monaco-list${K}.drop-target,
				.monaco-list${K} .monaco-list-rows.drop-target,
				.monaco-list${K} .monaco-list-row.drop-target { background-color: ${E.listDropBackground} !important; color: inherit !important; }
			`),E.tableColumnsBorder&&g.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${E.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),E.tableOddRowsBackgroundColor&&g.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${E.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=g.join(`
`)}}t.$RQ=oe,t.$SQ={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:d.$Us.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:d.$Us.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:d.$Us.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const me={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Ce(G,E){const K=G.indexOf(E);if(K===-1)return[];const g=[];let p=K-1;for(;p>=0&&G[p]===E-(K-p);)g.push(G[p--]);for(g.reverse(),p=K;p<G.length&&G[p]===E+(p-K);)g.push(G[p++]);return g}function Te(G,E){const K=[];let g=0,p=0;for(;g<G.length||p<E.length;)if(g>=G.length)K.push(E[p++]);else if(p>=E.length)K.push(G[g++]);else if(G[g]===E[p]){K.push(G[g]),g++,p++;continue}else G[g]<E[p]?K.push(G[g++]):K.push(E[p++]);return K}function Pe(G,E){const K=[];let g=0,p=0;for(;g<G.length||p<E.length;)if(g>=G.length)K.push(E[p++]);else if(p>=E.length)K.push(G[g++]);else if(G[g]===E[p]){g++,p++;continue}else G[g]<E[p]?K.push(G[g++]):p++;return K}const de=(G,E)=>G-E;class ie{constructor(E,K){this.c=E,this.d=K}get templateId(){return this.c}renderTemplate(E){return this.d.map(K=>K.renderTemplate(E))}renderElement(E,K,g,p){let V=0;for(const L of this.d)L.renderElement(E,K,g[V++],p)}disposeElement(E,K,g,p){let V=0;for(const L of this.d)L.disposeElement?.(E,K,g[V],p),V+=1}disposeTemplate(E){let K=0;for(const g of this.d)g.disposeTemplate(E[K++])}}class fe{constructor(E){this.c=E,this.templateId="a18n"}renderTemplate(E){return E}renderElement(E,K,g){const p=this.c.getAriaLabel(E);p?g.setAttribute("aria-label",p):g.removeAttribute("aria-label");const V=this.c.getAriaLevel&&this.c.getAriaLevel(E);typeof V=="number"?g.setAttribute("aria-level",`${V}`):g.removeAttribute("aria-level")}disposeTemplate(E){}}class Y{constructor(E,K){this.c=E,this.d=K}getDragElements(E){const K=this.c.getSelectedElements();return K.indexOf(E)>-1?K:[E]}getDragURI(E){return this.d.getDragURI(E)}getDragLabel(E,K){if(this.d.getDragLabel)return this.d.getDragLabel(E,K)}onDragStart(E,K){this.d.onDragStart?.(E,K)}onDragOver(E,K,g,p){return this.d.onDragOver(E,K,g,p)}onDragLeave(E,K,g,p){this.d.onDragLeave?.(E,K,g,p)}onDragEnd(E){this.d.onDragEnd?.(E)}drop(E,K,g,p){this.d.drop(E,K,g,p)}dispose(){this.d.dispose()}}class _{get onDidChangeFocus(){return s.Event.map(this.g.wrapEvent(this.c.onChange),E=>this.G(E),this.y)}get onDidChangeSelection(){return s.Event.map(this.g.wrapEvent(this.d.onChange),E=>this.G(E),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let E=!1;const K=s.Event.chain(this.y.add(new F.$tQ(this.k.domNode,"keydown")).event,V=>V.map(L=>new i.$zO(L)).filter(L=>E=L.keyCode===58||L.shiftKey&&L.keyCode===68).map(L=>y.$nP.stop(L,!0)).filter(()=>!1)),g=s.Event.chain(this.y.add(new F.$tQ(this.k.domNode,"keyup")).event,V=>V.forEach(()=>E=!1).map(L=>new i.$zO(L)).filter(L=>L.keyCode===58||L.shiftKey&&L.keyCode===68).map(L=>y.$nP.stop(L,!0)).map(({browserEvent:L})=>{const P=this.getFocus(),O=P.length?P[0]:void 0,q=typeof O<"u"?this.k.element(O):void 0,C=typeof O<"u"?this.k.domElement(O):this.k.domNode;return{index:O,element:q,anchor:C,browserEvent:L}})),p=s.Event.chain(this.k.onContextMenu,V=>V.filter(L=>!E).map(({element:L,index:P,browserEvent:O})=>({element:L,index:P,anchor:new $.$uO(O),browserEvent:O})));return s.Event.any(K,g,p)}get onKeyDown(){return this.y.add(new F.$tQ(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new F.$tQ(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new F.$tQ(this.k.domNode,"keypress")).event}get onDidFocus(){return s.Event.signal(this.y.add(new F.$tQ(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return s.Event.signal(this.y.add(new F.$tQ(this.k.domNode,"blur",!0)).event)}constructor(E,K,g,p,V=me){this.A=E,this.B=V,this.c=new o("focused"),this.f=new o("anchor"),this.g=new s.$Vd,this.x="",this.y=new e.$Rc,this.z=new s.$Nd,this.onDidDispose=this.z.event;const L=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new S(L!=="listbox");const P=[this.c.renderer,this.d.renderer];this.u=V.accessibilityProvider,this.u&&(P.push(new fe(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),p=p.map(q=>new ie(q.templateId,[...P,q]));const O={...V,dnd:V.dnd&&new Y(this,V.dnd)};if(this.k=this.C(K,g,p,O),this.k.domNode.setAttribute("role",L),V.styleController)this.q=V.styleController(this.k.domId);else{const q=(0,y.$dP)(this.k.domNode);this.q=new oe(q,this.k.domId)}if(this.o=new D.$xQ([new j(this.c,this.k,V.identityProvider),new j(this.d,this.k,V.identityProvider),new j(this.f,this.k,V.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new N(this,this.k)),(typeof V.keyboardSupport!="boolean"||V.keyboardSupport)&&(this.v=new B(this,this.k,V),this.y.add(this.v)),V.keyboardNavigationLabelProvider){const q=V.keyboardNavigationDelegate||t.$NQ;this.t=new I(this,this.k,V.keyboardNavigationLabelProvider,V.keyboardNavigationEventFilter??(()=>!0),q),this.y.add(this.t)}this.w=this.D(V),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(E,K,g,p){return new r.$JQ(E,K,g,p)}D(E){return new le(this)}updateOptions(E={}){this.B={...this.B,...E},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(E),this.v?.updateOptions(E),this.k.updateOptions(E)}get options(){return this.B}splice(E,K,g=[]){if(E<0||E>this.k.length)throw new n.$zQ(this.A,`Invalid start index: ${E}`);if(K<0)throw new n.$zQ(this.A,`Invalid delete count: ${K}`);K===0&&g.length===0||this.g.bufferEvents(()=>this.o.splice(E,K,g))}updateWidth(E){this.k.updateWidth(E)}updateElementHeight(E,K){this.k.updateElementHeight(E,K,null)}rerender(){this.k.rerender()}element(E){return this.k.element(E)}indexOf(E){return this.k.indexOf(E)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(E){this.k.setScrollTop(E)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(E){this.k.setScrollLeft(E)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(E){this.x=E,this.k.domNode.setAttribute("aria-label",E)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(E,K){this.k.layout(E,K)}triggerTypeNavigation(){this.t?.trigger()}setSelection(E,K){for(const g of E)if(g<0||g>=this.length)throw new n.$zQ(this.A,`Invalid index ${g}`);this.d.set(E,K)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(E=>this.k.element(E))}setAnchor(E){if(typeof E>"u"){this.f.set([]);return}if(E<0||E>=this.length)throw new n.$zQ(this.A,`Invalid index ${E}`);this.f.set([E])}getAnchor(){return(0,h.$Ob)(this.f.get(),void 0)}getAnchorElement(){const E=this.getAnchor();return typeof E>"u"?void 0:this.element(E)}setFocus(E,K){for(const g of E)if(g<0||g>=this.length)throw new n.$zQ(this.A,`Invalid index ${g}`);this.c.set(E,K)}focusNext(E=1,K=!1,g,p){if(this.length===0)return;const V=this.c.get(),L=this.E(V.length>0?V[0]+E:0,K,p);L>-1&&this.setFocus([L],g)}focusPrevious(E=1,K=!1,g,p){if(this.length===0)return;const V=this.c.get(),L=this.F(V.length>0?V[0]-E:0,K,p);L>-1&&this.setFocus([L],g)}async focusNextPage(E,K){let g=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);g=g===0?0:g-1;const p=this.getFocus()[0];if(p!==g&&(p===void 0||g>p)){const V=this.F(g,!1,K);V>-1&&p!==V?this.setFocus([V],E):this.setFocus([g],E)}else{const V=this.k.getScrollTop();let L=V+this.k.renderHeight;g>p&&(L-=this.k.elementHeight(g)),this.k.setScrollTop(L),this.k.getScrollTop()!==V&&(this.setFocus([]),await(0,f.$Ug)(0),await this.focusNextPage(E,K))}}async focusPreviousPage(E,K){let g;const p=this.k.getScrollTop();p===0?g=this.k.indexAt(p):g=this.k.indexAfter(p-1);const V=this.getFocus()[0];if(V!==g&&(V===void 0||V>=g)){const L=this.E(g,!1,K);L>-1&&V!==L?this.setFocus([L],E):this.setFocus([g],E)}else{const L=p;this.k.setScrollTop(p-this.k.renderHeight),this.k.getScrollTop()!==L&&(this.setFocus([]),await(0,f.$Ug)(0),await this.focusPreviousPage(E,K))}}focusLast(E,K){if(this.length===0)return;const g=this.F(this.length-1,!1,K);g>-1&&this.setFocus([g],E)}focusFirst(E,K){this.focusNth(0,E,K)}focusNth(E,K,g){if(this.length===0)return;const p=this.E(E,!1,g);p>-1&&this.setFocus([p],K)}E(E,K=!1,g){for(let p=0;p<this.length;p++){if(E>=this.length&&!K)return-1;if(E=E%this.length,!g||g(this.element(E)))return E;E++}return-1}F(E,K=!1,g){for(let p=0;p<this.length;p++){if(E<0&&!K)return-1;if(E=(this.length+E%this.length)%this.length,!g||g(this.element(E)))return E;E--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(E=>this.k.element(E))}reveal(E,K){if(E<0||E>=this.length)throw new n.$zQ(this.A,`Invalid index ${E}`);const g=this.k.getScrollTop(),p=this.k.elementTop(E),V=this.k.elementHeight(E);if((0,m.$Cf)(K)){const L=V-this.k.renderHeight;this.k.setScrollTop(L*(0,u.$Ml)(K,0,1)+p)}else{const L=p+V,P=g+this.k.renderHeight;p<g&&L>=P||(p<g||L>=P&&V>=this.k.renderHeight?this.k.setScrollTop(p):L>=P&&this.k.setScrollTop(L-this.k.renderHeight))}}getRelativeTop(E){if(E<0||E>=this.length)throw new n.$zQ(this.A,`Invalid index ${E}`);const K=this.k.getScrollTop(),g=this.k.elementTop(E),p=this.k.elementHeight(E);if(g<K||g+p>K+this.k.renderHeight)return null;const V=p-this.k.renderHeight;return Math.abs((K-g)/V)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(E){return this.k.getElementDomId(E)}style(E){this.q.style(E)}G({indexes:E,browserEvent:K}){return{indexes:E,elements:E.map(g=>this.k.element(g)),browserEvent:K}}H(){const E=this.c.get();this.k.domNode.classList.toggle("element-focused",E.length>0),this.I()}I(){const E=this.c.get();if(E.length>0){let K;this.u?.getActiveDescendantId&&(K=this.u.getActiveDescendantId(this.k.element(E[0]))),this.k.domNode.setAttribute("aria-activedescendant",K||this.k.getElementDomId(E[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const E=this.d.get();this.k.domNode.classList.toggle("selection-none",E.length===0),this.k.domNode.classList.toggle("selection-single",E.length===1),this.k.domNode.classList.toggle("selection-multiple",E.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$TQ=_,xe([T.$gh],_.prototype,"onDidChangeFocus",null),xe([T.$gh],_.prototype,"onDidChangeSelection",null),xe([T.$gh],_.prototype,"onContextMenu",null),xe([T.$gh],_.prototype,"onKeyDown",null),xe([T.$gh],_.prototype,"onKeyUp",null),xe([T.$gh],_.prototype,"onKeyPress",null),xe([T.$gh],_.prototype,"onDidFocus",null),xe([T.$gh],_.prototype,"onDidBlur",null)}),define(be[60],$e([1,0,6,34,36,12,15]),function(re,t,y,F,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9j=t.$8j=t.$7j=t.$6j=t.$5j=t.$4j=t.$3j=t.$2j=t.MarkdownStringTextNewlineStyle=void 0;var D;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(D||(t.MarkdownStringTextNewlineStyle=D={}));class h{constructor(m="",n=!1){if(this.value=m,typeof this.value!="string")throw(0,y.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(m,n=0){return this.value+=s(this.supportThemeIcons?(0,F.$Vj)(m):m).replace(/([ \t]+)/g,(r,$)=>"&nbsp;".repeat($.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,n){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(m,n,r){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(m),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(m,n){const r=new RegExp((0,U.$Fe)(n),"g");return m.replace(r,($,c)=>m.charAt(c-1)!=="\\"?`\\${$}`:$)}}t.$2j=h;function f(l){return d(l)?!l.value:Array.isArray(l)?l.every(f):!0}t.$3j=f;function d(l){return l instanceof h?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}t.$4j=d;function T(l,m){return l===m?!0:!l||!m?!1:l.value===m.value&&l.isTrusted===m.isTrusted&&l.supportThemeIcons===m.supportThemeIcons&&l.supportHtml===m.supportHtml&&(l.baseUri===m.baseUri||!!l.baseUri&&!!m.baseUri&&(0,i.$og)(w.URI.from(l.baseUri),w.URI.from(m.baseUri)))}t.$5j=T;function s(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$6j=s;function a(l){return l.replace(/"/g,"&quot;")}t.$7j=a;function e(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$8j=e;function u(l){const m=[],n=l.split("|").map($=>$.trim());l=n[0];const r=n[1];if(r){const $=/height=(\d+)/.exec(r),c=/width=(\d+)/.exec(r),o=$?$[1]:"",S=c?c[1]:"",j=isFinite(parseInt(S)),M=isFinite(parseInt(o));j&&m.push(`width="${S}"`),M&&m.push(`height="${o}"`)}return{href:l,dimensions:m}}t.$9j=u}),define(be[123],$e([1,0,3,115,21,53,14,19,116,6,4,60,34,75,27,2,77,51,29,49,36,12,15]),function(re,t,y,F,i,U,w,D,h,f,d,T,s,a,e,u,l,m,n,r,$,c,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1Q=t.$ZQ=t.$YQ=t.$XQ=t.$WQ=void 0;const S=Object.freeze({image:(Y,_,G)=>{let E=[],K=[];return Y&&({href:Y,dimensions:E}=(0,T.$9j)(Y),K.push(`src="${(0,T.$7j)(Y)}"`)),G&&K.push(`alt="${(0,T.$7j)(G)}"`),_&&K.push(`title="${(0,T.$7j)(_)}"`),E.length&&(K=K.concat(E)),"<img "+K.join(" ")+">"},paragraph:Y=>`<p>${Y}</p>`,link:(Y,_,G)=>typeof Y!="string"?"":(Y===G&&(G=(0,T.$8j)(G)),_=typeof _=="string"?(0,T.$7j)((0,T.$8j)(_)):"",Y=(0,T.$8j)(Y),Y=Y.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Y}" title="${_||Y}">${G}</a>`)});function j(Y,_={},G={}){const E=new u.$Rc;let K=!1;const g=(0,U.$sQ)(_),p=function(k){let H;try{H=(0,m.$kh)(decodeURIComponent(k))}catch{}return H?(H=(0,r.$6m)(H,Q=>{if(Y.uris&&Y.uris[Q])return o.URI.revive(Y.uris[Q])}),encodeURIComponent(JSON.stringify(H))):k},V=function(k,H){const Q=Y.uris&&Y.uris[k];let te=o.URI.revive(Q);return H?k.startsWith(n.Schemas.data+":")?k:(te||(te=o.URI.parse(k)),n.$cg.uriToBrowserUri(te).toString(!0)):!te||o.URI.parse(k).toString()===te.toString()?k:(te.query&&(te=te.with({query:p(te.query)})),te.toString())},L=new l.marked.Renderer;L.image=S.image,L.link=S.link,L.paragraph=S.paragraph;const P=[],O=[];if(_.codeBlockRendererSync?L.code=(k,H)=>{const Q=a.$jM.nextId(),te=_.codeBlockRendererSync(M(H),k);return O.push([Q,te]),`<div class="code" data-code="${Q}">${(0,c.$Ee)(k)}</div>`}:_.codeBlockRenderer&&(L.code=(k,H)=>{const Q=a.$jM.nextId(),te=_.codeBlockRenderer(M(H),k);return P.push(te.then(se=>[Q,se])),`<div class="code" data-code="${Q}">${(0,c.$Ee)(k)}</div>`}),_.actionHandler){const k=function(te){let se=te.target;if(!(se.tagName!=="A"&&(se=se.parentElement,!se||se.tagName!=="A")))try{let ge=se.dataset.href;ge&&(Y.baseUri&&(ge=b(o.URI.from(Y.baseUri),ge)),_.actionHandler.callback(ge,te))}catch(ge){(0,f.$1)(ge)}finally{te.preventDefault()}},H=_.actionHandler.disposables.add(new i.$tQ(g,"click")),Q=_.actionHandler.disposables.add(new i.$tQ(g,"auxclick"));_.actionHandler.disposables.add(d.Event.any(H.event,Q.event)(te=>{const se=new D.$uO(te);!se.leftButton&&!se.middleButton||k(se)})),_.actionHandler.disposables.add(y.$CO(g,"keydown",te=>{const se=new w.$zO(te);!se.equals(10)&&!se.equals(3)||k(se)}))}Y.supportHtml||(G.sanitizer=k=>(Y.isTrusted?k.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?k:"",G.sanitize=!0,G.silent=!0),G.renderer=L;let q=Y.value??"";q.length>1e5&&(q=`${q.substr(0,1e5)}\u2026`),Y.supportThemeIcons&&(q=(0,s.$Wj)(q));let C;if(_.fillInIncompleteTokens){const k={...l.marked.defaults,...G},H=l.marked.lexer(q,k),Q=ne(H);C=l.marked.parser(Q,k)}else C=l.marked.parse(q,G);Y.supportThemeIcons&&(C=(0,h.$UQ)(C).map(H=>typeof H=="string"?H:H.outerHTML).join(""));const A=new DOMParser().parseFromString(v(Y,C),"text/html");if(A.body.querySelectorAll("img").forEach(k=>{const H=k.getAttribute("src");if(H){let Q=H;try{Y.baseUri&&(Q=b(o.URI.from(Y.baseUri),Q))}catch{}k.src=V(Q,!0)}}),A.body.querySelectorAll("a").forEach(k=>{const H=k.getAttribute("href");if(k.setAttribute("href",""),!H||/^data:|javascript:/i.test(H)||/^command:/i.test(H)&&!Y.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(H))k.replaceWith(...k.childNodes);else{let Q=V(H,!1);Y.baseUri&&(Q=b(o.URI.from(Y.baseUri),H)),k.dataset.href=Q}}),g.innerHTML=v(Y,A.body.innerHTML),P.length>0)Promise.all(P).then(k=>{if(K)return;const H=new Map(k),Q=g.querySelectorAll("div[data-code]");for(const te of Q){const se=H.get(te.dataset.code??"");se&&y.$uP(te,se)}_.asyncRenderCallback?.()});else if(O.length>0){const k=new Map(O),H=g.querySelectorAll("div[data-code]");for(const Q of H){const te=k.get(Q.dataset.code??"");te&&y.$uP(Q,te)}}if(_.asyncRenderCallback)for(const k of g.getElementsByTagName("img")){const H=E.add(y.$CO(k,"load",()=>{H.dispose(),_.asyncRenderCallback()}))}return{element:g,dispose:()=>{K=!0,E.dispose()}}}t.$WQ=j;function M(Y){if(!Y)return"";const _=Y.split(/[\s+|:|,|\{|\?]/,1);return _.length?_[0]:Y}function b(Y,_){return/^\w[\w\d+.-]*:/.test(_)?_:Y.path.endsWith("/")?(0,$.$yg)(Y,_).toString():(0,$.$yg)((0,$.$ug)(Y),_).toString()}function v(Y,_){const{config:G,allowedSchemes:E}=B(Y);F.addHook("uponSanitizeAttribute",(g,p)=>{if(p.attrName==="style"||p.attrName==="class"){if(g.tagName==="SPAN"){if(p.attrName==="style"){p.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(p.attrValue);return}else if(p.attrName==="class"){p.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(p.attrValue);return}}p.keepAttr=!1;return}});const K=y.$OP(E);try{return F.sanitize(_,{...G,RETURN_TRUSTED_TYPE:!0})}finally{F.removeHook("uponSanitizeAttribute"),K.dispose()}}t.$XQ=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function B(Y){const _=[n.Schemas.http,n.Schemas.https,n.Schemas.mailto,n.Schemas.data,n.Schemas.file,n.Schemas.vscodeFileResource,n.Schemas.vscodeRemote,n.Schemas.vscodeRemoteResource];return Y.isTrusted&&_.push(n.Schemas.command),{config:{ALLOWED_TAGS:[...y.$PP],ALLOWED_ATTR:t.$XQ,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:_}}function z(Y){return typeof Y=="string"?Y:W(Y)}t.$YQ=z;function W(Y){let _=Y.value??"";_.length>1e5&&(_=`${_.substr(0,1e5)}\u2026`);const G=l.marked.parse(_,{renderer:N.value}).replace(/&(#\d+|[a-zA-Z]+);/g,E=>I.get(E)??E);return v({isTrusted:!1},G).toString()}t.$ZQ=W;const I=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),N=new e.$V(()=>{const Y=new l.marked.Renderer;return Y.code=_=>_,Y.blockquote=_=>_,Y.html=_=>"",Y.heading=(_,G,E)=>_+`
`,Y.hr=()=>"",Y.list=(_,G)=>_,Y.listitem=_=>_+`
`,Y.paragraph=_=>_+`
`,Y.table=(_,G)=>_+G+`
`,Y.tablerow=_=>_,Y.tablecell=(_,G)=>_+" ",Y.strong=_=>_,Y.em=_=>_,Y.codespan=_=>_,Y.br=()=>`
`,Y.del=_=>_,Y.image=(_,G,E)=>"",Y.text=_=>_,Y.link=(_,G,E)=>E,Y});function J(Y){let _="";return Y.forEach(G=>{_+=G.raw}),_}function ee(Y){for(const _ of Y.tokens)if(_.type==="text"){const G=_.raw.split(`
`),E=G[G.length-1];if(E.includes("`"))return le(Y);if(E.includes("**"))return Pe(Y);if(E.match(/\*\w/))return oe(Y);if(E.match(/(^|\s)__\w/))return de(Y);if(E.match(/(^|\s)_\w/))return me(Y);if(E.match(/(^|\s)\[.*\]\(\w*/))return Ce(Y);if(E.match(/(^|\s)\[\w/))return Te(Y)}}function ne(Y){let _,G;for(_=0;_<Y.length;_++){const E=Y[_];if(E.type==="paragraph"&&E.raw.match(/(\n|^)```/)){G=ue(Y.slice(_));break}if(E.type==="paragraph"&&E.raw.match(/(\n|^)\|/)){G=fe(Y.slice(_));break}if(_===Y.length-1&&E.type==="paragraph"){const K=ee(E);if(K){G=[K];break}}}if(G){const E=[...Y.slice(0,_),...G];return E.links=Y.links,E}return Y}t.$1Q=ne;function ue(Y){const _=J(Y);return l.marked.lexer(_+"\n```")}function le(Y){return ie(Y,"`")}function oe(Y){return ie(Y,"*")}function me(Y){return ie(Y,"_")}function Ce(Y){return ie(Y,")")}function Te(Y){return ie(Y,"](about:blank)")}function Pe(Y){return ie(Y,"**")}function de(Y){return ie(Y,"__")}function ie(Y,_){const G=J(Array.isArray(Y)?Y:[Y]);return l.marked.lexer(G+_)[0]}function fe(Y){const _=J(Y),G=_.split(`
`);let E,K=!1;for(let g=0;g<G.length;g++){const p=G[g].trim();if(typeof E>"u"&&p.match(/^\s*\|/)){const V=p.match(/(\|[^\|]+)(?=\||$)/g);V&&(E=V.length)}else if(typeof E=="number")if(p.match(/^\s*\|/)){if(g!==G.length-1)return;K=!0}else return}if(typeof E=="number"&&E>0){const g=K?G.slice(0,-1).join(`
`):_,p=!!g.match(/\|\s*$/),V=g+(p?"":"|")+`
|${" --- |".repeat(E)}`;return l.marked.lexer(V)}}}),define(be[124],$e([1,0,3,9,28,60,34,2,7,105]),function(re,t,y,F,i,U,w,D,h,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kQ=t.$jQ=void 0;function d(a,e){(0,h.$yf)(e)?a.title=(0,w.$Xj)(e):e?.markdownNotSupportedFallback?a.title=e.markdownNotSupportedFallback:a.removeAttribute("title")}t.$jQ=d;class T{constructor(e,u,l){this.c=e,this.d=u,this.f=l}async update(e,u,l){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let m;if(e===void 0||(0,h.$yf)(e)||e instanceof HTMLElement)m=e;else if(!(0,h.$Mf)(e.markdown))m=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,f.localize)(0,null),u),this.b=new i.$Xd;const n=this.b.token;if(m=await e.markdown(n),m===void 0&&(m=e.markdownNotSupportedFallback),this.isDisposed||n.isCancellationRequested)return}this.g(m,u,l)}g(e,u,l){const m=this.a;if(this.h(e)){const n={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!m,...l};this.a=this.c.showHover(n,u)}m?.dispose()}h(e){return e?(0,U.$4j)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function s(a,e,u,l){let m,n;const r=(j,M)=>{const b=n!==void 0;j&&(n?.dispose(),n=void 0),M&&(m?.dispose(),m=void 0),b&&a.onDidHideHover?.()},$=(j,M,b)=>new F.$4g(async()=>{(!n||n.isDisposed)&&(n=new T(a,b||e,j>0),await n.update(u,M,l))},j),c=()=>{if(m)return;const j=new D.$Rc,M=B=>r(!1,B.fromElement===e);j.add(y.$CO(e,y.$lP.MOUSE_LEAVE,M,!0));const b=()=>r(!0,!0);j.add(y.$CO(e,y.$lP.MOUSE_DOWN,b,!0));const v={targetElements:[e],dispose:()=>{}};if(a.placement===void 0||a.placement==="mouse"){const B=z=>{v.x=z.x+10,z.target instanceof HTMLElement&&z.target.classList.contains("action-label")&&r(!0,!0)};j.add(y.$CO(e,y.$lP.MOUSE_MOVE,B,!0))}j.add($(a.delay,!1,v)),m=j},o=y.$CO(e,y.$lP.MOUSE_OVER,c,!0);return{show:j=>{r(!1,!0),$(0,j)},hide:()=>{r(!0,!0)},update:async(j,M)=>{u=j,await n?.update(u,void 0,M)},dispose:()=>{o.dispose(),r(!0,!0)}}}t.$kQ=s}),define(be[125],$e([1,0,3,21,14,123,38,11,4,43,2,5,107,98]),function(re,t,y,F,i,U,w,D,h,f,d,T,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2Q=void 0;const a=y.$,e="selectOption.entry.template";class u{get templateId(){return e}renderTemplate(n){const r=Object.create(null);return r.root=n,r.text=y.$sP(n,a(".option-text")),r.detail=y.$sP(n,a(".option-detail")),r.decoratorRight=y.$sP(n,a(".option-decorator-right")),r}renderElement(n,r,$){const c=$,o=n.text,S=n.detail,j=n.decoratorRight,M=n.isDisabled;c.text.textContent=o,c.detail.textContent=S||"",c.decoratorRight.innerText=j||"",M?c.root.classList.add("option-disabled"):c.root.classList.remove("option-disabled")}disposeTemplate(n){}}class l extends d.$Sc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(n,r,$,c,o){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=c,this.g=o||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=l.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new h.$Nd,this.B(this.r),this.O(),this.N($),this.n=r||0,n&&this.setOptions(n,r),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(n){this.u=n,this.w=y.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=y.$sP(this.w,a(".select-box-details-pane"));const r=y.$sP(this.w,a(".select-box-dropdown-container-width-control")),$=y.$sP(r,a(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",y.$sP($,this.D),this.G=0,this.y=y.$dP(this.w),this.w.setAttribute("draggable","true"),this.B(y.$CO(this.w,y.$lP.DRAG_START,c=>{y.$nP.stop(c,!0)}))}O(){this.B(y.$DO(this.h,"change",r=>{this.n=r.target.selectedIndex,this.r.fire({index:r.target.selectedIndex,selected:r.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(y.$CO(this.h,y.$lP.CLICK,r=>{y.$nP.stop(r),this.f?this.X(!0):this.W()})),this.B(y.$CO(this.h,y.$lP.MOUSE_DOWN,r=>{y.$nP.stop(r)}));let n;this.B(y.$CO(this.h,"touchstart",r=>{n=this.f})),this.B(y.$CO(this.h,"touchend",r=>{y.$nP.stop(r),n?this.X(!0):this.W()})),this.B(y.$CO(this.h,y.$lP.KEY_DOWN,r=>{const $=new i.$zO(r);let c=!1;T.$k?($.keyCode===18||$.keyCode===16||$.keyCode===10||$.keyCode===3)&&(c=!0):($.keyCode===18&&$.altKey||$.keyCode===16&&$.altKey||$.keyCode===10||$.keyCode===3)&&(c=!0),c&&(this.W(),y.$nP.stop(r,!0))}))}get onDidSelect(){return this.r.event}setOptions(n,r){D.$ub(this.m,n)||(this.m=n,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach(($,c)=>{this.h.add(this.U($.text,c,$.isDisabled)),typeof $.description=="string"&&(this.H=!0)})),r!==void 0&&(this.select(r),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(n){n>=0&&n<this.m.length?this.n=n:n>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(n){this.g.ariaLabel=n,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(n){this.h.tabIndex=n?0:-1}render(n){this.j=n,n.classList.add("select-container"),n.appendChild(this.h),this.R()}Q(){const n=[];this.s.listFocusBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(n.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=n.join(`
`)}R(){const n=this.s.selectBackground??"",r=this.s.selectForeground??"",$=this.s.selectBorder??"";this.h.style.backgroundColor=n,this.h.style.color=r,this.h.style.borderColor=$}S(){const n=this.s.selectBackground??"",r=y.$KP(this.s.selectListBackground,n);this.C.style.backgroundColor=r,this.I.style.backgroundColor=r;const $=this.s.focusBorder??"";this.w.style.outlineColor=$,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(n,r,$){const c=document.createElement("option");return c.value=n,c.text=n,c.disabled=!!$,c}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(n){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),n&&this.h.focus(),this.u.hideContextView())}Y(n,r){return n.appendChild(this.w),this.ab(r),{dispose:()=>{try{n.removeChild(this.w)}catch{}}}}Z(){let n=0;return this.m.forEach((r,$)=>{this.hb($),this.I.offsetHeight>n&&(n=this.I.offsetHeight)}),n}ab(n){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const r=y.$UO(this.h),$=getComputedStyle(this.h),c=parseFloat($.getPropertyValue("--dropdown-padding-top"))+parseFloat($.getPropertyValue("--dropdown-padding-bottom")),o=window.innerHeight-r.top-r.height-(this.g.minBottomMargin||0),S=r.top-l.b,j=this.h.offsetWidth,M=this.bb(this.D),b=Math.max(M,Math.round(j)).toString()+"px";this.w.style.width=b,this.z.getHTMLElement().style.height="",this.z.layout();let v=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const B=this.H?this.L:0,z=v+c+B,W=Math.floor((o-c-B)/this.getHeight()),I=Math.floor((S-c-B)/this.getHeight());if(n)return r.top+r.height>window.innerHeight-22||r.top<l.b||W<1&&I<1?!1:(W<l.c&&I>W&&this.m.length>W?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(r.top+r.height>window.innerHeight-22||r.top<l.b||this.G===0&&W<1||this.G===1&&I<1)return this.X(!0),!1;if(this.G===0){if(this.f&&W+I<1)return this.X(!0),!1;z>o&&(v=W*this.getHeight())}else z>S&&(v=I*this.getHeight());return this.z.layout(v),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=v+c+"px",this.w.style.height=""):this.w.style.height=v+c+"px",this.hb(this.n),this.w.style.width=b,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(n){let r=0;if(n){let $=0,c=0;this.m.forEach((o,S)=>{const j=o.detail?o.detail.length:0,M=o.decoratorRight?o.decoratorRight.length:0,b=o.text.length+j+M;b>c&&($=S,c=b)}),n.textContent=this.m[$].text+(this.m[$].decoratorRight?this.m[$].decoratorRight+" ":""),r=y.$WO(n)}return r}cb(n){if(this.z)return;this.C=y.$sP(n,a(".select-box-dropdown-list-container")),this.t=new u,this.z=new w.$TQ("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:c=>{let o=c.text;return c.detail&&(o+=`. ${c.detail}`),c.decoratorRight&&(o+=`. ${c.decoratorRight}`),c.description&&(o+=`. ${c.description}`),o},getWidgetAriaLabel:()=>(0,s.localize)(0,null),getRole:()=>T.$k?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const r=this.B(new F.$tQ(this.C,"keydown")),$=h.Event.chain(r.event,c=>c.filter(()=>this.z.length>0).map(o=>new i.$zO(o)));this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===3))(this.jb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===2))(this.jb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===9))(this.ib,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===16))(this.lb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===18))(this.kb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===12))(this.nb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===11))(this.mb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===14))(this.ob,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode===13))(this.pb,this)),this.B(h.Event.chain($,c=>c.filter(o=>o.keyCode>=21&&o.keyCode<=56||o.keyCode>=85&&o.keyCode<=113))(this.qb,this)),this.B(y.$CO(this.z.getHTMLElement(),y.$lP.POINTER_UP,c=>this.db(c))),this.B(this.z.onMouseOver(c=>typeof c.index<"u"&&this.z.setFocus([c.index]))),this.B(this.z.onDidChangeFocus(c=>this.gb(c))),this.B(y.$CO(this.w,y.$lP.FOCUS_OUT,c=>{!this.f||y.$3O(c.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(n){if(!this.z.length)return;y.$nP.stop(n);const r=n.target;if(!r||r.classList.contains("slider"))return;const $=r.closest(".monaco-list-row");if(!$)return;const c=Number($.getAttribute("data-index")),o=$.classList.contains("option-disabled");c>=0&&c<this.m.length&&!o&&(this.n=c,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(n,r){const $=o=>{for(let S=0;S<o.childNodes.length;S++){const j=o.childNodes.item(S);(j.tagName&&j.tagName.toLowerCase())==="img"?o.removeChild(j):$(j)}},c=(0,U.$WQ)({value:n,supportThemeIcons:!0},{actionHandler:r});return c.element.classList.add("select-box-description-markdown"),$(c.element),c.element}gb(n){!this.f||!this.H||this.hb(n.indexes[0])}hb(n){this.I.innerText="";const r=this.m[n],$=r?.description??"",c=r?.descriptionIsMarkdown??!1;if($){if(c){const o=r.descriptionMarkdownActionHandler;this.I.appendChild(this.fb($,o))}else this.I.innerText=$;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(n){y.$nP.stop(n),this.select(this.F),this.X(!0)}jb(n){y.$nP.stop(n),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(n){if(this.n<this.m.length-1){y.$nP.stop(n,!0);const r=this.m[this.n+1].isDisabled;if(r&&this.m.length>this.n+2)this.n+=2;else{if(r)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(n){this.n>0&&(y.$nP.stop(n,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(n){y.$nP.stop(n),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(n){y.$nP.stop(n),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(n){y.$nP.stop(n),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(n){y.$nP.stop(n),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(n){const r=f.KeyCodeUtils.toString(n.keyCode);let $=-1;for(let c=0;c<this.m.length-1;c++)if($=(c+this.n+1)%this.m.length,this.m[$].text.charAt(0).toUpperCase()===r&&!this.m[$].isDisabled){this.select($),this.z.setFocus([$]),this.z.reveal(this.z.getFocus()[0]),y.$nP.stop(n);break}}dispose(){this.X(!1),super.dispose()}}t.$2Q=l}),define(be[126],$e([1,0,38,125,119,20,5,97]),function(re,t,y,F,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5Q=t.$4Q=void 0,t.$4Q={...y.$SQ,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class D extends U.$6P{constructor(f,d,T,s,a){super(),w.$k&&!a?.useCustomDrawn?this.a=new i.$3Q(f,d,s,a):this.a=new F.$2Q(f,d,T,s,a),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(f,d){this.a.setOptions(f,d)}select(f){this.a.select(f)}setAriaLabel(f){this.a.setAriaLabel(f)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(f){this.a.setFocusable(f)}render(f){this.a.render(f)}}t.$5Q=D}),define(be[61],$e([1,0,16,52,3,23,124,126,35,2,5,7,102,50]),function(re,t,y,F,i,U,w,D,h,f,d,T,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_Q=t.$$Q=t.$0Q=void 0;class a extends f.$Sc{get action(){return this._action}constructor(m,n,r={}){super(),this.m=r,this._context=m||this,this._action=n,n instanceof h.$ti&&this.B(n.onDidChange($=>{this.element&&this.t($)}))}t(m){m.enabled!==void 0&&this.u(),m.checked!==void 0&&this.G(),m.class!==void 0&&this.F(),m.label!==void 0&&(this.w(),this.C()),m.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new h.$ui)),this.j}set actionRunner(m){this.j=m}isEnabled(){return this._action.enabled}setActionContext(m){this._context=m}render(m){const n=this.element=m;this.B(U.$2P.addTarget(m));const r=this.m&&this.m.draggable;r&&(m.draggable=!0,y.$iO&&this.B((0,i.$CO)(m,i.$lP.DRAG_START,$=>$.dataTransfer?.setData(F.$ZP.TEXT,this._action.label)))),this.B((0,i.$CO)(n,U.EventType.Tap,$=>this.onClick($,!0))),this.B((0,i.$CO)(n,i.$lP.MOUSE_DOWN,$=>{r||i.$nP.stop($,!0),this._action.enabled&&$.button===0&&n.classList.add("active")})),d.$k&&this.B((0,i.$CO)(n,i.$lP.CONTEXT_MENU,$=>{$.button===0&&$.ctrlKey===!0&&this.onClick($)})),this.B((0,i.$CO)(n,i.$lP.CLICK,$=>{i.$nP.stop($,!0),this.m&&this.m.isMenu||this.onClick($)})),this.B((0,i.$CO)(n,i.$lP.DBLCLICK,$=>{i.$nP.stop($,!0)})),[i.$lP.MOUSE_UP,i.$lP.MOUSE_OUT].forEach($=>{this.B((0,i.$CO)(n,$,c=>{i.$nP.stop(c),n.classList.remove("active")}))})}onClick(m,n=!1){i.$nP.stop(m,!0);const r=T.$Hf(this._context)?this.m?.useEventAsContext?m:{preserveFocus:n}:this._context;this.actionRunner.run(this._action,r)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(m){this.element&&(this.element.tabIndex=m?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const m=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(m):(this.f=(0,w.$kQ)(this.m.hoverDelegate,this.element,m),this.q.add(this.f))):this.element.title=m}D(){if(this.element){const m=this.z()??"";this.element.setAttribute("aria-label",m)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$0Q=a;class e extends a{constructor(m,n,r){super(m,n,r),this.m=r,this.m.icon=r.icon!==void 0?r.icon:!1,this.m.label=r.label!==void 0?r.label:!0,this.J=""}render(m){super.render(m),T.$If(this.element);const n=document.createElement("a");if(n.classList.add("action-label"),n.setAttribute("role",this.L()),this.H=n,this.element.appendChild(n),this.m.label&&this.m.keybinding){const r=document.createElement("span");r.classList.add("keybinding"),r.textContent=this.m.keybinding,this.element.appendChild(r)}this.F(),this.w(),this.C(),this.u(),this.G()}L(){return this._action.id===h.$vi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.H&&(this.H.tabIndex=0,this.H.focus())}isFocused(){return!!this.H&&this.H?.tabIndex===0}blur(){this.H&&(this.H.tabIndex=-1)}setFocusable(m){this.H&&(this.H.tabIndex=m?0:-1)}w(){this.m.label&&this.H&&(this.H.textContent=this.action.label)}z(){let m=null;return this.action.tooltip?m=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(m=this.action.label,this.m.keybinding&&(m=s.localize(0,null,m,this.m.keybinding))),m??void 0}F(){this.J&&this.H&&this.H.classList.remove(...this.J.split(" ")),this.m.icon?(this.J=this.action.class,this.H&&(this.H.classList.add("codicon"),this.J&&this.H.classList.add(...this.J.split(" "))),this.u()):this.H?.classList.remove("codicon")}u(){this.action.enabled?(this.H&&(this.H.removeAttribute("aria-disabled"),this.H.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.H&&(this.H.setAttribute("aria-disabled","true"),this.H.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.H){const m=this.z()??"";this.H.setAttribute("aria-label",m)}}G(){this.H&&(this.action.checked!==void 0?(this.H.classList.toggle("checked",this.action.checked),this.H.setAttribute("aria-checked",this.action.checked?"true":"false"),this.H.setAttribute("role","checkbox")):(this.H.classList.remove("checked"),this.H.setAttribute("aria-checked",""),this.H.setAttribute("role",this.L())))}}t.$$Q=e;class u extends a{constructor(m,n,r,$,c,o,S){super(m,n),this.b=new D.$5Q(r,$,c,o,S),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(m,n){this.b.setOptions(m,n)}select(m){this.b.select(m)}g(){this.B(this.b.onDidSelect(m=>this.n(m.selected,m.index)))}n(m,n){this.actionRunner.run(this._action,this.r(m,n))}r(m,n){return m}setFocusable(m){this.b.setFocusable(m)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(m){this.b.render(m)}}t.$_Q=u}),define(be[62],$e([1,0,3,14,61,35,4,2,7,50]),function(re,t,y,F,i,U,w,D,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mQ=t.$lQ=t.ActionsOrientation=void 0;var f;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})(f||(t.ActionsOrientation=f={}));class d extends D.$Sc{constructor(a,e={}){super(),this.g=this.B(new D.$Rc),this.r=this.B(new D.$1c),this.w=!1,this.y=!0,this.C=this.B(new w.$Nd),this.onDidBlur=this.C.event,this.D=this.B(new w.$Nd({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new w.$Nd),this.onDidRun=this.G.event,this.H=this.B(new w.$Nd),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new U.$ui,this.g.add(this.f)),this.g.add(this.f.onDidRun(m=>this.G.fire(m))),this.g.add(this.f.onWillRun(m=>this.H.fire(m))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let u,l;switch(this.m){case 0:u=[15],l=[17];break;case 1:u=[16],l=[18],this.domNode.className+=" vertical";break}this.B(y.$CO(this.domNode,y.$lP.KEY_DOWN,m=>{const n=new F.$zO(m);let r=!0;const $=typeof this.t=="number"?this.viewItems[this.t]:void 0;u&&(n.equals(u[0])||n.equals(u[1]))?r=this.P():l&&(n.equals(l[0])||n.equals(l[1]))?r=this.O():n.equals(9)&&this.F?this.D.fire():n.equals(14)?r=this.M():n.equals(13)?r=this.N():n.equals(2)&&$ instanceof i.$0Q&&$.trapsArrowNavigation?r=this.O():this.J(n)?this.n.keyDown?this.R(n):this.w=!0:r=!1,r&&(n.preventDefault(),n.stopPropagation())})),this.B(y.$CO(this.domNode,y.$lP.KEY_UP,m=>{const n=new F.$zO(m);this.J(n)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(n)),n.preventDefault(),n.stopPropagation()):(n.equals(2)||n.equals(1026))&&this.L()})),this.u=this.B(y.$qP(this.domNode)),this.B(this.u.onDidBlur(()=>{(y.$$O()===this.domNode||!y.$3O(y.$$O(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),a.appendChild(this.domNode)}I(){this.length()>=2?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(a){a?this.z.setAttribute("aria-label",a):this.z.removeAttribute("aria-label")}setFocusable(a){if(this.y=a,this.y){const e=this.viewItems.find(u=>u instanceof i.$0Q&&u.isEnabled());e instanceof i.$0Q&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.$0Q&&e.setFocusable(!1)})}J(a){let e=!1;return this.n.keys.forEach(u=>{e=e||a.equals(u)}),e}L(){for(let a=0;a<this.z.children.length;a++){const e=this.z.children[a];if(y.$3O(y.$$O(),e)){this.t=a;break}}}get context(){return this.j}set context(a){this.j=a,this.viewItems.forEach(e=>e.setActionContext(a))}get actionRunner(){return this.f}set actionRunner(a){this.f=a,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=a)}getContainer(){return this.domNode}hasAction(a){return this.viewItems.findIndex(e=>e.action.id===a.id)!==-1}getAction(a){if(typeof a=="number")return this.viewItems[a]?.action;if(a instanceof HTMLElement){for(;a.parentElement!==this.z;){if(!a.parentElement)return;a=a.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===a)return this.viewItems[e].action}}push(a,e={}){const u=Array.isArray(a)?a:[a];let l=h.$Cf(e.index)?e.index:null;u.forEach(m=>{const n=document.createElement("li");n.className="action-item",n.setAttribute("role","presentation");let r;const $={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(r=this.b.actionViewItemProvider(m,$)),r||(r=new i.$$Q(this.context,m,$)),this.b.allowContextMenu||this.r.set(r,y.$CO(n,y.$lP.CONTEXT_MENU,c=>{y.$nP.stop(c,!0)})),r.actionRunner=this.f,r.setActionContext(this.context),r.render(n),this.y&&r instanceof i.$0Q&&this.viewItems.length===0&&r.setFocusable(!0),l===null||l<0||l>=this.z.children.length?(this.z.appendChild(n),this.viewItems.push(r)):(this.z.insertBefore(n,this.z.children[l]),this.viewItems.splice(l,0,r),l++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientWidth}return 0}getHeight(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientHeight}return 0}pull(a){a>=0&&a<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[a]),this.r.deleteAndDispose(this.viewItems[a]),(0,D.$Nc)(this.viewItems.splice(a,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,D.$Nc)(this.viewItems),this.r.clearAndDisposeAll(),y.$BO(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(a){let e=!1,u;if(a===void 0?e=!0:typeof a=="number"?u=a:typeof a=="boolean"&&(e=a),e&&typeof this.t>"u"){const l=this.viewItems.findIndex(m=>m.isEnabled());this.t=l===-1?void 0:l,this.Q(void 0,void 0,!0)}else u!==void 0&&(this.t=u),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(a){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let u;do{if(!a&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,u=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!u.isEnabled()||u.action.id===U.$vi.ID));return this.Q(),!0}P(a){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let u;do{if(this.t=this.t-1,this.t<0){if(!a&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}u=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!u.isEnabled()||u.action.id===U.$vi.ID));return this.Q(!0),!0}Q(a,e,u=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const l=this.t!==void 0&&this.viewItems[this.t];if(l){let m=!0;h.$Mf(l.focus)||(m=!1),this.b.focusOnlyEnabledItems&&h.$Mf(l.isEnabled)&&!l.isEnabled()&&(m=!1),l.action.id===U.$vi.ID&&(m=!1),m?(u||this.s!==this.t)&&(l.focus(a),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0)}}R(a){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof i.$0Q){const u=e._context===null||e._context===void 0?a:e._context;this.run(e._action,u)}}async run(a,e){await this.f.run(a,e)}dispose(){this.j=void 0,this.viewItems=(0,D.$Nc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$lQ=d;function T(s){if(!s.length)return s;let a=-1;for(let u=0;u<s.length;u++)if(s[u].id!==U.$vi.ID){a=u;break}if(a===-1)return[];s=s.slice(a);for(let u=s.length-1;u>=0&&s[u].id===U.$vi.ID;u--)s.splice(u,1);let e=!1;for(let u=s.length-1;u>=0;u--){const l=s[u].id===U.$vi.ID;l&&!e?s.splice(u,1):l?l&&(e=!1):e=!0}return s}t.$mQ=T}),define(be[63],$e([1,0,3,21,53,62,55,58,20,4,79,49,106,94]),function(re,t,y,F,i,U,w,D,h,f,d,T,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QR=t.$PR=t.$OR=t.MessageType=void 0;const a=y.$;var e;(function(m){m[m.INFO=1]="INFO",m[m.WARNING=2]="WARNING",m[m.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$OR={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class u extends h.$6P{constructor(n,r,$){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new f.$Nd),this.onDidChange=this.O.event,this.P=this.B(new f.$Nd),this.onDidHeightChange=this.P.event,this.a=r,this.g=$,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=y.$sP(n,a(".monaco-inputbox.idle"));const c=this.g.flexibleHeight?"textarea":"input",o=y.$sP(this.element,a(".ibwrapper"));if(this.b=y.$sP(o,a(c+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=y.$sP(o,a("div.mirror")),this.y.innerText="\xA0",this.N=new D.$dQ(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),y.$sP(n,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(M=>this.b.scrollTop=M.scrollTop));const S=this.B(new F.$tQ(document,"selectionchange")),j=f.Event.filter(S.event,()=>document.getSelection()?.anchorNode===o);this.B(j(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new U.$lQ(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(n){this.n=n,this.b.setAttribute("placeholder",n)}setTooltip(n){this.r=n,this.b.title=n}setAriaLabel(n){this.s=n,n?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(n){this.b.value!==n&&(this.b.value=n,this.Y())}get step(){return this.b.step}set step(n){this.b.step=n}get height(){return typeof this.J=="number"?this.J:y.$1O(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(n=null){this.b.select(),n&&(this.b.setSelectionRange(n.start,n.end),n.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(n){n?this.enable():this.disable()}get width(){return y.$WO(this.b)}set width(n){if(this.g.flexibleHeight&&this.g.flexibleWidth){let r=0;if(this.y){const $=parseFloat(this.y.style.paddingLeft||"")||0,c=parseFloat(this.y.style.paddingRight||"")||0;r=$+c}this.b.style.width=n-r+"px"}else this.b.style.width=n+"px";this.y&&(this.y.style.width=n+"px")}set paddingRight(n){this.b.style.width=`calc(100% - ${n}px)`,this.y&&(this.y.style.paddingRight=n+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const n=this.L,r=this.J,$=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:n,height:r}),this.N.setScrollPosition({scrollTop:$})}showMessage(n,r){if(this.w==="open"&&(0,T.$8m)(this.h,n))return;this.h=n,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(n.type));const $=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${y.$KP($.border,"transparent")}`,this.h.content&&(this.hasFocus()||r)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let n=null;return this.t&&(n=this.t(this.value),n?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(n)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),n?.type}stylesForType(n){const r=this.g.inputBoxStyles;switch(n){case 1:return{border:r.inputValidationInfoBorder,background:r.inputValidationInfoBackground,foreground:r.inputValidationInfoForeground};case 2:return{border:r.inputValidationWarningBorder,background:r.inputValidationWarningBackground,foreground:r.inputValidationWarningForeground};default:return{border:r.inputValidationErrorBorder,background:r.inputValidationErrorBackground,foreground:r.inputValidationErrorForeground}}}U(n){switch(n){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let n;const r=()=>n.style.width=y.$WO(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:c=>{if(!this.h)return null;n=y.$sP(c,a(".monaco-inputbox-container")),r();const o={inline:!0,className:"monaco-inputbox-message"},S=this.h.formatContent?(0,i.$rQ)(this.h.content,o):(0,i.$qQ)(this.h.content,o);S.classList.add(this.U(this.h.type));const j=this.stylesForType(this.h.type);return S.style.backgroundColor=j.background??"",S.style.color=j.foreground??"",S.style.border=j.border?`1px solid ${j.border}`:"",y.$sP(n,S),null},onHide:()=>{this.w="closed"},layout:r});let $;this.h.type===3?$=s.localize(0,null,this.h.content):this.h.type===2?$=s.localize(1,null,this.h.content):$=s.localize(2,null,this.h.content),w.$vQ($),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const n=this.value,$=n.charCodeAt(n.length-1)===10?" ":"";(n+$).replace(/\u000c/g,"")?this.y.textContent=n+$:this.y.innerText="\xA0",this.layout()}ab(){const n=this.g.inputBoxStyles,r=n.inputBackground??"",$=n.inputForeground??"",c=n.inputBorder??"";this.element.style.backgroundColor=r,this.element.style.color=$,this.b.style.backgroundColor="inherit",this.b.style.color=$,this.element.style.border=`1px solid ${y.$KP(c,"transparent")}`}layout(){if(!this.y)return;const n=this.L;this.L=y.$1O(this.y),n!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(n){const r=this.inputElement,$=r.selectionStart,c=r.selectionEnd,o=r.value;$!==null&&c!==null&&(this.value=o.substr(0,$)+n+o.substr(c),r.setSelectionRange($+1,$+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$PR=u;class l extends u{constructor(n,r,$){const c=s.localize(3,null),o=` or \u21C5 ${c}`,S=` (\u21C5 ${c})`;super(n,r,$),this.db=this.B(new f.$Nd),this.onDidFocus=this.db.event,this.eb=this.B(new f.$Nd),this.onDidBlur=this.eb.event,this.bb=new d.$MR($.history,100);const j=()=>{if($.showHistoryHint&&$.showHistoryHint()&&!this.n.endsWith(o)&&!this.n.endsWith(S)&&this.bb.getHistory().length){const M=this.n.endsWith(")")?o:S,b=this.n+M;$.showPlaceholderOnFocus&&document.activeElement!==this.b?this.n=b:this.setPlaceHolder(b)}};this.cb=new MutationObserver((M,b)=>{M.forEach(v=>{v.target.textContent||j()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>j()),this.F(this.b,()=>{const M=b=>{if(this.n.endsWith(b)){const v=this.n.slice(0,this.n.length-b.length);return $.showPlaceholderOnFocus?this.n=v:this.setPlaceHolder(v),!0}else return!1};M(S)||M(o)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(n){this.value&&(n||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(n){const r=this.getHistory();this.clearHistory(),n.forEach($=>{this.bb.add($)}),r.forEach($=>{this.bb.add($)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let n=this.jb();n&&(n=n===this.value?this.jb():n),this.value=n??"",w.$wQ(this.value?this.value:s.localize(4,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let n=this.ib();n&&(n=n===this.value?this.ib():n),n&&(this.value=n,w.$wQ(this.value))}clearHistory(){this.bb.clear()}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let n=this.bb.current();return n||(n=this.bb.last(),this.bb.next()),n}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$QR=l}),define(be[64],$e([1,0,61,20,17,18,4,99]),function(re,t,y,F,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9Q=t.$8Q=t.$7Q=t.$6Q=void 0,t.$6Q={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class D extends y.$0Q{constructor(T,s,a){super(T,s,a),this.a=this.B(new h({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:a.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:a.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:a.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(T){this.element=T,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(T){this.a.domNode.tabIndex=T?0:-1}}t.$7Q=D;class h extends F.$6P{constructor(T){super(),this.a=this.B(new w.$Nd),this.onChange=this.a.event,this.b=this.B(new w.$Nd),this.onKeyDown=this.b.event,this.c=T,this.s=this.c.isChecked;const s=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,s.push(...U.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&s.push(...this.c.actionClassName.split(" ")),this.s&&s.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...s),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,a=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),a.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,a=>{if(a.keyCode===10||a.keyCode===3){this.checked=!this.s,this.a.fire(!0),a.preventDefault(),a.stopPropagation();return}this.b.fire(a)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(T){this.s=T,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(T){this.g&&this.domNode.classList.remove(...U.ThemeIcon.asClassNameArray(this.g)),this.g=T,this.g&&this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(T){this.domNode.title=T,this.domNode.setAttribute("aria-label",T)}}t.$8Q=h;class f extends F.$6P{constructor(T,s,a){super(),this.c=T,this.g=s,this.a=new h({title:this.c,isChecked:this.g,icon:i.$Tj.check,actionClassName:"monaco-checkbox",...t.$6Q}),this.domNode=this.a.domNode,this.b=a,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(T){this.a.checked=T,this.h()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.$9Q=f}),define(be[127],$e([1,0,64,17,104]),function(re,t,y,F,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4R=t.$3R=t.$2R=void 0;const U=i.localize(0,null),w=i.localize(1,null),D=i.localize(2,null);class h extends y.$8Q{constructor(s){super({icon:F.$Tj.caseSensitive,title:U+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$2R=h;class f extends y.$8Q{constructor(s){super({icon:F.$Tj.wholeWord,title:w+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$3R=f;class d extends y.$8Q{constructor(s){super({icon:F.$Tj.regex,title:D+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$4R=d}),define(be[128],$e([1,0,3,127,63,20,4,103,2,93]),function(re,t,y,F,i,U,w,D,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5R=void 0;const f=D.localize(0,null);class d extends U.$6P{static{this.OPTION_CHANGE="optionChange"}constructor(s,a,e){super(),this.n=!0,this.s=!1,this.w=this.B(new h.$Tc),this.N=[],this.O=this.B(new w.$Nd),this.onDidOptionChange=this.O.event,this.P=this.B(new w.$Nd),this.onKeyDown=this.P.event,this.Q=this.B(new w.$Nd),this.onMouseDown=this.Q.event,this.R=this.B(new w.$Nd),this.onInput=this.R.event,this.S=this.B(new w.$Nd),this.onKeyUp=this.S.event,this.U=this.B(new w.$Nd),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new w.$Nd),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||f,this.h=!!e.showCommonFindToggles;const u=e.appendCaseSensitiveLabel||"",l=e.appendWholeWordsLabel||"",m=e.appendRegexLabel||"",n=e.history||[],r=!!e.flexibleHeight,$=!!e.flexibleWidth,c=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.$QR(this.domNode,a,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:n,showHistoryHint:e.showHistoryHint,flexibleHeight:r,flexibleWidth:$,flexibleMaxHeight:c,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new F.$4R({appendTitle:m,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(S=>{this.O.fire(S),!S&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(S=>{this.W.fire(S)})),this.L=this.B(new F.$3R({appendTitle:l,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(S=>{this.O.fire(S),!S&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new F.$2R({appendTitle:u,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(S=>{this.O.fire(S),!S&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(S=>{this.U.fire(S)}));const o=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,S=>{if(S.equals(15)||S.equals(17)||S.equals(9)){const j=o.indexOf(document.activeElement);if(j>=0){let M=-1;S.equals(17)?M=(j+1)%o.length:S.equals(15)&&(j===0?M=o.length-1:M=j-1),S.equals(9)?(o[j].blur(),this.inputBox.focus()):M>=0&&o[M].focus(),y.$nP.stop(S,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),s?.appendChild(this.domNode),this.B(y.$CO(this.inputBox.inputElement,"compositionstart",o=>{this.s=!0})),this.B(y.$CO(this.inputBox.inputElement,"compositionend",o=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,o=>this.P.fire(o)),this.C(this.inputBox.inputElement,o=>this.S.fire(o)),this.D(this.inputBox.inputElement,o=>this.R.fire()),this.j(this.inputBox.inputElement,o=>this.Q.fire(o))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(s){this.inputBox.layout(),this.X(s.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const s of this.N)s.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const s of this.N)s.disable()}setFocusInputOnOptionClick(s){this.n=s}setEnabled(s){s?this.enable():this.disable()}setAdditionalToggles(s){for(const a of this.N)a.domNode.remove();this.N=[],this.w.value=new h.$Rc;for(const a of s??[])this.w.value.add(a),this.y.appendChild(a.domNode),this.w.value.add(a.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(a);this.N.length>0&&(this.y.style.display=""),this.X()}X(s=!1){s?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((a,e)=>a+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(s){this.inputBox.value!==s&&(this.inputBox.value=s)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(s){this.M&&(this.M.checked=s)}getWholeWords(){return this.L?.checked??!1}setWholeWords(s){this.L&&(this.L.checked=s)}getRegex(){return this.J?.checked??!1}setRegex(s){this.J&&(this.J.checked=s,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(s){this.inputBox.showMessage(s)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$5R=d}),define(be[129],$e([1,0,3,21,14,62,128,63,59,38,64,56,24,35,11,9,17,18,31,4,33,2,45,7,108,100]),function(re,t,y,F,i,U,w,D,h,f,d,T,s,a,e,u,l,m,n,r,$,c,o,S,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CS=t.TreeFindMatchType=t.TreeFindMode=t.$BS=t.$AS=t.RenderIndentGuides=t.$zS=t.$yS=void 0;class M extends h.$GQ{set context(g){this.c.context=g}get context(){return this.c.context}constructor(g){super(g.elements.map(p=>p.element)),this.c=g}}function b(K){return K instanceof h.$GQ?new M(K):K}class v{constructor(g,p){this.d=g,this.f=p,this.b=c.$Sc.None,this.c=new c.$Rc}getDragURI(g){return this.f.getDragURI(g.element)}getDragLabel(g,p){if(this.f.getDragLabel)return this.f.getDragLabel(g.map(V=>V.element),p)}onDragStart(g,p){this.f.onDragStart?.(b(g),p)}onDragOver(g,p,V,L,P=!0){const O=this.f.onDragOver(b(g),p&&p.element,V,L),q=this.a!==p;if(q&&(this.b.dispose(),this.a=p),typeof p>"u")return O;if(q&&typeof O!="boolean"&&O.autoExpand&&(this.b=(0,u.$Vg)(()=>{const H=this.d(),Q=H.getNodeLocation(p);H.isCollapsed(Q)&&H.setCollapsed(Q,!1),this.a=void 0},500,this.c)),typeof O=="boolean"||!O.accept||typeof O.bubble>"u"||O.feedback){if(!P){const H=typeof O=="boolean"?O:O.accept,Q=typeof O=="boolean"?void 0:O.effect;return{accept:H,effect:Q,feedback:[V]}}return O}if(O.bubble===1){const H=this.d(),Q=H.getNodeLocation(p),te=H.getParentNodeLocation(Q),se=H.getNode(te),ge=te&&H.getListIndex(te);return this.onDragOver(g,se,ge,L,!1)}const C=this.d(),R=C.getNodeLocation(p),A=C.getListIndex(R),k=C.getListRenderCount(R);return{...O,feedback:(0,e.$Sb)(A,A+k)}}drop(g,p,V,L){this.b.dispose(),this.a=void 0,this.f.drop(b(g),p&&p.element,V,L)}onDragEnd(g){this.f.onDragEnd?.(g)}dispose(){this.c.dispose(),this.f.dispose()}}function B(K,g){return g&&{...g,identityProvider:g.identityProvider&&{getId(p){return g.identityProvider.getId(p.element)}},dnd:g.dnd&&new v(K,g.dnd),multipleSelectionController:g.multipleSelectionController&&{isSelectionSingleChangeEvent(p){return g.multipleSelectionController.isSelectionSingleChangeEvent({...p,element:p.element})},isSelectionRangeChangeEvent(p){return g.multipleSelectionController.isSelectionRangeChangeEvent({...p,element:p.element})}},accessibilityProvider:g.accessibilityProvider&&{...g.accessibilityProvider,getSetSize(p){const V=K(),L=V.getNodeLocation(p),P=V.getParentNodeLocation(L);return V.getNode(P).visibleChildrenCount},getPosInSet(p){return p.visibleChildIndex+1},isChecked:g.accessibilityProvider&&g.accessibilityProvider.isChecked?p=>g.accessibilityProvider.isChecked(p.element):void 0,getRole:g.accessibilityProvider&&g.accessibilityProvider.getRole?p=>g.accessibilityProvider.getRole(p.element):()=>"treeitem",getAriaLabel(p){return g.accessibilityProvider.getAriaLabel(p.element)},getWidgetAriaLabel(){return g.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:g.accessibilityProvider&&g.accessibilityProvider.getWidgetRole?()=>g.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:g.accessibilityProvider&&g.accessibilityProvider.getAriaLevel?p=>g.accessibilityProvider.getAriaLevel(p.element):p=>p.depth,getActiveDescendantId:g.accessibilityProvider.getActiveDescendantId&&(p=>g.accessibilityProvider.getActiveDescendantId(p.element))},keyboardNavigationLabelProvider:g.keyboardNavigationLabelProvider&&{...g.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(p){return g.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(p.element)}}}}class z{constructor(g){this.a=g}getHeight(g){return this.a.getHeight(g.element)}getTemplateId(g){return this.a.getTemplateId(g.element)}hasDynamicHeight(g){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(g.element)}setDynamicHeight(g,p){this.a.setDynamicHeight?.(g.element,p)}}t.$yS=z;class W{static lift(g){return g instanceof W?g:new W(g)}static empty(g=0){return new W({focus:[],selection:[],expanded:Object.create(null),scrollTop:g})}constructor(g){if(this.focus=new Set(g.focus),this.selection=new Set(g.selection),g.expanded instanceof Array){this.expanded=Object.create(null);for(const p of g.expanded)this.expanded[p]=1}else this.expanded=g.expanded;this.expanded=g.expanded,this.scrollTop=g.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$zS=W;var I;(function(K){K.None="none",K.OnHover="onHover",K.Always="always"})(I||(t.RenderIndentGuides=I={}));class N{get elements(){return this.b}constructor(g,p=[]){this.b=p,this.a=new c.$Rc,this.onDidChange=r.Event.forEach(g,V=>this.b=V,this.a)}dispose(){this.a.dispose()}}class J{static{this.a=8}constructor(g,p,V,L,P,O={}){this.o=g,this.p=p,this.q=L,this.s=P,this.b=new Map,this.c=new Map,this.d=J.a,this.f=!1,this.g=!1,this.j=new Set,this.k=c.$Sc.None,this.m=new c.$Rc,this.templateId=g.templateId,this.updateOptions(O),r.Event.map(V,q=>q.node)(this.u,this,this.m),g.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(g={}){if(typeof g.indent<"u"){const p=(0,o.$Ml)(g.indent,0,40);if(p!==this.d){this.d=p;for(const[V,L]of this.c)this.v(V,L)}}if(typeof g.renderIndentGuides<"u"){const p=g.renderIndentGuides!==I.None;if(p!==this.g){this.g=p;for(const[V,L]of this.c)this.w(V,L);if(this.k.dispose(),p){const V=new c.$Rc;this.q.onDidChange(this.x,this,V),this.k=V,this.x(this.q.elements)}}}typeof g.hideTwistiesOfChildlessElements<"u"&&(this.f=g.hideTwistiesOfChildlessElements)}renderTemplate(g){const p=(0,y.$sP)(g,(0,y.$)(".monaco-tl-row")),V=(0,y.$sP)(p,(0,y.$)(".monaco-tl-indent")),L=(0,y.$sP)(p,(0,y.$)(".monaco-tl-twistie")),P=(0,y.$sP)(p,(0,y.$)(".monaco-tl-contents")),O=this.o.renderTemplate(P);return{container:g,indent:V,twistie:L,indentGuidesDisposable:c.$Sc.None,templateData:O}}renderElement(g,p,V,L){this.c.set(g,V),this.b.set(g.element,g),this.v(g,V),this.o.renderElement(g,p,V.templateData,L)}disposeElement(g,p,V,L){V.indentGuidesDisposable.dispose(),this.o.disposeElement?.(g,p,V.templateData,L),typeof L=="number"&&(this.c.delete(g),this.b.delete(g.element))}disposeTemplate(g){this.o.disposeTemplate(g.templateData)}t(g){const p=this.b.get(g);p&&this.u(p)}u(g){const p=this.c.get(g);p&&(this.x(this.q.elements),this.v(g,p))}v(g,p){const V=J.a+(g.depth-1)*this.d;p.twistie.style.paddingLeft=`${V}px`,p.indent.style.width=`${V+this.d-16}px`,g.collapsible?p.container.setAttribute("aria-expanded",String(!g.collapsed)):p.container.removeAttribute("aria-expanded"),p.twistie.classList.remove(...m.ThemeIcon.asClassNameArray(l.$Tj.treeItemExpanded));let L=!1;this.o.renderTwistie&&(L=this.o.renderTwistie(g.element,p.twistie)),g.collapsible&&(!this.f||g.visibleChildrenCount>0)?(L||p.twistie.classList.add(...m.ThemeIcon.asClassNameArray(l.$Tj.treeItemExpanded)),p.twistie.classList.add("collapsible"),p.twistie.classList.toggle("collapsed",g.collapsed)):p.twistie.classList.remove("collapsible","collapsed"),this.w(g,p)}w(g,p){if((0,y.$BO)(p.indent),p.indentGuidesDisposable.dispose(),!this.g)return;const V=new c.$Rc,L=this.p();for(;;){const P=L.getNodeLocation(g),O=L.getParentNodeLocation(P);if(!O)break;const q=L.getNode(O),C=(0,y.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(q)&&C.classList.add("active"),p.indent.childElementCount===0?p.indent.appendChild(C):p.indent.insertBefore(C,p.indent.firstElementChild),this.s.add(q,C),V.add((0,c.$Qc)(()=>this.s.delete(q,C))),g=q}p.indentGuidesDisposable=V}x(g){if(!this.g)return;const p=new Set,V=this.p();g.forEach(L=>{const P=V.getNodeLocation(L);try{const O=V.getParentNodeLocation(P);L.collapsible&&L.children.length>0&&!L.collapsed?p.add(L):O&&p.add(V.getNode(O))}catch{}}),this.j.forEach(L=>{p.has(L)||this.s.forEach(L,P=>P.classList.remove("active"))}),p.forEach(L=>{this.j.has(L)||this.s.forEach(L,P=>P.classList.add("active"))}),this.j=p}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,c.$Nc)(this.m)}}class ee{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(g){this.c=g,this.d=g.toLowerCase()}constructor(g,p,V){this.g=g,this.j=p,this.k=V,this.a=0,this.b=0,this.c="",this.d="",this.f=new c.$Rc,g.onWillRefilter(this.m,this,this.f)}filter(g,p){let V=1;if(this.k){const O=this.k.filter(g,p);if(typeof O=="boolean"?V=O?1:0:(0,T.$vS)(O)?V=(0,T.$wS)(O.visibility):V=O,V===0)return!1}if(this.a++,!this.c)return this.b++,{data:$.FuzzyScore.Default,visibility:V};const L=this.j.getKeyboardNavigationLabel(g),P=Array.isArray(L)?L:[L];for(const O of P){const q=O&&O.toString();if(typeof q>"u")return{data:$.FuzzyScore.Default,visibility:V};let C;if(this.g.findMatchType===me.Contiguous){const R=q.toLowerCase().indexOf(this.d);if(R>-1){C=[Number.MAX_SAFE_INTEGER,0];for(let A=this.d.length;A>0;A--)C.push(R+A-1)}}else C=(0,$.$Oj)(this.c,this.d,0,q,q.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(C)return this.b++,P.length===1?{data:C,visibility:V}:{data:{label:q,score:C},visibility:V}}return this.g.findMode===oe.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(g):2:{data:$.FuzzyScore.Default,visibility:V}}m(){this.a=0,this.b=0}dispose(){(0,c.$Nc)(this.f)}}class ne extends d.$8Q{constructor(g){super({icon:l.$Tj.listFilter,title:(0,j.localize)(0,null),isChecked:g.isChecked??!1,inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.$AS=ne;class ue extends d.$8Q{constructor(g){super({icon:l.$Tj.searchFuzzy,title:(0,j.localize)(1,null),isChecked:g.isChecked??!1,inputActiveOptionBorder:g.inputActiveOptionBorder,inputActiveOptionForeground:g.inputActiveOptionForeground,inputActiveOptionBackground:g.inputActiveOptionBackground})}}t.$BS=ue;const le={inputBoxStyles:D.$OR,toggleStyles:d.$6Q,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var oe;(function(K){K[K.Highlight=0]="Highlight",K[K.Filter=1]="Filter"})(oe||(t.TreeFindMode=oe={}));var me;(function(K){K[K.Fuzzy=0]="Fuzzy",K[K.Contiguous=1]="Contiguous"})(me||(t.TreeFindMatchType=me={}));class Ce extends c.$Sc{set mode(g){this.b.checked=g===oe.Filter,this.f.inputBox.setPlaceHolder(g===oe.Filter?(0,j.localize)(2,null):(0,j.localize)(3,null))}set matchType(g){this.c.checked=g===me.Fuzzy}get value(){return this.f.inputBox.value}set value(g){this.f.inputBox.value=g}constructor(g,p,V,L,P,O){super(),this.t=p,this.a=(0,y.h)(".monaco-tree-type-filter",[(0,y.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,y.h)(".monaco-tree-type-filter-input@findInput"),(0,y.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new r.$Nd,this.onDidDisable=this._onDidDisable.event,g.appendChild(this.a.root),this.B((0,c.$Qc)(()=>g.removeChild(this.a.root)));const q=O?.styles??le;q.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=q.listFilterWidgetBackground),q.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${q.listFilterWidgetShadow}`),this.b=this.B(new ne({...q.toggleStyles,isChecked:L===oe.Filter})),this.c=this.B(new ue({...q.toggleStyles,isChecked:P===me.Fuzzy})),this.onDidChangeMode=r.Event.map(this.b.onChange,()=>this.b.checked?oe.Filter:oe.Highlight,this.q),this.onDidChangeMatchType=r.Event.map(this.c.onChange,()=>this.c.checked?me.Fuzzy:me.Contiguous,this.q),this.f=this.B(new w.$5R(this.a.findInput,V,{label:(0,j.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:q.inputBoxStyles,toggleStyles:q.toggleStyles,history:O?.history})),this.g=this.B(new U.$lQ(this.a.actionbar)),this.mode=L;const C=this.B(new F.$tQ(this.f.inputBox.inputElement,"keydown")),R=r.Event.chain(C.event,Q=>Q.map(te=>new i.$zO(te)));this.B(R(Q=>{if(Q.equals(3)){Q.preventDefault(),Q.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Q.equals(18)){Q.preventDefault(),Q.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Q.equals(16)){Q.preventDefault(),Q.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const A=this.B(new a.$ti("close",(0,j.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(A,{icon:!0,label:!1});const k=this.B(new F.$tQ(this.a.grab,"mousedown"));this.B(k.event(Q=>{const te=new c.$Rc,se=te.add(new F.$tQ(window,"mousemove")),ge=te.add(new F.$tQ(window,"mouseup")),we=this.m,Ne=Q.pageX,Ae=this.s,ve=Q.pageY;this.a.grab.classList.add("grabbing");const Ie=this.a.root.style.transition;this.a.root.style.transition="unset";const Oe=qe=>{const ze=qe.pageX-Ne;this.m=we-ze;const Me=qe.pageY-ve;this.s=Ae+Me,this.layout()};te.add(se.event(Oe)),te.add(ge.event(qe=>{Oe(qe),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Ie,te.dispose()}))}));const H=r.Event.chain(this.B(new F.$tQ(this.a.grab,"keydown")).event,Q=>Q.map(te=>new i.$zO(te)));this.B(H(Q=>{let te,se;if(Q.keyCode===15?te=Number.POSITIVE_INFINITY:Q.keyCode===17?te=0:Q.keyCode===10&&(te=this.m===0?Number.POSITIVE_INFINITY:0),Q.keyCode===16?se=0:Q.keyCode===18&&(se=Number.POSITIVE_INFINITY),te!==void 0&&(Q.preventDefault(),Q.stopPropagation(),this.m=te,this.layout()),se!==void 0){Q.preventDefault(),Q.stopPropagation(),this.s=se;const ge=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=ge},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(g=this.j){this.j=g,this.m=(0,o.$Ml)(this.m,0,Math.max(0,g-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,o.$Ml)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(g){this.f.showMessage(g)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,u.$Ug)(300),super.dispose()}}class Te{get pattern(){return this.b}get mode(){return this.d}set mode(g){g!==this.d&&(this.d=g,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(g))}get matchType(){return this.f}set matchType(g){g!==this.f&&(this.f=g,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(g))}constructor(g,p,V,L,P,O={}){this.t=g,this.u=V,this.v=L,this.w=P,this.x=O,this.b="",this.c="",this.j=0,this.k=new r.$Nd,this.onDidChangeMode=this.k.event,this.m=new r.$Nd,this.onDidChangeMatchType=this.m.event,this.o=new r.$Nd,this.onDidChangePattern=this.o.event,this.p=new r.$Nd,this.onDidChangeOpenState=this.p.event,this.q=new c.$Rc,this.s=new c.$Rc,this.d=g.options.defaultFindMode??oe.Highlight,this.f=g.options.defaultFindMatchType??me.Fuzzy,p.onDidSplice(this.z,this,this.s)}updateOptions(g={}){g.defaultFindMode!==void 0&&(this.mode=g.defaultFindMode),g.defaultFindMatchType!==void 0&&(this.matchType=g.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Ce(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(g=>this.mode=g,void 0,this.q),this.g.onDidChangeMatchType(g=>this.matchType=g,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(g){this.b=g,this.o.fire(g),this.v.pattern=g,this.t.refilter(),g&&this.t.focusNext(0,!0,void 0,V=>!$.FuzzyScore.isDefault(V.filterData));const p=this.t.getFocus();if(p.length>0){const V=p[0];this.t.getRelativeTop(V)===null&&this.t.reveal(V,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const g=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&g?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,j.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(g){return!this.g||!this.pattern||this.d===oe.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!$.FuzzyScore.isDefault(g.filterData)}layout(g){this.j=g,this.g?.layout(g)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Pe(K){let g=s.TreeMouseEventTarget.Unknown;return(0,y.$7O)(K.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?g=s.TreeMouseEventTarget.Twistie:(0,y.$7O)(K.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?g=s.TreeMouseEventTarget.Element:(0,y.$7O)(K.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(g=s.TreeMouseEventTarget.Filter),{browserEvent:K.browserEvent,element:K.element?K.element.element:null,target:g}}function de(K){return{element:K.element?K.element.element:null,browserEvent:K.browserEvent,anchor:K.anchor}}function ie(K,g){g(K),K.children.forEach(p=>ie(p,g))}class fe{get f(){return this.d||(this.d=this.m()),this.d}constructor(g,p){this.g=g,this.j=p,this.a=[],this.c=new r.$Nd,this.onDidChange=this.c.event}set(g,p){!p?.__forceEvent&&(0,e.$ub)(this.a,g)||this.k(g,!1,p)}k(g,p,V){if(this.a=[...g],this.b=void 0,this.d=void 0,!p){const L=this;this.c.fire({get elements(){return L.get()},browserEvent:V})}}get(){return this.b||(this.b=this.a.map(g=>g.element)),[...this.b]}getNodes(){return this.a}has(g){return this.f.has(g)}onDidModelSplice({insertedNodes:g,deletedNodes:p}){if(!this.j){const C=this.m(),R=A=>C.delete(A);p.forEach(A=>ie(A,R)),this.set([...C.values()]);return}const V=new Set,L=C=>V.add(this.j.getId(C.element).toString());p.forEach(C=>ie(C,L));const P=new Map,O=C=>P.set(this.j.getId(C.element).toString(),C);g.forEach(C=>ie(C,O));const q=[];for(const C of this.a){const R=this.j.getId(C.element).toString();if(!V.has(R))q.push(C);else{const k=P.get(R);k&&k.visible&&q.push(k)}}if(this.a.length>0&&q.length===0){const C=this.g();C&&q.push(C)}this.k(q,!0)}m(){const g=new Set;for(const p of this.a)g.add(p);return g}}class Y extends f.$QQ{constructor(g,p){super(g),this.x=p}u(g){if((0,f.$MQ)(g.browserEvent.target)||(0,f.$KQ)(g.browserEvent.target)||(0,f.$LQ)(g.browserEvent.target)||g.browserEvent.isHandledByList)return;const p=g.element;if(!p)return super.u(g);if(this.p(g)||this.o(g))return super.u(g);const V=g.browserEvent.target,L=V.classList.contains("monaco-tl-twistie")||V.classList.contains("monaco-icon-label")&&V.classList.contains("folder-icon")&&g.browserEvent.offsetX<16;let P=!1;if(typeof this.x.expandOnlyOnTwistieClick=="function"?P=this.x.expandOnlyOnTwistieClick(p.element):P=!!this.x.expandOnlyOnTwistieClick,P&&!L&&g.browserEvent.detail!==2)return super.u(g);if(!this.x.expandOnDoubleClick&&g.browserEvent.detail===2)return super.u(g);if(p.collapsible){const O=this.x.getNodeLocation(p),q=g.browserEvent.altKey;if(this.x.setFocus([O]),this.x.toggleCollapsed(O,q),P&&L){g.browserEvent.isHandledByList=!0;return}}super.u(g)}v(g){g.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||g.browserEvent.isHandledByList||super.v(g)}}class _ extends f.$TQ{constructor(g,p,V,L,P,O,q,C){super(g,p,V,L,C),this.p=P,this.s=O,this.K=q}D(g){return new Y(this,g.tree)}splice(g,p,V=[]){if(super.splice(g,p,V),V.length===0)return;const L=[],P=[];let O;V.forEach((q,C)=>{this.p.has(q)&&L.push(g+C),this.s.has(q)&&P.push(g+C),this.K.has(q)&&(O=g+C)}),L.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...L])),P.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...P])),typeof O=="number"&&super.setAnchor(O)}setFocus(g,p,V=!1){super.setFocus(g,p),V||this.p.set(g.map(L=>this.element(L)),p)}setSelection(g,p,V=!1){super.setSelection(g,p),V||this.s.set(g.map(L=>this.element(L)),p)}setAnchor(g,p=!1){super.setAnchor(g),p||(typeof g>"u"?this.K.set([]):this.K.set([this.element(g)]))}}class G{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return r.Event.map(this.j.onMouseClick,Pe)}get onMouseDblClick(){return r.Event.filter(r.Event.map(this.j.onMouseDblClick,Pe),g=>g.target!==s.TreeMouseEventTarget.Filter)}get onContextMenu(){return r.Event.map(this.j.onContextMenu,de)}get onTap(){return r.Event.map(this.j.onTap,Pe)}get onPointer(){return r.Event.map(this.j.onPointer,Pe)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return r.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??oe.Highlight}set findMode(g){this.x&&(this.x.mode=g)}get findMatchType(){return this.x?.matchType??me.Fuzzy}set findMatchType(g){this.x&&(this.x.matchType=g)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:r.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(g,p,V,L,P={}){this.D=g,this.E=P,this.w=new r.$Vd,this.onDidChangeFindOpenState=r.Event.None,this.A=new c.$Rc,this.B=new r.$Nd,this.onWillRefilter=this.B.event,this.C=new r.$Nd,this.onDidUpdateOptions=this.C.event;const O=new z(V),q=new r.$Wd,C=new r.$Wd,R=this.A.add(new N(C.event)),A=new n.$Gc;this.k=L.map(se=>new J(se,()=>this.o,q.event,R,A,P));for(const se of this.k)this.A.add(se);let k;P.keyboardNavigationLabelProvider&&(k=new ee(this,P.keyboardNavigationLabelProvider,P.filter),P={...P,filter:k},this.A.add(k)),this.p=new fe(()=>this.j.getFocusedElements()[0],P.identityProvider),this.q=new fe(()=>this.j.getSelectedElements()[0],P.identityProvider),this.u=new fe(()=>this.j.getAnchorElement(),P.identityProvider),this.j=new _(g,p,O,this.k,this.p,this.q,this.u,{...B(()=>this.o,P),tree:this}),this.o=this.I(g,this.j,P),q.input=this.o.onDidChangeCollapseState;const H=r.Event.forEach(this.o.onDidSplice,se=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(se),this.q.onDidModelSplice(se)})},this.A);H(()=>null,null,this.A);const Q=this.A.add(new r.$Nd),te=this.A.add(new u.$Qg(0));if(this.A.add(r.Event.any(H,this.p.onDidChange,this.q.onDidChange)(()=>{te.trigger(()=>{const se=new Set;for(const ge of this.p.getNodes())se.add(ge);for(const ge of this.q.getNodes())se.add(ge);Q.fire([...se.values()])})})),C.input=Q.event,P.keyboardSupport!==!1){const se=r.Event.chain(this.j.onKeyDown,ge=>ge.filter(we=>!(0,f.$KQ)(we.target)).map(we=>new i.$zO(we)));r.Event.chain(se,ge=>ge.filter(we=>we.keyCode===15))(this.F,this,this.A),r.Event.chain(se,ge=>ge.filter(we=>we.keyCode===17))(this.G,this,this.A),r.Event.chain(se,ge=>ge.filter(we=>we.keyCode===10))(this.H,this,this.A)}if((P.findWidgetEnabled??!0)&&P.keyboardNavigationLabelProvider&&P.contextViewProvider){const se=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Te(this,this.o,this.j,k,P.contextViewProvider,se),this.y=ge=>this.x.shouldAllowFocus(ge),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=r.Event.None,this.onDidChangeFindMatchType=r.Event.None;this.z=(0,y.$dP)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===I.Always)}updateOptions(g={}){this.E={...this.E,...g};for(const p of this.k)p.updateOptions(g);this.j.updateOptions(this.E),this.x?.updateOptions(g),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===I.Always)}get options(){return this.E}updateWidth(g){const p=this.o.getListIndex(g);p!==-1&&this.j.updateWidth(p)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(g){this.j.scrollTop=g}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(g){this.j.scrollLeft=g}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const g=this.j.firstVisibleIndex;return g<0||g>=this.j.length?void 0:this.j.element(g).element}get lastVisibleElement(){const g=this.j.lastVisibleIndex;return this.j.element(g).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(g){this.j.ariaLabel=g}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(g,p){this.j.layout(g,p),(0,S.$Cf)(p)&&this.x?.layout(p)}style(g){const p=`.${this.j.domId}`,V=[];g.treeIndentGuidesStroke&&(V.push(`.monaco-list${p}:hover .monaco-tl-indent > .indent-guide, .monaco-list${p}.always .monaco-tl-indent > .indent-guide  { border-color: ${g.treeInactiveIndentGuidesStroke}; }`),V.push(`.monaco-list${p} .monaco-tl-indent > .indent-guide.active { border-color: ${g.treeIndentGuidesStroke}; }`)),this.z.textContent=V.join(`
`),this.j.style(g)}getParentElement(g){const p=this.o.getParentNodeLocation(g);return this.o.getNode(p).element}getFirstElementChild(g){return this.o.getFirstElementChild(g)}getNode(g){return this.o.getNode(g)}getNodeLocation(g){return this.o.getNodeLocation(g)}collapse(g,p=!1){return this.o.setCollapsed(g,!0,p)}expand(g,p=!1){return this.o.setCollapsed(g,!1,p)}toggleCollapsed(g,p=!1){return this.o.setCollapsed(g,void 0,p)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(g){return this.o.isCollapsible(g)}setCollapsible(g,p){return this.o.setCollapsible(g,p)}isCollapsed(g){return this.o.isCollapsed(g)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(g){if(typeof g>"u")return this.j.setAnchor(void 0);const p=this.o.getNode(g);this.u.set([p]);const V=this.o.getListIndex(g);V>-1&&this.j.setAnchor(V,!0)}getAnchor(){return(0,e.$Ob)(this.u.get(),void 0)}setSelection(g,p){const V=g.map(P=>this.o.getNode(P));this.q.set(V,p);const L=g.map(P=>this.o.getListIndex(P)).filter(P=>P>-1);this.j.setSelection(L,p,!0)}getSelection(){return this.q.get()}setFocus(g,p){const V=g.map(P=>this.o.getNode(P));this.p.set(V,p);const L=g.map(P=>this.o.getListIndex(P)).filter(P=>P>-1);this.j.setFocus(L,p,!0)}focusNext(g=1,p=!1,V,L=this.y){this.j.focusNext(g,p,V,L)}focusPrevious(g=1,p=!1,V,L=this.y){this.j.focusPrevious(g,p,V,L)}focusNextPage(g,p=this.y){return this.j.focusNextPage(g,p)}focusPreviousPage(g,p=this.y){return this.j.focusPreviousPage(g,p)}focusLast(g,p=this.y){this.j.focusLast(g,p)}focusFirst(g,p=this.y){this.j.focusFirst(g,p)}getFocus(){return this.p.get()}reveal(g,p){this.o.expandTo(g);const V=this.o.getListIndex(g);V!==-1&&this.j.reveal(V,p)}getRelativeTop(g){const p=this.o.getListIndex(g);return p===-1?null:this.j.getRelativeTop(p)}getViewState(g=this.options.identityProvider){if(!g)throw new s.$tS(this.D,"Can't get tree view state without an identity provider");const p=O=>g.getId(O).toString(),V=W.empty(this.scrollTop);for(const O of this.getFocus())V.focus.add(p(O));for(const O of this.getSelection())V.selection.add(p(O));const L=this.o.getNode(),P=[L];for(;P.length>0;){const O=P.shift();O!==L&&O.collapsible&&(V.expanded[p(O.element)]=O.collapsed?0:1),P.push(...O.children)}return V}F(g){g.preventDefault(),g.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const V=p[0],L=this.o.getNodeLocation(V);if(!this.o.setCollapsed(L,!0)){const O=this.o.getParentNodeLocation(L);if(!O)return;const q=this.o.getListIndex(O);this.j.reveal(q),this.j.setFocus([q])}}G(g){g.preventDefault(),g.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const V=p[0],L=this.o.getNodeLocation(V);if(!this.o.setCollapsed(L,!1)){if(!V.children.some(C=>C.visible))return;const[O]=this.j.getFocus(),q=O+1;this.j.reveal(q),this.j.setFocus([q])}}H(g){g.preventDefault(),g.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const V=p[0],L=this.o.getNodeLocation(V),P=g.browserEvent.altKey;this.o.setCollapsed(L,void 0,P)}navigate(g){return new E(this.j,this.o,g)}dispose(){(0,c.$Nc)(this.A),this.j.dispose()}}t.$CS=G;class E{constructor(g,p,V){this.b=g,this.c=p,V?this.a=this.c.getListIndex(V):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[130],$e([1,0,129,120,24,26]),function(re,t,y,F,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NS=void 0;class w extends y.$CS{constructor(h,f,d,T,s,a={}){super(h,f,d,T,a),this.f=h,this.g=s,this.d=new Map,this.c=a.identityProvider}getInput(){return this.b}setInput(h,f){if(f&&!this.c)throw new i.$tS(this.f,"Can't restore tree view state without an identity provider");if(this.b=h,!h){this.d.clear(),this.o.setChildren(null,U.Iterable.empty());return}if(!f){this.m(h);return}const d=[],T=[],s=e=>{const u=this.c.getId(e).toString();return!f.expanded[u]},a=e=>{const u=this.c.getId(e.element).toString();f.focus.has(u)&&d.push(e.element),f.selection.has(u)&&T.push(e.element)};this.m(h,s,a),this.setFocus(d),this.setSelection(T),f&&typeof f.scrollTop=="number"&&(this.scrollTop=f.scrollTop)}updateChildren(h=this.b){if(typeof this.b>"u")throw new i.$tS(this.f,"Tree input not set");let f;this.c&&(f=d=>{const T=this.c.getId(d).toString(),s=this.d.get(T);if(s)return s.collapsed}),this.m(h,f)}resort(h=this.b,f=!0){this.o.resort(h===this.b?null:h,f)}refresh(h){if(h===void 0){this.j.rerender();return}this.o.rerender(h)}m(h,f,d){let T;if(this.c){const s=new Set,a=d;d=e=>{const u=this.c.getId(e.element).toString();s.add(u),this.d.set(u,e),a?.(e)},T=e=>{const u=this.c.getId(e.element).toString();s.has(u)||this.d.delete(u)}}this.o.setChildren(h===this.b?null:h,this.s(h,f).elements,{onDidCreateNode:d,onDidDeleteNode:T})}s(h,f){const d=[...this.g.getChildren(h)];return{elements:U.Iterable.map(d,s=>{const{elements:a,size:e}=this.s(s,f),u=this.g.hasChildren?this.g.hasChildren(s):void 0,l=e===0?void 0:f&&f(s);return{element:s,children:a,collapsible:u,collapsed:l}}),size:d.length}}I(h,f,d){return new F.$DS(h,f,d)}}t.$NS=w}),define(be[65],$e([1,0,11,9,32,28,25,6,4,2,51,12,7]),function(re,t,y,F,i,U,w,D,h,f,d,T,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xh=t.ProxyChannel=t.$wh=t.$vh=t.$uh=t.$th=t.$sh=t.$rh=t.RequestInitiator=t.$qh=t.$ph=t.$oh=t.$nh=t.$mh=void 0;var a;(function(de){de[de.Promise=100]="Promise",de[de.PromiseCancel=101]="PromiseCancel",de[de.EventListen=102]="EventListen",de[de.EventDispose=103]="EventDispose"})(a||(a={}));function e(de){switch(de){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(de){de[de.Initialize=200]="Initialize",de[de.PromiseSuccess=201]="PromiseSuccess",de[de.PromiseError=202]="PromiseError",de[de.PromiseErrorObj=203]="PromiseErrorObj",de[de.EventFire=204]="EventFire"})(u||(u={}));function l(de){switch(de){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(de){de[de.Uninitialized=0]="Uninitialized",de[de.Idle=1]="Idle"})(m||(m={}));function n(de){let ie=0;for(let fe=0;;fe+=7){const Y=de.read(1);if(ie|=(Y.buffer[0]&127)<<fe,!(Y.buffer[0]&128))return ie}}const r=j(0);function $(de,ie){if(ie===0){de.write(r);return}let fe=0;for(let _=ie;_!==0;_=_>>>7)fe++;const Y=i.$be.alloc(fe);for(let _=0;ie!==0;_++)Y.buffer[_]=ie&127,ie=ie>>>7,ie>0&&(Y.buffer[_]|=128);de.write(Y)}class c{constructor(ie){this.b=ie,this.a=0}read(ie){const fe=this.b.slice(this.a,this.a+ie);return this.a+=fe.byteLength,fe}}t.$mh=c;class o{constructor(){this.a=[]}get buffer(){return i.$be.concat(this.a)}write(ie){this.a.push(ie)}}t.$nh=o;var S;(function(de){de[de.Undefined=0]="Undefined",de[de.String=1]="String",de[de.Buffer=2]="Buffer",de[de.VSBuffer=3]="VSBuffer",de[de.Array=4]="Array",de[de.Object=5]="Object",de[de.Int=6]="Int"})(S||(S={}));function j(de){const ie=i.$be.alloc(1);return ie.writeUInt8(de,0),ie}const M={Undefined:j(S.Undefined),String:j(S.String),Buffer:j(S.Buffer),VSBuffer:j(S.VSBuffer),Array:j(S.Array),Object:j(S.Object),Uint:j(S.Int)},b=typeof Buffer<"u";function v(de,ie){if(typeof ie>"u")de.write(M.Undefined);else if(typeof ie=="string"){const fe=i.$be.fromString(ie);de.write(M.String),$(de,fe.byteLength),de.write(fe)}else if(b&&Buffer.isBuffer(ie)){const fe=i.$be.wrap(ie);de.write(M.Buffer),$(de,fe.byteLength),de.write(fe)}else if(ie instanceof i.$be)de.write(M.VSBuffer),$(de,ie.byteLength),de.write(ie);else if(Array.isArray(ie)){de.write(M.Array),$(de,ie.length);for(const fe of ie)v(de,fe)}else if(typeof ie=="number"&&(ie|0)===ie)de.write(M.Uint),$(de,ie);else{const fe=i.$be.fromString(JSON.stringify(ie));de.write(M.Object),$(de,fe.byteLength),de.write(fe)}}t.$oh=v;function B(de){switch(de.read(1).readUInt8(0)){case S.Undefined:return;case S.String:return de.read(n(de)).toString();case S.Buffer:return de.read(n(de)).buffer;case S.VSBuffer:return de.read(n(de));case S.Array:{const fe=n(de),Y=[];for(let _=0;_<fe;_++)Y.push(B(de));return Y}case S.Object:return JSON.parse(de.read(n(de)).toString());case S.Int:return n(de)}}t.$ph=B;class z{constructor(ie,fe,Y=null,_=1e3){this.h=ie,this.j=fe,this.k=Y,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(ie,fe){this.b.set(ie,fe),setTimeout(()=>this.w(ie),0)}m(ie){switch(ie.type){case 200:{const fe=this.o([ie.type]);this.k?.logOutgoing(fe,0,1,l(ie.type));return}case 201:case 202:case 204:case 203:{const fe=this.o([ie.type,ie.id],ie.data);this.k?.logOutgoing(fe,ie.id,1,l(ie.type),ie.data);return}}}o(ie,fe=void 0){const Y=new o;return v(Y,ie),v(Y,fe),this.p(Y.buffer)}p(ie){try{return this.h.send(ie),ie.byteLength}catch{return 0}}q(ie){const fe=new c(ie),Y=B(fe),_=B(fe),G=Y[0];switch(G){case 100:return this.k?.logIncoming(ie.byteLength,Y[1],1,`${e(G)}: ${Y[2]}.${Y[3]}`,_),this.s({type:G,id:Y[1],channelName:Y[2],name:Y[3],arg:_});case 102:return this.k?.logIncoming(ie.byteLength,Y[1],1,`${e(G)}: ${Y[2]}.${Y[3]}`,_),this.t({type:G,id:Y[1],channelName:Y[2],name:Y[3],arg:_});case 101:return this.k?.logIncoming(ie.byteLength,Y[1],1,`${e(G)}`),this.u({type:G,id:Y[1]});case 103:return this.k?.logIncoming(ie.byteLength,Y[1],1,`${e(G)}`),this.u({type:G,id:Y[1]})}}s(ie){const fe=this.b.get(ie.channelName);if(!fe){this.v(ie);return}const Y=new U.$Xd;let _;try{_=fe.call(this.j,ie.name,ie.arg,Y.token)}catch(K){_=Promise.reject(K)}const G=ie.id;_.then(K=>{this.m({id:G,data:K,type:201})},K=>{K instanceof Error?this.m({id:G,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:G,data:K,type:203})}).finally(()=>{E.dispose(),this.d.delete(ie.id)});const E=(0,f.$Qc)(()=>Y.cancel());this.d.set(ie.id,E)}t(ie){const fe=this.b.get(ie.channelName);if(!fe){this.v(ie);return}const Y=ie.id,G=fe.listen(this.j,ie.name,ie.arg)(E=>this.m({id:Y,data:E,type:204}));this.d.set(ie.id,G)}u(ie){const fe=this.d.get(ie.id);fe&&(fe.dispose(),this.d.delete(ie.id))}v(ie){let fe=this.g.get(ie.channelName);fe||(fe=[],this.g.set(ie.channelName,fe));const Y=setTimeout(()=>{console.error(`Unknown channel: ${ie.channelName}`),ie.type===100&&this.m({id:ie.id,data:{name:"Unknown channel",message:`Channel name '${ie.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);fe.push({request:ie,timeoutTimer:Y})}w(ie){const fe=this.g.get(ie);if(fe){for(const Y of fe)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.s(Y.request);break;case 102:this.t(Y.request);break}this.g.delete(ie)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,f.$Nc)(this.d.values()),this.d.clear()}}t.$qh=z;var W;(function(de){de[de.LocalSide=0]="LocalSide",de[de.OtherSide=1]="OtherSide"})(W||(t.RequestInitiator=W={}));class I{constructor(ie,fe=null){this.l=ie,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=fe}getChannel(ie){const fe=this;return{call(Y,_,G){return fe.a?Promise.reject(new D.$5):fe.m(ie,Y,_,G)},listen(Y,_){return fe.a?h.Event.None:fe.o(ie,Y,_)}}}m(ie,fe,Y,_=U.CancellationToken.None){const G=this.g++,K={id:G,type:100,channelName:ie,name:fe,arg:Y};if(_.isCancellationRequested)return Promise.reject(new D.$5);let g;return new Promise((V,L)=>{if(_.isCancellationRequested)return L(new D.$5);const P=()=>{const R=A=>{switch(A.type){case 201:this.f.delete(G),V(A.data);break;case 202:{this.f.delete(G);const k=new Error(A.data.message);k.stack=Array.isArray(A.data.stack)?A.data.stack.join(`
`):A.data.stack,k.name=A.data.name,L(k);break}case 203:this.f.delete(G),L(A.data);break}};this.f.set(G,R),this.p(K)};let O=null;this.b===m.Idle?P():(O=(0,F.$Hg)(R=>this.u()),O.then(()=>{O=null,P()}));const q=()=>{O?(O.cancel(),O=null):this.p({id:G,type:101}),L(new D.$5)},C=_.onCancellationRequested(q);g=(0,f.$Pc)((0,f.$Qc)(q),C),this.d.add(g)}).finally(()=>{g.dispose(),this.d.delete(g)})}o(ie,fe,Y){const _=this.g++,E={id:_,type:102,channelName:ie,name:fe,arg:Y};let K=null;const g=new h.$Nd({onWillAddFirstListener:()=>{K=(0,F.$Hg)(V=>this.u()),K.then(()=>{K=null,this.d.add(g),this.p(E)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(g),this.p({id:_,type:103}))}}),p=V=>g.fire(V.data);return this.f.set(_,p),g.event}p(ie){switch(ie.type){case 100:case 102:{const fe=this.q([ie.type,ie.id,ie.channelName,ie.name],ie.arg);this.j?.logOutgoing(fe,ie.id,0,`${e(ie.type)}: ${ie.channelName}.${ie.name}`,ie.arg);return}case 101:case 103:{const fe=this.q([ie.type,ie.id]);this.j?.logOutgoing(fe,ie.id,0,e(ie.type));return}}}q(ie,fe=void 0){const Y=new o;return v(Y,ie),v(Y,fe),this.r(Y.buffer)}r(ie){try{return this.l.send(ie),ie.byteLength}catch{return 0}}s(ie){const fe=new c(ie),Y=B(fe),_=B(fe),G=Y[0];switch(G){case 200:return this.j?.logIncoming(ie.byteLength,0,0,l(G)),this.t({type:Y[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ie.byteLength,Y[1],0,l(G),_),this.t({type:Y[0],id:Y[1],data:_})}}t(ie){if(ie.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(ie.id)?.(ie)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,f.$Nc)(this.d.values()),this.d.clear()}}t.$rh=I,xe([w.$gh],I.prototype,"onDidInitializePromise",null);class N{get connections(){const ie=[];return this.f.forEach(fe=>ie.push(fe)),ie}constructor(ie){this.a=new Map,this.f=new Set,this.g=new h.$Nd,this.onDidAddConnection=this.g.event,this.h=new h.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new f.$Rc,this.j.add(ie(({protocol:fe,onDidClientDisconnect:Y})=>{const _=h.Event.once(fe.onMessage);this.j.add(_(G=>{const E=new c(G),K=B(E),g=new z(fe,K),p=new I(fe);this.a.forEach((L,P)=>g.registerChannel(P,L));const V={channelServer:g,channelClient:p,ctx:K};this.f.add(V),this.g.fire(V),this.j.add(Y(()=>{g.dispose(),p.dispose(),this.f.delete(V),this.h.fire(V)}))}))}))}getChannel(ie,fe){const Y=this;return{call(_,G,E){let K;if((0,s.$Mf)(fe)){const p=(0,y.$4b)(Y.connections.filter(fe));K=p?Promise.resolve(p):h.Event.toPromise(h.Event.filter(Y.onDidAddConnection,fe))}else K=fe.routeCall(Y,_,G);const g=K.then(p=>p.channelClient.getChannel(ie));return ee(g).call(_,G,E)},listen(_,G){if((0,s.$Mf)(fe))return Y.k(ie,fe,_,G);const E=fe.routeEvent(Y,_,G).then(K=>K.channelClient.getChannel(ie));return ee(E).listen(_,G)}}}k(ie,fe,Y,_){const G=this;let E;const K=new h.$Nd({onWillAddFirstListener:()=>{E=new f.$Rc;const g=new h.$Td,p=new Map,V=P=>{const q=P.channelClient.getChannel(ie).listen(Y,_),C=g.add(q);p.set(P,C)},L=P=>{const O=p.get(P);O&&(O.dispose(),p.delete(P))};G.connections.filter(fe).forEach(V),h.Event.filter(G.onDidAddConnection,fe)(V,void 0,E),G.onDidRemoveConnection(L,void 0,E),g.event(K.fire,K,E),E.add(g)},onDidRemoveLastListener:()=>{E?.dispose(),E=void 0}});return K.event}registerChannel(ie,fe){this.a.set(ie,fe);for(const Y of this.f)Y.channelServer.registerChannel(ie,fe)}dispose(){this.j.dispose();for(const ie of this.f)ie.channelClient.dispose(),ie.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$sh=N;class J{constructor(ie,fe,Y=null){const _=new o;v(_,fe),ie.send(_.buffer),this.a=new I(ie,Y),this.d=new z(ie,fe,Y)}getChannel(ie){return this.a.getChannel(ie)}registerChannel(ie,fe){this.d.registerChannel(ie,fe)}dispose(){this.a.dispose(),this.d.dispose()}}t.$th=J;function ee(de){return{call(ie,fe,Y){return de.then(_=>_.call(ie,fe,Y))},listen(ie,fe){const Y=new h.$Wd;return de.then(_=>Y.input=_.listen(ie,fe)),Y.event}}}t.$uh=ee;function ne(de){let ie=!1;return{call(fe,Y,_){return ie?de.call(fe,Y,_):(0,F.$Ug)(0).then(()=>ie=!0).then(()=>de.call(fe,Y,_))},listen(fe,Y){if(ie)return de.listen(fe,Y);const _=new h.$Wd;return(0,F.$Ug)(0).then(()=>ie=!0).then(()=>_.input=de.listen(fe,Y)),_.event}}}t.$vh=ne;class ue{constructor(ie){this.a=ie}routeCall(ie){return this.b(ie)}routeEvent(ie){return this.b(ie)}async b(ie){for(const fe of ie.connections)if(await Promise.resolve(this.a(fe.ctx)))return Promise.resolve(fe);return await h.Event.toPromise(ie.onDidAddConnection),await this.b(ie)}}t.$wh=ue;var le;(function(de){function ie(G,E,K){const g=G,p=K&&K.disableMarshalling,V=new Map;for(const L in g)Y(L)&&V.set(L,h.Event.buffer(g[L],!0,void 0,E));return new class{listen(L,P,O){const q=V.get(P);if(q)return q;if(_(P)){const C=g[P];if(typeof C=="function")return C.call(g,O)}throw new D.$bb(`Event not found: ${P}`)}call(L,P,O){const q=g[P];if(typeof q=="function"){if(!p&&Array.isArray(O))for(let R=0;R<O.length;R++)O[R]=(0,d.$lh)(O[R]);let C=q.apply(g,O);return C instanceof Promise||(C=Promise.resolve(C)),C}throw new D.$bb(`Method not found: ${P}`)}}}de.fromService=ie;function fe(G,E){const K=E&&E.disableMarshalling;return new Proxy({},{get(g,p){if(typeof p=="string")return E?.properties?.has(p)?E.properties.get(p):_(p)?function(V){return G.listen(p,V)}:Y(p)?G.listen(p):async function(...V){let L;E&&!(0,s.$Hf)(E.context)?L=[E.context,...V]:L=V;const P=await G.call(p,L);return K?P:(0,d.$lh)(P)};throw new D.$bb(`Property not found: ${String(p)}`)}})}de.toService=fe;function Y(G){return G[0]==="o"&&G[1]==="n"&&T.$1e(G.charCodeAt(2))}function _(G){return/^onDynamic/.test(G)&&T.$1e(G.charCodeAt(9))}})(le||(t.ProxyChannel=le={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function me(de){if(Array.isArray(de))return de;if(de&&typeof de=="object"&&typeof de.toString=="function"){const ie=de.toString();if(ie!=="[object Object]")return ie}return de}function Ce(de){return Array.isArray(de)?de.map(me):me(de)}function Te(de,ie,fe,Y,_,G,E){E=Ce(E);const K=oe[_],g=K[Y%K.length];let p=[`%c[${de}]%c[${String(ie).padStart(7," ")}]%c[len: ${String(fe).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${g}`];/\($/.test(G)?(p=p.concat(E),p.push(")")):p.push(E),console.log.apply(console,p)}class Pe{constructor(ie,fe){this.d=ie,this.f=fe,this.a=0,this.b=0}logOutgoing(ie,fe,Y,_,G){this.b+=ie,Te(this.d,this.b,ie,fe,Y,_,G)}logIncoming(ie,fe,Y,_,G){this.a+=ie,Te(this.f,this.a,ie,fe,Y,_,G)}}t.$xh=Pe}),define(be[30],$e([1,0,5]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=t.$N=void 0,t.$N=y.$h.vscode.ipcRenderer,t.$O=y.$h.vscode.ipcMessagePort,t.$P=y.$h.vscode.webFrame,t.$Q=y.$h.vscode.process,t.$R=y.$h.vscode.context;function F(i){if(i===window)return{ipcRenderer:t.$N,webFrame:t.$P};const U=i;if(U?.vscode?.ipcRenderer&&U?.vscode?.webFrame)return U.vscode}t.$S=F}),define(be[131],$e([1,0,87,30]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hT=void 0;let i=0;function U(D,h,f){const d=[],T=i++,s=`vscode:onContextMenu${T}`,a=(e,u,l)=>{d[u].click?.(l)};F.$N.once(s,a),F.$N.once(y.$eT,(e,u)=>{u===T&&(F.$N.removeListener(s,a),f?.())}),F.$N.send(y.$dT,T,D.map(e=>w(e,d)),s,h)}t.$hT=U;function w(D,h){const f={id:h.length,label:D.label,type:D.type,accelerator:D.accelerator,checked:D.checked,enabled:typeof D.enabled=="boolean"?D.enabled:!0,visible:typeof D.visible=="boolean"?D.visible:!0};return h.push(D),Array.isArray(D.submenu)&&(f.submenu=D.submenu.map(d=>w(d,h))),f}}),define(be[132],$e([1,0,32,4,65,88,30]),function(re,t,y,F,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pT=void 0;class D extends i.$th{static f(){const f=F.Event.fromNodeEventEmitter(w.$N,"vscode:message",(d,T)=>y.$be.wrap(T));return w.$N.send("vscode:hello"),new U.$lT(w.$N,f)}constructor(f){const d=D.f();super(d,f),this.b=d}dispose(){this.b.disconnect()}}t.$pT=D}),define(be[133],$e([13,10]),function(re,t){return re.create("vs/platform/files/common/files",t)}),define(be[134],$e([13,10]),function(re,t){return re.create("vs/platform/theme/common/iconRegistry",t)}),define(be[39],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ph=t.$Oh=t.$Nh=t._util=void 0;var y;(function(w){w.serviceIds=new Map,w.DI_TARGET="$di$target",w.DI_DEPENDENCIES="$di$dependencies";function D(h){return h[w.DI_DEPENDENCIES]||[]}w.getServiceDependencies=D})(y||(t._util=y={})),t.$Nh=i("instantiationService");function F(w,D,h){D[y.DI_TARGET]===D?D[y.DI_DEPENDENCIES].push({id:w,index:h}):(D[y.DI_DEPENDENCIES]=[{id:w,index:h}],D[y.DI_TARGET]=D)}function i(w){if(y.serviceIds.has(w))return y.serviceIds.get(w);const D=function(h,f,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(D,h,d)};return D.toString=()=>w,y.serviceIds.set(w,D),D}t.$Oh=i;function U(w){return w}t.$Ph=U}),define(be[135],$e([1,0,39]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qm=t.$pm=t.$om=t.ID=void 0,t.ID="diagnosticsService",t.$om=(0,y.$Oh)(t.ID);function F(U){return!!U.hostName&&!!U.errorMessage}t.$pm=F;class i{async getPerformanceInfo(w,D){return{}}async getSystemInfo(w,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(w,D){return""}async getWorkspaceFileExtensions(w){return{extensions:[]}}async reportWorkspaceStats(w){}}t.$qm=i}),define(be[136],$e([1,0,86,22,12,7,15,133,39,5,29,27]),function(re,t,y,F,i,U,w,D,h,f,d,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gk=t.$Fk=t.$Ek=t.$Dk=t.$Ck=t.FileKind=t.$Bk=t.$Ak=t.$zk=t.$yk=t.$xk=t.$wk=t.$vk=t.FileOperationResult=t.$uk=t.$tk=t.$sk=t.$rk=t.$qk=t.FileChangeType=t.$pk=t.FileOperation=t.$ok=t.$nk=t.$mk=t.$lk=t.$kk=t.$jk=t.FileSystemProviderErrorCode=t.$ik=t.$hk=t.$gk=t.$fk=t.$ek=t.$dk=t.$ck=t.$bk=t.$ak=t.FileSystemProviderCapabilities=t.$_j=t.FilePermission=t.FileType=t.$$j=t.$0j=void 0,t.$0j=(0,h.$Oh)("fileService");function s(_){return _.create===!0}t.$$j=s;var a;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(a||(t.FileType=a={}));var e;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function u(_){const G=_;return!!G&&typeof G.onDidChange=="function"}t.$_j=u;var l;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(l||(t.FileSystemProviderCapabilities=l={}));function m(_){return!!(_.capabilities&2)}t.$ak=m;function n(_){return!!(_.capabilities&8)}t.$bk=n;function r(_){return!!(_.capabilities&131072)}t.$ck=r;function $(_){return!!(_.capabilities&4)}t.$dk=$;function c(_){return!!(_.capabilities&16)}t.$ek=c;function o(_){return m(_)?!!(_.capabilities&16384):!1}t.$fk=o;function S(_){return m(_)?!!(_.capabilities&32768):!1}t.$gk=S;function j(_){return!!(_.capabilities&65536)}t.$hk=j;function M(_){return!!(_.capabilities&2048)}t.$ik=M;var b;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(b||(t.FileSystemProviderErrorCode=b={}));class v extends Error{static create(G,E){const K=new v(G.toString(),E);return W(K,E),K}constructor(G,E){super(G),this.code=E}}t.$jk=v;function B(_,G){return v.create(_,G)}t.$kk=B;function z(_){return _||B((0,D.localize)(0,null),b.Unknown)}t.$lk=z;function W(_,G){return _.name=G?`${G} (FileSystemError)`:"FileSystemError",_}t.$mk=W;function I(_){if(!_)return b.Unknown;if(_ instanceof v)return _.code;const G=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!G)return b.Unknown;switch(G[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}t.$nk=I;function N(_){if(_ instanceof oe)return _.fileOperationResult;switch(I(_)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 9;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileTooLarge:return 7;default:return 10}}t.$ok=N;var J;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(J||(t.FileOperation=J={}));class ee{constructor(G,E,K){this.resource=G,this.operation=E,this.target=K}isOperation(G){return this.operation===G}}t.$pk=ee;var ne;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(ne||(t.FileChangeType=ne={}));class ue{static{this.a=null}constructor(G,E){this.c=E,this.b=void 0,this.d=new T.$V(()=>{const K=y.$Uh.forUris(()=>this.c);return K.fill(this.rawAdded.map(g=>[g,!0])),K}),this.f=new T.$V(()=>{const K=y.$Uh.forUris(()=>this.c);return K.fill(this.rawUpdated.map(g=>[g,!0])),K}),this.g=new T.$V(()=>{const K=y.$Uh.forUris(()=>this.c);return K.fill(this.rawDeleted.map(g=>[g,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of G){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==ue.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=ue.a):this.b!==void 0&&(this.b=ue.a))}}contains(G,...E){return this.h(G,{includeChildren:!1},...E)}affects(G,...E){return this.h(G,{includeChildren:!0},...E)}h(G,E,...K){if(!G)return!1;const g=K.length>0;return!!((!g||K.includes(1))&&(this.d.value.get(G)||E.includeChildren&&this.d.value.findSuperstr(G))||(!g||K.includes(0))&&(this.f.value.get(G)||E.includeChildren&&this.f.value.findSuperstr(G))||(!g||K.includes(2))&&(this.g.value.findSubstr(G)||E.includeChildren&&this.g.value.findSuperstr(G)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(G){return this.b===G}hasCorrelation(){return typeof this.b=="number"}}t.$qk=ue;function le(_,G,E){return!_||!G||_===G||G.length>_.length?!1:(G.charAt(G.length-1)!==F.sep&&(G+=F.sep),E?(0,i.$3e)(_,G):_.indexOf(G)===0)}t.$rk=le;class oe extends Error{constructor(G,E,K){super(G),this.fileOperationResult=E,this.options=K}}t.$sk=oe;class me extends oe{constructor(G,E,K,g){super(G,E,g),this.fileOperationResult=E,this.size=K}}t.$tk=me;class Ce extends oe{constructor(G,E,K){super(G,2,K),this.stat=E}}t.$uk=Ce;var Te;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Te||(t.FileOperationResult=Te={})),t.$vk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$wk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$xk="files.associations",t.$yk="files.exclude",t.$zk="files.readonlyInclude",t.$Ak="files.readonlyExclude",t.$Bk="files.readonlyFromPermissions";var Pe;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(Pe||(t.FileKind=Pe={})),t.$Ck="";function de(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}t.$Dk=de;async function ie(_,G){if(!G.hasProvider(w.URI.from({scheme:_.scheme})))return new Promise(E=>{const K=G.onDidChangeFileSystemProviderRegistrations(g=>{g.scheme===_.scheme&&g.added&&(K.dispose(),E())})})}t.$Ek=ie;class fe{static{this.KB=1024}static{this.MB=fe.KB*fe.KB}static{this.GB=fe.MB*fe.KB}static{this.TB=fe.GB*fe.KB}static formatSize(G){return(0,U.$Cf)(G)||(G=0),G<fe.KB?(0,D.localize)(1,null,G.toFixed(0)):G<fe.MB?(0,D.localize)(2,null,(G/fe.KB).toFixed(2)):G<fe.GB?(0,D.localize)(3,null,(G/fe.MB).toFixed(2)):G<fe.TB?(0,D.localize)(4,null,(G/fe.GB).toFixed(2)):(0,D.localize)(5,null,(G/fe.TB).toFixed(2))}}t.$Fk=fe;function Y(_){const G=typeof _=="string"||_?.scheme===d.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===d.Schemas.file?1024*fe.MB:G?10*fe.MB:f.$p?50*fe.MB:1024*fe.MB}t.$Gk=Y}),define(be[137],$e([1,0,39]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_7b=t.$$7b=void 0,t.$$7b=(0,y.$Oh)("mainProcessService");class F{constructor(U,w){this.a=U,this.b=w}getChannel(U){return this.a.getChannel(U,this.b)}registerChannel(U,w){this.a.registerChannel(U,w)}}t.$_7b=F}),define(be[138],$e([1,0,2,132]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$a8b=void 0;class i extends y.$Sc{constructor(w){super(),this.a=this.B(new F.$pT(`window:${w}`))}getChannel(w){return this.a.getChannel(w)}registerChannel(w,D){this.a.registerChannel(w,D)}}t.$a8b=i});var wi=this&&this.__param||function(re,t){return function(y,F){t(y,F,re)}};define(be[139],$e([1,0,65,137]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$b8b=void 0;let i=class{constructor(w,D){return this.windowId=w,y.ProxyChannel.toService(D.getChannel("nativeHost"),{context:w,properties:(()=>{const h=new Map;return h.set("windowId",w),h})()})}};t.$b8b=i,t.$b8b=i=xe([wi(1,F.$$7b)],i)}),define(be[66],$e([1,0,74,7]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dn=void 0;class i{constructor(){this.a=new Map}add(w,D){y.ok(F.$yf(w)),y.ok(F.$Af(D)),y.ok(!this.a.has(w),"There is already an extension with this id"),this.a.set(w,D)}knows(w){return this.a.has(w)}as(w){return this.a.get(w)||null}}t.$dn=new i}),define(be[140],$e([1,0,4,66]),function(re,t,y,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$en=void 0,t.$en={JSONContribution:"base.contributions.json"};function i(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class U{constructor(){this.b=new y.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,f){this.a[i(h)]=f,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const w=new U;F.$dn.add(t.$en.JSONContribution,w)}),define(be[141],$e([1,0,9,17,18,4,7,15,134,140,66]),function(re,t,y,F,i,U,w,D,h,f,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9v=t.$8v=t.$7v=t.$6v=t.$5v=t.$4v=t.$3v=t.$2v=t.IconFontDefinition=t.IconContribution=t.$1v=void 0,t.$1v={IconContribution:"base.contributions.icons"};var T;(function($){function c(o,S){let j=o.defaults;for(;i.ThemeIcon.isThemeIcon(j);){const M=e.getIcon(j.id);if(!M)return;j=M.defaults}return j}$.getDefinition=c})(T||(t.IconContribution=T={}));var s;(function($){function c(S){return{weight:S.weight,style:S.style,src:S.src.map(j=>({format:j.format,location:j.location.toString()}))}}$.toJSONObject=c;function o(S){const j=M=>(0,w.$yf)(M)?M:void 0;if(S&&Array.isArray(S.src)&&S.src.every(M=>(0,w.$yf)(M.format)&&(0,w.$yf)(M.location)))return{weight:j(S.weight),style:j(S.style),src:S.src.map(M=>({format:M.format,location:D.URI.parse(M.location)}))}}$.fromJSONObject=o})(s||(t.IconFontDefinition=s={}));class a{constructor(){this.a=new U.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,h.localize)(0,null)},fontCharacter:{type:"string",description:(0,h.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(c,o,S,j){const M=this.b[c];if(M){if(S&&!M.description){M.description=S,this.d.properties[c].markdownDescription=`${S} $(${c})`;const B=this.e.enum.indexOf(c);B!==-1&&(this.e.enumDescriptions[B]=S),this.a.fire()}return M}const b={id:c,description:S,defaults:o,deprecationMessage:j};this.b[c]=b;const v={$ref:"#/definitions/icons"};return j&&(v.deprecationMessage=j),S&&(v.markdownDescription=`${S}: $(${c})`),this.d.properties[c]=v,this.e.enum.push(c),this.e.enumDescriptions.push(S||""),this.a.fire(),{id:c}}deregisterIcon(c){delete this.b[c],delete this.d.properties[c];const o=this.e.enum.indexOf(c);o!==-1&&(this.e.enum.splice(o,1),this.e.enumDescriptions.splice(o,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(c=>this.b[c])}getIcon(c){return this.b[c]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(c,o){const S=this.f[c];return S||(this.f[c]=o,this.a.fire(),o)}deregisterIconFont(c){delete this.f[c]}getIconFont(c){return this.f[c]}toString(){const c=(M,b)=>M.id.localeCompare(b.id),o=M=>{for(;i.ThemeIcon.isThemeIcon(M.defaults);)M=this.b[M.defaults.id];return`codicon codicon-${M?M.id:""}`},S=[];S.push("| preview     | identifier                        | default codicon ID                | description"),S.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const j=Object.keys(this.b).map(M=>this.b[M]);for(const M of j.filter(b=>!!b.description).sort(c))S.push(`|<i class="${o(M)}"></i>|${M.id}|${i.ThemeIcon.isThemeIcon(M.defaults)?M.defaults.id:M.id}|${M.description||""}|`);S.push("| preview     | identifier                        "),S.push("| ----------- | --------------------------------- |");for(const M of j.filter(b=>!i.ThemeIcon.isThemeIcon(b.defaults)).sort(c))S.push(`|<i class="${o(M)}"></i>|${M.id}|`);return S.join(`
`)}}const e=new a;d.$dn.add(t.$1v.IconContribution,e);function u($,c,o,S){return e.registerIcon($,c,o,S)}t.$2v=u;function l(){return e}t.$3v=l;function m(){const $=(0,F.$Rj)();for(const c in $){const o="\\"+$[c].toString(16);e.registerIcon(c,{fontCharacter:o})}}m(),t.$4v="vscode://schemas/icons";const n=d.$dn.as(f.$en.JSONContribution);n.registerSchema(t.$4v,e.getIconSchema());const r=new y.$6g(()=>n.notifySchemaChanged(t.$4v),200);e.onDidChange(()=>{r.isScheduled()||r.schedule()}),t.$5v=u("widget-close",F.$Tj.close,(0,h.localize)(2,null)),t.$6v=u("goto-previous-location",F.$Tj.arrowUp,(0,h.localize)(3,null)),t.$7v=u("goto-next-location",F.$Tj.arrowDown,(0,h.localize)(4,null)),t.$8v=i.ThemeIcon.modify(F.$Tj.sync,"spin"),t.$9v=i.ThemeIcon.modify(F.$Tj.loading,"spin")}),define(be[142],$e([1,0,3,4,2,18,141]),function(re,t,y,F,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sCb=t.$rCb=void 0;function D(f){const d=new i.$Rc,T=d.add(new F.$Nd),s=(0,w.$3v)();return d.add(s.onDidChange(()=>T.fire())),f&&d.add(f.onDidProductIconThemeChange(()=>T.fire())),{dispose:()=>d.dispose(),onDidChange:T.event,getCSS(){const a=f?f.getProductIconTheme():new h,e={},u=m=>{const n=a.getIcon(m);if(!n)return;const r=n.font;return r?(e[r.id]=r.definition,`.codicon-${m.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,y.$JP)(r.id)}; }`):`.codicon-${m.id}:before { content: '${n.fontCharacter}'; }`},l=[];for(const m of s.getIcons()){const n=u(m);n&&l.push(n)}for(const m in e){const n=e[m],r=n.weight?`font-weight: ${n.weight};`:"",$=n.style?`font-style: ${n.style};`:"",c=n.src.map(o=>`${(0,y.$IP)(o.location)} format('${o.format}')`).join(", ");l.push(`@font-face { src: ${c}; font-family: ${(0,y.$JP)(m)};${r}${$} font-display: block; }`)}return l.join(`
`)}}}t.$rCb=D;class h{getIcon(d){const T=(0,w.$3v)();let s=d.defaults;for(;U.ThemeIcon.isThemeIcon(s);){const a=T.getIcon(s.id);if(!a)return;s=a.defaults}return s}}t.$sCb=h}),define(be[143],$e([1,0,5]),function(re,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5C=t.$4C=t.$3C=t.$2C=t.$1C=t.$ZC=t.$YC=t.$XC=void 0,t.$XC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function F(d){return!!d.workspaceUri}t.$YC=F;function i(d){return!!d.folderUri}t.$ZC=i;function U(d){return!!d.fileUri}t.$1C=U;function w(d){const T=D(d),s=d.getValue("window.menuBarVisibility");return s==="default"||T==="native"&&s==="compact"||y.$k&&y.$n?"classic":s}t.$2C=w;function D(d){if(y.$p)return"custom";const T=d.getValue("window");if(T){if(y.$k&&T.nativeTabs===!0||y.$k&&T.nativeFullScreen===!1)return"native";const e=T.titleBarStyle;if(e==="native"||e==="custom")return e}return y.$l?"native":"custom"}t.$3C=D;function h(d){return!(!y.$j||y.$p||D(d)==="native")}t.$4C=h;function f(d=0){return Math.pow(1.2,d)}t.$5C=f}),define(be[144],$e([1,0,16,3,30,143]),function(re,t,y,F,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$f8b=t.$e8b=t.$d8b=void 0;function w(f){for(const d of(0,F.getWindows)())(0,i.$S)(d)?.webFrame?.setZoomLevel(f);(0,y.$eO)((0,U.$5C)(f)),(0,y.$bO)(f)}t.$d8b=w;function D(){w((0,y.$cO)()+1)}t.$e8b=D;function h(){w((0,y.$cO)()-1)}t.$f8b=h}),define(be[145],$e([1,0,10,3,130,9,131,30,135,136,138,139,142,144,14,101,92]),function(re,t,y,F,i,U,w,D,h,f,d,T,s,a,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const u=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,l=/\s--inspect-port=(?<port>\d+)/;class m{getHeight(W){return 22}getTemplateId(W){return M(W)?"process":S(W)?"machine":(0,h.$pm)(W)?"error":j(W)?"header":""}}class n{hasChildren(W){return(0,h.$pm)(W)?!1:M(W)?!!W.children?.length:!0}getChildren(W){return M(W)?W.children?W.children:[]:(0,h.$pm)(W)?[]:j(W)?W.processRoots.length>1?W.processRoots:[W.processRoots[0].rootProcess]:S(W)?[W.rootProcess]:[W.processes]}}class r{constructor(){this.templateId="header"}renderTemplate(W){const I=(0,F.$sP)(W,(0,F.$)(".row")),N=(0,F.$sP)(I,(0,F.$)(".nameLabel")),J=(0,F.$sP)(I,(0,F.$)(".cpu")),ee=(0,F.$sP)(I,(0,F.$)(".memory")),ne=(0,F.$sP)(I,(0,F.$)(".pid"));return{name:N,CPU:J,memory:ee,PID:ne}}renderElement(W,I,N,J){N.name.textContent=(0,y.localize)(0,null),N.CPU.textContent=(0,y.localize)(1,null),N.PID.textContent=(0,y.localize)(2,null),N.memory.textContent=(0,y.localize)(3,null)}disposeTemplate(W){}}class ${constructor(){this.templateId="machine"}renderTemplate(W){const I=Object.create(null),N=(0,F.$sP)(W,(0,F.$)(".row"));return I.name=(0,F.$sP)(N,(0,F.$)(".nameLabel")),I}renderElement(W,I,N,J){N.name.textContent=W.element.name}disposeTemplate(W){}}class c{constructor(){this.templateId="error"}renderTemplate(W){const I=Object.create(null),N=(0,F.$sP)(W,(0,F.$)(".row"));return I.name=(0,F.$sP)(N,(0,F.$)(".nameLabel")),I}renderElement(W,I,N,J){N.name.textContent=W.element.errorMessage}disposeTemplate(W){}}class o{constructor(W,I,N){this.a=W,this.b=I,this.c=N,this.templateId="process"}renderTemplate(W){const I=(0,F.$sP)(W,(0,F.$)(".row")),N=(0,F.$sP)(I,(0,F.$)(".nameLabel")),J=(0,F.$sP)(I,(0,F.$)(".cpu")),ee=(0,F.$sP)(I,(0,F.$)(".memory")),ne=(0,F.$sP)(I,(0,F.$)(".pid"));return{name:N,CPU:J,PID:ne,memory:ee}}renderElement(W,I,N,J){const{element:ee}=W,ne=ee.pid.toFixed(0);let ue=ee.name;this.c.has(ee.pid)&&(ue=this.c.get(ee.pid)),N.name.textContent=ue,N.name.title=ee.cmd,N.CPU.textContent=ee.load.toFixed(0),N.PID.textContent=ne,N.PID.parentElement.id=`pid-${ne}`;const le=this.a==="win32"?ee.mem:this.b*(ee.mem/100);N.memory.textContent=(le/f.$Fk.MB).toFixed(0)}disposeTemplate(W){}}function S(z){return!!z.name&&!!z.rootProcess}function j(z){return!!z.processRoots}function M(z){return!!z.pid}class b{constructor(W,I){this.f=I,this.b=new Map;const N=new d.$a8b(W);this.c=new T.$b8b(W,N),this.k(I.styles),this.g(I),D.$N.on("vscode:pidToNameResponse",(J,ee)=>{this.b=new Map;for(const[ne,ue]of ee)this.b.set(ne,ue)}),D.$N.on("vscode:listProcessesResponse",async(J,ee)=>{ee.forEach((ne,ue)=>{M(ne.rootProcess)&&(ne.rootProcess.name=ue===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:ee}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(ee),this.m(0)}),this.a=Date.now(),D.$N.send("vscode:pidToNameRequest"),D.$N.send("vscode:listProcesses")}g(W){document.onkeydown=I=>{const N=W.platform==="darwin"?I.metaKey:I.ctrlKey;N&&I.keyCode===87&&(I.stopPropagation(),I.preventDefault(),D.$N.send("vscode:closeProcessExplorer")),N&&I.keyCode===187&&(0,a.$e8b)(),N&&I.keyCode===189&&(0,a.$f8b)()}}async h(W){const I=document.getElementById("process-list");if(!I)return;const{totalmem:N}=await this.c.getOSStatistics(),J=[new o(this.f.platform,N,this.b),new r,new $,new c];this.d=new i.$NS("processExplorer",I,new m,J,new n,{identityProvider:{getId:ee=>M(ee)?ee.pid.toString():(0,h.$pm)(ee)?ee.hostName:j(ee)?"processes":S(ee)?ee.name:"header"}}),this.d.setInput({processes:{processRoots:W}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(ee=>{const ne=new e.$zO(ee);if(ne.keyCode===35&&ne.altKey){const ue=this.n();Promise.all(ue.map(le=>this.c.killProcess(le,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(ee=>{M(ee.element)&&this.l(ee.element,!0)}),I.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{I.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(W){const I=u.exec(W);return I&&I.groups.port!=="0"||W.indexOf("node ")>=0||W.indexOf("node.exe")>=0}j(W){const I={type:"node",request:"attach",name:`process ${W.pid}`};let N=u.exec(W.cmd);N?I.port=Number(N.groups.port):I.processId=String(W.pid),N=l.exec(W.cmd),N&&(I.port=Number(N.groups.port)),D.$N.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[I]})}k(W){const I=(0,F.$dP)(),N=[];W.listFocusBackground&&(N.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${W.listFocusBackground}; }`),N.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${W.listFocusBackground}; }`)),W.listFocusForeground&&N.push(`.monaco-list:focus .monaco-list-row.focused { color: ${W.listFocusForeground}; }`),W.listActiveSelectionBackground&&(N.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${W.listActiveSelectionBackground}; }`),N.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${W.listActiveSelectionBackground}; }`)),W.listActiveSelectionForeground&&N.push(`.monaco-list:focus .monaco-list-row.selected { color: ${W.listActiveSelectionForeground}; }`),W.listHoverBackground&&N.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${W.listHoverBackground}; }`),W.listHoverForeground&&N.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${W.listHoverForeground}; }`),W.listFocusOutline&&N.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${W.listFocusOutline}; outline-offset: -1px; }`),W.listHoverOutline&&N.push(`.monaco-list-row:hover { outline: 1px dashed ${W.listHoverOutline}; outline-offset: -1px; }`),W.scrollbarShadowColor&&N.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${W.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${W.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${W.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),W.scrollbarSliderBackgroundColor&&N.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${W.scrollbarSliderBackgroundColor};
				}
			`),W.scrollbarSliderHoverBackgroundColor&&N.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${W.scrollbarSliderHoverBackgroundColor};
				}
			`),W.scrollbarSliderActiveBackgroundColor&&N.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${W.scrollbarSliderActiveBackgroundColor};
				}
			`),I.textContent=N.join(`
`),W.color&&(document.body.style.color=W.color)}l(W,I){const N=[],J=Number(W.pid);I&&(N.push({accelerator:"Alt+E",label:(0,y.localize)(4,null),click:()=>{this.c.killProcess(J,"SIGTERM")}}),N.push({label:(0,y.localize)(5,null),click:()=>{this.c.killProcess(J,"SIGKILL")}}),N.push({type:"separator"})),N.push({label:(0,y.localize)(6,null),click:()=>{const ee=this.n();ee?.includes(J)||(ee.length=0,ee.push(J));const ne=ee?.map(ue=>document.getElementById(`pid-${ue}`)).filter(ue=>!!ue);if(ne){const ue=ne.map(le=>le.innerText).filter(le=>!!le);this.c.writeClipboardText(ue.join(`
`))}}}),N.push({label:(0,y.localize)(7,null),click:()=>{const ee=document.getElementById("process-list");ee&&this.c.writeClipboardText(ee.innerText)}}),W&&I&&this.i(W.cmd)&&(N.push({type:"separator"}),N.push({label:(0,y.localize)(8,null),click:()=>{this.j(W)}})),(0,w.$hT)(N)}m(W){setTimeout(()=>{const I=Date.now(),N=W+I-this.a;this.a=I,N>1e3?(D.$N.send("vscode:pidToNameRequest"),D.$N.send("vscode:listProcesses")):this.m(N)},200)}n(){return this.d?.getSelection()?.map(W=>{if(!(!W||!("pid"in W)))return W.pid}).filter(W=>!!W)}}function v(){const z=(0,F.$dP)();z.id="codiconStyles";const W=(0,s.$rCb)(void 0);function I(){z.textContent=W.getCSS()}const N=new U.$6g(I,0);W.onDidChange(()=>N.schedule()),N.schedule()}function B(z){const W=z.data.platform==="win32"?"windows":z.data.platform==="linux"?"linux":"mac";document.body.classList.add(W),v(),(0,a.$d8b)(z.data.zoomLevel),new b(z.windowId,z.data)}t.startup=B})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9bb94efbe279580856897b63cc9417a3e875e405/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
