/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/id","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(J){for(var e=[],L=0,j=J.length;L<j;L++)e[L]=ne[J[L]];return e};define(ne[70],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class L{static get(){const R=new Map,A=new Map,D=new Map,b=new Map;function u(d,P){d.has(P.detail)||d.set(P.detail,-P.timestamp)}function c(d,P){const v=d.get(P.detail);v&&(v>=0||d.set(P.detail,v+P.timestamp))}let E=[];typeof J=="function"&&typeof J.getStats=="function"&&(E=J.getStats().slice(0).sort((d,P)=>d.timestamp-P.timestamp));for(const d of E)switch(d.type){case 10:u(R,d);break;case 11:case 12:c(R,d);break;case 21:u(A,d);break;case 22:c(A,d);break;case 33:u(D,d);break;case 34:c(D,d);break;case 31:u(b,d);break;case 32:c(b,d);break}let O=0;D.forEach(d=>O+=d);function m(d){const P=[];return d.forEach((v,$)=>P.push([$,v])),P}return{amdLoad:m(R),amdInvoke:m(A),nodeRequire:m(D),nodeEval:m(b),nodeRequireTotal:O}}static toMarkdownTable(R,A){let D="";const b=[];return R.forEach((u,c)=>{b[c]=u.length}),A.forEach(u=>{u.forEach((c,E)=>{typeof c>"u"&&(c=u[E]="-");const O=c.toString().length;b[E]=Math.max(O,b[E])})}),R.forEach((u,c)=>{D+=`| ${u+" ".repeat(b[c]-u.toString().length)} `}),D+=`|
`,R.forEach((u,c)=>{D+=`| ${"-".repeat(b[c])} `}),D+=`|
`,A.forEach(u=>{u.forEach((c,E)=>{typeof c<"u"&&(D+=`| ${c+" ".repeat(b[E]-c.toString().length)} `)}),D+=`|
`}),D}}e.$U=L}),define(ne[52],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=e.$hh=e.$gh=void 0;function L(D){return(b,u,c)=>{let E=null,O=null;if(typeof c.value=="function"?(E="value",O=c.value):typeof c.get=="function"&&(E="get",O=c.get),!O)throw new Error("not supported");c[E]=D(O,u)}}function j(D,b,u){let c=null,E=null;if(typeof u.value=="function"?(c="value",E=u.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",E=u.get),!E)throw new Error("not supported");const O=`$memoize$${b}`;u[c]=function(...m){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,m)}),this[O]}}e.$gh=j;function R(D,b,u){return L((c,E)=>{const O=`$debounce$${E}`,m=`$debounce$result$${E}`;return function(...d){this[m]||(this[m]=u?u():void 0),clearTimeout(this[O]),b&&(this[m]=b(this[m],...d),d=[this[m]]),this[O]=setTimeout(()=>{c.apply(this,d),this[m]=u?u():void 0},D)}})}e.$hh=R;function A(D,b,u){return L((c,E)=>{const O=`$throttle$timer$${E}`,m=`$throttle$result$${E}`,d=`$throttle$lastRun$${E}`,P=`$throttle$pending$${E}`;return function(...v){if(this[m]||(this[m]=u?u():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...v)),this[P])return;const $=this[d]+D;$<=Date.now()?(this[d]=Date.now(),c.apply(this,[this[m]]),this[m]=u?u():void 0):(this[P]=!0,this[O]=setTimeout(()=>{this[P]=!1,this[d]=Date.now(),c.apply(this,[this[m]]),this[m]=u?u():void 0},$-Date.now()))}})}e.$ih=A}),define(ne[71],re([0,1,9]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function j(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=j;function R(u,c="Unreachable"){throw new Error(c)}e.$4c=R;function A(u){if(!u)throw new L.$cb("Assertion Failed")}e.$5c=A;function D(u){if(!u()){debugger;u(),(0,L.$1)(new L.$cb("Assertion Failed"))}}e.$6c=D;function b(u,c){let E=0;for(;E<u.length-1;){const O=u[E],m=u[E+1];if(!c(O,m))return!1;E++}return!0}e.$7c=b}),define(ne[53],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var j;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(j||(e.SyntaxKind=j={}));var R;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var A;(function(s){s.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function D(s,o=!1){let t=0;const i=s.length;let n="",r=0,l=16,k=0;function y(te){let ae=0,le=0;for(;ae<te;){const ie=s.charCodeAt(t);if(ie>=48&&ie<=57)le=le*16+ie-48;else if(ie>=65&&ie<=70)le=le*16+ie-65+10;else if(ie>=97&&ie<=102)le=le*16+ie-97+10;else break;t++,ae++}return ae<te&&(le=-1),le}function w(te){t=te,n="",r=0,l=16,k=0}function N(){const te=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&c(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&c(s.charCodeAt(t)))for(t++;t<s.length&&c(s.charCodeAt(t));)t++;else return k=3,s.substring(te,t);let ae=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&c(s.charCodeAt(t))){for(t++;t<s.length&&c(s.charCodeAt(t));)t++;ae=t}else k=3;return s.substring(te,ae)}function H(){let te="",ae=t;for(;;){if(t>=i){te+=s.substring(ae,t),k=2;break}const le=s.charCodeAt(t);if(le===34){te+=s.substring(ae,t),t++;break}if(le===92){if(te+=s.substring(ae,t),t++,t>=i){k=2;break}switch(s.charCodeAt(t++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const q=y(4);q>=0?te+=String.fromCharCode(q):k=4;break}default:k=5}ae=t;continue}if(le>=0&&le<=31)if(u(le)){te+=s.substring(ae,t),k=2;break}else k=6;t++}return te}function _(){if(n="",k=0,r=t,t>=i)return r=i,l=17;let te=s.charCodeAt(t);if(b(te)){do t++,n+=String.fromCharCode(te),te=s.charCodeAt(t);while(b(te));return l=15}if(u(te))return t++,n+=String.fromCharCode(te),te===13&&s.charCodeAt(t)===10&&(t++,n+=`
`),l=14;switch(te){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,n=H(),l=10;case 47:{const ae=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<i&&!u(s.charCodeAt(t));)t++;return n=s.substring(ae,t),l=12}if(s.charCodeAt(t+1)===42){t+=2;const le=i-1;let ie=!1;for(;t<le;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,ie=!0;break}t++}return ie||(t++,k=1),n=s.substring(ae,t),l=13}return n+=String.fromCharCode(te),t++,l=16}case 45:if(n+=String.fromCharCode(te),t++,t===i||!c(s.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=N(),l=11;default:for(;t<i&&K(te);)t++,te=s.charCodeAt(t);if(r!==t){switch(n=s.substring(r,t),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(te),t++,l=16}}function K(te){if(b(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ue(){let te;do te=_();while(te>=12&&te<=15);return te}return{setPosition:w,getPosition:()=>t,scan:o?ue:_,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>t-r,getTokenError:()=>k}}e.$Rm=D;function b(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function u(s){return s===10||s===13||s===8232||s===8233}function c(s){return s>=48&&s<=57}var E;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(E||(E={}));function O(s,o){const t=[],i=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function k(y,w,N,H){r.value=y,r.offset=w,r.length=N,r.type=H,r.colonOffset=void 0,n=r}try{I(s,{onObjectBegin:(y,w)=>{if(o<=y)throw i;n=void 0,l=o>y,t.push("")},onObjectProperty:(y,w,N)=>{if(o<w||(k(y,w,N,"property"),t[t.length-1]=y,o<=w+N))throw i},onObjectEnd:(y,w)=>{if(o<=y)throw i;n=void 0,t.pop()},onArrayBegin:(y,w)=>{if(o<=y)throw i;n=void 0,t.push(0)},onArrayEnd:(y,w)=>{if(o<=y)throw i;n=void 0,t.pop()},onLiteralValue:(y,w,N)=>{if(o<w||(k(y,w,N,S(y)),o<=w+N))throw i},onSeparator:(y,w,N)=>{if(o<=w)throw i;if(y===":"&&n&&n.type==="property")n.colonOffset=w,l=!1,n=void 0;else if(y===","){const H=t[t.length-1];typeof H=="number"?t[t.length-1]=H+1:(l=!0,t[t.length-1]=""),n=void 0}}})}catch(y){if(y!==i)throw y}return{path:t,previousNode:n,isAtPropertyKey:l,matches:y=>{let w=0;for(let N=0;w<y.length&&N<t.length;N++)if(y[w]===t[N]||y[w]==="*")w++;else if(y[w]!=="**")return!1;return w===y.length}}}e.$Sm=O;function m(s,o=[],t=A.DEFAULT){let i=null,n=[];const r=[];function l(y){Array.isArray(n)?n.push(y):i!==null&&(n[i]=y)}return I(s,{onObjectBegin:()=>{const y={};l(y),r.push(n),n=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const y=[];l(y),r.push(n),n=y,i=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:l,onError:(y,w,N)=>{o.push({error:y,offset:w,length:N})}},t),n[0]}e.$Tm=m;function d(s,o=[],t=A.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function r(y){return i.children.push(y),y}I(s,{onObjectBegin:y=>{i=r({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,w,N)=>{i=r({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:w,length:N,parent:i})},onObjectEnd:(y,w)=>{i.length=y+w-i.offset,i=i.parent,n(y+w)},onArrayBegin:(y,w)=>{i=r({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,w)=>{i.length=y+w-i.offset,i=i.parent,n(y+w)},onLiteralValue:(y,w,N)=>{r({type:S(y),offset:w,length:N,parent:i,value:y}),n(w+N)},onSeparator:(y,w,N)=>{i.type==="property"&&(y===":"?i.colonOffset=w:y===","&&n(w))},onError:(y,w,N)=>{o.push({error:y,offset:w,length:N})}},t);const k=i.children[0];return k&&delete k.parent,k}e.$Um=d;function P(s,o){if(!s)return;let t=s;for(const i of o)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const r of t.children)if(Array.isArray(r.children)&&r.children[0].value===i){t=r.children[1],n=!0;break}if(!n)return}else{const n=i;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}e.$Vm=P;function v(s){if(!s.parent||!s.parent.children)return[];const o=v(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;o.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&o.push(t)}return o}e.$Wm=v;function $(s){switch(s.type){case"array":return s.children.map($);case"object":{const o=Object.create(null);for(const t of s.children){const i=t.children[1];i&&(o[t.children[0].value]=$(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$Xm=$;function h(s,o,t=!1){return o>=s.offset&&o<s.offset+s.length||t&&o===s.offset+s.length}e.$Ym=h;function f(s,o,t=!1){if(h(s,o,t)){const i=s.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const r=f(i[n],o,t);if(r)return r}return s}}e.$Zm=f;function I(s,o,t=A.DEFAULT){const i=D(s,!1);function n(Z){return Z?()=>Z(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(Z){return Z?Y=>Z(Y,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=n(o.onObjectBegin),k=r(o.onObjectProperty),y=n(o.onObjectEnd),w=n(o.onArrayBegin),N=n(o.onArrayEnd),H=r(o.onLiteralValue),_=r(o.onSeparator),K=n(o.onComment),ue=r(o.onError),te=t&&t.disallowComments,ae=t&&t.allowTrailingComma;function le(){for(;;){const Z=i.scan();switch(i.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:te||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(Z){case 12:case 13:te?ie(10):K();break;case 16:ie(1);break;case 15:case 14:break;default:return Z}}}function ie(Z,Y=[],U=[]){if(ue(Z),Y.length+U.length>0){let z=i.getToken();for(;z!==17;){if(Y.indexOf(z)!==-1){le();break}else if(U.indexOf(z)!==-1)break;z=le()}}}function q(Z){const Y=i.getTokenValue();return Z?H(Y):k(Y),le(),!0}function G(){switch(i.getToken()){case 11:{let Z=0;try{Z=JSON.parse(i.getTokenValue()),typeof Z!="number"&&(ie(2),Z=0)}catch{ie(2)}H(Z);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return le(),!0}function T(){return i.getToken()!==10?(ie(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(_(":"),le(),x()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function C(){l(),le();let Z=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Z||ie(4,[],[]),_(","),le(),i.getToken()===2&&ae)break}else Z&&ie(6,[],[]);T()||ie(4,[],[2,5]),Z=!0}return y(),i.getToken()!==2?ie(7,[2],[]):le(),!0}function B(){w(),le();let Z=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Z||ie(4,[],[]),_(","),le(),i.getToken()===4&&ae)break}else Z&&ie(6,[],[]);x()||ie(4,[],[4,5]),Z=!0}return N(),i.getToken()!==4?ie(8,[4],[]):le(),!0}function x(){switch(i.getToken()){case 3:return B();case 1:return C();case 10:return q(!0);default:return G()}}return le(),i.getToken()===17?t.allowEmptyContent?!0:(ie(4,[],[]),!1):x()?(i.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.$1m=I;function p(s,o){const t=D(s),i=[];let n,r=0,l;do switch(l=t.getPosition(),n=t.scan(),n){case 12:case 13:case 17:r!==l&&i.push(s.substring(r,l)),o!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,o)),r=t.getPosition();break}while(n!==17);return i.join("")}e.$2m=p;function S(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$3m=S}),define(ne[72],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ol=e.rot=e.$Ml=void 0;function L(b,u,c){return Math.min(Math.max(b,u),c)}e.$Ml=L;function j(b,u){return(u+b%u)%u}e.rot=j;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Ol=R;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Pl=A;class D{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const c=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ql=D}),function(){function J(R){const A=[];typeof R=="number"&&A.push("code/timeOrigin",R);function D(u){A.push(u,Date.now())}function b(){const u=[];for(let c=0;c<A.length;c+=2)u.push({name:A[c],startTime:A[c+1]});return u}return{mark:D,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const D of performance.getEntriesByType("mark"))A.push({name:D.name,startTime:Math.round(R+D.startTime)});return A}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var j;typeof global=="object"?j=global:typeof self=="object"?j=self:j={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(j)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(j):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),j.perf=L(j))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var j in L)(typeof exports=="object"?exports:J)[j]=L[j]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function L(j){if(e[j])return e[j].exports;var R=e[j]={i:j,l:!1,exports:{}};return J[j].call(R.exports,R,R.exports,L),R.l=!0,R.exports}return L.m=J,L.c=e,L.d=function(j,R,A){L.o(j,R)||Object.defineProperty(j,R,{enumerable:!0,get:A})},L.r=function(j){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(j,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(j,"__esModule",{value:!0})},L.t=function(j,R){if(1&R&&(j=L(j)),8&R||4&R&&typeof j=="object"&&j&&j.__esModule)return j;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:j}),2&R&&typeof j!="string")for(var D in j)L.d(A,D,function(b){return j[b]}.bind(null,D));return A},L.n=function(j){var R=j&&j.__esModule?function(){return j.default}:function(){return j};return L.d(R,"a",R),R},L.o=function(j,R){return Object.prototype.hasOwnProperty.call(j,R)},L.p="",L(L.s=0)}([function(J,e,L){(function(j){var R;e=J.exports=U,R=typeof j=="object"&&j.env&&j.env.NODE_DEBUG&&/\bsemver\b/i.test(j.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],u=e.src=[],c=0,E=c++;u[E]="0|[1-9]\\d*";var O=c++;u[O]="[0-9]+";var m=c++;u[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=c++;u[d]="("+u[E]+")\\.("+u[E]+")\\.("+u[E]+")";var P=c++;u[P]="("+u[O]+")\\.("+u[O]+")\\.("+u[O]+")";var v=c++;u[v]="(?:"+u[E]+"|"+u[m]+")";var $=c++;u[$]="(?:"+u[O]+"|"+u[m]+")";var h=c++;u[h]="(?:-("+u[v]+"(?:\\."+u[v]+")*))";var f=c++;u[f]="(?:-?("+u[$]+"(?:\\."+u[$]+")*))";var I=c++;u[I]="[0-9A-Za-z-]+";var p=c++;u[p]="(?:\\+("+u[I]+"(?:\\."+u[I]+")*))";var S=c++,s="v?"+u[d]+u[h]+"?"+u[p]+"?";u[S]="^"+s+"$";var o="[v=\\s]*"+u[P]+u[f]+"?"+u[p]+"?",t=c++;u[t]="^"+o+"$";var i=c++;u[i]="((?:<|>)?=?)";var n=c++;u[n]=u[O]+"|x|X|\\*";var r=c++;u[r]=u[E]+"|x|X|\\*";var l=c++;u[l]="[v=\\s]*("+u[r]+")(?:\\.("+u[r]+")(?:\\.("+u[r]+")(?:"+u[h]+")?"+u[p]+"?)?)?";var k=c++;u[k]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[f]+")?"+u[p]+"?)?)?";var y=c++;u[y]="^"+u[i]+"\\s*"+u[l]+"$";var w=c++;u[w]="^"+u[i]+"\\s*"+u[k]+"$";var N=c++;u[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=c++;u[H]="(?:~>?)";var _=c++;u[_]="(\\s*)"+u[H]+"\\s+",b[_]=new RegExp(u[_],"g");var K=c++;u[K]="^"+u[H]+u[l]+"$";var ue=c++;u[ue]="^"+u[H]+u[k]+"$";var te=c++;u[te]="(?:\\^)";var ae=c++;u[ae]="(\\s*)"+u[te]+"\\s+",b[ae]=new RegExp(u[ae],"g");var le=c++;u[le]="^"+u[te]+u[l]+"$";var ie=c++;u[ie]="^"+u[te]+u[k]+"$";var q=c++;u[q]="^"+u[i]+"\\s*("+o+")$|^$";var G=c++;u[G]="^"+u[i]+"\\s*("+s+")$|^$";var T=c++;u[T]="(\\s*)"+u[i]+"\\s*("+o+"|"+u[l]+")",b[T]=new RegExp(u[T],"g");var C=c++;u[C]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var B=c++;u[B]="^\\s*("+u[k]+")\\s+-\\s+("+u[k]+")\\s*$";var x=c++;u[x]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)R(Z,u[Z]),b[Z]||(b[Z]=new RegExp(u[Z]));function Y(V,Q){if(V instanceof U)return V;if(typeof V!="string"||V.length>A||!(Q?b[t]:b[S]).test(V))return null;try{return new U(V,Q)}catch{return null}}function U(V,Q){if(V instanceof U){if(V.loose===Q)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof U))return new U(V,Q);R("SemVer",V,Q),this.loose=Q;var ee=V.trim().match(Q?b[t]:b[S]);if(!ee)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ye=+$e;if(ye>=0&&ye<D)return ye}return $e}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=Y,e.valid=function(V,Q){var ee=Y(V,Q);return ee?ee.version:null},e.clean=function(V,Q){var ee=Y(V.trim().replace(/^[=v]+/,""),Q);return ee?ee.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(V){return R("SemVer.compare",this.version,this.loose,V),V instanceof U||(V=new U(V,this.loose)),this.compareMain(V)||this.comparePre(V)},U.prototype.compareMain=function(V){return V instanceof U||(V=new U(V,this.loose)),a(this.major,V.major)||a(this.minor,V.minor)||a(this.patch,V.patch)},U.prototype.comparePre=function(V){if(V instanceof U||(V=new U(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Q=0;do{var ee=this.prerelease[Q],$e=V.prerelease[Q];if(R("prerelease compare",Q,ee,$e),ee===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(ee===void 0)return-1;if(ee!==$e)return a(ee,$e)}while(++Q)},U.prototype.inc=function(V,Q){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Q,ee,$e){typeof ee=="string"&&($e=ee,ee=void 0);try{return new U(V,ee).inc(Q,$e).version}catch{return null}},e.diff=function(V,Q){if(X(V,Q))return null;var ee=Y(V),$e=Y(Q);if(ee.prerelease.length||$e.prerelease.length){for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==$e[ye])return"pre"+ye;return"prerelease"}for(var ye in ee)if((ye==="major"||ye==="minor"||ye==="patch")&&ee[ye]!==$e[ye])return ye},e.compareIdentifiers=a;var z=/^[0-9]+$/;function a(V,Q){var ee=z.test(V),$e=z.test(Q);return ee&&$e&&(V=+V,Q=+Q),ee&&!$e?-1:$e&&!ee?1:V<Q?-1:V>Q?1:0}function g(V,Q,ee){return new U(V,ee).compare(new U(Q,ee))}function F(V,Q,ee){return g(V,Q,ee)>0}function M(V,Q,ee){return g(V,Q,ee)<0}function X(V,Q,ee){return g(V,Q,ee)===0}function W(V,Q,ee){return g(V,Q,ee)!==0}function ce(V,Q,ee){return g(V,Q,ee)>=0}function oe(V,Q,ee){return g(V,Q,ee)<=0}function me(V,Q,ee,$e){var ye;switch(Q){case"===":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V===ee;break;case"!==":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),ye=V!==ee;break;case"":case"=":case"==":ye=X(V,ee,$e);break;case"!=":ye=W(V,ee,$e);break;case">":ye=F(V,ee,$e);break;case">=":ye=ce(V,ee,$e);break;case"<":ye=M(V,ee,$e);break;case"<=":ye=oe(V,ee,$e);break;default:throw new TypeError("Invalid operator: "+Q)}return ye}function de(V,Q){if(V instanceof de){if(V.loose===Q)return V;V=V.value}if(!(this instanceof de))return new de(V,Q);R("comparator",V,Q),this.loose=Q,this.parse(V),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(V,Q){return a(Q,V)},e.major=function(V,Q){return new U(V,Q).major},e.minor=function(V,Q){return new U(V,Q).minor},e.patch=function(V,Q){return new U(V,Q).patch},e.compare=g,e.compareLoose=function(V,Q){return g(V,Q,!0)},e.rcompare=function(V,Q,ee){return g(Q,V,ee)},e.sort=function(V,Q){return V.sort(function(ee,$e){return e.compare(ee,$e,Q)})},e.rsort=function(V,Q){return V.sort(function(ee,$e){return e.rcompare(ee,$e,Q)})},e.gt=F,e.lt=M,e.eq=X,e.neq=W,e.gte=ce,e.lte=oe,e.cmp=me,e.Comparator=de;var ge={};function fe(V,Q){if(V instanceof fe)return V.loose===Q?V:new fe(V.raw,Q);if(V instanceof de)return new fe(V.value,Q);if(!(this instanceof fe))return new fe(V,Q);if(this.loose=Q,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function he(V){return!V||V.toLowerCase()==="x"||V==="*"}function we(V,Q,ee,$e,ye,Re,Se,Le,Ie,Ae,Ue,Oe,De){return((Q=he(ee)?"":he($e)?">="+ee+".0.0":he(ye)?">="+ee+"."+$e+".0":">="+Q)+" "+(Le=he(Ie)?"":he(Ae)?"<"+(+Ie+1)+".0.0":he(Ue)?"<"+Ie+"."+(+Ae+1)+".0":Oe?"<="+Ie+"."+Ae+"."+Ue+"-"+Oe:"<="+Le)).trim()}function be(V,Q){for(var ee=0;ee<V.length;ee++)if(!V[ee].test(Q))return!1;if(Q.prerelease.length){for(ee=0;ee<V.length;ee++)if(R(V[ee].semver),V[ee].semver!==ge&&V[ee].semver.prerelease.length>0){var $e=V[ee].semver;if($e.major===Q.major&&$e.minor===Q.minor&&$e.patch===Q.patch)return!0}return!1}return!0}function ke(V,Q,ee){try{Q=new fe(Q,ee)}catch{return!1}return Q.test(V)}function Fe(V,Q,ee,$e){var ye,Re,Se,Le,Ie;switch(V=new U(V,$e),Q=new fe(Q,$e),ee){case">":ye=F,Re=oe,Se=M,Le=">",Ie=">=";break;case"<":ye=M,Re=ce,Se=F,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(V,Q,$e))return!1;for(var Ae=0;Ae<Q.set.length;++Ae){var Ue=Q.set[Ae],Oe=null,De=null;if(Ue.forEach(function(je){je.semver===ge&&(je=new de(">=0.0.0")),Oe=Oe||je,De=De||je,ye(je.semver,Oe.semver,$e)?Oe=je:Se(je.semver,De.semver,$e)&&(De=je)}),Oe.operator===Le||Oe.operator===Ie||(!De.operator||De.operator===Le)&&Re(V,De.semver)||De.operator===Ie&&Se(V,De.semver))return!1}return!0}de.prototype.parse=function(V){var Q=this.loose?b[q]:b[G],ee=V.match(Q);if(!ee)throw new TypeError("Invalid comparator: "+V);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new U(ee[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(V){return R("Comparator.test",V,this.loose),this.semver===ge||(typeof V=="string"&&(V=new U(V,this.loose)),me(V,this.operator,this.semver,this.loose))},de.prototype.intersects=function(V,Q){if(!(V instanceof de))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(V.value,Q),ke(this.value,ee,Q);if(V.operator==="")return ee=new fe(this.value,Q),ke(V.semver,ee,Q);var $e=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Re=this.semver.version===V.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=me(this.semver,"<",V.semver,Q)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=me(this.semver,">",V.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return $e||ye||Re&&Se||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var Q=this.loose;V=V.trim(),R("range",V,Q);var ee=Q?b[B]:b[C];V=V.replace(ee,we),R("hyphen replace",V),V=V.replace(b[T],"$1$2$3"),R("comparator trim",V,b[T]),V=(V=(V=V.replace(b[_],"$1~")).replace(b[ae],"$1^")).split(/\s+/).join(" ");var $e=Q?b[q]:b[G],ye=V.split(" ").map(function(Re){return function(Se,Le){return R("comp",Se),Se=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Ue){return function(Oe,De){R("caret",Oe,De);var je=De?b[ie]:b[le];return Oe.replace(je,function(Ce,ve,Ee,Pe,Ne){var ze;return R("caret",Oe,Ce,ve,Ee,Pe,Ne),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?ze=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Ne?(R("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+Ne+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+Ne+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+Ne+" <"+(+ve+1)+".0.0"):(R("no pr"),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+" <"+(+ve+1)+".0.0"),R("caret return",ze),ze})}(Ue,Ae)}).join(" ")}(Se,Le),R("caret",Se),Se=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Ue){return function(Oe,De){var je=De?b[ue]:b[K];return Oe.replace(je,function(Ce,ve,Ee,Pe,Ne){var ze;return R("tilde",Oe,Ce,ve,Ee,Pe,Ne),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Pe)?ze=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Ne?(R("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),ze=">="+ve+"."+Ee+"."+Pe+Ne+" <"+ve+"."+(+Ee+1)+".0"):ze=">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0",R("tilde return",ze),ze})}(Ue,Ae)}).join(" ")}(Se,Le),R("tildes",Se),Se=function(Ie,Ae){return R("replaceXRanges",Ie,Ae),Ie.split(/\s+/).map(function(Ue){return function(Oe,De){Oe=Oe.trim();var je=De?b[w]:b[y];return Oe.replace(je,function(Ce,ve,Ee,Pe,Ne,ze){R("xRange",Oe,Ce,ve,Ee,Pe,Ne,ze);var qe=he(Ee),Me=qe||he(Pe),Te=Me||he(Ne);return ve==="="&&Te&&(ve=""),qe?Ce=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Me&&(Pe=0),Te&&(Ne=0),ve===">"?(ve=">=",Me?(Ee=+Ee+1,Pe=0,Ne=0):Te&&(Pe=+Pe+1,Ne=0)):ve==="<="&&(ve="<",Me?Ee=+Ee+1:Pe=+Pe+1),Ce=ve+Ee+"."+Pe+"."+Ne):Me?Ce=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Te&&(Ce=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),R("xRange return",Ce),Ce})}(Ue,Ae)}).join(" ")}(Se,Le),R("xrange",Se),Se=function(Ie,Ae){return R("replaceStars",Ie,Ae),Ie.trim().replace(b[x],"")}(Se,Le),R("stars",Se),Se}(Re,Q)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Re){return!!Re.match($e)})),ye=ye.map(function(Re){return new de(Re,Q)})},fe.prototype.intersects=function(V,Q){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function($e){return V.set.some(function(ye){return ye.every(function(Re){return $e.intersects(Re,Q)})})})})},e.toComparators=function(V,Q){return new fe(V,Q).set.map(function(ee){return ee.map(function($e){return $e.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new U(V,this.loose));for(var Q=0;Q<this.set.length;Q++)if(be(this.set[Q],V))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(V,Q,ee){var $e=null,ye=null;try{var Re=new fe(Q,ee)}catch{return null}return V.forEach(function(Se){Re.test(Se)&&($e&&ye.compare(Se)!==-1||(ye=new U($e=Se,ee)))}),$e},e.minSatisfying=function(V,Q,ee){var $e=null,ye=null;try{var Re=new fe(Q,ee)}catch{return null}return V.forEach(function(Se){Re.test(Se)&&($e&&ye.compare(Se)!==1||(ye=new U($e=Se,ee)))}),$e},e.validRange=function(V,Q){try{return new fe(V,Q).range||"*"}catch{return null}},e.ltr=function(V,Q,ee){return Fe(V,Q,"<",ee)},e.gtr=function(V,Q,ee){return Fe(V,Q,">",ee)},e.outside=Fe,e.prerelease=function(V,Q){var ee=Y(V,Q);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(V,Q,ee){return V=new fe(V,ee),Q=new fe(Q,ee),V.intersects(Q)},e.coerce=function(V){if(V instanceof U)return V;if(typeof V!="string")return null;var Q=V.match(b[N]);return Q==null?null:Y((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,L(1))},function(J,e){var L,j,R=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function b($){if(L===setTimeout)return setTimeout($,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout($,0);try{return L($,0)}catch{try{return L.call(null,$,0)}catch{return L.call(this,$,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{j=typeof clearTimeout=="function"?clearTimeout:D}catch{j=D}})();var u,c=[],E=!1,O=-1;function m(){E&&u&&(E=!1,u.length?c=u.concat(c):O=-1,c.length&&d())}function d(){if(!E){var $=b(m);E=!0;for(var h=c.length;h;){for(u=c,c=[];++O<h;)u&&u[O].run();O=-1,h=c.length}u=null,E=!1,function(f){if(j===clearTimeout)return clearTimeout(f);if((j===D||!j)&&clearTimeout)return j=clearTimeout,clearTimeout(f);try{j(f)}catch{try{return j.call(null,f)}catch{return j.call(this,f)}}}($)}}function P($,h){this.fun=$,this.array=h}function v(){}R.nextTick=function($){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];c.push(new P($,h)),c.length!==1||E||b(d)},P.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=v,R.addListener=v,R.once=v,R.off=v,R.removeListener=v,R.removeAllListeners=v,R.emit=v,R.prependListener=v,R.prependOnceListener=v,R.listeners=function($){return[]},R.binding=function($){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function($){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ne[73],re([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=void 0;class j{constructor(b,u,c){this.level=b,this.key=u,this.value=c,this.forward=[]}}const R=void 0;class A{constructor(b,u=2**16){this.comparator=b,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new j(this.c,R,R)}get size(){return this.f}clear(){this.e=new j(this.c,R,R),this.f=0}has(b){return!!A.g(this,b,this.comparator)}get(b){return A.g(this,b,this.comparator)?.value}set(b,u){return A.h(this,b,u,this.comparator)&&(this.f+=1),this}delete(b){const u=A.k(this,b,this.comparator);return u&&(this.f-=1),u}forEach(b,u){let c=this.e.forward[0];for(;c;)b.call(u,c.value,c.key,this),c=c.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this.e.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this.e.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this.e.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",u=this.e.forward[0];for(;u;)b+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return b}static g(b,u,c){let E=b.e;for(let O=b.d-1;O>=0;O--)for(;E.forward[O]&&c(E.forward[O].key,u)<0;)E=E.forward[O];if(E=E.forward[0],E&&c(E.key,u)===0)return E}static h(b,u,c,E){const O=[];let m=b.e;for(let d=b.d-1;d>=0;d--){for(;m.forward[d]&&E(m.forward[d].key,u)<0;)m=m.forward[d];O[d]=m}if(m=m.forward[0],m&&E(m.key,u)===0)return m.value=c,!1;{const d=A.j(b);if(d>b.d){for(let P=b.d;P<d;P++)O[P]=b.e;b.d=d}m=new j(d,u,c);for(let P=0;P<d;P++)m.forward[P]=O[P].forward[P],O[P].forward[P]=m;return!0}}static j(b,u=.5){let c=1;for(;Math.random()<u&&c<b.c;)c+=1;return c}static k(b,u,c){const E=[];let O=b.e;for(let m=b.d-1;m>=0;m--){for(;O.forward[m]&&c(O.forward[m].key,u)<0;)O=O.forward[m];E[m]=O}if(O=O.forward[0],!O||c(O.key,u)!==0)return!1;for(let m=0;m<b.d&&E[m].forward[m]===O;m++)E[m].forward[m]=O.forward[m];for(;b.d>0&&b.e.forward[b.d-1]===R;)b.d-=1;return!0}}e.$wr=A}),define(ne[45],re([0,1,9,2]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function R(p){const S=p;return S?typeof S.read=="function":!1}e.$Yd=R;function A(p){const S=p;return S?[S.on,S.pause,S.resume,S.destroy].every(s=>typeof s=="function"):!1}e.$Zd=A;function D(p){const S=p;return S?A(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.$1d=D;function b(p,S){return new u(p,S)}e.$2d=b;class u{constructor(S,s){this.e=S,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(s=>s(S))}h(S){this.c.error.length===0?(0,L.$1)(S):this.c.error.slice(0).forEach(s=>s(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,s){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(S,s){if(this.a.destroyed)return;let o;switch(S){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const t=o.indexOf(s);t>=0&&o.splice(t,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(p,S){const s=[];let o;for(;(o=p.read())!==null;)s.push(o);return S(s)}e.$3d=c;function E(p,S,s){const o=[];let t;for(;(t=p.read())!==null&&o.length<s;)o.push(t);return t===null&&o.length>0?S(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return p.read()}}}e.$4d=E;function O(p,S){return new Promise((s,o)=>{const t=[];m(p,{onData:i=>{S&&t.push(i)},onError:i=>{S?o(i):s(void 0)},onEnd:()=>{s(S?S(t):void 0)}})})}e.$5d=O;function m(p,S,s){p.on("error",o=>{s?.isCancellationRequested||S.onError(o)}),p.on("end",()=>{s?.isCancellationRequested||S.onEnd()}),p.on("data",o=>{s?.isCancellationRequested||S.onData(o)})}e.$6d=m;function d(p,S){return new Promise((s,o)=>{const t=new j.$Rc,i=[],n=k=>{if(i.push(k),i.length>S)return t.dispose(),p.pause(),s({stream:p,buffer:i,ended:!1})},r=k=>(t.dispose(),o(k)),l=()=>(t.dispose(),s({stream:p,buffer:i,ended:!0}));t.add((0,j.$Qc)(()=>p.removeListener("error",r))),p.on("error",r),t.add((0,j.$Qc)(()=>p.removeListener("end",l))),p.on("end",l),t.add((0,j.$Qc)(()=>p.removeListener("data",n))),p.on("data",n)})}e.$7d=d;function P(p,S){const s=b(S);return s.end(p),s}e.$8d=P;function v(){const p=b(()=>{throw new Error("not supported")});return p.end(),p}e.$9d=v;function $(p){let S=!1;return{read:()=>S?null:(S=!0,p)}}e.$0d=$;function h(p,S,s){const o=b(s);return m(p,{onData:t=>o.write(S.data(t)),onError:t=>o.error(S.error?S.error(t):t),onEnd:()=>o.end()}),o}e.$$d=h;function f(p,S,s){let o=!1;return{read:()=>{const t=S.read();return o?t:(o=!0,t!==null?s([p,t]):p)}}}e.$_d=f;function I(p,S,s){let o=!1;const t=b(s);return m(S,{onData:i=>o?t.write(i):(o=!0,t.write(s([p,i]))),onError:i=>t.error(i),onEnd:()=>{o||(o=!0,t.write(p)),t.end()}}),t}e.$ae=I}),define(ne[14],re([0,1,164,45]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const R=typeof Buffer<"u",A=new L.$V(()=>new Uint8Array(256));let D,b;class u{static alloc(N){return R?new u(Buffer.allocUnsafe(N)):new u(new Uint8Array(N))}static wrap(N){return R&&!Buffer.isBuffer(N)&&(N=Buffer.from(N.buffer,N.byteOffset,N.byteLength)),new u(N)}static fromString(N,H){return!(H?.dontUseNodeBuffer||!1)&&R?new u(Buffer.from(N)):(D||(D=new TextEncoder),new u(D.encode(N)))}static fromByteArray(N){const H=u.alloc(N.length);for(let _=0,K=N.length;_<K;_++)H.buffer[_]=N[_];return H}static concat(N,H){if(typeof H>"u"){H=0;for(let ue=0,te=N.length;ue<te;ue++)H+=N[ue].byteLength}const _=u.alloc(H);let K=0;for(let ue=0,te=N.length;ue<te;ue++){const ae=N[ue];_.set(ae,K),K+=ae.byteLength}return _}constructor(N){this.buffer=N,this.byteLength=this.buffer.byteLength}clone(){const N=u.alloc(this.byteLength);return N.set(this),N}toString(){return R?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(N,H){return new u(this.buffer.subarray(N,H))}set(N,H){if(N instanceof u)this.buffer.set(N.buffer,H);else if(N instanceof Uint8Array)this.buffer.set(N,H);else if(N instanceof ArrayBuffer)this.buffer.set(new Uint8Array(N),H);else if(ArrayBuffer.isView(N))this.buffer.set(new Uint8Array(N.buffer,N.byteOffset,N.byteLength),H);else throw new Error("Unknown argument 'array'")}readUInt32BE(N){return m(this.buffer,N)}writeUInt32BE(N,H){d(this.buffer,N,H)}readUInt32LE(N){return P(this.buffer,N)}writeUInt32LE(N,H){v(this.buffer,N,H)}readUInt8(N){return $(this.buffer,N)}writeUInt8(N,H){h(this.buffer,N,H)}indexOf(N,H=0){return c(this.buffer,N instanceof u?N.buffer:N,H)}}e.$be=u;function c(w,N,H=0){const _=N.byteLength,K=w.byteLength;if(_===0)return 0;if(_===1)return w.indexOf(N[0]);if(_>K-H)return-1;const ue=A.value;ue.fill(N.length);for(let ie=0;ie<N.length;ie++)ue[N[ie]]=N.length-ie-1;let te=H+N.length-1,ae=te,le=-1;for(;te<K;)if(w[te]===N[ae]){if(ae===0){le=te;break}te--,ae--}else te+=Math.max(N.length-ae,ue[w[te]]),ae=N.length-1;return le}e.$ce=c;function E(w,N){return w[N+0]<<0>>>0|w[N+1]<<8>>>0}e.$de=E;function O(w,N,H){w[H+0]=N&255,N=N>>>8,w[H+1]=N&255}e.$ee=O;function m(w,N){return w[N]*2**24+w[N+1]*2**16+w[N+2]*2**8+w[N+3]}e.$fe=m;function d(w,N,H){w[H+3]=N,N=N>>>8,w[H+2]=N,N=N>>>8,w[H+1]=N,N=N>>>8,w[H]=N}e.$ge=d;function P(w,N){return w[N+0]<<0>>>0|w[N+1]<<8>>>0|w[N+2]<<16>>>0|w[N+3]<<24>>>0}e.$he=P;function v(w,N,H){w[H+0]=N&255,N=N>>>8,w[H+1]=N&255,N=N>>>8,w[H+2]=N&255,N=N>>>8,w[H+3]=N&255}e.$ie=v;function $(w,N){return w[N]}e.$je=$;function h(w,N,H){w[H]=N}e.$ke=h;function f(w){return j.$3d(w,N=>u.concat(N))}e.$le=f;function I(w){return j.$0d(w)}e.$me=I;function p(w){return j.$5d(w,N=>u.concat(N))}e.$ne=p;async function S(w){return w.ended?u.concat(w.buffer):u.concat([...w.buffer,await p(w.stream)])}e.$oe=S;function s(w){return j.$8d(w,N=>u.concat(N))}e.$pe=s;function o(w){return j.$$d(w,{data:N=>typeof N=="string"?u.fromString(N):u.wrap(N)},N=>u.concat(N))}e.$qe=o;function t(w){return j.$2d(N=>u.concat(N),w)}e.$re=t;function i(w,N){return j.$_d(w,N,H=>u.concat(H))}e.$se=i;function n(w,N){return j.$ae(w,N,H=>u.concat(H))}e.$te=n;function r(w){let N=0,H=0,_=0;const K=new Uint8Array(Math.floor(w.length/4*3)),ue=ae=>{switch(H){case 3:K[_++]=N|ae,H=0;break;case 2:K[_++]=N|ae>>>2,N=ae<<6,H=3;break;case 1:K[_++]=N|ae>>>4,N=ae<<4,H=2;break;default:N=ae<<2,H=1}};for(let ae=0;ae<w.length;ae++){const le=w.charCodeAt(ae);if(le>=65&&le<=90)ue(le-65);else if(le>=97&&le<=122)ue(le-97+26);else if(le>=48&&le<=57)ue(le-48+52);else if(le===43||le===45)ue(62);else if(le===47||le===95)ue(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${w[ae]}`)}}const te=_;for(;H>0;)ue(0);return u.wrap(K).slice(0,te)}e.$ue=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:w},N=!0,H=!1){const _=H?k:l;let K="";const ue=w.byteLength%3;let te=0;for(;te<w.byteLength-ue;te+=3){const ae=w[te+0],le=w[te+1],ie=w[te+2];K+=_[ae>>>2],K+=_[(ae<<4|le>>>4)&63],K+=_[(le<<2|ie>>>6)&63],K+=_[ie&63]}if(ue===1){const ae=w[te+0];K+=_[ae>>>2],K+=_[ae<<4&63],N&&(K+="==")}else if(ue===2){const ae=w[te+0],le=w[te+1];K+=_[ae>>>2],K+=_[(ae<<4|le>>>4)&63],K+=_[le<<2&63],N&&(K+="=")}return K}e.$ve=y}),define(ne[41],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;function j(h){return R(h,0)}e.$Ci=j;function R(h,f){switch(typeof h){case"object":return h===null?A(349,f):Array.isArray(h)?u(h,f):c(h,f);case"string":return b(h,f);case"boolean":return D(h,f);case"number":return A(h,f);case"undefined":return A(937,f);default:return A(617,f)}}e.$Di=R;function A(h,f){return(f<<5)-f+h|0}e.$Ei=A;function D(h,f){return A(h?433:863,f)}function b(h,f){f=A(149417,f);for(let I=0,p=h.length;I<p;I++)f=A(h.charCodeAt(I),f);return f}e.$Fi=b;function u(h,f){return f=A(104579,f),h.reduce((I,p)=>R(p,I),f)}function c(h,f){return f=A(181387,f),Object.keys(h).sort().reduce((I,p)=>(I=b(p,I),R(h[p],I)),f)}class E{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=R(f,this.g),this.g}}e.$Gi=E;var O;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function m(h,f,I=32){const p=I-f,S=~((1<<p)-1);return(h<<f|(S&h)>>>p)>>>0}function d(h,f=0,I=h.byteLength,p=0){for(let S=0;S<I;S++)h[f+S]=p}function P(h,f,I="0"){for(;h.length<f;)h=I+h;return h}function v(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(I=>I.toString(16).padStart(2,"0")).join(""):P((h>>>0).toString(16),f/4)}e.$Hi=v;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const I=f.length;if(I===0)return;const p=this.p;let S=this.r,s=this.u,o,t;for(s!==0?(o=s,t=-1,s=0):(o=f.charCodeAt(0),t=0);;){let i=o;if(L.$6e(o))if(t+1<I){const n=f.charCodeAt(t+1);L.$7e(n)?(t++,i=L.$8e(o,n)):i=65533}else{s=o;break}else L.$7e(o)&&(i=65533);if(S=this.w(p,S,i),t++,t<I)o=f.charCodeAt(t);else break}this.r=S,this.u=s}w(f,I,p){return p<128?f[I++]=p:p<2048?(f[I++]=192|(p&1984)>>>6,f[I++]=128|(p&63)>>>0):p<65536?(f[I++]=224|(p&61440)>>>12,f[I++]=128|(p&4032)>>>6,f[I++]=128|(p&63)>>>0):(f[I++]=240|(p&1835008)>>>18,f[I++]=128|(p&258048)>>>12,f[I++]=128|(p&4032)>>>6,f[I++]=128|(p&63)>>>0),I>=64&&(this.y(),I-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=$.g,I=this.q;for(let l=0;l<64;l+=4)f.setUint32(l,I.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)f.setUint32(l,m(f.getUint32(l-12,!1)^f.getUint32(l-32,!1)^f.getUint32(l-56,!1)^f.getUint32(l-64,!1),1),!1);let p=this.h,S=this.l,s=this.m,o=this.n,t=this.o,i,n,r;for(let l=0;l<80;l++)l<20?(i=S&s|~S&o,n=1518500249):l<40?(i=S^s^o,n=1859775393):l<60?(i=S&s|S&o|s&o,n=2400959708):(i=S^s^o,n=3395469782),r=m(p,5)+i+t+n+f.getUint32(l*4,!1)&4294967295,t=o,o=s,s=m(S,30),S=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+S&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+t&4294967295}}e.$Ii=$}),define(ne[54],re([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var j;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(j||(j={})),function(R){const A="error",D="warning",b="warn",u="info",c="ignore";function E(m){return m?L.$2e(A,m)?R.Error:L.$2e(D,m)||L.$2e(b,m)?R.Warning:L.$2e(u,m)?R.Info:R.Ignore:R.Ignore}R.fromValue=E;function O(m){switch(m){case R.Error:return A;case R.Warning:return D;case R.Info:return u;default:return c}}R.toString=O}(j||(j={})),e.default=j}),define(ne[30],re([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=void 0;function j(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([I,p])=>{f[I]=p&&typeof p=="object"?j(p):p}),f}e.$4m=j;function R(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const I=f.shift();Object.freeze(I);for(const p in I)if(A.call(I,p)){const S=I[p];typeof S=="object"&&!Object.isFrozen(S)&&!(0,L.$Bf)(S)&&f.push(S)}}return h}e.$5m=R;const A=Object.prototype.hasOwnProperty;function D(h,f){return b(h,f,new Set)}e.$6m=D;function b(h,f,I){if((0,L.$Hf)(h))return h;const p=f(h);if(typeof p<"u")return p;if(Array.isArray(h)){const S=[];for(const s of h)S.push(b(s,f,I));return S}if((0,L.$Af)(h)){if(I.has(h))throw new Error("Cannot clone recursive data-structure");I.add(h);const S={};for(const s in h)A.call(h,s)&&(S[s]=b(h[s],f,I));return I.delete(h),S}return h}function u(h,f,I=!0){return(0,L.$Af)(h)?((0,L.$Af)(f)&&Object.keys(f).forEach(p=>{p in h?I&&((0,L.$Af)(h[p])&&(0,L.$Af)(f[p])?u(h[p],f[p],I):h[p]=f[p]):h[p]=f[p]}),h):f}e.$7m=u;function c(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let I,p;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(I=0;I<h.length;I++)if(!c(h[I],f[I]))return!1}else{const S=[];for(p in h)S.push(p);S.sort();const s=[];for(p in f)s.push(p);if(s.sort(),!c(S,s))return!1;for(I=0;I<S.length;I++)if(!c(h[S[I]],f[S[I]]))return!1}return!0}e.$8m=c;function E(h){const f=new Set;return JSON.stringify(h,(I,p)=>{if((0,L.$Af)(p)||Array.isArray(p)){if(f.has(p))return"[Circular]";f.add(p)}return p})}e.$9m=E;function O(h,f){const I=Object.create(null);return!h||!f||Object.keys(f).forEach(S=>{const s=h[S],o=f[S];c(s,o)||(I[S]=o)}),I}e.$0m=O;function m(h,f){const I=f.toLowerCase(),p=Object.keys(h).find(S=>S.toLowerCase()===I);return p?h[p]:h[f]}e.$$m=m;function d(h,f){const I=Object.create(null);for(const[p,S]of Object.entries(h))f(p,S)&&(I[p]=S);return I}e.$_m=d;function P(h){let f=[];for(;Object.prototype!==h;)f=f.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return f}e.$an=P;function v(h){const f=[];for(const I of P(h))typeof h[I]=="function"&&f.push(I);return f}e.$bn=v;function $(h,f){const I=S=>function(){const s=Array.prototype.slice.call(arguments,0);return f(S,s)},p={};for(const S of h)p[S]=I(S);return p}e.$cn=$}),define(ne[28],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function j(R){return L.test(R)}e.$dg=j,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(b){for(let u=0;u<b.length;u++)b[u]=Math.floor(Math.random()*256);return b};const A=new Uint8Array(16),D=[];for(let b=0;b<256;b++)D.push(b.toString(16).padStart(2,"0"));return function(){R(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,c="";return c+=D[A[u++]],c+=D[A[u++]],c+=D[A[u++]],c+=D[A[u++]],c+="-",c+=D[A[u++]],c+=D[A[u++]],c+="-",c+=D[A[u++]],c+=D[A[u++]],c+="-",c+=D[A[u++]],c+=D[A[u++]],c+="-",c+=D[A[u++]],c+=D[A[u++]],c+=D[A[u++]],c+=D[A[u++]],c+=D[A[u++]],c+=D[A[u++]],c}}()}),define(ne[74],re([0,1,33]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=void 0;const j=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(D){const b=D.replace(/\-/g,":").toLowerCase();return!j.has(b)}function A(){const D=(0,L.networkInterfaces)();for(const b in D){const u=D[b];if(u){for(const{mac:c}of u)if(R(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Om=A}),define(ne[75],re([0,1,33,46,28,74]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=void 0,e.$Pm=new class{c(c){return this.a||(this.a=j.$Uh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(c)}value(){if(this.b===void 0){let c=0,E=0;const O=(0,L.networkInterfaces)();for(const m in O){const d=O[m];if(d)for(const{mac:P,internal:v}of d)v||(E+=1,this.c(P.toUpperCase())&&(c+=1))}this.b=E>0?c/E:0}return this.b}};let D;async function b(c){return D||(D=(async()=>await u(c)||R.$eg())()),D}e.$Qm=b;async function u(c){try{const E=await new Promise((m,d)=>{J(["crypto"],m,d)}),O=(0,A.$Om)();return E.createHash("sha256").update(O,"utf8").digest("hex")}catch(E){c(E);return}}}),define(ne[76],re([7,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[77],re([0,1,76]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=e.$bm=void 0;const j=60,R=j*60,A=R*24,D=A*7,b=A*30,u=A*365;function c(O,m,d,P){typeof O!="number"&&(O=O.getTime());const v=Math.round((new Date().getTime()-O)/1e3);if(v<-30)return(0,L.localize)(0,null,c(new Date().getTime()+v*1e3,!1));if(!P&&v<30)return(0,L.localize)(1,null);let $;return v<j?($=v,m?$===1?d?(0,L.localize)(2,null,$):(0,L.localize)(3,null,$):d?(0,L.localize)(4,null,$):(0,L.localize)(5,null,$):$===1?d?(0,L.localize)(6,null,$):(0,L.localize)(7,null,$):d?(0,L.localize)(8,null,$):(0,L.localize)(9,null,$)):v<R?($=Math.floor(v/j),m?$===1?d?(0,L.localize)(10,null,$):(0,L.localize)(11,null,$):d?(0,L.localize)(12,null,$):(0,L.localize)(13,null,$):$===1?d?(0,L.localize)(14,null,$):(0,L.localize)(15,null,$):d?(0,L.localize)(16,null,$):(0,L.localize)(17,null,$)):v<A?($=Math.floor(v/R),m?$===1?d?(0,L.localize)(18,null,$):(0,L.localize)(19,null,$):d?(0,L.localize)(20,null,$):(0,L.localize)(21,null,$):$===1?d?(0,L.localize)(22,null,$):(0,L.localize)(23,null,$):d?(0,L.localize)(24,null,$):(0,L.localize)(25,null,$)):v<D?($=Math.floor(v/A),m?$===1?(0,L.localize)(26,null,$):(0,L.localize)(27,null,$):$===1?(0,L.localize)(28,null,$):(0,L.localize)(29,null,$)):v<b?($=Math.floor(v/D),m?$===1?d?(0,L.localize)(30,null,$):(0,L.localize)(31,null,$):d?(0,L.localize)(32,null,$):(0,L.localize)(33,null,$):$===1?d?(0,L.localize)(34,null,$):(0,L.localize)(35,null,$):d?(0,L.localize)(36,null,$):(0,L.localize)(37,null,$)):v<u?($=Math.floor(v/b),m?$===1?d?(0,L.localize)(38,null,$):(0,L.localize)(39,null,$):d?(0,L.localize)(40,null,$):(0,L.localize)(41,null,$):$===1?d?(0,L.localize)(42,null,$):(0,L.localize)(43,null,$):d?(0,L.localize)(44,null,$):(0,L.localize)(45,null,$)):($=Math.floor(v/u),m?$===1?d?(0,L.localize)(46,null,$):(0,L.localize)(47,null,$):d?(0,L.localize)(48,null,$):(0,L.localize)(49,null,$):$===1?d?(0,L.localize)(50,null,$):(0,L.localize)(51,null,$):d?(0,L.localize)(52,null,$):(0,L.localize)(53,null,$))}e.$bm=c;function E(O){return O.getFullYear()+"-"+String(O.getMonth()+1).padStart(2,"0")+"-"+String(O.getDate()).padStart(2,"0")+"T"+String(O.getHours()).padStart(2,"0")+":"+String(O.getMinutes()).padStart(2,"0")+":"+String(O.getSeconds()).padStart(2,"0")+"."+(O.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$cm=E}),define(ne[78],re([7,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[34],re([0,1,19,3,78]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=e.$zi=void 0;function A(O,m){return m&&(O.stack||O.stacktrace)?R.localize(0,null,b(O),D(O.stack)||D(O.stacktrace)):b(O)}function D(O){return Array.isArray(O)?O.join(`
`):O}function b(O){return O.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${O.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof O.code=="string"&&typeof O.errno=="number"&&typeof O.syscall=="string"?R.localize(1,null,O.message):O.message||R.localize(2,null)}function u(O=null,m=!1){if(!O)return R.localize(3,null);if(Array.isArray(O)){const d=L.$Hb(O),P=u(d[0],m);return d.length>1?R.localize(4,null,P,d.length):P}if(j.$yf(O))return O;if(O.detail){const d=O.detail;if(d.error)return A(d.error,m);if(d.exception)return A(d.exception,m)}return O.stack?A(O,m):O.message?O.message:R.localize(5,null)}e.$zi=u;function c(O){const m=O;return m instanceof Error&&Array.isArray(m.actions)}e.$Ai=c;function E(O,m){let d;return typeof O=="string"?d=new Error(O):d=O,d.actions=m,d}e.$Bi=E}),define(ne[79],re([7,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ne[80],re([0,1,79]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;function j(R){switch(R){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$up=j}),define(ne[55],re([0,1,13]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=e.TerminateResponseCode=e.Source=void 0;var j;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(j||(e.Source=j={}));var R;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function A(b,...u){const c=u.reduce((m,d)=>(m[d]=!0,m),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!c[m]).forEach(m=>{for(let d=0;d<E.length;d++)if(m.search(E[d])!==-1){delete b[m];break}})}e.$xl=A;function D(b){b&&(delete b.DEBUG,L.$k&&delete b.DYLD_LIBRARY_PATH,L.$l&&delete b.LD_PRELOAD)}e.$yl=D}),define(ne[81],re([0,1,11]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Xp=e.$Wp=e.$Vp=void 0;function j(c){const E=c;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.$Vp=j;function R(c){const E=[];let O;try{const m=JSON.parse(c.arguments),d=m[m.length-1];d&&d.__$stack&&(m.pop(),O=d.__$stack),E.push(...m)}catch{E.push("Unable to log remote console arguments",c.arguments)}return{args:E,stack:O}}e.$Wp=R;function A(c){if(typeof c!="string")return A(R(c).stack);const E=c;if(E){const O=D(E),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(O||"");if(m&&m.length===4)return{uri:L.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$Xp=A;function D(c){if(!c)return c;const E=c.indexOf(`
`);return E===-1?c:c.substring(0,E)}function b(c,E){const{args:O,stack:m}=R(c),d=typeof O[0]=="string"&&O.length===1;let P=D(m);P&&(P=`(${P.trim()})`);let v=[];if(typeof O[0]=="string"?P&&d?v=[`%c[${E}] %c${O[0]} %c${P}`,u("blue"),u(""),u("grey")]:v=[`%c[${E}] %c${O[0]}`,u("blue"),u(""),...O.slice(1)]:v=[`%c[${E}]%`,u("blue"),...O],P&&!d&&v.push(P),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,v)}e.log=b;function u(c){return`color: ${c}`}}),define(ne[47],re([0,1,14,11]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=e.$kh=e.$jh=void 0;function R(u){return JSON.stringify(u,D)}e.$jh=R;function A(u){let c=JSON.parse(u);return c=b(c),c}e.$kh=A;function D(u,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function b(u,c=0){if(!u||c>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return j.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof L.$be||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let E=0;E<u.length;++E)u[E]=b(u[E],c+1);else for(const E in u)Object.hasOwnProperty.call(u,E)&&(u[E]=b(u[E],c+1))}return u}e.$lh=b}),define(ne[82],re([0,1,70,15,13,11]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iC=void 0;class D{constructor(m,d,P){this.id=m,this.dependencies=d,this.callback=P}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,d,P)=>{typeof m!="string"&&(P=d,d=m,m=null),(typeof d!="object"||!Array.isArray(d))&&(P=d,d=null),this.c.push(new D(m,d,P))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const d=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!d)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}h(m){return new Promise((d,P)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const $=()=>{v.removeEventListener("load",h),v.removeEventListener("error",f)},h=I=>{$(),d(this.c.pop())},f=I=>{$(),P(I)};v.addEventListener("load",h),v.addEventListener("error",f),this.f&&(m=this.f.createScriptURL(m)),v.setAttribute("src",m),document.getElementsByTagName("head")[0].appendChild(v)})}i(m){return new Promise((d,P)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),d(this.c.pop())}catch(v){P(v)}})}async j(m){try{const d=globalThis._VSCODE_NODE_MODULES.fs,P=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,$=A.URI.parse(m).fsPath,h=d.readFileSync($).toString(),f=v.wrap(h.replace(/^#!.*/,""));return new P.Script(f).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}const u=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function E(O,m,d){if(L.$T){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[O]&&(O=c[O]);const P=`${O}/${m}`;if(u.has(P))return u.get(P);let v;if(/^\w[\w\d+.-]*:\/\//.test(P))v=P;else{const I=`${d&&!R.$p?j.$_f:j.$$f}/${P}`;v=j.$cg.asBrowserUri(I).toString(!0)}const $=b.INSTANCE.load(v);return u.set(P,$),$}else return await new Promise((P,v)=>{J([O],P,v)})}e.$iC=E}),define(ne[83],re([0,1,33,16,24]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.$vl=void 0;const A=/^\d+$/,D=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var u;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(u||(u={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class O{constructor(S,s,o){this.exePath=S,this.displayName=s,this.a=o}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:p=!1}={}){return p?c===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:p=!1,findPreview:S=!1}={}){const s=m({useAlternateBitness:p});if(!s)return null;const o=j.$jc(s,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(o))return null;let t=-1,i=null;for(const l of await R.Promises.readdir(o)){let k=-1;if(S){const w=l.indexOf("-");if(w<0)continue;const N=l.substring(0,w);if(!A.test(N)||l.substring(w+1)!=="preview")continue;k=parseInt(N,10)}else{if(!A.test(l))continue;k=parseInt(l,10)}if(k<=t)continue;const y=j.$jc(o,l,"pwsh.exe");await R.SymlinkSupport.existsFile(y)&&(i=y,t=k)}if(!i)return null;const n=s.includes("x86")?" (x86)":"",r=S?" Preview":"";return new O(i,`PowerShell${r}${n}`,!0)}async function P({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const S=j.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(S))return null;const{pwshMsixDirRegex:s,pwshMsixName:o}=p?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(S))if(s.test(t)){const i=j.$jc(S,t,"pwsh.exe");return new O(i,o)}return null}function v(){const p=j.$jc(L.homedir(),".dotnet","tools","pwsh.exe");return new O(p,".NET Core PowerShell Global Tool")}function $(){const p=j.$jc(process.env.windir,c===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new O(p,"Windows PowerShell",!0)}async function*h(){let p=await d();p&&(yield p),p=await d({useAlternateBitness:!0}),p&&(yield p),p=await P(),p&&(yield p),p=v(),p&&(yield p),p=await d({findPreview:!0}),p&&(yield p),p=await P({findPreview:!0}),p&&(yield p),p=await d({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=$(),p&&(yield p)}async function*f(){for await(const p of h())await p.exists()&&(yield p)}e.$vl=f;async function I(){for await(const p of f())return p;return null}e.$wl=I}),define(ne[56],re([0,1,16,13,35,55,3,24]),function(J,e,L,j,R,A,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Al=e.$zl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(O=R.env){return O.comspec||"cmd.exe"}e.$zl=u;function c(O){let m=[],d=!1;const P=function(v){if(d){m.push(v);return}(!O.send(v,h=>{if(h&&console.error(h),d=!1,m.length>0){const f=m.slice(0);m=[],f.forEach(I=>P(I))}})||j.$j)&&(d=!0)};return{send:P}}e.$Al=c;var E;(function(O){async function m(d,P,v){if(L.$ic(d))return d;if(P===void 0&&(P=R.cwd()),L.$mc(d)!=="."||(v===void 0&&D.$yf(R.env.PATH)&&(v=R.env.PATH.split(L.$tc)),v===void 0||v.length===0))return L.$jc(P,d);async function h(f){if(await b.Promises.exists(f)){let I;try{I=await b.Promises.stat(f)}catch(p){p.message.startsWith("EACCES")&&(I=await b.Promises.lstat(f))}return I?!I.isDirectory():!1}return!1}for(const f of v){let I;if(L.$ic(f)?I=L.$jc(f,d):I=L.$jc(P,f,d),await h(I))return I;let p=I+".com";if(await h(p)||(p=I+".exe",await h(p)))return p}return L.$jc(P,d)}O.findExecutable=m})(E||(e.win32=E={}))}),define(ne[84],re([0,1,33,13,83,56]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=void 0;async function D(O,m){return O===1?j.$j?E():A.$zl(m):u(O,m)}e.$Bl=D;let b=null;function u(O,m){if(j.$l&&O===2||j.$k&&O===3)return"/bin/bash";if(!b){let d;if(j.$j)d="/bin/bash";else{if(d=m.SHELL,!d)try{d=(0,L.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}b=d}return b}let c=null;async function E(){return c||(c=(await(0,R.$wl)()).exePath),c}});var pe=this&&this.__decorate||function(J,e,L,j){var R=arguments.length,A=R<3?e:j===null?j=Object.getOwnPropertyDescriptor(e,L):j,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,L,j);else for(var b=J.length-1;b>=0;b--)(D=J[b])&&(A=(R<3?D(A):R>3?D(e,L,A):D(e,L))||A);return R>3&&A&&Object.defineProperty(e,L,A),A};define(ne[57],re([0,1,19,8,14,20,52,9,4,2,47,29,3]),function(J,e,L,j,R,A,D,b,u,c,E,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.ProxyChannel=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.RequestInitiator=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=void 0;var d;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(d||(d={}));function P(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(v||(v={}));function $(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(h||(h={}));function f(T){let C=0;for(let B=0;;B+=7){const x=T.read(1);if(C|=(x.buffer[0]&127)<<B,!(x.buffer[0]&128))return C}}const I=t(0);function p(T,C){if(C===0){T.write(I);return}let B=0;for(let Z=C;Z!==0;Z=Z>>>7)B++;const x=R.$be.alloc(B);for(let Z=0;C!==0;Z++)x.buffer[Z]=C&127,C=C>>>7,C>0&&(x.buffer[Z]|=128);T.write(x)}class S{constructor(C){this.b=C,this.a=0}read(C){const B=this.b.slice(this.a,this.a+C);return this.a+=B.byteLength,B}}e.$mh=S;class s{constructor(){this.a=[]}get buffer(){return R.$be.concat(this.a)}write(C){this.a.push(C)}}e.$nh=s;var o;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(o||(o={}));function t(T){const C=R.$be.alloc(1);return C.writeUInt8(T,0),C}const i={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},n=typeof Buffer<"u";function r(T,C){if(typeof C>"u")T.write(i.Undefined);else if(typeof C=="string"){const B=R.$be.fromString(C);T.write(i.String),p(T,B.byteLength),T.write(B)}else if(n&&Buffer.isBuffer(C)){const B=R.$be.wrap(C);T.write(i.Buffer),p(T,B.byteLength),T.write(B)}else if(C instanceof R.$be)T.write(i.VSBuffer),p(T,C.byteLength),T.write(C);else if(Array.isArray(C)){T.write(i.Array),p(T,C.length);for(const B of C)r(T,B)}else if(typeof C=="number"&&(C|0)===C)T.write(i.Uint),p(T,C);else{const B=R.$be.fromString(JSON.stringify(C));T.write(i.Object),p(T,B.byteLength),T.write(B)}}e.$oh=r;function l(T){switch(T.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return T.read(f(T)).toString();case o.Buffer:return T.read(f(T)).buffer;case o.VSBuffer:return T.read(f(T));case o.Array:{const B=f(T),x=[];for(let Z=0;Z<B;Z++)x.push(l(T));return x}case o.Object:return JSON.parse(T.read(f(T)).toString());case o.Int:return f(T)}}e.$ph=l;class k{constructor(C,B,x=null,Z=1e3){this.h=C,this.j=B,this.k=x,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Y=>this.q(Y)),this.m({type:200})}registerChannel(C,B){this.b.set(C,B),setTimeout(()=>this.w(C),0)}m(C){switch(C.type){case 200:{const B=this.o([C.type]);this.k?.logOutgoing(B,0,1,$(C.type));return}case 201:case 202:case 204:case 203:{const B=this.o([C.type,C.id],C.data);this.k?.logOutgoing(B,C.id,1,$(C.type),C.data);return}}}o(C,B=void 0){const x=new s;return r(x,C),r(x,B),this.p(x.buffer)}p(C){try{return this.h.send(C),C.byteLength}catch{return 0}}q(C){const B=new S(C),x=l(B),Z=l(B),Y=x[0];switch(Y){case 100:return this.k?.logIncoming(C.byteLength,x[1],1,`${P(Y)}: ${x[2]}.${x[3]}`,Z),this.s({type:Y,id:x[1],channelName:x[2],name:x[3],arg:Z});case 102:return this.k?.logIncoming(C.byteLength,x[1],1,`${P(Y)}: ${x[2]}.${x[3]}`,Z),this.t({type:Y,id:x[1],channelName:x[2],name:x[3],arg:Z});case 101:return this.k?.logIncoming(C.byteLength,x[1],1,`${P(Y)}`),this.u({type:Y,id:x[1]});case 103:return this.k?.logIncoming(C.byteLength,x[1],1,`${P(Y)}`),this.u({type:Y,id:x[1]})}}s(C){const B=this.b.get(C.channelName);if(!B){this.v(C);return}const x=new A.$Xd;let Z;try{Z=B.call(this.j,C.name,C.arg,x.token)}catch(z){Z=Promise.reject(z)}const Y=C.id;Z.then(z=>{this.m({id:Y,data:z,type:201})},z=>{z instanceof Error?this.m({id:Y,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:Y,data:z,type:203})}).finally(()=>{U.dispose(),this.d.delete(C.id)});const U=(0,c.$Qc)(()=>x.cancel());this.d.set(C.id,U)}t(C){const B=this.b.get(C.channelName);if(!B){this.v(C);return}const x=C.id,Y=B.listen(this.j,C.name,C.arg)(U=>this.m({id:x,data:U,type:204}));this.d.set(C.id,Y)}u(C){const B=this.d.get(C.id);B&&(B.dispose(),this.d.delete(C.id))}v(C){let B=this.g.get(C.channelName);B||(B=[],this.g.set(C.channelName,B));const x=setTimeout(()=>{console.error(`Unknown channel: ${C.channelName}`),C.type===100&&this.m({id:C.id,data:{name:"Unknown channel",message:`Channel name '${C.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:C,timeoutTimer:x})}w(C){const B=this.g.get(C);if(B){for(const x of B)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.s(x.request);break;case 102:this.t(x.request);break}this.g.delete(C)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Nc)(this.d.values()),this.d.clear()}}e.$qh=k;var y;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class w{constructor(C,B=null){this.l=C,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(x=>this.s(x)),this.j=B}getChannel(C){const B=this;return{call(x,Z,Y){return B.a?Promise.reject(new b.$5):B.m(C,x,Z,Y)},listen(x,Z){return B.a?u.Event.None:B.o(C,x,Z)}}}m(C,B,x,Z=A.CancellationToken.None){const Y=this.g++,z={id:Y,type:100,channelName:C,name:B,arg:x};if(Z.isCancellationRequested)return Promise.reject(new b.$5);let a;return new Promise((F,M)=>{if(Z.isCancellationRequested)return M(new b.$5);const X=()=>{const me=de=>{switch(de.type){case 201:this.f.delete(Y),F(de.data);break;case 202:{this.f.delete(Y);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,M(ge);break}case 203:this.f.delete(Y),M(de.data);break}};this.f.set(Y,me),this.p(z)};let W=null;this.b===h.Idle?X():(W=(0,j.$Hg)(me=>this.u()),W.then(()=>{W=null,X()}));const ce=()=>{W?(W.cancel(),W=null):this.p({id:Y,type:101}),M(new b.$5)},oe=Z.onCancellationRequested(ce);a=(0,c.$Pc)((0,c.$Qc)(ce),oe),this.d.add(a)}).finally(()=>{a.dispose(),this.d.delete(a)})}o(C,B,x){const Z=this.g++,U={id:Z,type:102,channelName:C,name:B,arg:x};let z=null;const a=new u.$Nd({onWillAddFirstListener:()=>{z=(0,j.$Hg)(F=>this.u()),z.then(()=>{z=null,this.d.add(a),this.p(U)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(a),this.p({id:Z,type:103}))}}),g=F=>a.fire(F.data);return this.f.set(Z,g),a.event}p(C){switch(C.type){case 100:case 102:{const B=this.q([C.type,C.id,C.channelName,C.name],C.arg);this.j?.logOutgoing(B,C.id,0,`${P(C.type)}: ${C.channelName}.${C.name}`,C.arg);return}case 101:case 103:{const B=this.q([C.type,C.id]);this.j?.logOutgoing(B,C.id,0,P(C.type));return}}}q(C,B=void 0){const x=new s;return r(x,C),r(x,B),this.r(x.buffer)}r(C){try{return this.l.send(C),C.byteLength}catch{return 0}}s(C){const B=new S(C),x=l(B),Z=l(B),Y=x[0];switch(Y){case 200:return this.j?.logIncoming(C.byteLength,0,0,$(Y)),this.t({type:x[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(C.byteLength,x[1],0,$(Y),Z),this.t({type:x[0],id:x[1],data:Z})}}t(C){if(C.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(C.id)?.(C)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Nc)(this.d.values()),this.d.clear()}}e.$rh=w,pe([D.$gh],w.prototype,"onDidInitializePromise",null);class N{get connections(){const C=[];return this.f.forEach(B=>C.push(B)),C}constructor(C){this.a=new Map,this.f=new Set,this.g=new u.$Nd,this.onDidAddConnection=this.g.event,this.h=new u.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new c.$Rc,this.j.add(C(({protocol:B,onDidClientDisconnect:x})=>{const Z=u.Event.once(B.onMessage);this.j.add(Z(Y=>{const U=new S(Y),z=l(U),a=new k(B,z),g=new w(B);this.a.forEach((M,X)=>a.registerChannel(X,M));const F={channelServer:a,channelClient:g,ctx:z};this.f.add(F),this.g.fire(F),this.j.add(x(()=>{a.dispose(),g.dispose(),this.f.delete(F),this.h.fire(F)}))}))}))}getChannel(C,B){const x=this;return{call(Z,Y,U){let z;if((0,m.$Mf)(B)){const g=(0,L.$4b)(x.connections.filter(B));z=g?Promise.resolve(g):u.Event.toPromise(u.Event.filter(x.onDidAddConnection,B))}else z=B.routeCall(x,Z,Y);const a=z.then(g=>g.channelClient.getChannel(C));return _(a).call(Z,Y,U)},listen(Z,Y){if((0,m.$Mf)(B))return x.k(C,B,Z,Y);const U=B.routeEvent(x,Z,Y).then(z=>z.channelClient.getChannel(C));return _(U).listen(Z,Y)}}}k(C,B,x,Z){const Y=this;let U;const z=new u.$Nd({onWillAddFirstListener:()=>{U=new c.$Rc;const a=new u.$Td,g=new Map,F=X=>{const ce=X.channelClient.getChannel(C).listen(x,Z),oe=a.add(ce);g.set(X,oe)},M=X=>{const W=g.get(X);W&&(W.dispose(),g.delete(X))};Y.connections.filter(B).forEach(F),u.Event.filter(Y.onDidAddConnection,B)(F,void 0,U),Y.onDidRemoveConnection(M,void 0,U),a.event(z.fire,z,U),U.add(a)},onDidRemoveLastListener:()=>{U?.dispose(),U=void 0}});return z.event}registerChannel(C,B){this.a.set(C,B);for(const x of this.f)x.channelServer.registerChannel(C,B)}dispose(){this.j.dispose();for(const C of this.f)C.channelClient.dispose(),C.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$sh=N;class H{constructor(C,B,x=null){const Z=new s;r(Z,B),C.send(Z.buffer),this.a=new w(C,x),this.d=new k(C,B,x)}getChannel(C){return this.a.getChannel(C)}registerChannel(C,B){this.d.registerChannel(C,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$th=H;function _(T){return{call(C,B,x){return T.then(Z=>Z.call(C,B,x))},listen(C,B){const x=new u.$Wd;return T.then(Z=>x.input=Z.listen(C,B)),x.event}}}e.$uh=_;function K(T){let C=!1;return{call(B,x,Z){return C?T.call(B,x,Z):(0,j.$Ug)(0).then(()=>C=!0).then(()=>T.call(B,x,Z))},listen(B,x){if(C)return T.listen(B,x);const Z=new u.$Wd;return(0,j.$Ug)(0).then(()=>C=!0).then(()=>Z.input=T.listen(B,x)),Z.event}}}e.$vh=K;class ue{constructor(C){this.a=C}routeCall(C){return this.b(C)}routeEvent(C){return this.b(C)}async b(C){for(const B of C.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await u.Event.toPromise(C.onDidAddConnection),await this.b(C)}}e.$wh=ue;var te;(function(T){function C(Y,U,z){const a=Y,g=z&&z.disableMarshalling,F=new Map;for(const M in a)x(M)&&F.set(M,u.Event.buffer(a[M],!0,void 0,U));return new class{listen(M,X,W){const ce=F.get(X);if(ce)return ce;if(Z(X)){const oe=a[X];if(typeof oe=="function")return oe.call(a,W)}throw new b.$bb(`Event not found: ${X}`)}call(M,X,W){const ce=a[X];if(typeof ce=="function"){if(!g&&Array.isArray(W))for(let me=0;me<W.length;me++)W[me]=(0,E.$lh)(W[me]);let oe=ce.apply(a,W);return oe instanceof Promise||(oe=Promise.resolve(oe)),oe}throw new b.$bb(`Method not found: ${X}`)}}}T.fromService=C;function B(Y,U){const z=U&&U.disableMarshalling;return new Proxy({},{get(a,g){if(typeof g=="string")return U?.properties?.has(g)?U.properties.get(g):Z(g)?function(F){return Y.listen(g,F)}:x(g)?Y.listen(g):async function(...F){let M;U&&!(0,m.$Hf)(U.context)?M=[U.context,...F]:M=F;const X=await Y.call(g,M);return z?X:(0,E.$lh)(X)};throw new b.$bb(`Property not found: ${String(g)}`)}})}T.toService=B;function x(Y){return Y[0]==="o"&&Y[1]==="n"&&O.$1e(Y.charCodeAt(2))}function Z(Y){return/^onDynamic/.test(Y)&&O.$1e(Y.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const C=T.toString();if(C!=="[object Object]")return C}return T}function ie(T){return Array.isArray(T)?T.map(le):le(T)}function q(T,C,B,x,Z,Y,U){U=ie(U);const z=ae[Z],a=z[x%z.length];let g=[`%c[${T}]%c[${String(C).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(Y)?(g=g.concat(U),g.push(")")):g.push(U),console.log.apply(console,g)}class G{constructor(C,B){this.d=C,this.f=B,this.a=0,this.b=0}logOutgoing(C,B,x,Z,Y){this.b+=C,q(this.d,this.b,C,B,x,Z,Y)}logIncoming(C,B,x,Z,Y){this.a+=C,q(this.f,this.a,C,B,x,Z,Y)}}e.$xh=G}),define(ne[85],re([0,1,58,8,14,20,81,9,4,2,30,56,55,57]),function(J,e,L,j,R,A,D,b,u,c,E,O,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=void 0;class P extends d.$qh{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>R.$be.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Zp=P;class v{constructor(h,f){this.i=h,this.j=f,this.c=new Set,this.g=new Map,this.h=new u.$Nd,this.onDidProcessExit=this.h.event;const I=f&&f.timeout?f.timeout:6e4;this.b=new j.$Qg(I),this.d=null,this.f=null}getChannel(h){const f=this;return{call(I,p,S){return f.k(h,I,p,S)},listen(I,p){return f.l(h,I,p)}}}k(h,f,I,p=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const S=this.n(h),s=(0,j.$Hg)(i=>S.call(f,I,i)),o=p.onCancellationRequested(()=>s.cancel()),t=(0,c.$Qc)(()=>s.cancel());return this.c.add(t),s.finally(()=>{o.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(h,f,I){if(!this.b)return u.Event.None;this.b.cancel();let p;const S=new u.$Nd({onWillAddFirstListener:()=>{p=this.n(h).listen(f,I)(S.fire,S),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return S.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,E.$4m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,m.$yl)(f.env),this.d=(0,L.fork)(this.i,h,f);const I=new u.$Nd;u.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,D.$Vp)(n)){(0,D.log)(n,`IPC Library: ${this.j.serverName}`);return}I.fire(R.$be.wrap(Buffer.from(n,"base64")))});const S=this.j.useQueue?(0,O.$Al)(this.d):this.d,s=n=>this.d&&this.d.connected&&S.send(n.buffer.toString("base64")),o=I.event,t={send:s,onMessage:o};this.f=new d.$rh(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",i),this.c.forEach(l=>(0,c.$Nc)(l)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(h){let f=this.g.get(h);return f||(f=this.m.getChannel(h),this.g.set(h,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$1p=v}),define(ne[86],re([0,1,8,4,2,47,3]),function(J,e,L,j,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.StorageState=e.$Yo=e.StorageHint=void 0;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function u(m){const d=m;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$Yo=u;var c;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(c||(e.StorageState=c={}));class E extends R.$Sc{static{this.a=100}constructor(d,P=Object.create(null)){super(),this.r=d,this.s=P,this.b=this.B(new j.$Qd),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new L.$Rg(E.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((P,v)=>this.w(v,P)),d.deleted?.forEach(P=>this.w(P,void 0))}finally{this.b.resume()}}w(d,P){if(this.c===c.Closed)return;let v=!1;(0,D.$Hf)(P)?v=this.f.delete(d):this.f.get(d)!==P&&(this.f.set(d,P),v=!0),v&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,P){const v=this.f.get(d);return(0,D.$Hf)(v)?P:v}getBoolean(d,P){const v=this.get(d);return(0,D.$Hf)(v)?P:v==="true"}getNumber(d,P){const v=this.get(d);return(0,D.$Hf)(v)?P:parseInt(v,10)}getObject(d,P){const v=this.get(d);return(0,D.$Hf)(v)?P:(0,A.$kh)(v)}async set(d,P,v=!1){if(this.c===c.Closed)return;if((0,D.$Hf)(P))return this.delete(d,v);const $=(0,D.$Af)(P)||Array.isArray(P)?(0,A.$jh)(P):String(P);if(this.f.get(d)!==$)return this.f.set(d,$),this.j.set(d,$),this.h.delete(d),this.b.fire({key:d,external:v}),this.D()}async delete(d,P=!1){if(!(this.c===c.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:P}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Zo=E;class O{constructor(){this.onDidChangeItemsExternal=j.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((P,v)=>this.a.set(v,P)),d.delete?.forEach(P=>this.a.delete(P))}async optimize(){}async close(){}}e.$1o=O}),define(ne[87],re([7,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[88],re([7,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],re([7,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],re([7,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[100],re([7,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[101],re([7,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],re([7,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],re([7,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[104],re([7,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],re([7,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],re([7,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],re([7,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],re([0,1,9,90]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.TokenType=void 0;var R;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(R||(e.TokenType=R={}));function A(...c){switch(c.length){case 1:return(0,j.localize)(0,null,c[0]);case 2:return(0,j.localize)(1,null,c[0],c[1]);case 3:return(0,j.localize)(2,null,c[0],c[1],c[2]);default:return}}const D=(0,j.localize)(3,null),b=(0,j.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return E.isTripleEq?"===":"==";case 4:return E.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return E.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return E.lexeme;case 18:return E.lexeme;case 19:return E.lexeme;case 20:return"EOF";default:throw(0,L.$8)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const O=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:O})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const O=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:O})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const O=this.d,m=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:m};this.g.push({offset:O,lexeme:m,additionalInfo:E}),this.f.push(d)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const O=this.c.substring(this.d,this.e),m=u.b.get(O);m?this.k(m):this.f.push({type:17,lexeme:O,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,O=!1,m=!1;for(;;){if(E>=this.c.length){this.e=E,this.l(b);return}const P=this.c.charCodeAt(E);if(O)O=!1;else if(P===47&&!m){E++;break}else P===91?m=!0:P===92?O=!0:P===93&&(m=!1);E++}for(;E<this.c.length&&u.a.has(this.c.charCodeAt(E));)E++;this.e=E;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ji=u}),define(ne[109],re([0,1,77,52,15,16,35,17,11]),function(J,e,L,j,R,A,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=e.$dm=void 0,e.$dm=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,A.$mc)(R.$cg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$jc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,b.$vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,b.$vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,L.$cm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$jc)(this.userDataPath,"logs",d)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.$vg)(u.URI.file((0,A.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.$vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.$vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.$vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=D.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.$jc)(d,"argv.json")):(0,b.$vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,A.$kc)(d):(0,A.$hc)((0,A.$jc)(R.$cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?u.URI.file((0,A.$kc)(d)):u.URI.file((0,A.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,A.$kc)(d);const P=D.env.VSCODE_EXTENSIONS;if(P)return P;const v=D.env.VSCODE_PORTABLE;return v?(0,A.$jc)(v,"extensions"):(0,b.$vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(P=>/^[^:/?#]+?:\/\//.test(P)?u.URI.parse(P):u.URI.file((0,A.$hc)(P)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?u.URI.parse(d):u.URI.file((0,A.$hc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$dm.test(d))}get extensionLogLevel(){const d=[];for(const P of this.args.log||[]){const v=e.$dm.exec(P);v&&v[1]&&v[2]&&d.push([v[1],v[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,b.$vg)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=D.env.VSCODE_PORTABLE;return d?u.URI.file((0,A.$jc)(d,"policy.json")):(0,b.$vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,P,v){this.a=d,this.b=P,this.c=v,this.editSessionId=this.args.editSessionId}}e.$em=c,pe([j.$gh],c.prototype,"appRoot",null),pe([j.$gh],c.prototype,"userHome",null),pe([j.$gh],c.prototype,"userDataPath",null),pe([j.$gh],c.prototype,"appSettingsHome",null),pe([j.$gh],c.prototype,"tmpDir",null),pe([j.$gh],c.prototype,"cacheHome",null),pe([j.$gh],c.prototype,"stateResource",null),pe([j.$gh],c.prototype,"userRoamingDataHome",null),pe([j.$gh],c.prototype,"userDataSyncHome",null),pe([j.$gh],c.prototype,"sync",null),pe([j.$gh],c.prototype,"machineSettingsResource",null),pe([j.$gh],c.prototype,"workspaceStorageHome",null),pe([j.$gh],c.prototype,"localHistoryHome",null),pe([j.$gh],c.prototype,"keyboardLayoutResource",null),pe([j.$gh],c.prototype,"argvResource",null),pe([j.$gh],c.prototype,"isExtensionDevelopment",null),pe([j.$gh],c.prototype,"untitledWorkspacesHome",null),pe([j.$gh],c.prototype,"builtinExtensionsPath",null),pe([j.$gh],c.prototype,"extensionsPath",null),pe([j.$gh],c.prototype,"extensionDevelopmentLocationURI",null),pe([j.$gh],c.prototype,"extensionDevelopmentKind",null),pe([j.$gh],c.prototype,"extensionTestsLocationURI",null),pe([j.$gh],c.prototype,"debugExtensionHost",null),pe([j.$gh],c.prototype,"logLevel",null),pe([j.$gh],c.prototype,"extensionLogLevel",null),pe([j.$gh],c.prototype,"serviceMachineIdResource",null),pe([j.$gh],c.prototype,"disableTelemetry",null),pe([j.$gh],c.prototype,"disableWorkspaceTrust",null),pe([j.$gh],c.prototype,"useInMemorySecretStorage",null),pe([j.$gh],c.prototype,"policyFile",null);function E(m,d){return O(m["inspect-extensions"],m["inspect-brk-extensions"],5870,d,m.debugId,m.extensionEnvironment)}e.$fm=E;function O(m,d,P,v,$,h){const I=Number(d||m)||(v?null:P),p=I?!!d:!1;let S;if(h)try{S=JSON.parse(h)}catch{}return{port:I,break:p,debugId:$,env:S}}e.$gm=O}),function(){"use strict";function J(e,L,j){function R(D,b){const u=A(D,b),c=[u];return e.isAbsolute(u)||c.unshift(j),e.resolve(...c)}function A(D,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,b);const E=D["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(O,"AppData","Roaming")}break;case"darwin":c=e.join(L.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,b)}return{getUserDataPath:R}}if(typeof define=="function")define(ne[110],re([165,33,35]),function(e,L,j){return J(e,L,j.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=J(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],re([0,1,33,109,110]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=void 0;class A extends j.$em{constructor(c,E){super(c,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,R.getUserDataPath)(c,E.nameShort)},E)}}e.$hm=A;function D(u,c){return(0,j.$gm)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}e.$im=D;function b(u,c){return(0,j.$gm)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,c,u.extensionEnvironment)}e.$jm=b}),define(ne[112],re([0,1,3,94]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=void 0;function R(D,b,u,c){try{A(D,b,u,c)}catch(E){D.error(E?.message??E)}return b}e.$vp=R;function A(D,b,u,c){const E=(O,m,d)=>{const P=O[m];if((0,L.$yf)(P)){const v=P,$=v.length;if($>1&&v[0]==="%"&&v[$-1]==="%"){const h=v.substr(1,$-2);let f=u[h];f===void 0&&c&&(f=c[h]);const I=typeof f=="string"?f:f?.message,p=c?.[h],S=typeof p=="string"?p:p?.message;if(!I){S||D.warn(`[${b.name}]: ${(0,j.localize)(0,null,h)}`);return}if(d&&(m==="title"||m==="category")&&S&&S!==I){const s={value:I,original:S};O[m]=s}else O[m]=I}}else if((0,L.$Af)(P))for(const v in P)P.hasOwnProperty(v)&&(v==="commands"?E(P,v,!0):E(P,v,d));else if(Array.isArray(P))for(let v=0;v<P.length;v++)E(P,v,d)};for(const O in b)b.hasOwnProperty(O)&&E(b,O)}}),define(ne[48],re([0,1,17,54,98,42]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function u(h){return h=h.trim(),h==="*"||D.test(h)}e.$Jo=u;function c(h){if(!u(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(D);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$Ko=c;function E(h){if(!h)return null;const f=h.majorBase,I=h.majorMustEqual,p=h.minorBase;let S=h.minorMustEqual;const s=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(f===0||(S=!1),o=!1);let t=0;if(h.preRelease){const i=b.exec(h.preRelease);if(i){const[,n,r,l]=i;t=Date.UTC(Number(n),Number(r)-1,Number(l))}}return{majorBase:f,majorMustEqual:I,minorBase:p,minorMustEqual:S,patchBase:s,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:t}}e.$Lo=E;function O(h,f,I){let p;typeof h=="string"?p=E(c(h)):p=h;let S;f instanceof Date?S=f.getTime():typeof f=="string"&&(S=new Date(f).getTime());let s;if(typeof I=="string"?s=E(c(I)):s=I,!p||!s)return!1;const o=p.majorBase,t=p.minorBase,i=p.patchBase;let n=s.majorBase,r=s.minorBase,l=s.patchBase;const k=s.notBefore;let y=s.majorMustEqual,w=s.minorMustEqual,N=s.patchMustEqual;return s.isMinimum?o>n?!0:o<n?!1:t>r?!0:t<r||S&&S<k?!1:i>=l:(o===1&&n===0&&(!y||!w||!N)&&(n=1,r=0,l=0,y=!0,w=!1,N=!1),o<n?!1:o>n?!y:t<r?!1:t>r?!w:i<l?!1:i>l?!N:!(S&&S<k))}e.$Mo=O;function m(h,f,I,p,S){const s=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return s.push([j.default.Error,R.localize(0,null)]),s;if(typeof p.name!="string")return s.push([j.default.Error,R.localize(1,null,"name")]),s;if(typeof p.version!="string")return s.push([j.default.Error,R.localize(2,null,"version")]),s;if(!p.engines)return s.push([j.default.Error,R.localize(3,null,"engines")]),s;if(typeof p.engines.vscode!="string")return s.push([j.default.Error,R.localize(4,null,"engines.vscode")]),s;if(typeof p.extensionDependencies<"u"&&!$(p.extensionDependencies))return s.push([j.default.Error,R.localize(5,null,"extensionDependencies")]),s;if(typeof p.activationEvents<"u"){if(!$(p.activationEvents))return s.push([j.default.Error,R.localize(6,null,"activationEvents")]),s;if(typeof p.main>"u"&&typeof p.browser>"u")return s.push([j.default.Error,R.localize(7,null,"activationEvents","main","browser")]),s}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&s.push([j.default.Warning,R.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return s.push([j.default.Error,R.localize(9,null,"main")]),s;{const i=(0,L.$vg)(I,p.main);(0,L.$pg)(i,I)||s.push([j.default.Warning,R.localize(10,null,i.path,I.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return s.push([j.default.Error,R.localize(11,null,"browser")]),s;{const i=(0,L.$vg)(I,p.browser);(0,L.$pg)(i,I)||s.push([j.default.Warning,R.localize(12,null,i.path,I.path)])}}if(!A.valid(p.version))return s.push([j.default.Error,R.localize(13,null)]),s;const o=[];if(!d(h,f,p,S,o))for(const i of o)s.push([j.default.Error,i]);return s}e.$No=m;function d(h,f,I,p,S){return p||typeof I.main>"u"&&typeof I.browser>"u"?!0:v(h,f,I.engines.vscode,S)}e.$Oo=d;function P(h,f,I){return h==="*"||v(f,I,h)}e.$Po=P;function v(h,f,I,p=[]){const S=E(c(I));if(!S)return p.push(R.localize(14,null,I)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return p.push(R.localize(15,null,I)),!1}else if(!S.majorMustEqual)return p.push(R.localize(16,null,I)),!1;return O(h,f,S)?!0:(p.push(R.localize(17,null,h,I)),!1)}function $(h){if(!Array.isArray(h))return!1;for(let f=0,I=h.length;f<I;f++)if(typeof h[f]!="string")return!1;return!0}}),define(ne[113],re([0,1,14,28]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=void 0;async function R(A,D,b){let u=b&&b.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const E=(await D.readFile(A.serviceMachineIdResource)).value.toString();u=(0,j.$dg)(E)?E:null}catch{u=null}if(!u){u=(0,j.$eg)();try{await D.writeFile(A.serviceMachineIdResource,L.$be.fromString(u))}catch{}}return b?.store("storage.serviceMachineId",u,-1,1),u}e.$0o=R}),define(ne[49],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class L{constructor(R,A=[],D=!1){this.ctor=R,this.staticArguments=A,this.supportsDelayedInstantiation=D}}e.$Lh=L}),define(ne[114],re([0,1,49]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.InstantiationType=void 0;const j=[];var R;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function A(b,u,c){u instanceof L.$Lh||(u=new L.$Lh(u,[],!!c)),j.push([b,u])}e.$ur=A;function D(){return j}e.$vr=D}),define(ne[115],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;class L{constructor(A,D){this.key=A,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$_p=L;class j{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const D of this.a.values())D.outgoing.size===0&&A.push(D);return A}insertEdge(A,D){const b=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(D);b.outgoing.set(u.key,u),u.incoming.set(b.key,b)}removeNode(A){const D=this.b(A);this.a.delete(D);for(const b of this.a.values())b.outgoing.delete(D),b.incoming.delete(D)}lookupOrInsertNode(A){const D=this.b(A);let b=this.a.get(D);return b||(b=new L(D,A),this.a.set(D,b)),b}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[D,b]of this.a)A.push(`${D}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,D]of this.a){const b=new Set([A]),u=this.c(D,b);if(u)return u}}c(A,D){for(const[b,u]of A.outgoing){if(D.has(b))return[...D,b].join(" -> ");D.add(b);const c=this.c(u,D);if(c)return c;D.delete(b)}}}e.$aq=j}),define(ne[25],re([0,1,3,11,10]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.ConfigurationTarget=e.$ki=e.$ji=e.$ii=void 0,e.$ii=(0,R.$Oh)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof j.URI)}e.$ji=A;function D(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof j.URI)}e.$ki=D;var b;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function u(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$li=u;function c(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$mi=c;function E(h,f){const I=Object.create(null);for(const p in h)O(I,p,h[p],f);return I}e.$ni=E;function O(h,f,I,p){const S=f.split("."),s=S.pop();let o=h;for(let t=0;t<S.length;t++){const i=S[t];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:p(`Ignoring ${f} as ${S.slice(0,t+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[s]=I}catch{p(`Ignoring ${f} as ${S.join(".")} is ${JSON.stringify(o)}`)}else p(`Ignoring ${f} as ${S.join(".")} is ${JSON.stringify(o)}`)}e.$oi=O;function m(h,f){const I=f.split(".");d(h,I)}e.$pi=m;function d(h,f){const I=f.shift();if(f.length===0){delete h[I];return}if(Object.keys(h).indexOf(I)!==-1){const p=h[I];typeof p=="object"&&!Array.isArray(p)&&(d(p,f),Object.keys(p).length===0&&delete h[I])}}function P(h,f,I){function p(o,t){let i=o;for(const n of t){if(typeof i!="object"||i===null)return;i=i[n]}return i}const S=f.split("."),s=p(h,S);return typeof s>"u"?I:s}e.$qi=P;function v(h,f,I){Object.keys(f).forEach(p=>{p!=="__proto__"&&(p in h?L.$Af(h[p])&&L.$Af(f[p])?v(h[p],f[p],I):I&&(h[p]=f[p]):h[p]=f[p])})}e.$ri=v;function $(h){return h.replace(/[\[\]]/g,"")}e.$si=$}),define(ne[116],re([0,1,13,29,108,10,89,9]),function(J,e,L,j,R,A,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.ContextKeyExprType=e.$Ki=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",L.$k),u.set("isLinux",L.$l),u.set("isWindows",L.$j),u.set("isWeb",L.$p),u.set("isMacNative",L.$k&&!L.$p),u.set("isEdge",L.$H),u.set("isFirefox",L.$F),u.set("isChrome",L.$E),u.set("isSafari",L.$G);function c(z,a){if(u.get(z)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(z,a)}e.$Ki=c;const E=Object.prototype.hasOwnProperty;var O;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(O||(e.ContextKeyExprType=O={}));const m={regexParsingWithErrorRecovery:!0},d=(0,D.localize)(0,null),P=(0,D.localize)(1,null),v=(0,D.localize)(2,null),$=(0,D.localize)(3,null),h=(0,D.localize)(4,null),f=(0,D.localize)(5,null),I=(0,D.localize)(6,null),p=(0,D.localize)(7,null);class S{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(a=m){this.k=a,this.d=new R.$Ji,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(a){if(a===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:P});return}this.f=this.d.reset(a).scan(),this.g=0,this.h=[];try{const g=this.l();if(!this.E()){const F=this.D(),M=F.type===17?f:void 0;throw this.h.push({message:h,offset:F.offset,lexeme:R.$Ji.getLexeme(F),additionalInfo:M}),S.c}return g}catch(g){if(g!==S.c)throw g;return}}l(){return this.m()}m(){const a=[this.o()];for(;this.y(16);){const g=this.o();a.push(g)}return a.length===1?a[0]:s.or(...a)}o(){const a=[this.s()];for(;this.y(15);){const g=this.s();a.push(g)}return a.length===1?a[0]:s.and(...a)}s(){if(this.y(2)){const a=this.D();switch(a.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const g=this.l();return this.A(1,$),g?.negate()}case 17:return this.z(),H.create(a.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",a)}}return this.t()}t(){const a=this.D();switch(a.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const g=this.l();return this.A(1,$),g}case 17:{const g=a.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const X=M.lexeme,W=X.lastIndexOf("/"),ce=W===X.length-1?void 0:this.w(X.substring(W+1));let oe;try{oe=new RegExp(X.substring(1,W),ce)}catch{throw this.B("REGEX",M)}return le.create(g,oe)}switch(M.type){case 10:case 19:{const X=[M.lexeme];this.z();let W=this.D(),ce=0;for(let fe=0;fe<M.lexeme.length;fe++)M.lexeme.charCodeAt(fe)===40?ce++:M.lexeme.charCodeAt(fe)===41&&ce--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:ce++;break;case 1:ce--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?ce++:M.lexeme.charCodeAt(fe)===41&&ce--}if(ce<0)break;X.push(R.$Ji.getLexeme(W)),this.z(),W=this.D()}const oe=X.join(""),me=oe.lastIndexOf("/"),de=me===oe.length-1?void 0:this.w(oe.substring(me+1));let ge;try{ge=new RegExp(oe.substring(1,me),de)}catch{throw this.B("REGEX",M)}return s.regex(g,ge)}case 18:{const X=M.lexeme;this.z();let W=null;if(!(0,j.$Be)(X)){const ce=X.indexOf("/"),oe=X.lastIndexOf("/");if(ce!==oe&&ce>=0){const me=X.slice(ce+1,oe),de=X[oe+1]==="i"?"i":"";try{W=new RegExp(me,de)}catch{throw this.B("REGEX",M)}}}if(W===null)throw this.B("REGEX",M);return le.create(g,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const M=this.u();return s.notIn(g,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return s.equals(g,M);switch(M){case"true":return s.has(g);case"false":return s.not(g);default:return s.equals(g,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return s.notEquals(g,M);switch(M){case"true":return s.not(g);case"false":return s.has(g);default:return s.notEquals(g,M)}}case 5:return this.z(),te.create(g,this.u());case 6:return this.z(),ae.create(g,this.u());case 7:return this.z(),K.create(g,this.u());case 8:return this.z(),ue.create(g,this.u());case 13:return this.z(),s.in(g,this.u());default:return s.has(g)}}case 20:throw this.h.push({message:I,offset:a.offset,lexeme:"",additionalInfo:p}),S.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const a=this.D();switch(a.type){case 17:case 18:return this.z(),a.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(a){return a.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(a){return this.C(a)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(a,g){if(this.C(a))return this.z();throw this.B(g,this.D())}B(a,g,F){const M=(0,D.localize)(8,null,a,R.$Ji.getLexeme(g)),X=g.offset,W=R.$Ji.getLexeme(g);return this.h.push({message:M,offset:X,lexeme:W,additionalInfo:F}),S.c}C(a){return this.D().type===a}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Li=S;class s{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(a){return l.create(a)}static equals(a,g){return k.create(a,g)}static notEquals(a,g){return N.create(a,g)}static regex(a,g){return le.create(a,g)}static in(a,g){return y.create(a,g)}static notIn(a,g){return w.create(a,g)}static not(a){return H.create(a)}static and(...a){return G.create(a,null,!0)}static or(...a){return T.create(a,null,!0)}static greater(a,g){return K.create(a,g)}static greaterEquals(a,g){return ue.create(a,g)}static smaller(a,g){return te.create(a,g)}static smallerEquals(a,g){return ae.create(a,g)}static{this.c=new S({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this.c.parse(a)}}e.$Mi=s;function o(z){const a=new S({regexParsingWithErrorRecovery:!1});return z.map(g=>(a.parse(g),a.lexingErrors.length>0?a.lexingErrors.map(F=>({errorMessage:F.additionalInfo?(0,D.localize)(9,null,F.additionalInfo):(0,D.localize)(10,null),offset:F.offset,length:F.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(F=>({errorMessage:F.additionalInfo?`${F.message}. ${F.additionalInfo}`:F.message,offset:F.offset,length:F.lexeme.length})):[]))}e.$Ni=o;function t(z,a){const g=z?z.substituteConstants():void 0,F=a?a.substituteConstants():void 0;return!g&&!F?!0:!g||!F?!1:g.equals(F)}e.$Oi=t;function i(z,a){return z.cmp(a)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return r.INSTANCE}}e.$Pi=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return n.INSTANCE}}e.$Qi=r;class l{static create(a,g=null){const F=u.get(a);return typeof F=="boolean"?F?r.INSTANCE:n.INSTANCE:new l(a,g)}constructor(a,g){this.key=a,this.c=g,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:B(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=u.get(this.key);return typeof a=="boolean"?a?r.INSTANCE:n.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.c||(this.c=H.create(this.key,this)),this.c}}e.$Ri=l;class k{static create(a,g,F=null){if(typeof g=="boolean")return g?l.create(a,F):H.create(a,F);const M=u.get(a);return typeof M=="boolean"?g===(M?"true":"false")?r.INSTANCE:n.INSTANCE:new k(a,g,F)}constructor(a,g,F){this.c=a,this.d=g,this.f=F,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:x(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=u.get(this.c);if(typeof a=="boolean"){const g=a?"true":"false";return this.d===g?r.INSTANCE:n.INSTANCE}return this}evaluate(a){return a.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(a){return a.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Si=k;class y{static create(a,g){return new y(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=10,this.c=null}cmp(a){return a.type!==this.type?this.type-a.type:x(this.d,this.f,a.d,a.f)}equals(a){return a.type===this.type?this.d===a.d&&this.f===a.f:!1}substituteConstants(){return this}evaluate(a){const g=a.getValue(this.f),F=a.getValue(this.d);return Array.isArray(g)?g.includes(F):typeof F=="string"&&typeof g=="object"&&g!==null?E.call(g,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(a){return a.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$Ti=y;class w{static create(a,g){return new w(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=11,this.c=y.create(a,g)}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(a){return a.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ui=w;class N{static create(a,g,F=null){if(typeof g=="boolean")return g?H.create(a,F):l.create(a,F);const M=u.get(a);return typeof M=="boolean"?g===(M?"true":"false")?n.INSTANCE:r.INSTANCE:new N(a,g,F)}constructor(a,g,F){this.c=a,this.d=g,this.f=F,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:x(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=u.get(this.c);if(typeof a=="boolean"){const g=a?"true":"false";return this.d===g?n.INSTANCE:r.INSTANCE}return this}evaluate(a){return a.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(a){return a.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Vi=N;class H{static create(a,g=null){const F=u.get(a);return typeof F=="boolean"?F?n.INSTANCE:r.INSTANCE:new H(a,g)}constructor(a,g){this.c=a,this.d=g,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:B(this.c,a.c)}equals(a){return a.type===this.type?this.c===a.c:!1}substituteConstants(){const a=u.get(this.c);return typeof a=="boolean"?a?n.INSTANCE:r.INSTANCE:this}evaluate(a){return!a.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(a){return a.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Wi=H;function _(z,a){if(typeof z=="string"){const g=parseFloat(z);isNaN(g)||(z=g)}return typeof z=="string"||typeof z=="number"?a(z):n.INSTANCE}class K{static create(a,g,F=null){return _(g,M=>new K(a,M,F))}constructor(a,g,F){this.c=a,this.d=g,this.f=F,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:x(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Xi=K;class ue{static create(a,g,F=null){return _(g,M=>new ue(a,M,F))}constructor(a,g,F){this.c=a,this.d=g,this.f=F,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:x(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Yi=ue;class te{static create(a,g,F=null){return _(g,M=>new te(a,M,F))}constructor(a,g,F){this.c=a,this.d=g,this.f=F,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:x(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Zi=te;class ae{static create(a,g,F=null){return _(g,M=>new ae(a,M,F))}constructor(a,g,F){this.c=a,this.d=g,this.f=F,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:x(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$1i=ae;class le{static create(a,g){return new le(a,g)}constructor(a,g){this.d=a,this.f=g,this.type=7,this.c=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.d<a.d)return-1;if(this.d>a.d)return 1;const g=this.f?this.f.source:"",F=a.f?a.f.source:"";return g<F?-1:g>F?1:0}equals(a){if(a.type===this.type){const g=this.f?this.f.source:"",F=a.f?a.f.source:"";return this.d===a.d&&g===F}return!1}substituteConstants(){return this}evaluate(a){const g=a.getValue(this.d);return this.f?this.f.test(g):!1}serialize(){const a=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${a}`}keys(){return[this.d]}map(a){return a.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$2i=le;class ie{static create(a){return new ie(a)}constructor(a){this.c=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(a){return new ie(this.c.map(a))}negate(){return this.c}}e.$3i=ie;function q(z){let a=null;for(let g=0,F=z.length;g<F;g++){const M=z[g].substituteConstants();if(z[g]!==M&&a===null){a=[];for(let X=0;X<g;X++)a[X]=z[X]}a!==null&&(a[g]=M)}return a===null?z:a}class G{static create(a,g,F){return G.d(a,g,F)}constructor(a,g){this.expr=a,this.c=g,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let g=0,F=this.expr.length;g<F;g++){const M=i(this.expr[g],a.expr[g]);if(M!==0)return M}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let g=0,F=this.expr.length;g<F;g++)if(!this.expr[g].equals(a.expr[g]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:G.create(a,this.c,!1)}evaluate(a){for(let g=0,F=this.expr.length;g<F;g++)if(!this.expr[g].evaluate(a))return!1;return!0}static d(a,g,F){const M=[];let X=!1;for(const W of a)if(W){if(W.type===1){X=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){M.push(...W.expr);continue}M.push(W)}if(M.length===0&&X)return r.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(i);for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];for(;M.length>1;){const W=M[M.length-1];if(W.type!==9)break;M.pop();const ce=M.pop(),oe=M.length===0,me=T.create(W.expr.map(de=>G.create([de,ce],null,F)),null,oe);me&&(M.push(me),M.sort(i))}if(M.length===1)return M[0];if(F){for(let W=0;W<M.length;W++)for(let ce=W+1;ce<M.length;ce++)if(M[W].negate().equals(M[ce]))return n.INSTANCE;if(M.length===1)return M[0]}return new G(M,g)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const g of this.expr)a.push(...g.keys());return a}map(a){return new G(this.expr.map(g=>g.map(a)),null)}negate(){if(!this.c){const a=[];for(const g of this.expr)a.push(g.negate());this.c=T.create(a,this,!0)}return this.c}}e.$4i=G;class T{static create(a,g,F){return T.d(a,g,F)}constructor(a,g){this.expr=a,this.c=g,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let g=0,F=this.expr.length;g<F;g++){const M=i(this.expr[g],a.expr[g]);if(M!==0)return M}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let g=0,F=this.expr.length;g<F;g++)if(!this.expr[g].equals(a.expr[g]))return!1;return!0}return!1}substituteConstants(){const a=q(this.expr);return a===this.expr?this:T.create(a,this.c,!1)}evaluate(a){for(let g=0,F=this.expr.length;g<F;g++)if(this.expr[g].evaluate(a))return!0;return!1}static d(a,g,F){let M=[],X=!1;if(a){for(let W=0,ce=a.length;W<ce;W++){const oe=a[W];if(oe){if(oe.type===0){X=!0;continue}if(oe.type===1)return r.INSTANCE;if(oe.type===9){M=M.concat(oe.expr);continue}M.push(oe)}}if(M.length===0&&X)return n.INSTANCE;M.sort(i)}if(M.length!==0){if(M.length===1)return M[0];for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];if(F){for(let W=0;W<M.length;W++)for(let ce=W+1;ce<M.length;ce++)if(M[W].negate().equals(M[ce]))return r.INSTANCE;if(M.length===1)return M[0]}return new T(M,g)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const g of this.expr)a.push(...g.keys());return a}map(a){return new T(this.expr.map(g=>g.map(a)),null)}negate(){if(!this.c){const a=[];for(const g of this.expr)a.push(g.negate());for(;a.length>1;){const g=a.shift(),F=a.shift(),M=[];for(const X of U(g))for(const W of U(F))M.push(G.create([X,W],null,!1));a.unshift(T.create(M,null,!1))}this.c=T.create(a,this,!0)}return this.c}}e.$5i=T;class C extends l{static{this.d=[]}static all(){return C.d.values()}constructor(a,g,F){super(a,null),this.f=g,typeof F=="object"?C.d.push({...F,key:a}):F!==!0&&C.d.push({key:a,description:F,type:g!=null?typeof g:void 0})}bindTo(a){return a.createKey(this.key,this.f)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return k.create(this.key,a)}notEqualsTo(a){return N.create(this.key,a)}}e.$6i=C,e.$7i=(0,A.$Oh)("contextKeyService");function B(z,a){return z<a?-1:z>a?1:0}function x(z,a,g,F){return z<g?-1:z>g?1:a<F?-1:a>F?1:0}function Z(z,a){if(z.type===0||a.type===1)return!0;if(z.type===9)return a.type===9?Y(z.expr,a.expr):!1;if(a.type===9){for(const g of a.expr)if(Z(z,g))return!0;return!1}if(z.type===6){if(a.type===6)return Y(a.expr,z.expr);for(const g of z.expr)if(Z(g,a))return!0;return!1}return z.equals(a)}e.$8i=Z;function Y(z,a){let g=0,F=0;for(;g<z.length&&F<a.length;){const M=z[g].cmp(a[F]);if(M<0)return!1;M===0&&g++,F++}return g===z.length}function U(z){return z.type===9?z.expr:[z]}}),define(ne[59],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0,e.$Ln=(0,L.$Oh)("downloadService")}),define(ne[18],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=void 0,e.$Vh=(0,L.$Oh)("environmentService"),e.$Wh=(0,L.$Ph)(e.$Vh)}),define(ne[21],re([0,1,92,10]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$8n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=void 0,e.$Un="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Vn=new RegExp(e.$Un),e.$Wn="__web_extension",e.$Xn="skipWalkthrough",e.$Yn="extensionsSync",e.$Zn="dependecyOrPackExtensionInstall";function R(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$1n=R;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$2n=A;function D(f,I){switch(f){case 3:return I==="x64"?"win32-x64":I==="ia32"?"win32-ia32":I==="arm64"?"win32-arm64":"unknown";case 2:return I==="x64"?"linux-x64":I==="arm64"?"linux-arm64":I==="arm"?"linux-armhf":"unknown";case"alpine":return I==="x64"?"alpine-x64":I==="arm64"?"alpine-arm64":"unknown";case 1:return I==="x64"?"darwin-x64":I==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$3n=D;function b(f,I){return I==="web"&&!f.includes("web")}e.$4n=b;function u(f,I,p){return b(I,p)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===p?!0:c(p).includes(f)}e.$5n=u;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$6n=c;function E(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.$7n=E;var O;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(O||(e.SortBy=O={}));var m;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var d;(function(f){f.Install="install",f.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var P;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(P||(e.InstallOperation=P={})),e.$8n=(0,j.$Oh)("extensionGalleryService");var v;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var $;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})($||(e.ExtensionSignaturetErrorCode=$={}));class h extends Error{constructor(I,p){super(I),this.code=p,this.name=p}}e.$9n=h,e.$0n=(0,j.$Oh)("extensionManagementService"),e.$$n="extensionsIdentifiers/disabled",e.$_n="extensionsIdentifiers/enabled",e.$ao=(0,j.$Oh)("IGlobalExtensionEnablementService"),e.$bo=(0,j.$Oh)("IExtensionTipsService"),e.$co=(0,L.localize)(0,null),e.$do={value:e.$co,original:"Extensions"},e.$eo={value:(0,L.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=void 0,e.$cp=(0,L.$Oh)("IExtensionSignatureVerificationService");class j{b(){return this.a||(this.a=new Promise((A,D)=>J(["node-vsce-sign"],async b=>A(b),D))),this.a}async verify(A,D,b){let u;try{u=await this.b()}catch{return!1}return u.verify(A,D,b)}}e.$dp=j}),define(ne[61],re([0,1,14,9,100,12]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;async function D(E,O,m,d,P,v){let $;try{await b(E,O,m,d,P,v)}catch(h){$=h}finally{$&&P.errorTransformer&&($=P.errorTransformer($)),typeof $<"u"&&m.error($),m.end()}}e.$Kp=D;async function b(E,O,m,d,P,v){u(v);const $=await E.open(O,{create:!1});try{u(v);let h=0,f=0,I=P&&typeof P.length=="number"?P.length:void 0,p=L.$be.alloc(Math.min(P.bufferSize,typeof I=="number"?I:P.bufferSize)),S=P&&typeof P.position=="number"?P.position:0,s=0;do f=await E.read($,S,p.buffer,s,p.byteLength-s),S+=f,s+=f,h+=f,typeof I=="number"&&(I-=f),s===p.byteLength&&(await m.write(d(p)),p=L.$be.alloc(Math.min(P.bufferSize,typeof I=="number"?I:P.bufferSize)),s=0);while(f>0&&(typeof I!="number"||I>0)&&u(v)&&c(h,P));if(s>0){let o=s;typeof I=="number"&&(o=Math.min(s,I)),m.write(d(p.slice(0,o)))}}catch(h){throw(0,A.$lk)(h)}finally{await E.close($)}}function u(E){if(E.isCancellationRequested)throw(0,j.$6)();return!0}function c(E,O){if(typeof O?.limits?.size=="number"&&E>O.limits.size)throw(0,A.$kk)((0,R.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],re([0,1,4,166,2,13,167]),function(J,e,L,j,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class b extends R.$Sc{constructor(){super(...arguments),this.a=this.B(new L.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(c){const E=this.j(c),O=E.filter(d=>{const P=this.c.get(d.path);return P?!(0,j.$zj)(P.request.excludes,d.excludes)||!(0,j.$zj)(P.request.includes,d.includes):!0}),m=Array.from(this.c.values()).filter(({request:d})=>!E.find(P=>P.path===d.path&&(0,j.$zj)(P.excludes,d.excludes)&&(0,j.$zj)(P.includes,d.includes))).map(({request:d})=>d.path);O.length&&this.m(`Request to start watching: ${O.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const d of m)this.h(d);for(const d of O)this.g(d)}g(c){const E=new D.$7p(c,m=>this.a.fire(m),m=>this.b.fire(m),this.f),O={request:c,instance:E};this.c.set(c.path,O)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const E=this.c.get(c);E&&(this.c.delete(c),E.instance.dispose())}j(c){const E=new Map;for(const O of c){const m=A.$l?O.path:O.path.toLowerCase();let d=E.get(O.correlationId);d||(d=new Map,E.set(O.correlationId,d)),d.set(m,O)}return Array.from(E.values()).map(O=>Array.from(O.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,E]of this.c)E.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,E){return E?`[File Watcher (node.js)] ${c} (path: ${E.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$9p=b}),define(ne[118],re([0,1,62,117]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class R extends L.$Op{constructor(D,b,u){super(D,b,u),this.s()}r(D){return D.add(new j.$9p)}}e.$0p=R}),define(ne[119],re([0,1,15,57,85,62]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class D extends A.$Pp{constructor(u,c,E){super(u,c,E),this.s()}r(u){const c=u.add(new R.$1p(L.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(c.onDidProcessExit(({code:E,signal:O})=>this.t(`terminated by itself with code ${E}, signal: ${O}`))),j.ProxyChannel.toService((0,j.$vh)(c.getChannel("watcher")))}}e.$2p=D}),define(ne[63],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class L{constructor(...R){this.a=new Map;for(const[A,D]of R)this.set(A,D)}set(R,A){const D=this.a.get(R);return this.a.set(R,A),D}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$Mh=L}),define(ne[120],re([0,1,8,9,2,49,115,10,63,168]),function(J,e,L,j,R,A,D,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;const E=!1;class O extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class m{constructor($=new u.$Mh,h=!1,f,I=E){this.f=$,this.g=h,this.h=f,this.i=I,this.o=new Set,this.f.set(b.$Nh,this),this._globalGraph=I?f?._globalGraph??new D.$aq(p=>p):void 0}createChild($){return new m($,this.g,this,this.i)}invokeFunction($,...h){const f=P.traceInvocation(this.i,$);let I=!1;try{return $({get:S=>{if(I)throw(0,j.$8)("service accessor is only valid during the invocation of its target method");const s=this.m(S,f);if(!s)throw new Error(`[invokeFunction] unknown service '${S}'`);return s}},...h)}finally{I=!0,f.stop()}}createInstance($,...h){let f,I;return $ instanceof A.$Lh?(f=P.traceCreation(this.i,$.ctor),I=this.j($.ctor,$.staticArguments.concat(h),f)):(f=P.traceCreation(this.i,$),I=this.j($,h,f)),f.stop(),I}j($,h=[],f){const I=b._util.getServiceDependencies($).sort((s,o)=>s.index-o.index),p=[];for(const s of I){const o=this.m(s.id,f);o||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${s.id}.`,!1),p.push(o)}const S=I.length>0?I[0].index:h.length;if(h.length!==S){console.trace(`[createInstance] First service dependency of ${$.name} at position ${S+1} conflicts with ${h.length} static arguments`);const s=S-h.length;s>0?h=h.concat(new Array(s)):h=h.slice(0,S)}return Reflect.construct($,h.concat(p))}k($,h){if(this.f.get($)instanceof A.$Lh)this.f.set($,h);else if(this.h)this.h.k($,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const h=this.f.get($);return!h&&this.h?this.h.l($):h}m($,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const f=this.l($);return f instanceof A.$Lh?this.q($,f,h.branch($,!0)):(h.branch($,!1),f)}q($,h,f){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,h,f)}finally{this.o.delete($)}}r($,h,f){const I=new D.$aq(s=>s.id.toString());let p=0;const S=[{id:$,desc:h,_trace:f}];for(;S.length;){const s=S.pop();if(I.lookupOrInsertNode(s),p++>1e3)throw new O(I);for(const o of b._util.getServiceDependencies(s.desc.ctor)){const t=this.l(o.id);if(t||this.u(`[createInstance] ${$} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),t instanceof A.$Lh){const i={id:o.id,desc:t,_trace:s._trace.branch(o.id,!0)};I.insertEdge(s,i),S.push(i)}}}for(;;){const s=I.roots();if(s.length===0){if(!I.isEmpty())throw new O(I);break}for(const{data:o}of s){if(this.l(o.id)instanceof A.$Lh){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}I.removeNode(o)}}return this.l($)}s($,h,f=[],I,p){if(this.f.get($)instanceof A.$Lh)return this.t($,h,f,I,p);if(this.h)return this.h.s($,h,f,I,p);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t($,h,f=[],I,p){if(I){const S=new m(void 0,this.g,this,this.i);S.c=String($);const s=new Map,o=new L.$$g(()=>{const t=S.j(h,f,p);for(const[i,n]of s){const r=t[i];if(typeof r=="function")for(const l of n)r.apply(t,l)}return s.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=s.get(i);return l||(l=new c.$2c,s.set(i,l)),(y,w,N)=>{const H=l.push([y,w,N]);return(0,R.$Qc)(H)}}if(i in t)return t[i];const n=o.value;let r=n[i];return typeof r!="function"||(r=r.bind(n),t[i]=r),r},set(t,i,n){return o.value[i]=n,!0},getPrototypeOf(t){return h.prototype}})}else return this.j(h,f,p)}u($,h){if(h&&console.warn($),this.g)throw new Error($)}}e.$bq=m;var d;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(d||(d={}));class P{static{this.all=new Set}static{this.c=new class extends P{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,h){return $?new P(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):P.c}static traceCreation($,h){return $?new P(1,h.name):P.c}static{this.f=0}constructor($,h){this.type=$,this.name=h,this.g=Date.now(),this.h=[]}branch($,h){const f=new P(3,$.toString());return this.h.push([$,h,f]),f}stop(){const $=Date.now()-this.g;P.f+=$;let h=!1;function f(p,S){const s=[],o=new Array(p+1).join("	");for(const[t,i,n]of S.h)if(i&&n){h=!0,s.push(`${o}CREATES -> ${t}`);const r=f(p+1,n);r&&s.push(r)}else s.push(`${o}uses -> ${t}`);return s.join(`
`)}const I=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${P.f.toFixed(2)}ms)`];($>2||h)&&P.all.add(I.join(`
`))}}e.$cq=P});var se=this&&this.__param||function(J,e){return function(L,j){e(L,j,J)}};define(ne[64],re([0,1,20,2,13,102,21,10]),function(J,e,L,j,R,A,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=e.$Pq=void 0;function u(E){return E.tags.find(O=>O.startsWith("lp-"))?.split("lp-")[1]}e.$Pq=u,e.$Qq=(0,b.$Oh)("languagePackService");let c=class extends j.$Sc{constructor(O){super(),this.c=O}async getAvailableLanguages(){const O=new L.$Xd;setTimeout(()=>O.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},O.token)}catch{return[]}const P=m.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some($=>$.startsWith("lp-"))).map(v=>{const $=v.properties.localizedLanguages?.[0],h=u(v);return{...this.f(h,$,v),extensionId:v.identifier.id,galleryExtension:v}});return P.push(this.f("en","English")),P}f(O,m,d){const P=m??O;let v;if(P!==O&&(v=`(${O})`),O.toLowerCase()===R.$w.toLowerCase()&&(v??="",v+=(0,A.localize)(0,null)),d?.installCount){v??="";const $=d.installCount;let h;$>1e6?h=`${Math.floor($/1e5)/10}M`:$>1e3?h=`${Math.floor($/1e3)}K`:h=String($),v+=` $(cloud-download) ${h}`}return{id:O,label:P,description:v}}};e.$Rq=c,e.$Rq=c=pe([se(0,D.$8n)],c)}),define(ne[6],re([0,1,34,4,41,2,31,13,17,3,11,116,10]),function(J,e,L,j,R,A,D,b,u,c,E,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.log=e.$_i=e.LogLevel=e.$$i=e.$0i=e.$9i=void 0,e.$9i=(0,m.$Oh)("logService"),e.$0i=(0,m.$Oh)("loggerService");function d(){return new Date().toISOString()}function P(y){return(0,c.$Cf)(y)}e.$$i=P;var v;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$_i=v.Info;function $(y,w,N){switch(w){case v.Trace:y.trace(N);break;case v.Debug:y.debug(N);break;case v.Info:y.info(N);break;case v.Warning:y.warn(N);break;case v.Error:y.error(N);break;case v.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=$;function h(y,w=!1){let N="";for(let H=0;H<y.length;H++){let _=y[H];if(_ instanceof Error&&(_=(0,L.$zi)(_,w)),typeof _=="object")try{_=JSON.stringify(_)}catch{}N+=(H>0?" ":"")+_}return N}class f extends A.$Sc{constructor(){super(...arguments),this.b=e.$_i,this.c=this.B(new j.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==v.Off&&this.b<=w}}e.$bj=f;class I extends f{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...N){this.f(v.Trace)&&this.g(v.Trace,h([w,...N],!0))}debug(w,...N){this.f(v.Debug)&&this.g(v.Debug,h([w,...N]))}info(w,...N){this.f(v.Info)&&this.g(v.Info,h([w,...N]))}warn(w,...N){this.f(v.Warning)&&this.g(v.Warning,h([w,...N]))}error(w,...N){if(this.f(v.Error))if(w instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=w.stack,this.g(v.Error,h(H))}else this.g(v.Error,h([w,...N]))}flush(){}}e.$cj=I;class p extends f{constructor(w=e.$_i){super(),this.setLevel(w),this.g=!b.$j}trace(w,...N){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...N):console.log(`[main ${d()}]`,w,...N))}debug(w,...N){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...N):console.log(`[main ${d()}]`,w,...N))}info(w,...N){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,w,...N):console.log(`[main ${d()}]`,w,...N))}warn(w,...N){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,w,...N):console.warn(`[main ${d()}]`,w,...N))}error(w,...N){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,w,...N):console.error(`[main ${d()}]`,w,...N))}dispose(){}flush(){}}e.$dj=p;class S extends f{constructor(w=e.$_i,N=!0){super(),this.g=N,this.setLevel(w)}trace(w,...N){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...N):console.log(w,...N))}debug(w,...N){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...N):console.log(w,...N))}info(w,...N){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...N):console.log(w,...N))}warn(w,...N){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...N):console.log(w,...N))}error(w,...N){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...N):console.error(w,...N))}dispose(){}flush(){}}e.$ej=S;class s extends f{constructor(w,N=e.$_i){super(),this.g=w,this.setLevel(N)}trace(w,...N){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(w),...N])}debug(w,...N){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(w),...N])}info(w,...N){this.f(v.Info)&&this.g.log(v.Info,[this.h(w),...N])}warn(w,...N){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(w),...N])}error(w,...N){this.f(v.Error)&&this.g.log(v.Error,[this.h(w),...N])}h(w){return typeof w=="string"?w:(0,L.$zi)(w,this.f(v.Trace))}dispose(){}flush(){}}e.$fj=s;class o extends f{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const N of this.g)N.setLevel(w);super.setLevel(w)}trace(w,...N){for(const H of this.g)H.trace(w,...N)}debug(w,...N){for(const H of this.g)H.debug(w,...N)}info(w,...N){for(const H of this.g)H.info(w,...N)}warn(w,...N){for(const H of this.g)H.warn(w,...N)}error(w,...N){for(const H of this.g)H.error(w,...N)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$gj=o;class t extends A.$Sc{constructor(w,N,H){if(super(),this.h=w,this.j=N,this.b=new D.$Ac,this.c=this.B(new j.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new j.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new j.$Nd),this.onDidChangeVisibility=this.g.event,H)for(const _ of H)this.b.set(_.resource,{logger:void 0,info:_})}m(w){return(0,c.$yf)(w)?[...this.b.values()].find(N=>N.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,N){const H=this.n(w),_=(0,c.$yf)(w)?w:N?.id??(0,R.$Ci)(H.toString()).toString(16);let K=this.b.get(H)?.logger;const ue=N?.logLevel==="always"?v.Trace:N?.logLevel;K||(K=this.s(H,ue??this.getLogLevel(H)??this.h,{...N,id:_}));const te={logger:K,info:{resource:H,id:_,logLevel:ue,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(te.info),this.b.set(H,te),K}n(w){return(0,c.$yf)(w)?(0,u.$vg)(this.j,`${w}.log`):w}setLogLevel(w,N){if(E.URI.isUri(w)){const H=w,_=N,K=this.b.get(H);K&&_!==K.info.logLevel&&(K.info.logLevel=_===this.h?void 0:_,K.logger?.setLevel(_),this.b.set(K.info.resource,K),this.f.fire([H,_]))}else{this.h=w;for(const[H,_]of this.b.entries())this.b.get(H)?.info.logLevel===void 0&&_.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,N){const H=this.m(w);H&&N!==!H.info.hidden&&(H.info.hidden=!N,this.b.set(H.info.resource,H),this.g.fire([H.info.resource,N]))}getLogLevel(w){let N;return w&&(N=this.b.get(w)?.info.logLevel),N??this.h}registerLogger(w){const N=this.b.get(w.resource);N?N.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const N=this.b.get(w);N&&(N.logger&&N.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$hj=t;class i{constructor(){this.onDidChangeLogLevel=new j.$Nd().event}setLevel(w){}getLevel(){return v.Info}trace(w,...N){}debug(w,...N){}info(w,...N){}warn(w,...N){}error(w,...N){}critical(w,...N){}dispose(){}flush(){}}e.$ij=i;class n extends i{}e.$jj=n;function r(y){if(y.verbose)return v.Trace;if(typeof y.logLevel=="string"){const w=k(y.logLevel.toLowerCase());if(w!==void 0)return w}return e.$_i}e.$kj=r;function l(y){switch(y){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$lj=l;function k(y){switch(y){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$mj=k,e.$nj=new O.$6i("logLevel",l(v.Info))}),define(ne[121],re([0,1,19,8,9,4,2,16,62,6]),function(J,e,L,j,R,A,D,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0;class E extends D.$Sc{constructor(m,d){super(),this.a=m,this.b=d,this.c=this.B(new A.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new j.$Rg(0)),this.w=[],this.y=this.B(new j.$Rg(0))}watch(m,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(m,d):this.z(m,d)}n(m,d){const P={path:this.H(m),excludes:d.excludes,includes:d.includes,recursive:d.recursive,correlationId:d.correlationId},v=(0,L.$Ub)(this.j,P);return this.r(),(0,D.$Qc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,R.$1)(m))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,u.$Qp)(d)),d=>this.G(d),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const d of this.j)(0,u.$Mp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const d of this.j)(0,u.$Mp)(d)&&m.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,d){const P={path:this.H(m),excludes:d.excludes,includes:d.includes,recursive:!1,correlationId:d.correlationId},v=(0,L.$Ub)(this.w,P);return this.C(),(0,D.$Qc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,R.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,u.$Qp)(m)),m=>this.G(m),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,b.$hc)(m.fsPath)}}e.$Up=E}),define(ne[122],re([0,1,19,8,14,20,4,41,65,2,46,15,123,17,45,99,12,61,6,9]),function(J,e,L,j,R,A,D,b,u,c,E,O,m,d,P,v,$,h,f,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;let S=class extends c.$Sc{static{p=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new D.$Nd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$Nd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$Nd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$Nd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$Nd),this.Y=this.B(new D.$Nd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$Nd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new j.$3g)}registerProvider(o,t){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${o}`);const i=new c.$Rc;return this.h.set(o,t),this.c.fire({added:!0,scheme:o,provider:t}),i.add(t.onDidChangeFile(n=>{const r=new $.$qk(n,!this.S(t));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:o}))),(0,c.$Qc)(()=>{this.c.fire({added:!1,scheme:o,provider:t}),this.h.delete(o),(0,c.$Nc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const t=[];this.f.fire({scheme:o,join(i){t.push(i)}}),!this.h.has(o)&&await j.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,t){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return u.Iterable.map(this.h,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async j(o){if(!(0,d.$zg)(o))throw new $.$sk((0,v.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const t=this.h.get(o.scheme);if(!t){const i=new I.$bb;throw i.message=(0,v.localize)(1,null,o.toString()),i}return t}async m(o){const t=await this.j(o);if((0,$.$dk)(t)||(0,$.$ak)(t)||(0,$.$ek)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const t=await this.j(o);if((0,$.$dk)(t)||(0,$.$ak)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.s(o,t)}catch(i){throw(0,$.$nk)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$sk((0,v.localize)(2,null,this.sb(o)),1):(0,$.$lk)(i)}}async s(o,t){const i=await this.j(o),n=this.S(i),r=t?.resolveTo,l=t?.resolveSingleChildDescendants,k=t?.resolveMetadata,y=await i.stat(o);let w;return this.t(i,o,y,void 0,!!k,(N,H)=>(w||(w=E.$Uh.forUris(()=>!n),w.set(o,!0),r&&w.fill(!0,r)),w.get(N.resource)||w.findSuperstr(N.resource.with({query:null,fragment:null}))?!0:N.isDirectory&&l?H===1:!1))}async t(o,t,i,n,r,l){const{providerExtUri:k}=this.R(o),y={resource:t,name:k.basename(t),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Dk)({mtime:i.mtime,size:i.size}),children:void 0};if(y.isDirectory&&l(y,n)){try{const w=await o.readdir(t),N=await j.Promises.settled(w.map(async([H,_])=>{try{const K=k.joinPath(t,H),ue=r?await o.stat(K):{type:_};return await this.t(o,K,ue,w.length,r,l)}catch(K){return this.b.trace(K),null}}));y.children=(0,L.$Hb)(N)}catch(w){this.b.trace(w),y.children=[]}return y}return y}async resolveAll(o){return j.Promises.settled(o.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.j(o),i=await t.stat(o);return this.t(t,o,i,void 0,!0,()=>!1)}async exists(o){const t=await this.j(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.u(o,t)}catch(i){return i}return!0}async u(o,t){if(!t?.overwrite&&await this.exists(o))throw new $.$sk((0,v.localize)(3,null,this.sb(o)),3,t)}async createFile(o,t=R.$be.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,t);return this.r.fire(new $.$pk(o,0,n)),n}async writeFile(o,t,i){const n=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(n);let l=i;if((0,$.$gk)(n)&&!l?.atomic){const k=n.enforceAtomicWriteFile?.(o);k&&(l={...i,atomic:k})}try{await this.w(n,o,l)||await this.U(n,r.dirname(o));let y;if((0,$.$ak)(n)&&!(t instanceof R.$be))if((0,P.$Zd)(t)){const w=await(0,P.$7d)(t,3);w.ended?y=R.$be.concat(w.buffer):y=w}else y=(0,P.$4d)(t,w=>R.$be.concat(w),3);else y=t;!(0,$.$dk)(n)||(0,$.$ak)(n)&&y instanceof R.$be||(0,$.$ak)(n)&&(0,$.$gk)(n)&&l?.atomic?await this.hb(n,o,l,y):await this.db(n,o,l,y instanceof R.$be?(0,R.$me)(y):y),this.r.fire(new $.$pk(o,4))}catch(k){throw new $.$sk((0,v.localize)(4,null,this.sb(o),(0,$.$lk)(k).toString()),(0,$.$ok)(k),l)}return this.resolve(o,{resolveMetadata:!0})}async w(o,t,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,v.localize)(6,null,this.sb(t)));if(!(o.capabilities&2))throw new Error((0,v.localize)(7,null,this.sb(t)));if(n)throw new Error((0,v.localize)(8,null,this.sb(t)))}let l;try{l=await o.stat(t)}catch{return}if(l.type&$.FileType.Directory)throw new $.$sk((0,v.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,l),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$Ck&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==(0,$.$Dk)({mtime:i.mtime,size:l.size}))throw new $.$sk((0,v.localize)(10,null),3,i);return l}async readFile(o,t,i){const n=await this.m(o);return t?.atomic?this.z(n,o,t,i):this.C(n,o,t,i)}async z(o,t,i,n){return new Promise((r,l)=>{this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{try{const k=await this.C(o,t,i,n);r(k)}catch(k){l(k)}})})}async C(o,t,i,n){const r=await this.D(o,t,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,R.$ne)(r.value)}}async readFileStream(o,t,i){const n=await this.m(o);return this.D(n,o,t,i)}async D(o,t,i,n){const r=new A.$Xd(n);let l=i;(0,$.$fk)(o)&&o.enforceAtomicReadFile?.(t)&&(l={...i,atomic:!0});const k=this.J(t,l).then(w=>w,w=>{throw r.dispose(!0),w});let y;try{return typeof l?.etag=="string"&&l.etag!==$.$Ck&&await k,l?.atomic&&(0,$.$fk)(o)||!((0,$.$dk)(o)||(0,$.$ek)(o))||(0,$.$ak)(o)&&l?.preferUnbuffered?y=this.I(o,t,l):(0,$.$ek)(o)?y=this.G(o,t,r.token,l):y=this.H(o,t,r.token,l),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await k,value:y}}catch(w){throw y&&await(0,P.$5d)(y),this.F(w,t,l)}}F(o,t,i){const n=(0,v.localize)(11,null,this.sb(t),(0,$.$lk)(o).toString());return o instanceof $.$uk?new $.$uk(n,o.stat,i):o instanceof $.$tk?new $.$tk(n,o.fileOperationResult,o.size,o.options):new $.$sk(n,(0,$.$ok)(o),i)}G(o,t,i,n=Object.create(null)){const r=o.readFileStream(t,n,i);return(0,P.$$d)(r,{data:l=>l instanceof R.$be?l:R.$be.wrap(l),error:l=>this.F(l,t,n)},l=>R.$be.concat(l))}H(o,t,i,n=Object.create(null)){const r=(0,R.$re)();return(0,h.$Kp)(o,t,r,l=>l,{...n,bufferSize:this.a,errorTransformer:l=>this.F(l,t,n)},i),r}I(o,t,i){const n=(0,P.$2d)(r=>R.$be.concat(r));return(async()=>{try{let r;i?.atomic&&(0,$.$fk)(o)?r=await o.readFile(t,{atomic:!0}):r=await o.readFile(t),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(t,r.byteLength,i),n.end(R.$be.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(o,t){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new $.$sk((0,v.localize)(12,null,this.sb(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==$.$Ck&&t.etag===i.etag)throw new $.$uk((0,v.localize)(13,null),i,t);return this.L(o,i.size,t),i}L(o,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new $.$tk((0,v.localize)(14,null,this.sb(o)),7,t,i)}async canMove(o,t,i){return this.M(o,t,"move",i)}async canCopy(o,t,i){return this.M(o,t,"copy",i)}async M(o,t,i,n){if(o.toString()!==t.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),l=this.qb(await this.n(t),t);await this.Q(r,o,l,t,i,n)}catch(r){return r}return!0}async move(o,t,i){const n=this.qb(await this.n(o),o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"move",!!i),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$pk(o,l==="move"?2:3,k)),k}async copy(o,t,i){const n=await this.m(o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"copy",!!i),k=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$pk(o,l==="copy"?3:2,k)),k}async N(o,t,i,n,r,l){if(t.toString()===n.toString())return r;const{exists:k,isSameResourceWithDifferentPathCase:y}=await this.Q(o,t,i,n,r,l);if(k&&!y&&l&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),r==="copy"){if(o===i&&(0,$.$bk)(o))await o.copy(t,n,{overwrite:l});else{const w=await this.resolve(t);w.isDirectory?await this.P(o,w,i,n):await this.O(o,t,i,n)}return r}else return o===i?(await o.rename(t,n,{overwrite:l}),r):(await this.N(o,t,i,n,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(o,t,i,n){if((0,$.$dk)(o)&&(0,$.$dk)(i))return this.jb(o,t,i,n);if((0,$.$dk)(o)&&(0,$.$ak)(i))return this.pb(o,t,i,n);if((0,$.$ak)(o)&&(0,$.$dk)(i))return this.nb(o,t,i,n);if((0,$.$ak)(o)&&(0,$.$ak)(i))return this.lb(o,t,i,n)}async P(o,t,i,n){await i.mkdir(n),Array.isArray(t.children)&&await j.Promises.settled(t.children.map(async r=>{const l=this.R(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,l):this.O(o,r.resource,i,l)}))}async Q(o,t,i,n,r,l){let k=!1;if(o===i){const{providerExtUri:w,isPathCaseSensitive:N}=this.R(o);if(N||(k=w.isEqual(t,n)),k&&r==="copy")throw new Error((0,v.localize)(15,null,this.sb(t),this.sb(n)));if(!k&&w.isEqualOrParent(n,t))throw new Error((0,v.localize)(16,null,this.sb(t),this.sb(n)))}const y=await this.exists(n);if(y&&!k){if(!l)throw new $.$sk((0,v.localize)(17,null,this.sb(t),this.sb(n)),4);if(o===i){const{providerExtUri:w}=this.R(o);if(w.isEqualOrParent(t,n))throw new Error((0,v.localize)(18,null,this.sb(t),this.sb(n)))}}return{exists:y,isSameResourceWithDifferentPathCase:k}}R(o){const t=this.S(o);return{providerExtUri:t?d.$lg:d.$ng,isPathCaseSensitive:t}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.qb(await this.j(o),o);await this.U(t,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new $.$pk(o,0,i)),i}async U(o,t){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(t,n.dirname(t));)try{if(!((await o.stat(t)).type&$.FileType.Directory))throw new Error((0,v.localize)(19,null,this.sb(t)));break}catch(r){if((0,$.$nk)(r)!==$.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(t)),t=n.dirname(t)}for(let r=i.length-1;r>=0;r--){t=n.joinPath(t,i[r]);try{await o.mkdir(t)}catch(l){if((0,$.$nk)(l)!==$.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(o,t){try{await this.W(o,t)}catch(i){return i}return!0}async W(o,t){const i=this.qb(await this.j(o),o),n=!!t?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,v.localize)(20,null,this.sb(o)));const r=t?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,v.localize)(21,null,this.sb(o)));if(n&&r)throw new Error((0,v.localize)(22,null,this.sb(o)));let l;try{l=await i.stat(o)}catch{}if(l)this.rb(o,l);else throw new $.$sk((0,v.localize)(23,null,this.sb(o)),1);if(!!!t?.recursive){const y=await this.resolve(o);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,v.localize)(24,null,this.sb(o)))}return i}async del(o,t){const i=await this.W(o,t);let n=t;if((0,$.$hk)(i)&&!n?.atomic){const y=i.enforceAtomicDelete?.(o);y&&(n={...t,atomic:y})}const r=!!n?.useTrash,l=!!n?.recursive,k=n?.atomic??!1;await i.delete(o,{recursive:l,useTrash:r,atomic:k}),this.r.fire(new $.$pk(o,1))}async cloneFile(o,t){const i=await this.j(o),n=this.qb(await this.n(t),t);if(i===n&&this.R(i).providerExtUri.isEqual(o,t))return;if(i===n&&(0,$.$ck)(i))return i.cloneFile(o,t);await this.U(n,this.R(n).providerExtUri.dirname(t));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===n&&(0,$.$bk)(i)?r.queue(()=>i.copy(o,t,{overwrite:!0})):r.queue(()=>this.O(i,o,n,t))}static{this.ab=0}createWatcher(o,t){return this.watch(o,{...t,correlationId:p.ab++})}watch(o,t={recursive:!1,excludes:[]}){const i=new c.$Rc;let n=!1,r=()=>{n=!0};i.add((0,c.$Qc)(()=>r())),(async()=>{try{const k=await this.bb(o,t);n?(0,c.$Nc)(k):r=()=>(0,c.$Nc)(k)}catch(k){this.b.error(k)}})();const l=t.correlationId;if(typeof l=="number"){const k=i.add(new D.$Nd);return i.add(this.X.event(w=>{w.correlates(l)&&k.fire(w)})),{onDidChange:k.event,dispose:()=>i.dispose()}}return i}async bb(o,t){const i=await this.j(o),n=(0,b.$Ci)([this.R(i).providerExtUri.getComparisonKey(o),t]);let r=this.$.get(n);return r||(r={count:0,disposable:i.watch(o,t)},this.$.set(n,r)),r.count+=1,(0,c.$Qc)(()=>{r&&(r.count--,r.count===0&&((0,c.$Nc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Nc)(o.disposable);this.$.clear()}async db(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,P.$Zd)(n)||(0,P.$1d)(n)?await this.eb(o,r,n):await this.fb(o,r,n)}catch(l){throw(0,$.$lk)(l)}finally{await o.close(r)}})}async eb(o,t,i){let n=0,r;if((0,P.$1d)(i)){if(i.buffer.length>0){const l=R.$be.concat(i.buffer);await this.gb(o,t,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((l,k)=>{(0,P.$6d)(r,{onData:async y=>{r.pause();try{await this.gb(o,t,y,y.byteLength,n,0)}catch(w){return k(w)}n+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>k(y),onEnd:()=>l()})})}async fb(o,t,i){let n=0,r;for(;(r=i.read())!==null;)await this.gb(o,t,r,r.byteLength,n,0),n+=r.byteLength}async gb(o,t,i,n,r,l){let k=0;for(;k<n;){const y=await o.write(t,r+k,i.buffer,l+k,n-k);k+=y}}async hb(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(()=>this.ib(o,t,i,n))}async ib(o,t,i,n){let r;n instanceof R.$be?r=n:(0,P.$Zd)(n)?r=await(0,R.$ne)(n):(0,P.$1d)(n)?r=await(0,R.$oe)(n):r=(0,R.$le)(n),await o.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(o,t,i,n))}async kb(o,t,i,n){let r,l;try{r=await o.open(t,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const k=R.$be.alloc(this.a);let y=0,w=0,N=0;do N=await o.read(r,y,k.buffer,w,k.byteLength-w),await this.gb(i,l,k,N,y,w),y+=N,w+=N,w===k.byteLength&&(w=0);while(N>0)}catch(k){throw(0,$.$lk)(k)}finally{await j.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async lb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(o,t,i,n))}async mb(o,t,i,n){return i.writeFile(n,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ob(o,t,i,n))}async ob(o,t,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const l=await o.readFile(t);await this.gb(i,r,R.$be.wrap(l),l.byteLength,0,0)}catch(l){throw(0,$.$lk)(l)}finally{await i.close(r)}}async pb(o,t,i,n){const r=await(0,R.$ne)(this.H(o,t,A.CancellationToken.None));await this.hb(i,n,void 0,r)}qb(o,t){if(o.capabilities&2048)throw new $.$sk((0,v.localize)(25,null,this.sb(t)),6);return o}rb(o,t){if((t.permissions??0)&$.FilePermission.Readonly)throw new $.$sk((0,v.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===O.Schemas.file?o.fsPath:o.toString(!0)}};e.$Lp=S,e.$Lp=S=p=pe([se(0,f.$9i)],S)}),define(ne[124],re([0,1,125,169,8,31,14,4,170,2,16,13,17,45,24,101,12,61,121,34,119,118]),function(J,e,L,j,R,A,D,b,u,c,E,O,m,d,P,v,$,h,f,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=void 0,(()=>{try{(0,j.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,I.$zi)(o)}`)}})();class s extends f.$Up{static{this.I=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=b.Event.None,this.N=new A.$Ac(n=>m.$mg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,O.$l&&(this.J|=1024)),this.J}async stat(t){try{const{stat:i,symbolicLink:n}=await P.SymlinkSupport.stat(this.H(t));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:$.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await P.Promises.readdir(this.H(t),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async r=>{try{let l;r.isSymbolicLink()?l=(await this.stat((0,m.$vg)(t,r.name))).type:l=this.M(r),n.push([r.name,l])}catch(l){this.a.trace(l)}})),n}catch(i){throw this.fb(i)}}M(t,i){let n;return i?.dangling?n=$.FileType.Unknown:t.isFile()?n=$.FileType.File:t.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,i&&(n|=$.FileType.SymbolicLink),n}async O(t){const i=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const r=new R.$Sg;return this.N.set(t,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(t)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(t,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),n=await this.O(t));const r=this.H(t);return await P.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{n?.dispose()}}P(t){s.I&&this.a.trace(t)}readFileStream(t,i,n){const r=(0,d.$2d)(l=>D.$be.concat(l.map(k=>D.$be.wrap(k))).buffer);return(0,h.$Kp)(this,t,r,l=>l.buffer,{...i,bufferSize:256*1024},n),r}async writeFile(t,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,m.$vg)((0,m.$ug)(t),`${(0,m.$sg)(t)}${n.atomic.postfix}`),i,n):this.S(t,i,n)}async Q(t){try{const i=this.H(t),{symbolicLink:n}=await P.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(t,i,n,r){const l=new c.$Rc;try{l.add(await this.O(t)),l.add(await this.O(i)),await this.S(i,n,r,!0);try{await this.rename(i,t,{overwrite:!0})}catch(k){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{l.dispose()}}async S(t,i,n,r){let l;try{const k=this.H(t);if(!n.create||!n.overwrite){if(await P.Promises.exists(k)){if(!n.overwrite)throw(0,$.$kk)((0,v.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$kk)((0,v.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:n.unlock},r),await this.write(l,0,i,0,i.byteLength)}catch(k){throw await this.gb(t,k)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){s.Y=t}async open(t,i,n){const r=this.H(t);let l;(0,$.$$j)(i)&&!n&&(l=await this.O(t));let k;try{if((0,$.$$j)(i)&&i.unlock)try{const{stat:w}=await P.SymlinkSupport.stat(r);w.mode&128||await P.Promises.chmod(r,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let y;if((0,$.$$j)(i)){if(O.$j)try{await P.Promises.truncate(r,0),y="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}y||(y="w")}else y="r";k=await P.Promises.open(r,y)}catch(y){throw l?.dispose(),(0,$.$$j)(i)?await this.gb(t,y):this.fb(y)}if(this.U.set(k,0),(0,$.$$j)(i)&&this.X.set(k,t),l){const y=this.W.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${r})`),this.W.set(k,l),y&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${r})`),y.dispose())}return k}async close(t){const i=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&s.Y)try{await P.Promises.fdatasync(t)}catch(n){s.configureFlushOnWrite(!1),this.a.error(n)}return await P.Promises.close(t)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(t)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,n,r,l){const k=this.Z(t,i);let y=null;try{y=(await P.Promises.read(t,n,r,l,k)).bytesRead}catch(w){throw this.fb(w)}finally{this.$(t,k,y)}return y}Z(t,i){return i===this.U.get(t)?null:i}$(t,i,n){const r=this.U.get(t);typeof r=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(t,r+n):this.U.delete(t)))}async write(t,i,n,r,l){return(0,R.$_g)(()=>this.ab(t,i,n,r,l),100,3)}async ab(t,i,n,r,l){const k=this.Z(t,i);let y=null;try{y=(await P.Promises.write(t,n,r,l,k)).bytesWritten}catch(w){throw await this.gb(this.X.get(t),w)}finally{this.$(t,k,y)}return y}async mkdir(t){try{await P.Promises.mkdir(this.H(t))}catch(i){throw this.fb(i)}}async delete(t,i){try{const n=this.H(t);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,E.$jc)((0,E.$mc)(n),`${(0,E.$nc)(n)}${i.atomic.postfix}`)),await P.Promises.rm(n,P.RimRafMode.MOVE,r)}else try{await P.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let l=!1;try{const{stat:k,symbolicLink:y}=await P.SymlinkSupport.stat(n);l=k.isDirectory()&&!y}catch{}if(l)await P.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.fb(n)}}async rename(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"move",n.overwrite),await P.Promises.rename(r,l)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,v.localize)(2,null,(0,E.$nc)(r),(0,E.$nc)((0,E.$mc)(l)),k.toString()))),this.fb(k)}}async copy(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"copy",n.overwrite),await P.Promises.copy(r,l,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,v.localize)(3,null,(0,E.$nc)(r),(0,E.$nc)((0,E.$mc)(l)),k.toString()))),this.fb(k)}}async bb(t,i,n,r){const l=this.H(t),k=this.H(i);let y=!1;if(!!(this.capabilities&1024)||(y=(0,u.$Wf)(l,k,!0)),y){if(n==="copy")throw(0,$.$kk)((0,v.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const N=await this.L(t);if(!N)throw(0,$.$kk)((0,v.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const H=await this.L(i);if(H){if(!r)throw(0,$.$kk)((0,v.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);N.type&$.FileType.File&&H.type&$.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.cb(t,i,!1)}async cb(t,i,n){const r=this.H(t),l=this.H(i),k=!!(this.capabilities&1024);if((0,u.$Wf)(r,l,!k))return;const y=new c.$Rc;try{y.add(await this.O(t)),y.add(await this.O(i)),n&&await P.Promises.mkdir((0,E.$mc)(l),{recursive:!0}),await P.Promises.copyFile(r,l)}catch(w){if(w.code==="ENOENT"&&!n)return this.cb(t,i,!0);throw this.fb(w)}finally{y.dispose()}}t(t,i,n){return new p.$2p(r=>t(r),r=>i(r),n)}F(t,i,n){return new S.$0p(r=>t(r),r=>i(r),n)}fb(t){if(t instanceof $.$jk)return t;let i=t,n;switch(t.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$kk)(i,n)}async gb(t,i){let n=this.fb(i);if(t&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await P.SymlinkSupport.stat(this.H(t));r.mode&128||(n=(0,$.$kk)(i,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$$p=s}),define(ne[126],re([0,1,2,6]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=void 0;class R extends L.$Sc{constructor(D,b=[]){super(),this.a=new j.$gj([D,...b]),this.B(D.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...b){this.a.trace(D,...b)}debug(D,...b){this.a.debug(D,...b)}info(D,...b){this.a.info(D,...b)}warn(D,...b){this.a.warn(D,...b)}error(D,...b){this.a.error(D,...b)}flush(){this.a.flush()}}e.$AN=R}),define(ne[127],re([0,1,12,6]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pN=void 0;var R;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(R||(R={}));async function A(c,E,O,m,d){try{const P=await new Promise(($,h)=>{J(["@vscode/spdlog"],$,h)});P.setFlushOn(R.Trace);const v=await P.createAsyncRotatingLogger(c,E,O,m);return d?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(P){console.error(P)}return null}function D(c,E,O){switch(E){case j.LogLevel.Trace:c.trace(O);break;case j.LogLevel.Debug:c.debug(O);break;case j.LogLevel.Info:c.info(O);break;case j.LogLevel.Warning:c.warn(O);break;case j.LogLevel.Error:c.error(O);break;case j.LogLevel.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function b(c,E){switch(E){case j.LogLevel.Trace:c.setLevel(R.Trace);break;case j.LogLevel.Debug:c.setLevel(R.Debug);break;case j.LogLevel.Info:c.setLevel(R.Info);break;case j.LogLevel.Warning:c.setLevel(R.Warning);break;case j.LogLevel.Error:c.setLevel(R.Error);break;case j.LogLevel.Off:c.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${E}`)}}class u extends j.$cj{constructor(E,O,m,d,P){super(),this.m=[],this.setLevel(P),this.n=this.s(E,O,m,d),this.B(this.onDidChangeLogLevel(v=>{this.r&&b(this.r,v)}))}async s(E,O,m,d){const P=m?6:1,v=30/P*L.$Fk.MB,$=await A(E,O,v,P,d);if($){this.r=$,b(this.r,this.getLevel());for(const{level:h,message:f}of this.m)D(this.r,h,f);this.m=[]}}g(E,O){this.r?D(this.r,E,O):this.getLevel()<=E&&this.m.push({level:E,message:O})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$pN=u}),define(ne[128],re([0,1,28,6,127]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=void 0;class A extends j.$hj{s(b,u,c){return new R.$pN((0,L.$eg)(),b.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,u)}}e.$qN=A}),define(ne[38],re([0,1,4,65,2,10]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=void 0,e.$fn=(0,A.$Oh)("policy");class D extends R.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Nd),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const E=Object.keys(this.f).length;return this.f={...c,...this.f},E!==Object.keys(this.f).length&&await this.j(c),j.Iterable.reduce(this.g.entries(),(O,[m,d])=>({...O,[m]:d}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return j.Iterable.reduce(Object.entries(this.f),(c,[E,O])=>({...c,[E]:{definition:O,value:this.g.get(E)}}),{})}}e.$gn=D;class b{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$hn=b}),define(ne[129],re([0,1,8,4,65,3,12,6,38]),function(J,e,L,j,R,A,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$97b=void 0;function c(O,m){const d=[];for(const P of new Set(R.Iterable.concat(O.keys(),m.keys())))O.get(P)!==m.get(P)&&d.push(P);return d}let E=class extends u.$gn{constructor(m,d,P){super(),this.m=m,this.n=d,this.s=P,this.c=this.B(new L.$Rg(500));const v=j.Event.filter(d.onDidFilesChange,$=>$.affects(m));this.B(d.watch(m)),this.B(v(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const m=new Map;try{const d=await this.n.readFile(this.m),P=JSON.parse(d.value.toString());if(!(0,A.$Af)(P))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(P))this.f[v]&&m.set(v,P[v])}catch(d){d.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",d)}return m}async w(){const m=await this.u(),d=c(this.g,m);this.g=m,d.length>0&&this.h.fire(d)}};e.$97b=E,e.$97b=E=pe([se(1,D.$0j),se(2,b.$9i)],E)}),define(ne[130],re([0,1,38,8,171,2,6]),function(J,e,L,j,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$87b=void 0;let b=class extends L.$gn{constructor(c,E){super(),this.m=c,this.n=E,this.a=new j.$Ng,this.b=this.B(new A.$Tc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((E,O)=>{try{this.b.value=(0,R.createWatcher)(this.n,c,m=>{this.t(m),E()})}catch(m){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),O(m)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const E in c){const O=c[E];O===void 0?this.g.delete(E):this.g.set(E,O)}this.h.fire(Object.keys(c))}};e.$87b=b,e.$87b=b=pe([se(0,D.$9i)],b)}),define(ne[32],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=void 0,e.$oj=(0,L.$Oh)("productService"),e.$pj="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,71,3]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=void 0;class R{constructor(){this.a=new Map}add(D,b){L.ok(j.$yf(D)),L.ok(j.$Af(b)),L.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,b)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$dn=new R}),define(ne[131],re([0,1,4,36]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=void 0,e.$en={JSONContribution:"base.contributions.json"};function R(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class A{constructor(){this.b=new L.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,c){this.a[R(u)]=c,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const D=new A;j.$dn.add(e.$en.JSONContribution,D)}),define(ne[43],re([0,1,19,4,3,88,25,131,36]),function(J,e,L,j,R,A,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.ConfigurationScope=e.$in=e.EditPresentationTypes=void 0;var c;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$in={Configuration:"base.contributions.configuration"};var E;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E||(e.ConfigurationScope=E={})),e.$jn={properties:{},patternProperties:{}},e.$kn={properties:{},patternProperties:{}},e.$ln={properties:{},patternProperties:{}},e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn="vscode://schemas/settings/resourceLanguage",e.$qn="vscode://schemas/settings/configurationDefaults";const O=u.$dn.as(b.$en.JSONContribution);class m{constructor(){this.h=new Set,this.i=new j.$Nd,this.onDidSchemaChange=this.i.event,this.j=new j.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},O.registerSchema(e.$pn,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const t=new Set;this.n(s,o,t),O.registerSchema(e.$pn,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(s){const o=new Set;this.o(s,o),O.registerSchema(e.$pn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const t=new Set;this.o(o,t),this.n(s,!1,t),O.registerSchema(e.$pn,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const t=[];for(const{overrides:i,source:n}of s)for(const r in i)if(o.add(r),e.$sn.test(r)){const l=this.a.get(r),k=l?.valuesSources??new Map;if(n)for(const H of Object.keys(i[r]))k.set(H,n);const y={...l?.value||{},...i[r]};this.a.set(r,{source:n,value:y,valuesSources:k});const w=(0,D.$si)(r),N={type:"object",default:y,description:A.localize(1,null,w),$ref:e.$pn,defaultDefaultValue:y,source:R.$yf(n)?void 0:n,defaultValueSource:n};t.push(...v(r)),this.d[r]=N,this.b.properties[r]=N}else{this.a.set(r,{value:i[r],source:n});const l=this.d[r];l&&(this.w(r,l),this.r(r,l))}this.m(t)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:t,source:i}of s)for(const n in t){const r=this.a.get(n),l=R.$yf(i)?i:i?.id,k=R.$yf(r?.source)?r?.source:r?.source?.id;if(l===k)if(o.add(n),this.a.delete(n),e.$sn.test(n))delete this.d[n],delete this.b.properties[n];else{const y=this.d[n];y&&(this.w(n,y),this.r(n,y))}}this.u()}deltaConfiguration(s){let o=!1;const t=new Set;s.removedDefaults&&(this.l(s.removedDefaults,t),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,t),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,t),s.addedConfigurations&&this.n(s.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,t){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(s,o){const t=i=>{if(i.properties)for(const n in i.properties){o.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>t(n))};for(const i of s){t(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(s,o=!0,t,i,n=3,r){n=R.$Hf(s.scope)?n:s.scope;const l=s.properties;if(l)for(const y in l){const w=l[y];if(o&&I(y,w)){delete l[y];continue}if(w.source=t,w.defaultDefaultValue=l[y].default,this.w(y,w),e.$sn.test(y)?w.scope=void 0:(w.scope=R.$Hf(w.scope)?n:w.scope,w.restricted=R.$Hf(w.restricted)?!!i?.includes(y):w.restricted),l[y].hasOwnProperty("included")&&!l[y].included){this.f[y]=l[y],delete l[y];continue}else this.d[y]=l[y],l[y].policy?.name&&this.e.set(l[y].policy.name,y);!l[y].deprecationMessage&&l[y].markdownDeprecationMessage&&(l[y].deprecationMessage=l[y].markdownDeprecationMessage),r.add(y)}const k=s.allOf;if(k)for(const y of k)this.p(y,o,t,i,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=t=>{const i=t.properties;if(i)for(const r in i)this.r(r,i[r]);t.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$jn.properties[s]=o,o.scope){case 1:e.$kn.properties[s]=o;break;case 2:e.$ln.properties[s]=o;break;case 6:e.$mn.properties[s]=o;break;case 3:e.$nn.properties[s]=o;break;case 4:e.$on.properties[s]=o;break;case 5:e.$on.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$jn.properties[s],o.scope){case 1:delete e.$kn.properties[s];break;case 2:delete e.$ln.properties[s];break;case 6:delete e.$mn.properties[s];break;case 3:delete e.$nn.properties[s];break;case 4:case 5:delete e.$on.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$pn};this.w(o,t),e.$jn.properties[o]=t,e.$kn.properties[o]=t,e.$ln.properties[o]=t,e.$mn.properties[o]=t,e.$nn.properties[o]=t,e.$on.properties[o]=t}}v(){const s={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$pn};e.$jn.patternProperties[e.$rn]=s,e.$kn.patternProperties[e.$rn]=s,e.$ln.patternProperties[e.$rn]=s,e.$mn.patternProperties[e.$rn]=s,e.$nn.patternProperties[e.$rn]=s,e.$on.patternProperties[e.$rn]=s,this.i.fire()}w(s,o){const t=this.a.get(s);let i=t?.value,n=t?.source;R.$Ff(i)&&(i=o.defaultDefaultValue,n=void 0),R.$Ff(i)&&(i=h(o.type)),o.default=i,o.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",P=new RegExp(d,"g");e.$rn=`^(${d})+$`,e.$sn=new RegExp(e.$rn);function v(S){const s=[];if(e.$sn.test(S)){let o=P.exec(S);for(;o?.length;){const t=o[1].trim();t&&s.push(t),o=P.exec(S)}}return(0,L.$Mb)(s)}e.$tn=v;function $(S){return S.reduce((s,o)=>`${s}[${o}]`,"")}e.$un=$;function h(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$vn=h;const f=new m;u.$dn.add(e.$in.Configuration,f);function I(S,s){return S.trim()?e.$sn.test(S)?A.localize(7,null,S):f.getConfigurationProperties()[S]!==void 0?A.localize(8,null,S):s.policy?.name&&f.getPolicyConfigurations().get(s.policy?.name)!==void 0?A.localize(9,null,S,s.policy?.name,f.getPolicyConfigurations().get(s.policy?.name)):null:A.localize(6,null)}e.$wn=I;function p(){const S=[],s=f.getConfigurationProperties();for(const o of Object.keys(s))S.push([o,s[o].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.$xn=p}),define(ne[66],re([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(J,e,L,j,R,A,D,b,u,c,E,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=void 0;function d(o){return Object.isFrozen(o)?o:b.$5m(o)}class P{constructor(t={},i=[],n=[],r){this.b=t,this.c=i,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof P)return i;const n=new v("");return n.parseRaw(i),n.configurationModel});this.f=t.reduce((i,n)=>n===i?n:i.merge(n),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,E.$qi)(this.contents,t):this.contents}inspect(t,i){const n=this.rawConfiguration.getValue(t),r=i?this.rawConfiguration.getOverrideValue(t,i):void 0,l=i?this.rawConfiguration.override(i).getValue(t):n;return{value:n,override:r,merged:l}}getOverrideValue(t,i){const n=this.i(i);return n?t?(0,E.$qi)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const n of this.overrides)n.identifiers.includes(t)&&i.push(...n.keys);return L.$Mb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return L.$Mb(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=b.$4m(this.contents),n=b.$4m(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const k of t)if(l.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(i,k.contents);for(const y of k.overrides){const[w]=n.filter(N=>L.$ub(N.identifiers,y.identifiers));w?(this.h(w.contents,y.contents),w.keys.push(...y.keys),w.keys=L.$Mb(w.keys)):n.push(b.$4m(y))}for(const y of k.keys)r.indexOf(y)===-1&&r.push(y)}return new P(i,r,n,l.every(k=>k instanceof P)?void 0:l)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const r of L.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[r];const k=i[r];k&&(typeof l=="object"&&typeof k=="object"?(l=b.$4m(l),this.h(l,k)):l=k),n[r]=l}return new P(n,this.keys,this.overrides)}h(t,i){for(const n of Object.keys(i)){if(n in t&&u.$Af(t[n])&&u.$Af(i[n])){this.h(t[n],i[n]);continue}t[n]=b.$4m(i[n])}}i(t){let i=null,n=null;const r=l=>{l&&(n?this.h(n,l):n=b.$4m(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?i=l.contents:l.identifiers.includes(t)&&r(l.contents);return r(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,E.$pi)(this.contents,t),O.$sn.test(t)&&this.overrides.splice(this.overrides.findIndex(n=>L.$ub(n.identifiers,(0,O.$tn)(t))),1))}j(t,i,n){(0,E.$oi)(this.contents,t,i,r=>console.error(r)),n=n||this.keys.indexOf(t)===-1,n&&this.keys.push(t),O.$sn.test(t)&&this.overrides.push({identifiers:(0,O.$tn)(t),keys:Object.keys(this.contents[t]),contents:(0,E.$ni)(this.contents[t],r=>console.error(r))})}}e.$yn=P;class v{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new P}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!u.$Hf(t)){const n=this.g(t);this.parseRaw(n,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:n,keys:r,overrides:l,restricted:k,hasExcludedProperties:y}=this.h(t,i);this.b=new P(n,r,l,y?[t]:void 0),this.c=k||[]}g(t){let i={},n=null,r=[];const l=[],k=[];function y(N){Array.isArray(r)?r.push(N):n!==null&&(r[n]=N)}const w={onObjectBegin:()=>{const N={};y(N),l.push(r),r=N,n=null},onObjectProperty:N=>{n=N},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const N=[];y(N),l.push(r),r=N,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:y,onError:(N,H,_)=>{k.push({error:N,offset:H,length:_})}};if(t)try{R.$1m(t,w),i=r[0]||{}}catch(N){console.error(`Error while parsing settings file ${this.f}: ${N}`),this.d=[N]}return i}h(t,i){const n=m.$dn.as(O.$in.Configuration).getConfigurationProperties(),r=this.i(t,n,!0,i);t=r.raw;const l=(0,E.$ni)(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),k=Object.keys(t),y=this.j(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:l,keys:k,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(t,i,n,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const k={},y=[];for(const w in t)if(O.$sn.test(w)&&n){const N=this.i(t[w],i,!1,r);k[w]=N.raw,l=l||N.hasExcludedProperties,y.push(...N.restricted)}else{const N=i[w],H=N?typeof N.scope<"u"?N.scope:3:void 0;N?.restricted&&y.push(w),!r.exclude?.includes(w)&&(r.include?.includes(w)||(H===void 0||r.scopes===void 0||r.scopes.includes(H))&&!(r.skipRestricted&&N?.restricted))?k[w]=t[w]:l=!0}return{raw:k,restricted:y,hasExcludedProperties:l}}j(t,i){const n=[];for(const r of Object.keys(t))if(O.$sn.test(r)){const l={};for(const k in t[r])l[k]=t[r][k];n.push({identifiers:(0,O.$tn)(r),keys:Object.keys(l),contents:(0,E.$ni)(l,i)})}return n}}e.$zn=v;class $ extends A.$Sc{constructor(t,i,n,r){super(),this.c=t,this.f=i,this.g=r,this.b=this.B(new j.$Nd),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(j.Event.any(j.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),j.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&n.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new P}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$An=$;class h{constructor(t,i,n,r,l,k,y,w,N,H,_,K,ue){this.a=t,this.b=i,this.c=n,this.overrideIdentifiers=r,this.d=l,this.f=k,this.g=y,this.h=w,this.i=N,this.j=H,this.k=_,this.l=K,this.m=ue}get value(){return d(this.c)}n(t,i,n){const r=t.inspect(i,n);return{get value(){return d(r.value)},get override(){return d(r.override)},get merged(){return d(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(t,i,n,r,l=new P,k=new P,y=new D.$Ac,w=new P,N=new D.$Ac){this.c=t,this.d=i,this.f=n,this.g=r,this.h=l,this.i=k,this.j=y,this.l=w,this.m=N,this.a=null,this.b=new D.$Ac,this.n=null}getValue(t,i,n){return this.q(t,i,n).getValue(t)}updateValue(t,i,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new P,this.m.set(n.resource,r))):r=this.l,i===void 0?r.removeValue(t):r.setValue(t,i),n.resource||(this.a=null)}inspect(t,i,n){const r=this.q(t,i,n),l=this.u(i.resource,n),k=i.resource?this.m.get(i.resource)||this.l:this.l,y=new Set;for(const w of r.overrides)for(const N of w.identifiers)r.getOverrideValue(t,N)!==void 0&&y.add(N);return new h(t,i,r.getValue(t),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,l||void 0,k)}keys(t){const i=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=[];if(!i){const{added:r,updated:l,removed:k}=S(this.c,t);i=[...r,...l,...k]}for(const r of i)for(const l of(0,O.$tn)(r)){const k=this.c.getKeysForOverrideIdentifier(l),y=t.getKeysForOverrideIdentifier(l),w=[...y.filter(N=>k.indexOf(N)===-1),...k.filter(N=>y.indexOf(N)===-1),...k.filter(N=>!b.$8m(this.c.override(l).getValue(N),t.override(l).getValue(N)))];n.push([l,w])}return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:n,removed:r}=S(this.d,t),l=[...i,...n,...r];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=S(this.applicationConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateApplicationConfiguration(t),{keys:k,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=S(this.localUserConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateLocalUserConfiguration(t),{keys:k,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=S(this.remoteUserConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateRemoteUserConfiguration(t),{keys:k,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=S(this.workspaceConfiguration,t),k=[...i,...n,...r];return k.length&&this.updateWorkspaceConfiguration(t),{keys:k,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const n=this.p.get(t),{added:r,updated:l,removed:k,overrides:y}=S(n,i),w=[...r,...l,...k];return(w.length||!n)&&this.updateFolderConfiguration(t,i),{keys:w,overrides:y}}compareAndDeleteFolderConfiguration(t){const i=this.p.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:l,overrides:k}=S(i,void 0);return{keys:[...n,...r,...l],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,i,n){let r=this.r(i,n);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(r=r.merge(this.d)),r}r({resource:t},i){let n=this.s();if(i&&t){const r=i.getFolder(t);r&&(n=this.t(r.uri)||n);const l=this.m.get(t);l&&(n=n.merge(l))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let i=this.b.get(t);if(!i){const n=this.s(),r=this.j.get(t);r?(i=n.merge(r),this.b.set(t,i)):i=n}return i}u(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:n,overrides:r,keys:l}=this.j.get(i);return t.push([i,{contents:n,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(n=>t.add(n))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}w(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.x(t.defaults),n=this.x(t.policy),r=this.x(t.application),l=this.x(t.user),k=this.x(t.workspace),y=t.folders.reduce((w,N)=>(w.set(c.URI.revive(N[0]),this.x(N[1])),w),new D.$Ac);return new f(i,n,r,l,new P,k,y,new P,new D.$Ac)}static x(t){return new P(t.contents,t.keys,t.overrides)}}e.$Bn=f;function I(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const r of o)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,k])=>{const y=(0,D.$xc)(i,l,new Set);k.forEach(w=>y.add(w))});const n=[];return i.forEach((r,l)=>n.push([l,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.$Cn=I;class p{constructor(t,i,n,r){this.change=t,this.f=i,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const k of l)this.affectedKeys.add(k);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(t,i){const n=this.a+t,r=this.d.indexOf(n);if(r<0)return!1;const l=r+n.length;if(l>=this.d.length)return!1;const k=this.d.charCodeAt(l);if(k!==this.b&&k!==this.c)return!1;if(i){const y=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,w=this.g.getValue(t,i,this.h);return!b.$8m(y,w)}return!0}}e.$Dn=p;function S(o,t){const{added:i,removed:n,updated:r}=s(t?.rawConfiguration,o?.rawConfiguration),l=[],k=o?.getAllOverrideIdentifiers()||[],y=t?.getAllOverrideIdentifiers()||[];if(t){const w=y.filter(N=>!k.includes(N));for(const N of w)l.push([N,t.getKeysForOverrideIdentifier(N)])}if(o){const w=k.filter(N=>!y.includes(N));for(const N of w)l.push([N,o.getKeysForOverrideIdentifier(N)])}if(t&&o){for(const w of k)if(y.includes(w)){const N=s({contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)},{contents:t.getOverrideValue(void 0,w)||{},keys:t.getKeysForOverrideIdentifier(w)});l.push([w,[...N.added,...N.removed,...N.updated]])}}return{added:i,removed:n,updated:r,overrides:l}}function s(o,t){const i=o?t?o.keys.filter(l=>t.keys.indexOf(l)===-1):[...o.keys]:[],n=t?o?t.keys.filter(l=>o.keys.indexOf(l)===-1):[...t.keys]:[],r=[];if(o&&t){for(const l of t.keys)if(o.keys.indexOf(l)!==-1){const k=(0,E.$qi)(t.contents,l),y=(0,E.$qi)(o.contents,l);b.$8m(k,y)||r.push(l)}}return{added:i,removed:n,updated:r}}}),define(ne[132],re([0,1,19,4,2,30,3,66,43,6,38,36]),function(J,e,L,j,R,A,D,b,u,c,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=void 0;class m extends R.$Sc{constructor(){super(...arguments),this.a=this.B(new j.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new b.$yn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(O.$dn.as(u.$in.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:h})=>this.c(Array.from($),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,h){this.h($,O.$dn.as(u.$in.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new b.$yn;const $=O.$dn.as(u.$in.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,h){const f=this.f();for(const I of $){const p=f[I],S=h[I];p!==void 0?this.b.addValue(I,p):S?this.b.addValue(I,S.default):this.b.removeValue(I)}}}e.$En=m;class d{constructor(){this.onDidChangeConfiguration=j.Event.None,this.configurationModel=new b.$yn}async initialize(){return this.configurationModel}}e.$Fn=d;let P=class extends R.$Sc{get configurationModel(){return this.b}constructor($,h,f){super(),this.c=$,this.f=h,this.g=f,this.a=this.B(new j.$Nd),this.onDidChangeConfiguration=this.a.event,this.b=new b.$yn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const h={},f=[],I=O.$dn.as(u.$in.Configuration).getConfigurationProperties();for(const p of $){const S=I[p];if(!S){f.push(p);continue}if(S.policy){if(S.type!=="string"&&S.type!=="number"){this.g.warn(`Policy ${S.policy.name} has unsupported type ${S.type}`);continue}f.push(p),h[S.policy.name]={type:S.type}}}return(0,D.$Lf)(h)||await this.f.updatePolicyDefinitions(h),f}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const h=O.$dn.as(u.$in.Configuration).getPolicyConfigurations(),f=(0,L.$Hb)($.map(I=>h.get(I)));this.m(f,!0)}m($,h){this.g.trace("PolicyConfiguration#update",$);const f=O.$dn.as(u.$in.Configuration).getConfigurationProperties(),I=[],p=this.b.isEmpty();for(const S of $){const s=f[S]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(p?o!==void 0:!(0,A.$8m)(this.b.getValue(S),o))&&I.push([S,o])}else this.b.getValue(S)!==void 0&&I.push([S,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const S=this.b;this.b=new b.$yn;for(const s of S.keys)this.b.setValue(s,S.getValue(s));for(const[s,o]of I)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);h&&this.a.fire(this.b)}}};e.$Gn=P,e.$Gn=P=pe([se(1,E.$fn),se(2,c.$9i)],P)}),define(ne[133],re([0,1,8,4,2,17,25,66,132,38]),function(J,e,L,j,R,A,D,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0;class E extends R.$Sc{constructor(m,d,P,v){super(),this.j=m,this.h=this.B(new j.$Nd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$En),this.c=P instanceof c.$hn?new u.$Fn:this.B(new u.$Gn(this.b,P,v)),this.f=this.B(new b.$An(this.j,{},A.$mg,d)),this.a=new b.$Bn(this.b.configurationModel,this.c.configurationModel,new b.$yn,new b.$yn),this.g=this.B(new L.$6g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:h})=>this.n($,h))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,d,P]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new b.$Bn(m,d,new b.$yn,P)}getConfigurationData(){return this.a.toData()}getValue(m,d){const P=typeof m=="string"?m:void 0,v=(0,D.$ji)(m)?m:(0,D.$ji)(d)?d:{};return this.a.getValue(P,v,void 0)}updateValue(m,d,P,v){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.m(m)}m(m){const d=this.a.toData(),P=this.a.compareAndUpdateLocalUserConfiguration(m);this.s(P,d,2)}n(m,d){const P=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(m,d);this.s(v,P,7)}r(m){const d=this.a.toData(),P=this.a.compareAndUpdatePolicyConfiguration(m);this.s(P,d,7)}s(m,d,P){const v=new b.$Dn(m,{data:d},this.a);v.source=P,v.sourceConfig=this.t(P),this.h.fire(v)}t(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Hn=E}),define(ne[67],re([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=void 0;function j(c){return c.scheme===L.Schemas.vscodeRemote?c.authority:void 0}e.$Tk=j;function R(c){if(!c)return;const E=c.indexOf("+");return E<0?c:c.substr(0,E)}e.$Uk=R;function A(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Vk=A;function D(c){const{host:E,port:O}=u(c);if(typeof O>"u")throw new Error("Remote authority doesn't contain a port!");return{host:E,port:O}}e.$Wk=D;function b(c,E){let{host:O,port:m}=u(c);return typeof m>"u"&&(m=E),{host:O,port:m}}e.$Xk=b;function u(c){const E=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const O=c.match(/^(\[[0-9a-z:]+\])$/);if(O)return{host:O[1],port:void 0};const m=c.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:c,port:void 0}}}),define(ne[37],re([0,1,29,10,67]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.TargetPlatform=e.ExtensionType=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=void 0,e.$Xl="extensions.user.cache",e.$Yl="extensions.builtin.cache",e.$Zl="undefined_publisher",e.$1l=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$2l=A,e.$3l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(D||(e.ExtensionType=D={}));var b;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class u{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,h){if(typeof $>"u"||$===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof $=="string"||typeof h=="string"){const f=typeof $=="string"?$:$.value,I=typeof h=="string"?h:h.value;return L.$2e(f,I)}return $._lower===h._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$4l=u;class c{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const h of $)this.add(h)}add($){this.c.add(u.toKey($))}delete($){return this.c.delete(u.toKey($))}has($){return this.c.has(u.toKey($))}}e.$5l=c;class E{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(u.toKey($))}get($){return this.c.get(u.toKey($))}has($){return this.c.has(u.toKey($))}set($,h){this.c.set(u.toKey($),h)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$6l=E;function O(v){return m(v)}e.$7l=O;function m(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$8l=m;function d(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$9l=d;function P(v,$){if($){const h=`onResolveRemoteAuthority:${(0,R.$Uk)($)}`;return!!v.activationEvents?.includes(h)}return!1}e.$0l=P,e.$$l=(0,j.$Oh)("IBuiltinExtensionsScannerService")}),define(ne[134],re([0,1,2,37,12]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;class A extends L.$Sc{constructor(b,u,c,E,O){super(),this.a=b,this.b=u,this.c=c,this.f=O,this.B(E.onDidInstallExtensions(m=>this.g(m))),this.B(E.onDidUninstallExtension(m=>this.h(m)))}g(b){for(const u of b)u.local&&this.invalidate(u.profileLocation)}h(b){b.error||this.invalidate(b.profileLocation)}async invalidate(b){if(b)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,b)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(b){try{await this.b.del(this.c.extUri.joinPath(b.cacheHome,j.$Xl))}catch(u){(0,R.$ok)(u)!==1&&this.f.error(u)}}}e.$Ep=A}),define(ne[44],re([0,1,14,9,2,103,43,10,6,36]),function(J,e,L,j,R,A,D,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=void 0,e.$Qo=(0,b.$Oh)("requestService");class E{constructor(S){this.b=S}toJSON(){if(!this.a){const S=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?S[s]="*****":S[s]=this.b[s];this.a=S}return this.a}}class O extends R.$Sc{constructor(S){super(),this.b=0,this.a=S.createLogger("network",{name:(0,A.localize)(0,null),when:u.$nj.isEqualTo((0,u.$lj)(u.LogLevel.Trace)).serialize()})}async c(S,s,o){const t=`${S} #${++this.b}: ${s.url}`;this.a.trace(`${t} - begin`,s.type,new E(s.headers??{}));try{const i=await o();return this.a.trace(`${t} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,s.type,(0,j.$0)(i)),i}}}e.$Ro=O;function m(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$So=m;function d(p){return p.res.statusCode===204}e.$To=d;async function P(p){return d(p)?null:(await(0,L.$ne)(p.stream)).toString()}e.$Uo=P;async function v(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);return P(p)}e.$Vo=v;async function $(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);if(d(p))return null;const s=(await(0,L.$ne)(p.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$Wo=$;function h(p){I(p)}e.$Xo=h;let f;function I(p){const S=c.$dn.as(D.$in.Configuration),s=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},S.updateConfigurations({add:[f],remove:s?[s]:[]})}I(1)}),define(ne[135],re([0,1,20,15,12,44]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=void 0;let D=class{constructor(u,c){this.a=u,this.b=c}async download(u,c,E=L.CancellationToken.None){if(u.scheme===j.Schemas.file||u.scheme===j.Schemas.vscodeRemote){await this.b.copy(u,c);return}const O={type:"GET",url:u.toString(!0)},m=await this.a.request(O,E);if(m.res.statusCode===200)await this.b.writeFile(c,m.stream);else{const d=await(0,A.$Vo)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${d}`)}}};e.$PN=D,e.$PN=D=pe([se(0,A.$Qo),se(1,R.$0j)],D)}),define(ne[136],re([0,1,137,3]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;function R(D,b){return D.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:D.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function A(D,b,u={}){const c=(0,L.parse)(D),E=u.proxyUrl||R(c,b);if(!E)return null;const O=(0,L.parse)(E);if(!/^https?:$/.test(O.protocol||""))return null;const m={host:O.hostname||"",port:O.port||(O.protocol==="https"?"443":"80"),auth:O.auth,rejectUnauthorized:(0,j.$Ef)(u.strictSSL)?u.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((d,P)=>{J(["http-proxy-agent"],d,P)}))(m):new(await new Promise((d,P)=>{J(["https-proxy-agent"],d,P)}))(m)}e.$Vq=A}),define(ne[138],re([0,1,58,16,104,20,34,9,13,28,84,172,8,72]),function(J,e,L,j,R,A,D,b,u,c,E,O,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=void 0;let P;async function v(h,f,I,p){return I["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$j?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,O.$Ll)(p)&&!I["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,O.$Ll)(p)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),P||(P=m.Promises.withAsyncBody(async(S,s)=>{const o=new A.$Xd;let t=1e4;const i=h.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,d.$Ml)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),s(new Error((0,R.localize)(0,null)))},t);try{S(await $(f,o.token))}catch(r){!(0,b.$4)(r)&&!o.token.isCancellationRequested?s(new Error((0,R.localize)(1,null,(0,D.$zi)(r)))):S({})}finally{clearTimeout(n),o.dispose()}})),P)}e.$Rl=v;async function $(h,f){const I=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",I);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",p);const S=(0,c.$eg)().replace(/-/g,"").substr(0,12),s=new RegExp(S+"({.*})"+S),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",o);const t=await(0,E.$Bl)(u.OS,o);return h.trace("getUnixShellEnvironment#shell",t),new Promise((i,n)=>{if(f.isCancellationRequested)return n(new b.$5);const r=(0,j.$nc)(t);let l,k;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' ${y} -p '''${S}'' + JSON.stringify(process.env) + ''${S}'''`,k=["-Login","-Command"]):r==="nu"?(l=`^'${process.execPath}' ${y} -p '"${S}" + JSON.stringify(process.env) + "${S}"'`,k=["-i","-l","-c"]):(l=`'${process.execPath}' ${y} -p '"${S}" + JSON.stringify(process.env) + "${S}"'`,r==="tcsh"||r==="csh"?k=["-ic"]:k=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),l);const w=(0,L.spawn)(t,[...k,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(w.kill(),n(new b.$5))),w.on("error",_=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,D.$zi)(_)),n(_)});const N=[];w.stdout.on("data",_=>N.push(_));const H=[];w.stderr.on("data",_=>H.push(_)),w.on("close",(_,K)=>{const ue=Buffer.concat(N).toString("utf8");h.trace("getUnixShellEnvironment#raw",ue);const te=Buffer.concat(H).toString("utf8");if(te.trim()&&h.trace("getUnixShellEnvironment#stderr",te),_||K)return n(new Error((0,R.localize)(2,null,_,K)));const ae=s.exec(ue),le=ae?ae[1]:"{}";try{const ie=JSON.parse(le);I?ie.ELECTRON_RUN_AS_NODE=I:delete ie.ELECTRON_RUN_AS_NODE,p?ie.ELECTRON_NO_ATTACH_CONSOLE=p:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.VSCODE_RESOLVING_ENVIRONMENT,delete ie.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",ie),i(ie)}catch(ie){h.error("getUnixShellEnvironment#errorCaught",(0,D.$zi)(ie)),n(ie)}})})}}),define(ne[139],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=e.$rN=void 0,e.$rN=(0,L.$Oh)("stateReadService"),e.$sN=(0,L.$Oh)("stateService")}),define(ne[68],re([0,1,8,14,2,3,18,12,6]),function(J,e,L,j,R,A,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=e.$tN=e.SaveStrategy=void 0;var c;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class E extends R.$Sc{constructor(P,v,$,h){super(),this.h=P,this.j=$,this.m=h,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=v===0?void 0:this.B(new L.$Rg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(P){P.fileOperationResult!==1&&this.j.error(P)}}getItem(P,v){const $=this.a[P];return(0,A.$Hf)($)?v:$}setItem(P,v){this.setItems([{key:P,data:v}])}setItems(P){let v=!1;for(const{key:$,data:h}of P)this.a[$]!==h&&((0,A.$Hf)(h)?(0,A.$Ff)(this.a[$])||(this.a[$]=void 0,v=!0):(this.a[$]=h,v=!0));v&&this.r()}removeItem(P){(0,A.$Ff)(this.a[P])||(this.a[P]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const P=JSON.stringify(this.a,null,4);if(P!==this.b)try{await this.m.writeFile(this.h,j.$be.fromString(P),{atomic:{postfix:".vsctmp"}}),this.b=P}catch(v){this.j.error(v)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$tN=E;let O=class extends R.$Sc{constructor(P,v,$,h){super(),this.a=this.B(new E(v.stateResource,P,$,h))}async init(){await this.a.init()}getItem(P,v){return this.a.getItem(P,v)}};e.$uN=O,e.$uN=O=pe([se(1,D.$Vh),se(2,u.$9i),se(3,b.$0j)],O);class m extends O{setItem(P,v){this.a.setItem(P,v)}setItems(P){this.a.setItems(P)}removeItem(P){this.a.removeItem(P)}close(){return this.a.close()}}e.$vN=m}),define(ne[69],re([0,1,13,35,28]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=void 0;function A(u){if(L.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function D(u,c,E,O,m,d,P,v){const $=Object.create(null);$["common.machineId"]=d,$.sessionID=(0,R.$eg)()+Date.now(),$.commitHash=O,$.version=m,$["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,L.$i)(L.$u),$["common.nodePlatform"]=j.$dc,$["common.nodeArch"]=E,$["common.product"]=v||"desktop",P&&($["common.msftInternal"]=P);let h=0;const f=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),L.$m&&($["common.snap"]="true");const I=A(c);return I&&($["common.platformDetail"]=I),$}e.$fo=D;function b(u){const c=j.env.USERDNSDOMAIN;if(!c)return!1;const E=c.toLowerCase();return u.some(O=>E===O)}e.$go=b}),define(ne[26],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=void 0,e.$bl=(0,L.$Oh)("telemetryService"),e.$cl=(0,L.$Oh)("customEndpointTelemetryService"),e.$dl="telemetry.currentSessionDate",e.$el="telemetry.firstSessionDate",e.$fl="telemetry.lastSessionDate",e.$gl="telemetry.machineId",e.$hl="telemetry",e.$il="telemetry.telemetryLevel",e.$jl="telemetry.enableCrashReporter",e.$kl="telemetry.enableTelemetry";var j;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(j||(e.TelemetryLevel=j={}));var R;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ne[39],re([0,1,30,3,4,25,67,69,26]),function(J,e,L,j,R,A,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$ho=c;class E{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$io=E,e.$jo=new E;class O{async publicLog(n,r,l){}async publicLogError(n,r,l){}}e.$ko=O,e.$lo="telemetry",e.$mo="extensionTelemetryLog",e.$no={log:()=>null,flush:()=>Promise.resolve(null)};function m(i,n){return R.Event.debounce(n.onDidChangeConfiguration,(l,k)=>{const y=l?new Set([...l.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:y}},1e3,!0)(l=>{l.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,A.$li)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$oo=m;function d(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$po=d;function P(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$qo=P;function v(i){const n=i.getValue(u.$il),r=i.getValue(u.$jl);if(i.getValue(u.$kl)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$ro=v;function $(i){const n={},r={},l={};I(i,l);for(let k in l){k=k.length>150?k.substr(k.length-149):k;const y=l[k];typeof y=="number"?r[k]=y:typeof y=="boolean"?r[k]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${y.length}`),n[k]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(n[k]=y)}return{properties:n,measurements:r}}e.$so=$;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(i){if(!i)return"none";const n=(0,D.$Uk)(i);return h.has(n)?n:"other"}e.$to=f;function I(i,n,r=0,l){if(i)for(const k of Object.getOwnPropertyNames(i)){const y=i[k],w=l?l+k:k;Array.isArray(y)?n[w]=(0,L.$9m)(y):y instanceof Date?n[w]=y.toISOString():(0,j.$Af)(y)?r<2?I(y,n,r+1,w+"."):n[w]=(0,L.$9m)(y):n[w]=y}}function p(i,n){const r=i.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,b.$go)(r)||l}e.$uo=p;function S(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$vo=S;function s(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const l=[];for(const N of n)for(;;){const H=N.exec(i);if(!H)break;l.push([H.index,N.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(r="";;){const N=y.exec(i);if(!N)break;const H=l.some(([_,K])=>N.index<K&&_<y.lastIndex);!k.test(N[0])&&!H&&(r+=i.substring(w,N.index)+"<REDACTED: user-file-path>",w=y.lastIndex)}return w<i.length&&(r+=i.substr(w)),r}function o(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function t(i,n){return(0,L.$6m)(i,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let l=r.replaceAll("%20"," ");l=s(l,n);for(const k of n)l=l.replace(k,"");return l=o(l),l}})}e.$wo=t}),define(ne[27],re([0,1,29,21,37,13,11,9,35,39]),function(J,e,L,j,R,A,D,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=void 0;function E(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,L.$We)(t.id,i.id)===0}e.$xo=E;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(i){const n=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new m(i.identifier,n,r)}static parse(i){const n=O.exec(i);return n&&n[1]&&n[2]?new m({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof m?E(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$yo=m;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function P(t){const i=d.exec(t);return i&&i[1]?[$(i[1]),i[2]]:[$(t),void 0]}e.$zo=P;function v(t,i){return`${t}.${i}`}e.$Ao=v;function $(t){return t.toLowerCase()}e.$Bo=$;function h(t,i){return $(v(t??R.$Zl,i))}e.$Co=h;function f(t,i){const n=[],r=l=>{for(const k of n)if(k.some(y=>E(i(y),i(l))))return k;return null};for(const l of t){const k=r(l);k?k.push(l):n.push([l])}return n}e.$Do=f;function I(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$Eo=I;function p(t){return{id:new c.$ho(t.identifier.id),name:new c.$ho(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Fo=p,e.$Go=new R.$4l("pprice.better-merge");function S(t,i){const n=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&n.every(k=>!E(k.identifier,{id:l}))){const k=t.filter(y=>E(y.identifier,{id:l}));k.length===1&&(n.push(k[0]),r.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Ho=S;async function s(t,i){if(!A.$l)return!1;let n;try{n=(await t.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await t.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,b.$0)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(t,i){const n=await s(t,i),r=(0,j.$3n)(n?"alpine":A.$u,u.$ec);return i.debug("ComputeTargetPlatform:",r),r}e.$Io=o}),define(ne[140],re([0,1,20,9,15,17,42,11,93,21,27,37]),function(J,e,L,j,R,A,D,b,u,c,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=void 0;const m=$=>(0,u.localize)(0,null,$),d=(0,u.localize)(1,null,"ms-dotnettools.csharp");function P($,h){return h?`${$.publisher}.${$.name}@${$.version}`:`${$.publisher}.${$.name}`}let v=class{constructor(h,f,I){this.a=h,this.b=f,this.d=I}get f(){}async listExtensions(h,f,I){let p=await this.b.getInstalled(1,I);const S=O.$3l.map(o=>o.toLowerCase());if(f&&f!==""){if(S.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(o=>o.manifest.categories?o.manifest.categories.map(i=>i.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),S.forEach(o=>{this.a.info(o)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),p=p.sort((o,t)=>o.identifier.id.localeCompare(t.identifier.id));let s;for(const o of p)s!==o.identifier.id&&(s=o.identifier.id,this.a.info(P(o.manifest,h)))}async installExtensions(h,f,I,p){const S=[];try{const s=[];h.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const o=[];let t=[];const i=(r,l,k)=>{t.push({id:r,version:l!=="prerelease"?l:void 0,installOptions:{...I,isBuiltin:k,installPreReleaseVersion:l==="prerelease"||I.installPreReleaseVersion}})};for(const r of h)if(r instanceof b.URI)o.push({vsix:r,installOptions:I});else{const[l,k]=(0,E.$zo)(r);i(l,k,!1)}for(const r of f)if(r instanceof b.URI)o.push({vsix:r,installOptions:{...I,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,k]=(0,E.$zo)(r);i(l,k,!0)}const n=await this.b.getInstalled(1,I.profileLocation);if(o.length&&await Promise.all(o.map(async({vsix:r,installOptions:l})=>{try{const k=await this.g(r,l,p,n);k&&s.push(k)}catch(k){this.a.error(k),S.push(r.toString())}})),t.length&&(t=t.filter(({id:r,version:l})=>{const k=n.find(y=>(0,E.$xo)(y.identifier,{id:r}));if(k){if(!p&&(!l||l==="prerelease"&&k.preRelease))return this.a.info((0,u.localize)(5,null,r,k.manifest.version,r)),!1;if(l&&k.manifest.version===l)return this.a.info((0,u.localize)(6,null,`${r}@${l}`)),!1}return!0}),t.length)){const r=await this.h(t);await Promise.all(t.map(async l=>{const k=r.get(l.id.toLowerCase());if(k)try{const y=await this.j(l,k,n);y&&s.push(y)}catch(y){this.a.error(y.message||y.stack||y),S.push(l.id)}else this.a.error(`${m(l.version?`${l.id}@${l.version}`:l.id)}
${d}`),S.push(l.id)}))}}catch(s){throw this.a.error((0,u.localize)(7,null,(0,j.$0)(s))),s}if(S.length)throw new Error((0,u.localize)(8,null,S.join(", ")))}async g(h,f,I,p){const S=await this.b.getManifest(h);if(!S)throw new Error("Invalid vsix");if(await this.l(S,I,f.profileLocation,p))try{return await this.b.install(h,f),this.a.info((0,u.localize)(9,null,(0,A.$sg)(h))),S}catch(o){if((0,j.$4)(o))return this.a.info((0,u.localize)(10,null,(0,A.$sg)(h))),null;throw o}return null}async h(h){const f=new Map,I=h.some(s=>s.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),S=[];for(const s of h)c.$Vn.test(s.id)&&S.push({...s,preRelease:I});if(S.length){const s=await this.d.getExtensions(S,{targetPlatform:p},L.CancellationToken.None);for(const o of s)f.set(o.identifier.id.toLowerCase(),o)}return f}async j({id:h,version:f,installOptions:I},p,S){const s=await this.d.getManifest(p,L.CancellationToken.None);if(s&&!this.k(s))return null;const o=S.find(t=>(0,E.$xo)(t.identifier,p.identifier));if(o){if(p.version===o.manifest.version)return this.a.info((0,u.localize)(11,null,f?`${h}@${f}`:h)),null;this.a.info((0,u.localize)(12,null,h,p.version))}try{I.isBuiltin?this.a.info(f?(0,u.localize)(13,null,h,f):(0,u.localize)(14,null,h)):this.a.info(f?(0,u.localize)(15,null,h,f):(0,u.localize)(16,null,h));const t=await this.b.installFromGallery(p,{...I,installGivenVersion:!!f});return this.a.info((0,u.localize)(17,null,h,t.manifest.version)),s}catch(t){if((0,j.$4)(t))return this.a.info((0,u.localize)(18,null,h)),null;throw t}}k(h){return!0}async l(h,f,I,p){if(!f){const S={id:(0,E.$Co)(h.publisher,h.name)},s=p.find(o=>(0,E.$xo)(S,o.identifier)&&(0,D.gt)(o.manifest.version,h.version));if(s)return this.a.info((0,u.localize)(19,null,s.identifier.id,s.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,f,I){const p=async s=>{if(s instanceof b.URI){const o=await this.b.getManifest(s);return P(o)}return s},S=[];for(const s of h){const o=await p(s),i=(await this.b.getInstalled(void 0,I)).filter(n=>(0,E.$xo)(n.identifier,{id:o}));if(!i.length)throw new Error(`${this.m(o)}
${d}`);if(i.some(n=>n.type===0)){this.a.info((0,u.localize)(20,null,o));return}if(!f&&i.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(21,null,o));return}this.a.info((0,u.localize)(22,null,o));for(const n of i)await this.b.uninstall(n,{profileLocation:I}),S.push(n);this.f?this.a.info((0,u.localize)(23,null,o,this.f)):this.a.info((0,u.localize)(24,null,o))}}async locateExtension(h){const f=await this.b.getInstalled();h.forEach(I=>{f.forEach(p=>{if(p.identifier.id===I&&p.location.scheme===R.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(h){return this.f?(0,u.localize)(25,null,h,this.f):(0,u.localize)(26,null,h)}};e.$ep=v,e.$ep=v=pe([se(1,c.$0n),se(2,c.$8n)],v)}),define(ne[141],re([0,1,4,2,31,27,37]),function(J,e,L,j,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=void 0;class b extends j.$Sc{constructor(c,E,O,m,d,P,v){super(),this.f=c,this.g=E,this.h=O,this.j=m,this.m=d,this.n=P,this.r=v,this.a=this.B(new L.$Nd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new j.$1c),this.s().then(null,$=>v.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(E=>(this.c.set(E.id,(0,j.$Pc)(this.n.watch(this.m.extUri.dirname(E.extensionsResource)),this.n.watch(E.extensionsResource))),this.G(E.extensionsResource))))}catch(E){throw this.r.error(E),E}}async w(c){for(const E of c.extensions)this.I(this.L(E.identifier,E.version),c.profileLocation)}async y(c){for(const E of c.extensions){const O=this.L(E.identifier,E.version);c.error?this.J(O,c.profileLocation):this.I(O,c.profileLocation)}}async z(c){for(const E of c.extensions)this.J(this.L(E.identifier,E.version),c.profileLocation)}async C(c){const E=[],O=[];for(const m of c.extensions){const d=this.L(m.identifier,m.version);c.error?this.I(d,c.profileLocation):(this.J(d,c.profileLocation),this.b.has(d)||(this.r.debug("Extension is removed from all profiles",m.identifier.id,m.version),O.push(this.f.scanInstalledExtensionAtLocation(m.location).then(P=>{P?E.push(P):this.r.info("Extension not found at the location",m.location.toString())},P=>this.r.error(P)))))}try{await Promise.all(O),E.length&&await this.H(E)}catch(m){this.r.error(m)}}D(c){for(const E of this.h.profiles)c.contains(E.extensionsResource,0,1)&&this.F(E.extensionsResource)}async F(c){const E=[],O=[],m=await this.j.scanProfileExtensions(c),d=new Set,P=new Set;for(const[v,$]of this.b)$.has(c)&&P.add(v);for(const v of m){const $=this.L(v.identifier,v.version);d.add($),P.has($)||(E.push(v.identifier),this.I($,c))}for(const v of P)if(!d.has(v)){const $=this.M(v);$&&(O.push($.identifier),this.J(v,c))}(E.length||O.length)&&this.a.fire({added:E.length?{extensions:E,profileLocation:c}:void 0,removed:O.length?{extensions:O,profileLocation:c}:void 0})}async G(c){const E=await this.j.scanProfileExtensions(c);for(const O of E)this.I(this.L(O.identifier,O.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(O=>!this.b.has(this.L(O.identifier,O.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,E){let O=this.b.get(c);O||this.b.set(c,O=new R.$Bc(m=>this.m.extUri.getComparisonKey(m))),O.add(E)}J(c,E){const O=this.b.get(c);O&&O.delete(E),O?.size||this.b.delete(c)}L(c,E){return`${D.$4l.toKey(c.id)}@${E}`}M(c){const[E,O]=(0,A.$zo)(c);return O?{identifier:{id:E},version:O}:void 0}}e.$Fp=b}),define(ne[142],re([0,1,113,39]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=void 0;async function R(A,D,b,u,c,E,O){const m={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${D.nameShort})`};if((0,j.$po)(D,b)&&(0,j.$ro)(u)===3){const d=await(0,L.$0o)(b,c,E);m["X-Market-User-Id"]=d,m["VSCode-SessionId"]=O.machineId||d}return m}e.$$o=R}),define(ne[143],re([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(J,e,L,j,R,A,D,b,u,c,E,O,m,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=void 0;let v=class extends d.$Rq{constructor(I,p,S,s){super(S),this.h=I,this.j=s,this.g=this.B(new $(p,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(I,p){const s=(await this.g.getLanguagePacks())[p];if(!s){this.j.warn(`No language pack found for ${p}`);return}const o=s.translations[I];return o?P.URI.file(o):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),p=Object.keys(I).map(S=>{const s=I[S];return{...this.f(S,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((S,s)=>S.label.localeCompare(s.label)),p}async m(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",I.identifier.id),await this.update())}async n(I){const p=await this.g.getLanguagePacks();Object.keys(p).some(S=>p[S]&&p[S].extensions.some(s=>(0,O.$xo)(s.extensionIdentifier,I.identifier)))&&(this.j.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),S=await this.g.update(p);return!(0,j.$ub)(Object.keys(I),Object.keys(S))}};e.$Sq=v,e.$Sq=v=pe([se(0,E.$0n),se(1,c.$Wh),se(2,E.$8n),se(3,m.$9i)],v);let $=class extends A.$Sc{constructor(I,p){super(),this.j=p,this.c={},this.f=(0,b.$jc)(I.userDataPath,"languagepacks.json"),this.g=new R.$1g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.s(p=>{Object.keys(p).forEach(S=>delete p[S]),this.m(p,...I)}).then(()=>this.c)}m(I,...p){for(const S of p)S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&this.n(I,S);Object.keys(I).forEach(S=>this.r(I[S]))}n(I,p){const S=p.identifier,s=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const o of s)if(p.location.scheme===D.Schemas.file&&h(o)){let t=I[o.languageId];t||(t={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},I[o.languageId]=t);const i=t.extensions.filter(n=>(0,O.$xo)(n.extensionIdentifier,S))[0];i?i.version=p.manifest.version:t.extensions.push({extensionIdentifier:S,version:p.manifest.version});for(const n of o.translations)t.translations[n.id]=(0,b.$jc)(p.location.fsPath,n.path)}}r(I){if(I){const p=(0,L.createHash)("md5");for(const S of I.extensions)p.update(S.extensionIdentifier.uuid||S.extensionIdentifier.id).update(S.version);I.hash=p.digest("hex")}}s(I=()=>null){return this.g.queue(()=>{let p=null;return u.Promises.readFile(this.f,"utf8").then(void 0,S=>S.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(S)).then(S=>{try{return JSON.parse(S)}catch{return{}}}).then(S=>(p=I(S),S)).then(S=>{for(const o of Object.keys(S))S[o]||delete S[o];this.c=S,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),u.Promises.writeFile(this.f,s)}).then(()=>p,S=>this.j.error(S))})}};$=pe([se(0,c.$Wh),se(1,m.$9i)],$);function h(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const I of f.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ne[144],re([0,1,82,9,30,39]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",b="https://mobile.events.data.microsoft.com/ping";async function u(E,O,m){const d=await(0,L.$iC)("@microsoft/1ds-core-js","dist/ms.core.js"),P=await(0,L.$iC)("@microsoft/1ds-post-js","dist/ms.post.js"),v=new d.AppInsightsCore,$=new P.PostChannel,h={instrumentationKey:E,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(m){h.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:m};h.extensionConfig[$.identifier]=f}return v.initialize(h,[]),v.addTelemetryInitializer(f=>{O&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),v}class c{constructor(O,m,d,P,v){this.e=O,this.f=m,this.g=d,this.h=v,this.c=D,this.d=b,this.g||(this.g={}),typeof P=="function"?this.a=P():this.a=P,this.b=null}i(O){if(this.a){if(typeof this.a!="string"){O(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(m=>{O(m)},m=>{(0,j.$1)(m),console.error(m)})}}log(O,m){if(!this.a)return;m=(0,R.$7m)(m,this.g),m=(0,A.$so)(m);const d=this.f+"/"+O;try{this.i(P=>{P.pluginVersionString=m?.properties.version??"Unknown",P.track({name:d,baseData:{name:d,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(O=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,O(void 0)})})}):Promise.resolve(void 0)}}e.$nN=c}),define(ne[145],re([0,1,2,30,13,29,105,25,43,146,32,36,26,39]),function(J,e,L,j,R,A,D,b,u,c,E,O,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;let P=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,f,I){this.k=f,this.l=I,this.d={},this.i=new L.$Rc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,A.$Fe)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Fe)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(m.$il)||p.affectsConfiguration(m.$kl)||p.affectsConfiguration(m.$jl))&&this.m()}))}setExperimentProperty(h,f){this.d[h]=f}m(){let h=(0,d.$ro)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const I=f.usage?3:f.error?2:0;h=Math.min(h,I)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,f,I){this.g<f||(I=(0,j.$7m)(I,this.d),I=(0,d.$wo)(I,this.j),I=(0,j.$7m)(I,this.c),this.b.forEach(p=>p.log(h,I)))}publicLog(h,f){this.n(h,3,f)}publicLog2(h,f){this.publicLog(h,f)}publicLogError(h,f){this.h&&this.n(h,2,f)}publicLogError2(h,f){this.publicLogError(h,f)}};e.$Yq=P,e.$Yq=P=pe([se(1,b.$ii),se(2,E.$oj)],P);function v(){const $=(0,D.localize)(0,null,c.default.nameLong),h=c.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=R.$p?"":(0,D.localize)(3,null),I=(0,D.localize)(4,null),p=(0,D.localize)(5,null),S=(0,D.localize)(6,null),s=(0,D.localize)(7,null),o=`
|       | ${I} | ${p} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,D.localize)(8,null);return`
${$} ${h} ${f}

&nbsp;

${s}
${o}

&nbsp;

${t}
`}O.$dn.as(u.$in.Configuration).registerConfiguration({id:m.$hl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[m.$il]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),O.$dn.as(u.$in.Configuration).registerConfiguration({id:m.$hl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[m.$kl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,D.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,D.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${m.$il}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],re([0,1,14,20,174,144]),function(J,e,L,j,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oN=void 0;async function D(E,O){const m=await O.request(E,j.CancellationToken.None),d=(await(0,L.$ne)(m.stream)).toString(),P=m.res.statusCode??200;return{headers:m.res.headers,statusCode:P,responseData:d}}async function b(E){const O={method:E.type,headers:E.headers};return new Promise((d,P)=>{const v=R.request(E.url??"",O,$=>{$.on("data",function(h){d({headers:$.headers,statusCode:$.statusCode??200,responseData:h.toString()})}),$.on("error",function(h){P(h)})});v.write(E.data,$=>{$&&P($)}),v.end()})}async function u(E,O,m){const d=typeof O.data=="string"?O.data:new TextDecoder().decode(O.data),P={type:"POST",headers:{...O.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(O.data).toString()},url:O.urlString,data:d};try{const v=E?await D(P,E):await b(P);m(v.statusCode,v.headers,v.responseData)}catch{m(0,{})}}class c extends A.$nN{constructor(O,m,d,P,v){const $={sendPOST:(h,f)=>{u(O,h,f)}};super(m,d,P,v,$)}}e.$oN=c}),define(ne[148],re([0,1,16,24]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8b=void 0;async function R(A,D){const b=Object.create(null),u=(E,O)=>{const m=JSON.parse(E);b[O]=m};if(D){const E=[],O=await j.Promises.readdir(D);for(const d of O)try{(await j.Promises.stat((0,L.$jc)(D,d))).isDirectory()&&E.push(d)}catch{}const m=[];for(const d of E)(await j.Promises.readdir((0,L.$jc)(D,d))).filter(v=>v==="telemetry.json").length===1&&m.push(d);for(const d of m){const P=(await j.Promises.readFile((0,L.$jc)(D,d,"telemetry.json"))).toString();u(P,d)}}let c=(await j.Promises.readFile((0,L.$jc)(A,"telemetry-core.json"))).toString();return u(c,"vscode-core"),c=(await j.Promises.readFile((0,L.$jc)(A,"telemetry-extensions.json"))).toString(),u(c,"vscode-extensions"),JSON.stringify(b,null,4)}e.$t8b=R}),define(ne[149],re([0,1,13,75,26]),function(J,e,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N7b=void 0;async function A(D,b){let u=D.getItem(R.$gl);return(typeof u!="string"||L.$k&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,j.$Qm)(b.error.bind(b))),u}e.$N7b=A}),define(ne[22],re([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=void 0,e.$Hk=(0,L.$Oh)("IUriIdentityService")}),define(ne[150],re([0,1,22,114,12,17,73,4,2]),function(J,e,L,j,R,A,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=void 0;class c{static{this._clock=0}constructor(m){this.uri=m,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let E=class{constructor(m){this.g=m,this.c=new u.$Rc,this.f=2**16;const d=new Map,P=v=>{let $=d.get(v.scheme);return $===void 0&&($=m.hasProvider(v)&&!this.g.hasCapability(v,1024),d.set(v.scheme,$)),$};this.c.add(b.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(v=>{d.delete(v.scheme)})),this.extUri=new A.$kg(P),this.d=new D.$wr((v,$)=>this.extUri.compare(v,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,A.$wg)(m));const d=this.d.get(m);return d?d.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new c(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((P,v)=>P[1].time<v[1].time?1:P[1].time>v[1].time?-1:0);c._clock=0,this.d.clear();const d=this.f*.5;for(let P=0;P<d;P++)this.d.set(m[P][0],m[P][1].touch())}};e.$xr=E,e.$xr=E=pe([se(0,R.$0j)],E),(0,j.$ur)(L.$Hk,E,1)}),define(ne[151],re([0,1,4,2,12,46,31]),function(J,e,L,j,R,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$07b=void 0;class b extends j.$Sc{constructor(c,E,O,m,d,P){super(),this.f=c,this.g=E,this.h=O,this.j=m,this.m=d,this.n=P,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Nd),this.onDidChangeFile=this.a.event,this.b=A.$Uh.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Bc(v=>this.m.extUri.getComparisonKey(this.t(v))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(v=>this.s(v)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,E){return this.g.open(this.t(c),E)}close(c){return this.g.close(c)}read(c,E,O,m,d){return this.g.read(c,E,O,m,d)}write(c,E,O,m,d){return this.g.write(c,E,O,m,d)}watch(c,E){this.b.set(c,c);const O=this.g.watch(this.t(c),E);return(0,j.$Qc)(()=>{this.b.delete(c),O.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,E,O){return this.g.rename(this.t(c),this.t(E),O)}readFile(c,E){return this.g.readFile(this.t(c),E)}readFileStream(c,E,O){return this.g.readFileStream(this.t(c),E,O)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,E,O){return this.g.writeFile(this.t(c),E,O)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,E){return this.g.delete(this.t(c),E)}copy(c,E,O){if((0,R.$bk)(this.g))return this.g.copy(this.t(c),this.t(E),O);throw new Error("copy not supported")}cloneFile(c,E){if((0,R.$ck)(this.g))return this.g.cloneFile(this.t(c),this.t(E));throw new Error("clone not supported")}s(c){const E=[];for(const O of c){if(O.resource.scheme!==this.f)continue;const m=this.u(O.resource);this.b.findSubstr(m)&&E.push({resource:m,type:O.type,cId:O.cId})}E.length&&(this.n.debug("User data changed"),this.a.fire(E))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$07b=b}),define(ne[152],re([0,1,107,16,46,17,11,10,15]),function(J,e,L,j,R,A,D,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.WorkbenchState=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=void 0,e.$Xh=(0,b.$Oh)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.$Yh=c;function E(i){return typeof i?.id=="string"&&!c(i)&&!m(i)}e.$Zh=E,e.$1h={id:"ext-dev"},e.$2h={id:"empty-window"};function O(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,j.$nc)(i)}:n?e.$1h:e.$2h;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$3h=O;function m(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.$4h=m;function d(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$5h=d;var P;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(P||(e.WorkbenchState=P={}));function v(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$6h=v;function $(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$7h=$;class h{constructor(n,r,l,k,y){this.h=n,this.j=l,this.k=k,this.l=y,this.c=R.$Uh.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=R.$Uh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$8h=h;class f{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,A.$vg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$9h=f;function I(i){return new f({uri:i,index:0,name:(0,A.$rg)(i)},{uri:i.toString()})}e.$0h=I,e.$$h="code-workspace",e.$_h=`.${e.$$h}`,e.$ai=[{name:(0,L.localize)(0,null),extensions:[e.$$h]}],e.$bi="workspace.json";function p(i,n){return A.$mg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$ci=p;function S(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===u.Schemas.tmp}e.$di=S,e.$ei="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$ei}e.$fi=s;function o(i,n){return!p(i,n)&&!S(i)}e.$gi=o;function t(i){return(typeof i=="string"?(0,j.$oc)(i):(0,A.$tg)(i))===e.$_h}e.$hi=t}),define(ne[23],re([0,1,41,4,2,17,11,106,18,12,10,6,152,31,22,8,28,29,3]),function(J,e,L,j,R,A,D,b,u,c,E,O,m,d,P,v,$,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.ProfileResourceType=void 0;var I;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function p(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.$Ik=p,e.$Jk=(0,E.$Oh)("IUserDataProfilesService");function S(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:D.URI.revive(i.location).with({scheme:n}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Kk=S;function s(i,n,r,l,k,y){return{id:i,name:n,location:r,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:y&&k?.useDefaultFlags?.globalState?y.globalStorageHome:(0,A.$vg)(r,"globalStorage"),settingsResource:y&&k?.useDefaultFlags?.settings?y.settingsResource:(0,A.$vg)(r,"settings.json"),keybindingsResource:y&&k?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,A.$vg)(r,"keybindings.json"),tasksResource:y&&k?.useDefaultFlags?.tasks?y.tasksResource:(0,A.$vg)(r,"tasks.json"),snippetsHome:y&&k?.useDefaultFlags?.snippets?y.snippetsHome:(0,A.$vg)(r,"snippets"),extensionsResource:y&&k?.useDefaultFlags?.extensions?y.extensionsResource:(0,A.$vg)(r,"extensions.json"),cacheHome:(0,A.$vg)(l,i),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}e.$Lk=s;let o=class extends R.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,l,k){super(),this.t=n,this.u=r,this.w=l,this.y=k,this.f=!0,this.h=this.B(new j.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new j.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new j.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new j.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,f.$yf)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(s((0,A.$sg)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},n))}}catch(y){this.y.error(y)}const l=new d.$Ac,k=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[w,N]of Object.entries(y.workspaces)){const H=D.URI.parse(w),_=r.find(K=>K.id===N);_&&l.set(H,_)}if(y.emptyWindows)for(const[w,N]of Object.entries(y.emptyWindows)){const H=r.find(_=>_.id===N);H&&k.set(w,H)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:l,emptyWindows:k}}return this.z}D(){const n=s("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",l=new RegExp(`${(0,h.$Fe)(r)}\\s(\\d+)`);let k=0;for(const w of this.profiles){const N=l.exec(w.name),H=N?parseInt(N[1]):0;k=H>k?H:k}const y=`${r} ${k+1}`;return this.createProfile((0,L.$Ci)((0,$.$eg)()).toString(16),y,{transient:!0},n)}async createNamedProfile(n,r,l){return this.createProfile((0,L.$Ci)((0,$.$eg)()).toString(16),n,r,l)}async createProfile(n,r,l,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(n,r,l);return k&&await this.setProfileForWorkspace(k,y),y}async F(n,r,l){if(!(0,f.$yf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(r);return k||(k=(async()=>{try{const y=this.profiles.find(H=>H.name===r||H.id===n);if(y)return y;const w=s(n,r,(0,A.$vg)(this.profilesHome,n),this.g,l,this.defaultProfile);await this.u.createFolder(w.location);const N=[];return this.j.fire({profile:w,join(H){N.push(H)}}),await v.Promises.settled(N),this.I([w],[],[]),w}finally{this.r.delete(r)}})(),this.r.set(r,k)),k}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(k=>k.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=s(l.id,r.name??l.name,l.location,this.g,{shortName:r.shortName??l.shortName,icon:r.icon===null?void 0:r.icon??l.icon,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(k=>k.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.m.fire({profile:r,join(k){l.push(k)}});try{await Promise.allSettled(l)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(k){(0,c.$ok)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(k=>k.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,l)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return D.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,m.$Yh)(n)?n.uri:(0,m.$4h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,l){const k=[...this.profiles,...n],y=[];this.s.profiles=[];for(let w of k)w.isDefault||r.some(N=>w.id===N.id)||(w=l.find(N=>w.id===N.id)??w,w.isTransient?this.s.profiles.push(w):y.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.P(y),this.z=void 0,this.J(n,r,l)}J(n,r,l){this.h.fire({added:n,removed:r,updated:l,all:this.profiles})}L(n,r,l){l=r?.isTransient?!0:l,l||this.L(n,void 0,!0);const k=this.G(n),y=l?this.s:this.C;D.URI.isUri(k)?(y.workspaces.delete(k),r&&y.workspaces.set(k,r)):(y.emptyWindows.delete(k),r&&y.emptyWindows.set(k,r)),l||this.M()}M(){const n={};for(const[l,k]of this.C.workspaces.entries())n[l.toString()]=k.id;const r={};for(const[l,k]of this.C.emptyWindows.entries())r[l.toString()]=k.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},l=this.D();if(n.workspaces)for(const[y,w]of Object.entries(n.workspaces)){const N=D.URI.parse(w);r[y]=this.w.extUri.isEqual(N,l.location)?l.id:this.w.extUri.basename(N)}const k={};if(n.emptyWindows)for(const[y,w]of Object.entries(n.emptyWindows)){const N=D.URI.parse(w);k[y]=this.w.extUri.isEqual(N,l.location)?l.id:this.w.extUri.basename(N)}return{workspaces:r,emptyWindows:k}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Mk=o,e.$Mk=o=pe([se(0,u.$Vh),se(1,c.$0j),se(2,P.$Hk),se(3,O.$9i)],o);class t extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Nk=t}),define(ne[153],re([0,1,19,8,20,9,4,2,13,3,11,91,21,27,37,6,32,26,22,23]),function(J,e,L,j,R,A,D,b,u,c,E,O,m,d,P,v,$,h,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=void 0;let p=class extends b.$Sc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,l,k,y,w){super(),this.z=n,this.C=r,this.D=l,this.F=k,this.G=y,this.H=w,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$Nd),this.s=this.B(new D.$Nd),this.t=this.B(new D.$Nd),this.u=this.B(new D.$Nd),this.w=this.B(new D.$Nd),this.y=[],this.B((0,b.$Qc)(()=>{this.j.forEach(({task:N})=>N.cancel()),this.m.forEach(N=>N.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(l=>(0,m.$5n)(l,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const k=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:y})=>(0,d.$xo)(y,n.identifier));if(k?.local)return k?.local;throw k?.error?k.error:s(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(l){throw s(l)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new m.$9n(O.localize(0,null),m.ExtensionManagementErrorCode.Internal);const r=[],l=[];await Promise.allSettled(n.map(async({extension:k,options:y})=>{try{const w=await this.O(k,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);l.push({...w,options:y})}catch(w){r.push({identifier:k.identifier,operation:2,source:k,error:w})}})),l.length&&r.push(...await this.I(l));for(const k of r)k.error&&(this.F.error("Failed to install extension.",k.identifier.id),this.F.error(k.error),k.source&&!E.URI.isUri(k.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,d.$Fo)(k.source),error:k.error}));return r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,r)}async toggleAppliationScope(n,r){if((0,P.$7l)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let l=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(l=await this.ab(n,this.H.defaultProfile.extensionsResource,r));for(const k of this.H.profiles){const y=(await this.getInstalled(1,k.extensionsResource)).find(w=>(0,d.$xo)(w.identifier,n.identifier));y?this.w.fire(y):this.u.fire({identifier:n.identifier,profileLocation:k.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const r=[];return await Promise.allSettled(n.map(async l=>{try{const k=await this.J(l);r.push(...k)}catch(k){r.push({identifier:{id:(0,d.$Co)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:k})}})),this.s.fire(r),r}async J({manifest:n,extension:r,options:l}){const k=l.isApplicationScoped||l.isBuiltin||(0,P.$7l)(n),y={...l,installOnlyNewlyAddedFromExtensionPack:E.URI.isUri(r)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:k,profileLocation:k?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},w=te=>`${d.$yo.create(te).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!E.URI.isUri(r)){const te=this.j.get(w(r));if(te)return this.F.info("Extensions is already requested to install",r.identifier.id),await te.task.waitUntilTaskIsFinished(),[]}const N=[],H=[],_=[],K=this.Z(n,r,y);E.URI.isUri(r)||this.j.set(w(r),{task:K,waitingTasks:[]}),this.n.fire({identifier:K.identifier,source:r,profileLocation:y.profileLocation}),this.F.info("Installing extension:",K.identifier.id),N.push({task:K,manifest:n});let ue=!1;try{if(y.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",K.identifier.id);else try{const ae=await this.N(K.identifier,n,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),le=await this.getInstalled(void 0,y.profileLocation),ie={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[m.$Zn]:!0}};for(const{gallery:q,manifest:G}of(0,L.$Mb)(ae,({gallery:T})=>T.identifier.id)){ue=ue||!!G.extensionDependencies?.some(B=>(0,d.$xo)({id:B},K.identifier));const T=w(q),C=this.j.get(T);if(C){if(this.L(K,C.task)){const B=C.task.identifier;this.F.info("Waiting for already requested installing extension",B.id,K.identifier.id),C.waitingTasks.push(K),H.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,x=>x.some(Z=>(0,d.$xo)(Z.identifier,B)))).then(x=>{if(this.F.info("Finished waiting for already requested installing extension",B.id,K.identifier.id),!x.find(Y=>(0,d.$xo)(Y.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!le.some(({identifier:B})=>(0,d.$xo)(B,q.identifier))){const B=this.Z(G,q,ie);this.j.set(T,{task:B,waitingTasks:[K]}),this.n.fire({identifier:B.identifier,source:q,profileLocation:y.profileLocation}),this.F.info("Installing extension:",B.identifier.id,K.identifier.id),N.push({task:B,manifest:G})}}}catch(ae){if(E.URI.isUri(K.source))(0,L.$Lb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",K.identifier.id,ae.message),(0,L.$Lb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",K.identifier.id,ae.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",K.identifier.id),ae}const te=N.reduce((ae,{task:le,manifest:ie})=>(ae.set(le.identifier.id.toLowerCase(),{task:le,manifest:ie}),ae),new Map);for(;te.size;){let ae;const le=[...te.values()].filter(({manifest:ie})=>!ie.extensionDependencies?.some(q=>te.has(q.toLowerCase())));le.length?ae=te.size===1?le:le.filter(({task:ie})=>!(ie===K&&!ue)):(this.F.info("Found extensions with circular dependencies",le.map(({task:ie})=>ie.identifier.id)),ae=[...te.values()]),await this.M(ae.map(async({task:ie})=>{const q=new Date().getTime();try{const G=await ie.run();if(await this.M(this.y.map(T=>T.postInstall(G,ie.source,y,R.CancellationToken.None))),!E.URI.isUri(ie.source)){const T=ie.operation===3,C=T?void 0:(new Date().getTime()-ie.source.lastUpdated)/1e3;if(o(this.C,T?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$Fo)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,durationSinceUpdate:C}),u.$p&&ie.operation!==3)try{await this.z.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}_.push({local:G,identifier:ie.identifier,operation:ie.operation,source:ie.source,context:ie.options.context,profileLocation:ie.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw E.URI.isUri(ie.source)||o(this.C,ie.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$Fo)(ie.source),verificationStatus:ie.verificationStatus,duration:new Date().getTime()-q,error:G}),this.F.error("Error while installing the extension:",ie.identifier.id),G}finally{te.delete(ie.identifier.id.toLowerCase())}}))}return H.length&&await this.M(H),_.forEach(({identifier:ae})=>this.F.info("Extension installed successfully:",ae.id)),_}catch(te){if(N.forEach(({task:ae})=>ae.cancel()),_.length)try{const ae=await Promise.allSettled(_.map(({local:le})=>this.$(le,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let le=0;le<ae.length;le++){const ie=ae[le],{identifier:q}=_[le];ie.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",q.id):this.F.warn("Rollback: Error while uninstalling extension",q.id,(0,A.$0)(ie.reason))}}catch(ae){this.F.warn("Error while rolling back extensions",(0,A.$0)(ae),_.map(({identifier:le})=>le.id))}return N.map(({task:ae})=>({identifier:ae.identifier,operation:2,source:ae.source,context:y.context,profileLocation:y.profileLocation,error:te}))}finally{for(const{task:te}of N)te.source&&!E.URI.isUri(te.source)&&this.j.delete(w(te.source))}}L(n,r){for(const[,{task:l,waitingTasks:k}]of this.j.entries())if(l===n&&(k.includes(r)||k.some(y=>this.L(y,r)))||l===r&&k[0]&&!this.L(n,k[0]))return!1;return!0}async M(n){const r=[],l=[],k=await Promise.allSettled(n);for(const y of k)y.status==="fulfilled"?r.push(y.value):l.push(y.reason);if(l.length)throw S(l);return r}async N(n,r,l,k,y){if(!this.z.isEnabled())return[];const w=await this.getInstalled(void 0,y),N=[],H=[],_=async(K,ue)=>{N.push(K);const te=ue.extensionDependencies||[],ae=[...te];if(ue.extensionPack){const le=l?w.find(ie=>(0,d.$xo)(ie.identifier,K)):void 0;for(const ie of ue.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(q=>(0,d.$xo)({id:q},{id:ie}))||ae.every(q=>!(0,d.$xo)({id:q},{id:ie}))&&ae.push(ie)}if(ae.length){const le=ae.filter(ie=>N.every(q=>!(0,d.$xo)(q,{id:ie})));if(le.length){const ie=await this.z.getExtensions(le.map(q=>({id:q,preRelease:k})),R.CancellationToken.None);for(const q of ie){if(N.find(C=>(0,d.$xo)(C,q.identifier)))continue;const G=te.some(C=>(0,d.$xo)({id:C},q.identifier));let T;try{T=await this.O(q,!1,k)}catch(C){if(G)throw C;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,A.$0)(C));continue}H.push({gallery:T.extension,manifest:T.manifest}),await _(T.extension.identifier,T.manifest)}}}};return await _(n,r),H}async O(n,r,l){let k;const y=await this.getExtensionsControlManifest();if(y.malicious.some(H=>(0,d.$xo)(n.identifier,H)))throw new m.$9n(O.localize(1,null,n.identifier.id),m.ExtensionManagementErrorCode.Malicious);const w=y.deprecated[n.identifier.id.toLowerCase()];if(w?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${w.extension.id}' extension instead.`),k=(await this.z.getExtensions([{id:w.extension.id,preRelease:w.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!k)throw new m.$9n(O.localize(2,null,n.identifier.id,w.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const H=await this.getTargetPlatform();throw new m.$9n(O.localize(3,null,n.identifier.id,this.G.nameLong,(0,m.$1n)(H)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(k=await this.P(n,r,l),!k)throw!l&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],R.CancellationToken.None))[0]?new m.$9n(O.localize(4,null,n.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$9n(O.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),m.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",k.identifier.id);const N=await this.z.getManifest(k,R.CancellationToken.None);if(N===null)throw new m.$9n(`Missing manifest for extension ${k.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(N.version!==k.version)throw new m.$9n(`Cannot install '${k.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:k,manifest:N}}async P(n,r,l){const k=await this.getTargetPlatform();let y=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==l&&(y=(await this.z.getExtensions([{...n.identifier,preRelease:l}],{targetPlatform:k,compatible:!0},R.CancellationToken.None))[0]||null),!y&&await this.z.isExtensionCompatible(n,l,k)&&(y=n),y||(r?y=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:k,compatible:!0},R.CancellationToken.None))[0]||null:y=await this.z.getCompatibleExtension(n,l,k)),y}async Q(n,r){const l={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},k=K=>`${K.id.toLowerCase()}${l.versionOnly?`-${n.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,y=this.m.get(k(n.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),y.waitUntilTaskIsFinished();const w=K=>{const ue=this.$(K,l);return this.m.set(k(ue.extension.identifier),ue),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${K.identifier.id}@${K.manifest.version}`),this.t.fire({identifier:K.identifier,profileLocation:l.profileLocation,applicationScoped:K.isApplicationScoped}),ue},N=(K,ue)=>{ue?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${K.identifier.id}@${K.manifest.version}`,l.profileLocation.toString(),ue.message):this.F.error("Failed to uninstall extension:",`${K.identifier.id}@${K.manifest.version}`,ue.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${K.identifier.id}@${K.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${K.identifier.id}@${K.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,d.$Eo)(K),error:ue}),this.u.fire({identifier:K.identifier,error:ue?.code,profileLocation:l.profileLocation,applicationScoped:K.isApplicationScoped})},H=[],_=[];try{H.push(w(n));const K=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const ue=this.U(n,K);for(const te of ue)this.m.has(k(te.identifier))?this.F.info("Extensions is already requested to uninstall",te.identifier.id):H.push(w(te))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(H.map(ue=>ue.extension),K,n),await this.M(H.map(async ue=>{try{if(await ue.run(),await this.M(this.y.map(te=>te.postUninstall(ue.extension,l,R.CancellationToken.None))),ue.extension.identifier.uuid)try{await this.z.reportStatistic(ue.extension.manifest.publisher,ue.extension.manifest.name,ue.extension.manifest.version,"uninstall")}catch{}N(ue.extension)}catch(te){const ae=te instanceof m.$9n?te:new m.$9n((0,A.$0)(te),m.ExtensionManagementErrorCode.Internal);throw N(ue.extension,ae),ae}finally{_.push(ue)}}))}catch(K){const ue=K instanceof m.$9n?K:new m.$9n((0,A.$0)(K),m.ExtensionManagementErrorCode.Internal);for(const te of H){try{te.cancel()}catch{}_.includes(te)||N(te.extension,ue)}throw ue}finally{for(const K of H)this.m.delete(k(K.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",K.extension.identifier.id)}}R(n,r,l){for(const k of n){const y=this.W(k,r);if(y.length){const w=y.filter(N=>!n.some(H=>(0,d.$xo)(H.identifier,N.identifier)));if(w.length)throw new Error(this.S(k,w,l))}}}S(n,r,l){return l===n?r.length===1?O.localize(6,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(7,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(8,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?O.localize(9,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(10,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(11,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(n,r,l=[]){if(l.indexOf(n)!==-1)return[];l.push(n);const k=n.manifest.extensionPack?n.manifest.extensionPack:[];if(k.length){const y=r.filter(N=>!N.isBuiltin&&k.some(H=>(0,d.$xo)({id:H},N.identifier))),w=[];for(const N of y)w.push(...this.U(N,r,l));return[...y,...w]}return[]}W(n,r){return r.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(k=>(0,d.$xo)({id:k},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$np=p,e.$np=p=pe([se(0,m.$8n),se(1,h.$bl),se(2,f.$Hk),se(3,v.$9i),se(4,$.$oj),se(5,I.$Jk)],p);function S(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,l)=>new Error(`${r.message}${r.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$op=S;function s(i){if(i instanceof m.$9n)return i;const n=new m.$9n(i.message,m.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.$pp=s;function o(i,n,{extensionData:r,verificationStatus:l,duration:k,error:y,durationSinceUpdate:w}){let N,H;(0,c.$Gf)(l)&&(l===!0?l="Verified":(l===!1||(N=m.ExtensionManagementErrorCode.Signature,H=l),l="Unverified")),y&&(y instanceof m.$9n?(N=y.code,y.code===m.ExtensionManagementErrorCode.Signature&&(H=y.message)):N=m.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:l,success:!y,duration:k,errorcode:N,errorcodeDetail:H,durationSinceUpdate:w})}class t{constructor(){this.d=new j.$Sg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,j.$Hg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,j.$Hg)(n=>new Promise((r,l)=>{const k=n.onCancellationRequested(()=>{k.dispose(),l(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$qp=t}),define(ne[40],re([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(J,e,L,j,R,A,D,b,u,c,E,O,m,d,P,v,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class I extends Error{constructor(t,i){super(t),this.code=i}}e.$rp=I,e.$sp=(0,O.$Oh)("IExtensionsProfileScannerService");let p=class extends R.$Sc{constructor(t,i,n,r,l,k){super(),this.j=t,this.m=i,this.n=n,this.r=r,this.s=l,this.t=k,this.b=this.B(new A.$Nd),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Nd),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Nd),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Nd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i){const n=[],r=[];try{return await this.u(i,l=>{const k=[];for(const y of l)t.some(([w])=>(0,c.$xo)(w.identifier,y.identifier)&&w.manifest.version!==y.version)?n.push(y):k.push(y);for(const[y,w]of t){const N=k.findIndex(_=>(0,c.$xo)(_.identifier,y.identifier)&&_.version===y.manifest.version),H={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:w};N===-1?(r.push(H),k.push(H)):k.splice(N,1,H)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),k}),r.length&&this.c.fire({extensions:r,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),r}catch(l){throw r.length&&this.c.fire({extensions:r,error:l,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:l,profileLocation:i}),l}}async updateMetadata(t,i){const n=[];return await this.u(i,r=>{const l=[];for(const k of r){const y=t.find(([w])=>(0,c.$xo)(w.identifier,k.identifier)&&w.manifest.version===k.version);y&&(k.metadata={...k.metadata,...y[1]},n.push(k)),l.push(k)}return l}),n}async removeExtensionFromProfile(t,i){const n=[];try{await this.u(i,r=>{const l=[];for(const k of r)(0,c.$xo)(k.identifier,t.identifier)?n.push(k):l.push(k);return n.length&&this.f.fire({extensions:n,profileLocation:i}),l}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:i}),r}}async u(t,i,n){return this.F(t).queue(async()=>{let r=[],l;try{const k=await this.m.readFile(t);l=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,E.$ok)(k)!==1)throw k;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&n?.bailOutWhenFileNotFound)throw new I((0,$.$0)(k),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let k=!1;for(const y of l){S(y)||this.w(t);let w;if((0,v.$yf)(y.relativeLocation)&&y.relativeLocation)w=this.z(y.relativeLocation);else if((0,v.$yf)(y.location))w=this.z(y.location),k=!0,y.relativeLocation=y.location,y.location=w.toJSON();else{w=b.URI.revive(y.location);const N=this.y(w);N&&(k=!0,y.relativeLocation=N)}r.push({identifier:y.identifier,location:w,version:y.version,metadata:y.metadata})}k&&await this.m.writeFile(t,j.$be.fromString(JSON.stringify(l)))}if(i){r=i(r);const k=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(t,j.$be.fromString(JSON.stringify(k)))}return r})}w(t){const i=new I(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(t)).value.toString()}catch(l){if((0,E.$ok)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let r;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(k=>S(k))?r=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,j.$be.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,E.$ok)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,E.$ok)(l)!==1&&this.t.error(l)}try{await this.m.del(i)}catch(l){(0,E.$ok)(l)!==1&&this.t.error(l)}return r})()),this.C}F(t){let i=this.h.get(t);return i||(i=new L.$1g,this.h.set(t,i)),i}};e.$tp=p,e.$tp=p=pe([se(1,E.$0j),se(2,d.$Jk),se(3,P.$Hk),se(4,h.$bl),se(5,m.$9i)],p);function S(o){return(0,v.$Af)(o)&&(0,u.$7n)(o.identifier)&&(s(o.location)||(0,v.$yf)(o.location)&&o.location)&&((0,v.$Ff)(o.relativeLocation)||(0,v.$yf)(o.relativeLocation))&&o.version&&(0,v.$yf)(o.version)}function s(o){return o?(0,v.$yf)(o.path)&&(0,v.$yf)(o.scheme):!1}}),define(ne[50],re([0,1,19,8,30,14,9,53,80,2,15,16,13,17,42,54,3,11,95,18,27,37,48,12,10,6,32,4,47,40,23,22,112]),function(J,e,L,j,R,A,D,b,u,c,E,O,m,d,P,v,$,h,f,I,p,S,s,o,t,i,n,r,l,k,y,w,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.Translations=void 0;var H;(function(ie){function q(G,T){if(G===T)return!0;const C=Object.keys(G),B=new Set;for(const x of Object.keys(T))B.add(x);if(C.length!==B.size)return!1;for(const x of C){if(G[x]!==T[x])return!1;B.delete(x)}return B.size===0}ie.equals=q})(H||(e.Translations=H={})),e.$wp=(0,t.$Oh)("IExtensionsScannerService");let _=class extends c.$Sc{constructor(q,G,T,C,B,x,Z,Y,U,z,a,g){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=G,this.r=T,this.s=C,this.t=B,this.u=x,this.w=Z,this.y=Y,this.z=U,this.C=z,this.D=a,this.F=g,this.g=this.B(new r.$Nd),this.onDidChangeCache=this.g.event,this.h=(0,d.$vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(te,this.s,this.h)),this.m=this.B(this.F.createInstance(te,this.s,this.h)),this.n=this.B(this.F.createInstance(ue,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,p.$Io)(this.w,this.y)),this.G}async scanAllExtensions(q,G,T){const[C,B]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(G)]),x=T?await this.scanExtensionsUnderDevelopment(q,[...C,...B]):[];return this.L(C,B,x,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const G=[];G.push(this.M(!!q.useCache,q.language)),G.push(this.N(q.language,!!q.checkControlFile));const[T,C]=await Promise.all(G);return this.J([...T,...C],0,q,!1)}async scanUserExtensions(q){const G=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",G);const T=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,C=await this.P(G,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,T),B=q.useCache&&!C.devMode&&C.excludeObsolete?this.m:this.n;let x;try{x=await B.scanExtensions(C)}catch(Z){if(Z instanceof k.$rp&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),x=await B.scanExtensions(C);else throw Z}return x=await this.J(x,1,q,!0),this.y.trace("Scanned user extensions:",x.length),x}async scanExtensionsUnderDevelopment(q,G){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const T=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(C=>C.scheme===E.Schemas.file).map(async C=>{const B=await this.P(C,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(B)).map(Z=>(Z.type=G.find(Y=>(0,p.$xo)(Y.identifier,Z.identifier))?.type??Z.type,this.n.validate(Z,B)))}))).flat();return this.J(T,"development",q,!0)}return[]}async scanExistingExtension(q,G,T){const C=await this.P(q,!1,G,!0,T.language,!0,void 0),B=await this.n.scanExtension(C);return!B||!T.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(q,G,T){const C=await this.P(q,!1,G,!0,T.language,!0,void 0),B=await this.n.scanOneOrMultipleExtensions(C);return this.J(B,G,T,!0)}async scanMetadata(q){const G=(0,d.$vg)(q,"package.json"),T=(await this.w.readFile(G)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(q,G){const T=(0,d.$vg)(q,"package.json"),C=(await this.w.readFile(T)).value.toString(),B=JSON.parse(C);G.isMachineScoped===!1&&delete G.isMachineScoped,G.isBuiltin===!1&&delete G.isBuiltin,B.__metadata={...B.__metadata,...G},await this.w.writeFile((0,d.$vg)(q,"package.json"),A.$be.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof k.$rp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(G=>[G,G.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$be.fromString(JSON.stringify([])))}catch(G){(0,o.$ok)(G)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(G))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,G,T,C){return T.includeAllVersions||(q=this.L(G===0?q:void 0,G===1?q:void 0,G==="development"?q:void 0,await this.getTargetPlatform(),C)),T.includeInvalid||(q=q.filter(B=>B.isValid)),q.sort((B,x)=>{const Z=O.$nc(B.location.fsPath),Y=O.$nc(x.location.fsPath);return Z<Y?-1:Z>Y?1:0})}L(q,G,T,C,B){const x=(Y,U,z)=>{if(Y.isValid&&!U.isValid)return!1;if(Y.isValid===U.isValid){if(B&&P.gt(Y.manifest.version,U.manifest.version))return this.y.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${Y.location.path} with version ${Y.manifest.version}`),!1;if(P.eq(Y.manifest.version,U.manifest.version)){if(Y.type===0)return this.y.debug(`Skipping extension ${U.location.path} in favour of system extension ${Y.location.path} with same version`),!1;if(Y.targetPlatform===C)return this.y.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${Y.location.path} with ${U.location.path}.`):this.y.debug(`Overwriting user extension ${Y.location.path} with ${U.location.path}.`),!0},Z=new S.$6l;return q?.forEach(Y=>{const U=Z.get(Y.identifier.id);(!U||x(U,Y,!1))&&Z.set(Y.identifier.id,Y)}),G?.forEach(Y=>{const U=Z.get(Y.identifier.id);if(!U&&q&&Y.type===0){this.y.debug(`Skipping obsolete system extension ${Y.location.path}.`);return}(!U||x(U,Y,!1))&&Z.set(Y.identifier.id,Y)}),T?.forEach(Y=>{const U=Z.get(Y.identifier.id);(!U||x(U,Y,!0))&&Z.set(Y.identifier.id,Y),Z.set(Y.identifier.id,Y)}),[...Z.values()]}async M(q,G){this.y.trace("Started scanning system extensions");const T=await this.P(this.systemExtensionsLocation,!1,0,!0,G,!0,void 0),B=await(q&&!T.devMode?this.j:this.n).scanExtensions(T);return this.y.trace("Scanned system extensions:",B.length),B}async N(q,G){const T=this.z.isBuilt?[]:this.C.builtInExtensions;if(!T?.length)return[];this.y.trace("Started scanning dev system extensions");const C=G?await this.O():{},B=[],x=h.URI.file(O.$hc(O.$jc(E.$cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Y of T){const U=C[Y.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":B.push((0,d.$vg)(x,Y.name));break;default:B.push(h.URI.file(U));break}}const Z=await Promise.all(B.map(async Y=>this.n.scanExtension(await this.P(Y,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Z.length),(0,L.$Hb)(Z)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,G,T,C,B,x,Z){const Y=await this.f(B??m.$w),U=await this.Q(q),z=G&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,a=z?await this.Q(z):void 0;return new K(q,U,z,a,G,Z,T,C,x,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,B,Y)}async Q(q){try{const G=await this.w.stat(q);if(typeof G.mtime=="number")return G.mtime}catch{}}};e.$xp=_,e.$xp=_=pe([se(4,y.$Jk),se(5,k.$sp),se(6,o.$0j),se(7,i.$9i),se(8,I.$Vh),se(9,n.$oj),se(10,w.$Hk),se(11,t.$Nh)],_);class K{constructor(q,G,T,C,B,x,Z,Y,U,z,a,g,F,M,X){this.location=q,this.mtime=G,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=C,this.profile=B,this.profileScanOptions=x,this.type=Z,this.excludeObsolete=Y,this.validate=U,this.productVersion=z,this.productDate=a,this.productCommit=g,this.devMode=F,this.language=M,this.translations=X}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,G){return(0,d.$og)(q.location,G.location)&&q.mtime===G.mtime&&(0,d.$og)(q.applicationExtensionslocation,G.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===G.applicationExtensionslocationMtime&&q.profile===G.profile&&R.$8m(q.profileScanOptions,G.profileScanOptions)&&q.type===G.type&&q.excludeObsolete===G.excludeObsolete&&q.validate===G.validate&&q.productVersion===G.productVersion&&q.productDate===G.productDate&&q.productCommit===G.productCommit&&q.devMode===G.devMode&&q.language===G.language&&H.equals(q.translations,G.translations)}}e.$yp=K;let ue=class extends c.$Sc{constructor(q,G,T,C,B){super(),this.f=q,this.g=G,this.h=T,this.j=C,this.m=B}async scanExtensions(q){const G=q.profile?await this.r(q):await this.n(q);let T={};if(q.excludeObsolete&&q.type===1)try{const C=(await this.j.readFile(this.f)).value.toString();T=JSON.parse(C)}catch{}return(0,$.$Lf)(T)?G:G.filter(C=>!T[p.$yo.create(C).toString()])}async n(q){const G=await this.j.resolve(q.location);if(!G.children?.length)return[];const T=await Promise.all(G.children.map(async C=>{if(!C.isDirectory||q.type===1&&(0,d.$sg)(C.resource).indexOf(".")===0)return null;const B=new K(C.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(B)}));return(0,L.$Hb)(T).sort((C,B)=>C.location.path<B.location.path?-1:1)}async r(q){let G=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){G=G.filter(C=>!C.metadata?.isApplicationScoped);const T=await this.s(q.applicationExtensionslocation,C=>!!C.metadata?.isBuiltin||!!C.metadata?.isApplicationScoped,q);G.push(...T)}return G}async s(q,G,T){const C=await this.g.scanProfileExtensions(q,T.profileScanOptions);if(!C.length)return[];const B=await Promise.all(C.map(async x=>{if(G(x)){const Z=new K(x.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(Z,x.metadata)}return null}));return(0,L.$Hb)(B)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,d.$vg)(q.location,"package.json"))){const G=await this.scanExtension(q);return G?[G]:[]}else return await this.scanExtensions(q)}catch(G){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,D.$0)(G)),[]}}async scanExtension(q,G){try{let T=await this.scanExtensionManifest(q.location);if(T){T.publisher||(T.publisher=S.$Zl),G=G??T.__metadata,delete T.__metadata;const C=(0,p.$Co)(T.publisher,T.name),B=G?.id?{id:C,uuid:G.id}:{id:C},x=G?.isSystem?0:q.type,Z=x===0||!!G?.isBuiltin;T=await this.t(q.location,T,K.createNlsConfiguration(q));const Y={type:x,identifier:B,manifest:T,location:q.location,isBuiltin:Z,targetPlatform:G?.targetPlatform??"undefined",metadata:G,isValid:!0,validations:[]};return q.validate?this.validate(Y,q):Y}}catch(T){q.type!==0&&this.m.error(T)}return null}validate(q,G){let T=!0;const C=(0,s.$No)(G.productVersion,G.productDate,G.location,q.manifest,q.isBuiltin);for(const[B,x]of C)B===v.default.Error&&(T=!1,this.m.error(this.z(G.location,x)));return q.isValid=T,q.validations=C,q}async scanExtensionManifest(q){const G=(0,d.$vg)(q,"package.json");let T;try{T=(await this.j.readFile(G)).value.toString()}catch(B){return(0,o.$ok)(B)!==1&&this.m.error(this.z(q,(0,f.localize)(0,null,G.path,B.message))),null}let C;try{C=JSON.parse(T)}catch{const x=[];(0,b.$Tm)(T,x);for(const Z of x)this.m.error(this.z(q,(0,f.localize)(1,null,G.path,Z.offset,Z.length,(0,u.$up)(Z.error))));return null}return(0,b.$3m)(C)!=="object"?(this.m.error(this.z(q,(0,f.localize)(2,null,G.path))),null):C}async t(q,G,T){const C=await this.u(q,G,T);if(C)try{const B=[],x=await this.w(C.default,B);if(B.length>0)return B.forEach(Y=>{this.m.error(this.z(q,(0,f.localize)(3,null,C.default?.path,(0,u.$up)(Y.error))))}),G;if((0,b.$3m)(C)!=="object")return this.m.error(this.z(q,(0,f.localize)(4,null,C.default?.path))),G;const Z=C.values||Object.create(null);return(0,N.$vp)(this.m,G,Z,x)}catch{}return G}async u(q,G,T){const C=(0,d.$vg)(q,"package.nls.json"),B=(U,z)=>{z.forEach(a=>{this.m.error(this.z(q,(0,f.localize)(5,null,U?.path,(0,u.$up)(a.error))))})},x=U=>{this.m.error(this.z(q,(0,f.localize)(6,null,U?.path)))},Z=`${G.publisher}.${G.name}`,Y=T.translations[Z];if(Y)try{const U=h.URI.file(Y),z=(await this.j.readFile(U)).value.toString(),a=[],g=(0,b.$Tm)(z,a);return a.length>0?(B(U,a),{values:void 0,default:C}):(0,b.$3m)(g)!=="object"?(x(U),{values:void 0,default:C}):{values:g.contents?g.contents.package:void 0,default:C}}catch{return{values:void 0,default:C}}else{if(!await this.j.exists(C))return;let z;try{z=await this.y(q,T)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const a=(await this.j.readFile(z.localized)).value.toString(),g=[],F=(0,b.$Tm)(a,g);return g.length>0?(B(z.localized,g),{values:void 0,default:z.original}):(0,b.$3m)(F)!=="object"?(x(z.localized),{values:void 0,default:z.original}):{values:F,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(q,G){if(q)try{const T=(await this.j.readFile(q)).value.toString();return(0,b.$Tm)(T,G)}catch{}}y(q,G){return new Promise((T,C)=>{const B=x=>{const Z=(0,d.$vg)(q,`package.nls.${x}.json`);this.j.exists(Z).then(Y=>{Y&&T({localized:Z,original:(0,d.$vg)(q,"package.nls.json")});const U=x.lastIndexOf("-");U===-1?T({localized:(0,d.$vg)(q,"package.nls.json"),original:null}):(x=x.substring(0,U),B(x))})};if(G.devMode||G.pseudo||!G.language)return T({localized:(0,d.$vg)(q,"package.nls.json"),original:null});B(G.language)})}z(q,G){return`[${q.path}]: ${G}`}};ue=pe([se(1,k.$sp),se(2,w.$Hk),se(3,o.$0j),se(4,i.$9i)],ue);let te=class extends ue{constructor(q,G,T,C,B,x,Z){super(G,C,B,x,Z),this.G=q,this.H=T,this.D=this.B(new j.$Rg(3e3)),this.F=this.B(new r.$Nd),this.onDidChangeCache=this.F.event}async scanExtensions(q){const G=this.M(q),T=await this.I(G);if(this.C=q,T&&T.input&&K.equals(T.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),T.result.map(B=>(B.location=h.URI.revive(B.location),B));const C=await super.scanExtensions(q);return await this.J(G,{input:q,result:C}),C}async I(q){try{const G=await this.j.readFile(q),T=JSON.parse(G.value.toString());return{result:T.result,input:(0,l.$lh)(T.input)}}catch(G){this.m.debug("Error while reading the extension cache file:",q.path,(0,D.$0)(G))}return null}async J(q,G){try{await this.j.writeFile(q,A.$be.fromString(JSON.stringify(G)))}catch(T){this.m.debug("Error while writing the extension cache file:",q.path,(0,D.$0)(T))}}async L(){if(!this.C)return;const q=this.M(this.C),G=await this.I(q);if(!G)return;const T=G.result,C=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!R.$8m(C,T))try{this.m.info("Invalidating Cache",T,C),await this.j.del(q),this.F.fire()}catch(B){this.m.error(B)}}M(q){const G=this.N(q);return this.h.extUri.joinPath(G.cacheHome,q.type===0?S.$Yl:S.$Xl)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(G=>this.h.extUri.isEqual(q.location,G.extensionsResource))??this.G:this.H.defaultProfile}};te=pe([se(2,y.$Jk),se(3,k.$sp),se(4,w.$Hk),se(5,o.$0j),se(6,i.$9i)],te);function ae(ie,q){const G=(0,p.$Ao)(ie.manifest.publisher,ie.manifest.name);return{id:G,identifier:new S.$4l(G),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:q,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.$zp=ae;class le extends _{constructor(q,G,T,C,B,x,Z,Y,U,z,a,g){super(q,G,(0,d.$vg)(T,".vscode-oss-dev","extensions","control.json"),C,B,x,Z,Y,U,z,a,g),this.R=(async()=>{if(m.$z)try{const F=await this.w.readFile(h.URI.file(m.$z));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$Ap=le}),define(ne[154],re([0,1,58,8,34,4,2,15,16,24,6,23]),function(J,e,L,j,R,A,D,b,u,c,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;let m=class extends D.$Sc{constructor(P,v){super(),this.b=P,this.f=v,this.a=new j.$Zg(5)}async postUninstall(P){const v=this.g(P,"uninstall");v&&(this.f.info(P.identifier.id,P.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(v.script,"uninstall",v.args,!0,P),this.f.info("Finished running post uninstall script",P.identifier.id,P.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",P.identifier.id,P.manifest.version),this.f.error($)}}));try{await c.Promises.rm(this.m(P))}catch($){this.f.error("Error while removing extension storage path",P.identifier.id),this.f.error($)}}g(P,v){const $=`vscode:${v}`;if(P.location.scheme===b.Schemas.file&&P.manifest&&P.manifest.scripts&&typeof P.manifest.scripts[$]=="string"){const h=P.manifest.scripts[$].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(P.identifier.id,P.manifest.version,`${$} should be a node script`),null):{script:(0,u.$jc)(P.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(P,v,$,h,f){return new Promise((I,p)=>{const S=this.j(P,v,$,f);let s;const o=t=>{s&&(clearTimeout(s),s=null),t?p(t):I(void 0)};S.on("error",t=>{o((0,R.$zi)(t)||"Unknown")}),S.on("exit",(t,i)=>{o(t?`post-${v} process exited with code ${t}`:void 0)}),h&&(s=setTimeout(()=>{s=null,S.kill(),p("timed out")},5e3))})}j(P,v,$,h){const f={silent:!0,execArgv:void 0},I=(0,L.fork)(P,[`--type=extension-post-${v}`,...$],f);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const p=A.Event.fromNodeEventEmitter(I.stdout,"data"),S=A.Event.fromNodeEventEmitter(I.stderr,"data");p(t=>this.f.info(h.identifier.id,h.manifest.version,`post-${v}`,t)),S(t=>this.f.error(h.identifier.id,h.manifest.version,`post-${v}`,t));const s=A.Event.any(A.Event.map(p,t=>({data:`%c${t}`,format:[""]})),A.Event.map(S,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(s,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(h.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),I}m(P){return(0,u.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,P.identifier.id.toLowerCase())}};e.$Cp=m,e.$Cp=m=pe([se(0,O.$Jk),se(1,E.$9i)],m)}),define(ne[155],re([0,1,6,23,22,26,40,12,18,11]),function(J,e,L,j,R,A,D,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=void 0;let E=class extends D.$tp{constructor(m,d,P,v,$,h){super(c.URI.file(m.extensionsPath),d,P,v,$,h)}};e.$zN=E,e.$zN=E=pe([se(0,u.$Wh),se(1,b.$0j),se(2,j.$Jk),se(3,R.$Hk),se(4,A.$bl),se(5,L.$9i)],E)}),define(ne[156],re([0,1,11,18,40,50,12,10,6,32,22,23]),function(J,e,L,j,R,A,D,b,u,c,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K7b=void 0;let m=class extends A.$Ap{constructor(P,v,$,h,f,I,p,S){super(L.URI.file(f.builtinExtensionsPath),L.URI.file(f.extensionsPath),f.userHome,P.defaultProfile,P,v,$,h,f,I,p,S)}};e.$K7b=m,e.$K7b=m=pe([se(0,O.$Jk),se(1,R.$sp),se(2,D.$0j),se(3,u.$9i),se(4,j.$Wh),se(5,c.$oj),se(6,E.$Hk),se(7,b.$Nh)],m)}),define(ne[157],re([0,1,8,4,2,123,3,86,10,23]),function(J,e,L,j,R,A,D,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$4o=e.$3o=e.$2o=void 0,e.$2o="__$__isNewStorageMarker",e.$3o="__$__targetStorageMarker",e.$4o=(0,u.$Oh)("storageService");var E;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(E||(e.WillSaveStateReason=E={}));var O;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(O||(e.StorageScope=O={}));var m;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function d(f){const I=f.get(e.$3o);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}e.$5o=d;class P extends R.$Sc{static{this.a=60*1e3}constructor(I={flushInterval:P.a}){super(),this.m=I,this.b=this.B(new j.$Qd),this.c=this.B(new j.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new j.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new L.$6g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(I,p,S){return j.Event.filter(this.b.event,s=>s.scope===I&&(p===void 0||s.key===p),S)}n(){this.j.value=(0,L.$0g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(I,p){const{key:S,external:s}=p;if(S===e.$3o){switch(I){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:S,target:this.J(I)[S],external:s})}w(I){this.f.fire({reason:I})}get(I,p,S){return this.P(p)?.get(I,S)}getBoolean(I,p,S){return this.P(p)?.getBoolean(I,S)}getNumber(I,p,S){return this.P(p)?.getNumber(I,S)}getObject(I,p,S){return this.P(p)?.getObject(I,S)}storeAll(I,p){this.y(()=>{for(const S of I)this.store(S.key,S.value,S.scope,S.target,p)})}store(I,p,S,s,o=!1){if((0,D.$Hf)(p)){this.remove(I,S,o);return}this.y(()=>{this.z(I,S,s),this.P(S)?.set(I,p,o)})}remove(I,p,S=!1){this.y(()=>{this.z(I,p,void 0),this.P(p)?.delete(I,S)})}y(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,p){const S=[],s=this.J(I);for(const o of Object.keys(s))s[o]===p&&S.push(o);return S}z(I,p,S,s=!1){const o=this.J(p);typeof S=="number"?o[I]!==S&&(o[I]=S,this.P(p)?.set(e.$3o,JSON.stringify(o),s)):typeof o[I]=="number"&&(delete o[I],this.P(p)?.set(e.$3o,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(I){switch(I){case-1:return this.I;case 0:return this.G;default:return this.D}}L(I){const p=this.P(I);return p?d(p):Object.create(null)}isNew(I){return this.getBoolean(e.$2o,I)===!0}async flush(I=E.NONE){this.f.fire({reason:I});const p=this.P(-1),S=this.P(0),s=this.P(1);switch(I){case E.NONE:await L.Promises.settled([p?.whenFlushed()??Promise.resolve(),S?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await L.Promises.settled([p?.flush(0)??Promise.resolve(),S?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.P(-1)?.items??new Map,p=this.P(0)?.items??new Map,S=this.P(1)?.items??new Map;return h(I,p,S,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(I){return await this.flush(),this.P(I)?.optimize()}async switch(I,p){return this.w(E.NONE),(0,c.$Ik)(I)?this.R(I,p):this.S(I,p)}M(I,p){return!(I.id===p.id||v(p)&&v(I))}N(I,p,S){this.y(()=>{const s=new Set;for(const[o,t]of I)s.add(o),p.get(o)!==t&&this.u(S,{key:o,external:!0});for(const[o]of p.items)s.has(o)||this.u(S,{key:o,external:!0})})}}e.$6o=P;function v(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$7o=v;class $ extends P{constructor(){super(),this.U=this.B(new b.$Zo(new b.$1o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Zo(new b.$1o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Zo(new b.$1o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(I=>this.u(1,I))),this.B(this.W.onDidChangeStorage(I=>this.u(0,I))),this.B(this.U.onDidChangeStorage(I=>this.u(-1,I)))}P(I){switch(I){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(I){switch(I){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(I){return!1}}e.$8o=$;async function h(f,I,p,S,s,o){const t=H=>{try{return JSON.parse(H)}catch{return H}},i=new Map,n=new Map;f.forEach((H,_)=>{i.set(_,H),n.set(_,t(H))});const r=new Map,l=new Map;I.forEach((H,_)=>{r.set(_,H),l.set(_,t(H))});const k=new Map,y=new Map;p.forEach((H,_)=>{k.set(_,H),y.set(_,t(H))}),console.group(S!==s?`Storage: Application (path: ${S})`:`Storage: Application & Profile (path: ${S}, default profile)`);const w=[];if(i.forEach((H,_)=>{w.push({key:_,value:H})}),console.table(w),console.groupEnd(),console.log(n),S!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const H=[];r.forEach((_,K)=>{H.push({key:K,value:_})}),console.table(H),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const N=[];k.forEach((H,_)=>{N.push({key:_,value:H})}),console.table(N),console.groupEnd(),console.log(y)}e.$9o=h}),define(ne[158],re([0,1,19,20,9,13,35,3,11,25,18,21,27,48,12,6,32,44,142,157,26,175]),function(J,e,L,j,R,A,D,b,u,c,E,O,m,d,P,v,$,h,f,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=void 0;const s=A.$p?"web":(0,O.$3n)(A.$u,D.$ec),o="X-Market-Search-Activity-Id";var t;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...a){return String(a.reduce((g,F)=>g|F,0))}var n;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class w{constructor(g=y){this.d=g}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(g,F=this.d.pageSize){return new w({...this.d,pageNumber:g,pageSize:F})}withFilter(g,...F){const M=[...this.d.criteria,...F.length?F.map(X=>({filterType:g,value:X})):[{filterType:g}]];return new w({...this.d,criteria:M})}withSortBy(g){return new w({...this.d,sortBy:g})}withSortOrder(g){return new w({...this.d,sortOrder:g})}withFlags(...g){return new w({...this.d,flags:g.reduce((F,M)=>F|M,0)})}withAssetTypes(...g){return new w({...this.d,assetTypes:g})}withSource(g){return new w({...this.d,source:g})}get raw(){const{criteria:g,pageNumber:F,pageSize:M,sortBy:X,sortOrder:W,flags:ce,assetTypes:oe}=this.d;return{filters:[{criteria:g,pageNumber:F,pageSize:M,sortBy:X,sortOrder:W}],assetTypes:oe,flags:ce}}get searchText(){const g=this.d.criteria.filter(F=>F.filterType===n.SearchText)[0];return g&&g.value?g.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(g=>String(g.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function N(a,g){const F=(a||[]).filter(M=>M.statisticName===g)[0];return F?F.value:0}function H(a){const g="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(M=>M.assetType.indexOf(g)===0).reduce((M,X)=>{const W=ue(a,X.assetType);return W&&M.push([X.assetType.substring(g.length),W]),M},[])}function _(a){if(a.properties){const g=a.properties.filter(X=>X.key===r.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=g.filter(X=>F.test(X.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return ue(a,r.Repository)}function K(a){return{uri:`${a.fallbackAssetUri}/${r.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${r.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function ue(a,g){return a.files.filter(M=>M.assetType===g)[0]?{uri:`${a.assetUri}/${g}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${g}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function te(a,g){const F=a.properties?a.properties.filter(X=>X.key===g):[],M=F.length>0&&F[0].value;return M?M.split(",").map(X=>(0,m.$Bo)(X)):[]}function ae(a){const g=a.properties?a.properties.filter(F=>F.key===l.Engine):[];return g.length>0&&g[0].value||""}function le(a){const g=a.properties?a.properties.filter(F=>F.key===l.PreRelease):[];return g.length>0&&g[0].value==="true"}function ie(a){const g=a.properties?a.properties.filter(M=>M.key===l.LocalizedLanguages):[],F=g.length>0&&g[0].value||"";return F?F.split(","):[]}function q(a){return a.properties?.find(g=>g.key===l.SponsorLink)?.value}function G(a){return a.indexOf("preview")!==-1}function T(a){return a.targetPlatform?(0,O.$2n)(a.targetPlatform):"undefined"}function C(a){const g=(0,L.$Mb)(a.versions.map(T)),F=!!a.tags?.includes(O.$Wn),M=g.indexOf("web");return F?M===-1&&g.push("web"):M!==-1&&g.splice(M,1),g}function B(a,g){const F=(0,O.$6n)(g);for(let M=0;M<a.length;M++){const X=a[M];if(X.version===a[M-1]?.version){let W=M;const ce=T(X);if(ce===g)for(;W>0&&a[W-1].version===X.version;)W--;else if(F.includes(ce))for(;W>0&&a[W-1].version===X.version&&T(a[W-1])!==g;)W--;W!==M&&(a.splice(M,1),a.splice(W,0,X))}}return a}e.$_o=B;function x(a,g,F){a.telemetryData={index:g,querySource:F,queryActivityId:a.queryContext?.[o]}}function Z(a,g,F,M){const X=a.versions[0],W={manifest:ue(g,r.Manifest),readme:ue(g,r.Details),changelog:ue(g,r.Changelog),license:ue(g,r.License),repository:_(g),download:K(g),icon:ue(g,r.Icon),signature:ue(g,r.Signature),coreTranslations:H(g)};return{identifier:{id:(0,m.$Co)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:g.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(X),description:a.shortDescription||"",installCount:N(a.statistics,"install"),rating:N(a.statistics,"averagerating"),ratingCount:N(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:F,assets:W,properties:{dependencies:te(g,l.Dependency),extensionPack:te(g,l.ExtensionPack),engine:ae(g),localizedLanguages:ie(g),targetPlatform:T(g),isPreReleaseVersion:le(g)},hasPreReleaseVersion:le(X),hasReleaseVersion:!0,preview:G(a.flags),isSigned:!!W.signature,queryContext:M}}let Y=class{constructor(g,F,M,X,W,ce,oe,me){this.k=F,this.l=M,this.n=X,this.o=W,this.q=ce,this.u=oe,this.w=me;const de=oe.extensionsGallery,ge=de?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,f.$$o)(oe.version,oe,this.n,this.w,this.q,g,this.o)}x(g=""){return`${this.d}${g}`}isEnabled(){return!!this.d}async getExtensions(g,F,M){const X=j.CancellationToken.isCancellationToken(F)?{}:F,W=j.CancellationToken.isCancellationToken(F)?F:M,ce=[],oe=[],me=[],de=[];let ge=!0;for(const we of g){we.uuid?oe.push(we.uuid):ce.push(we.id);const be=!!(we.version||we.preRelease);me.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!be}if(!oe.length&&!ce.length)return[];let fe=new w().withPage(1,g.length);oe.length&&(fe=fe.withFilter(n.ExtensionId,...oe)),ce.length&&(fe=fe.withFilter(n.ExtensionName,...ce)),(X.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,t.IncludeVersions)),X.source&&(fe=fe.withSource(X.source));const{extensions:he}=await this.z(fe,{targetPlatform:X.targetPlatform??s,includePreRelease:me,versions:de,compatible:!!X.compatible},W);return X.source&&he.forEach((we,be)=>x(we,be,X.source)),he}async getCompatibleExtension(g,F,M){if((0,O.$4n)(g.allTargetPlatforms,M))return null;if(await this.isExtensionCompatible(g,F,M))return g;const X=new w().withFlags(t.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,g.identifier.uuid),{extensions:W}=await this.z(X,{targetPlatform:M,compatible:!0,includePreRelease:F},j.CancellationToken.None);return W[0]||null}async isExtensionCompatible(g,F,M){if(!(0,O.$5n)(g.properties.targetPlatform,g.allTargetPlatforms,M)||!F&&g.properties.isPreReleaseVersion)return!1;let X=g.properties.engine;if(!X){const W=await this.getManifest(g,j.CancellationToken.None);if(!W)throw new Error("Manifest was not found");X=W.engines.vscode}return(0,d.$Po)(X,this.u.version,this.u.date)}async y(g,F,M,X,W){if(!(0,O.$5n)(T(g),X,W)||F!=="any"&&le(g)!==(F==="prerelease"))return!1;if(M)try{const ce=await this.E(g);if(!(0,d.$Po)(ce,this.u.version,this.u.date))return!1}catch(ce){return this.l.error(`Error while getting the engine for the version ${g.version}.`,(0,R.$0)(ce)),!1}return!0}async query(g,F){let M=g.text||"";const X=g.pageSize??50;let W=new w().withPage(1,X);M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Category,he||fe),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Tag,he||fe),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(n.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),W=W.withFilter(n.SearchText,M)),W=W.withSortBy(0)):g.ids?W=W.withFilter(n.ExtensionId,...g.ids):g.names?W=W.withFilter(n.ExtensionName,...g.names):W=W.withSortBy(4),typeof g.sortBy=="number"&&(W=W.withSortBy(g.sortBy)),typeof g.sortOrder=="number"&&(W=W.withSortOrder(g.sortOrder)),g.source&&(W=W.withSource(g.source));const ce=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!g.includePreRelease},fe);return he.forEach((be,ke)=>x(be,(ge.pageNumber-1)*ge.pageSize+ke,g.source)),{extensions:he,total:we}},{extensions:oe,total:me}=await ce(W,F),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new R.$5;const{extensions:he}=await ce(W.withPage(ge+1),fe);return he};return{firstPage:oe,total:me,pageSize:W.pageSize,getPage:de}}async z(g,F,M){const X=g.flags;g.flags&t.IncludeLatestVersionOnly&&g.flags&t.IncludeVersions&&(g=g.withFlags(g.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(g.flags&t.IncludeLatestVersionOnly)&&!(g.flags&t.IncludeVersions)&&(g=g.withFlags(g.flags,t.IncludeLatestVersionOnly)),F.versions?.length&&(g=g.withFlags(g.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),g=g.withFlags(g.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:W,total:ce,context:oe}=await this.B(g,M);if(!(g.flags&t.IncludeLatestVersionOnly)){const fe=[];for(const he of W){const we=await this.A(he,F,oe);we&&fe.push(we)}return{extensions:fe,total:ce}}const de=[],ge=new Map;for(let fe=0;fe<W.length;fe++){const he=W[fe],we={id:(0,m.$Co)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,b.$Ef)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(Fe=>(0,m.$xo)(Fe,we))?.includePreRelease;if(F.compatible&&(0,O.$4n)(C(he),F.targetPlatform))continue;const ke=await this.A(he,F,oe);!ke||ke.properties.isPreReleaseVersion&&(!be||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==F.targetPlatform&&ke.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,ke])}if(ge.size){const fe=new S.$Jd,he=new w().withFlags(X&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,F,M);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const be of we){const ke=ge.get(be.identifier.uuid);de.push([ke,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:ce}}async A(g,F,M){const X={id:(0,m.$Co)(g.publisher.publisherName,g.extensionName),uuid:g.extensionId},W=F.versions?.find(de=>(0,m.$xo)(de,X))?.version,ce=(0,b.$Ef)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(de=>(0,m.$xo)(de,X))?.includePreRelease,oe=C(g),me=B(g.versions,F.targetPlatform);if(F.compatible&&(0,O.$4n)(oe,F.targetPlatform))return null;for(let de=0;de<me.length;de++){const ge=me[de];if(!(W&&ge.version!==W)){if(await this.y(ge,ce?"any":"release",F.compatible,oe,F.targetPlatform))return Z(g,ge,oe,M);if(W&&ge.version===W)return null}}return W||F.compatible?null:Z(g,g.versions[0],oe)}async B(g,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");g=g.withFlags(g.flags,t.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(t.Unpublished));const M=await this.j,X=JSON.stringify(g.raw),W={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},ce=new S.$Jd;let oe,me,de=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&g.criteria.some(fe=>fe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:X,headers:W},F),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,h.$Wo)(oe);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[o]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw me=ge,ge}finally{this.o.publicLog2("galleryService:query",{...g.telemetryData,requestBodySize:String(X.length),duration:ce.elapsed(),success:!!oe&&(0,h.$So)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:me?(0,R.$4)(me)?"canceled":(0,R.$0)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(g,F,M,X){if(!this.isEnabled())return;const W=A.$p?this.x(`/itemName/${g}.${F}/version/${M}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${g}/extensions/${F}/${M}/stats?statType=${X}`),ce=A.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:ce};try{await this.k.request({type:"POST",url:W,headers:me},j.CancellationToken.None)}catch{}}async download(g,F,M){this.l.trace("ExtensionGalleryService#download",g.identifier.id);const X=(0,m.$Fo)(g),W=new Date().getTime(),ce=fe=>this.o.publicLog("galleryService:downloadVSIX",{...X,duration:fe}),oe=M===2?"install":M===3?"update":"",me=oe?{uri:`${g.assets.download.uri}${u.URI.parse(g.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${g.assets.download.fallbackUri}${u.URI.parse(g.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:g.assets.download,de=g.queryContext?.[o]?{[o]:g.queryContext[o]}:void 0,ge=await this.D(me,de?{headers:de}:void 0);await this.q.writeFile(F,ge.stream),ce(new Date().getTime()-W)}async downloadSignatureArchive(g,F){if(!g.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",g.identifier.id);const M=await this.D(g.assets.signature);await this.q.writeFile(F,M.stream)}async getReadme(g,F){if(g.assets.readme){const M=await this.D(g.assets.readme,{},F);return await(0,h.$Vo)(M)||""}return""}async getManifest(g,F){if(g.assets.manifest){const M=await this.D(g.assets.manifest,{},F),X=await(0,h.$Vo)(M);return X?JSON.parse(X):null}return null}async C(g,F){const M=ue(g,r.Manifest);if(!M)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},W=await this.D(M,{headers:X});return await(0,h.$Wo)(W)}async getCoreTranslation(g,F){const M=g.assets.coreTranslations.filter(X=>X[0]===F.toUpperCase())[0];if(M){const X=await this.D(M[1]),W=await(0,h.$Vo)(X);return W?JSON.parse(W):null}return null}async getChangelog(g,F){if(g.assets.changelog){const M=await this.D(g.assets.changelog,{},F);return await(0,h.$Vo)(M)||""}return""}async getAllCompatibleVersions(g,F,M){let X=new w().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);g.identifier.uuid?X=X.withFilter(n.ExtensionId,g.identifier.uuid):X=X.withFilter(n.ExtensionName,g.identifier.id);const{galleryExtensions:W}=await this.B(X,j.CancellationToken.None);if(!W.length)return[];const ce=C(W[0]);if((0,O.$4n)(ce,M))return[];const oe=[];await Promise.all(W[0].versions.map(async ge=>{try{await this.y(ge,F?"any":"release",!0,ce,M)&&oe.push(ge)}catch{}}));const me=[],de=new Set;for(const ge of B(oe,M))de.has(ge.version)||(de.add(ge.version),me.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:le(ge)}));return me}async D(g,F={},M=j.CancellationToken.None){const X=await this.j,W={type:"GET"},ce={...X,...F.headers||{}};F={...F,...W,headers:ce};const oe=g.uri,me=g.fallbackUri,de={...F,url:oe};try{const ge=await this.k.request(de,M);if(ge.res.statusCode===200)return ge;const fe=await(0,h.$Vo)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,R.$4)(ge))throw ge;const fe=(0,R.$0)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:fe});const he={...F,url:me};return this.k.request(he,M)}}async E(g){let F=ae(g);if(!F){const M=await this.C(g,j.CancellationToken.None);if(!M)throw new Error("Manifest was not found");F=M.engines.vscode}return F}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const g=await this.k.request({type:"GET",url:this.h},j.CancellationToken.None);if(g.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,h.$Wo)(g),M=[],X={},W=[];if(F){for(const ce of F.malicious)M.push({id:ce});if(F.migrateToPreRelease)for(const[ce,oe]of Object.entries(F.migrateToPreRelease))(!oe.engine||(0,d.$Po)(oe.engine,this.u.version,this.u.date))&&(X[ce.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(F.deprecated)for(const[ce,oe]of Object.entries(F.deprecated))oe&&(X[ce.toLowerCase()]=(0,b.$Ef)(oe)?{}:oe);if(F.search)for(const ce of F.search)W.push(ce)}return{malicious:M,deprecated:X,search:W}}};Y=pe([se(1,h.$Qo),se(2,v.$9i),se(3,E.$Vh),se(4,p.$bl),se(5,P.$0j),se(6,$.$oj),se(7,c.$ii)],Y);let U=class extends Y{constructor(g,F,M,X,W,ce,oe,me){super(g,F,M,X,W,ce,oe,me)}};e.$ap=U,e.$ap=U=pe([se(0,I.$4o),se(1,h.$Qo),se(2,v.$9i),se(3,E.$Vh),se(4,p.$bl),se(5,P.$0j),se(6,$.$oj),se(7,c.$ii)],U);let z=class extends Y{constructor(g,F,M,X,W,ce,oe){super(void 0,g,F,M,X,W,ce,oe)}};e.$bp=z,e.$bp=z=pe([se(0,h.$Qo),se(1,v.$9i),se(2,E.$Vh),se(3,p.$bl),se(4,P.$0j),se(5,$.$oj),se(6,c.$ii)],z)}),define(ne[159],re([0,1,11,18,12,6,139,22,23,3,68]),function(J,e,L,j,R,A,D,b,u,c,E){"use strict";var O,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=e.$xN=e.$wN=void 0;let d=class extends u.$Mk{static{O=this}static{this.a="profileAssociationsMigration"}constructor(h,f,I,p,S){super(I,p,f,S),this.U=h,this.W=I}O(){return this.U.getItem(O.b,[]).map(f=>({...f,location:(0,c.$yf)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):L.URI.revive(f.location)}))}Q(){const h=this.U.getItem(O.c,{});return this.U.getItem(O.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$wN=d,e.$wN=d=O=pe([se(0,D.$rN),se(1,b.$Hk),se(2,j.$Wh),se(3,R.$0j),se(4,A.$9i)],d);let P=m=class extends d{constructor(h,f,I,p,S){super(h,f,I,p,S),this.$=h}P(h){h.length?this.$.setItem(m.b,h.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(m.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(m.c,h):this.$.removeItem(m.c)}Q(){const h="workspaceAndProfileInfo",f=this.$.getItem(h,void 0);if(f){this.$.removeItem(h);const p=f.reduce((S,{workspace:s,profile:o})=>(S[L.URI.revive(s).toString()]=L.URI.revive(o).toString(),S),{});this.$.setItem(m.c,{workspaces:p})}const I=super.Q();return this.$.getItem(m.a,!1)||(this.R(I),this.$.setItem(m.a,!0)),I}};e.$xN=P,e.$xN=P=m=pe([se(0,D.$sN),se(1,b.$Hk),se(2,j.$Wh),se(3,R.$0j),se(4,A.$9i)],P);let v=class extends P{constructor(h,f,I,p){super(new E.$vN(0,f,p,I),h,f,I,p)}async init(){return await this.$.init(),super.init()}};e.$yN=v,e.$yN=v=pe([se(0,b.$Hk),se(1,j.$Wh),se(2,R.$0j),se(3,A.$9i)],v)}),define(ne[51],re([0,1,125,8,16,3,24,87,176,177]),function(J,e,L,j,R,A,D,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=e.$lp=e.zip=e.$jp=e.$ip=void 0,e.$ip="end of central directory record signature not found";const E=new RegExp(e.$ip);class O extends Error{constructor(o,t){let i=t.message;switch(o){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=o,this.cause=t}}e.$jp=O;function m(s){const o=s.externalFileAttributes>>16||33188;return[448,56,7].map(t=>o&t).reduce((t,i)=>t+i,o&61440)}function d(s){if(s instanceof O)return s;let o;return E.test(s.message)&&(o="CorruptZip"),new O(o,s)}function P(s,o,t,i,n,r){const l=R.$mc(o),k=R.$jc(i,l);if(!k.startsWith(i))return Promise.reject(new Error(b.localize(0,null,o)));const y=R.$jc(i,o);let w;return r.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(D.Promises.mkdir(k,{recursive:!0})).then(()=>new Promise((N,H)=>{if(!r.isCancellationRequested)try{w=(0,L.createWriteStream)(y,{mode:t}),w.once("close",()=>N()),w.once("error",H),s.once("error",H),s.pipe(w)}catch(_){H(_)}}))}function v(s,o,t,i){let n=(0,j.$Hg)(()=>Promise.resolve()),r=0;const l=i.onCancellationRequested(()=>{n.cancel(),s.close()});return new Promise((k,y)=>{const w=new j.$Og,N=H=>{H.isCancellationRequested||(r++,s.readEntry())};s.once("error",y),s.once("close",()=>n.then(()=>{i.isCancellationRequested||s.entryCount===r?k():y(new O("Incomplete",new Error(b.localize(1,null,r,s.entryCount))))},y)),s.readEntry(),s.on("entry",H=>{if(i.isCancellationRequested)return;if(!t.sourcePathRegex.test(H.fileName)){N(i);return}const _=H.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(_)){const te=R.$jc(o,_);n=(0,j.$Hg)(ae=>D.Promises.mkdir(te,{recursive:!0}).then(()=>N(ae)).then(void 0,y));return}const K=h(s,H),ue=m(H);n=(0,j.$Hg)(te=>w.queue(()=>K.then(ae=>P(ae,_,ue,o,t,te).then(()=>N(te)))).then(null,y))})}).finally(()=>l.dispose())}function $(s,o=!1){return new Promise((t,i)=>{(0,u.open)(s,o?{lazyEntries:!0}:void 0,(n,r)=>{n?i(d(n)):t((0,A.$Jf)(r))})})}function h(s,o){return new Promise((t,i)=>{s.openReadStream(o,(n,r)=>{n?i(d(n)):t((0,A.$Jf)(r))})})}function f(s,o){return new Promise((t,i)=>{const n=new c.ZipFile;o.forEach(l=>{l.contents?n.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&n.addFile(l.localPath,l.path)}),n.end();const r=(0,L.createWriteStream)(s);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>t(s))})}e.zip=f;function I(s,o,t={},i){const n=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let r=$(s,!0);return t.overwrite&&(r=r.then(l=>D.Promises.rm(o).then(()=>l))),r.then(l=>v(l,o,{sourcePathRegex:n},i))}e.$lp=I;function p(s,o){return $(s).then(t=>new Promise((i,n)=>{t.on("entry",r=>{r.fileName===o&&h(t,r).then(l=>i(l),l=>n(l))}),t.once("close",()=>n(new Error(b.localize(2,null,o))))}))}function S(s,o){return p(s,o).then(t=>new Promise((i,n)=>{const r=[];t.once("error",n),t.on("data",l=>r.push(l)),t.on("end",()=>i(Buffer.concat(r)))}))}e.$mp=S}),define(ne[160],re([0,1,8,9,2,15,17,42,3,28,24,51,25,18,21,27,60,12,6]),function(J,e,L,j,R,A,D,b,u,c,E,O,m,d,P,v,$,h,f){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;let p=class extends R.$Sc{static{I=this}static{this.c=".sigzip"}constructor(s,o,t,i,n,r){super(),this.h=o,this.j=t,this.m=i,this.n=n,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,t){await this.g;const i=(0,D.$vg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new P.$9n(r.message,P.ExtensionManagementErrorCode.Download)}let n=!1;if(t&&this.t(s)){const r=await this.u(s);try{n=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===f.LogLevel.Trace)}catch(l){const k=l;if(n=k.code,k.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${k.output}`),n===P.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===P.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new P.$9n(O.$ip,P.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(l){this.r.error(l)}}}return n===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${s.identifier.id}`),{location:i,verificationStatus:n}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,u.$Ef)(o)?o:!0}async u(s){await this.g;const o=(0,D.$vg)(this.extensionsDownloadDir,`${this.z(s)}${I.c}`);return await this.w(s,o,t=>this.j.downloadSignatureArchive(s,t)),o}async w(s,o,t){if(await this.h.exists(o))return;if(o.scheme!==A.Schemas.file){await t(o);return}const i=(0,D.$vg)(this.extensionsDownloadDir,`.${(0,c.$eg)()}`);await this.h.exists(i)||await t(i);try{await E.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,j.$0)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],t=[],i=[];for(const l of s.children)if(l.name.endsWith(I.c))i.push(l.resource);else{const k=v.$yo.parse(l.name);k&&t.push([k,l])}const n=(0,v.$Do)(t,([l])=>l),r=[];for(const l of n)l.sort((k,y)=>b.rcompare(k[0].version,y[0].version)),o.push(...l.slice(1).map(k=>k[1].resource)),r.push(l[0][1]);r.sort((l,k)=>l.mtime-k.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(l=>l.resource)),o.push(...i),await L.Promises.settled(o.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(s){this.r.error(s)}}z(s){return this.f?v.$yo.create(s).toString().toLowerCase():(0,c.$eg)()}};e.$Bp=p,e.$Bp=p=I=pe([se(0,d.$Wh),se(1,h.$0j),se(2,P.$8n),se(3,m.$ii),se(4,$.$cp),se(5,f.$9i)],p)}),define(ne[161],re([0,1,51,97]),function(J,e,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;function R(A){return(0,L.$mp)(A,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,j.localize)(0,null))}})}e.$Dp=R}),define(ne[162],re([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,12,10,6,32,26,22,23]),function(J,e,L,j,R,A,D,b,u,c,E,O,m,d,P,v,$,h,f,I,p,S,s,o,t,i,n,r,l,k,y,w,N,H,_,K,ue,te,ae,le,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.$Hp=e.$Gp=void 0,e.$Gp=(0,K.$Ph)(t.$0n);const q=".vsctmp";let G=class extends o.$np{constructor(U,z,a,g,F,M,X,W,ce,oe,me,de){super(U,z,me,a,oe,de),this.fb=F,this.gb=M,this.hb=X,this.ib=ce,this.eb=new Map,this.rb=new E.$Bc;const ge=this.B(W.createInstance(k.$Cp));this.bb=this.B(W.createInstance(T,he=>ge.postUninstall(he))),this.cb=this.B(new w.$Ep(de,ce,me,this,this.F)),this.db=this.B(W.createInstance(l.$Bp));const fe=this.B(new N.$Fp(this,this.fb,de,M,me,ce,a));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Io)(this.ib,this.F)),this.jb}async zip(U){this.F.trace("ExtensionManagementService#zip",U.identifier.id);const z=await this.pb(U),a=await(0,I.zip)((0,d.$vg)(this.db.extensionsDownloadDir,(0,h.$eg)()).fsPath,z);return $.URI.file(a)}async unzip(U){return this.F.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:z,cleanup:a}=await this.lb(U),g=m.$kc(z.fsPath);try{return await(0,y.$Dp)(g)}finally{await a()}}getInstalled(U,z=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(U??null,z)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(U){return this.bb.scanUserExtensionAtLocation(U)}async install(U,z={}){this.F.trace("ExtensionManagementService#install",U.toString());const{location:a,cleanup:g}=await this.lb(U);try{const F=await(0,y.$Dp)(m.$kc(a.fsPath)),M=(0,i.$Co)(F.publisher,F.name);if(F.engines&&F.engines.vscode&&!(0,H.$Po)(F.engines.vscode,this.G.version,this.G.date))throw new Error(p.localize(0,null,M,this.G.version));const W=(await this.I([{manifest:F,extension:a,options:z}])).find(({identifier:ce})=>(0,i.$xo)(ce,{id:M}));if(W?.local)return W.local;throw W?.error?W.error:(0,o.$pp)(new Error(`Unknown error while installing extension ${M}`))}finally{await g()}}async installFromLocation(U,z){this.F.trace("ExtensionManagementService#installFromLocation",U.toString());const a=await this.bb.scanUserExtensionAtLocation(U);if(!a)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.ub([[a,void 0]],z),this.F.info("Successfully installed extension",a.identifier.id,z.toString()),a}async installExtensionsFromProfile(U,z,a){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",U,z.toString(),a.toString());const g=(await this.bb.scanExtensions(1,z)).filter(F=>U.some(M=>(0,i.$xo)(M,F.identifier)));if(g.length){const F=await Promise.all(g.map(M=>this.bb.scanMetadata(M,z)));await this.ub(g.map((M,X)=>[M,F[X]]),a),this.F.info("Successfully installed extensions",g.map(M=>M.identifier.id),a.toString())}return g}async updateMetadata(U,z,a=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",U.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),U=await this.bb.updateMetadata(U,z,a),this.cb.invalidate(a),this.w.fire(U),U}async reinstallFromGallery(U){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.z.isEnabled())throw new Error(p.localize(1,null));const z=await this.getTargetPlatform(),[a]=await this.z.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:z,compatible:!0},R.CancellationToken.None);if(!a)throw new Error(p.localize(2,null));await this.bb.setUninstalled(U);try{await this.bb.removeUninstalledExtension(U)}catch(g){throw new Error(p.localize(3,null,(0,A.$zi)(g)))}return this.installFromGallery(a)}ab(U,z,a,g){return this.bb.copyExtension(U,z,a,g)}copyExtensions(U,z){return this.bb.copyExtensions(U,z)}markAsUninstalled(...U){return this.bb.setUninstalled(...U)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(U){this.F.error(U)}}async download(U,z,a){const{location:g}=await this.db.download(U,z,!a);return g}async lb(U){if(U.scheme===O.Schemas.file)return{location:U,async cleanup(){}};this.F.trace("Downloading extension from",U.toString());const z=(0,d.$vg)(this.db.extensionsDownloadDir,(0,h.$eg)());return await this.hb.download(U,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(g){this.F.error(g)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(U,z,a){if($.URI.isUri(z))return new x(U,z,a,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const g=i.$yo.create(z).toString();let F=this.eb.get(g);return F||(this.eb.set(g,F=new B(U,z,a,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),F.waitUntilTaskIsFinished().finally(()=>this.eb.delete(g))),F}$(U,z){return new Z(U,z.profileLocation,this.gb)}async pb(U){const z=async g=>{let F=await f.Promises.readdir(g);F=F.map(W=>m.$jc(g,W));const M=await Promise.all(F.map(W=>f.Promises.stat(W)));let X=Promise.resolve([]);return M.forEach((W,ce)=>{const oe=F[ce];W.isFile()&&(X=X.then(me=>[...me,oe])),W.isDirectory()&&(X=X.then(me=>z(oe).then(de=>[...me,...de])))}),X};return(await z(U.location.fsPath)).map(g=>({path:`extension/${m.$lc(U.location.fsPath,g)}`,localPath:g}))}async qb({added:U,removed:z}){if(z){const a=U&&this.D.extUri.isEqual(z.profileLocation,U.profileLocation)?z.extensions.filter(g=>U.extensions.every(F=>!(0,i.$xo)(F,g))):z.extensions;for(const g of a)this.F.info("Extensions removed from another source",g.id,z.profileLocation.toString()),this.u.fire({identifier:g,profileLocation:z.profileLocation})}if(U){const g=(await this.bb.scanExtensions(1,U.profileLocation)).filter(F=>U.extensions.some(M=>(0,i.$xo)(M,F.identifier)));this.s.fire(g.map(F=>(this.F.info("Extensions added from another source",F.identifier.id,U.profileLocation.toString()),{identifier:F.identifier,local:F,profileLocation:U.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(z=>this.rb.add(z)));const U=await this.ib.resolve(this.fb.userExtensionsLocation);for(const z of U.children??[])z.isDirectory&&this.rb.add(z.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.tb(z)))}async tb(U){if(!U.affects(this.fb.userExtensionsLocation,1))return;const z=[];for(const a of U.rawAdded){if(this.rb.has(a)||!this.D.extUri.isEqual(this.D.extUri.dirname(a),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(a,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(a).startsWith(".")||!(await this.ib.stat(a)).isDirectory)continue;const g=await this.bb.scanUserExtensionAtLocation(a);g&&g.installedTimestamp===void 0&&(this.rb.add(a),z.push(g))}z.length&&(await this.ub(z.map(a=>[a,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(a=>a.identifier.id)))}async ub(U,z){const a=U.map(g=>g[0]);await this.vb(a),await this.gb.addExtensionsToProfile(U,z),this.s.fire(a.map(g=>({local:g,identifier:g.identifier,operation:1,profileLocation:z})))}async vb(U){const z=await this.bb.getUninstalledExtensions();for(const a of U){const g=i.$yo.create(a);z[g.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",g.id),await this.bb.setInstalled(g),this.F.info("Removed the extension from uninstalled list:",g.id))}}};e.$Hp=G,e.$Hp=G=pe([se(0,t.$8n),se(1,ae.$bl),se(2,ue.$9i),se(3,s.$Wh),se(4,r.$wp),se(5,n.$sp),se(6,S.$Ln),se(7,K.$Nh),se(8,_.$0j),se(9,te.$oj),se(10,le.$Hk),se(11,ie.$Jk)],G);let T=class extends c.$Sc{constructor(U,z,a,g,F,M){super(),this.j=U,this.m=z,this.n=a,this.s=g,this.t=F,this.u=M,this.h=this.B(new b.$Nd),this.onExtract=this.h.event,this.c=(0,d.$vg)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$1g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(U,z){const a={includeInvalid:!0,profileLocation:z};let g=[];return U===null||U===0?g.push(...await this.n.scanAllExtensions({includeInvalid:!0},a,!1)):U===1&&g.push(...await this.n.scanUserExtensions(a)),g=U!==null?g.filter(F=>F.type===U):g,Promise.all(g.map(F=>this.F(F)))}async scanAllUserExtensions(U){const z=await this.n.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(z.map(a=>this.F(a)))}async scanUserExtensionAtLocation(U){try{const z=await this.n.scanExistingExtension(U,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(U,z,a,g,F){const M=U.toString(),X=$.URI.file(m.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,h.$eg)()}`)),W=$.URI.file(m.$jc(this.n.userExtensionsLocation.fsPath,M));let ce=await this.m.exists(W);if(ce&&g){try{await this.y(U.id,W,"removeExisting")}catch{throw new t.$9n(p.localize(4,null,W.fsPath,U.id),t.ExtensionManagementErrorCode.Delete)}ce=!1}if(!ce)try{try{this.u.trace(`Started extracting the extension from ${z} to ${W.fsPath}`),await(0,I.$lp)(z,X.fsPath,{sourcePath:"extension",overwrite:!0},F),this.u.info(`Extracted extension to ${W}:`,U.id)}catch(oe){let me=t.ExtensionManagementErrorCode.Extract;throw oe instanceof I.$jp&&(oe.type==="CorruptZip"?me=t.ExtensionManagementErrorCode.CorruptZip:oe.type==="Incomplete"&&(me=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$9n(oe.message,me)}await this.n.updateMetadata(X,a);try{this.u.trace(`Started renaming the extension from ${X.fsPath} to ${W.fsPath}`),await this.C(X.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(oe){if(oe.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.u.info(`Rename failed because of ${(0,D.$0)(oe)}. Deleted from extracted location`,X),oe}this.h.fire(W)}catch(oe){try{await this.m.del(X,{recursive:!0})}catch{}throw oe}return this.D(W,1)}async scanMetadata(U,z){return z?(await this.w(U,z))?.metadata:this.n.scanMetadata(U.location)}async w(U,z){return(await this.s.scanProfileExtensions(z)).find(g=>(0,i.$xo)(g.identifier,U.identifier))}async updateMetadata(U,z,a){return a?await this.s.updateMetadata([[U,z]],a):await this.n.updateMetadata(U.location,z),this.D(U.location,U.type,a)}getUninstalledExtensions(){return this.z()}async setUninstalled(...U){const z=U.map(a=>i.$yo.create(a));await this.z(a=>z.forEach(g=>{a[g.toString()]=!0,this.u.info("Marked extension as uninstalled",g.toString())}))}async setInstalled(U){await this.z(z=>delete z[U.toString()])}async removeExtension(U,z){if(this.t.extUri.isEqualOrParent(U.location,this.n.userExtensionsLocation))return this.y(U.identifier.id,U.location,z)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.z(z=>delete z[i.$yo.create(U).toString()])}async copyExtension(U,z,a,g){const F=await this.w(U,z),M=await this.w(U,a);return g={...F?.metadata,...g},M?await this.s.updateMetadata([[U,{...M.metadata,...g}]],a):await this.s.addExtensionsToProfile([[U,g]],a),this.D(U.location,U.type,a)}async copyExtensions(U,z){const a=await this.scanExtensions(1,U),g=await Promise.all(a.filter(F=>!F.isApplicationScoped).map(async F=>[F,await this.scanMetadata(F,U)]));await this.s.addExtensionsToProfile(g,z)}async y(U,z,a){this.u.trace(`Deleting ${a} extension from disk`,U,z.fsPath);const g=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,u.$Ci)((0,h.$eg)()).toString(16)}${q}`);await this.C(z.fsPath,g.fsPath),await this.m.del(g,{recursive:!0}),this.u.info(`Deleted ${a} extension from disk`,U,z.fsPath)}async z(U){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(g){if((0,_.$ok)(g)!==1)throw g}let a={};if(z)try{a=JSON.parse(z)}catch{}return U&&(U(a),Object.keys(a).length?await this.m.writeFile(this.c,j.$be.fromString(JSON.stringify(a))):await this.m.del(this.c)),a})}async C(U,z){try{await f.Promises.rename(U,z,2*60*1e3)}catch(a){throw new t.$9n(a.message||p.localize(5,null,U,z),a.code||t.ExtensionManagementErrorCode.Rename)}}async D(U,z,a){if(a){const F=(await this.n.scanUserExtensions({profileLocation:a})).find(M=>this.t.extUri.isEqual(M.location,U));if(F)return this.F(F)}else{const g=await this.n.scanExistingExtension(U,z,{includeInvalid:!0});if(g)return this.F(g)}throw new Error(p.localize(6,null,U.path))}async F(U){const z=await this.m.resolve(U.location);let a,g;return z.children&&(a=z.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,g=z.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:a,changelogUrl:g,publisherDisplayName:U.metadata?.publisherDisplayName||null,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned}}async G(){const U=await this.getUninstalledExtensions();if(Object.keys(U).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(U));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const F of z)U[i.$yo.create(F).toString()]||a.add(F.identifier.id.toLowerCase());try{const F=(0,i.$Do)(z,M=>M.identifier);await L.Promises.settled(F.map(async M=>{const X=M.sort((W,ce)=>P.rcompare(W.manifest.version,ce.manifest.version))[0];a.has(X.identifier.id.toLowerCase())||await this.j(await this.F(X))}))}catch(F){this.u.error(F)}const g=z.filter(F=>F.metadata&&U[i.$yo.create(F).toString()]);await Promise.allSettled(g.map(F=>this.removeUninstalledExtension(F)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let U;try{U=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,_.$ok)(z)!==1&&this.u.error(z);return}if(U?.children)try{await Promise.allSettled(U.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(a){(0,_.$ok)(a)!==1&&this.u.error(a)}}}))}catch{}}};e.$Ip=T,e.$Ip=T=pe([se(1,_.$0j),se(2,r.$wp),se(3,n.$sp),se(4,le.$Hk),se(5,ue.$9i)],T);class C extends o.$qp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,v.$Ff)(this.options.operation)?this.l:this.options.operation}constructor(U,z,a,g,F,M,X,W,ce){super(),this.identifier=U,this.source=z,this.options=a,this.m=g,this.n=F,this.o=M,this.p=X,this.q=W,this.s=ce,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(U){const[z,a]=await this.x(U);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,a]],this.j),z}async u({zipPath:U,key:z,metadata:a},g,F){let M=await this.v(z);return M||(this.s.trace("Extracting extension...",z.id),M=await this.m.extractUserExtension(z,U,a,g,F),this.s.info("Extracting extension completed.",z.id)),M}async v(U){return await this.w(U)?(this.s.trace("Removing the extension from uninstalled list:",U.id),await this.m.setInstalled(U),this.s.info("Removed the extension from uninstalled list:",U.id),(await this.m.scanAllUserExtensions(!0)).find(g=>i.$yo.create(g).equals(U))):void 0}async w(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}}class B extends C{constructor(U,z,a,g,F,M,X,W,ce,oe){super(z.identifier,z,a,F,M,X,W,ce,oe),this.y=z,this.z=g}async x(U){const a=(await this.m.scanExtensions(null,this.options.profileLocation)).find(X=>(0,i.$xo)(X.identifier,this.y.identifier));a&&(this.l=3);const g={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,v.$Ef)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.y.version)return[await this.m.updateMetadata(a,g),g];const{location:F,verificationStatus:M}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=M,this.B(F.fsPath),[await this.u({zipPath:F.fsPath,key:i.$yo.create(this.y),metadata:g},!1,U),g]}catch(X){try{await this.z.delete(F)}catch(W){this.s.warn("Error while deleting the downloaded file",F.toString(),(0,D.$0)(W))}throw X}}async B(U){try{await(0,y.$Dp)(U)}catch(z){throw new t.$9n((0,o.$op)(z).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$Jp=B;class x extends C{constructor(U,z,a,g,F,M,X,W,ce,oe){super({id:(0,i.$Co)(U.publisher,U.name)},z,a,F,M,X,W,ce,oe),this.y=U,this.z=z,this.A=g}async h(U){const z=await super.h(U);return this.D(z,U),z}async x(U){const z=new i.$yo(this.identifier,this.y.version),g=(await this.m.scanExtensions(1,this.options.profileLocation)).find(X=>(0,i.$xo)(this.identifier,X.identifier)),F={isApplicationScoped:this.options.isApplicationScoped||g?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||g?.isMachineScoped,isBuiltin:this.options.isBuiltin||g?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(g)if(this.l=3,z.equals(new i.$yo(g.identifier,g.manifest.version)))try{await this.m.removeExtension(g,"existing")}catch{throw new Error(p.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&P.gt(g.manifest.version,this.y.version)&&await this.m.setUninstalled(g);else{const X=await this.v(z);if(X)try{await this.m.removeExtension(X,"existing")}catch{throw new Error(p.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:m.$kc(this.z.fsPath),key:z,metadata:F},!0,U),F]}async D(U,z){try{let[a]=await this.A.getExtensions([{id:U.identifier.id,version:U.manifest.version}],z);if(a||([a]=await this.A.getExtensions([{id:U.identifier.id}],z)),a){const g={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(U,g,this.options.profileLocation)}}catch{}}}class Z extends o.$qp{constructor(U,z,a){super(),this.extension=U,this.j=z,this.k=a}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],re([0,1,137,8,14,9,3,25,18,138,6,44,136,178]),function(J,e,L,j,R,A,D,b,u,c,E,O,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;let P=class extends O.$Ro{constructor(f,I,p,S){super(S),this.m=f,this.n=I,this.r=p,this.s(),this.B(f.onDidChangeConfiguration(s=>{s.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,I){const{f:p,g:S}=this;let s;try{s=await(0,c.$Rl)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$0)(i)))}const o={...process.env,...s},t=f.agent?f.agent:await(0,m.$Vq)(f.url||"",o,{proxyUrl:p,strictSSL:S});return f.agent=t,f.strictSSL=S,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>$(f,I))}async resolveProxy(f){}};e.$Wq=P,e.$Wq=P=pe([se(0,b.$ii),se(1,u.$Wh),se(2,E.$9i),se(3,E.$0i)],P);async function v(h){return((0,L.parse)(h.url).protocol==="https:"?await new Promise((p,S)=>{J(["https"],p,S)}):await new Promise((p,S)=>{J(["http"],p,S)})).request}async function $(h,f){return j.Promises.withAsyncBody(async(I,p)=>{const S=(0,L.parse)(h.url),s=h.getRawRequest?h.getRawRequest(h):await v(h),o={hostname:S.hostname,port:S.port?parseInt(S.port):S.protocol==="https:"?443:80,protocol:S.protocol,path:S.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,D.$Ef)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(o.auth=h.user+":"+h.password);const t=s(o,i=>{const n=(0,D.$Cf)(h.followRedirects)?h.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)$({...h,url:i.headers.location,followRedirects:n-1},f).then(I,p);else{let r=i;!h.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,d.createGunzip)())),I({res:i,stream:(0,R.$qe)(r)})}});t.on("error",p),h.timeout&&t.setTimeout(h.timeout),h.isChromiumNetwork&&t.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&t.write(h.data),t.end(),f.onCancellationRequested(()=>{t.abort(),p(new A.$5)})})}e.$Xq=$}),define(ne[179],re([0,1,33,8,34,9,2,15,16,13,35,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,12,122,124,49,120,63,64,143,6,129,38,130,146,32,44,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(J,e,L,j,R,A,D,b,u,c,E,O,m,d,P,v,$,h,f,I,p,S,s,o,t,i,n,r,l,k,y,w,N,H,_,K,ue,te,ae,le,ie,q,G,T,C,B,x,Z,Y,U,z,a,g,F,M,X,W,ce,oe,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends D.$Sc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const ke=be.get(K.$9i),Fe=be.get(r.$0j),V=be.get(h.$Wh),Q=be.get(g.$Jk);ke.info("CLI main",this.b),this.g(ke),await this.h(V,Fe,Q,he),await Promise.all(we.map(ee=>{(0,j.$Lg)(ee.flush(),1e3)}))})}async f(){const he=new N.$Mh,we={_serviceBrand:void 0,...le.default};he.set(ie.$oj,we);const be=new f.$hm(this.b,we);he.set(h.$Wh,be),await Promise.all([be.appSettingsHome.with({scheme:b.Schemas.file}).fsPath,be.extensionsPath].map(je=>je?m.Promises.mkdir(je,{recursive:!0}):void 0));const ke=new ce.$qN((0,K.$kj)(be),be.logsHome);he.set(K.$0i,ke);const Fe=this.B(ke.createLogger("cli",{name:(0,oe.localize)(0,null)})),V=[];ke.getLogLevel()===K.LogLevel.Trace&&V.push(new K.$ej(ke.getLogLevel()));const Q=this.B(new W.$AN(Fe,V));he.set(K.$9i,Q);const ee=this.B(new l.$Lp(Q));he.set(r.$0j,ee);const $e=this.B(new k.$$p(Q));ee.registerProvider(b.Schemas.file,$e);const ye=new a.$xr(ee);he.set(z.$Hk,ye);const Re=new T.$uN(1,be,Q,ee),Se=new F.$wN(Re,ye,be,ee,Q);he.set(g.$Jk,Se),ee.registerProvider(b.Schemas.vscodeUserData,new me.$07b(b.Schemas.file,$e,b.Schemas.vscodeUserData,Se,ye,Q));const Le=c.$j&&we.win32RegValueName?this.B(new ae.$87b(Q,we.win32RegValueName)):be.policyFile?this.B(new ue.$97b(be.policyFile,ee,Q)):new te.$hn;he.set(te.$fn,Le);const Ie=this.B(new P.$Hn(Se.defaultProfile.settingsResource,ee,Le,Q));he.set(d.$ii,Ie),await Promise.all([Re.init(),Ie.initialize()]);let Ae;try{Ae=await(0,M.$N7b)(Re,Q)}catch(je){je.code!=="ENOENT"&&Q.error(je)}Se.init(),he.set(z.$Hk,new a.$xr(ee));const Ue=new G.$Wq(Ie,be,Q,ke);he.set(q.$Qo,Ue),he.set(v.$Ln,new y.$Lh($.$PN,void 0,!0)),he.set(o.$sp,new y.$Lh(X.$zN,void 0,!0)),he.set(t.$wp,new y.$Lh(n.$K7b,void 0,!0)),he.set(S.$cp,new y.$Lh(S.$dp,void 0,!0)),he.set(i.$Gp,new y.$Lh(i.$Hp,void 0,!0)),he.set(p.$8n,new y.$Lh(I.$bp,void 0,!0)),he.set(H.$Qq,new y.$Lh(_.$Sq,void 0,!1));const Oe=[],De=(0,Z.$uo)(we,Ie);if((0,Z.$po)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&Oe.push(new Y.$oN(Ue,De,"monacoworkbench",null,we.aiConfig.ariaKey));const je={appenders:Oe,sendErrorTelemetry:!1,commonProperties:(0,C.$fo)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,Ae,De),piiPaths:(0,Z.$vo)(be)};he.set(B.$bl,new y.$Lh(x.$Yq,[je],!1))}else he.set(B.$bl,Z.$jo);return[new w.$bq(he),Oe]}g(he){(0,A.setUnexpectedErrorHandler)(we=>{const be=(0,R.$zi)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,A.$Z)(we)||(0,A.$1)(we)}),process.on("unhandledRejection",we=>(0,A.$1)(we))}async h(he,we,be,ke){let Fe;if(he.args.profile&&(Fe=be.profiles.find(Q=>Q.name===he.args.profile),!Fe))throw new Error(`Profile '${he.args.profile}' not found.`);const V=(Fe??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(s.$ep,new K.$ej(K.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Q={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return ke.createInstance(s.$ep,new K.$ej(K.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Q,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(s.$ep,new K.$ej(K.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["locate-extension"])return ke.createInstance(s.$ep,new K.$ej(K.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,U.$t8b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?O.URI.file((0,u.$ic)(we)?we:(0,u.$jc)((0,E.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9bb94efbe279580856897b63cc9417a3e875e405/core/vs/code/node/cliProcessMain.js.map
