/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/path","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/workbench/api/common/extHostCommands","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","vs/editor/common/core/position","vs/base/common/marshalling","os","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function($e){for(var e=[],C=0,T=$e.length;C<T;C++)e[C]=De[$e[C]];return e};define(De[156],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class C{static get(){const d=new Map,L=new Map,A=new Map,$=new Map;function E(y,k){y.has(k.detail)||y.set(k.detail,-k.timestamp)}function v(y,k){const p=y.get(k.detail);p&&(p>=0||y.set(k.detail,p+k.timestamp))}let R=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(R=$e.getStats().slice(0).sort((y,k)=>y.timestamp-k.timestamp));for(const y of R)switch(y.type){case 10:E(d,y);break;case 11:case 12:v(d,y);break;case 21:E(L,y);break;case 22:v(L,y);break;case 33:E(A,y);break;case 34:v(A,y);break;case 31:E($,y);break;case 32:v($,y);break}let I=0;A.forEach(y=>I+=y);function w(y){const k=[];return y.forEach((p,u)=>k.push([u,p])),k}return{amdLoad:w(d),amdInvoke:w(L),nodeRequire:w(A),nodeEval:w($),nodeRequireTotal:I}}static toMarkdownTable(d,L){let A="";const $=[];return d.forEach((E,v)=>{$[v]=E.length}),L.forEach(E=>{E.forEach((v,R)=>{typeof v>"u"&&(v=E[R]="-");const I=v.toString().length;$[R]=Math.max(I,$[R])})}),d.forEach((E,v)=>{A+=`| ${E+" ".repeat($[v]-E.toString().length)} `}),A+=`|
`,d.forEach((E,v)=>{A+=`| ${"-".repeat($[v])} `}),A+=`|
`,L.forEach(E=>{E.forEach((v,R)=>{typeof v<"u"&&(A+=`| ${v+" ".repeat($[R]-v.toString().length)} `)}),A+=`|
`}),A}}e.$U=C}),define(De[118],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function C(p,u,c){const r=T(p,u);if(r!==-1)return p[r]}e.$fb=C;function T(p,u,c=p.length-1){for(let r=c;r>=0;r--){const o=p[r];if(u(o))return r}return-1}e.$gb=T;function d(p,u){const c=L(p,u);return c===-1?void 0:p[c]}e.$hb=d;function L(p,u,c=0,r=p.length){let o=c,m=r;for(;o<m;){const h=Math.floor((o+m)/2);u(p[h])?o=h+1:m=h}return o-1}e.$ib=L;function A(p,u){const c=$(p,u);return c===p.length?void 0:p[c]}e.$jb=A;function $(p,u,c=0,r=p.length){let o=c,m=r;for(;o<m;){const h=Math.floor((o+m)/2);u(p[h])?m=h:o=h+1}return o}e.$kb=$;function E(p,u,c=0,r=p.length){const o=$(p,u,c,r);return o===p.length?-1:o}e.$lb=E;class v{static{this.assertInvariants=!1}constructor(u){this.e=u,this.c=0}findLastMonotonous(u){if(v.assertInvariants){if(this.d){for(const r of this.e)if(this.d(r)&&!u(r))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=u}const c=L(this.e,u,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$mb=v;function R(p,u){if(p.length===0)return;let c=p[0];for(let r=1;r<p.length;r++){const o=p[r];u(o,c)>0&&(c=o)}return c}e.$nb=R;function I(p,u){if(p.length===0)return;let c=p[0];for(let r=1;r<p.length;r++){const o=p[r];u(o,c)>=0&&(c=o)}return c}e.$ob=I;function w(p,u){return R(p,(c,r)=>-u(c,r))}e.$pb=w;function y(p,u){if(p.length===0)return-1;let c=0;for(let r=1;r<p.length;r++){const o=p[r];u(o,p[c])>0&&(c=r)}return c}e.$qb=y;function k(p,u){for(const c of p){const r=u(c);if(r!==void 0)return r}}e.$rb=k}),define(De[74],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function C(A,$){const E=Object.create(null);for(const v of A){const R=$(v);let I=E[R];I||(I=E[R]=[]),I.push(v)}return E}e.$J=C;function T(A,$){const E=[],v=[];for(const R of A)$.has(R)||E.push(R);for(const R of $)A.has(R)||v.push(R);return{removed:E,added:v}}e.$K=T;function d(A,$){const E=[],v=[];for(const[R,I]of A)$.has(R)||E.push(I);for(const[R,I]of $)A.has(R)||v.push(I);return{removed:E,added:v}}e.$L=d;function L(A,$){const E=new Set;for(const v of $)A.has(v)&&E.add(v);return E}e.$M=L}),define(De[57],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=e.$hh=e.$gh=void 0;function C(A){return($,E,v)=>{let R=null,I=null;if(typeof v.value=="function"?(R="value",I=v.value):typeof v.get=="function"&&(R="get",I=v.get),!I)throw new Error("not supported");v[R]=A(I,E)}}function T(A,$,E){let v=null,R=null;if(typeof E.value=="function"?(v="value",R=E.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(v="get",R=E.get),!R)throw new Error("not supported");const I=`$memoize$${$}`;E[v]=function(...w){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,w)}),this[I]}}e.$gh=T;function d(A,$,E){return C((v,R)=>{const I=`$debounce$${R}`,w=`$debounce$result$${R}`;return function(...y){this[w]||(this[w]=E?E():void 0),clearTimeout(this[I]),$&&(this[w]=$(this[w],...y),y=[this[w]]),this[I]=setTimeout(()=>{v.apply(this,y),this[w]=E?E():void 0},A)}})}e.$hh=d;function L(A,$,E){return C((v,R)=>{const I=`$throttle$timer$${R}`,w=`$throttle$result$${R}`,y=`$throttle$lastRun$${R}`,k=`$throttle$pending$${R}`;return function(...p){if(this[w]||(this[w]=E?E():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),$&&(this[w]=$(this[w],...p)),this[k])return;const u=this[y]+A;u<=Date.now()?(this[y]=Date.now(),v.apply(this,[this[w]]),this[w]=E?E():void 0):(this[k]=!0,this[I]=setTimeout(()=>{this[k]=!1,this[y]=Date.now(),v.apply(this,[this[w]]),this[w]=E?E():void 0},u-Date.now()))}})}e.$ih=L}),define(De[8],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class C{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?o.isErrorNoTelemetry(t)?new o(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(n=>{n(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=C,e.$X=new C;function T(h){e.$X.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=T;function d(h){if(!h||typeof h!="object")return!1;const t=h;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=d;function L(h){v(h)||e.$X.onUnexpectedError(h)}e.$1=L;function A(h){v(h)||e.$X.onUnexpectedExternalError(h)}e.$2=A;function $(h){if(h instanceof Error){const{name:t,message:n}=h,a=h.stacktrace||h.stack;return{$isError:!0,name:t,message:n,stack:a,noTelemetry:o.isErrorNoTelemetry(h)}}return h}e.$3=$;const E="Canceled";function v(h){return h instanceof R?!0:h instanceof Error&&h.name===E&&h.message===E}e.$4=v;class R extends Error{constructor(){super(E),this.name=this.message}}e.$5=R;function I(){const h=new Error(E);return h.name=h.message,h}e.$6=I;function w(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.$7=w;function y(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.$8=y;class k extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=k;function p(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.$0=p;class u extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=u;class c extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=c;class r extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=r;class o extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof o)return t;const n=new o;return n.message=t.message,n.stack=t.stack,n}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=o;class m extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$cb=m}),define(De[19],Ce([1,0,8,118]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function d(ee,ne=0){return ee[ee.length-(1+ne)]}e.$sb=d;function L(ee){if(ee.length===0)throw new Error("Invalid tail call");return[ee.slice(0,ee.length-1),ee[ee.length-1]]}e.$tb=L;function A(ee,ne,re=(Ee,ce)=>Ee===ce){if(ee===ne)return!0;if(!ee||!ne||ee.length!==ne.length)return!1;for(let Ee=0,ce=ee.length;Ee<ce;Ee++)if(!re(ee[Ee],ne[Ee]))return!1;return!0}e.$ub=A;function $(ee,ne){const re=ee.length-1;ne<re&&(ee[ne]=ee[re]),ee.pop()}e.$vb=$;function E(ee,ne,re){return v(ee.length,Ee=>re(ee[Ee],ne))}e.$wb=E;function v(ee,ne){let re=0,Ee=ee-1;for(;re<=Ee;){const ce=(re+Ee)/2|0,de=ne(ce);if(de<0)re=ce+1;else if(de>0)Ee=ce-1;else return ce}return-(re+1)}e.$xb=v;function R(ee,ne,re){if(ee=ee|0,ee>=ne.length)throw new TypeError("invalid index");const Ee=ne[Math.floor(ne.length*Math.random())],ce=[],de=[],te=[];for(const he of ne){const be=re(he,Ee);be<0?ce.push(he):be>0?de.push(he):te.push(he)}return ee<ce.length?R(ee,ce,re):ee<ce.length+te.length?te[0]:R(ee-(ce.length+te.length),de,re)}e.$yb=R;function I(ee,ne){const re=[];let Ee;for(const ce of ee.slice(0).sort(ne))!Ee||ne(Ee[0],ce)!==0?(Ee=[ce],re.push(Ee)):Ee.push(ce);return re}e.$zb=I;function*w(ee,ne){let re,Ee;for(const ce of ee)Ee!==void 0&&ne(Ee,ce)?re.push(ce):(re&&(yield re),re=[ce]),Ee=ce;re&&(yield re)}e.$Ab=w;function y(ee,ne){for(let re=0;re<=ee.length;re++)ne(re===0?void 0:ee[re-1],re===ee.length?void 0:ee[re])}e.$Bb=y;function k(ee,ne){for(let re=0;re<ee.length;re++)ne(re===0?void 0:ee[re-1],ee[re],re+1===ee.length?void 0:ee[re+1])}e.$Cb=k;function p(ee,ne,re){const Ee=[];function ce(he,be,Pe){if(be===0&&Pe.length===0)return;const B=Ee[Ee.length-1];B&&B.start+B.deleteCount===he?(B.deleteCount+=be,B.toInsert.push(...Pe)):Ee.push({start:he,deleteCount:be,toInsert:Pe})}let de=0,te=0;for(;;){if(de===ee.length){ce(de,0,ne.slice(te));break}if(te===ne.length){ce(de,ee.length-de,[]);break}const he=ee[de],be=ne[te],Pe=re(he,be);Pe===0?(de+=1,te+=1):Pe<0?(ce(de,1,[]),de+=1):Pe>0&&(ce(de,0,[be]),te+=1)}return Ee}e.$Db=p;function u(ee,ne,re){const Ee=p(ee,ne,re),ce=[],de=[];for(const te of Ee)ce.push(...ee.slice(te.start,te.start+te.deleteCount)),de.push(...te.toInsert);return{removed:ce,added:de}}e.$Eb=u;function c(ee,ne,re){if(re===0)return[];const Ee=ee.slice(0,re).sort(ne);return o(ee,ne,Ee,re,ee.length),Ee}e.top=c;function r(ee,ne,re,Ee,ce){return re===0?Promise.resolve([]):new Promise((de,te)=>{(async()=>{const he=ee.length,be=ee.slice(0,re).sort(ne);for(let Pe=re,B=Math.min(re+Ee,he);Pe<he;Pe=B,B=Math.min(B+Ee,he)){if(Pe>re&&await new Promise(J=>setTimeout(J)),ce&&ce.isCancellationRequested)throw new C.$5;o(ee,ne,be,Pe,B)}return be})().then(de,te)})}e.$Gb=r;function o(ee,ne,re,Ee,ce){for(const de=re.length;Ee<ce;Ee++){const te=ee[Ee];if(ne(te,re[de-1])<0){re.pop();const he=(0,T.$kb)(re,be=>ne(te,be)<0);re.splice(he,0,te)}}}function m(ee){return ee.filter(ne=>!!ne)}e.$Hb=m;function h(ee){let ne=0;for(let re=0;re<ee.length;re++)ee[re]&&(ee[ne]=ee[re],ne+=1);ee.length=ne}e.$Ib=h;function t(ee,ne,re){ee.splice(re,0,ee.splice(ne,1)[0])}e.$Jb=t;function n(ee){return!Array.isArray(ee)||ee.length===0}e.$Kb=n;function a(ee){return Array.isArray(ee)&&ee.length>0}e.$Lb=a;function i(ee,ne=re=>re){const re=new Set;return ee.filter(Ee=>{const ce=ne(Ee);return re.has(ce)?!1:(re.add(ce),!0)})}e.$Mb=i;function s(ee){const ne=new Set;return re=>{const Ee=ee(re);return ne.has(Ee)?!1:(ne.add(Ee),!0)}}e.$Nb=s;function l(ee,ne){return ee.length>0?ee[0]:ne}e.$Ob=l;function D(ee,ne){return ee.length>0?ee[ee.length-1]:ne}e.$Pb=D;function S(ee,ne,re=(Ee,ce)=>Ee===ce){let Ee=0;for(let ce=0,de=Math.min(ee.length,ne.length);ce<de&&re(ee[ce],ne[ce]);ce++)Ee++;return Ee}e.$Qb=S;function b(ee){return[].concat(...ee)}e.$Rb=b;function f(ee,ne){let re=typeof ne=="number"?ee:0;typeof ne=="number"?re=ee:(re=0,ne=ee);const Ee=[];if(re<=ne)for(let ce=re;ce<ne;ce++)Ee.push(ce);else for(let ce=re;ce>ne;ce--)Ee.push(ce);return Ee}e.$Sb=f;function g(ee,ne,re){return ee.reduce((Ee,ce)=>(Ee[ne(ce)]=re?re(ce):ce,Ee),Object.create(null))}e.$Tb=g;function P(ee,ne){return ee.push(ne),()=>N(ee,ne)}e.$Ub=P;function N(ee,ne){const re=ee.indexOf(ne);if(re>-1)return ee.splice(re,1),ne}e.$Vb=N;function O(ee,ne,re){const Ee=ee.slice(0,ne),ce=ee.slice(ne);return Ee.concat(re,ce)}e.$Wb=O;function M(ee,ne){let re;if(typeof ne=="number"){let Ee=ne;re=()=>{const ce=Math.sin(Ee++)*179426549;return ce-Math.floor(ce)}}else re=Math.random;for(let Ee=ee.length-1;Ee>0;Ee-=1){const ce=Math.floor(re()*(Ee+1)),de=ee[Ee];ee[Ee]=ee[ce],ee[ce]=de}}e.$Xb=M;function j(ee,ne){const re=ee.indexOf(ne);re>-1&&(ee.splice(re,1),ee.unshift(ne))}e.$Yb=j;function z(ee,ne){const re=ee.indexOf(ne);re>-1&&(ee.splice(re,1),ee.push(ne))}e.$Zb=z;function F(ee,ne){for(const re of ne)ee.push(re)}e.$1b=F;function K(ee,ne){return Array.isArray(ee)?ee.map(ne):ne(ee)}e.$2b=K;function V(ee){return Array.isArray(ee)?ee:[ee]}e.$3b=V;function fe(ee){return ee[Math.floor(Math.random()*ee.length)]}e.$4b=fe;function Z(ee,ne,re){const Ee=X(ee,ne),ce=ee.length,de=re.length;ee.length=ce+de;for(let te=ce-1;te>=Ee;te--)ee[te+de]=ee[te];for(let te=0;te<de;te++)ee[te+Ee]=re[te]}e.$5b=Z;function Q(ee,ne,re,Ee){const ce=X(ee,ne);let de=ee.splice(ce,re);return de===void 0&&(de=[]),Z(ee,ce,Ee),de}e.$6b=Q;function X(ee,ne){return ne<0?Math.max(ne+ee.length,0):Math.min(ne,ee.length)}var oe;(function(ee){function ne(de){return de<0}ee.isLessThan=ne;function re(de){return de<=0}ee.isLessThanOrEqual=re;function Ee(de){return de>0}ee.isGreaterThan=Ee;function ce(de){return de===0}ee.isNeitherLessOrGreaterThan=ce,ee.greaterThan=1,ee.lessThan=-1,ee.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function x(ee,ne){return(re,Ee)=>ne(ee(re),ee(Ee))}e.$7b=x;function ae(...ee){return(ne,re)=>{for(const Ee of ee){const ce=Ee(ne,re);if(!oe.isNeitherLessOrGreaterThan(ce))return ce}return oe.neitherLessOrGreaterThan}}e.$8b=ae;const we=(ee,ne)=>ee-ne;e.$9b=we;const G=(ee,ne)=>(0,e.$9b)(ee?1:0,ne?1:0);e.$0b=G;function U(ee){return(ne,re)=>-ee(ne,re)}e.$$b=U;class q{constructor(ne){this.g=ne,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ne){let re=this.c;for(;re<this.g.length&&ne(this.g[re]);)re++;const Ee=re===this.c?null:this.g.slice(this.c,re);return this.c=re,Ee}takeFromEndWhile(ne){let re=this.d;for(;re>=0&&ne(this.g[re]);)re--;const Ee=re===this.d?null:this.g.slice(re+1,this.d+1);return this.d=re,Ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ne=this.g[this.c];return this.c++,ne}removeLast(){const ne=this.g[this.d];return this.d--,ne}takeCount(ne){const re=this.g.slice(this.c,this.c+ne);return this.c+=ne,re}}e.$_b=q;class me{static{this.empty=new me(ne=>{})}constructor(ne){this.iterate=ne}forEach(ne){this.iterate(re=>(ne(re),!0))}toArray(){const ne=[];return this.iterate(re=>(ne.push(re),!0)),ne}filter(ne){return new me(re=>this.iterate(Ee=>ne(Ee)?re(Ee):!0))}map(ne){return new me(re=>this.iterate(Ee=>re(ne(Ee))))}some(ne){let re=!1;return this.iterate(Ee=>(re=ne(Ee),!re)),re}findFirst(ne){let re;return this.iterate(Ee=>ne(Ee)?(re=Ee,!1):!0),re}findLast(ne){let re;return this.iterate(Ee=>(ne(Ee)&&(re=Ee),!0)),re}findLastMaxBy(ne){let re,Ee=!0;return this.iterate(ce=>((Ee||oe.isGreaterThan(ne(ce,re)))&&(Ee=!1,re=ce),!0)),re}}e.$ac=me}),define(De[58],Ce([1,0,8]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function T(E,v){if(!E)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=T;function d(E,v="Unreachable"){throw new Error(v)}e.$4c=d;function L(E){if(!E)throw new C.$cb("Assertion Failed")}e.$5c=L;function A(E){if(!E()){debugger;E(),(0,C.$1)(new C.$cb("Assertion Failed"))}}e.$6c=A;function $(E,v){let R=0;for(;R<E.length-1;){const I=E[R],w=E[R+1];if(!v(I,w))return!1;R++}return!0}e.$7c=$}),define(De[75],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function C(T){const d=this;let L=!1,A;return function(){return L||(L=!0,A=T.apply(d,arguments)),A}}e.$db=C}),define(De[119],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=e.$iM=void 0;class C{constructor(d){this.a=d,this.b=0}nextId(){return this.a+ ++this.b}}e.$iM=C,e.$jM=new C("id#")}),define(De[51],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(T){function d(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}T.is=d;const L=Object.freeze([]);function A(){return L}T.empty=A;function*$(h){yield h}T.single=$;function E(h){return d(h)?h:$(h)}T.wrap=E;function v(h){return h||L}T.from=v;function*R(h){for(let t=h.length-1;t>=0;t--)yield h[t]}T.reverse=R;function I(h){return!h||h[Symbol.iterator]().next().done===!0}T.isEmpty=I;function w(h){return h[Symbol.iterator]().next().value}T.first=w;function y(h,t){for(const n of h)if(t(n))return!0;return!1}T.some=y;function k(h,t){for(const n of h)if(t(n))return n}T.find=k;function*p(h,t){for(const n of h)t(n)&&(yield n)}T.filter=p;function*u(h,t){let n=0;for(const a of h)yield t(a,n++)}T.map=u;function*c(...h){for(const t of h)for(const n of t)yield n}T.concat=c;function r(h,t,n){let a=n;for(const i of h)a=t(a,i);return a}T.reduce=r;function*o(h,t,n=h.length){for(t<0&&(t+=h.length),n<0?n+=h.length:n>h.length&&(n=h.length);t<n;t++)yield h[t]}T.slice=o;function m(h,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,h];const a=h[Symbol.iterator]();for(let i=0;i<t;i++){const s=a.next();if(s.done)return[n,T.empty()];n.push(s.value)}return[n,{[Symbol.iterator](){return a}}]}T.consume=m})(C||(e.Iterable=C={}))}),define(De[157],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var d;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(d||(e.ParseErrorCode=d={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(t,n=!1){let a=0;const i=t.length;let s="",l=0,D=16,S=0;function b(j){let z=0,F=0;for(;z<j;){const K=t.charCodeAt(a);if(K>=48&&K<=57)F=F*16+K-48;else if(K>=65&&K<=70)F=F*16+K-65+10;else if(K>=97&&K<=102)F=F*16+K-97+10;else break;a++,z++}return z<j&&(F=-1),F}function f(j){a=j,s="",l=0,D=16,S=0}function g(){const j=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&v(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&v(t.charCodeAt(a)))for(a++;a<t.length&&v(t.charCodeAt(a));)a++;else return S=3,t.substring(j,a);let z=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&v(t.charCodeAt(a))){for(a++;a<t.length&&v(t.charCodeAt(a));)a++;z=a}else S=3;return t.substring(j,z)}function P(){let j="",z=a;for(;;){if(a>=i){j+=t.substring(z,a),S=2;break}const F=t.charCodeAt(a);if(F===34){j+=t.substring(z,a),a++;break}if(F===92){if(j+=t.substring(z,a),a++,a>=i){S=2;break}switch(t.charCodeAt(a++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const V=b(4);V>=0?j+=String.fromCharCode(V):S=4;break}default:S=5}z=a;continue}if(F>=0&&F<=31)if(E(F)){j+=t.substring(z,a),S=2;break}else S=6;a++}return j}function N(){if(s="",S=0,l=a,a>=i)return l=i,D=17;let j=t.charCodeAt(a);if($(j)){do a++,s+=String.fromCharCode(j),j=t.charCodeAt(a);while($(j));return D=15}if(E(j))return a++,s+=String.fromCharCode(j),j===13&&t.charCodeAt(a)===10&&(a++,s+=`
`),D=14;switch(j){case 123:return a++,D=1;case 125:return a++,D=2;case 91:return a++,D=3;case 93:return a++,D=4;case 58:return a++,D=6;case 44:return a++,D=5;case 34:return a++,s=P(),D=10;case 47:{const z=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<i&&!E(t.charCodeAt(a));)a++;return s=t.substring(z,a),D=12}if(t.charCodeAt(a+1)===42){a+=2;const F=i-1;let K=!1;for(;a<F;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,K=!0;break}a++}return K||(a++,S=1),s=t.substring(z,a),D=13}return s+=String.fromCharCode(j),a++,D=16}case 45:if(s+=String.fromCharCode(j),a++,a===i||!v(t.charCodeAt(a)))return D=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=g(),D=11;default:for(;a<i&&O(j);)a++,j=t.charCodeAt(a);if(l!==a){switch(s=t.substring(l,a),s){case"true":return D=8;case"false":return D=9;case"null":return D=7}return D=16}return s+=String.fromCharCode(j),a++,D=16}}function O(j){if($(j)||E(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let j;do j=N();while(j>=12&&j<=15);return j}return{setPosition:f,getPosition:()=>a,scan:n?M:N,getToken:()=>D,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>a-l,getTokenError:()=>S}}e.$Rm=A;function $(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function I(t,n){const a=[],i=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function S(b,f,g,P){l.value=b,l.offset=f,l.length=g,l.type=P,l.colonOffset=void 0,s=l}try{o(t,{onObjectBegin:(b,f)=>{if(n<=b)throw i;s=void 0,D=n>b,a.push("")},onObjectProperty:(b,f,g)=>{if(n<f||(S(b,f,g,"property"),a[a.length-1]=b,n<=f+g))throw i},onObjectEnd:(b,f)=>{if(n<=b)throw i;s=void 0,a.pop()},onArrayBegin:(b,f)=>{if(n<=b)throw i;s=void 0,a.push(0)},onArrayEnd:(b,f)=>{if(n<=b)throw i;s=void 0,a.pop()},onLiteralValue:(b,f,g)=>{if(n<f||(S(b,f,g,h(b)),n<=f+g))throw i},onSeparator:(b,f,g)=>{if(n<=f)throw i;if(b===":"&&s&&s.type==="property")s.colonOffset=f,D=!1,s=void 0;else if(b===","){const P=a[a.length-1];typeof P=="number"?a[a.length-1]=P+1:(D=!0,a[a.length-1]=""),s=void 0}}})}catch(b){if(b!==i)throw b}return{path:a,previousNode:s,isAtPropertyKey:D,matches:b=>{let f=0;for(let g=0;f<b.length&&g<a.length;g++)if(b[f]===a[g]||b[f]==="*")f++;else if(b[f]!=="**")return!1;return f===b.length}}}e.$Sm=I;function w(t,n=[],a=L.DEFAULT){let i=null,s=[];const l=[];function D(b){Array.isArray(s)?s.push(b):i!==null&&(s[i]=b)}return o(t,{onObjectBegin:()=>{const b={};D(b),l.push(s),s=b,i=null},onObjectProperty:b=>{i=b},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const b=[];D(b),l.push(s),s=b,i=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:D,onError:(b,f,g)=>{n.push({error:b,offset:f,length:g})}},a),s[0]}e.$Tm=w;function y(t,n=[],a=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(b){i.type==="property"&&(i.length=b-i.offset,i=i.parent)}function l(b){return i.children.push(b),b}o(t,{onObjectBegin:b=>{i=l({type:"object",offset:b,length:-1,parent:i,children:[]})},onObjectProperty:(b,f,g)=>{i=l({type:"property",offset:f,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:b,offset:f,length:g,parent:i})},onObjectEnd:(b,f)=>{i.length=b+f-i.offset,i=i.parent,s(b+f)},onArrayBegin:(b,f)=>{i=l({type:"array",offset:b,length:-1,parent:i,children:[]})},onArrayEnd:(b,f)=>{i.length=b+f-i.offset,i=i.parent,s(b+f)},onLiteralValue:(b,f,g)=>{l({type:h(b),offset:f,length:g,parent:i,value:b}),s(f+g)},onSeparator:(b,f,g)=>{i.type==="property"&&(b===":"?i.colonOffset=f:b===","&&s(f))},onError:(b,f,g)=>{n.push({error:b,offset:f,length:g})}},a);const S=i.children[0];return S&&delete S.parent,S}e.$Um=y;function k(t,n){if(!t)return;let a=t;for(const i of n)if(typeof i=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let s=!1;for(const l of a.children)if(Array.isArray(l.children)&&l.children[0].value===i){a=l.children[1],s=!0;break}if(!s)return}else{const s=i;if(a.type!=="array"||s<0||!Array.isArray(a.children)||s>=a.children.length)return;a=a.children[s]}return a}e.$Vm=k;function p(t){if(!t.parent||!t.parent.children)return[];const n=p(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;n.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&n.push(a)}return n}e.$Wm=p;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const n=Object.create(null);for(const a of t.children){const i=a.children[1];i&&(n[a.children[0].value]=u(i))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Xm=u;function c(t,n,a=!1){return n>=t.offset&&n<t.offset+t.length||a&&n===t.offset+t.length}e.$Ym=c;function r(t,n,a=!1){if(c(t,n,a)){const i=t.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=n;s++){const l=r(i[s],n,a);if(l)return l}return t}}e.$Zm=r;function o(t,n,a=L.DEFAULT){const i=A(t,!1);function s(x){return x?()=>x(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(x){return x?ae=>x(ae,i.getTokenOffset(),i.getTokenLength()):()=>!0}const D=s(n.onObjectBegin),S=l(n.onObjectProperty),b=s(n.onObjectEnd),f=s(n.onArrayBegin),g=s(n.onArrayEnd),P=l(n.onLiteralValue),N=l(n.onSeparator),O=s(n.onComment),M=l(n.onError),j=a&&a.disallowComments,z=a&&a.allowTrailingComma;function F(){for(;;){const x=i.scan();switch(i.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:j||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(x){case 12:case 13:j?K(10):O();break;case 16:K(1);break;case 15:case 14:break;default:return x}}}function K(x,ae=[],we=[]){if(M(x),ae.length+we.length>0){let G=i.getToken();for(;G!==17;){if(ae.indexOf(G)!==-1){F();break}else if(we.indexOf(G)!==-1)break;G=F()}}}function V(x){const ae=i.getTokenValue();return x?P(ae):S(ae),F(),!0}function fe(){switch(i.getToken()){case 11:{let x=0;try{x=JSON.parse(i.getTokenValue()),typeof x!="number"&&(K(2),x=0)}catch{K(2)}P(x);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return F(),!0}function Z(){return i.getToken()!==10?(K(3,[],[2,5]),!1):(V(!1),i.getToken()===6?(N(":"),F(),oe()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Q(){D(),F();let x=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(x||K(4,[],[]),N(","),F(),i.getToken()===2&&z)break}else x&&K(6,[],[]);Z()||K(4,[],[2,5]),x=!0}return b(),i.getToken()!==2?K(7,[2],[]):F(),!0}function X(){f(),F();let x=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(x||K(4,[],[]),N(","),F(),i.getToken()===4&&z)break}else x&&K(6,[],[]);oe()||K(4,[],[4,5]),x=!0}return g(),i.getToken()!==4?K(8,[4],[]):F(),!0}function oe(){switch(i.getToken()){case 3:return X();case 1:return Q();case 10:return V(!0);default:return fe()}}return F(),i.getToken()===17?a.allowEmptyContent?!0:(K(4,[],[]),!1):oe()?(i.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.$1m=o;function m(t,n){const a=A(t),i=[];let s,l=0,D;do switch(D=a.getPosition(),s=a.scan(),s){case 12:case 13:case 17:l!==D&&i.push(t.substring(l,D)),n!==void 0&&i.push(a.getTokenValue().replace(/[^\r\n]/g,n)),l=a.getPosition();break}while(s!==17);return i.join("")}e.$2m=m;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$3m=h}),define(De[47],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class C{constructor(d){this.d=d,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(d){this.c=d}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=C}),define(De[76],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class C{static{this.Undefined=new C(void 0)}constructor(L){this.element=L,this.next=C.Undefined,this.prev=C.Undefined}}class T{constructor(){this.a=C.Undefined,this.b=C.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===C.Undefined}clear(){let L=this.a;for(;L!==C.Undefined;){const A=L.next;L.prev=C.Undefined,L.next=C.Undefined,L=A}this.a=C.Undefined,this.b=C.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,A){const $=new C(L);if(this.a===C.Undefined)this.a=$,this.b=$;else if(A){const v=this.b;this.b=$,$.prev=v,v.next=$}else{const v=this.a;this.a=$,$.next=v,v.prev=$}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e($))}}shift(){if(this.a!==C.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==C.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==C.Undefined&&L.next!==C.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===C.Undefined&&L.next===C.Undefined?(this.a=C.Undefined,this.b=C.Undefined):L.next===C.Undefined?(this.b=this.b.prev,this.b.next=C.Undefined):L.prev===C.Undefined&&(this.a=this.a.next,this.a.prev=C.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==C.Undefined;)yield L.element,L=L.next}}e.$2c=T}),define(De[28],Ce([1,0]),function($e,e){"use strict";var C,T,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function L(r,o,m){let h=r.get(o);return h===void 0&&(h=m,r.set(o,h)),h}e.$xc=L;function A(r){const o=[];return r.forEach((m,h)=>{o.push(`${h} => ${m}`)}),`Map(${r.size}) {${o.join(", ")}}`}e.$yc=A;function $(r){const o=[];return r.forEach(m=>{o.push(m)}),`Set(${r.size}) {${o.join(", ")}}`}e.$zc=$;class E{constructor(o,m){this.uri=o,this.value=m}}function v(r){return Array.isArray(r)}class R{static{this.a=o=>o.toString()}constructor(o,m){if(this[C]="ResourceMap",o instanceof R)this.b=new Map(o.b),this.c=m??R.a;else if(v(o)){this.b=new Map,this.c=m??R.a;for(const[h,t]of o)this.set(h,t)}else this.b=new Map,this.c=o??R.a}set(o,m){return this.b.set(this.c(o),new E(o,m)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,m){typeof m<"u"&&(o=o.bind(m));for(const[h,t]of this.b)o(t.value,t.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$Ac=R;class I{constructor(o,m){this[T]="ResourceSet",!o||typeof o=="function"?this.a=new R(o):(this.a=new R(m),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,m){this.a.forEach((h,t)=>o.call(m,t,t,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=I;var w;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class y{constructor(){this[d]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,m=0){const h=this.a.get(o);if(h)return m!==0&&this.j(h,m),h.value}set(o,m,h=0){let t=this.a.get(o);if(t)t.value=m,h!==0&&this.j(t,h);else{switch(t={key:o,value:m,next:void 0,previous:void 0},h){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(o,t),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const m=this.a.get(o);if(m)return this.a.delete(o),this.i(m),this.d--,m.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,m){const h=this.e;let t=this.b;for(;t;){if(m?o.bind(m)(t.value,t.key,this):o(t.value,t.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const o=this,m=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(o.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const n={value:h.key,done:!1};return h=h.next,n}else return{value:void 0,done:!0}}};return t}values(){const o=this,m=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(o.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const n={value:h.value,done:!1};return h=h.next,n}else return{value:void 0,done:!0}}};return t}entries(){const o=this,m=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(o.e!==m)throw new Error("LinkedMap got modified during iteration.");if(h){const n={value:[h.key,h.value],done:!1};return h=h.next,n}else return{value:void 0,done:!0}}};return t}[(d=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let m=this.b,h=this.size;for(;m&&h>o;)this.a.delete(m.key),m=m.next,h--;this.b=m,this.d=h,m&&(m.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const m=o.next,h=o.previous;if(!m||!h)throw new Error("Invalid list");m.previous=h,h.next=m}o.next=void 0,o.previous=void 0,this.e++}j(o,m){if(!this.b||!this.c)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(o===this.b)return;const h=o.next,t=o.previous;o===this.c?(t.next=void 0,this.c=t):(h.previous=t,t.next=h),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(m===2){if(o===this.c)return;const h=o.next,t=o.previous;o===this.b?(h.previous=void 0,this.b=h):(h.previous=t,t.next=h),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((m,h)=>{o.push([h,m])}),o}fromJSON(o){this.clear();for(const[m,h]of o)this.set(m,h)}}e.$Cc=y;class k extends y{constructor(o,m=1){super(),this.k=o,this.l=Math.min(Math.max(0,m),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,m=2){return super.get(o,m)}peek(o){return super.get(o,0)}set(o,m){return super.set(o,m,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=k;class p{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let m=this.a.get(o)||0;return m===0?!1:(m--,m===0?this.a.delete(o):this.a.set(o,m),!0)}has(o){return this.a.has(o)}}e.$Ec=p;class u{constructor(o){if(this.a=new Map,this.b=new Map,o)for(const[m,h]of o)this.set(m,h)}clear(){this.a.clear(),this.b.clear()}set(o,m){this.a.set(o,m),this.b.set(m,o)}get(o){return this.a.get(o)}getKey(o){return this.b.get(o)}delete(o){const m=this.a.get(o);return m===void 0?!1:(this.a.delete(o),this.b.delete(m),!0)}forEach(o,m){this.a.forEach((h,t)=>{o.call(m,h,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=u;class c{constructor(){this.a=new Map}add(o,m){let h=this.a.get(o);h||(h=new Set,this.a.set(o,h)),h.add(m)}delete(o,m){const h=this.a.get(o);h&&(h.delete(m),h.size===0&&this.a.delete(o))}forEach(o,m){const h=this.a.get(o);h&&h.forEach(m)}get(o){const m=this.a.get(o);return m||new Set}}e.$Gc=c}),define(De[3],Ce([1,0,19,74,28,75,51]),function($e,e,C,T,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const $=!1;let E=null;class v{constructor(){this.b=new Map}static{this.a=0}c(g){let P=this.b.get(g);return P||(P={parent:null,source:null,isSingleton:!1,value:g,idx:v.a++},this.b.set(g,P)),P}trackDisposable(g){const P=this.c(g);P.source||(P.source=new Error().stack)}setParent(g,P){const N=this.c(g);N.parent=P}markAsDisposed(g){this.b.delete(g)}markAsSingleton(g){this.c(g).isSingleton=!0}f(g,P){const N=P.get(g);if(N)return N;const O=g.parent?this.f(this.c(g.parent),P):g;return P.set(g,O),O}getTrackedDisposables(){const g=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,g).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(g=10,P){let N;if(P)N=P;else{const F=new Map,K=[...this.b.values()].filter(fe=>fe.source!==null&&!this.f(fe,F).isSingleton);if(K.length===0)return;const V=new Set(K.map(fe=>fe.value));if(N=K.filter(fe=>!(fe.parent&&V.has(fe.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function O(F){function K(fe,Z){for(;fe.length>0&&Z.some(Q=>typeof Q=="string"?Q===fe[0]:fe[0].match(Q));)fe.shift()}const V=F.source.split(`
`).map(fe=>fe.trim().replace("at ","")).filter(fe=>fe!=="");return K(V,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),V.reverse()}const M=new d.$Gc;for(const F of N){const K=O(F);for(let V=0;V<=K.length;V++)M.add(K.slice(0,V).join(`
`),F)}N.sort((0,C.$7b)(F=>F.idx,C.$9b));let j="",z=0;for(const F of N.slice(0,g)){z++;const K=O(F),V=[];for(let fe=0;fe<K.length;fe++){let Z=K[fe];Z=`(shared with ${M.get(K.slice(0,fe+1).join(`
`)).size}/${N.length} leaks) at ${Z}`;const X=M.get(K.slice(0,fe).join(`
`)),oe=(0,T.$J)([...X].map(x=>O(x)[fe]),x=>x);delete oe[K[fe]];for(const[x,ae]of Object.entries(oe))V.unshift(`    - stacktraces of ${ae.length} other leaks continue with ${x}`);V.unshift(Z)}j+=`


==================== Leaking disposable ${z}/${N.length}: ${F.value.constructor.name} ====================
${V.join(`
`)}
============================================================

`}return N.length>g&&(j+=`


... and ${N.length-g} more leaking disposables

`),{leaks:N,details:j}}}e.$Hc=v;function R(f){E=f}if(e.$Ic=R,$){const f="__is_disposable_tracked__";R(new class{trackDisposable(g){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[f]||console.log(P)},3e3)}setParent(g,P){if(g&&g!==t.None)try{g[f]=!0}catch{}}markAsDisposed(g){if(g&&g!==t.None)try{g[f]=!0}catch{}}markAsSingleton(g){}})}function I(f){return E?.trackDisposable(f),f}e.$Jc=I;function w(f){E?.markAsDisposed(f)}e.$Kc=w;function y(f,g){E?.setParent(f,g)}function k(f,g){if(E)for(const P of f)E.setParent(P,g)}function p(f){return E?.markAsSingleton(f),f}e.$Lc=p;function u(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.$Mc=u;function c(f){if(A.Iterable.is(f)){const g=[];for(const P of f)if(P)try{P.dispose()}catch(N){g.push(N)}if(g.length===1)throw g[0];if(g.length>1)throw new AggregateError(g,"Encountered errors while disposing of store");return Array.isArray(f)?[]:f}else if(f)return f.dispose(),f}e.$Nc=c;function r(f){for(const g of f)u(g)&&g.dispose();return[]}e.$Oc=r;function o(...f){const g=m(()=>c(f));return k(f,g),g}e.$Pc=o;function m(f){const g=I({dispose:(0,L.$db)(()=>{w(g),f()})});return g}e.$Qc=m;class h{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return y(g,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(g),g}delete(g){if(g){if(g===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(g),g.dispose()}}deleteAndLeak(g){g&&this.f.has(g)&&(this.f.delete(g),y(g,null))}}e.$Rc=h;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new h,I(this),y(this.q,this)}dispose(){w(this),this.q.dispose()}B(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(g)}}e.$Sc=t;class n{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(g){this.b||g===this.a||(this.a?.dispose(),g&&y(g,this),this.a=g)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const g=this.a;return this.a=void 0,g&&y(g,null),g}}e.$Tc=n;class a{constructor(g){this.b=g,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=a;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(g){let P=g;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,w(this))},this}}e.$Vc=i;class s{constructor(){this.a=new Map}acquire(g,...P){let N=this.a.get(g);N||(N={counter:0,object:this.b(g,...P)},this.a.set(g,N));const{object:O}=N,M=(0,L.$db)(()=>{--N.counter===0&&(this.c(g,N.object),this.a.delete(g))});return N.counter++,{object:O,dispose:M}}}e.$Wc=s;class l{constructor(g){this.a=g}async acquire(g,...P){const N=this.a.acquire(g,...P);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(O){throw N.dispose(),O}}}e.$Xc=l;class D{constructor(g){this.object=g}dispose(){}}e.$Yc=D;function S(f){const g=new h;try{f(g)}finally{g.dispose()}}e.$Zc=S;class b{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(g){return this.a.has(g)}get size(){return this.a.size}get(g){return this.a.get(g)}set(g,P,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(g)?.dispose(),this.a.set(g,P)}deleteAndDispose(g){this.a.get(g)?.dispose(),this.a.delete(g)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=b}),function($e,e){typeof define=="function"&&define.amd?define(De[158],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(ne,re){for(var Ee=0;Ee<re.length;Ee++){var ce=re[Ee];ce.enumerable=ce.enumerable||!1,ce.configurable=!0,"value"in ce&&(ce.writable=!0),Object.defineProperty(ne,ce.key,ce)}}function C(ne,re,Ee){return re&&e(ne.prototype,re),Ee&&e(ne,Ee),Object.defineProperty(ne,"prototype",{writable:!1}),ne}function T(ne,re){if(ne){if(typeof ne=="string")return d(ne,re);var Ee=Object.prototype.toString.call(ne).slice(8,-1);if(Ee==="Object"&&ne.constructor&&(Ee=ne.constructor.name),Ee==="Map"||Ee==="Set")return Array.from(ne);if(Ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ee))return d(ne,re)}}function d(ne,re){(re==null||re>ne.length)&&(re=ne.length);for(var Ee=0,ce=new Array(re);Ee<re;Ee++)ce[Ee]=ne[Ee];return ce}function L(ne,re){var Ee=typeof Symbol<"u"&&ne[Symbol.iterator]||ne["@@iterator"];if(Ee)return(Ee=Ee.call(ne)).next.bind(Ee);if(Array.isArray(ne)||(Ee=T(ne))||re&&ne&&typeof ne.length=="number"){Ee&&(ne=Ee);var ce=0;return function(){return ce>=ne.length?{done:!0}:{done:!1,value:ne[ce++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=A();function $(ne){$e.defaults=ne}var E=/[&<>"']/,v=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(re){return w[re]};function k(ne,re){if(re){if(E.test(ne))return ne.replace(v,y)}else if(R.test(ne))return ne.replace(I,y);return ne}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(ne){return ne.replace(p,function(re,Ee){return Ee=Ee.toLowerCase(),Ee==="colon"?":":Ee.charAt(0)==="#"?Ee.charAt(1)==="x"?String.fromCharCode(parseInt(Ee.substring(2),16)):String.fromCharCode(+Ee.substring(1)):""})}var c=/(^|[^\[])\^/g;function r(ne,re){ne=typeof ne=="string"?ne:ne.source,re=re||"";var Ee={replace:function(de,te){return te=te.source||te,te=te.replace(c,"$1"),ne=ne.replace(de,te),Ee},getRegex:function(){return new RegExp(ne,re)}};return Ee}var o=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(ne,re,Ee){if(ne){var ce;try{ce=decodeURIComponent(u(Ee)).replace(o,"").toLowerCase()}catch{return null}if(ce.indexOf("javascript:")===0||ce.indexOf("vbscript:")===0||ce.indexOf("data:")===0)return null}re&&!m.test(Ee)&&(Ee=s(re,Ee));try{Ee=encodeURI(Ee).replace(/%25/g,"%")}catch{return null}return Ee}var t={},n=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(ne,re){t[" "+ne]||(n.test(ne)?t[" "+ne]=ne+"/":t[" "+ne]=b(ne,"/",!0)),ne=t[" "+ne];var Ee=ne.indexOf(":")===-1;return re.substring(0,2)==="//"?Ee?re:ne.replace(a,"$1")+re:re.charAt(0)==="/"?Ee?re:ne.replace(i,"$1")+re:ne+re}var l={exec:function(){}};function D(ne){for(var re=1,Ee,ce;re<arguments.length;re++){Ee=arguments[re];for(ce in Ee)Object.prototype.hasOwnProperty.call(Ee,ce)&&(ne[ce]=Ee[ce])}return ne}function S(ne,re){var Ee=ne.replace(/\|/g,function(te,he,be){for(var Pe=!1,B=he;--B>=0&&be[B]==="\\";)Pe=!Pe;return Pe?"|":" |"}),ce=Ee.split(/ \|/),de=0;if(ce[0].trim()||ce.shift(),ce.length>0&&!ce[ce.length-1].trim()&&ce.pop(),ce.length>re)ce.splice(re);else for(;ce.length<re;)ce.push("");for(;de<ce.length;de++)ce[de]=ce[de].trim().replace(/\\\|/g,"|");return ce}function b(ne,re,Ee){var ce=ne.length;if(ce===0)return"";for(var de=0;de<ce;){var te=ne.charAt(ce-de-1);if(te===re&&!Ee)de++;else if(te!==re&&Ee)de++;else break}return ne.slice(0,ce-de)}function f(ne,re){if(ne.indexOf(re[1])===-1)return-1;for(var Ee=ne.length,ce=0,de=0;de<Ee;de++)if(ne[de]==="\\")de++;else if(ne[de]===re[0])ce++;else if(ne[de]===re[1]&&(ce--,ce<0))return de;return-1}function g(ne){ne&&ne.sanitize&&!ne.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ne,re){if(re<1)return"";for(var Ee="";re>1;)re&1&&(Ee+=ne),re>>=1,ne+=ne;return Ee+ne}function N(ne,re,Ee,ce){var de=re.href,te=re.title?k(re.title):null,he=ne[1].replace(/\\([\[\]])/g,"$1");if(ne[0].charAt(0)!=="!"){ce.state.inLink=!0;var be={type:"link",raw:Ee,href:de,title:te,text:he,tokens:ce.inlineTokens(he)};return ce.state.inLink=!1,be}return{type:"image",raw:Ee,href:de,title:te,text:k(he)}}function O(ne,re){var Ee=ne.match(/^(\s+)(?:```)/);if(Ee===null)return re;var ce=Ee[1];return re.split(`
`).map(function(de){var te=de.match(/^\s+/);if(te===null)return de;var he=te[0];return he.length>=ce.length?de.slice(ce.length):de}).join(`
`)}var M=function(){function ne(Ee){this.options=Ee||$e.defaults}var re=ne.prototype;return re.space=function(ce){var de=this.rules.block.newline.exec(ce);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},re.code=function(ce){var de=this.rules.block.code.exec(ce);if(de){var te=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?te:b(te,`
`)}}},re.fences=function(ce){var de=this.rules.block.fences.exec(ce);if(de){var te=de[0],he=O(te,de[3]||"");return{type:"code",raw:te,lang:de[2]?de[2].trim():de[2],text:he}}},re.heading=function(ce){var de=this.rules.block.heading.exec(ce);if(de){var te=de[2].trim();if(/#$/.test(te)){var he=b(te,"#");(this.options.pedantic||!he||/ $/.test(he))&&(te=he.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:te,tokens:this.lexer.inline(te)}}},re.hr=function(ce){var de=this.rules.block.hr.exec(ce);if(de)return{type:"hr",raw:de[0]}},re.blockquote=function(ce){var de=this.rules.block.blockquote.exec(ce);if(de){var te=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},re.list=function(ce){var de=this.rules.block.list.exec(ce);if(de){var te,he,be,Pe,B,J,ie,se,Y,ge,ye,je,We=de[1].trim(),_e=We.length>1,Ye={type:"list",raw:"",ordered:_e,start:_e?+We.slice(0,-1):"",loose:!1,items:[]};We=_e?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=_e?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");ce&&(je=!1,!(!(de=it.exec(ce))||this.rules.block.hr.test(ce)));){if(te=de[0],ce=ce.substring(te.length),se=de[2].split(`
`,1)[0],Y=ce.split(`
`,1)[0],this.options.pedantic?(Pe=2,ye=se.trimLeft()):(Pe=de[2].search(/[^ ]/),Pe=Pe>4?1:Pe,ye=se.slice(Pe),Pe+=de[1].length),J=!1,!se&&/^ *$/.test(Y)&&(te+=Y+`
`,ce=ce.substring(Y.length+1),je=!0),!je)for(var et=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ne=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");ce&&(ge=ce.split(`
`,1)[0],se=ge,this.options.pedantic&&(se=se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ne.test(se)||qe.test(se)||et.test(se)||Ae.test(ce)));){if(se.search(/[^ ]/)>=Pe||!se.trim())ye+=`
`+se.slice(Pe);else if(!J)ye+=`
`+se;else break;!J&&!se.trim()&&(J=!0),te+=ge+`
`,ce=ce.substring(ge.length+1)}Ye.loose||(ie?Ye.loose=!0:/\n *\n *$/.test(te)&&(ie=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(ye),he&&(be=he[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:te,task:!!he,checked:be,loose:!1,text:ye}),Ye.raw+=te}Ye.items[Ye.items.length-1].raw=te.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var Le=Ye.items.length;for(B=0;B<Le;B++){this.lexer.state.top=!1,Ye.items[B].tokens=this.lexer.blockTokens(Ye.items[B].text,[]);var Xe=Ye.items[B].tokens.filter(function(ue){return ue.type==="space"}),le=Xe.every(function(ue){for(var Ie=ue.raw.split(""),Ve=0,Ue=L(Ie),xe;!(xe=Ue()).done;){var rt=xe.value;if(rt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Ye.loose&&Xe.length&&le&&(Ye.loose=!0,Ye.items[B].loose=!0)}return Ye}},re.html=function(ce){var de=this.rules.block.html.exec(ce);if(de){var te={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var he=this.options.sanitizer?this.options.sanitizer(de[0]):k(de[0]);te.type="paragraph",te.text=he,te.tokens=this.lexer.inline(he)}return te}},re.def=function(ce){var de=this.rules.block.def.exec(ce);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var te=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:de[0],href:de[2],title:de[3]}}},re.table=function(ce){var de=this.rules.block.table.exec(ce);if(de){var te={type:"table",header:S(de[1]).map(function(ie){return{text:ie}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=de[0];var he=te.align.length,be,Pe,B,J;for(be=0;be<he;be++)/^ *-+: *$/.test(te.align[be])?te.align[be]="right":/^ *:-+: *$/.test(te.align[be])?te.align[be]="center":/^ *:-+ *$/.test(te.align[be])?te.align[be]="left":te.align[be]=null;for(he=te.rows.length,be=0;be<he;be++)te.rows[be]=S(te.rows[be],te.header.length).map(function(ie){return{text:ie}});for(he=te.header.length,Pe=0;Pe<he;Pe++)te.header[Pe].tokens=this.lexer.inline(te.header[Pe].text);for(he=te.rows.length,Pe=0;Pe<he;Pe++)for(J=te.rows[Pe],B=0;B<J.length;B++)J[B].tokens=this.lexer.inline(J[B].text);return te}}},re.lheading=function(ce){var de=this.rules.block.lheading.exec(ce);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},re.paragraph=function(ce){var de=this.rules.block.paragraph.exec(ce);if(de){var te=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:te,tokens:this.lexer.inline(te)}}},re.text=function(ce){var de=this.rules.block.text.exec(ce);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},re.escape=function(ce){var de=this.rules.inline.escape.exec(ce);if(de)return{type:"escape",raw:de[0],text:k(de[1])}},re.tag=function(ce){var de=this.rules.inline.tag.exec(ce);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):k(de[0]):de[0]}},re.link=function(ce){var de=this.rules.inline.link.exec(ce);if(de){var te=de[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var he=b(te.slice(0,-1),"\\");if((te.length-he.length)%2===0)return}else{var be=f(de[2],"()");if(be>-1){var Pe=de[0].indexOf("!")===0?5:4,B=Pe+de[1].length+be;de[2]=de[2].substring(0,be),de[0]=de[0].substring(0,B).trim(),de[3]=""}}var J=de[2],ie="";if(this.options.pedantic){var se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(J);se&&(J=se[1],ie=se[3])}else ie=de[3]?de[3].slice(1,-1):"";return J=J.trim(),/^</.test(J)&&(this.options.pedantic&&!/>$/.test(te)?J=J.slice(1):J=J.slice(1,-1)),N(de,{href:J&&J.replace(this.rules.inline._escapes,"$1"),title:ie&&ie.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},re.reflink=function(ce,de){var te;if((te=this.rules.inline.reflink.exec(ce))||(te=this.rules.inline.nolink.exec(ce))){var he=(te[2]||te[1]).replace(/\s+/g," ");if(he=de[he.toLowerCase()],!he||!he.href){var be=te[0].charAt(0);return{type:"text",raw:be,text:be}}return N(te,he,te[0],this.lexer)}},re.emStrong=function(ce,de,te){te===void 0&&(te="");var he=this.rules.inline.emStrong.lDelim.exec(ce);if(he&&!(he[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=he[1]||he[2]||"";if(!be||be&&(te===""||this.rules.inline.punctuation.exec(te))){var Pe=he[0].length-1,B,J,ie=Pe,se=0,Y=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Y.lastIndex=0,de=de.slice(-1*ce.length+Pe);(he=Y.exec(de))!=null;)if(B=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!B){if(J=B.length,he[3]||he[4]){ie+=J;continue}else if((he[5]||he[6])&&Pe%3&&!((Pe+J)%3)){se+=J;continue}if(ie-=J,!(ie>0)){if(J=Math.min(J,J+ie+se),Math.min(Pe,J)%2){var ge=ce.slice(1,Pe+he.index+J);return{type:"em",raw:ce.slice(0,Pe+he.index+J+1),text:ge,tokens:this.lexer.inlineTokens(ge)}}var ye=ce.slice(2,Pe+he.index+J-1);return{type:"strong",raw:ce.slice(0,Pe+he.index+J+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},re.codespan=function(ce){var de=this.rules.inline.code.exec(ce);if(de){var te=de[2].replace(/\n/g," "),he=/[^ ]/.test(te),be=/^ /.test(te)&&/ $/.test(te);return he&&be&&(te=te.substring(1,te.length-1)),te=k(te,!0),{type:"codespan",raw:de[0],text:te}}},re.br=function(ce){var de=this.rules.inline.br.exec(ce);if(de)return{type:"br",raw:de[0]}},re.del=function(ce){var de=this.rules.inline.del.exec(ce);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},re.autolink=function(ce,de){var te=this.rules.inline.autolink.exec(ce);if(te){var he,be;return te[2]==="@"?(he=k(this.options.mangle?de(te[1]):te[1]),be="mailto:"+he):(he=k(te[1]),be=he),{type:"link",raw:te[0],text:he,href:be,tokens:[{type:"text",raw:he,text:he}]}}},re.url=function(ce,de){var te;if(te=this.rules.inline.url.exec(ce)){var he,be;if(te[2]==="@")he=k(this.options.mangle?de(te[0]):te[0]),be="mailto:"+he;else{var Pe;do Pe=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(Pe!==te[0]);he=k(te[0]),te[1]==="www."?be="http://"+he:be=he}return{type:"link",raw:te[0],text:he,href:be,tokens:[{type:"text",raw:he,text:he}]}}},re.inlineText=function(ce,de){var te=this.rules.inline.text.exec(ce);if(te){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):k(te[0]):te[0]:he=k(this.options.smartypants?de(te[0]):te[0]),{type:"text",raw:te[0],text:he}}},ne}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=r(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=r(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=r(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=r(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=r(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=r(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=D({},j),j.gfm=D({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=r(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=r(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=D({},j.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:r(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=r(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=r(j._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=r(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=r(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=r(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=r(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=r(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=r(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=r(z.reflink).replace("label",z._label).replace("ref",j._label).getRegex(),z.nolink=r(z.nolink).replace("ref",j._label).getRegex(),z.reflinkSearch=r(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=D({},z),z.pedantic=D({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=D({},z.normal,{escape:r(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=r(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=D({},z.gfm,{br:r(z.br).replace("{2,}","*").getRegex(),text:r(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(ne){return ne.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(ne){var re="",Ee,ce,de=ne.length;for(Ee=0;Ee<de;Ee++)ce=ne.charCodeAt(Ee),Math.random()>.5&&(ce="x"+ce.toString(16)),re+="&#"+ce+";";return re}var V=function(){function ne(Ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ee||$e.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ce={block:j.normal,inline:z.normal};this.options.pedantic?(ce.block=j.pedantic,ce.inline=z.pedantic):this.options.gfm&&(ce.block=j.gfm,this.options.breaks?ce.inline=z.breaks:ce.inline=z.gfm),this.tokenizer.rules=ce}ne.lex=function(ce,de){var te=new ne(de);return te.lex(ce)},ne.lexInline=function(ce,de){var te=new ne(de);return te.inlineTokens(ce)};var re=ne.prototype;return re.lex=function(ce){ce=ce.replace(/\r\n|\r/g,`
`),this.blockTokens(ce,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},re.blockTokens=function(ce,de){var te=this;de===void 0&&(de=[]),this.options.pedantic?ce=ce.replace(/\t/g,"    ").replace(/^ +$/gm,""):ce=ce.replace(/^( *)(\t+)/gm,function(ie,se,Y){return se+"    ".repeat(Y.length)});for(var he,be,Pe,B;ce;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ie){return(he=ie.call({lexer:te},ce,de))?(ce=ce.substring(he.raw.length),de.push(he),!0):!1}))){if(he=this.tokenizer.space(ce)){ce=ce.substring(he.raw.length),he.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(he);continue}if(he=this.tokenizer.code(ce)){ce=ce.substring(he.raw.length),be=de[de.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+he.raw,be.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=be.text):de.push(he);continue}if(he=this.tokenizer.fences(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.heading(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.hr(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.blockquote(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.list(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.html(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.def(ce)){ce=ce.substring(he.raw.length),be=de[de.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+he.raw,be.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=be.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.lheading(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(Pe=ce,this.options.extensions&&this.options.extensions.startBlock&&function(){var ie=1/0,se=ce.slice(1),Y=void 0;te.options.extensions.startBlock.forEach(function(ge){Y=ge.call({lexer:this},se),typeof Y=="number"&&Y>=0&&(ie=Math.min(ie,Y))}),ie<1/0&&ie>=0&&(Pe=ce.substring(0,ie+1))}(),this.state.top&&(he=this.tokenizer.paragraph(Pe))){be=de[de.length-1],B&&be.type==="paragraph"?(be.raw+=`
`+he.raw,be.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):de.push(he),B=Pe.length!==ce.length,ce=ce.substring(he.raw.length);continue}if(he=this.tokenizer.text(ce)){ce=ce.substring(he.raw.length),be=de[de.length-1],be&&be.type==="text"?(be.raw+=`
`+he.raw,be.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):de.push(he);continue}if(ce){var J="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return this.state.top=!0,de},re.inline=function(ce,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:ce,tokens:de}),de},re.inlineTokens=function(ce,de){var te=this;de===void 0&&(de=[]);var he,be,Pe,B=ce,J,ie,se;if(this.tokens.links){var Y=Object.keys(this.tokens.links);if(Y.length>0)for(;(J=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)Y.includes(J[0].slice(J[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,J.index)+"["+P("a",J[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(J=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,J.index)+"["+P("a",J[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(J=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,J.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ce;)if(ie||(se=""),ie=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(he=ye.call({lexer:te},ce,de))?(ce=ce.substring(he.raw.length),de.push(he),!0):!1}))){if(he=this.tokenizer.escape(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.tag(ce)){ce=ce.substring(he.raw.length),be=de[de.length-1],be&&he.type==="text"&&be.type==="text"?(be.raw+=he.raw,be.text+=he.text):de.push(he);continue}if(he=this.tokenizer.link(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.reflink(ce,this.tokens.links)){ce=ce.substring(he.raw.length),be=de[de.length-1],be&&he.type==="text"&&be.type==="text"?(be.raw+=he.raw,be.text+=he.text):de.push(he);continue}if(he=this.tokenizer.emStrong(ce,B,se)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.codespan(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.br(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.del(ce)){ce=ce.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.autolink(ce,K)){ce=ce.substring(he.raw.length),de.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(ce,K))){ce=ce.substring(he.raw.length),de.push(he);continue}if(Pe=ce,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,je=ce.slice(1),We=void 0;te.options.extensions.startInline.forEach(function(_e){We=_e.call({lexer:this},je),typeof We=="number"&&We>=0&&(ye=Math.min(ye,We))}),ye<1/0&&ye>=0&&(Pe=ce.substring(0,ye+1))}(),he=this.tokenizer.inlineText(Pe,F)){ce=ce.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(se=he.raw.slice(-1)),ie=!0,be=de[de.length-1],be&&be.type==="text"?(be.raw+=he.raw,be.text+=he.text):de.push(he);continue}if(ce){var ge="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return de},C(ne,null,[{key:"rules",get:function(){return{block:j,inline:z}}}]),ne}(),fe=function(){function ne(Ee){this.options=Ee||$e.defaults}var re=ne.prototype;return re.code=function(ce,de,te){var he=(de||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(ce,he);be!=null&&be!==ce&&(te=!0,ce=be)}return ce=ce.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+k(he,!0)+'">'+(te?ce:k(ce,!0))+`</code></pre>
`:"<pre><code>"+(te?ce:k(ce,!0))+`</code></pre>
`},re.blockquote=function(ce){return`<blockquote>
`+ce+`</blockquote>
`},re.html=function(ce){return ce},re.heading=function(ce,de,te,he){if(this.options.headerIds){var be=this.options.headerPrefix+he.slug(te);return"<h"+de+' id="'+be+'">'+ce+"</h"+de+`>
`}return"<h"+de+">"+ce+"</h"+de+`>
`},re.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},re.list=function(ce,de,te){var he=de?"ol":"ul",be=de&&te!==1?' start="'+te+'"':"";return"<"+he+be+`>
`+ce+"</"+he+`>
`},re.listitem=function(ce){return"<li>"+ce+`</li>
`},re.checkbox=function(ce){return"<input "+(ce?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},re.paragraph=function(ce){return"<p>"+ce+`</p>
`},re.table=function(ce,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ce+`</thead>
`+de+`</table>
`},re.tablerow=function(ce){return`<tr>
`+ce+`</tr>
`},re.tablecell=function(ce,de){var te=de.header?"th":"td",he=de.align?"<"+te+' align="'+de.align+'">':"<"+te+">";return he+ce+("</"+te+`>
`)},re.strong=function(ce){return"<strong>"+ce+"</strong>"},re.em=function(ce){return"<em>"+ce+"</em>"},re.codespan=function(ce){return"<code>"+ce+"</code>"},re.br=function(){return this.options.xhtml?"<br/>":"<br>"},re.del=function(ce){return"<del>"+ce+"</del>"},re.link=function(ce,de,te){if(ce=h(this.options.sanitize,this.options.baseUrl,ce),ce===null)return te;var he='<a href="'+k(ce)+'"';return de&&(he+=' title="'+de+'"'),he+=">"+te+"</a>",he},re.image=function(ce,de,te){if(ce=h(this.options.sanitize,this.options.baseUrl,ce),ce===null)return te;var he='<img src="'+ce+'" alt="'+te+'"';return de&&(he+=' title="'+de+'"'),he+=this.options.xhtml?"/>":">",he},re.text=function(ce){return ce},ne}(),Z=function(){function ne(){}var re=ne.prototype;return re.strong=function(ce){return ce},re.em=function(ce){return ce},re.codespan=function(ce){return ce},re.del=function(ce){return ce},re.html=function(ce){return ce},re.text=function(ce){return ce},re.link=function(ce,de,te){return""+te},re.image=function(ce,de,te){return""+te},re.br=function(){return""},ne}(),Q=function(){function ne(){this.seen={}}var re=ne.prototype;return re.serialize=function(ce){return ce.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},re.getNextSafeSlug=function(ce,de){var te=ce,he=0;if(this.seen.hasOwnProperty(te)){he=this.seen[ce];do he++,te=ce+"-"+he;while(this.seen.hasOwnProperty(te))}return de||(this.seen[ce]=he,this.seen[te]=0),te},re.slug=function(ce,de){de===void 0&&(de={});var te=this.serialize(ce);return this.getNextSafeSlug(te,de.dryrun)},ne}(),X=function(){function ne(Ee){this.options=Ee||$e.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new Q}ne.parse=function(ce,de){var te=new ne(de);return te.parse(ce)},ne.parseInline=function(ce,de){var te=new ne(de);return te.parseInline(ce)};var re=ne.prototype;return re.parse=function(ce,de){de===void 0&&(de=!0);var te="",he,be,Pe,B,J,ie,se,Y,ge,ye,je,We,_e,Ye,it,et,Ae,Ne,qe,Le=ce.length;for(he=0;he<Le;he++){if(ye=ce[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(qe=this.options.extensions.renderers[ye.type].call({parser:this},ye),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){te+=qe||"";continue}switch(ye.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,u(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(Y="",se="",B=ye.header.length,be=0;be<B;be++)se+=this.renderer.tablecell(this.parseInline(ye.header[be].tokens),{header:!0,align:ye.align[be]});for(Y+=this.renderer.tablerow(se),ge="",B=ye.rows.length,be=0;be<B;be++){for(ie=ye.rows[be],se="",J=ie.length,Pe=0;Pe<J;Pe++)se+=this.renderer.tablecell(this.parseInline(ie[Pe].tokens),{header:!1,align:ye.align[Pe]});ge+=this.renderer.tablerow(se)}te+=this.renderer.table(Y,ge);continue}case"blockquote":{ge=this.parse(ye.tokens),te+=this.renderer.blockquote(ge);continue}case"list":{for(je=ye.ordered,We=ye.start,_e=ye.loose,B=ye.items.length,ge="",be=0;be<B;be++)it=ye.items[be],et=it.checked,Ae=it.task,Ye="",it.task&&(Ne=this.renderer.checkbox(et),_e?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Ne+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Ne+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Ne}):Ye+=Ne),Ye+=this.parse(it.tokens,_e),ge+=this.renderer.listitem(Ye,Ae,et);te+=this.renderer.list(ge,je,We);continue}case"html":{te+=this.renderer.html(ye.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(ge=ye.tokens?this.parseInline(ye.tokens):ye.text;he+1<Le&&ce[he+1].type==="text";)ye=ce[++he],ge+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);te+=de?this.renderer.paragraph(ge):ge;continue}default:{var Xe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return te},re.parseInline=function(ce,de){de=de||this.renderer;var te="",he,be,Pe,B=ce.length;for(he=0;he<B;he++){if(be=ce[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Pe=this.options.extensions.renderers[be.type].call({parser:this},be),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(be.type))){te+=Pe||"";continue}switch(be.type){case"escape":{te+=de.text(be.text);break}case"html":{te+=de.html(be.text);break}case"link":{te+=de.link(be.href,be.title,this.parseInline(be.tokens,de));break}case"image":{te+=de.image(be.href,be.title,be.text);break}case"strong":{te+=de.strong(this.parseInline(be.tokens,de));break}case"em":{te+=de.em(this.parseInline(be.tokens,de));break}case"codespan":{te+=de.codespan(be.text);break}case"br":{te+=de.br();break}case"del":{te+=de.del(this.parseInline(be.tokens,de));break}case"text":{te+=de.text(be.text);break}default:{var J='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return te},ne}();function oe(ne,re,Ee){if(typeof ne>"u"||ne===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");if(typeof re=="function"&&(Ee=re,re=null),re=D({},oe.defaults,re||{}),g(re),Ee){var ce=re.highlight,de;try{de=V.lex(ne,re)}catch(B){return Ee(B)}var te=function(J){var ie;if(!J)try{re.walkTokens&&oe.walkTokens(de,re.walkTokens),ie=X.parse(de,re)}catch(se){J=se}return re.highlight=ce,J?Ee(J):Ee(null,ie)};if(!ce||ce.length<3||(delete re.highlight,!de.length))return te();var he=0;oe.walkTokens(de,function(B){B.type==="code"&&(he++,setTimeout(function(){ce(B.text,B.lang,function(J,ie){if(J)return te(J);ie!=null&&ie!==B.text&&(B.text=ie,B.escaped=!0),he--,he===0&&te()})},0))}),he===0&&te();return}function be(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+k(B.message+"",!0)+"</pre>";throw B}try{var Pe=V.lex(ne,re);if(re.walkTokens){if(re.async)return Promise.all(oe.walkTokens(Pe,re.walkTokens)).then(function(){return X.parse(Pe,re)}).catch(be);oe.walkTokens(Pe,re.walkTokens)}return X.parse(Pe,re)}catch(B){be(B)}}oe.options=oe.setOptions=function(ne){return D(oe.defaults,ne),$(oe.defaults),oe},oe.getDefaults=A,oe.defaults=$e.defaults,oe.use=function(){for(var ne=arguments.length,re=new Array(ne),Ee=0;Ee<ne;Ee++)re[Ee]=arguments[Ee];var ce=D.apply(void 0,[{}].concat(re)),de=oe.defaults.extensions||{renderers:{},childTokens:{}},te;re.forEach(function(he){if(he.extensions&&(te=!0,he.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var B=de.renderers?de.renderers[Pe.name]:null;B?de.renderers[Pe.name]=function(){for(var J=arguments.length,ie=new Array(J),se=0;se<J;se++)ie[se]=arguments[se];var Y=Pe.renderer.apply(this,ie);return Y===!1&&(Y=B.apply(this,ie)),Y}:de.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Pe.level]?de[Pe.level].unshift(Pe.tokenizer):de[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?de.startBlock?de.startBlock.push(Pe.start):de.startBlock=[Pe.start]:Pe.level==="inline"&&(de.startInline?de.startInline.push(Pe.start):de.startInline=[Pe.start]))}Pe.childTokens&&(de.childTokens[Pe.name]=Pe.childTokens)})),he.renderer&&function(){var Pe=oe.defaults.renderer||new fe,B=function(se){var Y=Pe[se];Pe[se]=function(){for(var ge=arguments.length,ye=new Array(ge),je=0;je<ge;je++)ye[je]=arguments[je];var We=he.renderer[se].apply(Pe,ye);return We===!1&&(We=Y.apply(Pe,ye)),We}};for(var J in he.renderer)B(J);ce.renderer=Pe}(),he.tokenizer&&function(){var Pe=oe.defaults.tokenizer||new M,B=function(se){var Y=Pe[se];Pe[se]=function(){for(var ge=arguments.length,ye=new Array(ge),je=0;je<ge;je++)ye[je]=arguments[je];var We=he.tokenizer[se].apply(Pe,ye);return We===!1&&(We=Y.apply(Pe,ye)),We}};for(var J in he.tokenizer)B(J);ce.tokenizer=Pe}(),he.walkTokens){var be=oe.defaults.walkTokens;ce.walkTokens=function(Pe){var B=[];return B.push(he.walkTokens.call(this,Pe)),be&&(B=B.concat(be.call(this,Pe))),B}}te&&(ce.extensions=de),oe.setOptions(ce)})},oe.walkTokens=function(ne,re){for(var Ee=[],ce=function(){var be=te.value;switch(Ee=Ee.concat(re.call(oe,be)),be.type){case"table":{for(var Pe=L(be.header),B;!(B=Pe()).done;){var J=B.value;Ee=Ee.concat(oe.walkTokens(J.tokens,re))}for(var ie=L(be.rows),se;!(se=ie()).done;)for(var Y=se.value,ge=L(Y),ye;!(ye=ge()).done;){var je=ye.value;Ee=Ee.concat(oe.walkTokens(je.tokens,re))}break}case"list":{Ee=Ee.concat(oe.walkTokens(be.items,re));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[be.type]?oe.defaults.extensions.childTokens[be.type].forEach(function(We){Ee=Ee.concat(oe.walkTokens(be[We],re))}):be.tokens&&(Ee=Ee.concat(oe.walkTokens(be.tokens,re)))}},de=L(ne),te;!(te=de()).done;)ce();return Ee},oe.parseInline=function(ne,re){if(typeof ne>"u"||ne===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");re=D({},oe.defaults,re||{}),g(re);try{var Ee=V.lexInline(ne,re);return re.walkTokens&&oe.walkTokens(Ee,re.walkTokens),X.parseInline(Ee,re)}catch(ce){if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,re.silent)return"<p>An error occurred:</p><pre>"+k(ce.message+"",!0)+"</pre>";throw ce}},oe.Parser=X,oe.parser=X.parse,oe.Renderer=fe,oe.TextRenderer=Z,oe.Lexer=V,oe.lexer=V.lex,oe.Tokenizer=M,oe.Slugger=Q,oe.parse=oe;var x=oe.options,ae=oe.setOptions,we=oe.use,G=oe.walkTokens,U=oe.parseInline,q=oe,me=X.parse,ee=V.lex;$e.Lexer=V,$e.Parser=X,$e.Renderer=fe,$e.Slugger=Q,$e.TextRenderer=Z,$e.Tokenizer=M,$e.getDefaults=A,$e.lexer=ee,$e.marked=oe,$e.options=x,$e.parse=q,$e.parseInline=U,$e.parser=me,$e.setOptions=ae,$e.use=we,$e.walkTokens=G,Object.defineProperty($e,"__esModule",{value:!0})}),define(De[77],Ce([1,0,28]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ol=e.$nl=e.$ml=void 0;const T=new C.$Dc(1e4);function d(v){return E(v,"NFC",T)}e.$ml=d;const L=new C.$Dc(1e4);function A(v){return E(v,"NFD",L)}e.$nl=A;const $=/[^\u0000-\u0080]/;function E(v,R,I){if(!v)return v;const w=I.get(v);if(w)return w;let y;return $.test(v)?y=v.normalize(R):y=v,I.set(v,y),y}e.$ol=function(){const v=/[\u0300-\u036f]/g;return function(R){return A(R).replace(v,"")}}()}),define(De[120],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ol=e.rot=e.$Ml=void 0;function C($,E,v){return Math.min(Math.max($,E),v)}e.$Ml=C;function T($,E){return(E+$%E)%E}e.rot=T;class d{constructor(){this.a=0}getNext(){return this.a++}}e.$Ol=d;class L{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Pl=L;class A{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const v=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=v,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ql=A}),function(){function $e(d){const L=[];typeof d=="number"&&L.push("code/timeOrigin",d);function A(E){L.push(E,Date.now())}function $(){const E=[];for(let v=0;v<L.length;v+=2)E.push({name:L[v],startTime:L[v+1]});return E}return{mark:A,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(d){performance.mark(d)},getMarks(){let d=performance.timeOrigin;typeof d!="number"&&(d=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(d)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(d+A.startTime)});return L}};if(typeof process=="object"){const d=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(d)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function C(d){return d.MonacoPerformanceMarks||(d.MonacoPerformanceMarks=e()),d.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=C(T))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var T in C)(typeof exports=="object"?exports:$e)[T]=C[T]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function C(T){if(e[T])return e[T].exports;var d=e[T]={i:T,l:!1,exports:{}};return $e[T].call(d.exports,d,d.exports,C),d.l=!0,d.exports}return C.m=$e,C.c=e,C.d=function(T,d,L){C.o(T,d)||Object.defineProperty(T,d,{enumerable:!0,get:L})},C.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},C.t=function(T,d){if(1&d&&(T=C(T)),8&d||4&d&&typeof T=="object"&&T&&T.__esModule)return T;var L=Object.create(null);if(C.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:T}),2&d&&typeof T!="string")for(var A in T)C.d(L,A,function($){return T[$]}.bind(null,A));return L},C.n=function(T){var d=T&&T.__esModule?function(){return T.default}:function(){return T};return C.d(d,"a",d),d},C.o=function(T,d){return Object.prototype.hasOwnProperty.call(T,d)},C.p="",C(C.s=0)}([function($e,e,C){(function(T){var d;e=$e.exports=we,d=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],E=e.src=[],v=0,R=v++;E[R]="0|[1-9]\\d*";var I=v++;E[I]="[0-9]+";var w=v++;E[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=v++;E[y]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var k=v++;E[k]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var p=v++;E[p]="(?:"+E[R]+"|"+E[w]+")";var u=v++;E[u]="(?:"+E[I]+"|"+E[w]+")";var c=v++;E[c]="(?:-("+E[p]+"(?:\\."+E[p]+")*))";var r=v++;E[r]="(?:-?("+E[u]+"(?:\\."+E[u]+")*))";var o=v++;E[o]="[0-9A-Za-z-]+";var m=v++;E[m]="(?:\\+("+E[o]+"(?:\\."+E[o]+")*))";var h=v++,t="v?"+E[y]+E[c]+"?"+E[m]+"?";E[h]="^"+t+"$";var n="[v=\\s]*"+E[k]+E[r]+"?"+E[m]+"?",a=v++;E[a]="^"+n+"$";var i=v++;E[i]="((?:<|>)?=?)";var s=v++;E[s]=E[I]+"|x|X|\\*";var l=v++;E[l]=E[R]+"|x|X|\\*";var D=v++;E[D]="[v=\\s]*("+E[l]+")(?:\\.("+E[l]+")(?:\\.("+E[l]+")(?:"+E[c]+")?"+E[m]+"?)?)?";var S=v++;E[S]="[v=\\s]*("+E[s]+")(?:\\.("+E[s]+")(?:\\.("+E[s]+")(?:"+E[r]+")?"+E[m]+"?)?)?";var b=v++;E[b]="^"+E[i]+"\\s*"+E[D]+"$";var f=v++;E[f]="^"+E[i]+"\\s*"+E[S]+"$";var g=v++;E[g]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=v++;E[P]="(?:~>?)";var N=v++;E[N]="(\\s*)"+E[P]+"\\s+",$[N]=new RegExp(E[N],"g");var O=v++;E[O]="^"+E[P]+E[D]+"$";var M=v++;E[M]="^"+E[P]+E[S]+"$";var j=v++;E[j]="(?:\\^)";var z=v++;E[z]="(\\s*)"+E[j]+"\\s+",$[z]=new RegExp(E[z],"g");var F=v++;E[F]="^"+E[j]+E[D]+"$";var K=v++;E[K]="^"+E[j]+E[S]+"$";var V=v++;E[V]="^"+E[i]+"\\s*("+n+")$|^$";var fe=v++;E[fe]="^"+E[i]+"\\s*("+t+")$|^$";var Z=v++;E[Z]="(\\s*)"+E[i]+"\\s*("+n+"|"+E[D]+")",$[Z]=new RegExp(E[Z],"g");var Q=v++;E[Q]="^\\s*("+E[D]+")\\s+-\\s+("+E[D]+")\\s*$";var X=v++;E[X]="^\\s*("+E[S]+")\\s+-\\s+("+E[S]+")\\s*$";var oe=v++;E[oe]="(<|>)?=?\\s*\\*";for(var x=0;x<35;x++)d(x,E[x]),$[x]||($[x]=new RegExp(E[x]));function ae(Y,ge){if(Y instanceof we)return Y;if(typeof Y!="string"||Y.length>L||!(ge?$[a]:$[h]).test(Y))return null;try{return new we(Y,ge)}catch{return null}}function we(Y,ge){if(Y instanceof we){if(Y.loose===ge)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof we))return new we(Y,ge);d("SemVer",Y,ge),this.loose=ge;var ye=Y.trim().match(ge?$[a]:$[h]);if(!ye)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<A)return We}return je}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ae,e.valid=function(Y,ge){var ye=ae(Y,ge);return ye?ye.version:null},e.clean=function(Y,ge){var ye=ae(Y.trim().replace(/^[=v]+/,""),ge);return ye?ye.version:null},e.SemVer=we,we.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},we.prototype.toString=function(){return this.version},we.prototype.compare=function(Y){return d("SemVer.compare",this.version,this.loose,Y),Y instanceof we||(Y=new we(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},we.prototype.compareMain=function(Y){return Y instanceof we||(Y=new we(Y,this.loose)),U(this.major,Y.major)||U(this.minor,Y.minor)||U(this.patch,Y.patch)},we.prototype.comparePre=function(Y){if(Y instanceof we||(Y=new we(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var ge=0;do{var ye=this.prerelease[ge],je=Y.prerelease[ge];if(d("prerelease compare",ge,ye,je),ye===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ye===void 0)return-1;if(ye!==je)return U(ye,je)}while(++ge)},we.prototype.inc=function(Y,ge){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,ge,ye,je){typeof ye=="string"&&(je=ye,ye=void 0);try{return new we(Y,ye).inc(ge,je).version}catch{return null}},e.diff=function(Y,ge){if(ne(Y,ge))return null;var ye=ae(Y),je=ae(ge);if(ye.prerelease.length||je.prerelease.length){for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return We},e.compareIdentifiers=U;var G=/^[0-9]+$/;function U(Y,ge){var ye=G.test(Y),je=G.test(ge);return ye&&je&&(Y=+Y,ge=+ge),ye&&!je?-1:je&&!ye?1:Y<ge?-1:Y>ge?1:0}function q(Y,ge,ye){return new we(Y,ye).compare(new we(ge,ye))}function me(Y,ge,ye){return q(Y,ge,ye)>0}function ee(Y,ge,ye){return q(Y,ge,ye)<0}function ne(Y,ge,ye){return q(Y,ge,ye)===0}function re(Y,ge,ye){return q(Y,ge,ye)!==0}function Ee(Y,ge,ye){return q(Y,ge,ye)>=0}function ce(Y,ge,ye){return q(Y,ge,ye)<=0}function de(Y,ge,ye,je){var We;switch(ge){case"===":typeof Y=="object"&&(Y=Y.version),typeof ye=="object"&&(ye=ye.version),We=Y===ye;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof ye=="object"&&(ye=ye.version),We=Y!==ye;break;case"":case"=":case"==":We=ne(Y,ye,je);break;case"!=":We=re(Y,ye,je);break;case">":We=me(Y,ye,je);break;case">=":We=Ee(Y,ye,je);break;case"<":We=ee(Y,ye,je);break;case"<=":We=ce(Y,ye,je);break;default:throw new TypeError("Invalid operator: "+ge)}return We}function te(Y,ge){if(Y instanceof te){if(Y.loose===ge)return Y;Y=Y.value}if(!(this instanceof te))return new te(Y,ge);d("comparator",Y,ge),this.loose=ge,this.parse(Y),this.semver===he?this.value="":this.value=this.operator+this.semver.version,d("comp",this)}e.rcompareIdentifiers=function(Y,ge){return U(ge,Y)},e.major=function(Y,ge){return new we(Y,ge).major},e.minor=function(Y,ge){return new we(Y,ge).minor},e.patch=function(Y,ge){return new we(Y,ge).patch},e.compare=q,e.compareLoose=function(Y,ge){return q(Y,ge,!0)},e.rcompare=function(Y,ge,ye){return q(ge,Y,ye)},e.sort=function(Y,ge){return Y.sort(function(ye,je){return e.compare(ye,je,ge)})},e.rsort=function(Y,ge){return Y.sort(function(ye,je){return e.rcompare(ye,je,ge)})},e.gt=me,e.lt=ee,e.eq=ne,e.neq=re,e.gte=Ee,e.lte=ce,e.cmp=de,e.Comparator=te;var he={};function be(Y,ge){if(Y instanceof be)return Y.loose===ge?Y:new be(Y.raw,ge);if(Y instanceof te)return new be(Y.value,ge);if(!(this instanceof be))return new be(Y,ge);if(this.loose=ge,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function Pe(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function B(Y,ge,ye,je,We,_e,Ye,it,et,Ae,Ne,qe,Le){return((ge=Pe(ye)?"":Pe(je)?">="+ye+".0.0":Pe(We)?">="+ye+"."+je+".0":">="+ge)+" "+(it=Pe(et)?"":Pe(Ae)?"<"+(+et+1)+".0.0":Pe(Ne)?"<"+et+"."+(+Ae+1)+".0":qe?"<="+et+"."+Ae+"."+Ne+"-"+qe:"<="+it)).trim()}function J(Y,ge){for(var ye=0;ye<Y.length;ye++)if(!Y[ye].test(ge))return!1;if(ge.prerelease.length){for(ye=0;ye<Y.length;ye++)if(d(Y[ye].semver),Y[ye].semver!==he&&Y[ye].semver.prerelease.length>0){var je=Y[ye].semver;if(je.major===ge.major&&je.minor===ge.minor&&je.patch===ge.patch)return!0}return!1}return!0}function ie(Y,ge,ye){try{ge=new be(ge,ye)}catch{return!1}return ge.test(Y)}function se(Y,ge,ye,je){var We,_e,Ye,it,et;switch(Y=new we(Y,je),ge=new be(ge,je),ye){case">":We=me,_e=ce,Ye=ee,it=">",et=">=";break;case"<":We=ee,_e=Ee,Ye=me,it="<",et="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ie(Y,ge,je))return!1;for(var Ae=0;Ae<ge.set.length;++Ae){var Ne=ge.set[Ae],qe=null,Le=null;if(Ne.forEach(function(Xe){Xe.semver===he&&(Xe=new te(">=0.0.0")),qe=qe||Xe,Le=Le||Xe,We(Xe.semver,qe.semver,je)?qe=Xe:Ye(Xe.semver,Le.semver,je)&&(Le=Xe)}),qe.operator===it||qe.operator===et||(!Le.operator||Le.operator===it)&&_e(Y,Le.semver)||Le.operator===et&&Ye(Y,Le.semver))return!1}return!0}te.prototype.parse=function(Y){var ge=this.loose?$[V]:$[fe],ye=Y.match(ge);if(!ye)throw new TypeError("Invalid comparator: "+Y);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new we(ye[2],this.loose):this.semver=he},te.prototype.toString=function(){return this.value},te.prototype.test=function(Y){return d("Comparator.test",Y,this.loose),this.semver===he||(typeof Y=="string"&&(Y=new we(Y,this.loose)),de(Y,this.operator,this.semver,this.loose))},te.prototype.intersects=function(Y,ge){if(!(Y instanceof te))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new be(Y.value,ge),ie(this.value,ye,ge);if(Y.operator==="")return ye=new be(this.value,ge),ie(Y.semver,ye,ge);var je=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),_e=this.semver.version===Y.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),it=de(this.semver,"<",Y.semver,ge)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),et=de(this.semver,">",Y.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return je||We||_e&&Ye||it||et},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(Y){var ge=this.loose;Y=Y.trim(),d("range",Y,ge);var ye=ge?$[X]:$[Q];Y=Y.replace(ye,B),d("hyphen replace",Y),Y=Y.replace($[Z],"$1$2$3"),d("comparator trim",Y,$[Z]),Y=(Y=(Y=Y.replace($[N],"$1~")).replace($[z],"$1^")).split(/\s+/).join(" ");var je=ge?$[V]:$[fe],We=Y.split(" ").map(function(_e){return function(Ye,it){return d("comp",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Ne){return function(qe,Le){d("caret",qe,Le);var Xe=Le?$[K]:$[F];return qe.replace(Xe,function(le,ue,Ie,Ve,Ue){var xe;return d("caret",qe,le,ue,Ie,Ve,Ue),Pe(ue)?xe="":Pe(Ie)?xe=">="+ue+".0.0 <"+(+ue+1)+".0.0":Pe(Ve)?xe=ue==="0"?">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+".0 <"+(+ue+1)+".0.0":Ue?(d("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),xe=ue==="0"?Ie==="0"?">="+ue+"."+Ie+"."+Ve+Ue+" <"+ue+"."+Ie+"."+(+Ve+1):">="+ue+"."+Ie+"."+Ve+Ue+" <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+"."+Ve+Ue+" <"+(+ue+1)+".0.0"):(d("no pr"),xe=ue==="0"?Ie==="0"?">="+ue+"."+Ie+"."+Ve+" <"+ue+"."+Ie+"."+(+Ve+1):">="+ue+"."+Ie+"."+Ve+" <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+"."+Ve+" <"+(+ue+1)+".0.0"),d("caret return",xe),xe})}(Ne,Ae)}).join(" ")}(Ye,it),d("caret",Ye),Ye=function(et,Ae){return et.trim().split(/\s+/).map(function(Ne){return function(qe,Le){var Xe=Le?$[M]:$[O];return qe.replace(Xe,function(le,ue,Ie,Ve,Ue){var xe;return d("tilde",qe,le,ue,Ie,Ve,Ue),Pe(ue)?xe="":Pe(Ie)?xe=">="+ue+".0.0 <"+(+ue+1)+".0.0":Pe(Ve)?xe=">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0":Ue?(d("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),xe=">="+ue+"."+Ie+"."+Ve+Ue+" <"+ue+"."+(+Ie+1)+".0"):xe=">="+ue+"."+Ie+"."+Ve+" <"+ue+"."+(+Ie+1)+".0",d("tilde return",xe),xe})}(Ne,Ae)}).join(" ")}(Ye,it),d("tildes",Ye),Ye=function(et,Ae){return d("replaceXRanges",et,Ae),et.split(/\s+/).map(function(Ne){return function(qe,Le){qe=qe.trim();var Xe=Le?$[f]:$[b];return qe.replace(Xe,function(le,ue,Ie,Ve,Ue,xe){d("xRange",qe,le,ue,Ie,Ve,Ue,xe);var rt=Pe(Ie),ot=rt||Pe(Ve),$t=ot||Pe(Ue);return ue==="="&&$t&&(ue=""),rt?le=ue===">"||ue==="<"?"<0.0.0":"*":ue&&$t?(ot&&(Ve=0),$t&&(Ue=0),ue===">"?(ue=">=",ot?(Ie=+Ie+1,Ve=0,Ue=0):$t&&(Ve=+Ve+1,Ue=0)):ue==="<="&&(ue="<",ot?Ie=+Ie+1:Ve=+Ve+1),le=ue+Ie+"."+Ve+"."+Ue):ot?le=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":$t&&(le=">="+Ie+"."+Ve+".0 <"+Ie+"."+(+Ve+1)+".0"),d("xRange return",le),le})}(Ne,Ae)}).join(" ")}(Ye,it),d("xrange",Ye),Ye=function(et,Ae){return d("replaceStars",et,Ae),et.trim().replace($[oe],"")}(Ye,it),d("stars",Ye),Ye}(_e,ge)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(_e){return!!_e.match(je)})),We=We.map(function(_e){return new te(_e,ge)})},be.prototype.intersects=function(Y,ge){if(!(Y instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(je){return Y.set.some(function(We){return We.every(function(_e){return je.intersects(_e,ge)})})})})},e.toComparators=function(Y,ge){return new be(Y,ge).set.map(function(ye){return ye.map(function(je){return je.value}).join(" ").trim().split(" ")})},be.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new we(Y,this.loose));for(var ge=0;ge<this.set.length;ge++)if(J(this.set[ge],Y))return!0;return!1},e.satisfies=ie,e.maxSatisfying=function(Y,ge,ye){var je=null,We=null;try{var _e=new be(ge,ye)}catch{return null}return Y.forEach(function(Ye){_e.test(Ye)&&(je&&We.compare(Ye)!==-1||(We=new we(je=Ye,ye)))}),je},e.minSatisfying=function(Y,ge,ye){var je=null,We=null;try{var _e=new be(ge,ye)}catch{return null}return Y.forEach(function(Ye){_e.test(Ye)&&(je&&We.compare(Ye)!==1||(We=new we(je=Ye,ye)))}),je},e.validRange=function(Y,ge){try{return new be(Y,ge).range||"*"}catch{return null}},e.ltr=function(Y,ge,ye){return se(Y,ge,"<",ye)},e.gtr=function(Y,ge,ye){return se(Y,ge,">",ye)},e.outside=se,e.prerelease=function(Y,ge){var ye=ae(Y,ge);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(Y,ge,ye){return Y=new be(Y,ye),ge=new be(ge,ye),Y.intersects(ge)},e.coerce=function(Y){if(Y instanceof we)return Y;if(typeof Y!="string")return null;var ge=Y.match($[g]);return ge==null?null:ae((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,C(1))},function($e,e){var C,T,d=$e.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function $(u){if(C===setTimeout)return setTimeout(u,0);if((C===L||!C)&&setTimeout)return C=setTimeout,setTimeout(u,0);try{return C(u,0)}catch{try{return C.call(null,u,0)}catch{return C.call(this,u,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:L}catch{C=L}try{T=typeof clearTimeout=="function"?clearTimeout:A}catch{T=A}})();var E,v=[],R=!1,I=-1;function w(){R&&E&&(R=!1,E.length?v=E.concat(v):I=-1,v.length&&y())}function y(){if(!R){var u=$(w);R=!0;for(var c=v.length;c;){for(E=v,v=[];++I<c;)E&&E[I].run();I=-1,c=v.length}E=null,R=!1,function(r){if(T===clearTimeout)return clearTimeout(r);if((T===A||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(r);try{T(r)}catch{try{return T.call(null,r)}catch{return T.call(this,r)}}}(u)}}function k(u,c){this.fun=u,this.array=c}function p(){}d.nextTick=function(u){var c=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)c[r-1]=arguments[r];v.push(new k(u,c)),v.length!==1||R||$(y)},k.prototype.run=function(){this.fun.apply(null,this.array)},d.title="browser",d.browser=!0,d.env={},d.argv=[],d.version="",d.versions={},d.on=p,d.addListener=p,d.once=p,d.off=p,d.removeListener=p,d.removeAllListeners=p,d.emit=p,d.prependListener=p,d.prependOnceListener=p,d.listeners=function(u){return[]},d.binding=function(u){throw new Error("process.binding is not supported")},d.cwd=function(){return"/"},d.chdir=function(u){throw new Error("process.chdir is not supported")},d.umask=function(){return 0}}])}),define(De[37],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(L){return new T(L)}constructor(L){this.c=C&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Jd=T}),define(De[4],Ce([1,0,8,75,3,76,37]),function($e,e,C,T,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.Event=void 0;const $=!1,E=!1;var v;(function(b){b.None=()=>d.$Sc.None;function f(de){if(E){const{onDidAddListener:te}=de,he=k.create();let be=0;de.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),he.print()),te?.()}}}function g(de,te){return fe(de,()=>{},0,void 0,!0,void 0,te)}b.defer=g;function P(de){return(te,he=null,be)=>{let Pe=!1,B;return B=de(J=>{if(!Pe)return B?B.dispose():Pe=!0,te.call(he,J)},null,be),Pe&&B.dispose(),B}}b.once=P;function N(de,te,he){return K((be,Pe=null,B)=>de(J=>be.call(Pe,te(J)),null,B),he)}b.map=N;function O(de,te,he){return K((be,Pe=null,B)=>de(J=>{te(J),be.call(Pe,J)},null,B),he)}b.forEach=O;function M(de,te,he){return K((be,Pe=null,B)=>de(J=>te(J)&&be.call(Pe,J),null,B),he)}b.filter=M;function j(de){return de}b.signal=j;function z(...de){return(te,he=null,be)=>{const Pe=(0,d.$Pc)(...de.map(B=>B(J=>te.call(he,J))));return V(Pe,be)}}b.any=z;function F(de,te,he,be){let Pe=he;return N(de,B=>(Pe=te(Pe,B),Pe),be)}b.reduce=F;function K(de,te){let he;const be={onWillAddFirstListener(){he=de(Pe.fire,Pe)},onDidRemoveLastListener(){he?.dispose()}};te||f(be);const Pe=new o(be);return te?.add(Pe),Pe.event}function V(de,te){return te instanceof Array?te.push(de):te&&te.add(de),de}function fe(de,te,he=100,be=!1,Pe=!1,B,J){let ie,se,Y,ge=0,ye;const je={leakWarningThreshold:B,onWillAddFirstListener(){ie=de(_e=>{ge++,se=te(se,_e),be&&!Y&&(We.fire(se),se=void 0),ye=()=>{const Ye=se;se=void 0,Y=void 0,(!be||ge>1)&&We.fire(Ye),ge=0},typeof he=="number"?(clearTimeout(Y),Y=setTimeout(ye,he)):Y===void 0&&(Y=0,queueMicrotask(ye))})},onWillRemoveListener(){Pe&&ge>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,ie.dispose()}};J||f(je);const We=new o(je);return J?.add(We),We.event}b.debounce=fe;function Z(de,te=0,he){return b.debounce(de,(be,Pe)=>be?(be.push(Pe),be):[Pe],te,void 0,!0,void 0,he)}b.accumulate=Z;function Q(de,te=(be,Pe)=>be===Pe,he){let be=!0,Pe;return M(de,B=>{const J=be||!te(B,Pe);return be=!1,Pe=B,J},he)}b.latch=Q;function X(de,te,he){return[b.filter(de,te,he),b.filter(de,be=>!te(be),he)]}b.split=X;function oe(de,te=!1,he=[],be){let Pe=he.slice(),B=de(se=>{Pe?Pe.push(se):ie.fire(se)});be&&be.add(B);const J=()=>{Pe?.forEach(se=>ie.fire(se)),Pe=null},ie=new o({onWillAddFirstListener(){B||(B=de(se=>ie.fire(se)),be&&be.add(B))},onDidAddFirstListener(){Pe&&(te?setTimeout(J):J())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return be&&be.add(ie),ie.event}b.buffer=oe;function x(de,te){return(be,Pe,B)=>{const J=te(new we);return de(function(ie){const se=J.evaluate(ie);se!==ae&&be.call(Pe,se)},void 0,B)}}b.chain=x;const ae=Symbol("HaltChainable");class we{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(he=>(te(he),he)),this}filter(te){return this.f.push(he=>te(he)?he:ae),this}reduce(te,he){let be=he;return this.f.push(Pe=>(be=te(be,Pe),be)),this}latch(te=(he,be)=>he===be){let he=!0,be;return this.f.push(Pe=>{const B=he||!te(Pe,be);return he=!1,be=Pe,B?Pe:ae}),this}evaluate(te){for(const he of this.f)if(te=he(te),te===ae)break;return te}}function G(de,te,he=be=>be){const be=(...ie)=>J.fire(he(...ie)),Pe=()=>de.on(te,be),B=()=>de.removeListener(te,be),J=new o({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return J.event}b.fromNodeEventEmitter=G;function U(de,te,he=be=>be){const be=(...ie)=>J.fire(he(...ie)),Pe=()=>de.addEventListener(te,be),B=()=>de.removeEventListener(te,be),J=new o({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return J.event}b.fromDOMEventEmitter=U;function q(de){return new Promise(te=>P(de)(te))}b.toPromise=q;function me(de){const te=new o;return de.then(he=>{te.fire(he)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}b.fromPromise=me;function ee(de,te){return te(void 0),de(he=>te(he))}b.runAndSubscribe=ee;function ne(de,te){let he=null;function be(B){he?.dispose(),he=new d.$Rc,te(B,he)}be(void 0);const Pe=de(B=>be(B));return(0,d.$Qc)(()=>{Pe.dispose(),he?.dispose()})}b.runAndSubscribeWithStore=ne;class re{constructor(te,he){this._observable=te,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};he||f(be),this.emitter=new o(be),he&&he.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,he){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(de,te){return new re(de,te).emitter.event}b.fromObservable=Ee;function ce(de){return te=>{let he=0,be=!1;const Pe={beginUpdate(){he++},endUpdate(){he--,he===0&&(de.reportChanges(),be&&(be=!1,te()))},handlePossibleChange(){},handleChange(){be=!0}};return de.addObserver(Pe),de.reportChanges(),{dispose(){de.removeObserver(Pe)}}}}b.fromObservableLight=ce})(v||(e.Event=v={}));class R{static{this.all=new Set}static{this.f=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${R.f++}`,R.all.add(this)}start(f){this.g=new A.$Jd,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$Ld=R;let I=-1;function w(b){const f=I;return I=b,{dispose(){I=f}}}e.$Md=w;class y{constructor(f,g=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=g,this.g=0}dispose(){this.f?.clear()}check(f,g){const P=this.threshold;if(P<=0||g<P)return;this.f||(this.f=new Map);const N=this.f.get(f.value)||0;if(this.f.set(f.value,N+1),this.g-=1,this.g<=0){this.g=P*.5;let O,M=0;for(const[j,z]of this.f)(!O||M<z)&&(O=j,M=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${M}):`),console.warn(O)}return()=>{const O=this.f.get(f.value)||0;this.f.set(f.value,O-1)}}}class k{static create(){return new k(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class u{constructor(f){this.value=f,this.id=p++}}const c=2,r=(b,f)=>{if(b instanceof u)f(b);else for(let g=0;g<b.length;g++){const P=b[g];P&&f(P)}};class o{constructor(f){this.w=0,this.f=f,this.g=I>0||this.f?.leakWarningThreshold?new y(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const f=this.t;queueMicrotask(()=>{r(f,g=>g.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(f,g,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),d.$Sc.None;if(this.m)return d.$Sc.None;g&&(f=f.bind(g));const N=new u(f);let O,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=k.create(),O=this.g.check(N.stack,this.w+1)),$&&(N.stack=M??k.create()),this.t?this.t instanceof u?(this.u??=new h,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,d.$Qc)(()=>{O?.(),this.x(N)});return P instanceof d.$Rc?P.add(j):Array.isArray(P)&&P.push(j),j},this.q}x(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const g=this.t,P=g.indexOf(f);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,g[P]=void 0;const N=this.u.current===this;if(this.w*c<=g.length){let O=0;for(let M=0;M<g.length;M++)g[M]?g[O++]=g[M]:N&&(this.u.end--,O<this.u.i&&this.u.i--);g.length=O}}y(f,g){if(!f)return;const P=this.f?.onListenerError||C.$1;if(!P){f.value(g);return}try{f.value(g)}catch(N){P(N)}}z(f){const g=f.current.t;for(;f.i<f.end;)this.y(g[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof u)this.y(this.t,f);else{const g=this.u;g.enqueue(this,f,this.t.length),this.z(g)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Nd=o;const m=()=>new h;e.$Od=m;class h{constructor(){this.i=-1,this.end=0}enqueue(f,g,P){this.i=0,this.end=P,this.current=f,this.value=g}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends o{async fireAsync(f,g,P){if(this.t)for(this.h||(this.h=new L.$2c),r(this.t,N=>this.h.push([N.value,f]));this.h.size>0&&!g.isCancellationRequested;){const[N,O]=this.h.shift(),M=[],j={...O,token:g,waitUntil:z=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");P&&(z=P(z,N)),M.push(z)}};try{N(j)}catch(z){(0,C.$1)(z);continue}Object.freeze(M),await Promise.allSettled(M).then(z=>{for(const F of z)F.status==="rejected"&&(0,C.$1)(F.reason)})}}}e.$Pd=t;class n extends o{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new L.$2c,this.A=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.A(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.w&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$Qd=n;class a extends n{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$Rd=a;class i extends o{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(g=>super.fire(g)),this.h=[]}))}}e.$Sd=i;class s{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const g={event:f,listener:null};this.h.push(g),this.g&&this.m(g);const P=()=>{this.g&&this.o(g);const N=this.h.indexOf(g);this.h.splice(N,1)};return(0,d.$Qc)((0,T.$db)(P))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event(g=>this.f.fire(g))}o(f){f.listener&&f.listener.dispose(),f.listener=null}dispose(){this.f.dispose()}}e.$Td=s;class l{constructor(f,g,P,N){this.f=new d.$Rc;const O=this.f.add(new s),M=this.f.add(new d.$1c);function j(z){M.set(z,O.add(N(z)))}for(const z of f)j(z);this.f.add(g(z=>{j(z)})),this.f.add(P(z=>{M.deleteAndDispose(z)})),this.event=O.event}dispose(){this.f.dispose()}}e.$Ud=l;class D{constructor(){this.f=[]}wrapEvent(f){return(g,P,N)=>f(O=>{const M=this.f[this.f.length-1];M?M.push(()=>g.call(P,O)):g.call(P,O)},void 0,N)}bufferEvents(f){const g=[];this.f.push(g);const P=f();return this.f.pop(),g.forEach(N=>N()),P}}e.$Vd=D;class S{constructor(){this.f=!1,this.g=v.None,this.h=d.$Sc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Wd=S}),define(De[21],Ce([1,0,4]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.CancellationToken=void 0;const T=Object.freeze(function($,E){const v=setTimeout($.bind(E),0);return{dispose(){clearTimeout(v)}}});var d;(function($){function E(v){return v===$.None||v===$.Cancelled||v instanceof L?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}$.isCancellationToken=E,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(d||(e.CancellationToken=d={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new C.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=d.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=d.None}}e.$Xd=A}),define(De[159],Ce([1,0,21]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=void 0;class T{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new C.$Xd,E=this.b($.token);return this.a={promise:E,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$we=T;class d{constructor($){this.c=$,this.a=void 0,this.b=void 0}get($){const E=JSON.stringify($);return this.b!==E&&(this.b=E,this.a=this.c($)),this.a}}e.$xe=d;class L{get cachedValues(){return this.a}constructor($){this.b=$,this.a=new Map}get($){if(this.a.has($))return this.a.get($);const E=this.b($);return this.a.set($,E),E}}e.$ye=L}),define(De[96],Ce([1,0,8,3]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function d(m){const h=m;return h?typeof h.read=="function":!1}e.$Yd=d;function L(m){const h=m;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}e.$Zd=L;function A(m){const h=m;return h?L(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$1d=A;function $(m,h){return new E(m,h)}e.$2d=$;class E{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,C.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let n;switch(h){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const a=n.indexOf(t);a>=0&&n.splice(a,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function v(m,h){const t=[];let n;for(;(n=m.read())!==null;)t.push(n);return h(t)}e.$3d=v;function R(m,h,t){const n=[];let a;for(;(a=m.read())!==null&&n.length<t;)n.push(a);return a===null&&n.length>0?h(n):{read:()=>{if(n.length>0)return n.shift();if(typeof a<"u"){const i=a;return a=void 0,i}return m.read()}}}e.$4d=R;function I(m,h){return new Promise((t,n)=>{const a=[];w(m,{onData:i=>{h&&a.push(i)},onError:i=>{h?n(i):t(void 0)},onEnd:()=>{t(h?h(a):void 0)}})})}e.$5d=I;function w(m,h,t){m.on("error",n=>{t?.isCancellationRequested||h.onError(n)}),m.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),m.on("data",n=>{t?.isCancellationRequested||h.onData(n)})}e.$6d=w;function y(m,h){return new Promise((t,n)=>{const a=new T.$Rc,i=[],s=S=>{if(i.push(S),i.length>h)return a.dispose(),m.pause(),t({stream:m,buffer:i,ended:!1})},l=S=>(a.dispose(),n(S)),D=()=>(a.dispose(),t({stream:m,buffer:i,ended:!0}));a.add((0,T.$Qc)(()=>m.removeListener("error",l))),m.on("error",l),a.add((0,T.$Qc)(()=>m.removeListener("end",D))),m.on("end",D),a.add((0,T.$Qc)(()=>m.removeListener("data",s))),m.on("data",s)})}e.$7d=y;function k(m,h){const t=$(h);return t.end(m),t}e.$8d=k;function p(){const m=$(()=>{throw new Error("not supported")});return m.end(),m}e.$9d=p;function u(m){let h=!1;return{read:()=>h?null:(h=!0,m)}}e.$0d=u;function c(m,h,t){const n=$(t);return w(m,{onData:a=>n.write(h.data(a)),onError:a=>n.error(h.error?h.error(a):a),onEnd:()=>n.end()}),n}e.$$d=c;function r(m,h,t){let n=!1;return{read:()=>{const a=h.read();return n?a:(n=!0,a!==null?t([m,a]):m)}}}e.$_d=r;function o(m,h,t){let n=!1;const a=$(t);return w(h,{onData:i=>n?a.write(i):(n=!0,a.write(t([m,i]))),onError:i=>a.error(i),onEnd:()=>{n||(n=!0,a.write(m)),a.end()}}),a}e.$ae=o}),define(De[22],Ce([1,0,47,96]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const d=typeof Buffer<"u",L=new C.$V(()=>new Uint8Array(256));let A,$;class E{static alloc(g){return d?new E(Buffer.allocUnsafe(g)):new E(new Uint8Array(g))}static wrap(g){return d&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new E(g)}static fromString(g,P){return!(P?.dontUseNodeBuffer||!1)&&d?new E(Buffer.from(g)):(A||(A=new TextEncoder),new E(A.encode(g)))}static fromByteArray(g){const P=E.alloc(g.length);for(let N=0,O=g.length;N<O;N++)P.buffer[N]=g[N];return P}static concat(g,P){if(typeof P>"u"){P=0;for(let M=0,j=g.length;M<j;M++)P+=g[M].byteLength}const N=E.alloc(P);let O=0;for(let M=0,j=g.length;M<j;M++){const z=g[M];N.set(z,O),O+=z.byteLength}return N}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=E.alloc(this.byteLength);return g.set(this),g}toString(){return d?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(g,P){return new E(this.buffer.subarray(g,P))}set(g,P){if(g instanceof E)this.buffer.set(g.buffer,P);else if(g instanceof Uint8Array)this.buffer.set(g,P);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),P);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return w(this.buffer,g)}writeUInt32BE(g,P){y(this.buffer,g,P)}readUInt32LE(g){return k(this.buffer,g)}writeUInt32LE(g,P){p(this.buffer,g,P)}readUInt8(g){return u(this.buffer,g)}writeUInt8(g,P){c(this.buffer,g,P)}indexOf(g,P=0){return v(this.buffer,g instanceof E?g.buffer:g,P)}}e.$be=E;function v(f,g,P=0){const N=g.byteLength,O=f.byteLength;if(N===0)return 0;if(N===1)return f.indexOf(g[0]);if(N>O-P)return-1;const M=L.value;M.fill(g.length);for(let K=0;K<g.length;K++)M[g[K]]=g.length-K-1;let j=P+g.length-1,z=j,F=-1;for(;j<O;)if(f[j]===g[z]){if(z===0){F=j;break}j--,z--}else j+=Math.max(g.length-z,M[f[j]]),z=g.length-1;return F}e.$ce=v;function R(f,g){return f[g+0]<<0>>>0|f[g+1]<<8>>>0}e.$de=R;function I(f,g,P){f[P+0]=g&255,g=g>>>8,f[P+1]=g&255}e.$ee=I;function w(f,g){return f[g]*2**24+f[g+1]*2**16+f[g+2]*2**8+f[g+3]}e.$fe=w;function y(f,g,P){f[P+3]=g,g=g>>>8,f[P+2]=g,g=g>>>8,f[P+1]=g,g=g>>>8,f[P]=g}e.$ge=y;function k(f,g){return f[g+0]<<0>>>0|f[g+1]<<8>>>0|f[g+2]<<16>>>0|f[g+3]<<24>>>0}e.$he=k;function p(f,g,P){f[P+0]=g&255,g=g>>>8,f[P+1]=g&255,g=g>>>8,f[P+2]=g&255,g=g>>>8,f[P+3]=g&255}e.$ie=p;function u(f,g){return f[g]}e.$je=u;function c(f,g,P){f[P]=g}e.$ke=c;function r(f){return T.$3d(f,g=>E.concat(g))}e.$le=r;function o(f){return T.$0d(f)}e.$me=o;function m(f){return T.$5d(f,g=>E.concat(g))}e.$ne=m;async function h(f){return f.ended?E.concat(f.buffer):E.concat([...f.buffer,await m(f.stream)])}e.$oe=h;function t(f){return T.$8d(f,g=>E.concat(g))}e.$pe=t;function n(f){return T.$$d(f,{data:g=>typeof g=="string"?E.fromString(g):E.wrap(g)},g=>E.concat(g))}e.$qe=n;function a(f){return T.$2d(g=>E.concat(g),f)}e.$re=a;function i(f,g){return T.$_d(f,g,P=>E.concat(P))}e.$se=i;function s(f,g){return T.$ae(f,g,P=>E.concat(P))}e.$te=s;function l(f){let g=0,P=0,N=0;const O=new Uint8Array(Math.floor(f.length/4*3)),M=z=>{switch(P){case 3:O[N++]=g|z,P=0;break;case 2:O[N++]=g|z>>>2,g=z<<6,P=3;break;case 1:O[N++]=g|z>>>4,g=z<<4,P=2;break;default:g=z<<2,P=1}};for(let z=0;z<f.length;z++){const F=f.charCodeAt(z);if(F>=65&&F<=90)M(F-65);else if(F>=97&&F<=122)M(F-97+26);else if(F>=48&&F<=57)M(F-48+52);else if(F===43||F===45)M(62);else if(F===47||F===95)M(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${f[z]}`)}}const j=N;for(;P>0;)M(0);return E.wrap(O).slice(0,j)}e.$ue=l;const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:f},g=!0,P=!1){const N=P?S:D;let O="";const M=f.byteLength%3;let j=0;for(;j<f.byteLength-M;j+=3){const z=f[j+0],F=f[j+1],K=f[j+2];O+=N[z>>>2],O+=N[(z<<4|F>>>4)&63],O+=N[(F<<2|K>>>6)&63],O+=N[K&63]}if(M===1){const z=f[j+0];O+=N[z>>>2],O+=N[z<<4&63],g&&(O+="==")}else if(M===2){const z=f[j+0],F=f[j+1];O+=N[z>>>2],O+=N[(z<<4|F>>>4)&63],O+=N[F<<2&63],g&&(O+="=")}return O}e.$ve=b}),define(De[15],Ce([1,0,159,47]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xf=e.$wf=e.$vf=e.$uf=e.GraphemeBreakType=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=void 0;function d(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Be=d;const L=/{(\d+)}/g;function A(Ae,...Ne){return Ne.length===0?Ae:Ae.replace(L,function(qe,Le){const Xe=parseInt(Le,10);return isNaN(Xe)||Xe<0||Xe>=Ne.length?qe:Ne[Xe]})}e.$Ce=A;const $=/{([^}]+)}/g;function E(Ae,Ne){return Ae.replace($,(qe,Le)=>Ne[Le]??qe)}e.$De=E;function v(Ae){return Ae.replace(/[<>&]/g,function(Ne){switch(Ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ne}})}e.$Ee=v;function R(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Fe=R;function I(Ae,Ne){let qe=0;const Le=Ne.charCodeAt(0);for(let Xe=Ae.length-1;Xe>=0;Xe--)Ae.charCodeAt(Xe)===Le&&qe++;return qe}e.$Ge=I;function w(Ae,Ne,qe="\u2026"){return Ae.length<=Ne?Ae:`${Ae.substr(0,Ne)}${qe}`}e.$He=w;function y(Ae,Ne=" "){const qe=k(Ae,Ne);return p(qe,Ne)}e.$Ie=y;function k(Ae,Ne){if(!Ae||!Ne)return Ae;const qe=Ne.length;if(qe===0||Ae.length===0)return Ae;let Le=0;for(;Ae.indexOf(Ne,Le)===Le;)Le=Le+qe;return Ae.substring(Le)}e.$Je=k;function p(Ae,Ne){if(!Ae||!Ne)return Ae;const qe=Ne.length,Le=Ae.length;if(qe===0||Le===0)return Ae;let Xe=Le,le=-1;for(;le=Ae.lastIndexOf(Ne,Xe-1),!(le===-1||le+qe!==Xe);){if(le===0)return"";Xe=le}return Ae.substring(0,Xe)}e.$Ke=p;function u(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Le=u;function c(Ae){return Ae.replace(/\*/g,"")}e.$Me=c;function r(Ae,Ne,qe={}){if(!Ae)throw new Error("Cannot create regex from empty string");Ne||(Ae=R(Ae)),qe.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Le="";return qe.global&&(Le+="g"),qe.matchCase||(Le+="i"),qe.multiline&&(Le+="m"),qe.unicode&&(Le+="u"),new RegExp(Ae,Le)}e.$Ne=r;function o(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Oe=o;function m(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Pe=m;function h(Ae){for(let Ne=0,qe=Ae.length;Ne<qe;Ne++){const Le=Ae.charCodeAt(Ne);if(Le!==32&&Le!==9)return Ne}return-1}e.$Qe=h;function t(Ae,Ne=0,qe=Ae.length){for(let Le=Ne;Le<qe;Le++){const Xe=Ae.charCodeAt(Le);if(Xe!==32&&Xe!==9)return Ae.substring(Ne,Le)}return Ae.substring(Ne,qe)}e.$Re=t;function n(Ae,Ne=Ae.length-1){for(let qe=Ne;qe>=0;qe--){const Le=Ae.charCodeAt(qe);if(Le!==32&&Le!==9)return qe}return-1}e.$Se=n;function a(Ae,Ne,qe){const Le=[];let Xe=0;for(const le of Ae.matchAll(Ne)){if(Le.push(Ae.slice(Xe,le.index)),le.index===void 0)throw new Error("match.index should be defined");Xe=le.index+le[0].length,Le.push(qe(le[0],...le.slice(1),le.index,Ae,le.groups))}return Le.push(Ae.slice(Xe)),Promise.all(Le).then(le=>le.join(""))}e.$Te=a;function i(Ae,Ne){return Ae<Ne?-1:Ae>Ne?1:0}e.$Ue=i;function s(Ae,Ne,qe=0,Le=Ae.length,Xe=0,le=Ne.length){for(;qe<Le&&Xe<le;qe++,Xe++){const Ve=Ae.charCodeAt(qe),Ue=Ne.charCodeAt(Xe);if(Ve<Ue)return-1;if(Ve>Ue)return 1}const ue=Le-qe,Ie=le-Xe;return ue<Ie?-1:ue>Ie?1:0}e.$Ve=s;function l(Ae,Ne){return D(Ae,Ne,0,Ae.length,0,Ne.length)}e.$We=l;function D(Ae,Ne,qe=0,Le=Ae.length,Xe=0,le=Ne.length){for(;qe<Le&&Xe<le;qe++,Xe++){let Ve=Ae.charCodeAt(qe),Ue=Ne.charCodeAt(Xe);if(Ve===Ue)continue;if(Ve>=128||Ue>=128)return s(Ae.toLowerCase(),Ne.toLowerCase(),qe,Le,Xe,le);b(Ve)&&(Ve-=32),b(Ue)&&(Ue-=32);const xe=Ve-Ue;if(xe!==0)return xe}const ue=Le-qe,Ie=le-Xe;return ue<Ie?-1:ue>Ie?1:0}e.$Xe=D;function S(Ae){return Ae>=48&&Ae<=57}e.$Ye=S;function b(Ae){return Ae>=97&&Ae<=122}e.$Ze=b;function f(Ae){return Ae>=65&&Ae<=90}e.$1e=f;function g(Ae,Ne){return Ae.length===Ne.length&&D(Ae,Ne)===0}e.$2e=g;function P(Ae,Ne){const qe=Ne.length;return Ne.length>Ae.length?!1:D(Ae,Ne,0,qe)===0}e.$3e=P;function N(Ae,Ne){const qe=Math.min(Ae.length,Ne.length);let Le;for(Le=0;Le<qe;Le++)if(Ae.charCodeAt(Le)!==Ne.charCodeAt(Le))return Le;return qe}e.$4e=N;function O(Ae,Ne){const qe=Math.min(Ae.length,Ne.length);let Le;const Xe=Ae.length-1,le=Ne.length-1;for(Le=0;Le<qe;Le++)if(Ae.charCodeAt(Xe-Le)!==Ne.charCodeAt(le-Le))return Le;return qe}e.$5e=O;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$6e=M;function j(Ae){return 56320<=Ae&&Ae<=57343}e.$7e=j;function z(Ae,Ne){return(Ae-55296<<10)+(Ne-56320)+65536}e.$8e=z;function F(Ae,Ne,qe){const Le=Ae.charCodeAt(qe);if(M(Le)&&qe+1<Ne){const Xe=Ae.charCodeAt(qe+1);if(j(Xe))return z(Le,Xe)}return Le}e.$9e=F;function K(Ae,Ne){const qe=Ae.charCodeAt(Ne-1);if(j(qe)&&Ne>1){const Le=Ae.charCodeAt(Ne-2);if(M(Le))return z(Le,qe)}return qe}class V{get offset(){return this.e}constructor(Ne,qe=0){this.c=Ne,this.d=Ne.length,this.e=qe}setOffset(Ne){this.e=Ne}prevCodePoint(){const Ne=K(this.c,this.e);return this.e-=Ne>=65536?2:1,Ne}nextCodePoint(){const Ne=F(this.c,this.d,this.e);return this.e+=Ne>=65536?2:1,Ne}eol(){return this.e>=this.d}}e.$0e=V;class fe{get offset(){return this.c.offset}constructor(Ne,qe=0){this.c=new V(Ne,qe)}nextGraphemeLength(){const Ne=ge.getInstance(),qe=this.c,Le=qe.offset;let Xe=Ne.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const le=qe.offset,ue=Ne.getGraphemeBreakType(qe.nextCodePoint());if(se(Xe,ue)){qe.setOffset(le);break}Xe=ue}return qe.offset-Le}prevGraphemeLength(){const Ne=ge.getInstance(),qe=this.c,Le=qe.offset;let Xe=Ne.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const le=qe.offset,ue=Ne.getGraphemeBreakType(qe.prevCodePoint());if(se(ue,Xe)){qe.setOffset(le);break}Xe=ue}return Le-qe.offset}eol(){return this.c.eol()}}e.$$e=fe;function Z(Ae,Ne){return new fe(Ae,Ne).nextGraphemeLength()}e.$_e=Z;function Q(Ae,Ne){return new fe(Ae,Ne).prevGraphemeLength()}e.$af=Q;function X(Ae,Ne){Ne>0&&j(Ae.charCodeAt(Ne))&&Ne--;const qe=Ne+Z(Ae,Ne);return[qe-Q(Ae,qe),qe]}e.$bf=X;function oe(Ae){const Ne=new fe(Ae);let qe=0;for(;!Ne.eol();)qe++,Ne.nextGraphemeLength();return qe}e.$cf=oe;let x;function ae(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function we(Ae){return x||(x=ae()),x.test(Ae)}e.$df=we;const G=/^[\t\n\r\x20-\x7E]*$/;function U(Ae){return G.test(Ae)}e.$ef=U,e.$ff=/[\u2028\u2029]/;function q(Ae){return e.$ff.test(Ae)}e.$gf=q;function me(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$hf=me;function ee(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$if=ee;function ne(Ae,Ne){if(Ae.length<Ne)return Ae;const qe=/\b/g;let Le=0;for(;qe.test(Ae)&&!(Ae.length-qe.lastIndex<Ne);)Le=qe.lastIndex,qe.lastIndex+=1;return Ae.substring(Le).replace(/^\s/,"")}e.$jf=ne;const re=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Ee=/\x1b\].*?\x07/g;function ce(Ae){return Ae&&(Ae=Ae.replace(re,"").replace(Ee,"")),Ae}e.$kf=ce,e.$lf=String.fromCharCode(65279);function de(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$mf=de;function te(Ae){return de(Ae)?Ae.substr(1):Ae}e.$nf=te;function he(Ae,Ne){if(!Ae||!Ne||Ae.length<Ne.length)return!1;const qe=Ne.length,Le=Ae.toLowerCase();let Xe=0,le=-1;for(;Xe<qe;){const ue=Le.indexOf(Ne[Xe],le+1);if(ue<0)return!1;le=ue,Xe++}return!0}e.$of=he;function be(Ae,Ne=!1){return Ae?(Ne&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$pf=be;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$qf=Pe;function B(Ae,Ne=1){if(Ne===0)return"";let qe=-1;do qe=Ae.indexOf(`
`,qe+1),Ne--;while(Ne>0&&qe>=0);return qe===-1?Ae:(Ae[qe-1]==="\r"&&qe--,Ae.substr(0,qe))}e.$rf=B;function J(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$sf=J;function ie(Ae){return ge.getInstance().getGraphemeBreakType(Ae)}e.$tf=ie;function se(Ae,Ne){return Ae===0?Ne!==5&&Ne!==7:Ae===2&&Ne===3?!1:Ae===4||Ae===2||Ae===3||Ne===4||Ne===2||Ne===3?!0:!(Ae===8&&(Ne===8||Ne===9||Ne===11||Ne===12)||(Ae===11||Ae===9)&&(Ne===9||Ne===10)||(Ae===12||Ae===10)&&Ne===10||Ne===5||Ne===13||Ne===7||Ae===1||Ae===13&&Ne===14||Ae===6&&Ne===6)}var Y;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(Y||(e.GraphemeBreakType=Y={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=ye()}getGraphemeBreakType(Ne){if(Ne<32)return Ne===10?3:Ne===13?2:4;if(Ne<127)return 0;const qe=this.d,Le=qe.length/3;let Xe=1;for(;Xe<=Le;)if(Ne<qe[3*Xe])Xe=2*Xe;else if(Ne>qe[3*Xe+1])Xe=2*Xe+1;else return qe[3*Xe+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ae,Ne){if(Ae===0)return 0;const qe=We(Ae,Ne);if(qe!==void 0)return qe;const Le=new V(Ne,Ae);return Le.prevCodePoint(),Le.offset}e.$uf=je;function We(Ae,Ne){const qe=new V(Ne,Ae);let Le=qe.prevCodePoint();for(;_e(Le)||Le===65039||Le===8419;){if(qe.offset===0)return;Le=qe.prevCodePoint()}if(!ee(Le))return;let Xe=qe.offset;return Xe>0&&qe.prevCodePoint()===8205&&(Xe=qe.offset),Xe}function _e(Ae){return 127995<=Ae&&Ae<=127999}var Ye;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$vf="\xA0";class it{static{this.c=new T.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new C.$xe(Ne=>{function qe(xe){const rt=new Map;for(let ot=0;ot<xe.length;ot+=2)rt.set(xe[ot],xe[ot+1]);return rt}function Le(xe,rt){const ot=new Map(xe);for(const[$t,St]of rt)ot.set($t,St);return ot}function Xe(xe,rt){if(!xe)return rt;const ot=new Map;for(const[$t,St]of xe)rt.has($t)&&ot.set($t,St);return ot}const le=this.c.value;let ue=Ne.filter(xe=>!xe.startsWith("_")&&xe in le);ue.length===0&&(ue=["_default"]);let Ie;for(const xe of ue){const rt=qe(le[xe]);Ie=Xe(Ie,rt)}const Ve=qe(le._common),Ue=Le(Ve,Ie);return new it(Ue)})}static getInstance(Ne){return it.d.get(Array.from(Ne))}static{this.e=new T.$V(()=>Object.keys(it.c.value).filter(Ne=>!Ne.startsWith("_")))}static getLocales(){return it.e.value}constructor(Ne){this.f=Ne}isAmbiguous(Ne){return this.f.has(Ne)}getPrimaryConfusable(Ne){return this.f.get(Ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$wf=it;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Ne){return et.e().has(Ne)}static get codePoints(){return et.e()}}e.$xf=et}),define(De[121],Ce([1,0,28,15]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.FuzzyScore=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.or=void 0;function d(...te){return function(he,be){for(let Pe=0,B=te.length;Pe<B;Pe++){const J=te[Pe](he,be);if(J)return J}return null}}e.or=d,e.$Bj=L.bind(void 0,!1),e.$Cj=L.bind(void 0,!0);function L(te,he,be){if(!be||be.length<he.length)return null;let Pe;return te?Pe=T.$3e(be,he):Pe=be.indexOf(he)===0,Pe?he.length>0?[{start:0,end:he.length}]:[]:null}function A(te,he){const be=he.toLowerCase().indexOf(te.toLowerCase());return be===-1?null:[{start:be,end:be+te.length}]}e.$Dj=A;function $(te,he){return E(te.toLowerCase(),he.toLowerCase(),0,0)}e.$Ej=$;function E(te,he,be,Pe){if(be===te.length)return[];if(Pe===he.length)return null;if(te[be]===he[Pe]){let B=null;return(B=E(te,he,be+1,Pe+1))?c({start:Pe,end:Pe+1},B):null}return E(te,he,be,Pe+1)}function v(te){return 97<=te&&te<=122}function R(te){return 65<=te&&te<=90}e.$Fj=R;function I(te){return 48<=te&&te<=57}function w(te){return te===32||te===9||te===10||te===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>y.add(te.charCodeAt(0)));function k(te){return w(te)||y.has(te)}function p(te,he){return te===he||k(te)&&k(he)}function u(te){return v(te)||R(te)||I(te)}function c(te,he){return he.length===0?he=[te]:te.end===he[0].start?he[0].start=te.start:he.unshift(te),he}function r(te,he){for(let be=he;be<te.length;be++){const Pe=te.charCodeAt(be);if(R(Pe)||I(Pe)||be>0&&!u(te.charCodeAt(be-1)))return be}return te.length}function o(te,he,be,Pe){if(be===te.length)return[];if(Pe===he.length)return null;if(te[be]!==he[Pe].toLowerCase())return null;{let B=null,J=Pe+1;for(B=o(te,he,be+1,Pe+1);!B&&(J=r(he,J))<he.length;)B=o(te,he,be+1,J),J++;return B===null?null:c({start:Pe,end:Pe+1},B)}}function m(te){let he=0,be=0,Pe=0,B=0,J=0;for(let ye=0;ye<te.length;ye++)J=te.charCodeAt(ye),R(J)&&he++,v(J)&&be++,u(J)&&Pe++,I(J)&&B++;const ie=he/te.length,se=be/te.length,Y=Pe/te.length,ge=B/te.length;return{upperPercent:ie,lowerPercent:se,alphaPercent:Y,numericPercent:ge}}function h(te){const{upperPercent:he,lowerPercent:be}=te;return be===0&&he>.6}function t(te){const{upperPercent:he,lowerPercent:be,alphaPercent:Pe,numericPercent:B}=te;return be>.2&&he<.8&&Pe>.6&&B<.2}function n(te){let he=0,be=0,Pe=0,B=0;for(let J=0;J<te.length;J++)Pe=te.charCodeAt(J),R(Pe)&&he++,v(Pe)&&be++,w(Pe)&&B++;return(he===0||be===0)&&B===0?te.length<=30:he<=5}function a(te,he){if(!he||(he=he.trim(),he.length===0)||!n(te)||he.length>60)return null;const be=m(he);if(!t(be)){if(!h(be))return null;he=he.toLowerCase()}let Pe=null,B=0;for(te=te.toLowerCase();B<he.length&&(Pe=o(te,he,0,B))===null;)B=r(he,B+1);return Pe}e.$Gj=a;function i(te,he,be=!1){if(!he||he.length===0)return null;let Pe=null,B=0;for(te=te.toLowerCase(),he=he.toLowerCase();B<he.length&&(Pe=s(te,he,0,B,be))===null;)B=l(he,B+1);return Pe}e.$Hj=i;function s(te,he,be,Pe,B){if(be===te.length)return[];if(Pe===he.length)return null;if(p(te.charCodeAt(be),he.charCodeAt(Pe))){let J=null,ie=Pe+1;if(J=s(te,he,be+1,Pe+1,B),!B)for(;!J&&(ie=l(he,ie))<he.length;)J=s(te,he,be+1,ie,B),ie++;return J?te.charCodeAt(be)!==he.charCodeAt(Pe)?J:c({start:Pe,end:Pe+1},J):null}else return null}function l(te,he){for(let be=he;be<te.length;be++)if(k(te.charCodeAt(be))||be>0&&k(te.charCodeAt(be-1)))return be;return te.length}const D=d(e.$Cj,a,A),S=d(e.$Cj,a,$),b=new C.$Dc(1e4);function f(te,he,be=!1){if(typeof te!="string"||typeof he!="string")return null;let Pe=b.get(te);Pe||(Pe=new RegExp(T.$Le(te),"i"),b.set(te,Pe));const B=Pe.exec(he);return B?[{start:B.index,end:B.index+B[0].length}]:be?S(te,he):D(te,he)}e.$Ij=f;function g(te,he){const be=me(te,te.toLowerCase(),0,he,he.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return be?N(be):null}e.$Jj=g;function P(te,he,be,Pe,B,J){const ie=Math.min(13,te.length);for(;be<ie;be++){const se=me(te,he,be,Pe,B,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(se)return se}return[0,J]}e.$Kj=P;function N(te){if(typeof te>"u")return[];const he=[],be=te[1];for(let Pe=te.length-1;Pe>1;Pe--){const B=te[Pe]+be,J=he[he.length-1];J&&J.end===B?J.end=B+1:he.push({start:B,end:B+1})}return he}e.$Lj=N;const O=128;function M(){const te=[],he=[];for(let be=0;be<=O;be++)he[be]=0;for(let be=0;be<=O;be++)te.push(he.slice(0));return te}function j(te){const he=[];for(let be=0;be<=te;be++)he[be]=0;return he}const z=j(2*O),F=j(2*O),K=M(),V=M(),fe=M(),Z=!1;function Q(te,he,be,Pe,B){function J(se,Y,ge=" "){for(;se.length<Y;)se=ge+se;return se}let ie=` |   |${Pe.split("").map(se=>J(se,3)).join("|")}
`;for(let se=0;se<=be;se++)se===0?ie+=" |":ie+=`${he[se-1]}|`,ie+=te[se].slice(0,B+1).map(Y=>J(Y.toString(),3)).join("|")+`
`;return ie}function X(te,he,be,Pe){te=te.substr(he),be=be.substr(Pe),console.log(Q(V,te,te.length,be,be.length)),console.log(Q(fe,te,te.length,be,be.length)),console.log(Q(K,te,te.length,be,be.length))}function oe(te,he){if(he<0||he>=te.length)return!1;const be=te.codePointAt(he);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$if(be)}}function x(te,he){if(he<0||he>=te.length)return!1;switch(te.charCodeAt(he)){case 32:case 9:return!0;default:return!1}}function ae(te,he,be){return he[te]!==be[te]}function we(te,he,be,Pe,B,J,ie=!1){for(;he<be&&B<J;)te[he]===Pe[B]&&(ie&&(z[he]=B),he+=1),B+=1;return he===be}e.$Mj=we;var G;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(G||(G={}));var U;(function(te){te.Default=[-100,0];function he(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}te.isDefault=he})(U||(e.FuzzyScore=U={}));class q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(he,be){this.firstMatchCanBeWeak=he,this.boostFullMatch=be}}e.$Nj=q;function me(te,he,be,Pe,B,J,ie=q.default){const se=te.length>O?O:te.length,Y=Pe.length>O?O:Pe.length;if(be>=se||J>=Y||se-be>Y-J||!we(he,be,se,B,J,Y,!0))return;ee(se,Y,be,J,he,B);let ge=1,ye=1,je=be,We=J;const _e=[!1];for(ge=1,je=be;je<se;ge++,je++){const Ne=z[je],qe=F[je],Le=je+1<se?F[je+1]:Y;for(ye=Ne-J+1,We=Ne;We<Le;ye++,We++){let Xe=Number.MIN_SAFE_INTEGER,le=!1;We<=qe&&(Xe=ne(te,he,je,be,Pe,B,We,Y,J,K[ge-1][ye-1]===0,_e));let ue=0;Xe!==Number.MAX_SAFE_INTEGER&&(le=!0,ue=Xe+V[ge-1][ye-1]);const Ie=We>Ne,Ve=Ie?V[ge][ye-1]+(K[ge][ye-1]>0?-5:0):0,Ue=We>Ne+1&&K[ge][ye-1]>0,xe=Ue?V[ge][ye-2]+(K[ge][ye-2]>0?-5:0):0;if(Ue&&(!Ie||xe>=Ve)&&(!le||xe>=ue))V[ge][ye]=xe,fe[ge][ye]=3,K[ge][ye]=0;else if(Ie&&(!le||Ve>=ue))V[ge][ye]=Ve,fe[ge][ye]=2,K[ge][ye]=0;else if(le)V[ge][ye]=ue,fe[ge][ye]=1,K[ge][ye]=K[ge-1][ye-1]+1;else throw new Error("not possible")}}if(Z&&X(te,be,Pe,J),!_e[0]&&!ie.firstMatchCanBeWeak)return;ge--,ye--;const Ye=[V[ge][ye],J];let it=0,et=0;for(;ge>=1;){let Ne=ye;do{const qe=fe[ge][Ne];if(qe===3)Ne=Ne-2;else if(qe===2)Ne=Ne-1;else break}while(Ne>=1);it>1&&he[be+ge-1]===B[J+ye-1]&&!ae(Ne+J-1,Pe,B)&&it+1>K[ge][Ne]&&(Ne=ye),Ne===ye?it++:it=1,et||(et=Ne),ge--,ye=Ne-1,Ye.push(ye)}Y===se&&ie.boostFullMatch&&(Ye[0]+=2);const Ae=et-se;return Ye[0]-=Ae,Ye}e.$Oj=me;function ee(te,he,be,Pe,B,J){let ie=te-1,se=he-1;for(;ie>=be&&se>=Pe;)B[ie]===J[se]&&(F[ie]=se,ie--),se--}function ne(te,he,be,Pe,B,J,ie,se,Y,ge,ye){if(he[be]!==J[ie])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return ie===be-Pe?je=te[be]===B[ie]?7:5:ae(ie,B,J)&&(ie===0||!ae(ie-1,B,J))?(je=te[be]===B[ie]?7:5,We=!0):oe(J,ie)&&(ie===0||!oe(J,ie-1))?je=5:(oe(J,ie-1)||x(J,ie-1))&&(je=5,We=!0),je>1&&be===Pe&&(ye[0]=!0),We||(We=ae(ie,B,J)||oe(J,ie-1)||x(J,ie-1)),be===Pe?ie>Y&&(je-=We?3:5):ge?je+=We?2:0:je+=We?0:1,ie+1===se&&(je-=We?3:5),je}function re(te,he,be,Pe,B,J,ie){return ce(te,he,be,Pe,B,J,!0,ie)}e.$Pj=re;function Ee(te,he,be,Pe,B,J,ie){return ce(te,he,be,Pe,B,J,!1,ie)}e.$Qj=Ee;function ce(te,he,be,Pe,B,J,ie,se){let Y=me(te,he,be,Pe,B,J,se);if(Y&&!ie)return Y;if(te.length>=3){const ge=Math.min(7,te.length-1);for(let ye=be+1;ye<ge;ye++){const je=de(te,ye);if(je){const We=me(je,je.toLowerCase(),be,Pe,B,J,se);We&&(We[0]-=3,(!Y||We[0]>Y[0])&&(Y=We))}}}return Y}function de(te,he){if(he+1>=te.length)return;const be=te[he],Pe=te[he+1];if(be!==Pe)return te.slice(0,he)+Pe+be+te.slice(he+2)}}),define(De[52],Ce([1,0,15]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;function T(c){return d(c,0)}e.$Ci=T;function d(c,r){switch(typeof c){case"object":return c===null?L(349,r):Array.isArray(c)?E(c,r):v(c,r);case"string":return $(c,r);case"boolean":return A(c,r);case"number":return L(c,r);case"undefined":return L(937,r);default:return L(617,r)}}e.$Di=d;function L(c,r){return(r<<5)-r+c|0}e.$Ei=L;function A(c,r){return L(c?433:863,r)}function $(c,r){r=L(149417,r);for(let o=0,m=c.length;o<m;o++)r=L(c.charCodeAt(o),r);return r}e.$Fi=$;function E(c,r){return r=L(104579,r),c.reduce((o,m)=>d(m,o),r)}function v(c,r){return r=L(181387,r),Object.keys(c).sort().reduce((o,m)=>(o=$(m,o),d(c[m],o)),r)}class R{constructor(){this.g=0}get value(){return this.g}hash(r){return this.g=d(r,this.g),this.g}}e.$Gi=R;var I;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function w(c,r,o=32){const m=o-r,h=~((1<<m)-1);return(c<<r|(h&c)>>>m)>>>0}function y(c,r=0,o=c.byteLength,m=0){for(let h=0;h<o;h++)c[r+h]=m}function k(c,r,o="0"){for(;c.length<r;)c=o+c;return c}function p(c,r=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(o=>o.toString(16).padStart(2,"0")).join(""):k((c>>>0).toString(16),r/4)}e.$Hi=p;class u{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(r){const o=r.length;if(o===0)return;const m=this.p;let h=this.r,t=this.u,n,a;for(t!==0?(n=t,a=-1,t=0):(n=r.charCodeAt(0),a=0);;){let i=n;if(C.$6e(n))if(a+1<o){const s=r.charCodeAt(a+1);C.$7e(s)?(a++,i=C.$8e(n,s)):i=65533}else{t=n;break}else C.$7e(n)&&(i=65533);if(h=this.w(m,h,i),a++,a<o)n=r.charCodeAt(a);else break}this.r=h,this.u=t}w(r,o,m){return m<128?r[o++]=m:m<2048?(r[o++]=192|(m&1984)>>>6,r[o++]=128|(m&63)>>>0):m<65536?(r[o++]=224|(m&61440)>>>12,r[o++]=128|(m&4032)>>>6,r[o++]=128|(m&63)>>>0):(r[o++]=240|(m&1835008)>>>18,r[o++]=128|(m&258048)>>>12,r[o++]=128|(m&4032)>>>6,r[o++]=128|(m&63)>>>0),o>=64&&(this.y(),o-=64,this.t+=64,r[0]=r[64+0],r[1]=r[64+1],r[2]=r[64+2]),o}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const r=8*this.t;this.q.setUint32(56,Math.floor(r/4294967296),!1),this.q.setUint32(60,r%4294967296,!1),this.y()}y(){const r=u.g,o=this.q;for(let D=0;D<64;D+=4)r.setUint32(D,o.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)r.setUint32(D,w(r.getUint32(D-12,!1)^r.getUint32(D-32,!1)^r.getUint32(D-56,!1)^r.getUint32(D-64,!1),1),!1);let m=this.h,h=this.l,t=this.m,n=this.n,a=this.o,i,s,l;for(let D=0;D<80;D++)D<20?(i=h&t|~h&n,s=1518500249):D<40?(i=h^t^n,s=1859775393):D<60?(i=h&t|h&n|t&n,s=2400959708):(i=h^t^n,s=3395469782),l=w(m,5)+i+a+s+r.getUint32(D*4,!1)&4294967295,a=n,n=t,t=w(h,30),h=m,m=l;this.h=this.h+m&4294967295,this.l=this.l+h&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+a&4294967295}}e.$Ii=u}),define(De[38],Ce([1,0,15]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(d){d[d.Ignore=0]="Ignore",d[d.Info=1]="Info",d[d.Warning=2]="Warning",d[d.Error=3]="Error"})(T||(T={})),function(d){const L="error",A="warning",$="warn",E="info",v="ignore";function R(w){return w?C.$2e(L,w)?d.Error:C.$2e(A,w)||C.$2e($,w)?d.Warning:C.$2e(E,w)?d.Info:d.Ignore:d.Ignore}d.fromValue=R;function I(w){switch(w){case d.Error:return L;case d.Warning:return A;case d.Info:return E;default:return v}}d.toString=I}(T||(T={})),e.default=T}),define(De[160],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(De[78],Ce([1,0,19,15]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=void 0;class d{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const k=y.charCodeAt(0),p=this.b.charCodeAt(this.c);return k-p}value(){return this.b[this.c]}}e.$Qh=d;class L{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,T.$Ve)(y,this.b,0,y.length,this.c,this.d):(0,T.$Xe)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Rh=L;class A{constructor(y=!0,k=!0){this.f=y,this.g=k}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let k=y.length-1;k>=0;k--,this.c--){const p=this.b.charCodeAt(k);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const k=this.b.charCodeAt(this.e);if(k===47||this.f&&k===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,T.$Ve)(y,this.b,0,y.length,this.d,this.e):(0,T.$Xe)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Sh=A;var $;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})($||($={}));class E{constructor(y,k){this.f=y,this.g=k,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,T.$We)(y,this.c.scheme);if(this.d[this.e]===2)return(0,T.$We)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,T.$Ue)(y,this.c.query);if(this.d[this.e]===5)return(0,T.$Ue)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Th=E;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(R||(R={}));class I{static forUris(y=()=>!1,k=()=>!1){return new I(new E(y,k))}static forPaths(y=!1){return new I(new A(void 0,!y))}static forStrings(){return new I(new d)}static forConfigKeys(){return new I(new L)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,k){if(k){const p=k.slice(0);(0,C.$Xb)(p);for(const u of p)this.set(u,y)}else{const p=y.slice(0);(0,C.$Xb)(p);for(const u of p)this.set(u[0],u[1])}}set(y,k){const p=this.b.reset(y);let u;this.c||(this.c=new v,this.c.segment=p.value());const c=[];for(u=this.c;;){const o=p.cmp(u.segment);if(o>0)u.left||(u.left=new v,u.left.segment=p.value()),c.push([-1,u]),u=u.left;else if(o<0)u.right||(u.right=new v,u.right.segment=p.value()),c.push([1,u]),u=u.right;else if(p.hasNext())p.next(),u.mid||(u.mid=new v,u.mid.segment=p.value()),c.push([0,u]),u=u.mid;else break}const r=u.value;u.value=k,u.key=y;for(let o=c.length-1;o>=0;o--){const m=c[o][1];m.updateHeight();const h=m.balanceFactor();if(h<-1||h>1){const t=c[o][0],n=c[o+1][0];if(t===1&&n===1)c[o][1]=m.rotateLeft();else if(t===-1&&n===-1)c[o][1]=m.rotateRight();else if(t===1&&n===-1)m.right=c[o+1][1]=c[o+1][1].rotateRight(),c[o][1]=m.rotateLeft();else if(t===-1&&n===1)m.left=c[o+1][1]=c[o+1][1].rotateLeft(),c[o][1]=m.rotateRight();else throw new Error;if(o>0)switch(c[o-1][0]){case-1:c[o-1][1].left=c[o][1];break;case 1:c[o-1][1].right=c[o][1];break;case 0:c[o-1][1].mid=c[o][1];break}else this.c=c[0][1]}}return r}get(y){return this.d(y)?.value}d(y){const k=this.b.reset(y);let p=this.c;for(;p;){const u=k.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(k.hasNext())k.next(),p=p.mid;else break}return p}has(y){const k=this.d(y);return!(k?.value===void 0&&k?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,k){const p=this.b.reset(y),u=[];let c=this.c;for(;c;){const r=p.cmp(c.segment);if(r>0)u.push([-1,c]),c=c.left;else if(r<0)u.push([1,c]),c=c.right;else if(p.hasNext())p.next(),u.push([0,c]),c=c.mid;else break}if(c){if(k?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const r=this.f(c.right);if(r.key){const{key:o,value:m,segment:h}=r;this.e(r.key,!1),c.key=o,c.value=m,c.segment=h}}else{const r=c.left??c.right;if(u.length>0){const[o,m]=u[u.length-1];switch(o){case-1:m.left=r;break;case 0:m.mid=r;break;case 1:m.right=r;break}}else this.c=r}for(let r=u.length-1;r>=0;r--){const o=u[r][1];o.updateHeight();const m=o.balanceFactor();if(m>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),u[r][1]=o.rotateLeft()):m<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),u[r][1]=o.rotateRight()),r>0)switch(u[r-1][0]){case-1:u[r-1][1].left=u[r][1];break;case 1:u[r-1][1].right=u[r][1];break;case 0:u[r-1][1].mid=u[r][1];break}else this.c=u[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const k=this.b.reset(y);let p=this.c,u;for(;p;){const c=k.cmp(p.segment);if(c>0)p=p.left;else if(c<0)p=p.right;else if(k.hasNext())k.next(),u=p.value||u,p=p.mid;else break}return p&&p.value||u}findSuperstr(y){return this.g(y,!1)}g(y,k){const p=this.b.reset(y);let u=this.c;for(;u;){const c=p.cmp(u.segment);if(c>0)u=u.left;else if(c<0)u=u.right;else if(p.hasNext())p.next(),u=u.mid;else return u.mid?this.h(u.mid):k?u.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[k,p]of this)y(p,k)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const k=[];return this.j(y,k),k[Symbol.iterator]()}j(y,k){y&&(y.left&&this.j(y.left,k),y.value&&k.push([y.key,y.value]),y.mid&&this.j(y.mid,k),y.right&&this.j(y.right,k))}_isBalanced(){const y=k=>{if(!k)return!0;const p=k.balanceFactor();return p<-1||p>1?!1:y(k.left)&&y(k.right)};return y(this.c)}}e.$Uh=I}),define(De[17],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=void 0;function C(h){return typeof h=="string"}e.$yf=C;function T(h){return Array.isArray(h)&&h.every(t=>C(t))}e.$zf=T;function d(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.$Af=d;function L(h){const t=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof t}e.$Bf=L;function A(h){return typeof h=="number"&&!isNaN(h)}e.$Cf=A;function $(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.$Df=$;function E(h){return h===!0||h===!1}e.$Ef=E;function v(h){return typeof h>"u"}e.$Ff=v;function R(h){return!I(h)}e.$Gf=R;function I(h){return v(h)||h===null}e.$Hf=I;function w(h,t){if(!h)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$If=w;function y(h){if(I(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.$Jf=y;function k(...h){const t=[];for(let n=0;n<h.length;n++){const a=h[n];if(I(a))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(a)}return t}e.$Kf=k;const p=Object.prototype.hasOwnProperty;function u(h){if(!d(h))return!1;for(const t in h)if(p.call(h,t))return!1;return!0}e.$Lf=u;function c(h){return typeof h=="function"}e.$Mf=c;function r(...h){return h.length>0&&h.every(c)}e.$Nf=r;function o(h,t){const n=Math.min(h.length,t.length);for(let a=0;a<n;a++)m(h[a],t[a])}e.$Of=o;function m(h,t){if(C(t)){if(typeof h!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(c(t)){try{if(h instanceof t)return}catch{}if(!I(h)&&h.constructor===t||t.length===1&&t.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Pf=m}),define(De[79],Ce([1,0,17]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tj=e.$Sj=e.$Rj=void 0;const T=Object.create(null);function d($,E){if((0,C.$yf)(E)){const v=T[E];if(v===void 0)throw new Error(`${$} references an unknown codicon: ${E}`);E=v}return T[$]=E,{id:$}}function L(){return T}e.$Rj=L;function A(){return Object.values(e.$Tj)}e.$Sj=A,e.$Tj={add:d("add",6e4),plus:d("plus",6e4),gistNew:d("gist-new",6e4),repoCreate:d("repo-create",6e4),lightbulb:d("lightbulb",60001),lightBulb:d("light-bulb",60001),repo:d("repo",60002),repoDelete:d("repo-delete",60002),gistFork:d("gist-fork",60003),repoForked:d("repo-forked",60003),gitPullRequest:d("git-pull-request",60004),gitPullRequestAbandoned:d("git-pull-request-abandoned",60004),recordKeys:d("record-keys",60005),keyboard:d("keyboard",60005),tag:d("tag",60006),tagAdd:d("tag-add",60006),tagRemove:d("tag-remove",60006),gitPullRequestLabel:d("git-pull-request-label",60006),person:d("person",60007),personFollow:d("person-follow",60007),personOutline:d("person-outline",60007),personFilled:d("person-filled",60007),gitBranch:d("git-branch",60008),gitBranchCreate:d("git-branch-create",60008),gitBranchDelete:d("git-branch-delete",60008),sourceControl:d("source-control",60008),mirror:d("mirror",60009),mirrorPublic:d("mirror-public",60009),star:d("star",60010),starAdd:d("star-add",60010),starDelete:d("star-delete",60010),starEmpty:d("star-empty",60010),comment:d("comment",60011),commentAdd:d("comment-add",60011),alert:d("alert",60012),warning:d("warning",60012),search:d("search",60013),searchSave:d("search-save",60013),logOut:d("log-out",60014),signOut:d("sign-out",60014),logIn:d("log-in",60015),signIn:d("sign-in",60015),eye:d("eye",60016),eyeUnwatch:d("eye-unwatch",60016),eyeWatch:d("eye-watch",60016),circleFilled:d("circle-filled",60017),primitiveDot:d("primitive-dot",60017),closeDirty:d("close-dirty",60017),debugBreakpoint:d("debug-breakpoint",60017),debugBreakpointDisabled:d("debug-breakpoint-disabled",60017),debugHint:d("debug-hint",60017),primitiveSquare:d("primitive-square",60018),edit:d("edit",60019),pencil:d("pencil",60019),info:d("info",60020),issueOpened:d("issue-opened",60020),gistPrivate:d("gist-private",60021),gitForkPrivate:d("git-fork-private",60021),lock:d("lock",60021),mirrorPrivate:d("mirror-private",60021),close:d("close",60022),removeClose:d("remove-close",60022),x:d("x",60022),repoSync:d("repo-sync",60023),sync:d("sync",60023),clone:d("clone",60024),desktopDownload:d("desktop-download",60024),beaker:d("beaker",60025),microscope:d("microscope",60025),vm:d("vm",60026),deviceDesktop:d("device-desktop",60026),file:d("file",60027),fileText:d("file-text",60027),more:d("more",60028),ellipsis:d("ellipsis",60028),kebabHorizontal:d("kebab-horizontal",60028),mailReply:d("mail-reply",60029),reply:d("reply",60029),organization:d("organization",60030),organizationFilled:d("organization-filled",60030),organizationOutline:d("organization-outline",60030),newFile:d("new-file",60031),fileAdd:d("file-add",60031),newFolder:d("new-folder",60032),fileDirectoryCreate:d("file-directory-create",60032),trash:d("trash",60033),trashcan:d("trashcan",60033),history:d("history",60034),clock:d("clock",60034),folder:d("folder",60035),fileDirectory:d("file-directory",60035),symbolFolder:d("symbol-folder",60035),logoGithub:d("logo-github",60036),markGithub:d("mark-github",60036),github:d("github",60036),terminal:d("terminal",60037),console:d("console",60037),repl:d("repl",60037),zap:d("zap",60038),symbolEvent:d("symbol-event",60038),error:d("error",60039),stop:d("stop",60039),variable:d("variable",60040),symbolVariable:d("symbol-variable",60040),array:d("array",60042),symbolArray:d("symbol-array",60042),symbolModule:d("symbol-module",60043),symbolPackage:d("symbol-package",60043),symbolNamespace:d("symbol-namespace",60043),symbolObject:d("symbol-object",60043),symbolMethod:d("symbol-method",60044),symbolFunction:d("symbol-function",60044),symbolConstructor:d("symbol-constructor",60044),symbolBoolean:d("symbol-boolean",60047),symbolNull:d("symbol-null",60047),symbolNumeric:d("symbol-numeric",60048),symbolNumber:d("symbol-number",60048),symbolStructure:d("symbol-structure",60049),symbolStruct:d("symbol-struct",60049),symbolParameter:d("symbol-parameter",60050),symbolTypeParameter:d("symbol-type-parameter",60050),symbolKey:d("symbol-key",60051),symbolText:d("symbol-text",60051),symbolReference:d("symbol-reference",60052),goToFile:d("go-to-file",60052),symbolEnum:d("symbol-enum",60053),symbolValue:d("symbol-value",60053),symbolRuler:d("symbol-ruler",60054),symbolUnit:d("symbol-unit",60054),activateBreakpoints:d("activate-breakpoints",60055),archive:d("archive",60056),arrowBoth:d("arrow-both",60057),arrowDown:d("arrow-down",60058),arrowLeft:d("arrow-left",60059),arrowRight:d("arrow-right",60060),arrowSmallDown:d("arrow-small-down",60061),arrowSmallLeft:d("arrow-small-left",60062),arrowSmallRight:d("arrow-small-right",60063),arrowSmallUp:d("arrow-small-up",60064),arrowUp:d("arrow-up",60065),bell:d("bell",60066),bold:d("bold",60067),book:d("book",60068),bookmark:d("bookmark",60069),debugBreakpointConditionalUnverified:d("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:d("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:d("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:d("debug-breakpoint-data-unverified",60072),debugBreakpointData:d("debug-breakpoint-data",60073),debugBreakpointDataDisabled:d("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:d("debug-breakpoint-log-unverified",60074),debugBreakpointLog:d("debug-breakpoint-log",60075),debugBreakpointLogDisabled:d("debug-breakpoint-log-disabled",60075),briefcase:d("briefcase",60076),broadcast:d("broadcast",60077),browser:d("browser",60078),bug:d("bug",60079),calendar:d("calendar",60080),caseSensitive:d("case-sensitive",60081),check:d("check",60082),checklist:d("checklist",60083),chevronDown:d("chevron-down",60084),dropDownButton:d("drop-down-button",60084),chevronLeft:d("chevron-left",60085),chevronRight:d("chevron-right",60086),chevronUp:d("chevron-up",60087),chromeClose:d("chrome-close",60088),chromeMaximize:d("chrome-maximize",60089),chromeMinimize:d("chrome-minimize",60090),chromeRestore:d("chrome-restore",60091),circle:d("circle",60092),circleOutline:d("circle-outline",60092),debugBreakpointUnverified:d("debug-breakpoint-unverified",60092),circleSlash:d("circle-slash",60093),circuitBoard:d("circuit-board",60094),clearAll:d("clear-all",60095),clippy:d("clippy",60096),closeAll:d("close-all",60097),cloudDownload:d("cloud-download",60098),cloudUpload:d("cloud-upload",60099),code:d("code",60100),collapseAll:d("collapse-all",60101),colorMode:d("color-mode",60102),commentDiscussion:d("comment-discussion",60103),compareChanges:d("compare-changes",60157),creditCard:d("credit-card",60105),dash:d("dash",60108),dashboard:d("dashboard",60109),database:d("database",60110),debugContinue:d("debug-continue",60111),debugDisconnect:d("debug-disconnect",60112),debugPause:d("debug-pause",60113),debugRestart:d("debug-restart",60114),debugStart:d("debug-start",60115),debugStepInto:d("debug-step-into",60116),debugStepOut:d("debug-step-out",60117),debugStepOver:d("debug-step-over",60118),debugStop:d("debug-stop",60119),debug:d("debug",60120),deviceCameraVideo:d("device-camera-video",60121),deviceCamera:d("device-camera",60122),deviceMobile:d("device-mobile",60123),diffAdded:d("diff-added",60124),diffIgnored:d("diff-ignored",60125),diffModified:d("diff-modified",60126),diffRemoved:d("diff-removed",60127),diffRenamed:d("diff-renamed",60128),diff:d("diff",60129),discard:d("discard",60130),editorLayout:d("editor-layout",60131),emptyWindow:d("empty-window",60132),exclude:d("exclude",60133),extensions:d("extensions",60134),eyeClosed:d("eye-closed",60135),fileBinary:d("file-binary",60136),fileCode:d("file-code",60137),fileMedia:d("file-media",60138),filePdf:d("file-pdf",60139),fileSubmodule:d("file-submodule",60140),fileSymlinkDirectory:d("file-symlink-directory",60141),fileSymlinkFile:d("file-symlink-file",60142),fileZip:d("file-zip",60143),files:d("files",60144),filter:d("filter",60145),flame:d("flame",60146),foldDown:d("fold-down",60147),foldUp:d("fold-up",60148),fold:d("fold",60149),folderActive:d("folder-active",60150),folderOpened:d("folder-opened",60151),gear:d("gear",60152),gift:d("gift",60153),gistSecret:d("gist-secret",60154),gist:d("gist",60155),gitCommit:d("git-commit",60156),gitCompare:d("git-compare",60157),gitMerge:d("git-merge",60158),githubAction:d("github-action",60159),githubAlt:d("github-alt",60160),globe:d("globe",60161),grabber:d("grabber",60162),graph:d("graph",60163),gripper:d("gripper",60164),heart:d("heart",60165),home:d("home",60166),horizontalRule:d("horizontal-rule",60167),hubot:d("hubot",60168),inbox:d("inbox",60169),issueClosed:d("issue-closed",60324),issueReopened:d("issue-reopened",60171),issues:d("issues",60172),italic:d("italic",60173),jersey:d("jersey",60174),json:d("json",60175),bracket:d("bracket",60175),kebabVertical:d("kebab-vertical",60176),key:d("key",60177),law:d("law",60178),lightbulbAutofix:d("lightbulb-autofix",60179),linkExternal:d("link-external",60180),link:d("link",60181),listOrdered:d("list-ordered",60182),listUnordered:d("list-unordered",60183),liveShare:d("live-share",60184),loading:d("loading",60185),location:d("location",60186),mailRead:d("mail-read",60187),mail:d("mail",60188),markdown:d("markdown",60189),megaphone:d("megaphone",60190),mention:d("mention",60191),milestone:d("milestone",60192),gitPullRequestMilestone:d("git-pull-request-milestone",60192),mortarBoard:d("mortar-board",60193),move:d("move",60194),multipleWindows:d("multiple-windows",60195),mute:d("mute",60196),noNewline:d("no-newline",60197),note:d("note",60198),octoface:d("octoface",60199),openPreview:d("open-preview",60200),package:d("package",60201),paintcan:d("paintcan",60202),pin:d("pin",60203),play:d("play",60204),run:d("run",60204),plug:d("plug",60205),preserveCase:d("preserve-case",60206),preview:d("preview",60207),project:d("project",60208),pulse:d("pulse",60209),question:d("question",60210),quote:d("quote",60211),radioTower:d("radio-tower",60212),reactions:d("reactions",60213),references:d("references",60214),refresh:d("refresh",60215),regex:d("regex",60216),remoteExplorer:d("remote-explorer",60217),remote:d("remote",60218),remove:d("remove",60219),replaceAll:d("replace-all",60220),replace:d("replace",60221),repoClone:d("repo-clone",60222),repoForcePush:d("repo-force-push",60223),repoPull:d("repo-pull",60224),repoPush:d("repo-push",60225),report:d("report",60226),requestChanges:d("request-changes",60227),rocket:d("rocket",60228),rootFolderOpened:d("root-folder-opened",60229),rootFolder:d("root-folder",60230),rss:d("rss",60231),ruby:d("ruby",60232),saveAll:d("save-all",60233),saveAs:d("save-as",60234),save:d("save",60235),screenFull:d("screen-full",60236),screenNormal:d("screen-normal",60237),searchStop:d("search-stop",60238),server:d("server",60240),settingsGear:d("settings-gear",60241),settings:d("settings",60242),shield:d("shield",60243),smiley:d("smiley",60244),sortPrecedence:d("sort-precedence",60245),splitHorizontal:d("split-horizontal",60246),splitVertical:d("split-vertical",60247),squirrel:d("squirrel",60248),starFull:d("star-full",60249),starHalf:d("star-half",60250),symbolClass:d("symbol-class",60251),symbolColor:d("symbol-color",60252),symbolCustomColor:d("symbol-customcolor",60252),symbolConstant:d("symbol-constant",60253),symbolEnumMember:d("symbol-enum-member",60254),symbolField:d("symbol-field",60255),symbolFile:d("symbol-file",60256),symbolInterface:d("symbol-interface",60257),symbolKeyword:d("symbol-keyword",60258),symbolMisc:d("symbol-misc",60259),symbolOperator:d("symbol-operator",60260),symbolProperty:d("symbol-property",60261),wrench:d("wrench",60261),wrenchSubaction:d("wrench-subaction",60261),symbolSnippet:d("symbol-snippet",60262),tasklist:d("tasklist",60263),telescope:d("telescope",60264),textSize:d("text-size",60265),threeBars:d("three-bars",60266),thumbsdown:d("thumbsdown",60267),thumbsup:d("thumbsup",60268),tools:d("tools",60269),triangleDown:d("triangle-down",60270),triangleLeft:d("triangle-left",60271),triangleRight:d("triangle-right",60272),triangleUp:d("triangle-up",60273),twitter:d("twitter",60274),unfold:d("unfold",60275),unlock:d("unlock",60276),unmute:d("unmute",60277),unverified:d("unverified",60278),verified:d("verified",60279),versions:d("versions",60280),vmActive:d("vm-active",60281),vmOutline:d("vm-outline",60282),vmRunning:d("vm-running",60283),watch:d("watch",60284),whitespace:d("whitespace",60285),wholeWord:d("whole-word",60286),window:d("window",60287),wordWrap:d("word-wrap",60288),zoomIn:d("zoom-in",60289),zoomOut:d("zoom-out",60290),listFilter:d("list-filter",60291),listFlat:d("list-flat",60292),listSelection:d("list-selection",60293),selection:d("selection",60293),listTree:d("list-tree",60294),debugBreakpointFunctionUnverified:d("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:d("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:d("debug-breakpoint-function-disabled",60296),debugStackframeActive:d("debug-stackframe-active",60297),circleSmallFilled:d("circle-small-filled",60298),debugStackframeDot:d("debug-stackframe-dot",60298),debugStackframe:d("debug-stackframe",60299),debugStackframeFocused:d("debug-stackframe-focused",60299),debugBreakpointUnsupported:d("debug-breakpoint-unsupported",60300),symbolString:d("symbol-string",60301),debugReverseContinue:d("debug-reverse-continue",60302),debugStepBack:d("debug-step-back",60303),debugRestartFrame:d("debug-restart-frame",60304),callIncoming:d("call-incoming",60306),callOutgoing:d("call-outgoing",60307),menu:d("menu",60308),expandAll:d("expand-all",60309),feedback:d("feedback",60310),gitPullRequestReviewer:d("git-pull-request-reviewer",60310),groupByRefType:d("group-by-ref-type",60311),ungroupByRefType:d("ungroup-by-ref-type",60312),account:d("account",60313),gitPullRequestAssignee:d("git-pull-request-assignee",60313),bellDot:d("bell-dot",60314),debugConsole:d("debug-console",60315),library:d("library",60316),output:d("output",60317),runAll:d("run-all",60318),syncIgnored:d("sync-ignored",60319),pinned:d("pinned",60320),githubInverted:d("github-inverted",60321),debugAlt:d("debug-alt",60305),serverProcess:d("server-process",60322),serverEnvironment:d("server-environment",60323),pass:d("pass",60324),stopCircle:d("stop-circle",60325),playCircle:d("play-circle",60326),record:d("record",60327),debugAltSmall:d("debug-alt-small",60328),vmConnect:d("vm-connect",60329),cloud:d("cloud",60330),merge:d("merge",60331),exportIcon:d("export",60332),graphLeft:d("graph-left",60333),magnet:d("magnet",60334),notebook:d("notebook",60335),redo:d("redo",60336),checkAll:d("check-all",60337),pinnedDirty:d("pinned-dirty",60338),passFilled:d("pass-filled",60339),circleLargeFilled:d("circle-large-filled",60340),circleLarge:d("circle-large",60341),circleLargeOutline:d("circle-large-outline",60341),combine:d("combine",60342),gather:d("gather",60342),table:d("table",60343),variableGroup:d("variable-group",60344),typeHierarchy:d("type-hierarchy",60345),typeHierarchySub:d("type-hierarchy-sub",60346),typeHierarchySuper:d("type-hierarchy-super",60347),gitPullRequestCreate:d("git-pull-request-create",60348),runAbove:d("run-above",60349),runBelow:d("run-below",60350),notebookTemplate:d("notebook-template",60351),debugRerun:d("debug-rerun",60352),workspaceTrusted:d("workspace-trusted",60353),workspaceUntrusted:d("workspace-untrusted",60354),workspaceUnspecified:d("workspace-unspecified",60355),terminalCmd:d("terminal-cmd",60356),terminalDebian:d("terminal-debian",60357),terminalLinux:d("terminal-linux",60358),terminalPowershell:d("terminal-powershell",60359),terminalTmux:d("terminal-tmux",60360),terminalUbuntu:d("terminal-ubuntu",60361),terminalBash:d("terminal-bash",60362),arrowSwap:d("arrow-swap",60363),copy:d("copy",60364),personAdd:d("person-add",60365),filterFilled:d("filter-filled",60366),wand:d("wand",60367),debugLineByLine:d("debug-line-by-line",60368),inspect:d("inspect",60369),layers:d("layers",60370),layersDot:d("layers-dot",60371),layersActive:d("layers-active",60372),compass:d("compass",60373),compassDot:d("compass-dot",60374),compassActive:d("compass-active",60375),azure:d("azure",60376),issueDraft:d("issue-draft",60377),gitPullRequestClosed:d("git-pull-request-closed",60378),gitPullRequestDraft:d("git-pull-request-draft",60379),debugAll:d("debug-all",60380),debugCoverage:d("debug-coverage",60381),runErrors:d("run-errors",60382),folderLibrary:d("folder-library",60383),debugContinueSmall:d("debug-continue-small",60384),beakerStop:d("beaker-stop",60385),graphLine:d("graph-line",60386),graphScatter:d("graph-scatter",60387),pieChart:d("pie-chart",60388),bracketDot:d("bracket-dot",60389),bracketError:d("bracket-error",60390),lockSmall:d("lock-small",60391),azureDevops:d("azure-devops",60392),verifiedFilled:d("verified-filled",60393),newLine:d("newline",60394),layout:d("layout",60395),layoutActivitybarLeft:d("layout-activitybar-left",60396),layoutActivitybarRight:d("layout-activitybar-right",60397),layoutPanelLeft:d("layout-panel-left",60398),layoutPanelCenter:d("layout-panel-center",60399),layoutPanelJustify:d("layout-panel-justify",60400),layoutPanelRight:d("layout-panel-right",60401),layoutPanel:d("layout-panel",60402),layoutSidebarLeft:d("layout-sidebar-left",60403),layoutSidebarRight:d("layout-sidebar-right",60404),layoutStatusbar:d("layout-statusbar",60405),layoutMenubar:d("layout-menubar",60406),layoutCentered:d("layout-centered",60407),layoutSidebarRightOff:d("layout-sidebar-right-off",60416),layoutPanelOff:d("layout-panel-off",60417),layoutSidebarLeftOff:d("layout-sidebar-left-off",60418),target:d("target",60408),indent:d("indent",60409),recordSmall:d("record-small",60410),errorSmall:d("error-small",60411),arrowCircleDown:d("arrow-circle-down",60412),arrowCircleLeft:d("arrow-circle-left",60413),arrowCircleRight:d("arrow-circle-right",60414),arrowCircleUp:d("arrow-circle-up",60415),heartFilled:d("heart-filled",60420),map:d("map",60421),mapFilled:d("map-filled",60422),circleSmall:d("circle-small",60423),bellSlash:d("bell-slash",60424),bellSlashDot:d("bell-slash-dot",60425),commentUnresolved:d("comment-unresolved",60426),gitPullRequestGoToChanges:d("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:d("git-pull-request-new-changes",60428),searchFuzzy:d("search-fuzzy",60429),commentDraft:d("comment-draft",60430),send:d("send",60431),sparkle:d("sparkle",60432),insert:d("insert",60433),mic:d("mic",60434),dialogError:d("dialog-error","error"),dialogWarning:d("dialog-warning","warning"),dialogInfo:d("dialog-info","info"),dialogClose:d("dialog-close","close"),treeItemExpanded:d("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:d("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:d("tree-filter-on-type-off","list-selection"),treeFilterClear:d("tree-filter-clear","close"),treeItemLoading:d("tree-item-loading","loading"),menuSelection:d("menu-selection","check"),menuSubmenu:d("menu-submenu","chevron-right"),menuBarMore:d("menubar-more","more"),scrollbarButtonLeft:d("scrollbar-button-left","triangle-left"),scrollbarButtonRight:d("scrollbar-button-right","triangle-right"),scrollbarButtonUp:d("scrollbar-button-up","triangle-up"),scrollbarButtonDown:d("scrollbar-button-down","triangle-down"),toolBarMore:d("toolbar-more","more"),quickInputBack:d("quick-input-back","arrow-left")}}),define(De[24],Ce([1,0,17]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=void 0;function T(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const r=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([o,m])=>{r[o]=m&&typeof m=="object"?T(m):m}),r}e.$4m=T;function d(c){if(!c||typeof c!="object")return c;const r=[c];for(;r.length>0;){const o=r.shift();Object.freeze(o);for(const m in o)if(L.call(o,m)){const h=o[m];typeof h=="object"&&!Object.isFrozen(h)&&!(0,C.$Bf)(h)&&r.push(h)}}return c}e.$5m=d;const L=Object.prototype.hasOwnProperty;function A(c,r){return $(c,r,new Set)}e.$6m=A;function $(c,r,o){if((0,C.$Hf)(c))return c;const m=r(c);if(typeof m<"u")return m;if(Array.isArray(c)){const h=[];for(const t of c)h.push($(t,r,o));return h}if((0,C.$Af)(c)){if(o.has(c))throw new Error("Cannot clone recursive data-structure");o.add(c);const h={};for(const t in c)L.call(c,t)&&(h[t]=$(c[t],r,o));return o.delete(c),h}return c}function E(c,r,o=!0){return(0,C.$Af)(c)?((0,C.$Af)(r)&&Object.keys(r).forEach(m=>{m in c?o&&((0,C.$Af)(c[m])&&(0,C.$Af)(r[m])?E(c[m],r[m],o):c[m]=r[m]):c[m]=r[m]}),c):r}e.$7m=E;function v(c,r){if(c===r)return!0;if(c==null||r===null||r===void 0||typeof c!=typeof r||typeof c!="object"||Array.isArray(c)!==Array.isArray(r))return!1;let o,m;if(Array.isArray(c)){if(c.length!==r.length)return!1;for(o=0;o<c.length;o++)if(!v(c[o],r[o]))return!1}else{const h=[];for(m in c)h.push(m);h.sort();const t=[];for(m in r)t.push(m);if(t.sort(),!v(h,t))return!1;for(o=0;o<h.length;o++)if(!v(c[h[o]],r[h[o]]))return!1}return!0}e.$8m=v;function R(c){const r=new Set;return JSON.stringify(c,(o,m)=>{if((0,C.$Af)(m)||Array.isArray(m)){if(r.has(m))return"[Circular]";r.add(m)}return m})}e.$9m=R;function I(c,r){const o=Object.create(null);return!c||!r||Object.keys(r).forEach(h=>{const t=c[h],n=r[h];v(t,n)||(o[h]=n)}),o}e.$0m=I;function w(c,r){const o=r.toLowerCase(),m=Object.keys(c).find(h=>h.toLowerCase()===o);return m?c[m]:c[r]}e.$$m=w;function y(c,r){const o=Object.create(null);for(const[m,h]of Object.entries(c))r(m,h)&&(o[m]=h);return o}e.$_m=y;function k(c){let r=[];for(;Object.prototype!==c;)r=r.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return r}e.$an=k;function p(c){const r=[];for(const o of k(c))typeof c[o]=="function"&&r.push(o);return r}e.$bn=p;function u(c,r){const o=h=>function(){const t=Array.prototype.slice.call(arguments,0);return r(h,t)},m={};for(const h of c)m[h]=o(h);return m}e.$cn=u}),define(De[59],Ce([1,0,79]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Uj=e.ThemeColor=void 0;var T;(function(A){function $(E){return E&&typeof E=="object"&&typeof E.id=="string"}A.isThemeColor=$})(T||(e.ThemeColor=T={}));function d(A){return{id:A}}e.$Uj=d;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(r){const o=$.exec(r.id);if(!o)return E(C.$Tj.error);const[,m,h]=o,t=["codicon","codicon-"+m];return h&&t.push("codicon-modifier-"+h.substring(1)),t}A.asClassNameArray=E;function v(r){return E(r).join(" ")}A.asClassName=v;function R(r){return"."+E(r).join(".")}A.asCSSSelector=R;function I(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||T.isThemeColor(r.color))}A.isThemeIcon=I;const w=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function y(r){const o=w.exec(r);if(!o)return;const[,m]=o;return{id:m}}A.fromString=y;function k(r){return{id:r}}A.fromId=k;function p(r,o){let m=r.id;const h=m.lastIndexOf("~");return h!==-1&&(m=m.substring(0,h)),o&&(m=`${m}~${o}`),{id:m}}A.modify=p;function u(r){const o=r.id.lastIndexOf("~");if(o!==-1)return r.id.substring(o+1)}A.getModifier=u;function c(r,o){return r.id===o.id&&r.color?.id===o.color?.id}A.isEqual=c})(L||(e.ThemeIcon=L={}))}),define(De[161],Ce([1,0,121,15,59]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=void 0;const L="$(",A=new RegExp(`\\$\\(${d.ThemeIcon.iconNameExpression}(?:${d.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${A.source}`,"g");function E(c){return c.replace($,(r,o)=>o?r:`\\${r}`)}e.$Vj=E;const v=new RegExp(`\\\\${A.source}`,"g");function R(c){return c.replace(v,r=>`\\${r}`)}e.$Wj=R;const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function w(c){return c.indexOf(L)===-1?c:c.replace(I,(r,o,m,h)=>m?r:o||h||"")}e.$Xj=w;function y(c){return c?c.replace(/\$\((.*?)\)/g,(r,o)=>` ${o} `).trim():""}e.$Yj=y;const k=new RegExp(`\\$\\(${d.ThemeIcon.iconNameCharacter}+\\)`,"g");function p(c){k.lastIndex=0;let r="";const o=[];let m=0;for(;;){const h=k.lastIndex,t=k.exec(c),n=c.substring(h,t?.index);if(n.length>0){r+=n;for(let a=0;a<n.length;a++)o.push(m)}if(!t)break;m+=t[0].length}return{text:r,iconOffsets:o}}e.$Zj=p;function u(c,r,o=!1){const{text:m,iconOffsets:h}=r;if(!h||h.length===0)return(0,C.$Ij)(c,m,o);const t=(0,T.$Je)(m," "),n=m.length-t.length,a=(0,C.$Ij)(c,t,o);if(a)for(const i of a){const s=h[i.start+n]+n;i.start+=s,i.end+=s}return a}e.$1j=u}),define(De[122],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.Constants=void 0;var C;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(C||(e.Constants=C={}));function T(L){return L<0?0:L>255?255:L|0}e.$ze=T;function d(L){return L<0?0:L>4294967295?4294967295:L|0}e.$Ae=d}),define(De[31],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(d){return C.test(d)}e.$dg=T,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let d;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?d=crypto.getRandomValues.bind(crypto):d=function($){for(let E=0;E<$.length;E++)$[E]=Math.floor(Math.random()*256);return $};const L=new Uint8Array(16),A=[];for(let $=0;$<256;$++)A.push($.toString(16).padStart(2,"0"));return function(){d(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,v="";return v+=A[L[E++]],v+=A[L[E++]],v+=A[L[E++]],v+=A[L[E++]],v+="-",v+=A[L[E++]],v+=A[L[E++]],v+="-",v+=A[L[E++]],v+=A[L[E++]],v+="-",v+=A[L[E++]],v+=A[L[E++]],v+="-",v+=A[L[E++]],v+=A[L[E++]],v+=A[L[E++]],v+=A[L[E++]],v+=A[L[E++]],v+=A[L[E++]],v}}()}),define(De[162],Ce([1,0,19,51,31]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.$Ys=e.$Xs=e.$Ws=e.$Vs=void 0;function L(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$Vs=L;function A(I,w,y){const k={id:(0,d.$eg)(),name:I,uri:w,data:y};return{asString:async()=>"",asFile:()=>k,value:void 0}}e.$Ws=A;class ${constructor(){this.a=new Map}get size(){let w=0;for(const y of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const y=[...this.a.keys()];return T.Iterable.some(this,([k,p])=>p.asFile())&&y.push("files"),R(E(w),y)}get(w){return this.a.get(this.b(w))?.[0]}append(w,y){const k=this.a.get(w);k?k.push(y):this.a.set(this.b(w),[y])}replace(w,y){this.a.set(this.b(w),[y])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,y]of this.a)for(const k of y)yield[w,k]}b(w){return E(w)}}e.$Xs=$;function E(I){return I.toLowerCase()}function v(I,w){return R(E(I),w.map(E))}e.$Ys=v;function R(I,w){if(I==="*/*")return w.length>0;if(w.includes(I))return!0;const y=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[k,p,u]=y;return u==="*"?w.some(c=>c.startsWith(p+"/")):!1}e.$Zs=Object.freeze({create:I=>(0,C.$Mb)(I.map(w=>w.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Zs.split(I).filter(w=>!w.startsWith("#"))})}),define(De[163],Ce([1,0,60]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=e.$gg=void 0;function T($,E,v,R=1){let I=!1;return new Promise(w=>{const y=setTimeout(()=>{if(!I)return I=!0,w(0)},v);d($,E,R,k=>{if(!I)return I=!0,clearTimeout(y),w(k)})})}e.$gg=T;function d($,E,v,R){if(E===0)return R(0);const I=new C.Socket;I.once("connect",()=>(A(I),d($+v,E-1,v,R))),I.once("data",()=>{}),I.once("error",w=>(A(I),w.code!=="ECONNREFUSED"?d($+v,E-1,v,R):R($))),I.connect($,"127.0.0.1")}e.$hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L($,E,v,R="127.0.0.1"){let I=!1,w,y=1;const k=C.createServer({pauseOnConnect:!0});function p(u,c){I||(I=!0,k.removeAllListeners(),k.close(),w&&clearTimeout(w),c(u))}return new Promise(u=>{w=setTimeout(()=>{p(0,u)},v),k.on("listening",()=>{p($,u)}),k.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&y<E?($++,y++,k.listen($,R)):p(0,u)}),k.on("close",()=>{p(0,u)}),k.listen($,R)})}e.$ig=L;function A($){try{$.removeAllListeners("connect"),$.removeAllListeners("error"),$.end(),$.destroy(),$.unref()}catch(E){console.error(E)}}}),define(De[123],Ce([1,0,122]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=e.$Ns=void 0;class T{constructor($){const E=(0,C.$ze)($);this.c=E,this.a=T.d(E),this.b=new Map}static d($){const E=new Uint8Array(256);return E.fill($),E}set($,E){const v=(0,C.$ze)(E);$>=0&&$<256?this.a[$]=v:this.b.set($,v)}get($){return $>=0&&$<256?this.a[$]:this.b.get($)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Ns=T;var d;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(d||(d={}));class L{constructor(){this.a=new T(0)}add($){this.a.set($,1)}has($){return this.a.get($)===1}clear(){return this.a.clear()}}e.$Os=L}),define(De[61],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=void 0;class C{constructor(d,L){this.lineNumber=d,this.column=L}with(d=this.lineNumber,L=this.column){return d===this.lineNumber&&L===this.column?this:new C(d,L)}delta(d=0,L=0){return this.with(this.lineNumber+d,this.column+L)}equals(d){return C.equals(this,d)}static equals(d,L){return!d&&!L?!0:!!d&&!!L&&d.lineNumber===L.lineNumber&&d.column===L.column}isBefore(d){return C.isBefore(this,d)}static isBefore(d,L){return d.lineNumber<L.lineNumber?!0:L.lineNumber<d.lineNumber?!1:d.column<L.column}isBeforeOrEqual(d){return C.isBeforeOrEqual(this,d)}static isBeforeOrEqual(d,L){return d.lineNumber<L.lineNumber?!0:L.lineNumber<d.lineNumber?!1:d.column<=L.column}static compare(d,L){const A=d.lineNumber|0,$=L.lineNumber|0;if(A===$){const E=d.column|0,v=L.column|0;return E-v}return A-$}clone(){return new C(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(d){return new C(d.lineNumber,d.column)}static isIPosition(d){return d&&typeof d.lineNumber=="number"&&typeof d.column=="number"}}e.$ps=C}),define(De[34],Ce([1,0,61]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=void 0;class T{constructor(L,A,$,E){L>$||L===$&&A>E?(this.startLineNumber=$,this.startColumn=E,this.endLineNumber=L,this.endColumn=A):(this.startLineNumber=L,this.startColumn=A,this.endLineNumber=$,this.endColumn=E)}isEmpty(){return T.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return T.containsPosition(this,L)}static containsPosition(L,A){return!(A.lineNumber<L.startLineNumber||A.lineNumber>L.endLineNumber||A.lineNumber===L.startLineNumber&&A.column<L.startColumn||A.lineNumber===L.endLineNumber&&A.column>L.endColumn)}static strictContainsPosition(L,A){return!(A.lineNumber<L.startLineNumber||A.lineNumber>L.endLineNumber||A.lineNumber===L.startLineNumber&&A.column<=L.startColumn||A.lineNumber===L.endLineNumber&&A.column>=L.endColumn)}containsRange(L){return T.containsRange(this,L)}static containsRange(L,A){return!(A.startLineNumber<L.startLineNumber||A.endLineNumber<L.startLineNumber||A.startLineNumber>L.endLineNumber||A.endLineNumber>L.endLineNumber||A.startLineNumber===L.startLineNumber&&A.startColumn<L.startColumn||A.endLineNumber===L.endLineNumber&&A.endColumn>L.endColumn)}strictContainsRange(L){return T.strictContainsRange(this,L)}static strictContainsRange(L,A){return!(A.startLineNumber<L.startLineNumber||A.endLineNumber<L.startLineNumber||A.startLineNumber>L.endLineNumber||A.endLineNumber>L.endLineNumber||A.startLineNumber===L.startLineNumber&&A.startColumn<=L.startColumn||A.endLineNumber===L.endLineNumber&&A.endColumn>=L.endColumn)}plusRange(L){return T.plusRange(this,L)}static plusRange(L,A){let $,E,v,R;return A.startLineNumber<L.startLineNumber?($=A.startLineNumber,E=A.startColumn):A.startLineNumber===L.startLineNumber?($=A.startLineNumber,E=Math.min(A.startColumn,L.startColumn)):($=L.startLineNumber,E=L.startColumn),A.endLineNumber>L.endLineNumber?(v=A.endLineNumber,R=A.endColumn):A.endLineNumber===L.endLineNumber?(v=A.endLineNumber,R=Math.max(A.endColumn,L.endColumn)):(v=L.endLineNumber,R=L.endColumn),new T($,E,v,R)}intersectRanges(L){return T.intersectRanges(this,L)}static intersectRanges(L,A){let $=L.startLineNumber,E=L.startColumn,v=L.endLineNumber,R=L.endColumn;const I=A.startLineNumber,w=A.startColumn,y=A.endLineNumber,k=A.endColumn;return $<I?($=I,E=w):$===I&&(E=Math.max(E,w)),v>y?(v=y,R=k):v===y&&(R=Math.min(R,k)),$>v||$===v&&E>R?null:new T($,E,v,R)}equalsRange(L){return T.equalsRange(this,L)}static equalsRange(L,A){return!L&&!A?!0:!!L&&!!A&&L.startLineNumber===A.startLineNumber&&L.startColumn===A.startColumn&&L.endLineNumber===A.endLineNumber&&L.endColumn===A.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(L){return new C.$ps(L.endLineNumber,L.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(L){return new C.$ps(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,A){return new T(this.startLineNumber,this.startColumn,L,A)}setStartPosition(L,A){return new T(L,A,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(L){return new T(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(L){return new T(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new T(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,A=L){return new T(L.lineNumber,L.column,A.lineNumber,A.column)}static lift(L){return L?new T(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,A){return!(L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<A.startColumn||A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<L.startColumn)}static areIntersecting(L,A){return!(L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<=A.startColumn||A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,A){if(L&&A){const v=L.startLineNumber|0,R=A.startLineNumber|0;if(v===R){const I=L.startColumn|0,w=A.startColumn|0;if(I===w){const y=L.endLineNumber|0,k=A.endLineNumber|0;if(y===k){const p=L.endColumn|0,u=A.endColumn|0;return p-u}return y-k}return I-w}return v-R}return(L?1:0)-(A?1:0)}static compareRangesUsingEnds(L,A){return L.endLineNumber===A.endLineNumber?L.endColumn===A.endColumn?L.startLineNumber===A.startLineNumber?L.startColumn-A.startColumn:L.startLineNumber-A.startLineNumber:L.endColumn-A.endColumn:L.endLineNumber-A.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$qs=T}),define(De[164],Ce([1,0,34]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=void 0;class T{static insert(L,A){return{range:new C.$qs(L.lineNumber,L.column,L.lineNumber,L.column),text:A,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,A){return{range:L,text:A}}static replaceMove(L,A){return{range:L,text:A,forceMoveMarkers:!0}}}e.$rs=T}),define(De[165],Ce([1,0,61,34]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.SelectionDirection=void 0;var d;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(d||(e.SelectionDirection=d={}));class L extends T.$qs{constructor($,E,v,R){super($,E,v,R),this.selectionStartLineNumber=$,this.selectionStartColumn=E,this.positionLineNumber=v,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection($){return L.selectionsEqual(this,$)}static selectionsEqual($,E){return $.selectionStartLineNumber===E.selectionStartLineNumber&&$.selectionStartColumn===E.selectionStartColumn&&$.positionLineNumber===E.positionLineNumber&&$.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition($,E){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,$,E):new L($,E,this.startLineNumber,this.startColumn)}getPosition(){return new C.$ps(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new C.$ps(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition($,E){return this.getDirection()===0?new L($,E,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,$,E)}static fromPositions($,E=$){return new L($.lineNumber,$.column,E.lineNumber,E.column)}static fromRange($,E){return E===0?new L($.startLineNumber,$.startColumn,$.endLineNumber,$.endColumn):new L($.endLineNumber,$.endColumn,$.startLineNumber,$.startColumn)}static liftSelection($){return new L($.selectionStartLineNumber,$.selectionStartColumn,$.positionLineNumber,$.positionColumn)}static selectionsArrEqual($,E){if($&&!E||!$&&E)return!1;if(!$&&!E)return!0;if($.length!==E.length)return!1;for(let v=0,R=$.length;v<R;v++)if(!this.selectionsEqual($[v],E[v]))return!1;return!0}static isISelection($){return $&&typeof $.selectionStartLineNumber=="number"&&typeof $.selectionStartColumn=="number"&&typeof $.positionLineNumber=="number"&&typeof $.positionColumn=="number"}static createWithDirection($,E,v,R,I){return I===0?new L($,E,v,R):new L(v,R,$,E)}}e.$ss=L}),define(De[166],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=void 0,e.$1r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[167],Ce([1,0,123]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=e.$Ps=e.WordCharacterClass=void 0;var T;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class d extends C.$Ns{constructor($){super(0);for(let E=0,v=$.length;E<v;E++)this.set($.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.$Ps=d;function L(A){const $={};return E=>($.hasOwnProperty(E)||($[E]=A(E)),$[E])}e.$Qs=L(A=>new d(A))}),define(De[124],Ce([1,0,51,3,76]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=e.$5r=e.$4r=e.$3r=e.$2r=void 0,e.$2r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(I=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$2r)I.indexOf(y)>=0||(w+="\\"+y);return w+="\\s]+)",new RegExp(w,"g")}e.$3r=L();function A(I){let w=e.$3r;if(I&&I instanceof RegExp)if(I.global)w=I;else{let y="g";I.ignoreCase&&(y+="i"),I.multiline&&(y+="m"),I.unicode&&(y+="u"),w=new RegExp(I.source,y)}return w.lastIndex=0,w}e.$4r=A;const $=new d.$2c;$.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(I){const w=$.unshift(I);return(0,T.$Qc)(w)}e.$5r=E;function v(I,w,y,k,p){if(p||(p=C.Iterable.first($)),y.length>p.maxLen){let m=I-p.maxLen/2;return m<0?m=0:k+=m,y=y.substring(m,I+p.maxLen/2),v(I,w,y,k,p)}const u=Date.now(),c=I-1-k;let r=-1,o=null;for(let m=1;!(Date.now()-u>=p.timeBudget);m++){const h=c-p.windowSize*m;w.lastIndex=Math.max(0,h);const t=R(w,y,c,r);if(!t&&o||(o=t,h<=0))break;r=h}if(o){const m={word:o[0],startColumn:k+1+o.index,endColumn:k+1+o.index+o[0].length};return w.lastIndex=0,m}return null}e.$6r=v;function R(I,w,y,k){let p;for(;p=I.exec(w);){const u=p.index||0;if(u<=y&&I.lastIndex>=y)return p;if(k>0&&u>k)return null}return null}}),define(De[168],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.$mt=e.IndentAction=void 0;var C;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class T{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let E=0,v=$.notIn.length;E<v;E++)switch($.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,E){if($.getTokenCount()===0)return!0;const v=$.findTokenIndexAtOffset(E-2),R=$.getStandardTokenType(v);return this.isOK(R)}g($,E){for(let v=$;v<=E;v++){const R=String.fromCharCode(v);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$mt=T;class d{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of $)L(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),L(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),L(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),L(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&L(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$nt=d;function L(A,$,E){A.has($)?A.get($).push(E):A.set($,[E])}}),define(De[169],Ce([1,0,123]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XY=e.$WY=e.$VY=e.State=void 0;var T;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(T||(e.State=T={}));class d{constructor(k,p,u){const c=new Uint8Array(k*p);for(let r=0,o=k*p;r<o;r++)c[r]=u;this.a=c,this.rows=k,this.cols=p}get(k,p){return this.a[k*this.cols+p]}set(k,p,u){this.a[k*this.cols+p]=u}}class L{constructor(k){let p=0,u=0;for(let r=0,o=k.length;r<o;r++){const[m,h,t]=k[r];h>p&&(p=h),m>u&&(u=m),t>u&&(u=t)}p++,u++;const c=new d(u,p,0);for(let r=0,o=k.length;r<o;r++){const[m,h,t]=k[r];c.set(m,h,t)}this.a=c,this.b=p}nextState(k,p){return p<0||p>=this.b?0:this.a.get(k,p)}}e.$VY=L;let A=null;function $(){return A===null&&(A=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var E;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let v=null;function R(){if(v===null){v=new C.$Ns(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<y.length;p++)v.set(y.charCodeAt(p),1);const k=".,;:";for(let p=0;p<k.length;p++)v.set(k.charCodeAt(p),2)}return v}class I{static a(k,p,u,c,r){let o=r-1;do{const m=p.charCodeAt(o);if(k.get(m)!==2)break;o--}while(o>c);if(c>0){const m=p.charCodeAt(c-1),h=p.charCodeAt(o);(m===40&&h===41||m===91&&h===93||m===123&&h===125)&&o--}return{range:{startLineNumber:u,startColumn:c+1,endLineNumber:u,endColumn:o+2},url:p.substring(c,o+1)}}static computeLinks(k,p=$()){const u=R(),c=[];for(let r=1,o=k.getLineCount();r<=o;r++){const m=k.getLineContent(r),h=m.length;let t=0,n=0,a=0,i=1,s=!1,l=!1,D=!1,S=!1;for(;t<h;){let b=!1;const f=m.charCodeAt(t);if(i===13){let g;switch(f){case 40:s=!0,g=0;break;case 41:g=s?0:1;break;case 91:D=!0,l=!0,g=0;break;case 93:D=!1,g=l?0:1;break;case 123:S=!0,g=0;break;case 125:g=S?0:1;break;case 39:case 34:case 96:a===f?g=1:a===39||a===34||a===96?g=0:g=1;break;case 42:g=a===42?1:0;break;case 124:g=a===124?1:0;break;case 32:g=D?0:1;break;default:g=u.get(f)}g===1&&(c.push(I.a(u,m,r,n,t)),b=!0)}else if(i===12){let g;f===91?(l=!0,g=0):g=u.get(f),g===1?b=!0:i=13}else i=p.nextState(i,f),i===0&&(b=!0);b&&(i=1,s=!1,l=!1,S=!1,n=t+1,a=f),t++}i===13&&c.push(I.a(u,m,r,n,h))}return c}}e.$WY=I;function w(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:I.computeLinks(y)}e.$XY=w}),define(De[125],Ce([1,0,24]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mu=e.$Lu=e.$Ku=e.$Ju=e.ModelConstants=e.PositionAffinity=e.$Iu=e.TrackedRangeStickiness=e.$Hu=e.$Gu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var T;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(T||(e.OverviewRulerLane=T={}));var d;(function(m){m[m.Left=1]="Left",m[m.Right=2]="Right"})(d||(e.GlyphMarginLane=d={}));var L;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var A;(function(m){m[m.Both=0]="Both",m[m.Right=1]="Right",m[m.Left=2]="Left",m[m.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var $;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var E;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var v;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(v||(e.EndOfLineSequence=v={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(h){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,h.tabSize|0),h.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,h.indentSize|0),this.a=!1),this.insertSpaces=!!h.insertSpaces,this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=!!h.trimAutoWhitespace,this.bracketPairColorizationOptions=h.bracketPairColorizationOptions}equals(h){return this.tabSize===h.tabSize&&this.a===h.a&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace&&(0,C.$8m)(this.bracketPairColorizationOptions,h.bracketPairColorizationOptions)}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.$Gu=R;class I{constructor(h,t){this._findMatchBrand=void 0,this.range=h,this.matches=t}}e.$Hu=I;var w;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(w||(e.TrackedRangeStickiness=w={}));function y(m){return m&&typeof m.read=="function"}e.$Iu=y;var k;(function(m){m[m.Left=0]="Left",m[m.Right=1]="Right",m[m.None=2]="None",m[m.LeftOfInjectedText=3]="LeftOfInjectedText",m[m.RightOfInjectedText=4]="RightOfInjectedText"})(k||(e.PositionAffinity=k={}));var p;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(p||(e.ModelConstants=p={}));class u{constructor(h,t,n,a,i,s){this.identifier=h,this.range=t,this.text=n,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=i,this._isTracked=s}}e.$Ju=u;class c{constructor(h,t,n){this.regex=h,this.wordSeparators=t,this.simpleSearch=n}}e.$Ku=c;class r{constructor(h,t,n){this.reverseEdits=h,this.changes=t,this.trimAutoWhitespaceLineNumbers=n}}e.$Lu=r;function o(m){return!m.isTooLargeForSyncing()&&!m.isForSimpleWidget}e.$Mu=o}),define(De[170],Ce([1,0,19,122]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ru=e.$Qu=e.$Pu=void 0;class d{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,v){E=(0,T.$Ae)(E);const R=this.a,I=this.b,w=v.length;return w===0?!1:(this.a=new Uint32Array(R.length+w),this.a.set(R.subarray(0,E),0),this.a.set(R.subarray(E),E+w),this.a.set(v,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(E,v){return E=(0,T.$Ae)(E),v=(0,T.$Ae)(v),this.a[E]===v?!1:(this.a[E]=v,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,v){E=(0,T.$Ae)(E),v=(0,T.$Ae)(v);const R=this.a,I=this.b;if(E>=R.length)return!1;const w=R.length-E;return v>=w&&(v=w),v===0?!1:(this.a=new Uint32Array(R.length-v),this.a.set(R.subarray(0,E),0),this.a.set(R.subarray(E+v),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,T.$Ae)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let v=this.c[0]+1;v===0&&(this.b[0]=this.a[0],v++),E>=this.a.length&&(E=this.a.length-1);for(let R=v;R<=E;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let v=0,R=this.a.length-1,I=0,w=0,y=0;for(;v<=R;)if(I=v+(R-v)/2|0,w=this.b[I],y=w-this.a[I],E<y)R=I-1;else if(E>=w)v=I+1;else break;return new A(I,E-y)}}e.$Pu=d;class L{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const v=this.e[E],R=v>0?this.d[v-1]:0;return new A(v,E-R)}removeValues(E,v){this.a.splice(E,v),this.f(E)}insertValues(E,v){this.a=(0,C.$Wb)(this.a,E,v),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,v=this.a.length;E<v;E++){const R=this.a[E],I=E>0?this.d[E-1]:0;this.d[E]=I+R;for(let w=0;w<R;w++)this.e[I+w]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,v){this.a[E]!==v&&(this.a[E]=v,this.f(E))}}e.$Qu=L;class A{constructor(E,v){this.index=E,this.remainder=v,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=v}}e.$Ru=A}),define(De[171],Ce([1,0,15,61,170]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Su=void 0;class L{constructor($,E,v,R){this.d=$,this.f=E,this.g=v,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents($){$.eol&&$.eol!==this.g&&(this.g=$.eol,this.j=null);const E=$.changes;for(const v of E)this.o(v.range),this.p(new T.$ps(v.range.startLineNumber,v.range.startColumn),v.text);this.h=$.versionId,this.k=null}l(){if(!this.j){const $=this.g.length,E=this.f.length,v=new Uint32Array(E);for(let R=0;R<E;R++)v[R]=this.f[R].length+$;this.j=new d.$Pu(v)}}n($,E){this.f[$]=E,this.j&&this.j.setValue($,this.f[$].length+this.g.length)}o($){if($.startLineNumber===$.endLineNumber){if($.startColumn===$.endColumn)return;this.n($.startLineNumber-1,this.f[$.startLineNumber-1].substring(0,$.startColumn-1)+this.f[$.startLineNumber-1].substring($.endColumn-1));return}this.n($.startLineNumber-1,this.f[$.startLineNumber-1].substring(0,$.startColumn-1)+this.f[$.endLineNumber-1].substring($.endColumn-1)),this.f.splice($.startLineNumber,$.endLineNumber-$.startLineNumber),this.j&&this.j.removeValues($.startLineNumber,$.endLineNumber-$.startLineNumber)}p($,E){if(E.length===0)return;const v=(0,C.$Pe)(E);if(v.length===1){this.n($.lineNumber-1,this.f[$.lineNumber-1].substring(0,$.column-1)+v[0]+this.f[$.lineNumber-1].substring($.column-1));return}v[v.length-1]+=this.f[$.lineNumber-1].substring($.column-1),this.n($.lineNumber-1,this.f[$.lineNumber-1].substring(0,$.column-1)+v[0]);const R=new Uint32Array(v.length-1);for(let I=1;I<v.length;I++)this.f.splice($.lineNumber+I-1,0,v[I]),R[I-1]=v[I].length+this.g.length;this.j&&this.j.insertValues($.lineNumber,R)}}e.$Su=L}),define(De[172],Ce([1,0,15,167,61,34,125]),function($e,e,C,T,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uB=e.$tB=e.$sB=e.$rB=e.$qB=e.$pB=void 0;const $=999;class E{constructor(r,o,m,h){this.searchString=r,this.isRegex=o,this.matchCase=m,this.wordSeparators=h}parseSearchRequest(){if(this.searchString==="")return null;let r;this.isRegex?r=v(this.searchString):r=this.searchString.indexOf(`
`)>=0;let o=null;try{o=C.$Ne(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:r,global:!0,unicode:!0})}catch{return null}if(!o)return null;let m=!this.isRegex&&!r;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new A.$Ku(o,this.wordSeparators?(0,T.$Qs)(this.wordSeparators):null,m?this.searchString:null)}}e.$pB=E;function v(c){if(!c||c.length===0)return!1;for(let r=0,o=c.length;r<o;r++){const m=c.charCodeAt(r);if(m===10)return!0;if(m===92){if(r++,r>=o)break;const h=c.charCodeAt(r);if(h===110||h===114||h===87)return!0}}return!1}e.$qB=v;function R(c,r,o){if(!o)return new A.$Hu(c,null);const m=[];for(let h=0,t=r.length;h<t;h++)m[h]=r[h];return new A.$Hu(c,m)}e.$rB=R;class I{constructor(r){const o=[];let m=0;for(let h=0,t=r.length;h<t;h++)r.charCodeAt(h)===10&&(o[m++]=h);this.a=o}findLineFeedCountBeforeOffset(r){const o=this.a;let m=0,h=o.length-1;if(h===-1||r<=o[0])return 0;for(;m<h;){const t=m+((h-m)/2>>0);o[t]>=r?h=t-1:o[t+1]>=r?(m=t,h=t):m=t+1}return m+1}}class w{static findMatches(r,o,m,h,t){const n=o.parseSearchRequest();return n?n.regex.multiline?this.b(r,m,new u(n.wordSeparators,n.regex),h,t):this.c(r,m,n,h,t):[]}static a(r,o,m,h,t,n){let a,i=0;h?(i=h.findLineFeedCountBeforeOffset(t),a=o+t+i):a=o+t;let s;if(h){const b=h.findLineFeedCountBeforeOffset(t+n.length)-i;s=a+n.length+b}else s=a+n.length;const l=r.getPositionAt(a),D=r.getPositionAt(s);return new L.$qs(l.lineNumber,l.column,D.lineNumber,D.column)}static b(r,o,m,h,t){const n=r.getOffsetAt(o.getStartPosition()),a=r.getValueInRange(o,1),i=r.getEOL()===`\r
`?new I(a):null,s=[];let l=0,D;for(m.reset(0);D=m.next(a);)if(s[l++]=R(this.a(r,n,a,i,D.index,D[0]),D,h),l>=t)return s;return s}static c(r,o,m,h,t){const n=[];let a=0;if(o.startLineNumber===o.endLineNumber){const s=r.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return a=this.d(m,s,o.startLineNumber,o.startColumn-1,a,n,h,t),n}const i=r.getLineContent(o.startLineNumber).substring(o.startColumn-1);a=this.d(m,i,o.startLineNumber,o.startColumn-1,a,n,h,t);for(let s=o.startLineNumber+1;s<o.endLineNumber&&a<t;s++)a=this.d(m,r.getLineContent(s),s,0,a,n,h,t);if(a<t){const s=r.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);a=this.d(m,s,o.endLineNumber,0,a,n,h,t)}return n}static d(r,o,m,h,t,n,a,i){const s=r.wordSeparators;if(!a&&r.simpleSearch){const S=r.simpleSearch,b=S.length,f=o.length;let g=-b;for(;(g=o.indexOf(S,g+b))!==-1;)if((!s||p(s,o,f,g,b))&&(n[t++]=new A.$Hu(new L.$qs(m,g+1+h,m,g+1+b+h),null),t>=i))return t;return t}const l=new u(r.wordSeparators,r.regex);let D;l.reset(0);do if(D=l.next(o),D&&(n[t++]=R(new L.$qs(m,D.index+1+h,m,D.index+1+D[0].length+h),D,a),t>=i))return t;while(D);return t}static findNextMatch(r,o,m,h){const t=o.parseSearchRequest();if(!t)return null;const n=new u(t.wordSeparators,t.regex);return t.regex.multiline?this.e(r,m,n,h):this.f(r,m,n,h)}static e(r,o,m,h){const t=new d.$ps(o.lineNumber,1),n=r.getOffsetAt(t),a=r.getLineCount(),i=r.getValueInRange(new L.$qs(t.lineNumber,t.column,a,r.getLineMaxColumn(a)),1),s=r.getEOL()===`\r
`?new I(i):null;m.reset(o.column-1);const l=m.next(i);return l?R(this.a(r,n,i,s,l.index,l[0]),l,h):o.lineNumber!==1||o.column!==1?this.e(r,new d.$ps(1,1),m,h):null}static f(r,o,m,h){const t=r.getLineCount(),n=o.lineNumber,a=r.getLineContent(n),i=this.g(m,a,n,o.column,h);if(i)return i;for(let s=1;s<=t;s++){const l=(n+s-1)%t,D=r.getLineContent(l+1),S=this.g(m,D,l+1,1,h);if(S)return S}return null}static g(r,o,m,h,t){r.reset(h-1);const n=r.next(o);return n?R(new L.$qs(m,n.index+1,m,n.index+1+n[0].length),n,t):null}static findPreviousMatch(r,o,m,h){const t=o.parseSearchRequest();if(!t)return null;const n=new u(t.wordSeparators,t.regex);return t.regex.multiline?this.h(r,m,n,h):this.j(r,m,n,h)}static h(r,o,m,h){const t=this.b(r,new L.$qs(1,1,o.lineNumber,o.column),m,h,10*$);if(t.length>0)return t[t.length-1];const n=r.getLineCount();return o.lineNumber!==n||o.column!==r.getLineMaxColumn(n)?this.h(r,new d.$ps(n,r.getLineMaxColumn(n)),m,h):null}static j(r,o,m,h){const t=r.getLineCount(),n=o.lineNumber,a=r.getLineContent(n).substring(0,o.column-1),i=this.k(m,a,n,h);if(i)return i;for(let s=1;s<=t;s++){const l=(t+n-s-1)%t,D=r.getLineContent(l+1),S=this.k(m,D,l+1,h);if(S)return S}return null}static k(r,o,m,h){let t=null,n;for(r.reset(0);n=r.next(o);)t=R(new L.$qs(m,n.index+1,m,n.index+1+n[0].length),n,h);return t}}e.$sB=w;function y(c,r,o,m,h){if(m===0)return!0;const t=r.charCodeAt(m-1);if(c.get(t)!==0||t===13||t===10)return!0;if(h>0){const n=r.charCodeAt(m);if(c.get(n)!==0)return!0}return!1}function k(c,r,o,m,h){if(m+h===o)return!0;const t=r.charCodeAt(m+h);if(c.get(t)!==0||t===13||t===10)return!0;if(h>0){const n=r.charCodeAt(m+h-1);if(c.get(n)!==0)return!0}return!1}function p(c,r,o,m,h){return y(c,r,o,m,h)&&k(c,r,o,m,h)}e.$tB=p;class u{constructor(r,o){this._wordSeparators=r,this.a=o,this.b=-1,this.c=0}reset(r){this.a.lastIndex=r,this.b=-1,this.c=0}next(r){const o=r.length;let m;do{if(this.b+this.c===o||(m=this.a.exec(r),!m))return null;const h=m.index,t=m[0].length;if(h===this.b&&t===this.c){if(t===0){C.$9e(r,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=h,this.c=t,!this._wordSeparators||p(this._wordSeparators,r,o,h,t))return m}while(m);return null}}e.$uB=u}),define(De[173],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J7=e.$I7=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const A=this.a.get(L);return this.a.delete(L),A}}addDragOperationTransfer(L,A){this.a.set(L,A)}}e.$I7=C;class T{constructor(L){this.identifier=L}}e.$J7=T}),define(De[174],Ce([1,0,4,3]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=void 0;class d{constructor(){this.a=new Map,this.b=new Map,this.c=new C.$Nd,this.onDidChange=this.c.event,this.d=null}handleChange($){this.c.fire({changedLanguages:$,changedColorMap:!1})}register($,E){return this.a.set($,E),this.handleChange([$]),(0,T.$Qc)(()=>{this.a.get($)===E&&(this.a.delete($),this.handleChange([$]))})}get($){return this.a.get($)||null}registerFactory($,E){this.b.get($)?.dispose();const v=new L(this,$,E);return this.b.set($,v),(0,T.$Qc)(()=>{const R=this.b.get($);!R||R!==v||(this.b.delete($),R.dispose())})}async getOrCreate($){const E=this.get($);if(E)return E;const v=this.b.get($);return!v||v.isResolved?null:(await v.resolve(),this.get($))}isResolved($){if(this.get($))return!0;const v=this.b.get($);return!!(!v||v.isResolved)}setColorMap($){this.d=$,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$2s=d;class L extends T.$Sc{get isResolved(){return this.c}constructor($,E,v){super(),this.f=$,this.g=E,this.h=v,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const $=await this.h.tokenizationSupport;this.c=!0,$&&!this.a&&this.B(this.f.register(this.g,$))}}}),define(De[175],Ce([10,11]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(De[176],Ce([1,0,4,3,175]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=void 0;class L extends T.$Sc{constructor(w,y="",k="",p=!0,u){super(),this.h=this.B(new C.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=y,this.u=k,this.w=p,this.C=u}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,y){this.C&&await this.C(w)}}e.$ti=L;class A extends T.$Sc{constructor(){super(...arguments),this.f=this.B(new C.$Nd),this.onWillRun=this.f.event,this.m=this.B(new C.$Nd),this.onDidRun=this.m.event}async run(w,y){if(!w.enabled)return;this.f.fire({action:w});let k;try{await this.u(w,y)}catch(p){k=p}this.m.fire({action:w,error:k})}async u(w,y){await w.run(y)}}e.$ui=A;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let y=[];for(const k of w)k.length&&(y.length?y=[...y,new $,...k]:y=k);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$vi=$;class E{get actions(){return this.a}constructor(w,y,k,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=y,this.class=p,this.a=k}async run(){}}e.$wi=E;class v extends L{static{this.ID="vs.actions.empty"}constructor(){super(v.ID,d.localize(0,null),void 0,!1)}}e.$xi=v;function R(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...w)=>I.run(...w),tooltip:I.label}}e.$yi=R}),define(De[177],Ce([10,11]),function($e,e){return $e.create("vs/base/common/date",e)}),define(De[178],Ce([1,0,177]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=e.$bm=void 0;const T=60,d=T*60,L=d*24,A=L*7,$=L*30,E=L*365;function v(I,w,y,k){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,C.localize)(0,null,v(new Date().getTime()+p*1e3,!1));if(!k&&p<30)return(0,C.localize)(1,null);let u;return p<T?(u=p,w?u===1?y?(0,C.localize)(2,null,u):(0,C.localize)(3,null,u):y?(0,C.localize)(4,null,u):(0,C.localize)(5,null,u):u===1?y?(0,C.localize)(6,null,u):(0,C.localize)(7,null,u):y?(0,C.localize)(8,null,u):(0,C.localize)(9,null,u)):p<d?(u=Math.floor(p/T),w?u===1?y?(0,C.localize)(10,null,u):(0,C.localize)(11,null,u):y?(0,C.localize)(12,null,u):(0,C.localize)(13,null,u):u===1?y?(0,C.localize)(14,null,u):(0,C.localize)(15,null,u):y?(0,C.localize)(16,null,u):(0,C.localize)(17,null,u)):p<L?(u=Math.floor(p/d),w?u===1?y?(0,C.localize)(18,null,u):(0,C.localize)(19,null,u):y?(0,C.localize)(20,null,u):(0,C.localize)(21,null,u):u===1?y?(0,C.localize)(22,null,u):(0,C.localize)(23,null,u):y?(0,C.localize)(24,null,u):(0,C.localize)(25,null,u)):p<A?(u=Math.floor(p/L),w?u===1?(0,C.localize)(26,null,u):(0,C.localize)(27,null,u):u===1?(0,C.localize)(28,null,u):(0,C.localize)(29,null,u)):p<$?(u=Math.floor(p/A),w?u===1?y?(0,C.localize)(30,null,u):(0,C.localize)(31,null,u):y?(0,C.localize)(32,null,u):(0,C.localize)(33,null,u):u===1?y?(0,C.localize)(34,null,u):(0,C.localize)(35,null,u):y?(0,C.localize)(36,null,u):(0,C.localize)(37,null,u)):p<E?(u=Math.floor(p/$),w?u===1?y?(0,C.localize)(38,null,u):(0,C.localize)(39,null,u):y?(0,C.localize)(40,null,u):(0,C.localize)(41,null,u):u===1?y?(0,C.localize)(42,null,u):(0,C.localize)(43,null,u):y?(0,C.localize)(44,null,u):(0,C.localize)(45,null,u)):(u=Math.floor(p/E),w?u===1?y?(0,C.localize)(46,null,u):(0,C.localize)(47,null,u):y?(0,C.localize)(48,null,u):(0,C.localize)(49,null,u):u===1?y?(0,C.localize)(50,null,u):(0,C.localize)(51,null,u):y?(0,C.localize)(52,null,u):(0,C.localize)(53,null,u))}e.$bm=v;function R(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$cm=R}),define(De[179],Ce([10,11]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(De[41],Ce([1,0,19,17,179]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=e.$zi=void 0;function L(I,w){return w&&(I.stack||I.stacktrace)?d.localize(0,null,$(I),A(I.stack)||A(I.stacktrace)):$(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function $(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?d.localize(1,null,I.message):I.message||d.localize(2,null)}function E(I=null,w=!1){if(!I)return d.localize(3,null);if(Array.isArray(I)){const y=C.$Hb(I),k=E(y[0],w);return y.length>1?d.localize(4,null,k,y.length):k}if(T.$yf(I))return I;if(I.detail){const y=I.detail;if(y.error)return L(y.error,w);if(y.exception)return L(y.exception,w)}return I.stack?L(I,w):I.message?I.message:d.localize(5,null)}e.$zi=E;function v(I){const w=I;return w instanceof Error&&Array.isArray(w.actions)}e.$Ai=v;function R(I,w){let y;return typeof I=="string"?y=new Error(I):y=I,y.actions=w,y}e.$Bi=R}),define(De[180],Ce([10,11]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(De[12],Ce([1,0,180]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$h=e.$g=void 0,e.$g="en";let T=!1,d=!1,L=!1,A=!1,$=!1,E=!1,v=!1,R=!1,I=!1,w=!1,y,k=e.$g,p=e.$g,u,c;e.$h=typeof self=="object"?self:typeof global=="object"?global:{};let r;typeof e.$h.vscode<"u"&&typeof e.$h.vscode.process<"u"?r=e.$h.vscode.process:typeof process<"u"&&(r=process);const o=typeof r?.versions?.electron=="string",m=o&&r?.type==="renderer";if(typeof navigator=="object"&&!m)c=navigator.userAgent,T=c.indexOf("Windows")>=0,d=c.indexOf("Macintosh")>=0,R=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=c.indexOf("Linux")>=0,w=c?.indexOf("Mobi")>=0,E=!0,y=C.getConfiguredDefaultLocale(C.localize(0,null))||e.$g,k=y,p=navigator.language;else if(typeof r=="object"){T=r.platform==="win32",d=r.platform==="darwin",L=r.platform==="linux",A=L&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,v=o,I=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,k=e.$g;const S=r.env.VSCODE_NLS_CONFIG;if(S)try{const b=JSON.parse(S),f=b.availableLanguages["*"];y=b.locale,p=b.osLocale,k=f||e.$g,u=b._translationsConfigFile}catch{}$=!0}else console.error("Unable to resolve platform.");var h;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(h||(e.Platform=h={}));function t(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$i=t;let n=0;d?n=1:T?n=3:L&&(n=2),e.$j=T,e.$k=d,e.$l=L,e.$m=A,e.$n=$,e.$o=v,e.$p=E,e.$q=E&&typeof e.$h.importScripts=="function",e.$r=R,e.$s=w,e.$t=I,e.$u=n,e.$v=c,e.$w=k;var a;(function(S){function b(){return e.$w}S.value=b;function f(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}S.isDefaultVariant=f;function g(){return e.$w==="en"}S.isDefault=g})(a||(e.Language=a={})),e.$x=y,e.$y=p,e.$z=u,e.$A=typeof e.$h.postMessage=="function"&&!e.$h.importScripts,e.$B=(()=>{if(e.$A){const S=[];e.$h.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let g=0,P=S.length;g<P;g++){const N=S[g];if(N.id===f.data.vscodeScheduleAsyncWork){S.splice(g,1),N.callback();return}}});let b=0;return f=>{const g=++b;S.push({id:g,callback:f}),e.$h.postMessage({vscodeScheduleAsyncWork:g},"*")}}return S=>setTimeout(S)})();var i;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=d||R?2:T?1:3;let s=!0,l=!1;function D(){if(!l){l=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,s=new Uint16Array(S.buffer)[0]===(2<<8)+1}return s}e.$D=D,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(De[48],Ce([1,0,12]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let T;if(typeof C.$h.vscode<"u"&&typeof C.$h.vscode.process<"u"){const d=C.$h.vscode.process;T={get platform(){return d.platform},get arch(){return d.arch},get env(){return d.env},cwd(){return d.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return C.$j?"win32":C.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.$dc=T.platform,e.$ec=T.arch}),define(De[16],Ce([1,0,48]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const T=65,d=97,L=90,A=122,$=46,E=47,v=92,R=58,I=63;class w extends Error{constructor(n,a,i){let s;typeof a=="string"&&a.indexOf("not ")===0?(s="must not be",a=a.replace(/^not /,"")):s="must be";const l=n.indexOf(".")!==-1?"property":"argument";let D=`The "${n}" ${l} ${s} of type ${a}`;D+=`. Received type ${typeof i}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,n){if(t===null||typeof t!="object")throw new w(n,"Object",t)}function k(t,n){if(typeof t!="string")throw new w(n,"string",t)}const p=C.$dc==="win32";function u(t){return t===E||t===v}function c(t){return t===E}function r(t){return t>=T&&t<=L||t>=d&&t<=A}function o(t,n,a,i){let s="",l=0,D=-1,S=0,b=0;for(let f=0;f<=t.length;++f){if(f<t.length)b=t.charCodeAt(f);else{if(i(b))break;b=E}if(i(b)){if(!(D===f-1||S===1))if(S===2){if(s.length<2||l!==2||s.charCodeAt(s.length-1)!==$||s.charCodeAt(s.length-2)!==$){if(s.length>2){const g=s.lastIndexOf(a);g===-1?(s="",l=0):(s=s.slice(0,g),l=s.length-1-s.lastIndexOf(a)),D=f,S=0;continue}else if(s.length!==0){s="",l=0,D=f,S=0;continue}}n&&(s+=s.length>0?`${a}..`:"..",l=2)}else s.length>0?s+=`${a}${t.slice(D+1,f)}`:s=t.slice(D+1,f),l=f-D-1;D=f,S=0}else b===$&&S!==-1?++S:S=-1}return s}function m(t,n){y(n,"pathObject");const a=n.dir||n.root,i=n.base||`${n.name||""}${n.ext||""}`;return a?a===n.root?`${a}${i}`:`${a}${t}${i}`:i}e.$fc={resolve(...t){let n="",a="",i=!1;for(let s=t.length-1;s>=-1;s--){let l;if(s>=0){if(l=t[s],k(l,"path"),l.length===0)continue}else n.length===0?l=C.cwd():(l=C.env[`=${n}`]||C.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==n.toLowerCase()&&l.charCodeAt(2)===v)&&(l=`${n}\\`));const D=l.length;let S=0,b="",f=!1;const g=l.charCodeAt(0);if(D===1)u(g)&&(S=1,f=!0);else if(u(g))if(f=!0,u(l.charCodeAt(1))){let P=2,N=P;for(;P<D&&!u(l.charCodeAt(P));)P++;if(P<D&&P!==N){const O=l.slice(N,P);for(N=P;P<D&&u(l.charCodeAt(P));)P++;if(P<D&&P!==N){for(N=P;P<D&&!u(l.charCodeAt(P));)P++;(P===D||P!==N)&&(b=`\\\\${O}\\${l.slice(N,P)}`,S=P)}}}else S=1;else r(g)&&l.charCodeAt(1)===R&&(b=l.slice(0,2),S=2,D>2&&u(l.charCodeAt(2))&&(f=!0,S=3));if(b.length>0)if(n.length>0){if(b.toLowerCase()!==n.toLowerCase())continue}else n=b;if(i){if(n.length>0)break}else if(a=`${l.slice(S)}\\${a}`,i=f,f&&n.length>0)break}return a=o(a,!i,"\\",u),i?`${n}\\${a}`:`${n}${a}`||"."},normalize(t){k(t,"path");const n=t.length;if(n===0)return".";let a=0,i,s=!1;const l=t.charCodeAt(0);if(n===1)return c(l)?"\\":t;if(u(l))if(s=!0,u(t.charCodeAt(1))){let S=2,b=S;for(;S<n&&!u(t.charCodeAt(S));)S++;if(S<n&&S!==b){const f=t.slice(b,S);for(b=S;S<n&&u(t.charCodeAt(S));)S++;if(S<n&&S!==b){for(b=S;S<n&&!u(t.charCodeAt(S));)S++;if(S===n)return`\\\\${f}\\${t.slice(b)}\\`;S!==b&&(i=`\\\\${f}\\${t.slice(b,S)}`,a=S)}}}else a=1;else r(l)&&t.charCodeAt(1)===R&&(i=t.slice(0,2),a=2,n>2&&u(t.charCodeAt(2))&&(s=!0,a=3));let D=a<n?o(t.slice(a),!s,"\\",u):"";return D.length===0&&!s&&(D="."),D.length>0&&u(t.charCodeAt(n-1))&&(D+="\\"),i===void 0?s?`\\${D}`:D:s?`${i}\\${D}`:`${i}${D}`},isAbsolute(t){k(t,"path");const n=t.length;if(n===0)return!1;const a=t.charCodeAt(0);return u(a)||n>2&&r(a)&&t.charCodeAt(1)===R&&u(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let n,a;for(let l=0;l<t.length;++l){const D=t[l];k(D,"path"),D.length>0&&(n===void 0?n=a=D:n+=`\\${D}`)}if(n===void 0)return".";let i=!0,s=0;if(typeof a=="string"&&u(a.charCodeAt(0))){++s;const l=a.length;l>1&&u(a.charCodeAt(1))&&(++s,l>2&&(u(a.charCodeAt(2))?++s:i=!1))}if(i){for(;s<n.length&&u(n.charCodeAt(s));)s++;s>=2&&(n=`\\${n.slice(s)}`)}return e.$fc.normalize(n)},relative(t,n){if(k(t,"from"),k(n,"to"),t===n)return"";const a=e.$fc.resolve(t),i=e.$fc.resolve(n);if(a===i||(t=a.toLowerCase(),n=i.toLowerCase(),t===n))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===v;)s++;let l=t.length;for(;l-1>s&&t.charCodeAt(l-1)===v;)l--;const D=l-s;let S=0;for(;S<n.length&&n.charCodeAt(S)===v;)S++;let b=n.length;for(;b-1>S&&n.charCodeAt(b-1)===v;)b--;const f=b-S,g=D<f?D:f;let P=-1,N=0;for(;N<g;N++){const M=t.charCodeAt(s+N);if(M!==n.charCodeAt(S+N))break;M===v&&(P=N)}if(N!==g){if(P===-1)return i}else{if(f>g){if(n.charCodeAt(S+N)===v)return i.slice(S+N+1);if(N===2)return i.slice(S+N)}D>g&&(t.charCodeAt(s+N)===v?P=N:N===2&&(P=3)),P===-1&&(P=0)}let O="";for(N=s+P+1;N<=l;++N)(N===l||t.charCodeAt(N)===v)&&(O+=O.length===0?"..":"\\..");return S+=P,O.length>0?`${O}${i.slice(S,b)}`:(i.charCodeAt(S)===v&&++S,i.slice(S,b))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const n=e.$fc.resolve(t);if(n.length<=2)return t;if(n.charCodeAt(0)===v){if(n.charCodeAt(1)===v){const a=n.charCodeAt(2);if(a!==I&&a!==$)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(r(n.charCodeAt(0))&&n.charCodeAt(1)===R&&n.charCodeAt(2)===v)return`\\\\?\\${n}`;return t},dirname(t){k(t,"path");const n=t.length;if(n===0)return".";let a=-1,i=0;const s=t.charCodeAt(0);if(n===1)return u(s)?t:".";if(u(s)){if(a=i=1,u(t.charCodeAt(1))){let S=2,b=S;for(;S<n&&!u(t.charCodeAt(S));)S++;if(S<n&&S!==b){for(b=S;S<n&&u(t.charCodeAt(S));)S++;if(S<n&&S!==b){for(b=S;S<n&&!u(t.charCodeAt(S));)S++;if(S===n)return t;S!==b&&(a=i=S+1)}}}}else r(s)&&t.charCodeAt(1)===R&&(a=n>2&&u(t.charCodeAt(2))?3:2,i=a);let l=-1,D=!0;for(let S=n-1;S>=i;--S)if(u(t.charCodeAt(S))){if(!D){l=S;break}}else D=!1;if(l===-1){if(a===-1)return".";l=a}return t.slice(0,l)},basename(t,n){n!==void 0&&k(n,"ext"),k(t,"path");let a=0,i=-1,s=!0,l;if(t.length>=2&&r(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(a=2),n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let D=n.length-1,S=-1;for(l=t.length-1;l>=a;--l){const b=t.charCodeAt(l);if(u(b)){if(!s){a=l+1;break}}else S===-1&&(s=!1,S=l+1),D>=0&&(b===n.charCodeAt(D)?--D===-1&&(i=l):(D=-1,i=S))}return a===i?i=S:i===-1&&(i=t.length),t.slice(a,i)}for(l=t.length-1;l>=a;--l)if(u(t.charCodeAt(l))){if(!s){a=l+1;break}}else i===-1&&(s=!1,i=l+1);return i===-1?"":t.slice(a,i)},extname(t){k(t,"path");let n=0,a=-1,i=0,s=-1,l=!0,D=0;t.length>=2&&t.charCodeAt(1)===R&&r(t.charCodeAt(0))&&(n=i=2);for(let S=t.length-1;S>=n;--S){const b=t.charCodeAt(S);if(u(b)){if(!l){i=S+1;break}continue}s===-1&&(l=!1,s=S+1),b===$?a===-1?a=S:D!==1&&(D=1):a!==-1&&(D=-1)}return a===-1||s===-1||D===0||D===1&&a===s-1&&a===i+1?"":t.slice(a,s)},format:m.bind(null,"\\"),parse(t){k(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const a=t.length;let i=0,s=t.charCodeAt(0);if(a===1)return u(s)?(n.root=n.dir=t,n):(n.base=n.name=t,n);if(u(s)){if(i=1,u(t.charCodeAt(1))){let P=2,N=P;for(;P<a&&!u(t.charCodeAt(P));)P++;if(P<a&&P!==N){for(N=P;P<a&&u(t.charCodeAt(P));)P++;if(P<a&&P!==N){for(N=P;P<a&&!u(t.charCodeAt(P));)P++;P===a?i=P:P!==N&&(i=P+1)}}}}else if(r(s)&&t.charCodeAt(1)===R){if(a<=2)return n.root=n.dir=t,n;if(i=2,u(t.charCodeAt(2))){if(a===3)return n.root=n.dir=t,n;i=3}}i>0&&(n.root=t.slice(0,i));let l=-1,D=i,S=-1,b=!0,f=t.length-1,g=0;for(;f>=i;--f){if(s=t.charCodeAt(f),u(s)){if(!b){D=f+1;break}continue}S===-1&&(b=!1,S=f+1),s===$?l===-1?l=f:g!==1&&(g=1):l!==-1&&(g=-1)}return S!==-1&&(l===-1||g===0||g===1&&l===S-1&&l===D+1?n.base=n.name=t.slice(D,S):(n.name=t.slice(D,l),n.base=t.slice(D,S),n.ext=t.slice(l,S))),D>0&&D!==i?n.dir=t.slice(0,D-1):n.dir=n.root,n},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(p){const t=/\\/g;return()=>{const n=C.cwd().replace(t,"/");return n.slice(n.indexOf("/"))}}return()=>C.cwd()})();e.$gc={resolve(...t){let n="",a=!1;for(let i=t.length-1;i>=-1&&!a;i--){const s=i>=0?t[i]:h();k(s,"path"),s.length!==0&&(n=`${s}/${n}`,a=s.charCodeAt(0)===E)}return n=o(n,!a,"/",c),a?`/${n}`:n.length>0?n:"."},normalize(t){if(k(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===E,a=t.charCodeAt(t.length-1)===E;return t=o(t,!n,"/",c),t.length===0?n?"/":a?"./":".":(a&&(t+="/"),n?`/${t}`:t)},isAbsolute(t){return k(t,"path"),t.length>0&&t.charCodeAt(0)===E},join(...t){if(t.length===0)return".";let n;for(let a=0;a<t.length;++a){const i=t[a];k(i,"path"),i.length>0&&(n===void 0?n=i:n+=`/${i}`)}return n===void 0?".":e.$gc.normalize(n)},relative(t,n){if(k(t,"from"),k(n,"to"),t===n||(t=e.$gc.resolve(t),n=e.$gc.resolve(n),t===n))return"";const a=1,i=t.length,s=i-a,l=1,D=n.length-l,S=s<D?s:D;let b=-1,f=0;for(;f<S;f++){const P=t.charCodeAt(a+f);if(P!==n.charCodeAt(l+f))break;P===E&&(b=f)}if(f===S)if(D>S){if(n.charCodeAt(l+f)===E)return n.slice(l+f+1);if(f===0)return n.slice(l+f)}else s>S&&(t.charCodeAt(a+f)===E?b=f:f===0&&(b=0));let g="";for(f=a+b+1;f<=i;++f)(f===i||t.charCodeAt(f)===E)&&(g+=g.length===0?"..":"/..");return`${g}${n.slice(l+b)}`},toNamespacedPath(t){return t},dirname(t){if(k(t,"path"),t.length===0)return".";const n=t.charCodeAt(0)===E;let a=-1,i=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===E){if(!i){a=s;break}}else i=!1;return a===-1?n?"/":".":n&&a===1?"//":t.slice(0,a)},basename(t,n){n!==void 0&&k(n,"ext"),k(t,"path");let a=0,i=-1,s=!0,l;if(n!==void 0&&n.length>0&&n.length<=t.length){if(n===t)return"";let D=n.length-1,S=-1;for(l=t.length-1;l>=0;--l){const b=t.charCodeAt(l);if(b===E){if(!s){a=l+1;break}}else S===-1&&(s=!1,S=l+1),D>=0&&(b===n.charCodeAt(D)?--D===-1&&(i=l):(D=-1,i=S))}return a===i?i=S:i===-1&&(i=t.length),t.slice(a,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===E){if(!s){a=l+1;break}}else i===-1&&(s=!1,i=l+1);return i===-1?"":t.slice(a,i)},extname(t){k(t,"path");let n=-1,a=0,i=-1,s=!0,l=0;for(let D=t.length-1;D>=0;--D){const S=t.charCodeAt(D);if(S===E){if(!s){a=D+1;break}continue}i===-1&&(s=!1,i=D+1),S===$?n===-1?n=D:l!==1&&(l=1):n!==-1&&(l=-1)}return n===-1||i===-1||l===0||l===1&&n===i-1&&n===a+1?"":t.slice(n,i)},format:m.bind(null,"/"),parse(t){k(t,"path");const n={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return n;const a=t.charCodeAt(0)===E;let i;a?(n.root="/",i=1):i=0;let s=-1,l=0,D=-1,S=!0,b=t.length-1,f=0;for(;b>=i;--b){const g=t.charCodeAt(b);if(g===E){if(!S){l=b+1;break}continue}D===-1&&(S=!1,D=b+1),g===$?s===-1?s=b:f!==1&&(f=1):s!==-1&&(f=-1)}if(D!==-1){const g=l===0&&a?1:l;s===-1||f===0||f===1&&s===D-1&&s===l+1?n.base=n.name=t.slice(g,D):(n.name=t.slice(g,s),n.base=t.slice(g,D),n.ext=t.slice(s,D))}return l>0?n.dir=t.slice(0,l-1):a&&(n.dir="/"),n},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=p?e.$fc.normalize:e.$gc.normalize,e.$ic=p?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=p?e.$fc.join:e.$gc.join,e.$kc=p?e.$fc.resolve:e.$gc.resolve,e.$lc=p?e.$fc.relative:e.$gc.relative,e.$mc=p?e.$fc.dirname:e.$gc.dirname,e.$nc=p?e.$fc.basename:e.$gc.basename,e.$oc=p?e.$fc.extname:e.$gc.extname,e.$pc=p?e.$fc.format:e.$gc.format,e.$qc=p?e.$fc.parse:e.$gc.parse,e.$rc=p?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=p?e.$fc.sep:e.$gc.sep,e.$tc=p?e.$fc.delimiter:e.$gc.delimiter}),define(De[126],Ce([1,0,47,16]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=void 0;const d=new C.$V(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),L=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(S,b,f=!1){const g=S||"",P=b||"",N=d.value.collator.compare(g,P);return d.value.collatorIsNumeric&&N===0&&g!==P?g<P?-1:1:N}e.$fq=$;function E(S,b){const f=L.value.collator;return S=S||"",b=b||"",m(f,S,b)}e.$gq=E;function v(S,b){const f=L.value.collator;return S=S||"",b=b||"",a(S,b)||m(f,S,b)}e.$hq=v;function R(S,b){const f=L.value.collator;return S=S||"",b=b||"",n(S,b)||m(f,S,b)}e.$iq=R;function I(S,b){return S=S||"",b=b||"",S===b?0:S<b?-1:1}e.$jq=I;function w(S,b){const[f,g]=r(S),[P,N]=r(b);let O=d.value.collator.compare(g,N);if(O===0){if(d.value.collatorIsNumeric&&g!==N)return g<N?-1:1;if(O=d.value.collator.compare(f,P),d.value.collatorIsNumeric&&O===0&&f!==P)return f<P?-1:1}return O}e.$kq=w;function y(S,b){S=S||"",b=b||"";const f=o(S),g=o(b),P=L.value.collator,N=A.value.collator;return m(N,f,g)||m(P,S,b)}e.$lq=y;function k(S,b){S=S||"",b=b||"";const f=o(S),g=o(b),P=L.value.collator,N=A.value.collator;return m(N,f,g)||a(S,b)||m(P,S,b)}e.$mq=k;function p(S,b){S=S||"",b=b||"";const f=o(S),g=o(b),P=L.value.collator,N=A.value.collator;return m(N,f,g)||n(S,b)||m(P,S,b)}e.$nq=p;function u(S,b){S=S||"",b=b||"";const f=o(S).toLowerCase(),g=o(b).toLowerCase();return f!==g?f<g?-1:1:S!==b?S<b?-1:1:0}e.$oq=u;const c=/^(.*?)(\.([^.]*))?$/;function r(S,b=!1){const f=S?c.exec(S):[];let g=[f&&f[1]||"",f&&f[3]||""];return b&&(!g[0]&&g[1]||g[0]&&g[0].charAt(0)===".")&&(g=[g[0]+"."+g[1],""]),g}function o(S){const b=S?c.exec(S):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function m(S,b,f){const g=S.compare(b,f);return g!==0?g:b.length!==f.length?b.length<f.length?-1:1:0}function h(S){const b=S.charAt(0);return b.toLocaleUpperCase()!==b}function t(S){const b=S.charAt(0);return b.toLocaleLowerCase()!==b}function n(S,b){return h(S)&&t(b)?-1:t(S)&&h(b)?1:0}function a(S,b){return t(S)&&h(b)?-1:h(S)&&t(b)?1:0}function i(S,b,f=!1){return f||(S=S&&S.toLowerCase(),b=b&&b.toLowerCase()),S===b?0:S<b?-1:1}function s(S,b,f=!1){const g=S.split(T.sep),P=b.split(T.sep),N=g.length-1,O=P.length-1;let M,j;for(let z=0;;z++){if(M=N===z,j=O===z,M&&j)return $(g[z],P[z],f);if(M)return-1;if(j)return 1;const F=i(g[z],P[z],f);if(F!==0)return F}}e.$pq=s;function l(S,b,f){const g=S.toLowerCase(),P=b.toLowerCase(),N=D(S,b,f);if(N)return N;const O=g.endsWith(f),M=P.endsWith(f);if(O!==M)return O?-1:1;const j=$(g,P);return j!==0?j:g.localeCompare(P)}e.$qq=l;function D(S,b,f){const g=S.toLowerCase(),P=b.toLowerCase(),N=g.startsWith(f),O=P.startsWith(f);if(N!==O)return N?-1:1;if(N&&O){if(g.length<P.length)return-1;if(g.length>P.length)return 1}return 0}e.$rq=D}),define(De[32],Ce([1,0,16,12,15,17]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function A(l){return l===47||l===92}e.$Qf=A;function $(l){return l.replace(/[\\/]/g,C.$gc.sep)}e.$Rf=$;function E(l){return l.indexOf("/")===-1&&(l=$(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$Sf=E;function v(l,D=C.$gc.sep){if(!l)return"";const S=l.length,b=l.charCodeAt(0);if(A(b)){if(A(l.charCodeAt(1))&&!A(l.charCodeAt(2))){let g=3;const P=g;for(;g<S&&!A(l.charCodeAt(g));g++);if(P!==g&&!A(l.charCodeAt(g+1))){for(g+=1;g<S;g++)if(A(l.charCodeAt(g)))return l.slice(0,g+1).replace(/[\\/]/g,D)}}return D}else if(c(b)&&l.charCodeAt(1)===58)return A(l.charCodeAt(2))?l.slice(0,2)+D:l.slice(0,2);let f=l.indexOf("://");if(f!==-1){for(f+=3;f<S;f++)if(A(l.charCodeAt(f)))return l.slice(0,f+1)}return""}e.$Tf=v;function R(l){if(!T.$j||!l||l.length<5)return!1;let D=l.charCodeAt(0);if(D!==92||(D=l.charCodeAt(1),D!==92))return!1;let S=2;const b=S;for(;S<l.length&&(D=l.charCodeAt(S),D!==92);S++);return!(b===S||(D=l.charCodeAt(S+1),isNaN(D)||D===92))}e.$Uf=R;const I=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function k(l,D=T.$j){const S=D?I:w;return!(!l||l.length===0||/^\s+$/.test(l)||(S.lastIndex=0,S.test(l))||D&&y.test(l)||l==="."||l===".."||D&&l[l.length-1]==="."||D&&l.length!==l.trim().length||l.length>255)}e.$Vf=k;function p(l,D,S){const b=l===D;return!S||b?b:!l||!D?!1:(0,d.$2e)(l,D)}e.$Wf=p;function u(l,D,S,b=C.sep){if(l===D)return!0;if(!l||!D||D.length>l.length)return!1;if(S){if(!(0,d.$3e)(l,D))return!1;if(D.length===l.length)return!0;let g=D.length;return D.charAt(D.length-1)===b&&g--,l.charAt(g)===b}return D.charAt(D.length-1)!==b&&(D+=b),l.indexOf(D)===0}e.$Xf=u;function c(l){return l>=65&&l<=90||l>=97&&l<=122}e.$Yf=c;function r(l,D){return T.$j&&l.endsWith(":")&&(l+=C.sep),(0,C.$ic)(l)||(l=(0,C.$jc)(D,l)),l=(0,C.$hc)(l),T.$j?(l=(0,d.$Ke)(l,C.sep),l.endsWith(":")&&(l+=C.sep)):(l=(0,d.$Ke)(l,C.sep),l||(l=C.sep)),l}e.$Zf=r;function o(l){const D=(0,C.$hc)(l);return T.$j?l.length>3?!1:m(D)&&(l.length===2||D.charCodeAt(2)===92):D===C.$gc.sep}e.$1f=o;function m(l,D=T.$j){return D?c(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$2f=m;function h(l,D=T.$j){return m(l,D)?l[0]:void 0}e.$3f=h;function t(l,D,S){return D.length>l.length?-1:l===D?0:(S&&(l=l.toLowerCase(),D=D.toLowerCase()),l.indexOf(D))}e.$4f=t;function n(l){const D=l.split(":");let S,b,f;for(const g of D){const P=Number(g);(0,L.$Cf)(P)?b===void 0?b=P:f===void 0&&(f=P):S=S?[S,g].join(":"):g}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:b!==void 0?b:void 0,column:f!==void 0?f:b!==void 0?1:void 0}}e.$5f=n;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(l,D,S=8){let b="";for(let g=0;g<S;g++){let P;g===0&&T.$j&&!D&&(S===3||S===4)?P=i:P=a,b+=P.charAt(Math.floor(Math.random()*P.length))}let f;return D?f=`${D}-${b}`:f=b,l?(0,C.$jc)(l,f):f}e.$6f=s}),define(De[127],Ce([1,0,126,121,52,16,12,15]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=void 0;const E=0,v=[E,[]];function R(K,V,fe,Z){if(!K||!V)return v;const Q=K.length,X=V.length;if(Q<X)return v;const oe=K.toLowerCase();return I(V,fe,X,K,oe,Q,Z)}e.$sq=R;function I(K,V,fe,Z,Q,X,oe){const x=[],ae=[];for(let q=0;q<fe;q++){const me=q*X,ee=me-X,ne=q>0,re=K[q],Ee=V[q];for(let ce=0;ce<X;ce++){const de=ce>0,te=me+ce,he=te-1,be=ee+ce-1,Pe=de?x[he]:0,B=ne&&de?x[be]:0,J=ne&&de?ae[be]:0;let ie;!B&&ne?ie=0:ie=w(re,Ee,Z,Q,ce,J),ie&&B+ie>=Pe&&(oe||ne||Q.startsWith(V,ce))?(ae[te]=J+1,x[te]=B+ie):(ae[te]=E,x[te]=Pe)}}const we=[];let G=fe-1,U=X-1;for(;G>=0&&U>=0;){const q=G*X+U;ae[q]===E||(we.push(U),G--),U--}return[x[fe*X-1],we.reverse()]}function w(K,V,fe,Z,Q,X){let oe=0;if(!y(V,Z[Q]))return oe;if(oe+=1,X>0&&(oe+=X*5),K===fe[Q]&&(oe+=1),Q===0)oe+=8;else{const x=k(fe.charCodeAt(Q-1));x?oe+=x:(0,T.$Fj)(fe.charCodeAt(Q))&&X===0&&(oe+=2)}return oe}function y(K,V){return K===V?!0:K==="/"||K==="\\"?V==="/"||V==="\\":!1}function k(K){switch(K){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function u(K,V,fe=0,Z=0){const Q=V;return Q.values&&Q.values.length>1?c(K,Q.values,fe,Z):r(K,V,fe,Z)}e.$tq=u;function c(K,V,fe,Z){let Q=0;const X=[];for(const oe of V){const[x,ae]=r(K,oe,fe,Z);if(typeof x!="number")return p;Q+=x,X.push(...ae)}return[Q,S(X)]}function r(K,V,fe,Z){const Q=(0,T.$Oj)(V.original,V.originalLowercase,fe,K,K.toLowerCase(),Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,T.$Lj)(Q)]:p}const o=Object.freeze({score:0}),m=1<<18,h=1<<17,t=1<<16;function n(K,V,fe,Z){const Q=Z.values?Z.values:[Z];return(0,d.$Ci)({[Z.normalized]:{values:Q.map(oe=>({value:oe.normalized,expectContiguousMatch:oe.expectContiguousMatch})),label:K,description:V,allowNonContiguousMatches:fe}})}function a(K,V,fe,Z,Q){if(!K||!V.normalized)return o;const X=Z.getItemLabel(K);if(!X)return o;const oe=Z.getItemDescription(K),x=n(X,oe,fe,V),ae=Q[x];if(ae)return ae;const we=i(X,oe,Z.getItemPath(K),V,fe);return Q[x]=we,we}e.$uq=a;function i(K,V,fe,Z,Q){const X=!fe||!Z.containsPathSeparator;return fe&&(A.$l?Z.pathNormalized===fe:(0,$.$2e)(Z.pathNormalized,fe))?{score:m,labelMatch:[{start:0,end:K.length}],descriptionMatch:V?[{start:0,end:V.length}]:void 0}:Z.values&&Z.values.length>1?s(K,V,fe,Z.values,X,Q):l(K,V,fe,Z,X,Q)}function s(K,V,fe,Z,Q,X){let oe=0;const x=[],ae=[];for(const we of Z){const{score:G,labelMatch:U,descriptionMatch:q}=l(K,V,fe,we,Q,X);if(G===E)return o;oe+=G,U&&x.push(...U),q&&ae.push(...q)}return{score:oe,labelMatch:S(x),descriptionMatch:S(ae)}}function l(K,V,fe,Z,Q,X){if(Q||!V){const[oe,x]=R(K,Z.normalized,Z.normalizedLowercase,X&&!Z.expectContiguousMatch);if(oe){const ae=(0,T.$Cj)(Z.normalized,K);let we;if(ae){we=h;const G=Math.round(Z.normalized.length/K.length*100);we+=G}else we=t;return{score:we+oe,labelMatch:ae||D(x)}}}if(V){let oe=V;fe&&(oe=`${V}${L.sep}`);const x=oe.length,ae=`${oe}${K}`,[we,G]=R(ae,Z.normalized,Z.normalizedLowercase,X&&!Z.expectContiguousMatch);if(we){const U=D(G),q=[],me=[];return U.forEach(ee=>{ee.start<x&&ee.end>x?(q.push({start:0,end:ee.end-x}),me.push({start:ee.start,end:x})):ee.start>=x?q.push({start:ee.start-x,end:ee.end-x}):me.push(ee)}),{score:we,labelMatch:q,descriptionMatch:me}}}return o}function D(K){const V=[];if(!K)return V;let fe;for(const Z of K)fe&&fe.end===Z?fe.end+=1:(fe={start:Z,end:Z+1},V.push(fe));return V}function S(K){const V=K.sort((Q,X)=>Q.start-X.start),fe=[];let Z;for(const Q of V)!Z||!b(Z,Q)?(Z=Q,fe.push(Q)):(Z.start=Math.min(Z.start,Q.start),Z.end=Math.max(Z.end,Q.end));return fe}function b(K,V){return!(K.end<V.start||V.end<K.start)}function f(K,V,fe,Z,Q,X){const oe=a(K,fe,Z,Q,X),x=a(V,fe,Z,Q,X),ae=oe.score,we=x.score;if((ae===m||we===m)&&ae!==we)return ae===m?-1:1;if(ae>t||we>t){if(ae!==we)return ae>we?-1:1;if(ae<h&&we<h){const re=P(oe.labelMatch,x.labelMatch);if(re!==0)return re}const ee=Q.getItemLabel(K)||"",ne=Q.getItemLabel(V)||"";if(ee.length!==ne.length)return ee.length-ne.length}if(ae!==we)return ae>we?-1:1;const G=Array.isArray(oe.labelMatch)&&oe.labelMatch.length>0,U=Array.isArray(x.labelMatch)&&x.labelMatch.length>0;if(G&&!U)return-1;if(U&&!G)return 1;const q=g(K,oe,Q),me=g(V,x,Q);return q&&me&&q!==me?me>q?-1:1:N(K,V,fe,Q)}e.$vq=f;function g(K,V,fe){let Z=-1,Q=-1;if(V.descriptionMatch&&V.descriptionMatch.length?Z=V.descriptionMatch[0].start:V.labelMatch&&V.labelMatch.length&&(Z=V.labelMatch[0].start),V.labelMatch&&V.labelMatch.length){if(Q=V.labelMatch[V.labelMatch.length-1].end,V.descriptionMatch&&V.descriptionMatch.length){const X=fe.getItemDescription(K);X&&(Q+=X.length)}}else V.descriptionMatch&&V.descriptionMatch.length&&(Q=V.descriptionMatch[V.descriptionMatch.length-1].end);return Q-Z}function P(K,V){if(!K&&!V||(!K||!K.length)&&(!V||!V.length))return 0;if(!V||!V.length)return-1;if(!K||!K.length)return 1;const fe=K[0].start,Q=K[K.length-1].end-fe,X=V[0].start,x=V[V.length-1].end-X;return Q===x?0:x<Q?1:-1}function N(K,V,fe,Z){const Q=Z.getItemLabel(K)||"",X=Z.getItemLabel(V)||"",oe=Z.getItemDescription(K),x=Z.getItemDescription(V),ae=Q.length+(oe?oe.length:0),we=X.length+(x?x.length:0);if(ae!==we)return ae-we;const G=Z.getItemPath(K),U=Z.getItemPath(V);return G&&U&&G.length!==U.length?G.length-U.length:Q!==X?(0,C.$qq)(Q,X,fe.normalized):oe&&x&&oe!==x?(0,C.$qq)(oe,x,fe.normalized):G&&U&&G!==U?(0,C.$qq)(G,U,fe.normalized):0}function O(K){return K.startsWith('"')&&K.endsWith('"')}const M=" ";function j(K){typeof K!="string"&&(K="");const V=K.toLowerCase(),{pathNormalized:fe,normalized:Z,normalizedLowercase:Q}=z(K),X=fe.indexOf(L.sep)>=0,oe=O(K);let x;const ae=K.split(M);if(ae.length>1)for(const we of ae){const G=O(we),{pathNormalized:U,normalized:q,normalizedLowercase:me}=z(we);q&&(x||(x=[]),x.push({original:we,originalLowercase:we.toLowerCase(),pathNormalized:U,normalized:q,normalizedLowercase:me,expectContiguousMatch:G}))}return{original:K,originalLowercase:V,pathNormalized:fe,normalized:Z,normalizedLowercase:Q,values:x,containsPathSeparator:X,expectContiguousMatch:oe}}e.$wq=j;function z(K){let V;A.$j?V=K.replace(/\//g,L.sep):V=K.replace(/\\/g,L.sep);const fe=(0,$.$Me)(V).replace(/\s|"/g,"");return{pathNormalized:V,normalized:fe,normalizedLowercase:fe.toLowerCase()}}function F(K){return Array.isArray(K)?j(K.map(V=>V.original).join(M)):j(K.original)}e.$xq=F}),define(De[97],Ce([1,0,16]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=e.$Pr=e.$Or=e.$Nr=void 0,e.$Nr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},d={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(R){const I=(0,C.$oc)(R),w=T[I.toLowerCase()];return w!==void 0?w:A(R)}e.$Or=L;function A(R){const I=(0,C.$oc)(R);return d[I.toLowerCase()]}e.$Pr=A;function $(R){for(const I in d)if(d[I]===R)return I}e.$Qr=$;const E=/^(.+)\/(.+?)(;.+)?$/;function v(R,I){const w=E.exec(R);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:I?void 0:R}e.$Rr=v}),define(De[98],Ce([1,0,12]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=e.TerminateResponseCode=e.Source=void 0;var T;(function($){$[$.stdout=0]="stdout",$[$.stderr=1]="stderr"})(T||(e.Source=T={}));var d;(function($){$[$.Success=0]="Success",$[$.Unknown=1]="Unknown",$[$.AccessDenied=2]="AccessDenied",$[$.ProcessNotFound=3]="ProcessNotFound"})(d||(e.TerminateResponseCode=d={}));function L($,...E){const v=E.reduce((w,y)=>(w[y]=!0,w),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys($).filter(w=>!v[w]).forEach(w=>{for(let y=0;y<R.length;y++)if(w.search(R[y])!==-1){delete $[w];break}})}e.$xl=L;function A($){$&&(delete $.DEBUG,C.$k&&delete $.DYLD_LIBRARY_PATH,C.$l&&delete $.LD_PRELOAD)}e.$yl=A}),define(De[2],Ce([1,0,16,12]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const d=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function $(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!d.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(i,s){return!i&&!s?"file":i}function v(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==I&&(s=I+s):s=I;break}return s}const R="",I="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(s){return s instanceof y?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,l,D,S,b,f=!1){typeof s=="object"?(this.scheme=s.scheme||R,this.authority=s.authority||R,this.path=s.path||R,this.query=s.query||R,this.fragment=s.fragment||R):(this.scheme=E(s,f),this.authority=l||R,this.path=v(this.scheme,D||R),this.query=S||R,this.fragment=b||R,$(this,f))}get fsPath(){return m(this,!1)}with(s){if(!s)return this;let{scheme:l,authority:D,path:S,query:b,fragment:f}=s;return l===void 0?l=this.scheme:l===null&&(l=R),D===void 0?D=this.authority:D===null&&(D=R),S===void 0?S=this.path:S===null&&(S=R),b===void 0?b=this.query:b===null&&(b=R),f===void 0?f=this.fragment:f===null&&(f=R),l===this.scheme&&D===this.authority&&S===this.path&&b===this.query&&f===this.fragment?this:new u(l,D,S,b,f)}static parse(s,l=!1){const D=w.exec(s);return D?new u(D[2]||R,a(D[4]||R),a(D[5]||R),a(D[7]||R),a(D[9]||R),l):new u(R,R,R,R,R)}static file(s){let l=R;if(T.$j&&(s=s.replace(/\\/g,I)),s[0]===I&&s[1]===I){const D=s.indexOf(I,2);D===-1?(l=s.substring(2),s=I):(l=s.substring(2,D),s=s.substring(D)||I)}return new u("file",l,s,R,R)}static from(s,l){return new u(s.scheme,s.authority,s.path,s.query,s.fragment,l)}static joinPath(s,...l){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let D;return T.$j&&s.scheme==="file"?D=y.file(C.$fc.join(m(s,!0),...l)).path:D=C.$gc.join(s.path,...l),s.with({path:D})}toString(s=!1){return h(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof y)return s;{const l=new u(s);return l._formatted=s.external??null,l._fsPath=s._sep===p?s.fsPath??null:null,l}}else return s}}e.URI=y;function k(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=k;const p=T.$j?1:void 0;class u extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(s=!1){return s?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=p),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function r(i,s,l){let D,S=-1;for(let b=0;b<i.length;b++){const f=i.charCodeAt(b);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||s&&f===47||l&&f===91||l&&f===93||l&&f===58)S!==-1&&(D+=encodeURIComponent(i.substring(S,b)),S=-1),D!==void 0&&(D+=i.charAt(b));else{D===void 0&&(D=i.substr(0,b));const g=c[f];g!==void 0?(S!==-1&&(D+=encodeURIComponent(i.substring(S,b)),S=-1),D+=g):S===-1&&(S=b)}}return S!==-1&&(D+=encodeURIComponent(i.substring(S))),D!==void 0?D:i}function o(i){let s;for(let l=0;l<i.length;l++){const D=i.charCodeAt(l);D===35||D===63?(s===void 0&&(s=i.substr(0,l)),s+=c[D]):s!==void 0&&(s+=i[l])}return s!==void 0?s:i}function m(i,s){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,T.$j&&(l=l.replace(/\//g,"\\")),l}e.$wc=m;function h(i,s){const l=s?o:r;let D="",{scheme:S,authority:b,path:f,query:g,fragment:P}=i;if(S&&(D+=S,D+=":"),(b||S==="file")&&(D+=I,D+=I),b){let N=b.indexOf("@");if(N!==-1){const O=b.substr(0,N);b=b.substr(N+1),N=O.lastIndexOf(":"),N===-1?D+=l(O,!1,!1):(D+=l(O.substr(0,N),!1,!1),D+=":",D+=l(O.substr(N+1),!1,!0)),D+="@"}b=b.toLowerCase(),N=b.lastIndexOf(":"),N===-1?D+=l(b,!1,!0):(D+=l(b.substr(0,N),!1,!0),D+=b.substr(N))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const N=f.charCodeAt(1);N>=65&&N<=90&&(f=`/${String.fromCharCode(N+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const N=f.charCodeAt(0);N>=65&&N<=90&&(f=`${String.fromCharCode(N+32)}:${f.substr(2)}`)}D+=l(f,!0,!1)}return g&&(D+="?",D+=l(g,!1,!1)),P&&(D+="#",D+=s?P:r(P,!1,!1)),D}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(n)?i.replace(n,s=>t(s)):i}}),define(De[181],Ce([1,0,2]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Xp=e.$Wp=e.$Vp=void 0;function T(v){const R=v;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$Vp=T;function d(v){const R=[];let I;try{const w=JSON.parse(v.arguments),y=w[w.length-1];y&&y.__$stack&&(w.pop(),I=y.__$stack),R.push(...w)}catch{R.push("Unable to log remote console arguments",v.arguments)}return{args:R,stack:I}}e.$Wp=d;function L(v){if(typeof v!="string")return L(d(v).stack);const R=v;if(R){const I=A(R),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(w&&w.length===4)return{uri:C.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.$Xp=L;function A(v){if(!v)return v;const R=v.indexOf(`
`);return R===-1?v:v.substring(0,R)}function $(v,R){const{args:I,stack:w}=d(v),y=typeof I[0]=="string"&&I.length===1;let k=A(w);k&&(k=`(${k.trim()})`);let p=[];if(typeof I[0]=="string"?k&&y?p=[`%c[${R}] %c${I[0]} %c${k}`,E("blue"),E(""),E("grey")]:p=[`%c[${R}] %c${I[0]}`,E("blue"),E(""),...I.slice(1)]:p=[`%c[${R}]%`,E("blue"),...I],k&&!y&&p.push(k),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,p)}e.log=$;function E(v){return`color: ${v}`}}),define(De[62],Ce([1,0,22,2]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=e.$kh=e.$jh=void 0;function d(E){return JSON.stringify(E,A)}e.$jh=d;function L(E){let v=JSON.parse(E);return v=$(v),v}e.$kh=L;function A(E,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:v.flags}:v}function $(E,v=0){if(!E||v>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return T.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof C.$be||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let R=0;R<E.length;++R)E[R]=$(E[R],v+1);else for(const R in E)Object.hasOwnProperty.call(E,R)&&(E[R]=$(E[R],v+1))}return E}e.$lh=$}),define(De[18],Ce([1,0,8,12,2]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var L;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$7f="vscode-tkn",e.$8f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${L.vscodeRemoteResource}`}set(R,I,w){this.a[R]=I,this.b[R]=w}setConnectionToken(R,I){this.c[R]=I}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(u){return C.$1(u),R}const I=R.authority;let w=this.a[I];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const y=this.b[I],k=this.c[I];let p=`path=${encodeURIComponent(R.path)}`;return typeof k=="string"&&(p+=`&${e.$8f}=${encodeURIComponent(k)}`),d.URI.from({scheme:T.$p?this.d:L.vscodeRemoteResource,authority:`${w}:${y}`,path:this.f,query:p})}}e.$9f=new A,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class ${static{this.a=e.$bg}asBrowserUri(R){const I=this.b(R,$e);return this.uriToBrowserUri(I)}uriToBrowserUri(R){return R.scheme===L.vscodeRemote?e.$9f.rewrite(R):R.scheme===L.file&&(T.$n||T.$q&&T.$h.origin===`${L.vscodeFileResource}://${$.a}`)?R.with({scheme:L.vscodeFileResource,authority:R.authority||$.a,query:null,fragment:null}):R}asFileUri(R){const I=this.b(R,$e);return this.uriToFileUri(I)}uriToFileUri(R){return R.scheme===L.vscodeFileResource?R.with({scheme:L.file,authority:R.authority!==$.a?R.authority:null,query:null,fragment:null}):R}b(R,I){return d.URI.isUri(R)?R:d.URI.parse(I.toUrl(R))}}e.$cg=new $;var E;(function(v){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(R.get("3"));const I="vscode-coi";function w(k){let p;typeof k=="string"?p=new URL(k).searchParams:k instanceof URL?p=k.searchParams:d.URI.isUri(k)&&(p=new URL(k.toString(!0)).searchParams);const u=p?.get(I);if(u)return R.get(u)}v.getHeadersFromQuery=w;function y(k,p,u){if(!globalThis.crossOriginIsolated)return;const c=p&&u?"3":u?"2":"1";k instanceof URLSearchParams?k.set(I,c):k[I]=c}v.addSearchParam=y})(E||(e.COI=E={}))}),define(De[182],Ce([1,0,156,18,12,2]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iC=void 0;class A{constructor(w,y,k){this.id=w,this.dependencies=y,this.callback=k}}class ${static{this.INSTANCE=new $}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,y,k)=>{typeof w!="string"&&(k=y,y=w,w=null),(typeof y!="object"||!Array.isArray(y))&&(k=y,y=null),this.c.push(new A(w,y,k))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const y=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!y)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(w){return new Promise((y,k)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const u=()=>{p.removeEventListener("load",c),p.removeEventListener("error",r)},c=o=>{u(),y(this.c.pop())},r=o=>{u(),k(o)};p.addEventListener("load",c),p.addEventListener("error",r),this.f&&(w=this.f.createScriptURL(w)),p.setAttribute("src",w),document.getElementsByTagName("head")[0].appendChild(p)})}i(w){return new Promise((y,k)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),y(this.c.pop())}catch(p){k(p)}})}async j(w){try{const y=globalThis._VSCODE_NODE_MODULES.fs,k=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,u=L.URI.parse(w).fsPath,c=y.readFileSync(u).toString(),r=p.wrap(c.replace(/^#!.*/,""));return new k.Script(r).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const E=new Map;let v={};typeof globalThis.require=="object"&&(v=globalThis.require.paths??{});async function R(I,w,y){if(C.$T){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),v[I]&&(I=v[I]);const k=`${I}/${w}`;if(E.has(k))return E.get(k);let p;if(/^\w[\w\d+.-]*:\/\//.test(k))p=k;else{const o=`${y&&!d.$p?T.$_f:T.$$f}/${k}`;p=T.$cg.asBrowserUri(o).toString(!0)}const u=$.INSTANCE.load(p);return E.set(k,u),u}else return await new Promise((k,p)=>{$e([I],k,p)})}e.$iC=R}),define(De[23],Ce([1,0,32,18,16,12,15,2]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function E(y){return(0,$.$wc)(y,!0)}e.$jg=E;class v{constructor(k){this.a=k}compare(k,p,u=!1){return k===p?0:(0,A.$Ue)(this.getComparisonKey(k,u),this.getComparisonKey(p,u))}isEqual(k,p,u=!1){return k===p?!0:!k||!p?!1:this.getComparisonKey(k,u)===this.getComparisonKey(p,u)}getComparisonKey(k,p=!1){return k.with({path:this.a(k)?k.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(k){return this.a(k)}isEqualOrParent(k,p,u=!1){if(k.scheme===p.scheme){if(k.scheme===T.Schemas.file)return C.$Xf(E(k),E(p),this.a(k))&&k.query===p.query&&(u||k.fragment===p.fragment);if((0,e.$Ag)(k.authority,p.authority))return C.$Xf(k.path,p.path,this.a(k),"/")&&k.query===p.query&&(u||k.fragment===p.fragment)}return!1}joinPath(k,...p){return $.URI.joinPath(k,...p)}basenameOrAuthority(k){return(0,e.$sg)(k)||k.authority}basename(k){return d.$gc.basename(k.path)}extname(k){return d.$gc.extname(k.path)}dirname(k){if(k.path.length===0)return k;let p;return k.scheme===T.Schemas.file?p=$.URI.file(d.$mc(E(k))).path:(p=d.$gc.dirname(k.path),k.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${k.toString})) resulted in a relative path`),p="/")),k.with({path:p})}normalizePath(k){if(!k.path.length)return k;let p;return k.scheme===T.Schemas.file?p=$.URI.file(d.$hc(E(k))).path:p=d.$gc.normalize(k.path),k.with({path:p})}relativePath(k,p){if(k.scheme!==p.scheme||!(0,e.$Ag)(k.authority,p.authority))return;if(k.scheme===T.Schemas.file){const r=d.$lc(E(k),E(p));return L.$j?C.$Rf(r):r}let u=k.path||"/";const c=p.path||"/";if(this.a(k)){let r=0;for(const o=Math.min(u.length,c.length);r<o&&!(u.charCodeAt(r)!==c.charCodeAt(r)&&u.charAt(r).toLowerCase()!==c.charAt(r).toLowerCase());r++);u=c.substr(0,r)+u.substr(r)}return d.$gc.relative(u,c)}resolvePath(k,p){if(k.scheme===T.Schemas.file){const u=$.URI.file(d.$kc(E(k),p));return k.with({authority:u.authority,path:u.path})}return p=C.$Sf(p),k.with({path:d.$gc.resolve(k.path,p)})}isAbsolutePath(k){return!!k.path&&k.path[0]==="/"}isEqualAuthority(k,p){return k===p||k!==void 0&&p!==void 0&&(0,A.$2e)(k,p)}hasTrailingPathSeparator(k,p=d.sep){if(k.scheme===T.Schemas.file){const u=E(k);return u.length>C.$Tf(u).length&&u[u.length-1]===p}else{const u=k.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(k.fsPath)}}removeTrailingPathSeparator(k,p=d.sep){return(0,e.$Bg)(k,p)?k.with({path:k.path.substr(0,k.path.length-1)}):k}addTrailingPathSeparator(k,p=d.sep){let u=!1;if(k.scheme===T.Schemas.file){const c=E(k);u=c!==void 0&&c.length===C.$Tf(c).length&&c[c.length-1]===p}else{p="/";const c=k.path;u=c.length===1&&c.charCodeAt(c.length-1)===47}return!u&&!(0,e.$Bg)(k,p)?k.with({path:k.path+"/"}):k}}e.$kg=v,e.$lg=new v(()=>!1),e.$mg=new v(y=>y.scheme===T.Schemas.file?!L.$l:!0),e.$ng=new v(y=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function R(y,k){const p=[];for(let u=0;u<y.length;u++){const c=k(y[u]);y.some((r,o)=>o===u?!1:(0,e.$pg)(c,k(r)))||p.push(y[u])}return p}e.$Eg=R;var I;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function k(p){const u=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(o=>{const[m,h]=o.split(":");m&&h&&u.set(m,h)});const r=p.path.substring(0,p.path.indexOf(";"));return r&&u.set(y.META_DATA_MIME,r),u}y.parseMetaData=k})(I||(e.DataUri=I={}));function w(y,k,p){if(k){let u=y.path;return u&&u[0]!==d.$gc.sep&&(u=d.$gc.sep+u),y.with({scheme:p,authority:k,path:u})}return y.with({scheme:p})}e.$Fg=w}),define(De[9],Ce([1,0,21,8,4,3,23,12,160]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function v(U){return!!U&&typeof U.then=="function"}e.$Gg=v;function R(U){const q=new C.$Xd,me=U(q.token),ee=new Promise((ne,re)=>{const Ee=q.token.onCancellationRequested(()=>{Ee.dispose(),q.dispose(),re(new T.$5)});Promise.resolve(me).then(ce=>{Ee.dispose(),q.dispose(),ne(ce)},ce=>{Ee.dispose(),q.dispose(),re(ce)})});return new class{cancel(){q.cancel()}then(ne,re){return ee.then(ne,re)}catch(ne){return this.then(void 0,ne)}finally(ne){return ee.finally(ne)}}}e.$Hg=R;function I(U,q,me){return new Promise((ee,ne)=>{const re=q.onCancellationRequested(()=>{re.dispose(),ee(me)});U.then(ee,ne).finally(()=>re.dispose())})}e.$Ig=I;function w(U,q){return new Promise((me,ee)=>{const ne=q.onCancellationRequested(()=>{ne.dispose(),ee(new T.$5)});U.then(me,ee).finally(()=>ne.dispose())})}e.$Jg=w;async function y(U){let q=-1;const me=U.map((ee,ne)=>ee.then(re=>(q=ne,re)));try{return await Promise.race(me)}finally{U.forEach((ee,ne)=>{ne!==q&&ee.cancel()})}}e.$Kg=y;function k(U,q,me){let ee;const ne=setTimeout(()=>{ee?.(void 0),me?.()},q);return Promise.race([U.finally(()=>clearTimeout(ne)),new Promise(re=>ee=re)])}e.$Lg=k;function p(U){return new Promise((q,me)=>{const ee=U();v(ee)?ee.then(q,me):q(ee)})}e.$Mg=p;class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const me=()=>{if(this.b=null,this.f)return;const ee=this.queue(this.d);return this.d=null,ee};this.b=new Promise(ee=>{this.a.then(me,me).then(ee)})}return new Promise((me,ee)=>{this.b.then(me,ee)})}return this.a=q(),new Promise((me,ee)=>{this.a.then(ne=>{this.a=null,me(ne)},ne=>{this.a=null,ee(ne)})})}dispose(){this.f=!0}}e.$Ng=u;class c{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$Og=c;class r{constructor(){this.a=new Map}queue(q,me){const ne=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.a.get(q)===ne&&this.a.delete(q)});return this.a.set(q,ne),ne}}e.$Pg=r;const o=(U,q)=>{let me=!0;const ee=setTimeout(()=>{me=!1,q()},U);return{isTriggered:()=>me,dispose:()=>{clearTimeout(ee),me=!1}}},m=U=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,U())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class h{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,me=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((ne,re)=>{this.d=ne,this.f=re}).then(()=>{if(this.b=null,this.d=null,this.g){const ne=this.g;return this.g=null,ne()}}));const ee=()=>{this.a=null,this.d?.(null)};return this.a=me===E.$Kd?m(ee):o(me,ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=h;class t{constructor(q){this.a=new h(q),this.b=new u}trigger(q,me){return this.a.trigger(()=>this.b.queue(q),me)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=t;class n{constructor(){this.a=!1,this.b=new Promise((q,me)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=n;class a extends n{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$Tg=a;function i(U,q){return q?new Promise((me,ee)=>{const ne=setTimeout(()=>{re.dispose(),me()},U),re=q.onCancellationRequested(()=>{clearTimeout(ne),re.dispose(),ee(new T.$5)})}):R(me=>i(U,me))}e.$Ug=i;function s(U,q=0,me){const ee=setTimeout(()=>{U(),me&&ne.dispose()},q),ne=(0,L.$Qc)(()=>{clearTimeout(ee),me?.deleteAndLeak(ne)});return me?.add(ne),ne}e.$Vg=s;function l(U){const q=[];let me=0;const ee=U.length;function ne(){return me<ee?U[me++]():null}function re(Ee){Ee!=null&&q.push(Ee);const ce=ne();return ce?ce.then(re):Promise.resolve(q)}return Promise.resolve(null).then(re)}e.$Wg=l;function D(U,q=ee=>!!ee,me=null){let ee=0;const ne=U.length,re=()=>{if(ee>=ne)return Promise.resolve(me);const Ee=U[ee++];return Promise.resolve(Ee()).then(de=>q(de)?Promise.resolve(de):re())};return re()}e.$Xg=D;function S(U,q=ee=>!!ee,me=null){if(U.length===0)return Promise.resolve(me);let ee=U.length;const ne=()=>{ee=-1;for(const re of U)re.cancel?.()};return new Promise((re,Ee)=>{for(const ce of U)ce.then(de=>{--ee>=0&&q(de)?(ne(),re(de)):ee===0&&re(me)}).catch(de=>{--ee>=0&&(ne(),Ee(de))})})}e.$Yg=S;class b{constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new d.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((me,ee)=>{this.f.push({factory:q,c:me,e:ee}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const me=q.factory();me.then(q.c,q.e),me.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=b;class f extends b{constructor(){super(1)}}e.$1g=f;class g{constructor(){this.a=new fe,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$2g=g;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new X;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,me=A.$lg){const ee=me.getComparisonKey(q);let ne=this.a.get(ee);if(!ne){ne=new f;const re=this.f++,Ee=d.Event.once(ne.onDrained)(()=>{ne?.dispose(),this.a.delete(ee),this.h(),this.d?.deleteAndDispose(re),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$1c),this.d.set(re,Ee),this.a.set(ee,ne)}return ne}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=P;class N{constructor(q,me){this.a=-1,typeof q=="function"&&typeof me=="number"&&this.setIfNotSet(q,me)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,me){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},me)}setIfNotSet(q,me){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},me))}}e.$4g=N;class O{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(q,me){this.cancel(),this.a=setInterval(()=>{q()},me)}}e.$5g=O;class M{constructor(q,me){this.b=-1,this.a=q,this.d=me,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=M;class j{constructor(q,me){me%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.a=q,this.b=me,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=j;class z extends M{constructor(q,me){super(q,me),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$8g=z;class F extends L.$Sc{constructor(q,me){super(),this.g=q,this.h=me,this.a=[],this.b=this.B(new L.$Tc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const me of q)this.a.push(me);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=U=>{(0,$.$B)(()=>{if(q)return;const me=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.$0g=(U,q)=>{const me=requestIdleCallback(U,typeof q=="number"?{timeout:q}:void 0);let ee=!1;return{dispose(){ee||(ee=!0,cancelIdleCallback(me))}}}}();class K{constructor(q){this.d=!1,this.a=()=>{try{this.f=q()}catch(me){this.g=me}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=K;async function V(U,q,me){let ee;for(let ne=0;ne<me;ne++)try{return await U()}catch(re){ee=re,await i(q)}throw ee}e.$_g=V;class fe{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,me,ee){return this.a={taskId:q,cancel:()=>ee?.(),promise:me},me.then(()=>this.d(q),()=>this.d(q)),me}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{let me,ee;const ne=new Promise((re,Ee)=>{me=re,ee=Ee});this.b={run:q,promise:ne,promiseResolve:me,promiseReject:ee}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=fe;class Z{constructor(q,me=()=>Date.now()){this.d=q,this.f=me,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$bh=Z;var Q;(function(U){U[U.Resolved=0]="Resolved",U[U.Rejected=1]="Rejected"})(Q||(Q={}));class X{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((q,me)=>{this.a=q,this.b=me})}complete(q){return new Promise(me=>{this.a(q),this.d={outcome:0,value:q},me()})}error(q){return new Promise(me=>{this.b(q),this.d={outcome:1,value:q},me()})}cancel(){return this.error(new T.$5)}}e.$ch=X;var oe;(function(U){async function q(ee){let ne;const re=await Promise.all(ee.map(Ee=>Ee.then(ce=>ce,ce=>{ne||(ne=ce)})));if(typeof ne<"u")throw ne;return re}U.settled=q;function me(ee){return new Promise(async(ne,re)=>{try{await ee(ne,re)}catch(Ee){re(Ee)}})}U.withAsyncBody=me})(oe||(e.Promises=oe={}));var x;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(x||(x={}));class ae{static fromArray(q){return new ae(me=>{me.emitMany(q)})}static fromPromise(q){return new ae(async me=>{me.emitMany(await q)})}static fromPromises(q){return new ae(async me=>{await Promise.all(q.map(async ee=>me.emitOne(await ee)))})}static merge(q){return new ae(async me=>{await Promise.all(q.map(async ee=>{for await(const ne of ee)me.emitOne(ne)}))})}static{this.EMPTY=ae.fromArray([])}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new d.$Nd,queueMicrotask(async()=>{const me={emitOne:ee=>this.g(ee),emitMany:ee=>this.h(ee),reject:ee=>this.k(ee)};try{await Promise.resolve(q(me)),this.j()}catch(ee){this.k(ee)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await d.Event.toPromise(this.f.event)}while(!0)}}}static map(q,me){return new ae(async ee=>{for await(const ne of q)ee.emitOne(me(ne))})}map(q){return ae.map(this,q)}static filter(q,me){return new ae(async ee=>{for await(const ne of q)me(ne)&&ee.emitOne(ne)})}filter(q){return ae.filter(this,q)}static coalesce(q){return ae.filter(q,me=>!!me)}coalesce(){return ae.coalesce(this)}static async toPromise(q){const me=[];for await(const ee of q)me.push(ee);return me}toPromise(){return ae.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}e.$dh=ae;class we extends ae{constructor(q,me){super(me),this.l=q}cancel(){this.l.cancel()}}e.$eh=we;function G(U){const q=new C.$Xd,me=U(q.token);return new we(q,async ee=>{const ne=q.token.onCancellationRequested(()=>{ne.dispose(),q.dispose(),ee.reject(new T.$5)});try{for await(const re of me){if(q.token.isCancellationRequested)return;ee.emitOne(re)}ne.dispose(),q.dispose()}catch(re){ne.dispose(),q.dispose(),ee.reject(re)}})}e.$fh=G}),define(De[35],Ce([1,0,19,9,32,28,16,12,15]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=void 0;function v(){return Object.create(null)}e.$qj=v,e.$rj="**",e.$sj="/";const R="[/\\\\]",I="[^/\\\\]",w=/\//g;function y(fe,Z){switch(fe){case 0:return"";case 1:return`${I}*?`;default:return`(?:${R}|${I}+${R}${Z?`|${R}${I}+`:""})*?`}}function k(fe,Z){if(!fe)return[];const Q=[];let X=!1,oe=!1,x="";for(const ae of fe){switch(ae){case Z:if(!X&&!oe){Q.push(x),x="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}x+=ae}return x&&Q.push(x),Q}e.$tj=k;function p(fe){if(!fe)return"";let Z="";const Q=k(fe,e.$sj);if(Q.every(X=>X===e.$rj))Z=".*";else{let X=!1;Q.forEach((oe,x)=>{if(oe===e.$rj){if(X)return;Z+=y(2,x===Q.length-1)}else{let ae=!1,we="",G=!1,U="";for(const q of oe){if(q!=="}"&&ae){we+=q;continue}if(G&&(q!=="]"||!U)){let me;q==="-"?me=q:(q==="^"||q==="!")&&!U?me="^":q===e.$sj?me="":me=(0,E.$Fe)(q),U+=me;continue}switch(q){case"{":ae=!0;continue;case"[":G=!0;continue;case"}":{const ee=`(?:${k(we,",").map(ne=>p(ne)).join("|")})`;Z+=ee,ae=!1,we="";break}case"]":{Z+="["+U+"]",G=!1,U="";break}case"?":Z+=I;continue;case"*":Z+=y(1);continue;default:Z+=(0,E.$Fe)(q)}}x<Q.length-1&&(Q[x+1]!==e.$rj||x+2<Q.length)&&(Z+=R)}X=oe===e.$rj})}return Z}const u=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Dc(1e4),n=function(){return!1},a=function(){return null};function i(fe,Z){if(!fe)return a;let Q;typeof fe!="string"?Q=fe.pattern:Q=fe,Q=Q.trim();const X=`${Q}_${!!Z.trimForExclusions}`;let oe=t.get(X);if(oe)return s(oe,fe);let x;return u.test(Q)?oe=D(Q.substr(4),Q):(x=c.exec(l(Q,Z)))?oe=S(x[1],Q):(Z.trimForExclusions?o:r).test(Q)?oe=b(Q,Z):(x=m.exec(l(Q,Z)))?oe=f(x[1].substr(1),Q,!0):(x=h.exec(l(Q,Z)))?oe=f(x[1],Q,!1):oe=g(Q),t.set(X,oe),s(oe,fe)}function s(fe,Z){if(typeof Z=="string")return fe;const Q=function(X,oe){return(0,d.$Xf)(X,Z.base,!$.$l)?fe((0,E.$Je)(X.substr(Z.base.length),A.sep),oe):null};return Q.allBasenames=fe.allBasenames,Q.allPaths=fe.allPaths,Q.basenames=fe.basenames,Q.patterns=fe.patterns,Q}function l(fe,Z){return Z.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function D(fe,Z){return function(Q,X){return typeof Q=="string"&&Q.endsWith(fe)?Z:null}}function S(fe,Z){const Q=`/${fe}`,X=`\\${fe}`,oe=function(ae,we){return typeof ae!="string"?null:we?we===fe?Z:null:ae===fe||ae.endsWith(Q)||ae.endsWith(X)?Z:null},x=[fe];return oe.basenames=x,oe.patterns=[Z],oe.allBasenames=x,oe}function b(fe,Z){const Q=K(fe.slice(1,-1).split(",").map(we=>i(we,Z)).filter(we=>we!==a),fe),X=Q.length;if(!X)return a;if(X===1)return Q[0];const oe=function(we,G){for(let U=0,q=Q.length;U<q;U++)if(Q[U](we,G))return fe;return null},x=Q.find(we=>!!we.allBasenames);x&&(oe.allBasenames=x.allBasenames);const ae=Q.reduce((we,G)=>G.allPaths?we.concat(G.allPaths):we,[]);return ae.length&&(oe.allPaths=ae),oe}function f(fe,Z,Q){const X=A.sep===A.$gc.sep,oe=X?fe:fe.replace(w,A.sep),x=A.sep+oe,ae=A.$gc.sep+fe;let we;return Q?we=function(G,U){return typeof G=="string"&&(G===oe||G.endsWith(x)||!X&&(G===fe||G.endsWith(ae)))?Z:null}:we=function(G,U){return typeof G=="string"&&(G===oe||!X&&G===fe)?Z:null},we.allPaths=[(Q?"*/":"./")+fe],we}function g(fe){try{const Z=new RegExp(`^${p(fe)}$`);return function(Q){return Z.lastIndex=0,typeof Q=="string"&&Z.test(Q)?fe:null}}catch{return a}}function P(fe,Z,Q){return!fe||typeof Z!="string"?!1:N(fe)(Z,void 0,Q)}e.$uj=P;function N(fe,Z={}){if(!fe)return n;if(typeof fe=="string"||O(fe)){const Q=i(fe,Z);if(Q===a)return n;const X=function(oe,x){return!!Q(oe,x)};return Q.allBasenames&&(X.allBasenames=Q.allBasenames),Q.allPaths&&(X.allPaths=Q.allPaths),X}return z(fe,Z)}e.$vj=N;function O(fe){const Z=fe;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}e.$wj=O;function M(fe){return fe.allBasenames||[]}e.$xj=M;function j(fe){return fe.allPaths||[]}e.$yj=j;function z(fe,Z){const Q=K(Object.getOwnPropertyNames(fe).map(we=>F(we,fe[we],Z)).filter(we=>we!==a)),X=Q.length;if(!X)return a;if(!Q.some(we=>!!we.requiresSiblings)){if(X===1)return Q[0];const we=function(q,me){let ee;for(let ne=0,re=Q.length;ne<re;ne++){const Ee=Q[ne](q,me);if(typeof Ee=="string")return Ee;(0,T.$Gg)(Ee)&&(ee||(ee=[]),ee.push(Ee))}return ee?(async()=>{for(const ne of ee){const re=await ne;if(typeof re=="string")return re}return null})():null},G=Q.find(q=>!!q.allBasenames);G&&(we.allBasenames=G.allBasenames);const U=Q.reduce((q,me)=>me.allPaths?q.concat(me.allPaths):q,[]);return U.length&&(we.allPaths=U),we}const oe=function(we,G,U){let q,me;for(let ee=0,ne=Q.length;ee<ne;ee++){const re=Q[ee];re.requiresSiblings&&U&&(G||(G=(0,A.$nc)(we)),q||(q=G.substr(0,G.length-(0,A.$oc)(we).length)));const Ee=re(we,G,q,U);if(typeof Ee=="string")return Ee;(0,T.$Gg)(Ee)&&(me||(me=[]),me.push(Ee))}return me?(async()=>{for(const ee of me){const ne=await ee;if(typeof ne=="string")return ne}return null})():null},x=Q.find(we=>!!we.allBasenames);x&&(oe.allBasenames=x.allBasenames);const ae=Q.reduce((we,G)=>G.allPaths?we.concat(G.allPaths):we,[]);return ae.length&&(oe.allPaths=ae),oe}function F(fe,Z,Q){if(Z===!1)return a;const X=i(fe,Q);if(X===a)return a;if(typeof Z=="boolean")return X;if(Z){const oe=Z.when;if(typeof oe=="string"){const x=(ae,we,G,U)=>{if(!U||!X(ae,we))return null;const q=oe.replace("$(basename)",()=>G),me=U(q);return(0,T.$Gg)(me)?me.then(ee=>ee?fe:null):me?fe:null};return x.requiresSiblings=!0,x}}return X}function K(fe,Z){const Q=fe.filter(we=>!!we.basenames);if(Q.length<2)return fe;const X=Q.reduce((we,G)=>{const U=G.basenames;return U?we.concat(U):we},[]);let oe;if(Z){oe=[];for(let we=0,G=X.length;we<G;we++)oe.push(Z)}else oe=Q.reduce((we,G)=>{const U=G.patterns;return U?we.concat(U):we},[]);const x=function(we,G){if(typeof we!="string")return null;if(!G){let q;for(q=we.length;q>0;q--){const me=we.charCodeAt(q-1);if(me===47||me===92)break}G=we.substr(q)}const U=X.indexOf(G);return U!==-1?oe[U]:null};x.basenames=X,x.patterns=oe,x.allBasenames=X;const ae=fe.filter(we=>!we.basenames);return ae.push(x),ae}function V(fe,Z){return(0,C.$ub)(fe,Z,(Q,X)=>typeof Q=="string"&&typeof X=="string"?Q===X:typeof Q!="string"&&typeof X!="string"?Q.base===X.base&&Q.pattern===X.pattern:!1)}e.$zj=V}),define(De[80],Ce([1,0,8,161,23,15,2]),function($e,e,C,T,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class E{constructor(c="",r=!1){if(this.value=c,typeof this.value!="string")throw(0,C.$7)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(c,r=0){return this.value+=w(this.supportThemeIcons?(0,T.$Vj)(c):c).replace(/([ \t]+)/g,(o,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,r){return this.value+="\n```",this.value+=c,this.value+=`
`,this.value+=r,this.value+="\n```\n",this}appendLink(c,r,o){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(c),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(c,r){const o=new RegExp((0,L.$Fe)(r),"g");return c.replace(o,(m,h)=>c.charAt(h-1)!=="\\"?`\\${m}`:m)}}e.$2j=E;function v(u){return R(u)?!u.value:Array.isArray(u)?u.every(v):!0}e.$3j=v;function R(u){return u instanceof E?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||typeof u.isTrusted=="object"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.$4j=R;function I(u,c){return u===c?!0:!u||!c?!1:u.value===c.value&&u.isTrusted===c.isTrusted&&u.supportThemeIcons===c.supportThemeIcons&&u.supportHtml===c.supportHtml&&(u.baseUri===c.baseUri||!!u.baseUri&&!!c.baseUri&&(0,d.$og)(A.URI.from(u.baseUri),A.URI.from(c.baseUri)))}e.$5j=I;function w(u){return u.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$6j=w;function y(u){return u.replace(/"/g,"&quot;")}e.$7j=y;function k(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$8j=k;function p(u){const c=[],r=u.split("|").map(m=>m.trim());u=r[0];const o=r[1];if(o){const m=/height=(\d+)/.exec(o),h=/width=(\d+)/.exec(o),t=m?m[1]:"",n=h?h[1]:"",a=isFinite(parseInt(n)),i=isFinite(parseInt(t));a&&c.push(`width="${n}"`),i&&c.push(`height="${t}"`)}return{href:u,dimensions:c}}e.$9j=p}),define(De[99],Ce([1,0,19,32,16,12,23,15]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=void 0;function E(i,s){const{os:l,tildify:D,relative:S}=s;if(S){const g=v(i,S,l);if(typeof g=="string")return g}let b=i.fsPath;if(l===1&&!L.$j?b=b.replace(/\//g,"\\"):l!==1&&L.$j&&(b=b.replace(/\\/g,"/")),l!==1&&D?.userHome){const g=D.userHome.fsPath;let P;i.scheme!==D.userHome.scheme&&i.path.startsWith(d.$gc.sep)?P=D.userHome.with({path:i.path}).fsPath:P=i.fsPath,b=w(P,g,l)}return(l===1?d.$fc:d.$gc).normalize(R(b,l===1))}e.$nv=E;function v(i,s,l){const D=l===1?d.$fc:d.$gc,S=l===3?A.$lg:A.$ng,b=s.getWorkspace(),f=(0,C.$Ob)(b.folders);if(!f)return;i.scheme!==f.uri.scheme&&i.path.startsWith(d.$gc.sep)&&(i=f.uri.with({path:i.path}));const g=s.getWorkspaceFolder(i);if(!g)return;let P;if(S.isEqual(g.uri,i)?P="":P=S.relativePath(g.uri,i)??"",P&&(P=D.normalize(P)),b.folders.length>1&&!s.noPrefix){const N=g.name?g.name:S.basenameOrAuthority(g.uri);P=P?`${N} \u2022 ${P}`:N}return P}function R(i,s=L.$j){return(0,T.$2f)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$ov=R;let I=Object.create(null);function w(i,s,l=L.OS){if(l===1||!i||!s)return i;let D=I.original===s?I.normalized:void 0;D||(D=s,L.$j&&(D=(0,T.$Rf)(D)),D=`${(0,$.$Ke)(D,d.$gc.sep)}${d.$gc.sep}`,I={original:s,normalized:D});let S=i;return L.$j&&(S=(0,T.$Rf)(S)),(l===3?S.startsWith(D):(0,$.$3e)(S,D))?`~/${S.substr(D.length)}`:i}e.$pv=w;function y(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.$qv=y;const k="\u2026",p="\\\\",u="~";function c(i,s=d.sep){const l=new Array(i.length);let D=!1;for(let S=0;S<i.length;S++){const b=i[S];if(b===""){l[S]=`.${s}`;continue}if(!b){l[S]=b;continue}D=!0;let f="",g=b;g.indexOf(p)===0?(f=g.substr(0,g.indexOf(p)+p.length),g=g.substr(g.indexOf(p)+p.length)):g.indexOf(s)===0?(f=g.substr(0,g.indexOf(s)+s.length),g=g.substr(g.indexOf(s)+s.length)):g.indexOf(u)===0&&(f=g.substr(0,g.indexOf(u)+u.length),g=g.substr(g.indexOf(u)+u.length));const P=g.split(s);for(let N=1;D&&N<=P.length;N++)for(let O=P.length-N;D&&O>=0;O--){D=!1;let M=P.slice(O,O+N).join(s);for(let j=0;!D&&j<i.length;j++)if(j!==S&&i[j]&&i[j].indexOf(M)>-1){const z=O+N===P.length,F=O>0&&i[j].indexOf(s)>-1?s+M:M,K=i[j].endsWith(F);D=!z||K}if(!D){let j="";(P[0].endsWith(":")||f!=="")&&(O===1&&(O=0,N++,M=P[0]+s+M),O>0&&(j=P[0]+s),j=f+j),O>0&&(j=j+k+s),j=j+M,O+N<P.length&&(j=j+s+k),l[S]=j}}D&&(l[S]=b)}return l}e.$rv=c;var r;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function o(i,s=Object.create(null)){const l=[];let D=!1,S="";for(const b of i)if(b==="$"||D&&b==="{")S&&l.push({value:S,type:r.TEXT}),S="",D=!0;else if(b==="}"&&D){const f=s[S];if(typeof f=="string")f.length&&l.push({value:f,type:r.VARIABLE});else if(f){const g=l[l.length-1];(!g||g.type!==r.SEPARATOR)&&l.push({value:f.label,type:r.SEPARATOR})}S="",D=!1}else S+=b;return S&&!D&&l.push({value:S,type:r.TEXT}),l.filter((b,f)=>{if(b.type===r.SEPARATOR){const g=l[f-1],P=l[f+1];return[g,P].every(N=>N&&(N.type===r.VARIABLE||N.type===r.TEXT)&&N.value.length>0)}return!0}).map(b=>b.value).join("")}e.$sv=o;function m(i,s){return L.$k||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$k?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$tv=m;function h(i,s){return L.$k||s?i.replace(/\(&&\w\)|&&/g,""):L.$j?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$uv=h;function t(i){return i.replace(/&/g,"&&")}e.$vv=t;function n(i){if(i.endsWith("]")){const s=i.lastIndexOf(" [",i.length-2);if(s!==-1){const l=a(i.substring(0,s));return{name:l.name,parentPath:l.parentPath+i.substring(s)}}}return a(i)}e.$wv=n;function a(i){const s=i.indexOf("/")!==-1?d.$gc:d.$fc,l=s.basename(i),D=s.dirname(i);return l.length?{name:l,parentPath:D}:{name:D,parentPath:""}}}),define(De[128],Ce([1,0,22,2]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=void 0;function d(I){return I.toJSON()}class L{constructor(w){this.a=w}transformIncoming(w){const y=this.a.transformIncoming(w);return y===w?w:d(T.URI.from(y))}transformOutgoing(w){const y=this.a.transformOutgoing(w);return y===w?w:d(T.URI.from(y))}transformOutgoingURI(w){const y=this.a.transformOutgoing(w);return y===w?w:T.URI.from(y)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$Jm=L,e.$Km=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function A(I,w,y){if(!I||y>200)return null;if(typeof I=="object"){if(I instanceof T.URI)return w.transformOutgoing(I);for(const k in I)if(Object.hasOwnProperty.call(I,k)){const p=A(I[k],w,y+1);p!==null&&(I[k]=p)}}return null}function $(I,w){const y=A(I,w,0);return y===null?I:y}e.$Lm=$;function E(I,w,y,k){if(!I||k>200)return null;if(typeof I=="object"){if(I.$mid===1)return y?T.URI.revive(w.transformIncoming(I)):w.transformIncoming(I);if(I instanceof C.$be)return null;for(const p in I)if(Object.hasOwnProperty.call(I,p)){const u=E(I[p],w,y,k+1);u!==null&&(I[p]=u)}}return null}function v(I,w){const y=E(I,w,!1,0);return y===null?I:y}e.$Mm=v;function R(I,w){const y=E(I,w,!0,0);return y===null?I:y}e.$Nm=R}),define(De[29],Ce([1,0,53,63,372,9,32,77,16,12,23,2]),function($e,e,C,T,d,L,A,$,E,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function y(F,K=w.UNLINK,V){if((0,A.$1f)(F))throw new Error("rimraf - will refuse to recursively delete root");return K===w.UNLINK?p(F):k(F,V)}async function k(F,K=(0,A.$6f)((0,T.tmpdir)())){try{try{await C.promises.rename(F,K)}catch(V){return V.code==="ENOENT"?void 0:p(F)}p(K).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function p(F){return(0,d.promisify)(C.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function u(F){if((0,A.$1f)(F))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=u;async function c(F,K){return m(await(K?r(F):(0,d.promisify)(C.readdir)(F)))}async function r(F){try{return await(0,d.promisify)(C.readdir)(F,{withFileTypes:!0})}catch(fe){console.warn("[node.js fs] readdir with filetypes failed with error: ",fe)}const K=[],V=await c(F);for(const fe of V){let Z=!1,Q=!1,X=!1;try{const oe=await e.Promises.lstat((0,E.$jc)(F,fe));Z=oe.isFile(),Q=oe.isDirectory(),X=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}K.push({name:fe,isFile:()=>Z,isDirectory:()=>Q,isSymbolicLink:()=>X})}return K}function o(F){return m(C.readdirSync(F))}e.readdirSync=o;function m(F){return F.map(K=>typeof K=="string"?v.$k?(0,$.$ml)(K):K:(K.name=v.$k?(0,$.$ml)(K.name):K.name,K))}async function h(F){const K=await c(F),V=[];for(const fe of K)await n.existsDirectory((0,E.$jc)(F,fe))&&V.push(fe);return V}function t(F,K=1e3){return new Promise(V=>{let fe=!1;const Z=setInterval(()=>{fe||(fe=!0,C.access(F,Q=>{fe=!1,Q&&(clearInterval(Z),V(void 0))}))},K)})}e.whenDeleted=t;var n;(function(F){async function K(Z){let Q;try{if(Q=await e.Promises.lstat(Z),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(v.$j&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw oe}throw X}}F.stat=K;async function V(Z){try{const{stat:Q,symbolicLink:X}=await F.stat(Z);return Q.isFile()&&X?.dangling!==!0}catch{}return!1}F.existsFile=V;async function fe(Z){try{const{stat:Q,symbolicLink:X}=await F.stat(Z);return Q.isDirectory()&&X?.dangling!==!0}catch{}return!1}F.existsDirectory=fe})(n||(e.SymlinkSupport=n={}));const a=new L.$3g;function i(F,K,V){return a.queueFor(I.URI.file(F),R.$mg).queue(()=>{const fe=b(V);return new Promise((Z,Q)=>D(F,K,fe,X=>X?Q(X):Z()))})}let s=!0;function l(F){s=F}e.configureFlushOnWrite=l;function D(F,K,V,fe){if(!s)return C.writeFile(F,K,{mode:V.mode,flag:V.flag},fe);C.open(F,V.flag,V.mode,(Z,Q)=>{if(Z)return fe(Z);C.writeFile(Q,K,X=>{if(X)return C.close(Q,()=>fe(X));C.fdatasync(Q,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),l(!1)),C.close(Q,x=>fe(x))))})})}function S(F,K,V){const fe=b(V);if(!s)return C.writeFileSync(F,K,{mode:fe.mode,flag:fe.flag});const Z=C.openSync(F,fe.flag,fe.mode);try{C.writeFileSync(Z,K);try{C.fdatasyncSync(Z)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),l(!1)}}finally{C.closeSync(Z)}}e.writeFileSync=S;function b(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function f(F,K,V=6e4){if(F!==K)try{v.$j&&typeof V=="number"?await g(F,K,Date.now(),V):await(0,d.promisify)(C.rename)(F,K)}catch(fe){if(F.toLowerCase()!==K.toLowerCase()&&fe.code==="EXDEV"||F.endsWith("."))await P(F,K,{preserveSymlinks:!1}),await y(F,w.MOVE);else throw fe}}async function g(F,K,V,fe,Z=0){try{return await(0,d.promisify)(C.rename)(F,K)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-V>=fe)throw console.error(`[node.js fs] rename failed after ${Z} retries with error: ${Q}`),Q;if(Z===0){let X=!1;try{const{stat:oe}=await n.stat(K);oe.isFile()||(X=!0)}catch{}if(X)throw Q}return await(0,L.$Ug)(Math.min(100,Z*10)),g(F,K,V,fe,Z+1)}}async function P(F,K,V){return O(F,K,{root:{source:F,target:K},options:V,handledSourcePaths:new Set})}const N=511;async function O(F,K,V){if(V.handledSourcePaths.has(F))return;V.handledSourcePaths.add(F);const{stat:fe,symbolicLink:Z}=await n.stat(F);if(Z){if(V.options.preserveSymlinks)try{return await z(F,K,V)}catch(Q){console.warn("[node.js fs] copy of symlink failed: ",Q)}if(Z.dangling)return}return fe.isDirectory()?M(F,K,fe.mode&N,V):j(F,K,fe.mode&N)}async function M(F,K,V,fe){await e.Promises.mkdir(K,{recursive:!0,mode:V});const Z=await c(F);for(const Q of Z)await O((0,E.$jc)(F,Q),(0,E.$jc)(K,Q),fe)}async function j(F,K,V){await e.Promises.copyFile(F,K),await e.Promises.chmod(K,V)}async function z(F,K,V){let fe=await e.Promises.readlink(F);(0,A.$Xf)(fe,V.root.source,!v.$l)&&(fe=(0,E.$jc)(V.root.target,fe.substr(V.root.source.length+1))),await e.Promises.symlink(fe,K)}e.Promises=new class{get access(){return(0,d.promisify)(C.access)}get stat(){return(0,d.promisify)(C.stat)}get lstat(){return(0,d.promisify)(C.lstat)}get utimes(){return(0,d.promisify)(C.utimes)}get read(){return(F,K,V,fe,Z)=>new Promise((Q,X)=>{C.read(F,K,V,fe,Z,(oe,x,ae)=>oe?X(oe):Q({bytesRead:x,buffer:ae}))})}get readFile(){return(0,d.promisify)(C.readFile)}get write(){return(F,K,V,fe,Z)=>new Promise((Q,X)=>{C.write(F,K,V,fe,Z,(oe,x,ae)=>oe?X(oe):Q({bytesWritten:x,buffer:ae}))})}get appendFile(){return(0,d.promisify)(C.appendFile)}get fdatasync(){return(0,d.promisify)(C.fdatasync)}get truncate(){return(0,d.promisify)(C.truncate)}get copyFile(){return(0,d.promisify)(C.copyFile)}get open(){return(0,d.promisify)(C.open)}get close(){return(0,d.promisify)(C.close)}get symlink(){return(0,d.promisify)(C.symlink)}get readlink(){return(0,d.promisify)(C.readlink)}get chmod(){return(0,d.promisify)(C.chmod)}get mkdir(){return(0,d.promisify)(C.mkdir)}get unlink(){return(0,d.promisify)(C.unlink)}get rmdir(){return(0,d.promisify)(C.rmdir)}get realpath(){return(0,d.promisify)(C.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return h}get writeFile(){return i}get rm(){return y}get rename(){return f}get copy(){return P}}}),define(De[100],Ce([1,0,53,16,12,15,29]),function($e,e,C,T,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.$4p=e.$3p=void 0;function $(w){if(d.$l)return w;const y=(0,T.$mc)(w);if(w===y)return w;const k=((0,T.$nc)(w)||w).toLowerCase();try{const u=(0,A.readdirSync)(y).filter(c=>c.toLowerCase()===k);if(u.length===1){const c=$(y);if(c)return(0,T.$jc)(c,u[0])}else if(u.length>1){const c=u.indexOf(k);if(c>=0){const r=$(y);if(r)return(0,T.$jc)(r,u[c])}}}catch{}return null}e.$3p=$;async function E(w){if(d.$l)return w;const y=(0,T.$mc)(w);if(w===y)return w;const k=((0,T.$nc)(w)||w).toLowerCase();try{const u=(await A.Promises.readdir(y)).filter(c=>c.toLowerCase()===k);if(u.length===1){const c=await E(y);if(c)return(0,T.$jc)(c,u[0])}else if(u.length>1){const c=u.indexOf(k);if(c>=0){const r=await E(y);if(r)return(0,T.$jc)(r,u[c])}}}catch{}return null}e.$4p=E;async function v(w){try{return await A.Promises.realpath(w)}catch{const k=I(w);return await A.Promises.access(k,C.constants.R_OK),k}}e.$5p=v;function R(w){try{return C.realpathSync(w)}catch{const k=I(w);return C.accessSync(k,C.constants.R_OK),k}}e.$6p=R;function I(w){return(0,L.$Ke)((0,T.$hc)(w),T.sep)}}),define(De[101],Ce([1,0,16,12,48,98,17,29]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Al=e.$zl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function E(I=d.env){return I.comspec||"cmd.exe"}e.$zl=E;function v(I){let w=[],y=!1;const k=function(p){if(y){w.push(p);return}(!I.send(p,c=>{if(c&&console.error(c),y=!1,w.length>0){const r=w.slice(0);w=[],r.forEach(o=>k(o))}})||T.$j)&&(y=!0)};return{send:k}}e.$Al=v;var R;(function(I){async function w(y,k,p){if(C.$ic(y))return y;if(k===void 0&&(k=d.cwd()),C.$mc(y)!=="."||(p===void 0&&A.$yf(d.env.PATH)&&(p=d.env.PATH.split(C.$tc)),p===void 0||p.length===0))return C.$jc(k,y);async function c(r){if(await $.Promises.exists(r)){let o;try{o=await $.Promises.stat(r)}catch(m){m.message.startsWith("EACCES")&&(o=await $.Promises.lstat(r))}return o?!o.isDirectory():!1}return!1}for(const r of p){let o;if(C.$ic(r)?o=C.$jc(r,y):o=C.$jc(k,r,y),await c(o))return o;let m=o+".com";if(await c(m)||(m=o+".exe",await c(m)))return m}return C.$jc(k,y)}I.findExecutable=w})(R||(e.win32=R={}))});var He=this&&this.__decorate||function($e,e,C,T){var d=arguments.length,L=d<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,C):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate($e,e,C,T);else for(var $=$e.length-1;$>=0;$--)(A=$e[$])&&(L=(d<3?A(L):d>3?A(e,C,L):A(e,C))||L);return d>3&&L&&Object.defineProperty(e,C,L),L};define(De[81],Ce([1,0,19,9,22,21,57,8,4,3,62,15,17]),function($e,e,C,T,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.ProxyChannel=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.RequestInitiator=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=void 0;var y;(function(Z){Z[Z.Promise=100]="Promise",Z[Z.PromiseCancel=101]="PromiseCancel",Z[Z.EventListen=102]="EventListen",Z[Z.EventDispose=103]="EventDispose"})(y||(y={}));function k(Z){switch(Z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(Z){Z[Z.Initialize=200]="Initialize",Z[Z.PromiseSuccess=201]="PromiseSuccess",Z[Z.PromiseError=202]="PromiseError",Z[Z.PromiseErrorObj=203]="PromiseErrorObj",Z[Z.EventFire=204]="EventFire"})(p||(p={}));function u(Z){switch(Z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(Z){Z[Z.Uninitialized=0]="Uninitialized",Z[Z.Idle=1]="Idle"})(c||(c={}));function r(Z){let Q=0;for(let X=0;;X+=7){const oe=Z.read(1);if(Q|=(oe.buffer[0]&127)<<X,!(oe.buffer[0]&128))return Q}}const o=a(0);function m(Z,Q){if(Q===0){Z.write(o);return}let X=0;for(let x=Q;x!==0;x=x>>>7)X++;const oe=d.$be.alloc(X);for(let x=0;Q!==0;x++)oe.buffer[x]=Q&127,Q=Q>>>7,Q>0&&(oe.buffer[x]|=128);Z.write(oe)}class h{constructor(Q){this.b=Q,this.a=0}read(Q){const X=this.b.slice(this.a,this.a+Q);return this.a+=X.byteLength,X}}e.$mh=h;class t{constructor(){this.a=[]}get buffer(){return d.$be.concat(this.a)}write(Q){this.a.push(Q)}}e.$nh=t;var n;(function(Z){Z[Z.Undefined=0]="Undefined",Z[Z.String=1]="String",Z[Z.Buffer=2]="Buffer",Z[Z.VSBuffer=3]="VSBuffer",Z[Z.Array=4]="Array",Z[Z.Object=5]="Object",Z[Z.Int=6]="Int"})(n||(n={}));function a(Z){const Q=d.$be.alloc(1);return Q.writeUInt8(Z,0),Q}const i={Undefined:a(n.Undefined),String:a(n.String),Buffer:a(n.Buffer),VSBuffer:a(n.VSBuffer),Array:a(n.Array),Object:a(n.Object),Uint:a(n.Int)},s=typeof Buffer<"u";function l(Z,Q){if(typeof Q>"u")Z.write(i.Undefined);else if(typeof Q=="string"){const X=d.$be.fromString(Q);Z.write(i.String),m(Z,X.byteLength),Z.write(X)}else if(s&&Buffer.isBuffer(Q)){const X=d.$be.wrap(Q);Z.write(i.Buffer),m(Z,X.byteLength),Z.write(X)}else if(Q instanceof d.$be)Z.write(i.VSBuffer),m(Z,Q.byteLength),Z.write(Q);else if(Array.isArray(Q)){Z.write(i.Array),m(Z,Q.length);for(const X of Q)l(Z,X)}else if(typeof Q=="number"&&(Q|0)===Q)Z.write(i.Uint),m(Z,Q);else{const X=d.$be.fromString(JSON.stringify(Q));Z.write(i.Object),m(Z,X.byteLength),Z.write(X)}}e.$oh=l;function D(Z){switch(Z.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return Z.read(r(Z)).toString();case n.Buffer:return Z.read(r(Z)).buffer;case n.VSBuffer:return Z.read(r(Z));case n.Array:{const X=r(Z),oe=[];for(let x=0;x<X;x++)oe.push(D(Z));return oe}case n.Object:return JSON.parse(Z.read(r(Z)).toString());case n.Int:return r(Z)}}e.$ph=D;class S{constructor(Q,X,oe=null,x=1e3){this.h=Q,this.j=X,this.k=oe,this.l=x,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(Q,X){this.b.set(Q,X),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const X=this.o([Q.type]);this.k?.logOutgoing(X,0,1,u(Q.type));return}case 201:case 202:case 204:case 203:{const X=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(X,Q.id,1,u(Q.type),Q.data);return}}}o(Q,X=void 0){const oe=new t;return l(oe,Q),l(oe,X),this.p(oe.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const X=new h(Q),oe=D(X),x=D(X),ae=oe[0];switch(ae){case 100:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${k(ae)}: ${oe[2]}.${oe[3]}`,x),this.s({type:ae,id:oe[1],channelName:oe[2],name:oe[3],arg:x});case 102:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${k(ae)}: ${oe[2]}.${oe[3]}`,x),this.t({type:ae,id:oe[1],channelName:oe[2],name:oe[3],arg:x});case 101:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${k(ae)}`),this.u({type:ae,id:oe[1]});case 103:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${k(ae)}`),this.u({type:ae,id:oe[1]})}}s(Q){const X=this.b.get(Q.channelName);if(!X){this.v(Q);return}const oe=new L.$Xd;let x;try{x=X.call(this.j,Q.name,Q.arg,oe.token)}catch(G){x=Promise.reject(G)}const ae=Q.id;x.then(G=>{this.m({id:ae,data:G,type:201})},G=>{G instanceof Error?this.m({id:ae,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.m({id:ae,data:G,type:203})}).finally(()=>{we.dispose(),this.d.delete(Q.id)});const we=(0,v.$Qc)(()=>oe.cancel());this.d.set(Q.id,we)}t(Q){const X=this.b.get(Q.channelName);if(!X){this.v(Q);return}const oe=Q.id,ae=X.listen(this.j,Q.name,Q.arg)(we=>this.m({id:oe,data:we,type:204}));this.d.set(Q.id,ae)}u(Q){const X=this.d.get(Q.id);X&&(X.dispose(),this.d.delete(Q.id))}v(Q){let X=this.g.get(Q.channelName);X||(X=[],this.g.set(Q.channelName,X));const oe=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:Q,timeoutTimer:oe})}w(Q){const X=this.g.get(Q);if(X){for(const oe of X)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,v.$Nc)(this.d.values()),this.d.clear()}}e.$qh=S;var b;(function(Z){Z[Z.LocalSide=0]="LocalSide",Z[Z.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class f{constructor(Q,X=null){this.l=Q,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=X}getChannel(Q){const X=this;return{call(oe,x,ae){return X.a?Promise.reject(new $.$5):X.m(Q,oe,x,ae)},listen(oe,x){return X.a?E.Event.None:X.o(Q,oe,x)}}}m(Q,X,oe,x=L.CancellationToken.None){const ae=this.g++,G={id:ae,type:100,channelName:Q,name:X,arg:oe};if(x.isCancellationRequested)return Promise.reject(new $.$5);let U;return new Promise((me,ee)=>{if(x.isCancellationRequested)return ee(new $.$5);const ne=()=>{const de=te=>{switch(te.type){case 201:this.f.delete(ae),me(te.data);break;case 202:{this.f.delete(ae);const he=new Error(te.data.message);he.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,he.name=te.data.name,ee(he);break}case 203:this.f.delete(ae),ee(te.data);break}};this.f.set(ae,de),this.p(G)};let re=null;this.b===c.Idle?ne():(re=(0,T.$Hg)(de=>this.u()),re.then(()=>{re=null,ne()}));const Ee=()=>{re?(re.cancel(),re=null):this.p({id:ae,type:101}),ee(new $.$5)},ce=x.onCancellationRequested(Ee);U=(0,v.$Pc)((0,v.$Qc)(Ee),ce),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Q,X,oe){const x=this.g++,we={id:x,type:102,channelName:Q,name:X,arg:oe};let G=null;const U=new E.$Nd({onWillAddFirstListener:()=>{G=(0,T.$Hg)(me=>this.u()),G.then(()=>{G=null,this.d.add(U),this.p(we)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(U),this.p({id:x,type:103}))}}),q=me=>U.fire(me.data);return this.f.set(x,q),U.event}p(Q){switch(Q.type){case 100:case 102:{const X=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(X,Q.id,0,`${k(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const X=this.q([Q.type,Q.id]);this.j?.logOutgoing(X,Q.id,0,k(Q.type));return}}}q(Q,X=void 0){const oe=new t;return l(oe,Q),l(oe,X),this.r(oe.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const X=new h(Q),oe=D(X),x=D(X),ae=oe[0];switch(ae){case 200:return this.j?.logIncoming(Q.byteLength,0,0,u(ae)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,oe[1],0,u(ae),x),this.t({type:oe[0],id:oe[1],data:x})}}t(Q){if(Q.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,v.$Nc)(this.d.values()),this.d.clear()}}e.$rh=f,He([A.$gh],f.prototype,"onDidInitializePromise",null);class g{get connections(){const Q=[];return this.f.forEach(X=>Q.push(X)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new E.$Nd,this.onDidAddConnection=this.g.event,this.h=new E.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new v.$Rc,this.j.add(Q(({protocol:X,onDidClientDisconnect:oe})=>{const x=E.Event.once(X.onMessage);this.j.add(x(ae=>{const we=new h(ae),G=D(we),U=new S(X,G),q=new f(X);this.a.forEach((ee,ne)=>U.registerChannel(ne,ee));const me={channelServer:U,channelClient:q,ctx:G};this.f.add(me),this.g.fire(me),this.j.add(oe(()=>{U.dispose(),q.dispose(),this.f.delete(me),this.h.fire(me)}))}))}))}getChannel(Q,X){const oe=this;return{call(x,ae,we){let G;if((0,w.$Mf)(X)){const q=(0,C.$4b)(oe.connections.filter(X));G=q?Promise.resolve(q):E.Event.toPromise(E.Event.filter(oe.onDidAddConnection,X))}else G=X.routeCall(oe,x,ae);const U=G.then(q=>q.channelClient.getChannel(Q));return N(U).call(x,ae,we)},listen(x,ae){if((0,w.$Mf)(X))return oe.k(Q,X,x,ae);const we=X.routeEvent(oe,x,ae).then(G=>G.channelClient.getChannel(Q));return N(we).listen(x,ae)}}}k(Q,X,oe,x){const ae=this;let we;const G=new E.$Nd({onWillAddFirstListener:()=>{we=new v.$Rc;const U=new E.$Td,q=new Map,me=ne=>{const Ee=ne.channelClient.getChannel(Q).listen(oe,x),ce=U.add(Ee);q.set(ne,ce)},ee=ne=>{const re=q.get(ne);re&&(re.dispose(),q.delete(ne))};ae.connections.filter(X).forEach(me),E.Event.filter(ae.onDidAddConnection,X)(me,void 0,we),ae.onDidRemoveConnection(ee,void 0,we),U.event(G.fire,G,we),we.add(U)},onDidRemoveLastListener:()=>{we?.dispose(),we=void 0}});return G.event}registerChannel(Q,X){this.a.set(Q,X);for(const oe of this.f)oe.channelServer.registerChannel(Q,X)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$sh=g;class P{constructor(Q,X,oe=null){const x=new t;l(x,X),Q.send(x.buffer),this.a=new f(Q,oe),this.d=new S(Q,X,oe)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,X){this.d.registerChannel(Q,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.$th=P;function N(Z){return{call(Q,X,oe){return Z.then(x=>x.call(Q,X,oe))},listen(Q,X){const oe=new E.$Wd;return Z.then(x=>oe.input=x.listen(Q,X)),oe.event}}}e.$uh=N;function O(Z){let Q=!1;return{call(X,oe,x){return Q?Z.call(X,oe,x):(0,T.$Ug)(0).then(()=>Q=!0).then(()=>Z.call(X,oe,x))},listen(X,oe){if(Q)return Z.listen(X,oe);const x=new E.$Wd;return(0,T.$Ug)(0).then(()=>Q=!0).then(()=>x.input=Z.listen(X,oe)),x.event}}}e.$vh=O;class M{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const X of Q.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await E.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$wh=M;var j;(function(Z){function Q(ae,we,G){const U=ae,q=G&&G.disableMarshalling,me=new Map;for(const ee in U)oe(ee)&&me.set(ee,E.Event.buffer(U[ee],!0,void 0,we));return new class{listen(ee,ne,re){const Ee=me.get(ne);if(Ee)return Ee;if(x(ne)){const ce=U[ne];if(typeof ce=="function")return ce.call(U,re)}throw new $.$bb(`Event not found: ${ne}`)}call(ee,ne,re){const Ee=U[ne];if(typeof Ee=="function"){if(!q&&Array.isArray(re))for(let de=0;de<re.length;de++)re[de]=(0,R.$lh)(re[de]);let ce=Ee.apply(U,re);return ce instanceof Promise||(ce=Promise.resolve(ce)),ce}throw new $.$bb(`Method not found: ${ne}`)}}}Z.fromService=Q;function X(ae,we){const G=we&&we.disableMarshalling;return new Proxy({},{get(U,q){if(typeof q=="string")return we?.properties?.has(q)?we.properties.get(q):x(q)?function(me){return ae.listen(q,me)}:oe(q)?ae.listen(q):async function(...me){let ee;we&&!(0,w.$Hf)(we.context)?ee=[we.context,...me]:ee=me;const ne=await ae.call(q,ee);return G?ne:(0,R.$lh)(ne)};throw new $.$bb(`Property not found: ${String(q)}`)}})}Z.toService=X;function oe(ae){return ae[0]==="o"&&ae[1]==="n"&&I.$1e(ae.charCodeAt(2))}function x(ae){return/^onDynamic/.test(ae)&&I.$1e(ae.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(Z){if(Array.isArray(Z))return Z;if(Z&&typeof Z=="object"&&typeof Z.toString=="function"){const Q=Z.toString();if(Q!=="[object Object]")return Q}return Z}function K(Z){return Array.isArray(Z)?Z.map(F):F(Z)}function V(Z,Q,X,oe,x,ae,we){we=K(we);const G=z[x],U=G[oe%G.length];let q=[`%c[${Z}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ae)?(q=q.concat(we),q.push(")")):q.push(we),console.log.apply(console,q)}class fe{constructor(Q,X){this.d=Q,this.f=X,this.a=0,this.b=0}logOutgoing(Q,X,oe,x,ae){this.b+=Q,V(this.d,this.b,Q,X,oe,x,ae)}logIncoming(Q,X,oe,x,ae){this.a+=Q,V(this.f,this.a,Q,X,oe,x,ae)}}e.$xh=fe}),define(De[82],Ce([1,0,22,4,3,81]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=e.$zh=e.ProtocolConstants=e.$yh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var $;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let l=0;function D(b,f){if(!s.has(b)){const g=String(++l);s.set(b,g)}return s.get(b)}function S(b,f,g,P){if(!i.enableDiagnostics)return;const N=D(b,f);if(P instanceof C.$be||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const O=C.$be.alloc(P.byteLength);O.set(P),i.records.push({timestamp:Date.now(),id:N,label:f,type:g,buff:O})}else i.records.push({timestamp:Date.now(),id:N,label:f,type:g,data:P})}i.traceSocketEvent=S})($||(e.SocketDiagnostics=$={}));var E;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let v=null;function R(){return v||(v=C.$be.alloc(0)),v}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,l){if(s===0)return R();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const f=this.a[0];return l&&(this.a.shift(),this.b-=s),f}if(this.a[0].byteLength>s){const f=this.a[0].slice(0,s);return l&&(this.a[0]=this.a[0].slice(s),this.b-=s),f}const D=C.$be.alloc(s);let S=0,b=0;for(;s>0;){const f=this.a[b];if(f.byteLength>s){const g=f.slice(0,s);D.set(g,S),S+=s,l&&(this.a[b]=f.slice(s),this.b-=s),s-=s}else D.set(f,S),S+=f.byteLength,l?(this.a.shift(),this.b-=f.byteLength):b++,s-=f.byteLength}return D}}e.$yh=I;var w;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(w||(w={}));function y(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var k;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(k||(e.ProtocolConstants=k={}));class p{constructor(s,l,D,S){this.type=s,this.id=l,this.ack=D,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends d.$Sc{constructor(s){super(),this.f=this.B(new T.$Nd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new I,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const D=this.g.messageType,S=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new p(D,S,b,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=C.$be.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(l,s.data)}g(s,l){const D=this.f===0;return this.d.push(s,l),this.f+=s.byteLength+l.byteLength,D}h(){const s=C.$be.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,l){this.g(s,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class r extends d.$Sc{constructor(s){super(),this.f=new T.$Nd,this.onMessage=this.f.event,this.g=new T.$Nd,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new c(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new p(1,0,0,s))}}e.$zh=r;class o extends L.$th{static fromSocket(s,l){return new o(new r(s),l)}get onDidDispose(){return this.b.onDidDispose}constructor(s,l,D=null){super(s,l,D),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$Ah=o;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.$Nd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$Bh=m;class h{constructor(s){this.data=s,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let s=0,l=this.a;for(;l;)l=l.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let l=0,D=this.a;for(;D;)s[l++]=D.data,D=D.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const l=new h(s);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class n{static{this.a=10}static{this.b=null}static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const s=Date.now();for(let l=0;l<n.a;l++)this.c[l]=s-1e3*l;setInterval(()=>{for(let l=n.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),l=(1+n.a)*1e3;let D=0;for(let S=0;S<n.a;S++)s-this.c[S]<=l&&D++;return 1-D/n.a}hasHighLoad(){return this.d()>=.5}}class a{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??n.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new d.$Rc,this.o=s.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new p(5,0,0,R());this.p.write(s),this.p.flush()}sendPause(){const s=new p(7,0,0,R());this.p.write(s)}sendResume(){const s=new p(8,0,0,R());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,l){this.a=!0,this.r.dispose(),this.r=new d.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(D=>this.z(D))),this.r.add(this.o.onClose(D=>this.x.fire(D))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new p(3,0,this.h,R());this.p.write(s);const l=this.b.toArray();for(let D=0,S=l.length;D<S;D++)this.p.write(l[D]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const l=this.b.peek();if(l&&l.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new p(6,0,0,R())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let D=0,S=l.length;D<S;D++)this.p.write(l[D]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const l=++this.c;this.h=this.g;const D=new p(1,l,this.h,s);this.b.push(D),this.a||(this.p.write(D),this.B())}sendControl(s){const l=new p(2,0,0,s);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),l=Date.now()-s.writtenTime,D=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(l>=2e4&&D>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:D});return}const b=Math.max(2e4-l,2e4-D,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},b)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new p(3,0,this.h,R());this.p.write(s)}D(){this.h=this.g;const s=new p(9,0,this.h,R());this.p.write(s)}}e.$Ch=a}),define(De[183],Ce([1,0,49,9,22,21,181,8,4,3,24,101,98,81]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=void 0;class k extends y.$qh{constructor(c){super({send:r=>{try{process.send?.(r.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",r=>d.$be.wrap(Buffer.from(r,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Zp=k;class p{constructor(c,r){this.i=c,this.j=r,this.c=new Set,this.g=new Map,this.h=new E.$Nd,this.onDidProcessExit=this.h.event;const o=r&&r.timeout?r.timeout:6e4;this.b=new T.$Qg(o),this.d=null,this.f=null}getChannel(c){const r=this;return{call(o,m,h){return r.k(c,o,m,h)},listen(o,m){return r.l(c,o,m)}}}k(c,r,o,m=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject($.$6());this.b.cancel();const h=this.n(c),t=(0,T.$Hg)(i=>h.call(r,o,i)),n=m.onCancellationRequested(()=>t.cancel()),a=(0,v.$Qc)(()=>t.cancel());return this.c.add(a),t.finally(()=>{n.dispose(),this.c.delete(a),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,r,o){if(!this.b)return E.Event.None;this.b.cancel();let m;const h=new E.$Nd({onWillAddFirstListener:()=>{m=this.n(c).listen(r,o)(h.fire,h),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return h.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],r=Object.create(null);r.env={...(0,R.$4m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(r.env={...r.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(r.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(r.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(r.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),r.execArgv===void 0&&(r.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,w.$yl)(r.env),this.d=(0,C.fork)(this.i,c,r);const o=new E.$Nd;E.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,A.$Vp)(s)){(0,A.log)(s,`IPC Library: ${this.j.serverName}`);return}o.fire(d.$be.wrap(Buffer.from(s,"base64")))});const h=this.j.useQueue?(0,I.$Al)(this.d):this.d,t=s=>this.d&&this.d.connected&&h.send(s.buffer.toString("base64")),n=o.event,a={send:t,onMessage:n};this.f=new y.$rh(a);const i=()=>this.o();process.once("exit",i),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,l)=>{process.removeListener("exit",i),this.c.forEach(D=>(0,v.$Nc)(D)),this.c.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:l})})}return this.f}n(c){let r=this.g.get(c);return r||(r=this.m.getChannel(c),this.g.set(c,r)),r}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$1p=p}),define(De[184],Ce([1,0,9,4,3,62,17]),function($e,e,C,T,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.StorageState=e.$Yo=e.StorageHint=void 0;var $;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})($||(e.StorageHint=$={}));function E(w){const y=w;return y?.changed instanceof Map||y?.deleted instanceof Set}e.$Yo=E;var v;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(v||(e.StorageState=v={}));class R extends d.$Sc{static{this.a=100}constructor(y,k=Object.create(null)){super(),this.r=y,this.s=k,this.b=this.B(new T.$Qd),this.onDidChangeStorage=this.b.event,this.c=v.None,this.f=new Map,this.g=this.B(new C.$Rg(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((k,p)=>this.w(p,k)),y.deleted?.forEach(k=>this.w(k,void 0))}finally{this.b.resume()}}w(y,k){if(this.c===v.Closed)return;let p=!1;(0,A.$Hf)(k)?p=this.f.delete(y):this.f.get(y)!==k&&(this.f.set(y,k),p=!0),p&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===v.None&&(this.c=v.Initialized,this.s.hint!==$.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,k){const p=this.f.get(y);return(0,A.$Hf)(p)?k:p}getBoolean(y,k){const p=this.get(y);return(0,A.$Hf)(p)?k:p==="true"}getNumber(y,k){const p=this.get(y);return(0,A.$Hf)(p)?k:parseInt(p,10)}getObject(y,k){const p=this.get(y);return(0,A.$Hf)(p)?k:(0,L.$kh)(p)}async set(y,k,p=!1){if(this.c===v.Closed)return;if((0,A.$Hf)(k))return this.delete(y,p);const u=(0,A.$Af)(k)||Array.isArray(k)?(0,L.$jh)(k):String(k);if(this.f.get(y)!==u)return this.f.set(y,u),this.j.set(y,u),this.h.delete(y),this.b.fire({key:y,external:p}),this.D()}async delete(y,k=!1){if(!(this.c===v.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:k}),this.D()}async optimize(){if(this.c!==v.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=v.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===$.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===$.STORAGE_IN_MEMORY}}e.$Zo=R;class I{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((k,p)=>this.a.set(p,k)),y.delete?.forEach(k=>this.a.delete(k))}async optimize(){}async close(){}}e.$1o=I}),define(De[185],Ce([1,0,35,16]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oE=void 0;function d(L,A,$,E,v,R){if(Array.isArray(L)){let I=0;for(const w of L){const y=d(w,A,$,E,v,R);if(y===10)return y;y>I&&(I=y)}return I}else{if(typeof L=="string")return E?L==="*"?5:L===$?10:0:0;if(L){const{language:I,pattern:w,scheme:y,hasAccessToAllModels:k,notebookType:p}=L;if(!E&&!k)return 0;p&&v&&(A=v);let u=0;if(y)if(y===A.scheme)u=10;else if(y==="*")u=5;else return 0;if(I)if(I===$)u=10;else if(I==="*")u=Math.max(u,5);else return 0;if(p)if(p===R)u=10;else if(p==="*"&&R!==void 0)u=Math.max(u,5);else return 0;if(w){let c;if(typeof w=="string"?c=w:c={...w,base:(0,T.$hc)(w.base)},c===A.fsPath||(0,C.$uj)(c,A.fsPath))u=10;else return 0}return u}else return 0}}e.$oE=d}),define(De[129],Ce([1,0,22,12]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T0=e.$S0=void 0;var d;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(d||(d={}));function L(I){for(let w=0,y=I.length;w<y;w+=4){const k=I[w+0],p=I[w+1],u=I[w+2],c=I[w+3];I[w+0]=c,I[w+1]=u,I[w+2]=p,I[w+3]=k}}function A(I){const w=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return T.$D()||L(w),C.$be.wrap(w)}function $(I){const w=I.buffer;if(T.$D()||L(w),w.byteOffset%4===0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const y=new Uint8Array(w.byteLength);return y.set(w),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function E(I){const w=new Uint32Array(v(I));let y=0;if(w[y++]=I.id,I.type==="full")w[y++]=1,w[y++]=I.data.length,w.set(I.data,y),y+=I.data.length;else{w[y++]=2,w[y++]=I.deltas.length;for(const k of I.deltas)w[y++]=k.start,w[y++]=k.deleteCount,k.data?(w[y++]=k.data.length,w.set(k.data,y),y+=k.data.length):w[y++]=0}return A(w)}e.$S0=E;function v(I){let w=0;if(w+=1+1,I.type==="full")w+=1+I.data.length;else{w+=1,w+=(1+1+1)*I.deltas.length;for(const y of I.deltas)y.data&&(w+=y.data.length)}return w}function R(I){const w=$(I);let y=0;const k=w[y++];if(w[y++]===1){const r=w[y++],o=w.subarray(y,y+r);return y+=r,{id:k,type:"full",data:o}}const u=w[y++],c=[];for(let r=0;r<u;r++){const o=w[y++],m=w[y++],h=w[y++];let t;h>0&&(t=w.subarray(y,y+h),y+=h),c[r]={start:o,deleteCount:m,data:t}}return{id:k,type:"delta",deltas:c}}e.$T0=R}),define(De[186],Ce([10,11]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(De[130],Ce([1,0,19,24,12,166,124,186]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(le){le[le.None=0]="None",le[le.Keep=1]="Keep",le[le.Brackets=2]="Brackets",le[le.Advanced=3]="Advanced",le[le.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class v{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=v;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class I{constructor(ue,Ie,Ve,Ue){this.id=ue,this.name=Ie,this.defaultValue=Ve,this.schema=Ue}applyUpdate(ue,Ie){return y(ue,Ie)}compute(ue,Ie,Ve){return Ve}}class w{constructor(ue,Ie){this.newValue=ue,this.didChange=Ie}}e.ApplyUpdateResult=w;function y(le,ue){if(typeof le!="object"||typeof ue!="object"||!le||!ue)return new w(ue,le!==ue);if(Array.isArray(le)||Array.isArray(ue)){const Ve=Array.isArray(le)&&Array.isArray(ue)&&C.$ub(le,ue);return new w(ue,!Ve)}let Ie=!1;for(const Ve in ue)if(ue.hasOwnProperty(Ve)){const Ue=y(le[Ve],ue[Ve]);Ue.didChange&&(le[Ve]=Ue.newValue,Ie=!0)}return new w(le,Ie)}class k{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Ie){return y(ue,Ie)}validate(ue){return this.defaultValue}}class p{constructor(ue,Ie,Ve,Ue){this.id=ue,this.name=Ie,this.defaultValue=Ve,this.schema=Ue}applyUpdate(ue,Ie){return y(ue,Ie)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Ie,Ve){return Ve}}function u(le,ue){return typeof le>"u"?ue:le==="false"?!1:!!le}e.boolean=u;class c extends p{constructor(ue,Ie,Ve,Ue=void 0){typeof Ue<"u"&&(Ue.type="boolean",Ue.default=Ve),super(ue,Ie,Ve,Ue)}validate(ue){return u(ue,this.defaultValue)}}function r(le,ue,Ie,Ve){if(typeof le>"u")return ue;let Ue=parseInt(le,10);return isNaN(Ue)?ue:(Ue=Math.max(Ie,Ue),Ue=Math.min(Ve,Ue),Ue|0)}e.clampedInt=r;class o extends p{static clampedInt(ue,Ie,Ve,Ue){return r(ue,Ie,Ve,Ue)}constructor(ue,Ie,Ve,Ue,xe,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Ve,rt.minimum=Ue,rt.maximum=xe),super(ue,Ie,Ve,rt),this.minimum=Ue,this.maximum=xe}validate(ue){return o.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function m(le,ue,Ie,Ve){if(typeof le>"u")return ue;const Ue=h.float(le,ue);return h.clamp(Ue,Ie,Ve)}e.clampedFloat=m;class h extends p{static clamp(ue,Ie,Ve){return ue<Ie?Ie:ue>Ve?Ve:ue}static float(ue,Ie){if(typeof ue=="number")return ue;if(typeof ue>"u")return Ie;const Ve=parseFloat(ue);return isNaN(Ve)?Ie:Ve}constructor(ue,Ie,Ve,Ue,xe){typeof xe<"u"&&(xe.type="number",xe.default=Ve),super(ue,Ie,Ve,xe),this.validationFn=Ue}validate(ue){return this.validationFn(h.float(ue,this.defaultValue))}}class t extends p{static string(ue,Ie){return typeof ue!="string"?Ie:ue}constructor(ue,Ie,Ve,Ue=void 0){typeof Ue<"u"&&(Ue.type="string",Ue.default=Ve),super(ue,Ie,Ve,Ue)}validate(ue){return t.string(ue,this.defaultValue)}}function n(le,ue,Ie,Ve){return typeof le!="string"?ue:Ve&&le in Ve?Ve[le]:Ie.indexOf(le)===-1?ue:le}e.stringSet=n;class a extends p{constructor(ue,Ie,Ve,Ue,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.enum=Ue,xe.default=Ve),super(ue,Ie,Ve,xe),this.c=Ue}validate(ue){return n(ue,this.defaultValue,this.c)}}class i extends I{constructor(ue,Ie,Ve,Ue,xe,rt,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=xe,ot.default=Ue),super(ue,Ie,Ve,ot),this.c=xe,this.d=rt}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function s(le){switch(le){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Ie,Ve){return Ve===0?ue.accessibilitySupport:Ve}}class D extends I{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:$.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertSpace:u(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(le){le[le.Hidden=0]="Hidden",le[le.Blink=1]="Blink",le[le.Smooth=2]="Smooth",le[le.Phase=3]="Phase",le[le.Expand=4]="Expand",le[le.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function b(le){switch(le){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(le){le[le.Line=1]="Line",le[le.Block=2]="Block",le[le.Underline=3]="Underline",le[le.LineThin=4]="LineThin",le[le.BlockOutline=5]="BlockOutline",le[le.UnderlineThin=6]="UnderlineThin"})(f||(e.TextEditorCursorStyle=f={}));function g(le){switch(le){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=g;function P(le){switch(le){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class N extends k{constructor(){super(140)}compute(ue,Ie,Ve){const Ue=["monaco-editor"];return Ie.get(39)&&Ue.push(Ie.get(39)),ue.extraEditorClassName&&Ue.push(ue.extraEditorClassName),Ie.get(73)==="default"?Ue.push("mouse-default"):Ie.get(73)==="copy"&&Ue.push("mouse-copy"),Ie.get(110)&&Ue.push("showUnused"),Ie.get(138)&&Ue.push("showDeprecated"),Ue.join(" ")}}class O extends c{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(ue,Ie,Ve){return Ve&&ue.emptySelectionClipboard}}class M extends I{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:$.localize(16,null),included:d.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:$.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{cursorMoveOnType:u(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":n(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":n(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(Ie.loop,this.defaultValue.loop)}}}class j extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?j.OFF:ue==="true"?j.ON:ue:ue?j.ON:j.OFF}}e.EditorFontLigatures=j;class z extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",z.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?z.OFF:ue==="true"?z.TRANSLATE:ue:ue?z.TRANSLATE:z.OFF}compute(ue,Ie,Ve){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=z;class F extends k{constructor(){super(50)}compute(ue,Ie,Ve){return ue.fontInfo}}class K extends p{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(ue){const Ie=h.float(ue,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(Ie,6,100)}compute(ue,Ie,Ve){return ue.fontInfo.fontSize}}class V extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(o.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}class fe extends I{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ve,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ve,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ve,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ve,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ve,description:$.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{multiple:n(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??n(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??n(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??n(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??n(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??n(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends I{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:$.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:u(Ie.enabled,this.defaultValue.enabled),delay:o.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:u(Ie.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:u(Ie.above,this.defaultValue.above)}}}var Q;(function(le){le[le.None=0]="None",le[le.Text=1]="Text",le[le.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class X extends k{constructor(){super(143)}compute(ue,Ie,Ve){return X.computeLayout(Ie,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Ie=ue.height/ue.lineHeight,Ve=Math.floor(ue.paddingTop/ue.lineHeight);let Ue=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(Ue=Math.max(Ue,Ie-1));const xe=(Ve+ue.viewLineCount+Ue)/(ue.pixelRatio*ue.height),rt=Math.floor(ue.viewLineCount/xe);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Ue,desiredRatio:xe,minimapLineCount:rt}}static c(ue,Ie){const Ve=ue.outerWidth,Ue=ue.outerHeight,xe=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(xe*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const rt=Ie.stableMinimapLayoutInput,ot=rt&&ue.outerHeight===rt.outerHeight&&ue.lineHeight===rt.lineHeight&&ue.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&ue.pixelRatio===rt.pixelRatio&&ue.scrollBeyondLastLine===rt.scrollBeyondLastLine&&ue.paddingTop===rt.paddingTop&&ue.paddingBottom===rt.paddingBottom&&ue.minimap.enabled===rt.minimap.enabled&&ue.minimap.side===rt.minimap.side&&ue.minimap.size===rt.minimap.size&&ue.minimap.showSlider===rt.minimap.showSlider&&ue.minimap.renderCharacters===rt.minimap.renderCharacters&&ue.minimap.maxColumn===rt.minimap.maxColumn&&ue.minimap.scale===rt.minimap.scale&&ue.verticalScrollbarWidth===rt.verticalScrollbarWidth&&ue.isViewportWrapping===rt.isViewportWrapping,$t=ue.lineHeight,St=ue.typicalHalfwidthCharacterWidth,Yt=ue.scrollBeyondLastLine,Gt=ue.minimap.renderCharacters;let vt=xe>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const Ut=ue.minimap.maxColumn,Nt=ue.minimap.size,Bt=ue.minimap.side,At=ue.verticalScrollbarWidth,Rt=ue.viewLineCount,Ot=ue.remainingWidth,Wt=ue.isViewportWrapping,Jt=Gt?2:3;let qt=Math.floor(xe*Ue);const Vt=qt/xe;let Lt=!1,lt=!1,ft=Jt*vt,Ft=vt/xe,Kt=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Me,extraLinesBeforeFirstLine:Te,extraLinesBeyondLastLine:Se,desiredRatio:_,minimapLineCount:Fe}=X.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Yt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:Ue,lineHeight:$t,pixelRatio:xe});if(Rt/Fe>1)Lt=!0,lt=!0,vt=1,ft=1,Ft=vt/xe;else{let Ze=!1,Je=vt+1;if(Nt==="fit"){const nt=Math.ceil((Te+Rt+Se)*ft);Wt&&ot&&Ot<=Ie.stableFitRemainingWidth?(Ze=!0,Je=Ie.stableFitMaxMinimapScale):Ze=nt>qt}if(Nt==="fill"||Ze){Lt=!0;const nt=vt;ft=Math.min($t*xe,Math.max(1,Math.floor(1/_))),Wt&&ot&&Ot<=Ie.stableFitRemainingWidth&&(Je=Ie.stableFitMaxMinimapScale),vt=Math.min(Je,Math.max(1,Math.floor(ft/Jt))),vt>nt&&(Kt=Math.min(2,vt/nt)),Ft=vt/xe/Kt,qt=Math.ceil(Math.max(Me,Te+Rt+Se)*ft),Wt?(Ie.stableMinimapLayoutInput=ue,Ie.stableFitRemainingWidth=Ot,Ie.stableFitMaxMinimapScale=vt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Dt=Math.floor(Ut*Ft),ct=Math.min(Dt,Math.max(0,Math.floor((Ot-At-2)*Ft/(St+Ft)))+e.MINIMAP_GUTTER_WIDTH);let wt=Math.floor(xe*ct);const Ht=wt/xe;wt=Math.floor(wt*Kt);const Pt=Gt?1:2,Ge=Bt==="left"?0:Ve-ct-At;return{renderMinimap:Pt,minimapLeft:Ge,minimapWidth:ct,minimapHeightIsEditorHeight:Lt,minimapIsSampling:lt,minimapScale:vt,minimapLineHeight:ft,minimapCanvasInnerWidth:wt,minimapCanvasInnerHeight:qt,minimapCanvasOuterWidth:Ht,minimapCanvasOuterHeight:Vt}}static computeLayout(ue,Ie){const Ve=Ie.outerWidth|0,Ue=Ie.outerHeight|0,xe=Ie.lineHeight|0,rt=Ie.lineNumbersDigitCount|0,ot=Ie.typicalHalfwidthCharacterWidth,$t=Ie.maxDigitWidth,St=Ie.pixelRatio,Yt=Ie.viewLineCount,Gt=ue.get(135),vt=Gt==="inherit"?ue.get(134):Gt,Ut=vt==="inherit"?ue.get(130):vt,Nt=ue.get(133),Bt=Ie.isDominatedByLongLines,At=ue.get(57),Rt=ue.get(67).renderType!==0,Ot=ue.get(68),Wt=ue.get(104),Jt=ue.get(83),qt=ue.get(72),Vt=ue.get(102),Lt=Vt.verticalScrollbarSize,lt=Vt.verticalHasArrows,ft=Vt.arrowSize,Ft=Vt.horizontalScrollbarSize,Kt=ue.get(43),Dt=ue.get(109)!=="never";let ct=ue.get(65);Kt&&Dt&&(ct+=16);let wt=0;if(Rt){const jt=Math.max(rt,Ot);wt=Math.round(jt*$t)}let Ht=0;At&&(Ht=xe*Ie.glyphMarginDecorationLaneCount);let Pt=0,Ge=Pt+Ht,Me=Ge+wt,Te=Me+ct;const Se=Ve-Ht-wt-ct;let _=!1,Fe=!1,Ke=-1;vt==="inherit"&&Bt?(_=!0,Fe=!0):Ut==="on"||Ut==="bounded"?Fe=!0:Ut==="wordWrapColumn"&&(Ke=Nt);const Ze=X.c({outerWidth:Ve,outerHeight:Ue,lineHeight:xe,typicalHalfwidthCharacterWidth:ot,pixelRatio:St,scrollBeyondLastLine:Wt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:qt,verticalScrollbarWidth:Lt,viewLineCount:Yt,remainingWidth:Se,isViewportWrapping:Fe},Ie.memory||new R);Ze.renderMinimap!==0&&Ze.minimapLeft===0&&(Pt+=Ze.minimapWidth,Ge+=Ze.minimapWidth,Me+=Ze.minimapWidth,Te+=Ze.minimapWidth);const Je=Se-Ze.minimapWidth,nt=Math.max(1,Math.floor((Je-Lt-2)/ot)),pt=lt?ft:0;return Fe&&(Ke=Math.max(1,nt),Ut==="bounded"&&(Ke=Math.min(Ke,Nt))),{width:Ve,height:Ue,glyphMarginLeft:Pt,glyphMarginWidth:Ht,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Ge,lineNumbersWidth:wt,decorationsLeft:Me,decorationsWidth:ct,contentLeft:Te,contentWidth:Je,minimap:Ze,viewportColumn:nt,isWordWrapMinified:_,isViewportWrapping:Fe,wrappingColumn:Ke,verticalScrollbarWidth:Lt,horizontalScrollbarHeight:Ft,overviewRuler:{top:pt,width:Lt,height:Ue-2*pt,right:0}}}}e.EditorLayoutInfoComputer=X;class oe extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(ue){return n(ue,"simple",["simple","advanced"])}compute(ue,Ie,Ve){return Ie.get(2)===2?"advanced":Ve}}class x extends I{constructor(){const ue={enabled:!0};super(64,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"boolean",default:ue.enabled,description:$.localize(50,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:u(ue.enabled,this.defaultValue.enabled)}}}class ae extends I{constructor(){const ue={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:$.localize(54,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:u(Ie.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:n(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:u(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class we extends I{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,d.$k?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,d.$k?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:$.localize(62,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:n(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:u(Ie.padding,this.defaultValue.padding)}}}class G extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):o.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Ie,Ve){return Ve<0?o.clampedInt(-Ve*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class U extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>h.clamp(ue,0,150),{markdownDescription:$.localize(63,null)})}compute(ue,Ie,Ve){return ue.fontInfo.lineHeight}}class q extends I{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:ue.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:$.localize(74,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:u(Ie.enabled,this.defaultValue.enabled),autohide:u(Ie.autohide,this.defaultValue.autohide),size:n(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(Ie.side,this.defaultValue.side,["right","left"]),showSlider:n(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(Ie.scale,1,1,3),maxColumn:o.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function me(le){return le==="ctrlCmd"?d.$k?"metaKey":"ctrlKey":"altKey"}class ee extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{top:o.clampedInt(Ie.top,0,0,1e3),bottom:o.clampedInt(Ie.bottom,0,0,1e3)}}}class ne extends I{constructor(){const ue={enabled:!0,cycle:!0};super(85,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:$.localize(78,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:u(Ie.enabled,this.defaultValue.enabled),cycle:u(Ie.cycle,this.defaultValue.cycle)}}}class re extends k{constructor(){super(141)}compute(ue,Ie,Ve){return ue.pixelRatio}}class Ee extends I{constructor(){const ue={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(88,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ue.strings,description:$.localize(82,null)},comments:{anyOf:Ie,default:ue.comments,description:$.localize(83,null)},other:{anyOf:Ie,default:ue.other,description:$.localize(84,null)}},default:ue,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const St=ue?"on":"off";return{comments:St,strings:St,other:St}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Ie,comments:Ve,strings:Ue}=ue,xe=["on","inline","off"];let rt,ot,$t;return typeof Ie=="boolean"?rt=Ie?"on":"off":rt=n(Ie,this.defaultValue.other,xe),typeof Ve=="boolean"?ot=Ve?"on":"off":ot=n(Ve,this.defaultValue.comments,xe),typeof Ue=="boolean"?$t=Ue?"on":"off":$t=n(Ue,this.defaultValue.strings,xe),{other:rt,comments:ot,strings:$t}}}var ce;(function(le){le[le.Off=0]="Off",le[le.On=1]="On",le[le.Relative=2]="Relative",le[le.Interval=3]="Interval",le[le.Custom=4]="Custom"})(ce||(e.RenderLineNumbersType=ce={}));class de extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(ue){let Ie=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Ie=4,Ve=ue):ue==="interval"?Ie=3:ue==="relative"?Ie=2:ue==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ve}}}function te(le){const ue=le.get(97);return ue==="editable"?le.get(90):ue!=="on"}e.filterValidationDecorations=te;class he extends I{constructor(){const ue=[],Ie={type:"number",description:$.localize(91,null)};super(101,"rulers",ue,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:ue,description:$.localize(93,null)})}validate(ue){if(Array.isArray(ue)){const Ie=[];for(const Ve of ue)if(typeof Ve=="number")Ie.push({column:o.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Ue=Ve;Ie.push({column:o.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return Ie.sort((Ve,Ue)=>Ve.column-Ue.column),Ie}return this.defaultValue}}class be extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Pe(le,ue){if(typeof le!="string")return ue;switch(le){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends I{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:$.localize(104,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue,Ve=o.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=o.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:u(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:o.clampedInt(Ie.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:o.clampedInt(Ie.verticalSliderSize,Ue,0,1e3),scrollByPage:u(Ie.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends I{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:$.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:$.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:$.localize(111,null)}})}applyUpdate(ue,Ie){let Ve=!1;Ie.allowedCharacters&&ue&&(T.$8m(ue.allowedCharacters,Ie.allowedCharacters)||(ue={...ue,allowedCharacters:Ie.allowedCharacters},Ve=!0)),Ie.allowedLocales&&ue&&(T.$8m(ue.allowedLocales,Ie.allowedLocales)||(ue={...ue,allowedLocales:Ie.allowedLocales},Ve=!0));const Ue=super.applyUpdate(ue,Ie);return Ve?new w(Ue.newValue,!0):Ue}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{nonBasicASCII:ge(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ge(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ge(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Ie){if(typeof ue!="object"||!ue)return Ie;const Ve={};for(const[Ue,xe]of Object.entries(ue))xe===!0&&(Ve[Ue]=!0);return Ve}}class ie extends I{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:$.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover"],enumDescriptions:[$.localize(113,null),$.localize(114,null)],description:$.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:$.localize(116,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:u(Ie.enabled,this.defaultValue.enabled),mode:n(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:n(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:u(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:u(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class se extends I{constructor(){const ue={enabled:L.$1r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$1r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:$.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:$.localize(118,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:u(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:u(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Y extends I{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(119,null),$.localize(120,null),$.localize(121,null)],default:ue.bracketPairs,description:$.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(123,null),$.localize(124,null),$.localize(125,null)],default:ue.bracketPairsHorizontal,description:$.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:$.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:$.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(129,null),$.localize(130,null),$.localize(131,null)],default:ue.highlightActiveIndentation,description:$.localize(132,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{bracketPairs:ge(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ge(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:ge(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ge(le,ue,Ie){const Ve=Ie.indexOf(le);return Ve===-1?ue:Ie[Ve]}class ye extends I{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(133,null),$.localize(134,null)],default:ue.insertMode,description:$.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:$.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:$.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:$.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(139,null),$.localize(140,null),$.localize(141,null),$.localize(142,null)],default:ue.selectionMode,markdownDescription:$.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:$.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:$.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:$.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:$.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:$.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertMode:n(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:n(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:u(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:u(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:u(Ie.preview,this.defaultValue.preview),previewMode:n(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(Ie.showMethods,this.defaultValue.showMethods),showFunctions:u(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:u(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:u(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:u(Ie.showFields,this.defaultValue.showFields),showVariables:u(Ie.showVariables,this.defaultValue.showVariables),showClasses:u(Ie.showClasses,this.defaultValue.showClasses),showStructs:u(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:u(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:u(Ie.showModules,this.defaultValue.showModules),showProperties:u(Ie.showProperties,this.defaultValue.showProperties),showEvents:u(Ie.showEvents,this.defaultValue.showEvents),showOperators:u(Ie.showOperators,this.defaultValue.showOperators),showUnits:u(Ie.showUnits,this.defaultValue.showUnits),showValues:u(Ie.showValues,this.defaultValue.showValues),showConstants:u(Ie.showConstants,this.defaultValue.showConstants),showEnums:u(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:u(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(Ie.showKeywords,this.defaultValue.showKeywords),showWords:u(Ie.showWords,this.defaultValue.showWords),showColors:u(Ie.showColors,this.defaultValue.showColors),showFiles:u(Ie.showFiles,this.defaultValue.showFiles),showReferences:u(Ie.showReferences,this.defaultValue.showReferences),showFolders:u(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:u(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:u(Ie.showUsers,this.defaultValue.showUsers),showIssues:u(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(182,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:u(ue.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(le){le[le.None=0]="None",le[le.Same=1]="Same",le[le.Indent=2]="Indent",le[le.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class _e extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(183,null),$.localize(184,null),$.localize(185,null),$.localize(186,null)],description:$.localize(187,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Ie,Ve){return Ie.get(2)===2?0:Ve}}class Ye extends k{constructor(){super(144)}compute(ue,Ie,Ve){const Ue=Ie.get(143);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}class it extends I{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:$.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(190,null),$.localize(191,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:u(Ie.enabled,this.defaultValue.enabled),showDropSelector:n(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class et extends I{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:$.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(194,null),$.localize(195,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:u(Ie.enabled,this.defaultValue.enabled),showPasteSelector:n(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Ne="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:d.$k?Ne:d.$l?qe:Ae,fontWeight:"normal",fontSize:d.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(le){return e.editorOptionsRegistry[le.id]=le,le}var Xe;(function(le){le[le.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",le[le.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",le[le.accessibilitySupport=2]="accessibilitySupport",le[le.accessibilityPageSize=3]="accessibilityPageSize",le[le.ariaLabel=4]="ariaLabel",le[le.ariaRequired=5]="ariaRequired",le[le.autoClosingBrackets=6]="autoClosingBrackets",le[le.autoClosingComments=7]="autoClosingComments",le[le.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",le[le.autoClosingDelete=9]="autoClosingDelete",le[le.autoClosingOvertype=10]="autoClosingOvertype",le[le.autoClosingQuotes=11]="autoClosingQuotes",le[le.autoIndent=12]="autoIndent",le[le.automaticLayout=13]="automaticLayout",le[le.autoSurround=14]="autoSurround",le[le.bracketPairColorization=15]="bracketPairColorization",le[le.guides=16]="guides",le[le.codeLens=17]="codeLens",le[le.codeLensFontFamily=18]="codeLensFontFamily",le[le.codeLensFontSize=19]="codeLensFontSize",le[le.colorDecorators=20]="colorDecorators",le[le.colorDecoratorsLimit=21]="colorDecoratorsLimit",le[le.columnSelection=22]="columnSelection",le[le.comments=23]="comments",le[le.contextmenu=24]="contextmenu",le[le.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",le[le.cursorBlinking=26]="cursorBlinking",le[le.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",le[le.cursorStyle=28]="cursorStyle",le[le.cursorSurroundingLines=29]="cursorSurroundingLines",le[le.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",le[le.cursorWidth=31]="cursorWidth",le[le.disableLayerHinting=32]="disableLayerHinting",le[le.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",le[le.domReadOnly=34]="domReadOnly",le[le.dragAndDrop=35]="dragAndDrop",le[le.dropIntoEditor=36]="dropIntoEditor",le[le.emptySelectionClipboard=37]="emptySelectionClipboard",le[le.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",le[le.extraEditorClassName=39]="extraEditorClassName",le[le.fastScrollSensitivity=40]="fastScrollSensitivity",le[le.find=41]="find",le[le.fixedOverflowWidgets=42]="fixedOverflowWidgets",le[le.folding=43]="folding",le[le.foldingStrategy=44]="foldingStrategy",le[le.foldingHighlight=45]="foldingHighlight",le[le.foldingImportsByDefault=46]="foldingImportsByDefault",le[le.foldingMaximumRegions=47]="foldingMaximumRegions",le[le.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",le[le.fontFamily=49]="fontFamily",le[le.fontInfo=50]="fontInfo",le[le.fontLigatures=51]="fontLigatures",le[le.fontSize=52]="fontSize",le[le.fontWeight=53]="fontWeight",le[le.fontVariations=54]="fontVariations",le[le.formatOnPaste=55]="formatOnPaste",le[le.formatOnType=56]="formatOnType",le[le.glyphMargin=57]="glyphMargin",le[le.gotoLocation=58]="gotoLocation",le[le.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",le[le.hover=60]="hover",le[le.inDiffEditor=61]="inDiffEditor",le[le.inlineSuggest=62]="inlineSuggest",le[le.letterSpacing=63]="letterSpacing",le[le.lightbulb=64]="lightbulb",le[le.lineDecorationsWidth=65]="lineDecorationsWidth",le[le.lineHeight=66]="lineHeight",le[le.lineNumbers=67]="lineNumbers",le[le.lineNumbersMinChars=68]="lineNumbersMinChars",le[le.linkedEditing=69]="linkedEditing",le[le.links=70]="links",le[le.matchBrackets=71]="matchBrackets",le[le.minimap=72]="minimap",le[le.mouseStyle=73]="mouseStyle",le[le.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",le[le.mouseWheelZoom=75]="mouseWheelZoom",le[le.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",le[le.multiCursorModifier=77]="multiCursorModifier",le[le.multiCursorPaste=78]="multiCursorPaste",le[le.multiCursorLimit=79]="multiCursorLimit",le[le.occurrencesHighlight=80]="occurrencesHighlight",le[le.overviewRulerBorder=81]="overviewRulerBorder",le[le.overviewRulerLanes=82]="overviewRulerLanes",le[le.padding=83]="padding",le[le.pasteAs=84]="pasteAs",le[le.parameterHints=85]="parameterHints",le[le.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",le[le.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",le[le.quickSuggestions=88]="quickSuggestions",le[le.quickSuggestionsDelay=89]="quickSuggestionsDelay",le[le.readOnly=90]="readOnly",le[le.readOnlyMessage=91]="readOnlyMessage",le[le.renameOnType=92]="renameOnType",le[le.renderControlCharacters=93]="renderControlCharacters",le[le.renderFinalNewline=94]="renderFinalNewline",le[le.renderLineHighlight=95]="renderLineHighlight",le[le.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",le[le.renderValidationDecorations=97]="renderValidationDecorations",le[le.renderWhitespace=98]="renderWhitespace",le[le.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",le[le.roundedSelection=100]="roundedSelection",le[le.rulers=101]="rulers",le[le.scrollbar=102]="scrollbar",le[le.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",le[le.scrollBeyondLastLine=104]="scrollBeyondLastLine",le[le.scrollPredominantAxis=105]="scrollPredominantAxis",le[le.selectionClipboard=106]="selectionClipboard",le[le.selectionHighlight=107]="selectionHighlight",le[le.selectOnLineNumbers=108]="selectOnLineNumbers",le[le.showFoldingControls=109]="showFoldingControls",le[le.showUnused=110]="showUnused",le[le.snippetSuggestions=111]="snippetSuggestions",le[le.smartSelect=112]="smartSelect",le[le.smoothScrolling=113]="smoothScrolling",le[le.stickyScroll=114]="stickyScroll",le[le.stickyTabStops=115]="stickyTabStops",le[le.stopRenderingLineAfter=116]="stopRenderingLineAfter",le[le.suggest=117]="suggest",le[le.suggestFontSize=118]="suggestFontSize",le[le.suggestLineHeight=119]="suggestLineHeight",le[le.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",le[le.suggestSelection=121]="suggestSelection",le[le.tabCompletion=122]="tabCompletion",le[le.tabIndex=123]="tabIndex",le[le.unicodeHighlighting=124]="unicodeHighlighting",le[le.unusualLineTerminators=125]="unusualLineTerminators",le[le.useShadowDOM=126]="useShadowDOM",le[le.useTabStops=127]="useTabStops",le[le.wordBreak=128]="wordBreak",le[le.wordSeparators=129]="wordSeparators",le[le.wordWrap=130]="wordWrap",le[le.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",le[le.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",le[le.wordWrapColumn=133]="wordWrapColumn",le[le.wordWrapOverride1=134]="wordWrapOverride1",le[le.wordWrapOverride2=135]="wordWrapOverride2",le[le.wrappingIndent=136]="wrappingIndent",le[le.wrappingStrategy=137]="wrappingStrategy",le[le.showDeprecated=138]="showDeprecated",le[le.inlayHints=139]="inlayHints",le[le.editorClassName=140]="editorClassName",le[le.pixelRatio=141]="pixelRatio",le[le.tabFocusMode=142]="tabFocusMode",le[le.layoutInfo=143]="layoutInfo",le[le.wrappingInfo=144]="wrappingInfo",le[le.defaultColorDecorators=145]="defaultColorDecorators",le[le.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",le[le.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new c(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(196,null)})),acceptSuggestionOnEnter:Le(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(197,null),""],markdownDescription:$.localize(198,null)})),accessibilitySupport:Le(new l),accessibilityPageSize:Le(new o(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(199,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",$.localize(200,null))),ariaRequired:Le(new c(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new c(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:Le(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(202,null),$.localize(203,null),""],description:$.localize(204,null)})),autoClosingComments:Le(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(205,null),$.localize(206,null),""],description:$.localize(207,null)})),autoClosingDelete:Le(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(208,null),""],description:$.localize(209,null)})),autoClosingOvertype:Le(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(210,null),""],description:$.localize(211,null)})),autoClosingQuotes:Le(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(212,null),$.localize(213,null),""],description:$.localize(214,null)})),autoIndent:Le(new i(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],s,{enumDescriptions:[$.localize(215,null),$.localize(216,null),$.localize(217,null),$.localize(218,null),$.localize(219,null)],description:$.localize(220,null)})),automaticLayout:Le(new c(13,"automaticLayout",!1)),autoSurround:Le(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(221,null),$.localize(222,null),$.localize(223,null),""],description:$.localize(224,null)})),bracketPairColorization:Le(new se),bracketPairGuides:Le(new Y),stickyTabStops:Le(new c(115,"stickyTabStops",!1,{description:$.localize(225,null)})),codeLens:Le(new c(17,"codeLens",!0,{description:$.localize(226,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:$.localize(227,null)})),codeLensFontSize:Le(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(228,null)})),colorDecorators:Le(new c(20,"colorDecorators",!0,{description:$.localize(229,null)})),colorDecoratorActivatedOn:Le(new a(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(230,null),$.localize(231,null),$.localize(232,null)],description:$.localize(233,null)})),colorDecoratorsLimit:Le(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(234,null)})),columnSelection:Le(new c(22,"columnSelection",!1,{description:$.localize(235,null)})),comments:Le(new D),contextmenu:Le(new c(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new c(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(236,null)})),cursorBlinking:Le(new i(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:$.localize(237,null)})),cursorSmoothCaretAnimation:Le(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(238,null),$.localize(239,null),$.localize(240,null)],description:$.localize(241,null)})),cursorStyle:Le(new i(28,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:$.localize(242,null)})),cursorSurroundingLines:Le(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(243,null)})),cursorSurroundingLinesStyle:Le(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(244,null),$.localize(245,null)],markdownDescription:$.localize(246,null)})),cursorWidth:Le(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(247,null)})),disableLayerHinting:Le(new c(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new c(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new c(34,"domReadOnly",!1)),dragAndDrop:Le(new c(35,"dragAndDrop",!0,{description:$.localize(248,null)})),emptySelectionClipboard:Le(new O),dropIntoEditor:Le(new it),stickyScroll:Le(new ae),experimentalWhitespaceRendering:Le(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(249,null),$.localize(250,null),$.localize(251,null)],description:$.localize(252,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new h(40,"fastScrollSensitivity",5,le=>le<=0?5:le,{markdownDescription:$.localize(253,null)})),find:Le(new M),fixedOverflowWidgets:Le(new c(42,"fixedOverflowWidgets",!1)),folding:Le(new c(43,"folding",!0,{description:$.localize(254,null)})),foldingStrategy:Le(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(255,null),$.localize(256,null)],description:$.localize(257,null)})),foldingHighlight:Le(new c(45,"foldingHighlight",!0,{description:$.localize(258,null)})),foldingImportsByDefault:Le(new c(46,"foldingImportsByDefault",!1,{description:$.localize(259,null)})),foldingMaximumRegions:Le(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(260,null)})),unfoldOnClickAfterEndOfLine:Le(new c(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(261,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(262,null)})),fontInfo:Le(new F),fontLigatures2:Le(new j),fontSize:Le(new K),fontWeight:Le(new V),fontVariations:Le(new z),formatOnPaste:Le(new c(55,"formatOnPaste",!1,{description:$.localize(263,null)})),formatOnType:Le(new c(56,"formatOnType",!1,{description:$.localize(264,null)})),glyphMargin:Le(new c(57,"glyphMargin",!0,{description:$.localize(265,null)})),gotoLocation:Le(new fe),hideCursorInOverviewRuler:Le(new c(59,"hideCursorInOverviewRuler",!1,{description:$.localize(266,null)})),hover:Le(new Z),inDiffEditor:Le(new c(61,"inDiffEditor",!1)),letterSpacing:Le(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,le=>h.clamp(le,-5,20),{description:$.localize(267,null)})),lightbulb:Le(new x),lineDecorationsWidth:Le(new G),lineHeight:Le(new U),lineNumbers:Le(new de),lineNumbersMinChars:Le(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new c(69,"linkedEditing",!1,{description:$.localize(268,null)})),links:Le(new c(70,"links",!0,{description:$.localize(269,null)})),matchBrackets:Le(new a(71,"matchBrackets","always",["always","near","never"],{description:$.localize(270,null)})),minimap:Le(new q),mouseStyle:Le(new a(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new h(74,"mouseWheelScrollSensitivity",1,le=>le===0?1:le,{markdownDescription:$.localize(271,null)})),mouseWheelZoom:Le(new c(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(272,null)})),multiCursorMergeOverlapping:Le(new c(76,"multiCursorMergeOverlapping",!0,{description:$.localize(273,null)})),multiCursorModifier:Le(new i(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],me,{markdownEnumDescriptions:[$.localize(274,null),$.localize(275,null)],markdownDescription:$.localize(276,null)})),multiCursorPaste:Le(new a(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(277,null),$.localize(278,null)],markdownDescription:$.localize(279,null)})),multiCursorLimit:Le(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(280,null)})),occurrencesHighlight:Le(new c(80,"occurrencesHighlight",!0,{description:$.localize(281,null)})),overviewRulerBorder:Le(new c(81,"overviewRulerBorder",!0,{description:$.localize(282,null)})),overviewRulerLanes:Le(new o(82,"overviewRulerLanes",3,0,3)),padding:Le(new ee),pasteAs:Le(new et),parameterHints:Le(new ne),peekWidgetDefaultFocus:Le(new a(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(283,null),$.localize(284,null)],description:$.localize(285,null)})),definitionLinkOpensInPeek:Le(new c(87,"definitionLinkOpensInPeek",!1,{description:$.localize(286,null)})),quickSuggestions:Le(new Ee),quickSuggestionsDelay:Le(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(287,null)})),readOnly:Le(new c(90,"readOnly",!1)),readOnlyMessage:Le(new be),renameOnType:Le(new c(92,"renameOnType",!1,{description:$.localize(288,null),markdownDeprecationMessage:$.localize(289,null)})),renderControlCharacters:Le(new c(93,"renderControlCharacters",!0,{description:$.localize(290,null),restricted:!0})),renderFinalNewline:Le(new a(94,"renderFinalNewline",d.$l?"dimmed":"on",["off","on","dimmed"],{description:$.localize(291,null)})),renderLineHighlight:Le(new a(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(292,null)],description:$.localize(293,null)})),renderLineHighlightOnlyWhenFocus:Le(new c(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(294,null)})),renderValidationDecorations:Le(new a(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new a(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(295,null),$.localize(296,null),$.localize(297,null),""],description:$.localize(298,null)})),revealHorizontalRightPadding:Le(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new c(100,"roundedSelection",!0,{description:$.localize(299,null)})),rulers:Le(new he),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(300,null)})),scrollBeyondLastLine:Le(new c(104,"scrollBeyondLastLine",!0,{description:$.localize(301,null)})),scrollPredominantAxis:Le(new c(105,"scrollPredominantAxis",!0,{description:$.localize(302,null)})),selectionClipboard:Le(new c(106,"selectionClipboard",!0,{description:$.localize(303,null),included:d.$l})),selectionHighlight:Le(new c(107,"selectionHighlight",!0,{description:$.localize(304,null)})),selectOnLineNumbers:Le(new c(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new a(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(305,null),$.localize(306,null),$.localize(307,null)],description:$.localize(308,null)})),showUnused:Le(new c(110,"showUnused",!0,{description:$.localize(309,null)})),showDeprecated:Le(new c(138,"showDeprecated",!0,{description:$.localize(310,null)})),inlayHints:Le(new we),snippetSuggestions:Le(new a(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(311,null),$.localize(312,null),$.localize(313,null),$.localize(314,null)],description:$.localize(315,null)})),smartSelect:Le(new je),smoothScrolling:Le(new c(113,"smoothScrolling",!1,{description:$.localize(316,null)})),stopRenderingLineAfter:Le(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ye),inlineSuggest:Le(new ie),inlineCompletionsAccessibilityVerbose:Le(new c(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(317,null)})),suggestFontSize:Le(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new c(120,"suggestOnTriggerCharacters",!0,{description:$.localize(320,null)})),suggestSelection:Le(new a(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(321,null),$.localize(322,null),$.localize(323,null)],description:$.localize(324,null)})),tabCompletion:Le(new a(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(325,null),$.localize(326,null),$.localize(327,null)],description:$.localize(328,null)})),tabIndex:Le(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new J),unusualLineTerminators:Le(new a(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(329,null),$.localize(330,null),$.localize(331,null)],description:$.localize(332,null)})),useShadowDOM:Le(new c(126,"useShadowDOM",!0)),useTabStops:Le(new c(127,"useTabStops",!0,{description:$.localize(333,null)})),wordBreak:Le(new a(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(334,null),$.localize(335,null)],description:$.localize(336,null)})),wordSeparators:Le(new t(129,"wordSeparators",A.$2r,{description:$.localize(337,null)})),wordWrap:Le(new a(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(338,null),$.localize(339,null),$.localize(340,null),$.localize(341,null)],description:$.localize(342,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(343,null)})),wordWrapOverride1:Le(new a(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new a(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new N),defaultColorDecorators:Le(new c(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(344,null)})),pixelRatio:Le(new re),tabFocusMode:Le(new c(142,"tabFocusMode",!1,{markdownDescription:$.localize(345,null)})),layoutInfo:Le(new X),wrappingInfo:Le(new Ye),wrappingIndent:Le(new _e),wrappingStrategy:Le(new oe)}}),define(De[187],Ce([10,11]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(De[83],Ce([1,0,79,2,164,34,174,187]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$ht=e.$gt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$ft=e.$et=e.SymbolKinds=e.SymbolTag=e.$dt=e.$ct=e.SymbolKind=e.$bt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$at=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$_s=e.$$s=e.$0s=void 0;class E{constructor(j,z,F){this.offset=j,this.type=z,this.language=F,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$0s=E;class v{constructor(j,z){this.tokens=j,this.endState=z,this._tokenizationResultBrand=void 0}}e.$$s=v;class R{constructor(j,z){this.tokens=j,this.endState=z,this._encodedTokenizationResultBrand=void 0}}e.$_s=R;var I;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var w;(function(M){const j=new Map;j.set(0,C.$Tj.symbolMethod),j.set(1,C.$Tj.symbolFunction),j.set(2,C.$Tj.symbolConstructor),j.set(3,C.$Tj.symbolField),j.set(4,C.$Tj.symbolVariable),j.set(5,C.$Tj.symbolClass),j.set(6,C.$Tj.symbolStruct),j.set(7,C.$Tj.symbolInterface),j.set(8,C.$Tj.symbolModule),j.set(9,C.$Tj.symbolProperty),j.set(10,C.$Tj.symbolEvent),j.set(11,C.$Tj.symbolOperator),j.set(12,C.$Tj.symbolUnit),j.set(13,C.$Tj.symbolValue),j.set(15,C.$Tj.symbolEnum),j.set(14,C.$Tj.symbolConstant),j.set(15,C.$Tj.symbolEnum),j.set(16,C.$Tj.symbolEnumMember),j.set(17,C.$Tj.symbolKeyword),j.set(27,C.$Tj.symbolSnippet),j.set(18,C.$Tj.symbolText),j.set(19,C.$Tj.symbolColor),j.set(20,C.$Tj.symbolFile),j.set(21,C.$Tj.symbolReference),j.set(22,C.$Tj.symbolCustomColor),j.set(23,C.$Tj.symbolFolder),j.set(24,C.$Tj.symbolTypeParameter),j.set(25,C.$Tj.account),j.set(26,C.$Tj.issues);function z(V){let fe=j.get(V);return fe||(console.info("No codicon found for CompletionItemKind "+V),fe=C.$Tj.symbolProperty),fe}M.toIcon=z;const F=new Map;F.set("method",0),F.set("function",1),F.set("constructor",2),F.set("field",3),F.set("variable",4),F.set("class",5),F.set("struct",6),F.set("interface",7),F.set("module",8),F.set("property",9),F.set("event",10),F.set("operator",11),F.set("unit",12),F.set("value",13),F.set("constant",14),F.set("enum",15),F.set("enum-member",16),F.set("enumMember",16),F.set("keyword",17),F.set("snippet",27),F.set("text",18),F.set("color",19),F.set("file",20),F.set("reference",21),F.set("customcolor",22),F.set("folder",23),F.set("type-parameter",24),F.set("typeParameter",24),F.set("account",25),F.set("issue",26);function K(V,fe){let Z=F.get(V);return typeof Z>"u"&&!fe&&(Z=9),Z}M.fromString=K})(w||(e.CompletionItemKinds=w={}));var y;(function(M){M[M.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var k;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(k||(e.CompletionItemInsertTextRule=k={}));var p;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(e.CompletionTriggerKind=p={}));var u;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(u||(e.InlineCompletionTriggerKind=u={}));class c{constructor(j,z,F,K){this.range=j,this.text=z,this.completionKind=F,this.isSnippetText=K}equals(j){return L.$qs.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$at=c;var r;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(r||(e.CodeActionTriggerType=r={}));var o;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(o||(e.SignatureHelpTriggerKind=o={}));var m;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(m||(e.DocumentHighlightKind=m={}));function h(M){return M&&T.URI.isUri(M.uri)&&L.$qs.isIRange(M.range)&&(L.$qs.isIRange(M.originSelectionRange)||L.$qs.isIRange(M.targetSelectionRange))}e.$bt=h;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$ct={[17]:(0,$.localize)(0,null),[16]:(0,$.localize)(1,null),[4]:(0,$.localize)(2,null),[13]:(0,$.localize)(3,null),[8]:(0,$.localize)(4,null),[9]:(0,$.localize)(5,null),[21]:(0,$.localize)(6,null),[23]:(0,$.localize)(7,null),[7]:(0,$.localize)(8,null),[0]:(0,$.localize)(9,null),[11]:(0,$.localize)(10,null),[10]:(0,$.localize)(11,null),[19]:(0,$.localize)(12,null),[5]:(0,$.localize)(13,null),[1]:(0,$.localize)(14,null),[2]:(0,$.localize)(15,null),[20]:(0,$.localize)(16,null),[15]:(0,$.localize)(17,null),[18]:(0,$.localize)(18,null),[24]:(0,$.localize)(19,null),[3]:(0,$.localize)(20,null),[6]:(0,$.localize)(21,null),[14]:(0,$.localize)(22,null),[22]:(0,$.localize)(23,null),[25]:(0,$.localize)(24,null),[12]:(0,$.localize)(25,null)};function n(M,j){return(0,$.localize)(26,null,M,e.$ct[j])}e.$dt=n;var a;(function(M){M[M.Deprecated=1]="Deprecated"})(a||(e.SymbolTag=a={}));var i;(function(M){const j=new Map;j.set(0,C.$Tj.symbolFile),j.set(1,C.$Tj.symbolModule),j.set(2,C.$Tj.symbolNamespace),j.set(3,C.$Tj.symbolPackage),j.set(4,C.$Tj.symbolClass),j.set(5,C.$Tj.symbolMethod),j.set(6,C.$Tj.symbolProperty),j.set(7,C.$Tj.symbolField),j.set(8,C.$Tj.symbolConstructor),j.set(9,C.$Tj.symbolEnum),j.set(10,C.$Tj.symbolInterface),j.set(11,C.$Tj.symbolFunction),j.set(12,C.$Tj.symbolVariable),j.set(13,C.$Tj.symbolConstant),j.set(14,C.$Tj.symbolString),j.set(15,C.$Tj.symbolNumber),j.set(16,C.$Tj.symbolBoolean),j.set(17,C.$Tj.symbolArray),j.set(18,C.$Tj.symbolObject),j.set(19,C.$Tj.symbolKey),j.set(20,C.$Tj.symbolNull),j.set(21,C.$Tj.symbolEnumMember),j.set(22,C.$Tj.symbolStruct),j.set(23,C.$Tj.symbolEvent),j.set(24,C.$Tj.symbolOperator),j.set(25,C.$Tj.symbolTypeParameter);function z(F){let K=j.get(F);return K||(console.info("No codicon found for SymbolKind "+F),K=C.$Tj.symbolProperty),K}M.toIcon=z})(i||(e.SymbolKinds=i={}));class s{static asEditOperation(j){return d.$rs.replace(L.$qs.lift(j.range),j.text)}}e.$et=s;class l{static{this.Comment=new l("comment")}static{this.Imports=new l("imports")}static{this.Region=new l("region")}static fromValue(j){switch(j){case"comment":return l.Comment;case"imports":return l.Imports;case"region":return l.Region}return new l(j)}constructor(j){this.value=j}}e.$ft=l;var D;(function(M){function j(z){return!z||typeof z!="object"?!1:typeof z.id=="string"&&typeof z.title=="string"}M.is=j})(D||(e.Command=D={}));var S;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(S||(e.CommentThreadCollapsibleState=S={}));var b;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(b||(e.CommentThreadState=b={}));var f;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(f||(e.CommentMode=f={}));var g;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(g||(e.CommentState=g={}));var P;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class N{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$gt=N,e.$ht=new A.$2s;var O;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(O||(e.ExternalUriOpenerPriority=O={}))}),define(De[188],Ce([10,11]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[189],Ce([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(De[190],Ce([10,11]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(De[191],Ce([10,11]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(De[192],Ce([10,11]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[193],Ce([10,11]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[194],Ce([10,11]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[195],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(De[196],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(De[197],Ce([10,11]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[198],Ce([10,11]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(De[199],Ce([10,11]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(De[200],Ce([10,11]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(De[201],Ce([10,11]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(De[202],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostChat",e)}),define(De[203],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[204],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[205],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[206],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(De[207],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[208],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(De[209],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[210],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[211],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[212],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[213],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[214],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[215],Ce([10,11]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[216],Ce([10,11]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(De[217],Ce([10,11]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(De[218],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[219],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[220],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[221],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[222],Ce([10,11]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[223],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[224],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[225],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(De[226],Ce([10,11]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[227],Ce([1,0,8,190]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.TokenType=void 0;var d;(function(v){v[v.LParen=0]="LParen",v[v.RParen=1]="RParen",v[v.Neg=2]="Neg",v[v.Eq=3]="Eq",v[v.NotEq=4]="NotEq",v[v.Lt=5]="Lt",v[v.LtEq=6]="LtEq",v[v.Gt=7]="Gt",v[v.GtEq=8]="GtEq",v[v.RegexOp=9]="RegexOp",v[v.RegexStr=10]="RegexStr",v[v.True=11]="True",v[v.False=12]="False",v[v.In=13]="In",v[v.Not=14]="Not",v[v.And=15]="And",v[v.Or=16]="Or",v[v.Str=17]="Str",v[v.QuotedStr=18]="QuotedStr",v[v.Error=19]="Error",v[v.EOF=20]="EOF"})(d||(e.TokenType=d={}));function L(...v){switch(v.length){case 1:return(0,T.localize)(0,null,v[0]);case 2:return(0,T.localize)(1,null,v[0],v[1]);case 3:return(0,T.localize)(2,null,v[0],v[1],v[2]);default:return}}const A=(0,T.localize)(3,null),$=(0,T.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,C.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const I=this.d,w=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:w};this.g.push({offset:I,lexeme:w,additionalInfo:R}),this.f.push(y)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const I=this.c.substring(this.d,this.e),w=E.b.get(I);w?this.k(w):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,I=!1,w=!1;for(;;){if(R>=this.c.length){this.e=R,this.l($);return}const k=this.c.charCodeAt(R);if(I)I=!1;else if(k===47&&!w){R++;break}else k===91?w=!0:k===92?I=!0:k===93&&(w=!1);R++}for(;R<this.c.length&&E.a.has(this.c.charCodeAt(R));)R++;this.e=R;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ji=E}),define(De[228],Ce([1,0,23,38,193,373]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function E(c){return c=c.trim(),c==="*"||A.test(c)}e.$Jo=E;function v(c){if(!E(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=c.match(A);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}e.$Ko=v;function R(c){if(!c)return null;const r=c.majorBase,o=c.majorMustEqual,m=c.minorBase;let h=c.minorMustEqual;const t=c.patchBase;let n=c.patchMustEqual;c.hasCaret&&(r===0||(h=!1),n=!1);let a=0;if(c.preRelease){const i=$.exec(c.preRelease);if(i){const[,s,l,D]=i;a=Date.UTC(Number(s),Number(l)-1,Number(D))}}return{majorBase:r,majorMustEqual:o,minorBase:m,minorMustEqual:h,patchBase:t,patchMustEqual:n,isMinimum:c.hasGreaterEquals,notBefore:a}}e.$Lo=R;function I(c,r,o){let m;typeof c=="string"?m=R(v(c)):m=c;let h;r instanceof Date?h=r.getTime():typeof r=="string"&&(h=new Date(r).getTime());let t;if(typeof o=="string"?t=R(v(o)):t=o,!m||!t)return!1;const n=m.majorBase,a=m.minorBase,i=m.patchBase;let s=t.majorBase,l=t.minorBase,D=t.patchBase;const S=t.notBefore;let b=t.majorMustEqual,f=t.minorMustEqual,g=t.patchMustEqual;return t.isMinimum?n>s?!0:n<s?!1:a>l?!0:a<l||h&&h<S?!1:i>=D:(n===1&&s===0&&(!b||!f||!g)&&(s=1,l=0,D=0,b=!0,f=!1,g=!1),n<s?!1:n>s?!b:a<l?!1:a>l?!f:i<D?!1:i>D?!g:!(h&&h<S))}e.$Mo=I;function w(c,r,o,m,h){const t=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return t.push([T.default.Error,d.localize(0,null)]),t;if(typeof m.name!="string")return t.push([T.default.Error,d.localize(1,null,"name")]),t;if(typeof m.version!="string")return t.push([T.default.Error,d.localize(2,null,"version")]),t;if(!m.engines)return t.push([T.default.Error,d.localize(3,null,"engines")]),t;if(typeof m.engines.vscode!="string")return t.push([T.default.Error,d.localize(4,null,"engines.vscode")]),t;if(typeof m.extensionDependencies<"u"&&!u(m.extensionDependencies))return t.push([T.default.Error,d.localize(5,null,"extensionDependencies")]),t;if(typeof m.activationEvents<"u"){if(!u(m.activationEvents))return t.push([T.default.Error,d.localize(6,null,"activationEvents")]),t;if(typeof m.main>"u"&&typeof m.browser>"u")return t.push([T.default.Error,d.localize(7,null,"activationEvents","main","browser")]),t}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&t.push([T.default.Warning,d.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return t.push([T.default.Error,d.localize(9,null,"main")]),t;{const i=(0,C.$vg)(o,m.main);(0,C.$pg)(i,o)||t.push([T.default.Warning,d.localize(10,null,i.path,o.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return t.push([T.default.Error,d.localize(11,null,"browser")]),t;{const i=(0,C.$vg)(o,m.browser);(0,C.$pg)(i,o)||t.push([T.default.Warning,d.localize(12,null,i.path,o.path)])}}if(!L.valid(m.version))return t.push([T.default.Error,d.localize(13,null)]),t;const n=[];if(!y(c,r,m,h,n))for(const i of n)t.push([T.default.Error,i]);return t}e.$No=w;function y(c,r,o,m,h){return m||typeof o.main>"u"&&typeof o.browser>"u"?!0:p(c,r,o.engines.vscode,h)}e.$Oo=y;function k(c,r,o){return c==="*"||p(r,o,c)}e.$Po=k;function p(c,r,o,m=[]){const h=R(v(o));if(!h)return m.push(d.localize(14,null,o)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return m.push(d.localize(15,null,o)),!1}else if(!h.majorMustEqual)return m.push(d.localize(16,null,o)),!1;return I(c,r,h)?!0:(m.push(d.localize(17,null,c,o)),!1)}function u(c){if(!Array.isArray(c))return!1;for(let r=0,o=c.length;r<o;r++)if(typeof c[r]!="string")return!1;return!0}}),define(De[102],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class C{constructor(d,L=[],A=!1){this.ctor=d,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$Lh=C}),define(De[103],Ce([1,0,102]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.InstantiationType=void 0;const T=[];var d;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(d||(e.InstantiationType=d={}));function L($,E,v){E instanceof C.$Lh||(E=new C.$Lh(E,[],!!v)),T.push([$,E])}e.$ur=L;function A(){return T}e.$vr=A}),define(De[229],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;class C{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$_p=C;class T{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const $=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(A);$.outgoing.set(E.key,E),E.incoming.set($.key,$)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const $ of this.a.values())$.outgoing.delete(A),$.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let $=this.a.get(A);return $||($=new C(A,L),this.a.set(A,$)),$}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,$]of this.a)L.push(`${A}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const $=new Set([L]),E=this.c(A,$);if(E)return E}}c(L,A){for(const[$,E]of L.outgoing){if(A.has($))return[...A,$].join(" -> ");A.add($);const v=this.c(E,A);if(v)return v;A.delete($)}}}e.$aq=T}),define(De[5],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=e._util=void 0;var C;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function $(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=$})(C||(e._util=C={})),e.$Nh=d("instantiationService");function T(A,$,E){$[C.DI_TARGET]===$?$[C.DI_DEPENDENCIES].push({id:A,index:E}):($[C.DI_DEPENDENCIES]=[{id:A,index:E}],$[C.DI_TARGET]=$)}function d(A){if(C.serviceIds.has(A))return C.serviceIds.get(A);const $=function(E,v,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T($,E,R)};return $.toString=()=>A,C.serviceIds.set(A,$),$}e.$Oh=d;function L(A){return A}e.$Ph=L}),define(De[50],Ce([1,0,17,2,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.ConfigurationTarget=e.$ki=e.$ji=e.$ii=void 0,e.$ii=(0,d.$Oh)("configurationService");function L(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof T.URI)}e.$ji=L;function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof T.URI)}e.$ki=A;var $;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function E(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$li=E;function v(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$mi=v;function R(c,r){const o=Object.create(null);for(const m in c)I(o,m,c[m],r);return o}e.$ni=R;function I(c,r,o,m){const h=r.split("."),t=h.pop();let n=c;for(let a=0;a<h.length;a++){const i=h[a];let s=n[i];switch(typeof s){case"undefined":s=n[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${r} as ${h.slice(0,a+1).join(".")} is ${JSON.stringify(s)}`);return}n=s}if(typeof n=="object"&&n!==null)try{n[t]=o}catch{m(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(n)}`)}else m(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(n)}`)}e.$oi=I;function w(c,r){const o=r.split(".");y(c,o)}e.$pi=w;function y(c,r){const o=r.shift();if(r.length===0){delete c[o];return}if(Object.keys(c).indexOf(o)!==-1){const m=c[o];typeof m=="object"&&!Array.isArray(m)&&(y(m,r),Object.keys(m).length===0&&delete c[o])}}function k(c,r,o){function m(n,a){let i=n;for(const s of a){if(typeof i!="object"||i===null)return;i=i[s]}return i}const h=r.split("."),t=m(c,h);return typeof t>"u"?o:t}e.$qi=k;function p(c,r,o){Object.keys(r).forEach(m=>{m!=="__proto__"&&(m in c?C.$Af(c[m])&&C.$Af(r[m])?p(c[m],r[m],o):o&&(c[m]=r[m]):c[m]=r[m])})}e.$ri=p;function u(c){return c.replace(/[\[\]]/g,"")}e.$si=u}),define(De[42],Ce([1,0,12,15,227,5,189,8]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.ContextKeyExprType=e.$Ki=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",C.$k),E.set("isLinux",C.$l),E.set("isWindows",C.$j),E.set("isWeb",C.$p),E.set("isMacNative",C.$k&&!C.$p),E.set("isEdge",C.$H),E.set("isFirefox",C.$F),E.set("isChrome",C.$E),E.set("isSafari",C.$G);function v(G,U){if(E.get(G)!==void 0)throw(0,$.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(G,U)}e.$Ki=v;const R=Object.prototype.hasOwnProperty;var I;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const w={regexParsingWithErrorRecovery:!0},y=(0,A.localize)(0,null),k=(0,A.localize)(1,null),p=(0,A.localize)(2,null),u=(0,A.localize)(3,null),c=(0,A.localize)(4,null),r=(0,A.localize)(5,null),o=(0,A.localize)(6,null),m=(0,A.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=w){this.k=U,this.d=new d.$Ji,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:k});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const q=this.l();if(!this.E()){const me=this.D(),ee=me.type===17?r:void 0;throw this.h.push({message:c,offset:me.offset,lexeme:d.$Ji.getLexeme(me),additionalInfo:ee}),h.c}return q}catch(q){if(q!==h.c)throw q;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const q=this.o();U.push(q)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const q=this.s();U.push(q)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const q=this.l();return this.A(1,u),q?.negate()}case 17:return this.z(),P.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const q=this.l();return this.A(1,u),q}case 17:{const q=U.lexeme;if(this.z(),this.y(9)){const ee=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ee.type!==10)throw this.B("REGEX",ee);const ne=ee.lexeme,re=ne.lastIndexOf("/"),Ee=re===ne.length-1?void 0:this.w(ne.substring(re+1));let ce;try{ce=new RegExp(ne.substring(1,re),Ee)}catch{throw this.B("REGEX",ee)}return F.create(q,ce)}switch(ee.type){case 10:case 19:{const ne=[ee.lexeme];this.z();let re=this.D(),Ee=0;for(let be=0;be<ee.lexeme.length;be++)ee.lexeme.charCodeAt(be)===40?Ee++:ee.lexeme.charCodeAt(be)===41&&Ee--;for(;!this.E()&&re.type!==15&&re.type!==16;){switch(re.type){case 0:Ee++;break;case 1:Ee--;break;case 10:case 18:for(let be=0;be<re.lexeme.length;be++)re.lexeme.charCodeAt(be)===40?Ee++:ee.lexeme.charCodeAt(be)===41&&Ee--}if(Ee<0)break;ne.push(d.$Ji.getLexeme(re)),this.z(),re=this.D()}const ce=ne.join(""),de=ce.lastIndexOf("/"),te=de===ce.length-1?void 0:this.w(ce.substring(de+1));let he;try{he=new RegExp(ce.substring(1,de),te)}catch{throw this.B("REGEX",ee)}return t.regex(q,he)}case 18:{const ne=ee.lexeme;this.z();let re=null;if(!(0,T.$Be)(ne)){const Ee=ne.indexOf("/"),ce=ne.lastIndexOf("/");if(Ee!==ce&&Ee>=0){const de=ne.slice(Ee+1,ce),te=ne[ce+1]==="i"?"i":"";try{re=new RegExp(de,te)}catch{throw this.B("REGEX",ee)}}}if(re===null)throw this.B("REGEX",ee);return F.create(q,re)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const ee=this.u();return t.notIn(q,ee)}switch(this.D().type){case 3:{this.z();const ee=this.u();if(this.x().type===18)return t.equals(q,ee);switch(ee){case"true":return t.has(q);case"false":return t.not(q);default:return t.equals(q,ee)}}case 4:{this.z();const ee=this.u();if(this.x().type===18)return t.notEquals(q,ee);switch(ee){case"true":return t.not(q);case"false":return t.has(q);default:return t.notEquals(q,ee)}}case 5:return this.z(),j.create(q,this.u());case 6:return this.z(),z.create(q,this.u());case 7:return this.z(),O.create(q,this.u());case 8:return this.z(),M.create(q,this.u());case 13:return this.z(),t.in(q,this.u());default:return t.has(q)}}case 20:throw this.h.push({message:o,offset:U.offset,lexeme:"",additionalInfo:m}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,q){if(this.C(U))return this.z();throw this.B(q,this.D())}B(U,q,me){const ee=(0,A.localize)(8,null,U,d.$Ji.getLexeme(q)),ne=q.offset,re=d.$Ji.getLexeme(q);return this.h.push({message:ee,offset:ne,lexeme:re,additionalInfo:me}),h.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Li=h;class t{static false(){return s.INSTANCE}static true(){return l.INSTANCE}static has(U){return D.create(U)}static equals(U,q){return S.create(U,q)}static notEquals(U,q){return g.create(U,q)}static regex(U,q){return F.create(U,q)}static in(U,q){return b.create(U,q)}static notIn(U,q){return f.create(U,q)}static not(U){return P.create(U)}static and(...U){return fe.create(U,null,!0)}static or(...U){return Z.create(U,null,!0)}static greater(U,q){return O.create(U,q)}static greaterEquals(U,q){return M.create(U,q)}static smaller(U,q){return j.create(U,q)}static smallerEquals(U,q){return z.create(U,q)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Mi=t;function n(G){const U=new h({regexParsingWithErrorRecovery:!1});return G.map(q=>(U.parse(q),U.lexingErrors.length>0?U.lexingErrors.map(me=>({errorMessage:me.additionalInfo?(0,A.localize)(9,null,me.additionalInfo):(0,A.localize)(10,null),offset:me.offset,length:me.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(me=>({errorMessage:me.additionalInfo?`${me.message}. ${me.additionalInfo}`:me.message,offset:me.offset,length:me.lexeme.length})):[]))}e.$Ni=n;function a(G,U){const q=G?G.substituteConstants():void 0,me=U?U.substituteConstants():void 0;return!q&&!me?!0:!q||!me?!1:q.equals(me)}e.$Oi=a;function i(G,U){return G.cmp(U)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return l.INSTANCE}}e.$Pi=s;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return s.INSTANCE}}e.$Qi=l;class D{static create(U,q=null){const me=E.get(U);return typeof me=="boolean"?me?l.INSTANCE:s.INSTANCE:new D(U,q)}constructor(U,q){this.key=U,this.c=q,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:X(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=E.get(this.key);return typeof U=="boolean"?U?l.INSTANCE:s.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Ri=D;class S{static create(U,q,me=null){if(typeof q=="boolean")return q?D.create(U,me):P.create(U,me);const ee=E.get(U);return typeof ee=="boolean"?q===(ee?"true":"false")?l.INSTANCE:s.INSTANCE:new S(U,q,me)}constructor(U,q,me){this.c=U,this.d=q,this.f=me,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=E.get(this.c);if(typeof U=="boolean"){const q=U?"true":"false";return this.d===q?l.INSTANCE:s.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.$Si=S;class b{static create(U,q){return new b(U,q)}constructor(U,q){this.d=U,this.f=q,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const q=U.getValue(this.f),me=U.getValue(this.d);return Array.isArray(q)?q.includes(me):typeof me=="string"&&typeof q=="object"&&q!==null?R.call(q,me):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Ti=b;class f{static create(U,q){return new f(U,q)}constructor(U,q){this.d=U,this.f=q,this.type=11,this.c=b.create(U,q)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ui=f;class g{static create(U,q,me=null){if(typeof q=="boolean")return q?P.create(U,me):D.create(U,me);const ee=E.get(U);return typeof ee=="boolean"?q===(ee?"true":"false")?s.INSTANCE:l.INSTANCE:new g(U,q,me)}constructor(U,q,me){this.c=U,this.d=q,this.f=me,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=E.get(this.c);if(typeof U=="boolean"){const q=U?"true":"false";return this.d===q?s.INSTANCE:l.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Vi=g;class P{static create(U,q=null){const me=E.get(U);return typeof me=="boolean"?me?s.INSTANCE:l.INSTANCE:new P(U,q)}constructor(U,q){this.c=U,this.d=q,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:X(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=E.get(this.c);return typeof U=="boolean"?U?s.INSTANCE:l.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.$Wi=P;function N(G,U){if(typeof G=="string"){const q=parseFloat(G);isNaN(q)||(G=q)}return typeof G=="string"||typeof G=="number"?U(G):s.INSTANCE}class O{static create(U,q,me=null){return N(q,ee=>new O(U,ee,me))}constructor(U,q,me){this.c=U,this.d=q,this.f=me,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Xi=O;class M{static create(U,q,me=null){return N(q,ee=>new M(U,ee,me))}constructor(U,q,me){this.c=U,this.d=q,this.f=me,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Yi=M;class j{static create(U,q,me=null){return N(q,ee=>new j(U,ee,me))}constructor(U,q,me){this.c=U,this.d=q,this.f=me,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Zi=j;class z{static create(U,q,me=null){return N(q,ee=>new z(U,ee,me))}constructor(U,q,me){this.c=U,this.d=q,this.f=me,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$1i=z;class F{static create(U,q){return new F(U,q)}constructor(U,q){this.d=U,this.f=q,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const q=this.f?this.f.source:"",me=U.f?U.f.source:"";return q<me?-1:q>me?1:0}equals(U){if(U.type===this.type){const q=this.f?this.f.source:"",me=U.f?U.f.source:"";return this.d===U.d&&q===me}return!1}substituteConstants(){return this}evaluate(U){const q=U.getValue(this.d);return this.f?this.f.test(q):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$2i=F;class K{static create(U){return new K(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new K(this.c.map(U))}negate(){return this.c}}e.$3i=K;function V(G){let U=null;for(let q=0,me=G.length;q<me;q++){const ee=G[q].substituteConstants();if(G[q]!==ee&&U===null){U=[];for(let ne=0;ne<q;ne++)U[ne]=G[ne]}U!==null&&(U[q]=ee)}return U===null?G:U}class fe{static create(U,q,me){return fe.d(U,q,me)}constructor(U,q){this.expr=U,this.c=q,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let q=0,me=this.expr.length;q<me;q++){const ee=i(this.expr[q],U.expr[q]);if(ee!==0)return ee}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let q=0,me=this.expr.length;q<me;q++)if(!this.expr[q].equals(U.expr[q]))return!1;return!0}return!1}substituteConstants(){const U=V(this.expr);return U===this.expr?this:fe.create(U,this.c,!1)}evaluate(U){for(let q=0,me=this.expr.length;q<me;q++)if(!this.expr[q].evaluate(U))return!1;return!0}static d(U,q,me){const ee=[];let ne=!1;for(const re of U)if(re){if(re.type===1){ne=!0;continue}if(re.type===0)return s.INSTANCE;if(re.type===6){ee.push(...re.expr);continue}ee.push(re)}if(ee.length===0&&ne)return l.INSTANCE;if(ee.length!==0){if(ee.length===1)return ee[0];ee.sort(i);for(let re=1;re<ee.length;re++)ee[re-1].equals(ee[re])&&(ee.splice(re,1),re--);if(ee.length===1)return ee[0];for(;ee.length>1;){const re=ee[ee.length-1];if(re.type!==9)break;ee.pop();const Ee=ee.pop(),ce=ee.length===0,de=Z.create(re.expr.map(te=>fe.create([te,Ee],null,me)),null,ce);de&&(ee.push(de),ee.sort(i))}if(ee.length===1)return ee[0];if(me){for(let re=0;re<ee.length;re++)for(let Ee=re+1;Ee<ee.length;Ee++)if(ee[re].negate().equals(ee[Ee]))return s.INSTANCE;if(ee.length===1)return ee[0]}return new fe(ee,q)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const q of this.expr)U.push(...q.keys());return U}map(U){return new fe(this.expr.map(q=>q.map(U)),null)}negate(){if(!this.c){const U=[];for(const q of this.expr)U.push(q.negate());this.c=Z.create(U,this,!0)}return this.c}}e.$4i=fe;class Z{static create(U,q,me){return Z.d(U,q,me)}constructor(U,q){this.expr=U,this.c=q,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let q=0,me=this.expr.length;q<me;q++){const ee=i(this.expr[q],U.expr[q]);if(ee!==0)return ee}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let q=0,me=this.expr.length;q<me;q++)if(!this.expr[q].equals(U.expr[q]))return!1;return!0}return!1}substituteConstants(){const U=V(this.expr);return U===this.expr?this:Z.create(U,this.c,!1)}evaluate(U){for(let q=0,me=this.expr.length;q<me;q++)if(this.expr[q].evaluate(U))return!0;return!1}static d(U,q,me){let ee=[],ne=!1;if(U){for(let re=0,Ee=U.length;re<Ee;re++){const ce=U[re];if(ce){if(ce.type===0){ne=!0;continue}if(ce.type===1)return l.INSTANCE;if(ce.type===9){ee=ee.concat(ce.expr);continue}ee.push(ce)}}if(ee.length===0&&ne)return s.INSTANCE;ee.sort(i)}if(ee.length!==0){if(ee.length===1)return ee[0];for(let re=1;re<ee.length;re++)ee[re-1].equals(ee[re])&&(ee.splice(re,1),re--);if(ee.length===1)return ee[0];if(me){for(let re=0;re<ee.length;re++)for(let Ee=re+1;Ee<ee.length;Ee++)if(ee[re].negate().equals(ee[Ee]))return l.INSTANCE;if(ee.length===1)return ee[0]}return new Z(ee,q)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const q of this.expr)U.push(...q.keys());return U}map(U){return new Z(this.expr.map(q=>q.map(U)),null)}negate(){if(!this.c){const U=[];for(const q of this.expr)U.push(q.negate());for(;U.length>1;){const q=U.shift(),me=U.shift(),ee=[];for(const ne of we(q))for(const re of we(me))ee.push(fe.create([ne,re],null,!1));U.unshift(Z.create(ee,null,!1))}this.c=Z.create(U,this,!0)}return this.c}}e.$5i=Z;class Q extends D{static{this.d=[]}static all(){return Q.d.values()}constructor(U,q,me){super(U,null),this.f=q,typeof me=="object"?Q.d.push({...me,key:U}):me!==!0&&Q.d.push({key:U,description:me,type:q!=null?typeof q:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return S.create(this.key,U)}notEqualsTo(U){return g.create(this.key,U)}}e.$6i=Q,e.$7i=(0,L.$Oh)("contextKeyService");function X(G,U){return G<U?-1:G>U?1:0}function oe(G,U,q,me){return G<q?-1:G>q?1:U<me?-1:U>me?1:0}function x(G,U){if(G.type===0||U.type===1)return!0;if(G.type===9)return U.type===9?ae(G.expr,U.expr):!1;if(U.type===9){for(const q of U.expr)if(x(G,q))return!0;return!1}if(G.type===6){if(U.type===6)return ae(U.expr,G.expr);for(const q of G.expr)if(x(q,U))return!0;return!1}return G.equals(U)}e.$8i=x;function ae(G,U){let q=0,me=0;for(;q<G.length&&me<U.length;){const ee=G[q].cmp(U[me]);if(ee<0)return!1;ee===0&&q++,me++}return q===G.length}function we(G){return G.type===9?G.expr:[G]}}),define(De[230],Ce([1,0,23,38,191,5,99,12,24]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.ConfirmResult=e.$zv=e.$yv=e.$xv=void 0,e.$xv=(0,L.$Oh)("dialogService");var v;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(v||(v={}));class R{a(u){return this.d(u,v.Confirmation)}b(u){return this.d(u,v.Prompt)}c(u){return this.d(u,v.Input)}d(u,c){const r=[];switch(c){case v.Confirmation:{const o=u;o.primaryButton?r.push(o.primaryButton):r.push((0,d.localize)(0,null)),o.cancelButton?r.push(o.cancelButton):r.push((0,d.localize)(1,null));break}case v.Prompt:{const o=u;Array.isArray(o.buttons)&&o.buttons.length>0&&r.push(...o.buttons.map(m=>m.label)),o.cancelButton&&(o.cancelButton===!0?r.push((0,d.localize)(2,null)):typeof o.cancelButton=="string"?r.push(o.cancelButton):o.cancelButton.label?r.push(o.cancelButton.label):r.push((0,d.localize)(3,null))),r.length===0&&r.push((0,d.localize)(4,null));break}case v.Input:{const o=u;o.primaryButton?r.push(o.primaryButton):r.push((0,d.localize)(5,null)),o.cancelButton?r.push(o.cancelButton):r.push((0,d.localize)(6,null));break}}return r}e(u){if(typeof u=="string")return u;if(typeof u=="number")return u===T.default.Info?"info":u===T.default.Error?"error":u===T.default.Warning?"warning":"none"}f(u,c,r){const o=[...u.buttons??[]];u.cancelButton&&typeof u.cancelButton!="string"&&typeof u.cancelButton!="boolean"&&o.push(u.cancelButton);let m=o[c]?.run({checkboxChecked:r});return m instanceof Promise||(m=Promise.resolve(m)),{result:m,checkboxChecked:r}}}e.$yv=R,e.$zv=(0,L.$Oh)("fileDialogService");var I;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const w=10;function y(p){const u=[];return u.push(...p.slice(0,w).map(c=>typeof c=="string"?c:(0,C.$sg)(c))),p.length>w&&(p.length-w===1?u.push((0,d.localize)(7,null)):u.push((0,d.localize)(8,null,p.length-w))),u.push(""),u.join(`
`)}e.$Av=y;function k(p,u){const c=(0,E.$4m)(p);let r=(c.buttons??[]).map(t=>(0,A.$uv)(t)),o=(p.buttons||[]).map((t,n)=>n),m=0,h=c.cancelId??r.length-1;if(r.length>1){const t=typeof h=="number"?r[h]:void 0;if($.$l||$.$k){if(typeof t=="string"&&r.length>1&&h!==1){r.splice(h,1),r.splice(1,0,t);const n=o[h];o.splice(h,1),o.splice(1,0,n),h=1}$.$l&&r.length>1&&(r=r.reverse(),o=o.reverse(),m=r.length-1,typeof t=="string"&&(h=m-1))}else if($.$j&&typeof t=="string"&&r.length>1&&h!==r.length-1){r.splice(h,1),r.push(t);const n=o[h];o.splice(h,1),o.push(n),h=r.length-1}}return c.buttons=r,c.defaultId=m,c.cancelId=h,c.noLink=!0,c.title=c.title||u.nameLong,{options:c,buttonIndeces:o}}e.$Bv=k}),define(De[131],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=void 0,e.$Vh=(0,C.$Oh)("environmentService"),e.$Wh=(0,C.$Ph)(e.$Vh)}),define(De[132],Ce([1,0,192,5]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$8n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=void 0,e.$Un="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Vn=new RegExp(e.$Un),e.$Wn="__web_extension",e.$Xn="skipWalkthrough",e.$Yn="extensionsSync",e.$Zn="dependecyOrPackExtensionInstall";function d(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$1n=d;function L(r){switch(r){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$2n=L;function A(r,o){switch(r){case 3:return o==="x64"?"win32-x64":o==="ia32"?"win32-ia32":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$3n=A;function $(r,o){return o==="web"&&!r.includes("web")}e.$4n=$;function E(r,o,m){return $(o,m)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===m?!0:v(m).includes(r)}e.$5n=E;function v(r){switch(r){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$6n=v;function R(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.$7n=R;var I;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var w;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var y;(function(r){r.Install="install",r.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var k;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(k||(e.InstallOperation=k={})),e.$8n=(0,T.$Oh)("extensionGalleryService");var p;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.Extract="Extract",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var u;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(u||(e.ExtensionSignaturetErrorCode=u={}));class c extends Error{constructor(o,m){super(o),this.code=m,this.name=m}}e.$9n=c,e.$0n=(0,T.$Oh)("extensionManagementService"),e.$$n="extensionsIdentifiers/disabled",e.$_n="extensionsIdentifiers/enabled",e.$ao=(0,T.$Oh)("IGlobalExtensionEnablementService"),e.$bo=(0,T.$Oh)("IExtensionTipsService"),e.$co=(0,C.localize)(0,null),e.$do={value:e.$co,original:"Extensions"},e.$eo={value:(0,C.localize)(1,null),original:"Preferences"}}),define(De[231],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Xb=e.$3Xb=void 0,e.$3Xb=(0,C.$Oh)("externalTerminal"),e.$4Xb="Terminal.app"}),define(De[232],Ce([1,0,49,18,16,12,98,29,101,194,231]),function($e,e,C,T,d,L,A,$,E,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P6b=e.$O6b=e.$N6b=void 0;const I=v.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends w{static{this.b="cmd.exe"}openTerminal(m,h){return this.spawnTerminal(C,m,E.$zl(),h)}spawnTerminal(m,h,t,n){const a=h.windowsExec||y.getDefaultTerminalWindows();n&&n[1]===":"&&(n=n[0].toUpperCase()+n.substr(1));const i=d.$nc(a,".exe").toLowerCase();if(i==="cmder")return m.spawn(a,n?[n]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return a.indexOf(" ")>=0&&s.push('""'),s.push(a),i==="wt"&&s.push("-d ."),new Promise((l,D)=>{const S=u(process),b=m.spawn(t,s,{cwd:n,env:S});b.on("error",D),b.on("exit",()=>l())})}runInTerminal(m,h,t,n,a){const i="windowsExec"in a&&a.windowsExec?a.windowsExec:y.getDefaultTerminalWindows();return new Promise((s,l)=>{const D=`"${h} - ${I}"`,S=`""${t.join('" "')}" & pause"`,b=Object.assign({},u(process),n);Object.keys(b).filter(O=>b[O]===null).forEach(O=>delete b[O]);const f={cwd:h,env:b,windowsVerbatimArguments:!0};let g,P;d.$nc(i,".exe")==="wt"?(g=i,P=["-d",".",y.b,"/c",S]):(g=y.b,P=["/c","start",D,"/wait",i,"/c",S]),C.spawn(g,P,f).on("error",O=>{l(c(O))}),s(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const m=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${m?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.$N6b=y;class k extends w{static{this.b="/usr/bin/osascript"}openTerminal(m,h){return this.spawnTerminal(C,m,h)}runInTerminal(m,h,t,n,a){const i=a.osxExec||R.$4Xb;return new Promise((s,l)=>{if(i===R.$4Xb||i==="iTerm.app"){const D=i===R.$4Xb?"TerminalHelper":"iTermHelper",b=[T.$cg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",m||I,"-w",h];for(const P of t)b.push("-a"),b.push(P);if(n){const P=Object.assign({},u(process),n);for(const N in P){const O=P[N];O===null?(b.push("-u"),b.push(N)):(b.push("-e"),b.push(`${N}=${O}`))}}let f="";const g=C.spawn(k.b,b);g.on("error",P=>{l(c(P))}),g.stderr.on("data",P=>{f+=P.toString()}),g.on("exit",P=>{if(P===0)s(void 0);else if(f){const N=f.split(`
`,1);l(new Error(N[0]))}else l(new Error(v.localize(1,null,D,P)))})}else l(new Error(v.localize(2,null,i)))})}spawnTerminal(m,h,t){const n=h.osxExec||R.$4Xb;return new Promise((a,i)=>{const s=["-a",n];t&&s.push(t);const l=u(process),D=m.spawn("/usr/bin/open",s,{cwd:t,env:l});D.on("error",i),D.on("exit",()=>a())})}}e.$O6b=k;class p extends w{static{this.b=v.localize(3,null)}openTerminal(m,h){return this.spawnTerminal(C,m,h)}runInTerminal(m,h,t,n,a){const i=a.linuxExec?Promise.resolve(a.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((s,l)=>{const D=[];i.then(S=>{S.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const b=`${r(t)}; echo; read -p "${p.b}" -n1;`;D.push(`''${b}''`);const f=Object.assign({},u(process),n);Object.keys(f).filter(O=>f[O]===null).forEach(O=>delete f[O]);const g={cwd:h,env:f};let P="";const N=C.spawn(S,D,g);N.on("error",O=>{l(c(O))}),N.stderr.on("data",O=>{P+=O.toString()}),N.on("exit",O=>{if(O===0)s(void 0);else if(P){const M=P.split(`
`,1);l(new Error(M[0]))}else l(new Error(v.localize(4,null,S,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!L.$l)p.d=Promise.resolve("xterm");else{const m=await $.Promises.exists("/etc/debian_version");p.d=new Promise(h=>{m?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm")})}return p.d}spawnTerminal(m,h,t){const n=h.linuxExec?Promise.resolve(h.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((a,i)=>{n.then(s=>{const l=u(process),D=m.spawn(s,[],{cwd:t,env:l});D.on("error",i),D.on("exit",()=>a())})})}}e.$P6b=p;function u(o){const m={...o.env};return(0,A.$xl)(m),m}function c(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(v.localize(5,null,o.path)):o}function r(o){let m="";for(const h of o)h.indexOf(" ")>=0?m+='"'+h+'"':m+=h,m+=" ";return m}}),define(De[30],Ce([1,0,78,16,15,17,2,195,5,12,18,47]),function($e,e,C,T,d,L,A,$,E,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileKind=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileOperationResult=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileChangeType=e.$pk=e.FileOperation=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.FileSystemProviderErrorCode=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.FileSystemProviderCapabilities=e.$_j=e.FilePermission=e.FileType=e.$$j=e.$0j=void 0,e.$0j=(0,E.$Oh)("fileService");function w(x){return x.create===!0}e.$$j=w;var y;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var k;(function(x){x[x.Readonly=1]="Readonly",x[x.Locked=2]="Locked"})(k||(e.FilePermission=k={}));function p(x){const ae=x;return!!ae&&typeof ae.onDidChange=="function"}e.$_j=p;var u;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileAtomicWrite=32768]="FileAtomicWrite",x[x.FileAtomicDelete=65536]="FileAtomicDelete",x[x.FileClone=131072]="FileClone"})(u||(e.FileSystemProviderCapabilities=u={}));function c(x){return!!(x.capabilities&2)}e.$ak=c;function r(x){return!!(x.capabilities&8)}e.$bk=r;function o(x){return!!(x.capabilities&131072)}e.$ck=o;function m(x){return!!(x.capabilities&4)}e.$dk=m;function h(x){return!!(x.capabilities&16)}e.$ek=h;function t(x){return c(x)?!!(x.capabilities&16384):!1}e.$fk=t;function n(x){return c(x)?!!(x.capabilities&32768):!1}e.$gk=n;function a(x){return!!(x.capabilities&65536)}e.$hk=a;function i(x){return!!(x.capabilities&2048)}e.$ik=i;var s;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsStorageQuota="EntryExceedsStorageQuota",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class l extends Error{static create(ae,we){const G=new l(ae.toString(),we);return b(G,we),G}constructor(ae,we){super(ae),this.code=we}}e.$jk=l;function D(x,ae){return l.create(x,ae)}e.$kk=D;function S(x){return x||D((0,$.localize)(0,null),s.Unknown)}e.$lk=S;function b(x,ae){return x.name=ae?`${ae} (FileSystemError)`:"FileSystemError",x}e.$mk=b;function f(x){if(!x)return s.Unknown;if(x instanceof l)return x.code;const ae=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!ae)return s.Unknown;switch(ae[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$nk=f;function g(x){if(x instanceof z)return x.fileOperationResult;switch(f(x)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$ok=g;var P;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class N{constructor(ae,we,G){this.resource=ae,this.operation=we,this.target=G}isOperation(ae){return this.operation===ae}}e.$pk=N;var O;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class M{static{this.a=null}constructor(ae,we){this.c=we,this.b=void 0,this.d=new I.$V(()=>{const G=C.$Uh.forUris(()=>this.c);return G.fill(this.rawAdded.map(U=>[U,!0])),G}),this.f=new I.$V(()=>{const G=C.$Uh.forUris(()=>this.c);return G.fill(this.rawUpdated.map(U=>[U,!0])),G}),this.g=new I.$V(()=>{const G=C.$Uh.forUris(()=>this.c);return G.fill(this.rawDeleted.map(U=>[U,!0])),G}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const G of ae){switch(G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}this.b!==M.a&&(typeof G.cId=="number"?this.b===void 0?this.b=G.cId:this.b!==G.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(ae,...we){return this.h(ae,{includeChildren:!1},...we)}affects(ae,...we){return this.h(ae,{includeChildren:!0},...we)}h(ae,we,...G){if(!ae)return!1;const U=G.length>0;return!!((!U||G.includes(1))&&(this.d.value.get(ae)||we.includeChildren&&this.d.value.findSuperstr(ae))||(!U||G.includes(0))&&(this.f.value.get(ae)||we.includeChildren&&this.f.value.findSuperstr(ae))||(!U||G.includes(2))&&(this.g.value.findSubstr(ae)||we.includeChildren&&this.g.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.b===ae}hasCorrelation(){return typeof this.b=="number"}}e.$qk=M;function j(x,ae,we){return!x||!ae||x===ae||ae.length>x.length?!1:(ae.charAt(ae.length-1)!==T.sep&&(ae+=T.sep),we?(0,d.$3e)(x,ae):x.indexOf(ae)===0)}e.$rk=j;class z extends Error{constructor(ae,we,G){super(ae),this.fileOperationResult=we,this.options=G}}e.$sk=z;class F extends z{constructor(ae,we,G,U){super(ae,we,U),this.fileOperationResult=we,this.size=G}}e.$tk=F;class K extends z{constructor(ae,we,G){super(ae,2,G),this.stat=we}}e.$uk=K;var V;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.$vk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$wk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$xk="files.associations",e.$yk="files.exclude",e.$zk="files.readonlyInclude",e.$Ak="files.readonlyExclude",e.$Bk="files.readonlyFromPermissions";var fe;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.$Ck="";function Z(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.$Dk=Z;async function Q(x,ae){if(!ae.hasProvider(A.URI.from({scheme:x.scheme})))return new Promise(we=>{const G=ae.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===x.scheme&&U.added&&(G.dispose(),we())})})}e.$Ek=Q;class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(ae){return(0,L.$Cf)(ae)||(ae=0),ae<X.KB?(0,$.localize)(1,null,ae.toFixed(0)):ae<X.MB?(0,$.localize)(2,null,(ae/X.KB).toFixed(2)):ae<X.GB?(0,$.localize)(3,null,(ae/X.MB).toFixed(2)):ae<X.TB?(0,$.localize)(4,null,(ae/X.GB).toFixed(2)):(0,$.localize)(5,null,(ae/X.TB).toFixed(2))}}e.$Fk=X;function oe(x){const ae=typeof x=="string"||x?.scheme===R.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===R.Schemas.file?1024*X.MB:ae?10*X.MB:v.$p?50*X.MB:1024*X.MB}e.$Gk=oe}),define(De[233],Ce([1,0,22,8,196,30]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;async function A(R,I,w,y,k,p){let u;try{await $(R,I,w,y,k,p)}catch(c){u=c}finally{u&&k.errorTransformer&&(u=k.errorTransformer(u)),typeof u<"u"&&w.error(u),w.end()}}e.$Kp=A;async function $(R,I,w,y,k,p){E(p);const u=await R.open(I,{create:!1});try{E(p);let c=0,r=0,o=k&&typeof k.length=="number"?k.length:void 0,m=C.$be.alloc(Math.min(k.bufferSize,typeof o=="number"?o:k.bufferSize)),h=k&&typeof k.position=="number"?k.position:0,t=0;do r=await R.read(u,h,m.buffer,t,m.byteLength-t),h+=r,t+=r,c+=r,typeof o=="number"&&(o-=r),t===m.byteLength&&(await w.write(y(m)),m=C.$be.alloc(Math.min(k.bufferSize,typeof o=="number"?o:k.bufferSize)),t=0);while(r>0&&(typeof o!="number"||o>0)&&E(p)&&v(c,k));if(t>0){let n=t;typeof o=="number"&&(n=Math.min(t,o)),w.write(y(m.slice(0,n)))}}catch(c){throw(0,L.$lk)(c)}finally{await R.close(u)}}function E(R){if(R.isCancellationRequested)throw(0,T.$6)();return!0}function v(R,I){if(typeof I?.limits?.size=="number"&&R>I.limits.size)throw(0,L.$kk)((0,d.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[84],Ce([1,0,35,3,16,12,2,30]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=e.$Rp=e.$Qp=e.$Pp=e.$Op=e.$Np=e.$Mp=void 0;function E(c){return c.recursive===!0}e.$Mp=E;class v extends T.$Sc{static{this.a=5}constructor(r,o,m,h){super(),this.h=r,this.j=o,this.m=m,this.n=h,this.c=this.B(new T.$Tc),this.f=void 0,this.g=0}s(){const r=new T.$Rc;this.c.value=r,this.b=this.r(r),this.b.setVerboseLogging(this.m),r.add(this.b.onDidChangeFile(o=>this.h(o))),r.add(this.b.onDidLogMessage(o=>this.j(o))),r.add(this.b.onDidError(o=>this.t(o)))}t(r){this.n.restartOnError?this.g<v.a&&this.f?(this.w(`restarting watcher after error: ${r}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${r}`):this.w(r)}u(r){this.g++,this.s(),this.watch(r)}async watch(r){this.f=r,await this.b?.watch(r)}async setVerboseLogging(r){this.m=r,await this.b?.setVerboseLogging(r)}w(r){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${r}`})}y(r){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${r}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Np=v;class R extends v{constructor(r,o,m){super(r,o,m,{type:"node.js",restartOnError:!1})}}e.$Op=R;class I extends v{constructor(r,o,m){super(r,o,m,{type:"universal",restartOnError:!0})}}e.$Pp=I;function w(c){return c.map(r=>({type:r.type,resource:A.URI.revive(r.resource),cId:r.cId}))}e.$Qp=w;function y(c){const r=new u;for(const o of c)r.processEvent(o);return r.coalesce()}e.$Rp=y;function k(c,r){return typeof r=="string"&&!r.startsWith(C.$rj)&&!(0,d.$ic)(r)?{base:c,pattern:r}:r}e.$Sp=k;function p(c,r){const o=[];for(const m of r)o.push((0,C.$vj)(k(c,m)));return o}e.$Tp=p;class u{constructor(){this.a=new Set,this.b=new Map}c(r){return L.$l?r.resource.fsPath:r.resource.fsPath.toLowerCase()}processEvent(r){const o=this.b.get(this.c(r));let m=!1;if(o){const h=o.type,t=r.type;o.resource.fsPath!==r.resource.fsPath&&(r.type===2||r.type===1)?m=!0:h===1&&t===2?(this.b.delete(this.c(r)),this.a.delete(o)):h===2&&t===1?o.type=0:h===1&&t===0||(o.type=t)}else m=!0;m&&(this.a.add(r),this.b.set(this.c(r),r))}coalesce(){const r=[],o=[];return Array.from(this.a).filter(m=>m.type!==2?(r.push(m),!1):!0).sort((m,h)=>m.resource.fsPath.length-h.resource.fsPath.length).filter(m=>o.some(h=>(0,$.$rk)(m.resource.fsPath,h,!L.$l))?!1:(o.push(m.resource.fsPath),!0)).concat(r)}}}),define(De[234],Ce([1,0,53,9,21,32,3,77,16,12,23,2,100,29,84]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0;class p extends A.$Sc{static{this.a=100}static{this.b=75}constructor(r,o,m,h){super(),this.m=r,this.n=o,this.r=m,this.s=h,this.c=this.B(new T.$9g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new T.$8g(t=>this.z(t),p.b)),this.g=(0,k.$Tp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,k.$Tp)(this.m.path,this.m.includes):void 0,this.j=new d.$Xd,this.ready=this.t()}async t(){try{const r=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const o=await y.Promises.stat(r);this.B(await this.w(r,o.isDirectory()))}catch(r){r.code!=="ENOENT"?this.D(r):this.G(r)}}async u(r){let o=r.path;try{o=await y.Promises.realpath(r.path),r.path===o&&(o=await(0,w.$4p)(r.path)??r.path),r.path!==o&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${o})`)}catch{}return o}async w(r,o){if(v.$k&&(0,L.$Xf)(r,"/Volumes/",!0))return this.D(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Sc.None;const m=new d.$Xd(this.j.token),h=new A.$Rc;try{const t=I.URI.file(this.m.path),n=(0,E.$nc)(r),a=(0,C.watch)(r);h.add((0,A.$Qc)(()=>{a.removeAllListeners(),a.close()})),this.G(`Started watching: '${r}'`);const i=new Set;if(o)try{for(const l of await y.Promises.readdir(r))i.add(l)}catch(l){this.D(l)}const s=new Map;h.add((0,A.$Qc)(()=>{for(const[,l]of s)l.dispose();s.clear()})),a.on("error",(l,D)=>{this.D(`Failed to watch ${r} for changes using fs.watch() (${l}, ${D})`),this.dispose()}),a.on("change",(l,D)=>{if(m.token.isCancellationRequested)return;this.G(`[raw] ["${l}"] ${D}`);let S="";if(D&&(S=D.toString(),v.$k&&(S=(0,$.$ml)(S))),!(!S||l!=="change"&&l!=="rename"))if(o)if(l==="rename"){s.get(S)?.dispose();const b=setTimeout(async()=>{if(s.delete(S),S===n&&!await y.Promises.exists(r)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.C((0,E.$jc)(r,S));if(m.token.isCancellationRequested)return;let g;f?i.has(S)?g=0:(g=1,i.add(S)):(i.delete(S),g=2),this.y({resource:(0,R.$vg)(t,S),type:g,cId:this.m.correlationId})},p.a);s.set(S,(0,A.$Qc)(()=>clearTimeout(b)))}else{let b;i.has(S)?b=0:(b=1,i.add(S)),this.y({resource:(0,R.$vg)(t,S),type:b,cId:this.m.correlationId})}else if(l==="rename"||S!==n){const b=setTimeout(async()=>{const f=await y.Promises.exists(r);m.token.isCancellationRequested||(f?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),h.add(await this.w(r,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);h.clear(),h.add((0,A.$Qc)(()=>clearTimeout(b)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await y.Promises.exists(r)&&!m.token.isCancellationRequested&&this.D(`Failed to watch ${r} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Qc)(()=>{m.dispose(!0),h.dispose()})}y(r,o=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.resource.fsPath}`),!o&&this.g.some(m=>m(r.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${r.resource.fsPath}`):!o&&this.h&&this.h.length>0&&!this.h.some(m=>m(r.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${r.resource.fsPath}`):this.f.work(r))}z(r){const o=(0,k.$Rp)(r);if(o.length>0){if(this.s)for(const h of o)this.G(` >> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`);this.c.work(o)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(r){if(v.$l)return y.Promises.exists(r);try{const o=(0,E.$nc)(r);return(await y.Promises.readdir((0,E.$mc)(r))).some(h=>h===o)}catch(o){return this.G(o),!1}}setVerboseLogging(r){this.s=r}D(r){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}F(r){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}G(r){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$7p=p;async function u(c,r,o,m,h=512){const t=await y.Promises.open(c,"r"),n=Buffer.allocUnsafe(h),a=new d.$Xd(m);let i,s=!1;const l={path:c,excludes:[],recursive:!1},D=new p(l,S=>{(async()=>{for(const{type:b}of S)if(b===0){if(s)return;s=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:f}=await y.Promises.read(t,n,0,h,null);if(!f||a.token.isCancellationRequested)break;r(n.slice(0,f))}}catch(f){i=new Error(f),a.dispose(!0)}finally{s=!1}}})()});return await D.ready,o(),new Promise((S,b)=>{a.token.onCancellationRequested(async()=>{D.dispose();try{await y.Promises.close(t)}catch(f){i=new Error(f)}i?b(i):S()})})}e.$8p=u}),define(De[235],Ce([1,0,4,35,3,12,234]),function($e,e,C,T,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class $ extends d.$Sc{constructor(){super(...arguments),this.a=this.B(new C.$Nd),this.onDidChangeFile=this.a.event,this.b=this.B(new C.$Nd),this.onDidLogMessage=this.b.event,this.onDidError=C.Event.None,this.c=new Map,this.f=!1}async watch(v){const R=this.j(v),I=R.filter(y=>{const k=this.c.get(y.path);return k?!(0,T.$zj)(k.request.excludes,y.excludes)||!(0,T.$zj)(k.request.includes,y.includes):!0}),w=Array.from(this.c.values()).filter(({request:y})=>!R.find(k=>k.path===y.path&&(0,T.$zj)(k.excludes,y.excludes)&&(0,T.$zj)(k.includes,y.includes))).map(({request:y})=>y.path);I.length&&this.m(`Request to start watching: ${I.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`).join(",")}`),w.length&&this.m(`Request to stop watching: ${w.join(",")}`);for(const y of w)this.h(y);for(const y of I)this.g(y)}g(v){const R=new A.$7p(v,w=>this.a.fire(w),w=>this.b.fire(w),this.f),I={request:v,instance:R};this.c.set(v.path,I)}async stop(){for(const[v]of this.c)this.h(v);this.c.clear()}h(v){const R=this.c.get(v);R&&(this.c.delete(v),R.instance.dispose())}j(v){const R=new Map;for(const I of v){const w=L.$l?I.path:I.path.toLowerCase();let y=R.get(I.correlationId);y||(y=new Map,R.set(I.correlationId,y)),y.set(w,I)}return Array.from(R.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(v){this.f=v;for(const[,R]of this.c)R.instance.setVerboseLogging(v)}m(v){this.f&&this.b.fire({type:"trace",message:this.n(v)})}n(v,R){return R?`[File Watcher (node.js)] ${v} (path: ${R.request.path})`:`[File Watcher (node.js)] ${v}`}}e.$9p=$}),define(De[236],Ce([1,0,84,235]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class d extends C.$Op{constructor(A,$,E){super(A,$,E),this.s()}r(A){return A.add(new T.$9p)}}e.$0p=d}),define(De[237],Ce([1,0,18,81,183,84]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class A extends L.$Pp{constructor(E,v,R){super(E,v,R),this.s()}r(E){const v=E.add(new d.$1p(C.$cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(v.onDidProcessExit(({code:R,signal:I})=>this.t(`terminated by itself with code ${R}, signal: ${I}`))),T.ProxyChannel.toService((0,T.$vh)(v.getChannel("watcher")))}}e.$2p=A}),define(De[104],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class C{constructor(...d){this.a=new Map;for(const[L,A]of d)this.set(L,A)}set(d,L){const A=this.a.get(d);return this.a.set(d,L),A}has(d){return this.a.has(d)}get(d){return this.a.get(d)}}e.$Mh=C}),define(De[238],Ce([1,0,9,8,3,102,229,5,104,76]),function($e,e,C,T,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;const R=!1;class I extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class w{constructor(u=new E.$Mh,c=!1,r,o=R){this.f=u,this.g=c,this.h=r,this.i=o,this.o=new Set,this.f.set($.$Nh,this),this._globalGraph=o?r?._globalGraph??new A.$aq(m=>m):void 0}createChild(u){return new w(u,this.g,this,this.i)}invokeFunction(u,...c){const r=k.traceInvocation(this.i,u);let o=!1;try{return u({get:h=>{if(o)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(h,r);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...c)}finally{o=!0,r.stop()}}createInstance(u,...c){let r,o;return u instanceof L.$Lh?(r=k.traceCreation(this.i,u.ctor),o=this.j(u.ctor,u.staticArguments.concat(c),r)):(r=k.traceCreation(this.i,u),o=this.j(u,c,r)),r.stop(),o}j(u,c=[],r){const o=$._util.getServiceDependencies(u).sort((t,n)=>t.index-n.index),m=[];for(const t of o){const n=this.m(t.id,r);n||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),m.push(n)}const h=o.length>0?o[0].index:c.length;if(c.length!==h){console.trace(`[createInstance] First service dependency of ${u.name} at position ${h+1} conflicts with ${c.length} static arguments`);const t=h-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,h)}return Reflect.construct(u,c.concat(m))}k(u,c){if(this.f.get(u)instanceof L.$Lh)this.f.set(u,c);else if(this.h)this.h.k(u,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const c=this.f.get(u);return!c&&this.h?this.h.l(u):c}m(u,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const r=this.l(u);return r instanceof L.$Lh?this.q(u,r,c.branch(u,!0)):(c.branch(u,!1),r)}q(u,c,r){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,c,r)}finally{this.o.delete(u)}}r(u,c,r){const o=new A.$aq(t=>t.id.toString());let m=0;const h=[{id:u,desc:c,_trace:r}];for(;h.length;){const t=h.pop();if(o.lookupOrInsertNode(t),m++>1e3)throw new I(o);for(const n of $._util.getServiceDependencies(t.desc.ctor)){const a=this.l(n.id);if(a||this.u(`[createInstance] ${u} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),a instanceof L.$Lh){const i={id:n.id,desc:a,_trace:t._trace.branch(n.id,!0)};o.insertEdge(t,i),h.push(i)}}}for(;;){const t=o.roots();if(t.length===0){if(!o.isEmpty())throw new I(o);break}for(const{data:n}of t){if(this.l(n.id)instanceof L.$Lh){const i=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,i)}o.removeNode(n)}}return this.l(u)}s(u,c,r=[],o,m){if(this.f.get(u)instanceof L.$Lh)return this.t(u,c,r,o,m);if(this.h)return this.h.s(u,c,r,o,m);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(u,c,r=[],o,m){if(o){const h=new w(void 0,this.g,this,this.i);h.c=String(u);const t=new Map,n=new C.$$g(()=>{const a=h.j(c,r,m);for(const[i,s]of t){const l=a[i];if(typeof l=="function")for(const D of s)l.apply(a,D)}return t.clear(),a});return new Proxy(Object.create(null),{get(a,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let D=t.get(i);return D||(D=new v.$2c,t.set(i,D)),(b,f,g)=>{const P=D.push([b,f,g]);return(0,d.$Qc)(P)}}if(i in a)return a[i];const s=n.value;let l=s[i];return typeof l!="function"||(l=l.bind(s),a[i]=l),l},set(a,i,s){return n.value[i]=s,!0},getPrototypeOf(a){return c.prototype}})}else return this.j(c,r,m)}u(u,c){if(c&&console.warn(u),this.g)throw new Error(u)}}e.$bq=w;var y;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(y||(y={}));class k{static{this.all=new Set}static{this.c=new class extends k{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(u,c){return u?new k(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):k.c}static traceCreation(u,c){return u?new k(1,c.name):k.c}static{this.f=0}constructor(u,c){this.type=u,this.name=c,this.g=Date.now(),this.h=[]}branch(u,c){const r=new k(3,u.toString());return this.h.push([u,c,r]),r}stop(){const u=Date.now()-this.g;k.f+=u;let c=!1;function r(m,h){const t=[],n=new Array(m+1).join("	");for(const[a,i,s]of h.h)if(i&&s){c=!0,t.push(`${n}CREATES -> ${a}`);const l=r(m+1,s);l&&t.push(l)}else t.push(`${n}uses -> ${a}`);return t.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${k.f.toFixed(2)}ms)`];(u>2||c)&&k.all.add(o.join(`
`))}}e.$cq=k}),define(De[14],Ce([1,0,41,4,52,3,28,12,23,17,2,42,5]),function($e,e,C,T,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.log=e.$_i=e.LogLevel=e.$$i=e.$0i=e.$9i=void 0,e.$9i=(0,w.$Oh)("logService"),e.$0i=(0,w.$Oh)("loggerService");function y(){return new Date().toISOString()}function k(b){return(0,v.$Cf)(b)}e.$$i=k;var p;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$_i=p.Info;function u(b,f,g){switch(f){case p.Trace:b.trace(g);break;case p.Debug:b.debug(g);break;case p.Info:b.info(g);break;case p.Warning:b.warn(g);break;case p.Error:b.error(g);break;case p.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=u;function c(b,f=!1){let g="";for(let P=0;P<b.length;P++){let N=b[P];if(N instanceof Error&&(N=(0,C.$zi)(N,f)),typeof N=="object")try{N=JSON.stringify(N)}catch{}g+=(P>0?" ":"")+N}return g}class r extends L.$Sc{constructor(){super(...arguments),this.b=e.$_i,this.c=this.B(new T.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==p.Off&&this.b<=f}}e.$bj=r;class o extends r{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...g){this.f(p.Trace)&&this.g(p.Trace,c([f,...g],!0))}debug(f,...g){this.f(p.Debug)&&this.g(p.Debug,c([f,...g]))}info(f,...g){this.f(p.Info)&&this.g(p.Info,c([f,...g]))}warn(f,...g){this.f(p.Warning)&&this.g(p.Warning,c([f,...g]))}error(f,...g){if(this.f(p.Error))if(f instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=f.stack,this.g(p.Error,c(P))}else this.g(p.Error,c([f,...g]))}flush(){}}e.$cj=o;class m extends r{constructor(f=e.$_i){super(),this.setLevel(f),this.g=!$.$j}trace(f,...g){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,f,...g):console.log(`[main ${y()}]`,f,...g))}debug(f,...g){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,f,...g):console.log(`[main ${y()}]`,f,...g))}info(f,...g){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,f,...g):console.log(`[main ${y()}]`,f,...g))}warn(f,...g){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,f,...g):console.warn(`[main ${y()}]`,f,...g))}error(f,...g){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,f,...g):console.error(`[main ${y()}]`,f,...g))}dispose(){}flush(){}}e.$dj=m;class h extends r{constructor(f=e.$_i,g=!0){super(),this.g=g,this.setLevel(f)}trace(f,...g){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...g):console.log(f,...g))}debug(f,...g){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...g):console.log(f,...g))}info(f,...g){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...g):console.log(f,...g))}warn(f,...g){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...g):console.log(f,...g))}error(f,...g){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...g):console.error(f,...g))}dispose(){}flush(){}}e.$ej=h;class t extends r{constructor(f,g=e.$_i){super(),this.g=f,this.setLevel(g)}trace(f,...g){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(f),...g])}debug(f,...g){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(f),...g])}info(f,...g){this.f(p.Info)&&this.g.log(p.Info,[this.h(f),...g])}warn(f,...g){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(f),...g])}error(f,...g){this.f(p.Error)&&this.g.log(p.Error,[this.h(f),...g])}h(f){return typeof f=="string"?f:(0,C.$zi)(f,this.f(p.Trace))}dispose(){}flush(){}}e.$fj=t;class n extends r{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const g of this.g)g.setLevel(f);super.setLevel(f)}trace(f,...g){for(const P of this.g)P.trace(f,...g)}debug(f,...g){for(const P of this.g)P.debug(f,...g)}info(f,...g){for(const P of this.g)P.info(f,...g)}warn(f,...g){for(const P of this.g)P.warn(f,...g)}error(f,...g){for(const P of this.g)P.error(f,...g)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.$gj=n;class a extends L.$Sc{constructor(f,g,P){if(super(),this.h=f,this.j=g,this.b=new A.$Ac,this.c=this.B(new T.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Nd),this.onDidChangeVisibility=this.g.event,P)for(const N of P)this.b.set(N.resource,{logger:void 0,info:N})}m(f){return(0,v.$yf)(f)?[...this.b.values()].find(g=>g.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,g){const P=this.n(f),N=(0,v.$yf)(f)?f:g?.id??(0,d.$Ci)(P.toString()).toString(16);let O=this.b.get(P)?.logger;const M=g?.logLevel==="always"?p.Trace:g?.logLevel;O||(O=this.s(P,M??this.getLogLevel(P)??this.h,{...g,id:N}));const j={logger:O,info:{resource:P,id:N,logLevel:M,name:g?.name,hidden:g?.hidden,extensionId:g?.extensionId,when:g?.when}};return this.registerLogger(j.info),this.b.set(P,j),O}n(f){return(0,v.$yf)(f)?(0,E.$vg)(this.j,`${f}.log`):f}setLogLevel(f,g){if(R.URI.isUri(f)){const P=f,N=g,O=this.b.get(P);O&&N!==O.info.logLevel&&(O.info.logLevel=N===this.h?void 0:N,O.logger?.setLevel(N),this.b.set(O.info.resource,O),this.f.fire([P,N]))}else{this.h=f;for(const[P,N]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,g){const P=this.m(f);P&&g!==!P.info.hidden&&(P.info.hidden=!g,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,g]))}getLogLevel(f){let g;return f&&(g=this.b.get(f)?.info.logLevel),g??this.h}registerLogger(f){const g=this.b.get(f.resource);g?g.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const g=this.b.get(f);g&&(g.logger&&g.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[g.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$hj=a;class i{constructor(){this.onDidChangeLogLevel=new T.$Nd().event}setLevel(f){}getLevel(){return p.Info}trace(f,...g){}debug(f,...g){}info(f,...g){}warn(f,...g){}error(f,...g){}critical(f,...g){}dispose(){}flush(){}}e.$ij=i;class s extends i{}e.$jj=s;function l(b){if(b.verbose)return p.Trace;if(typeof b.logLevel=="string"){const f=S(b.logLevel.toLowerCase());if(f!==void 0)return f}return e.$_i}e.$kj=l;function D(b){switch(b){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$lj=D;function S(b){switch(b){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$mj=S,e.$nj=new I.$6i("logLevel",D(p.Info))}),define(De[239],Ce([1,0,19,9,8,4,3,16,84,14]),function($e,e,C,T,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0;class R extends A.$Sc{constructor(w,y){super(),this.a=w,this.b=y,this.c=this.B(new L.$Nd),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Nd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new T.$Rg(0)),this.w=[],this.y=this.B(new T.$Rg(0))}watch(w,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n(w,y):this.z(w,y)}n(w,y){const k={path:this.H(w),excludes:y.excludes,includes:y.includes,recursive:y.recursive,correlationId:y.correlationId},p=(0,C.$Ub)(this.j,k);return this.r(),(0,A.$Qc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,d.$1)(w))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,E.$Qp)(y)),y=>this.G(y),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const y of this.j)(0,E.$Mp)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const y of this.j)(0,E.$Mp)(y)&&w.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,y){const k={path:this.H(w),excludes:y.excludes,includes:y.includes,recursive:!1,correlationId:y.correlationId},p=(0,C.$Ub)(this.w,k);return this.C(),(0,A.$Qc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,d.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,E.$Qp)(w)),w=>this.G(w),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,$.$hc)(w.fsPath)}}e.$Up=R}),define(De[240],Ce([1,0,53,374,9,28,22,4,32,3,16,12,23,96,29,197,30,233,239,41,237,236]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r,o,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=void 0,(()=>{try{(0,T.gracefulify)(C)}catch(n){console.error(`Error enabling graceful-fs: ${(0,o.$zi)(n)}`)}})();class t extends r.$Up{static{this.I=!1}constructor(a,i){super(a,i),this.onDidChangeCapabilities=$.Event.None,this.N=new L.$Ac(s=>w.$mg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$l&&(this.J|=1024)),this.J}async stat(a){try{const{stat:i,symbolicLink:s}=await k.SymlinkSupport.stat(this.H(a));return{type:this.M(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:u.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const i=await k.Promises.readdir(this.H(a),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async l=>{try{let D;l.isSymbolicLink()?D=(await this.stat((0,w.$vg)(a,l.name))).type:D=this.M(l),s.push([l.name,D])}catch(D){this.a.trace(D)}})),s}catch(i){throw this.fb(i)}}M(a,i){let s;return i?.dangling?s=u.FileType.Unknown:a.isFile()?s=u.FileType.File:a.isDirectory()?s=u.FileType.Directory:s=u.FileType.Unknown,i&&(s|=u.FileType.SymbolicLink),s}async O(a){const i=this.H(a);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.N.get(a);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const l=new d.$Sg;return this.N.set(a,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,v.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(a)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(a)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(a,i){let s;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(a)})`),s=await this.O(a));const l=this.H(a);return await k.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{s?.dispose()}}P(a){t.I&&this.a.trace(a)}readFileStream(a,i,s){const l=(0,y.$2d)(D=>A.$be.concat(D.map(S=>A.$be.wrap(S))).buffer);return(0,c.$Kp)(this,a,l,D=>D.buffer,{...i,bufferSize:256*1024},s),l}async writeFile(a,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(a)?this.R(a,(0,w.$vg)((0,w.$ug)(a),`${(0,w.$sg)(a)}${s.atomic.postfix}`),i,s):this.S(a,i,s)}async Q(a){try{const i=this.H(a),{symbolicLink:s}=await k.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async R(a,i,s,l){const D=new v.$Rc;try{D.add(await this.O(a)),D.add(await this.O(i)),await this.S(i,s,l,!0);try{await this.rename(i,a,{overwrite:!0})}catch(S){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{D.dispose()}}async S(a,i,s,l){let D;try{const S=this.H(a);if(!s.create||!s.overwrite){if(await k.Promises.exists(S)){if(!s.overwrite)throw(0,u.$kk)((0,p.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,u.$kk)((0,p.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}D=await this.open(a,{create:!0,unlock:s.unlock},l),await this.write(D,0,i,0,i.byteLength)}catch(S){throw await this.gb(a,S)}finally{typeof D=="number"&&await this.close(D)}}static{this.Y=!0}static configureFlushOnWrite(a){t.Y=a}async open(a,i,s){const l=this.H(a);let D;(0,u.$$j)(i)&&!s&&(D=await this.O(a));let S;try{if((0,u.$$j)(i)&&i.unlock)try{const{stat:f}=await k.SymlinkSupport.stat(l);f.mode&128||await k.Promises.chmod(l,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let b;if((0,u.$$j)(i)){if(I.$j)try{await k.Promises.truncate(l,0),b="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}b||(b="w")}else b="r";S=await k.Promises.open(l,b)}catch(b){throw D?.dispose(),(0,u.$$j)(i)?await this.gb(a,b):this.fb(b)}if(this.U.set(S,0),(0,u.$$j)(i)&&this.X.set(S,a),D){const b=this.W.get(S);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${l})`),this.W.set(S,D),b&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${l})`),b.dispose())}return S}async close(a){const i=this.W.get(a);try{if(this.U.delete(a),this.X.delete(a)&&t.Y)try{await k.Promises.fdatasync(a)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await k.Promises.close(a)}catch(s){throw this.fb(s)}finally{i&&(this.W.get(a)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.W.delete(a)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),i.dispose())}}async read(a,i,s,l,D){const S=this.Z(a,i);let b=null;try{b=(await k.Promises.read(a,s,l,D,S)).bytesRead}catch(f){throw this.fb(f)}finally{this.$(a,S,b)}return b}Z(a,i){return i===this.U.get(a)?null:i}$(a,i,s){const l=this.U.get(a);typeof l=="number"&&(typeof i=="number"||(typeof s=="number"?this.U.set(a,l+s):this.U.delete(a)))}async write(a,i,s,l,D){return(0,d.$_g)(()=>this.ab(a,i,s,l,D),100,3)}async ab(a,i,s,l,D){const S=this.Z(a,i);let b=null;try{b=(await k.Promises.write(a,s,l,D,S)).bytesWritten}catch(f){throw await this.gb(this.X.get(a),f)}finally{this.$(a,S,b)}return b}async mkdir(a){try{await k.Promises.mkdir(this.H(a))}catch(i){throw this.fb(i)}}async delete(a,i){try{const s=this.H(a);if(i.recursive){let l;i?.atomic!==!1&&i.atomic.postfix&&(l=(0,R.$jc)((0,R.$mc)(s),`${(0,R.$nc)(s)}${i.atomic.postfix}`)),await k.Promises.rm(s,k.RimRafMode.MOVE,l)}else try{await k.Promises.unlink(s)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let D=!1;try{const{stat:S,symbolicLink:b}=await k.SymlinkSupport.stat(s);D=S.isDirectory()&&!b}catch{}if(D)await k.Promises.rmdir(s);else throw l}else throw l}}catch(s){throw this.fb(s)}}async rename(a,i,s){const l=this.H(a),D=this.H(i);if(l!==D)try{await this.bb(a,i,"move",s.overwrite),await k.Promises.rename(l,D)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,p.localize)(2,null,(0,R.$nc)(l),(0,R.$nc)((0,R.$mc)(D)),S.toString()))),this.fb(S)}}async copy(a,i,s){const l=this.H(a),D=this.H(i);if(l!==D)try{await this.bb(a,i,"copy",s.overwrite),await k.Promises.copy(l,D,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,p.localize)(3,null,(0,R.$nc)(l),(0,R.$nc)((0,R.$mc)(D)),S.toString()))),this.fb(S)}}async bb(a,i,s,l){const D=this.H(a),S=this.H(i);let b=!1;if(!!(this.capabilities&1024)||(b=(0,E.$Wf)(D,S,!0)),b){if(s==="copy")throw(0,u.$kk)((0,p.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const g=await this.L(a);if(!g)throw(0,u.$kk)((0,p.localize)(5,null),u.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(i);if(P){if(!l)throw(0,u.$kk)((0,p.localize)(6,null),u.FileSystemProviderErrorCode.FileExists);g.type&u.FileType.File&&P.type&u.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,i){return this.cb(a,i,!1)}async cb(a,i,s){const l=this.H(a),D=this.H(i),S=!!(this.capabilities&1024);if((0,E.$Wf)(l,D,!S))return;const b=new v.$Rc;try{b.add(await this.O(a)),b.add(await this.O(i)),s&&await k.Promises.mkdir((0,R.$mc)(D),{recursive:!0}),await k.Promises.copyFile(l,D)}catch(f){if(f.code==="ENOENT"&&!s)return this.cb(a,i,!0);throw this.fb(f)}finally{b.dispose()}}t(a,i,s){return new m.$2p(l=>a(l),l=>i(l),s)}F(a,i,s){return new h.$0p(l=>a(l),l=>i(l),s)}fb(a){if(a instanceof u.$jk)return a;let i=a,s;switch(a.code){case"ENOENT":s=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=u.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=u.FileSystemProviderErrorCode.Unknown;break;default:s=u.FileSystemProviderErrorCode.Unknown}return(0,u.$kk)(i,s)}async gb(a,i){let s=this.fb(i);if(a&&s.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await k.SymlinkSupport.stat(this.H(a));l.mode&128||(s=(0,u.$kk)(i,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return s}}e.$$p=t}),define(De[241],Ce([1,0,3,14]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=void 0;class d extends C.$Sc{constructor(A,$=[]){super(),this.a=new T.$gj([A,...$]),this.B(A.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...$){this.a.trace(A,...$)}debug(A,...$){this.a.debug(A,...$)}info(A,...$){this.a.info(A,...$)}warn(A,...$){this.a.warn(A,...$)}error(A,...$){this.a.error(A,...$)}flush(){this.a.flush()}}e.$AN=d}),define(De[242],Ce([1,0,30,14]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pN=void 0;var d;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(d||(d={}));async function L(v,R,I,w,y){try{const k=await new Promise((u,c)=>{$e(["@vscode/spdlog"],u,c)});k.setFlushOn(d.Trace);const p=await k.createAsyncRotatingLogger(v,R,I,w);return y?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(k){console.error(k)}return null}function A(v,R,I){switch(R){case T.LogLevel.Trace:v.trace(I);break;case T.LogLevel.Debug:v.debug(I);break;case T.LogLevel.Info:v.info(I);break;case T.LogLevel.Warning:v.warn(I);break;case T.LogLevel.Error:v.error(I);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function $(v,R){switch(R){case T.LogLevel.Trace:v.setLevel(d.Trace);break;case T.LogLevel.Debug:v.setLevel(d.Debug);break;case T.LogLevel.Info:v.setLevel(d.Info);break;case T.LogLevel.Warning:v.setLevel(d.Warning);break;case T.LogLevel.Error:v.setLevel(d.Error);break;case T.LogLevel.Off:v.setLevel(d.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class E extends T.$cj{constructor(R,I,w,y,k){super(),this.m=[],this.setLevel(k),this.n=this.s(R,I,w,y),this.B(this.onDidChangeLogLevel(p=>{this.r&&$(this.r,p)}))}async s(R,I,w,y){const k=w?6:1,p=30/k*C.$Fk.MB,u=await L(R,I,p,k,y);if(u){this.r=u,$(this.r,this.getLevel());for(const{level:c,message:r}of this.m)A(this.r,c,r);this.m=[]}}g(R,I){this.r?A(this.r,R,I):this.getLevel()<=R&&this.m.push({level:R,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$pN=E}),define(De[133],Ce([1,0,38,198,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(E){function v(k,p){return p-k}E.compare=v;const R=Object.create(null);R[E.Error]=(0,T.localize)(0,null),R[E.Warning]=(0,T.localize)(1,null),R[E.Info]=(0,T.localize)(2,null);function I(k){return R[k]||""}E.toString=I;function w(k){switch(k){case C.default.Error:return E.Error;case C.default.Warning:return E.Warning;case C.default.Info:return E.Info;case C.default.Ignore:return E.Hint}}E.fromSeverity=w;function y(k){switch(k){case E.Error:return C.default.Error;case E.Warning:return C.default.Warning;case E.Info:return C.default.Info;case E.Hint:return C.default.Ignore}}E.toSeverity=y}(A||(e.MarkerSeverity=A={}));var $;(function(E){const v="";function R(w){return I(w,!0)}E.makeKey=R;function I(w,y){const k=[v];return w.source?k.push(w.source.replace("\xA6","\\\xA6")):k.push(v),w.code?typeof w.code=="string"?k.push(w.code.replace("\xA6","\\\xA6")):k.push(w.code.value.replace("\xA6","\\\xA6")):k.push(v),w.severity!==void 0&&w.severity!==null?k.push(A.toString(w.severity)):k.push(v),w.message&&y?k.push(w.message.replace("\xA6","\\\xA6")):k.push(v),w.startLineNumber!==void 0&&w.startLineNumber!==null?k.push(w.startLineNumber.toString()):k.push(v),w.startColumn!==void 0&&w.startColumn!==null?k.push(w.startColumn.toString()):k.push(v),w.endLineNumber!==void 0&&w.endLineNumber!==null?k.push(w.endLineNumber.toString()):k.push(v),w.endColumn!==void 0&&w.endColumn!==null?k.push(w.endColumn.toString()):k.push(v),k.push(v),k.join("\xA6")}E.makeKeyOptionalMessage=I})($||(e.IMarkerData=$={})),e.$9s=(0,d.$Oh)("markerService")}),define(De[243],Ce([1,0,4,38,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yu=e.$Xu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Wu=e.Severity=void 0,e.Severity=T.default,e.$Wu=(0,d.$Oh)("notificationService");var L;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var $;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class E{constructor(){this.progress=new v,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$Xu=E;class v{infinite(){}done(){}total(I){}worked(I){}}e.$Yu=v}),define(De[134],Ce([1,0,15,2,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cU=e.$bU=e.$aU=e.$_T=e.$$T=void 0,e.$$T=(0,d.$Oh)("openerService");function L(v,R){return T.URI.isUri(v)?(0,C.$2e)(v.scheme,R):(0,C.$3e)(v,R+":")}e.$_T=L;function A(v,...R){return R.some(I=>L(v,I))}e.$aU=A;function $(v,R){return v.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.$bU=$;function E(v){let R;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(v.fragment);return I&&(R={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},v=v.with({fragment:""})),{selection:R,uri:v}}e.$cU=E}),define(De[244],Ce([1,0,12,48]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let d;if(typeof C.$h.vscode<"u"&&typeof C.$h.vscode.context<"u"){const L=C.$h.vscode.context.configuration();if(L)d=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(d=globalThis._VSCODE_PRODUCT_JSON,T.env.VSCODE_DEV&&Object.assign(d,{nameShort:`${d.nameShort} Dev`,nameLong:`${d.nameLong} Dev`,dataFolderName:`${d.dataFolderName}-dev`,serverDataFolderName:d.serverDataFolderName?`${d.serverDataFolderName}-dev`:void 0}),!d.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(d,{version:L.version})}}else d={},Object.keys(d).length===0&&Object.assign(d,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=d}),define(De[135],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=void 0,e.$oj=(0,C.$Oh)("productService"),e.$pj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function($e,e){return function(C,T){e(C,T,$e)}};define(De[64],Ce([1,0,9,21,3,5]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5u=e.$4u=e.$3u=e.$2u=e.$1u=e.ProgressLocation=e.$Zu=void 0,e.$Zu=(0,L.$Oh)("progressService");var A;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$1u=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(I,w){this.e=I,this.report=w?.async?this.g.bind(this):this.f.bind(this)}f(I){this.a=I,this.e(this.a)}g(I){this.b?this.b.push(I):this.b=[I],this.h()}async h(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const I=this.b.shift();this.a=I,await this.e(this.a)}}finally{this.c=!1;const I=this.d;this.d=void 0,I?.()}}drain(){return this.c?new Promise(I=>{const w=this.d;this.d=()=>{w?.(),I()}}):Promise.resolve()}}e.$2u=$;let E=class extends d.$Sc{constructor(I,w){super(),this.a=new C.$ch,w.withProgress(I,y=>(this.b=y,this.c&&y.report(this.c),this.a.p)),this.B((0,d.$Qc)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};e.$3u=E,e.$3u=E=He([Be(1,e.$Zu)],E);class v extends d.$Sc{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new d.$Rc)}start(I){this.stop();const w=++this.a,y=new T.$Xd;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,d.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,d.$Qc)(()=>y.cancel())),this.b.add((0,d.$Qc)(()=>this.c?this.c.done():void 0)),{id:w,token:y.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.$4u=v,e.$5u=(0,L.$Oh)("editorProgressService")}),define(De[43],Ce([1,0,58,17]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=void 0;class d{constructor(){this.a=new Map}add(A,$){C.ok(T.$yf(A)),C.ok(T.$Af($)),C.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,$)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$dn=new d}),define(De[105],Ce([1,0,4,43]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=void 0,e.$en={JSONContribution:"base.contributions.json"};function d($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class L{constructor(){this.b=new C.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,v){this.a[d(E)]=v,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;T.$dn.add(e.$en.JSONContribution,A)}),define(De[136],Ce([1,0,19,4,17,188,50,105,43]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.ConfigurationScope=e.$in=e.EditPresentationTypes=void 0;var v;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(v||(e.EditPresentationTypes=v={})),e.$in={Configuration:"base.contributions.configuration"};var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$jn={properties:{},patternProperties:{}},e.$kn={properties:{},patternProperties:{}},e.$ln={properties:{},patternProperties:{}},e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn="vscode://schemas/settings/resourceLanguage",e.$qn="vscode://schemas/settings/configurationDefaults";const I=E.$dn.as($.$en.JSONContribution);class w{constructor(){this.h=new Set,this.i=new T.$Nd,this.onDidSchemaChange=this.i.event,this.j=new T.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$pn,this.g),this.v()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const a=new Set;this.n(t,n,a),I.registerSchema(e.$pn,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const n=new Set;this.o(t,n),I.registerSchema(e.$pn,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const a=new Set;this.o(n,a),this.n(t,!1,a),I.registerSchema(e.$pn,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const n=new Set;this.k(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}k(t,n){const a=[];for(const{overrides:i,source:s}of t)for(const l in i)if(n.add(l),e.$sn.test(l)){const D=this.a.get(l),S=D?.valuesSources??new Map;if(s)for(const P of Object.keys(i[l]))S.set(P,s);const b={...D?.value||{},...i[l]};this.a.set(l,{source:s,value:b,valuesSources:S});const f=(0,A.$si)(l),g={type:"object",default:b,description:L.localize(1,null,f),$ref:e.$pn,defaultDefaultValue:b,source:d.$yf(s)?void 0:s,defaultValueSource:s};a.push(...p(l)),this.d[l]=g,this.b.properties[l]=g}else{this.a.set(l,{value:i[l],source:s});const D=this.d[l];D&&(this.w(l,D),this.r(l,D))}this.m(a)}deregisterDefaultConfigurations(t){const n=new Set;this.l(t,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}l(t,n){for(const{overrides:a,source:i}of t)for(const s in a){const l=this.a.get(s),D=d.$yf(i)?i:i?.id,S=d.$yf(l?.source)?l?.source:l?.source?.id;if(D===S)if(n.add(s),this.a.delete(s),e.$sn.test(s))delete this.d[s],delete this.b.properties[s];else{const b=this.d[s];b&&(this.w(s,b),this.r(s,b))}}this.u()}deltaConfiguration(t){let n=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),n=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),n=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:n})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const n of t)this.h.add(n);this.u()}n(t,n,a){t.forEach(i=>{this.p(i,n,i.extensionInfo,i.restrictedProperties,void 0,a),this.c.push(i),this.q(i)})}o(t,n){const a=i=>{if(i.properties)for(const s in i.properties){n.add(s);const l=this.d[s];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>a(s))};for(const i of t){a(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(t,n=!0,a,i,s=3,l){s=d.$Hf(t.scope)?s:t.scope;const D=t.properties;if(D)for(const b in D){const f=D[b];if(n&&o(b,f)){delete D[b];continue}if(f.source=a,f.defaultDefaultValue=D[b].default,this.w(b,f),e.$sn.test(b)?f.scope=void 0:(f.scope=d.$Hf(f.scope)?s:f.scope,f.restricted=d.$Hf(f.restricted)?!!i?.includes(b):f.restricted),D[b].hasOwnProperty("included")&&!D[b].included){this.f[b]=D[b],delete D[b];continue}else this.d[b]=D[b],D[b].policy?.name&&this.e.set(D[b].policy.name,b);!D[b].deprecationMessage&&D[b].markdownDeprecationMessage&&(D[b].deprecationMessage=D[b].markdownDeprecationMessage),l.add(b)}const S=t.allOf;if(S)for(const b of S)this.p(b,n,a,i,s,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const n=a=>{const i=a.properties;if(i)for(const l in i)this.r(l,i[l]);a.allOf?.forEach(n)};n(t)}r(t,n){switch(e.$jn.properties[t]=n,n.scope){case 1:e.$kn.properties[t]=n;break;case 2:e.$ln.properties[t]=n;break;case 6:e.$mn.properties[t]=n;break;case 3:e.$nn.properties[t]=n;break;case 4:e.$on.properties[t]=n;break;case 5:e.$on.properties[t]=n,this.g.properties[t]=n;break}}s(t,n){switch(delete e.$jn.properties[t],n.scope){case 1:delete e.$kn.properties[t];break;case 2:delete e.$ln.properties[t];break;case 6:delete e.$mn.properties[t];break;case 3:delete e.$nn.properties[t];break;case 4:case 5:delete e.$on.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const n=`[${t}]`,a={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$pn};this.w(n,a),e.$jn.properties[n]=a,e.$kn.properties[n]=a,e.$ln.properties[n]=a,e.$mn.properties[n]=a,e.$nn.properties[n]=a,e.$on.properties[n]=a}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$pn};e.$jn.patternProperties[e.$rn]=t,e.$kn.patternProperties[e.$rn]=t,e.$ln.patternProperties[e.$rn]=t,e.$mn.patternProperties[e.$rn]=t,e.$nn.patternProperties[e.$rn]=t,e.$on.patternProperties[e.$rn]=t,this.i.fire()}w(t,n){const a=this.a.get(t);let i=a?.value,s=a?.source;d.$Ff(i)&&(i=n.defaultDefaultValue,s=void 0),d.$Ff(i)&&(i=c(n.type)),n.default=i,n.defaultValueSource=s}}const y="\\[([^\\]]+)\\]",k=new RegExp(y,"g");e.$rn=`^(${y})+$`,e.$sn=new RegExp(e.$rn);function p(h){const t=[];if(e.$sn.test(h)){let n=k.exec(h);for(;n?.length;){const a=n[1].trim();a&&t.push(a),n=k.exec(h)}}return(0,C.$Mb)(t)}e.$tn=p;function u(h){return h.reduce((t,n)=>`${t}[${n}]`,"")}e.$un=u;function c(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$vn=c;const r=new w;E.$dn.add(e.$in.Configuration,r);function o(h,t){return h.trim()?e.$sn.test(h)?L.localize(7,null,h):r.getConfigurationProperties()[h]!==void 0?L.localize(8,null,h):t.policy?.name&&r.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,h,t.policy?.name,r.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$wn=o;function m(){const h=[],t=r.getConfigurationProperties();for(const n of Object.keys(t))h.push([n,t[n].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$xn=m}),define(De[245],Ce([1,0,19,4,157,3,28,24,17,2,50,136,43]),function($e,e,C,T,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=void 0;function y(n){return Object.isFrozen(n)?n:$.$5m(n)}class k{constructor(a={},i=[],s=[],l){this.b=a,this.c=i,this.d=s,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const a=this.raw.map(i=>{if(i instanceof k)return i;const s=new p("");return s.parseRaw(i),s.configurationModel});this.f=a.reduce((i,s)=>s===i?s:i.merge(s),a[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,R.$qi)(this.contents,a):this.contents}inspect(a,i){const s=this.rawConfiguration.getValue(a),l=i?this.rawConfiguration.getOverrideValue(a,i):void 0,D=i?this.rawConfiguration.override(i).getValue(a):s;return{value:s,override:l,merged:D}}getOverrideValue(a,i){const s=this.i(i);return s?a?(0,R.$qi)(s,a):s:void 0}getKeysForOverrideIdentifier(a){const i=[];for(const s of this.overrides)s.identifiers.includes(a)&&i.push(...s.keys);return C.$Mb(i)}getAllOverrideIdentifiers(){const a=[];for(const i of this.overrides)a.push(...i.identifiers);return C.$Mb(a)}override(a){let i=this.a.get(a);return i||(i=this.g(a),this.a.set(a,i)),i}merge(...a){const i=$.$4m(this.contents),s=$.$4m(this.overrides),l=[...this.keys],D=this.raw?.length?[...this.raw]:[this];for(const S of a)if(D.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(i,S.contents);for(const b of S.overrides){const[f]=s.filter(g=>C.$ub(g.identifiers,b.identifiers));f?(this.h(f.contents,b.contents),f.keys.push(...b.keys),f.keys=C.$Mb(f.keys)):s.push($.$4m(b))}for(const b of S.keys)l.indexOf(b)===-1&&l.push(b)}return new k(i,l,s,D.every(S=>S instanceof k)?void 0:D)}g(a){const i=this.i(a);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const l of C.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let D=this.contents[l];const S=i[l];S&&(typeof D=="object"&&typeof S=="object"?(D=$.$4m(D),this.h(D,S)):D=S),s[l]=D}return new k(s,this.keys,this.overrides)}h(a,i){for(const s of Object.keys(i)){if(s in a&&E.$Af(a[s])&&E.$Af(i[s])){this.h(a[s],i[s]);continue}a[s]=$.$4m(i[s])}}i(a){let i=null,s=null;const l=D=>{D&&(s?this.h(s,D):s=$.$4m(D))};for(const D of this.overrides)D.identifiers.length===1&&D.identifiers[0]===a?i=D.contents:D.identifiers.includes(a)&&l(D.contents);return l(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,i){this.j(a,i,!0)}setValue(a,i){this.j(a,i,!1)}removeValue(a){const i=this.keys.indexOf(a);i!==-1&&(this.keys.splice(i,1),(0,R.$pi)(this.contents,a),I.$sn.test(a)&&this.overrides.splice(this.overrides.findIndex(s=>C.$ub(s.identifiers,(0,I.$tn)(a))),1))}j(a,i,s){(0,R.$oi)(this.contents,a,i,l=>console.error(l)),s=s||this.keys.indexOf(a)===-1,s&&this.keys.push(a),I.$sn.test(a)&&this.overrides.push({identifiers:(0,I.$tn)(a),keys:Object.keys(this.contents[a]),contents:(0,R.$ni)(this.contents[a],l=>console.error(l))})}}e.$yn=k;class p{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new k}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,i){if(!E.$Hf(a)){const s=this.g(a);this.parseRaw(s,i)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,i){this.a=a;const{contents:s,keys:l,overrides:D,restricted:S,hasExcludedProperties:b}=this.h(a,i);this.b=new k(s,l,D,b?[a]:void 0),this.c=S||[]}g(a){let i={},s=null,l=[];const D=[],S=[];function b(g){Array.isArray(l)?l.push(g):s!==null&&(l[s]=g)}const f={onObjectBegin:()=>{const g={};b(g),D.push(l),l=g,s=null},onObjectProperty:g=>{s=g},onObjectEnd:()=>{l=D.pop()},onArrayBegin:()=>{const g=[];b(g),D.push(l),l=g,s=null},onArrayEnd:()=>{l=D.pop()},onLiteralValue:b,onError:(g,P,N)=>{S.push({error:g,offset:P,length:N})}};if(a)try{d.$1m(a,f),i=l[0]||{}}catch(g){console.error(`Error while parsing settings file ${this.f}: ${g}`),this.d=[g]}return i}h(a,i){const s=w.$dn.as(I.$in.Configuration).getConfigurationProperties(),l=this.i(a,s,!0,i);a=l.raw;const D=(0,R.$ni)(a,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),S=Object.keys(a),b=this.j(a,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:D,keys:S,overrides:b,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(a,i,s,l){let D=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:D};const S={},b=[];for(const f in a)if(I.$sn.test(f)&&s){const g=this.i(a[f],i,!1,l);S[f]=g.raw,D=D||g.hasExcludedProperties,b.push(...g.restricted)}else{const g=i[f],P=g?typeof g.scope<"u"?g.scope:3:void 0;g?.restricted&&b.push(f),!l.exclude?.includes(f)&&(l.include?.includes(f)||(P===void 0||l.scopes===void 0||l.scopes.includes(P))&&!(l.skipRestricted&&g?.restricted))?S[f]=a[f]:D=!0}return{raw:S,restricted:b,hasExcludedProperties:D}}j(a,i){const s=[];for(const l of Object.keys(a))if(I.$sn.test(l)){const D={};for(const S in a[l])D[S]=a[l][S];s.push({identifiers:(0,I.$tn)(l),keys:Object.keys(D),contents:(0,R.$ni)(D,i)})}return s}}e.$zn=p;class u extends L.$Sc{constructor(a,i,s,l){super(),this.c=a,this.f=i,this.g=l,this.b=this.B(new T.$Nd),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(0)||D.isOperation(3)||D.isOperation(1)||D.isOperation(4))&&s.isEqual(D.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new k}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$An=u;class c{constructor(a,i,s,l,D,S,b,f,g,P,N,O,M){this.a=a,this.b=i,this.c=s,this.overrideIdentifiers=l,this.d=D,this.f=S,this.g=b,this.h=f,this.i=g,this.j=P,this.k=N,this.l=O,this.m=M}get value(){return y(this.c)}n(a,i,s){const l=a.inspect(i,s);return{get value(){return y(l.value)},get override(){return y(l.override)},get merged(){return y(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class r{constructor(a,i,s,l,D=new k,S=new k,b=new A.$Ac,f=new k,g=new A.$Ac){this.c=a,this.d=i,this.f=s,this.g=l,this.h=D,this.i=S,this.j=b,this.l=f,this.m=g,this.a=null,this.b=new A.$Ac,this.n=null}getValue(a,i,s){return this.q(a,i,s).getValue(a)}updateValue(a,i,s={}){let l;s.resource?(l=this.m.get(s.resource),l||(l=new k,this.m.set(s.resource,l))):l=this.l,i===void 0?l.removeValue(a):l.setValue(a,i),s.resource||(this.a=null)}inspect(a,i,s){const l=this.q(a,i,s),D=this.u(i.resource,s),S=i.resource?this.m.get(i.resource)||this.l:this.l,b=new Set;for(const f of l.overrides)for(const g of f.identifiers)l.getOverrideValue(a,g)!==void 0&&b.add(g);return new c(a,i,l.getValue(a),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,D||void 0,S)}keys(a){const i=this.u(void 0,a);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.i=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,i){this.j.set(a,i),this.b.delete(a)}deleteFolderConfiguration(a){this.p.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,i){const s=[];if(!i){const{added:l,updated:D,removed:S}=h(this.c,a);i=[...l,...D,...S]}for(const l of i)for(const D of(0,I.$tn)(l)){const S=this.c.getKeysForOverrideIdentifier(D),b=a.getKeysForOverrideIdentifier(D),f=[...b.filter(g=>S.indexOf(g)===-1),...S.filter(g=>b.indexOf(g)===-1),...S.filter(g=>!$.$8m(this.c.override(D).getValue(g),a.override(D).getValue(g)))];s.push([D,f])}return this.updateDefaultConfiguration(a),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(a){const{added:i,updated:s,removed:l}=h(this.d,a),D=[...i,...s,...l];return D.length&&this.updatePolicyConfiguration(a),{keys:D,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:i,updated:s,removed:l,overrides:D}=h(this.applicationConfiguration,a),S=[...i,...s,...l];return S.length&&this.updateApplicationConfiguration(a),{keys:S,overrides:D}}compareAndUpdateLocalUserConfiguration(a){const{added:i,updated:s,removed:l,overrides:D}=h(this.localUserConfiguration,a),S=[...i,...s,...l];return S.length&&this.updateLocalUserConfiguration(a),{keys:S,overrides:D}}compareAndUpdateRemoteUserConfiguration(a){const{added:i,updated:s,removed:l,overrides:D}=h(this.remoteUserConfiguration,a),S=[...i,...s,...l];return S.length&&this.updateRemoteUserConfiguration(a),{keys:S,overrides:D}}compareAndUpdateWorkspaceConfiguration(a){const{added:i,updated:s,removed:l,overrides:D}=h(this.workspaceConfiguration,a),S=[...i,...s,...l];return S.length&&this.updateWorkspaceConfiguration(a),{keys:S,overrides:D}}compareAndUpdateFolderConfiguration(a,i){const s=this.p.get(a),{added:l,updated:D,removed:S,overrides:b}=h(s,i),f=[...l,...D,...S];return(f.length||!s)&&this.updateFolderConfiguration(a,i),{keys:f,overrides:b}}compareAndDeleteFolderConfiguration(a){const i=this.p.get(a);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:s,updated:l,removed:D,overrides:S}=h(i,void 0);return{keys:[...s,...l,...D],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(a,i,s){let l=this.r(i,s);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(l=l.merge(this.d)),l}r({resource:a},i){let s=this.s();if(i&&a){const l=i.getFolder(a);l&&(s=this.t(l.uri)||s);const D=this.m.get(a);D&&(s=s.merge(D))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(a){let i=this.b.get(a);if(!i){const s=this.s(),l=this.j.get(a);l?(i=s.merge(l),this.b.set(a,i)):i=s}return i}u(a,i){if(i&&a){const s=i.getFolder(a);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((a,i)=>{const{contents:s,overrides:l,keys:D}=this.j.get(i);return a.push([i,{contents:s,overrides:l,keys:D}]),a},[])}}allKeys(){const a=new Set;return this.c.keys.forEach(i=>a.add(i)),this.userConfiguration.keys.forEach(i=>a.add(i)),this.i.keys.forEach(i=>a.add(i)),this.j.forEach(i=>i.keys.forEach(s=>a.add(s))),[...a.values()]}v(){const a=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>a.add(s))),[...a.values()]}w(a){const i=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(s=>i.add(s)),this.i.getKeysForOverrideIdentifier(a).forEach(s=>i.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(a).forEach(l=>i.add(l))),[...i.values()]}static parse(a){const i=this.x(a.defaults),s=this.x(a.policy),l=this.x(a.application),D=this.x(a.user),S=this.x(a.workspace),b=a.folders.reduce((f,g)=>(f.set(v.URI.revive(g[0]),this.x(g[1])),f),new A.$Ac);return new r(i,s,l,D,new k,S,b,new k,new A.$Ac)}static x(a){return new k(a.contents,a.keys,a.overrides)}}e.$Bn=r;function o(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const a=new Set,i=new Map;for(const l of n)l.keys.forEach(D=>a.add(D)),l.overrides.forEach(([D,S])=>{const b=(0,A.$xc)(i,D,new Set);S.forEach(f=>b.add(f))});const s=[];return i.forEach((l,D)=>s.push([D,[...l.values()]])),{keys:[...a.values()],overrides:s}}e.$Cn=o;class m{constructor(a,i,s,l){this.change=a,this.f=i,this.g=s,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const D of a.keys)this.affectedKeys.add(D);for(const[,D]of a.overrides)for(const S of D)this.affectedKeys.add(S);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(a,i){const s=this.a+a,l=this.d.indexOf(s);if(l<0)return!1;const D=l+s.length;if(D>=this.d.length)return!1;const S=this.d.charCodeAt(D);if(S!==this.b&&S!==this.c)return!1;if(i){const b=this.previousConfiguration?this.previousConfiguration.getValue(a,i,this.f?.workspace):void 0,f=this.g.getValue(a,i,this.h);return!$.$8m(b,f)}return!0}}e.$Dn=m;function h(n,a){const{added:i,removed:s,updated:l}=t(a?.rawConfiguration,n?.rawConfiguration),D=[],S=n?.getAllOverrideIdentifiers()||[],b=a?.getAllOverrideIdentifiers()||[];if(a){const f=b.filter(g=>!S.includes(g));for(const g of f)D.push([g,a.getKeysForOverrideIdentifier(g)])}if(n){const f=S.filter(g=>!b.includes(g));for(const g of f)D.push([g,n.getKeysForOverrideIdentifier(g)])}if(a&&n){for(const f of S)if(b.includes(f)){const g=t({contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)},{contents:a.getOverrideValue(void 0,f)||{},keys:a.getKeysForOverrideIdentifier(f)});D.push([f,[...g.added,...g.removed,...g.updated]])}}return{added:i,removed:s,updated:l,overrides:D}}function t(n,a){const i=n?a?n.keys.filter(D=>a.keys.indexOf(D)===-1):[...n.keys]:[],s=a?n?a.keys.filter(D=>n.keys.indexOf(D)===-1):[...a.keys]:[],l=[];if(n&&a){for(const D of a.keys)if(n.keys.indexOf(D)!==-1){const S=(0,R.$qi)(a.contents,D),b=(0,R.$qi)(n.contents,D);$.$8m(S,b)||l.push(D)}}return{added:i,removed:s,updated:l}}}),define(De[246],Ce([1,0,22,4,3,82]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykb=e.$xkb=e.$wkb=e.$vkb=void 0;const A=(v,R,I)=>{const w=new Uint8Array(16);for(let p=0;p<16;p++)w[p]=Math.round(Math.random()*256);const y=(0,C.$ve)(C.$be.wrap(w));return[`GET ws://localhost${v}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$vkb=A,e.$wkb=C.$be.fromString(`\r
\r
`);async function $(v,R,I,w,y){v.write(C.$be.fromString((0,e.$vkb)(R,I,w)));const k=new d.$Rc;try{return await new Promise((p,u)=>{let c;k.add(v.onData(r=>{c?c=C.$be.concat([c,r],c.byteLength+r.byteLength):c=r;const o=c.indexOf(e.$wkb);if(o===-1)return;p(v),v.pauseData();const m=c.slice(o+e.$wkb.byteLength);m.byteLength&&y.onData.fire(m)})),k.add(v.onClose(r=>u(r??new Error("socket closed")))),k.add(v.onEnd(()=>u(new Error("socket ended"))))})}catch(p){throw v.dispose(),p}finally{k.dispose()}}e.$xkb=$;class E extends d.$Sc{constructor(R,I){super(),this.g=R,this.a=this.B(new T.$Qd),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new T.$Nd),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(w=>this.a.fire(w))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,I){L.SocketDiagnostics.traceSocketEvent(this,this.g,R,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$ykb=E}),define(De[65],Ce([1,0,8,5]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.RemoteAuthorityResolverErrorCode=e.$Qk=e.$Pk=e.RemoteConnectionType=e.$Ok=void 0,e.$Ok=(0,T.$Oh)("remoteAuthorityResolverService");var d;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(d||(e.RemoteConnectionType=d={}));class L{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$Pk=L;class A{constructor(I,w){this.host=I,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Qk=A;var $;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class E extends C.$bb{static isNotAvailable(I){return I instanceof E&&I._code===$.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof E&&I._code===$.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof E&&I._code===$.NoResolverFound}static isInvalidAuthority(I){return I instanceof E&&I._code===$.InvalidAuthority}static isHandled(I){return I instanceof E&&I.isHandled}constructor(I,w=$.Unknown,y){super(I),this._message=I,this._code=w,this._detail=y,this.isHandled=w===$.NotAvailable&&y===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Rk=E;function v(R){const I=R.indexOf("+");return I===-1?R:R.substring(0,I)}e.$Sk=v}),define(De[66],Ce([1,0,18]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=void 0;function T(v){return v.scheme===C.Schemas.vscodeRemote?v.authority:void 0}e.$Tk=T;function d(v){if(!v)return;const R=v.indexOf("+");return R<0?v:v.substr(0,R)}e.$Uk=d;function L(v){return`/${v.quality??"oss"}-${v.commit??"dev"}`}e.$Vk=L;function A(v){const{host:R,port:I}=E(v);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:I}}e.$Wk=A;function $(v,R){let{host:I,port:w}=E(v);return typeof w>"u"&&(w=R),{host:I,port:w}}e.$Xk=$;function E(v){const R=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const I=v.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const w=v.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:v,port:void 0}}}),define(De[25],Ce([1,0,15,5,66]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.TargetPlatform=e.ExtensionType=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=void 0,e.$Xl="extensions.user.cache",e.$Yl="extensions.builtin.cache",e.$Zl="undefined_publisher",e.$1l=["ui","workspace","web"];function L(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$2l=L,e.$3l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(A||(e.ExtensionType=A={}));var $;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class E{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,c){if(typeof u>"u"||u===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof u=="string"||typeof c=="string"){const r=typeof u=="string"?u:u.value,o=typeof c=="string"?c:c.value;return C.$2e(r,o)}return u._lower===c._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.$4l=E;class v{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const c of u)this.add(c)}add(u){this.c.add(E.toKey(u))}delete(u){return this.c.delete(E.toKey(u))}has(u){return this.c.has(E.toKey(u))}}e.$5l=v;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(E.toKey(u))}get(u){return this.c.get(E.toKey(u))}has(u){return this.c.has(E.toKey(u))}set(u,c){this.c.set(E.toKey(u),c)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$6l=R;function I(p){return w(p)}e.$7l=I;function w(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$8l=w;function y(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$9l=y;function k(p,u){if(u){const c=`onResolveRemoteAuthority:${(0,d.$Uk)(u)}`;return!!p.activationEvents?.includes(c)}return!1}e.$0l=k,e.$$l=(0,T.$Oh)("IBuiltinExtensionsScannerService")}),define(De[137],Ce([1,0,8,25]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RE=e.$QE=void 0;class d{constructor(){this.a=new Map,this.b=new WeakMap}register(A,$){this.a.set(A,$)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const $=Object.create(null);for(const E of A){const v=this.readActivationEvents(E);v.length>0&&($[T.$4l.toKey(E.identifier)]=v)}return $}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const $=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return $;for(const E in A.contributes){const v=this.a.get(E);if(!v)continue;const R=A.contributes[E],I=Array.isArray(R)?R:[R];try{v(I,$)}catch(w){(0,C.$1)(w)}}return $}}e.$QE=d,e.$RE=new d}),define(De[247],Ce([1,0,9,22,21,8,4,3,54,37,31,82,65,66]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.PersistentConnectionEventType=e.$5k=e.$4k=e.$3k=e.ConnectionType=void 0;const k=30*1e3;var p;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function u(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(G){const U=new d.$Xd;return setTimeout(()=>U.cancel(),G),U.token}function r(G,U){if(G.isCancellationRequested||U.isCancellationRequested)return d.CancellationToken.Cancelled;const q=new d.$Xd;return G.onCancellationRequested(()=>q.cancel()),U.onCancellationRequested(()=>q.cancel()),q.token}class o{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new $.$Rc,this.promise=new Promise((q,me)=>{this.f=q,this.g=me}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function m(G,U){const q=new o(U);return q.registerDisposable(G.onControlMessage(me=>{const ee=JSON.parse(me.toString()),ne=Q(ee);ne?q.reject(ne):q.resolve(ee)})),q.promise}function h(G,U,q,me,ee,ne,re,Ee){const ce=new o(Ee),de=v.$Jd.create(!1);return G.info(`Creating a socket (${re})...`),E.mark(`code/willCreateSocket/${ne}`),U.connect(q,me,ee,re).then(te=>{ce.didTimeout?(E.mark(`code/didCreateSocketError/${ne}`),G.info(`Creating a socket (${re}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),te?.dispose()):(E.mark(`code/didCreateSocketOK/${ne}`),G.info(`Creating a socket (${re}) was successful after ${de.elapsed()} ms.`),ce.resolve(te))},te=>{E.mark(`code/didCreateSocketError/${ne}`),G.info(`Creating a socket (${re}) returned an error after ${de.elapsed()} ms.`),G.error(te),ce.reject(te)}),ce.promise}function t(G,U){const q=new o(U);return G.then(me=>{q.didTimeout||q.resolve(me)},me=>{q.didTimeout||q.reject(me)}),q.promise}async function n(G,U,q,me){const ee=ae(G,U);G.logService.trace(`${ee} 1/6. invoking socketFactory.connect().`);let ne;try{ne=await h(G.logService,G.remoteSocketFactoryService,G.connectTo,(0,y.$Vk)(G),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,u(U),`renderer-${u(U)}-${G.reconnectionToken}`,me)}catch(te){throw G.logService.error(`${ee} socketFactory.connect() failed or timed out. Error:`),G.logService.error(te),te}G.logService.trace(`${ee} 2/6. socketFactory.connect() was successful.`);let re,Ee;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(ne,null),re=G.reconnectionProtocol,Ee=!1):(re=new I.$Ch({socket:ne}),Ee=!0),G.logService.trace(`${ee} 3/6. sending AuthRequest control message.`);const ce=await t(G.signService.createNewMessage((0,R.$eg)()),me),de={type:"auth",auth:G.connectionToken||"00000000000000000000",data:ce.data};re.sendControl(T.$be.fromString(JSON.stringify(de)));try{const te=await m(re,r(me,c(1e4)));if(te.type!=="sign"||typeof te.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(G.logService.trace(`${ee} 4/6. received SignRequest control message.`),!await t(G.signService.validate(ce,te.signedData),me)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const be=await t(G.signService.sign(te.data),me),Pe={type:"connectionType",commit:G.commit,signedData:be,desiredConnectionType:U};return q&&(Pe.args=q),G.logService.trace(`${ee} 5/6. sending ConnectionTypeRequest control message.`),re.sendControl(T.$be.fromString(JSON.stringify(Pe))),{protocol:re,ownsProtocol:Ee}}catch(te){throw te&&te.code==="ETIMEDOUT"&&(G.logService.error(`${ee} the handshake timed out. Error:`),G.logService.error(te)),te&&te.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${ee} received error control message when negotiating connection. Error:`),G.logService.error(te)),Ee&&Z(re),te}}async function a(G,U,q,me){const ee=Date.now(),ne=ae(G,U),{protocol:re,ownsProtocol:Ee}=await n(G,U,q,me),ce=new o(me);return ce.registerDisposable(re.onControlMessage(de=>{const te=JSON.parse(de.toString()),he=Q(te);he?(G.logService.error(`${ne} received error control message when negotiating connection. Error:`),G.logService.error(he),Ee&&Z(re),ce.reject(he)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${ne} 6/6. handshake finished, connection is up and running after ${we(ee)}!`),ce.resolve({protocol:re,firstMessage:te}))})),ce.promise}async function i(G,U){const{protocol:q}=await a(G,1,void 0,U);return{protocol:q}}async function s(G,U,q){const{protocol:me,firstMessage:ee}=await a(G,2,U,q),ne=ee&&ee.debugPort;return{protocol:me,debugPort:ne}}async function l(G,U,q){const me=Date.now(),ee=ae(G,3),{protocol:ne}=await n(G,3,U,q);return G.logService.trace(`${ee} 6/6. handshake finished, connection is up and running after ${we(me)}!`),ne}async function D(G,U,q){const{connectTo:me,connectionToken:ee}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:me,connectionToken:ee,reconnectionToken:U,reconnectionProtocol:q,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function S(G,U,q){return f(G,async me=>{const{protocol:ee}=await i(me,d.CancellationToken.None);return new V(G,U,q,me.reconnectionToken,ee)})}e.$3k=S;async function b(G,U){return f(G,async q=>{const{protocol:me,debugPort:ee}=await s(q,U,d.CancellationToken.None);return new fe(G,U,q.reconnectionToken,me,ee)})}e.$4k=b;async function f(G,U){for(let me=1;;me++)try{const ee=(0,R.$eg)(),ne=await D(G,ee,null);return await U(ne)}catch(ee){if(me<5)G.logService.error(`[remote-connection][attempt ${me}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(ee);else throw G.logService.error(`[remote-connection][attempt ${me}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(ee),K.triggerPermanentFailure(0,0,w.$Rk.isHandled(ee)),ee}}async function g(G,U,q){const me=await D(G,(0,R.$eg)(),null);return await l(me,{host:U,port:q},d.CancellationToken.None)}e.$5k=g;function P(G){return(0,C.$Hg)(U=>new Promise((q,me)=>{const ee=setTimeout(q,G*1e3);U.onCancellationRequested(()=>{clearTimeout(ee),q()})}))}var N;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class O{constructor(U,q){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.type=0}}e.$6k=O;class M{constructor(U,q,me,ee){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.durationSeconds=me,this.c=ee,this.type=1}skipWait(){this.c.cancel()}}e.$7k=M;class j{constructor(U,q,me){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.attempt=me,this.type=2}}e.$8k=j;class z{constructor(U,q,me){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.attempt=me,this.type=4}}e.$9k=z;class F{constructor(U,q,me,ee){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.attempt=me,this.handled=ee,this.type=3}}e.$0k=F;class K extends $.$Sc{static triggerPermanentFailure(U,q,me){this._permanentFailure=!0,this.f=U,this.g=q,this.h=me,this.j.forEach(ee=>ee.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||K._permanentFailure}constructor(U,q,me,ee,ne){super(),this.t=U,this.u=q,this.reconnectionToken=me,this.protocol=ee,this.w=ne,this.m=this.B(new A.$Nd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(ee.onSocketClose(re=>{const Ee=x(this.t,this.reconnectionToken,!0);re?re.type===0?(this.u.logService.info(`${Ee} received socket close event (hadError: ${re.hadError}).`),re.error&&this.u.logService.error(re.error)):(this.u.logService.info(`${Ee} received socket close event (wasClean: ${re.wasClean}, code: ${re.code}, reason: ${re.reason}).`),re.event&&this.u.logService.error(re.event)):this.u.logService.info(`${Ee} received socket close event.`),this.y()})),this.B(ee.onSocketTimeout(re=>{const Ee=x(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Ee} received socket timeout event (unacknowledgedMsgCount: ${re.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${re.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${re.timeSinceLastReceivedSomeData}).`),this.y()})),K.j.push(this),this.B((0,$.$Qc)(()=>{const re=K.j.indexOf(this);re>=0&&K.j.splice(re,1)})),this.n&&this.D(K.f,K.g,K.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=x(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const q=[0,5,5,10,10,10,10,10,30];let me=-1;do{me++;const ee=me<q.length?q[me]:q[q.length-1];try{if(ee>0){const re=P(ee);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ee,re)),this.u.logService.info(`${U} waiting for ${ee} seconds before reconnecting...`);try{await re}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),me+1)),this.u.logService.info(`${U} resolving connection...`);const ne=await D(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${ne.connectTo}...`),await this.G(ne,c(k)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),me+1));break}catch(ne){if(ne.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ne),this.C(this.protocol.getMillisSinceLastIncomingData(),me+1,!1);break}if(me>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ne),this.C(this.protocol.getMillisSinceLastIncomingData(),me+1,!1);break}if(w.$Rk.isTemporarilyNotAvailable(ne)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ne);continue}if((ne.code==="ETIMEDOUT"||ne.code==="ENETUNREACH"||ne.code==="ECONNREFUSED"||ne.code==="ECONNRESET")&&ne.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ne);continue}if((0,L.$4)(ne)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ne);continue}if(ne instanceof w.$Rk){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ne),this.C(this.protocol.getMillisSinceLastIncomingData(),me+1,w.$Rk.isHandled(ne));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ne),this.C(this.protocol.getMillisSinceLastIncomingData(),me+1,!1);break}}while(!this.n&&!this.s)}C(U,q,me){this.w?K.triggerPermanentFailure(U,q,me):this.D(U,q,me)}D(U,q,me){this.m.fire(new F(this.reconnectionToken,U,q,me)),Z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$$k=K;class V extends K{constructor(U,q,me,ee,ne){super(1,U,ee,ne,!0),this.client=this.B(new I.$Ah(ne,{remoteAuthority:q,clientId:me},U.ipcLogger))}async G(U,q){await i(U,q)}}e.$_k=V;class fe extends K{constructor(U,q,me,ee,ne){super(2,U,me,ee,!1),this.H=q,this.debugPort=ne}async G(U,q){await s(U,this.H,q)}}e.$al=fe;function Z(G){try{G.acceptDisconnect();const U=G.getSocket();G.dispose(),U.dispose()}catch(U){(0,L.$1)(U)}}function Q(G){if(G&&G.type==="error"){const U=new Error(`Connection error: ${G.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function X(G,U){for(;G.length<U;)G+=" ";return G}function oe(G,U){return`[remote-connection][${X(u(G),13)}][${U.substr(0,5)}\u2026]`}function x(G,U,q){return`${oe(G,U)}[${q?"reconnect":"initial"}]`}function ae(G,U){return`${x(U,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function we(G){return`${Date.now()-G} ms`}}),define(De[248],Ce([1,0,3,5]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=void 0,e.$Yk=(0,T.$Oh)("remoteSocketFactoryService");class d{constructor(){this.a={}}register(A,$){return this.a[A]??=[],this.a[A].push($),(0,C.$Qc)(()=>{const E=this.a[A]?.indexOf($);typeof E=="number"&&E>=0&&this.a[A]?.splice(E,1)})}b(A){return(this.a[A.type]||[]).find(E=>E.supports(A))}connect(A,$,E,v){const R=this.b(A);if(!R)throw new Error(`No socket factory found for ${A}`);return R.connect(A,$,E,v)}}e.$Zk=d}),define(De[249],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d3b=void 0;class C{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(d){try{const L=await this.c();if(L){const A=String(C.a++);return this.b.set(A,L),{id:A,data:L.createNewMessage(d)}}}catch{}return{id:"",data:d}}async validate(d,L){if(!d.id)return!0;const A=this.b.get(d.id);if(!A)return!1;this.b.delete(d.id);try{return A.validate(L)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(d){try{return await this.d(d)}catch{}return d}}e.$d3b=C}),define(De[106],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=void 0,e.$1k="signService",e.$2k=(0,C.$Oh)(e.$1k)}),define(De[138],Ce([1,0,249]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$77b=void 0;class T extends C.$d3b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(A=>new A.signer().sign(L))}h(){return new Promise((L,A)=>$e(["vsda"],L,A))}}e.$77b=T}),define(De[250],Ce([1,0,12,48,31]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=void 0;function L(E){if(C.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function A(E,v,R,I,w,y,k,p){const u=Object.create(null);u["common.machineId"]=y,u.sessionID=(0,d.$eg)()+Date.now(),u.commitHash=I,u.version=w,u["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,C.$i)(C.$u),u["common.nodePlatform"]=T.$dc,u["common.nodeArch"]=R,u["common.product"]=p||"desktop",k&&(u["common.msftInternal"]=k);let c=0;const r=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),C.$m&&(u["common.snap"]="true");const o=L(v);return o&&(u["common.platformDetail"]=o),u}e.$fo=A;function $(E){const v=T.env.USERDNSDOMAIN;if(!v)return!1;const R=v.toLowerCase();return E.some(I=>R===I)}e.$go=$}),define(De[251],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=void 0,e.$bl=(0,C.$Oh)("telemetryService"),e.$cl=(0,C.$Oh)("customEndpointTelemetryService"),e.$dl="telemetry.currentSessionDate",e.$el="telemetry.firstSessionDate",e.$fl="telemetry.lastSessionDate",e.$gl="telemetry.machineId",e.$hl="telemetry",e.$il="telemetry.telemetryLevel",e.$jl="telemetry.enableCrashReporter",e.$kl="telemetry.enableTelemetry";var T;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var d;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(d||(e.TelemetryConfiguration=d={}))}),define(De[85],Ce([1,0,24,17,4,50,66,250,251]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=void 0;class v{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$ho=v;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$io=R,e.$jo=new R;class I{async publicLog(s,l,D){}async publicLogError(s,l,D){}}e.$ko=I,e.$lo="telemetry",e.$mo="extensionTelemetryLog",e.$no={log:()=>null,flush:()=>Promise.resolve(null)};function w(i,s){return d.Event.debounce(s.onDidChangeConfiguration,(D,S)=>{const b=D?new Set([...D.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:b}},1e3,!0)(D=>{D.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,L.$li)(D.source),configurationKeys:Array.from(D.affectedKeys)})})}e.$oo=w;function y(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry)}e.$po=y;function k(i,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$qo=k;function p(i){const s=i.getValue(E.$il),l=i.getValue(E.$jl);if(i.getValue(E.$kl)===!1||l===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$ro=p;function u(i){const s={},l={},D={};o(i,D);for(let S in D){S=S.length>150?S.substr(S.length-149):S;const b=D[S];typeof b=="number"?l[S]=b:typeof b=="boolean"?l[S]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${b.length}`),s[S]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(s[S]=b)}return{properties:s,measurements:l}}e.$so=u;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(i){if(!i)return"none";const s=(0,A.$Uk)(i);return c.has(s)?s:"other"}e.$to=r;function o(i,s,l=0,D){if(i)for(const S of Object.getOwnPropertyNames(i)){const b=i[S],f=D?D+S:S;Array.isArray(b)?s[f]=(0,C.$9m)(b):b instanceof Date?s[f]=b.toISOString():(0,T.$Af)(b)?l<2?o(b,s,l+1,f+"."):s[f]=(0,C.$9m)(b):s[f]=b}}function m(i,s){const l=i.msftInternalDomains||[],D=s.getValue("telemetry.internalTesting");return(0,$.$go)(l)||D}e.$uo=m;function h(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$vo=h;function t(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let l=i;const D=[];for(const g of s)for(;;){const P=g.exec(i);if(!P)break;D.push([P.index,g.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(l="";;){const g=b.exec(i);if(!g)break;const P=D.some(([N,O])=>g.index<O&&N<b.lastIndex);!S.test(g[0])&&!P&&(l+=i.substring(f,g.index)+"<REDACTED: user-file-path>",f=b.lastIndex)}return f<i.length&&(l+=i.substr(f)),l}function n(i){if(!i)return i;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of s)if(l.regex.test(i))return`<REDACTED: ${l.label}>`;return i}function a(i,s){return(0,C.$6m)(i,l=>{if(l instanceof v||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let D=l.replaceAll("%20"," ");D=t(D,s);for(const S of s)D=D.replace(S,"");return D=n(D),D}})}e.$wo=a}),define(De[252],Ce([1,0,15,132,25,12,2,8,48,85]),function($e,e,C,T,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=void 0;function R(a,i){return a.uuid&&i.uuid?a.uuid===i.uuid:a.id===i.id?!0:(0,C.$We)(a.id,i.id)===0}e.$xo=R;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(i){const s=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new w(i.identifier,s,l)}static parse(i){const s=I.exec(i);return s&&s[1]&&s[2]?new w({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,l="undefined"){this.version=s,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof w?R(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$yo=w;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(a){const i=y.exec(a);return i&&i[1]?[u(i[1]),i[2]]:[u(a),void 0]}e.$zo=k;function p(a,i){return`${a}.${i}`}e.$Ao=p;function u(a){return a.toLowerCase()}e.$Bo=u;function c(a,i){return u(p(a??d.$Zl,i))}e.$Co=c;function r(a,i){const s=[],l=D=>{for(const S of s)if(S.some(b=>R(i(b),i(D))))return S;return null};for(const D of a){const S=l(D);S?S.push(D):s.push([D])}return s}e.$Do=r;function o(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.$Eo=o;function m(a){return{id:new v.$ho(a.identifier.id),name:new v.$ho(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Fo=m,e.$Go=new d.$4l("pprice.better-merge");function h(a,i){const s=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const D=l.shift();if(D&&s.every(S=>!R(S.identifier,{id:D}))){const S=a.filter(b=>R(b.identifier,{id:D}));S.length===1&&(s.push(S[0]),l.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$Ho=h;async function t(a,i){if(!L.$l)return!1;let s;try{s=(await a.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await a.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){i.debug("Error while getting the os-release file.",(0,$.$0)(D))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(a,i){const s=await t(a,i),l=(0,T.$3n)(s?"alpine":L.$u,E.$ec);return i.debug("ComputeTargetPlatform:",l),l}e.$Io=n}),define(De[253],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.$lr=e.$kr=e.$jr=e.$ir=void 0;function C(E){return[...E.entries()]}e.$ir=C;function T(E){return E?[...E.entries()]:[]}e.$jr=T;function d(E){return new Map(E)}e.$kr=d;function L(E){return new Map(E??[])}e.$lr=L;function A(E){return Array.from(E.entries()).map(v=>[v[0],C(v[1].map),T(v[1].descriptionMap)])}e.$mr=A;function $(E){return new Map(E.map(v=>[v[0],{map:d(v[1]),descriptionMap:L(v[2])}]))}e.$nr=$}),define(De[254],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkb=void 0;class C{constructor(d){this.b=d,this.a=new Map}dispose(){for(const d of this.a.values())d.dispose()}startBuffering(d,L,A=5){const $=L(E=>{const v=typeof E=="string"?E:E.data;let R=this.a.get(d);if(R){R.data.push(v);return}const I=setTimeout(()=>this.flushBuffer(d),A);R={data:[v],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(d),$.dispose()}},this.a.set(d,R)});return $}stopBuffering(d){this.a.get(d)?.dispose()}flushBuffer(d){const L=this.a.get(d);L&&(this.a.delete(d),this.b(d,L.data.join("")))}}e.$Pkb=C}),define(De[255],Ce([1,0,9,79,59,4,17,2,199,105,43]),function($e,e,C,T,d,L,A,$,E,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9v=e.$8v=e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.IconFontDefinition=e.IconContribution=e.$1v=void 0,e.$1v={IconContribution:"base.contributions.icons"};var I;(function(m){function h(t,n){let a=t.defaults;for(;d.ThemeIcon.isThemeIcon(a);){const i=k.getIcon(a.id);if(!i)return;a=i.defaults}return a}m.getDefinition=h})(I||(e.IconContribution=I={}));var w;(function(m){function h(n){return{weight:n.weight,style:n.style,src:n.src.map(a=>({format:a.format,location:a.location.toString()}))}}m.toJSONObject=h;function t(n){const a=i=>(0,A.$yf)(i)?i:void 0;if(n&&Array.isArray(n.src)&&n.src.every(i=>(0,A.$yf)(i.format)&&(0,A.$yf)(i.location)))return{weight:a(n.weight),style:a(n.style),src:n.src.map(i=>({format:i.format,location:$.URI.parse(i.location)}))}}m.fromJSONObject=t})(w||(e.IconFontDefinition=w={}));class y{constructor(){this.a=new L.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${d.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,t,n,a){const i=this.b[h];if(i){if(n&&!i.description){i.description=n,this.d.properties[h].markdownDescription=`${n} $(${h})`;const D=this.e.enum.indexOf(h);D!==-1&&(this.e.enumDescriptions[D]=n),this.a.fire()}return i}const s={id:h,description:n,defaults:t,deprecationMessage:a};this.b[h]=s;const l={$ref:"#/definitions/icons"};return a&&(l.deprecationMessage=a),n&&(l.markdownDescription=`${n}: $(${h})`),this.d.properties[h]=l,this.e.enum.push(h),this.e.enumDescriptions.push(n||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const t=this.e.enum.indexOf(h);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,t){const n=this.f[h];return n||(this.f[h]=t,this.a.fire(),t)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(i,s)=>i.id.localeCompare(s.id),t=i=>{for(;d.ThemeIcon.isThemeIcon(i.defaults);)i=this.b[i.defaults.id];return`codicon codicon-${i?i.id:""}`},n=[];n.push("| preview     | identifier                        | default codicon ID                | description"),n.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(i=>this.b[i]);for(const i of a.filter(s=>!!s.description).sort(h))n.push(`|<i class="${t(i)}"></i>|${i.id}|${d.ThemeIcon.isThemeIcon(i.defaults)?i.defaults.id:i.id}|${i.description||""}|`);n.push("| preview     | identifier                        "),n.push("| ----------- | --------------------------------- |");for(const i of a.filter(s=>!d.ThemeIcon.isThemeIcon(s.defaults)).sort(h))n.push(`|<i class="${t(i)}"></i>|${i.id}|`);return n.join(`
`)}}const k=new y;R.$dn.add(e.$1v.IconContribution,k);function p(m,h,t,n){return k.registerIcon(m,h,t,n)}e.$2v=p;function u(){return k}e.$3v=u;function c(){const m=(0,T.$Rj)();for(const h in m){const t="\\"+m[h].toString(16);k.registerIcon(h,{fontCharacter:t})}}c(),e.$4v="vscode://schemas/icons";const r=R.$dn.as(v.$en.JSONContribution);r.registerSchema(e.$4v,k.getIconSchema());const o=new C.$6g(()=>r.notifySchemaChanged(e.$4v),200);k.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$5v=p("widget-close",T.$Tj.close,(0,E.localize)(2,null)),e.$6v=p("goto-previous-location",T.$Tj.arrowUp,(0,E.localize)(3,null)),e.$7v=p("goto-next-location",T.$Tj.arrowDown,(0,E.localize)(4,null)),e.$8v=d.ThemeIcon.modify(T.$Tj.sync,"spin"),e.$9v=d.ThemeIcon.modify(T.$Tj.loading,"spin")}),define(De[86],Ce([1,0,4,50,5,14]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dv=e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.ProvidedOnAutoForward=e.$8u=e.TunnelPrivacyId=e.TunnelProtocol=e.$7u=e.$6u=void 0,e.$6u=(0,d.$Oh)("tunnelService"),e.$7u=(0,d.$Oh)("sharedTunnelsService");var A;(function(u){u.Http="http",u.Https="https"})(A||(e.TunnelProtocol=A={}));var $;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})($||(e.TunnelPrivacyId=$={}));function E(u){return!!u.forwardPort}e.$8u=E;var v;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(v||(e.ProvidedOnAutoForward=v={}));function R(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(c)return{address:c[1],port:+c[2]}}e.$9u=R,e.$0u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(u){return e.$0u.indexOf(u)>=0}e.$$u=I,e.$_u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(u){return e.$_u.indexOf(u)>=0}e.$av=w;function y(u,c,r,o){if(r===1)return!1;if(r===2&&w(c)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(m?.length===4&&parseInt(m[1])>=18)return!1}return u<1024}e.$bv=y;class k{constructor(c,r,o){this.remoteAddress=c,this.localAddress=r,this.b=o,this.a=new C.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$cv=k;let p=class{constructor(c,r){this.j=c,this.k=r,this.a=new C.$Nd,this.onTunnelOpened=this.a.event,this.b=new C.$Nd,this.onTunnelClosed=this.b.event,this.c=new C.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const c=this.k.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.f=c,c?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.g=c.elevation,this.h=c.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const c=[],r=Array.from(this.e.values());for(const o of r){const m=Array.from(o.values());for(const h of m){const t=await h.value;t&&typeof t!="string"&&c.push(t)}}return c}async dispose(){for(const c of this.e.values()){for(const{value:r}of c.values())await r.then(o=>typeof o!="string"?o?.dispose():void 0);c.clear()}this.e.clear()}setEnvironmentTunnel(c,r,o,m,h){this.p(c,r,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:r,localAddress:o,privacy:m,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,r){(w(c)||I(c))&&(c=e.$0u[0]);const o=this.r(c,r);if(o)return++o.refcount,o.value}openTunnel(c,r,o,m,h,t=!1,n,a){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${o} on local port ${h}.`);const i=this.f??c;if(!i)return;if(r||(r="localhost"),m||(m=this.l),this.f&&this.i.has(o)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.s(i,r,o,m,h,t,n,a);return s?s.then(l=>{if(l){if(typeof l=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(r,o),l}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(r,o);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.n(l);return(l.tunnelRemoteHost!==r||l.tunnelRemotePort!==o)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&l.privacy!==n&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}n(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const r=this.e.get(c.tunnelRemoteHost);if(r){const o=r.get(c.tunnelRemotePort);o&&(o.refcount--,await this.o(c.tunnelRemoteHost,c.tunnelRemotePort,o))}}}}async o(c,r,o){if(o.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${r}.`);const m=o.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(c)&&this.e.get(c).delete(r),m}}async closeTunnel(c,r){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${r} `);const o=this.e.get(c);if(o&&o.has(r)){const m=o.get(r);m.refcount=0,await this.o(c,r,m)}}p(c,r,o){this.e.has(c)||this.e.set(c,new Map),this.e.get(c).set(r,{refcount:1,value:o})}async q(c,r){const o=this.e.get(c);if(o){const m=o.get(r),h=m?await m.value:void 0;(!h||typeof h=="string")&&o.delete(r),o.size===0&&this.e.delete(c)}}r(c,r){const o=[c];I(c)?(o.push(...e.$0u),o.push(...e.$_u)):w(c)&&o.push(...e.$_u);const m=o.map(h=>this.e.get(h));for(const h of m){const t=h?.get(r);if(t)return t}}canTunnel(c){return!!R(c)}t(c,r,o,m,h,t,n){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${o} on local port ${m}.`);const a=o;this.i.add(a);const i=m===void 0?o:m,s={elevationRequired:h?this.isPortPrivileged(i):!1},l={remoteAddress:{host:r,port:o},localAddressPort:m,privacy:t,public:t?t!==$.Private:void 0,protocol:n},D=c.forwardPort(l,s);return D?(this.p(r,o,D),D.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(a)})):this.i.delete(a),D}};e.$dv=p,e.$dv=p=He([Be(0,L.$9i),Be(1,T.$ii)],p)}),define(De[256],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=void 0,e.$Hk=(0,C.$Oh)("IUriIdentityService")}),define(De[257],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ev=void 0,e.$ev=(0,C.$Oh)("editSessionIdentityService");var T;(function(d){d[d.Complete=100]="Complete",d[d.Partial=50]="Partial",d[d.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(De[258],Ce([1,0,18]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=void 0;function T(E){return E.scheme!==C.Schemas.file&&E.scheme!==C.Schemas.vscodeRemote}e.$LJ=T;function d(E){if(E.folders.length)return E.folders.every(v=>T(v.uri))?E.folders[0].uri:void 0;if(E.configuration&&T(E.configuration))return E.configuration}e.$MJ=d;function L(E){return d(E)?.scheme}e.$NJ=L;function A(E){return d(E)?.authority}e.$OJ=A;function $(E){return d(E)!==void 0}e.$PJ=$}),define(De[44],Ce([1,0,201,16,78,23,2,5,18]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.WorkbenchState=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=void 0,e.$Xh=(0,$.$Oh)("contextService");function v(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}e.$Yh=v;function R(i){return typeof i?.id=="string"&&!v(i)&&!w(i)}e.$Zh=R,e.$1h={id:"ext-dev"},e.$2h={id:"empty-window"};function I(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,T.$nc)(i)}:s?e.$1h:e.$2h;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$3h=I;function w(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}e.$4h=w;function y(i){const s=i;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:A.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}e.$5h=y;var k;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(k||(e.WorkbenchState=k={}));function p(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$6h=p;function u(i){const s=i;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$7h=u;class c{constructor(s,l,D,S,b){this.h=s,this.j=D,this.k=S,this.l=b,this.c=d.$Uh.forUris(this.l,()=>!0),this.folders=l}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=d.$Uh.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$8h=c;class r{constructor(s,l){this.raw=l,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,L.$vg)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$9h=r;function o(i){return new r({uri:i,index:0,name:(0,L.$rg)(i)},{uri:i.toString()})}e.$0h=o,e.$$h="code-workspace",e.$_h=`.${e.$$h}`,e.$ai=[{name:(0,C.localize)(0,null),extensions:[e.$$h]}],e.$bi="workspace.json";function m(i,s){return L.$mg.isEqualOrParent(i,s.untitledWorkspacesHome)}e.$ci=m;function h(i){let s;return A.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===E.Schemas.tmp}e.$di=h,e.$ei="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$ei}e.$fi=t;function n(i,s){return!m(i,s)&&!h(i)}e.$gi=n;function a(i){return(typeof i=="string"?(0,T.$oc)(i):(0,L.$tg)(i))===e.$_h}e.$hi=a}),define(De[259],Ce([1,0,52,4,3,23,2,200,131,30,5,14,44,28,256,9,31,15,17]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.ProfileResourceType=void 0;var o;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(o||(e.ProfileResourceType=o={}));function m(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}e.$Ik=m,e.$Jk=(0,R.$Oh)("IUserDataProfilesService");function h(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:s}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Kk=h;function t(i,s,l,D,S,b){return{id:i,name:s,location:l,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:b&&S?.useDefaultFlags?.globalState?b.globalStorageHome:(0,L.$vg)(l,"globalStorage"),settingsResource:b&&S?.useDefaultFlags?.settings?b.settingsResource:(0,L.$vg)(l,"settings.json"),keybindingsResource:b&&S?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,L.$vg)(l,"keybindings.json"),tasksResource:b&&S?.useDefaultFlags?.tasks?b.tasksResource:(0,L.$vg)(l,"tasks.json"),snippetsHome:b&&S?.useDefaultFlags?.snippets?b.snippetsHome:(0,L.$vg)(l,"snippets"),extensionsResource:b&&S?.useDefaultFlags?.extensions?b.extensionsResource:(0,L.$vg)(l,"extensions.json"),cacheHome:(0,L.$vg)(D,i),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}e.$Lk=t;let n=class extends d.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,l,D,S){super(),this.t=s,this.u=l,this.w=D,this.y=S,this.f=!0,this.h=this.B(new T.$Nd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new T.$Nd),this.onWillCreateProfile=this.j.event,this.m=this.B(new T.$Nd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new T.$Nd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$Ac,emptyWindows:new Map},this.profilesHome=(0,L.$vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),l=[s];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,r.$yf)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}l.push(t((0,L.$sg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},s))}}catch(b){this.y.error(b)}const D=new y.$Ac,S=new Map;if(l.length)try{const b=this.Q();if(b.workspaces)for(const[f,g]of Object.entries(b.workspaces)){const P=A.URI.parse(f),N=l.find(O=>O.id===g);N&&D.set(P,N)}if(b.emptyWindows)for(const[f,g]of Object.entries(b.emptyWindows)){const P=l.find(N=>N.id===g);P&&S.set(f,P)}}catch(b){this.y.error(b)}this.z={profiles:l,workspaces:D,emptyWindows:S}}return this.z}D(){const s=t("__default__profile__",(0,$.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const l="Temp",D=new RegExp(`${(0,c.$Fe)(l)}\\s(\\d+)`);let S=0;for(const f of this.profiles){const g=D.exec(f.name),P=g?parseInt(g[1]):0;S=P>S?P:S}const b=`${l} ${S+1}`;return this.createProfile((0,C.$Ci)((0,u.$eg)()).toString(16),b,{transient:!0},s)}async createNamedProfile(s,l,D){return this.createProfile((0,C.$Ci)((0,u.$eg)()).toString(16),s,l,D)}async createProfile(s,l,D,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(s,l,D);return S&&await this.setProfileForWorkspace(S,b),b}async F(s,l,D){if(!(0,r.$yf)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(l);return S||(S=(async()=>{try{const b=this.profiles.find(P=>P.name===l||P.id===s);if(b)return b;const f=t(s,l,(0,L.$vg)(this.profilesHome,s),this.g,D,this.defaultProfile);await this.u.createFolder(f.location);const g=[];return this.j.fire({profile:f,join(P){g.push(P)}}),await p.Promises.settled(g),this.I([f],[],[]),f}finally{this.r.delete(l)}})(),this.r.set(l,S)),S}async updateProfile(s,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(S=>S.id===s.id);if(!D)throw new Error(`Profile '${s.name}' does not exist`);return D=t(D.id,l.name??D.name,D.location,this.g,{shortName:l.shortName??D.shortName,icon:l.icon===null?void 0:l.icon??D.icon,transient:l.transient??D.isTransient,useDefaultFlags:l.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(S=>S.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);const D=[];this.m.fire({profile:l,join(S){D.push(S)}});try{await Promise.allSettled(D)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(S){(0,v.$ok)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(s,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(S=>S.id===l.id);if(!D)throw new Error(`Profile '${l.name}' does not exist`);this.L(s,D)}unsetWorkspace(s,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(l=>l.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(s.map(l=>this.removeProfile(l)))}getProfileForWorkspace(s){const l=this.G(s);return A.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(s){return(0,w.$Yh)(s)?s.uri:(0,w.$4h)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,s.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,s.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,s.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,s.location)))}I(s,l,D){const S=[...this.profiles,...s],b=[];this.s.profiles=[];for(let f of S)f.isDefault||l.some(g=>f.id===g.id)||(f=D.find(g=>f.id===g.id)??f,f.isTransient?this.s.profiles.push(f):b.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P(b),this.z=void 0,this.J(s,l,D)}J(s,l,D){this.h.fire({added:s,removed:l,updated:D,all:this.profiles})}L(s,l,D){D=l?.isTransient?!0:D,D||this.L(s,void 0,!0);const S=this.G(s),b=D?this.s:this.C;A.URI.isUri(S)?(b.workspaces.delete(S),l&&b.workspaces.set(S,l)):(b.emptyWindows.delete(S),l&&b.emptyWindows.set(S,l)),D||this.M()}M(){const s={};for(const[D,S]of this.C.workspaces.entries())s[D.toString()]=S.id;const l={};for(const[D,S]of this.C.emptyWindows.entries())l[D.toString()]=S.id;this.R({workspaces:s,emptyWindows:l}),this.z=void 0}N(s){const l={},D=this.D();if(s.workspaces)for(const[b,f]of Object.entries(s.workspaces)){const g=A.URI.parse(f);l[b]=this.w.extUri.isEqual(g,D.location)?D.id:this.w.extUri.basename(g)}const S={};if(s.emptyWindows)for(const[b,f]of Object.entries(s.emptyWindows)){const g=A.URI.parse(f);S[b]=this.w.extUri.isEqual(g,D.location)?D.id:this.w.extUri.basename(g)}return{workspaces:l,emptyWindows:S}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Mk=n,e.$Mk=n=He([Be(0,E.$Vh),Be(1,v.$0j),Be(2,k.$Hk),Be(3,I.$9i)],n);class a extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Nk=a}),define(De[260],Ce([1,0,9,4,3,54,17,184,5,259]),function($e,e,C,T,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$4o=e.$3o=e.$2o=void 0,e.$2o="__$__isNewStorageMarker",e.$3o="__$__targetStorageMarker",e.$4o=(0,E.$Oh)("storageService");var R;(function(r){r[r.NONE=0]="NONE",r[r.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var I;(function(r){r[r.APPLICATION=-1]="APPLICATION",r[r.PROFILE=0]="PROFILE",r[r.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var w;(function(r){r[r.USER=0]="USER",r[r.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function y(r){const o=r.get(e.$3o);if(o)try{return JSON.parse(o)}catch{}return Object.create(null)}e.$5o=y;class k extends d.$Sc{static{this.a=60*1e3}constructor(o={flushInterval:k.a}){super(),this.m=o,this.b=this.B(new T.$Qd),this.c=this.B(new T.$Qd),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.$Nd),this.onWillSaveState=this.f.event,this.h=this.B(new C.$6g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new d.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(o,m,h){return T.Event.filter(this.b.event,t=>t.scope===o&&(m===void 0||t.key===m),h)}n(){this.j.value=(0,C.$0g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,d.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(o,m){const{key:h,external:t}=m;if(h===e.$3o){switch(o){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:o})}else this.b.fire({scope:o,key:h,target:this.J(o)[h],external:t})}w(o){this.f.fire({reason:o})}get(o,m,h){return this.P(m)?.get(o,h)}getBoolean(o,m,h){return this.P(m)?.getBoolean(o,h)}getNumber(o,m,h){return this.P(m)?.getNumber(o,h)}getObject(o,m,h){return this.P(m)?.getObject(o,h)}storeAll(o,m){this.y(()=>{for(const h of o)this.store(h.key,h.value,h.scope,h.target,m)})}store(o,m,h,t,n=!1){if((0,A.$Hf)(m)){this.remove(o,h,n);return}this.y(()=>{this.z(o,h,t),this.P(h)?.set(o,m,n)})}remove(o,m,h=!1){this.y(()=>{this.z(o,m,void 0),this.P(m)?.delete(o,h)})}y(o){this.b.pause(),this.c.pause();try{o()}finally{this.b.resume(),this.c.resume()}}keys(o,m){const h=[],t=this.J(o);for(const n of Object.keys(t))t[n]===m&&h.push(n);return h}z(o,m,h,t=!1){const n=this.J(m);typeof h=="number"?n[o]!==h&&(n[o]=h,this.P(m)?.set(e.$3o,JSON.stringify(n),t)):typeof n[o]=="number"&&(delete n[o],this.P(m)?.set(e.$3o,JSON.stringify(n),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(o){switch(o){case-1:return this.I;case 0:return this.G;default:return this.D}}L(o){const m=this.P(o);return m?y(m):Object.create(null)}isNew(o){return this.getBoolean(e.$2o,o)===!0}async flush(o=R.NONE){this.f.fire({reason:o});const m=this.P(-1),h=this.P(0),t=this.P(1);switch(o){case R.NONE:await C.Promises.settled([m?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await C.Promises.settled([m?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const o=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return c(o,m,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(o){return await this.flush(),this.P(o)?.optimize()}async switch(o,m){return this.w(R.NONE),(0,v.$Ik)(o)?this.R(o,m):this.S(o,m)}M(o,m){return!(o.id===m.id||p(m)&&p(o))}N(o,m,h){this.y(()=>{const t=new Set;for(const[n,a]of o)t.add(n),m.get(n)!==a&&this.u(h,{key:n,external:!0});for(const[n]of m.items)t.has(n)||this.u(h,{key:n,external:!0})})}}e.$6o=k;function p(r){return r.isDefault||!!r.useDefaultFlags?.globalState}e.$7o=p;class u extends k{constructor(){super(),this.U=this.B(new $.$Zo(new $.$1o,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new $.$Zo(new $.$1o,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new $.$Zo(new $.$1o,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(o=>this.u(1,o))),this.B(this.W.onDidChangeStorage(o=>this.u(0,o))),this.B(this.U.onDidChangeStorage(o=>this.u(-1,o)))}P(o){switch(o){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(o){switch(o){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(o){return!1}}e.$8o=u;async function c(r,o,m,h,t,n){const a=P=>{try{return JSON.parse(P)}catch{return P}},i=new Map,s=new Map;r.forEach((P,N)=>{i.set(N,P),s.set(N,a(P))});const l=new Map,D=new Map;o.forEach((P,N)=>{l.set(N,P),D.set(N,a(P))});const S=new Map,b=new Map;m.forEach((P,N)=>{S.set(N,P),b.set(N,a(P))}),console.group(h!==t?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const f=[];if(i.forEach((P,N)=>{f.push({key:N,value:P})}),console.table(f),console.groupEnd(),console.log(s),h!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];l.forEach((N,O)=>{P.push({key:O,value:N})}),console.table(P),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${n})`);const g=[];S.forEach((P,N)=>{g.push({key:N,value:P})}),console.table(g),console.groupEnd(),console.log(b)}e.$9o=c}),define(De[107],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;class C{static{this.a=!1}constructor(d){this.d=d,this.b=new Map,this.c=1}add(d){const L=this.c++;return this.b.set(L,d),this.e(),L}get(d,L){return this.b.has(d)?this.b.get(d)[L]:void 0}delete(d){this.b.delete(d),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Rbc=C}),define(De[55],Ce([1,0,18,23,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=e.$Tbc=void 0;class L{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new T.$kg($=>{const E=this.b.get($.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos($,E){E===null?this.b.delete($.scheme):this.b.set($.scheme,E)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$Tbc=L,e.$Ubc=(0,d.$Oh)("IExtHostFileSystemInfo")}),define(De[27],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=void 0,e.$tM=(0,C.$Oh)("IExtHostInitDataService")}),define(De[261],Ce([1,0,206,14,241,27]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;let A=class extends d.$AN{constructor(E,v,R){const I=R.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",w=R.remote.isRemote?(0,C.localize)(0,null):E?(0,C.localize)(1,null):(0,C.localize)(2,null);super(v.createLogger(I,{name:w}))}};e.$3dc=A,e.$3dc=A=He([Be(1,T.$0i),Be(2,L.$tM)],A)}),define(De[262],Ce([1,0,9]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=e.$kcc=void 0;class T{constructor(A,$,E){this.h=new Map,this.a=A,this.b=$,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(v=>(this.f=v,this)),this.g=this.c.onDidChangeStorage(v=>{v.shared===this.b&&v.key===this.a&&(this.f=v.value)}),this.i=new C.$6g(()=>{const v=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of v.values())R.complete()}catch(R){for(const I of v.values())I.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,$){let E=this.f[A];return typeof E>"u"&&(E=$),E}update(A,$){this.f[A]=$;const E=this.h.get(A);if(E!==void 0)return E.p;const v=new C.$ch;return this.h.set(A,v),this.i.isScheduled()||this.i.schedule(),v.p}dispose(){this.g.dispose()}}e.$kcc=T;class d extends T{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,$){super(A.identifier.value,!0,$),this.j=A}}e.$lcc=d}),define(De[263],Ce([1,0,4,2]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;class d{constructor(A){this.c=A,this.a=new C.$Nd,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$Nd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,$,E,v){const I=this.c.getNotebookDocument(T.URI.revive(A)).acceptModelChanged($.value,E,v);this.b.fire(I)}$acceptDirtyStateChanged(A,$){this.c.getNotebookDocument(T.URI.revive(A)).acceptDirty($)}$acceptModelSaved(A){const $=this.c.getNotebookDocument(T.URI.revive(A));this.a.fire($.apiNotebook)}}e.$Jdc=d}),define(De[20],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$dM=void 0,e.$dM=(0,C.$Oh)("IExtHostRpcService");class T{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$eM=T}),define(De[264],Ce([1,0,25,4]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;class d{#e;constructor(A,$){this.b=new T.$Nd,this.onDidChange=this.b.event,this.a=C.$4l.toKey(A.identifier),this.#e=$,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(A){return this.#e.get(this.a,A)}store(A,$){return this.#e.store(this.a,A,$)}delete(A){return this.#e.delete(this.a,A)}}e.$wcc=d}),define(De[67],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=e.$5bc=void 0,e.$5bc=(0,C.$Oh)("IURITransformerService");class T{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$6bc=T}),define(De[265],Ce([1,0,22]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcb=e.$vcb=void 0;class T{constructor(){this.buffers=[]}add(E){let v=this.buffers.indexOf(E);return v<0&&(v=this.buffers.length,this.buffers.push(E)),v}}function d($,E){if(E.serializeBuffersForPostMessage){const v=new T,I=JSON.stringify($,(y,k)=>{if(k instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:v.add(k)};if(ArrayBuffer.isView(k)){const p=L(k);if(p)return{$$vscode_array_buffer_reference$$:!0,index:v.add(k.buffer),view:{type:p,byteLength:k.byteLength,byteOffset:k.byteOffset}}}return k}),w=v.buffers.map(y=>{const k=new Uint8Array(y);return C.$be.wrap(k)});return{message:I,buffers:w}}else return{message:JSON.stringify($),buffers:[]}}e.$vcb=d;function L($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A($,E){const v=E.map(w=>{const y=new ArrayBuffer(w.byteLength);return new Uint8Array(y).set(w.buffer),y}),R=E.length?(w,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const k=y,{index:p}=k,u=v[p];if(k.view)switch(k.view.type){case 1:return new Int8Array(u,k.view.byteOffset,k.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,k.view.byteOffset,k.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,k.view.byteOffset,k.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,k.view.byteOffset,k.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,k.view.byteOffset,k.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,k.view.byteOffset,k.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,k.view.byteOffset,k.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,k.view.byteOffset,k.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,k.view.byteOffset,k.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,k.view.byteOffset,k.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,k.view.byteOffset,k.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return y}:void 0;return{message:JSON.parse($,R),arrayBuffers:v}}e.$wcb=A}),define(De[266],Ce([1,0,267,375,376,60,2,14,377]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;const v=!1;function R(o,m,h,t,n,a){const i=a.environment.useHostProxy,s=typeof i=="boolean"?i:!a.remote.isRemote,l={resolveProxy:b=>o.resolveProxy(b),lookupProxyAuthorization:u.bind(void 0,t,n,m,{},a.remote.isRemote),getProxyURL:()=>m.getConfiguration("http").get("proxy"),getProxySupport:()=>m.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>w(m),getSystemCertificatesV2:()=>y(m),log:(b,f,...g)=>{switch(b){case E.LogLevel.Trace:t.trace(f,...g);break;case E.LogLevel.Debug:t.debug(f,...g);break;case E.LogLevel.Info:t.info(f,...g);break;case E.LogLevel.Warning:t.warn(f,...g);break;case E.LogLevel.Error:t.error(f,...g);break;case E.LogLevel.Critical:t.error(f,...g);break;case E.LogLevel.Off:break;default:P(b,f,g);break}function P(N,O,...M){t.error("Unknown log level",N),t.error(O,...M)}},getLogLevel:()=>{const b=t.getLevel();switch(b){case $.LogLevel.Trace:return E.LogLevel.Trace;case $.LogLevel.Debug:return E.LogLevel.Debug;case $.LogLevel.Info:return E.LogLevel.Info;case $.LogLevel.Warning:return E.LogLevel.Warning;case $.LogLevel.Error:return E.LogLevel.Error;case $.LogLevel.Off:return E.LogLevel.Off;default:return f(b)}function f(g){return t.error("Unknown log level",g),E.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:s,addCertificates:[],env:process.env},D=(0,E.createProxyResolver)(l),S=I(l,D);return p(h,S)}e.$yec=R;function I(o,m){return{http:Object.assign(C,(0,E.createHttpPatch)(o,C,m)),https:Object.assign(T,(0,E.createHttpPatch)(o,T,m)),net:Object.assign(L,(0,E.createNetPatch)(o,L)),tls:Object.assign(d,(0,E.createTlsPatch)(o,d))}}function w(o){const m=o.getConfiguration("http");return!m.get("experimental.systemCertificatesV2",v)&&!!m.get("systemCertificates")}function y(o){const m=o.getConfiguration("http");return!!m.get("experimental.systemCertificatesV2",v)&&!!m.get("systemCertificates")}const k=new Map;function p(o,m){return o.getExtensionPathIndex().then(h=>{const t=globalThis._VSCODE_NODE_MODULES.module,n=t._load;t._load=function(i,s,l){if(i==="net")return m.net;if(i==="tls")return m.tls;if(i!=="http"&&i!=="https")return n.apply(this,arguments);const D=h.findSubstr(A.URI.file(s.filename));let S=k.get(D);if(S||k.set(D,S={}),!S[i]){const b=m[i];S[i]={...b}}return S[i]}})}async function u(o,m,h,t,n,a,i,s){const l=t[a];i&&(t[a]=i),o.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${a}`,`proxyAuthenticate:${i}`,`proxyAuthenticateCache:${l}`);const D=i||l,S=Array.isArray(D)?D:typeof D=="string"?[D]:[];if(r(m,S,n),S.some(b=>/^(Negotiate|Kerberos)( |$)/i.test(b))&&!s.kerberosRequested)try{s.kerberosRequested=!0;const b=await new Promise((O,M)=>{$e(["kerberos"],O,M)}),f=new URL(a),g=h.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${f.hostname}`:`HTTP@${f.hostname}`);return o.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${a}`,`spn:${g}`),"Negotiate "+await(await b.initializeClient(g)).step("")}catch(b){o.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",b)}}let c=!1;function r(o,m,h){c||!m.length||(c=!0,o.$publicLog2("proxyAuthenticationRequest",{authenticationType:m.map(t=>t.split(" ")[0]).join(","),extensionHostType:h?"remote":"local"}))}}),define(De[268],Ce([1,0,128]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;function T(L){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:L,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function d(L){return new C.$Jm(T(L))}e.$yr=d}),define(De[139],Ce([1,0,216,17,2,3,5,43,30,18,41,176,38]),function($e,e,C,T,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cE=e.$bE=e.$aE=e.EditorsOrder=e.$_D=e.CloseDirection=e.$$D=e.$0D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$9D=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=e.$3D=e.$2D=e.EditorInputCapabilities=e.$1D=e.SaveReason=e.Verbosity=e.$ZD=e.$YD=e.$XD=e.$WD=e.$VD=e.$UD=e.$TD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$SD=e.$RD=e.$QD=e.$PD=e.$OD=void 0,e.$OD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$PD={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$QD="workbench.editor.sidebysideEditor",e.$RD="workbench.editors.textDiffEditor",e.$SD="workbench.editors.binaryResourceDiffEditor";var y;(function(ae){ae[ae.PROGRAMMATIC=1]="PROGRAMMATIC",ae[ae.USER=2]="USER",ae[ae.EDIT=3]="EDIT",ae[ae.NAVIGATION=4]="NAVIGATION",ae[ae.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var k;(function(ae){ae[ae.IDENTICAL=1]="IDENTICAL",ae[ae.SIMILAR=2]="SIMILAR",ae[ae.DIFFERENT=3]="DIFFERENT"})(k||(e.EditorPaneSelectionCompareResult=k={}));function p(ae){const we=ae;return!!we&&typeof we.getSelection=="function"&&!!we.onDidChangeSelection}e.$TD=p;function u(ae,we,G){for(const U of G.visibleEditorPanes)if(U.group.id===we&&ae.matches(U.input))return U.getViewState()}e.$UD=u;function c(ae){if(l(ae))return!1;const we=ae;return d.URI.isUri(we?.resource)}e.$VD=c;function r(ae){if(l(ae))return!1;const we=ae;return we?.original!==void 0&&we.modified!==void 0}e.$WD=r;function o(ae){if(l(ae)||r(ae))return!1;const we=ae;return we?.primary!==void 0&&we.secondary!==void 0}e.$XD=o;function m(ae){if(l(ae))return!1;const we=ae;return we?we.resource===void 0||we.resource.scheme===v.Schemas.untitled||we.forceUntitled===!0:!1}e.$YD=m;function h(ae){if(l(ae))return!1;const we=ae;return d.URI.isUri(we?.base?.resource)&&d.URI.isUri(we?.input1?.resource)&&d.URI.isUri(we?.input2?.resource)&&d.URI.isUri(we?.result?.resource)}e.$ZD=h;var t;(function(ae){ae[ae.SHORT=0]="SHORT",ae[ae.MEDIUM=1]="MEDIUM",ae[ae.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var n;(function(ae){ae[ae.EXPLICIT=1]="EXPLICIT",ae[ae.AUTO=2]="AUTO",ae[ae.FOCUS_CHANGE=3]="FOCUS_CHANGE",ae[ae.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class a{constructor(){this.a=new Map}registerSource(we,G){let U=this.a.get(we);return U||(U={source:we,label:G},this.a.set(we,U)),U.source}getSourceLabel(we){return this.a.get(we)?.label??we}}e.$1D=new a;var i;(function(ae){ae[ae.None=0]="None",ae[ae.Readonly=2]="Readonly",ae[ae.Untitled=4]="Untitled",ae[ae.Singleton=8]="Singleton",ae[ae.RequiresTrust=16]="RequiresTrust",ae[ae.CanSplitInGroup=32]="CanSplitInGroup",ae[ae.ForceDescription=64]="ForceDescription",ae[ae.CanDropIntoEditor=128]="CanDropIntoEditor",ae[ae.MultipleEditors=256]="MultipleEditors",ae[ae.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class s extends L.$Sc{}e.$2D=s;function l(ae){return ae instanceof s}e.$3D=l;function D(ae){const we=ae;return d.URI.isUri(we?.preferredResource)}function S(ae){const we=ae;return l(we?.primary)&&l(we?.secondary)}e.$4D=S;function b(ae){const we=ae;return l(we?.modified)&&l(we?.original)}e.$5D=b;function f(ae,we,G,U,q){return x(U,[(0,I.$yi)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const me={...G,limits:{size:Number.MAX_VALUE}};ae.openEditor(we,me)}}),(0,I.$yi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}e.$6D=f;function g(ae){return l(ae?.editor)}e.$7D=g;function P(ae){const we=ae;return g(ae)&&we?.group!==void 0}e.$8D=P;function N(ae){const we=ae;return typeof we?.groupId=="number"&&l(we.editor)}e.$9D=N;var O;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.REPLACE=1]="REPLACE",ae[ae.MOVE=2]="MOVE",ae[ae.UNPIN=3]="UNPIN"})(O||(e.EditorCloseContext=O={}));var M;(function(ae){ae[ae.GROUP_ACTIVE=0]="GROUP_ACTIVE",ae[ae.GROUP_INDEX=1]="GROUP_INDEX",ae[ae.GROUP_LOCKED=2]="GROUP_LOCKED",ae[ae.EDITOR_OPEN=3]="EDITOR_OPEN",ae[ae.EDITOR_CLOSE=4]="EDITOR_CLOSE",ae[ae.EDITOR_MOVE=5]="EDITOR_MOVE",ae[ae.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ae[ae.EDITOR_LABEL=7]="EDITOR_LABEL",ae[ae.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ae[ae.EDITOR_PIN=9]="EDITOR_PIN",ae[ae.EDITOR_STICKY=10]="EDITOR_STICKY",ae[ae.EDITOR_DIRTY=11]="EDITOR_DIRTY",ae[ae.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var j;(function(ae){ae[ae.PRIMARY=1]="PRIMARY",ae[ae.SECONDARY=2]="SECONDARY",ae[ae.BOTH=3]="BOTH",ae[ae.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class z{getOriginalUri(we,G){if(!we)return;if(h(we))return e.$$D.getOriginalUri(we.result,G);if(G?.supportSideBySide){const{primary:q,secondary:me}=this.a(we);if(q&&me){if(G?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:G.filterByScheme}),secondary:this.getOriginalUri(me,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===j.ANY)return this.getOriginalUri(q,{filterByScheme:G.filterByScheme})??this.getOriginalUri(me,{filterByScheme:G.filterByScheme});we=G.supportSideBySide===j.PRIMARY?q:me}}if(r(we)||o(we)||h(we))return;const U=D(we)?we.preferredResource:we.resource;return!U||!G||!G.filterByScheme?U:this.b(U,G.filterByScheme)}a(we){return S(we)||o(we)?{primary:we.primary,secondary:we.secondary}:b(we)||r(we)?{primary:we.modified,secondary:we.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(we,G){if(!we)return;if(h(we))return e.$$D.getCanonicalUri(we.result,G);if(G?.supportSideBySide){const{primary:q,secondary:me}=this.a(we);if(q&&me){if(G?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:G.filterByScheme}),secondary:this.getCanonicalUri(me,{filterByScheme:G.filterByScheme})};if(G?.supportSideBySide===j.ANY)return this.getCanonicalUri(q,{filterByScheme:G.filterByScheme})??this.getCanonicalUri(me,{filterByScheme:G.filterByScheme});we=G.supportSideBySide===j.PRIMARY?q:me}}if(r(we)||o(we)||h(we))return;const U=we.resource;return!U||!G||!G.filterByScheme?U:this.b(U,G.filterByScheme)}b(we,G){if(Array.isArray(G)){if(G.some(U=>we.scheme===U))return we}else if(G===we.scheme)return we}}var F;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.KEYBOARD=1]="KEYBOARD",ae[ae.MOUSE=2]="MOUSE"})(F||(e.EditorCloseMethod=F={}));function K(ae,we,G,U){if(!ae.isSticky(we))return!1;switch(U.preventPinnedEditorClose){case"keyboardAndMouse":return G===F.MOUSE||G===F.KEYBOARD;case"mouse":return G===F.MOUSE;case"keyboard":return G===F.KEYBOARD}return!1}e.$0D=K,e.$$D=new z;var V;(function(ae){ae[ae.LEFT=0]="LEFT",ae[ae.RIGHT=1]="RIGHT"})(V||(e.CloseDirection=V={}));class fe{constructor(){this.c=new Map,this.d=new Map}start(we){const G=this.a=we.get(A.$Nh);for(const[U,q]of this.c)this.e(U,q,G);this.c.clear()}e(we,G,U){const q=U.createInstance(G);this.d.set(we,q)}registerFileEditorFactory(we){if(this.b)throw new Error("Can only register one file editor factory.");this.b=we}getFileEditorFactory(){return(0,T.$Jf)(this.b)}registerEditorSerializer(we,G){if(this.c.has(we)||this.d.has(we))throw new Error(`A editor serializer with type ID '${we}' was already registered.`);return this.a?this.e(we,G,this.a):this.c.set(we,G),(0,L.$Qc)(()=>{this.c.delete(we),this.d.delete(we)})}getEditorSerializer(we){return this.d.get(typeof we=="string"?we:we.typeId)}}$.$dn.add(e.$OD.EditorFactory,new fe);async function Z(ae,we,G){return!ae||!ae.length?[]:await Promise.all(ae.map(async U=>{const q=d.URI.revive(U.fileUri);if(!q){G.info("Cannot resolve the path because it is not valid.",U);return}if(!await we.canHandleResource(q)){G.info("Cannot resolve the path because it cannot be handled",U);return}let ee=U.exists,ne=U.type;if(typeof ee!="boolean"||typeof ne!="number")try{ne=(await we.stat(q)).isDirectory?E.FileType.Directory:E.FileType.Unknown,ee=!0}catch(Ee){G.error(Ee),ee=!1}if(!ee&&U.openOnlyIfExists){G.info("Cannot resolve the path because it does not exist",U);return}if(ne===E.FileType.Directory){G.info("Cannot resolve the path because it is a directory",U);return}const re={...U.options,pinned:!0};return ee?{resource:q,options:re}:{resource:q,options:re,forceUntitled:!0}}))}e.$_D=Z;var Q;(function(ae){ae[ae.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ae[ae.SEQUENTIAL=1]="SEQUENTIAL"})(Q||(e.EditorsOrder=Q={}));function X(ae){const we=ae;if(!we)return!1;const G=we;if(G.modified)return X(G.modified);const U=we;return!!(U.contributionsState&&U.viewState&&Array.isArray(U.cursorState))}e.$aE=X;function oe(ae){return(0,R.$Ai)(ae)}e.$bE=oe;function x(ae,we,G){const U=(0,R.$Bi)(ae,we);return U.forceMessage=G?.forceMessage,U.forceSeverity=G?.forceSeverity,U.allowDialog=G?.allowDialog,U}e.$cE=x}),define(De[269],Ce([1,0,4,217,5,3,28,43,19,24,79,255]),function($e,e,C,T,d,L,A,$,E,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nE=e.$mE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$lE=e.$kE=e.ViewContentGroups=e.$jE=e.$iE=e.ViewContainerLocation=e.Extensions=e.$hE=e.$gE=e.$fE=void 0,e.$fE="views",e.$gE=(0,T.localize)(0,null),e.$hE=(0,I.$2v)("default-view-icon",R.$Tj.window,(0,T.localize)(1,null));var w;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(w||(e.Extensions=w={}));var y;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$iE=[0,1,2];function k(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$jE=k;class p extends L.$Sc{constructor(){super(...arguments),this.c=this.B(new C.$Nd),this.onDidRegister=this.c.event,this.f=this.B(new C.$Nd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Rb)([...this.g.values()])}registerViewContainer(a,i,s){const l=this.get(a.id);if(l)return l;const D=a;return D.openCommandActionDescriptor=s?.doNotRegisterOpenCommand?void 0:D.openCommandActionDescriptor??{id:D.id},(0,A.$xc)(this.g,i,[]).push(D),s?.isDefault&&this.h.push(D),this.c.fire({viewContainer:D,viewContainerLocation:i}),D}deregisterViewContainer(a){for(const i of this.g.keys()){const s=this.g.get(i),l=s?.indexOf(a);if(l!==-1){s?.splice(l,1),s.length===0&&this.g.delete(i),this.f.fire({viewContainer:a,viewContainerLocation:i});return}}}get(a){return this.all.filter(i=>i.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(i=>this.getViewContainers(i).filter(s=>s?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(i=>this.getViewContainerLocation(i)===a)}}$.$dn.add(w.ViewContainersRegistry,new p);var u;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(u||(e.ViewContentGroups=u={}));function c(n,a){const i=n.group??u.More,s=a.group??u.More;return i!==s?i.localeCompare(s):(n.order??5)-(a.order??5)}class r extends L.$Sc{constructor(){super(...arguments),this.c=this.B(new C.$Nd),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$Nd),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$Nd),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$Nd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(a,i){this.registerViews2([{views:a,viewContainer:i}])}registerViews2(a){a.forEach(({views:i,viewContainer:s})=>this.r(i,s)),this.c.fire(a)}deregisterViews(a,i){const s=this.s(a,i);s.length&&this.f.fire({views:s,viewContainer:i})}moveViews(a,i){for(const s of this.m.keys())if(s!==i){const l=this.s(a,s);l.length&&(this.r(l,i),this.g.fire({views:l,from:s,to:i}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const i of this.j){const s=(this.m.get(i)||[]).filter(l=>l.id===a)[0];if(s)return s}return null}getViewContainer(a){for(const i of this.j)if((this.m.get(i)||[]).filter(l=>l.id===a)[0])return i;return null}registerViewWelcomeContent(a,i){return this.n.add(a,i),this.h.fire(a),(0,L.$Qc)(()=>{this.n.delete(a,i),this.h.fire(a)})}registerViewWelcomeContent2(a,i){const s=new Map;for(const[l,D]of i)this.n.add(a,D),s.set(l,(0,L.$Qc)(()=>{this.n.delete(a,D),this.h.fire(a)}));return this.h.fire(a),s}getViewWelcomeContent(a){const i=[];return this.n.forEach(a,s=>i.push(s)),i.sort(c)}r(a,i){let s=this.m.get(i);s||(s=[],this.m.set(i,s),this.j.push(i));for(const l of a){if(this.getView(l.id)!==null)throw new Error((0,T.localize)(2,null,l.id));s.push(l)}}s(a,i){const s=this.m.get(i);if(!s)return[];const l=[],D=[];for(const S of s)a.includes(S)?l.push(S):D.push(S);return l.length&&(D.length?this.m.set(i,D):(this.m.delete(i),this.j.splice(this.j.indexOf(i),1))),l}}$.$dn.add(w.ViewsRegistry,new r),e.$kE=(0,d.$Oh)("viewsService"),e.$lE=(0,d.$Oh)("viewDescriptorService");var o;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var m;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(m||(e.TreeItemCollapsibleState=m={}));class h{constructor(a,i){this.c=!1,this.d=!1,(0,v.$7m)(this,a),this.d=!!i,this.resolve=async s=>{if(i&&!this.c){const l=await i(s);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}s.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$mE=h;class t extends Error{constructor(a){super((0,T.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$nE=t}),define(De[140],Ce([1,0,4,9,218]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new C.$Nd,this.n=new C.$Nd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,E,v,R){const I={command:$};if(E&&Object.keys(E).length>0&&(I.arguments=E),this.s("request",I),typeof R=="number"){const w=setTimeout(()=>{clearTimeout(w);const y=this.f.get(I.seq);if(y){this.f.delete(I.seq);const k={type:"response",seq:0,request_seq:I.seq,success:!1,command:$,message:(0,d.localize)(0,null,R,$)};y(k)}},R)}return v&&this.f.set(I.seq,v),I.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,E){return $.type!=="event"||E.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,T.$Ug)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const E=$,v=this.f.get(E.request_seq);v&&(this.f.delete(E.request_seq),v(E));break}}}}s($,E){E.type=$,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((E,v)=>$.set(v,E)),await(0,T.$Ug)(500),$.forEach((E,v)=>{E({type:"response",seq:0,request_seq:v,success:!1,command:"canceled",message:"canceled"}),this.f.delete(v)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$2cb=L}),define(De[270],Ce([1,0,219,42,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$ZG=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$YG=e.MemoryRangeType=e.$XG=e.State=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=void 0,e.$VF="workbench.view.debug",e.$WF="workbench.debug.variablesView",e.$XF="workbench.debug.watchExpressionsView",e.$YF="workbench.debug.callStackView",e.$ZF="workbench.debug.loadedScriptsView",e.$1F="workbench.debug.breakPointsView",e.$2F="workbench.debug.disassemblyView",e.$3F="workbench.panel.repl",e.$4F="workbench.panel.repl.view",e.$5F=new T.$6i("debugType",void 0,{type:"string",description:C.localize(0,null)}),e.$6F=new T.$6i("debugConfigurationType",void 0,{type:"string",description:C.localize(1,null)}),e.$7F=new T.$6i("debugState","inactive",{type:"string",description:C.localize(2,null)}),e.$8F="debugUx",e.$9F=new T.$6i(e.$8F,"default",{type:"string",description:C.localize(3,null)}),e.$0F=new T.$6i("hasDebugged",!1,{type:"boolean",description:C.localize(4,null)}),e.$$F=new T.$6i("inDebugMode",!1,{type:"boolean",description:C.localize(5,null)}),e.$_F=new T.$6i("inDebugRepl",!1,{type:"boolean",description:C.localize(6,null)}),e.$aG=new T.$6i("breakpointWidgetVisible",!1,{type:"boolean",description:C.localize(7,null)}),e.$bG=new T.$6i("inBreakpointWidget",!1,{type:"boolean",description:C.localize(8,null)}),e.$cG=new T.$6i("breakpointsFocused",!0,{type:"boolean",description:C.localize(9,null)}),e.$dG=new T.$6i("watchExpressionsFocused",!0,{type:"boolean",description:C.localize(10,null)}),e.$eG=new T.$6i("watchExpressionsExist",!1,{type:"boolean",description:C.localize(11,null)}),e.$fG=new T.$6i("variablesFocused",!0,{type:"boolean",description:C.localize(12,null)}),e.$gG=new T.$6i("expressionSelected",!1,{type:"boolean",description:C.localize(13,null)}),e.$hG=new T.$6i("breakpointInputFocused",!1,{type:"boolean",description:C.localize(14,null)}),e.$iG=new T.$6i("callStackItemType",void 0,{type:"string",description:C.localize(15,null)}),e.$jG=new T.$6i("callStackSessionIsAttach",!1,{type:"boolean",description:C.localize(16,null)}),e.$kG=new T.$6i("callStackItemStopped",!1,{type:"boolean",description:C.localize(17,null)}),e.$lG=new T.$6i("callStackSessionHasOneThread",!1,{type:"boolean",description:C.localize(18,null)}),e.$mG=new T.$6i("watchItemType",void 0,{type:"string",description:C.localize(19,null)}),e.$nG=new T.$6i("canViewMemory",void 0,{type:"boolean",description:C.localize(20,null)}),e.$oG=new T.$6i("breakpointItemType",void 0,{type:"string",description:C.localize(21,null)}),e.$pG=new T.$6i("breakpointSupportsCondition",!1,{type:"boolean",description:C.localize(22,null)}),e.$qG=new T.$6i("loadedScriptsSupported",!1,{type:"boolean",description:C.localize(23,null)}),e.$rG=new T.$6i("loadedScriptsItemType",void 0,{type:"string",description:C.localize(24,null)}),e.$sG=new T.$6i("focusedSessionIsAttach",!1,{type:"boolean",description:C.localize(25,null)}),e.$tG=new T.$6i("stepBackSupported",!1,{type:"boolean",description:C.localize(26,null)}),e.$uG=new T.$6i("restartFrameSupported",!1,{type:"boolean",description:C.localize(27,null)}),e.$vG=new T.$6i("stackFrameSupportsRestart",!1,{type:"boolean",description:C.localize(28,null)}),e.$wG=new T.$6i("jumpToCursorSupported",!1,{type:"boolean",description:C.localize(29,null)}),e.$xG=new T.$6i("stepIntoTargetsSupported",!1,{type:"boolean",description:C.localize(30,null)}),e.$yG=new T.$6i("breakpointsExist",!1,{type:"boolean",description:C.localize(31,null)}),e.$zG=new T.$6i("debuggersAvailable",!1,{type:"boolean",description:C.localize(32,null)}),e.$AG=new T.$6i("debugExtensionAvailable",!0,{type:"boolean",description:C.localize(33,null)}),e.$BG=new T.$6i("debugProtocolVariableMenuContext",void 0,{type:"string",description:C.localize(34,null)}),e.$CG=new T.$6i("debugSetVariableSupported",!1,{type:"boolean",description:C.localize(35,null)}),e.$DG=new T.$6i("debugSetExpressionSupported",!1,{type:"boolean",description:C.localize(36,null)}),e.$EG=new T.$6i("breakWhenValueChangesSupported",!1,{type:"boolean",description:C.localize(37,null)}),e.$FG=new T.$6i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:C.localize(38,null)}),e.$GG=new T.$6i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:C.localize(39,null)}),e.$HG=new T.$6i("terminateDebuggeeSupported",!1,{type:"boolean",description:C.localize(40,null)}),e.$IG=new T.$6i("suspendDebuggeeSupported",!1,{type:"boolean",description:C.localize(41,null)}),e.$JG=new T.$6i("variableEvaluateNamePresent",!1,{type:"boolean",description:C.localize(42,null)}),e.$KG=new T.$6i("variableIsReadonly",!1,{type:"boolean",description:C.localize(43,null)}),e.$LG=new T.$6i("exceptionWidgetVisible",!1,{type:"boolean",description:C.localize(44,null)}),e.$MG=new T.$6i("multiSessionRepl",!1,{type:"boolean",description:C.localize(45,null)}),e.$NG=new T.$6i("multiSessionDebug",!1,{type:"boolean",description:C.localize(46,null)}),e.$OG=new T.$6i("disassembleRequestSupported",!1,{type:"boolean",description:C.localize(47,null)}),e.$PG=new T.$6i("disassemblyViewFocus",!1,{type:"boolean",description:C.localize(48,null)}),e.$QG=new T.$6i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:C.localize(49,null)}),e.$RG=new T.$6i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:C.localize(50,null)});const L=w=>C.localize(51,null,w);e.$SG=L,e.$TG="editor.contrib.debug",e.$UG="editor.contrib.breakpoint",e.$VG="debug",e.$WG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:C.localize(52,null)};var A;(function(w){w[w.Inactive=0]="Inactive",w[w.Initializing=1]="Initializing",w[w.Stopped=2]="Stopped",w[w.Running=3]="Running"})(A||(e.State=A={}));function $(w){switch(w){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$XG=$;var E;(function(w){w[w.Valid=0]="Valid",w[w.Unreadable=1]="Unreadable",w[w.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$YG="vscode-debug-memory";var v;(function(w){w[w.Initial=1]="Initial",w[w.Dynamic=2]="Dynamic"})(v||(e.DebugConfigurationProviderTriggerKind=v={}));var R;(function(w){w.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$ZG=(0,d.$Oh)("debugService");var I;(function(w){w[w.CONDITION=0]="CONDITION",w[w.HIT_COUNT=1]="HIT_COUNT",w[w.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(De[271],Ce([1,0,15,2,16,24,18,34,21,19]),function($e,e,C,T,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=void 0;const R=/{([^}]+)}/g;function I(S,b,f){return S.replace(R,function(g,P){return b&&P.length>0&&P[0]!=="_"?g:f&&f.hasOwnProperty(P)?f[P]:g})}e.$kF=I;function w(S){const b={};for(const f of Object.keys(S))f.startsWith("!")||(b[f]=S[f]);return b}e.$lF=w;function y(S){return S.configuration.request==="attach"&&!k(S)&&(!S.parentSession||y(S.parentSession))}e.$mF=y;function k(S){let b=S.configuration.type;if(b)return b==="vslsShare"&&(b=S.configuration.adapterProxy.configuration.type),(0,C.$2e)(b,"extensionhost")||(0,C.$2e)(b,"pwa-extensionhost")?S:S.parentSession?k(S.parentSession):void 0}e.$nF=k;function p(S){return S.type&&(S.label||S.program||S.runtime)}e.$oF=p;function u(S,b,f){let g,P=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=N.exec(S);){const M=O.index+1,j=M+O[0].length;if(M<=b&&j>=f){g=O[0],P=M;break}}if(g){const M=/\w+/g;let j=null;for(;(j=M.exec(g))&&!(j.index+1+P+j[0].length>=f););j&&(g=g.substring(0,M.lastIndex))}return g?{start:P,end:P+g.length-1}:{start:0,end:0}}e.$pF=u;async function c(S,b,f,g){if(S.evaluatableExpressionProvider.has(b)){const P=S.evaluatableExpressionProvider.ordered(b),N=(0,v.$Hb)(await Promise.all(P.map(async O=>{try{return await O.provideEvaluatableExpression(b,f,g??E.CancellationToken.None)}catch{return}})));if(N.length>0){let O=N[0].expression;const M=N[0].range;return O||(O=b.getLineContent(f.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:O}}}else{const P=b.getLineContent(f.lineNumber),{start:N,end:O}=u(P,f.column,f.column),M=P.substring(N-1,O);return{matchingExpression:M,range:new $.$qs(f.lineNumber,N,f.lineNumber,N+M.length)}}return null}e.$qF=c;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(S){return!!(S&&S.match(r))}e.$rF=o;function m(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(o(S.path))return T.URI.parse(S.path);if((0,d.$ic)(S.path))return T.URI.file(S.path)}return S.path}function h(S){if(typeof S.path=="object"){const b=T.URI.revive(S.path);if(b)return b.scheme===A.Schemas.file?b.fsPath:b.toString()}return S.path}function t(S,b){const f=b?m:h,g=(0,L.$4m)(S);return a(g,(P,N)=>{P&&N&&(N.path=f(N))}),g}e.$sF=t;function n(S,b){const f=b?m:h,g=(0,L.$4m)(S);return a(g,(P,N)=>{!P&&N&&(N.path=f(N))}),g}e.$tF=n;function a(S,b){switch(S.type){case"event":{const f=S;switch(f.event){case"output":b(!1,f.body.source);break;case"loadedSource":b(!1,f.body.source);break;case"breakpoint":b(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=S;switch(f.command){case"setBreakpoints":b(!0,f.arguments.source);break;case"breakpointLocations":b(!0,f.arguments.source);break;case"source":b(!0,f.arguments.source);break;case"gotoTargets":b(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(g=>b(!1,g));break;default:break}break}case"response":{const f=S;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(g=>b(!1,g.source));break;case"loadedSources":f.body.sources.forEach(g=>b(!1,g));break;case"scopes":f.body.scopes.forEach(g=>b(!1,g.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(g=>b(!1,g.source));break;case"setBreakpoints":f.body.breakpoints.forEach(g=>b(!1,g.source));break;case"disassemble":f.body?.instructions.forEach(P=>b(!1,P.location));break;default:break}break}}}function i(S){return S.filter(b=>!b.presentation?.hidden).sort((b,f)=>b.presentation?f.presentation?b.presentation.group?f.presentation.group?b.presentation.group!==f.presentation.group?b.presentation.group.localeCompare(f.presentation.group):s(b.presentation.order,f.presentation.order):-1:f.presentation.group?1:s(b.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.$uF=i;function s(S,b){return typeof S!="number"?typeof b!="number"?0:1:typeof b!="number"?-1:S-b}async function l(S,b){const f=S.getValue("debug.saveBeforeStart",{overrideIdentifier:b.activeTextEditorLanguageId});if(f!=="none"&&(await b.saveAll(),f==="allEditorsInActiveGroup")){const g=b.activeEditorPane;g&&g.input.resource?.scheme===A.Schemas.untitled&&await b.save({editor:g.input,groupId:g.group.id})}await S.reloadConfiguration()}e.$vF=l;const D=(S,b)=>!S||!b?S===b:S.name===b.name&&S.path===b.path&&S.sourceReference===b.sourceReference;e.$wF=D}),define(De[272],Ce([1,0,49,60,24,16,12,15,29,220,140]),function($e,e,C,T,d,L,A,$,E,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=e.$_dc=e.$$dc=e.$0dc=e.$9dc=void 0;class I extends R.$2cb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(c,r){this.p=r,this.r=Buffer.allocUnsafe(0),this.t=-1,c.on("data",o=>this.w(o))}sendMessage(c){if(this.p){const r=JSON.stringify(c);this.p.write(`Content-Length: ${Buffer.byteLength(r,"utf8")}${I.a}${r}`,"utf8")}}w(c){for(this.r=Buffer.concat([this.r,c]);;){if(this.t>=0){if(this.r.length>=this.t){const r=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,r.length>0)try{this.acceptMessage(JSON.parse(r))}catch(o){this.m.fire(new Error((o.message||o)+`
`+r))}continue}}else{const r=this.r.indexOf(I.a);if(r!==-1){const m=this.r.toString("utf8",0,r).split(I.b);for(const h of m){const t=h.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(r+I.a.length);continue}}break}}}e.$9dc=I;class w extends I{startSession(){return new Promise((c,r)=>{let o=!1;this.x=this.y(()=>{this.v(this.x,this.x),c(),o=!0}),this.x.on("close",()=>{o?this.m.fire(new Error("connection closed")):r(new Error("connection closed"))}),this.x.on("error",m=>{o?this.m.fire(m):r(m)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$0dc=w;class y extends w{constructor(c){super(),this.z=c}y(c){return T.createConnection(this.z.port,this.z.host||"127.0.0.1",c)}}e.$$dc=y;class k extends w{constructor(c){super(),this.z=c}y(c){return T.createConnection(this.z.path,c)}}e.$_dc=k;class p extends I{constructor(c,r){super(),this.y=c,this.z=r}async startSession(){const c=this.y.command,r=this.y.args,o=this.y.options||{};try{if(c)if(L.$ic(c)){if(!await E.Promises.exists(c))throw new Error(v.localize(0,null,c))}else c.indexOf("/")<0&&c.indexOf("\\")<0;else throw new Error(v.localize(1,null,this.z));let m=process.env;if(o.env&&Object.keys(o.env).length>0&&(m=d.$7m(d.$4m(process.env),o.env)),c==="node")if(Array.isArray(r)&&r.length>0){const h=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:m,execArgv:h?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(t.cwd=o.cwd);const n=C.fork(r[0],r.slice(1),t);if(!n.pid)throw new Error(v.localize(2,null,r[0]));this.x=n}else throw new Error(v.localize(3,null));else{const h={env:m};o.cwd&&(h.cwd=o.cwd),this.x=C.spawn(c,r,h)}this.x.on("error",h=>{this.m.fire(h)}),this.x.on("exit",(h,t)=>{this.n.fire(h)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",h=>{this.m.fire(h)}),this.x.stdin.on("error",h=>{this.m.fire(h)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(m){this.m.fire(m)}}async stopSession(){return this.x?(await this.u(),A.$j?new Promise((c,r)=>{const o=C.exec(`taskkill /F /T /PID ${this.x.pid}`,function(m,h,t){if(m)return r(m)});o.on("exit",c),o.on("error",r)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(c,r){if(!c)return;const o=Object.create(null);c.runtime&&(c.runtime.indexOf("./")===0?o.runtime=L.$jc(r,c.runtime):o.runtime=c.runtime),c.runtimeArgs&&(o.runtimeArgs=c.runtimeArgs),c.program&&(L.$ic(c.program)?o.program=c.program:o.program=L.$jc(r,c.program)),c.args&&(o.args=c.args);const m=c;return m.win&&(o.win=p.A(m.win,r)),m.winx86&&(o.winx86=p.A(m.winx86,r)),m.windows&&(o.windows=p.A(m.windows,r)),m.osx&&(o.osx=p.A(m.osx,r)),m.linux&&(o.linux=p.A(m.linux,r)),o}static platformAdapterExecutable(c,r){let o=Object.create(null);r=r.toLowerCase();for(const i of c)if(i.contributes){const s=i.contributes.debuggers;s&&s.length>0&&s.filter(l=>typeof l.type=="string"&&$.$2e(l.type,r)).forEach(l=>{const D=p.A(l,i.extensionLocation.fsPath);o=d.$7m(o,D,i.isBuiltin)})}let m;A.$j&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=o.winx86||o.win||o.windows:A.$j?m=o.win||o.windows:A.$k?m=o.osx:A.$l&&(m=o.linux),m=m||o;const h=m.program||o.program,t=m.args||o.args,n=m.runtime||o.runtime,a=m.runtimeArgs||o.runtimeArgs;if(n)return{type:"executable",command:n,args:(a||[]).concat(typeof h=="string"?[h]:[]).concat(t||[])};if(h)return{type:"executable",command:h,args:t||[]}}}e.$aec=p}),define(De[273],Ce([1,0,49,32,12]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=e.$bec=void 0;function L(v,R){return new Promise((I,w)=>{let y="";const k=C.spawn(v,R);k.pid&&k.stdout.on("data",p=>{y+=p.toString()}),k.on("error",p=>{w(p)}),k.on("close",p=>{I(y)})})}async function A(v){if(v)if(d.$j){const R=await new Promise((I,w)=>{$e(["@vscode/windows-process-tree"],I,w)});return new Promise(I=>{R.getProcessTree(v,w=>{I(!!w&&w.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(v)]).then(R=>{const I=R.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.$bec=A;var $;(function(v){v[v.cmd=0]="cmd",v[v.powershell=1]="powershell",v[v.bash=2]="bash"})($||($={}));function E(v,R,I,w,y){v=v.trim().toLowerCase();let k;v.indexOf("powershell")>=0||v.indexOf("pwsh")>=0?k=1:v.indexOf("cmd.exe")>=0?k=0:v.indexOf("bash")>=0?k=2:d.$j?k=0:k=2;let p,u=" ";switch(k){case 1:if(p=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),w){const c=(0,T.$3f)(w);c&&(u+=`${c}:; `),u+=`cd ${p(w)}; `}if(y)for(const c in y){const r=y[c];r===null?u+=`Remove-Item env:${c}; `:u+=`\${env:${c}}='${r}'; `}if(R.length>0){const c=R.shift(),r=I?c:p(c);u+=r[0]==="'"?`& ${r} `:`${r} `;for(const o of R)u+=o==="<"||o===">"||I?o:p(o),u+=" "}break;case 0:if(p=c=>(c=c.replace(/\"/g,'""'),c=c.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(r=>c.includes(r))||c.length===0?`"${c}"`:c),w){const c=(0,T.$3f)(w);c&&(u+=`${c}: && `),u+=`cd ${p(w)} && `}if(y){u+='cmd /C "';for(const c in y){let r=y[c];r===null?u+=`set "${c}=" && `:(r=r.replace(/[&^|<>]/g,o=>`^${o}`),u+=`set "${c}=${r}" && `)}}for(const c of R)u+=c==="<"||c===">"||I?c:p(c),u+=" ";y&&(u+='"');break;case 2:{p=r=>(r=r.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),r.length===0?'""':r);const c=r=>/[^\w@%\/+=,.:^-]/.test(r)?`'${r.replace(/'/g,"'\\''")}'`:r;if(w&&(u+=`cd ${p(w)} ; `),y){u+="/usr/bin/env";for(const r in y){const o=y[r];o===null?u+=` -u ${c(r)}`:u+=` ${c(`${r}=${o}`)}`}u+=" "}for(const r of R)u+=r==="<"||r===">"||I?r:p(r),u+=" ";break}}return u}e.$cec=E}),define(De[108],Ce([1,0,22,35,51,97,18,16,12,42]),function($e,e,C,T,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oI=e.$nI=e.$mI=e.$lI=e.CellStatusbarAlignment=e.$kI=e.$jI=e.$iI=e.NotebookEditorPriority=e.$hI=e.$gI=e.$fI=e.$eI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$dI=e.$cI=e.$bI=e.$aI=e.CellKind=e.$_H=e.$$H=e.$0H=void 0,e.$0H="workbench.editor.notebook",e.$$H="workbench.editor.notebookTextDiffEditor",e.$_H="workbench.editor.interactive";var R;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(R||(e.CellKind=R={})),e.$aI=["application/json","application/javascript","text/html","image/svg+xml",L.$Nr.latex,L.$Nr.markdown,"image/png","image/jpeg",L.$Nr.text],e.$bI=[L.$Nr.latex,L.$Nr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Nr.text],e.$cI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$dI="_notAvailable";var I;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var w;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var y;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var k;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(k||(e.NotebookRendererMatch=k={}));var p;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(p||(e.RendererMessagingSpec=p={}));var u;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(u||(e.NotebookCellsChangeType=u={}));var c;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(c||(e.SelectionStateType=c={}));var r;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var o;(function(F){F.scheme=A.Schemas.vscodeNotebookCell;const K=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${K.join("")}]+`),fe=7;function Z(we,G){const U=G.toString(fe),me=`${U.length<K.length?K[U.length-1]:"z"}${U}s${(0,C.$ve)(C.$be.fromString(we.scheme),!0,!0)}`;return we.with({scheme:F.scheme,fragment:me})}F.generate=Z;function Q(we){if(we.scheme!==F.scheme)return;const G=we.fragment.indexOf("s");if(G<0)return;const U=parseInt(we.fragment.substring(0,G).replace(V,""),fe),q=(0,C.$ue)(we.fragment.substring(G+1)).toString();if(!isNaN(U))return{handle:U,notebook:we.with({scheme:q,fragment:null})}}F.parse=Q;function X(we,G){return we.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${G??""},${we.scheme!==A.Schemas.file?we.scheme:""}`})}F.generateCellOutputUri=X;function oe(we){if(we.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const G=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(we.fragment);if(!G)return;const U=G[1]&&G[1]!==""?G[1]:void 0,q=G[2];return{outputId:U,notebook:we.with({scheme:q||A.Schemas.file,fragment:null})}}F.parseCellOutputUri=oe;function x(we,G,U){return F.generate(we,G).with({scheme:U})}F.generateCellPropertyUri=x;function ae(we,G){if(we.scheme===G)return F.parse(we.with({scheme:F.scheme}))}F.parseCellPropertyUri=ae})(o||(e.CellUri=o={}));const m=F=>E.$j?F.replace(/\//g,"\\"):F;class h{constructor(K=[],V=e.$aI){this.e=V,this.d=[...new Set(K)].map(fe=>({pattern:fe,matches:T.$vj(m(fe))}))}sort(K){const V=new Map(d.Iterable.map(K,Z=>[Z,m(Z)]));let fe=[];for(const{matches:Z}of this.d)for(const[Q,X]of V)if(Z(X)){fe.push(Q),V.delete(Q);break}return V.size&&(fe=fe.concat([...V.keys()].sort((Z,Q)=>this.e.indexOf(Z)-this.e.indexOf(Q)))),fe}prioritize(K,V){const fe=this.f(K);if(fe===-1){this.d.unshift({pattern:K,matches:T.$vj(m(K))});return}const Z=new Set(V.map(X=>this.f(X,fe)));Z.delete(-1);const Q=Array.from(Z).sort();this.d.splice(fe+1,0,...Q.map(X=>this.d[X]));for(let X=Q.length-1;X>=0;X--)this.d.splice(Q[X],1)}toArray(){return this.d.map(K=>K.pattern)}f(K,V=this.d.length){const fe=m(K);for(let Z=0;Z<V;Z++)if(this.d[Z].matches(fe))return Z;return-1}}e.$eI=h;function t(F,K,V,fe=(Z,Q)=>Z===Q){const Z=[];function Q(x,ae,we){if(ae===0&&we.length===0)return;const G=Z[Z.length-1];G&&G.start+G.deleteCount===x?(G.deleteCount+=ae,G.toInsert.push(...we)):Z.push({start:x,deleteCount:ae,toInsert:we})}let X=0,oe=0;for(;;){if(X===F.length){Q(X,0,K.slice(oe));break}if(oe===K.length){Q(X,F.length-X,[]);break}const x=F[X],ae=K[oe];if(fe(x,ae)){X+=1,oe+=1;continue}V(ae)?(Q(X,1,[]),X+=1):(Q(X,0,[ae]),oe+=1)}return Z}e.$fI=t,e.$gI=new v.$6i("notebookEditorCursorAtBoundary","none"),e.$hI=new v.$6i("notebookEditorCursorAtLineBoundary","none");var n;(function(F){F.default="default",F.option="option"})(n||(e.NotebookEditorPriority=n={}));function a(F){const K=F;return!!((typeof K.include=="string"||T.$wj(K.include))&&(typeof K.exclude=="string"||T.$wj(K.exclude)))}e.$iI=a;function i(F,K,V){if(Array.isArray(F.viewType)&&F.viewType.indexOf(K)>=0||F.viewType===K)return!0;if(F.filenamePattern){const fe=a(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,Z=a(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(T.$uj(fe,(0,$.$nc)(V.fsPath).toLowerCase()))return!(Z&&T.$uj(Z,(0,$.$nc)(V.fsPath).toLowerCase()))}return!1}e.$jI=i,e.$kI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var s;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(s||(e.CellStatusbarAlignment=s={}));class l{static{this.d="notebook/"}static create(K){return`${l.d}${K}`}static parse(K){if(K.startsWith(l.d))return K.substring(l.d.length)}}e.$lI=l;function D(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.$mI=D;const S=new TextDecoder;function b(F){const K=[];let V=!1;for(const X of F)(K.length===0||V)&&(K.push(X),V=!0);let fe=P(K);const Z=C.$be.concat(K.map(X=>C.$be.wrap(X))),Q=z(Z);return fe=fe||Q.byteLength!==Z.byteLength,{data:Q,didCompression:fe}}e.$nI=b,e.$oI=`${String.fromCharCode(27)}[A`;const f=e.$oI.split("").map(F=>F.charCodeAt(0)),g=10;function P(F){let K=!1;return F.forEach((V,fe)=>{if(fe===0||V.length<e.$oI.length)return;const Z=F[fe-1],Q=V.subarray(0,e.$oI.length);if(Q[0]===f[0]&&Q[1]===f[1]&&Q[2]===f[2]){const X=Z.lastIndexOf(g);if(X===-1)return;K=!0,F[fe-1]=Z.subarray(0,X),F[fe]=V.subarray(e.$oI.length)}}),K}function N(F){let K=F;do F=K,K=F.replace(/[^\n]\x08/gm,"");while(K.length<F.length);return F}function O(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const K=F.match(/^(.*)\r+/m)[1];let V=F.match(/\r+(.*)$/m)[1];V=V+K.slice(V.length,K.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return F}const M="\b".charCodeAt(0),j="\r".charCodeAt(0);function z(F){return!F.buffer.includes(M)&&!F.buffer.includes(j)?F:C.$be.fromString(O(N(S.decode(F.buffer))))}}),define(De[7],Ce([1,0,19,8,80,28,97,15,17,2,31,25,30,65,108]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k){"use strict";var p,u,c,r,o,m,h,t,n,a,i,s,l,D,S,b,f,g;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.$5L=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.TestRunProfileKind=e.TestResultState=e.$LL=e.$KL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$JL=e.$IL=e.$HL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$GL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.ColorThemeKind=e.$AL=e.$zL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$yL=e.DebugConsoleMode=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$sL=e.$rL=e.FileChangeType=e.$qL=e.$pL=e.$oL=e.$nL=e.InlineCompletionTriggerKind=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.ConfigurationTarget=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$3K=e.ViewBadge=e.ProgressLocation=e.$2K=e.$1K=e.TaskScope=e.ShellQuoting=e.$ZK=e.$YK=e.$XK=e.TaskPanelKind=e.TaskRevealKind=e.$WK=e.TerminalLocation=e.$VK=e.$UK=e.$TK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$SK=e.$RK=e.$QK=e.$PK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$OK=e.StatusBarAlignment=e.ViewColumn=e.$NK=e.$MK=e.$LK=e.$KK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$JK=e.$IK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.LanguageStatusSeverity=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.CodeActionTriggerKind=e.$wK=e.$vK=e.SymbolTag=e.SymbolKind=e.$uK=e.DocumentHighlightKind=e.$tK=e.$sK=e.$rK=e.$qK=e.DiagnosticSeverity=e.DiagnosticTag=e.$pK=e.$oK=e.FileEditType=e.$nK=e.$mK=e.$lK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(H){return Object.assign(H,{apply:function(...pe){if(pe.length===0)return Reflect.construct(H,[]);{const Re=pe.length===1?[]:pe[1];return Reflect.construct(H,Re,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(H,[]);{const[Re,...Qe]=pe;return Reflect.construct(H,Qe,Re.constructor)}}})}var N;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var O;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let M=p=class{static from(...W){let pe=W;return new p(function(){if(pe){for(const Re of pe)Re&&typeof Re.dispose=="function"&&Re.dispose();pe=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$eK=M,e.$eK=M=p=He([P],M);let j=u=class{static Min(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Re=1;Re<W.length;Re++){const Qe=W[Re];Qe.isBefore(pe)&&(pe=Qe)}return pe}static Max(...W){if(W.length===0)throw new TypeError;let pe=W[0];for(let Re=1;Re<W.length;Re++){const Qe=W[Re];Qe.isAfter(pe)&&(pe=Qe)}return pe}static isPosition(W){if(!W)return!1;if(W instanceof u)return!0;const{line:pe,character:Re}=W;return typeof pe=="number"&&typeof Re=="number"}static of(W){if(W instanceof u)return W;if(this.isPosition(W))return new u(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,pe){if(W<0)throw(0,T.$7)("line must be non-negative");if(pe<0)throw(0,T.$7)("character must be non-negative");this.c=W,this.e=pe}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,pe=0){if(W===null||pe===null)throw(0,T.$7)();let Re;return typeof W>"u"?Re=0:typeof W=="number"?Re=W:(Re=typeof W.lineDelta=="number"?W.lineDelta:0,pe=typeof W.characterDelta=="number"?W.characterDelta:0),Re===0&&pe===0?this:new u(this.line+Re,this.character+pe)}with(W,pe=this.character){if(W===null||pe===null)throw(0,T.$7)();let Re;return typeof W>"u"?Re=this.line:typeof W=="number"?Re=W:(Re=typeof W.line=="number"?W.line:this.line,pe=typeof W.character=="number"?W.character:this.character),Re===this.line&&pe===this.character?this:new u(Re,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$fK=j,e.$fK=j=u=He([P],j);let z=c=class{static isRange(W){return W instanceof c?!0:W?j.isPosition(W.start)&&j.isPosition(W.end):!1}static of(W){if(W instanceof c)return W;if(this.isRange(W))return new c(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,pe,Re,Qe){let tt,at;if(typeof W=="number"&&typeof pe=="number"&&typeof Re=="number"&&typeof Qe=="number"?(tt=new j(W,pe),at=new j(Re,Qe)):j.isPosition(W)&&j.isPosition(pe)&&(tt=j.of(W),at=j.of(pe)),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this.c=tt,this.e=at):(this.c=at,this.e=tt)}contains(W){return c.isRange(W)?this.contains(W.start)&&this.contains(W.end):j.isPosition(W)?!(j.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const pe=j.Max(W.start,this.c),Re=j.Min(W.end,this.e);if(!pe.isAfter(Re))return new c(pe,Re)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const pe=j.Min(W.start,this.c),Re=j.Max(W.end,this.end);return new c(pe,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,pe=this.end){if(W===null||pe===null)throw(0,T.$7)();let Re;return W?j.isPosition(W)?Re=W:(Re=W.start||this.start,pe=W.end||this.end):Re=this.start,Re.isEqual(this.c)&&pe.isEqual(this.end)?this:new c(Re,pe)}toJSON(){return[this.start,this.end]}};e.$gK=z,e.$gK=z=c=He([P],z);let F=r=class extends z{static isSelection(W){return W instanceof r?!0:W?z.isRange(W)&&j.isPosition(W.anchor)&&j.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,pe,Re,Qe){let tt,at;if(typeof W=="number"&&typeof pe=="number"&&typeof Re=="number"&&typeof Qe=="number"?(tt=new j(W,pe),at=new j(Re,Qe)):j.isPosition(W)&&j.isPosition(pe)&&(tt=j.of(W),at=j.of(pe)),!tt||!at)throw new Error("Invalid arguments");super(tt,at),this.f=tt,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$hK=F,e.$hK=F=r=He([P],F);const K=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,T.$7)("connectionToken")};class V{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe,Re){if(typeof W!="string"||W.length===0)throw(0,T.$7)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,T.$7)("port");typeof Re<"u"&&K(Re),this.host=W,this.port=Math.round(pe),this.connectionToken=Re}}e.$iK=V;class fe{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,pe){this.makeConnection=W,this.connectionToken=pe,typeof pe<"u"&&K(pe)}}e.$jK=fe;class Z extends Error{static NotAvailable(W,pe){return new Z(W,y.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(W){return new Z(W,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,pe=y.RemoteAuthorityResolverErrorCode.Unknown,Re){super(W),this._message=W,this._code=pe,this._detail=Re,Object.setPrototypeOf(this,Z.prototype)}}e.$kK=Z;var Q;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(Q||(e.EndOfLine=Q={}));var X;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(X||(e.EnvironmentVariableMutatorType=X={}));let oe=o=class{static isTextEdit(W){return W instanceof o?!0:W?z.isRange(W)&&typeof W.newText=="string":!1}static replace(W,pe){return new o(W,pe)}static insert(W,pe){return o.replace(new z(W,W),pe)}static delete(W){return o.replace(W,"")}static setEndOfLine(W){const pe=new o(new z(new j(0,0),new j(0,0)),"");return pe.newEol=W,pe}get range(){return this.c}set range(W){if(W&&!z.isRange(W))throw(0,T.$7)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,T.$7)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,T.$7)("newEol");this.f=W}constructor(W,pe){this.c=W,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$lK=oe,e.$lK=oe=o=He([P],oe);let x=m=class{static isNotebookCellEdit(W){return W instanceof m?!0:W?xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,pe){return new m(W,pe)}static insertCells(W,pe){return new m(new xt(W,W),pe)}static deleteCells(W){return new m(W,[])}static updateCellMetadata(W,pe){const Re=new m(new xt(W,W),[]);return Re.newCellMetadata=pe,Re}static updateNotebookMetadata(W){const pe=new m(new xt(0,0),[]);return pe.newNotebookMetadata=W,pe}constructor(W,pe){this.range=W,this.newCells=pe}};e.$mK=x,e.$mK=x=m=He([P],x);class ae{static isSnippetTextEdit(W){return W instanceof ae?!0:W?z.isRange(W.range)&&U.isSnippetString(W.snippet):!1}static replace(W,pe){return new ae(W,pe)}static insert(W,pe){return ae.replace(new z(W,W),pe)}constructor(W,pe){this.range=W,this.snippet=pe}}e.$nK=ae;var we;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let G=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,pe,Re,Qe){this.c.push({_type:1,from:W,to:pe,options:Re,metadata:Qe})}createFile(W,pe,Re){this.c.push({_type:1,from:void 0,to:W,options:pe,metadata:Re})}deleteFile(W,pe,Re){this.c.push({_type:1,from:W,to:void 0,options:pe,metadata:Re})}e(W,pe,Re){this.c.push({_type:3,metadata:Re,uri:W,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(W,pe,Re,Qe){const tt=pe.start,at=pe.end;(tt!==at||Re.length>0)&&this.c.push({_type:5,uri:W,index:tt,count:at-tt,cells:Re,metadata:Qe})}g(W,pe,Re,Qe){this.c.push({_type:3,metadata:Qe,uri:W,edit:{editType:3,index:pe,metadata:Re}})}replace(W,pe,Re,Qe){this.c.push({_type:2,uri:W,edit:new oe(pe,Re),metadata:Qe})}insert(W,pe,Re,Qe){this.replace(W,new z(pe,pe),Re,Qe)}delete(W,pe,Re){this.replace(W,pe,"",Re)}has(W){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===W.toString())}set(W,pe){if(pe)for(const Re of pe){if(!Re)continue;let Qe,tt;Array.isArray(Re)?(Qe=Re[0],tt=Re[1]):Qe=Re,x.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(W,Qe.range.start,Qe.newCellMetadata,tt):Qe.newNotebookMetadata?this.e(W,Qe.newNotebookMetadata,tt):this.f(W,Qe.range,Qe.newCells,tt):ae.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:W,range:Qe.range,edit:Qe.snippet,metadata:tt}):this.c.push({_type:2,uri:W,edit:Qe,metadata:tt})}else{for(let Re=0;Re<this.c.length;Re++){const Qe=this.c[Re];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===W.toString()&&(this.c[Re]=void 0);break}}(0,C.$Ib)(this.c)}}get(W){const pe=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===W.toString()&&pe.push(Re.edit);return pe}entries(){const W=new L.$Ac;for(const pe of this.c)if(pe._type===2){let Re=W.get(pe.uri);Re||(Re=[pe.uri,[]],W.set(pe.uri,Re)),Re[1].push(pe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$oK=G,e.$oK=G=He([P],G);let U=h=class{static isSnippetString(W){return W instanceof h?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=h.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,pe=this.e++){if(typeof W=="function"){const Re=new h;Re.e=this.e,W(Re),this.e=Re.e,W=Re.value}else W=h.c(W);return this.value+="${",this.value+=pe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,pe=this.e++){const Re=W.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(W,pe){if(typeof pe=="function"){const Re=new h;Re.e=this.e,pe(Re),this.e=Re.e,pe=Re.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$pK=U,e.$pK=U=h=He([P],U);var q;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var me;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(me||(e.DiagnosticSeverity=me={}));let ee=t=class{static isLocation(W){return W instanceof t?!0:W?z.isRange(W.range)&&v.URI.isUri(W.uri):!1}constructor(W,pe){if(this.uri=W,pe)if(z.isRange(pe))this.range=z.of(pe);else if(j.isPosition(pe))this.range=new z(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$qK=ee,e.$qK=ee=t=He([P],ee);let ne=class{static is(W){return W?typeof W.message=="string"&&W.location&&z.isRange(W.location.range)&&v.URI.isUri(W.location.uri):!1}constructor(W,pe){this.location=W,this.message=pe}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.location.range.isEqual(pe.location.range)&&W.location.uri.toString()===pe.location.uri.toString()}};e.$rK=ne,e.$rK=ne=He([P],ne);let re=class{constructor(W,pe,Re=me.Error){if(!z.isRange(W))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=W,this.message=pe,this.severity=Re}toJSON(){return{severity:me[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,pe){return W===pe?!0:!W||!pe?!1:W.message===pe.message&&W.severity===pe.severity&&W.code===pe.code&&W.severity===pe.severity&&W.source===pe.source&&W.range.isEqual(pe.range)&&(0,C.$ub)(W.tags,pe.tags)&&(0,C.$ub)(W.relatedInformation,pe.relatedInformation,ne.isEqual)}};e.$sK=re,e.$sK=re=He([P],re);let Ee=class{constructor(W,pe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=pe}};e.$tK=Ee,e.$tK=Ee=He([P],Ee);var ce;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(ce||(e.DocumentHighlightKind=ce={}));let de=class{constructor(W,pe=ce.Text){this.range=W,this.kind=pe}toJSON(){return{range:this.range,kind:ce[this.kind]}}};e.$uK=de,e.$uK=de=He([P],de);var te;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(te||(e.SymbolKind=te={}));var he;(function(H){H[H.Deprecated=1]="Deprecated"})(he||(e.SymbolTag=he={}));let be=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,pe,Re,Qe,tt){this.name=W,this.kind=pe,this.containerName=tt,typeof Re=="string"&&(this.containerName=Re),Qe instanceof ee?this.location=Qe:Re instanceof z&&(this.location=new ee(Qe,Re)),n.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};e.$vK=be,e.$vK=be=n=He([P],be);let Pe=a=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(a.validate)}constructor(W,pe,Re,Qe,tt){this.name=W,this.detail=pe,this.kind=Re,this.range=Qe,this.selectionRange=tt,this.children=[],a.validate(this)}};e.$wK=Pe,e.$wK=Pe=a=He([P],Pe);var B;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let J=class{constructor(W,pe){this.title=W,this.kind=pe}};e.$xK=J,e.$xK=J=He([P],J);let ie=class{static{i=this}static{this.c="."}constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.c)}};e.$yK=ie,e.$yK=ie=i=He([P],ie),ie.Empty=new ie(""),ie.QuickFix=ie.Empty.append("quickfix"),ie.Refactor=ie.Empty.append("refactor"),ie.RefactorExtract=ie.Refactor.append("extract"),ie.RefactorInline=ie.Refactor.append("inline"),ie.RefactorMove=ie.Refactor.append("move"),ie.RefactorRewrite=ie.Refactor.append("rewrite"),ie.Source=ie.Empty.append("source"),ie.SourceOrganizeImports=ie.Source.append("organizeImports"),ie.SourceFixAll=ie.Source.append("fixAll"),ie.Notebook=ie.Empty.append("notebook");let se=class{constructor(W,pe){if(this.range=W,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$zK=se,e.$zK=se=He([P],se);class Y{constructor(W,pe,Re,Qe,tt,at){this.kind=W,this.name=pe,this.detail=Re,this.uri=Qe,this.range=tt,this.selectionRange=at}}e.$AK=Y;class ge{constructor(W,pe){this.fromRanges=pe,this.from=W}}e.$BK=ge;class ye{constructor(W,pe){this.fromRanges=pe,this.to=W}}e.$CK=ye;var je;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let We=class{constructor(W,pe){this.range=W,this.command=pe}get isResolved(){return!!this.command}};e.$DK=We,e.$DK=We=He([P],We);let _e=s=class{#e;static isMarkdownString(W){return W instanceof s?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,pe=!1){this.#e=new d.$2j(W,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,pe){return this.#e.appendCodeblock(pe??"",W),this}};e.$EK=_e,e.$EK=_e=s=He([P],_e);let Ye=class{constructor(W,pe){this.label=W,this.documentation=pe}};e.$FK=Ye,e.$FK=Ye=He([P],Ye);let it=class{constructor(W,pe){this.label=W,this.documentation=pe,this.parameters=[]}};e.$GK=it,e.$GK=it=He([P],it);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$HK=et,e.$HK=et=He([P],et);var Ae;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Ne;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(Ne||(e.InlayHintKind=Ne={}));let qe=class{constructor(W){this.value=W}};e.$IK=qe,e.$IK=qe=He([P],qe);let Le=class{constructor(W,pe,Re){this.position=W,this.label=pe,this.kind=Re}};e.$JK=Le,e.$JK=Le=He([P],Le);var Xe;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe||(e.CompletionTriggerKind=Xe={}));var le;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(le||(e.CompletionItemKind=le={}));var ue;(function(H){H[H.Deprecated=1]="Deprecated"})(ue||(e.CompletionItemTag=ue={}));let Ie=class{constructor(W,pe){this.label=W,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$KK=Ie,e.$KK=Ie=He([P],Ie);let Ve=class{constructor(W=[],pe=!1){this.items=W,this.isIncomplete=pe}};e.$LK=Ve,e.$LK=Ve=He([P],Ve);let Ue=class{constructor(W,pe,Re){this.insertText=W,this.range=pe,this.command=Re}};e.$MK=Ue,e.$MK=Ue=He([P],Ue);let xe=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$NK=xe,e.$NK=xe=He([P],xe);var rt;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var ot;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function $t(H,W){return`${I.$4l.toKey(H)}.${W}`}e.$OK=$t;var St;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(St||(e.TextEditorLineNumbersStyle=St={}));var Yt;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Yt||(e.TextDocumentSaveReason=Yt={}));var Gt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Gt||(e.TextEditorRevealType=Gt={}));var vt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(vt||(e.TextEditorSelectionChangeKind=vt={}));var Ut;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Nt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(H){function W(pe){switch(pe){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=W}(vt||(e.TextEditorSelectionChangeKind=vt={}));var Bt;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(H){function W(pe){switch(pe){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=W}(Bt||(e.SyntaxTokenType=Bt={}));let At=class{constructor(W,pe){if(pe&&!v.URI.isUri(pe))throw(0,T.$7)("target");if(!z.isRange(W)||W.isEmpty)throw(0,T.$7)("range");this.range=W,this.target=pe}};e.$PK=At,e.$PK=At=He([P],At);let Rt=class{constructor(W,pe,Re,Qe){this.red=W,this.green=pe,this.blue=Re,this.alpha=Qe}};e.$QK=Rt,e.$QK=Rt=He([P],Rt);let Ot=class{constructor(W,pe){if(pe&&!(pe instanceof Rt))throw(0,T.$7)("color");if(!z.isRange(W)||W.isEmpty)throw(0,T.$7)("range");this.range=W,this.color=pe}};e.$RK=Ot,e.$RK=Ot=He([P],Ot);let Wt=class{constructor(W){if(!W||typeof W!="string")throw(0,T.$7)("label");this.label=W}};e.$SK=Wt,e.$SK=Wt=He([P],Wt);var Jt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var qt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(qt||(e.SourceControlInputBoxValidationType=qt={}));var Vt;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(Vt||(e.TerminalExitReason=Vt={}));class Lt{constructor(W,pe,Re){if(this.startIndex=W,this.length=pe,this.tooltip=Re,typeof W!="number"||W<0)throw(0,T.$7)("startIndex");if(typeof pe!="number"||pe<1)throw(0,T.$7)("length");if(Re!==void 0&&typeof Re!="string")throw(0,T.$7)("tooltip")}}e.$TK=Lt;class lt{constructor(W){this.uri=W}}e.$UK=lt;class ft{constructor(W){this.terminalCommand=W}}e.$VK=ft;var Ft;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(Ft||(e.TerminalLocation=Ft={}));class Kt{constructor(W){if(this.options=W,typeof W!="object")throw(0,T.$7)("options")}}e.$WK=Kt;var Dt;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Dt||(e.TaskRevealKind=Dt={}));var ct;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(ct||(e.TaskPanelKind=ct={}));let wt=class{static{l=this}static{this.Clean=new l("clean","Clean")}static{this.Build=new l("build","Build")}static{this.Rebuild=new l("rebuild","Rebuild")}static{this.Test=new l("test","Test")}static from(W){switch(W){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}constructor(W,pe){if(this.label=pe,typeof W!="string"||typeof pe!="string")throw(0,T.$7)("name");this.c=W}get id(){return this.c}};e.$XK=wt,e.$XK=wt=l=He([P],wt);function Ht(H){let W="";for(let pe=0;pe<H.length;pe++)W+=H[pe].replace(/,/g,",,")+",";return W}let Pt=class{constructor(W,pe,Re){if(typeof W!="string")throw(0,T.$7)("process");this.e=[],this.c=W,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Re):this.f=pe)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,T.$7)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)W.push(pe);return Ht(W)}};e.$YK=Pt,e.$YK=Pt=He([P],Pt);let Ge=class{constructor(W,pe,Re){if(this.f=[],Array.isArray(pe)){if(!W)throw(0,T.$7)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,T.$7)("command");this.e=W,this.f=pe,this.g=Re}else{if(typeof W!="string")throw(0,T.$7)("commandLine");this.c=W,this.g=pe}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,T.$7)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,T.$7)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)W.push(typeof pe=="string"?pe:pe.value);return Ht(W)}};e.$ZK=Ge,e.$ZK=Ge=He([P],Ge);var Me;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Me||(e.ShellQuoting=Me={}));var Te;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Te||(e.TaskScope=Te={}));class Se{constructor(W){this.c=W}computeId(){return"customExecution"+(0,R.$eg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$1K=Se;let _=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,pe,Re,Qe,tt,at){this.j=!1,this.k=this.definition=W;let dt;typeof pe=="string"?(this.m=this.name=pe,this.t=this.source=Re,this.execution=Qe,dt=tt,this.j=!0):pe===Te.Global||pe===Te.Workspace?(this.target=pe,this.m=this.name=Re,this.t=this.source=Qe,this.execution=tt,dt=at):(this.target=pe,this.m=this.name=Re,this.t=this.source=Qe,this.execution=tt,dt=at),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Pt?this.k={type:D.e,id:this.n.computeId()}:this.n instanceof Ge?this.k={type:D.f,id:this.n.computeId()}:this.n instanceof Se?this.k={type:D.c,id:this.n.computeId()}:this.k={type:D.g,id:(0,R.$eg)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,T.$7)("Kind can't be undefined or null");this.z(),this.k=W}get scope(){return this.l}set target(W){this.z(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,T.$7)("name");this.z(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.z(),this.n=W;const pe=this.k.type;(D.g===pe||D.e===pe||D.f===pe||D.c===pe)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.z(),this.o=W,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.z(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,T.$7)("source must be a string of length > 0");this.z(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.z(),this.u=W}get detail(){return this.y}set detail(W){W===null&&(W=void 0),this.y=W}get presentationOptions(){return this.w}set presentationOptions(W){W==null&&(W=Object.create(null)),this.z(),this.w=W}get runOptions(){return this.x}set runOptions(W){W==null&&(W=Object.create(null)),this.z(),this.x=W}};e.$2K=_,e.$2K=_=D=He([P],_);var Fe;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Fe||(e.ProgressLocation=Fe={}));var Ke;(function(H){function W(pe){const Re=pe;return(0,E.$Cf)(Re.value)?Re.tooltip&&!(0,E.$yf)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}H.isViewBadge=W})(Ke||(e.ViewBadge=Ke={}));let Ze=S=class{static isTreeItem(W,pe){const Re=W;if(Re.checkboxState!==void 0){const Qe=(0,E.$Cf)(Re.checkboxState)?Re.checkboxState:(0,E.$Af)(Re.checkboxState)&&(0,E.$Cf)(Re.checkboxState.state)?Re.checkboxState.state:void 0,tt=!(0,E.$Cf)(Re.checkboxState)&&(0,E.$Af)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==nt.Checked&&Qe!==nt.Unchecked||tt!==void 0&&!(0,E.$yf)(tt))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(W instanceof S)return!0;if(Re.label!==void 0&&!(0,E.$yf)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,E.$yf)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,E.$yf)(Re.iconPath)&&!v.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,E.$yf)(Re.iconPath.id))){const Qe=Re.iconPath;if(!Qe||!(0,E.$yf)(Qe.light)&&!v.URI.isUri(Qe.light)&&!(0,E.$yf)(Qe.dark)&&!v.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,E.$yf)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!v.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,E.$yf)(Re.tooltip)&&!(Re.tooltip instanceof _e)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<Je.None&&Re.collapsibleState>Je.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,E.$yf)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(W,pe=Je.None){this.collapsibleState=pe,v.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$3K=Ze,e.$3K=Ze=S=He([P],Ze);var Je;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Je||(e.TreeItemCollapsibleState=Je={}));var nt;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(nt||(e.TreeItemCheckboxState=nt={}));let pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$4K=pt,e.$4K=pt=He([P],pt);class jt extends pt{}e.$5K=jt;class kt extends jt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$6K=kt;class ht{constructor(W,pe,Re,Qe){this.name=W,this.uri=pe,this._itemId=Re,this.c=Qe}data(){return this.c()}}e.$7K=ht;let gt=class{#e=new Map;constructor(W){for(const[pe,Re]of W??[]){const Qe=this.#e.get(this.#t(pe));Qe?Qe.push(Re):this.#e.set(this.#t(pe),[Re])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,pe){this.#e.set(this.#t(W),[pe])}forEach(W,pe){for(const[Re,Qe]of this.#e)for(const tt of Qe)W.call(pe,tt,Re,this)}*[Symbol.iterator](){for(const[W,pe]of this.#e)for(const Re of pe)yield[W,Re]}#t(W){return W.toLowerCase()}};e.$8K=gt,e.$8K=gt=He([P],gt);let yt=class{constructor(W){this.insertText=W}};e.$9K=yt,e.$9K=yt=He([P],yt);let mi=class{constructor(W,pe){this.label=pe,this.insertText=W}};e.$0K=mi,e.$0K=mi=He([P],mi);let Ct=class{constructor(W,pe){this.id=W,this.color=pe}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$$K=Ct,e.$$K=Ct=He([P],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Di=class{constructor(W){this.id=W}};e.$_K=Di,e.$_K=Di=He([P],Di);var ui;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(ui||(e.ConfigurationTarget=ui={}));let $i=class{get base(){return this.c}set base(W){this.c=W,this.e=v.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,pe){if(typeof W!="string"&&(!W||!v.URI.isUri(W)&&!v.URI.isUri(W.uri)))throw(0,T.$7)("base");if(typeof pe!="string")throw(0,T.$7)("pattern");typeof W=="string"?this.baseUri=v.URI.file(W):v.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$aL=$i,e.$aL=$i=He([P],$i);const It=new WeakMap;function fn(H,W){It.set(H,W)}e.$bL=fn;let ri=class{constructor(W,pe,Re,Qe){this.enabled=typeof W=="boolean"?W:!0,typeof pe=="string"&&(this.condition=pe),typeof Re=="string"&&(this.hitCondition=Re),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this.c||(this.c=It.get(this)??(0,R.$eg)()),this.c}};e.$cL=ri,e.$cL=ri=He([P],ri);let Et=class extends ri{constructor(W,pe,Re,Qe,tt){if(super(pe,Re,Qe,tt),W===null)throw(0,T.$7)("location");this.location=W}};e.$dL=Et,e.$dL=Et=He([P],Et);let bi=class extends ri{constructor(W,pe,Re,Qe,tt){super(pe,Re,Qe,tt),this.functionName=W}};e.$eL=bi,e.$eL=bi=He([P],bi);let vi=class extends ri{constructor(W,pe,Re,Qe,tt,at,dt){if(super(Qe,tt,at,dt),!pe)throw(0,T.$7)("dataId");this.label=W,this.dataId=pe,this.canPersist=Re}};e.$fL=vi,e.$fL=vi=He([P],vi);let si=class{constructor(W,pe,Re){this.command=W,this.args=pe||[],this.options=Re}};e.$gL=si,e.$gL=si=He([P],si);let Ci=class{constructor(W,pe){this.port=W,this.host=pe}};e.$hL=Ci,e.$hL=Ci=He([P],Ci);let Ii=class{constructor(W){this.path=W}};e.$iL=Ii,e.$iL=Ii=He([P],Ii);let Mt=class{constructor(W){this.implementation=W}};e.$jL=Mt,e.$jL=Mt=He([P],Mt);let wi=class{constructor(W,pe,Re){this.session=W,this.threadId=pe,this.frameId=Re}};e.$kL=wi,e.$kL=wi=He([P],wi);let Pi=class{constructor(W,pe){this.session=W,this.threadId=pe}};e.$lL=Pi,e.$lL=Pi=He([P],Pi);let oi=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$mL=oi,e.$mL=oi=He([P],oi);var li;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(li||(e.InlineCompletionTriggerKind=li={}));let ut=class{constructor(W,pe){this.range=W,this.text=pe}};e.$nL=ut,e.$nL=ut=He([P],ut);let Ai=class{constructor(W,pe,Re=!0){this.range=W,this.variableName=pe,this.caseSensitiveLookup=Re}};e.$oL=Ai,e.$oL=Ai=He([P],Ai);let Zt=class{constructor(W,pe){this.range=W,this.expression=pe}};e.$pL=Zt,e.$pL=Zt=He([P],Zt);let ii=class{constructor(W,pe){this.frameId=W,this.stoppedLocation=pe}};e.$qL=ii,e.$qL=ii=He([P],ii);var Ri;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Li=b=class extends Error{static FileExists(W){return new b(W,w.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(W){return new b(W,w.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(W){return new b(W,w.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(W){return new b(W,w.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(W){return new b(W,w.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(W){return new b(W,w.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}constructor(W,pe=w.FileSystemProviderErrorCode.Unknown,Re){super(v.URI.isUri(W)?W.toString(!0):W),this.code=Re?.name??"Unknown",(0,w.$mk)(this,pe),Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$rL=Li,e.$rL=Li=b=He([P],Li);let Mi=class{constructor(W,pe,Re){this.start=W,this.end=pe,this.kind=Re}};e.$sL=Mi,e.$sL=Mi=He([P],Mi);var Xi;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Ti;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Ti||(e.CommentThreadCollapsibleState=Ti={}));var Yi;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(Yi||(e.CommentMode=Yi={}));var Fi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Fi||(e.CommentState=Fi={}));var ai;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class gn{constructor(W,pe=[]){this.tokenTypes=W,this.tokenModifiers=pe}}e.$tL=gn;function Ni(H){return typeof H>"u"||(0,E.$zf)(H)}class hi{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let pe=0,Re=W.tokenTypes.length;pe<Re;pe++)this.j.set(W.tokenTypes[pe],pe);for(let pe=0,Re=W.tokenModifiers.length;pe<Re;pe++)this.k.set(W.tokenModifiers[pe],pe)}}push(W,pe,Re,Qe,tt){if(typeof W=="number"&&typeof pe=="number"&&typeof Re=="number"&&typeof Qe=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.n(W,pe,Re,Qe,tt);if(z.isRange(W)&&typeof pe=="string"&&Ni(Re))return this.m(W,pe,Re);throw(0,T.$7)()}m(W,pe,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(pe))throw new Error("`tokenType` is not in the provided legend");const Qe=W.start.line,tt=W.start.character,at=W.end.character-W.start.character,dt=this.j.get(pe);let zt=0;if(Re)for(const Xt of Re){if(!this.k.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Xt);zt|=1<<ei>>>0}this.n(Qe,tt,at,dt,zt)}n(W,pe,Re,Qe,tt){if(this.f&&(W<this.c||W===this.c&&pe<this.e)){this.f=!1;const zt=this.g.length/5|0;let Xt=0,ei=0;for(let ti=0;ti<zt;ti++){let ni=this.g[5*ti],Ji=this.g[5*ti+1];ni===0?(ni=Xt,Ji+=ei):ni+=Xt,this.g[5*ti]=ni,this.g[5*ti+1]=Ji,Xt=ni,ei=Ji}}let at=W,dt=pe;this.f&&this.h>0&&(at-=this.c,at===0&&(dt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=dt,this.g[this.h++]=Re,this.g[this.h++]=Qe,this.g[this.h++]=tt,this.c=W,this.e=pe}static o(W){const pe=[],Re=W.length/5|0;for(let dt=0;dt<Re;dt++)pe[dt]=dt;pe.sort((dt,zt)=>{const Xt=W[5*dt],ei=W[5*zt];if(Xt===ei){const ti=W[5*dt+1],ni=W[5*zt+1];return ti-ni}return Xt-ei});const Qe=new Uint32Array(W.length);let tt=0,at=0;for(let dt=0;dt<Re;dt++){const zt=5*pe[dt],Xt=W[zt+0],ei=W[zt+1],ti=W[zt+2],ni=W[zt+3],Ji=W[zt+4],Cn=Xt-tt,Mn=Cn===0?ei-at:ei,Qi=5*dt;Qe[Qi+0]=Cn,Qe[Qi+1]=Mn,Qe[Qi+2]=ti,Qe[Qi+3]=ni,Qe[Qi+4]=Ji,tt=Xt,at=ei}return Qe}build(W){return this.f?new Oi(new Uint32Array(this.g),W):new Oi(hi.o(this.g),W)}}e.$uL=hi;class Oi{constructor(W,pe){this.resultId=pe,this.data=W}}e.$vL=Oi;class mn{constructor(W,pe,Re){this.start=W,this.deleteCount=pe,this.data=Re}}e.$wL=mn;class di{constructor(W,pe){this.resultId=pe,this.edits=W}}e.$xL=di;var Zi;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let ji=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.$yL=ji,e.$yL=ji=He([P],ji);var xi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var fi;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(fi||(e.InputBoxValidationSeverity=fi={}));var _i;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class $n{static validate(W){if(typeof W.badge=="string"){let pe=(0,$.$_e)(W.badge,0);if(pe<W.badge.length&&(pe+=(0,$.$_e)(W.badge,pe)),W.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Ct.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,pe,Re){this.badge=W,this.tooltip=pe,this.color=Re}}e.$zL=$n;let zi=class{constructor(W){this.kind=W}};e.$AL=zi,e.$AL=zi=He([P],zi);var gi;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(gi||(e.ColorThemeKind=gi={}));class xt{static isNotebookRange(W){return W instanceof xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,pe){if(W<0)throw(0,T.$7)("start must be positive");if(pe<0)throw(0,T.$7)("end must be positive");W<=pe?(this.c=W,this.e=pe):(this.c=pe,this.e=W)}with(W){let pe=this.c,Re=this.e;return W.start!==void 0&&(pe=W.start),W.end!==void 0&&(Re=W.end),pe===this.c&&Re===this.e?this:new xt(pe,Re)}}e.$BL=xt;class pi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(pe=>pi.isNotebookCellData(pe))}static isNotebookCellData(W){return!0}constructor(W,pe,Re,Qe,tt,at,dt){this.kind=W,this.value=pe,this.languageId=Re,this.mime=Qe,this.outputs=tt??[],this.metadata=at,this.executionSummary=dt,pi.validate(this)}}e.$CL=pi;class bn{constructor(W){this.cells=W}}e.$DL=bn;class Qt{static isNotebookCellOutputItem(W){return W instanceof Qt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const pe={name:W.name,message:W.message,stack:W.stack};return Qt.json(pe,"application/vnd.code.notebook.error")}static stdout(W){return Qt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Qt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,pe="application/octet-stream"){return new Qt(W,pe)}static#e=new TextEncoder;static text(W,pe=A.$Nr.text){const Re=Qt.#e.encode(String(W));return new Qt(Re,pe)}static json(W,pe="text/x-json"){const Re=JSON.stringify(W,void 0,"	");return Qt.text(Re,pe)}constructor(W,pe){this.data=W,this.mime=pe;const Re=(0,A.$Rr)(pe,!0);if(!Re)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$EL=Qt;class yi{static isNotebookCellOutput(W){return W instanceof yi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,pe=!1){const Re=new Set,Qe=new Set;for(let tt=0;tt<W.length;tt++){const at=W[tt],dt=(0,A.$Rr)(at.mime);if(!Re.has(dt)||(0,k.$mI)(dt)){Re.add(dt);continue}Qe.add(tt),pe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Qe.size===0?W:W.filter((tt,at)=>!Qe.has(at))}constructor(W,pe,Re){this.items=yi.ensureUniqueMimeTypes(W,!0),typeof pe=="string"?(this.id=pe,this.metadata=Re):(this.id=(0,R.$eg)(),this.metadata=pe??Re)}}e.$FL=yi;var en;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(en||(e.NotebookCellKind=en={}));var tn;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(tn||(e.NotebookCellExecutionState=tn={}));var nn;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(nn||(e.NotebookCellStatusBarAlignment=nn={}));var Ei;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class rn{constructor(W,pe){this.text=W,this.alignment=pe}}e.$GL=rn;var ze;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(ze||(e.NotebookControllerAffinity=ze={}));var _t;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class sn{constructor(W,pe=[]){this.uri=W,this.provides=(0,C.$3b)(pe)}}e.$HL=sn;class mt{constructor(W){this.label=W}}e.$IL=mt;let Ui=class{constructor(W,pe){this.label=W,this.timestamp=pe}};e.$JL=Ui,e.$JL=Ui=He([P],Ui);var on;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var Bi;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var an;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class ki{constructor(W,pe){this.ranges=W,this.wordPattern=pe}}e.$KL=ki;class vn{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$LL=vn;var cn;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Si=class{constructor(W=void 0,pe=void 0,Re=void 0,Qe=!1){this.include=W,this.exclude=pe,this.profile=Re,this.continuous=Qe}};e.$ML=Si,e.$ML=Si=He([P],Si);let Wi=f=class{static diff(W,pe,Re){const Qe=new f(W);return Qe.expectedOutput=pe,Qe.actualOutput=Re,Qe}constructor(W){this.message=W}};e.$NL=Wi,e.$NL=Wi=f=He([P],Wi);let qi=class{constructor(W){this.id=W}};e.$OL=qi,e.$OL=qi=He([P],qi);let ci=class{constructor(W,pe){this.covered=W,this.total=pe}};e.$PL=ci,e.$PL=ci=He([P],ci);let Vi=g=class{static fromDetails(W,pe){const Re=new ci(0,0),Qe=new ci(0,0),tt=new ci(0,0);for(const dt of pe)if("branches"in dt){Re.total+=1,Re.covered+=dt.executionCount>0?1:0;for(const zt of dt.branches)Qe.total+=1,Qe.covered+=zt.executionCount>0?1:0}else tt.total+=1,tt.covered+=dt.executionCount>0?1:0;const at=new g(W,Re,Qe.total>0?Qe:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=pe,at}constructor(W,pe,Re,Qe){this.uri=W,this.statementCoverage=pe,this.branchCoverage=Re,this.functionCoverage=Qe}};e.$QL=Vi,e.$QL=Vi=g=He([P],Vi);let Ki=class{constructor(W,pe,Re=[]){this.executionCount=W,this.location=pe,this.branches=Re}};e.$RL=Ki,e.$RL=Ki=He([P],Ki);let Hi=class{constructor(W,pe){this.executionCount=W,this.location=pe}};e.$SL=Hi,e.$SL=Hi=He([P],Hi);let Gi=class{constructor(W,pe){this.executionCount=W,this.location=pe}};e.$TL=Gi,e.$TL=Gi=He([P],Gi);var ln;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(ln||(e.ExternalUriOpenerPriority=ln={}));var hn;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(hn||(e.WorkspaceTrustState=hn={}));var dn;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(dn||(e.PortAutoForwardAction=dn={}));class ve{constructor(W,pe,Re,Qe,tt,at){this.kind=W,this.name=pe,this.detail=Re,this.uri=Qe,this.range=tt,this.selectionRange=at}}e.$UL=ve;class ke{constructor(W){this.uri=W}}e.$VL=ke;class Oe{constructor(W,pe){this.original=W,this.modified=pe}}e.$WL=Oe;class st{constructor(W,pe,Re,Qe){this.base=W,this.input1=pe,this.input2=Re,this.result=Qe}}e.$XL=st;class bt{constructor(W,pe){this.uri=W,this.viewType=pe}}e.$YL=bt;class Tt{constructor(W){this.viewType=W}}e.$ZL=Tt;class In{constructor(W,pe){this.uri=W,this.notebookType=pe}}e.$1L=In;class Pn{constructor(W,pe,Re){this.original=W,this.modified=pe,this.notebookType=Re}}e.$2L=Pn;class An{constructor(){}}e.$3L=An;class Rn{constructor(W,pe){this.uri=W,this.inputBoxUri=pe}}e.$4L=Rn;var wn;(function(H){H[H.Up=1]="Up",H[H.Down=2]="Down"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var pn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var yn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(H){H[H.System=0]="System",H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var kn;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(kn||(e.ChatVariableLevel=kn={}));class Ln{constructor(W,pe){this.role=W,this.content=pe}}e.$5L=Ln;var Sn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var Dn;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}))}),define(De[141],Ce([1,0,58,18,15,171,124,7,19]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=e.$gM=e.$fM=void 0;const v=new Map;function R(k,p){p?v.set(k,p):v.delete(k)}e.$fM=R;function I(k){return v.get(k)}class w extends L.$Su{constructor(p,u,c,r,o,m,h,t){super(u,c,r,o),this.c=p,this.m=m,this.q=h,this.notebook=t,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(p){return(0,E.$ub)(this.f,p)}get document(){if(!this.a){const p=this;this.a={get uri(){return p.d},get fileName(){return p.d.fsPath},get isUntitled(){return p.d.scheme===T.Schemas.untitled},get languageId(){return p.m},get version(){return p.h},get isClosed(){return p.b},get isDirty(){return p.q},save(){return p.r()},getText(u){return u?p.s(u):p.getText()},get eol(){return p.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return p.f.length},lineAt(u){return p.t(u)},offsetAt(u){return p.u(u)},positionAt(u){return p.v(u)},validateRange(u){return p.w(u)},validatePosition(u){return p.x(u)},getWordRangeAtPosition(u,c){return p.y(u,c)}}}return Object.freeze(this.a)}_acceptLanguageId(p){(0,C.ok)(!this.b),this.m=p}_acceptIsDirty(p){(0,C.ok)(!this.b),this.q=p}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(p){const u=this.w(p);if(u.isEmpty)return"";if(u.isSingleLine)return this.f[u.start.line].substring(u.start.character,u.end.character);const c=this.g,r=u.start.line,o=u.end.line,m=[];m.push(this.f[r].substring(u.start.character));for(let h=r+1;h<o;h++)m.push(this.f[h]);return m.push(this.f[o].substring(0,u.end.character)),m.join(c)}t(p){let u;if(p instanceof $.$fK?u=p.line:typeof p=="number"&&(u=p),typeof u!="number"||u<0||u>=this.f.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new y(u,this.f[u],u===this.f.length-1)}u(p){return p=this.x(p),this.l(),this.j.getPrefixSum(p.line-1)+p.character}v(p){p=Math.floor(p),p=Math.max(0,p),this.l();const u=this.j.getIndexOf(p),c=this.f[u.index].length;return new $.$fK(u.index,Math.min(u.remainder,c))}w(p){if(!(p instanceof $.$gK))throw new Error("Invalid argument");const u=this.x(p.start),c=this.x(p.end);return u===p.start&&c===p.end?p:new $.$gK(u.line,u.character,c.line,c.character)}x(p){if(!(p instanceof $.$fK))throw new Error("Invalid argument");if(this.f.length===0)return p.with(0,0);let{line:u,character:c}=p,r=!1;if(u<0)u=0,c=0,r=!0;else if(u>=this.f.length)u=this.f.length-1,c=this.f[u].length,r=!0;else{const o=this.f[u].length;c<0?(c=0,r=!0):c>o&&(c=o,r=!0)}return r?new $.$fK(u,c):p}y(p,u){const c=this.x(p);if(!u)u=I(this.m);else if((0,d.$Oe)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const r=(0,A.$6r)(c.character+1,(0,A.$4r)(u),this.f[c.line],0);if(r)return new $.$gK(c.line,r.startColumn-1,c.line,r.endColumn-1)}}e.$gM=w;class y{constructor(p,u,c){this.a=p,this.b=u,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$gK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$gK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$hM=y}),define(De[274],Ce([1,0,7,20,4]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;let L=class{constructor($){this.a=new C.$AL(C.ColorThemeKind.Dark),this.b=new d.$Nd}get activeColorTheme(){return this.a}$onColorThemeChange($){let E;switch($){case"light":E=C.ColorThemeKind.Light;break;case"hcDark":E=C.ColorThemeKind.HighContrast;break;case"hcLight":E=C.ColorThemeKind.HighContrastLight;break;default:E=C.ColorThemeKind.Dark}this.a=new C.$AL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$sdc=L,e.$sdc=L=He([Be(0,T.$dM)],L)}),define(De[275],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qI=e.CellExecutionUpdateType=void 0;var T;(function(d){d[d.Output=1]="Output",d[d.OutputItems=2]="OutputItems",d[d.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$qI=(0,C.$Oh)("INotebookExecutionService")}),define(De[68],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8I=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(L){L.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var T;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class d{static fromExtHostTestItem(A,$,E=A.parent){if(A._isRoot)return new d([$]);const v=[A.id];for(let R=E;R&&R.id!==$;R=R.parent)v.push(R.id);return v.push($),new d(v.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const $=A.indexOf("\0");return $===-1?A:A.slice(0,$)}static fromString(A){return new d(A.split("\0"))}static join(A,$){return new d([...A.path,$])}static joinToString(A,$){return A.toString()+"\0"+$}static parentId(A){const $=A.lastIndexOf("\0");return $===-1?void 0:A.slice(0,$)}static localId(A){const $=A.lastIndexOf("\0");return $===-1?A:A.slice($+1)}static isChild(A,$){return $.startsWith(A)&&$[A.length]==="\0"}static compare(A,$){return A===$?0:d.isChild(A,$)?2:d.isChild($,A)?3:1}constructor(A,$=A.length){if(this.path=A,this.d=$,A.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new d(this.path,1)}get parentId(){return this.d>1?new d(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new d(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new d(this.path,A)}compare(A){if(typeof A=="string")return d.compare(this.toString(),A);for(let $=0;$<A.d&&$<this.d;$++)if(A.path[$]!==this.path[$])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$8I=d}),define(De[87],Ce([1,0,2,34,68]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$bJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$aJ=e.$_I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$$I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$0I=e.$9I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var A;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var $;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$9I=[2,4,8,16,32,64];const E=S=>"runId"in S;e.$0I=E;var v;(function(S){S.serialize=b=>({range:b.range.toJSON(),uri:b.uri.toJSON()}),S.deserialize=b=>({range:T.$qs.lift(b.range),uri:C.URI.revive(b.uri)})})(v||(e.IRichLocation=v={}));var R;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(R||(e.TestMessageType=R={}));var I;(function(S){S.serialize=b=>({message:b.message,type:0,expected:b.expected,actual:b.actual,contextValue:b.contextValue,location:b.location&&v.serialize(b.location)}),S.deserialize=b=>({message:b.message,type:0,expected:b.expected,actual:b.actual,contextValue:b.contextValue,location:b.location&&v.deserialize(b.location)})})(I||(e.ITestErrorMessage=I={}));const w=(S,b)=>`${b?"s":"e"}${S}`;e.$$I=w;var y;(function(S){S.serialize=b=>({message:b.message,type:1,offset:b.offset,length:b.length,location:b.location&&v.serialize(b.location)}),S.deserialize=b=>({message:b.message,type:1,offset:b.offset,length:b.length,location:b.location&&v.deserialize(b.location)})})(y||(e.ITestOutputMessage=y={}));var k;(function(S){S.serialize=b=>b.type===0?I.serialize(b):y.serialize(b),S.deserialize=b=>b.type===0?I.deserialize(b):y.deserialize(b)})(k||(e.ITestMessage=k={}));var p;(function(S){S.serializeWithoutMessages=b=>({state:b.state,duration:b.duration,messages:[]}),S.serialize=b=>({state:b.state,duration:b.duration,messages:b.messages.map(k.serialize)}),S.deserialize=b=>({state:b.state,duration:b.duration,messages:b.messages.map(k.deserialize)})})(p||(e.ITestTaskState=p={}));const u="\0",c=(S,b)=>S+u+b;e.$_I=c;const r=S=>{const b=S.indexOf(u);return{ctrlId:S.slice(0,b),tagId:S.slice(b+1)}};e.$aJ=r;var o;(function(S){S.serialize=b=>({extId:b.extId,label:b.label,tags:b.tags,busy:b.busy,children:void 0,uri:b.uri?.toJSON(),range:b.range?.toJSON()||null,description:b.description,error:b.error,sortText:b.sortText}),S.deserialize=b=>({extId:b.extId,label:b.label,tags:b.tags,busy:b.busy,children:void 0,uri:b.uri?C.URI.revive(b.uri):void 0,range:b.range?T.$qs.lift(b.range):null,description:b.description,error:b.error,sortText:b.sortText})})(o||(e.ITestItem=o={}));var m;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(m||(e.TestItemExpandState=m={}));var h;(function(S){S.serialize=b=>({expand:b.expand,item:o.serialize(b.item)}),S.deserialize=b=>({controllerId:d.$8I.root(b.item.extId),expand:b.expand,item:o.deserialize(b.item)})})(h||(e.InternalTestItem=h={}));var t;(function(S){S.serialize=b=>{let f;return b.item&&(f={},b.item.label!==void 0&&(f.label=b.item.label),b.item.tags!==void 0&&(f.tags=b.item.tags),b.item.busy!==void 0&&(f.busy=b.item.busy),b.item.uri!==void 0&&(f.uri=b.item.uri?.toJSON()),b.item.range!==void 0&&(f.range=b.item.range?.toJSON()),b.item.description!==void 0&&(f.description=b.item.description),b.item.error!==void 0&&(f.error=b.item.error),b.item.sortText!==void 0&&(f.sortText=b.item.sortText)),{extId:b.extId,expand:b.expand,item:f}},S.deserialize=b=>{let f;return b.item&&(f={},b.item.label!==void 0&&(f.label=b.item.label),b.item.tags!==void 0&&(f.tags=b.item.tags),b.item.busy!==void 0&&(f.busy=b.item.busy),b.item.range!==void 0&&(f.range=b.item.range?T.$qs.lift(b.item.range):null),b.item.description!==void 0&&(f.description=b.item.description),b.item.error!==void 0&&(f.error=b.item.error),b.item.sortText!==void 0&&(f.sortText=b.item.sortText)),{extId:b.extId,expand:b.expand,item:f}}})(t||(e.ITestItemUpdate=t={}));const n=(S,b)=>{b.expand!==void 0&&(S.expand=b.expand),b.item!==void 0&&(S.item=S.item?Object.assign(S.item,b.item):b.item)};e.$bJ=n;var a;(function(S){S.serializeWithoutMessages=b=>({...h.serialize(b),ownComputedState:b.ownComputedState,computedState:b.computedState,tasks:b.tasks.map(p.serializeWithoutMessages)}),S.serialize=b=>({...h.serialize(b),ownComputedState:b.ownComputedState,computedState:b.computedState,tasks:b.tasks.map(p.serialize)}),S.deserialize=b=>({...h.deserialize(b),ownComputedState:b.ownComputedState,computedState:b.computedState,tasks:b.tasks.map(p.deserialize),retired:!0})})(a||(e.TestResultItem=a={}));var i;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(i||(e.DetailType=i={}));var s;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(s||(e.TestDiffOpType=s={}));var l;(function(S){S.deserialize=b=>b.op===0?{op:b.op,item:h.deserialize(b.item)}:b.op===1?{op:b.op,item:t.deserialize(b.item)}:b.op===2?{op:b.op,uri:C.URI.revive(b.uri),docv:b.docv}:b,S.serialize=b=>b.op===0?{op:b.op,item:h.serialize(b.item)}:b.op===1?{op:b.op,item:t.serialize(b.item)}:b})(l||(e.TestsDiffOp=l={}));class D{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(b){const f=this.p();for(const g of b)switch(g.op){case 0:this.k(h.deserialize(g.item),f);break;case 1:this.l(t.deserialize(g.item),f);break;case 3:this.m(g.itemId,f);break;case 5:this.o(g.itemId);break;case 4:this.updatePendingRoots(g.amount);break;case 6:this.d.set(g.tag.id,g.tag);break;case 7:this.d.delete(g.id);break}f.complete?.()}k(b,f){const g=d.$8I.parentId(b.item.extId)?.toString();let P;if(!g)P=this.q(b),this.g.add(P),this.f.set(b.item.extId,P);else if(this.f.has(g)){const N=this.f.get(g);N.children.add(b.item.extId),P=this.q(b,N),this.f.set(b.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(b)}`);return}return f.add?.(P),b.expand===2&&this.h++,P}l(b,f){const g=this.f.get(b.extId);if(g)return b.expand!==void 0&&(g.expand===2&&this.h--,b.expand===2&&this.h++),(0,e.$bJ)(g,b),f.update?.(g),g}m(b,f){const g=this.f.get(b);if(!g)return;const P=d.$8I.parentId(g.item.extId)?.toString();P?this.f.get(P).children.delete(g.item.extId):this.g.delete(g);const N=[[b]];for(;N.length;)for(const O of N.pop()){const M=this.f.get(O);M&&(N.push(M.children),this.f.delete(O),f.remove?.(M,M!==g),M.expand===2&&this.h--)}}o(b){}updatePendingRoots(b){this.j+=b}p(){return{}}}e.$cJ=D}),define(De[109],Ce([1,0,9,4,3,58,87,68]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.TestItemEventOp=void 0;var E;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const v=(r,o)=>r===o,I=Object.entries({range:(r,o)=>r===o?!0:!r||!o?!1:r.equalsRange(o),busy:v,label:v,description:v,error:v,sortText:v,tags:(r,o)=>!(r.length!==o.length||r.some(m=>!o.includes(m)))}),w=(r,o)=>{let m;for(const[h,t]of I)t(r[h],o[h])||(m?m[h]=o[h]:m={[h]:o[h]});return m};class y extends d.$Sc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new C.$6g(()=>this.flushDiff(),200)),this.g=this.B(new T.$Nd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(o){this.h=o;for(const m of this.tree.values())this.I(m)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const m of this.m)if(m.op===2&&m.uri===o.uri){m.docv=o.docv;return}break}case 1:{const m=this.m[this.m.length-1];if(m){if(m.op===1&&m.item.extId===o.item.extId){(0,A.$bJ)(m.item,o.item);return}if(m.op===0&&m.item.item.extId===o.item.extId){(0,A.$bJ)(m.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,m){const h=this.tree.get(o);if(h){if((h.expandLevels===void 0||m>h.expandLevels)&&(h.expandLevels=m),h.expand===1){const t=this.L(h);return t.isOpen()?this.J(h,m-1):t.wait().then(()=>this.J(h,m-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.J(h,m-1)):this.J(h,m-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(o,m){switch(m.op){case 3:this.N($.$8I.joinToString(o.fullId,m.id));break;case 0:this.y(m.item,o);break;case 5:for(const h of m.ops)this.u(o,h);break;case 1:this.z(m.new,m.old,o.fullId.toString());break;case 2:this.I(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:m.update}});break;case 6:this.w(o.actual.uri);break;default:(0,L.$4c)(m)}}w(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}y(o,m){const h=$.$8I.fromExtHostTestItem(o,this.root.id,m?.actual),t=this.s.getApiFor(o);t.parent&&t.parent!==m?.actual&&this.s.getChildren(t.parent).delete(o.id);let n=this.tree.get(h.toString());if(!n){n={fullId:h,actual:o,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},o.tags.forEach(this.C,this),this.tree.set(n.fullId.toString(),n),this.F(o,m),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:n.expand,item:this.s.toITestItem(o)}}),this.H(o,n,m);return}if(n.actual===o){this.G(o,n,m);return}if(n.actual.uri?.toString()!==o.uri?.toString())return this.N(h.toString()),this.y(o,m);const a=this.s.getChildren(n.actual),i=n.actual,s=w(this.s.toITestItem(i),this.s.toITestItem(o));this.s.getApiFor(i).listener=void 0,n.actual=o,n.expand=0,s&&(s.hasOwnProperty("tags")&&(this.z(o.tags,i.tags,h.toString()),delete s.tags),this.u(n,{op:4,update:s})),this.H(o,n,m);for(const[l,D]of a)this.s.getChildren(o).get(D.id)||this.N($.$8I.joinToString(h,D.id));this.w(n.actual.uri)}z(o,m,h){const t=new Set(m.map(n=>n.id));for(const n of o)t.delete(n.id)||this.C(n);this.pushDiff({op:1,item:{extId:h,item:{tags:o.map(n=>(0,A.$_I)(this.s.controllerId,n.id))}}}),t.forEach(this.D,this)}C(o){const m=this.j.get(o.id);m?m.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$_I)(this.s.controllerId,o.id)}}))}D(o){const m=this.j.get(o);m&&!--m.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,A.$_I)(this.s.controllerId,o)}))}F(o,m){this.s.getApiFor(o).parent=m&&m.actual!==this.root?m.actual:void 0}G(o,m,h){this.F(o,h);const t=this.s.getApiFor(o);t.parent=h?.actual,t.listener=n=>this.u(m,n),this.I(m)}H(o,m,h){this.G(o,m,h);for(const[t,n]of this.s.getChildren(o))this.y(n,m)}I(o){let m;this.h?o.resolveBarrier?m=o.resolveBarrier.isOpen()?3:2:m=o.actual.canResolveChildren?1:0:m=0,m!==o.expand&&(o.expand=m,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:m}}),m===1&&o.expandLevels!==void 0&&this.L(o))}J(o,m){if(m<0)return;const h=[];for(const[t,n]of this.s.getChildren(o.actual)){const a=this.expand($.$8I.joinToString(o.fullId,n.id),m);(0,C.$Gg)(a)&&h.push(a)}if(h.length)return Promise.all(h).then(()=>{})}L(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const n=new C.$Sg;return n.open(),n}o.expand=2,this.M(o);const m=o.resolveBarrier=new C.$Sg,h=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,n)};let t;try{t=this.h(o.actual===this.root?void 0:o.actual)}catch(n){h(n)}return(0,C.$Gg)(t)?t.catch(h).then(()=>{m.open(),this.I(o)}):(m.open(),this.I(o)),o.resolveBarrier}M(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}N(o){const m=this.tree.get(o);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const h=[m];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const n of t.actual.tags)this.D(n.id);this.tree.delete(t.fullId.toString());for(const[n,a]of this.s.getChildren(t.actual))h.push(this.tree.get($.$8I.joinToString(t.fullId,a.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$6L=y;class k extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$7L=k;class p extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$8L=p;class u extends Error{constructor(o,m,h){super(`TestItem with ID "${o}" is from controller "${m}" and cannot be added as a child of an item from controller "${h}".`)}}e.$9L=u;const c=(r,o,m)=>{let h=new Map;return{get size(){return h.size},forEach(t,n){for(const a of h.values())t.call(n,a,this)},[Symbol.iterator](){return h.entries()},replace(t){const n=new Map,a=new Set(h.keys()),i={op:5,ops:[]};for(const s of t){if(!(s instanceof m))throw new p(s.id);const l=o(s).controllerId;if(l!==r.controllerId)throw new u(s.id,l,r.controllerId);if(n.has(s.id))throw new k(s.id);n.set(s.id,s),a.delete(s.id),i.ops.push({op:0,item:s})}for(const s of a.keys())i.ops.push({op:3,id:s});r.listener?.(i),h=n},add(t){if(!(t instanceof m))throw new p(t.id);h.set(t.id,t),r.listener?.({op:0,item:t})},delete(t){h.delete(t)&&r.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$0L=c}),define(De[142],Ce([1,0,109]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=void 0;const T=new WeakMap,d=(A,$)=>{const E={controllerId:$};return T.set(A,E),E};e.$$L=d;const L=A=>{const $=T.get(A);if(!$)throw new C.$8L(A?.id||"<unknown>");return $};e.$_L=L}),define(De[110],Ce([1,0,18,2]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ob=e.$5ob=e.$4ob=e.$3ob=e.$2ob=void 0,e.$2ob="vscode-cdn.net",e.$3ob=`vscode-resource.${e.$2ob}`,e.$4ob=`'self' https://*.${e.$2ob}`;function d($,E){return $.scheme===C.Schemas.http||$.scheme===C.Schemas.https?$:(E&&E.authority&&E.isRemote&&$.scheme===C.Schemas.file&&($=T.URI.from({scheme:C.Schemas.vscodeRemote,authority:E.authority,path:$.path})),T.URI.from({scheme:C.Schemas.https,authority:`${$.scheme}+${L($.authority)}.${e.$3ob}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$5ob=d;function L($){return $.replace(/./g,E=>{const v=E.charCodeAt(0);return v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57?E:"-"+v.toString(16).padStart(4,"0")})}function A($){return $.replace(/-([0-9a-f]{4})/g,(E,v)=>String.fromCharCode(parseInt(v,16)))}e.$6ob=A}),define(De[276],Ce([1,0,4,3,110]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;class L{constructor($,E,v){this.d=$,this.e=E,this.f=v,this.a=0,this.b=new T.$Rc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const R=E.getVisibleTextEditors();for(const I of this.c.values())R.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,E,v,R,I){let w;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===$){w=o;break}if(!w)throw new Error("not a visible editor");const y=this,k=this.a++,p=new C.$Nd,u=new C.$Nd,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,d.$5ob)(o,y.f)}get cspSource(){return d.$4ob}set options(o){this.b=o,y.d.$setOptions(k,o)}get options(){return this.b}set html(o){this.a=o,y.d.$setHtml(k,o)}get html(){return this.a}get onDidReceiveMessage(){return p.event}postMessage(o){return y.d.$postMessage(k,o)}},r=new class{constructor(){this.editor=$,this.line=E,this.height=v,this.webview=c,this.onDidDispose=u.event}dispose(){y.c.has(k)&&(y.c.delete(k),y.d.$disposeEditorInset(k),u.fire(),u.dispose(),p.dispose())}};return this.d.$createEditorInset(k,w.id,w.value.document.uri,E+1,v,R||{},I.identifier,I.extensionLocation),this.c.set(k,{editor:$,inset:r,onDidReceiveMessage:p}),r}$onDidDispose($){const E=this.c.get($);E&&E.inset.dispose()}$onDidReceiveMessage($,E){this.c.get($)?.onDidReceiveMessage.fire(E)}}e.$3cc=L}),define(De[277],Ce([1,0,5]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3M=e.VariableKind=e.$2M=void 0,e.$2M=(0,C.$Oh)("configurationResolverService");var T;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class d extends Error{constructor(A,$){super($),this.variable=A}}e.$3M=d}),define(De[278],Ce([1,0,16,48,17,24,12,99,223,277,15]),function($e,e,C,T,d,L,A,$,E,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,k,p,u){this.h=new Map,this.a=y,this.b=k,this.g=p,u&&(this.c=u.then(c=>this.i(c)))}i(y){if(A.$j){const k=Object.create(null);return Object.keys(y).forEach(p=>{k[p.toLowerCase()]=y[p]}),k}return y}resolveWithEnvironment(y,k,p){return this.l({env:this.i(y),userHome:void 0},k?k.uri:void 0,p)}async resolveAsync(y,k){const p={env:await this.c,userHome:await this.g};return this.l(p,y?y.uri:void 0,k)}async j(y,k,p,u){const c=L.$4m(k);A.$j&&c.windows?Object.keys(c.windows).forEach(o=>c[o]=c.windows[o]):A.$k&&c.osx?Object.keys(c.osx).forEach(o=>c[o]=c.osx[o]):A.$l&&c.linux&&Object.keys(c.linux).forEach(o=>c[o]=c.linux[o]),delete c.windows,delete c.osx,delete c.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,y?y.uri:void 0,c,p,u)}async resolveAnyAsync(y,k,p){return this.j(y,k,p)}async resolveAnyMap(y,k,p){const u=new Map;return{newConfig:await this.j(y,k,p,u),resolvedVariables:u}}resolveWithInteractionReplace(y,k,p,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,k,p,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,k){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,k)}async l(y,k,p,u,c){if(d.$yf(p))return this.m(y,k,p,u,c);if(Array.isArray(p))return Promise.all(p.map(r=>this.l(y,k,r,u,c)));if(d.$Af(p)){const r=Object.create(null),o=await Promise.all(Object.keys(p).map(async m=>[await this.m(y,k,m,u,c),await this.l(y,k,p[m],u,c)]));for(const[m,h]of o)r[m]=h;return r}return p}m(y,k,p,u,c){return(0,R.$Te)(p,I.VARIABLE_REGEXP,async(r,o)=>{if(o.includes(I.VARIABLE_LHS))return r;let m=await this.o(y,r,o,k,u);return c?.set(o,m),m!==r&&d.$yf(m)&&m.match(I.VARIABLE_REGEXP)&&(m=await this.m(y,k,m,u,c)),m})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,k,p,u,c){let r;const o=p.split(":");o.length>1&&(p=o[0],r=o[1]);const m=n=>{const a=this.a.getFilePath();if(a)return(0,$.$ov)(a);throw new v.$3M(n,(0,E.localize)(0,null,k))},h=n=>{const a=m(n);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,$.$ov)(i)}throw new v.$3M(n,(0,E.localize)(1,null,k,C.$nc(a)))},t=n=>{if(r){const a=this.a.getFolderUri(r);if(a)return a;throw new v.$3M(n,(0,E.localize)(2,null,k,r))}if(u)return u;throw this.a.getWorkspaceFolderCount()>1?new v.$3M(n,(0,E.localize)(3,null,k)):new v.$3M(n,(0,E.localize)(4,null,k))};switch(p){case"env":if(r){if(y.env){const n=y.env[A.$j?r.toLowerCase():r];if(d.$yf(n))return n}return""}throw new v.$3M(v.VariableKind.Env,(0,E.localize)(5,null,k));case"config":if(r){const n=this.a.getConfigurationValue(u,r);if(d.$Hf(n))throw new v.$3M(v.VariableKind.Config,(0,E.localize)(6,null,k,r));if(d.$Af(n))throw new v.$3M(v.VariableKind.Config,(0,E.localize)(7,null,k,r));return n}throw new v.$3M(v.VariableKind.Config,(0,E.localize)(8,null,k));case"command":return this.p(v.VariableKind.Command,k,r,c,"command");case"input":return this.p(v.VariableKind.Input,k,r,c,"input");case"extensionInstallFolder":if(r){const n=await this.a.getExtension(r);if(!n)throw new v.$3M(v.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,k,r));return this.n(n.extensionLocation)}throw new v.$3M(v.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,k));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,$.$ov)(this.n(t(v.VariableKind.WorkspaceFolder)));case"cwd":return u||r?(0,$.$ov)(this.n(t(v.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$ov)(C.$nc(this.n(t(v.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new v.$3M(v.VariableKind.UserHome,(0,E.localize)(11,null,k))}case"lineNumber":{const n=this.a.getLineNumber();if(n)return n;throw new v.$3M(v.VariableKind.LineNumber,(0,E.localize)(12,null,k))}case"selectedText":{const n=this.a.getSelectedText();if(n)return n;throw new v.$3M(v.VariableKind.SelectedText,(0,E.localize)(13,null,k))}case"file":return m(v.VariableKind.File);case"fileWorkspaceFolder":return h(v.VariableKind.FileWorkspaceFolder);case"relativeFile":return u||r?C.$lc(this.n(t(v.VariableKind.RelativeFile)),m(v.VariableKind.RelativeFile)):m(v.VariableKind.RelativeFile);case"relativeFileDirname":{const n=C.$mc(m(v.VariableKind.RelativeFileDirname));if(u||r){const a=C.$lc(this.n(t(v.VariableKind.RelativeFileDirname)),n);return a.length===0?".":a}return n}case"fileDirname":return C.$mc(m(v.VariableKind.FileDirname));case"fileExtname":return C.$oc(m(v.VariableKind.FileExtname));case"fileBasename":return C.$nc(m(v.VariableKind.FileBasename));case"fileBasenameNoExtension":{const n=C.$nc(m(v.VariableKind.FileBasenameNoExtension));return n.slice(0,n.length-C.$oc(n).length)}case"fileDirnameBasename":return C.$nc(C.$mc(m(v.VariableKind.FileDirnameBasename)));case"execPath":{const n=this.a.getExecPath();return n||k}case"execInstallFolder":{const n=this.a.getAppRoot();return n||k}case"pathSeparator":return C.sep;default:try{const n=r?`${p}:${r}`:p;return this.p(v.VariableKind.Unknown,k,n,c,void 0)}catch{return k}}}}p(y,k,p,u,c){if(p&&u){const r=c===void 0?u[p]:u[c+":"+p];if(typeof r=="string")return r;throw new v.$3M(y,(0,E.localize)(14,null,k))}return k}}e.$eN=I}),define(De[143],Ce([1,0,5,139]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=e.$cC=e.OpenEditorContext=e.GroupsOrder=e.$bC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$aC=void 0,e.$aC=(0,C.$Oh)("editorGroupsService");var d;(function(k){k[k.UP=0]="UP",k[k.DOWN=1]="DOWN",k[k.LEFT=2]="LEFT",k[k.RIGHT=3]="RIGHT"})(d||(e.GroupDirection=d={}));var L;(function(k){k[k.HORIZONTAL=0]="HORIZONTAL",k[k.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function(k){k[k.FIRST=0]="FIRST",k[k.LAST=1]="LAST",k[k.NEXT=2]="NEXT",k[k.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var $;(function(k){k[k.MAXIMIZE=0]="MAXIMIZE",k[k.EVEN=1]="EVEN",k[k.TOGGLE=2]="TOGGLE"})($||(e.GroupsArrangement=$={}));var E;(function(k){k[k.COPY_EDITORS=0]="COPY_EDITORS",k[k.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function v(k){const p=k;return(0,T.$3D)(p?.editor)&&(0,T.$3D)(p?.replacement)}e.$bC=v;var R;(function(k){k[k.CREATION_TIME=0]="CREATION_TIME",k[k.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",k[k.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var I;(function(k){k[k.NEW_EDITOR=1]="NEW_EDITOR",k[k.MOVE_EDITOR=2]="MOVE_EDITOR",k[k.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function w(k){const p=k;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.$cC=w;function y(k){return k.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$dC=y}),define(De[279],Ce([1,0,5,143]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hC=e.$gC=e.$fC=e.$eC=void 0,e.$eC=(0,C.$Oh)("editorService"),e.$fC=-1,e.$gC=-2;function d(L){const A=L;return typeof L=="number"||(0,T.$cC)(A)}e.$hC=d}),define(De[13],Ce([1,0,19,22,162,75,80,28,158,62,97,24,17,2,34,83,133,142,139,108,68,87,279,7]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r,o,m,h,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$cM=e.$bM=e.MarkdownString=e.$aM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(Me){function Te(_){const{selectionStartLineNumber:Fe,selectionStartColumn:Ke,positionLineNumber:Ze,positionColumn:Je}=_,nt=new n.$fK(Fe-1,Ke-1),pt=new n.$fK(Ze-1,Je-1);return new n.$hK(nt,pt)}Me.to=Te;function Se(_){const{anchor:Fe,active:Ke}=_;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ke.line+1,positionColumn:Ke.character+1}}Me.from=Se})(a||(e.Selection=a={}));var i;(function(Me){function Te(_){if(!_)return;const{start:Fe,end:Ke}=_;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ke.line+1,endColumn:Ke.character+1}}Me.from=Te;function Se(_){if(!_)return;const{startLineNumber:Fe,startColumn:Ke,endLineNumber:Ze,endColumn:Je}=_;return new n.$gK(Fe-1,Ke-1,Ze-1,Je-1)}Me.to=Se})(i||(e.Range=i={}));var s;(function(Me){function Te(Se){switch(Se){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}Me.to=Te})(s||(e.TokenType=s={}));var l;(function(Me){function Te(_){return new n.$fK(_.lineNumber-1,_.column-1)}Me.to=Te;function Se(_){return{lineNumber:_.line+1,column:_.character+1}}Me.from=Se})(l||(e.Position=l={}));var D;(function(Me){function Te(Fe,Ke,Ze){return(0,C.$Hb)((0,C.$3b)(Fe).map(Je=>Se(Je,Ke,Ze)))}Me.from=Te;function Se(Fe,Ke,Ze){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:Ze?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:_(Fe.scheme,Ke),pattern:Xe.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:Ze?.isBuiltin}}function _(Fe,Ke){return Ke&&typeof Fe=="string"?Ke.transformOutgoingScheme(Fe):Fe}})(D||(e.DocumentSelector=D={}));var S;(function(Me){function Te(_){switch(_){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function Se(_){switch(_){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}Me.to=Se})(S||(e.DiagnosticTag=S={}));var b;(function(Me){function Te(_){let Fe;return _.code&&((0,w.$yf)(_.code)||(0,w.$Cf)(_.code)?Fe=String(_.code):Fe={value:String(_.code.value),target:_.code.target}),{...i.from(_.range),message:_.message,source:_.source,code:Fe,severity:g.from(_.severity),relatedInformation:_.relatedInformation&&_.relatedInformation.map(f.from),tags:Array.isArray(_.tags)?(0,C.$Hb)(_.tags.map(S.from)):void 0}}Me.from=Te;function Se(_){const Fe=new n.$sK(i.to(_),_.message,g.to(_.severity));return Fe.source=_.source,Fe.code=(0,w.$yf)(_.code)?_.code:_.code?.value,Fe.relatedInformation=_.relatedInformation&&_.relatedInformation.map(f.to),Fe.tags=_.tags&&(0,C.$Hb)(_.tags.map(S.to)),Fe}Me.to=Se})(b||(e.Diagnostic=b={}));var f;(function(Me){function Te(_){return{...i.from(_.location.range),message:_.message,resource:_.location.uri}}Me.from=Te;function Se(_){return new n.$rK(new n.$qK(_.resource,i.to(_)),_.message)}Me.to=Se})(f||(e.DiagnosticRelatedInformation=f={}));var g;(function(Me){function Te(_){switch(_){case n.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}Me.from=Te;function Se(_){switch(_){case u.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}Me.to=Se})(g||(e.DiagnosticSeverity=g={}));var P;(function(Me){function Te(_){return typeof _=="number"&&_>=n.ViewColumn.One?_-1:_===n.ViewColumn.Beside?t.$gC:t.$fC}Me.from=Te;function Se(_){if(typeof _=="number"&&_>=0)return _+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Se})(P||(e.ViewColumn=P={}));function N(Me){return typeof Me.range<"u"}function O(Me){return Me.length===0?!0:!!N(Me[0])}e.$aM=O;var M;(function(Me){function Te(Je){return Je.map(Me.from)}Me.fromMany=Te;function Se(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function _(Je){let nt;if(Se(Je)){const{language:ht,value:gt}=Je;nt={value:"```"+ht+`
`+gt+"\n```\n"}}else n.$EK.isMarkdownString(Je)?nt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?nt={value:Je}:nt={value:""};const pt=Object.create(null);nt.uris=pt;const jt=ht=>{try{let gt=y.URI.parse(ht,!0);gt=gt.with({query:Fe(gt.query,pt)}),pt[ht]=gt}catch{}return""},kt=new E.marked.Renderer;return kt.link=jt,kt.image=ht=>typeof ht=="string"?jt(A.$9j(ht).href):"",(0,E.marked)(nt.value,{renderer:kt}),nt}Me.from=_;function Fe(Je,nt){if(!Je)return Je;let pt;try{pt=(0,v.$kh)(Je)}catch{}if(!pt)return Je;let jt=!1;return pt=(0,I.$6m)(pt,kt=>{if(y.URI.isUri(kt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[ht]=kt,jt=!0,ht}else return}),jt?JSON.stringify(pt):Je}function Ke(Je){const nt=new n.$EK(Je.value,Je.supportThemeIcons);return nt.isTrusted=Je.isTrusted,nt.supportHtml=Je.supportHtml,nt.baseUri=Je.baseUri?y.URI.from(Je.baseUri):void 0,nt}Me.to=Ke;function Ze(Je){if(Je)return typeof Je=="string"?Je:Me.from(Je)}Me.fromStrict=Ze})(M||(e.MarkdownString=M={}));function j(Me){return O(Me)?Me.map(Te=>({range:i.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?M.fromMany(Te.hoverMessage):Te.hoverMessage?M.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:i.from(Te)}))}e.$bM=j;function z(Me){return typeof Me>"u"?Me:typeof Me=="string"?y.URI.file(Me):Me}e.$cM=z;var F;(function(Me){function Te(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?z(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Me.from=Te})(F||(e.ThemableDecorationAttachmentRenderOptions=F={}));var K;(function(Me){function Te(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?z(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?F.from(Se.before):void 0,after:Se.after?F.from(Se.after):void 0}}Me.from=Te})(K||(e.ThemableDecorationRenderOptions=K={}));var V;(function(Me){function Te(Se){if(typeof Se>"u")return Se;switch(Se){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(V||(e.DecorationRangeBehavior=V={}));var fe;(function(Me){function Te(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?V.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?K.from(Se.light):void 0,dark:Se.dark?K.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?z(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?F.from(Se.before):void 0,after:Se.after?F.from(Se.after):void 0}}Me.from=Te})(fe||(e.DecorationRenderOptions=fe={}));var Z;(function(Me){function Te(_){return{text:_.newText,eol:_.newEol&&et.from(_.newEol),range:i.from(_.range)}}Me.from=Te;function Se(_){const Fe=new n.$lK(i.to(_.range),_.text);return Fe.newEol=typeof _.eol>"u"?void 0:et.to(_.eol),Fe}Me.to=Se})(Z||(e.TextEdit=Z={}));var Q;(function(Me){function Te(_,Fe){const Ke={edits:[]};if(_ instanceof n.$oK){const Ze=new $.$Bc;for(const Je of _._allEntries())Je._type===1&&y.URI.isUri(Je.to)&&Je.from===void 0&&Ze.add(Je.to);for(const Je of _._allEntries())if(Je._type===1){let nt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?nt={type:"base64",value:(0,T.$ve)(T.$be.wrap(Je.options.contents))}:nt={type:"dataTransferItem",id:Je.options.contents._itemId}),Ke.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:nt},metadata:Je.metadata})}else Je._type===2?Ke.edits.push({resource:Je.uri,textEdit:Z.from(Je.edit),versionId:Ze.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?Ke.edits.push({resource:Je.uri,textEdit:{range:i.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:Ze.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?Ke.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&Ke.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(ot.from)}})}return Ke}Me.from=Te;function Se(_){const Fe=new n.$oK,Ke=new $.$Ac;for(const Ze of _.edits)if(Ze.textEdit){const Je=Ze,nt=y.URI.revive(Je.resource),pt=i.to(Je.textEdit.range),jt=Je.textEdit.text,kt=Je.textEdit.insertAsSnippet;let ht;kt?ht=n.$nK.replace(pt,new n.$pK(jt)):ht=n.$lK.replace(pt,jt);const gt=Ke.get(nt);gt?gt.push(ht):Ke.set(nt,[ht])}else Fe.renameFile(y.URI.revive(Ze.oldResource),y.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Je]of Ke)Fe.set(Ze,Je);return Fe}Me.to=Se})(Q||(e.WorkspaceEdit=Q={}));var X;(function(Me){const Te=Object.create(null);Te[n.SymbolKind.File]=0,Te[n.SymbolKind.Module]=1,Te[n.SymbolKind.Namespace]=2,Te[n.SymbolKind.Package]=3,Te[n.SymbolKind.Class]=4,Te[n.SymbolKind.Method]=5,Te[n.SymbolKind.Property]=6,Te[n.SymbolKind.Field]=7,Te[n.SymbolKind.Constructor]=8,Te[n.SymbolKind.Enum]=9,Te[n.SymbolKind.Interface]=10,Te[n.SymbolKind.Function]=11,Te[n.SymbolKind.Variable]=12,Te[n.SymbolKind.Constant]=13,Te[n.SymbolKind.String]=14,Te[n.SymbolKind.Number]=15,Te[n.SymbolKind.Boolean]=16,Te[n.SymbolKind.Array]=17,Te[n.SymbolKind.Object]=18,Te[n.SymbolKind.Key]=19,Te[n.SymbolKind.Null]=20,Te[n.SymbolKind.EnumMember]=21,Te[n.SymbolKind.Struct]=22,Te[n.SymbolKind.Event]=23,Te[n.SymbolKind.Operator]=24,Te[n.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Te[Fe]=="number"?Te[Fe]:6}Me.from=Se;function _(Fe){for(const Ke in Te)if(Te[Ke]===Fe)return Number(Ke);return n.SymbolKind.Property}Me.to=_})(X||(e.SymbolKind=X={}));var oe;(function(Me){function Te(_){switch(_){case n.SymbolTag.Deprecated:return 1}}Me.from=Te;function Se(_){switch(_){case 1:return n.SymbolTag.Deprecated}}Me.to=Se})(oe||(e.SymbolTag=oe={}));var x;(function(Me){function Te(_){return{name:_.name,kind:X.from(_.kind),tags:_.tags&&_.tags.map(oe.from),containerName:_.containerName,location:q.from(_.location)}}Me.from=Te;function Se(_){const Fe=new n.$vK(_.name,X.to(_.kind),_.containerName,q.to(_.location));return Fe.tags=_.tags&&_.tags.map(oe.to),Fe}Me.to=Se})(x||(e.WorkspaceSymbol=x={}));var ae;(function(Me){function Te(_){const Fe={name:_.name||"!!MISSING: name!!",detail:_.detail,range:i.from(_.range),selectionRange:i.from(_.selectionRange),kind:X.from(_.kind),tags:_.tags?.map(oe.from)??[]};return _.children&&(Fe.children=_.children.map(Te)),Fe}Me.from=Te;function Se(_){const Fe=new n.$wK(_.name,_.detail,X.to(_.kind),i.to(_.range),i.to(_.selectionRange));return(0,C.$Lb)(_.tags)&&(Fe.tags=_.tags.map(oe.to)),_.children&&(Fe.children=_.children.map(Se)),Fe}Me.to=Se})(ae||(e.DocumentSymbol=ae={}));var we;(function(Me){function Te(_){const Fe=new n.$AK(X.to(_.kind),_.name,_.detail||"",y.URI.revive(_.uri),i.to(_.range),i.to(_.selectionRange));return Fe._sessionId=_._sessionId,Fe._itemId=_._itemId,Fe}Me.to=Te;function Se(_,Fe,Ke){if(Fe=Fe??_._sessionId,Ke=Ke??_._itemId,Fe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ke,name:_.name,detail:_.detail,kind:X.from(_.kind),uri:_.uri,range:i.from(_.range),selectionRange:i.from(_.selectionRange),tags:_.tags?.map(oe.from)}}Me.from=Se})(we||(e.CallHierarchyItem=we={}));var G;(function(Me){function Te(Se){return new n.$BK(we.to(Se.from),Se.fromRanges.map(_=>i.to(_)))}Me.to=Te})(G||(e.CallHierarchyIncomingCall=G={}));var U;(function(Me){function Te(Se){return new n.$CK(we.to(Se.to),Se.fromRanges.map(_=>i.to(_)))}Me.to=Te})(U||(e.CallHierarchyOutgoingCall=U={}));var q;(function(Me){function Te(_){return{range:_.range&&i.from(_.range),uri:_.uri}}Me.from=Te;function Se(_){return new n.$qK(y.URI.revive(_.uri),i.to(_.range))}Me.to=Se})(q||(e.location=q={}));var me;(function(Me){function Te(_){const Fe=_,Ke=_;return{originSelectionRange:Fe.originSelectionRange?i.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ke.uri,range:i.from(Fe.targetRange?Fe.targetRange:Ke.range),targetSelectionRange:Fe.targetSelectionRange?i.from(Fe.targetSelectionRange):void 0}}Me.from=Te;function Se(_){return{targetUri:y.URI.revive(_.uri),targetRange:i.to(_.range),targetSelectionRange:_.targetSelectionRange?i.to(_.targetSelectionRange):void 0,originSelectionRange:_.originSelectionRange?i.to(_.originSelectionRange):void 0}}Me.to=Se})(me||(e.DefinitionLink=me={}));var ee;(function(Me){function Te(_){return{range:i.from(_.range),contents:M.fromMany(_.contents)}}Me.from=Te;function Se(_){return new n.$tK(_.contents.map(M.to),i.to(_.range))}Me.to=Se})(ee||(e.Hover=ee={}));var ne;(function(Me){function Te(_){return{range:i.from(_.range),expression:_.expression}}Me.from=Te;function Se(_){return new n.$mL(i.to(_.range),_.expression)}Me.to=Se})(ne||(e.EvaluatableExpression=ne={}));var re;(function(Me){function Te(_){if(_ instanceof n.$nL)return{type:"text",range:i.from(_.range),text:_.text};if(_ instanceof n.$oL)return{type:"variable",range:i.from(_.range),variableName:_.variableName,caseSensitiveLookup:_.caseSensitiveLookup};if(_ instanceof n.$pL)return{type:"expression",range:i.from(_.range),expression:_.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function Se(_){switch(_.type){case"text":return{range:i.to(_.range),text:_.text};case"variable":return{range:i.to(_.range),variableName:_.variableName,caseSensitiveLookup:_.caseSensitiveLookup};case"expression":return{range:i.to(_.range),expression:_.expression}}}Me.to=Se})(re||(e.InlineValue=re={}));var Ee;(function(Me){function Te(_){return{frameId:_.frameId,stoppedLocation:i.from(_.stoppedLocation)}}Me.from=Te;function Se(_){return new n.$qL(_.frameId,i.to(_.stoppedLocation))}Me.to=Se})(Ee||(e.InlineValueContext=Ee={}));var ce;(function(Me){function Te(_){return{range:i.from(_.range),kind:_.kind}}Me.from=Te;function Se(_){return new n.$uK(i.to(_.range),_.kind)}Me.to=Se})(ce||(e.DocumentHighlight=ce={}));var de;(function(Me){function Te(Se){switch(Se){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}Me.to=Te})(de||(e.CompletionTriggerKind=de={}));var te;(function(Me){function Te(Se){return{triggerKind:de.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Me.to=Te})(te||(e.CompletionContext=te={}));var he;(function(Me){function Te(_){switch(_){case n.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function Se(_){switch(_){case 1:return n.CompletionItemTag.Deprecated}}Me.to=Se})(he||(e.CompletionItemTag=he={}));var be;(function(Me){const Te=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function Se(Ke){return Te.get(Ke)??9}Me.from=Se;const _=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Fe(Ke){return _.get(Ke)??n.CompletionItemKind.Property}Me.to=Fe})(be||(e.CompletionItemKind=be={}));var Pe;(function(Me){function Te(Se,_){const Fe=new n.$KK(Se.label);return Fe.insertText=Se.insertText,Fe.kind=be.to(Se.kind),Fe.tags=Se.tags?.map(he.to),Fe.detail=Se.detail,Fe.documentation=A.$4j(Se.documentation)?M.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,k.$qs.isIRange(Se.range)?Fe.range=i.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:i.to(Se.range.insert),replacing:i.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new n.$pK(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof n.$gK?new n.$lK(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(Ke=>Z.to(Ke))),Fe.command=_&&Se.command?_.fromInternal(Se.command):void 0,Fe}Me.to=Te})(Pe||(e.CompletionItem=Pe={}));var B;(function(Me){function Te(_){if(typeof _.label!="string"&&!Array.isArray(_.label))throw new TypeError("Invalid label");return{label:_.label,documentation:M.fromStrict(_.documentation)}}Me.from=Te;function Se(_){return{label:_.label,documentation:A.$4j(_.documentation)?M.to(_.documentation):_.documentation}}Me.to=Se})(B||(e.ParameterInformation=B={}));var J;(function(Me){function Te(_){return{label:_.label,documentation:M.fromStrict(_.documentation),parameters:Array.isArray(_.parameters)?_.parameters.map(B.from):[],activeParameter:_.activeParameter}}Me.from=Te;function Se(_){return{label:_.label,documentation:A.$4j(_.documentation)?M.to(_.documentation):_.documentation,parameters:Array.isArray(_.parameters)?_.parameters.map(B.to):[],activeParameter:_.activeParameter}}Me.to=Se})(J||(e.SignatureInformation=J={}));var ie;(function(Me){function Te(_){return{activeSignature:_.activeSignature,activeParameter:_.activeParameter,signatures:Array.isArray(_.signatures)?_.signatures.map(J.from):[]}}Me.from=Te;function Se(_){return{activeSignature:_.activeSignature,activeParameter:_.activeParameter,signatures:Array.isArray(_.signatures)?_.signatures.map(J.to):[]}}Me.to=Se})(ie||(e.SignatureHelp=ie={}));var se;(function(Me){function Te(Se,_){const Fe=new n.$JK(l.to(_.position),typeof _.label=="string"?_.label:_.label.map(Y.to.bind(void 0,Se)),_.kind&&ge.to(_.kind));return Fe.textEdits=_.textEdits&&_.textEdits.map(Z.to),Fe.tooltip=A.$4j(_.tooltip)?M.to(_.tooltip):_.tooltip,Fe.paddingLeft=_.paddingLeft,Fe.paddingRight=_.paddingRight,Fe}Me.to=Te})(se||(e.InlayHint=se={}));var Y;(function(Me){function Te(Se,_){const Fe=new n.$IK(_.label);return Fe.tooltip=A.$4j(_.tooltip)?M.to(_.tooltip):_.tooltip,p.Command.is(_.command)&&(Fe.command=Se.fromInternal(_.command)),_.location&&(Fe.location=q.to(_.location)),Fe}Me.to=Te})(Y||(e.InlayHintLabelPart=Y={}));var ge;(function(Me){function Te(_){return _}Me.from=Te;function Se(_){return _}Me.to=Se})(ge||(e.InlayHintKind=ge={}));var ye;(function(Me){function Te(_){return{range:i.from(_.range),url:_.target,tooltip:_.tooltip}}Me.from=Te;function Se(_){let Fe;if(_.url)try{Fe=typeof _.url=="string"?y.URI.parse(_.url,!0):y.URI.revive(_.url)}catch{}return new n.$PK(i.to(_.range),Fe)}Me.to=Se})(ye||(e.DocumentLink=ye={}));var je;(function(Me){function Te(_){const Fe=new n.$SK(_.label);return _.textEdit&&(Fe.textEdit=Z.to(_.textEdit)),_.additionalTextEdits&&(Fe.additionalTextEdits=_.additionalTextEdits.map(Ke=>Z.to(Ke))),Fe}Me.to=Te;function Se(_){return{label:_.label,textEdit:_.textEdit?Z.from(_.textEdit):void 0,additionalTextEdits:_.additionalTextEdits?_.additionalTextEdits.map(Fe=>Z.from(Fe)):void 0}}Me.from=Se})(je||(e.ColorPresentation=je={}));var We;(function(Me){function Te(_){return new n.$QK(_[0],_[1],_[2],_[3])}Me.to=Te;function Se(_){return[_.red,_.green,_.blue,_.alpha]}Me.from=Se})(We||(e.Color=We={}));var _e;(function(Me){function Te(_){return{range:i.from(_.range)}}Me.from=Te;function Se(_){return new n.$zK(i.to(_.range))}Me.to=Se})(_e||(e.SelectionRange=_e={}));var Ye;(function(Me){function Te(Se){switch(Se){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}Me.to=Te})(Ye||(e.TextDocumentSaveReason=Ye={}));var it;(function(Me){function Te(_){switch(_){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function Se(_){switch(_){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}Me.to=Se})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Me){function Te(_){if(_===n.EndOfLine.CRLF)return 1;if(_===n.EndOfLine.LF)return 0}Me.from=Te;function Se(_){if(_===1)return n.EndOfLine.CRLF;if(_===0)return n.EndOfLine.LF}Me.to=Se})(et||(e.EndOfLine=et={}));var Ae;(function(Me){function Te(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(Ae||(e.ProgressLocation=Ae={}));var Ne;(function(Me){function Te(_){const Fe={start:_.start+1,end:_.end+1};return _.kind&&(Fe.kind=qe.from(_.kind)),Fe}Me.from=Te;function Se(_){const Fe={start:_.start-1,end:_.end-1};return _.kind&&(Fe.kind=qe.to(_.kind)),Fe}Me.to=Se})(Ne||(e.FoldingRange=Ne={}));var qe;(function(Me){function Te(_){if(_)switch(_){case n.FoldingRangeKind.Comment:return p.$ft.Comment;case n.FoldingRangeKind.Imports:return p.$ft.Imports;case n.FoldingRangeKind.Region:return p.$ft.Region}}Me.from=Te;function Se(_){if(_)switch(_.value){case p.$ft.Comment.value:return n.FoldingRangeKind.Comment;case p.$ft.Imports.value:return n.FoldingRangeKind.Imports;case p.$ft.Region.value:return n.FoldingRangeKind.Region}}Me.to=Se})(qe||(e.FoldingRangeKind=qe={}));var Le;(function(Me){function Te(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?i.from(Se.selection):void 0,override:typeof Se.override=="boolean"?r.$PD.id:void 0}}Me.from=Te})(Le||(e.TextEditorOpenOptions=Le={}));var Xe;(function(Me){function Te(Ke){return Ke instanceof n.$aL?Ke.toJSON():typeof Ke=="string"?Ke:Se(Ke)||_(Ke)?new n.$aL(Ke.baseUri??Ke.base,Ke.pattern).toJSON():Ke}Me.from=Te;function Se(Ke){const Ze=Ke;return Ze?y.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function _(Ke){const Ze=Ke;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Fe(Ke){return typeof Ke=="string"?Ke:new n.$aL(y.URI.revive(Ke.baseUri),Ke.pattern)}Me.to=Fe})(Xe||(e.GlobPattern=Xe={}));var le;(function(Me){function Te(Se){if(Se){if(Array.isArray(Se))return Se.map(Te);if(typeof Se=="string")return Se;{const _=Se;return{language:_.language,scheme:_.scheme,pattern:Xe.from(_.pattern),exclusive:_.exclusive,notebookType:_.notebookType}}}else return}Me.from=Te})(le||(e.LanguageSelector=le={}));var ue;(function(Me){function Te(_){return!!_&&typeof _=="object"&&"documents"in _&&Array.isArray(_.documents)&&_.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Ke=>Ke&&typeof Ke=="object"&&"uri"in Ke&&y.URI.isUri(Ke.uri)&&"version"in Ke&&typeof Ke.version=="number"&&"ranges"in Ke&&Array.isArray(Ke.ranges)&&Ke.ranges.every(Ze=>Ze instanceof n.$gK)))}Me.is=Te;function Se(_){return{documents:_.documents.map(Fe=>Fe.map(Ke=>({uri:y.URI.from(Ke.uri),version:Ke.version,ranges:Ke.ranges.map(Ze=>i.from(Ze))})))}}Me.from=Se})(ue||(e.MappedEditsContext=ue={}));var Ie;(function(Me){function Te(_){return{start:_.start,end:_.end}}Me.from=Te;function Se(_){return new n.$BL(_.start,_.end)}Me.to=Se})(Ie||(e.NotebookRange=Ie={}));var Ve;(function(Me){function Te(_){return{timing:typeof _.runStartTime=="number"&&typeof _.runEndTime=="number"?{startTime:_.runStartTime,endTime:_.runEndTime}:void 0,executionOrder:_.executionOrder,success:_.lastRunSuccess}}Me.to=Te;function Se(_){return{lastRunSuccess:_.success,runStartTime:_.timing?.startTime,runEndTime:_.timing?.endTime,executionOrder:_.executionOrder}}Me.from=Se})(Ve||(e.NotebookCellExecutionSummary=Ve={}));var Ue;(function(Me){function Te(Se){if(Se===o.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(Se===o.NotebookCellExecutionState.Pending)return;if(Se===o.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Me.to=Te})(Ue||(e.NotebookCellExecutionState=Ue={}));var xe;(function(Me){function Te(_){switch(_){case n.NotebookCellKind.Markup:return o.CellKind.Markup;case n.NotebookCellKind.Code:default:return o.CellKind.Code}}Me.from=Te;function Se(_){switch(_){case o.CellKind.Markup:return n.NotebookCellKind.Markup;case o.CellKind.Code:default:return n.NotebookCellKind.Code}}Me.to=Se})(xe||(e.NotebookCellKind=xe={}));var rt;(function(Me){function Te(_){const Fe={metadata:_.metadata??Object.create(null),cells:[]};for(const Ke of _.cells)n.$CL.validate(Ke),Fe.cells.push(ot.from(Ke));return Fe}Me.from=Te;function Se(_){const Fe=new n.$DL(_.cells.map(ot.to));return(0,w.$Lf)(_.metadata)||(Fe.metadata=_.metadata),Fe}Me.to=Se})(rt||(e.NotebookData=rt={}));var ot;(function(Me){function Te(_){return{cellKind:xe.from(_.kind),language:_.languageId,mime:_.mime,source:_.value,metadata:_.metadata,internalMetadata:Ve.from(_.executionSummary??{}),outputs:_.outputs?_.outputs.map(St.from):[]}}Me.from=Te;function Se(_){return new n.$CL(xe.to(_.cellKind),_.source,_.language,_.mime,_.outputs?_.outputs.map(St.to):void 0,_.metadata,_.internalMetadata?Ve.to(_.internalMetadata):void 0)}Me.to=Se})(ot||(e.NotebookCellData=ot={}));var $t;(function(Me){function Te(_){return{mime:_.mime,valueBytes:T.$be.wrap(_.data)}}Me.from=Te;function Se(_){return new n.$EL(_.valueBytes.buffer,_.mime)}Me.to=Se})($t||(e.NotebookCellOutputItem=$t={}));var St;(function(Me){function Te(_){return{outputId:_.id,items:_.items.map($t.from),metadata:_.metadata}}Me.from=Te;function Se(_){const Fe=_.items.map($t.to);return new n.$FL(Fe,_.outputId,_.metadata)}Me.to=Se})(St||(e.NotebookCellOutput=St={}));var Yt;(function(Me){function Te(Fe){return _(Fe)?{include:Xe.from(Fe.include)??void 0,exclude:Xe.from(Fe.exclude)??void 0}:Xe.from(Fe)??void 0}Me.from=Te;function Se(Fe){return _(Fe)?{include:Xe.to(Fe.include),exclude:Xe.to(Fe.exclude)}:Xe.to(Fe)}Me.to=Se;function _(Fe){const Ke=Fe;return Ke?!(0,w.$Hf)(Ke.include)&&!(0,w.$Hf)(Ke.exclude):!1}})(Yt||(e.NotebookExclusiveDocumentPattern=Yt={}));var Gt;(function(Me){function Te(Se,_,Fe){const Ke=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:_.toInternal(Ke,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Me.from=Te})(Gt||(e.NotebookStatusBarItem=Gt={}));var vt;(function(Me){function Te(Se,_,Fe){const Ke=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:_.toInternal(Ke,Fe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Me.from=Te})(vt||(e.NotebookKernelSourceAction=vt={}));var Ut;(function(Me){function Te(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Me.from=Te})(Ut||(e.NotebookDocumentContentOptions=Ut={}));var Nt;(function(Me){function Te(_){return{uri:_.uri,provides:_.provides}}Me.from=Te;function Se(_){return new n.$HL(y.URI.revive(_.uri),_.provides)}Me.to=Se})(Nt||(e.NotebookRendererScript=Nt={}));var Bt;(function(Me){function Te(_){return{message:M.fromStrict(_.message)||"",type:0,expected:_.expectedOutput,actual:_.actualOutput,contextValue:_.contextValue,location:_.location&&{range:i.from(_.location.range),uri:_.location.uri}}}Me.from=Te;function Se(_){const Fe=new n.$NL(typeof _.message=="string"?_.message:M.to(_.message));return Fe.actualOutput=_.actual,Fe.expectedOutput=_.expected,Fe.contextValue=_.contextValue,Fe.location=_.location?q.to(_.location):void 0,Fe}Me.to=Se})(Bt||(e.TestMessage=Bt={}));var At;(function(Me){Me.namespace=h.$_I,Me.denamespace=h.$aJ})(At||(e.TestTag=At={}));var Rt;(function(Me){function Te(_){const Fe=(0,c.$_L)(_).controllerId;return{extId:m.$8I.fromExtHostTestItem(_,Fe).toString(),label:_.label,uri:y.URI.revive(_.uri),busy:_.busy,tags:_.tags.map(Ke=>At.namespace(Fe,Ke.id)),range:k.$qs.lift(i.from(_.range)),description:_.description||null,sortText:_.sortText||null,error:_.error&&M.fromStrict(_.error)||null}}Me.from=Te;function Se(_){return{parent:void 0,error:void 0,id:m.$8I.fromString(_.extId).localId,label:_.label,uri:y.URI.revive(_.uri),tags:(_.tags||[]).map(Fe=>{const{tagId:Ke}=At.denamespace(Fe);return new n.$OL(Ke)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(_.range||void 0),canResolveChildren:!1,busy:_.busy,description:_.description||void 0,sortText:_.sortText||void 0}}Me.toPlain=Se})(Rt||(e.TestItem=Rt={})),function(Me){function Te(_){return{id:_.id}}Me.from=Te;function Se(_){return new n.$OL(_.id)}Me.to=Se}(At||(e.TestTag=At={}));var Ot;(function(Me){const Te=(_,Fe)=>{const Ke=[];for(const[Je,nt]of Fe)m.$8I.compare(nt.item.extId,Je)===2&&(Fe.delete(Je),Ke.push(nt));const Ze={...Rt.toPlain(_.item),parent:void 0,taskStates:_.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(nt=>nt.type===0).map(Bt.to)})),children:Ke.map(Je=>Te(Je,Fe))};for(const Je of Ze.children)Je.parent=Ze;return Ze};function Se(_){const Fe=[],Ke=new Map;for(const Ze of _.items){Ke.set(Ze.item.extId,Ze);const Je=m.$8I.root(Ze.item.extId);_.request.targets.some(nt=>nt.controllerId===Je&&nt.testIds.includes(Ze.item.extId))&&Fe.push(Ze)}return{completedAt:_.completedAt,results:Fe.map(Ze=>Te(Ze,Ke))}}Me.to=Se})(Ot||(e.TestResults=Ot={}));var Wt;(function(Me){function Te(Ke){return{covered:Ke.covered,total:Ke.covered}}function Se(Ke){return"line"in Ke?l.from(Ke):i.from(Ke)}function _(Ke){return"branches"in Ke?{count:Ke.executionCount,location:Se(Ke.location),type:1,branches:Ke.branches.length?Ke.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&Se(Ze.location)})):void 0}:{type:0,count:Ke.executionCount,location:Se(Ke.location)}}Me.fromDetailed=_;function Fe(Ke){return{uri:Ke.uri,statement:Te(Ke.statementCoverage),branch:Ke.branchCoverage&&Te(Ke.branchCoverage),function:Ke.functionCoverage&&Te(Ke.functionCoverage),details:Ke.detailedCoverage?.map(_)}}Me.fromFile=Fe})(Wt||(e.TestCoverage=Wt={}));var Jt;(function(Me){function Te(Se){switch(Se){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}Me.to=Te})(Jt||(e.CodeActionTriggerKind=Jt={}));var qt;(function(Me){function Te(_){const Fe=new n.$UL(X.to(_.kind),_.name,_.detail||"",y.URI.revive(_.uri),i.to(_.range),i.to(_.selectionRange));return Fe._sessionId=_._sessionId,Fe._itemId=_._itemId,Fe}Me.to=Te;function Se(_,Fe,Ke){if(Fe=Fe??_._sessionId,Ke=Ke??_._itemId,Fe===void 0||Ke===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ke,kind:X.from(_.kind),name:_.name,detail:_.detail??"",uri:_.uri,range:i.from(_.range),selectionRange:i.from(_.selectionRange),tags:_.tags?.map(oe.from)}}Me.from=Se})(qt||(e.TypeHierarchyItem=qt={}));var Vt;(function(Me){function Te(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Me.from=Te})(Vt||(e.ViewBadge=Vt={}));var Lt;(function(Me){function Te(Ke,Ze,Je){const nt=Ze.fileData;return nt?new n.$6K(new n.$7K(nt.name,y.URI.revive(nt.uri),nt.id,(0,L.$db)(()=>Je(nt.id)))):Ke===R.$Nr.uriList&&Ze.uriListData?new n.$5K(Fe(Ze.uriListData)):new n.$5K(Ze.asString)}Me.to=Te;async function Se(Ke,Ze){const Je=await Ze.asString();if(Ke===R.$Nr.uriList)return{asString:Je,fileData:void 0,uriListData:_(Je)};const nt=Ze.asFile();return{asString:Je,fileData:nt?{name:nt.name,uri:nt.uri,id:nt._itemId??nt.id}:void 0}}Me.from=Se;function _(Ke){return d.$Zs.split(Ke).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return y.URI.parse(Ze)}catch{}return Ze})}function Fe(Ke){return d.$Zs.create(Ke.map(Ze=>typeof Ze=="string"?Ze:y.URI.revive(Ze)))}})(Lt||(e.DataTransferItem=Lt={}));var lt;(function(Me){function Te(_,Fe){const Ke=_.items.map(([Ze,Je])=>[Ze,Lt.to(Ze,Je,Fe)]);return new n.$8K(Ke)}Me.toDataTransfer=Te;async function Se(_){const Fe={items:[]},Ke=[];for(const[Ze,Je]of _)Ke.push((async()=>{Fe.items.push([Ze,await Lt.from(Ze,Je)])})());return await Promise.all(Ke),Fe}Me.from=Se})(lt||(e.DataTransfer=lt={}));var ft;(function(Me){function Te(_){return{message:_.message,metadata:_.metadata,title:_.title,tooltip:_.tooltip}}Me.to=Te;function Se(_){return{kind:"reply",message:_.message,metadata:_.metadata,title:_.title,tooltip:_.tooltip}}Me.from=Se})(ft||(e.ChatReplyFollowup=ft={}));var Ft;(function(Me){function Te(Se){return typeof Se=="string"?{title:Se,message:Se,kind:"reply"}:"commandId"in Se?{kind:"command",title:Se.title??"",commandId:Se.commandId??"",when:Se.when??"",args:Se.args}:ft.from(Se)}Me.from=Te})(Ft||(e.ChatFollowup=Ft={}));var Kt;(function(Me){function Te(_){const Fe=new n.$5L(Dt.to(_.role),_.content);return Fe.name=_.name,Fe}Me.to=Te;function Se(_){return{role:Dt.from(_.role),content:_.content,name:_.name}}Me.from=Se})(Kt||(e.ChatMessage=Kt={}));var Dt;(function(Me){function Te(_){switch(_){case 0:return n.ChatMessageRole.System;case 1:return n.ChatMessageRole.User;case 2:return n.ChatMessageRole.Assistant;case 3:return n.ChatMessageRole.Function}}Me.to=Te;function Se(_){switch(_){case n.ChatMessageRole.System:return 0;case n.ChatMessageRole.Assistant:return 2;case n.ChatMessageRole.Function:return 3;case n.ChatMessageRole.User:default:return 1}}Me.from=Se})(Dt||(e.ChatMessageRole=Dt={}));var ct;(function(Me){function Te(_){return{level:wt.to(_.level),value:_.value,description:_.description}}Me.to=Te;function Se(_){return{level:wt.from(_.level),value:_.value,description:_.description}}Me.from=Se})(ct||(e.ChatVariable=ct={}));var wt;(function(Me){function Te(_){switch(_){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}Me.to=Te;function Se(_){switch(_){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}Me.from=Se})(wt||(e.ChatVariableLevel=wt={}));var Ht;(function(Me){function Te(Se){switch(Se){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Te})(Ht||(e.InteractiveEditorResponseFeedbackKind=Ht={}));var Pt;(function(Me){function Te(Se){return"placeholder"in Se&&"resolvedContent"in Se?{placeholder:Se.placeholder}:"responseId"in Se?{requestId:Se.responseId}:"content"in Se?{content:typeof Se.content=="string"?Se.content:M.from(Se.content)}:"documents"in Se?{documents:Se.documents.map(_=>({uri:_.uri,version:_.version,ranges:_.ranges.map(Fe=>i.from(Fe))}))}:"reference"in Se?{reference:"uri"in Se.reference?{uri:Se.reference.uri,range:i.from(Se.reference.range)}:Se.reference}:"inlineReference"in Se?{inlineReference:"uri"in Se.inlineReference?{uri:Se.inlineReference.uri,range:i.from(Se.inlineReference.range)}:Se.inlineReference,title:Se.title}:Se}Me.from=Te})(Pt||(e.ChatResponseProgress=Pt={}));var Ge;(function(Me){function Te(Se,_,Fe){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand}:"uri"in Se?{uri:Se.uri}:_.toInternal(Se,Fe)}Me.from=Te})(Ge||(e.TerminalQuickFix=Ge={}))}),define(De[280],Ce([1,0,2,8,7,13,76]),function($e,e,C,T,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=void 0;class ${constructor(v,R,I,w={timeout:1500,errors:3}){this.c=v,this.d=R,this.f=I,this.g=w,this.a=new A.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(v){return(R,I,w)=>{const k={dispose:this.a.push([R,I,v])};return Array.isArray(w)&&w.push(k),k}}async $participateInSave(v,R){const I=C.URI.revive(v);let w=!1;const y=setTimeout(()=>w=!0,this.g.timeout),k=[];try{for(const p of[...this.a]){if(w)break;const u=this.d.getDocument(I),c=await this.h(p,{document:u,reason:L.TextDocumentSaveReason.to(R)});k.push(c)}}finally{clearTimeout(y)}return k}h([v,R,I],w){const y=this.b.get(v);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(I,v,R,w).then(()=>!0,k=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(k),!(k instanceof Error)||k.message!=="concurrent_edits"){const p=this.b.get(v);this.b.set(v,p?p+1:1),typeof p=="number"&&p>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(v,R,I,w){const y=[],k=Date.now(),{document:p,reason:u}=w,{version:c}=p,r=Object.freeze({document:p,reason:u,waitUntil(o){if(Object.isFrozen(y))throw(0,T.$8)("waitUntil can not be called async");y.push(Promise.resolve(o))}});try{R.apply(I,[r])}catch(o){return Promise.reject(o)}return Object.freeze(y),new Promise((o,m)=>{const h=setTimeout(()=>m(new Error("timeout")),this.g.timeout);return Promise.all(y).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' finished after ${Date.now()-k}ms`),clearTimeout(h),o(t)}).catch(t=>{clearTimeout(h),m(t)})}).then(o=>{const m={edits:[]};for(const h of o)if(Array.isArray(h)&&h.every(t=>t instanceof d.$lK))for(const{newText:t,newEol:n,range:a}of h)m.edits.push({resource:p.uri,versionId:void 0,textEdit:{range:a&&L.Range.from(a),text:t,eol:n&&L.EndOfLine.from(n)}});if(m.edits.length!==0)return c===p.version?this.f.$tryApplyWorkspaceEdit(m):Promise.reject(new Error("concurrent_edits"))})}}e.$bcc=$}),define(De[281],Ce([1,0,18,2,13,7,108]),function($e,e,C,T,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=e.$odc=void 0;class ${constructor(I,w,y,k){this.start=I,this.deletedCount=w,this.deletedItems=y,this.items=k}asApiEvent(){return{range:new L.$BL(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(I,w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,w,y){this.notebook=I,this.h=w,this.j=y,this.handle=y.handle,this.uri=T.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(d.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(d.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,w=this.h.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:d.NotebookCellKind.to(this.j.cellKind),document:w.document,get mime(){return I.g},set mime(k){I.g=k},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(y)}return this.f}setOutputs(I){this.a=I.map(d.NotebookCellOutput.to)}setOutputItems(I,w,y){const k=y.map(d.NotebookCellOutputItem.to),p=this.a.find(u=>u.id===I);if(p&&(w||(p.items.length=0),p.items.push(...k),p.items.length>1&&p.items.every(u=>A.$mI(u.mime)))){const u=new Map,c=[];p.items.forEach(r=>{let o;u.has(r.mime)?o=u.get(r.mime):(o=[],u.set(r.mime,o),c.push(r.mime)),o.push(r.data)}),p.items.length=0,c.forEach(r=>{const o=A.$nI(u.get(r));p.items.push({mime:r,data:o.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(d.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$odc=E;class v{static{this.a=0}constructor(I,w,y,k,p){this.k=I,this.l=w,this.m=y,this.uri=k,this.handle=v.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=p.viewType,this.f=Object.freeze(p.metadata??Object.create(null)),this.r([[0,0,p.cells]],!0,void 0),this.g=p.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,w={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===C.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(y){return y=I.n(y),I.b[y].apiCell},getCells(y){return(y?I.p(y):I.b).map(p=>p.apiCell)},save(){return I.q()}};this.e=Object.freeze(w)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,w,y){this.g=I.versionId,this.h=w,this.acceptDocumentPropertiesChanged({metadata:y});const k={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},p=[];for(const c of I.rawEvents)c.kind===A.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,k.contentChanges):c.kind===A.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,k.contentChanges):c.kind===A.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),p.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===A.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),p.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),p.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===A.NotebookCellsChangeType.ChangeCellContent?p.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),p.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),p.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const u=new Map;for(let c=0;c<p.length;c++){const r=p[c],o=u.get(r.cell);if(o===void 0){const m=k.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});u.set(r.cell,m-1)}else k.cellChanges[o]={...k.cellChanges[o],...r}}return Object.freeze(k),Object.freeze(k.cellChanges),Object.freeze(k.contentChanges),k}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let w=I.start|0,y=I.end|0;return w<0&&(w=0),y>this.b.length&&(y=this.b.length),I.with({start:w,end:y})}p(I){I=this.o(I);const w=[];for(let y=I.start;y<I.end;y++)w.push(this.b[y]);return w}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,w,y){if(this.j)return;const k=[],p=[],u=[];if(I.reverse().forEach(c=>{const o=c[2].map(t=>{const n=new E(this,this.l,t);return w||p.push(E.asModelAddData(this.apiNotebook,t)),n}),m=new $(c[0],c[1],[],o),h=this.b.splice(c[0],c[1],...o);for(const t of h)u.push(t.uri),m.deletedItems.push(t.apiCell);k.push(m)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:u}),y)for(const c of k)y.push(c.asApiEvent())}s(I,w,y,k){const p=this.b.splice(I,w);this.b.splice(y,0,...p);const u=[new $(I,w,p.map(c=>c.apiCell),[]),new $(y,0,[],p)];for(const c of u)k.push(c.asApiEvent())}t(I,w){this.b[I].setOutputs(w)}u(I,w,y,k){this.b[I].setOutputItems(w,y,k)}v(I,w){const y=this.b[I];y.apiCell.document.languageId!==w&&this.m.$acceptModelLanguageChanged(y.uri,w)}w(I,w){const y=this.b[I];y.apiCell.mime=w}x(I,w){this.b[I].setMetadata(w)}y(I,w){this.b[I].setInternalMetadata(w)}getCellFromApiCell(I){return this.b.find(w=>w.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(w=>w.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$pdc=v}),define(De[282],Ce([1,0,4,2,13,7]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;class A{constructor(E,v,R,I={timeout:1500,errors:3}){this.b=E,this.c=v,this.d=R,this.f=I,this.a=new C.$Pd}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(v,R,I)=>{const w=function(k){v.call(R,k)};return w.extension=E,this.a.event(w,void 0,I)}}async $participateInSave(E,v,R){const I=T.URI.revive(E),w=this.c.getNotebookDocument(I);if(!w)throw new Error("Unable to resolve notebook document");const y=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:d.TextDocumentSaveReason.to(v)},R,async(p,u)=>{const c=Date.now(),r=await await Promise.resolve(p);Date.now()-c>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier),!R.isCancellationRequested&&r&&(r instanceof L.$oK?y.push(r):this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(y.length===0)return!0;const k={edits:[]};for(const p of y){const{edits:u}=d.WorkspaceEdit.from(p);k.edits=k.edits.concat(u)}return this.d.$tryApplyWorkspaceEdit(k)}}e.$Pdc=A}),define(De[144],Ce([1,0,8,13,7]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor($,E,v,R,I,w){this.id=$,this.f=E,this.notebookData=v,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=R,this.c=w}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(E){this.selections=[E]},get selections(){return $.a},set selections(E){if(!Array.isArray(E)||!E.every(d.$BL.isNotebookRange))throw(0,C.$7)("selections");$.a=E,$.g(E)},get visibleRanges(){return $.b},revealRange(E,v){$.f.$tryRevealRange($.id,T.NotebookRange.from(E),v??d.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(T.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$qdc=L}),define(De[283],Ce([1,0,8,4,14,13]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;let A=class{constructor(E,v){this.c=E,this.d=v,this.a=new T.$Nd({onListenerError:C.$2}),this.b=new T.$Nd({onListenerError:C.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,v){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,v);const R=this.d.getEditorById(E);v.visibleRanges&&R._acceptVisibleRanges(v.visibleRanges.ranges.map(L.NotebookRange.to)),v.selections&&R._acceptSelections(v.selections.selections.map(L.NotebookRange.to)),v.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),v.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const v in E)this.d.getEditorById(v)._acceptViewColumn(L.ViewColumn.to(E[v]))}};e.$Idc=A,e.$Idc=A=He([Be(0,d.$9i)],A)}),define(De[284],Ce([1,0,13,64,208,21,57,8]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class E{constructor(w){this.b=0,this.c=new Map,this.a=w}async withProgress(w,y,k){const p=this.b++,{title:u,location:c,cancellable:r}=y,o={label:(0,d.localize)(0,null,w.displayName||w.name),id:w.identifier.value};return this.a.$startProgress(p,{location:C.ProgressLocation.from(c),title:u,source:o,cancellable:r},w.isUnderDevelopment?void 0:w.identifier.value).catch($.$2),this.d(p,k,!!r)}d(w,y,k){let p;k&&(p=new L.$Xd,this.c.set(w,p));const u=r=>{this.a.$progressEnd(r),this.c.delete(r),p?.dispose()};let c;try{c=y(new R(this.a,w),k&&p?p.token:L.CancellationToken.None)}catch(r){throw u(w),r}return c.then(r=>u(w),r=>u(w)),c}$acceptProgressCanceled(w){const y=this.c.get(w);y&&(y.cancel(),this.c.delete(w))}}e.$Mcc=E;function v(I,w){return I.message=w.message,typeof w.increment=="number"&&(typeof I.increment=="number"?I.increment+=w.increment:I.increment=w.increment),I}class R extends T.$2u{constructor(w,y){super(k=>this.throttledReport(k)),this.i=w,this.j=y}throttledReport(w){this.i.$progressReport(this.j,w)}}He([(0,A.$ih)(100,(I,w)=>v(I,w),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(De[145],Ce([1,0,34,142,68,109,87,13,2]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=e.$qM=e.$pM=void 0;const v=(o,m,h,t)=>{let n=m;return{enumerable:!0,configurable:!1,get(){return n},set(a){if(!h(n,a)){const i=n;n=a,o.listener?.(t(a,i))}}}},R=(o,m)=>o===m,I={range:(o,m)=>o===m?!0:!o||!m?!1:o.isEqual(m),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(o,m)=>!(o.length!==m.length||o.some(h=>!m.find(t=>h.id===t.id)))},w=o=>m=>({op:4,update:o(m)}),y=(o,m)=>({range:(()=>{let h;const t=w(n=>({range:C.$qs.lift($.Range.from(n))}));return{enumerable:!0,configurable:!1,get(){return h},set(n){o.listener?.({op:6}),I.range(h,n)||(h=n,o.listener?.(t(n)))}}})(),label:v(o,m,I.label,w(h=>({label:h}))),description:v(o,void 0,I.description,w(h=>({description:h}))),sortText:v(o,void 0,I.sortText,w(h=>({sortText:h}))),canResolveChildren:v(o,!1,I.canResolveChildren,h=>({op:2,state:h})),busy:v(o,!1,I.busy,w(h=>({busy:h}))),error:v(o,void 0,I.error,w(h=>({error:$.MarkdownString.fromStrict(h)||null}))),tags:v(o,[],I.tags,(h,t)=>({op:1,new:h.map($.TestTag.from),old:t.map($.TestTag.from)}))}),k=o=>{const m=d.$8I.fromString(o.extId),h=new u(m.controllerId,m.localId,o.label,E.URI.revive(o.uri)||void 0);return h.range=$.Range.to(o.range||void 0),h.description=o.description||void 0,h.sortText=o.sortText||void 0,h.tags=o.tags.map(t=>$.TestTag.to({id:(0,A.$aJ)(t).tagId})),h},p=o=>{let m;for(const h of o.tests){const t=k(h.item);(0,T.$_L)(t).parent=m,m=t}return m};e.$pM=p;class u{constructor(m,h,t,n){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const a=(0,T.$$L)(this,m);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof c?void 0:a.parent}},children:{value:(0,L.$0L)(a,T.$_L,u),enumerable:!0,writable:!1},...y(a,t)})}}e.$qM=u;class c extends u{constructor(m,h){super(m,m,h,void 0),this._isRoot=!0}}e.$rM=c;class r extends L.$6L{constructor(m,h,t){super({controllerId:m,getDocumentVersion:n=>n&&t.getDocument(n)?.version,getApiFor:T.$_L,getChildren:n=>n.children,root:new c(m,h),toITestItem:$.TestItem.from})}}e.$sM=r}),define(De[146],Ce([1,0,58,8,119,13,7]),function($e,e,C,T,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=e.$kM=void 0;class ${static{this.c=new d.$iM("TextEditorDecorationType")}constructor(w,y,k){const p=$.c.nextId();w.$registerTextEditorDecorationType(y.identifier,p,L.DecorationRenderOptions.from(k)),this.value=Object.freeze({key:p,dispose(){w.$removeTextEditorDecorationType(p)}})}}e.$kM=$;class E{constructor(w,y){this.g=[],this.h=void 0,this.j=!1,this.c=w,this.d=w.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(w,y){this.k();let k=null;if(w instanceof A.$fK)k=new A.$gK(w,w);else if(w instanceof A.$gK)k=w;else throw new Error("Unrecognized location");this.l(k,y,!1)}insert(w,y){this.k(),this.l(new A.$gK(w,w),y,!0)}delete(w){this.k();let y=null;if(w instanceof A.$gK)y=w;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(w,y,k){const p=this.c.validateRange(w);this.g.push({range:p,text:y,forceMoveMarkers:k})}setEndOfLine(w){if(this.k(),w!==A.EndOfLine.LF&&w!==A.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=w}}class v{constructor(w,y,k,p){this.c=w,this.d=y,this._accept(k),this.e=p;const u=this;this.value={get tabSize(){return u.f},set tabSize(c){u.m(c)},get indentSize(){return u.g},set indentSize(c){u.o(c)},get insertSpaces(){return u.h},set insertSpaces(c){u.q(c)},get cursorStyle(){return u.j},set cursorStyle(c){u.s(c)},get lineNumbers(){return u.k},set lineNumbers(c){u.t(c)}}}_accept(w){this.f=w.tabSize,this.g=w.indentSize,this.h=w.insertSpaces,this.j=w.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(w.lineNumbers)}l(w){if(w==="auto")return"auto";if(typeof w=="number"){const y=Math.floor(w);return y>0?y:null}if(typeof w=="string"){const y=parseInt(w,10);return isNaN(y)?null:y>0?y:null}return null}m(w){const y=this.l(w);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(w){if(w==="tabSize")return"tabSize";if(typeof w=="number"){const y=Math.floor(w);return y>0?y:null}if(typeof w=="string"){const y=parseInt(w,10);return isNaN(y)?null:y>0?y:null}return null}o(w){const y=this.n(w);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(w){return w==="auto"?"auto":w==="false"?!1:!!w}q(w){const y=this.p(w);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(w){this.j!==w&&(this.j=w,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:w})))}t(w){this.k!==w&&(this.k=w,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(w)})))}assign(w){const y={};let k=!1;if(typeof w.tabSize<"u"){const p=this.l(w.tabSize);p==="auto"?(k=!0,y.tabSize=p):typeof p=="number"&&this.f!==p&&(this.f=p,k=!0,y.tabSize=p)}if(typeof w.indentSize<"u"){const p=this.n(w.indentSize);p==="tabSize"?(k=!0,y.indentSize=p):typeof p=="number"&&this.g!==p&&(this.g=p,k=!0,y.indentSize=p)}if(typeof w.insertSpaces<"u"){const p=this.p(w.insertSpaces);p==="auto"?(k=!0,y.insertSpaces=p):this.h!==p&&(this.h=p,k=!0,y.insertSpaces=p)}typeof w.cursorStyle<"u"&&this.j!==w.cursorStyle&&(this.j=w.cursorStyle,k=!0,y.cursorStyle=w.cursorStyle),typeof w.lineNumbers<"u"&&this.k!==w.lineNumbers&&(this.k=w.lineNumbers,k=!0,y.lineNumbers=L.TextEditorLineNumbersStyle.from(w.lineNumbers)),k&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(w,y){y.catch(k=>{this.e.warn(`ExtHostTextEditorOptions '${w}' failed:'`),this.e.warn(k)})}}e.$lM=v;class R{constructor(w,y,k,p,u,c,r,o){this.id=w,this.j=y,this.k=k,this.g=!1,this.h=new Set,this.c=u,this.d=new v(this.j,this.id,c,k),this.e=r,this.f=o;const m=this;this.value=Object.freeze({get document(){return p.value},set document(h){throw new T.$9("document")},get selection(){return m.c&&m.c[0]},set selection(h){if(!(h instanceof A.$hK))throw(0,T.$7)("selection");m.c=[h],m.l()},get selections(){return m.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof A.$hK)))throw(0,T.$7)("selections");m.c=h,m.l()},get visibleRanges(){return m.e},set visibleRanges(h){throw new T.$9("visibleRanges")},get options(){return m.d.value},set options(h){m.g||m.d.assign(h)},get viewColumn(){return m.f},set viewColumn(h){throw new T.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(m.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new E(p.value,t);return h(n),m.m(n)},insertSnippet(h,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(m.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=m.c.map(i=>L.Range.from(i));else if(t instanceof A.$fK){const{lineNumber:i,column:s}=L.Position.from(t);a=[{startLineNumber:i,startColumn:s,endLineNumber:i,endColumn:s}]}else if(t instanceof A.$gK)a=[L.Range.from(t)];else{a=[];for(const i of t)if(i instanceof A.$gK)a.push(L.Range.from(i));else{const{lineNumber:s,column:l}=L.Position.from(i);a.push({startLineNumber:s,startColumn:l,endLineNumber:s,endColumn:l})}}return y.$tryInsertSnippet(w,p.value.version,h.value,a,n)},setDecorations(h,t){const n=t.length===0;n&&!m.h.has(h.key)||(n?m.h.delete(h.key):m.h.add(h.key),m.n(()=>{if(L.$aM(t))return y.$trySetDecorations(w,h.key,L.$bM(t));{const a=new Array(4*t.length);for(let i=0,s=t.length;i<s;i++){const l=t[i];a[4*i]=l.start.line+1,a[4*i+1]=l.start.character+1,a[4*i+2]=l.end.line+1,a[4*i+3]=l.end.character+1}return y.$trySetDecorationsFast(w,h.key,a)}}))},revealRange(h,t){m.n(()=>y.$tryRevealRange(w,L.Range.from(h),t||A.TextEditorRevealType.Default))},show(h){y.$tryShowEditor(w,L.ViewColumn.from(h))},hide(){y.$tryHideEditor(w)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(w){(0,C.ok)(!this.g),this.d._accept(w)}_acceptVisibleRanges(w){(0,C.ok)(!this.g),this.e=w}_acceptViewColumn(w){(0,C.ok)(!this.g),this.f=w}_acceptSelections(w){(0,C.ok)(!this.g),this.c=w}async l(){const w=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,w)),this.value}m(w){const y=w.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const k=y.edits.map(u=>u.range);k.sort((u,c)=>u.end.line===c.end.line?u.end.character===c.end.character?u.start.line===c.start.line?u.start.character-c.start.character:u.start.line-c.start.line:u.end.character-c.end.character:u.end.line-c.end.line);for(let u=0,c=k.length-1;u<c;u++){const r=k[u].end;if(k[u+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=y.edits.map(u=>({range:L.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,p,{setEndOfLine:typeof y.setEndOfLine=="number"?L.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(w){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$mM=R}),define(De[147],Ce([1,0,5,131]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zJ=void 0,e.$zJ=(0,C.$Ph)(T.$Vh)}),define(De[148],Ce([1,0,25,4,16,3]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i4b=e.$h4b=e.$g4b=e.$f4b=e.$e4b=e.$d4b=void 0;class A{constructor(c,r){this.versionId=c,this.removedDueToLooping=r}}e.$d4b=A;class ${static isHostExtension(c,r,o){if(r.getExtensionDescription(c))return!1;const m=o.getExtensionDescription(c);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(c,r){this.j=c,this.c=new T.$Nd,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(k),this.f=new C.$6l,this.g=[],this.h=new Map;for(const c of this.e){if(this.f.has(c.identifier)){console.error("Extension `"+c.identifier.value+"` is already registered");continue}this.f.set(c.identifier,c),this.g.push(c);const r=this.j.readActivationEvents(c);if(Array.isArray(r))for(let o of r)o==="onUri"&&(o=`onUri:${C.$4l.toKey(c.identifier)}`),this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(c)}}set(c){return this.e=c,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(c,r){this.e=p(this.e,r),this.e=this.e.concat(c);const o=$.l(this.e);return this.e=p(this.e,o.map(m=>m.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,o)}static l(c){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,a){this.addNode(n),this.addNode(a),this.c.has(n)?this.c.get(n).push(a):this.c.set(n,[a])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,a){const i=r.getArcs(n);for(let s=0;s<i.length;s++)if(!a.has(i[s]))return!1;return!0}getNodes(){return this.e}},o=new C.$6l;for(const n of c)if(o.set(n.identifier,n),n.extensionDependencies)for(const a of n.extensionDependencies)r.addArc(C.$4l.toKey(n.identifier),C.$4l.toKey(a));const m=new Set;r.getNodes().filter(n=>r.getArcs(n).length===0).forEach(n=>m.add(n));const h=r.getNodes().filter(n=>!m.has(n));let t;do{t=!1;for(let n=0;n<h.length;n++){const a=h[n];r.hasOnlyGoodArcs(a,m)&&(h.splice(n,1),n--,m.add(a),t=!0)}}while(t);return h.map(n=>o.get(n))}containsActivationEvent(c){return this.h.has(c)}containsExtension(c){return this.f.has(c)}getExtensionDescriptionsForActivationEvent(c){const r=this.h.get(c);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(c){const r=this.f.get(c);return r||void 0}getExtensionDescriptionByUUID(c){for(const r of this.g)if(r.uuid===c)return r}getExtensionDescriptionByIdOrUUID(c,r){return this.getExtensionDescription(c)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$e4b=$;class E{constructor(c,r){this.versionId=c,this.extensions=r}}e.$f4b=E,e.$g4b={readActivationEvents:u=>u.activationEvents};class v{constructor(c){this.d=new w,this.c=new $(c,[])}async acquireLock(c){const r=await this.d.acquire(c);return new R(this,r)}deltaExtensions(c,r,o){if(!c.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,o)}containsActivationEvent(c){return this.c.containsActivationEvent(c)}containsExtension(c){return this.c.containsExtension(c)}getExtensionDescriptionsForActivationEvent(c){return this.c.getExtensionDescriptionsForActivationEvent(c)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(c){return this.c.getExtensionDescription(c)}getExtensionDescriptionByUUID(c){return this.c.getExtensionDescriptionByUUID(c)}getExtensionDescriptionByIdOrUUID(c,r){return this.c.getExtensionDescriptionByIdOrUUID(c,r)}}e.$h4b=v;class R extends L.$Sc{constructor(c,r){super(),this.f=c,this.c=!1,this.B(r)}isAcquiredFor(c){return!this.c&&this.f===c}}e.$i4b=R;class I{constructor(c){this.name=c,this.promise=new Promise((r,o)=>{this.c=r})}resolve(c){this.c(c)}}class w{constructor(){this.c=[],this.d=!1}async acquire(c){const r=new I(c);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const c=this.c.shift();this.d=!0;let r=!0;const o=setTimeout(()=>{r&&console.warn(`The customer named ${c.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),m=()=>{r&&(clearTimeout(o),r=!1,this.d=!1,this.e())};c.resolve((0,L.$Qc)(m))}}var y;(function(u){u[u.Builtin=0]="Builtin",u[u.User=1]="User",u[u.Dev=2]="Dev"})(y||(y={}));function k(u,c){const r=u.isBuiltin?0:u.isUnderDevelopment?2:1,o=c.isBuiltin?0:c.isUnderDevelopment?2:1;if(r!==o)return r-o;const m=d.$gc.basename(u.extensionLocation.path),h=d.$gc.basename(c.extensionLocation.path);return m<h?-1:m>h?1:0}function p(u,c){const r=new C.$5l(c);return u.filter(o=>!r.has(o.identifier))}}),define(De[285],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.ExtHostConnectionType=void 0;var C;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(C||(e.ExtHostConnectionType=C={}));class T{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[T.ENV_KEY]=this.pipeName}}e.$vm=T;class d{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[d.ENV_KEY]="1"}}e.$wm=d;class L{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[L.ENV_KEY]="1"}}e.$xm=L;function A(R){delete R[T.ENV_KEY],delete R[d.ENV_KEY],delete R[L.ENV_KEY]}function $(R,I){A(I),R.serialize(I)}e.$ym=$;function E(R){if(R[T.ENV_KEY])return v(R,new T(R[T.ENV_KEY]));if(R[d.ENV_KEY])return v(R,new d);if(R[L.ENV_KEY])return v(R,new L);throw new Error("No connection information defined in environment!")}e.$zm=E;function v(R,I){return A(R),I}}),define(De[111],Ce([1,0,22]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$am=e.$_l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(v){v[v.Desktop=1]="Desktop",v[v.Web=2]="Web"})(T||(e.UIKind=T={}));var d;(function(v){v[v.VersionMismatch=55]="VersionMismatch",v[v.UnexpectedError=81]="UnexpectedError"})(d||(e.ExtensionHostExitCode=d={}));var L;(function(v){v[v.Initialized=0]="Initialized",v[v.Ready=1]="Ready",v[v.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A(v){const R=C.$be.alloc(1);switch(v){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$_l=A;function $(v,R){if(v.byteLength!==1)return!1;switch(v.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$am=$;var E;(function(v){v.Start="START_NATIVE_LOG",v.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(De[88],Ce([1,0,5,4,14,27,111,66,85,24,2,3,210]),function($e,e,C,T,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=e.$vM=e.$uM=void 0;let y=class extends I.$Sc{constructor(c,r){super(),this.s=c,this.t=r,this.a=this.B(new T.$Nd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Nd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:E.$mo,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(r.onDidChangeLogLevel(o=>{(0,d.$$i)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===d.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(c,r,o){const m=this.getTelemetryDetails(),h=new k(r,o,c,this.n,this.j,this.getBuiltInCommonProperties(c),{isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}),t=this.r.get(c.identifier.value)??[];return this.r.set(c.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(c,r,o){this.f=c,this.g=r,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(c){const r=Object.create(null);switch(r["common.extname"]=`${c.publisher}.${c.name}`,r["common.extversion"]=c.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=p(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:r["common.uikind"]="web";break;case A.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,$.$Uk)((0,E.$to)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(c){this.h=this.getTelemetryConfiguration(),this.f=c;const r=this.getTelemetryDetails();this.r.forEach((o,m)=>{const h=o.filter(t=>!t.isDisposed);h.length===0?this.r.delete(m):this.r.set(m,h)}),this.r.forEach(o=>{for(const m of o)m.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(c,r){const m=this.r.get(c.value)?.filter(t=>!t.isDisposed);if(!m)return this.r.delete(c.value),!1;let h=!1;for(const t of m)t.ignoreUnhandledExtHostErrors||(t.logError(r),h=!0);return h}};e.$uM=y,e.$uM=y=He([Be(0,L.$tM),Be(1,d.$0i)],y);class k{static validateSender(c){if(typeof c!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof c.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof c.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof c.flush<"u"&&typeof c.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(c,r,o,m,h,t,n){this.g=o,this.h=m,this.i=h,this.j=t,this.a=new T.$Nd,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=c,this.d={isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}}updateTelemetryEnablements(c,r){this.e&&(this.d={isUsageEnabled:c,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(c){let r="properties"in c?c.properties??{}:c;return r=(0,E.$wo)(r,[]),this.c&&(r=(0,v.$7m)(r,this.c)),this.b||(r=(0,v.$7m)(r,this.j)),"properties"in c?c.properties=r:c=r,c}k(c,r){this.f&&(this.g.publisher==="vscode"?c=this.g.name+"/"+c:c=this.g.identifier.value+"/"+c,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(c,r),this.h.trace(c,r))}logUsage(c,r){this.d.isUsageEnabled&&this.k(c,r)}logError(c,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof c=="string")this.k(c,r);else{const o={name:c.name,message:c.message,stack:c.stack,cause:c.cause},m=(0,E.$wo)(o,[]),h=new Error(m.message,{cause:m.cause});h.stack=m.stack,h.name=m.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(h,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const c=this,r={logUsage:c.logUsage.bind(c),get isUsageEnabled(){return c.d.isUsageEnabled},get isErrorsEnabled(){return c.d.isErrorsEnabled},logError:c.logError.bind(c),dispose:c.dispose.bind(c),onDidChangeEnableStates:c.a.event.bind(c)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let c=this.f;this.f=void 0,Promise.resolve(c.flush()).then(c=void 0),this.e=void 0}else this.f=void 0}}e.$vM=k;function p(u){const c=Date.now()-new Date(u).getTime();return isNaN(c)?!1:c<1e3*60*60*24}e.$wM=p,e.$xM=(0,C.$Oh)("IExtHostTelemetry")}),define(De[26],Ce([1,0,4,2,252,137,25,5]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fF=e.$eF=e.$dF=e.ActivationKind=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=e.ExtensionHostStartup=e.$0E=e.$9E=e.$8E=e.$7E=void 0,e.$7E=Object.freeze({identifier:new A.$4l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$8E="extensions.webWorker",e.$9E=(0,$.$Oh)("extensionService");class E{constructor(h){this.dependency=h}}e.$0E=E;var v;(function(m){m[m.EagerAutoStart=1]="EagerAutoStart",m[m.EagerManualStart=2]="EagerManualStart",m[m.Lazy=3]="Lazy"})(v||(e.ExtensionHostStartup=v={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,n){this.c=h,this.d=t.slice(0),this.e=n.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$RE.createActivationEventsMap(this.d)}}set(h,t,n){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const a=[],i=[],s=[],l=[],D=I(this.d),S=I(t),b=(O,M)=>O.extensionLocation.toString()===M.extensionLocation.toString()||O.isBuiltin===M.isBuiltin||O.isUserBuiltin===M.isUserBuiltin||O.isUnderDevelopment===M.isUnderDevelopment;for(const O of this.d){const M=S.get(O.identifier);if(!M){a.push(O.identifier),D.delete(O.identifier);continue}if(!b(O,M)){a.push(O.identifier),D.delete(O.identifier);continue}}for(const O of t){const M=D.get(O.identifier);if(!M){i.push(O);continue}if(!b(M,O)){a.push(M.identifier),D.delete(M.identifier);continue}}const f=new A.$5l(this.e),g=new A.$5l(n);for(const O of this.e)g.has(O)||s.push(O);for(const O of n)f.has(O)||l.push(O);const P=L.$RE.createActivationEventsMap(i),N={versionId:h,toRemove:a,toAdd:i,addActivationEvents:P,myToRemove:s,myToAdd:l};return this.delta(N),N}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:n,myToRemove:a,myToAdd:i}=h,s=new A.$5l(t),l=new A.$5l(a);for(let D=0;D<this.d.length;D++)s.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)l.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of n)this.d.push(D);for(const D of i)this.e.push(D);return h}containsExtension(h){for(const t of this.e)if(A.$4l.equals(t,h))return!0;return!1}}e.$$E=R;function I(m){const h=new A.$6l;for(const t of m)h.set(t.identifier,t);return h}function w(m,h){return m.enabledApiProposals?m.enabledApiProposals.includes(h):!1}e.$_E=w;function y(m,h){if(!w(m,h))throw new Error(`Extension '${m.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${m.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.$aF=y;class k{constructor(h,t,n,a){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=n,this.activationReason=a}}e.$bF=k;class p{constructor(h,t){this.description=h,this.value=t}}e.$cF=p;var u;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(u||(e.ActivationKind=u={}));function c(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,d.$Co)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation,targetPlatform:m.targetPlatform,validations:[],isValid:!0}}e.$dF=c;function r(m,h){return{identifier:new A.$4l((0,d.$Ao)(m.manifest.publisher,m.manifest.name)),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!!h,extensionLocation:m.location,...m.manifest,uuid:m.identifier.uuid,targetPlatform:m.targetPlatform}}e.$eF=r;class o{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$fF=o}),define(De[286],Ce([1,0,8,148,25,26,14,9]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=e.$gcc=e.$fcc=e.$ecc=e.$dcc=e.$ccc=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(c,r,o,m){this.startup=c,this.codeLoadingTime=r,this.activateCallTime=o,this.activateResolvedTime=m}}e.$ccc=E;class v{constructor(c){this.a=c,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(c,r){return c===-1||r===-1?-1:r-c}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$dcc=v;class R{constructor(c,r,o,m,h,t){this.activationFailed=c,this.activationFailedError=r,this.activationTimes=o,this.module=m,this.exports=h,this.subscriptions=t}}e.$ecc=R;class I extends R{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.$fcc=I;class w extends R{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$gcc=w;class y extends R{constructor(c){super(!0,c,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let k=class{constructor(c,r,o,m){this.g=m,this.a=c,this.b=r,this.c=o,this.d=new d.$6l,this.f=Object.create(null)}dispose(){for(const[c,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const c=[];for(const[r,o]of this.d)c.push(o.wait());await Promise.all(c)}isActivated(c){const r=this.d.get(c);return!!(r&&r.value)}getActivatedExtension(c){const r=this.d.get(c);if(!r||!r.value)throw new Error(`Extension '${c.value}' is not known or not activated`);return r.value}async activateByEvent(c,r){if(this.f[c])return;const o=this.a.getExtensionDescriptionsForActivationEvent(c);await this.h(o.map(m=>({id:m.identifier,reason:{startup:r,extensionId:m.identifier,activationEvent:c}}))),this.f[c]=!0}activateById(c,r){const o=this.a.getExtensionDescription(c);if(!o)throw new Error(`Extension '${c}' is not known`);return this.h([{id:o.identifier,reason:r}])}async h(c){const r=c.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(r.map(o=>o.wait()))}j(c){if(this.d.has(c.id))return this.d.get(c.id);if(this.l(c.id))return this.k(c,null,[],null);const r=this.a.getExtensionDescription(c.id);if(!r){const h=new Error(`Cannot activate unknown extension '${c.id.value}'`),t=this.k(c,null,[],new y(h));return this.c.onExtensionActivationError(c.id,h,new L.$0E(c.id.value)),t}const o=[],m=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const h of m){if(this.m(h))continue;const t=this.d.get(h);if(t){o.push(t);continue}if(this.l(h)){o.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:c.reason}));continue}const n=this.a.getExtensionDescription(h);if(n){if(!n.main&&!n.browser)continue;o.push(this.j({id:n.identifier,reason:c.reason}));continue}const a=r.displayName||r.identifier.value,i=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${h}'`),s=this.k(c,r.displayName,[],new y(i));return this.c.onExtensionActivationError(r.identifier,i,new L.$0E(h)),s}return this.k(c,r.displayName,o,null)}k(c,r,o,m){const h=new p(c.id,r,c.reason,o,m,this.c,this.g);return this.d.set(c.id,h),h}l(c){return T.$e4b.isHostExtension(c,this.a,this.b)}m(c){const r=this.b.getExtensionDescription(c);return r?!r.main&&!r.browser:!1}};e.$hcc=k,e.$hcc=k=He([Be(3,A.$9i)],k);let p=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(c,r,o,m,h,t,n){this.c=c,this.d=r,this.f=o,this.g=m,this.h=h,this.j=t,this.k=n,this.a=new $.$Sg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let c=0;c<this.g.length;c++){const r=this.g[c];if(r.value&&!r.value.activationFailed){this.g.splice(c,1),c--;continue}if(r.value&&r.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);o.detail=r.value.activationFailedError,this.h=new y(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(c=>c.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(c){const r=new Error;if(c&&c.name&&(r.name=c.name),c&&c.message?r.message=`Activating extension '${this.c.value}' failed: ${c.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${c}.`,c&&c.stack&&(r.stack=c.stack),this.h=new y(r),this.b&&C.$4(c))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(c)}}};p=He([Be(6,A.$9i)],p)}),define(De[287],Ce([1,0,212,23,2,4,3,269,9,7,17,19,13,80,21,173,26]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=void 0;function c(m,h){if((0,R.$yf)(m))return{label:m};if(m&&typeof m=="object"&&typeof m.label=="string"){let t;return Array.isArray(m.highlights)&&(t=m.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),t=t.length?t:void 0),{label:m.label,highlights:t}}}class r extends A.$Sc{constructor(h,t,n){super(),this.f=h,this.g=t,this.h=n,this.a=new Map,this.b=new p.$I7;function a(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:i=>a(i)?this.r(i):Array.isArray(i)&&i.length>0?i.map(s=>a(s)?this.r(s):s):i})}registerTreeDataProvider(h,t,n){const a=this.createTreeView(h,{treeDataProvider:t},n);return{dispose:()=>a.dispose()}}createTreeView(h,t,n){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],i=t.dragAndDropController?.dragMimeTypes??[],s=!!t.dragAndDropController?.handleDrag,l=!!t.dragAndDropController?.handleDrop,D=this.m(h,t,n),S={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:i,hasHandleDrag:s,hasHandleDrop:l,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},b=this.f.$registerTreeViewDataProvider(h,S),f={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,u.$aF)(n,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,u.$aF)(n,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(g){(0,y.$4j)(g)&&(0,u.$aF)(n,"treeViewMarkdownMessage"),D.message=g},get title(){return D.title},set title(g){D.title=g},get description(){return D.description},set description(g){D.description=g},get badge(){return D.badge},set badge(g){g!==void 0&&v.ViewBadge.isViewBadge(g)?D.badge={value:Math.floor(Math.abs(g.value)),tooltip:g.tooltip}:g===void 0&&(D.badge=void 0)},reveal:(g,P)=>D.reveal(g,P),dispose:async()=>{await b,this.a.delete(h),D.dispose()}};return this.B(f),f}$getChildren(h,t){const n=this.a.get(h);return n?n.getChildren(t):Promise.reject(new $.$nE(h))}async $handleDrop(h,t,n,a,i,s,l,D){const S=this.a.get(h);if(!S)return Promise.reject(new $.$nE(h));const b=w.DataTransfer.toDataTransfer(n,async f=>(await this.f.$resolveDropFileData(h,t,f)).buffer);return l===h&&D&&await this.j(b,S,D,i,s),S.onDrop(b,a,i)}async j(h,t,n,a,i){const s=this.b.removeDragOperationTransfer(i);if(s)(await s)?.forEach((l,D)=>{l&&h.set(D,l)});else if(i&&t.handleDrag){const l=t.handleDrag(n,h,a);this.b.addDragOperationTransfer(i,l),await l}return h}async $handleDrag(h,t,n,a){const i=this.a.get(h);if(!i)return Promise.reject(new $.$nE(h));const s=await this.j(new v.$8K,i,t,a,n);if(!(!s||a.isCancellationRequested))return w.DataTransfer.from(s)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new $.$nE(h);return t.hasResolve}$resolve(h,t,n){const a=this.a.get(h);if(!a)throw new $.$nE(h);return a.resolveTreeItem(t,n)}$setExpanded(h,t,n){const a=this.a.get(h);if(!a)throw new $.$nE(h);a.setExpanded(t,n)}$setSelectionAndFocus(h,t,n){const a=this.a.get(h);if(!a)throw new $.$nE(h);a.setSelectionAndFocus(t,n)}$setVisible(h,t){const n=this.a.get(h);if(!n){if(!t)return;throw new $.$nE(h)}n.setVisible(t)}$changeCheckboxState(h,t){const n=this.a.get(h);if(!n)throw new $.$nE(h);n.setCheckboxState(t)}m(h,t,n){const a=this.B(new o(h,t,this.f,this.g.converter,this.h,n));return this.a.set(h,a),a}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$Tcc=r;class o extends A.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,R.$Hf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,n,a,i,s){if(super(),this.I=h,this.J=n,this.L=a,this.M=i,this.N=s,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Nd),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Nd),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Nd),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Nd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Nd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Nd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Nd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new k.$Xd,s.contributes&&s.contributes.views)for(const b in s.contributes.views)for(const f of s.contributes.views[b])f.id===h&&(this.P=f.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(b=>this.F.fire({message:!1,element:b})));let l,D;const S=L.Event.debounce(this.F.event,(b,f)=>(b||(b={message:!1,elements:[]}),f.element!==!1&&(l||(l=new Promise(g=>D=g),this.G=this.G.then(()=>l)),Array.isArray(f.element)?b.elements.push(...f.element):b.elements.push(f.element)),f.message&&(b.message=!0),b),200,!0);this.B(S(({message:b,elements:f})=>{f.length&&(this.H=this.H.then(()=>{const g=D;return l=null,this.$(f).then(()=>g())})),b&&this.J.$setMessage(this.I,w.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let n=this.X(h);return n||(n=await this.Y(t)),n?n.map(a=>a.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const n=(0,R.$Hf)(t.select)?!0:t.select,a=(0,R.$Hf)(t.focus)?!1:t.focus,i=(0,R.$Hf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(s=>this.W(h,s[s.length-1]).then(l=>this.J.$reveal(this.I,{item:l.item,parentChain:s.map(D=>D.item)},{select:n,focus:a,expand:i})),s=>this.M.error(s)):this.J.$reveal(this.I,void 0,{select:n,focus:a,expand:i})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=w.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const n=this.getExtensionElement(h);n&&(t?this.u.fire(Object.freeze({element:n})):this.w.fire(Object.freeze({element:n})))}setSelectionAndFocus(h,t){const n=!(0,I.$ub)(this.s,h);this.s=h;const a=this.t!==t;this.t=t,n&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async n=>{const a=this.getExtensionElement(n.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:n.newState?v.TreeItemCheckboxState.Checked:v.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);t.forEach(n=>{n.treeItem.checkboxState=n.newState?v.TreeItemCheckboxState.Checked:v.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(n=>[n.extensionItem,n.newState])})}async handleDrag(h,t,n){const a=[];for(const i of h){const s=this.getExtensionElement(i);s&&a.push(s)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,n),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,n){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,E.$Mg)(()=>this.g?.handleDrop?this.g.handleDrop(a,h,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const n=this.j.get(h);if(n){const a=this.m.get(n);if(a){const i=await this.f.resolveTreeItem(a.extensionItem,n,t)??a.extensionItem;return this.hb(i),a.item.tooltip=this.eb(i.tooltip),a.item.command=this.fb(a.disposableStore,i.command),a.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(n=>this.W(t,n[n.length-1]).then(a=>(n.push(a),n))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,E.$Mg)(()=>this.f.getParent(h))}W(h,t){const n=this.m.get(h);return n?Promise.resolve(n):(0,E.$Mg)(()=>this.f.getTreeItem(h)).then(a=>this.kb(h,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const i=this.getExtensionElement(a);if(i){const s=this.m.get(i);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const n=this.getExtensionElement(h);t=n?this.m.get(n):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new k.$Xd(this.Z.token);try{const n=h?this.m.get(h):void 0,a=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const i=await Promise.all((0,I.$Hb)(a||[]).map(async s=>{const l=await this.f.getTreeItem(s);return l&&!t.token.isCancellationRequested?this.db(s,l,n):null}));return t.token.isCancellationRequested?void 0:(0,I.$Hb)(i)}finally{t.dispose()}}$(h){if(h.some(n=>!n))return this.Z.dispose(!0),this.Z=new k.$Xd,this.tb(),this.J.$refresh(this.I);{const n=this.ab(h);if(n.length)return this.bb(n)}return Promise.resolve(void 0)}ab(h){const t=new Set,n=h.map(i=>this.m.get(i));for(const i of n)if(i&&!t.has(i.item.handle)){let s=i;for(;s&&s.parent&&n.findIndex(l=>s&&s.parent&&l&&l.item.handle===s.parent.item.handle)===-1;){const l=this.j.get(s.parent.item.handle);s=l?this.m.get(l):void 0}s&&!s.parent&&t.add(i.item.handle)}const a=[];return t.forEach(i=>{const s=this.j.get(i);if(s){const l=this.m.get(s);l&&(!l.parent||!t.has(l.parent.item.handle))&&a.push(i)}}),a}bb(h){const t={};return Promise.all(h.map(n=>this.cb(n).then(a=>{a&&(t[n]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const n=this.m.get(t);if(n)return this.rb(t),(0,E.$Mg)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const i=this.ib(t,a,n.parent);return this.pb(t,i,n,n.parent),n.dispose(),i}return null})}return Promise.resolve(null)}db(h,t,n){const a=this.ib(h,t,n);if(t.id&&this.j.has(a.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.ob(h,a),this.qb(a,n),a}eb(h){return v.$EK.isMarkdownString(h)?w.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,n,a;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,n=h.checkboxState.tooltip,a=h.checkboxState.accessibilityInformation),{isChecked:t===v.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:a}}hb(h){if(!v.$3K.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,n){this.hb(t);const a=this.B(new A.$Rc),i=this.kb(h,t,n),s=this.lb(t);return{item:{handle:i,parentHandle:n?n.item.handle:void 0,label:c(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:s,iconDark:this.mb(t)||s,themeIcon:this.jb(t),collapsibleState:(0,R.$Hf)(t.collapsibleState)?v.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:n,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(h){return h.iconPath instanceof v.$$K?h.iconPath:void 0}kb(h,{id:t,label:n,resourceUri:a},i,s){if(t)return`${o.b}/${t}`;const l=c(n,this.N),D=i?i.item.handle:o.a;let S=l?l.label:a?(0,T.$sg)(a):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const b=this.m.has(h)?this.m.get(h).item.handle:void 0,f=this.X(i)||[];let g,P=0;do{if(g=`${D}/${P}:${S}`,s||!this.j.has(g)||b===g)break;P++}while(P<=f.length);return g}lb(h){if(h.iconPath&&!(h.iconPath instanceof v.$$K))return typeof h.iconPath=="string"||d.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof v.$$K)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return d.URI.isUri(h)?h:d.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,n,a){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==n.item.handle&&this.j.delete(n.item.handle),this.ob(h,t);const i=this.X(a)||[],s=i.filter(l=>l.item.handle===n.item.handle)[0];s&&i.splice(i.indexOf(s),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const n of t.children){const a=this.j.get(n.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const n of t.children){const a=this.j.get(n.item.handle);a&&this.sb(a)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(De[288],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[289],Ce([1,0,224,8,38,132,105,43,25,288,135,137]),function($e,e,C,T,d,L,A,$,E,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=void 0;const w=$.$dn.as(A.$en.JSONContribution);class y{constructor(h,t,n){this.a=h,this.b=t,this.c=n}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(d.default.Error,h)}warn(h){this.d(d.default.Warning,h)}info(h){this.d(d.default.Info,h)}}e.$1E=y;class k{static a(h){const t=new E.$5l;for(let n=0,a=h.length;n<a;n++)t.add(h[n].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new k(t,[]);if(!t||!t.length)return new k([],h);const n=this.a(h),a=this.a(t),i=t.filter(l=>!n.has(l.description.identifier)),s=h.filter(l=>!a.has(l.description.identifier));return new k(i,s)}constructor(h,t){this.added=h,this.removed=t}}e.$2E=k;class p{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=k.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,T.$1)(h)}}}e.$3E=p;const u={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},c="vscode://schemas/vscode-extensions";e.$4E={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$3l},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"*",description:C.localize(42,null),body:"*"}]}},badges:{type:"array",description:C.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(44,null)},href:{type:"string",description:C.localize(45,null)},description:{type:"string",description:C.localize(46,null)}}}},markdown:{type:"string",description:C.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Un}},extensionPack:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Un}},extensionKind:{description:C.localize(51,null),type:"array",items:u,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(52,null)},{body:["workspace"],description:C.localize(53,null)},{body:["ui","workspace"],description:C.localize(54,null)},{body:["workspace","ui"],description:C.localize(55,null)},{body:[],description:C.localize(56,null)}]},capabilities:{description:C.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(60,null),C.localize(61,null),C.localize(62,null)]},description:{type:"string",markdownDescription:C.localize(63,null)}}},untrustedWorkspaces:{description:C.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(66,null),C.localize(67,null),C.localize(68,null)]},restrictedConfigurations:{description:C.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(70,null)}}}}},sponsor:{description:C.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(73,null),type:"string"},"vscode:uninstall":{description:C.localize(74,null),type:"string"}}},icon:{type:"string",description:C.localize(75,null)},l10n:{type:"string",description:C.localize(76,null)},pricing:{type:"string",markdownDescription:C.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new p(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&I.$RE.register(h.extensionPoint,h.activationEventsGenerator),e.$4E.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,w.registerSchema(c,e.$4E),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$5E=r;const o={ExtensionsRegistry:"ExtensionsRegistry"};$.$dn.add(o.ExtensionsRegistry,new r),e.$6E=$.$dn.as(o.ExtensionsRegistry),w.registerSchema(c,e.$4E),w.registerSchema(R.$pj,{properties:{extensionEnabledApiProposals:{description:C.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(v.allApiProposals),markdownEnumDescriptions:Object.values(v.allApiProposals)}}]}}}})}),define(De[290],Ce([1,0,221,17,24,289,42,4]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KF=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var v;(function(w){function y(k,p,u){if(!k)return;const c=T.$yf(k.type)?k.type:void 0;if(!c||c.length===0){u.error(C.localize(3,null));return}const r=[];if(Array.isArray(k.required))for(const o of k.required)T.$yf(o)&&r.push(o);return{extensionId:p.value,taskType:c,required:r,properties:k.properties?d.$4m(k.properties):{},when:k.when?A.$Mi.deserialize(k.when):void 0}}w.from=y})(v||(v={}));const R=L.$6E.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(w,y)=>{for(const k of w)k.type&&y.push(`onTaskType:${k.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:E}});class I{constructor(){this.d=new $.$Nd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,k)=>{R.setHandler((p,u)=>{this.c=void 0;try{for(const c of u.removed){const r=c.value;for(const o of r)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const c of u.added){const r=c.value;for(const o of r){const m=v.from(o,c.description.identifier,c.collector);m&&(this.a[m.taskType]=m)}}(u.removed.length>0||u.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const k of this.all()){const p={type:"object",additionalProperties:!1};k.required.length>0&&(p.required=k.required.slice(0)),k.properties!==void 0?p.properties=d.$4m(k.properties):p.properties=Object.create(null),p.properties.type={type:"string",enum:[k.taskType]},y.push(p)}this.c={oneOf:y}}return this.c}}e.$KF=new I}),define(De[291],Ce([1,0,222,17,23,24,42,290]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$UF=e.JsonSchemaVersion=e.ExecutionEngine=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$OF=e.ShellQuoting=e.$NF=e.$MF=e.$LF=void 0,e.$LF="settings",e.$MF=new A.$6i("taskRunning",!1,C.localize(0,null)),e.$NF={value:C.localize(1,null),original:"Tasks"};var E;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$OF="$customized",function(z){function F(K){if(!K)return z.Strong;switch(K.toLowerCase()){case"escape":return z.Escape;case"strong":return z.Strong;case"weak":return z.Weak;default:return z.Strong}}z.from=F}(E||(e.ShellQuoting=E={}));var v;(function(z){z.defaults={cwd:"${workspaceFolder}"}})(v||(e.CommandOptions=v={}));var R;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(R||(e.RevealKind=R={})),function(z){function F(K){switch(K.toLowerCase()){case"always":return z.Always;case"silent":return z.Silent;case"never":return z.Never;default:return z.Always}}z.fromString=F}(R||(e.RevealKind=R={}));var I;(function(z){z[z.Never=1]="Never",z[z.OnProblem=2]="OnProblem",z[z.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(z){function F(K){switch(K.toLowerCase()){case"always":return z.Always;case"never":return z.Never;case"onproblem":return z.OnProblem;default:return z.OnProblem}}z.fromString=F}(I||(e.RevealProblemKind=I={}));var w;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(w||(e.PanelKind=w={})),function(z){function F(K){switch(K.toLowerCase()){case"shared":return z.Shared;case"dedicated":return z.Dedicated;case"new":return z.New;default:return z.Shared}}z.fromString=F}(w||(e.PanelKind=w={}));var y;(function(z){z.defaults={echo:!0,reveal:R.Always,revealProblems:I.Never,focus:!1,panel:w.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var k;(function(z){z[z.Shell=1]="Shell",z[z.Process=2]="Process",z[z.CustomExecution=3]="CustomExecution"})(k||(e.RuntimeType=k={})),function(z){function F(V){switch(V.toLowerCase()){case"shell":return z.Shell;case"process":return z.Process;case"customExecution":return z.CustomExecution;default:return z.Process}}z.fromString=F;function K(V){switch(V){case z.Shell:return"shell";case z.Process:return"process";case z.CustomExecution:return"customExecution";default:return"process"}}z.toString=K}(k||(e.RuntimeType=k={}));var p;(function(z){function F(K){return T.$yf(K)?K:K.value}z.value=F})(p||(e.CommandString=p={}));var u;(function(z){z.Clean={_id:"clean",isDefault:!1},z.Build={_id:"build",isDefault:!1},z.Rebuild={_id:"rebuild",isDefault:!1},z.Test={_id:"test",isDefault:!1};function F(V){return V===z.Clean._id||V===z.Build._id||V===z.Rebuild._id||V===z.Test._id}z.is=F;function K(V){if(V!==void 0)return T.$yf(V)?F(V)?{_id:V,isDefault:!1}:void 0:V}z.from=K})(u||(e.TaskGroup=u={}));var c;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.Folder=3]="Folder"})(c||(e.TaskScope=c={}));var r;(function(z){z.Workspace="workspace",z.Extension="extension",z.InMemory="inMemory",z.WorkspaceFile="workspaceFile",z.User="user";function F(K){switch(K){case z.User:return 2;case z.WorkspaceFile:return 5;default:return 6}}z.toConfigurationTarget=F})(r||(e.TaskSourceKind=r={}));var o;(function(z){z.parallel="parallel",z.sequence="sequence"})(o||(e.DependsOrder=o={}));var m;(function(z){z[z.default=1]="default",z[z.folderOpen=2]="folderOpen"})(m||(e.RunOnOptions=m={}));var h;(function(z){z.defaults={reevaluateOnRerun:!0,runOn:m.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(F,K,V,fe,Z,Q){this._label="",this._id=F,K&&(this._label=K),V&&(this.type=V),this.runOptions=fe,this.configurationProperties=Z,this._source=Q}getDefinition(F){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,K=!1){if(F===void 0)return!1;if(T.$yf(F))return F===this._label||F===this.configurationProperties.identifier||K&&F===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$PF=t;class n extends t{constructor(F,K,V,fe,Z,Q,X,oe){super(F,V,void 0,X,oe,K),this.command={},this._source=K,this.hasDefinedMatchers=Q,Z&&(this.command=Z)}clone(){return new n(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case k.Shell:K="shell";break;case k.Process:K="process";break;case k.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(F){return F instanceof n}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$LF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let K=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(K+=this._source.kind);const V={type:e.$OF,folder:F,id:K};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.$sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new n(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$QF=n;class a extends t{constructor(F,K,V,fe,Z,Q,X){super(F,V,fe,Q,X,K),this._source=K,this.configures=Z}static is(F){return F instanceof a}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?d.$sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$LF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let K=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(K+=this._source.kind);const V={type:e.$OF,folder:F,id:K};return JSON.stringify(V)}}e.$RF=a;class i extends t{constructor(F,K,V,fe,Z,Q,X,oe,x){super(F,V,fe,oe,x,K),this.defines=Z,this.hasDefinedMatchers=X,this.command=Q,this.icon=x.icon,this.hide=x.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof i}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new i(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$SF=i;class s extends t{constructor(F,K,V,fe,Z,Q){super(F,V,fe,Z,Q,K),this._source=K}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new s(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$TF=s;var l;(function(z){z[z.Process=1]="Process",z[z.Terminal=2]="Terminal"})(l||(e.ExecutionEngine=l={})),function(z){z._default=z.Terminal}(l||(e.ExecutionEngine=l={}));var D;(function(z){z[z.V0_1_0=1]="V0_1_0",z[z.V2_0_0=2]="V2_0_0"})(D||(e.JsonSchemaVersion=D={}));class S{constructor(F){this.c=new Map;for(let K=0;K<F.length;K++)this.c.set(F[K].uri.toString(),K)}compare(F,K){const V=F.getWorkspaceFolder(),fe=K.getWorkspaceFolder();if(V&&fe){let Z=this.c.get(V.uri.toString());Z=Z===void 0?0:Z+1;let Q=this.c.get(fe.uri.toString());return Q=Q===void 0?0:Q+1,Z===Q?F._label.localeCompare(K._label):Z-Q}else return!V&&fe?-1:V&&!fe?1:0}}e.$UF=S;var b;(function(z){z.DependsOnStarted="dependsOnStarted",z.AcquiredInput="acquiredInput",z.Start="start",z.ProcessStarted="processStarted",z.Active="active",z.Inactive="inactive",z.Changed="changed",z.Terminated="terminated",z.ProcessEnded="processEnded",z.End="end"})(b||(e.TaskEventKind=b={}));var f;(function(z){z.SingleRun="singleRun",z.Background="background"})(f||(e.TaskRunType=f={}));var g;(function(z){z[z.System=0]="System",z[z.User=1]="User",z[z.FolderOpen=2]="FolderOpen",z[z.ConfigurationChange=3]="ConfigurationChange",z[z.Reconnect=4]="Reconnect"})(g||(e.TaskRunSource=g={}));var P;(function(z){function F(oe){return{taskId:oe._id,taskName:oe.configurationProperties.name,runType:oe.configurationProperties.isBackground?"background":"singleRun",group:oe.configurationProperties.group,__task:oe}}function K(oe,x,ae){return{...F(oe),kind:"start",terminalId:x,resolvedVariables:ae}}z.start=K;function V(oe,x,ae){return{...F(oe),kind:"processStarted",terminalId:x,processId:ae}}z.processStarted=V;function fe(oe,x,ae){return{...F(oe),kind:"processEnded",terminalId:x,exitCode:ae}}z.processEnded=fe;function Z(oe,x,ae){return{...F(oe),kind:"terminated",exitReason:ae,terminalId:x}}z.terminated=Z;function Q(oe,x,ae){return{...F(x),kind:oe,terminalId:ae}}z.general=Q;function X(){return{kind:"changed"}}z.changed=X})(P||(e.TaskEvent=P={}));var N;(function(z){function F(V){const fe=Object.keys(V).sort();let Z="";for(const Q of fe){let X=V[Q];X instanceof Object?X=F(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),Z+=Q+","+X+","}return Z}function K(V){const Z={_key:F(V),type:V.taskType};return Object.assign(Z,V),Z}z.create=K})(N||(e.KeyedTaskIdentifier=N={}));var O;(function(z){z.AutoDetect="task.autoDetect",z.SaveBeforeRun="task.saveBeforeRun",z.ShowDecorations="task.showDecorations",z.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",z.SlowProviderWarning="task.slowProviderWarning",z.QuickOpenHistory="task.quickOpen.history",z.QuickOpenDetail="task.quickOpen.detail",z.QuickOpenSkip="task.quickOpen.skip",z.QuickOpenShowAll="task.quickOpen.showAll",z.AllowAutomaticTasks="task.allowAutomaticTasks",z.Reconnection="task.reconnection"})(O||(e.TaskSettingId=O={}));var M;(function(z){z.Tasks="tasks",z.SuppressTaskName="tasks.suppressTaskName",z.Windows="tasks.windows",z.Osx="tasks.osx",z.Linux="tasks.linux",z.ShowOutput="tasks.showOutput",z.IsShellCommand="tasks.isShellCommand",z.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var j;(function(z){function F(K,V){const fe=$.$KF.get(K.type);if(fe===void 0){const oe=L.$4m(K);return delete oe._key,N.create(oe)}const Z=Object.create(null);Z.type=fe.taskType;const Q=new Set;fe.required.forEach(oe=>Q.add(oe));const X=fe.properties;for(const oe of Object.keys(X)){const x=K[oe];if(x!=null)Z[oe]=x;else if(Q.has(oe)){const ae=X[oe];if(ae.default!==void 0)Z[oe]=L.$4m(ae.default);else switch(ae.type){case"boolean":Z[oe]=!1;break;case"number":case"integer":Z[oe]=0;break;case"string":Z[oe]="";break;default:V.error(C.localize(2,null,JSON.stringify(K,void 0,0),oe));return}}}return N.create(Z)}z.createTaskIdentifier=F})(j||(e.TaskDefinition=j={}))}),define(De[292],Ce([1,0,8]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k4b=e.$j4b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,$)=>{this.b=A,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,C.$1)(A))}then(A,$){return this.j().then(A,$)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$j4b=T;class d extends T{constructor(){super(),this.h=!0,this.i=new C.$5}}e.$k4b=d}),define(De[69],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mv=e.$lv=e.$kv=e.$jv=void 0;class C{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++C.count}}e.$jv=C;const T=[];function d($){const E=new C($);return T[E.nid]=E,E}e.$kv=d;function L($){return T[$].sid}e.$lv=L;class A{constructor(E){this.value=E}}e.$mv=A}),define(De[6],Ce([1,0,69]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.$cK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$bK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var d;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(d||(e.TabInputKind=d={}));var L;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var $;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var E;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var v;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(v||(e.NotebookEditorRevealType=v={}));var R;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class I{static{this.a=0}static mixin(u){return u._id=I.a++,u}}e.$bK=I;var w;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.kindModifier="m",p.commandIdent="n",p.commandId="o",p.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var y;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var k;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(k||(e.ExtHostTestingResource=k={})),e.$cK={MainThreadAuthentication:(0,C.$kv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$kv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,C.$kv)("MainThreadChatProvider"),MainThreadChatAgents:(0,C.$kv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,C.$kv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,C.$kv)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$kv)("MainThreadClipboard"),MainThreadCommands:(0,C.$kv)("MainThreadCommands"),MainThreadComments:(0,C.$kv)("MainThreadComments"),MainThreadConfiguration:(0,C.$kv)("MainThreadConfiguration"),MainThreadConsole:(0,C.$kv)("MainThreadConsole"),MainThreadDebugService:(0,C.$kv)("MainThreadDebugService"),MainThreadDecorations:(0,C.$kv)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$kv)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$kv)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$kv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$kv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$kv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$kv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$kv)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$kv)("MainThreadErrors"),MainThreadTreeViews:(0,C.$kv)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$kv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$kv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$kv)("MainThreadLanguages"),MainThreadLogger:(0,C.$kv)("MainThreadLogger"),MainThreadMessageService:(0,C.$kv)("MainThreadMessageService"),MainThreadOutputService:(0,C.$kv)("MainThreadOutputService"),MainThreadProgress:(0,C.$kv)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$kv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$kv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$kv)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$kv)("MainThreadSecretState"),MainThreadStorage:(0,C.$kv)("MainThreadStorage"),MainThreadSpeech:(0,C.$kv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,C.$kv)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$kv)("MainThreadTerminalService"),MainThreadWebviews:(0,C.$kv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$kv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$kv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$kv)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$kv)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$kv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$kv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$kv)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$kv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,C.$kv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,C.$kv)("MainThreadExtensionService"),MainThreadSCM:(0,C.$kv)("MainThreadSCM"),MainThreadSearch:(0,C.$kv)("MainThreadSearch"),MainThreadShare:(0,C.$kv)("MainThreadShare"),MainThreadTask:(0,C.$kv)("MainThreadTask"),MainThreadWindow:(0,C.$kv)("MainThreadWindow"),MainThreadLabelService:(0,C.$kv)("MainThreadLabelService"),MainThreadNotebook:(0,C.$kv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$kv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$kv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$kv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$kv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$kv)("MainThreadInteractive"),MainThreadChat:(0,C.$kv)("MainThreadChat"),MainThreadInlineChat:(0,C.$kv)("MainThreadInlineChatShape"),MainThreadTheming:(0,C.$kv)("MainThreadTheming"),MainThreadTunnelService:(0,C.$kv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$kv)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$kv)("MainThreadTimeline"),MainThreadTesting:(0,C.$kv)("MainThreadTesting"),MainThreadLocalization:(0,C.$kv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$kv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$kv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,C.$kv)("MainThreadIssueReporter")},e.$dK={ExtHostCommands:(0,C.$kv)("ExtHostCommands"),ExtHostConfiguration:(0,C.$kv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$kv)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$kv)("ExtHostDebugService"),ExtHostDecorations:(0,C.$kv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$kv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$kv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$kv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$kv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$kv)("ExtHostEditors"),ExtHostTreeViews:(0,C.$kv)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$kv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$kv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$kv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$kv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$kv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$kv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$kv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$kv)("ExtHostStatusBar"),ExtHostShare:(0,C.$kv)("ExtHostShare"),ExtHostExtensionService:(0,C.$kv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$kv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$kv)("ExtHostTerminalService"),ExtHostSCM:(0,C.$kv)("ExtHostSCM"),ExtHostSearch:(0,C.$kv)("ExtHostSearch"),ExtHostTask:(0,C.$kv)("ExtHostTask"),ExtHostWorkspace:(0,C.$kv)("ExtHostWorkspace"),ExtHostWindow:(0,C.$kv)("ExtHostWindow"),ExtHostWebviews:(0,C.$kv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$kv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$kv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$kv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$kv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$kv)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$kv)("ExtHostProgress"),ExtHostComments:(0,C.$kv)("ExtHostComments"),ExtHostSecretState:(0,C.$kv)("ExtHostSecretState"),ExtHostStorage:(0,C.$kv)("ExtHostStorage"),ExtHostUrls:(0,C.$kv)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$kv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$kv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$kv)("ExtHostOutputService"),ExtHosLabelService:(0,C.$kv)("ExtHostLabelService"),ExtHostNotebook:(0,C.$kv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$kv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$kv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$kv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$kv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$kv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$kv)("ExtHostInteractive"),ExtHostInlineChat:(0,C.$kv)("ExtHostInlineChatShape"),ExtHostChat:(0,C.$kv)("ExtHostChat"),ExtHostChatAgents:(0,C.$kv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,C.$kv)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$kv)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$kv)("ExtHostChatProvider"),ExtHostSpeech:(0,C.$kv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,C.$kv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$kv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$kv)("ExtHostTheming"),ExtHostTunnelService:(0,C.$kv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$kv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$kv)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$kv)("ExtHostTimeline"),ExtHostTesting:(0,C.$kv)("ExtHostTesting"),ExtHostTelemetry:(0,C.$kv)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$kv)("ExtHostLocalization"),ExtHostIssueReporter:(0,C.$kv)("ExtHostIssueReporter")}}),define(De[293],Ce([1,0,6,7]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;class d{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$cK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,$,E){if(this.a.size===0)throw new Error("No related information providers registered");const v=this.a.get(A);if(!v)throw new Error("related information provider not found");return await v.provideRelatedInformation($,E)??[]}getRelatedInformation(A,$,E){return this.c.$getAiRelatedInformation($,E)}registerRelatedInformationProvider(A,$,E){const v=this.b;return this.b++,this.a.set(v,E),this.c.$registerAiRelatedInformationProvider(v,$),new T.$eK(()=>{this.c.$unregisterAiRelatedInformationProvider(v),this.a.delete(v)})}}e.$Vdc=d}),define(De[89],Ce([1,0,5,14,6,20]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=e.$Xbc=void 0,e.$Xbc=(0,C.$Oh)("IExtHostApiDeprecationService");let A=class{constructor(E,v){this.c=v,this.a=new Set,this.b=E.getProxy(d.$cK.MainThreadTelemetry)}report(E,v,R){const I=this.d(E,v);this.a.has(I)||(this.a.add(I),v.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:v.identifier.value,apiId:E}))}d(E,v){return`${E}-${v.identifier.value}`}};e.$Ybc=A,e.$Ybc=A=He([Be(0,L.$dM),Be(1,T.$9i)],A),e.$Zbc=Object.freeze(new class{report($,E,v){}})}),define(De[294],Ce([1,0,4,6,7,25]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class A{constructor(v){this.b=new Map,this.c=[],this.d=new C.$Nd,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=v.getProxy(T.$cK.MainThreadAuthentication)}$setProviders(v){return this.c=v,Promise.resolve()}async getSession(v,R,I,w={}){const y=L.$4l.toKey(v.identifier),k=[...I].sort().join(" ");return await this.f.getOrCreate(`${y} ${R} ${k}`,async()=>{await this.a.$ensureProvider(R);const p=v.displayName||v.name;return this.a.$getSession(R,I,y,p,w)})}async getSessions(v,R,I){const w=L.$4l.toKey(v.identifier),y=[...I].sort().join(" ");return await this.g.getOrCreate(`${w} ${y}`,async()=>{await this.a.$ensureProvider(R);const k=v.displayName||v.name;return this.a.$getSessions(R,I,w,k)})}async removeSession(v,R){const I=this.b.get(v);return I?I.provider.removeSession(R):this.a.$removeSession(v,R)}registerAuthenticationProvider(v,R,I,w){if(this.b.get(v))throw new Error(`An authentication provider with id '${v}' is already registered.`);this.b.set(v,{label:R,provider:I,options:w??{supportsMultipleAccounts:!1}}),this.c.find(k=>k.id===v)||this.c.push({id:v,label:R});const y=I.onDidChangeSessions(k=>{this.a.$sendDidChangeSessions(v,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this.a.$registerAuthenticationProvider(v,R,w?.supportsMultipleAccounts??!1),new d.$eK(()=>{y.dispose(),this.b.delete(v);const k=this.c.findIndex(p=>p.id===v);k>-1&&this.c.splice(k),this.a.$unregisterAuthenticationProvider(v)})}$createSession(v,R,I){const w=this.b.get(v);if(w)return Promise.resolve(w.provider.createSession(R,I));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$removeSession(v,R){const I=this.b.get(v);if(I)return Promise.resolve(I.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$getSessions(v,R){const I=this.b.get(v);if(I)return Promise.resolve(I.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$onDidChangeAuthenticationSessions(v,R){return this.d.fire({provider:{id:v,label:R}}),Promise.resolve()}}e.$tdc=A;class ${constructor(){this.a=new Map}getOrCreate(v,R){const I=this.a.get(v);if(I)return I;const w=R().finally(()=>this.a.delete(v));return this.a.set(v,w),w}}}),define(De[295],Ce([1,0,6,20,13]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;let L=class{constructor($,E){this.a=$.getProxy(C.$cK.MainThreadBulkEdits),this.b={getTextDocumentVersion:v=>E.getDocument(v)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,E,v){const R=d.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,v?.isRefactoring??!1)}};e.$zdc=L,e.$zdc=L=He([Be(0,T.$dM)],L)}),define(De[296],Ce([1,0,9,4,51,3,37,202,6,13]),function($e,e,C,T,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;class R{static{this.a=0}constructor(y,k){this.extension=y,this.provider=k,this.handle=R.a++}}class I{static{this.a=0}constructor(y,k){this.h=k,this.b=new Map,this.d=new Map,this.e=new T.$Nd,this.onDidPerformUserAction=this.e.event,this.g=y.getProxy(E.$cK.MainThreadChat)}registerChatProvider(y,k,p){const u=new R(y,p);return this.b.set(u.handle,u),this.g.$registerChatProvider(u.handle,k),(0,L.$Qc)(()=>{this.g.$unregisterChatProvider(u.handle),this.b.delete(u.handle)})}transferChatSession(y,k){const p=d.Iterable.find(this.d.keys(),u=>this.d.get(u)===y)??0;typeof p=="number"&&this.g.$transferChatSession(p,k)}sendInteractiveRequestToProvider(y,k){this.g.$sendRequestToProvider(y,k)}async $prepareChat(y,k,p){const u=this.b.get(y);if(!u)return;const c=await u.provider.prepareSession(k,p);if(!c)return;const r=I.a++;return this.d.set(r,c),{id:r,requesterUsername:c.requester?.name,requesterAvatarIconUri:c.requester?.icon,responderUsername:c.responder?.name,responderAvatarIconUri:c.responder?.icon,inputPlaceholder:c.inputPlaceholder}}async $provideWelcomeMessage(y,k){const p=this.b.get(y);if(!p||!p.provider.provideWelcomeMessage)return;const u=await p.provider.provideWelcomeMessage(k);if(u)return u.map(c=>typeof c=="string"?c:c.map(r=>v.ChatReplyFollowup.from(r)))}async $provideFollowups(y,k,p){const u=this.b.get(y);if(!u)return;const c=this.d.get(k);return!c||!u.provider.provideFollowups?void 0:(await u.provider.provideFollowups(c,p))?.map(o=>v.ChatFollowup.from(o))}async $provideSampleQuestions(y,k){const p=this.b.get(y);if(!p||!p.provider.provideSampleQuestions)return;const u=await p.provider.provideSampleQuestions(k);if(u)return u?.map(c=>v.ChatReplyFollowup.from(c))}$removeRequest(y,k,p){const u=this.b.get(y);if(!u)return;const c=this.d.get(k);c&&u.provider.removeRequest&&u.provider.removeRequest(c,p)}async $provideReply(y,k,p,u){const c=this.b.get(y);if(!c)return;const r=this.d.get(k);if(!r)return;const o={session:r,message:typeof p.message=="string"?p.message:v.ChatReplyFollowup.to(p.message),variables:{}};if(p.variables)for(const i of Object.keys(p.variables))o.variables[i]=p.variables[i].map(v.ChatVariable.to);const m=A.$Jd.create(!1);let h;const t={report:i=>{if(u.isCancellationRequested)return;typeof h>"u"&&(h=m.elapsed());const s=v.ChatResponseProgress.from(i);if("placeholder"in i&&"resolvedContent"in i){const l=Promise.all([this.g.$acceptResponseProgress(y,k,s),i.resolvedContent]);(0,C.$Ig)(l,u).then(D=>{if(!D)return;const[S,b]=D;this.g.$acceptResponseProgress(y,k,b,S??void 0)})}else this.g.$acceptResponseProgress(y,k,s)}};let n;try{n=await c.provider.provideResponseWithProgress(o,t,u),n||(n={errorDetails:{message:(0,$.localize)(0,null)}})}catch(i){n={errorDetails:{message:(0,$.localize)(1,null,i.message),responseIsIncomplete:!0}},this.h.error(i)}try{if(r.saveState&&this.d.has(k)){const i=r.saveState();this.g.$acceptChatState(k,i)}}catch(i){this.h.warn(i)}const a={firstProgress:h??0,totalElapsed:m.elapsed()};return{errorDetails:n.errorDetails,timings:a}}async $provideSlashCommands(y,k,p){const u=this.b.get(y);if(!u)return;const c=this.d.get(k);return!c||!u.provider.provideSlashCommands?void 0:(await u.provider.provideSlashCommands(c,p))?.map(o=>({...o,kind:v.CompletionItemKind.from(o.kind)}))}$releaseSession(y){this.d.delete(y)}async $onDidPerformUserAction(y){this.e.fire(y)}}e.$Ndc=I}),define(De[297],Ce([1,0,9,3,64,6,13,7]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=void 0;class E{static{this.a=0}constructor(I,w,y){this.d=w,this.e=y,this.b=new Map,this.c=I.getProxy(L.$cK.MainThreadChatAgents)}registerAgent(I,w,y,k){const p=E.a++;return this.b.set(p,{extension:I,agent:y}),this.c.$registerAgent(p,w,k),(0,T.$Qc)(()=>{this.c.$unregisterAgent(p),this.b.delete(p)})}async $invokeAgent(I,w,y,k,p){const u=this.b.get(I);if(!u){this.e.warn(`[CHAT](${I}) CANNOT invoke agent because the agent is not registered`);return}let c=!1;function r(){if(c)throw new Error("Only valid while executing the command")}const o=new C.$ch;p.onCancellationRequested(()=>o.complete()),setTimeout(()=>o.complete(),10*1e3),this.d.allowListExtensionWhile(u.extension,o.p);const m=u.agent({role:$.ChatMessageRole.User,content:y},{history:k.history.map(A.ChatMessage.to)},new d.$2u(h=>{r(),this.c.$handleProgressChunk(w,{content:v(h.message)?h.message:h.message.value})}),p);try{return await(0,C.$Ig)(Promise.resolve(m).then(h=>{if(h&&"followUp"in h)return{followUp:h?.followUp?.map(n=>A.ChatFollowup.from(n))}}),p)}finally{c=!0,o.complete()}}}e.$Xdc=E;function v(R){return!!R&&typeof R=="object"&&"treeData"in R}}),define(De[298],Ce([1,0,9,21,41,17,64,6,13]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;class v{static{this.a=0}constructor(w,y,k){this.g=y,this.h=k,this.b=new Map,this.d=w.getProxy($.$cK.MainThreadChatAgents2)}createChatAgent(w,y,k){const p=v.a++,u=new R(w,y,this.d,p,k);return this.b.set(p,u),this.d.$registerAgent(p,y,{}),u.apiAgent}async $invokeAgent(w,y,k,p,u){const c=this.b.get(w);if(!c)throw new Error(`[CHAT](${w}) CANNOT invoke agent because the agent is not registered`);let r=!1;function o(){if(r)throw new Error("Only valid while executing the command")}const m=new C.$ch;u.onCancellationRequested(()=>m.complete()),setTimeout(()=>m.complete(),3*1e3),this.g.allowListExtensionWhile(c.extension,m.p);const h=k.command?await c.validateSlashCommand(k.command):void 0;try{const t=c.invoke({prompt:k.message,variables:{},slashCommand:h},{history:p.history.map(E.ChatMessage.to)},new A.$2u(n=>{o();const a=E.ChatResponseProgress.from(n);this.d.$handleProgressChunk(y,a)}),u);return await(0,C.$Ig)(Promise.resolve(t).then(n=>{if(n)return{errorDetails:n.errorDetails}}),u)}catch(t){return this.h.error(t,c.extension),{errorDetails:{message:(0,d.$zi)(t)}}}finally{r=!0,m.complete()}}async $provideSlashCommands(w,y){const k=this.b.get(w);return k?k.provideSlashCommand(y):[]}async $provideFollowups(w,y,k){const p=this.b.get(w);return p?p.provideFollowups(null,k):[]}}e.$Ydc=v;class R{constructor(w,y,k,p,u){this.extension=w,this.j=y,this.k=k,this.l=p,this.m=u}async validateSlashCommand(w){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,L.$If)(this.b));const y=this.b.find(k=>k.name===w);if(!y)throw new Error(`Unknown slashCommand: ${w}`);return y}async provideSlashCommand(w){if(!this.a)return[];const y=await this.a.provideSlashCommands(w);return y?(this.b=y,y.map(k=>({name:k.name,description:k.description}))):[]}async provideFollowups(w,y){if(!this.d)return[];const k=await this.d.provideFollowups(w,y);return k?k.map(p=>E.ChatFollowup.from(p)):[]}get apiAgent(){let w=!1;const y=()=>{w||(w=!0,queueMicrotask(()=>{this.k.$updateAgent(this.l,{description:this.g??"",fullName:this.h,icon:this.i,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0}),w=!1}))},k=this;return{get name(){return k.j},get description(){return k.g??""},set description(p){k.g=p,y()},get fullName(){return k.h??k.extension.value},set fullName(p){k.h=p,y()},get iconPath(){return k.i},set iconPath(p){k.i=p,y()},get slashCommandProvider(){return k.a},set slashCommandProvider(p){k.a=p,y()},get followupProvider(){return k.d},set followupProvider(p){k.d=p,y()},dispose(){k.k.$unregisterAgent(k.l)}}}invoke(w,y,k,p){return this.m(w,y,k,p)}}}),define(De[299],Ce([1,0,3,6,13,64,25]),function($e,e,C,T,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class ${static{this.a=1}constructor(v,R){this.d=R,this.c=new Map,this.e=new Map,this.f=new A.$6l,this.b=v.getProxy(T.$cK.MainThreadChatProvider)}registerProvider(v,R,I,w){const y=$.a++;return this.c.set(y,{extension:v,provider:I}),this.b.$registerProvider(y,R,{extension:v,displayName:w.name??v.value}),(0,C.$Qc)(()=>{this.b.$unregisterProvider(y),this.c.delete(y)})}async $provideChatResponse(v,R,I,w,y){const k=this.c.get(v);if(!k)return;const p=new L.$2u(async u=>{if(y.isCancellationRequested){this.d.warn(`[CHAT](${k.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(R,{index:u.index,part:u.part})},{async:!0});return k.provider.provideChatResponse(I.map(d.ChatMessage.to),w,p,y)}allowListExtensionWhile(v,R){this.f.set(v,R),R.finally(()=>this.f.delete(v))}async requestChatResponseProvider(v,R){if(!this.f.has(v))throw new Error("Extension is NOT allowed to make chat requests");const I=this;return{get isRevoked(){return!I.f.has(v)},async makeRequest(w,y,k,p){if(!I.f.has(v))throw new Error("Access to chat has been revoked");const u=Math.random()*1e6|0;I.e.set(u,k);try{await I.b.$fetchResponse(v,R,u,w.map(d.ChatMessage.from),y,p)}finally{I.e.delete(u)}}}}async $handleResponseFragment(v,R){this.e.get(v)?.report(R)}}e.$Sdc=$}),define(De[300],Ce([1,0,3,6,8,13]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;class A{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(T.$cK.MainThreadChatVariables)}async $resolveVariable(E,v,R){const I=this.b.get(E);if(I)try{const w=await I.resolver.resolve(I.data.name,{message:v},R);if(w)return w.map(L.ChatVariable.from)}catch(w){(0,d.$2)(w)}}registerVariableResolver(E,v,R,I){const w=A.a++;return this.b.set(w,{extension:E.identifier,data:{name:v,description:R},resolver:I}),this.c.$registerVariable(w,{name:v,description:R}),(0,C.$Qc)(()=>{this.b.delete(w),this.c.$unregisterVariable(w)})}}e.$Udc=A}),define(De[301],Ce([1,0,6]),function($e,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=void 0;class T{constructor(L){const A=L.getProxy(C.$cK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText($){return A.$writeText($)}})}}e.$3bc=T}),define(De[33],Ce([1,0,17,7,13,24,6,19,14,62,34,61,2,3,5,20,145,22,69,41,37,85,88]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r,o,m,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=void 0;let n=class{#e;#t;#i;constructor(S,b,f){this.b=new Map,this.c=new Map,this.#e=S.getProxy(A.$cK.MainThreadCommands),this.d=b,this.#i=f,this.#t=S.getProxy(A.$cK.MainThreadTelemetry),this.converter=new a(this,g=>{const P=this.c.get(g);return P?.result===s.Void?P:void 0},b),this.f=[{processArgument(g){return(0,v.$lh)(g)}},{processArgument(g){return(0,L.$6m)(g,function(P){if(R.$qs.isIRange(P))return d.Range.to(P);if(I.$ps.isIPosition(P))return d.Position.to(P);if(R.$qs.isIRange(P.range)&&w.URI.isUri(P.uri))return d.location.to(P);if(P instanceof c.$be)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const b=this.registerCommand(!1,S.id,async(...f)=>{const g=S.args.map((N,O)=>{if(!N.validate(f[O]))throw new Error(`Invalid argument '${N.name}' when running '${S.id}', received: ${typeof f[O]=="object"?JSON.stringify(f[O],null,"	"):f[O]} `);return N.convert(f[O])}),P=await this.executeCommand(S.internalId,...g);return S.result.convert(P,f,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new T.$eK(()=>{b.dispose(),this.c.delete(S.id)})}registerCommand(S,b,f,g,P,N){if(this.d.trace("ExtHostCommands#registerCommand",b),!b.trim().length)throw new Error("invalid id");if(this.b.has(b))throw new Error(`command '${b}' already exists`);return this.b.set(b,{callback:f,thisArg:g,metadata:P,extension:N}),S&&this.#e.$registerCommand(b),new T.$eK(()=>{this.b.delete(b)&&S&&this.#e.$unregisterCommand(b)})}executeCommand(S,...b){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,b,!0)}async g(S,b,f){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,b,!1);{let g=!1;const P=(0,L.$6m)(b,function(N){if(N instanceof T.$fK)return d.Position.from(N);if(N instanceof T.$gK)return d.Range.from(N);if(N instanceof T.$qK)return d.location.from(N);if(T.$BL.isNotebookRange(N))return d.NotebookRange.from(N);if(N instanceof ArrayBuffer)return g=!0,c.$be.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return g=!0,c.$be.wrap(N);if(N instanceof c.$be)return g=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(S,g?new r.$mv(P):P,f);return(0,v.$lh)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(S,b,!1);throw N}}}async h(S,b,f){const g=this.b.get(S);if(!g)throw new Error("Unknown command");const{callback:P,thisArg:N,metadata:O}=g;if(O?.args)for(let j=0;j<O.args.length;j++)try{(0,C.$Pf)(b[j],O.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${O.args[j].name}' - ${O.args[j].description}`)}const M=m.$Jd.create();try{return await P.apply(N,b)}catch(j){if(S===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...b);z&&(S=z.command)}if(this.d.error(j,S,g.extension?.identifier),!f)throw j;if(g.extension?.identifier){const z=this.#i.onExtensionError(g.extension.identifier,j);this.d.trace("forwarded error to extension?",z,g.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$zi)(j)),this.id=S,this.source=g.extension?.displayName??g.extension?.name}}}finally{this.j(g,S,M.elapsed())}}j(S,b,f){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new h.$ho(b),duration:f})}$executeContributedCommand(S,...b){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const f=this.b.get(S);return f?(b=b.map(g=>this.f.reduce((P,N)=>N.processArgument(P,f.extension?.identifier),g)),this.h(S,b,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(b=>(S&&(b=b.filter(f=>f[0]!=="_")),b))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[b,f]of this.b){const{metadata:g}=f;g&&(S[b]=g)}return Promise.resolve(S)}};e.$yM=n,e.$yM=n=He([Be(0,p.$dM),Be(1,E.$9i),Be(2,t.$xM)],n),e.$zM=(0,k.$Oh)("IExtHostCommands");class a{constructor(S,b,f){this.d=S,this.f=b,this.g=f,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,b){if(!S)return;const f={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return f;const g=this.f(S.command);if(g)f.id=g.internalId,f.arguments=g.args.map((P,N)=>P.convert(S.arguments&&S.arguments[N]));else if((0,$.$Lb)(S.arguments)){const P=`${S.command} /${++this.c}`;this.b.set(P,S),b.add((0,y.$Qc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),f.$ident=P,f.id=this.delegatingCommandId,f.arguments=[P],this.g.trace("CommandsConverter#CREATE",S.command,P)}return f}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const b=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],b?b.command:"MISSING"),b?this.d.executeCommand(b.command,...b.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$AM=a;class i{static{this.Uri=new i("uri","Uri of a text document",S=>w.URI.isUri(S),S=>S)}static{this.Position=new i("position","A position in a text document",S=>T.$fK.isPosition(S),d.Position.from)}static{this.Range=new i("range","A range in a text document",S=>T.$gK.isRange(S),d.Range.from)}static{this.Selection=new i("selection","A selection in a text document",S=>T.$hK.isSelection(S),d.Selection.from)}static{this.Number=new i("number","",S=>typeof S=="number",S=>S)}static{this.String=new i("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=i.Arr(i.String)}static Arr(S){return new i(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,b=>Array.isArray(b)&&b.every(f=>S.validate(f)),b=>b.map(f=>S.convert(f)))}static{this.CallHierarchyItem=new i("item","A call hierarchy item",S=>S instanceof T.$AK,d.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new i("item","A type hierarchy item",S=>S instanceof T.$UL,d.TypeHierarchyItem.from)}static{this.TestItem=new i("testItem","A VS Code TestItem",S=>S instanceof u.$qM,d.TestItem.from)}constructor(S,b,f,g){this.name=S,this.description=b,this.validate=f,this.convert=g}optional(){return new i(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,b){return new i(S??this.name,b??this.description,this.validate,this.convert)}}e.$BM=i;class s{static{this.Void=new s("no result",S=>S)}constructor(S,b){this.description=S,this.convert=b}}e.$CM=s;class l{constructor(S,b,f,g,P){this.id=S,this.internalId=b,this.description=f,this.args=g,this.result=P}}e.$DM=l}),define(De[302],Ce([1,0,19,18,2,83,129,42,134,33,13,7]),function($e,e,C,T,d,L,A,$,E,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=void 0;const w=[new v.$DM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[v.$BM.Uri,v.$BM.Position],new v.$CM("A promise that resolves to an array of DocumentHighlight-instances.",k(R.DocumentHighlight.to))),new v.$DM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[v.$BM.Uri],new v.$CM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,c)=>{if((0,C.$Kb)(u))return;class r extends I.$vK{static to(m){const h=new r(m.name,R.SymbolKind.to(m.kind),m.containerName||"",new I.$qK(c[0],R.Range.to(m.range)));return h.detail=m.detail,h.range=h.location.range,h.selectionRange=R.Range.to(m.selectionRange),h.children=m.children?m.children.map(r.to):[],h}}return u.map(r.to)})),new v.$DM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[v.$BM.Uri,new v.$BM("options","Formatting options",u=>!0,u=>u)],new v.$CM("A promise that resolves to an array of TextEdits.",k(R.TextEdit.to))),new v.$DM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[v.$BM.Uri,v.$BM.Range,new v.$BM("options","Formatting options",u=>!0,u=>u)],new v.$CM("A promise that resolves to an array of TextEdits.",k(R.TextEdit.to))),new v.$DM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[v.$BM.Uri,v.$BM.Position,new v.$BM("ch","Trigger character",u=>typeof u=="string",u=>u),new v.$BM("options","Formatting options",u=>!0,u=>u)],new v.$CM("A promise that resolves to an array of TextEdits.",k(R.TextEdit.to))),new v.$DM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[v.$BM.Uri,v.$BM.Position],new v.$CM("A promise that resolves to an array of Location or LocationLink instances.",p)),new v.$DM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[v.$BM.Uri,v.$BM.Position],new v.$CM("A promise that resolves to an array of Location or LocationLink instances.",p)),new v.$DM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[v.$BM.Uri,v.$BM.Position],new v.$CM("A promise that resolves to an array of Location or LocationLink instances.",p)),new v.$DM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[v.$BM.Uri,v.$BM.Position],new v.$CM("A promise that resolves to an array of Location or LocationLink instances.",p)),new v.$DM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[v.$BM.Uri,v.$BM.Position],new v.$CM("A promise that resolves to an array of Location-instances.",k(R.location.to))),new v.$DM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[v.$BM.Uri,v.$BM.Position],new v.$CM("A promise that resolves to an array of Hover-instances.",k(R.Hover.to))),new v.$DM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[v.$BM.Uri,new v.$BM("position","A position in a text document",u=>Array.isArray(u)&&u.every(c=>I.$fK.isPosition(c)),u=>u.map(R.Position.from))],new v.$CM("A promise that resolves to an array of ranges.",u=>u.map(c=>{let r;for(const o of c.reverse())r=new I.$zK(R.Range.to(o),r);return r}))),new v.$DM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[v.$BM.String.with("query","Search string")],new v.$CM("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(R.WorkspaceSymbol.to))),new v.$DM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[v.$BM.Uri,v.$BM.Position],new v.$CM("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(R.CallHierarchyItem.to))),new v.$DM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[v.$BM.CallHierarchyItem],new v.$CM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(R.CallHierarchyIncomingCall.to))),new v.$DM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[v.$BM.CallHierarchyItem],new v.$CM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(R.CallHierarchyOutgoingCall.to))),new v.$DM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[v.$BM.Uri,v.$BM.Position],new v.$CM("A promise that resolves to a range and placeholder text.",u=>{if(u)return{range:R.Range.to(u.range),placeholder:u.text}})),new v.$DM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[v.$BM.Uri,v.$BM.Position,v.$BM.String.with("newName","The new symbol name")],new v.$CM("A promise that resolves to a WorkspaceEdit.",u=>{if(u){if(u.rejectReason)throw new Error(u.rejectReason);return R.WorkspaceEdit.to(u)}})),new v.$DM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[v.$BM.Uri,v.$BM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new v.$CM("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(R.DocumentLink.to))),new v.$DM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[v.$BM.Uri],new v.$CM("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new I.$tL(u.tokenTypes,u.tokenModifiers)})),new v.$DM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[v.$BM.Uri],new v.$CM("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const c=(0,A.$T0)(u);if(c.type==="full")return new I.$vL(c.data,void 0)})),new v.$DM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[v.$BM.Uri,v.$BM.Range.optional()],new v.$CM("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new I.$tL(u.tokenTypes,u.tokenModifiers)})),new v.$DM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[v.$BM.Uri,v.$BM.Range],new v.$CM("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const c=(0,A.$T0)(u);if(c.type==="full")return new I.$vL(c.data,void 0)})),new v.$DM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[v.$BM.Uri,v.$BM.Position,v.$BM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),v.$BM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new v.$CM("A promise that resolves to a CompletionList-instance.",(u,c,r)=>{if(!u)return new I.$LK([]);const o=u.suggestions.map(m=>R.CompletionItem.to(m,r));return new I.$LK(o,u.incomplete)})),new v.$DM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[v.$BM.Uri,v.$BM.Position,v.$BM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new v.$CM("A promise that resolves to SignatureHelp.",u=>{if(u)return R.SignatureHelp.to(u)})),new v.$DM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[v.$BM.Uri,v.$BM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new v.$CM("A promise that resolves to an array of CodeLens-instances.",(u,c,r)=>k(o=>new I.$DK(R.Range.to(o.range),o.command&&r.fromInternal(o.command)))(u))),new v.$DM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[v.$BM.Uri,new v.$BM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>I.$gK.isRange(u),u=>I.$hK.isSelection(u)?R.Selection.from(u):R.Range.from(u)),v.$BM.String.with("kind","Code action kind to return code actions for").optional(),v.$BM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new v.$CM("A promise that resolves to an array of Command-instances.",(u,c,r)=>k(o=>{if(o._isSynthetic){if(!o.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(o.command)}else{const m=new I.$xK(o.title,o.kind?new I.$yK(o.kind):void 0);return o.edit&&(m.edit=R.WorkspaceEdit.to(o.edit)),o.command&&(m.command=r.fromInternal(o.command)),m.isPreferred=o.isPreferred,m}})(u))),new v.$DM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[v.$BM.Uri],new v.$CM("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(c=>new I.$RK(R.Range.to(c.range),R.Color.to(c.color))):[])),new v.$DM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new v.$BM("color","The color to show and insert",u=>u instanceof I.$QK,R.Color.from),new v.$BM("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:R.Range.from(u.range)}))],new v.$CM("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(R.ColorPresentation.to):[])),new v.$DM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[v.$BM.Uri,v.$BM.Range],new v.$CM("A promise that resolves to an array of Inlay objects",(u,c,r)=>u.map(R.InlayHint.to.bind(void 0,r)))),new v.$DM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[v.$BM.Uri],new v.$CM("A promise that resolves to an array of FoldingRange objects",(u,c)=>{if(u)return u.map(R.FoldingRange.to)})),new v.$DM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new v.$CM("A promise that resolves to an array of NotebookContentProvider static info objects.",k(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(c=>R.NotebookExclusiveDocumentPattern.to(c))})))),new v.$DM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[v.$BM.Uri,v.$BM.Range,new v.$BM("context","An InlineValueContext",u=>u&&typeof u.frameId=="number"&&u.stoppedLocation instanceof I.$gK,u=>R.InlineValueContext.from(u))],new v.$CM("A promise that resolves to an array of InlineValue objects",u=>u.map(R.InlineValue.to))),new v.$DM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new v.$BM("uriOrString","Uri-instance or string (only http/https)",u=>d.URI.isUri(u)||typeof u=="string"&&(0,E.$aU)(u,T.Schemas.http,T.Schemas.https),u=>u),new v.$BM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[R.ViewColumn.from(u),void 0]:[R.ViewColumn.from(u.viewColumn),R.TextEditorOpenOptions.from(u)])).optional(),v.$BM.String.with("label","").optional()],v.$CM.Void),new v.$DM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[v.$BM.Uri.with("resource","Resource to open"),v.$BM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new v.$BM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[R.ViewColumn.from(u),void 0]:[R.ViewColumn.from(u.viewColumn),R.TextEditorOpenOptions.from(u)])).optional()],v.$CM.Void),new v.$DM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[v.$BM.Uri.with("left","Left-hand side resource of the diff editor"),v.$BM.Uri.with("right","Right-hand side resource of the diff editor"),v.$BM.String.with("title","Human readable title for the diff editor").optional(),new v.$BM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[R.ViewColumn.from(u.viewColumn),R.TextEditorOpenOptions.from(u)]).optional()],v.$CM.Void),new v.$DM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[v.$BM.Uri,v.$BM.Position],new v.$CM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(R.TypeHierarchyItem.to))),new v.$DM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[v.$BM.TypeHierarchyItem],new v.$CM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(R.TypeHierarchyItem.to))),new v.$DM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[v.$BM.TypeHierarchyItem],new v.$CM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(R.TypeHierarchyItem.to))),new v.$DM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[v.$BM.TestItem],v.$CM.Void),new v.$DM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[v.$BM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],v.$CM.Void),new v.$DM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[v.$BM.String.with("name","The context key name"),new v.$BM("value","The context key value",()=>!0,u=>u)],v.$CM.Void),new v.$DM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[v.$BM.Uri,v.$BM.StringArray,new v.$BM("MappedEditsContext","Mapped Edits Context",u=>R.MappedEditsContext.is(u),u=>R.MappedEditsContext.from(u))],new v.$CM("A promise that resolves to a workspace edit or null",u=>u?R.WorkspaceEdit.to(u):null))];class y{static register(c){w.forEach(c.registerApiCommand,c),this.a(c)}static a(c){c.registerCommand(!1,"_validateWhenClauses",$.$Ni)}}e.$2bc=y;function k(u){return c=>{if(Array.isArray(c))return c.map(u)}}function p(u){if(!Array.isArray(u))return;const c=[];for(const r of u)L.$bt(r)?c.push(R.DefinitionLink.to(r)):c.push(R.location.to(r));return c}}),define(De[303],Ce([1,0,9,57,4,3,2,83,25,13,7,6,26]),function($e,e,C,T,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=void 0;function y(k,p,u){const c=k.getProxy(I.$cK.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$6l,p.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const D=this.b.get(l.handle);return D?D.value:l}else if(l&&l.$mid===7){const D=this.b.get(l.commentControlHandle);if(!D)return l;const S=D.getCommentThread(l.commentThreadHandle);return S?S.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const S=D.getCommentThread(l.thread.commentThreadHandle);return S?l.$mid===8?S.value:{thread:S.value,text:l.text}:l}else if(l&&l.$mid===10){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const S=D.getCommentThread(l.thread.commentThreadHandle);if(!S)return l;const b=l.commentUniqueId,f=S.getCommentByUniqueId(b);return f||l}else if(l&&l.$mid===11){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const S=D.getCommentThread(l.thread.commentThreadHandle);if(!S)return l;const b=l.text,f=l.commentUniqueId,g=S.getCommentByUniqueId(f);return g?(typeof g.body=="string"?g.body=b:g.body=new R.$EK(b),g):l}return l}})}createCommentController(l,D,S){const b=r.a++,f=new m(l,b,D,S);this.b.set(f.handle,f);const g=this.c.get(l.identifier)||[];return g.push(f),this.c.set(l.identifier,g),f.value}async $createCommentThreadTemplate(l,D,S){const b=this.b.get(l);b&&b.$createCommentThreadTemplate(D,S)}async $updateCommentThreadTemplate(l,D,S){const b=this.b.get(l);b&&b.$updateCommentThreadTemplate(D,S)}$deleteCommentThread(l,D){this.b.get(l)?.$deleteCommentThread(D)}$provideCommentingRanges(l,D,S){const b=this.b.get(l);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const f=u.getDocument(A.URI.revive(D));return(0,C.$Mg)(async()=>{const g=await b.commentingRangeProvider.provideCommentingRanges(f,S);let P;return Array.isArray(g)?P={ranges:g,fileComments:!1}:g?P={ranges:g.ranges||[],fileComments:g.fileComments||!1}:P=g??void 0,P}).then(g=>{let P;return g&&(P={ranges:g.ranges.map(N=>v.Range.from(N)),fileComments:g.fileComments}),P})}$toggleReaction(l,D,S,b,f){const g=this.b.get(l);return!g||!g.reactionHandler?Promise.resolve(void 0):(0,C.$Mg)(()=>{const P=g.getCommentThread(D);if(P){const N=P.getCommentByUniqueId(b.uniqueIdInThread);if(g!==void 0&&N&&g.reactionHandler)return g.reactionHandler(N,n(f))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,D,S,b,f,g,P,N){this.m=D,this.n=S,this.o=b,this.p=f,this.q=g,this.extensionDescription=P,this.r=N,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new d.$Nd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Tc,this.l.value=new L.$Rc,this.n===void 0&&(this.n=`${l}.${this.handle}`),c.$createCommentThread(D,this.handle,this.n,this.o,v.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=g,this.i.push({dispose:()=>{c.$deleteCommentThread(D,this.handle)}});const O=this;this.value={get uri(){return O.uri},get range(){return O.range},set range(M){O.range=M},get comments(){return O.comments},set comments(M){O.comments=M},get collapsibleState(){return O.collapsibleState},set collapsibleState(M){O.collapsibleState=M},get canReply(){return O.canReply},set canReply(M){O.canReply=M},get contextValue(){return O.contextValue},set contextValue(M){O.contextValue=M},get label(){return O.label},set label(M){O.label=M},get state(){return O.state},set state(M){O.state=M},dispose:()=>{O.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Rc);const l=S=>Object.prototype.hasOwnProperty.call(this.b,S),D={};l("range")&&(D.range=v.Range.from(this.p)),l("label")&&(D.label=this.label),l("contextValue")&&(D.contextValue=this.contextValue??null),l("comments")&&(D.comments=this.q.map(S=>h(this,S,this.k,this.extensionDescription))),l("collapsibleState")&&(D.collapseState=a(this.g)),l("canReply")&&(D.canReply=this.canReply),l("state")&&(D.state=i(this.h)),l("isTemplate")&&(D.isTemplate=this.r),this.b={},c.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(l){for(const D of this.k){const S=D[0],b=D[1];if(l===b)return S}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}He([(0,T.$hh)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class m{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,c.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,c.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,D,S,b){this.f=l,this.g=D,this.h=S,this.i=b,this.a=new Map,c.$registerCommentController(this.handle,S,b,this.f.identifier.value);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(g){f.options=g},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(g){f.commentingRangeProvider=g},get reactionHandler(){return f.reactionHandler},set reactionHandler(g){f.reactionHandler=g},createCommentThread(g,P,N){return f.createCommentThread(g,P,N).value},dispose:()=>{f.dispose()}}),this.e=[],this.e.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(l,D,S){D===void 0&&(0,w.$aF)(this.f,"fileComments");const b=new o(this.id,this.handle,void 0,l,D,S,this.f,!1);return this.a.set(b.handle,b),b}$createCommentThreadTemplate(l,D){const S=new o(this.id,this.handle,void 0,A.URI.revive(l),v.Range.to(D),[],this.f,!0);return S.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(S.handle,S),S}$updateCommentThreadTemplate(l,D){const S=this.a.get(l);S&&(S.range=v.Range.to(D))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function h(s,l,D,S){let b=D.get(l);return b||(b=++s.commentHandle,D.set(l,b)),l.state!==void 0&&(0,w.$aF)(S,"commentsDraftState"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:b,body:typeof l.body=="string"?l.body:v.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(f=>t(f)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(s){return{label:s.label,iconPath:s.iconPath?v.$cM(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function n(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?A.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function a(s){if(s!==void 0)switch(s){case R.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function i(s){if(s!==void 0)switch(s){case R.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new r}e.$4bc=y}),define(De[304],Ce([1,0,24,6,27,20]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;let A=class{constructor(R,I){this.a=R.getProxy(T.$cK.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,I){const w=this,y=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){w.e(R,I,y,arguments)}})}e(R,I,w,y){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:E(y,this.b)}),this.c&&this.f(R,w,y)}};e.$2dc=A,e.$2dc=A=He([Be(0,L.$dM),Be(1,d.$tM)],A);const $=1e5;function E(v,R){const I=[];if(v.length)for(let w=0;w<v.length;w++){let y=v[w];if(typeof y>"u")y="undefined";else if(y instanceof Error){const k=y;k.stack?y=k.stack:y=k.toString()}I.push(y)}if(R){const w=new Error().stack;w&&I.push({__$stack:w.split(`
`).slice(3).join(`
`)})}try{const w=(0,C.$9m)(I);return w.length>$?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}),define(De[149],Ce([1,0,2,6,7,5,20,14,19,15,16,26]),function($e,e,C,T,d,L,A,$,E,v,R,I){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=e.$5cc=void 0;let y=class{static{w=this}static{this.c=0}static{this.d=250}constructor(p,u){this.h=u,this.f=new Map,this.g=p.getProxy(T.$cK.MainThreadDecorations)}registerFileDecorationProvider(p,u){const c=w.c++;this.f.set(c,{provider:p,extensionDescription:u}),this.g.$registerDecorationProvider(c,u.identifier.value);const r=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(c,null);return}const m=(0,E.$3b)(o);if(m.length<=w.d){this.g.$onDidChange(c,m);return}this.h.warn("[Decorations] CAPPING events from decorations provider",u.identifier.value,m.length);const h=m.map(a=>({uri:a,rank:(0,v.$Ge)(a.path,"/")})),t=(0,E.$zb)(h,(a,i)=>a.rank-i.rank||(0,v.$Ue)(a.uri.path,i.uri.path)),n=[];e:for(const a of t){let i;for(const s of a){const l=(0,R.$mc)(s.uri.path);if(i!==l&&(i=l,n.push(s.uri)>=w.d))break e}}this.g.$onDidChange(c,n)});return new d.$eK(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(p,u,c){if(!this.f.has(p))return Object.create(null);const r=Object.create(null),{provider:o,extensionDescription:m}=this.f.get(p);return await Promise.all(u.map(async h=>{try{const{uri:t,id:n}=h,a=await Promise.resolve(o.provideFileDecoration(C.URI.revive(t),c));if(!a)return;try{d.$zL.validate(a),a.badge&&typeof a.badge!="string"&&(0,I.$aF)(m,"codiconDecoration"),r[n]=[a.propagate,a.tooltip,a.badge,a.color]}catch(i){this.h.warn(`INVALID decoration from extension '${m.identifier.value}': ${i}`)}}catch(t){this.h.error(t)}})),r}};e.$5cc=y,e.$5cc=y=w=He([Be(0,A.$dM),Be(1,$.$9i)],y),e.$6cc=(0,L.$Oh)("IExtHostDecorations")}),define(De[305],Ce([1,0,203,133,2,6,7,13,4,14,28,55]),function($e,e,C,T,d,L,A,$,E,v,R,I){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=e.$Vbc=void 0;class y{#e;#t;#i;constructor(u,c,r,o,m,h,t,n){this.d=u,this.e=c,this.f=r,this.g=o,this.h=m,this.c=!1,this.f=Math.max(o,r),this.#i=new R.$Ac(a=>h.getComparisonKey(a)),this.#e=t,this.#t=n}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(u,c){if(!u){this.clear();return}this.j();let r=[];if(d.URI.isUri(u)){if(!c){this.delete(u);return}this.#i.set(u,c.slice()),r=[u]}else if(Array.isArray(u)){r=[];let h;u=[...u].sort(y.k);for(const t of u){const[n,a]=t;if((!h||n.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=n,r.push(n),this.#i.set(n,[])),a)this.#i.get(n)?.push(...a);else{const i=this.#i.get(n);i&&(i.length=0)}}}if(this.#t.fire(r),!this.#e)return;const o=[];let m=0;for(const h of r){let t=[];const n=this.#i.get(h);if(n)if(n.length>this.g){t=[];const a=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const s of n)if(s.severity===a[i]&&t.push({...$.Diagnostic.from(s),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:T.MarkerSeverity.Info,message:(0,C.localize)(0,null,n.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=n.map(a=>({...$.Diagnostic.from(a),modelVersionId:this.h(h)}));if(o.push([h,t]),m+=t.length,m>this.f)break}this.#e.$changeMany(this.e,o)}delete(u){this.j(),this.#t.fire([u]),this.#i.delete(u),this.#e?.$changeMany(this.e,[[u,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(u,c){this.j();for(const[r,o]of this)u.call(c,r,o,this)}*[Symbol.iterator](){this.j();for(const u of this.#i.keys())yield[u,this.get(u)]}get(u){this.j();const c=this.#i.get(u);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(u){return this.j(),Array.isArray(this.#i.get(u))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(u,c){return u[0].toString()<c[0].toString()?-1:u[0].toString()>c[0].toString()?1:0}}e.$Vbc=y;let k=class{static{w=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*w.d}static _mapper(u){const c=new R.$Ac;for(const r of u)c.set(r,r);return{uris:Object.freeze(Array.from(c.values()))}}constructor(u,c,r,o){this.j=c,this.k=r,this.l=o,this.g=new Map,this.h=new E.$Rd({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,w._mapper),this.f=u.getProxy(L.$cK.MainThreadDiagnostics)}createDiagnosticCollection(u,c){const{g:r,f:o,h:m,j:h,k:t,l:n}=this,a=new class{$changeMany(l,D){o.$changeMany(l,D),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,l,D.length===0?"CLEARING":D)}$clear(l){o.$clear(l),h.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,l)}dispose(){o.dispose()}};let i;if(!c)c="_generated_diagnostic_collection_name_#"+w.c++,i=c;else if(!r.has(c))i=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do i=c+w.c++;while(r.has(i))}return new class extends y{constructor(){super(c,i,w.e,w.d,l=>n.getDocument(l)?.version,t.extUri,a,m),r.set(i,this)}dispose(){super.dispose(),r.delete(i)}}}getDiagnostics(u){if(u)return this.m(u);{const c=new Map,r=[];for(const o of this.g.values())o.forEach((m,h)=>{let t=c.get(m.toString());typeof t>"u"&&(t=r.length,c.set(m.toString(),t),r.push([m,[]])),r[t][1]=r[t][1].concat(...h)});return r}}m(u){let c=[];for(const r of this.g.values())r.has(u)&&(c=c.concat(r.get(u)));return c}$acceptMarkersChange(u){if(!this.n){const c="_generated_mirror",r=new y(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,o=>{},this.k.extUri,void 0,this.h);this.g.set(c,r),this.n=r}for(const[c,r]of u)this.n.set(d.URI.revive(c),r.map($.Diagnostic.to))}};e.$Wbc=k,e.$Wbc=k=w=He([Be(1,v.$9i),Be(2,I.$Ubc)],k)}),define(De[306],Ce([1,0,2,6,26]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=void 0;class L{constructor($){this.a=$.getProxy(T.$cK.MainThreadDialogs)}showOpenDialog($,E){return E?.allowUIResources&&(0,d.$aF)($,"showLocal"),this.a.$showOpenDialog(E).then(v=>v?v.map(R=>C.URI.revive(R)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(E=>E?C.URI.revive(E):void 0)}}e.$_bc=L}),define(De[307],Ce([1,0,8,2,7,6,18,21,15]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=void 0;class v{static{this.a=0}constructor(I,w,y){this.d=w,this.e=y,this.b=new Map,this.c=I.getProxy(L.$cK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,w){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const y=v.a++;this.b.set(y,w),this.c.$registerTextContentProvider(y,I);let k;return typeof w.onDidChange=="function"&&(k=w.onDidChange(p=>{if(p.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this.d.getDocument(p)&&this.$provideTextDocumentContent(y,p).then(u=>{if(!u&&typeof u!="string")return;const c=this.d.getDocument(p);if(!c)return;const r=(0,E.$Pe)(u);if(!c.equalLines(r))return this.c.$onVirtualDocumentChange(p,u)},C.$1)})),new d.$eK(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),k&&(k.dispose(),k=void 0)})}$provideTextDocumentContent(I,w){const y=this.b.get(I);return y?Promise.resolve(y.provideTextDocumentContent(T.URI.revive(w),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.$acc=v}),define(De[308],Ce([1,0,4,3,2,6,141,13,17,24,7,8]),function($e,e,C,T,d,L,A,$,E,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;class w{constructor(k,p){this.a=new C.$Nd({onListenerError:I.$2}),this.b=new C.$Nd({onListenerError:I.$2}),this.c=new C.$Nd({onListenerError:I.$2}),this.d=new C.$Nd({onListenerError:I.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Rc,this.h=new Map,this.f=k.getProxy(L.$cK.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(u=>{for(const c of u)this.b.fire(c.document)},void 0,this.e),this.g.onDidAddDocuments(u=>{for(const c of u)this.a.fire(c.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const p=this.g.getDocument(k);if(p)return p}getDocument(k){const p=this.getDocumentData(k);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return p.document}ensureDocumentData(k){const p=this.g.getDocument(k);if(p)return Promise.resolve(p);let u=this.h.get(k.toString());return u||(u=this.f.$tryOpenDocument(k).then(c=>{this.h.delete(k.toString());const r=d.URI.revive(c);return(0,E.$Jf)(this.g.getDocument(r))},c=>(this.h.delete(k.toString()),Promise.reject(c))),this.h.set(k.toString(),u)),u}createDocumentData(k){return this.f.$tryCreateDocument(k).then(p=>d.URI.revive(p))}$acceptModelLanguageChanged(k,p){const u=d.URI.revive(k),c=this.g.getDocument(u);if(!c)throw new Error("unknown document");this.b.fire(c.document),c._acceptLanguageId(p),this.a.fire(c.document)}$acceptModelSaved(k){const p=d.URI.revive(k),u=this.g.getDocument(p);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(u.document)}$acceptDirtyStateChanged(k,p){const u=d.URI.revive(k),c=this.g.getDocument(u);if(!c)throw new Error("unknown document");c._acceptIsDirty(p),this.c.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,p,u){const c=d.URI.revive(k),r=this.g.getDocument(c);if(!r)throw new Error("unknown document");r._acceptIsDirty(u),r.onEvents(p);let o;p.isUndoing?o=R.TextDocumentChangeReason.Undo:p.isRedoing&&(o=R.TextDocumentChangeReason.Redo),this.c.fire((0,v.$5m)({document:r.document,contentChanges:p.changes.map(m=>({range:$.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text})),reason:o}))}setWordDefinitionFor(k,p){(0,A.$fM)(k,p)}}e.$Sbc=w}),define(De[70],Ce([1,0,58,4,3,2,5,6,141,20,146,13,14,28,18,51,47]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oM=e.$nM=void 0;class c{constructor(m){this.value=m,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(m,h){this.h=m,this.i=h,this.a=null,this.b=new Map,this.c=new y.$Ac,this.d=new T.$Nd,this.e=new T.$Nd,this.f=new T.$Nd,this.g=new T.$Nd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(m){this.acceptDocumentsAndEditorsDelta(m)}acceptDocumentsAndEditorsDelta(m){const h=[],t=[],n=[];if(m.removedDocuments)for(const a of m.removedDocuments){const i=L.URI.revive(a),s=this.c.get(i);s?.unref()&&(this.c.delete(i),h.push(s.value))}if(m.addedDocuments)for(const a of m.addedDocuments){const i=L.URI.revive(a.uri);let s=this.c.get(i);if(s&&i.scheme!==k.Schemas.vscodeNotebookCell&&i.scheme!==k.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);s||(s=new c(new E.$gM(this.h.getProxy($.$cK.MainThreadDocuments),i,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(i,s),t.push(s.value)),s.ref()}if(m.removedEditors)for(const a of m.removedEditors){const i=this.b.get(a);this.b.delete(a),i&&n.push(i)}if(m.addedEditors)for(const a of m.addedEditors){const i=L.URI.revive(a.documentUri);C.ok(this.c.has(i),`document '${i}' does not exist`),C.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const s=this.c.get(i).value,l=new R.$mM(a.id,this.h.getProxy($.$cK.MainThreadTextEditors),this.i,new u.$V(()=>s.document),a.selections.map(I.Selection.to),a.options,a.visibleRanges.map(D=>I.Range.to(D)),typeof a.editorPosition=="number"?I.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,l)}m.newActiveEditor!==void 0&&(C.ok(m.newActiveEditor===null||this.b.has(m.newActiveEditor),`active editor '${m.newActiveEditor}' does not exist`),this.a=m.newActiveEditor),(0,d.$Nc)(h),(0,d.$Nc)(n),m.removedDocuments&&this.e.fire(h),m.addedDocuments&&this.d.fire(t),(m.removedEditors||m.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),m.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(m){return this.c.get(m)?.value}allDocuments(){return p.Iterable.map(this.c.values(),m=>m.value)}getEditor(m){return this.b.get(m)}activeEditor(m){if(!this.a)return;const h=this.b.get(this.a);return m?h:h?.value}allEditors(){return[...this.b.values()]}};e.$nM=r,e.$nM=r=He([Be(0,v.$dM),Be(1,w.$9i)],r),e.$oM=(0,A.$Oh)("IExtHostDocumentsAndEditors")}),define(De[71],Ce([1,0,13,6,2,4,5,7,20,17,74]),function($e,e,C,T,d,L,A,$,E,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=e.$0cc=void 0,e.$0cc=(0,A.$Oh)("IExtHostEditorTabs");class I{constructor(u,c,r){this.e=r,this.d=c,this.acceptDtoUpdate(u)}get apiObject(){if(!this.a){const u=this,c={get isActive(){return u.b.id===u.e()},get label(){return u.b.label},get input(){return u.c},get isDirty(){return u.b.isDirty},get isPinned(){return u.b.isPinned},get isPreview(){return u.b.isPreview},get group(){return u.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(u){this.b=u,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new $.$VL(d.URI.revive(this.b.input.uri));case 2:return new $.$WL(d.URI.revive(this.b.input.original),d.URI.revive(this.b.input.modified));case 3:return new $.$XL(d.URI.revive(this.b.input.base),d.URI.revive(this.b.input.input1),d.URI.revive(this.b.input.input2),d.URI.revive(this.b.input.result));case 6:return new $.$YL(d.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new $.$ZL(this.b.input.viewType);case 4:return new $.$1L(d.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new $.$2L(d.URI.revive(this.b.input.original),d.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new $.$3L;case 9:return new $.$4L(d.URI.revive(this.b.input.uri),d.URI.revive(this.b.input.inputBoxUri));default:return}}}class w{constructor(u,c){this.c=[],this.d="",this.b=u,this.e=c;for(const r of u.tabs)r.isActive&&(this.d=r.id),this.c.push(new I(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const u=this,c={get isActive(){return u.b.groupId===u.e()},get viewColumn(){return C.ViewColumn.to(u.b.viewColumn)},get activeTab(){return u.c.find(r=>r.tabId===u.d)?.apiObject},get tabs(){return Object.freeze(u.c.map(r=>r.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(u){this.b=u}acceptTabOperation(u){if(u.kind===0){const r=new I(u.tabDto,this,()=>this.activeTabId());return this.c.splice(u.index,0,r),u.tabDto.isActive&&(this.d=r.tabId),r}else if(u.kind===1){const r=this.c.splice(u.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(u.kind===3){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(u.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this.c.splice(u.index,0,r),r}const c=this.c.find(r=>r.tabId===u.tabDto.id);if(!c)throw new Error("INVALID tab");return u.tabDto.isActive?this.d=u.tabDto.id:this.d===u.tabDto.id&&!u.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(u.tabDto),c}activeTabId(){return this.d}}let y=class{constructor(u){this.b=new L.$Nd,this.c=new L.$Nd,this.e=[],this.a=u.getProxy(T.$cK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const u=this,c={onDidChangeTabGroups:u.c.event,onDidChangeTabs:u.b.event,get all(){return Object.freeze(u.e.map(r=>r.apiObject))},get activeTabGroup(){const r=u.d;return(0,v.$Jf)(u.e.find(m=>m.groupId===r)?.apiObject)},close:async(r,o)=>{const m=Array.isArray(r)?r:[r];return m.length?k(m[0])?this.j(m,o):this.i(m,o):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(u){const c=new Set(this.e.map(a=>a.groupId)),r=new Set(u.map(a=>a.groupId)),o=(0,R.$K)(c,r),m=this.e.filter(a=>o.removed.includes(a.groupId)).map(a=>a.apiObject),h=[],t=[];this.e=u.map(a=>{const i=new w(a,()=>this.d);return o.added.includes(i.groupId)?h.push(i.apiObject):t.push(i.apiObject),i});const n=(0,v.$Jf)(u.find(a=>a.isActive===!0)?.groupId);n!==void 0&&this.d!==n&&(this.d=n),this.c.fire(Object.freeze({opened:h,closed:m,changed:t}))}$acceptTabGroupUpdate(u){const c=this.e.find(r=>r.groupId===u.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(u),u.isActive&&(this.d=u.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const c=this.e.find(o=>o.groupId===u.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const r=c.acceptTabOperation(u);switch(u.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(u){for(const c of this.e)for(const r of c.tabs)if(r.apiObject===u)return r}h(u){return this.e.find(c=>c.apiObject===u)}async i(u,c){const r=[];for(const o of u){const m=this.g(o);if(!m)throw new Error("Tab close: Invalid tab not found!");r.push(m.tabId)}return this.a.$closeTab(r,c)}async j(u,c){const r=[];for(const o of u){const m=this.h(o);if(!m)throw new Error("Group close: Invalid group not found!");r.push(m.groupId)}return this.a.$closeGroup(r,c)}};e.$$cc=y,e.$$cc=y=He([Be(0,E.$dM)],y);function k(p){return p.tabs!==void 0}}),define(De[309],Ce([1,0,6,7]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0;class d{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$cK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,$,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const v=this.a.get(A);if(!v)throw new Error("Embedding vector provider not found");const R=await v.provideEmbeddingVector($,E);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,$,E){const v=this.b;return this.b++,this.a.set(v,E),this.c.$registerAiEmbeddingVectorProvider($,v),new T.$eK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(v),this.a.delete(v)})}}e.$Wdc=d}),define(De[310],Ce([1,0,2,6,3,7,13,169,15,22,26,80]),function($e,e,C,T,d,L,A,$,E,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=void 0;class w{constructor(){this.a=[]}add(p){this.b=void 0,this.a.push(p)}delete(p){const u=this.a.indexOf(p);u>=0&&(this.a.splice(u,1),this.b=void 0)}c(){if(!this.b){const p=this.a.sort(),u=[];let c,r,o=14,m=14;for(const h of p){let t=c?(0,E.$4e)(c,h):0;for(t===0?r=1:r=m;t<h.length;t++)t+1===h.length?(o=m,m=9):m+=1,u.push([r,h.toUpperCase().charCodeAt(t),m]),u.push([r,h.toLowerCase().charCodeAt(t),m]),r=m;c=h,m=o}u.push([9,58,10]),u.push([10,47,12]),this.b=new $.$VY(u)}}provideDocumentLinks(p){this.c();const u=[],c=$.$WY.computeLinks({getLineContent(r){return p.lineAt(r-1).text},getLineCount(){return p.lineCount}},this.b);for(const r of c){const o=A.DocumentLink.to(r);o.target&&u.push(o)}return u}}class y{constructor(p,u){this.i=u,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=p.getProxy(T.$cK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(p,u,c,r={}){if(y.j(c),this.d.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(p,"*",this.b));const o=this.h++;this.b.add(u),this.d.add(u),this.c.set(o,c);let m=2;r.isCaseSensitive&&(m+=1024),r.isReadonly&&(m+=2048),typeof c.copy=="function"&&(m+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&((0,R.$aF)(p,"fsChunks"),m+=4);let h;r.isReadonly&&(0,I.$4j)(r.isReadonly)&&((0,R.$aF)(p,"readonlyMessage"),h={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(o,u,m,h).catch(n=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${u}`),console.error(n)});const t=c.onDidChangeFile(n=>{const a=[];for(const i of n){const{uri:s,type:l}=i;if(s.scheme!==u)continue;let D;switch(l){case L.FileChangeType.Changed:D=0;break;case L.FileChangeType.Created:D=1;break;case L.FileChangeType.Deleted:D=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:s,type:D})}this.a.$onFileSystemChange(o,a)});return(0,d.$Qc)(()=>{t.dispose(),this.b.delete(u),this.d.delete(u),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static k(p){const{type:u,ctime:c,mtime:r,size:o,permissions:m}=p;return{type:u,ctime:c,mtime:r,size:o,permissions:m}}$stat(p,u){return Promise.resolve(this.l(p).stat(C.URI.revive(u))).then(c=>y.k(c))}$readdir(p,u){return Promise.resolve(this.l(p).readDirectory(C.URI.revive(u)))}$readFile(p,u){return Promise.resolve(this.l(p).readFile(C.URI.revive(u))).then(c=>v.$be.wrap(c))}$writeFile(p,u,c,r){return Promise.resolve(this.l(p).writeFile(C.URI.revive(u),c.buffer,r))}$delete(p,u,c){return Promise.resolve(this.l(p).delete(C.URI.revive(u),c))}$rename(p,u,c,r){return Promise.resolve(this.l(p).rename(C.URI.revive(u),C.URI.revive(c),r))}$copy(p,u,c,r){const o=this.l(p);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(C.URI.revive(u),C.URI.revive(c),r))}$mkdir(p,u){return Promise.resolve(this.l(p).createDirectory(C.URI.revive(u)))}$watch(p,u,c,r){const o=this.l(p).watch(C.URI.revive(c),r);this.f.set(u,o)}$unwatch(p,u){const c=this.f.get(u);c&&(c.dispose(),this.f.delete(u))}$open(p,u,c){const r=this.l(p);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(C.URI.revive(u),c))}$close(p,u){const c=this.l(p);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(u))}$read(p,u,c,r){const o=this.l(p);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const m=v.$be.alloc(r);return Promise.resolve(o.read(u,c,m.buffer,0,r)).then(h=>m.slice(0,h))}$write(p,u,c,r){const o=this.l(p);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(u,c,r.buffer,0,r.byteLength))}l(p){const u=this.c.get(p);if(!u){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return u}}e.$Gcc=y}),define(De[72],Ce([1,0,6,30,7,22,5,20,55,3,9,23,18]),function($e,e,C,T,d,L,A,$,E,v,R,I,w){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=e.$mcc=void 0;let k=y=class{constructor(u,c){this.b=new Map,this.c=new R.$3g,this.a=u.getProxy(C.$cK.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(o){try{let m;const h=r.b.get(o.scheme);return h?(await r.a.$ensureActivation(o.scheme),m=await h.impl.stat(o)):m=await r.a.$stat(o),{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===T.FilePermission.Readonly?1:void 0}}catch(m){y.e(m)}},async readDirectory(o){try{const m=r.b.get(o.scheme);return m?(await r.a.$ensureActivation(o.scheme),(await m.impl.readDirectory(o)).slice()):await r.a.$readdir(o)}catch(m){return y.e(m)}},async createDirectory(o){try{const m=r.b.get(o.scheme);return m&&!m.isReadonly?(await r.a.$ensureActivation(o.scheme),await r.d(m.impl,m.extUri,o)):await r.a.$mkdir(o)}catch(m){return y.e(m)}},async readFile(o){try{const m=r.b.get(o.scheme);return m?(await r.a.$ensureActivation(o.scheme),(await m.impl.readFile(o)).slice()):(await r.a.$readFile(o)).buffer}catch(m){return y.e(m)}},async writeFile(o,m){try{const h=r.b.get(o.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(o.scheme),await r.d(h.impl,h.extUri,h.extUri.dirname(o)),await r.c.queueFor(o).queue(()=>Promise.resolve(h.impl.writeFile(o,m,{create:!0,overwrite:!0})))):await r.a.$writeFile(o,L.$be.wrap(m))}catch(h){return y.e(h)}},async delete(o,m){try{const h=r.b.get(o.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(o.scheme),await h.impl.delete(o,{recursive:!1,...m})):await r.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...m})}catch(h){return y.e(h)}},async rename(o,m,h){try{return await r.a.$rename(o,m,{overwrite:!1,...h})}catch(t){return y.e(t)}},async copy(o,m,h){try{return await r.a.$copy(o,m,{overwrite:!1,...h})}catch(t){return y.e(t)}},isWritableFileSystem(o){const m=c.getCapabilities(o);if(typeof m=="number")return!(m&2048)}})}async d(u,c,r){const o=[];for(;!c.isEqual(r,c.dirname(r));)try{if(!((await u.stat(r)).type&T.FileType.Directory))throw d.$rL.FileExists(`Unable to create folder '${r.scheme===w.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(m){if(T.$nk(m)!==T.FileSystemProviderErrorCode.FileNotFound)throw m;o.push(c.basename(r)),r=c.dirname(r)}for(let m=o.length-1;m>=0;m--){r=c.joinPath(r,o[m]);try{await u.createDirectory(r)}catch(h){if(T.$nk(h)!==T.FileSystemProviderErrorCode.FileExists)throw h}}}static e(u){if(u instanceof d.$rL)throw u;if(u instanceof T.$jk)switch(u.code){case T.FileSystemProviderErrorCode.FileExists:throw d.$rL.FileExists(u.message);case T.FileSystemProviderErrorCode.FileNotFound:throw d.$rL.FileNotFound(u.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw d.$rL.FileNotADirectory(u.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw d.$rL.FileIsADirectory(u.message);case T.FileSystemProviderErrorCode.NoPermissions:throw d.$rL.NoPermissions(u.message);case T.FileSystemProviderErrorCode.Unavailable:throw d.$rL.Unavailable(u.message);default:throw new d.$rL(u.message,u.name)}if(!(u instanceof Error))throw new d.$rL(String(u));if(u.name==="ENOPRO"||u.message.includes("ENOPRO"))throw d.$rL.Unavailable(u.message);switch(u.name){case T.FileSystemProviderErrorCode.FileExists:throw d.$rL.FileExists(u.message);case T.FileSystemProviderErrorCode.FileNotFound:throw d.$rL.FileNotFound(u.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw d.$rL.FileNotADirectory(u.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw d.$rL.FileIsADirectory(u.message);case T.FileSystemProviderErrorCode.NoPermissions:throw d.$rL.NoPermissions(u.message);case T.FileSystemProviderErrorCode.Unavailable:throw d.$rL.Unavailable(u.message);default:throw new d.$rL(u.message,u.name)}}addFileSystemProvider(u,c,r){return this.b.set(u,{impl:c,extUri:r?.isCaseSensitive?I.$lg:I.$ng,isReadonly:!!r?.isReadonly}),(0,v.$Qc)(()=>this.b.delete(u))}getFileSystemProviderExtUri(u){return this.b.get(u)?.extUri??I.$lg}};e.$mcc=k,e.$mcc=k=y=He([Be(0,$.$dM),Be(1,E.$Ubc)],k),e.$ncc=(0,A.$Oh)("IExtHostConsumerFileSystem")}),define(De[311],Ce([1,0,4,35,2,6,13,7,47]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;class v{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,k,p,u,c,r){this.a=Math.random(),this.b=new C.$Nd,this.c=new C.$Nd,this.d=new C.$Nd,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const o=(0,T.$vj)(c),m=typeof c=="string",h=u(t=>{if(!(typeof t.session=="number"&&t.session!==this.a)){if(!r?.ignoreCreateEvents)for(const n of t.created){const a=d.URI.revive(n);o(a.fsPath)&&(!m||k.getWorkspaceFolder(a))&&this.b.fire(a)}if(!r?.ignoreChangeEvents)for(const n of t.changed){const a=d.URI.revive(n);o(a.fsPath)&&(!m||k.getWorkspaceFolder(a))&&this.c.fire(a)}if(!r?.ignoreDeleteEvents)for(const n of t.deleted){const a=d.URI.revive(n);o(a.fsPath)&&(!m||k.getWorkspaceFolder(a))&&this.d.fire(a)}}});this.g=$.$eK.from(this.i(y,p,c,r),this.b,this.c,this.d,h)}i(y,k,p,u){const c=$.$eK.from();if(typeof p=="string")return c;const r=y.getProxy(L.$cK.MainThreadFileSystemEventService);let o=!1;return(p.pattern.includes(T.$rj)||p.pattern.includes(T.$sj))&&(o=!0),r.$watch(k.identifier.value,this.a,p.baseUri,{recursive:o,excludes:u?.excludes??[]}),$.$eK.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(y){this.a=y,this.session=this.a.session,this.b=new E.$V(()=>this.a.created.map(d.URI.revive)),this.c=new E.$V(()=>this.a.changed.map(d.URI.revive)),this.d=new E.$V(()=>this.a.deleted.map(d.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(y,k,p){this.j=y,this.k=k,this.l=p,this.a=new C.$Nd,this.b=new C.$Nd,this.c=new C.$Nd,this.d=new C.$Nd,this.g=new C.$Pd,this.h=new C.$Pd,this.i=new C.$Pd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,k,p,u){return new v(this.j,y,k,this.a.event,A.GlobPattern.from(p),u)}$onFileEvent(y){this.a.fire(new R(y))}$onDidRunFileOperation(y,k){switch(y){case 2:this.b.fire(Object.freeze({files:k.map(p=>({oldUri:d.URI.revive(p.source),newUri:d.URI.revive(p.target)}))}));break;case 1:this.d.fire(Object.freeze({files:k.map(p=>d.URI.revive(p.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:k.map(p=>d.URI.revive(p.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,k){return(p,u,c)=>{const r=function(m){p.call(u,m)};return r.extension=y,k.event(r,void 0,c)}}async $onWillRunFileOperation(y,k,p,u){switch(y){case 2:return await this.n(this.g,{files:k.map(c=>({oldUri:d.URI.revive(c.source),newUri:d.URI.revive(c.target)}))},p,u);case 1:return await this.n(this.i,{files:k.map(c=>d.URI.revive(c.target))},p,u);case 0:case 3:return await this.n(this.h,{files:k.map(c=>d.URI.revive(c.target))},p,u)}}async n(y,k,p,u){const c=new Set,r=[];if(await y.fireAsync(k,u,async(m,h)=>{const t=Date.now(),n=await Promise.resolve(m);n instanceof $.$oK&&(r.push([h.extension,n]),c.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>p&&this.k.warn("SLOW file-participant",h.extension.identifier)}),u.isCancellationRequested||r.length===0)return;const o={edits:[]};for(const[,m]of r){const{edits:h}=A.WorkspaceEdit.from(m,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(h)}return{edit:o,extensionNames:Array.from(c)}}}e.$Hcc=I}),define(De[312],Ce([1,0,3,2,6,13,7,33,9]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class v{static{this.a=0}constructor(y,k){this.extension=y,this.provider=k,this.handle=v.a++}}class R{constructor(y){this.session=y,this.responses=[]}}class I{static{this.a=0}constructor(y,k,p,u){this.f=p,this.g=u,this.b=new Map,this.d=new Map,this.e=y.getProxy(d.$cK.MainThreadInlineChat),k.registerApiCommand(new $.$DM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$BM("Run arguments","",c=>!0,c=>{if(c)return{initialRange:c.initialRange?L.Range.from(c.initialRange):void 0,initialSelection:c.initialSelection?L.Selection.from(c.initialSelection):void 0,message:c.message,autoSend:c.autoSend,position:c.position?L.Position.from(c.position):void 0}})],$.$CM.Void))}registerProvider(y,k,p){const u=new v(y,k);return this.b.set(u.handle,u),this.e.$registerInteractiveEditorProvider(u.handle,p.label,y.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function"),(0,C.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(u.handle),this.b.delete(u.handle)})}async $prepareSession(y,k,p,u){const c=this.b.get(y);if(!c){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(T.URI.revive(k)),o=L.Selection.to(p),m=await c.provider.prepareInteractiveEditorSession({document:r,selection:o},u);if(!m)return;if(m.wholeRange&&!m.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=I.a++;return this.d.set(h,new R(m)),{id:h,placeholder:m.placeholder,slashCommands:m.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:L.Range.from(m.wholeRange),message:m.message}}async $provideResponse(y,k,p,u){const c=this.b.get(y);if(!c)return;const r=this.d.get(k.id);if(!r)return;const o={prompt:p.prompt,selection:L.Selection.to(p.selection),wholeRange:L.Range.to(p.wholeRange),attempt:p.attempt,live:p.live};let m=!1;const h={report:async l=>{if(!p.live)throw new Error("Progress reporting is only supported for live sessions");m||u.isCancellationRequested||await this.e.$handleProgressChunk(p.requestId,{message:l.message,edits:l.edits?.map(L.TextEdit.from),slashCommand:l.slashCommand?.command})}},t=Promise.resolve(c.provider.provideInteractiveEditorResponse(r.session,o,h,u));let n;try{n=await(0,E.$Ig)(t,u)}finally{m=!0}if(!n)return;const a=r.responses.push(n)-1,i={wholeRange:L.Range.from(n.wholeRange),placeholder:n.placeholder};if(I.h(n))return{...i,id:a,type:"message",message:L.MarkdownString.from(n.contents)};const{edits:s}=n;return s instanceof A.$oK?{...i,id:a,type:"bulkEdit",edits:L.WorkspaceEdit.from(s)}:{...i,id:a,type:"editorEdit",edits:s.map(L.TextEdit.from)}}$handleFeedback(y,k,p,u){const c=this.b.get(y),r=this.d.get(k),o=r?.responses[p];if(c&&o){const m=L.InteractiveEditorResponseFeedbackKind.to(u);c.provider.handleInteractiveEditorResponseFeedback?.(r.session,o,m)}}$releaseSession(y,k){}static h(y){return typeof y=="object"&&typeof y.contents=="object"}}e.$Odc=I}),define(De[313],Ce([1,0,2,33]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class d{constructor(A,$,E,v,R){this.a=$,this.b=E,this.c=v;const I=new T.$DM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$BM("showOptions","Show Options",w=>!0,w=>w),new T.$BM("resource","Interactive resource Uri",w=>!0,w=>w),new T.$BM("controllerId","Notebook controller Id",w=>!0,w=>w),new T.$BM("title","Interactive editor title",w=>!0,w=>w)],new T.$CM("Notebook and input URI",w=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",w.notebookEditorId),w.notebookEditorId!==void 0){const y=this.a.getEditorById(w.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:C.URI.revive(w.notebookUri),inputUri:C.URI.revive(w.inputUri),notebookEditor:y.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",w.notebookUri,w.inputUri),{notebookUri:C.URI.revive(w.notebookUri),inputUri:C.URI.revive(w.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(A,$,E,v){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(C.URI.revive(v))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Kdc=d}),define(De[314],Ce([1,0,6,7]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;class d{constructor(A){this.a=new Map,this.b=A.getProxy(C.$cK.MainThreadIssueReporter)}async $getIssueReporterUri(A,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(A);if(!E)throw new Error("Issue request handler not found");const v=await E.handleIssueUrlRequest();if(!v)throw new Error("Issue request handler returned no result");return v}registerIssueUriRequestHandler(A,$){const E=A.identifier.value;return this.a.set(E,$),this.b.$registerIssueUriRequestHandler(E),new T.$eK(()=>{this.b.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}}e.$Qdc=d}),define(De[315],Ce([1,0,3,6]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class d{constructor(A){this.b=0,this.a=A.getProxy(T.$cK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const $=this.b++;return this.a.$registerResourceLabelFormatter($,A),(0,C.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$4cc=d}),define(De[316],Ce([1,0,2,24,13,7,83,6,15,34,19,17,165,21,25,3,129,119,107,37,8,9,26,205]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r,o,m,h,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=void 0;class a{constructor(B,J){this.d=B,this.e=J}async provideDocumentSymbols(B,J){const ie=this.d.getDocument(B),se=await this.e.provideDocumentSymbols(ie,J);if(!(0,R.$Kb)(se))return se[0]instanceof L.$wK?se.map(d.DocumentSymbol.from):a.f(se)}static f(B){B=B.slice(0).sort((se,Y)=>{let ge=se.location.range.start.compareTo(Y.location.range.start);return ge===0&&(ge=Y.location.range.end.compareTo(se.location.range.end)),ge});const J=[],ie=[];for(const se of B){const Y={name:se.name||"!!MISSING: name!!",kind:d.SymbolKind.from(se.kind),tags:se.tags?.map(d.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:d.Range.from(se.location.range),selectionRange:d.Range.from(se.location.range),children:[]};for(;;){if(ie.length===0){ie.push(Y),J.push(Y);break}const ge=ie[ie.length-1];if(v.$qs.containsRange(ge.range,Y.range)&&!v.$qs.equalsRange(ge.range,Y.range)){ge.children?.push(Y),ie.push(Y);break}ie.pop()}}return J}}class i{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,J,ie){this.g=B,this.h=J,this.j=ie,this.e=new r.$Rbc("CodeLens"),this.f=new Map}async provideCodeLenses(B,J){const ie=this.g.getDocument(B),se=await this.j.provideCodeLenses(ie,J);if(!se||J.isCancellationRequested)return;const Y=this.e.add(se),ge=new p.$Rc;this.f.set(Y,ge);const ye={cacheId:Y,lenses:[]};for(let je=0;je<se.length;je++)ye.lenses.push({cacheId:[Y,je],range:d.Range.from(se[je].range),command:this.h.toInternal(se[je].command,ge)});return ye}async resolveCodeLens(B,J){const ie=B.cacheId&&this.e.get(...B.cacheId);if(!ie)return;let se;if(typeof this.j.resolveCodeLens!="function"||ie.isResolved?se=ie:se=await this.j.resolveCodeLens(ie,J),se||(se=ie),J.isCancellationRequested)return;const Y=B.cacheId&&this.f.get(B.cacheId[0]);if(Y)return B.command=this.h.toInternal(se.command??i.d,Y),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function s(Pe){return Array.isArray(Pe)?Pe.map(d.DefinitionLink.from):Pe?[d.DefinitionLink.from(Pe)]:[]}class l{constructor(B,J){this.d=B,this.e=J}async provideDefinition(B,J,ie){const se=this.d.getDocument(B),Y=d.Position.to(J),ge=await this.e.provideDefinition(se,Y,ie);return s(ge)}}class D{constructor(B,J){this.d=B,this.e=J}async provideDeclaration(B,J,ie){const se=this.d.getDocument(B),Y=d.Position.to(J),ge=await this.e.provideDeclaration(se,Y,ie);return s(ge)}}class S{constructor(B,J){this.d=B,this.e=J}async provideImplementation(B,J,ie){const se=this.d.getDocument(B),Y=d.Position.to(J),ge=await this.e.provideImplementation(se,Y,ie);return s(ge)}}class b{constructor(B,J){this.d=B,this.e=J}async provideTypeDefinition(B,J,ie){const se=this.d.getDocument(B),Y=d.Position.to(J),ge=await this.e.provideTypeDefinition(se,Y,ie);return s(ge)}}class f{constructor(B,J){this.d=B,this.e=J}async provideHover(B,J,ie){const se=this.d.getDocument(B),Y=d.Position.to(J),ge=await this.e.provideHover(se,Y,ie);if(!(!ge||(0,R.$Kb)(ge.contents)))return ge.range||(ge.range=se.getWordRangeAtPosition(Y)),ge.range||(ge.range=new L.$gK(Y,Y)),d.Hover.from(ge)}}class g{constructor(B,J){this.d=B,this.e=J}async provideEvaluatableExpression(B,J,ie){const se=this.d.getDocument(B),Y=d.Position.to(J),ge=await this.e.provideEvaluatableExpression(se,Y,ie);if(ge)return d.EvaluatableExpression.from(ge)}}class P{constructor(B,J){this.d=B,this.e=J}async provideInlineValues(B,J,ie,se){const Y=this.d.getDocument(B),ge=await this.e.provideInlineValues(Y,d.Range.to(J),d.InlineValueContext.to(ie),se);if(Array.isArray(ge))return ge.map(ye=>d.InlineValue.from(ye))}}class N{constructor(B,J){this.d=B,this.e=J}async provideDocumentHighlights(B,J,ie){const se=this.d.getDocument(B),Y=d.Position.to(J),ge=await this.e.provideDocumentHighlights(se,Y,ie);if(Array.isArray(ge))return ge.map(d.DocumentHighlight.from)}}class O{constructor(B,J){this.d=B,this.e=J}async provideLinkedEditingRanges(B,J,ie){const se=this.d.getDocument(B),Y=d.Position.to(J),ge=await this.e.provideLinkedEditingRanges(se,Y,ie);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,R.$Hb)(ge.ranges.map(d.Range.from)),wordPattern:ge.wordPattern}}}class M{constructor(B,J){this.d=B,this.e=J}async provideReferences(B,J,ie,se){const Y=this.d.getDocument(B),ge=d.Position.to(J),ye=await this.e.provideReferences(Y,ge,ie,se);if(Array.isArray(ye))return ye.map(d.location.from)}}class j{static{this.d=1e3}constructor(B,J,ie,se,Y,ge,ye){this.g=B,this.h=J,this.j=ie,this.k=se,this.l=Y,this.m=ge,this.n=ye,this.e=new r.$Rbc("CodeAction"),this.f=new Map}async provideCodeActions(B,J,ie,se){const Y=this.g.getDocument(B),ge=w.$ss.isISelection(J)?d.Selection.to(J):d.Range.to(J),ye=[];for(const et of this.j.getDiagnostics(B))if(ge.intersection(et.range)&&ye.push(et)>j.d)break;const je={diagnostics:ye,only:ie.only?new L.$yK(ie.only):void 0,triggerKind:d.CodeActionTriggerKind.to(ie.trigger)},We=await this.k.provideCodeActions(Y,ge,je,se);if(!(0,R.$Lb)(We)||se.isCancellationRequested)return;const _e=this.e.add(We),Ye=new p.$Rc;this.f.set(_e,Ye);const it=[];for(let et=0;et<We.length;et++){const Ae=We[et];Ae&&(j.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Ye)})):(je.only&&(Ae.kind?je.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[_e,et],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Ye),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(d.Diagnostic.from),edit:Ae.edit&&d.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$_E)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:_e,actions:it}}async resolveCodeAction(B,J){const[ie,se]=B,Y=this.e.get(ie,se);if(!Y||j.o(Y))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(Y,J)??Y;let ye;ge.edit&&(ye=d.WorkspaceEdit.from(ge.edit,void 0));let je;if(ge.command){const We=this.f.get(ie);We&&(je=this.h.toInternal(ge.command,We))}return{edit:ye,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class z{static toInternalProviderId(B,J){return B+"."+J}constructor(B,J,ie,se,Y){this.d=B,this.e=J,this.f=ie,this.g=se,this.h=Y}async prepareDocumentPaste(B,J,ie,se){if(!this.f.prepareDocumentPaste)return;const Y=this.e.getDocument(B),ge=J.map(We=>d.Range.to(We)),ye=d.DataTransfer.toDataTransfer(ie,()=>{throw new m.$$});if(await this.f.prepareDocumentPaste(Y,ge,ye,se),se.isCancellationRequested)return;const je=Array.from(ye).filter(([,We])=>!(We instanceof L.$5K));return d.DataTransfer.from(je)}async providePasteEdits(B,J,ie,se,Y){if(!this.f.provideDocumentPasteEdits)return;const ge=this.e.getDocument(J),ye=ie.map(_e=>d.Range.to(_e)),je=d.DataTransfer.toDataTransfer(se,async _e=>(await this.d.$resolvePasteFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentPasteEdits(ge,ye,je,Y);if(We)return{label:We.label??(0,n.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:z.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?d.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class F{constructor(B,J){this.d=B,this.e=J}async provideDocumentFormattingEdits(B,J,ie){const se=this.d.getDocument(B),Y=await this.e.provideDocumentFormattingEdits(se,J,ie);if(Array.isArray(Y))return Y.map(d.TextEdit.from)}}class K{constructor(B,J){this.d=B,this.e=J}async provideDocumentRangeFormattingEdits(B,J,ie,se){const Y=this.d.getDocument(B),ge=d.Range.to(J),ye=await this.e.provideDocumentRangeFormattingEdits(Y,ge,ie,se);if(Array.isArray(ye))return ye.map(d.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,J,ie,se){(0,I.$If)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Y=this.d.getDocument(B),ge=J.map(d.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(Y,ge,ie,se);if(Array.isArray(ye))return ye.map(d.TextEdit.from)}}class V{constructor(B,J){this.d=B,this.e=J,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,J,ie,se,Y){const ge=this.d.getDocument(B),ye=d.Position.to(J),je=await this.e.provideOnTypeFormattingEdits(ge,ye,ie,se,Y);if(Array.isArray(je))return je.map(d.TextEdit.from)}}class fe{constructor(B,J){this.e=B,this.f=J,this.d=new r.$Rbc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,J){const ie=await this.e.provideWorkspaceSymbols(B,J);if(!(0,R.$Lb)(ie))return{symbols:[]};const se=this.d.add(ie),Y={cacheId:se,symbols:[]};for(let ge=0;ge<ie.length;ge++){const ye=ie[ge];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}Y.symbols.push({...d.WorkspaceSymbol.from(ye),cacheId:[se,ge]})}return Y}async resolveWorkspaceSymbol(B,J){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const ie=this.d.get(...B.cacheId);if(ie){const se=await this.e.resolveWorkspaceSymbol(ie,J);return se&&(0,T.$7m)(B,d.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class Z{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,J,ie){this.d=B,this.e=J,this.f=ie}async provideRenameEdits(B,J,ie,se){const Y=this.d.getDocument(B),ge=d.Position.to(J);try{const ye=await this.e.provideRenameEdits(Y,ge,ie,se);return ye?d.WorkspaceEdit.from(ye):void 0}catch(ye){const je=Z.g(ye);return je?{rejectReason:je,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,J,ie){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const se=this.d.getDocument(B),Y=d.Position.to(J);try{const ge=await this.e.prepareRename(se,Y,ie);let ye,je;if(L.$gK.isRange(ge)?(ye=ge,je=se.getText(ge)):(0,I.$Af)(ge)&&(ye=ge.range,je=ge.placeholder),!ye||!je)return;if(ye.start.line>Y.line||ye.end.line<Y.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:d.Range.from(ye),text:je}}catch(ge){const ye=Z.g(ge);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(ge)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Q{constructor(B,J){this.resultId=B,this.tokens=J}}class X{constructor(B,J){this.f=B,this.g=J,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,J,ie){const se=this.f.getDocument(B),Y=J!==0?this.d.get(J):null;let ge=typeof Y?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(se,Y.resultId,ie):await this.g.provideDocumentSemanticTokens(se,ie);return Y&&this.d.delete(J),ge?(ge=X.h(ge),this.o(X.n(Y,ge),ge)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return X.j(B)?X.k(B)?B:new L.$vL(new Uint32Array(B.data),B.resultId):X.l(B)?X.m(B)?B:new L.$xL(B.edits.map(J=>new L.$wL(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const J of B.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static n(B,J){if(!X.j(J)||!B||!B.tokens)return J;const ie=B.tokens,se=ie.length,Y=J.data,ge=Y.length;let ye=0;const je=Math.min(se,ge);for(;ye<je&&ie[ye]===Y[ye];)ye++;if(ye===se&&ye===ge)return new L.$xL([],J.resultId);let We=0;const _e=je-ye;for(;We<_e&&ie[se-We-1]===Y[ge-We-1];)We++;return new L.$xL([{start:ye,deleteCount:se-ye-We,data:Y.subarray(ye,ge-We)}],J.resultId)}o(B,J){if(X.j(B)){const ie=this.e++;return this.d.set(ie,new Q(B.resultId,B.data)),(0,u.$S0)({id:ie,type:"full",data:B.data})}if(X.l(B)){const ie=this.e++;return X.j(J)?this.d.set(ie,new Q(J.resultId,J.data)):this.d.set(ie,new Q(B.resultId)),(0,u.$S0)({id:ie,type:"delta",deltas:(B.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}class oe{constructor(B,J){this.d=B,this.e=J}async provideDocumentRangeSemanticTokens(B,J,ie){const se=this.d.getDocument(B),Y=await this.e.provideDocumentRangeSemanticTokens(se,d.Range.to(J),ie);return Y?this.f(Y):null}f(B){return(0,u.$S0)({id:0,type:"full",data:B.data})}}class x{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,J,ie,se,Y){this.f=B,this.g=J,this.h=ie,this.j=se,this.k=Y,this.d=new r.$Rbc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,J,ie,se){const Y=this.f.getDocument(B),ge=d.Position.to(J),ye=Y.getWordRangeAtPosition(ge)||new L.$gK(ge,ge),je=ye.with({end:ge}),We=new o.$Jd,_e=await this.h.provideCompletionItems(Y,ge,se,d.CompletionContext.to(ie));if(!_e||se.isCancellationRequested)return;const Ye=Array.isArray(_e)?new L.$LK(_e):_e,it=x.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),et=new p.$Rc;this.e.set(it,et);const Ae=[],Ne={x:it,b:Ae,a:{replace:d.Range.from(ye),insert:d.Range.from(je)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let qe=0;qe<Ye.items.length;qe++){const Le=Ye.items[qe],Xe=this.l(Le,[it,qe],je,ye);Ae.push(Xe)}return Ne}async resolveCompletionItem(B,J){if(typeof this.h.resolveCompletionItem!="function")return;const ie=this.d.get(...B);if(!ie)return;const se=this.l(ie,B),Y=await this.h.resolveCompletionItem(ie,J);if(!Y)return;const ge=this.l(Y,B);return(se.h!==ge.h||se.i!==ge.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(se.n!==ge.n||se.o!==ge.o||!(0,T.$8m)(se.p,ge.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...se,d:ge.d,c:ge.c,l:ge.l,h:ge.h,i:ge.i,n:ge.n,o:ge.o,p:ge.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,J,ie,se){const Y=this.e.get(J[0]);if(!Y)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(B.command,Y),ye={x:J,a:B.label,b:B.kind!==void 0?d.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(d.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:d.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(d.TextEdit.from),n:ge?.$ident,o:ge?.id,p:ge?.$ident?void 0:ge?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=B.textEdit.newText):typeof B.insertText=="string"?ye.h=B.insertText:B.insertText instanceof L.$pK&&(ye.h=B.insertText.value,ye.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),L.$gK.isRange(je)?ye.j=d.Range.from(je):je&&(!ie?.isEqual(je.inserting)||!se?.isEqual(je.replacing))&&(ye.j={insert:d.Range.from(je.inserting),replace:d.Range.from(je.replacing)}),ye}}class ae{async provideInlineCompletions(B,J,ie,se){}disposeCompletions(B){}handleDidShowCompletionItem(B,J,ie){}handlePartialAccept(B,J,ie){}}class we extends ae{constructor(B,J,ie,se){super(),this.f=B,this.g=J,this.h=ie,this.j=se,this.d=new G,this.e=(0,t.$_E)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$_E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,J,ie,se){const Y=this.g.getDocument(B),ge=d.Position.to(J),ye=await this.h.provideInlineCompletionItems(Y,ge,{selectedCompletionInfo:ie.selectedSuggestionInfo?{range:d.Range.to(ie.selectedSuggestionInfo.range),text:ie.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ie.triggerKind]},se);if(!ye||se.isCancellationRequested)return;const je=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],_e=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:je}),items:je.map((et,Ae)=>{let Ne;et.command&&(Ye||(Ye=new p.$Rc),Ne=this.j.toInternal(et.command,Ye));const qe=et.insertText;return{insertText:typeof qe=="string"?qe:{snippet:qe.value},filterText:et.filterText,range:et.range?d.Range.from(et.range):void 0,command:Ne,idx:Ae,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:We.map(et=>(Ye||(Ye=new p.$Rc),this.j.toInternal(et,Ye))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,J,ie){const se=this.d.get(B)?.items[J];se&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(se,ie)}handlePartialAccept(B,J,ie){const se=this.d.get(B)?.items[J];se&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(se,ie)}}class G{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const J=this.e++;return this.d.set(J,B),J}disposeReferenceId(B){const J=this.d.get(B);return this.d.delete(B),J}get(B){return this.d.get(B)}}class U{constructor(B,J){this.e=B,this.f=J,this.d=new r.$Rbc("SignatureHelp")}async provideSignatureHelp(B,J,ie,se){const Y=this.e.getDocument(B),ge=d.Position.to(J),ye=this.g(ie),je=await this.f.provideSignatureHelp(Y,ge,se,ye);if(je){const We=this.d.add([je]);return{...d.SignatureHelp.from(je),id:We}}}g(B){let J;if(B.activeSignatureHelp){const ie=d.SignatureHelp.to(B.activeSignatureHelp),se=this.d.get(B.activeSignatureHelp.id,0);se?(J=se,J.activeSignature=ie.activeSignature,J.activeParameter=ie.activeParameter):J=ie}return{...B,activeSignatureHelp:J}}releaseSignatureHelp(B){this.d.delete(B)}}class q{constructor(B,J,ie,se,Y){this.f=B,this.g=J,this.h=ie,this.j=se,this.k=Y,this.d=new r.$Rbc("InlayHints"),this.e=new Map}async provideInlayHints(B,J,ie){const se=this.f.getDocument(B),Y=d.Range.to(J),ge=await this.h.provideInlayHints(se,Y,ie);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${J}`);return}if(ie.isCancellationRequested)return;const ye=this.d.add(ge);this.e.set(ye,new p.$Rc);const je={hints:[],cacheId:ye};for(let We=0;We<ge.length;We++)this.l(ge[We],Y)&&je.hints.push(this.m(ge[We],[ye,We]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for ${J}`),je}async resolveInlayHint(B,J){if(typeof this.h.resolveInlayHint!="function")return;const ie=this.d.get(...B);if(!ie)return;const se=await this.h.resolveInlayHint(ie,J);if(se&&this.l(se))return this.m(se,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,J){return B.label.length===0||Array.isArray(B.label)&&B.label.every(ie=>ie.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(J&&!J.contains(B.position))}m(B,J){const ie=this.e.get(J[0]);if(!ie)throw Error("DisposableStore is missing...");const se={label:"",cacheId:J,tooltip:d.MarkdownString.fromStrict(B.tooltip),position:d.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(d.TextEdit.from),kind:B.kind&&d.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?se.label=B.label:se.label=B.label.map(Y=>{const ge={label:Y.value};return ge.tooltip=d.MarkdownString.fromStrict(Y.tooltip),L.$qK.isLocation(Y.location)&&(ge.location=d.location.from(Y.location)),Y.command&&(ge.command=this.g.toInternal(Y.command,ie)),ge}),se}}class me{constructor(B,J){this.e=B,this.f=J,this.d=new r.$Rbc("DocumentLink")}async provideLinks(B,J){const ie=this.e.getDocument(B),se=await this.f.provideDocumentLinks(ie,J);if(!(!Array.isArray(se)||se.length===0)&&!J.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:se.filter(me.g).map(d.DocumentLink.from)};{const Y=this.d.add(se),ge={links:[],cacheId:Y};for(let ye=0;ye<se.length;ye++){if(!me.g(se[ye]))continue;const je=d.DocumentLink.from(se[ye]);je.cacheId=[Y,ye],ge.links.push(je)}return ge}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,J){if(typeof this.f.resolveDocumentLink!="function")return;const ie=this.d.get(...B);if(!ie)return;const se=await this.f.resolveDocumentLink(ie,J);if(!(!se||!me.g(se)))return d.DocumentLink.from(se)}releaseLinks(B){this.d.delete(B)}}class ee{constructor(B,J){this.d=B,this.e=J}async provideColors(B,J){const ie=this.d.getDocument(B),se=await this.e.provideDocumentColors(ie,J);return Array.isArray(se)?se.map(ge=>({color:d.Color.from(ge.color),range:d.Range.from(ge.range)})):[]}async provideColorPresentations(B,J,ie){const se=this.d.getDocument(B),Y=d.Range.to(J.range),ge=d.Color.to(J.color),ye=await this.e.provideColorPresentations(ge,{document:se,range:Y},ie);if(Array.isArray(ye))return ye.map(d.ColorPresentation.from)}}class ne{constructor(B,J){this.d=B,this.e=J}async provideFoldingRanges(B,J,ie){const se=this.d.getDocument(B),Y=await this.e.provideFoldingRanges(se,J,ie);if(Array.isArray(Y))return Y.map(d.FoldingRange.from)}}class re{constructor(B,J,ie){this.d=B,this.e=J,this.f=ie}async provideSelectionRanges(B,J,ie){const se=this.d.getDocument(B),Y=J.map(d.Position.to),ge=await this.e.provideSelectionRanges(se,Y,ie);if(!(0,R.$Lb)(ge))return[];if(ge.length!==Y.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let je=0;je<Y.length;je++){const We=[];ye.push(We);let _e=Y[je],Ye=ge[je];for(;;){if(!Ye.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(We.push(d.SelectionRange.from(Ye)),!Ye.parent)break;_e=Ye.range,Ye=Ye.parent}}return ye}}class Ee{constructor(B,J){this.f=B,this.g=J,this.d=new c.$iM(""),this.e=new Map}async prepareSession(B,J,ie){const se=this.f.getDocument(B),Y=d.Position.to(J),ge=await this.g.prepareCallHierarchy(se,Y,ie);if(!ge)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(ge)?ge.map(je=>this.h(ye,je)):[this.h(ye,ge)]}async provideCallsTo(B,J,ie){const se=this.j(B,J);if(!se)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyIncomingCalls(se,ie);if(Y)return Y.map(ge=>({from:this.h(B,ge.from),fromRanges:ge.fromRanges.map(ye=>d.Range.from(ye))}))}async provideCallsFrom(B,J,ie){const se=this.j(B,J);if(!se)throw new Error("missing call hierarchy item");const Y=await this.g.provideCallHierarchyOutgoingCalls(se,ie);if(Y)return Y.map(ge=>({to:this.h(B,ge.to),fromRanges:ge.fromRanges.map(ye=>d.Range.from(ye))}))}releaseSession(B){this.e.delete(B)}h(B,J){const ie=this.e.get(B),se=d.CallHierarchyItem.from(J,B,ie.size.toString(36));return ie.set(se._itemId,J),se}j(B,J){return this.e.get(B)?.get(J)}}class ce{constructor(B,J){this.f=B,this.g=J,this.d=new c.$iM(""),this.e=new Map}async prepareSession(B,J,ie){const se=this.f.getDocument(B),Y=d.Position.to(J),ge=await this.g.prepareTypeHierarchy(se,Y,ie);if(!ge)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(ge)?ge.map(je=>this.h(ye,je)):[this.h(ye,ge)]}async provideSupertypes(B,J,ie){const se=this.j(B,J);if(!se)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySupertypes(se,ie);if(Y)return Y.map(ge=>this.h(B,ge))}async provideSubtypes(B,J,ie){const se=this.j(B,J);if(!se)throw new Error("missing type hierarchy item");const Y=await this.g.provideTypeHierarchySubtypes(se,ie);if(Y)return Y.map(ge=>this.h(B,ge))}releaseSession(B){this.e.delete(B)}h(B,J){const ie=this.e.get(B),se=d.TypeHierarchyItem.from(J,B,ie.size.toString(36));return ie.set(se._itemId,J),se}j(B,J){return this.e.get(B)?.get(J)}}class de{static toInternalProviderId(B,J){return B+"."+J}constructor(B,J,ie,se,Y){this.d=B,this.e=J,this.f=ie,this.g=se,this.h=Y}async provideDocumentOnDropEdits(B,J,ie,se,Y){const ge=this.e.getDocument(J),ye=d.Position.to(ie),je=d.DataTransfer.toDataTransfer(se,async _e=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentDropEdits(ge,ye,je,Y);if(We)return{label:We.label??(0,n.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:de.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?d.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class te{constructor(B,J){this.d=B,this.e=J}async provideMappedEdits(B,J,ie,se){const Y=C.URI.revive(B),ge=this.d.getDocument(Y),ye=ie.documents.map(_e=>_e.map(Ye=>({uri:C.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(it=>d.Range.to(it))}))),je={documents:ye,selections:ye[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(ge,J,je,se);return We?d.WorkspaceEdit.from(We):null}}class he{constructor(B,J){this.adapter=B,this.extension=J}}class be{static{this.d=0}constructor(B,J,ie,se,Y,ge,ye,je){this.g=J,this.h=ie,this.j=se,this.k=Y,this.l=ge,this.m=ye,this.n=je,this.f=new Map,this.e=B.getProxy($.$cK.MainThreadLanguageFeatures)}o(B,J){return d.DocumentSelector.from(B,this.g,J)}p(B){return new L.$eK(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return be.d++}async s(B,J,ie,se,Y,ge=!1){const ye=this.f.get(B);if(!ye||!(ye.adapter instanceof J))return se;const je=Date.now();ge||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${ie.toString().replace(/[\r\n]/g,"")}'`);const We=ie(ye.adapter,ye.extension);return Promise.resolve(We).catch(_e=>{(0,m.$4)(_e)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(ye.extension.identifier,_e))}).finally(()=>{ge||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),y.CancellationToken.isCancellationToken(Y)?(0,h.$Jg)(We,Y):We}t(B,J){const ie=this.q();return this.f.set(ie,new he(B,J)),ie}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,J,ie,se){const Y=this.t(new a(this.h,ie),B),ge=se&&se.label||be.u(B);return this.e.$registerDocumentSymbolProvider(Y,this.o(J,B),ge),this.p(Y)}$provideDocumentSymbols(B,J,ie){return this.s(B,a,se=>se.provideDocumentSymbols(C.URI.revive(J),ie),void 0,ie)}registerCodeLensProvider(B,J,ie){const se=this.q(),Y=typeof ie.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(se,new he(new i(this.h,this.j.converter,ie),B)),this.e.$registerCodeLensSupport(se,this.o(J,B),Y);let ge=this.p(se);if(Y!==void 0){const ye=ie.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(Y));ge=L.$eK.from(ge,ye)}return ge}$provideCodeLenses(B,J,ie){return this.s(B,i,se=>se.provideCodeLenses(C.URI.revive(J),ie),void 0,ie)}$resolveCodeLens(B,J,ie){return this.s(B,i,se=>se.resolveCodeLens(J,ie),void 0,void 0)}$releaseCodeLenses(B,J){this.s(B,i,ie=>Promise.resolve(ie.releaseCodeLenses(J)),void 0,void 0)}registerDefinitionProvider(B,J,ie){const se=this.t(new l(this.h,ie),B);return this.e.$registerDefinitionSupport(se,this.o(J,B)),this.p(se)}$provideDefinition(B,J,ie,se){return this.s(B,l,Y=>Y.provideDefinition(C.URI.revive(J),ie,se),[],se)}registerDeclarationProvider(B,J,ie){const se=this.t(new D(this.h,ie),B);return this.e.$registerDeclarationSupport(se,this.o(J,B)),this.p(se)}$provideDeclaration(B,J,ie,se){return this.s(B,D,Y=>Y.provideDeclaration(C.URI.revive(J),ie,se),[],se)}registerImplementationProvider(B,J,ie){const se=this.t(new S(this.h,ie),B);return this.e.$registerImplementationSupport(se,this.o(J,B)),this.p(se)}$provideImplementation(B,J,ie,se){return this.s(B,S,Y=>Y.provideImplementation(C.URI.revive(J),ie,se),[],se)}registerTypeDefinitionProvider(B,J,ie){const se=this.t(new b(this.h,ie),B);return this.e.$registerTypeDefinitionSupport(se,this.o(J,B)),this.p(se)}$provideTypeDefinition(B,J,ie,se){return this.s(B,b,Y=>Y.provideTypeDefinition(C.URI.revive(J),ie,se),[],se)}registerHoverProvider(B,J,ie,se){const Y=this.t(new f(this.h,ie),B);return this.e.$registerHoverProvider(Y,this.o(J,B)),this.p(Y)}$provideHover(B,J,ie,se){return this.s(B,f,Y=>Y.provideHover(C.URI.revive(J),ie,se),void 0,se)}registerEvaluatableExpressionProvider(B,J,ie,se){const Y=this.t(new g(this.h,ie),B);return this.e.$registerEvaluatableExpressionProvider(Y,this.o(J,B)),this.p(Y)}$provideEvaluatableExpression(B,J,ie,se){return this.s(B,g,Y=>Y.provideEvaluatableExpression(C.URI.revive(J),ie,se),void 0,se)}registerInlineValuesProvider(B,J,ie,se){const Y=typeof ie.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new P(this.h,ie),B);this.e.$registerInlineValuesProvider(ge,this.o(J,B),Y);let ye=this.p(ge);if(Y!==void 0){const je=ie.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Y));ye=L.$eK.from(ye,je)}return ye}$provideInlineValues(B,J,ie,se,Y){return this.s(B,P,ge=>ge.provideInlineValues(C.URI.revive(J),ie,se,Y),void 0,Y)}registerDocumentHighlightProvider(B,J,ie){const se=this.t(new N(this.h,ie),B);return this.e.$registerDocumentHighlightProvider(se,this.o(J,B)),this.p(se)}$provideDocumentHighlights(B,J,ie,se){return this.s(B,N,Y=>Y.provideDocumentHighlights(C.URI.revive(J),ie,se),void 0,se)}registerLinkedEditingRangeProvider(B,J,ie){const se=this.t(new O(this.h,ie),B);return this.e.$registerLinkedEditingRangeProvider(se,this.o(J,B)),this.p(se)}$provideLinkedEditingRanges(B,J,ie,se){return this.s(B,O,async Y=>{const ge=await Y.provideLinkedEditingRanges(C.URI.revive(J),ie,se);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?be.w(ge.wordPattern):void 0}},void 0,se)}registerReferenceProvider(B,J,ie){const se=this.t(new M(this.h,ie),B);return this.e.$registerReferenceSupport(se,this.o(J,B)),this.p(se)}$provideReferences(B,J,ie,se,Y){return this.s(B,M,ge=>ge.provideReferences(C.URI.revive(J),ie,se,Y),void 0,Y)}registerCodeActionProvider(B,J,ie,se){const Y=new p.$Rc,ge=this.t(new j(this.h,this.j.converter,this.k,ie,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(ge,this.o(J,B),{providedKinds:se?.providedCodeActionKinds?.map(ye=>ye.value),documentation:se?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,Y)}))},be.u(B),!!ie.resolveCodeAction),Y.add(this.p(ge)),Y}$provideCodeActions(B,J,ie,se,Y){return this.s(B,j,ge=>ge.provideCodeActions(C.URI.revive(J),ie,se,Y),void 0,Y)}$resolveCodeAction(B,J,ie){return this.s(B,j,se=>se.resolveCodeAction(J,ie),{},void 0)}$releaseCodeActions(B,J){this.s(B,j,ie=>Promise.resolve(ie.releaseCodeActions(J)),void 0,void 0)}registerDocumentFormattingEditProvider(B,J,ie){const se=this.t(new F(this.h,ie),B);return this.e.$registerDocumentFormattingSupport(se,this.o(J,B),B.identifier,B.displayName||B.name),this.p(se)}$provideDocumentFormattingEdits(B,J,ie,se){return this.s(B,F,Y=>Y.provideDocumentFormattingEdits(C.URI.revive(J),ie,se),void 0,se)}registerDocumentRangeFormattingEditProvider(B,J,ie){const se=typeof ie.provideDocumentRangesFormattingEdits=="function",Y=this.t(new K(this.h,ie),B);return this.e.$registerRangeFormattingSupport(Y,this.o(J,B),B.identifier,B.displayName||B.name,se),this.p(Y)}$provideDocumentRangeFormattingEdits(B,J,ie,se,Y){return this.s(B,K,ge=>ge.provideDocumentRangeFormattingEdits(C.URI.revive(J),ie,se,Y),void 0,Y)}$provideDocumentRangesFormattingEdits(B,J,ie,se,Y){return this.s(B,K,ge=>ge.provideDocumentRangesFormattingEdits(C.URI.revive(J),ie,se,Y),void 0,Y)}registerOnTypeFormattingEditProvider(B,J,ie,se){const Y=this.t(new V(this.h,ie),B);return this.e.$registerOnTypeFormattingSupport(Y,this.o(J,B),se,B.identifier),this.p(Y)}$provideOnTypeFormattingEdits(B,J,ie,se,Y,ge){return this.s(B,V,ye=>ye.provideOnTypeFormattingEdits(C.URI.revive(J),ie,se,Y,ge),void 0,ge)}registerWorkspaceSymbolProvider(B,J){const ie=this.t(new fe(J,this.l),B);return this.e.$registerNavigateTypeSupport(ie,typeof J.resolveWorkspaceSymbol=="function"),this.p(ie)}$provideWorkspaceSymbols(B,J,ie){return this.s(B,fe,se=>se.provideWorkspaceSymbols(J,ie),{symbols:[]},ie)}$resolveWorkspaceSymbol(B,J,ie){return this.s(B,fe,se=>se.resolveWorkspaceSymbol(J,ie),void 0,void 0)}$releaseWorkspaceSymbols(B,J){this.s(B,fe,ie=>ie.releaseWorkspaceSymbols(J),void 0,void 0)}registerRenameProvider(B,J,ie){const se=this.t(new Z(this.h,ie,this.l),B);return this.e.$registerRenameSupport(se,this.o(J,B),Z.supportsResolving(ie)),this.p(se)}$provideRenameEdits(B,J,ie,se,Y){return this.s(B,Z,ge=>ge.provideRenameEdits(C.URI.revive(J),ie,se,Y),void 0,Y)}$resolveRenameLocation(B,J,ie,se){return this.s(B,Z,Y=>Y.resolveRenameLocation(C.URI.revive(J),ie,se),void 0,se)}registerDocumentSemanticTokensProvider(B,J,ie,se){const Y=this.t(new X(this.h,ie),B),ge=typeof ie.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Y,this.o(J,B),se,ge);let ye=this.p(Y);if(ge){const je=ie.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(ge));ye=L.$eK.from(ye,je)}return ye}$provideDocumentSemanticTokens(B,J,ie,se){return this.s(B,X,Y=>Y.provideDocumentSemanticTokens(C.URI.revive(J),ie,se),null,se)}$releaseDocumentSemanticTokens(B,J){this.s(B,X,ie=>ie.releaseDocumentSemanticColoring(J),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,J,ie,se){const Y=this.t(new oe(this.h,ie),B);return this.e.$registerDocumentRangeSemanticTokensProvider(Y,this.o(J,B),se),this.p(Y)}$provideDocumentRangeSemanticTokens(B,J,ie,se){return this.s(B,oe,Y=>Y.provideDocumentRangeSemanticTokens(C.URI.revive(J),ie,se),null,se)}registerCompletionItemProvider(B,J,ie,se){const Y=this.t(new x(this.h,this.j.converter,ie,this.m,B),B);return this.e.$registerCompletionsProvider(Y,this.o(J,B),se,x.supportsResolving(ie),B.identifier),this.p(Y)}$provideCompletionItems(B,J,ie,se,Y){return this.s(B,x,ge=>ge.provideCompletionItems(C.URI.revive(J),ie,se,Y),void 0,Y)}$resolveCompletionItem(B,J,ie){return this.s(B,x,se=>se.resolveCompletionItem(J,ie),void 0,ie)}$releaseCompletionItems(B,J){this.s(B,x,ie=>ie.releaseCompletionItems(J),void 0,void 0)}registerInlineCompletionsProvider(B,J,ie,se){const Y=new we(B,this.h,ie,this.j.converter),ge=this.t(Y,B);return this.e.$registerInlineCompletionsSupport(ge,this.o(J,B),Y.supportsHandleEvents,k.$4l.toKey(B.identifier.value),se?.yieldTo?.map(ye=>k.$4l.toKey(ye))||[]),this.p(ge)}$provideInlineCompletions(B,J,ie,se,Y){return this.s(B,ae,ge=>ge.provideInlineCompletions(C.URI.revive(J),ie,se,Y),void 0,Y)}$handleInlineCompletionDidShow(B,J,ie,se){this.s(B,ae,async Y=>{Y.handleDidShowCompletionItem(J,ie,se)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,J,ie,se){this.s(B,ae,async Y=>{Y.handlePartialAccept(J,ie,se)},void 0,void 0)}$freeInlineCompletionsList(B,J){this.s(B,ae,async ie=>{ie.disposeCompletions(J)},void 0,void 0)}registerSignatureHelpProvider(B,J,ie,se){const Y=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,ge=this.t(new U(this.h,ie),B);return this.e.$registerSignatureHelpProvider(ge,this.o(J,B),Y),this.p(ge)}$provideSignatureHelp(B,J,ie,se,Y){return this.s(B,U,ge=>ge.provideSignatureHelp(C.URI.revive(J),ie,se,Y),void 0,Y)}$releaseSignatureHelp(B,J){this.s(B,U,ie=>ie.releaseSignatureHelp(J),void 0,void 0)}registerInlayHintsProvider(B,J,ie){const se=typeof ie.onDidChangeInlayHints=="function"?this.q():void 0,Y=this.t(new q(this.h,this.j.converter,ie,this.l,B),B);this.e.$registerInlayHintsProvider(Y,this.o(J,B),typeof ie.resolveInlayHint=="function",se,be.u(B));let ge=this.p(Y);if(se!==void 0){const ye=ie.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(se));ge=L.$eK.from(ge,ye)}return ge}$provideInlayHints(B,J,ie,se){return this.s(B,q,Y=>Y.provideInlayHints(C.URI.revive(J),ie,se),void 0,se)}$resolveInlayHint(B,J,ie){return this.s(B,q,se=>se.resolveInlayHint(J,ie),void 0,ie)}$releaseInlayHints(B,J){this.s(B,q,ie=>ie.releaseHints(J),void 0,void 0)}registerDocumentLinkProvider(B,J,ie){const se=this.t(new me(this.h,ie),B);return this.e.$registerDocumentLinkProvider(se,this.o(J,B),typeof ie.resolveDocumentLink=="function"),this.p(se)}$provideDocumentLinks(B,J,ie){return this.s(B,me,se=>se.provideLinks(C.URI.revive(J),ie),void 0,ie,J.scheme==="output")}$resolveDocumentLink(B,J,ie){return this.s(B,me,se=>se.resolveLink(J,ie),void 0,void 0,!0)}$releaseDocumentLinks(B,J){this.s(B,me,ie=>ie.releaseLinks(J),void 0,void 0,!0)}registerColorProvider(B,J,ie){const se=this.t(new ee(this.h,ie),B);return this.e.$registerDocumentColorProvider(se,this.o(J,B)),this.p(se)}$provideDocumentColors(B,J,ie){return this.s(B,ee,se=>se.provideColors(C.URI.revive(J),ie),[],ie)}$provideColorPresentations(B,J,ie,se){return this.s(B,ee,Y=>Y.provideColorPresentations(C.URI.revive(J),ie,se),void 0,se)}registerFoldingRangeProvider(B,J,ie){const se=this.q(),Y=typeof ie.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(se,new he(new ne(this.h,ie),B)),this.e.$registerFoldingRangeProvider(se,this.o(J,B),B.identifier,Y);let ge=this.p(se);if(Y!==void 0){const ye=ie.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Y));ge=L.$eK.from(ge,ye)}return ge}$provideFoldingRanges(B,J,ie,se){return this.s(B,ne,Y=>Y.provideFoldingRanges(C.URI.revive(J),ie,se),void 0,se)}registerSelectionRangeProvider(B,J,ie){const se=this.t(new re(this.h,ie,this.l),B);return this.e.$registerSelectionRangeProvider(se,this.o(J,B)),this.p(se)}$provideSelectionRanges(B,J,ie,se){return this.s(B,re,Y=>Y.provideSelectionRanges(C.URI.revive(J),ie,se),[],se)}registerCallHierarchyProvider(B,J,ie){const se=this.t(new Ee(this.h,ie),B);return this.e.$registerCallHierarchyProvider(se,this.o(J,B)),this.p(se)}$prepareCallHierarchy(B,J,ie,se){return this.s(B,Ee,Y=>Promise.resolve(Y.prepareSession(C.URI.revive(J),ie,se)),void 0,se)}$provideCallHierarchyIncomingCalls(B,J,ie,se){return this.s(B,Ee,Y=>Y.provideCallsTo(J,ie,se),void 0,se)}$provideCallHierarchyOutgoingCalls(B,J,ie,se){return this.s(B,Ee,Y=>Y.provideCallsFrom(J,ie,se),void 0,se)}$releaseCallHierarchy(B,J){this.s(B,Ee,ie=>Promise.resolve(ie.releaseSession(J)),void 0,void 0)}registerTypeHierarchyProvider(B,J,ie){const se=this.t(new ce(this.h,ie),B);return this.e.$registerTypeHierarchyProvider(se,this.o(J,B)),this.p(se)}$prepareTypeHierarchy(B,J,ie,se){return this.s(B,ce,Y=>Promise.resolve(Y.prepareSession(C.URI.revive(J),ie,se)),void 0,se)}$provideTypeHierarchySupertypes(B,J,ie,se){return this.s(B,ce,Y=>Y.provideSupertypes(J,ie,se),void 0,se)}$provideTypeHierarchySubtypes(B,J,ie,se){return this.s(B,ce,Y=>Y.provideSubtypes(J,ie,se),void 0,se)}$releaseTypeHierarchy(B,J){this.s(B,ce,ie=>Promise.resolve(ie.releaseSession(J)),void 0,void 0)}registerDocumentOnDropEditProvider(B,J,ie,se){const Y=this.q();this.f.set(Y,new he(new de(this.e,this.h,ie,Y,B),B));const ge=(0,t.$_E)(B,"dropMetadata")&&se?de.toInternalProviderId(B.identifier.value,se.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Y,this.o(J,B),ge,(0,t.$_E)(B,"dropMetadata")?se:void 0),this.p(Y)}$provideDocumentOnDropEdits(B,J,ie,se,Y,ge){return this.s(B,de,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(J,C.URI.revive(ie),se,Y,ge)),void 0,void 0)}registerMappedEditsProvider(B,J,ie){const se=this.t(new te(this.h,ie),B);return this.e.$registerMappedEditsProvider(se,this.o(J,B)),this.p(se)}$provideMappedEdits(B,J,ie,se,Y){return this.s(B,te,ge=>Promise.resolve(ge.provideMappedEdits(J,ie,se,Y)),null,Y)}registerDocumentPasteEditProvider(B,J,ie,se){const Y=this.q();this.f.set(Y,new he(new z(this.e,this.h,ie,Y,B),B));const ge=z.toInternalProviderId(B.identifier.value,se.id);return this.e.$registerPasteEditProvider(Y,this.o(J,B),ge,{supportsCopy:!!ie.prepareDocumentPaste,supportsPaste:!!ie.provideDocumentPasteEdits,copyMimeTypes:se.copyMimeTypes,pasteMimeTypes:se.pasteMimeTypes}),this.p(Y)}$prepareDocumentPaste(B,J,ie,se,Y){return this.s(B,z,ge=>ge.prepareDocumentPaste(C.URI.revive(J),ie,se,Y),void 0,Y)}$providePasteEdits(B,J,ie,se,Y,ge){return this.s(B,z,ye=>ye.providePasteEdits(J,C.URI.revive(ie),se,Y,ge),void 0,ge)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:be.w(B.decreaseIndentPattern),increaseIndentPattern:be.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?be.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?be.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:be.w(B.beforeText),afterText:B.afterText?be.w(B.afterText):void 0,previousLineText:B.previousLineText?be.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(be.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(J=>L.SyntaxTokenType.toString(J)):void 0}}static D(B){return B.map(be.C)}setLanguageConfiguration(B,J,ie){const{wordPattern:se}=ie;if(se&&(0,E.$Oe)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this.h.setWordDefinitionFor(J,se):this.h.setWordDefinitionFor(J,void 0),ie.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),ie.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const Y=this.q(),ge={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?be.w(ie.wordPattern):void 0,indentationRules:ie.indentationRules?be.y(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?be.B(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport,autoClosingPairs:ie.autoClosingPairs?be.D(ie.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Y,J,ge),this.p(Y)}$setWordDefinitions(B){for(const J of B)this.h.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.$1bc=be}),define(De[317],Ce([1,0,6,13,7,38,9,3,26]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=void 0;class v{constructor(I,w,y,k){this.c=w,this.d=y,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(C.$cK.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,w){await this.a.$changeLanguage(I,w);const y=this.c.getDocumentData(I);if(!y)throw new Error(`document '${I.toString()}' NOT found`);return y.document}async tokenAtPosition(I,w){const y=I.version,k=T.Position.from(w),p=await this.a.$tokensAtPosition(I.uri,k),u={type:d.StandardTokenType.Other,range:I.getWordRangeAtPosition(w)??new d.$gK(w.line,w.character,w.line,w.character)};if(!p)return u;const c={range:T.Range.to(p.range),type:T.TokenType.to(p.type)};return!c.range.contains(w)||y!==I.version?u:c}createLanguageStatusItem(I,w,y){const k=this.f++,p=this.a,u=this.g,c=`${I.identifier.value}/${w}`;if(u.has(c))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);u.add(c);const r={selector:y,id:w,name:I.displayName??I.name,severity:d.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const m=new $.$Rc,h=()=>{if(o?.dispose(),!u.has(c)){console.warn(`LanguageStatusItem (${w}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,A.$Vg)(()=>{m.clear(),this.a.$setLanguageStatus(k,{id:c,name:r.name??I.displayName??I.name,source:I.displayName??I.name,selector:T.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===d.LanguageStatusSeverity.Error?L.default.Error:r.severity===d.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:r.command&&this.d.toInternal(r.command,m),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},t={dispose(){m.dispose(),o?.dispose(),p.$removeLanguageStatus(k),u.delete(c)},get id(){return r.id},get name(){return r.name},set name(n){r.name=n,h()},get selector(){return r.selector},set selector(n){r.selector=n,h()},get text(){return r.text},set text(n){r.text=n,h()},set text2(n){(0,E.$aF)(I,"languageStatusText"),r.text=n,h()},get text2(){return(0,E.$aF)(I,"languageStatusText"),r.text},get detail(){return r.detail},set detail(n){r.detail=n,h()},get severity(){return r.severity},set severity(n){r.severity=n,h()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(n){r.accessibilityInformation=n,h()},get command(){return r.command},set command(n){r.command=n,h()},get busy(){return r.busy},set busy(n){r.busy=n,h()}};return h(),t}}e.$Icc=v}),define(De[112],Ce([1,0,12,15,2,5,14,6,27,20]),function($e,e,C,T,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=e.$xcc=void 0;let R=class{constructor(w,y,k){this.f=k,this.d=new Map,this.a=y.getProxy($.$cK.MainThreadLocalization),this.b=w.environment.appLanguage,this.c=this.b===C.$g}getMessage(w,y){const{message:k,args:p,comment:u}=y;if(this.c)return(0,T.$De)(k,p??{});let c=k;u&&u.length>0&&(c+=`/${Array.isArray(u)?u.join(""):u}`);const r=this.d.get(w)?.contents[c];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,T.$De)(r??k,p??{})}getBundle(w){return this.d.get(w)?.contents}getBundleUri(w){return this.d.get(w)?.uri}async initializeLocalizedMessages(w){if(this.c||!w.l10n&&!w.isBuiltin||this.d.has(w.identifier.value))return;let y;const k=await this.g(w);if(!k){this.f.error(`No bundle location found for extension ${w.identifier.value}`);return}try{const p=await this.a.$fetchBundleContents(k),u=JSON.parse(p);y=w.isBuiltin?u.contents?.bundle:u}catch(p){this.f.error(`Failed to load translations for ${w.identifier.value} from ${k}: ${p.message}`);return}y&&this.d.set(w.identifier.value,{contents:y,uri:k})}async g(w){if(w.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(w.identifier.value,this.b);return d.URI.revive(y)}return w.l10n?d.URI.joinPath(w.extensionLocation,w.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$xcc=R,e.$xcc=R=He([Be(0,E.$tM),Be(1,v.$dM),Be(2,A.$9i)],R),e.$ycc=(0,L.$Oh)("IExtHostLocalizationService")}),define(De[150],Ce([1,0,14,6,27,20,2,62]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;let E=class extends C.$hj{constructor(I,w){super(w.logLevel,w.logsLocation,w.loggers.map(y=>(0,$.$lh)(y))),this.r=I.getProxy(T.$cK.MainThreadLogger)}$setLogLevel(I,w){w?this.setLogLevel(A.URI.revive(w),I):this.setLogLevel(I)}setVisibility(I,w){super.setVisibility(I,w),this.r.$setVisibility(I,w)}s(I,w,y){return new v(this.r,I,w,y)}};e.$1dc=E,e.$1dc=E=He([Be(0,L.$dM),Be(1,d.$tM)],E);class v extends C.$cj{constructor(I,w,y,k){super(k?.logLevel==="always"),this.r=I,this.s=w,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(w,k).then(()=>{this.u(this.n),this.m=!0})}g(I,w){const y=[[I,w]];this.m?this.u(y):this.n.push(...y)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(De[113],Ce([1,0,6,5,3,20,22]),function($e,e,C,T,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=e.$zcc=void 0,e.$zcc=(0,T.$Oh)("IExtHostManagedSockets");let $=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(C.$cK.MainThreadManagedSockets)}setFactory(I,w){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(I,w),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const w=++this.b,y=await this.c.makeConnection(),k=new d.$Rc;return this.d.set(w,new v(w,y,k)),k.add((0,d.$Qc)(()=>this.d.delete(w))),k.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(w),k.dispose()})),k.add(y.onDidClose(p=>{this.a.$onDidManagedSocketClose(w,p?.stack??p?.message),k.dispose()})),k.add(y.onDidReceiveMessage(p=>this.a.$onDidManagedSocketHaveData(w,A.$be.wrap(p)))),w}$remoteSocketWrite(I,w){this.d.get(I)?.actual.send(w.buffer)}$remoteSocketEnd(I){const w=this.d.get(I);w&&(w.actual.end(),w.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$Acc=$,e.$Acc=$=He([Be(0,L.$dM)],$);class E{constructor(I,w){this.socketFactoryId=I,this.makeConnection=w}}class v extends d.$Sc{constructor(I,w,y){super(),this.socketId=I,this.actual=w,this.B(y)}}}),define(De[318],Ce([1,0,6,14,26]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=void 0;function L($){return $&&$.title}let A=class{constructor(E,v){this.b=v,this.a=E.getProxy(C.$cK.MainThreadMessageService)}showMessage(E,v,R,I,w){const y={source:{identifier:E.identifier,label:E.displayName||E.name}};let k;typeof I=="string"||L(I)?k=[I,...w]:(y.modal=I?.modal,y.useCustom=I?.useCustom,y.detail=I?.detail,k=w),y.useCustom&&(0,d.$aF)(E,"resolvers");const p=[];for(let u=0;u<k.length;u++){const c=k[u];if(typeof c=="string")p.push({title:c,handle:u,isCloseAffordance:!1});else if(typeof c=="object"){const{title:r,isCloseAffordance:o}=c;p.push({title:r,isCloseAffordance:!!o,handle:u})}else this.b.warn("Invalid message item:",c)}return this.a.$showMessage(v,R,y,p).then(u=>{if(typeof u=="number")return k[u]})}};e.$Jcc=A,e.$Jcc=A=He([Be(1,T.$9i)],A)}),define(De[319],Ce([1,0,207,22,4,3,28,15,17,2,30,107,6,33,13,7,69,281,144,8,24,18]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r,o,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;class t{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(a=>a.apiEditor)}constructor(a,i,s,l,D){this.q=s,this.r=l,this.s=D,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new d.$Nd({onListenerError:o.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new d.$Nd({onListenerError:o.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new d.$Nd({onListenerError:o.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new d.$Nd({onListenerError:o.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$Rbc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=a.getProxy(w.$cK.MainThreadNotebook),this.c=a.getProxy(w.$cK.MainThreadNotebookDocuments),this.d=a.getProxy(w.$cK.MainThreadNotebookEditors),this.i=i.converter,i.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const b=S.notebookEditor?.notebookUri,f=S.cell.handle,P=this.g.get(b)?.getCell(f);if(P)return P.apiCell}if(S&&S.$mid===14){const b=S.uri,f=this.g.get(b);if(f)return f.apiNotebook}return S}}),t.A(i)}getEditorById(a){const i=this.h.get(a);if(!i)throw new Error(`unknown text editor: ${a}. known editors: ${[...this.h.keys()]} `);return i}getIdByEditor(a){for(const[i,s]of this.h)if(s.apiEditor===a)return i}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(a,i){const s=this.g.get(a);if(!s&&!i)throw new Error(`NO notebook document for '${a}'`);return s}static t(a,i){if(!i)return;const s=i.filenamePattern.map(l=>k.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(i.filenamePattern&&!s){console.warn(`Notebook content provider view options file name pattern is invalid ${i.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:i.displayName,filenamePattern:s,exclusive:i.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,i,s){const l=t.a++,D=typeof s.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(l,s),this.b.$registerNotebookCellStatusBarItemProvider(l,D,i);let S;return D!==void 0&&(S=s.onDidChangeCellStatusBarItems(b=>this.b.$emitCellStatusBarEvent(D))),new p.$eK(()=>{this.f.delete(l),this.b.$unregisterNotebookCellStatusBarItemProvider(l,D),S?.dispose()})}async createNotebookDocument(a){const i=await this.c.$tryCreateNotebook({viewType:a.viewType,content:a.content&&k.NotebookData.from(a.content)});return v.URI.revive(i)}async openNotebookDocument(a){const i=this.g.get(a);if(i)return i.apiNotebook;const s=await this.c.$tryOpenNotebook(a),l=this.g.get(v.URI.revive(s));return(0,E.$Jf)(l?.apiNotebook)}async showNotebookDocument(a,i){v.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let s;typeof i=="object"?s={position:k.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus,selections:i.selections&&i.selections.map(k.NotebookRange.from),pinned:typeof i.preview=="boolean"?!i.preview:void 0}:s={preserveFocus:!1};const l=await this.d.$tryShowNotebookDocument(a.uri,a.notebookType,s),D=l&&this.h.get(l)?.apiEditor;if(D)return D;throw l?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,i,s,l){const D=this.f.get(a),S=v.URI.revive(i),b=this.g.get(S);if(!b||!D)return;const f=b.getCellFromIndex(s);if(!f)return;const g=await D.provideCellStatusBarItems(f.apiCell,l);if(!g)return;const P=new L.$Rc,N=this.p.add([P]),M=(Array.isArray(g)?g:[g]).map(j=>k.NotebookStatusBarItem.from(j,this.i,P));return{cacheId:N,items:M}}$releaseNotebookCellStatusBarItems(a){this.p.delete(a)}registerNotebookSerializer(a,i,s,l,D){if((0,$.$Be)(i))throw new Error("viewType cannot be empty or just whitespace");const S=this.u++;return this.w.set(S,{viewType:i,serializer:s,options:l}),this.b.$registerNotebookSerializer(S,{id:a.identifier,location:a.extensionLocation},i,k.NotebookDocumentContentOptions.from(l),t.t(a,D)),(0,L.$Qc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(a,i,s){const l=this.w.get(a);if(!l)throw new Error("NO serializer found");const D=await l.serializer.deserializeNotebook(i.buffer,s);return new u.$mv(k.NotebookData.from(D))}async $notebookToData(a,i,s){const l=this.w.get(a);if(!l)throw new Error("NO serializer found");const D=await l.serializer.serializeNotebook(k.NotebookData.to(i.value),s);return T.$be.wrap(D)}async $saveNotebook(a,i,s,l,D){const S=v.URI.revive(i),b=this.w.get(a);if(!b)throw new Error("NO serializer found");const f=this.g.get(S);if(!f)throw new Error("Document NOT found");if(f.versionId!==s)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new R.$sk((0,C.localize)(0,null,this.y(S)),6);await this.x(S,l);const g={metadata:(0,m.$_m)(f.apiNotebook.metadata,j=>!(b.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of f.apiNotebook.getCells()){const z=new p.$CL(j.kind,j.document.getText(),j.document.languageId,j.mime,b.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);z.metadata=(0,m.$_m)(j.metadata,F=>!(b.options?.transientCellMetadata??{})[F]),g.cells.push(z)}const P=await b.serializer.serializeNotebook(g,D);await this.s.value.writeFile(S,P);const N=this.s.getFileSystemProviderExtUri(S.scheme),O=await this.s.value.stat(S);return{name:N.basename(S),isFile:(O.type&R.FileType.File)!==0,isDirectory:(O.type&R.FileType.Directory)!==0,isSymbolicLink:(O.type&R.FileType.SymbolicLink)!==0,mtime:O.mtime,ctime:O.ctime,size:O.size,readonly:!!((O.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((O.permissions??0)&R.FilePermission.Locked),etag:R.$Dk({mtime:O.mtime,size:O.size}),children:void 0}}async x(a,i){const s=await this.s.value.stat(a);if(typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==R.$Ck&&typeof s.mtime=="number"&&typeof s.size=="number"&&i.mtime<s.mtime&&i.etag!==R.$Dk({mtime:i.mtime,size:s.size}))throw new R.$sk((0,C.localize)(1,null),3,i)}y(a){return a.scheme===h.Schemas.file?a.fsPath:a.toString()}z(a,i,s){if(this.h.has(i))throw new Error(`editor with id ALREADY EXSIST: ${i}`);const l=new r.$qdc(i,this.d,a,s.visibleRanges.map(k.NotebookRange.to),s.selections.map(k.NotebookRange.to),typeof s.viewColumn=="number"?k.ViewColumn.to(s.viewColumn):void 0);this.h.set(i,l)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const s of a.value.removedDocuments){const l=v.URI.revive(s),D=this.g.get(l);D&&(D.dispose(),this.g.delete(l),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:D.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(D.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===l.toString()&&this.h.delete(S.id)}if(a.value.addedDocuments){const s=[];for(const l of a.value.addedDocuments){const D=v.URI.revive(l.uri);if(this.g.has(D))throw new Error(`adding EXISTING notebook ${D} `);const S=new c.$pdc(this.c,this.q,this.r,D,l);s.push(...l.cells.map(b=>c.$odc.asModelAddData(S.apiNotebook,b))),this.g.get(D)?.dispose(),this.g.set(D,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:s}),this.m.fire(S.apiNotebook)}}if(a.value.addedEditors)for(const s of a.value.addedEditors){if(this.h.has(s.id))return;const l=v.URI.revive(s.documentUri),D=this.g.get(l);D&&this.z(D,s.id,s)}const i=[];if(a.value.removedEditors)for(const s of a.value.removedEditors){const l=this.h.get(s);l&&(this.h.delete(s),this.k?.id===l.id&&(this.k=void 0),i.push(l))}if(a.value.visibleEditors){this.l=a.value.visibleEditors.map(l=>this.h.get(l)).filter(l=>!!l);const s=new Set;this.l.forEach(l=>s.add(l.id));for(const l of this.h.values()){const D=s.has(l.id);l._acceptVisibility(D)}this.l=[...this.h.values()].map(l=>l).filter(l=>l.visible),this.o.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this.k=void 0:a.value.newActiveEditor&&(this.h.get(a.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${a.value.newActiveEditor}`),this.k=this.h.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(a){const i=y.$BM.String.with("notebookType","A notebook type"),s=new y.$DM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[i,new y.$BM("data","Bytes to convert to data",D=>D instanceof Uint8Array,D=>T.$be.wrap(D))],new y.$CM("Notebook Data",D=>k.NotebookData.to(D.value))),l=new y.$DM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[i,new y.$BM("NotebookData","Notebook data to convert to bytes",D=>!0,D=>new u.$mv(k.NotebookData.from(D)))],new y.$CM("Bytes",D=>D.buffer));a.registerApiCommand(s),a.registerApiCommand(l)}}e.$rdc=t}),define(De[320],Ce([1,0,19,9,21,4,3,28,2,25,14,6,33,13,7,110,275,26,69]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=e.$Fdc=void 0;let o=class{constructor(l,D,S,b,f){this.l=D,this.m=S,this.n=b,this.o=f,this.b=new $.$Ac,this.c=new $.$Ac,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new L.$Nd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=l.getProxy(I.$cK.MainThreadNotebookKernels);const g=new w.$DM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new w.$BM("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const N=this.m.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:N}}else if(P&&"notebookEditor"in P){const N=this.m.getIdByEditor(P.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return P})],w.$CM.Void);this.n.registerApiCommand(g)}createNotebookController(l,D,S,b,f,g){for(const oe of this.i.values())if(oe.controller.id===D&&v.$4l.equals(l.identifier,oe.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const P=this.j++,N=this;this.o.trace(`NotebookController[${P}], CREATED by ${l.identifier.value}, ${D}`);const O=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${l.identifier}'`);let M=!1;const j=new L.$Nd,z=new L.$Nd,F={id:i(l.identifier,D),notebookType:S,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:b||l.identifier.value,preloads:g?g.map(y.NotebookRendererScript.from):[]};let K=f??O,V;this.a.$addKernel(P,F).catch(oe=>{console.log(oe),M=!0});let fe=0;const Z=()=>{if(M)return;const oe=++fe;Promise.resolve().then(()=>{oe===fe&&this.a.$updateKernel(P,F)})},Q=new $.$Ac,X={get id(){return D},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return F.label},set label(oe){F.label=oe??l.displayName??l.name,Z()},get detail(){return F.detail??""},set detail(oe){F.detail=oe,Z()},get description(){return F.description??""},set description(oe){F.description=oe,Z()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(oe){F.supportedLanguages=oe,Z()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){F.supportsExecutionOrder=oe,Z()},get rendererScripts(){return F.preloads?F.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(oe){K=oe??O},get interruptHandler(){return V},set interruptHandler(oe){V=oe,F.supportsInterrupt=!!oe,Z()},createNotebookCellExecution(oe){if(M)throw new Error("notebook controller is DISPOSED");if(!Q.has(oe.notebook.uri))throw N.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(x=>x.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return N._createNotebookCellExecution(oe,i(l.identifier,this.id))},createNotebookExecution(oe){if((0,c.$aF)(l,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!Q.has(oe.uri))throw N.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(x=>x.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.uri.toString()}`);return N._createNotebookExecution(oe,i(l.identifier,this.id))},dispose:()=>{M||(this.o.trace(`NotebookController[${P}], DISPOSED`),M=!0,this.i.delete(P),j.dispose(),z.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(oe,x){x===k.NotebookControllerAffinity2.Hidden&&(0,c.$aF)(l,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(P,oe.uri,x)},onDidReceiveMessage:z.event,postMessage(oe,x){return(0,c.$aF)(l,"notebookMessaging"),N.a.$postMessage(P,x&&N.m.getIdByEditor(x),oe)},asWebviewUri(oe){return(0,c.$aF)(l,"notebookMessaging"),(0,p.$5ob)(oe,N.l.remote)}};return this.i.set(P,{extensionId:l.identifier,controller:X,onDidReceiveMessage:z,onDidChangeSelection:j,associatedNotebooks:Q}),X}getIdByController(l){for(const[D,S]of this.i)if(S.controller===l)return i(S.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,D){const S=this.f++,b=this;this.o.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(S,D);const f={dispose:()=>{this.e.delete(S),b.a.$removeKernelDetectionTask(S)}};return this.e.set(S,f),f}registerKernelSourceActionProvider(l,D,S){const b=this.h++,f=typeof S.onDidChangeNotebookKernelSourceActions=="function"?b:void 0,g=this;this.g.set(b,S),this.o.trace(`NotebookKernelSourceActionProvider[${b}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(b,b,D);let P;return f!==void 0&&(P=S.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.g.delete(b),g.a.$removeKernelSourceActionProvider(b,b),P?.dispose()}}}async $provideKernelSourceActions(l,D){const S=this.g.get(l);if(S){const b=new A.$Rc;return(await S.provideNotebookKernelSourceActions(D)??[]).map(g=>y.NotebookKernelSourceAction.from(g,this.n.converter,b))}return[]}$acceptNotebookAssociation(l,D,S){const b=this.i.get(l);if(b){const f=this.m.getNotebookDocument(E.URI.revive(D));S?b.associatedNotebooks.set(f.uri,!0):b.associatedNotebooks.delete(f.uri),this.o.trace(`NotebookController[${l}] ASSOCIATE notebook`,f.uri.toString(),S),b.onDidChangeSelection.fire({selected:S,notebook:f.apiNotebook})}}async $executeCells(l,D,S){const b=this.i.get(l);if(!b)return;const f=this.m.getNotebookDocument(E.URI.revive(D)),g=[];for(const P of S){const N=f.getCell(P);N&&g.push(N.apiCell)}try{this.o.trace(`NotebookController[${l}] EXECUTE cells`,f.uri.toString(),g.length),await b.controller.executeHandler.call(b.controller,g,f.apiNotebook,b.controller)}catch(P){this.o.error(`NotebookController[${l}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(l,D,S){const b=this.i.get(l);if(!b)return;const f=this.m.getNotebookDocument(E.URI.revive(D));if(b.controller.interruptHandler)await b.controller.interruptHandler.call(b.controller,f.apiNotebook);else for(const g of S){const P=f.getCell(g);P&&this.b.get(P.uri)?.cancel()}if(b.controller.interruptHandler){const g=this.c.get(f.uri);S.length&&Array.isArray(g)&&g.length&&g.forEach(P=>P.dispose())}}$acceptKernelMessageFromRenderer(l,D,S){const b=this.i.get(l);if(!b)return;const f=this.m.getEditorById(D);b.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:S}))}$cellExecutionChanged(l,D,S){const f=this.m.getNotebookDocument(E.URI.revive(l)).getCell(D);if(f){const g=S?y.NotebookCellExecutionState.to(S):k.NotebookCellExecutionState.Idle;g!==void 0&&this.k.fire({cell:f.apiCell,state:g})}}_createNotebookCellExecution(l,D){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const b=this.m.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!b)throw new Error("invalid cell");if(this.b.has(b.uri))throw new Error(`duplicate execution for ${b.uri}`);const f=new h(D,b,this.a);this.b.set(b.uri,f);const g=f.onDidChangeState(()=>{f.state===m.Resolved&&(f.dispose(),g.dispose(),this.b.delete(b.uri))});return f.asApiObject()}_createNotebookExecution(l,D){const S=this.m.getNotebookDocument(l.uri),b=l.getCells().find(P=>{const N=S.getCellFromApiCell(P);return N&&this.b.has(N.uri)});if(b)throw new Error(`duplicate cell execution for ${b.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const f=new n(D,S,this.a),g=f.onDidChangeState(()=>{f.state===t.Resolved&&(f.dispose(),g.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[f,g]),f.asApiObject()}};e.$Fdc=o,e.$Fdc=o=He([Be(4,R.$9i)],o);var m;(function(s){s[s.Init=0]="Init",s[s.Started=1]="Started",s[s.Resolved=2]="Resolved"})(m||(m={}));class h extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(l,D,S){super(),this.m=D,this.n=S,this.b=h.a++,this.c=new L.$Nd,this.onDidChangeState=this.c.event,this.f=m.Init,this.g=this.B(new d.$Xd),this.h=new a(10,b=>this.s(b)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,l,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(l){await this.h.addItem(l)}async s(l){const D=Array.isArray(l)?l:[l];return this.n.$updateExecution(this.b,new r.$mv(D))}t(){if(this.f===m.Init)throw new Error("Must call start before modifying cell output");if(this.f===m.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(l){let D=this.m;if(l&&(D=this.m.notebook.getCellFromApiCell(l)),!D)throw new Error("INVALID cell");return D.handle}y(l){return l.map(D=>{const S=k.$FL.ensureUniqueMimeTypes(D.items,!0);return S===D.items?y.NotebookCellOutput.from(D):y.NotebookCellOutput.from({items:S,id:D.id,metadata:D.metadata})})}async z(l,D,S){const b=this.w(D),f=this.y((0,C.$3b)(l));return this.r({editType:u.CellExecutionUpdateType.Output,cellHandle:b,append:S,outputs:f})}async C(l,D,S){return l=k.$FL.ensureUniqueMimeTypes((0,C.$3b)(l),!0),this.r({editType:u.CellExecutionUpdateType.OutputItems,items:l.map(y.NotebookCellOutputItem.from),outputId:D.id,append:S})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.m.apiCell},get executionOrder(){return l.j},set executionOrder(S){l.j=S,l.s([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:l.j}])},start(S){if(l.f===m.Resolved||l.f===m.Started)throw new Error("Cannot call start again");l.f=m.Started,l.c.fire(),l.s({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,b){if(l.f===m.Resolved)throw new Error("Cannot call resolve twice");l.f=m.Resolved,l.c.fire(),l.h.flush(),l.n.$completeExecution(l.b,new r.$mv({runEndTime:b,lastRunSuccess:S}))},clearOutput(S){return l.t(),l.z([],S,!1)},appendOutput(S,b){return l.t(),l.z(S,b,!0)},replaceOutput(S,b){return l.t(),l.z(S,b,!1)},appendOutputItems(S,b){return l.t(),l.C(S,b,!0)},replaceOutputItems(S,b){return l.t(),l.C(S,b,!1)}})}}var t;(function(s){s[s.Init=0]="Init",s[s.Started=1]="Started",s[s.Resolved=2]="Resolved"})(t||(t={}));class n extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(l,D,S){super(),this.h=D,this.j=S,this.b=n.a++,this.c=new L.$Nd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new d.$Xd),this.j.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class a{constructor(l,D){this.e=l,this.f=D,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new T.$ch,this.b=Date.now(),(0,T.$Ug)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const D=this.a;return this.a=[],this.f(D).finally(()=>l.complete())}}function i(s,l){return`${s.value}/${l}`}e.$Gdc=i}),define(De[321],Ce([1,0,4,6,144]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class L{constructor($,E){this.c=E,this.a=new Map,this.b=$.getProxy(T.$cK.MainThreadNotebookRenderers)}$postRendererMessage($,E,v){const R=this.c.getEditorById($);this.a.get(E)?.fire({editor:R.apiEditor,message:v})}createRendererMessaging($,E){if(!$.contributes?.notebookRenderer?.some(R=>R.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(R,I,w)=>this.d(E).event(R,I,w),postMessage:(R,I)=>{d.$qdc.apiEditorsToExtHost.has(R)&&([R,I]=[I,R]);const w=I&&d.$qdc.apiEditorsToExtHost.get(I);return this.b.$postMessage(w?.id,E,R)}}}d($){let E=this.a.get($);return E||(E=new C.$Nd({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete($)}}),this.a.set($,E),E)}}e.$Hdc=L}),define(De[322],Ce([1,0,3,17,2,26,6]),function($e,e,C,T,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0;class ${constructor(v){this.b=new Map,this.a=v.getProxy(A.$cK.MainThreadProfileContentHandlers)}registrProfileContentHandler(v,R,I){if((0,L.$aF)(v,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,I),this.a.$registerProfileContentHandler(R,I.name,I.description,v.identifier.value),(0,C.$Qc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(v,R,I,w){const y=this.b.get(v);if(!y)throw new Error(`Unknown handler with id: ${v}`);return y.saveProfile(R,I,w)}async $readProfile(v,R,I){const w=this.b.get(v);if(!w)throw new Error(`Unknown handler with id: ${v}`);return w.readProfile((0,T.$yf)(R)?R:d.URI.revive(R),I)}}e.$Ldc=$}),define(De[323],Ce([1,0,2,6,9,13]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=void 0;class A{static{this.a=0}constructor(E,v){this.d=v,this.c=new Map,this.b=E.getProxy(T.$cK.MainThreadQuickDiff)}$provideOriginalResource(E,v,R){const I=C.URI.revive(v),w=this.c.get(E);return w?(0,d.$Mg)(()=>w.provideOriginalResource(I,R)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(E,v,R,I){const w=A.a++;return this.c.set(w,v),this.b.$registerQuickDiffProvider(w,L.DocumentSelector.from(E,this.d),R,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(w),this.c.delete(w)}}}}e.$Mdc=A}),define(De[324],Ce([1,0,21,4,3,6,2,7,8,19,38,59,26,13]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;function k(p,u,c){const r=p.getProxy(L.$cK.MainThreadQuickOpen);class o{constructor(D,S){this.e=new Map,this.f=0,this.a=D,this.b=S}showQuickPick(D,S,b,f=C.CancellationToken.None){this.c=void 0;const g=Promise.resolve(S),P=++this.f,N=r.$show(P,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},f),O={},M=N.then(()=>O);return Promise.race([M,g]).then(j=>{if(j===O)return;const z=(0,w.$_E)(D,"quickPickItemTooltip");return g.then(F=>{const K=[];for(let V=0;V<F.length;V++){const fe=F[V];if(typeof fe=="string")K.push({label:fe,handle:V});else if(fe.kind===$.QuickPickItemKind.Separator)K.push({type:"separator",label:fe.label});else{fe.tooltip&&!z&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const Z=fe.iconPath?a(fe.iconPath):void 0;K.push({label:fe.label,iconPath:Z?.iconPath,iconClass:Z?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:z?y.MarkdownString.fromStrict(fe.tooltip):void 0,handle:V})}}return b&&typeof b.onDidSelectItem=="function"&&(this.c=V=>{b.onDidSelectItem(F[V])}),r.$setItems(P,K),N.then(V=>{if(typeof V=="number")return F[V];if(Array.isArray(V))return V.map(fe=>F[fe])})})}).then(void 0,j=>{if(!(0,E.$4)(j))return r.$setError(P,j),Promise.reject(j)})}$onItemSelected(D){this.c?.(D)}showInput(D,S=C.CancellationToken.None){return this.d=D?.validateInput,r.$input(D,typeof this.d=="function",S).then(void 0,b=>{if(!(0,E.$4)(b))return Promise.reject(b)})}async $validateInput(D){if(!this.d)return;const S=await this.d(D);if(!S||typeof S=="string")return S;let b;switch(S.severity){case $.InputBoxValidationSeverity.Info:b=R.default.Info;break;case $.InputBoxValidationSeverity.Warning:b=R.default.Warning;break;case $.InputBoxValidationSeverity.Error:b=R.default.Error;break;default:b=S.message?R.default.Error:R.default.Ignore;break}return{content:S.message,severity:b}}async showWorkspaceFolderPick(D,S=C.CancellationToken.None){const b=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!b)return;const f=await this.a.getWorkspaceFolders2();if(f)return f.find(g=>g.uri.toString()===b.uri.toString())}createQuickPick(D){const S=new i(D,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(D){const S=new s(D,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(D,S){this.e.get(D)?._fireDidChangeValue(S)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,S){const b=this.e.get(D);b instanceof i&&b._fireDidChangeActive(S)}$onDidChangeSelection(D,S){const b=this.e.get(D);b instanceof i&&b._fireDidChangeSelection(S)}$onDidTriggerButton(D,S){this.e.get(D)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(D,S,b){const f=this.e.get(D);f instanceof i&&f._fireDidTriggerItemButton(S,b)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class m{static{this.a=1}constructor(D,S){this.x=D,this.y=S,this._id=i.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Nd,this.q=new T.$Nd,this.r=new T.$Nd,this.s=new T.$Nd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((S,b)=>{const f=S===$.$yL.Back?-1:b;this.o.set(f,S)}),this.z({buttons:D.map((S,b)=>({...a(S.iconPath),tooltip:S.tooltip,handle:S===$.$yL.Back?-1:b}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const S=this.o.get(D);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,d.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(D){if(!this.v){for(const S of Object.keys(D)){const b=D[S];this.u[S]=b===void 0?null:b}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function h(l){if(l instanceof $.$$K)return{id:l.id};const D=n(l),S=t(l);return{dark:typeof D=="string"?A.URI.file(D):D,light:typeof S=="string"?A.URI.file(S):S}}function t(l){return typeof l=="object"&&"light"in l?l.light:l}function n(l){return typeof l=="object"&&"dark"in l?l.dark:l}function a(l){const D=h(l);let S,b;return"id"in D?b=I.ThemeIcon.asClassName(D):S=D,{iconPath:S,iconClass:b}}class i extends m{constructor(D,S){super(D.identifier,S),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Nd,this.L=[],this.M=new T.$Nd,this.N=new T.$Nd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((f,g)=>{this.C.set(g,f),this.D.set(f,g)});const S=(0,w.$_E)(this.O,"quickPickItemTooltip"),b=[];for(let f=0;f<D.length;f++){const g=D[f];if(g.kind===$.QuickPickItemKind.Separator)b.push({type:"separator",label:g.label});else{g.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=g.iconPath?a(g.iconPath):void 0;b.push({handle:f,label:g.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:g.description,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,tooltip:S?y.MarkdownString.fromStrict(g.tooltip):void 0,buttons:g.buttons?.map((N,O)=>({...a(N.iconPath),tooltip:N.tooltip,handle:O}))})}}this.z({items:b})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(D){const S=(0,v.$Hb)(D.map(b=>this.C.get(b)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(D){const S=(0,v.$Hb)(D.map(b=>this.C.get(b)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(D,S){const b=this.C.get(D);if(!b||!b.buttons||!b.buttons.length)return;const f=b.buttons[S];f&&this.N.fire({button:f,item:b})}}class s extends m{constructor(D,S){super(D.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:R.default.Error}):this.z({validationMessage:D.message,severity:D.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new o(u,c)}e.$Ncc=k}),define(De[325],Ce([1,0,2,4,57,3,9,6,19,126,14,25,59,13,26,18]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=void 0;function c(f){if(f)return typeof f.iconPath=="string"?C.URI.file(f.iconPath):C.URI.isUri(f.iconPath)||w.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function r(f){if(f.icon){if(C.URI.isUri(f.icon))return f.icon;if(w.ThemeIcon.isThemeIcon(f.icon))return f.icon;{const g=f.icon;return{light:g.light,dark:g.dark}}}else return}function o(f,g){if(!f.iconPath&&!g.iconPath)return 0;if(f.iconPath){if(!g.iconPath)return 1}else return-1;const P=typeof f.iconPath=="string"?f.iconPath:C.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,N=typeof g.iconPath=="string"?g.iconPath:C.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,v.$pq)(P,N)}function m(f,g){let P=0;if(f.strikeThrough!==g.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==g.faded)return f.faded?1:-1;if(f.tooltip!==g.tooltip)return(f.tooltip||"").localeCompare(g.tooltip||"");if(P=o(f,g),P!==0)return P;if(f.light&&g.light)P=o(f.light,g.light);else{if(f.light)return 1;if(g.light)return-1}if(P!==0)return P;if(f.dark&&g.dark)P=o(f.dark,g.dark);else{if(f.dark)return 1;if(g.dark)return-1}return P}function h(f,g){if(f.command!==g.command)return f.command<g.command?-1:1;if(f.title!==g.title)return f.title<g.title?-1:1;if(f.tooltip!==g.tooltip){if(f.tooltip!==void 0&&g.tooltip!==void 0)return f.tooltip<g.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(f.arguments===g.arguments)return 0;if(f.arguments)if(g.arguments){if(f.arguments.length!==g.arguments.length)return f.arguments.length-g.arguments.length}else return 1;else return-1;for(let P=0;P<f.arguments.length;P++){const N=f.arguments[P],O=g.arguments[P];if(N!==O)return N<O?-1:1}return 0}function t(f,g){let P=(0,v.$pq)(f.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(P!==0)return P;if(f.command&&g.command)P=h(f.command,g.command);else{if(f.command)return 1;if(g.command)return-1}if(P!==0)return P;if(f.decorations&&g.decorations)P=m(f.decorations,g.decorations);else{if(f.decorations)return 1;if(g.decorations)return-1}return P}function n(f,g){for(let P=0;P<f.length;P++)if(f[P]!==g[P])return!1;return!0}function a(f,g){return f.command===g.command&&f.title===g.title&&f.tooltip===g.tooltip&&(f.arguments&&g.arguments?n(f.arguments,g.arguments):f.arguments===g.arguments)}function i(f,g){return(0,E.$ub)(f,g,a)}function s(f,g){return f===g?!0:!f||!g?!1:f.id===g.id&&f.label===g.label&&f.upstream?.id===g.upstream?.id&&f.upstream?.label===g.upstream?.label}class l{#e;#t;get value(){return this.d}set value(g){g=g??"",this.#e.$setInputBoxValue(this.l,g),this.n(g)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(g){this.#e.$setInputBoxPlaceholder(this.l,g),this.f=g}get validateInput(){return(0,k.$aF)(this.k,"scmValidation"),this.g}set validateInput(g){if((0,k.$aF)(this.k,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=g,this.#e.$setValidationProviderIsEnabled(this.l,!!g)}get enabled(){return this.h}set enabled(g){g=!!g,this.h!==g&&(this.h=g,this.#e.$setInputBoxEnablement(this.l,g))}get visible(){return this.j}set visible(g){g=!!g,this.j!==g&&(this.j=g,this.#e.$setInputBoxVisibility(this.l,g))}get document(){return(0,k.$aF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(g,P,N,O,M){this.k=g,this.l=O,this.m=M,this.d="",this.e=new T.$Nd,this.f="",this.h=!0,this.j=!0,this.#t=P,this.#e=N}showValidationMessage(g,P){(0,k.$aF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,g,P)}$onInputBoxValueChange(g){this.n(g)}n(g){this.d=g,this.e.fire(g)}}e.$Occ=l;class D{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(g){this.v=g,this.q.$updateGroupLabel(this.t,this.handle,g)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(g){this.p=g,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(g){this.f=[...g],this.k.fire()}constructor(g,P,N,O,M){this.q=g,this.s=P,this.t=N,this.u=O,this.v=M,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Nd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Nd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=D.d++}getResourceState(g){return this.g.get(g)}$executeResourceCommand(g,P){const N=this.h.get(g);return N?(0,A.$Mg)(()=>this.s.executeCommand(N.command,...N.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this.f].sort(t),N=(0,E.$Db)(this.o,g,t).map(j=>{const z=j.toInsert.map(F=>{const K=this.e++;this.g.set(K,F);const V=F.resourceUri;let fe;if(F.command)if(F.command.command==="vscode.open"||F.command.command==="vscode.diff"){const q=new L.$Rc;fe=this.s.converter.toInternal(F.command,q),this.j.set(K,q)}else this.h.set(K,F.command);const Z=c(F.decorations),Q=F.decorations&&c(F.decorations.light)||Z,X=F.decorations&&c(F.decorations.dark)||Z,oe=[Q,X],x=F.decorations&&F.decorations.tooltip||"",ae=F.decorations&&!!F.decorations.strikeThrough,we=F.decorations&&!!F.decorations.faded,G=F.contextValue||"";return{rawResource:[K,V,oe,x,ae,we,G,fe],handle:K}});return{start:j.start,deleteCount:j.deleteCount,toInsert:z}}),O=N.map(({start:j,deleteCount:z,toInsert:F})=>[j,z,F.map(K=>K.rawResource)]),M=N.reverse();for(const{start:j,deleteCount:z,toInsert:F}of M){const K=F.map(fe=>fe.handle),V=this.n.splice(j,z,...K);for(const fe of V)this.g.delete(fe),this.h.delete(fe),this.j.get(fe)?.dispose(),this.j.delete(fe)}return this.o=g,O}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(g){this.g!==g&&(this.g=g,this.#e.$updateSourceControl(this.x,{count:g}))}get quickDiffProvider(){return this.h}set quickDiffProvider(g){this.h=g;let P;(0,k.$_E)(this.y,"quickDiffProvider")&&(P=g?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!g,quickDiffLabel:P})}get historyProvider(){return(0,k.$aF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(g){(0,k.$aF)(this.y,"scmHistoryProvider"),this.j=g,this.k.value=new L.$Rc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!g}),g&&(this.k.value.add(g.onDidChangeCurrentHistoryItemGroup(()=>{s(this.l,g?.currentHistoryItemGroup)||(this.l=g?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(g.onDidChangeActionButton(()=>{(0,k.$aF)(this.y,"scmActionButton"),this.m.value=new L.$Rc;const P=g.actionButton!==void 0?{command:this.z.converter.toInternal(g.actionButton.command,this.m.value),description:g.actionButton.description,enabled:g.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,P??null)})))}get commitTemplate(){return this.n}set commitTemplate(g){g!==this.n&&(this.n=g,this.#e.$updateSourceControl(this.x,{commitTemplate:g}))}get acceptInputCommand(){return this.p}set acceptInputCommand(g){this.o.value=new L.$Rc,this.p=g;const P=this.z.converter.toInternal(g,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:P})}get actionButton(){return(0,k.$aF)(this.y,"scmActionButton"),this.s}set actionButton(g){(0,k.$aF)(this.y,"scmActionButton"),this.q.value=new L.$Rc,this.s=g;const P=g!==void 0?{command:this.z.converter.toInternal(g.command,this.q.value),secondaryCommands:g.secondaryCommands?.map(N=>N.map(O=>this.z.converter.toInternal(O,this.q.value))),description:g.description,enabled:g.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:P??null})}get statusBarCommands(){return this.u}set statusBarCommands(g){if(this.u&&g&&i(this.u,g))return;this.t.value=new L.$Rc,this.u=g;const P=(g||[]).map(N=>this.z.converter.toInternal(N,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:P})}get selected(){return this.v}constructor(g,P,N,O,M,j,z){this.y=g,this.z=O,this.A=M,this.B=j,this.C=z,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Tc,this.m=new L.$Tc,this.n=void 0,this.o=new L.$Tc,this.p=void 0,this.q=new L.$Tc,this.t=new L.$Tc,this.u=void 0,this.v=!1,this.w=new T.$Nd,this.onDidChangeSelection=this.w.event,this.x=S.d++,this.D=new Map,this.E=new Set,this.#e=N;const F=C.URI.from({scheme:p.Schemas.vscodeSourceControl,path:`${M}/scm${this.x}/input`,query:z?`rootUri=${encodeURIComponent(z.toString())}`:void 0});this.f=new l(g,P,this.#e,this.x,F),this.#e.$registerSourceControl(this.x,M,j,z,F)}createResourceGroup(g,P){const N=new D(this.#e,this.z,this.x,g,P),O=T.Event.once(N.onDidDispose)(()=>this.D.delete(N));return this.D.set(N,O),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const g=[],P=[];for(const[N,O]of this.D){O.dispose();const M=N.onDidUpdateResourceStates(()=>{this.E.add(N),this.eventuallyUpdateResourceStates()});T.Event.once(N.onDidDispose)(()=>{this.E.delete(N),M.dispose(),this.e.delete(N.handle),this.#e.$unregisterGroup(this.x,N.handle)}),g.push([N.handle,N.id,N.label,N.features]);const j=N._takeResourceStateSnapshot();j.length>0&&P.push([N.handle,j]),this.e.set(N.handle,N)}this.#e.$registerGroups(this.x,g,P),this.D.clear()}eventuallyUpdateResourceStates(){const g=[];this.E.forEach(P=>{const N=P._takeResourceStateSnapshot();N.length!==0&&g.push([P.handle,N])}),g.length>0&&this.#e.$spliceResourceStates(this.x,g),this.E.clear()}getResourceGroup(g){return this.e.get(g)}setSelectionState(g){this.v=g,this.w.fire(g)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(g=>g.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,d.$hh)(100)],S.prototype,"eventuallyAddResourceGroups",null),He([(0,d.$hh)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{u=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(g,P,N,O){this.l=P,this.m=N,this.n=O,this.g=new Map,this.h=new I.$6l,this.j=new T.$Nd,this.e=g.getProxy($.$cK.MainThreadSCM),this.f=g.getProxy($.$cK.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const j=this.g.get(M.sourceControlHandle);if(!j)return M;const z=j.getResourceGroup(M.groupHandle);return z?z.getResourceState(M.handle):M}else if(M&&M.$mid===4){const j=this.g.get(M.sourceControlHandle);return j?j.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const j=this.g.get(M.handle);return j||M}return M}})}createSourceControl(g,P,N,O){this.n.trace("ExtHostSCM#createSourceControl",g.identifier.value,P,N,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const M=u.d++,j=new S(g,this.m,this.e,this.l,P,N,O);this.g.set(M,j);const z=this.h.get(g.identifier)||[];return z.push(j),this.h.set(g.identifier,z),j}getLastInputBox(g){this.n.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const P=this.h.get(g.identifier),N=P&&P[P.length-1];return N&&N.inputBox}$provideOriginalResource(g,P,N){const O=C.URI.revive(P);this.n.trace("ExtHostSCM#$provideOriginalResource",g,O.toString());const M=this.g.get(g);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Mg)(()=>M.quickDiffProvider.provideOriginalResource(O,N)).then(j=>j||null)}$onInputBoxValueChange(g,P){this.n.trace("ExtHostSCM#$onInputBoxValueChange",g);const N=this.g.get(g);return N&&N.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(g,P,N,O){this.n.trace("ExtHostSCM#$executeResourceCommand",g,P,N);const M=this.g.get(g);if(!M)return Promise.resolve(void 0);const j=M.getResourceGroup(P);return j?j.$executeResourceCommand(N,O):Promise.resolve(void 0)}$validateInput(g,P,N){this.n.trace("ExtHostSCM#$validateInput",g);const O=this.g.get(g);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Mg)(()=>O.inputBox.validateInput(P,N)).then(M=>{if(!M)return Promise.resolve(void 0);const j=y.MarkdownString.fromStrict(M.message);return j?Promise.resolve([j,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this.g.get(g)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=g,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(g,P,N){return await this.g.get(g)?.historyProvider?.resolveHistoryItemGroupBase(P,N)??void 0}async $resolveHistoryItemGroupCommonAncestor(g,P,N,O){return await this.g.get(g)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(P,N,O)??void 0}async $provideHistoryItems(g,P,N,O){return(await this.g.get(g)?.historyProvider?.provideHistoryItems(P,N,O))?.map(z=>({id:z.id,parentIds:z.parentIds,label:z.label,description:z.description,icon:r(z),timestamp:z.timestamp}))??void 0}async $provideHistoryItemChanges(g,P,N){return await this.g.get(g)?.historyProvider?.provideHistoryItemChanges(P,N)??void 0}};e.$Pcc=b,e.$Pcc=b=u=He([Be(3,R.$9i)],b)}),define(De[114],Ce([1,0,6,4,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=e.$ucc=void 0;class L{constructor($){this.b=new T.$Nd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(C.$cK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,E){return this.a.$getPassword($,E)}store($,E,v){return this.a.$setPassword($,E,v)}delete($,E){return this.a.$deletePassword($,E)}}e.$ucc=L,e.$vcc=(0,d.$Oh)("IExtHostSecretState")}),define(De[326],Ce([1,0,6,13,2]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;class L{static{this.a=0}constructor($,E){this.d=E,this.c=new Map,this.b=$.getProxy(C.$cK.MainThreadShare)}async $provideShare($,E,v){return await this.c.get($)?.provideShare({selection:T.Range.to(E.selection),resourceUri:d.URI.revive(E.resourceUri)},v)??void 0}registerShareProvider($,E){const v=L.a++;return this.c.set(v,E),this.b.$registerShareProvider(v,T.DocumentSelector.from($,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(v),this.c.delete(v)}}}}e.$Rdc=L}),define(De[327],Ce([1,0,3,6]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class d{static{this.a=1}constructor(A){this.c=new Map,this.b=A.getProxy(T.$cK.MainThreadSpeech)}async $createSpeechToTextSession(A,$,E){const v=this.c.get(A);if(!v)return;const R=v.provideSpeechToTextSession(E);if(E.isCancellationRequested)return;const I=R.onDidChange(w=>{E.isCancellationRequested||this.b.$emitSpeechToTextEvent($,w)});E.onCancellationRequested(()=>{I.dispose(),R.dispose()})}registerProvider(A,$,E){const v=d.a++;return this.c.set(v,E),this.b.$registerProvider(v,$,{extension:A,displayName:A.value}),(0,C.$Qc)(()=>{this.b.$unregisterProvider(v),this.c.delete(v)})}}e.$Tdc=d}),define(De[328],Ce([1,0,7,6,209,3,13,17]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$_K("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$_K("statusBarItem.warningForeground")]])}#e;#t;constructor(w,y,k,p,u,c=C.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new L.$Rc,this.#e=w,this.#t=y,u&&p){this.c=(0,C.$OK)(p.identifier,u);const o=k.get(this.c);o&&(c=o.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,r=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(E.a++);this.e=p,this.f=u,this.g=c,this.h=this.u(r)}u(w){if((0,$.$Cf)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(w){this.k=w,this.v()}set name(w){this.m=w,this.v()}set tooltip(w){this.l=w,this.v()}set color(w){this.n=w,this.v()}set backgroundColor(w){w&&!E.b.has(w.id)&&(w=void 0),this.o=w,this.v()}set command(w){this.r?.fromApi!==w&&(this.p&&this.q.add(this.p),this.p=new L.$Rc,typeof w=="string"?this.r={fromApi:w,internal:this.#t.toInternal({title:"",command:w},this.p)}:w?this.r={fromApi:w,internal:this.#t.toInternal(w,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(w){this.t=w,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let w;this.e?this.f?w=`${this.e.identifier.value}.${this.f}`:w=this.e.identifier.value:w=this.f;let y;this.m?y=this.m:y=(0,d.localize)(0,null,this.e.displayName||this.e.name);let k=this.n;this.o&&(k=E.b.get(this.o.id));const p=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,w,this.e?.identifier.value,y,this.k,p,this.r?.internal,k,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Qcc=E;class v{constructor(w){this.b=[],this.a=w.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,d.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(w){const y={message:w};return this.b.unshift(y),this.c(),new C.$eK(()=>{const k=this.b.indexOf(y);k>=0&&(this.b.splice(k,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(w,y){this.e=new Map,this.a=w.getProxy(T.$cK.MainThreadStatusBar),this.b=y,this.c=new v(this)}$acceptStaticEntries(w){for(const y of w)this.e.set(y.entryId,y)}createStatusBarEntry(w,y,k,p){return new E(this.a,this.b,this.e,w,y,k,p)}setStatusBarMessage(w,y){const k=this.c.setMessage(w);let p;return typeof y=="number"?p=setTimeout(()=>k.dispose(),y):typeof y<"u"&&y.then(()=>k.dispose(),()=>k.dispose()),new C.$eK(()=>{k.dispose(),clearTimeout(p)})}}e.$Rcc=R}),define(De[115],Ce([1,0,6,4,5]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=e.$icc=void 0;class L{constructor($,E){this.c=E,this.b=new T.$Nd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(C.$cK.MainThreadStorage)}registerExtensionStorageKeysToSync($,E){this.a.$registerExtensionStorageKeysToSync($,E)}async initializeExtensionStorage($,E,v){const R=await this.a.$initializeExtensionStorage($,E);let I;return R&&(I=this.d($,E,R)),I||v}setValue($,E,v){return this.a.$setValue($,E,v)}$acceptValue($,E,v){const R=this.d($,E,v);R&&this.b.fire({shared:$,key:E,value:R})}d($,E,v){try{return JSON.parse(v)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${$}): ${R}`)}}}e.$icc=L,e.$jcc=(0,d.$Oh)("IExtHostStorage")}),define(De[90],Ce([1,0,5,27,14,72,2]),function($e,e,C,T,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=e.$occ=void 0,e.$occ=(0,C.$Oh)("IExtensionStoragePaths");let $=class{constructor(v,R,I){this.d=R,this.f=I,this.a=v.workspace??void 0,this.b=v.environment,this.whenReady=this.h().then(w=>this.c=w)}async g(v){return A.URI.joinPath(this.b.workspaceStorageHome,v)}async h(){if(!this.a)return Promise.resolve(void 0);const v=this.a.id,R=await this.g(v);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(v){if(this.c)return A.URI.joinPath(this.c,v.identifier.value)}globalValue(v){return A.URI.joinPath(this.b.globalStorageHome,v.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$pcc=$,e.$pcc=$=He([Be(0,T.$tM),Be(1,d.$9i),Be(2,L.$ncc)],$)}),define(De[45],Ce([1,0,4,6,5,2,20,3,7,211,8,253,21,31,254,59,9,13,33]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=e.$scc=e.$rcc=e.$qcc=void 0,e.$qcc=(0,d.$Oh)("IExtHostTerminalService");class o{constructor(b,f,g,P){this.l=b,this._id=f,this.m=g,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(O=>this.f=O);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(O,M=!0){N.q(),N.l.$sendText(N._id,O,M)},show(O){N.q(),N.l.$show(N._id,O)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(b,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??void 0,env:b.env??void 0,icon:s(b.iconPath)??void 0,color:p.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,isFeatureTerminal:f?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:f?.useShellEnvironment??void 0,location:f?.location||this.o(b.location,f?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,f,g,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:g,color:p.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o(b,f),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(b,f){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in b?{viewColumn:c.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.n=b}setExitStatus(b,f){this.h=Object.freeze({code:b,reason:f})}setDimensions(b,f){return b===this.d&&f===this.g||b===0||f===0?!1:(this.d=b,this.g=f,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(b){this.k=b}_setProcessId(b){this.f?(this.f(b),this.f=void 0):this.b.then(f=>{f!==b&&(this.b=Promise.resolve(b))})}}e.$rcc=o;class m{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new C.$Nd,this.onProcessData=this.a.event,this.b=new C.$Nd,this.d=new C.$Nd,this.onDidChangeProperty=this.d.event,this.f=new C.$Nd,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${f}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,f){this.g.setDimensions?.({columns:b,rows:f})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(f=>this.a.fire(f)),this.g.onDidClose?.((f=void 0)=>{this.f.fire(f===void 0?void 0:f)}),this.g.onDidOverrideDimensions?.(f=>{f&&this.d.fire({type:"overrideDimensions",value:{cols:f.columns,rows:f.rows}})}),this.g.onDidChangeName?.(f=>{this.d.fire({type:"title",value:f})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends $.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,f,g){super(),this.Q=f,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$Nd,this.onDidCloseTerminal=this.H.event,this.I=new C.$Nd,this.onDidOpenTerminal=this.I.event,this.J=new C.$Nd,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$Nd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$Nd,this.onDidChangeTerminalState=this.M.event,this.N=new C.$Nd,this.onDidChangeShell=this.N.event,this.O=new C.$Nd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$Nd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=g.getProxy(T.$cK.MainThreadTerminalService),this.y=new k.$Pkb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:P=>{const N=O=>{const M=O;return this.W(M.instanceId)?.value};switch(P?.$mid){case 15:return N(P);default:{if(Array.isArray(P))for(let O=0;O<P.length&&P[O].$mid===15;O++)P[O]=N(P[O]);return P}}}}),this.B({dispose:()=>{for(const[P,N]of this.g)N.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,f){const g=new o(this.a,(0,y.$eg)(),b,b.name),P=new m(b.pty);return g.createExtensionTerminal(b.location,this.R(b,f).resolvedExtHostIdentifier,s(b.iconPath),l(b.color)).then(N=>{const O=this.S(N,P);this.h[N]=O}),this.f.push(g),g.value}R(b,f){if(f=f||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const g=b.location.parentTerminal;if(g){const P=this.f.find(N=>N.value===g);P&&(f.resolvedExtHostIdentifier=P._id)}}else b.location&&typeof b.location!="object"?f.location=b.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal(b,f){if(!this.W(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const P=new m(f),N=this.S(b,P);this.h[b]=N}async $acceptActiveTerminalChanged(b){const f=this.b;if(b===null){this.b=void 0,f!==this.b&&this.J.fire(this.b);return}const g=this.W(b);g&&(this.b=g,f!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,f){const g=this.W(b);g&&this.O.fire({terminal:g.value,data:f})}async $acceptTerminalDimensions(b,f,g){const P=this.W(b);P&&P.setDimensions(f,g)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(b,f){const g=this.W(b);g&&this.P.fire({terminal:g.value,...f})}async $acceptTerminalMaximumDimensions(b,f,g){this.g.get(b)?.resize(f,g)}async $acceptTerminalTitleChange(b,f){const g=this.W(b);g&&(g.name=f)}async $acceptTerminalClosed(b,f,g){const P=this.Y(this.f,b);if(P!==null){const N=this.f.splice(P,1)[0];N.setExitStatus(f,g),this.H.fire(N.value)}}$acceptTerminalOpened(b,f,g,P){if(f){const M=this.Y(this.f,f);if(M!==null){this.f[M]._id=b,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const N={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:L.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},O=new o(this.a,b,N,g);this.f.push(O),this.I.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId(b,f){this.W(b)?._setProcessId(f)}async $startExtensionTerminal(b,f){const g=this.W(b);if(!g)return{message:(0,v.localize)(0,null,b)};g.isOpen||await new Promise(N=>{const O=this.onDidOpenTerminal(async M=>{M===g.value&&(O.dispose(),N())})});const P=this.g.get(b);P?P.startSendingEvents(f):this.j[b]={initialDimensions:f}}S(b,f){const g=new $.$Rc;g.add(f.onProcessReady(N=>this.a.$sendProcessReady(b,N.pid,N.cwd,N.windowsPty))),g.add(f.onDidChangeProperty(N=>this.a.$sendProcessProperty(b,N))),this.y.startBuffering(b,f.onProcessData),g.add(f.onProcessExit(N=>this.U(b,N))),this.g.set(b,f);const P=this.j[b];return P&&f instanceof m&&(f.startSendingEvents(P.initialDimensions),delete this.j[b]),g}$acceptProcessAckDataEvent(b,f){this.g.get(b)?.acknowledgeDataEvent(f)}$acceptProcessInput(b,f){this.g.get(b)?.input(f)}$acceptTerminalInteraction(b){const f=this.W(b);f?.setInteractedWith()&&this.M.fire(f.value)}$acceptTerminalSelection(b,f){this.W(b)?.setSelection(f)}$acceptProcessResize(b,f,g){try{this.g.get(b)?.resize(f,g)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(b,f){this.g.get(b)?.shutdown(f)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(f=>this.a.$sendProcessProperty(b,{type:"initialCwd",value:f}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(f=>this.a.$sendProcessProperty(b,{type:"cwd",value:f}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new E.$eK(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,f,g){if(this.C.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this.C.set(f,g),this.a.$registerProfileProvider(f,b.identifier.value),new E.$eK(()=>{this.C.delete(f),this.a.$unregisterProfileProvider(f)})}registerTerminalQuickFixProvider(b,f,g){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,g),this.a.$registerQuickFixProvider(b,f),new E.$eK(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,f){const g=new w.$Xd().token;if(g.isCancellationRequested)return;const P=this.D.get(b);if(!P)return;const N=await P.provideTerminalQuickFixes(f,g);if(N===null||Array.isArray(N)&&N.length===0)return;const O=new $.$Rc;if(this.w.value=O,!Array.isArray(N))return N?c.TerminalQuickFix.from(N,this.Q.converter,O):void 0;const M=[];for(const j of N){const z=c.TerminalQuickFix.from(j,this.Q.converter,O);z&&M.push(z)}return M}async $createContributedProfileTerminal(b,f){const g=new w.$Xd().token;let P=await this.C.get(b)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,f);return}this.createTerminalFromOptions(P.options,f)}}async $provideLinks(b,f){const g=this.W(b);if(!g)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const N=new w.$Xd;this.G.set(b,N);const O=[],M={terminal:g.value,line:f},j=[];for(const K of this.z)j.push(u.Promises.withAsyncBody(async V=>{N.token.onCancellationRequested(()=>V({provider:K,links:[]}));const fe=await K.provideTerminalLinks(M,N.token)||[];N.token.isCancellationRequested||V({provider:K,links:fe})}));const z=await Promise.all(j);if(N.token.isCancellationRequested)return[];const F=new Map;for(const K of z)K&&K.links.length>0&&O.push(...K.links.map(V=>{const fe={id:h++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return F.set(fe.id,{provider:K.provider,link:V}),fe}));return this.F.set(b,F),O}$activateLink(b,f){const g=this.F.get(b)?.get(f);g&&g.provider.handleTerminalLink(g.link)}U(b,f){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const g=this.h[b];g&&(g.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,f)}W(b){return this.X(this.f,b)}X(b,f){const g=this.Y(b,f);return g!==null?b[g]:null}Y(b,f){const g=b.findIndex(P=>P._id===f);return g===-1?null:g}getEnvironmentVariableCollection(b){let f=this.n.get(b.identifier.value);return f||(f=new n,this.$(b.identifier.value,f)),f.getScopedEnvironmentVariableCollection(void 0)}Z(b,f){const g=(0,I.$ir)(f.map),P=(0,I.$jr)(f.descriptionMap);this.a.$setEnvironmentVariableCollection(b,f.persistent,g.length===0?void 0:g,P)}$initEnvironmentVariableCollections(b){b.forEach(f=>{const g=f[0],P=new n(f[1]);this.$(g,P)})}$acceptDefaultProfile(b,f){const g=this.s;this.s=b,this.u=f,g?.path!==b.path&&this.N.fire(b.path)}$(b,f){this.n.set(b,f),f.onDidChangeCollection(()=>{this.Z(b,f)})}};e.$scc=t,e.$scc=t=He([Be(1,r.$zM),Be(2,A.$dM)],t);class n{get persistent(){return this.b}set persistent(b){this.b=b,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(b){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$Nd,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const f=this.h(b);let g=this.a.get(f);return g||(g=new a(this,b),this.a.set(f,g),g.onDidChangeCollection(()=>this.d.fire())),g}replace(b,f,g,P){this.f(b,{value:f,type:E.EnvironmentVariableMutatorType.Replace,options:g??{applyAtProcessCreation:!0},scope:P})}append(b,f,g,P){this.f(b,{value:f,type:E.EnvironmentVariableMutatorType.Append,options:g??{applyAtProcessCreation:!0},scope:P})}prepend(b,f,g,P){this.f(b,{value:f,type:E.EnvironmentVariableMutatorType.Prepend,options:g??{applyAtProcessCreation:!0},scope:P})}f(b,f){if(f.options&&f.options.applyAtProcessCreation===!1&&!f.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const g=this.g(b,f.scope),P=this.map.get(g),N=f.options?{applyAtProcessCreation:f.options.applyAtProcessCreation??!1,applyAtShellIntegration:f.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==f.value||P.type!==f.type||P.options?.applyAtProcessCreation!==N.applyAtProcessCreation||P.options?.applyAtShellIntegration!==N.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index){const O=this.g(b,f.scope),M={variable:b,...f,options:N};this.map.set(O,M),this.d.fire()}}get(b,f){const g=this.g(b,f),P=this.map.get(g);return P?D(P):void 0}g(b,f){const g=this.h(f);return g.length?`${b}:::${g}`:b}h(b){return this.j(b?.workspaceFolder)??""}j(b){return b?b.uri.toString():void 0}getVariableMap(b){const f=new Map;for(const[g,P]of this.map)this.h(P.scope)===this.h(b)&&f.set(P.variable,D(P));return f}delete(b,f){const g=this.g(b,f);this.map.delete(g),this.d.fire()}clear(b){if(b?.workspaceFolder){for(const[f,g]of this.map)g.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(f);this.k(b)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(b,f){const g=this.h(f),P=this.descriptionMap.get(g);if(!P||P.description!==b){let N;typeof b=="string"?N=b:N=b?.value.split(`

`)[0];const O={description:N,scope:f};this.descriptionMap.set(g,O),this.d.fire()}}getDescription(b){const f=this.h(b);return this.descriptionMap.get(f)?.description}k(b){const f=this.h(b);this.descriptionMap.delete(f)}}class a{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,f){this.b=b,this.d=f,this.a=new C.$Nd}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,f,g){this.b.replace(b,f,g,this.d)}append(b,f,g){this.b.append(b,f,g,this.d)}prepend(b,f,g){this.b.prepend(b,f,g,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,f){this.b.getVariableMap(this.d).forEach((g,P)=>b.call(f,P,g,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let i=class extends t{constructor(b,f){super(!1,b,f)}createTerminal(b,f,g){throw new R.$_}createTerminalFromOptions(b,f){throw new R.$_}};e.$tcc=i,e.$tcc=i=He([Be(0,r.$zM),Be(1,A.$dM)],i);function s(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function l(S){return p.ThemeColor.isThemeColor(S)?S:void 0}function D(S){const b={...S};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(De[329],Ce([1,0,118,9,22,21,4,75,52,3,24,17,31,6,20,145,13,7,68,109,87,26]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r,o,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=e.$Cdc=e.$Bdc=e.$Adc=void 0;let t=class{constructor(M,j,z){this.k=z,this.d=new A.$Nd,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=M.getProxy(y.$cK.MainThreadTesting),this.j=new g(this.g),this.h=new s(this.g),j.registerArgumentProcessor({processArgument:F=>{switch(F?.$mid){case 16:{const K=F,V=K.tests[K.tests.length-1].item.extId;return this.f.get(r.$8I.root(V))?.collection.tree.get(V)?.actual??(0,p.$pM)(F)}case 18:{const{extId:K,message:V}=F;return{test:this.f.get(r.$8I.root(K))?.collection.tree.get(K)?.actual,message:u.TestMessage.to(V)}}default:return F}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const F=await j.executeCommand("_testing.getExplorerSelection"),K=V=>{const fe=this.f.get(r.$8I.root(V));if(fe)return r.$8I.isRoot(V)?fe.controller:fe.collection.tree.get(V)?.actual};return{include:F?.include.map(K).filter(I.$Gf)||[],exclude:F?.exclude.map(K).filter(I.$Gf)||[]}})}createTestController(M,j,z,F){if(this.f.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const K=new v.$Rc,V=K.add(new p.$sM(j,z,this.k));V.root.label=z;const fe=new Map,Z=this.g,Q={items:V.root.children,get label(){return z},set label(oe){z=oe,V.root.label=oe,Z.$updateController(j,{label:z})},get refreshHandler(){return F},set refreshHandler(oe){F=oe,Z.$updateController(j,{canRefresh:!!oe})},get id(){return j},createRunProfile:(oe,x,ae,we,G,U)=>{let q=(0,E.$Ci)(oe);for(;fe.has(q);)q++;return new P(this.g,fe,j,q,oe,x,ae,we,G,U)},createTestItem(oe,x,ae){return new p.$qM(j,oe,x,ae)},createTestRun:(oe,x,ae=!0)=>this.h.createTestRun(M,j,V,oe,x,ae),invalidateTestResults:oe=>{if(oe===void 0)this.g.$markTestRetired(void 0);else{const x=oe instanceof Array?oe:[oe];this.g.$markTestRetired(x.map(ae=>r.$8I.fromExtHostTestItem(ae,j).toString()))}},set resolveHandler(oe){V.resolveHandler=oe},get resolveHandler(){return V.resolveHandler},dispose:()=>{K.dispose()}};Z.$registerTestController(j,z,!!F),K.add((0,v.$Qc)(()=>Z.$unregisterTestController(j)));const X={controller:Q,collection:V,profiles:fe,extension:M};return this.f.set(j,X),K.add((0,v.$Qc)(()=>this.f.delete(j))),K.add(V.onDidGenerateDiff(oe=>Z.$publishDiff(j,oe.map(m.TestsDiffOp.serialize)))),Q}createTestObserver(){return this.j.checkout()}async runTests(M,j=L.CancellationToken.None){const z=l(M);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.f.get(z.controllerId);if(!F)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(K=>r.$8I.fromExtHostTestItem(K,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:N[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:M.exclude?.map(K=>K.id)},j)}$syncTests(){for(const{collection:M}of this.f.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,j,z){return(0,C.$rb)(this.h.trackers,K=>K.id===M?K.getCoverage(j):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(M,j,z,F){return(0,C.$rb)(this.h.trackers,V=>V.id===M?V.getCoverage(j):void 0)?.resolveFileCoverage(z,F)??Promise.resolve([])}$configureRunProfile(M,j){this.f.get(M)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(M,j){await this.f.get(M)?.controller.refreshHandler?.(j)}$publishTestResults(M){this.results=Object.freeze(M.map(j=>(0,R.$5m)(u.TestResults.to(j))).concat(this.results).sort((j,z)=>z.completedAt-j.completedAt).slice(0,32)),this.d.fire()}async $expandTest(M,j){const z=this.f.get(r.$8I.fromString(M).controllerId)?.collection;z&&(await z.expand(M,j<0?1/0:j),z.flushDiff())}$acceptDiff(M){this.j.applyDiff(M.map(m.TestsDiffOp.deserialize))}async $runControllerTests(M,j){return Promise.all(M.map(z=>this.l(z,!1,j)))}async $startContinuousRun(M,j){const z=new L.$Xd(j),F=await Promise.all(M.map(K=>this.l(K,!0,z.token)));return!j.isCancellationRequested&&!F.some(K=>K.error)&&await new Promise(K=>j.onCancellationRequested(K)),z.dispose(!0),F}async l(M,j,z){const F=this.f.get(M.controllerId);if(!F)return{};const{collection:K,profiles:V,extension:fe}=F,Z=V.get(M.profileId);if(!Z)return{};const Q=M.testIds.map(ae=>K.tree.get(ae)).filter(I.$Gf),X=M.excludeExtIds.map(ae=>F.collection.tree.get(ae)).filter(I.$Gf).filter(ae=>Q.some(we=>we.fullId.compare(ae.fullId)===2));if(!Q.length)return{};const oe=new c.$ML(Q.some(ae=>ae.actual instanceof p.$rM)?void 0:Q.map(ae=>ae.actual),X.map(ae=>ae.actual),Z,j),x=(0,m.$0I)(M)&&this.h.prepareForMainThreadTestRun(oe,D.fromInternal(M,F.collection),fe,z);try{return await Z.runHandler(oe,z),{}}catch(ae){return{error:String(ae)}}finally{x&&(x.hasRunningTasks&&!z.isCancellationRequested&&await A.Event.toPromise(x.onEnd),x.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.h.cancelAllRuns():this.h.cancelRunById(M)}};e.$Adc=t,e.$Adc=t=He([Be(0,k.$dM)],t);const n=1e4;var a;(function(O){O[O.Running=0]="Running",O[O.Cancelling=1]="Cancelling",O[O.Ended=2]="Ended"})(a||(a={}));class i extends v.$Sc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(M,j,z,F){super(),this.s=M,this.u=j,this.w=z,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$Nd),this.onEnd=this.m.event,this.j=this.B(new L.$Xd(F));const K=this.B(new T.$6g(()=>this.y(),n));this.B(this.j.token.onCancellationRequested(()=>K.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(M){return this.g.get(M)?.coverage}createRun(M){const j=this.s.id,z=this.s.controllerId,F=(0,w.$eg)(),K=new S(this.u,j,F),V=X=>(oe,...x)=>{if(Z){console.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.s.isIncluded(oe)&&(this.C(oe),X(oe,...x))},fe=(X,oe)=>{const x=oe instanceof Array?oe.map(u.TestMessage.from):[u.TestMessage.from(oe)];if(x.some(ae=>ae.contextValue!==void 0)&&(0,h.$aF)(this.w,"testMessageContextValue"),X.uri&&X.range){const ae={range:u.Range.from(X.range),uri:X.uri};for(const we of x)we.location=we.location||ae}this.u.$appendTestMessagesInRun(j,F,r.$8I.fromExtHostTestItem(X,z).toString(),x)};let Z=!1;const Q={isPersisted:this.s.isPersisted,token:this.j.token,name:M,get coverageProvider(){return K.coverageProvider},set coverageProvider(X){K.coverageProvider=X},enqueued:V(X=>{this.u.$updateTestStateInRun(j,F,r.$8I.fromExtHostTestItem(X,z).toString(),1)}),skipped:V(X=>{this.u.$updateTestStateInRun(j,F,r.$8I.fromExtHostTestItem(X,z).toString(),5)}),started:V(X=>{this.u.$updateTestStateInRun(j,F,r.$8I.fromExtHostTestItem(X,z).toString(),2)}),errored:V((X,oe,x)=>{fe(X,oe),this.u.$updateTestStateInRun(j,F,r.$8I.fromExtHostTestItem(X,z).toString(),6,x)}),failed:V((X,oe,x)=>{fe(X,oe),this.u.$updateTestStateInRun(j,F,r.$8I.fromExtHostTestItem(X,z).toString(),4,x)}),passed:V((X,oe)=>{this.u.$updateTestStateInRun(j,F,r.$8I.fromExtHostTestItem(X,this.s.controllerId).toString(),3,oe)}),appendOutput:(X,oe,x)=>{Z||(x&&(this.s.isIncluded(x)?this.C(x):x=void 0),this.u.$appendOutputToRun(j,F,d.$be.fromString(X),oe&&u.location.from(oe),x&&r.$8I.fromExtHostTestItem(x,z).toString()))},end:()=>{Z||(Z=!0,this.u.$finishedTestRunTask(j,F),this.g.delete(F),this.g.size||this.z())}};return this.g.set(F,{run:Q,coverage:K}),this.u.$startedTestRunTask(j,{id:F,name:M,running:!0}),Q}y(){for(const{run:M}of this.g.values())M.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(M){if(!(M instanceof p.$qM))throw new o.$8L(M.id);if(this.h.has(r.$8I.fromExtHostTestItem(M,this.s.controllerId).toString()))return;const j=[],z=this.s.colllection.root;for(;;){const F=u.TestItem.from(M);if(j.unshift(F),this.h.has(F.extId)||(this.h.add(F.extId),M===z))break;M=M.parent||z}this.u.$addTestsToRun(this.s.controllerId,this.s.id,j)}dispose(){this.z(),super.dispose()}}class s{get trackers(){return this.d.values()}constructor(M){this.f=M,this.d=new Map}prepareForMainThreadTestRun(M,j,z,F){return this.g(M,j,z,F)}cancelRunById(M){for(const j of this.d.values())if(j.id===M){j.cancel();return}}cancelAllRuns(){for(const M of this.d.values())M.cancel()}createTestRun(M,j,z,F,K,V){const fe=this.d.get(F);if(fe)return fe.createRun(K);const Z=D.fromPublic(j,z,F,V),Q=l(F);this.f.$startedExtensionTestRun({controllerId:j,continuous:!!F.continuous,profile:Q&&{group:N[Q.kind],id:Q.profileId},exclude:F.exclude?.map(oe=>r.$8I.fromExtHostTestItem(oe,z.root.id).toString())??[],id:Z.id,include:F.include?.map(oe=>r.$8I.fromExtHostTestItem(oe,z.root.id).toString())??[z.root.id],persist:V});const X=this.g(F,Z,M);return A.Event.once(X.onEnd)(()=>{this.f.$finishedExtensionTestRun(Z.id),X.dispose()}),X.createRun(K)}g(M,j,z,F){const K=new i(j,this.f,z,F);return this.d.set(M,K),A.Event.once(K.onEnd)(()=>this.d.delete(M)),K}}e.$Bdc=s;const l=O=>{if(O.profile){if(!(O.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return O.profile}};class D{static fromPublic(M,j,z,F){return new D(M,(0,w.$eg)(),z.include?.map(K=>r.$8I.fromExtHostTestItem(K,M).toString())??[M],z.exclude?.map(K=>r.$8I.fromExtHostTestItem(K,M).toString())??[],F,j)}static fromInternal(M,j){return new D(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,j)}constructor(M,j,z,F,K,V){this.controllerId=M,this.id=j,this.isPersisted=K,this.colllection=V,this.d=z.map(fe=>fe+"\0"),this.f=F.map(fe=>fe+"\0")}isIncluded(M){const j=r.$8I.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const z of this.f)if(j===z||j.startsWith(z))return!1;for(const z of this.d)if(j===z||j.startsWith(z))return!0;return!1}}e.$Cdc=D;class S{set coverageProvider(M){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");M&&(this.d=M,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(M,j,z){this.g=M,this.h=j,this.j=z}async provideFileCoverage(M){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(M))());try{return(await this.f)?.map(u.TestCoverage.fromFile)??[]}catch(j){throw this.f=void 0,j}}async resolveFileCoverage(M,j){const z=await this.f;let F=z?.[M];return!this.d||!z||!F?[]:(F.detailedCoverage||(F=z[M]=await this.d.resolveFileCoverage?.(F,j)??F),F.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class b{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(M){this.j=M,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(M){this.d.add(M)}update(M){Object.assign(M.revived,u.TestItem.toPlain(M.item)),this.d.has(M)||this.f.add(M)}remove(M){if(this.d.has(M)){this.d.delete(M);return}this.f.delete(M);const j=r.$8I.parentId(M.item.extId);if(j&&this.h.has(j.toString())){this.h.add(M.item.extId);return}this.g.add(M)}getChangeEvent(){const{d:M,f:j,g:z}=this;return{get added(){return[...M].map(F=>F.revived)},get updated(){return[...j].map(F=>F.revived)},get removed(){return[...z].map(F=>F.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class f extends m.$cJ{constructor(){super(...arguments),this.s=new A.$Nd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(M){return this.f.get(M)}getMirroredTestDataByReference(M){return this.f.get(M.id)}q(M,j){return{...M,revived:u.TestItem.toPlain(M.item),depth:j?j.depth+1:0,children:new Set}}p(){return new b(this.s)}}class g{constructor(M){this.f=M}checkout(){this.d||(this.d=this.g());const M=this.d;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(j=>j.revived)},dispose:(0,$.$db)(()=>{--M.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(M){return this.d?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.d?.tests.apply(M)}g(){const M=new f;return this.f.$subscribeToDiffs(),{observers:0,tests:M}}}class P{#e;#t;get label(){return this.f}set label(M){M!==this.f&&(this.f=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(M){M!==this.h&&(this.h=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.g}set isDefault(M){M!==this.g&&(this.g=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?u.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.d}set configureHandler(M){M!==this.d&&(this.d=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,j,z,F,K,V,fe,Z=!1,Q=void 0,X=!1){this.controllerId=z,this.profileId=F,this.f=K,this.kind=V,this.runHandler=fe,this.g=Z,this._tag=Q,this.h=X,this.#e=M,this.#t=j,j.set(F,this);const oe=N[V];if(typeof oe!="number")throw new Error(`Unknown TestRunProfile.group ${V}`);this.#e.$publishTestRunProfile({profileId:F,controllerId:z,tag:Q?u.TestTag.namespace(this.controllerId,Q.id):null,label:K,group:oe,isDefault:Z,hasConfigurationHandler:!1,supportsContinuousRun:X})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Ddc=P;const N={[c.TestRunProfileKind.Coverage]:8,[c.TestRunProfileKind.Debug]:4,[c.TestRunProfileKind.Run]:2}}),define(De[330],Ce([1,0,19,8,4,6,146,13,7]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;class v{constructor(I,w){this.i=w,this.a=new d.$Nd({onListenerError:T.$2}),this.b=new d.$Nd({onListenerError:T.$2}),this.c=new d.$Nd({onListenerError:T.$2}),this.d=new d.$Nd({onListenerError:T.$2}),this.f=new d.$Nd({onListenerError:T.$2}),this.g=new d.$Nd({onListenerError:T.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(L.$cK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const w=this.i.allEditors();return I?w:w.map(y=>y.value)}async showTextDocument(I,w,y){let k;typeof w=="number"?k={position:$.ViewColumn.from(w),preserveFocus:y}:typeof w=="object"?k={position:$.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?$.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:k={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(I.uri,k),u=p&&this.i.getEditor(p);if(u)return u.value;throw p?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,w){return new A.$kM(this.h,I,w).value}$acceptEditorPropertiesChanged(I,w){const y=this.i.getEditor(I);if(!y)throw new Error("unknown text editor");if(w.options&&y._acceptOptions(w.options),w.selections){const k=w.selections.selections.map($.Selection.to);y._acceptSelections(k)}if(w.visibleRanges){const k=C.$Hb(w.visibleRanges.map($.Range.to));y._acceptVisibleRanges(k)}if(w.options&&this.b.fire({textEditor:y.value,options:{...w.options,lineNumbers:$.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const k=E.TextEditorSelectionChangeKind.fromValue(w.selections.source),p=w.selections.selections.map($.Selection.to);this.a.fire({textEditor:y.value,selections:p,kind:k})}if(w.visibleRanges){const k=C.$Hb(w.visibleRanges.map($.Range.to));this.c.fire({textEditor:y.value,visibleRanges:k})}}$acceptEditorPositionData(I){for(const w in I){const y=this.i.getEditor(w);if(!y)throw new Error("Unknown text editor");const k=$.ViewColumn.to(I[w]);y.value.viewColumn!==k&&(y._acceptViewColumn(k),this.d.fire({textEditor:y.value,viewColumn:k}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$Scc=v}),define(De[331],Ce([1,0,2,5,6,3,7,13,25,17]),function($e,e,C,T,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=e.$udc=void 0,e.$udc=(0,T.$Oh)("IExtHostTimeline");class R{constructor(y,k){this.b=new Map,this.c=new Map,this.a=y.getProxy(d.$cK.MainThreadTimeline),k.registerArgumentProcessor({processArgument:(p,u)=>{if(p&&p.$mid===12)if(this.b.get(p.source)&&E.$4l.equals(u,this.b.get(p.source)?.extension)){const c=p.uri===void 0?void 0:C.URI.revive(p.uri);return this.c.get(p.source)?.get(I(c))?.get(p.handle)}else return;return p}})}async $getTimeline(y,k,p,u){return this.b.get(y)?.provider.provideTimeline(C.URI.revive(k),p,u)}registerTimelineProvider(y,k,p,u){const c=new L.$Rc,r=this.d(k.id,u,c).bind(this);let o;k.onDidChange&&(o=k.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:k.id}),this));const m=this.c;return this.f({...k,scheme:y,onDidChange:void 0,async provideTimeline(h,t,n){t?.resetCache&&(c.clear(),m.get(k.id)?.clear());const a=await k.provideTimeline(h,t,n);if(a==null)return;const i=r(h,t);return{...a,source:k.id,items:a.items.map(i)}},dispose(){for(const h of m.values())h.get(k.id)?.clear();o?.dispose(),c.dispose()}},p)}d(y,k,p){return(u,c)=>{let r;if(c?.cacheResults){let o=this.c.get(y);o===void 0&&(o=new Map,this.c.set(y,o));const m=I(u);r=o.get(m),r===void 0&&(r=new Map,o.set(m,r))}return o=>{const{iconPath:m,...h}=o,t=`${y}|${o.id??o.timestamp}`;r?.set(t,o);let n,a,i;o.iconPath&&(m instanceof A.$$K?i={id:m.id,color:m.color}:C.URI.isUri(m)?(n=m,a=m):{light:n,dark:a}=m);let s;return A.$EK.isMarkdownString(h.tooltip)?s=$.MarkdownString.from(h.tooltip):(0,v.$yf)(h.tooltip)?s=h.tooltip:A.$EK.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=$.MarkdownString.from(h.detail)):(0,v.$yf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=h.detail),{...h,id:h.id??void 0,handle:t,source:y,command:o.command?k.toInternal(o.command,p):void 0,icon:n,iconDark:a,themeIcon:i,tooltip:s,accessibilityInformation:o.accessibilityInformation}}}}f(y,k){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:k}),(0,L.$Qc)(()=>{for(const u of this.c.values())u.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$vdc=R;function I(w){return w?.toString()}}),define(De[73],Ce([1,0,21,4,3,213,5,14,86,6,27,20,7]),function($e,e,C,T,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3vb=e.$2vb=e.TunnelDtoConverter=void 0;class y extends E.$cv{}var k;(function(u){function c(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:o.protocol}}u.fromApiTunnel=c;function r(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==E.TunnelPrivacyId.ConstantPrivate&&o.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}u.fromServiceTunnel=r})(k||(e.TunnelDtoConverter=k={})),e.$2vb=(0,A.$Oh)("IExtHostTunnelService");let p=class extends d.$Sc{constructor(c,r,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Nd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(v.$cK.MainThreadTunnelService)}async openTunnel(c,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const o=await this.a.$openTunnel(r,c.displayName);if(o){const m=new y(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(m),m}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,r){const o=this.u();return this.r.set(o,{selector:c,provider:r}),this.a.$registerPortsAttributesProvider(c,o),new w.$eK(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(c,r,o,m,h){const t=[];for(const a of c){const i=this.r.get(a);if(!i)return[];t.push(...await Promise.all(r.map(async s=>{let l;try{l=await i.provider.providePortAttributes({port:s,pid:o,commandLine:m},h)}catch{l=await i.provider.providePortAttributes(s,o,m,h)}return{providedAttributes:l,port:s}})))}const n=t.filter(a=>!!a.providedAttributes);return n.length>0?n.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(m,h)=>await c.provideTunnel(m,h,new C.$Xd().token)??void 0;const o=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,d.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,r){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const o=c.tunnelFactory??(r?this.w(r):void 0);if(o){this.b=o;let m=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&m.length===0&&(m=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const h=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:m}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,d.$Qc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,r){if(this.g.has(c.host)){const o=this.g.get(c.host);o.has(c.port)&&(r&&o.get(c.port).disposeListener.dispose(),await o.get(c.port).tunnel.dispose(),o.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(c,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const m=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),m===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const h=this.B(m.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(m.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:m,disposeListener:h}),k.fromApiTunnel(m)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(c){const r=await Promise.all(c.map(m=>this.f(m.host,m.port,m.detail??""))),o=c.filter((m,h)=>r[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(m=>m.port).join(", ")} to ${o.map(m=>m.port).join(", ")}`),o}};e.$3vb=p,e.$3vb=p=He([Be(0,I.$dM),Be(1,R.$tM),Be(2,$.$9i)],p)}),define(De[332],Ce([1,0,3,18,2,6]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;class A{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(L.$cK.MainThreadUriOpeners)}registerExternalUriOpener(E,v,R,I){if(this.c.has(v))throw new Error(`Opener with id '${v}' already registered`);const w=I.schemes.find(y=>!A.a.has(y));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this.c.set(v,R),this.b.$registerUriOpener(v,I.schemes,E,I.label),(0,C.$Qc)(()=>{this.c.delete(v),this.b.$unregisterUriOpener(v)})}async $canOpenUri(E,v,R){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener with id: ${E}`);const w=d.URI.revive(v);return I.canOpenExternalUri(w,R)}async $openUri(E,v,R){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener id: '${E}'`);return I.openExternalUri(d.URI.revive(v.resolvedUri),{sourceUri:d.URI.revive(v.sourceUri)},R)}}e.$Edc=A}),define(De[333],Ce([1,0,6,2,3,8,25]),function($e,e,C,T,d,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;class ${static{this.a=0}constructor(v){this.c=new A.$5l,this.d=new Map,this.b=v.getProxy(C.$cK.MainThreadUrls)}registerUriHandler(v,R){const I=v.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const w=$.a++;return this.c.add(I),this.d.set(w,R),this.b.$registerUriHandler(w,I,v.displayName||v.name),(0,d.$Qc)(()=>{this.c.delete(I),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(v,R){const I=this.d.get(v);if(!I)return Promise.resolve(void 0);try{I.handleUri(T.URI.revive(R))}catch(w){(0,L.$1)(w)}return Promise.resolve(void 0)}async createAppUri(v){return T.URI.revive(await this.b.$createAppUri(v))}}e.$Ucc=$}),define(De[91],Ce([1,0,4,3,18,24,2,228,265,110,6]),function($e,e,C,T,d,L,A,$,E,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=e.$Ycc=e.$Xcc=e.$Wcc=e.$Vcc=void 0;class I{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(m,h,t,n,a,i,s){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new C.$Nd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$Nd,this._onDidDispose=this.#h.event,this.#e=m,this.#t=h,this.#r=t,this.#l=n,this.#u=a,this.#n=i,this.#c=w(i),this.#d=y(i),this.#i=s}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return this.#a=!0,(0,v.$5ob)(m,this.#l)}get cspSource(){const m=this.#n.extensionLocation;if(m.scheme===d.Schemas.https||m.scheme===d.Schemas.http){let h=m.toString();return h.endsWith("/")||(h+="/"),h+" "+v.$4ob}return v.$4ob}get html(){return this.a(),this.#s}set html(m){this.a(),this.#s!==m&&(this.#s=m,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(m)))}get options(){return this.a(),this.#r}set options(m){this.a(),L.$8m(this.#r,m)||this.#t.$setOptions(this.#e,u(this.#n,this.#u,m)),this.#r=m}async postMessage(m){if(this.#o)return!1;const h=(0,E.$vcb)(m,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(m){if(!this.#d)return m;const h=this.#n.extensionLocation?.scheme===d.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===d.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return m.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,a,i,s,l,D)=>{const S=A.URI.from({scheme:s||"file",path:decodeURIComponent(l)}),b=(0,v.$5ob)(S,{isRemote:h,authority:t}).toString();return`${a}${b}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,a,i,s,l,D)=>{const S=A.URI.from({scheme:s||"file",path:decodeURIComponent(l)}),b=(0,v.$5ob)(S,{isRemote:h,authority:t}).toString();return`${a}${b}${D}`})}}e.$Vcc=I;function w(o){try{const m=(0,$.$Lo)((0,$.$Ko)(o.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.$Wcc=w;function y(o){try{const m=(0,$.$Lo)((0,$.$Ko)(o.engines.vscode));return m?m.majorBase<1||m.majorBase===1&&m.minorBase<60:!1}catch{return!1}}class k extends T.$Sc{constructor(m,h,t,n,a){super(),this.c=h,this.f=t,this.g=n,this.h=a,this.b=new Map,this.a=m.getProxy(R.$cK.MainThreadWebviews)}dispose(){super.dispose();for(const m of this.b.values())m.dispose();this.b.clear()}$onMessage(m,h,t){const n=this.j(m);if(n){const{message:a}=(0,E.$wcb)(h,t.value);n._onMessageEmitter.fire(a)}}$onMissingCsp(m,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,h,t){const n=new I(m,this.a,c(h),this.c,this.f,t,this.h);this.b.set(m,n);const a=n._onDidDispose(()=>{a.dispose(),this.deleteWebview(m)});return n}deleteWebview(m){this.b.delete(m)}j(m){return this.b.get(m)}}e.$Xcc=k;function p(o){return{id:o.identifier,location:o.extensionLocation}}e.$Ycc=p;function u(o,m,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||r(o,m)}}e.$Zcc=u;function c(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(m=>A.URI.from(m))}}function r(o,m){return[...(m?.getWorkspaceFolders()||[]).map(h=>h.uri),o.extensionLocation]}}),define(De[334],Ce([1,0,21,52,3,18,23,2,13,91,107,6,7]),function($e,e,C,T,d,L,A,$,E,v,R,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;class y{constructor(n,a){this.document=n,this.b=a,this.a=1,this.c=new R.$Rbc("custom documents")}addEdit(n){return this.c.add([n])}async undo(n,a){await this.f(n).undo(),a||this.disposeBackup()}async redo(n,a){await this.f(n).redo(),a||this.disposeBackup()}disposeEdits(n){for(const a of n)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const n=h(this.document.uri)+this.a++;return(0,A.$vg)(this.b,n)}updateBackup(n){this.d?.delete(),this.d=n}disposeBackup(){this.d?.delete(),this.d=void 0}f(n){const a=this.c.get(n,0);if(!a)throw new Error("No edit found");return a}}class k{constructor(){this.a=new Map}get(n,a){return this.a.get(this.b(n,a))}add(n,a,i){const s=this.b(n,a.uri);if(this.a.has(s))throw new Error(`Document already exists for viewType:${n} resource:${a.uri}`);const l=new y(a,i);return this.a.set(s,l),l}delete(n,a){const i=this.b(n,a.uri);this.a.delete(i)}b(n,a){return`${n}@@@${a}`}}var p;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(p||(p={}));class u{constructor(){this.a=new Map}addTextProvider(n,a,i){return this.b(0,n,a,i)}addCustomProvider(n,a,i){return this.b(1,n,a,i)}get(n){return this.a.get(n)}b(n,a,i,s){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:n,extension:i,provider:s}),new w.$eK(()=>this.a.delete(a))}}class c{constructor(n,a,i,s,l){this.d=a,this.f=i,this.g=s,this.h=l,this.b=new u,this.c=new k,this.a=n.getProxy(I.$cK.MainThreadCustomEditors)}registerCustomEditorProvider(n,a,i,s){const l=new d.$Rc;return o(i)?(l.add(this.b.addTextProvider(a,n,i)),this.a.$registerTextEditorProvider((0,v.$Ycc)(n),a,s.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,v.$Wcc)(n))):(l.add(this.b.addCustomProvider(a,n,i)),r(i)&&l.add(i.onDidChangeCustomDocument(D=>{const S=this.i(a,D.document.uri);if(m(D)){const b=S.addEdit(D);this.a.$onDidEdit(D.document.uri,a,b,D.label)}else this.a.$onContentChange(D.document.uri,a)})),this.a.$registerCustomEditorProvider((0,v.$Ycc)(n),a,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,v.$Wcc)(n))),w.$eK.from(l,new w.$eK(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(n,a,i,s,l){const D=this.b.get(a);if(!D)throw new Error(`No provider found for '${a}'`);if(D.type!==1)throw new Error(`Invalid provide type for '${a}'`);const S=$.URI.revive(n),b=await D.provider.openCustomDocument(S,{backupId:i,untitledDocumentData:s?.buffer},l);let f;return r(D.provider)&&this.f&&(f=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(a,b,f),{editable:r(D.provider)}}async $disposeCustomDocument(n,a){const i=this.b.get(a);if(!i)throw new Error(`No provider found for '${a}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${a}'`);const s=$.URI.revive(n),{document:l}=this.i(a,s);this.c.delete(a,l),l.dispose()}async $resolveCustomEditor(n,a,i,s,l,D){const S=this.b.get(i);if(!S)throw new Error(`No provider found for '${i}'`);const b=E.ViewColumn.to(l),f=this.g.createNewWebview(a,s.contentOptions,S.extension),g=this.h.createNewWebviewPanel(a,i,s.title,b,s.options,f,s.active),P=$.URI.revive(n);switch(S.type){case 1:{const{document:N}=this.i(i,P);return S.provider.resolveCustomEditor(N,g,D)}case 0:{const N=this.d.getDocument(P);return S.provider.resolveCustomTextEditor(N,g,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,a,i){this.i(a,n).disposeEdits(i)}async $onMoveCustomEditor(n,a,i){const s=this.b.get(i);if(!s)throw new Error(`No provider found for '${i}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const l=this.h.getWebviewPanel(n);if(!l)throw new Error("No webview found");const D=$.URI.revive(a),S=this.d.getDocument(D);await s.provider.moveCustomTextEditor(S,l,C.CancellationToken.None)}async $undo(n,a,i,s){return this.i(a,n).undo(i,s)}async $redo(n,a,i,s){return this.i(a,n).redo(i,s)}async $revert(n,a,i){const s=this.i(a,n);await this.j(a).revertCustomDocument(s.document,i),s.disposeBackup()}async $onSave(n,a,i){const s=this.i(a,n);await this.j(a).saveCustomDocument(s.document,i),s.disposeBackup()}async $onSaveAs(n,a,i,s){const l=this.i(a,n);return this.j(a).saveCustomDocumentAs(l.document,$.URI.revive(i),s)}async $backup(n,a,i){const s=this.i(a,n),D=await this.j(a).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},i);return s.updateBackup(D),D.id}i(n,a){const i=this.c.get(n,$.URI.revive(a));if(!i)throw new Error("No custom document found");return i}j(n){const i=this.b.get(n)?.provider;if(!i||!r(i))throw new Error("Custom document is not editable");return i}}e.$ydc=c;function r(t){return!!t.onDidChangeCustomDocument}function o(t){return typeof t.resolveCustomTextEditor=="function"}function m(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const n=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,T.$Ci)(n)+""}}),define(De[335],Ce([1,0,4,3,2,31,13,91,6,7]),function($e,e,C,T,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;class R extends T.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(k,p,u,c){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new C.$Nd),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$Nd),this.onDidChangeViewState=this.#h.event,this.#e=k,this.#t=p,this.#l=u,this.#i=c.viewType,this.#u=c.panelOptions,this.#r=c.viewColumn,this.#n=c.title,this.#a=c.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(k){this.c(),this.#n!==k&&(this.#n=k,this.#t.$setTitle(this.#e,k))}get iconPath(){return this.c(),this.#s}set iconPath(k){this.c(),this.#s!==k&&(this.#s=k,this.#t.$setIconPath(this.#e,d.URI.isUri(k)?{light:k,dark:k}:k))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(k){this.#c||(this.active!==k.active||this.visible!==k.visible||this.viewColumn!==k.viewColumn)&&(this.#a=k.active,this.#o=k.visible,this.#r=k.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(k,p){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof k>"u"?void 0:A.ViewColumn.from(k),preserveFocus:!!p})}c(){if(this.#c)throw new Error("Webview is disposed")}}class I extends T.$Sc{static c(){return(0,L.$eg)()}constructor(k,p,u){super(),this.j=p,this.m=u,this.g=new Map,this.h=new Map,this.f=k.getProxy(E.$cK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(k=>k.dispose()),this.g.clear()}createWebviewPanel(k,p,u,c,r={}){const o=typeof c=="object"?c.viewColumn:c,m={viewColumn:A.ViewColumn.from(o),preserveFocus:typeof c=="object"&&!!c.preserveFocus},h=(0,$.$Wcc)(k),t=I.c();this.f.$createWebviewPanel((0,$.$Ycc)(k),t,p,{title:u,panelOptions:w(r),webviewOptions:(0,$.$Zcc)(k,this.m,r),serializeBuffersForPostMessage:h},m);const n=this.j.createNewWebview(t,r,k);return this.createNewWebviewPanel(t,p,u,o,r,n,!0)}$onDidChangeWebviewPanelViewStates(k){const p=Object.keys(k);p.sort((u,c)=>{const r=k[u],o=k[c];return r.active?1:o.active?-1:+r.visible-+o.visible});for(const u of p){const c=this.getWebviewPanel(u);if(!c)continue;const r=k[u];c._updateViewState({active:r.active,visible:r.visible,viewColumn:A.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(k){this.getWebviewPanel(k)?.dispose(),this.g.delete(k),this.j.deleteWebview(k)}registerWebviewPanelSerializer(k,p,u){if(this.h.has(p))throw new Error(`Serializer for '${p}' already registered`);return this.h.set(p,{serializer:u,extension:k}),this.f.$registerSerializer(p,{serializeBuffersForPostMessage:(0,$.$Wcc)(k)}),new v.$eK(()=>{this.h.delete(p),this.f.$unregisterSerializer(p)})}async $deserializeWebviewPanel(k,p,u,c){const r=this.h.get(p);if(!r)throw new Error(`No serializer found for '${p}'`);const{serializer:o,extension:m}=r,h=this.j.createNewWebview(k,u.webviewOptions,m),t=this.createNewWebviewPanel(k,p,u.title,c,u.panelOptions,h,u.active);await o.deserializeWebviewPanel(t,u.state)}createNewWebviewPanel(k,p,u,c,r,o,m){const h=new R(k,this.f,o,{viewType:p,title:u,viewColumn:c,panelOptions:r,active:m});return this.g.set(k,h),h}getWebviewPanel(k){return this.g.get(k)}}e.$xdc=I;function w(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(De[336],Ce([1,0,4,3,91,13,6,7]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class E extends T.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(I,w,y,k,p,u){super(),this.#u=!1,this.#a=this.B(new C.$Nd),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new C.$Nd),this.onDidDispose=this.#c.event,this.#i=y,this.#s=k,this.#e=I,this.#t=w,this.#l=p,this.#n=u}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#r}set description(I){this.a(),this.#r!==I&&(this.#r=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#u||(this.#n=I,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(I){this.a(),!(I?.value===this.#o?.value&&I?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#u)throw new Error("Webview is disposed")}}class v{constructor(I,w){this.d=w,this.b=new Map,this.c=new Map,this.a=I.getProxy(A.$cK.MainThreadWebviewViews)}registerWebviewViewProvider(I,w,y,k){if(this.b.has(w))throw new Error(`View provider for '${w}' already registered`);return this.b.set(w,{provider:y,extension:I}),this.a.$registerWebviewViewProvider((0,d.$Ycc)(I),w,{retainContextWhenHidden:k?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,d.$Wcc)(I)}),new $.$eK(()=>{this.b.delete(w),this.a.$unregisterWebviewViewProvider(w)})}async $resolveWebviewView(I,w,y,k,p){const u=this.b.get(w);if(!u)throw new Error(`No view provider found for '${w}'`);const{provider:c,extension:r}=u,o=this.d.createNewWebview(I,{},r),m=new E(I,this.a,w,y,o,!0);this.c.set(I,m),await c.resolveWebviewView(m,{state:k},p)}async $onDidChangeWebviewViewVisibility(I,w){this.e(I)._setVisible(w)}async $disposeWebviewView(I){const w=this.e(I);this.c.delete(I),w.dispose(),this.d.deleteWebview(I)}e(I){const w=this.c.get(I);if(!w)throw new Error("No webview found");return w}}e.$wdc=v}),define(De[151],Ce([1,0,4,6,2,18,15,5,20,26]),function($e,e,C,T,d,L,A,$,E,v){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=e.$1cc=void 0;let I=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(y){const k=this.d;return{get focused(){return k.focused},get active(){return(0,v.$aF)(y,"windowActivity"),k.active}}}constructor(y){this.c=new C.$Nd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=y.getProxy(T.$cK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:p})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",p)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,k){k!==this.d[y]&&(this.d={...this.d,[y]:k},this.c.fire(this.d))}openUri(y,k){let p;if(typeof y=="string"){p=y;try{y=d.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,A.$Be)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this.b.$openUri(y,p,k)}async asExternalUri(y,k){if((0,A.$Be)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this.b.$asExternalUri(y,k);return d.URI.from(p)}};e.$1cc=I,e.$1cc=I=R=He([Be(0,E.$dM)],I),e.$2cc=(0,$.$Oh)("IExtHostWindow")}),define(De[337],Ce([1,0,304,27,20]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0;const L=1024*1024;let A=class extends C.$2dc{constructor(E,v){super(E,v),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,v,R){const I=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),v.apply(console,R),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,v){const R=process[E],I=R.write;let w="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(y,k,p)=>{if(!this.g){w+=y.toString(k);const u=w.length>L?w.length:w.lastIndexOf(`
`);u!==-1&&(console[v](w.slice(0,u)),w=w.slice(u+1))}I.call(R,y,k,p)}})}};e.$Aec=A,e.$Aec=A=He([Be(0,d.$dM),Be(1,T.$tM)],A)}),define(De[338],Ce([1,0,72,18,14,240,30,12]),function($e,e,C,T,d,L,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=void 0;let E=class{constructor(I,w){I.addFileSystemProvider(T.Schemas.file,new v(w),{isCaseSensitive:$.$l})}};e.$Bec=E,e.$Bec=E=He([Be(0,C.$ncc),Be(1,d.$9i)],E);class v{constructor(I){this.b=I,this.a=new L.$$p(this.b)}async stat(I){const w=await this.a.stat(I);return{type:w.type,ctime:w.ctime,mtime:w.mtime,size:w.size,permissions:w.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,w,y){return this.a.writeFile(I,w,{...y,unlock:!1,atomic:!1})}delete(I,w){return this.a.delete(I,{...w,useTrash:!1,atomic:!1})}rename(I,w,y){return this.a.rename(I,w,y)}copy(I,w,y){return this.a.copy(I,w,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,w){throw new Error("Method not implemented.")}}}),define(De[339],Ce([1,0,16,63,31,33,3,6,2,20]),function($e,e,C,T,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;let R=class extends A.$Sc{constructor(w,y){super();const k=w.getProxy($.$cK.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async p=>{const u=E.URI.file((0,C.$jc)((0,T.tmpdir)(),(0,d.$eg)()));return await k.$download(p,u),u})}};e.$zec=R,e.$zec=R=He([Be(0,v.$dM),Be(1,L.$zM)],R)}),define(De[340],Ce([1,0,150,18,242,31]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=void 0;class A extends C.$1dc{s(E,v,R){return E.scheme===T.Schemas.file?new d.$pN(R?.name||(0,L.$eg)(),E.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,v):super.s(E,v,R)}registerLogger(E){super.registerLogger(E),this.r.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.r.$deregisterLogger(E)}}e.$Mec=A}),define(De[341],Ce([1,0,53,16,2,90,3,18,9,29]),function($e,e,C,T,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;class R extends L.$pcc{constructor(){super(...arguments),this.i=null}async g(t){const n=await super.g(t);if(n.scheme!==$.Schemas.file)return n;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${n.fsPath}.`),n;const a=n.fsPath;let i=0;do{let s;i===0?s=a:s=/[/\\]$/.test(a)?`${a.substr(0,a.length-1)}-${i}`:`${a}-${i}`,await I(s);const l=T.$jc(s,"vscode.lock"),D=await p(this.d,l,!1);if(D)return this.i=D,process.on("exit",()=>{D.dispose()}),d.URI.file(s);i++}while(i<10);return n}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Lec=R;async function I(h){try{await v.Promises.stat(h);return}catch{}try{await v.Promises.mkdir(h,{recursive:!0})}catch{}}const w=1e3,y=10*60*1e3;class k extends A.$Sc{constructor(t,n){super(),this.b=t,this.c=n,this.a=this.B(new E.$5g),this.a.cancelAndSet(async()=>{const a=await u(t,n);(!a||a.pid!==process.pid)&&(t.info(`Lock '${n}': The lock was lost unexpectedly.`),this.a.cancel());try{await v.Promises.utimes(n,new Date,new Date)}catch(i){t.error(i),t.info(`Lock '${n}': Could not update mtime.`)}},w)}dispose(){super.dispose();try{C.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const n={pid:process.pid,willReleaseAt:Date.now()+t};await v.Promises.writeFile(this.c,JSON.stringify(n),{flag:"w"})}catch(n){this.b.error(n)}}}async function p(h,t,n){try{const i={pid:process.pid,willReleaseAt:0};await v.Promises.writeFile(t,JSON.stringify(i),{flag:"wx"})}catch(i){h.error(i)}const a=await u(h,t);return!a||a.pid!==process.pid?n?(h.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(h.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),o(h,t)):(h.info(`Lock '${t}': Lock acquired.`),new k(h,t))}async function u(h,t){let n;try{n=await v.Promises.readFile(t)}catch(a){return h.error(a),null}try{return JSON.parse(String(n))}catch(a){return h.error(a),null}}async function c(h,t){let n;try{n=await v.Promises.stat(t)}catch(a){return h.error(a),0}return n.mtime.getTime()}function r(h){try{return process.kill(h,0),!0}catch{return!1}}async function o(h,t){const n=await u(h,t);if(!n)return h.info(`Lock '${t}': Could not read pid of lock holder.`),m(h,t);if(n.willReleaseAt){let D=n.willReleaseAt-Date.now();if(D<5e3){for(D>0?h.info(`Lock '${t}': The lockfile is scheduled to be released in ${D} ms.`):h.info(`Lock '${t}': The lockfile is scheduled to have been released.`);D>0;){if(await(0,E.$Ug)(Math.min(100,D)),await c(h,t)===0)return m(h,t);D=n.willReleaseAt-Date.now()}return m(h,t)}}if(!r(n.pid))return h.info(`Lock '${t}': The pid ${n.pid} appears to be gone.`),m(h,t);const a=await c(h,t),i=Date.now()-a;if(i<=y)return h.info(`Lock '${t}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;h.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,E.$Ug)(2e3);const s=await c(h,t),l=Date.now()-s;return l<=y?(h.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(h.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),m(h,t))}async function m(h,t){h.info(`Lock '${t}': Deleting a stale lock.`);try{await v.Promises.unlink(t)}catch{}return p(h,t,!0)}}),define(De[342],Ce([1,0,31,20,45,33]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0;let A=class extends d.$scc{constructor(E,v){super(!0,E,v)}createTerminal(E,v,R){return this.createTerminalFromOptions({name:E,shellPath:v,shellArgs:R})}createTerminalFromOptions(E,v){const R=new d.$rcc(this.a,(0,C.$eg)(),E,E.name);return this.f.push(R),R.create(E,this.R(E,v)),R.value}};e.$7dc=A,e.$7dc=A=He([Be(0,L.$zM),Be(1,T.$dM)],A)}),define(De[343],Ce([1,0,9,22,21,8,4,3,128,292,69]),function($e,e,C,T,d,L,A,$,E,v,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$n4b=e.ResponsiveState=e.RequestInitiator=e.$m4b=e.$l4b=void 0;function w(g,P){try{return JSON.stringify(g,P)}catch{return"null"}}const y="$$ref$$",k={[y]:-1};class p{constructor(P,N){this.jsonString=P,this.referencedBuffers=N}}function u(g,P=null,N=!1){const O=[];return{jsonString:(N?w:JSON.stringify)(g,(j,z)=>{if(typeof z>"u")return k;if(typeof z=="object"){if(z instanceof T.$be){const F=O.push(z)-1;return{[y]:F}}if(P)return P(j,z)}return z}),referencedBuffers:O}}e.$l4b=u;function c(g,P,N){return JSON.parse(g,(O,M)=>{if(M){const j=M[y];if(typeof j=="number")return P[j];if(N&&M.$mid===1)return N.transformIncoming(M)}return M})}e.$m4b=c;function r(g,P){return JSON.stringify(g,P)}function o(g){return g?(P,N)=>N&&N.$mid===1?g.transformOutgoing(N):N:null}var m;(function(g){g[g.LocalSide=0]="LocalSide",g[g.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));var h;(function(g){g[g.Responsive=0]="Responsive",g[g.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},n=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class i extends $.$Sc{static{I=n}static{this.a=3*1e3}constructor(P,N=null,O=null){super(),this[I]=!0,this.b=this.B(new A.$Nd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=N,this.g=O,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,j=R.$jv.count;M<j;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$6g(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const N=this.w[P];delete this.w[P],N.resolveErr(L.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+i.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+i.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,E.$Mm)(P,this.g):P}getProxy(P){const{nid:N,sid:O}=P;return this.s[N]||(this.s[N]=this.J(N,O)),this.s[N]}J(P,N){const O={get:(M,j)=>(typeof j=="string"&&!M[j]&&j.charCodeAt(0)===36&&(M[j]=(...z)=>this.U(P,j,z)),j===a?N:M[j])};return new Proxy(Object.create(null),O)}set(P,N){return this.m[P.nid]=N,N}assertRegistered(P){for(let N=0,O=P.length;N<O;N++){const M=P[N];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(P){if(this.j)return;const N=P.byteLength,O=l.read(P,0),M=O.readUInt8(),j=O.readUInt32();switch(M){case 1:case 2:{let{rpcId:z,method:F,args:K}=S.deserializeRequestJSONArgs(O);this.g&&(K=(0,E.$Mm)(K,this.g)),this.M(N,j,z,F,K,M===2);break}case 3:case 4:{let{rpcId:z,method:F,args:K}=S.deserializeRequestMixedArgs(O);this.g&&(K=(0,E.$Mm)(K,this.g)),this.M(N,j,z,F,K,M===4);break}case 5:{this.f?.logIncoming(N,j,0,"ack"),this.G(j);break}case 6:{this.N(N,j);break}case 7:{this.O(N,j,void 0);break}case 9:{let z=S.deserializeReplyOKJSON(O);this.g&&(z=(0,E.$Mm)(z,this.g)),this.O(N,j,z);break}case 10:{const z=S.deserializeReplyOKJSONWithBuffers(O,this.g);this.O(N,j,z);break}case 8:{const z=S.deserializeReplyOKVSBuffer(O);this.O(N,j,z);break}case 11:{let z=S.deserializeReplyErrError(O);this.g&&(z=(0,E.$Mm)(z,this.g)),this.P(N,j,z);break}case 12:{this.P(N,j,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,N,O,M,j,z){this.f?.logIncoming(P,N,1,`receiveRequest ${(0,R.$lv)(O)}.${M}(`,j);const F=String(N);let K,V;if(z){const Z=new d.$Xd;j.push(Z.token),K=this.Q(O,M,j),V=()=>Z.cancel()}else K=this.Q(O,M,j),V=t;this.u[F]=V;const fe=S.serializeAcknowledged(N);this.f?.logOutgoing(fe.byteLength,N,1,"ack"),this.c.send(fe),K.then(Z=>{delete this.u[F];const Q=S.serializeReplyOK(N,Z,this.h);this.f?.logOutgoing(Q.byteLength,N,1,"reply:",Z),this.c.send(Q)},Z=>{delete this.u[F];const Q=S.serializeReplyErr(N,Z);this.f?.logOutgoing(Q.byteLength,N,1,"replyErr:",Z),this.c.send(Q)})}N(P,N){this.f?.logIncoming(P,N,1,"receiveCancel");const O=String(N);this.u[O]?.()}O(P,N,O){this.f?.logIncoming(P,N,0,"receiveReply:",O);const M=String(N);if(!this.w.hasOwnProperty(M))return;const j=this.w[M];delete this.w[M],j.resolveOk(O)}P(P,N,O){this.f?.logIncoming(P,N,0,"receiveReplyErr:",O);const M=String(N);if(!this.w.hasOwnProperty(M))return;const j=this.w[M];delete this.w[M];let z;O&&(O.$isError?(z=new Error,z.name=O.name,z.message=O.message,z.stack=O.stack):z=O),j.resolveErr(z)}Q(P,N,O){try{return Promise.resolve(this.S(P,N,O))}catch(M){return Promise.reject(M)}}S(P,N,O){const M=this.m[P];if(!M)throw new Error("Unknown actor "+(0,R.$lv)(P));const j=M[N];if(typeof j!="function")throw new Error("Unknown method "+N+" on actor "+(0,R.$lv)(P));return j.apply(M,O)}U(P,N,O){if(this.j)return new v.$k4b;let M=null;if(O.length>0&&d.CancellationToken.isCancellationToken(O[O.length-1])&&(M=O.pop()),M&&M.isCancellationRequested)return Promise.reject(L.$6());const j=S.serializeRequestArguments(O,this.h),z=++this.t,F=String(z),K=new v.$j4b,V=new $.$Rc;M&&V.add(M.onCancellationRequested(()=>{const Z=S.serializeCancel(z);this.f?.logOutgoing(Z.byteLength,z,0,"cancel"),this.c.send(S.serializeCancel(z))})),this.w[F]=new s(K,V),this.F(z);const fe=S.serializeRequest(z,P,N,j,!!M);return this.f?.logOutgoing(fe.byteLength,z,0,`request: ${(0,R.$lv)(P)}.${N}(`,O),this.c.send(fe),K}}e.$n4b=i;class s{constructor(P,N){this.a=P,this.b=N}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class l{static alloc(P,N,O){const M=new l(T.$be.alloc(O+1+4),0);return M.writeUInt8(P),M.writeUInt32(N),M}static read(P,N){return new l(P,N)}get buffer(){return this.a}constructor(P,N){this.a=P,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const O=this.a.slice(this.b,this.b+P).toString();return this.b+=P,O}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+P).toString();return this.b+=P,O}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+P);return this.b+=P,N}static sizeMixedArray(P){let N=0;N+=1;for(let O=0,M=P.length;O<M;O++){const j=P[O];switch(N+=1,j.type){case 1:N+=this.sizeLongString(j.value);break;case 2:N+=this.sizeVSBuffer(j.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(j.value);for(let z=0;z<j.buffers.length;++z)N+=this.sizeVSBuffer(j.buffers[z]);break;case 4:break}}return N}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let N=0,O=P.length;N<O;N++){const M=P[N];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let j=0;j<M.buffers.length;++j)this.writeBuffer(M.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const N=new Array(P);for(let O=0;O<P;O++)switch(this.readUInt8()){case 1:N[O]=this.readLongString();break;case 2:N[O]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),z=this.readLongString(),F=[];for(let K=0;K<j;++K)F.push(this.readVSBuffer());N[O]=new R.$mv(c(z,F,null));break}case 4:N[O]=void 0;break}return N}}var D;(function(g){g[g.Simple=0]="Simple",g[g.Mixed=1]="Mixed"})(D||(D={}));class S{static a(P){for(let N=0,O=P.length;N<O;N++)if(P[N]instanceof T.$be||P[N]instanceof R.$mv||typeof P[N]>"u")return!0;return!1}static serializeRequestArguments(P,N){if(this.a(P)){const O=[];for(let M=0,j=P.length;M<j;M++){const z=P[M];if(z instanceof T.$be)O[M]={type:2,value:z};else if(typeof z>"u")O[M]={type:4};else if(z instanceof R.$mv){const{jsonString:F,referencedBuffers:K}=u(z.value,N);O[M]={type:3,value:T.$be.fromString(F),buffers:K}}else O[M]={type:1,value:T.$be.fromString(r(z,N))}}return{type:1,args:O}}return{type:0,args:r(P,N)}}static serializeRequest(P,N,O,M,j){switch(M.type){case 0:return this.b(P,N,O,M.args,j);case 1:return this.c(P,N,O,M.args,j)}}static b(P,N,O,M,j){const z=T.$be.fromString(O),F=T.$be.fromString(M);let K=0;K+=l.sizeUInt8(),K+=l.sizeShortString(z),K+=l.sizeLongString(F);const V=l.alloc(j?2:1,P,K);return V.writeUInt8(N),V.writeShortString(z),V.writeLongString(F),V.buffer}static deserializeRequestJSONArgs(P){const N=P.readUInt8(),O=P.readShortString(),M=P.readLongString();return{rpcId:N,method:O,args:JSON.parse(M)}}static c(P,N,O,M,j){const z=T.$be.fromString(O);let F=0;F+=l.sizeUInt8(),F+=l.sizeShortString(z),F+=l.sizeMixedArray(M);const K=l.alloc(j?4:3,P,F);return K.writeUInt8(N),K.writeShortString(z),K.writeMixedArray(M),K.buffer}static deserializeRequestMixedArgs(P){const N=P.readUInt8(),O=P.readShortString(),M=P.readMixedArray(),j=new Array(M.length);for(let z=0,F=M.length;z<F;z++){const K=M[z];typeof K=="string"?j[z]=JSON.parse(K):j[z]=K}return{rpcId:N,method:O,args:j}}static serializeAcknowledged(P){return l.alloc(5,P,0).buffer}static serializeCancel(P){return l.alloc(6,P,0).buffer}static serializeReplyOK(P,N,O){if(typeof N>"u")return this.d(P);if(N instanceof T.$be)return this.e(P,N);if(N instanceof R.$mv){const{jsonString:M,referencedBuffers:j}=u(N.value,O,!0);return this.g(P,M,j)}else return this.f(P,w(N,O))}static d(P){return l.alloc(7,P,0).buffer}static e(P,N){let O=0;O+=l.sizeVSBuffer(N);const M=l.alloc(8,P,O);return M.writeVSBuffer(N),M.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,N){const O=T.$be.fromString(N);let M=0;M+=l.sizeLongString(O);const j=l.alloc(9,P,M);return j.writeLongString(O),j.buffer}static g(P,N,O){const M=T.$be.fromString(N);let j=0;j+=l.sizeUInt32,j+=l.sizeLongString(M);for(const F of O)j+=l.sizeVSBuffer(F);const z=l.alloc(10,P,j);z.writeUInt32(O.length),z.writeLongString(M);for(const F of O)z.writeBuffer(F);return z.buffer}static deserializeReplyOKJSON(P){const N=P.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(P,N){const O=P.readUInt32(),M=P.readLongString(),j=[];for(let z=0;z<O;++z)j.push(P.readVSBuffer());return new R.$mv(c(M,j,N))}static serializeReplyErr(P,N){const O=N?w(L.$3(N),null):void 0;if(typeof O!="string")return this.h(P);const M=T.$be.fromString(O);let j=0;j+=l.sizeLongString(M);const z=l.alloc(11,P,j);return z.writeLongString(M),z.buffer}static deserializeReplyErrError(P){const N=P.readLongString();return JSON.parse(N)}static h(P){return l.alloc(12,P,0).buffer}}var b;(function(g){g[g.RequestJSONArgs=1]="RequestJSONArgs",g[g.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",g[g.RequestMixedArgs=3]="RequestMixedArgs",g[g.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",g[g.Acknowledged=5]="Acknowledged",g[g.Cancel=6]="Cancel",g[g.ReplyOKEmpty=7]="ReplyOKEmpty",g[g.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",g[g.ReplyOKJSON=9]="ReplyOKJSON",g[g.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",g[g.ReplyErrError=11]="ReplyErrError",g[g.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var f;(function(g){g[g.String=1]="String",g[g.VSBuffer=2]="VSBuffer",g[g.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",g[g.Undefined=4]="Undefined"})(f||(f={}))}),define(De[344],Ce([1,0,4,43,42,5]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yJ=e.$xJ=e.OutputChannelUpdateMode=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=void 0,e.$nJ="text/x-code-output",e.$oJ="output",e.$pJ="Log",e.$qJ="text/x-code-log-output",e.$rJ="log",e.$sJ="workbench.panel.output",e.$tJ=new d.$6i("inOutput",!1),e.$uJ=new d.$6i("activeLogOutput",!1),e.$vJ=new d.$6i("outputView.scrollLock",!1),e.$wJ=(0,L.$Oh)("outputService");var A;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$xJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new C.$Nd,this.onDidRegisterChannel=this.b.event,this.c=new C.$Nd,this.onDidRemoveChannel=this.c.event}registerChannel(v){this.a.has(v.id)||(this.a.set(v.id,v),this.b.fire(v.id))}getChannels(){const v=[];return this.a.forEach(R=>v.push(R)),v}getChannel(v){return this.a.get(v)}removeChannel(v){this.a.delete(v),this.c.fire(v)}}T.$dn.add(e.$xJ.OutputChannels,new $),e.$yJ=new d.$6i("activeOutputChannel","")}),define(De[152],Ce([1,0,6,5,20,25,14,344,72,27,55,178,22,17,30,4,3]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=e.$Kcc=void 0;class c extends A.$cj{get disposed(){return this.n}constructor(h,t,n,a,i){super(),this.id=h,this.name=t,this.r=n,this.s=a,this.extension=i,this.m=0,this.n=!1,this.visible=!1,this.setLevel(n.getLevel()),this.B(n.onDidChangeLogLevel(s=>this.setLevel(s)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=w.$be.fromString(t).byteLength,(0,A.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends c{appendLine(h){this.append(h)}}let o=class{constructor(h,t,n,a,i,s){this.i=t,this.j=n,this.k=a,this.l=i,this.m=s,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(C.$cK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$cm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,n]of this.g)n.visible=t===this.h}createOutputChannel(h,t,n){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,i=(0,y.$yf)(t)?t:void 0;if((0,y.$yf)(i)&&!i.trim())throw new Error("illegal argument `languageId`. must not be empty");let s;const l=this.i.environment.extensionLogLevel?.find(([S])=>L.$4l.equals(n.identifier,S))?.[1];l&&(s=(0,A.$mj)(l));const D=a?this.o(h,s,n):this.n(h,i,n);return D.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),a?this.r(h,s??this.m.getLevel(),D):this.q(h,D)}async n(h,t,n){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,i=this.k.extUri.joinPath(a,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(i,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),l=await this.a.$register(h,i,t,n.identifier.value);return new c(l,h,s,this.a,n)}async o(h,t,n){const a=await this.p(n),i=h.replace(/[\\/:\*\?"<>\|]/g,""),s=this.k.extUri.joinPath(a,`${i}.log`),l=`${n.identifier.value}.${i}`,D=this.l.createLogger(s,{id:l,name:h,logLevel:t,extensionId:n.identifier.value});return new r(l,h,D,this.a,n)}p(h){let t=this.d.get(h.identifier.value);if(!t){const n=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(n)}catch(a){if((0,k.$nk)(a)!==k.FileSystemProviderErrorCode.FileExists)throw a}return n})())}return t}q(h,t){let n=!1;const a=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return h},append(i){a(),t.then(s=>s.append(i))},appendLine(i){a(),t.then(s=>s.appendLine(i))},clear(){a(),t.then(i=>i.clear())},replace(i){a(),t.then(s=>s.replace(i))},show(i,s){a(),t.then(l=>l.show(i,s))},hide(){a(),t.then(i=>i.hide())},dispose(){n=!0,t.then(i=>i.dispose())}}}r(h,t,n){const a=new u.$Rc,i=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},s=a.add(new p.$Nd);function l(D){t=D,s.fire(D)}return n.then(D=>{a.add(D),D.logLevel!==t&&l(D.logLevel),a.add(D.onDidChangeLogLevel(S=>l(S)))}),{...this.q(h,n),get logLevel(){return t},onDidChangeLogLevel:s.event,trace(D,...S){i(),n.then(b=>b.trace(D,...S))},debug(D,...S){i(),n.then(b=>b.debug(D,...S))},info(D,...S){i(),n.then(b=>b.info(D,...S))},warn(D,...S){i(),n.then(b=>b.warn(D,...S))},error(D,...S){i(),n.then(b=>b.error(D,...S))},dispose(){a.dispose()}}}};e.$Kcc=o,e.$Kcc=o=He([Be(0,d.$dM),Be(1,v.$tM),Be(2,E.$ncc),Be(3,R.$Ubc),Be(4,A.$0i),Be(5,A.$9i)],o),e.$Lcc=(0,T.$Oh)("IExtHostOutputService")}),define(De[345],Ce([1,0,5,9]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=void 0,e.$rm=(0,C.$Oh)("remoteAgentService"),e.$sm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(d){let L=1/0;for(let $=0;$<this.maxSampleCount;$++){const E=await d.getRoundTripTime();if(E===void 0)return;L=Math.min(L,E/2),await(0,T.$Ug)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(L):A=this.initial.reduce(($,E)=>$+E,0)/this.initial.length,this.lastMeasurement={initial:A,current:L,average:this.average.reduce(($,E)=>$+E,0)/this.average.length,high:(()=>typeof A>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(De[346],Ce([1,0,32,18,16,12,23,2,5,258,44,147,345]),function($e,e,C,T,d,L,A,$,E,v,R,I,w){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$RJ=e.$QJ=void 0,e.$QJ=(0,E.$Oh)("pathService");let k=y=class{constructor(u,c,r,o){this.d=u,this.e=c,this.f=r,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const m=await this.e.getEnvironment();return this.c=m?.userHome??u})()}hasValidBasename(u,c,r){return typeof c=="string"||typeof c>"u"?this.a.then(o=>this.h(u,o,c)):this.h(u,c,r)}h(u,c,r){return u.scheme===T.Schemas.file||u.scheme===T.Schemas.vscodeRemote?(0,C.$Vf)(r??(0,A.$sg)(u),c===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(u,c){if(u.remoteAuthority)return T.Schemas.vscodeRemote;const r=(0,v.$NJ)(c.getWorkspace());if(r)return r;const o=c.getWorkspace().folders[0];if(o)return o.uri.scheme;const m=c.getWorkspace().configuration;return m?m.scheme:T.Schemas.file}userHome(u){return u?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(u=>u===1?d.$fc:d.$gc)}async fileURI(u){let c="";if(await this.a===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const o=u.indexOf("/",2);o===-1?(c=u.substring(2),u="/"):(c=u.substring(2,o),u=u.substring(o)||"/")}return $.URI.from({scheme:T.Schemas.file,authority:c,path:u,query:"",fragment:""})}};e.$RJ=k,e.$RJ=k=y=He([Be(1,w.$rm),Be(2,I.$zJ),Be(3,R.$Xh)],k)}),define(De[347],Ce([1,0,225,19,57,4,52,3,2,50,230,14,65,260,86,44,147,26,21,17,24,42]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r,o,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KJ=e.$JJ=e.$IJ=e.OnPortForward=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.TunnelSource=e.TunnelCloseReason=e.$CJ=e.$BJ=e.$AJ=void 0;const t=10*1e3,n="remote.tunnels.toRestore";e.$AJ="onTunnel",e.$BJ=new h.$6i("forwardedPortsViewEnabled",!1,C.localize(0,null));function a(N){const O=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(O)return{host:O[1]?.substring(0,O[1].length-1)||"localhost",port:Number(O[2])}}e.$CJ=a;var i;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(i||(e.TunnelCloseReason=i={}));var s;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(s||(e.TunnelSource=s={})),e.$DJ={source:s.User,description:C.localize(1,null)},e.$EJ={source:s.Auto,description:C.localize(2,null)};function l(N,O,M){const j=N.get(S(O,M));if(j)return j;if((0,k.$$u)(O))for(const z of k.$0u){const F=S(z,M);if(N.has(F))return N.get(F)}else if((0,k.$av)(O))for(const z of k.$_u){const F=S(z,M);if(N.has(F))return N.get(F)}}e.$FJ=l;function D(N,O,M){const j=l(N,O,M);if(j)return j;const z=(0,k.$av)(O)?"localhost":(0,k.$$u)(O)?"0.0.0.0":void 0;if(z)return l(N,z,M)}e.$GJ=D;function S(N,O){return N+":"+O}e.$HJ=S;var b;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(b||(e.OnPortForward=b={}));function f(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}e.$IJ=f;class g extends $.$Sc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(O){super(),this.r=O,this.j=[],this.n=new L.$Nd,this.onDidChangeAttributes=this.n.event,this.B(O.onDidChangeConfiguration(M=>{(M.affectsConfiguration(g.c)||M.affectsConfiguration(g.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(O,M,j){let z=this.w(O,M,j,this.j,0);const F={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;z>=0;){const K=this.j[z];K.key===O?(F.onAutoForward=K.onAutoForward??F.onAutoForward,F.elevateIfNeeded=K.elevateIfNeeded!==void 0?K.elevateIfNeeded:F.elevateIfNeeded,F.label=K.label??F.label,F.requireLocalPort=K.requireLocalPort,F.protocol=K.protocol):(F.onAutoForward=F.onAutoForward??K.onAutoForward,F.elevateIfNeeded=F.elevateIfNeeded!==void 0?F.elevateIfNeeded:K.elevateIfNeeded,F.label=F.label??K.label,F.requireLocalPort=F.requireLocalPort!==void 0?F.requireLocalPort:void 0,F.protocol=F.protocol??K.protocol),z=this.w(O,M,j,this.j,z+1)}return F.onAutoForward!==void 0||F.elevateIfNeeded!==void 0||F.label!==void 0||F.requireLocalPort!==void 0||F.protocol!==void 0?F:this.C()}t(O){return O.start!==void 0&&O.end!==void 0}u(O){return O.host!==void 0&&O.port!==void 0&&(0,o.$yf)(O.host)&&(0,o.$Cf)(O.port)}w(O,M,j,z,F){if(F>=z.length)return-1;const K=!(0,k.$$u)(M)&&!(0,k.$av)(M),fe=z.slice(F).findIndex(Z=>(0,o.$Cf)(Z.key)?K?!1:Z.key===O:this.t(Z.key)?K?!1:O>=Z.key.start&&O<=Z.key.end:this.u(Z.key)?O===Z.key.port&&M===Z.key.host:j?Z.key.test(j):!1);return fe>=0?fe+F:-1}y(){const O=this.r.getValue(g.c);if(!O||!(0,o.$Af)(O))return[];const M=[];for(const z in O){if(z===void 0)continue;const F=O[z];let K;if(Number(z))K=Number(z);else if((0,o.$yf)(z))if(g.g.test(z)){const V=z.match(g.g);K={start:Number(V[1]),end:Number(V[2])}}else if(g.h.test(z)){const V=z.match(g.h);K={host:V[1],port:Number(V[2])}}else{let V;try{V=RegExp(z)}catch{}V&&(K=V)}K&&M.push({key:K,elevateIfNeeded:F.elevateIfNeeded,onAutoForward:F.onAutoForward,label:F.label,requireLocalPort:F.requireLocalPort,protocol:F.protocol})}const j=this.r.getValue(g.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(M)}z(O){function M(j,z){return(0,o.$Cf)(j.key)?j.key:z.t(j.key)?j.key.start:z.u(j.key)?j.key.port:Number.MAX_VALUE}return O.sort((j,z)=>M(j,this)-M(z,this))}C(){return this.m}static providedActionToAction(O){switch(O){case k.ProvidedOnAutoForward.Notify:return b.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return b.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return b.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return b.OpenPreview;case k.ProvidedOnAutoForward.Silent:return b.Silent;case k.ProvidedOnAutoForward.Ignore:return b.Ignore;default:return}}async addAttributes(O,M,j){const F=this.r.inspect(g.c).userRemoteValue;let K;!F||!(0,o.$Af)(F)?K={}:K=(0,m.$4m)(F),K[`${O}`]||(K[`${O}`]={});for(const V in M)K[`${O}`][V]=M[V];return this.r.updateValue(g.c,K,j)}}e.$JJ=g;let P=class extends $.$Sc{constructor(O,M,j,z,F,K,V,fe,Z,Q){super(),this.H=O,this.I=M,this.J=j,this.L=z,this.M=F,this.N=K,this.O=V,this.P=fe,this.Q=Z,this.R=Q,this.c=new Map,this.g=new L.$Nd,this.onForwardPort=this.g.event,this.h=new L.$Nd,this.onClosePort=this.h.event,this.j=new L.$Nd,this.onPortName=this.j.event,this.n=new L.$Nd,this.onCandidatesChanged=this.n.event,this.t=new L.$Nd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$Nd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new g(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async X=>{const oe=await this.getAttributes(X.map(x=>({port:x.tunnelRemotePort,host:x.tunnelRemoteHost})));for(const x of X)if(x.localAddress){const ae=S(x.tunnelRemoteHost,x.tunnelRemotePort),we=D(this.m??new Map,x.tunnelRemoteHost,x.tunnelRemotePort);this.forwarded.set(ae,{remotePort:x.tunnelRemotePort,remoteHost:x.tunnelRemoteHost,localAddress:x.localAddress,protocol:oe?.get(x.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(x.localAddress,oe?.get(x.tunnelRemotePort)),localPort:x.tunnelLocalPort,runningProcess:we?.detail,hasRunningProcess:!!we,pid:we?.pid,privacy:x.privacy,source:e.$DJ}),this.f.set(ae,x)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async X=>{const oe=S(X.tunnelRemoteHost,X.tunnelRemotePort);if(!D(this.forwarded,X.tunnelRemoteHost,X.tunnelRemotePort)&&!D(this.detected,X.tunnelRemoteHost,X.tunnelRemotePort)&&!D(this.c,X.tunnelRemoteHost,X.tunnelRemotePort)&&X.localAddress){const x=D(this.m??new Map,X.tunnelRemoteHost,X.tunnelRemotePort),ae=(await this.getAttributes([{port:X.tunnelRemotePort,host:X.tunnelRemoteHost}]))?.get(X.tunnelRemotePort);this.forwarded.set(oe,{remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localAddress:X.localAddress,protocol:ae?.protocol??k.TunnelProtocol.Http,localUri:await this.X(X.localAddress,ae),localPort:X.tunnelLocalPort,closeable:!0,runningProcess:x?.detail,hasRunningProcess:!!x,pid:x?.pid,privacy:X.privacy,source:e.$DJ})}await this.$(),this.f.set(oe,X),this.g.fire(this.forwarded.get(oe))})),this.B(this.H.onTunnelClosed(X=>this.W(X,i.Other))),this.U()}S(){return this.Q.extensions.find(O=>O.activationEvents?.includes(e.$AJ))?(this.R.createKey(e.$BJ.key,!0),!0):!1}U(){if(this.S())return;const O=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&O.dispose()}))}async W(O,M){const j=S(O.host,O.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(O))}X(O,M){if(O.startsWith("http"))return E.URI.parse(O);const j=M?.protocol??"http";return E.URI.parse(`${j}://${O}`)}async Y(){const O=this.N.getWorkspace(),M=O.configuration?(0,A.$Ci)(O.configuration.path):O.folders.length>0?(0,A.$Ci)(O.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${n}.${this.L.remoteAuthority}.${M}`}async Z(){const O=this.I.get(n,1);if(O)return this.I.remove(n,1),await this.$(),O;const M=await this.Y();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=await this.s;if(O&&O!==this.y){const M=JSON.parse(O)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(j=>j.remotePort).join(", ")}`);for(const j of M){const z=D(this.detected,j.remoteHost,j.remotePort);j.source.source!==s.Extension&&!z||j.source.source===s.Extension&&z?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===s.Extension&&!z&&this.D.set(S(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const O=await this.Y();this.w=this.B(new $.$Rc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===O&&(this.s=Promise.resolve(this.I.get(O,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=JSON.stringify(Array.from(this.forwarded.values()));if(O!==this.y){this.y=O;const M=await this.Y();M&&this.I.store(M,this.y,0,0)}}}async bb(O,M,j){if(!O.tunnelLocalPort||!j?.requireLocalPort||O.tunnelLocalPort===M)return;const z=new Date;if(this.ab.getTime()+t>z.getTime())return;this.ab=z;const F=C.localize(3,null,M,O.tunnelRemotePort,O.tunnelLocalPort);return this.P.info(F)}async forward(O,M){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.cb(O,M)}async cb(O,M){await this.Q.activateByEvent(e.$AJ);const j=D(this.forwarded,O.remote.host,O.remote.port);M=M??(M!==null?(await this.getAttributes([O.remote]))?.get(O.remote.port):void 0);const z=O.local!==void 0?O.local:O.remote.port;let F;if(j)return this.eb(j,O,M);{const K=this.L.remoteAuthority,V=K?{getAddress:async()=>(await this.M.resolveAuthority(K)).authority}:void 0,fe=S(O.remote.host,O.remote.port);this.c.set(fe,!0),O=this.db(fe,O);const Z=await this.H.openTunnel(V,O.remote.host,O.remote.port,void 0,z,O.elevateIfNeeded?O.elevateIfNeeded:M?.elevateIfNeeded,O.privacy,M?.protocol);if(typeof Z=="string")F=Z;else if(Z&&Z.localAddress){const Q=D(this.m??new Map,O.remote.host,O.remote.port),X=Z.protocol?Z.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:M?.protocol??k.TunnelProtocol.Http,oe={remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localPort:Z.tunnelLocalPort,name:M?.label??O.name,closeable:!0,localAddress:Z.localAddress,protocol:X,localUri:await this.X(Z.localAddress,M),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:O.source??e.$DJ,privacy:Z.privacy};return this.forwarded.set(fe,oe),this.f.set(fe,Z),this.c.delete(fe),await this.$(),await this.bb(Z,z,M),this.g.fire(oe),Z}this.c.delete(fe)}return F}db(O,M){const j=this.D.has(O)?this.D:this.F.has(O)?this.F:void 0;if(j){const z=j.get(O);j.delete(O),z&&(M.name=z.name??M.name,M.local=("local"in z?z.local:"localPort"in z?z.localPort:void 0)??M.local,M.privacy=z.privacy??M.privacy)}return M}async eb(O,M,j){const z=j?.label??M.name;let F;(function(V){V[V.None=0]="None",V[V.Fire=1]="Fire",V[V.Reopen=2]="Reopen"})(F||(F={}));let K=F.None;switch(z!==O.name&&(O.name=z,K=F.Fire),(j?.protocol||O.protocol!==k.TunnelProtocol.Http)&&j?.protocol!==O.protocol&&(M.source=O.source,K=F.Reopen),M.privacy&&O.privacy!==M.privacy&&(K=F.Reopen),K){case F.Fire:{this.g.fire();break}case F.Reopen:await this.close(O.remoteHost,O.remotePort,i.User),await this.cb(M,j)}return D(this.f,M.remote.host,M.remote.port)}async name(O,M,j){const z=D(this.forwarded,O,M),F=S(O,M);if(z){z.name=j,await this.$(),this.j.fire({host:O,port:M});return}else this.detected.has(F)&&(this.detected.get(F).name=j,this.j.fire({host:O,port:M}))}async close(O,M,j){const z=S(O,M),F=this.forwarded.get(z);return j===i.AutoForwardEnd&&F&&F.source.source===s.Auto&&this.F.set(z,{local:F.localPort,name:F.name,privacy:F.privacy}),await this.H.closeTunnel(O,M),this.W({host:O,port:M},j)}address(O,M){const j=S(O,M);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(O){if(O)for(const M of O){const j=D(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),z=typeof M.localAddress=="string"?M.localAddress:S(M.localAddress.host,M.localAddress.port);this.detected.set(S(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:z,protocol:k.TunnelProtocol.Http,localUri:this.X(z),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:s.Extension,description:C.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,z,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(O){this.r=O}async setCandidates(O){let M=O;this.r&&(M=await this.r(O));const j=this.fb(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(z=>z.port).join(", ")}`),this.n.fire(j)}fb(O){const M=this.m??new Map,j=new Map;return this.m=j,O.forEach(z=>{const F=S(z.host,z.port);j.set(F,{host:z.host,port:z.port,detail:z.detail,pid:z.pid}),M.has(F)&&M.delete(F);const K=D(this.forwarded,z.host,z.port);K&&(K.runningProcess=z.detail,K.hasRunningProcess=!0,K.pid=z.pid)}),M.forEach((z,F)=>{const K=a(F);if(!K)return;const V=D(this.forwarded,K.host,K.port);V&&(V.runningProcess=void 0,V.hasRunningProcess=!1,V.pid=void 0);const fe=D(this.detected,K.host,K.port);fe&&(fe.runningProcess=void 0,fe.hasRunningProcess=!1,fe.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const O=Array.from(this.forwarded.values()),M=await this.getAttributes(O.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(M)for(const j of O){const z=M.get(j.remotePort);(z?.protocol||j.protocol!==k.TunnelProtocol.Http)&&z?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},z),z&&z.label&&z.label!==j.name&&await this.name(j.remoteHost,j.remotePort,z.label)}}async getAttributes(O,M=!0){const j=new Map,z=new Map;O.forEach(Z=>{const Q=D(this.m??new Map,k.$0u[0],Z.port)??Z;if(Q){j.set(Z.port,Q);const X=f(Q)?Q.pid:void 0;z.has(X)||z.set(X,[]),z.get(X)?.push(Z.port)}});const F=new Map;if(O.forEach(Z=>{const Q=this.configPortsAttributes.getAttributes(Z.port,Z.host,j.get(Z.port)?.detail);Q&&F.set(Z.port,Q)}),this.G.length===0||!M)return F.size>0?F:void 0;const K=await Promise.all((0,T.$Rb)(this.G.map(Z=>Array.from(z.entries()).map(Q=>{const X=Q[1],oe=j.get(X[0]);return Z.providePortAttributes(X,oe?.pid,oe?.detail,new r.$Xd().token)})))),V=new Map;if(K.forEach(Z=>Z.forEach(Q=>{Q&&V.set(Q.port,Q)})),!F&&!V)return;const fe=new Map;return O.forEach(Z=>{const Q=F.get(Z.port),X=V.get(Z.port);fe.set(Z.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??g.providedActionToAction(X?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),fe}addAttributesProvider(O){this.G.push(O)}};e.$KJ=P,He([(0,d.$hh)(1e3)],P.prototype,"$",null),e.$KJ=P=He([Be(0,k.$6u),Be(1,y.$4o),Be(2,v.$ii),Be(3,u.$zJ),Be(4,w.$Ok),Be(5,p.$Xh),Be(6,I.$9i),Be(7,R.$xv),Be(8,c.$9E),Be(9,h.$7i)],P)}),define(De[92],Ce([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$yI=e.$xI=void 0;class C{constructor(A,$){this.line=A,this.character=$}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,$){return new C(0,0)}with(A){return new C(0,0)}}e.$xI=C;class T{constructor(A,$,E,v){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(A,$),this.end=new C(E,v)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new T(0,0,0,0)}with(A){return new T(0,0,0,0)}}e.$yI=T;var d;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(d||(e.TextSearchCompleteMessageType=d={}))}),define(De[36],Ce([1,0,19,35,24,32,15,5,16,8,92,9]),function($e,e,C,T,d,L,A,$,E,v,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.SearchErrorCode=e.$NI=e.$MI=e.SearchSortOrder=e.ViewMode=e.$LI=e.$KI=e.$JI=e.$II=e.SearchCompletionExitCode=e.$HI=e.$GI=e.$FI=e.QueryType=e.SearchProviderType=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$zI="workbench.view.search",e.$AI="workbench.panel.search",e.$BI="workbench.view.search",e.$CI="search-result",e.$DI="search.exclude";const w="\u27EA ",y=" characters skipped \u27EB",k=(w.length+y.length+5)*2;e.$EI=(0,$.$Oh)("searchService");var p;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(p||(e.SearchProviderType=p={}));var u;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(u||(e.QueryType=u={}));function c(X){return!!X.preview}e.$FI=c;function r(X){return!!X.resource}e.$GI=r;function o(X){return!!X.message}e.$HI=o;var m;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(m||(e.SearchCompletionExitCode=m={}));class h{constructor(oe){this.resource=oe,this.results=[]}}e.$II=h;class t{constructor(oe,x,ae,we){this.ranges=x,this.webviewIndex=we;const G=Array.isArray(x)?x:[x];if(ae&&ae.matchLines===1&&n(G)){oe=(0,A.$rf)(oe,ae.matchLines);let U="",q=0,me=0;const ee=Math.floor(ae.charsPerLine/5),ne=[];for(const re of G){const Ee=Math.max(re.startColumn-ee,0),ce=re.startColumn+ae.charsPerLine;if(Ee>me+ee+k){const de=w+(Ee-me)+y;U+=de+oe.slice(Ee,ce),q+=Ee-(me+de.length)}else U+=oe.slice(me,ce);ne.push(new i(0,re.startColumn-q,re.endColumn-q)),me=ce}this.preview={text:U,matches:Array.isArray(this.ranges)?ne:ne[0]}}else{const U=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:oe,matches:(0,C.$2b)(x,q=>new a(q.startLineNumber-U,q.startColumn,q.endLineNumber-U,q.endColumn))}}}}e.$JI=t;function n(X){const oe=X[0].startLineNumber;for(const x of X)if(x.startLineNumber!==oe||x.endLineNumber!==oe)return!1;return!0}class a{constructor(oe,x,ae,we){this.startLineNumber=oe,this.startColumn=x,this.endLineNumber=ae,this.endColumn=we}}e.$KI=a;class i extends a{constructor(oe,x,ae){super(oe,x,oe,ae)}}e.$LI=i;var s;(function(X){X.List="list",X.Tree="tree"})(s||(e.ViewMode=s={}));var l;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(l||(e.SearchSortOrder=l={}));function D(X,oe=!0){const x=X&&X.files&&X.files.exclude,ae=oe&&X&&X.search&&X.search.exclude;if(!x&&!ae)return;if(!x||!ae)return x||ae;let we=Object.create(null);return we=d.$7m(we,d.$4m(x)),we=d.$7m(we,d.$4m(ae),!0),we}e.$MI=D;function S(X,oe){return X.excludePattern&&T.$uj(X.excludePattern,oe)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&T.$uj(X.includePattern,oe)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(x=>{const ae=x.folder.fsPath;if(L.$Xf(oe,ae)){const we=E.$lc(ae,oe);return!x.includePattern||!!T.$uj(x.includePattern,we)}else return!1}):!1:!0}e.$NI=S;var b;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class f extends Error{constructor(oe,x){super(oe),this.code=x}}e.$OI=f;function g(X){const oe=X.message;if((0,v.$4)(X))return new f(oe,b.canceled);try{const x=JSON.parse(oe);return new f(x.message,x.code)}catch{return new f(oe,b.other)}}e.$PI=g;function P(X){const oe={message:X.message,code:X.code};return new Error(JSON.stringify(oe))}e.$QI=P;function N(X){return X.type==="error"?!0:X.type==="success"}e.$RI=N;function O(X){return X.type==="success"}e.$SI=O;function M(X){return!!X.path}e.$TI=M;function j(X,oe){const x=X.searchPath?X.searchPath:X.relativePath;return(0,A.$of)(x,oe)}e.$UI=j;class z{constructor(oe){this.path=oe,this.results=[]}addMatch(oe){this.results.push(oe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$VI=z;function F(X,oe){const x={...X||{},...oe||{}};return Object.keys(x).filter(ae=>{const we=x[ae];return typeof we=="boolean"&&we})}e.$WI=F;class K{constructor(oe,x){this.c=null,this.a={...oe.excludePattern||{},...x.excludePattern||{}},this.b=T.$vj(this.a);let ae=oe.includePattern;x.includePattern&&(ae?ae={...ae,...x.includePattern}:ae=x.includePattern),ae&&(this.c=T.$vj(ae))}matchesExcludesSync(oe,x,ae){return!!(this.b&&this.b(oe,x,ae))}includedInQuerySync(oe,x,ae){return!(this.b&&this.b(oe,x,ae)||this.c&&!this.c(oe,x,ae))}includedInQuery(oe,x,ae){const we=this.b(oe,x,ae),G=()=>this.c?!!this.c(oe,x,ae):!0;return(0,I.$Gg)(we)?we.then(U=>U?!1:G()):G()}hasSiblingExcludeClauses(){return V(this.a)}}e.$XI=K;function V(X){for(const oe in X)if(typeof X[oe]!="boolean")return!0;return!1}function fe(X){if(!X)return;let oe;return x=>(oe||(oe=(X()||Promise.resolve([])).then(ae=>ae?Q(ae):{})),oe.then(ae=>!!ae[x]))}e.$YI=fe;function Z(X){if(!X)return;let oe;return x=>{if(!oe){const ae=X();oe=ae?Q(ae):{}}return!!oe[x]}}e.$ZI=Z;function Q(X){const oe={};for(const x of X)oe[x]=!0;return oe}}),define(De[39],Ce([1,0,19,9,21,4,3,78,18,120,23,15,2,214,5,14,243,44,55,27,20,13,7,67,36,6]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r,o,m,h,t,n,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=e.$7bc=void 0;function s(N,O,M){return new R.$kg(j=>b(j,M)).isEqual(N,O)}function l(N,O,M){return s(N.uri,O.uri,M)?0:(0,I.$Ue)(N.uri.toString(),O.uri.toString())}function D(N,O,M){return N.index!==O.index?N.index<O.index?-1:1:s(N.uri,O.uri,M)?(0,I.$Ue)(N.name,O.name):(0,I.$Ue)(N.uri.toString(),O.uri.toString())}function S(N,O,M,j){const z=N.slice(0).sort((K,V)=>M(K,V,j)),F=O.slice(0).sort((K,V)=>M(K,V,j));return(0,C.$Eb)(z,F,(K,V)=>M(K,V,j))}function b(N,O){const M=O.getCapabilities(N.scheme);return!(M&&M&1024)}class f extends c.$8h{static toExtHostWorkspace(O,M,j,z){if(!O)return{workspace:null,added:[],removed:[]};const{id:F,name:K,folders:V,configuration:fe,transient:Z,isUntitled:Q}=O,X=[],oe=M;M?V.forEach((G,U)=>{const q=w.URI.revive(G.uri),me=f.o(j||M,q,z);me?(me.name=G.name,me.index=G.index,X.push(me)):X.push({uri:q,name:G.name,index:U})}):X.push(...V.map(({uri:G,name:U,index:q})=>({uri:w.URI.revive(G),name:U,index:q}))),X.sort((G,U)=>G.index<U.index?-1:1);const x=new f(F,K,X,!!Z,fe?w.URI.revive(fe):null,!!Q,G=>b(G,z)),{added:ae,removed:we}=S(oe?oe.workspaceFolders:[],x.workspaceFolders,l,z);return{workspace:x,added:ae,removed:we}}static o(O,M,j){for(let z=0;z<O.folders.length;z++){const F=O.workspaceFolders[z];if(s(F.uri,M,j))return F}}constructor(O,M,j,z,F,K,V){super(O,j.map(fe=>new c.$9h(fe)),z,F,V),this.t=M,this.u=K,this.q=[],this.s=$.$Uh.forUris(V),j.forEach(fe=>{this.q.push(fe),this.s.set(fe.uri,fe)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(O,M){return M&&this.s.get(O)&&(O=(0,R.$ug)(O)),this.s.findSubstr(O)}resolveWorkspaceFolder(O){return this.s.get(O)}}let g=class{constructor(O,M,j,z,F){this.c=new L.$Nd,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Nd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$Pd,this.B=new Map,this.h=z,this.s=j,this.t=F,this.j=new v.$Ol,this.k=new T.$Sg,this.o=O.getProxy(i.$cK.MainThreadWorkspace),this.q=O.getProxy(i.$cK.MainThreadMessageService);const K=M.workspace;this.l=K?new f(K.id,K.name,[],!!K.transient,K.configuration?w.URI.revive(K.configuration):null,!!K.isUntitled,V=>b(V,j)):void 0}$initializeWorkspace(O,M){this.v=M,this.$acceptWorkspaceData(O),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?w.URI.from({scheme:E.Schemas.untitled,path:(0,R.$sg)((0,R.$ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(O,M,j,...z){const F=[];if(Array.isArray(z)&&z.forEach(Q=>{w.URI.isUri(Q.uri)&&!F.some(X=>s(X.uri,Q.uri,this.s))&&F.push({uri:Q.uri,name:Q.name||(0,R.$rg)(Q.uri)})}),this.n||[M,j].some(Q=>typeof Q!="number"||Q<0)||j===0&&F.length===0)return!1;const K=this.x?this.x.workspaceFolders:[];if(M+j>K.length)return!1;const V=K.slice(0);V.splice(M,j,...F.map(Q=>({uri:Q.uri,name:Q.name||(0,R.$rg)(Q.uri),index:void 0})));for(let Q=0;Q<V.length;Q++){const X=V[Q];if(V.some((oe,x)=>x!==Q&&s(X.uri,oe.uri,this.s)))return!1}V.forEach((Q,X)=>Q.index=X);const{added:fe,removed:Z}=S(K,V,D,this.s);if(fe.length===0&&Z.length===0)return!1;if(this.o){const Q=O.displayName||O.name;this.o.$updateWorkspaceFolders(Q,M,j,F).then(void 0,X=>{this.n=void 0;const oe={source:{identifier:O.identifier,label:O.displayName||O.name}};this.q.$showMessage(u.Severity.Error,(0,y.localize)(0,null,Q,X.toString()),oe,[])})}return this.y(V),!0}getWorkspaceFolder(O,M){if(this.x)return this.x.getWorkspaceFolder(O,M)}async getWorkspaceFolder2(O,M){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(O,M)}async resolveWorkspaceFolder(O){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(O)}getPath(){if(!this.x)return;const{folders:O}=this.x;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,M){let j,z="";if(typeof O=="string"?(j=w.URI.file(O),z=O):typeof O<"u"&&(j=O,z=O.fsPath),!j)return z;const F=this.getWorkspaceFolder(j,!0);if(!F)return z;typeof M>"u"&&this.x&&(M=this.x.folders.length>1);let K=(0,R.$xg)(F.uri,j);return M&&F.name&&(K=`${F.name}/${K}`),K}y(O){this.x&&(this.n=f.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:O,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:M,added:j,removed:z}=f.toExtHostWorkspace(O,this.l,this.n,this.s);this.l=M||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:z}))}findFiles(O,M,j,z,F=d.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let K;if(M===null?K=!1:M&&(typeof M=="string"?K=M:K=M.pattern),F&&F.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:fe}=P(h.GlobPattern.from(O));return this.o.$startFileSearch(V??null,fe??null,K??null,j??null,F).then(Z=>Array.isArray(Z)?Z.map(Q=>w.URI.revive(Q)):[])}async findTextInFiles(O,M,j,z,F=d.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const K=this.j.getNext(),V=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:fe,folder:Z}=P(h.GlobPattern.from(M.include)),Q=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,X={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:V,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:fe,excludePattern:Q},oe=!1;if(this.u[K]=x=>{if(oe)return;const ae=w.URI.revive(x.resource);x.results.forEach(we=>{(0,a.$FI)(we)?j({uri:ae,preview:{text:we.preview.text,matches:(0,C.$2b)(we.preview.matches,G=>new t.$gK(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))},ranges:(0,C.$2b)(we.ranges,G=>new t.$gK(G.startLineNumber,G.startColumn,G.endLineNumber,G.endColumn))}):j({uri:ae,text:we.text,lineNumber:we.lineNumber})})},F.isCancellationRequested)return{};try{const x=await this.o.$startTextSearch(O,Z??null,X,K,F);return delete this.u[K],x||{}}catch(x){throw delete this.u[K],x}}$handleTextSearchResult(O,M){this.u[M]?.(O)}async save(O){const M=await this.o.$save(O,{saveAs:!1});return w.URI.revive(M)}async saveAs(O){const M=await this.o.$save(O,{saveAs:!0});return w.URI.revive(M)}saveAll(O){return this.o.$saveAll(O)}resolveProxy(O){return this.o.$resolveProxy(O)}get trusted(){return this.v}requestWorkspaceTrust(O){return this.o.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(O,M){if(this.w.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.w.set(O,M);const j=this.t.transformOutgoingScheme(O),z=this.z++;return this.o.$registerEditSessionIdentityProvider(z,j),(0,A.$Qc)(()=>{this.w.delete(O),this.o.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(O,M){this.h.info("Getting edit session identifier for workspaceFolder",O);const j=await this.resolveWorkspaceFolder(w.URI.revive(O));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const z=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!z),!z)return;const F=await z.provideEditSessionIdentity(j,M);if(this.h.info("Provider returned edit session identifier: ",F),!!F)return F}async $provideEditSessionIdentityMatch(O,M,j,z){this.h.info("Getting edit session identifier for workspaceFolder",O);const F=await this.resolveWorkspaceFolder(w.URI.revive(O));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const K=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!K),!K)return;const V=await K.provideEditSessionIdentityMatch?.(M,j,z);if(this.h.info("Provider returned edit session identifier match result: ",V),!!V)return V}getOnWillCreateEditSessionIdentityEvent(O){return(M,j,z)=>{const F=function(V){M.call(j,V)};return F.extension=O,this.A.event(F,void 0,z)}}async $onWillCreateEditSessionIdentity(O,M,j){const z=await this.resolveWorkspaceFolder(w.URI.revive(O));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:z},M,async(F,K)=>{const V=Date.now();await Promise.resolve(F),Date.now()-V>j&&this.h.warn("SLOW edit session create-participant",K.extension.identifier)}),M.isCancellationRequested}registerCanonicalUriProvider(O,M){if(this.B.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.B.set(O,M);const j=this.t.transformOutgoingScheme(O),z=this.z++;return this.o.$registerCanonicalUriProvider(z,j),(0,A.$Qc)(()=>{this.B.delete(O),this.o.$unregisterCanonicalUriProvider(z)})}async provideCanonicalUri(O,M,j){const z=this.B.get(O.scheme);if(!z)return;const F=await z.provideCanonicalUri?.(w.URI.revive(O),M,j);if(F)return F}async $provideCanonicalUri(O,M,j){return this.provideCanonicalUri(w.URI.revive(O),{targetScheme:M},j)}};e.$7bc=g,e.$7bc=g=He([Be(0,m.$dM),Be(1,o.$tM),Be(2,r.$Ubc),Be(3,p.$9i),Be(4,n.$5bc)],g),e.$8bc=(0,k.$Oh)("IExtHostWorkspace");function P(N){let O,M;return N&&(typeof N=="string"?O=N:(O=N.pattern,M=w.URI.revive(N.baseUri))),{includePattern:O,folder:M}}}),define(De[40],Ce([1,0,24,4,39,6,7,245,136,17,9,5,20,14,2]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=e.$0bc=e.$9bc=void 0;function p(n,a){if(a){const i=a.split(".");let s=n;for(let l=0;s&&l<i.length;l++)s=s[i[l]];return s}}function u(n){return n instanceof k.URI}function c(n){return n&&n.uri instanceof k.URI&&n.languageId&&typeof n.languageId=="string"}function r(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function o(n){return n&&n.uri instanceof k.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function m(n){if(u(n))return{resource:n};if(c(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(r(n))return{overrideIdentifier:n.languageId};if(o(n))return{resource:n.uri};if(n===null)return{resource:null}}let h=class{constructor(a,i,s){this.a=a.getProxy(L.$cK.MainThreadConfiguration),this.c=i,this.b=s,this.d=new R.$Sg,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,i){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(a,i))}};e.$9bc=h,e.$9bc=h=He([Be(0,w.$dM),Be(1,d.$8bc),Be(2,y.$9i)],h);class t{constructor(a,i,s,l){this.a=new T.$Nd,this.b=a,this.f=l,this.c=i,this.e=$.$Bn.parse(s),this.d=this.k(s.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,i){const s={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Bn.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(i,s))}getConfiguration(a,i,s){const l=m(i)||{},D=this.g(a?p(this.e.getValue(void 0,l,this.c.workspace),a):this.e.getValue(void 0,l,this.c.workspace));a&&this.h(a,l,s?.identifier);function S(f){if(f==null)return null;if(typeof f=="boolean")return f?2:5;switch(f){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const b={has(f){return typeof p(D,f)<"u"},get:(f,g)=>{this.h(a?`${a}.${f}`:f,l,s?.identifier);let P=p(D,f);if(typeof P>"u")P=g;else{let N;const O=(M,j)=>{if((0,v.$Af)(M)){let z;const F=()=>{N=N||(0,C.$4m)(D),z=z||p(N,j)};return new Proxy(M,{get:(K,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return F(),()=>z;if(N)return z=z||p(N,j),z[V];const fe=K[V];return typeof V=="string"?O(fe,`${j}.${V}`):fe},set:(K,V,fe)=>(F(),z&&(z[V]=fe),!0),deleteProperty:(K,V)=>(F(),z&&delete z[V],!0),defineProperty:(K,V,fe)=>(F(),z&&Object.defineProperty(z,V,fe),!0)})}return Array.isArray(M)?(0,C.$4m)(M):M};P=O(P,f)}return P},update:(f,g,P,N)=>{f=a?`${a}.${f}`:f;const O=S(P);return g!==void 0?this.b.$updateConfigurationOption(O,f,g,l,N):this.b.$removeConfigurationOption(O,f,l,N)},inspect:f=>{f=a?`${a}.${f}`:f;const g=this.e.inspect(f,l,this.c.workspace);if(g)return{key:f,defaultValue:(0,C.$4m)(g.policy?.value??g.default?.value),globalValue:(0,C.$4m)(g.user?.value??g.application?.value),workspaceValue:(0,C.$4m)(g.workspace?.value),workspaceFolderValue:(0,C.$4m)(g.workspaceFolder?.value),defaultLanguageValue:(0,C.$4m)(g.default?.override),globalLanguageValue:(0,C.$4m)(g.user?.override??g.application?.override),workspaceLanguageValue:(0,C.$4m)(g.workspace?.override),workspaceFolderLanguageValue:(0,C.$4m)(g.workspaceFolder?.override),languageIds:(0,C.$4m)(g.overrideIdentifiers)}}};return typeof D=="object"&&(0,C.$7m)(b,D,!1),Object.freeze(b)}g(a){const i=s=>(0,v.$Af)(s)?new Proxy(s,{get:(l,D)=>i(l[D]),set:(l,D,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(D)}' of object`)},deleteProperty:(l,D)=>{throw new Error(`TypeError: Cannot delete read only property '${String(D)}' of object`)},defineProperty:(l,D)=>{throw new Error(`TypeError: Cannot define property '${String(D)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return i(a)}h(a,i,s){const l=E.$sn.test(a)?4:this.d.get(a),D=s?`[${s.value}] `:"";if(l===4){typeof i?.resource>"u"&&this.f.warn(`${D}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){i?.resource&&this.f.warn(`${D}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,i){const s=new $.$Dn(a,i,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(l,D)=>s.affectsConfiguration(l,m(D))})}k(a){return a.reduce((i,s)=>(i.set(s[0],s[1]),i),new Map)}}e.$0bc=t,e.$$bc=(0,I.$Oh)("IExtHostConfiguration")}),define(De[93],Ce([1,0,2,9,4,6,7,39,70,40,21,45,20,27,5,18,12,14,89,291,8]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.$8cc=e.$7cc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(O){function M(z){if(z!=null)return z}O.from=M;function j(z){if(z!=null)return z}O.to=j})(h||(h={}));var t;(function(O){function M(z){if(z!=null)return z}O.from=M;function j(z){if(z!=null)return z}O.to=j})(t||(t={}));var n;(function(O){function M(z){if(z!=null)return z}O.from=M;function j(z){if(z!=null)return z}O.to=j})(n||(n={}));var a;(function(O){function M(F){if(F){const K=F;return K&&!!K.process}else return!1}O.is=M;function j(F){if(F==null)return;const K={process:F.process,args:F.args};return F.options&&(K.options=n.from(F.options)),K}O.from=j;function z(F){if(F!=null)return new A.$YK(F.process,F.args,F.options)}O.to=z})(a||(a={}));var i;(function(O){function M(z){if(z!=null)return z}O.from=M;function j(z){if(z!=null)return z}O.to=j})(i||(i={}));var s;(function(O){function M(F){if(F){const K=F;return K&&(!!K.commandLine||!!K.command)}else return!1}O.is=M;function j(F){if(F==null)return;const K={};return F.commandLine!==void 0?K.commandLine=F.commandLine:(K.command=F.command,K.args=F.args),F.options&&(K.options=i.from(F.options)),K}O.from=j;function z(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new A.$ZK(F.commandLine,F.options):new A.$ZK(F.command,F.args?F.args:[],F.options)}O.to=z})(s||(s={}));var l;(function(O){function M(F){if(F){const K=F;return K&&K.customExecution==="customExecution"}else return!1}O.is=M;function j(F){return{customExecution:"customExecution"}}O.from=j;function z(F,K){return K.get(F)}O.to=z})(l||(e.CustomExecutionDTO=l={}));var D;(function(O){function M(j,z){let F;return j.scope!==void 0&&typeof j.scope!="number"?F=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===A.TaskScope.Workspace&&z&&z.workspaceFile?F=z.workspaceFile:F=o.$LF),{id:j._id,workspaceFolder:F}}O.from=M})(D||(e.TaskHandleDTO=D={}));var S;(function(O){function M(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}O.from=M})(S||(S={}));var b;(function(O){function M(F,K){if(F==null)return[];const V=[];for(const fe of F){const Z=j(fe,K);Z&&V.push(Z)}return V}O.fromMany=M;function j(F,K){if(F==null)return;let V;F.execution instanceof A.$YK?V=a.from(F.execution):F.execution instanceof A.$ZK?V=s.from(F.execution):F.execution&&F.execution instanceof A.$1K&&(V=l.from(F.execution));const fe=h.from(F.definition);let Z;return F.scope?typeof F.scope=="number"?Z=F.scope:Z=F.scope.uri:Z=A.TaskScope.Workspace,!fe||!Z?void 0:{_id:F._id,definition:fe,name:F.name,source:{extensionId:K.identifier.value,label:F.source,scope:Z},execution:V,isBackground:F.isBackground,group:S.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}O.from=j;async function z(F,K,V){if(F==null)return;let fe;a.is(F.execution)?fe=a.to(F.execution):s.is(F.execution)?fe=s.to(F.execution):l.is(F.execution)&&(fe=l.to(F._id,V));const Z=h.to(F.definition);let Q;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Q=F.source.scope:Q=await K.resolveWorkspaceFolder(C.URI.revive(F.source.scope)):Q=A.TaskScope.Workspace),!Z||!Q)return;const X=new A.$2K(Z,Q,F.name,F.source.label,fe,F.problemMatchers);return F.isBackground!==void 0&&(X.isBackground=F.isBackground),F.group!==void 0&&(X.group=A.$XK.from(F.group._id),X.group&&F.group.isDefault&&(X.group=new A.$XK(X.group.id,X.group.label),F.group.isDefault===!0&&(X.group.isDefault=F.group.isDefault))),F.presentationOptions&&(X.presentationOptions=t.to(F.presentationOptions)),F._id&&(X._id=F._id),F.detail&&(X.detail=F.detail),X}O.to=z})(b||(e.TaskDTO=b={}));var f;(function(O){function M(z){return z}O.from=M;function j(z){if(z)return Object.assign(Object.create(null),z)}O.to=j})(f||(f={}));class g{#e;constructor(M,j,z){this._id=j,this.a=z,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let P=class{constructor(M,j,z,F,K,V,fe,Z){this.q=new d.$Nd,this.r=new d.$Nd,this.s=new d.$Nd,this.t=new d.$Nd,this.a=M.getProxy(L.$cK.MainThreadTask),this.b=z,this.c=F,this.d=K,this.e=V,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=fe,this.g=Z,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,j,z){if(!z)return new A.$eK(()=>{});const F=this.w();return this.j.set(F,{type:j,provider:z,extension:M}),this.a.$registerTaskProvider(F,j),new A.$eK(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(M,j){this.a.$registerTaskSystem(M,j)}fetchTasks(M){return this.a.$fetchTasks(f.from(M)).then(async j=>{const z=[];for(const F of j){const K=await b.to(F,this.b,this.m);K&&z.push(K)}return z})}get taskExecutions(){const M=[];return this.k.forEach(j=>M.push(j)),M}terminateTask(M){if(!(M instanceof g))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,j,z){const F=this.m.get(M.id);F&&(this.o.set(M.id,F),this.e.attachPtyToTerminal(j,await F.callback(z))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const j=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const j=await this.y(M.id);this.s.fire({execution:j,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const j=await this.y(M.id);this.t.fire({execution:j,exitCode:M.exitCode})}$provideTasks(M,j){const z=this.j.get(M);if(!z)return Promise.reject(new Error("no handler found"));const F=[],K=(0,T.$Mg)(()=>z.provider.provideTasks(R.CancellationToken.None)).then(V=>this.u(j,F,z,V));return new Promise(V=>{K.then(fe=>{Promise.all(F).then(()=>{V(fe)})})})}async $resolveTask(M,j){const z=this.j.get(M);if(!z)return Promise.reject(new Error("no handler found"));if(j.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${z.type}].`);const F=await b.to(j,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const K=await z.provider.resolveTask(F,R.CancellationToken.None);if(!K)return;this.z(K,z);const V=b.from(K,z.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(V.execution)&&await this.x(V,K,!0),await this.v(V)}w(){return this.h++}async x(M,j,z){const F=await this.a.$createTaskId(M);!z&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,j.execution)),this.m.set(F,j.execution)}async y(M,j){if(typeof M=="string"){const K=this.l.get(M);if(!K)throw new m.$bb("Unexpected: The specified task is missing an execution");return K}const z=this.l.get(M.id);if(z)return z;const F=new Promise((K,V)=>{function fe(Z,Q,X){X?K(new g(Z,Q.id,X)):V("Unexpected: Task does not exist.")}j?fe(this,M,j):b.to(M.task,this.b,this.m).then(Z=>fe(this,M,Z))});return this.l.set(M.id,F),F.then(K=>(this.k.set(M.id,K),K),K=>Promise.reject(K))}z(M,j){M._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const z=this.n.values();let F=z.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=z.next()}};e.$7cc=P,e.$7cc=P=He([Be(0,w.$dM),Be(1,y.$tM),Be(2,$.$8bc),Be(3,E.$oM),Be(4,v.$$bc),Be(5,I.$qcc),Be(6,c.$9i),Be(7,r.$Xbc)],P);let N=class extends P{constructor(M,j,z,F,K,V,fe,Z){super(M,j,z,F,K,V,fe,Z),this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:u.$i(0)})}async executeTask(M,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const z=b.from(j,M);if(z===void 0)throw new Error("Task is not valid");if(l.is(z.execution))await this.x(z,j,!1);else throw new m.$_;const F=await this.y(await this.a.$getTaskExecution(z),j);return this.a.$executeTask(z).catch(K=>{throw new Error(K)}),F}u(M,j,z,F){const K=[];if(F)for(const V of F){this.z(V,z),(!V.definition||!M[V.definition.type])&&this.f.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const fe=b.from(V,z.extension);fe&&l.is(fe.execution)?(K.push(fe),j.push(this.x(fe,V,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:z.extension}}async v(M){if(l.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,j,z){}};e.$8cc=N,e.$8cc=N=He([Be(0,w.$dM),Be(1,y.$tM),Be(2,$.$8bc),Be(3,E.$oM),Be(4,v.$$bc),Be(5,I.$qcc),Be(6,c.$9i),Be(7,r.$Xbc)],N),e.$9cc=(0,k.$Oh)("IExtHostTask")}),define(De[348],Ce([1,0,16,21,41,35,23,37,36]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=void 0;class v{constructor(w,y,k){this.k=w,this.l=y,this.o=k,this.e=!1,this.f=0,this.g=!1,this.a=w.filePattern,this.b=w.includePattern&&L.$vj(w.includePattern),this.c=w.maxResults||void 0,this.d=w.exists,this.h=new Set,this.j=w.excludePattern&&L.$vj(w.excludePattern)}cancel(){this.g=!0,this.h.forEach(w=>w.cancel()),this.h=new Set}search(w){const y=this.k.folderQueries||[];return new Promise((k,p)=>{const u=c=>{this.f++,w(c)};if(this.g)return k({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const r=c.toString(),o=C.$nc(r);this.j&&this.j(r,o)||this.v(u,{base:c,basename:o})}),Promise.all(y.map(c=>this.p(c,u))).then(c=>{k({limitHit:this.e,stats:c[0]||void 0})},c=>{p(new Error((0,d.$zi)(c)))})})}async p(w,y){const k=new T.$Xd,p=this.q(w),u=this.r(),c=new E.$XI(this.k,w),r=!c.hasSiblingExcludeClauses();let o;try{this.h.add(k),o=$.$Jd.create();const m=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},p,k.token),h=o.elapsed(),t=$.$Jd.create();return this.g&&!this.e||(m&&m.forEach(n=>{const a=C.$gc.relative(w.folder.path,n.path);if(r){const i=C.$nc(n.path);this.v(y,{base:w.folder,relativePath:a,basename:i});return}this.s(u,w.folder,a,y)}),this.g&&!this.e)?null:(this.u(u,c,y),{providerTime:h,postProcessTime:t.elapsed()})}finally{k.dispose(),this.h.delete(k)}}q(w){const y=(0,E.$WI)(this.k.includePattern,w.includePattern),k=(0,E.$WI)(this.k.excludePattern,w.excludePattern);return{folder:w.folder,excludes:k,includes:y,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}s({pathToEntries:w},y,k,p){if(k===this.a){const c=C.$nc(this.a);this.v(p,{base:y,relativePath:this.a,basename:c})}function u(c){const r=C.$nc(c),o=C.$mc(c);let m=w[o];m||(m=w[o]=[],u(o)),m.push({base:y,relativePath:c,basename:r})}u(k)}u({rootEntries:w,pathToEntries:y},k,p){const u=this,c=this.a;function r(o){const m=(0,E.$ZI)(()=>o.map(h=>h.basename));for(let h=0,t=o.length;h<t;h++){const n=o[h],{relativePath:a,basename:i}=n;if(k.matchesExcludesSync(a,i,c!==i?m:void 0))continue;const s=y[a];if(s)r(s);else{if(a===c)continue;u.v(p,n)}if(u.e)break}}r(w)}v(w,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||w(y))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(w,y,k,p){const u=this.c(w.cacheKey),c=new v(w,y,u&&u.token);let r=0;const o=m=>{r+=m.length,k(m.map(h=>this.d(h)))};return this.e(c,R.a,o,p).then(m=>({limitHit:m.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:m.stats}}))}clearCache(w){this.c(w)?.cancel()}c(w){if(w)return this.b.has(w)||this.b.set(w,new T.$Xd),this.b.get(w)}d(w){return w.relativePath?{resource:A.$vg(w.base,w.relativePath)}:{resource:w.base}}e(w,y,k,p){const u=p.onCancellationRequested(()=>{w.cancel()}),c=o=>{o&&(r.push(o),y>0&&r.length>=y&&(k(r),r=[]))};let r=[];return w.search(c).then(o=>(r.length&&k(r),u.dispose(),o),o=>(r.length&&k(r),u.dispose(),Promise.reject(o)))}}e.$gdc=R}),define(De[349],Ce([1,0,19,74,35,99,28,18,16,23,15,17,2,172,226,50,14,44,143,346,36]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$SJ=void 0;let h=class{constructor(f,g,P,N,O){this.a=f,this.b=g,this.c=P,this.d=N,this.e=O}text(f,g,P={}){f=this.f(f,P);const N=this.a.getValue(),O=g&&g.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(g?.map(c.$0h),P),type:2,contentPattern:f,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:N.search.usePCRE2||O||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(f,g){const P=this.a.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const N={...f,wordSeparators:P.editor.wordSeparators};return this.j(f,g)&&(N.isCaseSensitive=!0),this.k(f)&&(N.isMultiline=!0),g.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=g.notebookSearchConfig.includeMarkupInput),g.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=g.notebookSearchConfig.includeMarkupPreview),g.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=g.notebookSearchConfig.includeCodeInput),g.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=g.notebookSearchConfig.includeOutput),N}file(f,g={}){return{...this.h(f,g),type:1,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey}}g(f,g){return f?(f=Array.isArray(f)?f.map(s):s(f),g?this.parseSearchPaths(f):{pattern:n(...Array.isArray(f)?f:[f])}):{}}h(f=[],g={}){const P=this.g(g.includePattern,g.expandPatterns),N=this.g(g.excludePattern,g.expandPatterns),O=f.length>1,M=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(F=>this.q(F,g,N)):f.map(F=>this.r(F,g,N,O))).filter(F=>!!F),j={_reason:g._reason,folderQueries:M,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:N.pattern,includePattern:P.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const F=C.$Hb(C.$Rb(this.c.groups.map(fe=>fe.editors.map(Z=>Z.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const K=F.filter(fe=>(0,m.$NI)(j,fe.fsPath)),V=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...j,...V}}const z=g.extraFileResources&&g.extraFileResources.filter(F=>(0,m.$NI)(j,F.fsPath));return j.extraFileResources=z&&z.length?z:void 0,j}i(f){const g=[],P=new A.$Ac,N={};let O=!1;return f.forEach(M=>{if(M.scheme===$.Schemas.walkThrough)return;if((0,v.$zg)(M)){const z=this.b.getWorkspaceFolder(M)?.uri??M.with({path:E.$mc(M.fsPath)});let F=P.get(z);F||(O=!0,F={folder:z,includePattern:{}},g.push(F),P.set(z,F));const K=E.$lc(z.fsPath,M.fsPath);(0,I.$Jf)(F.includePattern)[K.replace(/\\/g,"/")]=!0}else M.fsPath&&(O=!0,N[M.fsPath]=!0)}),{folderQueries:g,includePattern:N,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}j(f,g){if(g.isSmartCase){if(f.isRegExp){if(R.$pf(f.pattern,!0))return!0}else if(R.$pf(f.pattern))return!0}return!!f.isCaseSensitive}k(f){return f.isMultiline||f.isRegExp&&(0,y.$qB)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const g=V=>E.$ic(V)||/^\.\.?([\/\\]|$)/.test(V),N=(Array.isArray(f)?f:a(f)).map(V=>{const fe=this.e.resolvedUserHome;return fe?(0,L.$qv)(V,fe.scheme===$.Schemas.file?fe.fsPath:fe.path):V}),O=T.$J(N,V=>g(V)?"searchPaths":"exprSegments"),M=(O.exprSegments||[]).map(V=>R.$Ke(V,"/")).map(V=>R.$Ke(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),i(V))),j={},z=this.m(O.searchPaths||[]);z&&z.length&&(j.searchPaths=z);const F=C.$Rb(M),K=n(...F);return K&&(j.pattern=K),j}l(f,g){return g.disregardExcludeSettings?void 0:(0,m.$MI)(f,!g.disregardSearchExcludeSettings)}m(f){if(!f||!f.length)return[];const g=f.flatMap(N=>{let{pathPortion:O,globPortion:M}=t(N);return M&&(M=l(M)),this.n(O).flatMap(z=>this.o(z,M))}),P=new Map;return g.forEach(N=>{const O=N.searchPath.toString(),M=P.get(O);M?N.pattern&&(M.pattern=M.pattern||{},M.pattern[N.pattern]=!0):P.set(O,{searchPath:N.searchPath,pattern:N.pattern?n(N.pattern):void 0})}),Array.from(P.values())}n(f){if(E.$ic(f)){const g=this.b.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==$.Schemas.file?[{searchPath:g[0].uri.with({path:f})}]:[{searchPath:w.URI.file(E.$hc(f))}]}if(this.b.getWorkbenchState()===2){const g=this.b.getWorkspace().folders[0].uri;if(f=s(f),f.startsWith("../")||f===".."){const N=E.$gc.resolve(g.path,f);return[{searchPath:g.with({path:N})}]}const P=l(f);return[{searchPath:g,pattern:P}]}else{if(f==="./"||f===".\\")return[];{const g=f.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(O=>{const M=g.match(new RegExp(`^${R.$Fe(O.name)}(?:/(.*)|$)`));return M?{match:M,folder:O}:null}).filter(I.$Gf);if(N.length)return N.map(O=>{const M=O.match[1];return{searchPath:O.folder.uri,pattern:M&&l(M)}});{const O=f.match(/\.[\/\\](.+)[\/\\]?/),M=O?O[1]:f,j=k.localize(0,null,M);throw new Error(j)}}}}o(f,g){const P=f.pattern&&g?`${f.pattern}/${g}`:f.pattern||g,N=[{searchPath:f.searchPath,pattern:P}];return P&&!P.endsWith("**")&&N.push({searchPath:f.searchPath,pattern:P+"/**"}),N}q(f,g,P){const N=this.r((0,c.$0h)(f.searchPath),g,P,!1);return N?{...N,includePattern:f.pattern}:null}r(f,g,P,N){let O;const M=w.URI.isUri(f)?f:f.uri;if(P.searchPaths){const V=P.searchPaths.filter(fe=>(0,v.$og)(fe.searchPath,M))[0];if(V&&!V.pattern)return null;V&&(O=V.pattern)}const j=this.a.getValue({resource:M}),F={...this.l(j,g)||{},...O||{}},K=w.URI.isUri(f)?(0,v.$sg)(f):f.name;return{folder:M,folderName:N?K:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof g.disregardParentIgnoreFiles=="boolean"?g.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!j.search.followSymlinks}}};e.$SJ=h,e.$SJ=h=He([Be(0,p.$ii),Be(1,c.$Xh),Be(2,r.$aC),Be(3,u.$9i),Be(4,o.$QJ)],h);function t(b){const f=b.match(/[\*\{\}\(\)\[\]\?]/);if(f){const g=f.index,P=b.substr(0,g).match(/[/|\\][^/\\]*$/);if(P){let N=b.substr(0,P.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:b.substr((P.index||0)+1)}}}return{pathPortion:b}}function n(...b){return b.length?b.reduce((f,g)=>(f[g]=!0,f),Object.create(null)):void 0}function a(b){return d.$tj(b,",").map(f=>f.trim()).filter(f=>!!f.length)}function i(b){return[`**/${b}/**`,`**/${b}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function s(b){return b.replace(/\\/g,"/")}function l(b){return s(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(b){return b.replace(/([?*[\]])/g,"[$1]")}function S(b,f){b=C.$Mb(b,N=>N.toString());const g=[],P=f.getWorkspace();return b&&b.forEach(N=>{let O;if(f.getWorkbenchState()===2)O=(0,v.$xg)(P.folders[0].uri,N),O&&O!=="."&&(O="./"+O);else{const M=f.getWorkspaceFolder(N);if(M){const j=M.name;if(P.folders.filter(F=>F.name===j).length===1){const F=(0,v.$xg)(M.uri,N);F===""?O=`./${M.name}`:O=`./${M.name}/${F}`}else O=N.fsPath}}O&&g.push(D(O))}),g}e.$TJ=S}),define(De[350],Ce([1,0,23,2,21,8,5,349,36,44]),function($e,e,C,T,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlb=e.$vlb=void 0;const R=7e3;function I(p,u){const c=u.activationEvents;if(!c)return Promise.resolve(void 0);const r=[],o=[];for(const i of c)if(/^workspaceContains:/.test(i)){const s=i.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||p.forceUsingSearch?o.push(s):r.push(s)}if(r.length===0&&o.length===0)return Promise.resolve(void 0);let m;const h=new Promise((i,s)=>{m=i}),t=i=>m({activationEvent:i}),n=Promise.all(r.map(i=>w(p,i,t))).then(()=>{}),a=y(p,u.identifier,o,t);return Promise.all([n,a]).then(()=>{m(void 0)}),h}e.$vlb=I;async function w(p,u,c){for(const r of p.folders)if(await p.exists(C.$vg(T.URI.revive(r),u))){c(`workspaceContains:${u}`);return}}async function y(p,u,c,r){if(c.length===0)return Promise.resolve(void 0);const o=new d.$Xd,m=p.checkExists(p.folders,c,o.token),h=setTimeout(async()=>{o.cancel(),p.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${c.join(",")}`)},R);let t=!1;try{t=await m}catch(n){L.$4(n)||L.$1(n)}o.dispose(),clearTimeout(h),t&&r(`workspaceContains:${c.join(",")}`)}function k(p,u,c,r){const o=p.get(A.$Nh),m=p.get(E.$EI),t=o.createInstance($.$SJ).file(u.map(n=>(0,v.$0h)(T.URI.revive(n))),{_reason:"checkExists",includePattern:c,exists:!0});return m.fileSearch(t,r).then(n=>!!n.limitHit,n=>L.$4(n)?!1:Promise.reject(n))}e.$wlb=k}),define(De[46],Ce([1,0,204,16,54,23,9,3,78,2,14,6,40,286,115,39,26,148,8,25,22,262,7,65,5,27,90,20,104,73,45,4,350,114,264,18,112,37,12,113]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r,o,m,h,t,n,a,i,s,l,D,S,b,f,g,P,N,O,M,j,z,F){"use strict";var K;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=e.$Ecc=e.$Dcc=e.$Ccc=e.$Bcc=void 0,e.$Bcc=(0,a.$Oh)("IHostUtils");let V=K=class extends $.$Sc{constructor(G,U,q,me,ee,ne,re,Ee,ce,de,te,he){super(),this.X=he,this.a=this.B(new f.$Nd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=q,this.f=re,this.j=me,this.m=ee,this.s=ne,this.t=ce,this.u=de,this.w=te,this.y=this.g.getProxy(I.$cK.MainThreadWorkspace),this.z=this.g.getProxy(I.$cK.MainThreadTelemetry),this.C=this.g.getProxy(I.$cK.MainThreadExtensionService),this.D=new A.$Sg,this.F=new A.$Sg,this.G=new A.$Sg,this.H=new A.$Sg,this.I=new ae(this.f.extensions.activationEvents),this.L=new c.$e4b(this.I,this.f.extensions.allExtensions);const be=new o.$5l(this.f.extensions.myExtensions);this.J=new c.$e4b(this.I,oe(this.L,be)),z.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new k.$icc(this.g,this.s),this.N=new P.$ucc(this.g),this.O=Ee,this.h=G.createChild(new D.$Mh([k.$jcc,this.M],[P.$vcc,this.N])),this.P=this.B(new y.$hcc(this.J,this.L,{onExtensionActivationError:(Pe,B,J)=>{this.C.$onExtensionActivationError(Pe,r.$3(B),J)},actualActivateExtension:async(Pe,B)=>{if(c.$e4b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,B),new y.$gcc;const J=this.J.getExtensionDescription(Pe);return this.db(J,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),d.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(G){r.$1(G)}}async Y(){this.O.onWillDeactivateAll();let G=[];try{G=this.J.getAllExtensionDescriptions().map(ee=>ee.identifier).filter(ee=>this.isActivated(ee)).map(ee=>this.cb(ee))}catch{}await Promise.all(G)}terminate(G,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${G}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(me=>{this.s.error(me)}),this.g.dispose();const q=this.Y();Promise.race([(0,A.$Ug)(5e3),q]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(G){return this.G.isOpen()?this.P.isActivated(G):!1}async getExtension(G){const U=await this.C.$getExtension(G);return U&&{...U,identifier:new o.$4l(U.identifier.value),extensionLocation:v.URI.revive(U.extensionLocation)}}Z(G,U){return this.P.activateByEvent(G,U)}$(G,U){return this.P.activateById(G,U)}activateByIdWithErrors(G,U){return this.$(G,U).then(()=>{const q=this.P.getActivatedExtension(G);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(G=>this.J)}getExtensionExports(G){if(this.G.isOpen())return this.P.getActivatedExtension(G).exports;try{return this.P.getActivatedExtension(G).exports}catch{return null}}async ab(G){if(G.scheme===O.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(G.fsPath);return v.URI.file(U)}return G}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(G=>new x(G))),this.Q}async bb(G){const U=E.$Uh.forUris(q=>L.$mg.ignorePathCasing(q));return await Promise.all(G.map(async q=>{if(this.ub(q)){const me=await this.ab(q.extensionLocation);U.set(me,q)}})),U}cb(G){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(G))return U;const q=this.P.getActivatedExtension(G);if(!q)return U;try{typeof q.module.deactivate=="function"&&(U=Promise.resolve(q.module.deactivate()).then(void 0,me=>(this.s.error(me),Promise.resolve(void 0))))}catch(me){this.s.error(`An error occurred when deactivating the extension '${G.value}':`),this.s.error(me)}try{(0,$.$Nc)(q.subscriptions)}catch(me){this.s.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this.s.error(me)}return U}async db(G,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(G.identifier):await this.C.$onWillActivateExtension(G.identifier),this.fb(G,U).then(q=>{const me=q.activationTimes;return this.C.$onDidActivateExtension(G.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,U),this.eb(G,U,"success",me),q},q=>{throw this.eb(G,U,"failure"),q})}eb(G,U,q,me){const ee=Z(G,U);this.z.$publicLog2("extensionActivationTimes",{...ee,...me||{},outcome:q})}fb(G,U){const q=Z(G,U);this.z.$publicLog2("activatePlugin",q);const me=this.ub(G);if(!me)return Promise.resolve(new y.$fcc(y.$ccc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${G.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const ee=new y.$dcc(U.startup);return Promise.all([this.vb(G,(0,L.$vg)(G.extensionLocation,me),ee),this.gb(G)]).then(ne=>(d.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),K.hb(this.s,G.identifier,ne[0],ne[1],ee))).then(ne=>(d.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),ne))}gb(G){const U=new h.$lcc(G,this.M),q=new h.$kcc(G.identifier.value,!1,this.M),me=new N.$wcc(G,this.N),ee=G.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ne=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([U.whenReady,q.whenReady,this.O.whenReady]).then(()=>{const re=this;let Ee,ce;const de=(0,u.$_E)(G,"ipc")?this.f.messagePorts?.get(o.$4l.toKey(G.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:q,secrets:me,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(te){return T.$jc(G.extensionLocation.fsPath,te)},get storagePath(){return re.O.workspaceValue(G)?.fsPath},get globalStoragePath(){return re.O.globalValue(G).fsPath},get logPath(){return T.$jc(re.f.logsLocation.fsPath,G.identifier.value)},get logUri(){return v.URI.joinPath(re.f.logsLocation,G.identifier.value)},get storageUri(){return re.O.workspaceValue(G)},get globalStorageUri(){return re.O.globalValue(G)},get extensionMode(){return ee},get extension(){return Ee===void 0&&(Ee=new X(re,G.identifier,G,ne,!1)),Ee},get extensionRuntime(){return(0,u.$aF)(G,"extensionRuntime"),re.extensionRuntime},get environmentVariableCollection(){return re.u.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!ce){if(!de)return;const te=f.Event.buffer(f.Event.fromDOMEventEmitter(de,"message",he=>he.data));de.start(),ce={onDidReceiveMessage:te,postMessage:de.postMessage.bind(de)}}return ce}})})}static hb(G,U,q,me,ee){return q=q||{activate:void 0,deactivate:void 0},this.ib(G,U,q,me,ee).then(ne=>new y.$ecc(!1,null,ee.build(),q,ne,me.subscriptions))}static ib(G,U,q,me,ee){if(typeof q.activate=="function")try{ee.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${U.value}`);const ne=typeof global=="object"?global:self,re=q.activate.apply(ne,[me]);return ee.activateCallStop(),ee.activateResolveStart(),Promise.resolve(re).then(Ee=>(ee.activateResolveStop(),Ee))}catch(ne){return Promise.reject(ne)}else return Promise.resolve(q)}jb(G,U){this.$(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:U}).then(void 0,q=>{this.s.error(q)})}kb(G,U=0){const me=Date.now();(0,z.$B)(()=>{for(let ee=U;ee<G.length;ee+=1){const ne=G[ee];for(const re of ne.activationEvents??[])if(re==="onStartupFinished")if(Date.now()-me>50){this.kb(G,ee);break}else this.jb(ne,re)}})}lb(){this.C.$setPerformanceMarks(d.getMarks()),this.m.getConfigProvider().then(G=>{const U=G.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),q=this.J.getAllExtensionDescriptions();if(U)this.kb(q);else for(const me of q)if(me.activationEvents)for(const ee of me.activationEvents)ee==="onStartupFinished"&&this.jb(me,ee)})}mb(){const G=this.Z("*",!0).then(void 0,ne=>{this.s.error(ne)});this.B(this.j.onDidChangeWorkspace(ne=>this.nb(ne.added)));const U=this.j.workspace?this.j.workspace.folders:[],q=this.nb(U),me=this.pb(),ee=Promise.all([me,G,q]).then(()=>{});return Promise.race([ee,(0,A.$Ug)(1e4)]).then(()=>{this.lb()}),ee}nb(G){return G.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(G,U))).then(()=>{})}async ob(G,U){if(this.isActivated(U.identifier))return;const q=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.s,folders:G.map(ne=>ne.uri),forceUsingSearch:q||!this.c.fsExists,exists:ne=>this.c.fsExists(ne.fsPath),checkExists:(ne,re,Ee)=>this.y.$checkExists(ne,re,Ee)},ee=await(0,g.$vlb)(me,U);if(ee)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:ee.activationEvent}).then(void 0,ne=>this.s.error(ne))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(G){throw console.error(G),G}}async qb(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:U}=this.f.environment;if(!G||!U)throw new Error(C.localize(0,null));const q=await this.vb(null,U,new y.$dcc(!1));if(!q||typeof q.run!="function")throw new Error(C.localize(1,null,U.toString()));return new Promise((me,ee)=>{const ne=(ce,de)=>{ce?(z.$t&&this.s.error("Test runner called back with error",ce),ee(ce)):(z.$t&&(de?this.s.info(`Test runner called back with ${de} failures.`):this.s.info("Test runner called back with successful outcome.")),me(typeof de=="number"&&de>0?1:0))},re=(0,L.$jg)(U),Ee=q.run(re,ne);Ee&&Ee.then&&Ee.then(()=>{z.$t&&this.s.info("Test runner finished successfully."),me(0)}).catch(ce=>{z.$t&&this.s.error("Test runner finished with error",ce),ee(ce instanceof Error&&ce.stack?ce.stack:String(ce))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Ug)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,U){return this.R[G]=U,(0,$.$Qc)(()=>{delete this.R[G]})}async getRemoteExecServer(G){const{resolver:U}=await this.sb(G);return U?.resolveExecServer?.(G,{resolveAttempt:0})}async sb(G){const U=G.indexOf("+");if(U===-1)throw new t.$kK("Not an authority that can be resolved!",n.RemoteAuthorityResolverErrorCode.InvalidAuthority);const q=G.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this.R[q]}}async $resolveAuthority(G,U){const q=j.$Jd.create(!1),me=()=>`[resolveAuthority(${(0,n.$Sk)(G)},${U})][${q.elapsed()}ms] `,ee=se=>this.s.info(`${me()}${se}`),ne=se=>this.s.warn(`${me()}${se}`),re=(se,Y=void 0)=>this.s.error(`${me()}${se}`,Y),Ee=se=>{if(se instanceof t.$kK)return{type:"error",error:{code:se._code,message:se._message,detail:se._detail}};throw se},ce=async se=>{ee(`activating resolver for ${se}...`);const{resolver:Y,authorityPrefix:ge}=await this.sb(se);if(!Y)throw re(`no resolver for ${ge}`),new t.$kK(`No remote extension installed to resolve ${ge}.`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Y,authorityPrefix:ge,remoteAuthority:se}},de=G.split(/@|%40/g).reverse();ee(`activating remote resolvers ${de.join(" -> ")}`);let te;try{te=await Promise.all(de.map(ce)).catch(async se=>{if(!(se instanceof t.$kK)||se._code!==n.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw se;return ne(`resolving nested authorities failed: ${se.message}`),[await ce(G)]})}catch(se){return Ee(se)}const he=new A.$5g;he.cancelAndSet(()=>ee("waiting..."),1e3);let be,Pe;for(const[se,{authorityPrefix:Y,resolver:ge,remoteAuthority:ye}]of te.entries())try{if(se===te.length-1)ee("invoking final resolve()..."),d.mark(`code/extHost/willResolveAuthority/${Y}`),be=await ge.resolve(ye,{resolveAttempt:U,execServer:Pe}),d.mark(`code/extHost/didResolveAuthorityOK/${Y}`),ee("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ge,t.$jK.isManagedResolvedAuthority(be)?be:void 0));else{if(ee(`invoking resolveExecServer() for ${ye}`),d.mark(`code/extHost/willResolveExecServer/${Y}`),Pe=await ge.resolveExecServer?.(ye,{resolveAttempt:U,execServer:Pe}),!Pe)throw new t.$kK(`Exec server was not available for ${ye}`,n.RemoteAuthorityResolverErrorCode.NoResolverFound);d.mark(`code/extHost/didResolveExecServerOK/${Y}`)}}catch(je){return d.mark(`code/extHost/didResolveAuthorityError/${Y}`),re("returned an error",je),he.dispose(),Ee(je)}he.dispose();const B={environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures},J={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};ee(`returned ${t.$jK.isManagedResolvedAuthority(be)?"managed authority":`${be.host}:${be.port}`}`);let ie;if(t.$jK.isManagedResolvedAuthority(be)){const se=U;this.X.setFactory(se,be.makeConnection),ie={authority:G,connectTo:new n.$Pk(se),connectionToken:be.connectionToken}}else ie={authority:G,connectTo:new n.$Qk(be.host,be.port),connectionToken:be.connectionToken};return{type:"ok",value:{authority:ie,options:J,tunnelInformation:B}}}async $getCanonicalURI(G,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,n.$Sk)(G)})`);const{resolver:q}=await this.sb(G);if(!q)return null;const me=v.URI.revive(U);if(typeof q.getCanonicalURI>"u")return me;const ee=await(0,A.$Mg)(()=>q.getCanonicalURI(me));return ee||me}$startExtensionHost(G){G.toAdd.forEach(me=>me.extensionLocation=v.URI.revive(me.extensionLocation));const{globalRegistry:U,myExtensions:q}=fe(this.I,this.L,this.J,G);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(q),z.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.rb()}$activateByEvent(G,U){return U===1?this.D.wait().then(q=>this.Z(G,!1)):this.G.wait().then(q=>this.Z(G,!1))}async $activate(G,U){return await this.G.wait(),this.J.getExtensionDescription(G)?(await this.$(G,U),!0):!1}async $deltaExtensions(G){G.toAdd.forEach(ne=>ne.extensionLocation=v.URI.revive(ne.extensionLocation));const{globalRegistry:U,myExtensions:q}=fe(this.I,this.L,this.J,G),me=await this.bb(q);return(await this.getExtensionPathIndex()).setSearchTree(me),this.L.set(U.getAllExtensionDescriptions()),this.J.set(q),z.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){const U=m.$be.alloc(G),q=Math.random()%256;for(let me=0;me<G;me++)U.writeUInt8(q,me);return U}async $updateRemoteConnectionData(G){this.W=G,this.a.fire()}};e.$Ccc=V,e.$Ccc=V=K=He([Be(0,a.$Nh),Be(1,e.$Bcc),Be(2,l.$dM),Be(3,p.$8bc),Be(4,w.$$bc),Be(5,R.$9i),Be(6,i.$tM),Be(7,s.$occ),Be(8,S.$2vb),Be(9,b.$qcc),Be(10,M.$ycc),Be(11,F.$zcc)],V);function fe(we,G,U,q){we.addActivationEvents(q.addActivationEvents);const me=new c.$e4b(we,G.getAllExtensionDescriptions());me.deltaExtensions(q.toAdd,q.toRemove);const ee=new o.$5l(U.getAllExtensionDescriptions().map(re=>re.identifier));for(const re of q.myToRemove)ee.delete(re);for(const re of q.myToAdd)ee.add(re);const ne=oe(me,ee);return{globalRegistry:me,myExtensions:ne}}function Z(we,G){return{id:we.identifier.value,name:we.name,extensionVersion:we.version,publisherDisplayName:we.publisher,activationEvents:we.activationEvents?we.activationEvents.join(","):null,isBuiltin:we.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}function Q(we){return we.getAllExtensionDescriptions().map(G=>G.identifier.value).join(",")}e.$Dcc=(0,a.$Oh)("IExtHostExtensionService");class X{#e;#t;#i;constructor(G,U,q,me,ee){this.#e=G,this.#t=U,this.#i=q.identifier,this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=T.$hc((0,L.$jg)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=me,this.isFromDifferentExtensionHost=ee}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Ecc=X;function oe(we,G){return we.getAllExtensionDescriptions().filter(U=>G.has(U.identifier))}class x{constructor(G){this.a=G}setSearchTree(G){this.a=G}findSubstr(G){return this.a.findSubstr(G)}forEach(G){return this.a.forEach(G)}}e.$Fcc=x;class ae{constructor(G){this.a=new o.$6l,this.addActivationEvents(G)}readActivationEvents(G){return this.a.get(G.identifier)}addActivationEvents(G){for(const U of Object.keys(G))this.a.set(U,G[U])}}}),define(De[351],Ce([1,0,54,2,6,40,26,25,20,27,5,46,14,15]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=void 0;let p=class{constructor(m,h,t,n,a,i,s){this.c=m,this.d=h,this.e=t,this.f=n,this.g=a,this.h=i,this.i=s,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const m=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new c(this.c,h,this.d,m,this.i)),this.register(this.e.createInstance(u)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,h,this.h.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(const h of m.nodeModuleName)this.a.set(h,m);else this.a.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this.b.push(h=>m.alternativeModuleName(h))}};e.$4dc=p,e.$4dc=p=He([Be(2,R.$Nh),Be(3,L.$$bc),Be(4,I.$Dcc),Be(5,v.$tM),Be(6,w.$9i)],p);let u=class{static{k=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(m){if(m.environment.appRoot&&k.a.size){const h=(0,y.$Fe)(this.c(m.environment.appRoot.fsPath)),t="[a-z0-9_.-]",n=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${a}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(m){if(!this.b)return;const h=this.b.exec(this.c(m));if(!h)return;const[,t,n,a]=h,i=k.a.get(n);if(i!==void 0)return console.warn(`${n} as been renamed to ${i}, please update your imports`),t+i+a}c(m){return m.replace(/\\/g,"/")}};u=k=He([Be(0,v.$tM)],u);class c{constructor(m,h,t,n,a){this.c=m,this.d=h,this.e=t,this.f=n,this.g=a,this.nodeModuleName="vscode",this.a=new $.$6l}load(m,h){const t=this.d.findSubstr(h);if(t){let n=this.a.get(t.identifier);return n||(n=this.c(t,this.e,this.f),this.a.set(t.identifier,n)),n}if(!this.b){let n="";this.d.forEach((a,i)=>n+=`	${i} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${n}`),this.b=this.c(A.$7E,this.e,this.f)}return this.b}}let r=class{constructor(m,h,t){this.e=m,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(d.$cK.MainThreadTelemetry);const n=t.getProxy(d.$cK.MainThreadWindow);this.c=(a,i)=>{const s=T.URI.parse(a);return i?this.g(a,i):s.scheme==="http"||s.scheme==="https"?n.$openUri(s,a,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this.f?n.$openUri(s,a,{}):this.g(a,i)}}load(m,h,t){const n=this.e.findSubstr(h);return n&&(this.a=n.identifier.value,this.h()),this.b=t(m),this.c}g(m,h){return this.i(),this.b(m,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=He([Be(2,E.$dM)],r)}),define(De[56],Ce([1,0,47,3,16,48,5,70,71,46,7,39,278,40]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.$_cc=void 0,e.$_cc=(0,A.$Oh)("IExtHostVariableResolverProvider");class k extends w.$eN{constructor(c,r,o,m,h,t,n){function a(){if(o){const i=o.activeEditor();if(i)return i.document.uri;const s=m.tabGroups.all.find(l=>l.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof R.$WL||s.input instanceof R.$2L)return s.input.modified;if(s.input instanceof R.$VL||s.input instanceof R.$1L||s.input instanceof R.$YL)return s.input.uri}}}super({getFolderUri:i=>{const s=t.folders.filter(l=>l.name===i);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(i,s)=>h.getConfiguration(void 0,i).get(s),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=a();if(i)return d.$hc(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const i=a();if(i){const s=r.getWorkspaceFolder(i);if(s)return d.$hc(s.uri.fsPath)}}},getSelectedText:()=>{if(o){const i=o.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(o){const i=o.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>c.getExtension(i)},void 0,n?Promise.resolve(n):void 0,Promise.resolve(L.env))}}let p=class extends T.$Sc{constructor(c,r,o,m,h){super(),this.b=c,this.c=r,this.g=o,this.h=m,this.j=h,this.a=new C.$V(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async i=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new k(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$adc=p,e.$adc=p=He([Be(0,v.$Dcc),Be(1,I.$8bc),Be(2,$.$oM),Be(3,y.$$bc),Be(4,E.$0cc)],p)}),define(De[94],Ce([1,0,9,4,2,5,6,71,46,20,7,39,140,271,40,56]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=e.$ddc=e.$cdc=e.$bdc=void 0,e.$bdc=(0,L.$Oh)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(n,a,i,s,l,D){this.E=a,this.F=i,this.G=s,this.H=l,this.I=D,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Nd,this.n=new T.$Nd,this.o=new T.$Nd,this.u=new T.$Nd,this.k=n.getProxy(A.$cK.MainThreadDebugService),this.y=new T.$Nd,this.A=new T.$Nd,this.v=new r(this.k),this.w=new Map,this.F.getExtensionRegistry().then(S=>{S.onDidChange(b=>{this.J(S)}),this.J(S)})}asDebugSourceUri(n,a){const i=n;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let s=`debug:${encodeURIComponent(i.path||"")}`,l="?";return a&&(s+=`${l}session=${encodeURIComponent(a.id)}`,l="&"),s+=`${l}ref=${i.sourceReference}`,d.URI.parse(s)}else{if(i.path)return d.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(n){const a=[];for(const i of n.getAllExtensionDescriptions())if(i.contributes){const s=i.contributes.debuggers;if(s&&s.length>0)for(const l of s)(0,y.$oF)(l)&&a.push(l.type)}this.k.$registerDebugTypes(a)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const n=[];return this.w.forEach(a=>n.push(a)),n}addBreakpoints(n){const a=n.filter(l=>{const D=l.id;return this.w.has(D)?!1:(this.w.set(D,l),!0)});this.U(a,[],[]);const i=[],s=new Map;for(const l of a)if(l instanceof R.$dL){let D=s.get(l.location.uri.toString());D||(D={type:"sourceMulti",uri:l.location.uri,lines:[]},s.set(l.location.uri.toString(),D),i.push(D)),D.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof R.$eL&&i.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this.k.$registerBreakpoints(i)}removeBreakpoints(n){const a=n.filter(D=>this.w.delete(D.id));this.U([],a,[]);const i=a.filter(D=>D instanceof R.$dL).map(D=>D.id),s=a.filter(D=>D instanceof R.$eL).map(D=>D.id),l=a.filter(D=>D instanceof R.$fL).map(D=>D.id);return this.k.$unregisterBreakpoints(i,s,l)}startDebugging(n,a,i){return this.k.$startDebugging(n?n.uri:void 0,a,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(n){return this.k.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,a,i){if(!a)return new R.$eK(()=>{});const s=this.d++;return this.f.push({type:n,handle:s,provider:a}),this.k.$registerDebugConfigurationProvider(n,i,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,s),new R.$eK(()=>{this.f=this.f.filter(l=>l.provider!==a),this.k.$unregisterDebugConfigurationProvider(s)})}registerDebugAdapterDescriptorFactory(n,a,i){if(!i)return new R.$eK(()=>{});if(!this.Q(n,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.N(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const s=this.g++;return this.h.push({type:a,handle:s,factory:i}),this.k.$registerDebugAdapterDescriptorFactory(a,s),new R.$eK(()=>{this.h=this.h.filter(l=>l.factory!==i),this.k.$unregisterDebugAdapterDescriptorFactory(s)})}registerDebugAdapterTrackerFactory(n,a){if(!a)return new R.$eK(()=>{});const i=this.i++;return this.j.push({type:n,handle:i,factory:a}),new R.$eK(()=>{this.j=this.j.filter(s=>s.factory!==a)})}async $runInTerminal(n,a){return Promise.resolve(void 0)}async $substituteVariables(n,a){let i;const s=await this.W(n);return s&&(i={uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(i,a)}K(n,a){if(n.type==="implementation")return new m(n.implementation)}L(){}async $startDASession(n,a){const i=this,s=await this.V(a);return this.S(this.N(s.type),s).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${s.type}' (extension might have failed to activate)`);const D=this.M(l),S=this.K(D,s);if(!S)throw new Error(`Couldn't create a debug adapter for type '${s.type}'.`);const b=S;return this.B.set(n,b),this.R(s).then(f=>(f&&this.C.set(n,f),b.onMessage(async g=>{if(g.type==="request"&&g.command==="handshake"){const P=g,N={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const O=await this.D.sign(P.arguments.value);N.body={signature:O},b.sendResponse(N)}else throw new Error("no signer")}catch(O){N.success=!1,N.message=O.message,b.sendResponse(N)}}else f&&f.onDidSendMessage&&f.onDidSendMessage(g),g=(0,y.$tF)(g,!0),i.k.$acceptDAMessage(n,g)}),b.onError(g=>{f&&f.onError&&f.onError(g),this.k.$acceptDAError(n,g.name,g.message,g.stack)}),b.onExit(g=>{f&&f.onExit&&f.onExit(g??void 0,void 0),this.k.$acceptDAExit(n,g??void 0,void 0)}),f&&f.onWillStartSession&&f.onWillStartSession(),b.startSession()))})}$sendDAMessage(n,a){a=(0,y.$sF)(a,!1);const i=this.C.get(n);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(a),this.B.get(n)?.sendMessage(a)}$stopDASession(n){const a=this.C.get(n);this.C.delete(n),a&&a.onWillStopSession&&a.onWillStopSession();const i=this.B.get(n);return this.B.delete(n),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const a=[],i=[],s=[];if(n.added)for(const l of n.added){const D=l.id;if(D&&!this.w.has(D)){let S;if(l.type==="function")S=new R.$eL(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")S=new R.$fL(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const b=d.URI.revive(l.uri);S=new R.$dL(new R.$qK(b,new R.$fK(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}(0,R.$bL)(S,D),this.w.set(D,S),a.push(S)}}if(n.removed)for(const l of n.removed){const D=this.w.get(l);D&&(this.w.delete(l),i.push(D))}if(n.changed){for(const l of n.changed)if(l.id){const D=this.w.get(l.id);if(D){if(D instanceof R.$eL&&l.type==="function"){const S=D;S.enabled=l.enabled,S.condition=l.condition,S.hitCondition=l.hitCondition,S.logMessage=l.logMessage,S.functionName=l.functionName}else if(D instanceof R.$dL&&l.type==="source"){const S=D;S.enabled=l.enabled,S.condition=l.condition,S.hitCondition=l.hitCondition,S.logMessage=l.logMessage,S.location=new R.$qK(d.URI.revive(l.uri),new R.$fK(l.line,l.character))}s.push(D)}}}this.U(a,i,s)}async $acceptStackFrameFocus(n){let a;const i=n.sessionId?await this.V(n.sessionId):void 0;if(!i)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?a=new R.$lL(i,n.threadId):a=new R.$kL(i,n.threadId,n.frameId),this.z=a,this.A.fire(this.z)}$provideDebugConfigurations(n,a,i){return(0,C.$Mg)(async()=>{const s=this.P(n);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.W(a);return s.provideDebugConfigurations(l,i)}).then(s=>{if(!s)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return s})}$resolveDebugConfiguration(n,a,i,s){return(0,C.$Mg)(async()=>{const l=this.P(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const D=await this.W(a);return l.resolveDebugConfiguration(D,i,s)})}$resolveDebugConfigurationWithSubstitutedVariables(n,a,i,s){return(0,C.$Mg)(async()=>{const l=this.P(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const D=await this.W(a);return l.resolveDebugConfigurationWithSubstitutedVariables(D,i,s)})}async $provideDebugAdapter(n,a){const i=this.O(n);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const s=await this.V(a);return this.S(i,s).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${s.type}'`);return this.M(l)})}async $acceptDebugSessionStarted(n){const a=await this.V(n);this.m.fire(a)}async $acceptDebugSessionTerminated(n){const a=await this.V(n);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(n){this.q=n?await this.V(n):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(n,a){(await this.V(n))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(n,a){const s={session:await this.V(n),event:a.event,body:a.body};this.u.fire(s)}M(n){if(n instanceof R.$gL)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof R.$hL)return{type:"server",port:n.port,host:n.host};if(n instanceof R.$iL)return{type:"pipeServer",path:n.path};if(n instanceof R.$jL)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}N(n){const a=this.h.filter(i=>i.type===n);if(a.length>0)return a[0].factory}O(n){const a=this.h.filter(i=>i.handle===n);if(a.length>0)return a[0].factory}P(n){const a=this.f.filter(i=>i.handle===n);if(a.length>0)return a[0].provider}Q(n,a){if(n.contributes){const i=n.contributes.debuggers;if(i&&i.length>0){for(const s of i)if(s.label&&s.type&&s.type===a)return!0}}return!1}R(n){const i=n.configuration.type,s=this.j.filter(l=>l.type===i||l.type==="*").map(l=>(0,C.$Mg)(()=>l.factory.createDebugAdapterTracker(n)).then(D=>D,D=>null));return Promise.race([Promise.all(s).then(l=>{const D=l.filter(S=>!!S);if(D.length>0)return new o(D)}),new Promise(l=>setTimeout(()=>l(void 0),1e3))]).catch(l=>{})}async S(n,a){const i=a.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new R.$hL(i));if(n){const l=await this.F.getExtensionRegistry();return(0,C.$Mg)(()=>n.createDebugAdapterDescriptor(a,this.T(a,l))).then(D=>{if(D)return D})}const s=await this.F.getExtensionRegistry();return Promise.resolve(this.T(a,s))}T(n,a){}U(n,a,i){(n.length>0||a.length>0||i.length>0)&&this.y.fire(Object.freeze({added:n,removed:a,changed:i}))}async V(n){if(n)if(typeof n=="string"){const a=this.l.get(n);if(a)return a}else{let a=this.l.get(n.id);if(!a){const i=await this.W(n.folderUri),s=n.parent?this.l.get(n.parent):void 0;a=new c(this.k,n.id,n.type,n.name,i,n.configuration,s),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(n){if(n){const a=d.URI.revive(n);return this.E.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};e.$cdc=u,e.$cdc=u=He([Be(0,v.$dM),Be(1,I.$8bc),Be(2,E.$Dcc),Be(3,k.$$bc),Be(4,$.$0cc),Be(5,p.$_cc)],u);class c{constructor(n,a,i,s,l,D,S){this.d=n,this.f=a,this.g=i,this.h=s,this.i=l,this.j=D,this.k=S}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(n){this.h=n,this.d.$setDebugSessionName(this.f,n)}get parentSession(){return this.k}_acceptNameChanged(n){this.h=n}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(n,a){return this.d.$customDebugAdapterRequest(this.f,n,a)}getDebugProtocolBreakpoint(n){return this.d.$getDebugProtocolBreakpoint(this.f,n.id)}}e.$ddc=c;class r{constructor(n){this.value=Object.freeze({append(a){n.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.$edc=r;class o{constructor(n){this.d=n}onWillStartSession(){this.d.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(n):void 0)}onWillStopSession(){this.d.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.d.forEach(a=>a.onError?a.onError(n):void 0)}onExit(n,a){this.d.forEach(i=>i.onExit?i.onExit(n,a):void 0)}}class m extends w.$2cb{constructor(n){super(),this.h=n,n.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.h.handleMessage(n)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends u{constructor(n,a,i,s,l,D){super(n,a,i,s,l,D)}};e.$fdc=h,e.$fdc=h=He([Be(0,v.$dM),Be(1,I.$8bc),Be(2,E.$Dcc),Be(3,k.$$bc),Be(4,$.$0cc),Be(5,p.$_cc)],h)}),define(De[352],Ce([1,0,8,54,2,6,343,14,103,104,27,238,20,67,46,88]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=e.$5dc=void 0;class u{static async installEarlyHandler(o){Error.stackTraceLimit=100;const m=o.get($.$9i),t=o.get(w.$dM).getProxy(L.$cK.MainThreadErrors);C.setUnexpectedErrorHandler(n=>{m.error(n);const a=C.$3(n);t.$onUnexpectedError(a)})}static async installFullHandler(o){const m=o.get($.$9i),h=o.get(w.$dM),t=o.get(k.$Dcc),n=o.get(p.$xM),a=h.getProxy(L.$cK.MainThreadExtensionService),i=h.getProxy(L.$cK.MainThreadErrors),s=await t.getExtensionPathIndex(),l=new WeakMap;function D(f,g){if(l.has(f))return l.get(f).stack;let P="",N,O;for(const j of g)P+=`
	at ${j.toString()}`,O=j.getFileName(),!N&&O&&(N=s.findSubstr(d.URI.file(O)));const M=`${f.name||"Error"}: ${f.message||""}${P}`;return l.set(f,{extensionIdentifier:N?.identifier,stack:M}),M}const S=Symbol("prepareStackTrace wrapped");let b=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return b},set(f){if(f===D||!f||f[S]){b=f||D;return}b=function(g,P){return D(g,P),f.call(Error,g,P)},Object.assign(b,{[S]:!0})}}),C.setUnexpectedErrorHandler(f=>{m.error(f);const g=C.$3(f),P=l.get(f);if(!P?.extensionIdentifier){i.$onUnexpectedError(g);return}a.$onExtensionRuntimeError(P.extensionIdentifier,g);const N=n.onExtensionError(P.extensionIdentifier,f);m.trace("forwarded error to extension?",N,P)})}}e.$5dc=u;class c{constructor(o,m,h,t,n){this.a=h,this.b=new A.$n4b(o,null,t),m=c.e(m,this.b);const a=new v.$Mh(...(0,E.$vr)());a.set(R.$tM,{_serviceBrand:void 0,...m,messagePorts:n}),a.set(w.$dM,new w.$eM(this.b)),a.set(y.$5bc,new y.$6bc(t)),a.set(k.$Bcc,h);const i=new I.$bq(a,!0);i.invokeFunction(u.installEarlyHandler),this.d=i.invokeFunction(s=>s.get($.$9i)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",m),this.c=i.invokeFunction(s=>s.get(k.$Dcc)),this.c.initialize(),i.invokeFunction(u.installFullHandler)}async asBrowserUri(o){const m=this.b.getProxy(L.$cK.MainThreadExtensionService);return d.URI.revive(await m.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,m){o.extensions.allExtensions.forEach(t=>{t.extensionLocation=d.URI.revive(m.transformIncomingURIs(t.extensionLocation))}),o.environment.appRoot=d.URI.revive(m.transformIncomingURIs(o.environment.appRoot));const h=o.environment.extensionDevelopmentLocationURI;return h&&(o.environment.extensionDevelopmentLocationURI=h.map(t=>d.URI.revive(m.transformIncomingURIs(t)))),o.environment.extensionTestsLocationURI=d.URI.revive(m.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=d.URI.revive(m.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=d.URI.revive(m.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=d.URI.revive(m.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=d.URI.revive(m.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=d.URI.revive(m.transformIncomingURIs(o.logsLocation)),o.workspace=m.transformIncomingURIs(o.workspace),o}}e.$6dc=c}),define(De[353],Ce([1,0,9,12,215,232,138,94,71,46,20,45,7,56,39,272,273,40]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;let r=class extends $.$cdc{constructor(n,a,i,s,l,D,S){super(n,a,i,s,D,S),this.Z=l,this.X=new h}K(n,a){switch(n.type){case"server":return new p.$$dc(n);case"pipeServer":return new p.$_dc(n);case"executable":return new p.$aec(n,a.type)}return super.K(n,a)}T(n,a){const i=p.$aec.platformAdapterExecutable(a.getAllExtensionDescriptions(),n.type);if(i)return new w.$gL(i.command,i.args,i.options)}L(){return new A.$77b}async $runInTerminal(n,a){if(n.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const i=await this.G.getConfigProvider(),s=this.Z.getDefaultShell(!0),l=this.Z.getDefaultShellArgs(!0),D=n.title||d.localize(0,null),S=JSON.stringify({shell:s,shellArgs:l});let b=await this.X.checkout(S,D),f,g=!1;if(b)f=n.cwd;else{const M={shellPath:s,shellArgs:l,cwd:n.cwd,name:D,iconPath:new w.$$K("debug")};g=!0,b=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(b,S)}b.show(!0);const P=await b.processId;g?await new Promise(M=>setTimeout(M,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(s.indexOf("powershell")>=0||s.indexOf("pwsh")>=0||s.indexOf("cmd.exe")>=0?b.sendText("cls"):s.indexOf("bash")>=0?b.sendText("clear"):T.$j?b.sendText("cls"):b.sendText("clear"));const N=(0,u.$cec)(s,n.args,!!n.argsCanBeInterpretedByShell,f,n.env);b.sendText(N);const O=this.onDidTerminateDebugSession(M=>{M.id===a&&(this.X.free(b),O.dispose())});return P}else if(n.kind==="external")return m(n,await this.G.getConfigProvider());return super.$runInTerminal(n,a)}};e.$dec=r,e.$dec=r=He([Be(0,R.$dM),Be(1,k.$8bc),Be(2,v.$Dcc),Be(3,c.$$bc),Be(4,I.$qcc),Be(5,E.$0cc),Be(6,y.$_cc)],r);let o;function m(t,n){if(!o)if(T.$j)o=new L.$N6b;else if(T.$k)o=new L.$O6b;else if(T.$l)o=new L.$P6b;else throw new Error("external terminals not supported on this platform");const a=n.getConfiguration("terminal");return o.runInTerminal(t.title,t.cwd,t.args,t.env||{},a.external||{})}class h{constructor(){this.b=new Map}static{this.a=1e3}async checkout(n,a){const s=[...this.b.entries()].map(([l,D])=>(0,C.$Hg)(async S=>{if(l.name!==a||D.lastUsedAt!==-1&&await(0,u.$bec)(await l.processId))return null;const b=Date.now();return D.lastUsedAt+h.a>b||S.isCancellationRequested||D.config!==n?null:(D.lastUsedAt=b,l)}));return await(0,C.$Yg)(s,l=>!!l)}insert(n,a){this.b.set(n,{lastUsedAt:Date.now(),config:a})}free(n){const a=this.b.get(n);a&&(a.lastUsedAt=-1)}onTerminalClosed(n){this.b.delete(n)}}}),define(De[354],Ce([1,0,16,2,101,39,70,40,44,45,20,27,93,18,14,89,23,63,56]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;let o=class extends w.$7cc{constructor(h,t,n,a,i,s,l,D,S){super(h,t,n,a,i,s,l,D),this.B=n,this.C=S,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(h,t){const n=t;if(!t.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const a=w.TaskHandleDTO.from(n,this.B),i=await this.a.$getTaskExecution(a);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.y(i,t);return this.a.$executeTask(a).catch(()=>{}),s}else{const a=w.TaskDTO.from(t,h);if(a===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(a.execution)&&await this.x(a,t,!1);const i=await this.y(await this.a.$getTaskExecution(a),t);return this.a.$executeTask(a).catch(()=>{}),i}}u(h,t,n,a){const i=[];if(a)for(const s of a){this.z(s,n),(!s.definition||!h[s.definition.type])&&this.f.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const l=w.TaskDTO.from(s,n.extension);l&&(i.push(l),w.CustomExecutionDTO.is(l.execution)&&t.push(this.x(l,s,!0)))}return{tasks:i,extension:n.extension}}async v(h){return h}async F(h){let t=h&&h.length>0?h[0]:void 0;if(!t){const n=T.URI.file((0,c.homedir)());t=new E.$9h({uri:n,name:u.$sg(n),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(h,t){const n=T.URI.revive(h),a={process:void 0,variables:Object.create(null)},i=await this.b.resolveWorkspaceFolder(n),s=await this.b.getWorkspaceFolders2()??[],l=await this.C.getResolver(),D=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(s);for(const S of t.variables)a.variables[S]=await l.resolveAsync(D,S);if(t.process!==void 0){let S;if(t.process.path!==void 0){S=t.process.path.split(C.$tc);for(let b=0;b<S.length;b++)S[b]=await l.resolveAsync(D,S[b])}a.process=await d.win32.findExecutable(await l.resolveAsync(D,t.process.name),t.process.cwd!==void 0?await l.resolveAsync(D,t.process.cwd):void 0,S)}return a}async $jsonTasksSupported(){return!0}async $findExecutable(h,t,n){return d.win32.findExecutable(h,t,n)}};e.$8dc=o,e.$8dc=o=He([Be(0,R.$dM),Be(1,I.$tM),Be(2,L.$8bc),Be(3,A.$oM),Be(4,$.$$bc),Be(5,v.$qcc),Be(6,k.$9i),Be(7,p.$Xbc),Be(8,r.$_cc)],o)}),define(De[355],Ce([1,0,63,56]),function($e,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;class d extends T.$adc{m(){return(0,C.homedir)()}}e.$Nec=d}),define(De[153],Ce([1,0,19,9,21,41,18,16,23,2,36]),function($e,e,C,T,d,L,A,$,E,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=e.$jdc=e.$idc=e.$hdc=void 0;class I{constructor(r,o,m,h){this.d=r,this.e=o,this.f=m,this.g=h,this.a=null,this.b=!1,this.c=0}search(r,o){const m=this.d.folderQueries||[],h=new d.$Xd(o);return new Promise((t,n)=>{this.a=new y(r);let a=!1;const i=(s,l)=>{if(!a&&!this.b){const D=this.h(s);p(s)&&typeof this.d.maxResults=="number"&&this.c+D>this.d.maxResults&&(this.b=!0,a=!0,h.cancel(),s=this.j(s,this.d.maxResults-this.c));const S=this.h(s);this.c+=S,(S>0||!p(s))&&this.a.add(s,l)}};Promise.all(m.map((s,l)=>this.k(s,D=>i(D,l),h.token))).then(s=>{h.dispose(),this.a.flush();const l=s.some(D=>!!D&&!!D.limitHit);t({limitHit:this.b||l,messages:(0,C.$Rb)(s.map(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[])),stats:{type:this.g}})},s=>{h.dispose();const l=(0,L.$zi)(s);n(new Error(l))})})}h(r){return p(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,o){const m=Array.isArray(r.ranges)?r.ranges:[r.ranges],h=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:m.slice(0,o),preview:{matches:h.slice(0,o),text:r.preview.text},uri:r.uri}}async k(r,o,m){const h=new R.$XI(this.d,r),t=[],n={report:s=>{if(!this.l(s))return;const l=r.folder.scheme===A.Schemas.file?(0,R.$YI)(()=>this.f.readdir(E.$ug(s.uri))):void 0,D=E.$xg(r.folder,s.uri);if(D){const S=h.includedInQuery(D,$.$nc(D),l);(0,T.$Gg)(S)?t.push(S.then(b=>{b&&o(s)})):S&&o(s)}}},a=this.n(r),i=await this.e.provideTextSearchResults(w(this.d.contentPattern),a,n,m);return t.length&&await Promise.all(t),i}l(r){if(p(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const o=(0,R.$WI)(this.d.includePattern,r.includePattern),m=(0,R.$WI)(this.d.excludePattern,r.excludePattern),h={folder:v.URI.from(r.folder),excludes:m,includes:o,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.f.toCanonicalName(r.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$hdc=I;function w(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class y{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new u(512,o=>this.g(o))}add(r,o){this.d&&(this.b!==o||!E.$og(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:r.uri,results:[]}),this.d.results.push(k(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$idc=y;function k(c){return p(c)?{preview:{matches:(0,C.$2b)(c.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:c.preview.text},ranges:(0,C.$2b)(c.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function p(c){return!!c.preview}e.$jdc=p;class u{static{this.a=4e3}static{this.b=50}constructor(r,o){this.g=r,this.h=o,this.c=0,this.d=[],this.e=0}addItem(r,o){r&&this.j(r,o)}addItems(r,o){r&&this.k(r,o)}j(r,o){this.d.push(r),this.e+=o,this.l()}k(r,o){this.d=this.d.concat(r),this.e+=o,this.l()}l(){this.c<u.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},u.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$kdc=u}),define(De[95],Ce([1,0,3,6,5,348,20,67,14,2,153]),function($e,e,C,T,d,L,A,$,E,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=e.$mdc=e.$ldc=void 0,e.$ldc=(0,d.$Oh)("IExtHostSearch");let I=class{constructor(p,u,c){this.k=p,this.l=u,this.n=c,this.c=this.k.getProxy(T.$cK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$gdc}o(p){return this.l.transformOutgoingScheme(p)}registerTextSearchProvider(p,u){if(this.g.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this.g.add(p);const c=this.d++;return this.e.set(c,u),this.c.$registerTextSearchProvider(c,this.o(p)),(0,C.$Qc)(()=>{this.g.delete(p),this.e.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(p,u){if(this.i.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this.i.add(p);const c=this.d++;return this.h.set(c,u),this.c.$registerFileSearchProvider(c,this.o(p)),(0,C.$Qc)(()=>{this.i.delete(p),this.h.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(p,u,c,r){const o=w(c),m=this.h.get(p);if(m)return this.j.fileSearch(o,m,h=>{this.c.$handleFileMatch(p,u,h.map(t=>t.resource))},r);throw new Error("unknown provider: "+p)}$clearCache(p){return this.j.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,u,c,r){const o=this.e.get(p);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const m=w(c);return this.q(m,o).search(t=>this.c.$handleTextMatch(p,u,t),r)}$enableExtensionHostSearch(){}q(p,u){return new R.$hdc(p,u,{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}};e.$mdc=I,e.$mdc=I=He([Be(0,A.$dM),Be(1,$.$5bc),Be(2,E.$9i)],I);function w(k){return{...k,folderQueries:k.folderQueries&&k.folderQueries.map(y),extraFileResources:k.extraFileResources&&k.extraFileResources.map(p=>v.URI.revive(p))}}e.$ndc=w;function y(k){return{...k,folder:v.URI.revive(k.folder)}}}),define(De[356],Ce([1,0,21,8,4,38,2,130,125,168,185,30,6,111,302,301,33,303,40,305,306,307,280,308,70,46,310,311,316,317,318,152,284,324,325,328,115,45,330,287,13,7,85,333,91,151,39,25,276,315,66,149,93,94,95,14,67,20,27,319,274,73,89,294,331,90,72,336,334,335,295,55,329,332,114,71,88,320,92,321,18,134,283,263,313,3,26,270,112,257,322,323,296,312,282,314,113,326,299,327,300,293,309,297,298]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r,o,m,h,t,n,a,i,s,l,D,S,b,f,g,P,N,O,M,j,z,F,K,V,fe,Z,Q,X,oe,x,ae,we,G,U,q,me,ee,ne,re,Ee,ce,de,te,he,be,Pe,B,J,ie,se,Y,ge,ye,je,We,_e,Ye,it,et,Ae,Ne,qe,Le,Xe,le,ue,Ie,Ve,Ue,xe,rt,ot,$t,St,Yt,Gt,vt,Ut,Nt,Bt,At,Rt,Ot,Wt,Jt,qt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;function Lt(lt){const ft=lt.get(ce.$tM),Ft=lt.get(je.$Ubc),Kt=lt.get(ie.$ncc),Dt=lt.get(i.$Dcc),ct=lt.get(oe.$8bc),wt=lt.get(et.$xM),Ht=lt.get(r.$$bc),Pt=lt.get(re.$5bc),Ge=lt.get(Ee.$dM),Me=lt.get(M.$jcc),Te=lt.get(J.$occ),Se=lt.get(ne.$0i),_=lt.get(ne.$9i),Fe=lt.get(he.$2vb),Ke=lt.get(be.$Xbc),Ze=lt.get(X.$2cc),Je=lt.get(Ye.$vcc),nt=lt.get(it.$0cc),pt=lt.get(Nt.$zcc);Ge.set(w.$dK.ExtHostFileSystemInfo,Ft),Ge.set(w.$dK.ExtHostLogLevelServiceShape,Se),Ge.set(w.$dK.ExtHostWorkspace,ct),Ge.set(w.$dK.ExtHostConfiguration,Ht),Ge.set(w.$dK.ExtHostExtensionService,Dt),Ge.set(w.$dK.ExtHostStorage,Me),Ge.set(w.$dK.ExtHostTunnelService,Fe),Ge.set(w.$dK.ExtHostWindow,Ze),Ge.set(w.$dK.ExtHostSecretState,Je),Ge.set(w.$dK.ExtHostTelemetry,wt),Ge.set(w.$dK.ExtHostEditorTabs,nt),Ge.set(w.$dK.ExtHostManagedSockets,pt);const jt=Ge.set(w.$dK.ExtHostDecorations,lt.get(U.$6cc)),kt=Ge.set(w.$dK.ExtHostDocumentsAndEditors,lt.get(a.$oM)),ht=Ge.set(w.$dK.ExtHostCommands,lt.get(u.$zM)),gt=Ge.set(w.$dK.ExtHostTerminalService,lt.get(j.$qcc)),yt=Ge.set(w.$dK.ExtHostDebugService,lt.get(me.$bdc)),mi=Ge.set(w.$dK.ExtHostSearch,lt.get(ee.$ldc)),Ct=Ge.set(w.$dK.ExtHostTask,lt.get(q.$9cc)),Di=Ge.set(w.$dK.ExtHostOutputService,lt.get(f.$Lcc)),ui=Ge.set(w.$dK.ExtHostLocalization,lt.get(rt.$ycc)),$i=Ge.set(w.$dK.ExtHostUrls,new Z.$Ucc(Ge)),It=Ge.set(w.$dK.ExtHostDocuments,new n.$Sbc(Ge,kt)),fn=Ge.set(w.$dK.ExtHostDocumentContentProviders,new h.$acc(Ge,kt,_)),ri=Ge.set(w.$dK.ExtHostDocumentSaveParticipant,new t.$bcc(_,It,Ge.getProxy(w.$cK.MainThreadBulkEdits))),Et=Ge.set(w.$dK.ExtHostNotebook,new de.$rdc(Ge,ht,kt,It,Kt)),bi=Ge.set(w.$dK.ExtHostNotebookDocuments,new ue.$Jdc(Et)),vi=Ge.set(w.$dK.ExtHostNotebookEditors,new le.$Idc(_,Et)),si=Ge.set(w.$dK.ExtHostNotebookKernels,new Ae.$Fdc(Ge,ft,Et,ht,_)),Ci=Ge.set(w.$dK.ExtHostNotebookRenderers,new qe.$Hdc(Ge,Et)),Ii=Ge.set(w.$dK.ExtHostNotebookDocumentSaveParticipant,new vt.$Pdc(_,Et,Ge.getProxy(w.$cK.MainThreadBulkEdits))),Mt=Ge.set(w.$dK.ExtHostEditors,new z.$Scc(Ge,kt)),wi=Ge.set(w.$dK.ExtHostTreeViews,new F.$Tcc(Ge.getProxy(w.$cK.MainThreadTreeViews),ht,_)),Pi=Ge.set(w.$dK.ExtHostEditorInsets,new ae.$3cc(Ge.getProxy(w.$cK.MainThreadEditorInsets),Mt,ft.remote)),oi=Ge.set(w.$dK.ExtHostDiagnostics,new o.$Wbc(Ge,_,Ft,kt)),li=Ge.set(w.$dK.ExtHostLanguages,new S.$Icc(Ge,It,ht.converter,Pt)),ut=Ge.set(w.$dK.ExtHostLanguageFeatures,new D.$1bc(Ge,Pt,It,ht,oi,_,Ke,wt)),Ai=Ge.set(w.$dK.ExtHostFileSystem,new s.$Gcc(Ge,ut)),Zt=Ge.set(w.$dK.ExtHostFileSystemEventService,new l.$Hcc(Ge,_,kt)),ii=Ge.set(w.$dK.ExtHostQuickOpen,(0,P.$Ncc)(Ge,ct,ht)),Ri=Ge.set(w.$dK.ExtHostSCM,new N.$Pcc(Ge,ht,It,_)),Li=Ge.set(w.$dK.ExtHostQuickDiff,new St.$Mdc(Ge,Pt)),Mi=Ge.set(w.$dK.ExtHostShare,new Bt.$Rdc(Ge,Pt)),Xi=Ge.set(w.$dK.ExtHostComments,(0,c.$4bc)(Ge,ht,It)),Ti=Ge.set(w.$dK.ExtHostProgress,new g.$Mcc(Ge.getProxy(w.$cK.MainThreadProgress))),Yi=Ge.set(w.$dK.ExtHosLabelService,new we.$4cc(Ge)),Fi=Ge.set(w.$dK.ExtHostTheming,new te.$sdc(Ge)),ai=Ge.set(w.$dK.ExtHostAuthentication,new Pe.$tdc(Ge)),gn=Ge.set(w.$dK.ExtHostTimeline,new B.$vdc(Ge,ht)),Ni=Ge.set(w.$dK.ExtHostWebviews,new Q.$Xcc(Ge,ft.remote,ct,_,Ke)),hi=Ge.set(w.$dK.ExtHostWebviewPanels,new ge.$xdc(Ge,Ni,ct)),Oi=Ge.set(w.$dK.ExtHostCustomEditors,new Y.$ydc(Ge,It,Te,Ni,hi)),mn=Ge.set(w.$dK.ExtHostWebviewViews,new se.$wdc(Ge,Ni)),di=Ge.set(w.$dK.ExtHostTesting,new We.$Adc(Ge,ht,kt)),Zi=Ge.set(w.$dK.ExtHostUriOpeners,new _e.$Edc(Ge)),ji=Ge.set(w.$dK.ExtHostProfileContentHandlers,new $t.$Ldc(Ge));Ge.set(w.$dK.ExtHostInteractive,new Ie.$Kdc(Ge,Et,kt,ht,_));const xi=Ge.set(w.$dK.ExtHostInlineChat,new Gt.$Odc(Ge,ht,It,_)),fi=Ge.set(w.$dK.ExtHostChatProvider,new At.$Sdc(Ge,_)),_i=Ge.set(w.$dK.ExtHostChatAgents,new qt.$Xdc(Ge,fi,_)),$n=Ge.set(w.$dK.ExtHostChatAgents2,new Vt.$Ydc(Ge,fi,_)),zi=Ge.set(w.$dK.ExtHostChatVariables,new Ot.$Udc(Ge)),gi=Ge.set(w.$dK.ExtHostChat,new Yt.$Ndc(Ge,_)),xt=Ge.set(w.$dK.ExtHostAiRelatedInformation,new Wt.$Vdc(Ge)),pi=Ge.set(w.$dK.ExtHostAiEmbeddingVector,new Jt.$Wdc(Ge)),bn=Ge.set(w.$dK.ExtHostIssueReporter,new Ut.$Qdc(Ge)),Qt=Ge.set(w.$dK.ExtHostStatusBar,new O.$Rcc(Ge,ht.converter)),yi=Ge.set(w.$dK.ExtHostSpeech,new Rt.$Tdc(Ge)),en=Object.values(w.$dK);Ge.assertRegistered(en);const tn=new ye.$zdc(Ge,kt),nn=new p.$3bc(Ge),Ei=new b.$Jcc(Ge,_),rn=new m.$_bc(Ge);return k.$2bc.register(ht),function(ze,_t,sn){const mt=function(){let ve=!ze.isUnderDevelopment;function ke(){ve||(_.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ve=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")ke();else{const bt=st;typeof bt.scheme>"u"&&ke(),typeof bt.exclusive=="boolean"&&(0,Ue.$aF)(ze,"documentFiltersExclusive")}return st}}(),Ui={getSession(ve,ke,Oe){return ai.getSession(ze,ve,ke,Oe)},getSessions(ve,ke){return(0,Ue.$aF)(ze,"authGetSessions"),ai.getSessions(ze,ve,ke)},async hasSession(ve,ke){return(0,Ue.$aF)(ze,"authSession"),!!await ai.getSession(ze,ve,ke,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(ve,ke,Oe,st){return ai.registerAuthenticationProvider(ve,ke,Oe,st)}},on={registerCommand(ve,ke,Oe){return ht.registerCommand(!0,ve,ke,Oe,void 0,ze)},registerTextEditorCommand(ve,ke,Oe){return ht.registerCommand(!0,ve,(...st)=>{const bt=Mt.getActiveTextEditor();if(!bt){_.warn("Cannot execute "+ve+" because there is no active text editor.");return}return bt.edit(Tt=>{ke.apply(Oe,[bt,Tt,...st])}).then(Tt=>{Tt||_.warn("Edits from command "+ve+" were not applied.")},Tt=>{_.warn("An error occurred while running command "+ve,Tt)})},void 0,void 0,ze)},registerDiffInformationCommand:(ve,ke,Oe)=>((0,Ue.$aF)(ze,"diffCommand"),ht.registerCommand(!0,ve,async(...st)=>{const bt=kt.activeEditor(!0);if(!bt){_.warn("Cannot execute "+ve+" because there is no active text editor.");return}const Tt=await Mt.getDiffInformation(bt.id);ke.apply(Oe,[Tt,...st])},void 0,void 0,ze)),executeCommand(ve,...ke){return ht.executeCommand(ve,...ke)},getCommands(ve=!1){return ht.getCommands(ve)}},Bi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return gt.onDidChangeShell},get isTelemetryEnabled(){return wt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return wt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ue.$aF)(ze,"telemetry"),wt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ue.$aF)(ze,"telemetry"),wt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.$wM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(ve,ke){return et.$vM.validateSender(ve),wt.instantiateLogger(ze,ve,ke)},openExternal(ve,ke){return Ze.openUri(ve,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(ve){if(ve.scheme===ft.environment.appUriScheme)return $i.createAppUri(ve);try{return await Ze.asExternalUri(ve,{allowTunneling:!!ft.remote.authority})}catch(ke){if((0,Xe.$_T)(ve,Le.Schemas.http)||(0,Xe.$_T)(ve,Le.Schemas.https))return ve;throw ke}},get remoteName(){return(0,G.$Uk)(ft.remote.authority)},get remoteAuthority(){return(0,Ue.$aF)(ze,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return _.getLevel()},get onDidChangeLogLevel(){return _.onDidChangeLogLevel},registerIssueUriRequestHandler(ve){return(0,Ue.$aF)(ze,"handleIssueUri"),bn.registerIssueUriRequestHandler(ze,ve)},get appQuality(){return(0,Ue.$aF)(ze,"resolvers"),ft.quality},get appCommit(){return(0,Ue.$aF)(ze,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Bi);const an={createTestController(ve,ke,Oe){return di.createTestController(ze,ve,ke,Oe)},createTestObserver(){return(0,Ue.$aF)(ze,"testObserver"),di.createTestObserver()},runTests(ve){return(0,Ue.$aF)(ze,"testObserver"),di.runTests(ve)},get onDidChangeTestResults(){return(0,Ue.$aF)(ze,"testObserver"),di.onResultsChanged},get testResults(){return(0,Ue.$aF)(ze,"testObserver"),di.results}},ki=ft.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,vn={getExtension(ve,ke){(0,Ue.$_E)(ze,"extensionsAny")||(ke=!1);const Oe=_t.mine.getExtensionDescription(ve);if(Oe)return new i.$Ecc(Dt,ze.identifier,Oe,ki,!1);if(ke){const st=_t.all.getExtensionDescription(ve);if(st)return new i.$Ecc(Dt,ze.identifier,st,ki,!0)}},get all(){const ve=[];for(const ke of _t.mine.getAllExtensionDescriptions())ve.push(new i.$Ecc(Dt,ze.identifier,ke,ki,!1));return ve},get allAcrossExtensionHosts(){(0,Ue.$aF)(ze,"extensionsAny");const ve=new x.$5l(_t.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ke=[];for(const Oe of _t.all.getAllExtensionDescriptions()){const st=!ve.has(Oe.identifier);ke.push(new i.$Ecc(Dt,ze.identifier,Oe,ki,st))}return ke},get onDidChange(){return(0,Ue.$_E)(ze,"extensionsAny")?d.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},cn={createDiagnosticCollection(ve){return oi.createDiagnosticCollection(ze.identifier,ve)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:ve=>oi.getDiagnostics(ve),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(ve,ke){return li.changeLanguage(ve.uri,ke)},match(ve,ke){const Oe=It.getDocumentData(ke.uri)?.notebook;return(0,R.$oE)(K.LanguageSelector.from(ve),ke.uri,ke.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ve,ke,Oe){return ut.registerCodeActionProvider(ze,mt(ve),ke,Oe)},registerDocumentPasteEditProvider(ve,ke,Oe){return(0,Ue.$aF)(ze,"documentPaste"),ut.registerDocumentPasteEditProvider(ze,mt(ve),ke,Oe)},registerCodeLensProvider(ve,ke){return ut.registerCodeLensProvider(ze,mt(ve),ke)},registerDefinitionProvider(ve,ke){return ut.registerDefinitionProvider(ze,mt(ve),ke)},registerDeclarationProvider(ve,ke){return ut.registerDeclarationProvider(ze,mt(ve),ke)},registerImplementationProvider(ve,ke){return ut.registerImplementationProvider(ze,mt(ve),ke)},registerTypeDefinitionProvider(ve,ke){return ut.registerTypeDefinitionProvider(ze,mt(ve),ke)},registerHoverProvider(ve,ke){return ut.registerHoverProvider(ze,mt(ve),ke,ze.identifier)},registerEvaluatableExpressionProvider(ve,ke){return ut.registerEvaluatableExpressionProvider(ze,mt(ve),ke,ze.identifier)},registerInlineValuesProvider(ve,ke){return ut.registerInlineValuesProvider(ze,mt(ve),ke,ze.identifier)},registerDocumentHighlightProvider(ve,ke){return ut.registerDocumentHighlightProvider(ze,mt(ve),ke)},registerLinkedEditingRangeProvider(ve,ke){return ut.registerLinkedEditingRangeProvider(ze,mt(ve),ke)},registerReferenceProvider(ve,ke){return ut.registerReferenceProvider(ze,mt(ve),ke)},registerRenameProvider(ve,ke){return ut.registerRenameProvider(ze,mt(ve),ke)},registerDocumentSymbolProvider(ve,ke,Oe){return ut.registerDocumentSymbolProvider(ze,mt(ve),ke,Oe)},registerWorkspaceSymbolProvider(ve){return ut.registerWorkspaceSymbolProvider(ze,ve)},registerDocumentFormattingEditProvider(ve,ke){return ut.registerDocumentFormattingEditProvider(ze,mt(ve),ke)},registerDocumentRangeFormattingEditProvider(ve,ke){return ut.registerDocumentRangeFormattingEditProvider(ze,mt(ve),ke)},registerOnTypeFormattingEditProvider(ve,ke,Oe,...st){return ut.registerOnTypeFormattingEditProvider(ze,mt(ve),ke,[Oe].concat(st))},registerDocumentSemanticTokensProvider(ve,ke,Oe){return ut.registerDocumentSemanticTokensProvider(ze,mt(ve),ke,Oe)},registerDocumentRangeSemanticTokensProvider(ve,ke,Oe){return ut.registerDocumentRangeSemanticTokensProvider(ze,mt(ve),ke,Oe)},registerSignatureHelpProvider(ve,ke,Oe,...st){return typeof Oe=="object"?ut.registerSignatureHelpProvider(ze,mt(ve),ke,Oe):ut.registerSignatureHelpProvider(ze,mt(ve),ke,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(ve,ke,...Oe){return ut.registerCompletionItemProvider(ze,mt(ve),ke,Oe)},registerInlineCompletionItemProvider(ve,ke,Oe){return ke.handleDidShowCompletionItem&&(0,Ue.$aF)(ze,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,Ue.$aF)(ze,"inlineCompletionsAdditions"),Oe&&(0,Ue.$aF)(ze,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(ze,mt(ve),ke,Oe)},registerDocumentLinkProvider(ve,ke){return ut.registerDocumentLinkProvider(ze,mt(ve),ke)},registerColorProvider(ve,ke){return ut.registerColorProvider(ze,mt(ve),ke)},registerFoldingRangeProvider(ve,ke){return ut.registerFoldingRangeProvider(ze,mt(ve),ke)},registerSelectionRangeProvider(ve,ke){return ut.registerSelectionRangeProvider(ze,ve,ke)},registerCallHierarchyProvider(ve,ke){return ut.registerCallHierarchyProvider(ze,ve,ke)},registerTypeHierarchyProvider(ve,ke){return ut.registerTypeHierarchyProvider(ze,ve,ke)},setLanguageConfiguration:(ve,ke)=>ut.setLanguageConfiguration(ze,ve,ke),getTokenInformationAtPosition(ve,ke){return(0,Ue.$aF)(ze,"tokenInformation"),li.tokenAtPosition(ve,ke)},registerInlayHintsProvider(ve,ke){return ut.registerInlayHintsProvider(ze,ve,ke)},createLanguageStatusItem(ve,ke){return li.createLanguageStatusItem(ze,ve,ke)},registerDocumentDropEditProvider(ve,ke,Oe){return ut.registerDocumentOnDropEditProvider(ze,ve,ke,(0,Ue.$_E)(ze,"dropMetadata")?Oe:void 0)}},un={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(ve,ke,Oe){const st=await(A.URI.isUri(ve)?Promise.resolve(Si.openTextDocument(ve)):Promise.resolve(ve));return Mt.showTextDocument(st,ke,Oe)},createTextEditorDecorationType(ve){return Mt.createTextEditorDecorationType(ze,ve)},onDidChangeActiveTextEditor(ve,ke,Oe){return Mt.onDidChangeActiveTextEditor(ve,ke,Oe)},onDidChangeVisibleTextEditors(ve,ke,Oe){return Mt.onDidChangeVisibleTextEditors(ve,ke,Oe)},onDidChangeTextEditorSelection(ve,ke,Oe){return Mt.onDidChangeTextEditorSelection(ve,ke,Oe)},onDidChangeTextEditorOptions(ve,ke,Oe){return Mt.onDidChangeTextEditorOptions(ve,ke,Oe)},onDidChangeTextEditorVisibleRanges(ve,ke,Oe){return Mt.onDidChangeTextEditorVisibleRanges(ve,ke,Oe)},onDidChangeTextEditorViewColumn(ve,ke,Oe){return Mt.onDidChangeTextEditorViewColumn(ve,ke,Oe)},onDidCloseTerminal(ve,ke,Oe){return gt.onDidCloseTerminal(ve,ke,Oe)},onDidOpenTerminal(ve,ke,Oe){return gt.onDidOpenTerminal(ve,ke,Oe)},onDidChangeActiveTerminal(ve,ke,Oe){return gt.onDidChangeActiveTerminal(ve,ke,Oe)},onDidChangeTerminalDimensions(ve,ke,Oe){return(0,Ue.$aF)(ze,"terminalDimensions"),gt.onDidChangeTerminalDimensions(ve,ke,Oe)},onDidChangeTerminalState(ve,ke,Oe){return gt.onDidChangeTerminalState(ve,ke,Oe)},onDidWriteTerminalData(ve,ke,Oe){return(0,Ue.$aF)(ze,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(ve,ke,Oe)},onDidExecuteTerminalCommand(ve,ke,Oe){return(0,Ue.$aF)(ze,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(ve,ke,Oe)},get state(){return Ze.getState(ze)},onDidChangeWindowState(ve,ke,Oe){return Ze.onDidChangeWindowState(ve,ke,Oe)},showInformationMessage(ve,...ke){return Ei.showMessage(ze,L.default.Info,ve,ke[0],ke.slice(1))},showWarningMessage(ve,...ke){return Ei.showMessage(ze,L.default.Warning,ve,ke[0],ke.slice(1))},showErrorMessage(ve,...ke){return Ei.showMessage(ze,L.default.Error,ve,ke[0],ke.slice(1))},showQuickPick(ve,ke,Oe){return ii.showQuickPick(ze,ve,ke,Oe)},showWorkspaceFolderPick(ve){return ii.showWorkspaceFolderPick(ve)},showInputBox(ve,ke){return ii.showInput(ve,ke)},showOpenDialog(ve){return rn.showOpenDialog(ze,ve)},showSaveDialog(ve){return rn.showSaveDialog(ve)},createStatusBarItem(ve,ke,Oe){let st,bt,Tt;return typeof ve=="string"?(st=ve,bt=ke,Tt=Oe):(bt=ve,Tt=ke),Qt.createStatusBarEntry(ze,st,bt,Tt)},setStatusBarMessage(ve,ke){return Qt.setStatusBarMessage(ve,ke)},withScmProgress(ve){return Ke.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Ti.withProgress(ze,{location:V.ProgressLocation.SourceControl},(ke,Oe)=>ve({report(st){}}))},withProgress(ve,ke){return Ti.withProgress(ze,ve,ke)},createOutputChannel(ve,ke){return Di.createOutputChannel(ve,ke,ze)},createWebviewPanel(ve,ke,Oe,st){return hi.createWebviewPanel(ze,ve,ke,Oe,st)},createWebviewTextEditorInset(ve,ke,Oe,st){return(0,Ue.$aF)(ze,"editorInsets"),Pi.createWebviewEditorInset(ve,ke,Oe,st,ze)},createTerminal(ve,ke,Oe){return typeof ve=="object"?"pty"in ve?gt.createExtensionTerminal(ve):gt.createTerminalFromOptions(ve):gt.createTerminal(ve,ke,Oe)},registerTerminalLinkProvider(ve){return gt.registerLinkProvider(ve)},registerTerminalProfileProvider(ve,ke){return gt.registerProfileProvider(ze,ve,ke)},registerTerminalQuickFixProvider(ve,ke){return(0,Ue.$aF)(ze,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(ve,ze.identifier.value,ke)},registerTreeDataProvider(ve,ke){return wi.registerTreeDataProvider(ve,ke,ze)},createTreeView(ve,ke){return wi.createTreeView(ve,ke,ze)},registerWebviewPanelSerializer:(ve,ke)=>hi.registerWebviewPanelSerializer(ze,ve,ke),registerCustomEditorProvider:(ve,ke,Oe={})=>Oi.registerCustomEditorProvider(ze,ve,ke,Oe),registerFileDecorationProvider(ve){return jt.registerFileDecorationProvider(ve,ze)},registerUriHandler(ve){return $i.registerUriHandler(ze,ve)},createQuickPick(){return ii.createQuickPick(ze)},createInputBox(){return ii.createInputBox(ze)},get activeColorTheme(){return Fi.activeColorTheme},onDidChangeActiveColorTheme(ve,ke,Oe){return Fi.onDidChangeActiveColorTheme(ve,ke,Oe)},registerWebviewViewProvider(ve,ke,Oe){return mn.registerWebviewViewProvider(ze,ve,ke,Oe?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ve,ke,Oe){return Et.onDidChangeActiveNotebookEditor(ve,ke,Oe)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ve,ke,Oe){return vi.onDidChangeNotebookEditorSelection(ve,ke,Oe)},onDidChangeNotebookEditorVisibleRanges(ve,ke,Oe){return vi.onDidChangeNotebookEditorVisibleRanges(ve,ke,Oe)},showNotebookDocument(ve,ke){return Et.showNotebookDocument(ve,ke)},registerExternalUriOpener(ve,ke,Oe){return(0,Ue.$aF)(ze,"externalUriOpener"),Zi.registerExternalUriOpener(ze.identifier,ve,ke,Oe)},registerProfileContentHandler(ve,ke){return(0,Ue.$aF)(ze,"profileContentHandlers"),ji.registrProfileContentHandler(ze,ve,ke)},registerQuickDiffProvider(ve,ke,Oe,st){return(0,Ue.$aF)(ze,"quickDiffProvider"),Li.registerQuickDiffProvider(mt(ve),ke,Oe,st)},get tabGroups(){return nt.tabGroups},registerShareProvider(ve,ke){return(0,Ue.$aF)(ze,"shareProvider"),Mi.registerShareProvider(mt(ve),ke)}},Si={get rootPath(){return Ke.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ct.getPath()},set rootPath(ve){throw new T.$9("rootPath")},getWorkspaceFolder(ve){return ct.getWorkspaceFolder(ve)},get workspaceFolders(){return ct.getWorkspaceFolders()},get name(){return ct.name},set name(ve){throw new T.$9("name")},get workspaceFile(){return ct.workspaceFile},set workspaceFile(ve){throw new T.$9("workspaceFile")},updateWorkspaceFolders:(ve,ke,...Oe)=>ct.updateWorkspaceFolders(ze,ve,ke||0,...Oe),onDidChangeWorkspaceFolders:function(ve,ke,Oe){return ct.onDidChangeWorkspace(ve,ke,Oe)},asRelativePath:(ve,ke)=>ct.getRelativePath(ve,ke),findFiles:(ve,ke,Oe,st)=>ct.findFiles(ve,ke,Oe,ze.identifier,st),findTextInFiles:(ve,ke,Oe,st)=>{(0,Ue.$aF)(ze,"findTextInFiles");let bt,Tt;return typeof ke=="object"?(bt=ke,Tt=Oe):(bt={},Tt=ke,st=Oe),ct.findTextInFiles(ve,bt||{},Tt,ze.identifier,st)},save:ve=>((0,Ue.$aF)(ze,"saveEditor"),ct.save(ve)),saveAs:ve=>((0,Ue.$aF)(ze,"saveEditor"),ct.saveAs(ve)),saveAll:ve=>ct.saveAll(ve),applyEdit(ve,ke){return tn.applyWorkspaceEdit(ve,ze,ke)},createFileSystemWatcher:(ve,ke,Oe,st)=>{let bt;return typeof ke=="boolean"?bt={ignoreCreateEvents:!!ke,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!st}:ke&&((0,Ue.$aF)(ze,"createFileSystemWatcher"),bt=ke),Zt.createFileSystemWatcher(ct,ze,ve,bt)},get textDocuments(){return It.getAllDocumentData().map(ve=>ve.document)},set textDocuments(ve){throw new T.$9("textDocuments")},openTextDocument(ve){let ke;const Oe=ve;if(typeof ve=="string")ke=Promise.resolve(A.URI.file(ve));else if(A.URI.isUri(ve))ke=Promise.resolve(ve);else if(!Oe||typeof Oe=="object")ke=It.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(st=>It.ensureDocumentData(st).then(bt=>bt.document))},onDidOpenTextDocument:(ve,ke,Oe)=>It.onDidAddDocument(ve,ke,Oe),onDidCloseTextDocument:(ve,ke,Oe)=>It.onDidRemoveDocument(ve,ke,Oe),onDidChangeTextDocument:(ve,ke,Oe)=>It.onDidChangeDocument(ve,ke,Oe),onDidSaveTextDocument:(ve,ke,Oe)=>It.onDidSaveDocument(ve,ke,Oe),onWillSaveTextDocument:(ve,ke,Oe)=>ri.getOnWillSaveTextDocumentEvent(ze)(ve,ke,Oe),get notebookDocuments(){return Et.notebookDocuments.map(ve=>ve.apiNotebook)},async openNotebookDocument(ve,ke){let Oe;if(A.URI.isUri(ve))Oe=ve,await Et.openNotebookDocument(ve);else if(typeof ve=="string")Oe=A.URI.revive(await Et.createNotebookDocument({viewType:ve,content:ke}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ve,ke,Oe){return bi.onDidSaveNotebookDocument(ve,ke,Oe)},onDidChangeNotebookDocument(ve,ke,Oe){return bi.onDidChangeNotebookDocument(ve,ke,Oe)},onWillSaveNotebookDocument(ve,ke,Oe){return Ii.getOnWillSaveNotebookDocumentEvent(ze)(ve,ke,Oe)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ve,ke,Oe,st){return Et.registerNotebookSerializer(ze,ve,ke,Oe,(0,Ue.$_E)(ze,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(ve,ke,Oe)=>sn.onDidChangeConfiguration(ve,ke,Oe),getConfiguration(ve,ke){return ke=arguments.length===1?void 0:ke,sn.getConfiguration(ve,ke,ze)},registerTextDocumentContentProvider(ve,ke){return fn.registerTextDocumentContentProvider(ve,ke)},registerTaskProvider:(ve,ke)=>(Ke.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(ze,ve,ke)),registerFileSystemProvider(ve,ke,Oe){return(0,Ve.$Pc)(Ai.registerFileSystemProvider(ze,ve,ke,Oe),Kt.addFileSystemProvider(ve,ke,Oe))},get fs(){return Kt.value},registerFileSearchProvider:(ve,ke)=>((0,Ue.$aF)(ze,"fileSearchProvider"),mi.registerFileSearchProvider(ve,ke)),registerTextSearchProvider:(ve,ke)=>((0,Ue.$aF)(ze,"textSearchProvider"),mi.registerTextSearchProvider(ve,ke)),registerRemoteAuthorityResolver:(ve,ke)=>((0,Ue.$aF)(ze,"resolvers"),Dt.registerRemoteAuthorityResolver(ve,ke)),registerResourceLabelFormatter:ve=>((0,Ue.$aF)(ze,"resolvers"),Yi.$registerResourceLabelFormatter(ve)),getRemoteExecServer:ve=>((0,Ue.$aF)(ze,"resolvers"),Dt.getRemoteExecServer(ve)),onDidCreateFiles:(ve,ke,Oe)=>Zt.onDidCreateFile(ve,ke,Oe),onDidDeleteFiles:(ve,ke,Oe)=>Zt.onDidDeleteFile(ve,ke,Oe),onDidRenameFiles:(ve,ke,Oe)=>Zt.onDidRenameFile(ve,ke,Oe),onWillCreateFiles:(ve,ke,Oe)=>Zt.getOnWillCreateFileEvent(ze)(ve,ke,Oe),onWillDeleteFiles:(ve,ke,Oe)=>Zt.getOnWillDeleteFileEvent(ze)(ve,ke,Oe),onWillRenameFiles:(ve,ke,Oe)=>Zt.getOnWillRenameFileEvent(ze)(ve,ke,Oe),openTunnel:ve=>((0,Ue.$aF)(ze,"tunnels"),Fe.openTunnel(ze,ve).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,Ue.$aF)(ze,"tunnels"),Fe.getTunnels()},onDidChangeTunnels:(ve,ke,Oe)=>((0,Ue.$aF)(ze,"tunnels"),Fe.onDidChangeTunnels(ve,ke,Oe)),registerPortAttributesProvider:(ve,ke)=>((0,Ue.$aF)(ze,"portsAttributes"),Fe.registerPortsAttributesProvider(ve,ke)),registerTunnelProvider:(ve,ke)=>((0,Ue.$aF)(ze,"tunnelFactory"),Fe.registerTunnelProvider(ve,ke)),registerTimelineProvider:(ve,ke)=>((0,Ue.$aF)(ze,"timeline"),gn.registerTimelineProvider(ve,ke,ze.identifier,ht.converter)),get isTrusted(){return ct.trusted},requestWorkspaceTrust:ve=>((0,Ue.$aF)(ze,"workspaceTrust"),ct.requestWorkspaceTrust(ve)),onDidGrantWorkspaceTrust:(ve,ke,Oe)=>ct.onDidGrantWorkspaceTrust(ve,ke,Oe),registerEditSessionIdentityProvider:(ve,ke)=>((0,Ue.$aF)(ze,"editSessionIdentityProvider"),ct.registerEditSessionIdentityProvider(ve,ke)),onWillCreateEditSessionIdentity:(ve,ke,Oe)=>((0,Ue.$aF)(ze,"editSessionIdentityProvider"),ct.getOnWillCreateEditSessionIdentityEvent(ze)(ve,ke,Oe)),registerCanonicalUriProvider:(ve,ke)=>((0,Ue.$aF)(ze,"canonicalUriProvider"),ct.registerCanonicalUriProvider(ve,ke)),getCanonicalUri:(ve,ke,Oe)=>((0,Ue.$aF)(ze,"canonicalUriProvider"),ct.provideCanonicalUri(ve,ke,Oe))},Wi={get inputBox(){return Ke.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(ze)},createSourceControl(ve,ke,Oe){return Ri.createSourceControl(ze,ve,ke,Oe)}},qi={createCommentController(ve,ke){return Xi.createCommentController(ze,ve,ke)}},ci={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get stackFrameFocus(){return yt.stackFrameFocus},onDidStartDebugSession(ve,ke,Oe){return yt.onDidStartDebugSession(ve,ke,Oe)},onDidTerminateDebugSession(ve,ke,Oe){return yt.onDidTerminateDebugSession(ve,ke,Oe)},onDidChangeActiveDebugSession(ve,ke,Oe){return yt.onDidChangeActiveDebugSession(ve,ke,Oe)},onDidReceiveDebugSessionCustomEvent(ve,ke,Oe){return yt.onDidReceiveDebugSessionCustomEvent(ve,ke,Oe)},onDidChangeBreakpoints(ve,ke,Oe){return yt.onDidChangeBreakpoints(ve,ke,Oe)},onDidChangeStackFrameFocus(ve,ke,Oe){return(0,Ue.$aF)(ze,"debugFocus"),yt.onDidChangeStackFrameFocus(ve,ke,Oe)},registerDebugConfigurationProvider(ve,ke,Oe){return yt.registerDebugConfigurationProvider(ve,ke,Oe||xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ve,ke){return yt.registerDebugAdapterDescriptorFactory(ze,ve,ke)},registerDebugAdapterTrackerFactory(ve,ke){return yt.registerDebugAdapterTrackerFactory(ve,ke)},startDebugging(ve,ke,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?yt.startDebugging(ve,ke,{parentSession:Oe}):yt.startDebugging(ve,ke,Oe||{})},stopDebugging(ve){return yt.stopDebugging(ve)},addBreakpoints(ve){return yt.addBreakpoints(ve)},removeBreakpoints(ve){return yt.removeBreakpoints(ve)},asDebugSourceUri(ve,ke){return yt.asDebugSourceUri(ve,ke)}},Vi={registerTaskProvider:(ve,ke)=>Ct.registerTaskProvider(ze,ve,ke),fetchTasks:ve=>Ct.fetchTasks(ve),executeTask:ve=>Ct.executeTask(ze,ve),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(ve,ke,Oe)=>Ct.onDidStartTask(ve,ke,Oe),onDidEndTask:(ve,ke,Oe)=>Ct.onDidEndTask(ve,ke,Oe),onDidStartTaskProcess:(ve,ke,Oe)=>Ct.onDidStartTaskProcess(ve,ke,Oe),onDidEndTaskProcess:(ve,ke,Oe)=>Ct.onDidEndTaskProcess(ve,ke,Oe)},Ki={createNotebookController(ve,ke,Oe,st,bt){return si.createNotebookController(ze,ve,ke,Oe,st,(0,Ue.$_E)(ze,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(ve,ke)=>Et.registerNotebookCellStatusBarItemProvider(ze,ve,ke),createRendererMessaging(ve){return Ci.createRendererMessaging(ze,ve)},createNotebookControllerDetectionTask(ve){return(0,Ue.$aF)(ze,"notebookKernelSource"),si.createNotebookControllerDetectionTask(ze,ve)},registerKernelSourceActionProvider(ve,ke){return(0,Ue.$aF)(ze,"notebookKernelSource"),si.registerKernelSourceActionProvider(ze,ve,ke)},onDidChangeNotebookCellExecutionState(ve,ke,Oe){return(0,Ue.$aF)(ze,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(ve,ke,Oe)}},Hi={t(...ve){if(typeof ve[0]=="string"){const ke=ve.shift(),Oe=!ve||typeof ve[0]!="object"?ve:ve[0];return ui.getMessage(ze.identifier.value,{message:ke,args:Oe})}return ui.getMessage(ze.identifier.value,ve[0])},get bundle(){return ui.getBundle(ze.identifier.value)},get uri(){return ui.getBundleUri(ze.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(ve,ke){return(0,Ue.$aF)(ze,"interactive"),xi.registerProvider(ze,ve,ke={label:ke?.label??ze.displayName??ze.name})},registerInteractiveSessionProvider(ve,ke){return(0,Ue.$aF)(ze,"interactive"),gi.registerChatProvider(ze,ve,ke)},sendInteractiveRequestToProvider(ve,ke){return(0,Ue.$aF)(ze,"interactive"),gi.sendInteractiveRequestToProvider(ve,ke)},get onDidPerformUserAction(){return(0,Ue.$aF)(ze,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(ve,ke){return(0,Ue.$aF)(ze,"interactive"),gi.transferChatSession(ve,ke)}},ln={getRelatedInformation(ve,ke){return(0,Ue.$aF)(ze,"aiRelatedInformation"),xt.getRelatedInformation(ze,ve,ke)},registerRelatedInformationProvider(ve,ke){return(0,Ue.$aF)(ze,"aiRelatedInformation"),xt.registerRelatedInformationProvider(ze,ve,ke)},registerEmbeddingVectorProvider(ve,ke){return(0,Ue.$aF)(ze,"aiRelatedInformation"),pi.registerEmbeddingVectorProvider(ze,ve,ke)}},hn={registerChatResponseProvider(ve,ke,Oe){return(0,Ue.$aF)(ze,"chatProvider"),fi.registerProvider(ze.identifier,ve,ke,Oe)},requestChatAccess(ve){return(0,Ue.$aF)(ze,"chatRequestAccess"),fi.requestChatResponseProvider(ze.identifier,ve)},registerVariable(ve,ke,Oe){return(0,Ue.$aF)(ze,"chatVariables"),zi.registerVariableResolver(ze,ve,ke,Oe)},registerMappedEditsProvider(ve,ke){return(0,Ue.$aF)(ze,"mappedEditsProvider"),ut.registerMappedEditsProvider(ze,ve,ke)},createChatAgent(ve,ke){return(0,Ue.$aF)(ze,"chatAgents2"),$n.createChatAgent(ze.identifier,ve,ke)},registerAgent(ve,ke,Oe){return(0,Ue.$aF)(ze,"chatAgents"),_i.registerAgent(ze.identifier,ve,ke,Oe)}},dn={registerSpeechProvider(ve,ke){return(0,Ue.$aF)(ze,"speech"),yi.registerProvider(ze.identifier,ve,ke)}};return{version:ft.version,ai:ln,authentication:Ui,commands:on,comments:qi,chat:hn,debug:ci,env:Bi,extensions:vn,interactive:Gi,l10n:Hi,languages:cn,notebooks:Ki,scm:Wi,speech:dn,tasks:Vi,tests:an,window:un,workspace:Si,Breakpoint:V.$cL,TerminalOutputAnchor:V.TerminalOutputAnchor,ChatMessage:V.$5L,ChatMessageRole:V.ChatMessageRole,ChatVariableLevel:V.ChatVariableLevel,CallHierarchyIncomingCall:V.$BK,CallHierarchyItem:V.$AK,CallHierarchyOutgoingCall:V.$CK,CancellationError:T.$5,CancellationTokenSource:C.$Xd,CandidatePortSource:w.CandidatePortSource,CodeAction:V.$xK,CodeActionKind:V.$yK,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.$DK,Color:V.$QK,ColorInformation:V.$RK,ColorPresentation:V.$SK,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentState:V.CommentState,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.$KK,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.$LK,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.$1K,DebugAdapterExecutable:V.$gL,DebugAdapterInlineImplementation:V.$jL,DebugAdapterNamedPipeServer:V.$iL,DebugAdapterServer:V.$hL,DebugConfigurationProviderTriggerKind:xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.$sK,DiagnosticRelatedInformation:V.$rK,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.$eK,DocumentHighlight:V.$uK,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.$PK,DocumentSymbol:V.$wK,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.$mL,InlineValueText:V.$nL,InlineValueVariableLookup:V.$oL,InlineValueEvaluatableExpression:V.$pL,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:d.$Nd,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.$zL,FileDecoration2:V.$zL,FileSystemError:V.$rL,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:V.$sL,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.$eL,InlineCompletionItem:V.$MK,InlineCompletionList:V.$NK,Hover:V.$tK,IndentAction:v.IndentAction,Location:V.$qK,MarkdownString:V.$EK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:V.$FK,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.$fK,ProcessExecution:V.$YK,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.$yL,Range:V.$gK,RelativePattern:V.$aL,Selection:V.$hK,SelectionRange:V.$zK,SemanticTokens:V.$vL,SemanticTokensBuilder:V.$uL,SemanticTokensEdit:V.$wL,SemanticTokensEdits:V.$xL,SemanticTokensLegend:V.$tL,ShellExecution:V.$ZK,ShellQuoting:V.ShellQuoting,SignatureHelp:V.$HK,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.$GK,SnippetString:V.$pK,SourceBreakpoint:V.$dL,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.$vK,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.$2K,TaskGroup:V.$XK,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.$TK,TerminalQuickFixExecuteTerminalCommand:V.$VK,TerminalQuickFixOpener:V.$UK,TerminalLocation:V.TerminalLocation,TerminalProfile:V.$WK,TerminalExitReason:V.TerminalExitReason,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.$lK,SnippetTextEdit:V.$nK,TextEditorCursorStyle:$.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,SyntaxTokenType:V.SyntaxTokenType,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.$_K,ThemeIcon:V.$$K,TreeItem:V.$3K,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.$UL,UIKind:y.UIKind,Uri:A.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.$oK,DocumentDropEdit:V.$9K,DocumentPasteEdit:V.$0K,InlayHint:V.$JK,InlayHintLabelPart:V.$IK,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.$kK,ResolvedAuthority:V.$iK,ManagedResolvedAuthority:V.$jK,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.$JL,NotebookRange:V.$BL,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.$CL,NotebookData:V.$DL,NotebookRendererScript:V.$HL,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.$FL,NotebookCellOutputItem:V.$EL,NotebookCellStatusBarItem:V.$GL,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.$mK,NotebookKernelSourceAction:V.$IL,PortAttributes:V.$LL,LinkedEditingRanges:V.$KL,TestResultState:V.TestResultState,TestRunRequest:V.$ML,TestMessage:V.$NL,TestMessage2:V.$NL,TestTag:V.$OL,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:Ne.TextSearchCompleteMessageType,DataTransfer:V.$8K,DataTransferItem:V.$4K,CoveredCount:V.$PL,FileCoverage:V.$QL,StatementCoverage:V.$RL,BranchCoverage:V.$SL,FunctionCoverage:V.$TL,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.$VL,TabInputTextDiff:V.$WL,TabInputTextMerge:V.$XL,TabInputCustom:V.$YL,TabInputNotebook:V.$1L,TabInputNotebookDiff:V.$2L,TabInputWebview:V.$ZL,TabInputTerminal:V.$3L,TabInputInteractiveWindow:V.$4L,TelemetryTrustedValue:fe.$ho,LogLevel:ne.LogLevel,EditSessionIdentityMatch:ot.EditSessionIdentityMatch,InteractiveSessionVoteDirection:V.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:V.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:V.InteractiveEditorResponseFeedbackKind,StackFrameFocus:V.$kL,ThreadFocus:V.$lL,RelatedInformationType:V.RelatedInformationType,SpeechToTextStatus:V.SpeechToTextStatus}}}e.$Zdc=Lt}),define(De[357],Ce([1,0,103,152,39,149,40,33,70,45,93,94,95,115,73,89,151,72,55,114,88,71,150,14,56,112,113]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r,o,m,h,t,n,a,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$ur)(i.$ycc,i.$xcc,1),(0,C.$ur)(n.$0i,t.$1dc,1),(0,C.$ur)(p.$Xbc,p.$Ybc,1),(0,C.$ur)($.$zM,$.$yM,0),(0,C.$ur)(A.$$bc,A.$9bc,0),(0,C.$ur)(c.$ncc,c.$mcc,0),(0,C.$ur)(I.$bdc,I.$fdc,0),(0,C.$ur)(L.$6cc,L.$5cc,0),(0,C.$ur)(E.$oM,E.$nM,0),(0,C.$ur)(s.$zcc,s.$Acc,0),(0,C.$ur)(r.$Ubc,r.$Tbc,0),(0,C.$ur)(T.$Lcc,T.$Kcc,1),(0,C.$ur)(w.$ldc,w.$mdc,0),(0,C.$ur)(y.$jcc,y.$icc,0),(0,C.$ur)(R.$9cc,R.$8cc,0),(0,C.$ur)(v.$qcc,v.$tcc,0),(0,C.$ur)(k.$2vb,k.$3vb,0),(0,C.$ur)(u.$2cc,u.$1cc,0),(0,C.$ur)(d.$8bc,d.$7bc,0),(0,C.$ur)(o.$vcc,o.$ucc,0),(0,C.$ur)(m.$xM,m.$uM,0),(0,C.$ur)(h.$0cc,h.$$cc,0),(0,C.$ur)(a.$_cc,a.$adc,0)}),define(De[116],Ce([1,0,19,14,36,92]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=e.$fec=e.$eec=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$eec=A;function $(I,w,y,k){const p=(0,C.$2b)(y,E),u=new d.$JI(w,p,k),c=u.preview.matches;return{ranges:(0,C.$2b)(p,v),uri:I,preview:{text:u.preview.text,matches:(0,C.$2b)(c,v)}}}e.$fec=$;function E(I){return new d.$KI(I.start.line,I.start.character,I.end.line,I.end.character)}function v(I){return new L.$yI(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let R=class{constructor(w,y){this.a=w,this.b=y}appendLine(w){this.b.debug(`${this.a}#search`,w)}};e.$gec=R,e.$gec=R=He([Be(1,T.$9i)],R)}),define(De[358],Ce([1,0,49,16,77,32,12,15,116,359]),function($e,e,C,T,d,L,A,$,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=e.$iec=e.$hec=void 0;const R=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(o,m,h,t){const n=w(o,m,h,t),a=m.folder.fsPath;return{cmd:C.spawn(R,n.args,{cwd:a}),rgDiskPath:R,siblingClauses:n.siblingClauses,rgArgs:n,cwd:a}}e.$hec=I;function w(o,m,h,t){const n=["--files","--hidden","--case-sensitive","--no-require-git"];k([m],h,!1).forEach(i=>{const s=(0,E.$eec)(i);if(n.push("-g",s),A.$k){const l=(0,d.$nl)(s);l!==s&&n.push("-g",l)}});const a=y([m],t,void 0,!1);return a.globArgs.forEach(i=>{const s=`!${(0,E.$eec)(i)}`;if(n.push("-g",s),A.$k){const l=(0,d.$nl)(s);l!==s&&n.push("-g",l)}}),m.disregardIgnoreFiles!==!1?n.push("--no-ignore"):m.disregardParentIgnoreFiles!==!1&&n.push("--no-ignore-parent"),m.ignoreSymlinks||n.push("--follow"),o.exists&&n.push("--quiet"),n.push("--no-config"),m.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:a.siblingClauses}}function y(o,m,h,t=!0){const n=[];let a={};return o.forEach(i=>{const s=Object.assign({},i.excludePattern||{},m||{}),l=p(s,t?i.folder.fsPath:void 0,h);n.push(...l.globArgs),l.siblingClauses&&(a=Object.assign(a,l.siblingClauses))}),{globArgs:n,siblingClauses:a}}function k(o,m,h=!0){const t=[];return o.forEach(n=>{const a=Object.assign({},m||{},n.includePattern||{}),i=p(a,h?n.folder.fsPath:void 0);t.push(...i.globArgs)}),t}function p(o,m,h){const t=[],n={};return Object.keys(o).forEach(a=>{if(h&&h.has(a)||!a)return;const i=o[a];a=c(m?u(m,a):a),a.startsWith("\\\\")?a="\\\\"+a.substr(2).replace(/\\/g,"/"):a=a.replace(/\\/g,"/"),typeof i=="boolean"&&i?(a.startsWith("\\\\")&&(a+="**"),t.push(r(a))):i&&i.when&&(n[a]=i)}),{globArgs:t,siblingClauses:n}}function u(o,m){return T.$ic(m)?m:T.$jc(o,m)}e.$iec=u;function c(o){return o=$.$Ke(o,"\\"),$.$Ke(o,"/")}function r(o){return L.$Tf(o).toLowerCase()==="c:/"?o.replace(/^c:[/\\]/i,"/"):o}e.$jec=r}),define(De[360],Ce([1,0,49,53,16,361,19,41,35,77,32,12,37,15,17,29,36,358,127]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=e.$kec=void 0;const o=new Set;process.on("exit",()=>{o.forEach(a=>a())});class m{constructor(i){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=i,this.b=i.filePattern||"",this.d=i.includePattern&&E.$vj(i.includePattern),this.f=i.maxResults||null,this.g=!!i.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,r.$wq)(this.b).normalizedLowercase),this.u=i.excludePattern&&E.$vj(i.excludePattern),this.t=new Map,i.folderQueries.forEach(s=>{const l=Object.assign({},s.excludePattern||{},this.a.excludePattern||{}),D=s.folder.fsPath;i.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==D).forEach(S=>{(0,R.$Xf)(S,D)&&(l[d.$lc(D,S)]=!0)}),this.t.set(D,new t(l,D))})}cancel(){this.l=!0,o.forEach(i=>i())}walk(i,s,l,D,S){if(this.m=w.$Jd.create(!1),this.l)return S(null,this.j);s.forEach(b=>{const f=d.$nc(b.fsPath);this.u&&this.u(b.fsPath,f)||this.J(l,{relativePath:b.fsPath,searchPath:void 0})}),this.r=w.$Jd.create(!1),this.w(i,(b,f)=>{this.x(this.y,this,b,l,D,g=>{if(g){const P=(0,$.$zi)(g);console.error(P),this.q.push(P),f(g,void 0)}else f(null,void 0)})},(b,f)=>{this.m.stop();const g=b?A.$Hb(b)[0]:null;S(g,this.j)})}w(i,s,l){const D=new Array(i.length),S=new Array(i.length);let b=!1,f=0;if(i.length===0)return l(null,[]);i.forEach((g,P)=>{s(g,(N,O)=>{if(N?(b=!0,D[P]=null,S[P]=N):(D[P]=O,S[P]=null),++f===i.length)return l(b?S:null,D)})})}x(i,s,...l){try{i.apply(s,l)}catch(D){l[l.length-1](D)}}y(i,s,l,D){const S=i.folder.fsPath,b=I.$k,f=()=>M&&M.kill();o.add(f);let g=K=>{o.delete(f),g=()=>{},D(K)},P="";const N=this.D(),O=(0,c.$hec)(this.a,i,this.a.includePattern,this.t.get(i.folder.fsPath).expression),M=O.cmd,j=!Object.keys(O.siblingClauses).length,z=O.rgArgs.args.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");let F=`${O.rgDiskPath} ${z}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),l({message:F}),this.s=0,this.z(M,"utf8",l,(K,V,fe)=>{if(K){g(K);return}if(this.j){g();return}const Q=(P+(b?v.$ml(V||""):V)).split(`
`);if(fe){const X=Q.length;Q[X-1]=Q[X-1].trim(),Q[X-1]||Q.pop()}else P=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){g(new Error("Splitting up files failed"));return}if(this.s+=Q.length,j){for(const X of Q)if(this.J(s,{base:S,relativePath:X,searchPath:this.N(i,X)}),this.j){f();break}(fe||this.j)&&g();return}this.G(i,N,S,Q,s),fe&&(this.H(N,S,s),g())})}spawnFindCmd(i){const s=this.t.get(i.folder.fsPath),l=s.getBasenameTerms(),D=s.getPathTerms(),S=["-L","."];if(l.length||D.length){S.push("-not","(","(");for(const b of l)S.push("-name",b),S.push("-o");for(const b of D)S.push("-path",b),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),C.spawn("find",S,{cwd:i.folder.fsPath})}readStdout(i,s,l){let D="";this.z(i,s,()=>{},(S,b,f)=>{if(S){l(S);return}D+=b,f&&l(null,D)})}z(i,s,l,D){let S=(g,P,N)=>{(g||N)&&(S=()=>{},this.r?.stop()),D(g,P,N)},b=!1;i.stdout?(this.A(i.stdout,s,S),i.stdout.once("data",()=>b=!0)):l({message:"stdout is null"});let f;i.stderr?f=this.B(i.stderr):l({message:"stderr is null"}),i.on("error",g=>{S(g)}),i.on("close",g=>{let P;!b&&(P=this.C(f,s))&&n(P)?S(new Error(`command failed with error code ${g}: ${this.C(f,s)}`)):(this.g&&g===0&&(this.j=!0),S(null,"",!0))})}A(i,s,l){const D=new L.StringDecoder(s);return i.on("data",S=>{l(null,D.write(S))}),D}B(i){const s=[];return i.on("data",l=>{s.push(l)}),s}C(i,s){const l=new L.StringDecoder(s);return i.map(D=>l.write(D)).join("")}D(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}G(i,{pathToEntries:s},l,D,S){D.indexOf(this.b)!==-1&&this.J(S,{base:l,relativePath:this.b,searchPath:this.N(i,this.b)});const b=f=>{const g=d.$nc(f),P=d.$mc(f);let N=s[P];N||(N=s[P]=[],b(P)),N.push({base:l,relativePath:f,basename:g,searchPath:this.N(i,f)})};D.forEach(b)}H({rootEntries:i,pathToEntries:s},l,D){const S=this,b=this.t.get(l),f=this.b;function g(P){S.o++;const N=(0,u.$ZI)(()=>P.map(O=>O.basename));for(let O=0,M=P.length;O<M;O++){const j=P[O],{relativePath:z,basename:F}=j;if(b.test(z,F,f!==F?N:void 0))continue;const K=s[z];if(K)g(K);else{if(S.p++,z===f)continue;S.J(D,j)}if(S.j)break}}g(i)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(i,s,l,D,S){const b=i.folder,f=(0,u.$ZI)(()=>l);this.w(l,(g,P)=>{if(this.l||this.j)return P(null);const N=s?[s,g].join(d.sep):g;if(this.t.get(i.folder.fsPath).test(N,g,this.a.filePattern!==g?f:void 0))return P(null);const O=[b.fsPath,N].join(d.sep);T.lstat(O,(M,j)=>{if(M||this.l||this.j)return P(null);this.L(O,j,(z,F)=>z||this.l||this.j?P(null):F.isDirectory()?(this.o++,this.M(O,j,(K,V)=>K||this.l||this.j||(V=V||"",this.v[V])?P(null):(this.v[V]=!0,p.Promises.readdir(O).then(fe=>{if(this.l||this.j)return P(null);this.I(i,N,fe,D,Z=>P(Z||null))},fe=>{P(null)})))):(this.p++,N===this.b||this.h&&k.$Cf(F.size)&&F.size>this.h||this.J(D,{base:b.fsPath,relativePath:N,searchPath:this.N(i,N)}),P(null,void 0)))})},g=>{const P=g&&A.$Hb(g);return S(P&&P.length>0?P[0]:void 0)})}J(i,s){this.K(s)&&(!this.d||this.d(s.relativePath,d.$nc(s.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||i(s))}K(i){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,u.$UI)(i,this.c)}return!0}L(i,s,l){return s.isSymbolicLink()?T.stat(i,l):l(null,s)}M(i,s,l){return s.isSymbolicLink()?T.realpath(i,(D,S)=>D?l(D):l(null,S)):l(null,i)}N(i,s){return i.folderName?d.$jc(i.folderName,s):s}}e.$kec=m;class h{constructor(i){this.a=i.folderQueries,this.b=i.extraFileResources||[],this.c=new m(i)}search(i,s,l){this.c.walk(this.a,this.b,i,s,(D,S)=>{l(D,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$lec=h;class t{constructor(i,s){this.expression=i,this.c=s,this.d(i)}d(i){let s,l;Object.keys(i).filter(D=>i[D]).forEach(D=>{d.$ic(D)?(s=s||E.$qj(),s[D]=i[D]):(l=l||E.$qj(),l[D]=i[D])}),this.a=s&&E.$vj(s,{trimForExclusions:!0}),this.b=l&&E.$vj(l,{trimForExclusions:!0})}test(i,s,l){return this.b&&this.b(i,s,l)||this.a&&this.a(d.$jc(this.c,i),s,l)}getBasenameTerms(){const i=[];return this.a&&i.push(...E.$xj(this.a)),this.b&&i.push(...E.$xj(this.b)),i}getPathTerms(){const i=[];return this.a&&i.push(...E.$yj(this.a)),this.b&&i.push(...E.$yj(this.b)),i}}function n(a){const i=a.trim().split(`
`),s=i[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return y.$qf(i[i.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}}),define(De[362],Ce([1,0,96,22,182,21]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=e.$yC=e.$xC=e.$wC=e.$vC=e.$uC=e.$tC=e.$sC=e.$rC=e.DecodeStreamErrorKind=e.$qC=e.$pC=e.$oC=e.$nC=e.$mC=e.$lC=e.$kC=e.$jC=void 0,e.$jC="utf8",e.$kC="utf8bom",e.$lC="utf16be",e.$mC="utf16le";function A(s){return[e.$jC,e.$kC,e.$lC,e.$mC].some(l=>l===s)}e.$nC=A,e.$oC=[254,255],e.$pC=[255,254],e.$qC=[239,187,191];const $=512,E=512,v=512*8,R=512*128;var I;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class w extends Error{constructor(l,D){super(l),this.decodeStreamErrorKind=D}}e.$rC=w;class y{static async create(l){let D;if(l!==e.$jC)D=(await(0,d.$iC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(c(l));else{const S=new TextDecoder;D={write(b){return S.decode(b,{stream:!0})},end(){return S.decode()}}}return new y(D)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function k(s,l){const D=l.minBytesRequiredForDetection??l.guessEncoding?v:E;return new Promise((S,b)=>{const f=(0,C.$2d)(j=>j.join("")),g=[];let P=0,N;const O=new L.$Xd,M=async()=>{try{const j=await i({buffer:T.$be.concat(g),bytesRead:P},l.guessEncoding);if(j.seemsBinary&&l.acceptTextOnly)throw new w("Stream is binary but only text is accepted for decoding",1);j.encoding=await l.overwriteEncoding(j.encoding),N=await y.create(j.encoding);const z=N.write(T.$be.concat(g).buffer);f.write(z),g.length=0,P=0,S({stream:f,detected:j})}catch(j){O.cancel(),f.destroy(),b(j)}};(0,C.$6d)(s,{onData:async j=>{N?f.write(N.write(j.buffer)):(g.push(j),P+=j.byteLength,P>=D&&(s.pause(),await M(),setTimeout(()=>s.resume())))},onError:j=>f.error(j),onEnd:async()=>{N||await M(),f.end(N?.end())}},O.token)})}e.$sC=k;async function p(s,l,D){const b=(await(0,d.$iC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(c(l),D);let f=!1,g=!1;return{read(){if(g)return null;const P=s.read();if(typeof P!="string"){if(g=!0,!f&&D?.addBOM)switch(l){case e.$jC:case e.$kC:return T.$be.wrap(Uint8Array.from(e.$qC));case e.$lC:return T.$be.wrap(Uint8Array.from(e.$oC));case e.$mC:return T.$be.wrap(Uint8Array.from(e.$pC))}const N=b.end();return N&&N.length>0?(f=!0,T.$be.wrap(N)):null}return f=!0,T.$be.wrap(b.write(P))}}}e.$tC=p;async function u(s){return(await(0,d.$iC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(c(s))}e.$uC=u;function c(s){return s===e.$kC||s===null?e.$jC:s}e.$vC=c;function r(s,l){if(!s||l<e.$oC.length)return null;const D=s.readUInt8(0),S=s.readUInt8(1);if(D===e.$oC[0]&&S===e.$oC[1])return e.$lC;if(D===e.$pC[0]&&S===e.$pC[1])return e.$mC;if(l<e.$qC.length)return null;const b=s.readUInt8(2);return D===e.$qC[0]&&S===e.$qC[1]&&b===e.$qC[2]?e.$kC:null}e.$wC=r;const o=["ascii","utf-16","utf-32"];async function m(s){const l=await(0,d.$iC)("jschardet","dist/jschardet.min.js"),D=s.slice(0,R),S=n(D.buffer),b=l.detect(S);if(!b||!b.encoding)return null;const f=b.encoding.toLowerCase();return 0<=o.indexOf(f)?null:t(b.encoding)}const h={ibm866:"cp866",big5:"cp950"};function t(s){const l=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return h[l]||l}function n(s){let l="";for(let D=0;D<s.length;D++)l+=String.fromCharCode(s[D]);return l}function a(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=s.match(/windows(\d+)/);return l?"windows-"+l[1]:s}}}e.$xC=a;function i({buffer:s,bytesRead:l},D){let S=r(s,l),b=!1;if(S!==e.$lC&&S!==e.$mC&&s){let f=!0,g=!0,P=!1;for(let N=0;N<l&&N<$;N++){const O=N%2===1,M=s.readUInt8(N)===0;if(M&&(P=!0),f&&(O&&!M||!O&&M)&&(f=!1),g&&(O&&M||!O&&!M)&&(g=!1),M&&!f&&!g)break}P&&(f?S=e.$mC:g?S=e.$lC:b=!0)}return D&&!b&&!S&&s?m(s.slice(0,l)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:b,encoding:S}}e.$yC=i,e.$zC={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[154],Ce([1,0,362,29,153]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=void 0;class L extends d.$hdc{constructor($,E,v=T,R="searchProcess"){super($,E,{readdir:I=>v.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,C.$xC)(I)},R)}}e.$tec=L}),define(De[155],Ce([1,0,49,378,361,19,74,35,16,15,2,36,92,379,359,116]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=e.$rec=e.$qec=e.$pec=e.$oec=e.$nec=e.$mec=void 0;const u=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class c{constructor(g){this.a=g}provideTextSearchResults(g,P,N,O){return this.a.appendLine(`provideTextSearchResults ${g.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((M,j)=>{O.onCancellationRequested(()=>X());const z=n(g,P),F=P.folder.fsPath,K=z.map(G=>G.match(/^-/)?G:`'${G}'`).join(" ");this.a.appendLine(`${u} ${K}
 - cwd: ${F}`);let V=C.spawn(u,z,{cwd:F});V.on("error",G=>{console.error(G),this.a.appendLine("Error: "+(G&&G.message)),j((0,I.$QI)(new I.$OI(G&&G.message,I.SearchErrorCode.rgProcessError)))});let fe=!1;const Z=new m(P.maxResults,F,P.previewOptions);Z.on("result",G=>{fe=!0,x="",N.report(G)});let Q=!1;const X=()=>{Q=!0,V?.kill(),Z?.cancel()};let oe=!1;Z.on("hitLimit",()=>{oe=!0,X()});let x="";V.stdout.on("data",G=>{Z.handleData(G),fe||(x+=G)});let ae=!1;V.stdout.once("data",()=>ae=!0);let we="";V.stderr.on("data",G=>{const U=G.toString();this.a.appendLine(U),we.length+U.length<1e6&&(we+=U)}),V.on("close",()=>{if(this.a.appendLine(ae?"Got data from stdout":"No data from stdout"),this.a.appendLine(fe?"Got result from parser":"No result from parser"),x&&this.a.appendLine(`Got data without result: ${x}`),this.a.appendLine(""),Q)M({limitHit:oe});else{Z.flush(),V=null;let G;we&&!ae&&(G=r(we))?j((0,I.$QI)(new I.$OI(G.message,G.code))):M({limitHit:oe})}})})}}e.$mec=c;function r(f){const g=f.split(`
`),P=g[0].trim();if(g.some(O=>O.startsWith("regex parse error")))return new I.$OI(o(g),I.SearchErrorCode.regexParseError);const N=P.match(/grep config error: unknown encoding: (.*)/);if(N)return new I.$OI(`Unknown encoding: ${N[1]}`,I.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new I.$OI(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new I.$OI(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new I.$OI(P,I.SearchErrorCode.regexParseError)}function o(f){const g=["Regex parse error"],P=f.filter(N=>N.startsWith("PCRE2:"));if(P.length>=1){const N=P[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const O=N.split(":")[1];g.push(":"+O)}}return g.join("")}class m extends T.EventEmitter{constructor(g,P,N){super(),this.g=g,this.h=P,this.j=N,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new d.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(g,P){return super.on(g,P),this}handleData(g){if(this.b)return;const P=typeof g=="string"?g:this.d.write(g);this.k(P)}k(g){let P=g.indexOf(`
`);const N=this.a+g;if(P>=0)P+=this.a.length;else{this.a=N;return}let O=0;for(;P>=0;)this.m(N.substring(O,P).trim()),O=P+1,P=N.indexOf(`
`,O);this.a=N.substring(O)}m(g){if(this.b||!g)return;let P;try{P=JSON.parse(g)}catch{throw new Error(`malformed line from rg: ${g}`)}if(P.type==="match"){const N=h(P.data.path),O=R.URI.file(E.$jc(this.h,N)),M=this.n(P.data,O);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const N=h(P.data.path),O=R.URI.file(E.$jc(this.h,N));this.o(P.data,O).forEach(j=>this.p(j))}}n(g,P){const N=g.line_number-1,O=h(g.lines),M=Buffer.from(O);let j=0,z=0,F=N;g.submatches.length===0&&g.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const K=(0,L.$Hb)(g.submatches.map((V,fe)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Z=h(V.match),Q=M.slice(j,V.start).toString(),X=t(Q),oe=X.numLines>0?X.lastLineLength:X.lastLineLength+z,x=t(Z),ae=X.numLines+F,we=x.numLines+ae,G=x.numLines>0?x.lastLineLength:x.lastLineLength+oe;return j=V.end,z=G,F=we,new w.$yI(ae,oe,we,G)}));return(0,p.$fec)(P,O,K,this.j)}o(g,P){const N=h(g.lines),O=g.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((M,j)=>({text:M,uri:P,lineNumber:O+j}))}p(g){this.emit("result",g)}}e.$nec=m;function h(f){return f.bytes?Buffer.from(f.bytes,"base64").toString():f.text}function t(f){const g=/\n/g;let P=0,N=-1,O;for(;O=g.exec(f);)P++,N=O.index;const M=N>=0?f.length-N-1:f.length;return{numLines:P,lastLineLength:M}}function n(f,g){const P=["--hidden","--no-require-git"];P.push(f.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:O}=(0,A.$J)(g.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const j=new Set;O.forEach(z=>{j.add(z)}),P.push("-g","!*"),j.forEach(z=>{a(z).map(p.$eec).forEach(F=>{P.push("-g",F)})})}N&&N.length&&N.forEach(j=>{P.push("-g",j)}),g.excludes.map(p.$eec).forEach(j=>P.push("-g",`!${j}`)),g.maxFileSize&&P.push("--max-filesize",g.maxFileSize+""),g.useIgnoreFiles?g.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),g.followSymlinks&&P.push("--follow"),g.encoding&&g.encoding!=="utf8"&&P.push("--encoding",g.encoding),f.pattern==="--"&&(f.isRegExp=!0,f.pattern="\\-\\-"),f.isMultiline&&!f.isRegExp&&(f.pattern=(0,v.$Fe)(f.pattern),f.isRegExp=!0),g.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),f.isRegExp&&(f.pattern=i(f.pattern),P.push("--engine","auto"));let M;if(f.isWordMatch){const z=(0,v.$Ne)(f.pattern,!!f.isRegExp,{wholeWord:f.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",z)}else if(f.isRegExp){let j=l(f.pattern);j=D(j),P.push("--regexp",j)}else M=f.pattern,P.push("--fixed-strings");return P.push("--no-config"),g.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),f.isMultiline&&P.push("--multiline"),g.beforeContext&&P.push("--before-context",g.beforeContext+""),g.afterContext&&P.push("--after-context",g.afterContext+""),P.push("--"),M&&P.push(M),P.push("."),P}e.$oec=n;function a(f){return b(f).flatMap(P=>{const N=(0,$.$tj)(P,"/");return N.map((O,M)=>N.slice(0,M+1).join("/"))})}function i(f){const g=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;f.match(g);)f=f.replace(g,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;f.match(P);)f=f.replace(P,"$1\\x{$2}");return f}e.$pec=i;const s=f=>f.type==="Assertion"&&f.kind==="lookbehind";function l(f){let g;try{g=new y.RegExpParser().parsePattern(f)}catch{return f}let P="",N=0;const O=(z,F,K)=>{P+=f.slice(N,z)+K,N=F},M=[];return new y.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const F=M[0];if(!F)O(z.start,z.end,"\\r?\\n");else if(!M.some(s))if(F.type==="CharacterClass")if(F.negate){const K=f.slice(F.start+2,z.start)+f.slice(z.end,F.end-1);F.parent?.type==="Quantifier"?O(F.start,F.end,K?`[^${K}]`:"."):O(F.start,F.end,"(?!\\r?\\n"+(K?`|[${K}]`:"")+")")}else{const K=f.slice(F.start+1,z.start)+f.slice(z.end,F.end-1);O(F.start,F.end,K===""?"\\r?\\n":`(?:[${K}]|\\r?\\n)`)}else F.type==="Quantifier"&&O(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){M.unshift(z)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(z){M.unshift(z)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(z){M.unshift(z)},onCharacterClassLeave(){M.shift()},onAssertionEnter(z){s(z)&&M.push(z)},onAssertionLeave(z){M[0]===z&&M.shift()}}).visit(g),P+=f.slice(N),P}e.$qec=l;function D(f){return f.replace(/\n/g,"\\r?\\n")}e.$rec=D;function S(f){let g=!1,P=!1,N="",O="";for(let M=0;M<f.length;M++){const j=f[M];switch(j){case"\\":P?(g?O+="\\"+j:N+="\\"+j,P=!1):P=!0;break;case"{":if(P)g?O+=j:N+=j,P=!1;else{if(g)return{strInBraces:N+"{"+O+"{"+f.substring(M+1)};g=!0}break;case"}":if(P)g?O+=j:N+=j,P=!1;else{if(g)return{fixedStart:N,strInBraces:O,fixedEnd:f.substring(M+1)};N+=j}break;default:g?O+=(P?"\\":"")+j:N+=(P?"\\":"")+j,P=!1;break}}return{strInBraces:N+(g?"{"+O:"")}}function b(f){const{fixedStart:g,strInBraces:P,fixedEnd:N}=S(f);if(g===void 0||N===void 0)return[P];let O=(0,$.$tj)(P,",");O.length||(O=[""]);const M=b(N);return O.flatMap(j=>{const z=g+j;return M.map(F=>z+F)})}e.$sec=b}),define(De[363],Ce([1,0,21,155,64,18]),function($e,e,C,T,d,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=void 0;class A{constructor(v){this.b=v,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(v,R,I,w){const y=new T.$mec(this.b);if(R.folder.scheme===L.Schemas.vscodeUserData){const k={...R,folder:R.folder.with({scheme:L.Schemas.file})},p=new d.$2u(u=>I.report({...u,uri:u.uri.with({scheme:R.folder.scheme})}));return this.c(w,u=>y.provideTextSearchResults(v,k,p,u))}else return this.c(w,k=>y.provideTextSearchResults(v,R,I,k))}async c(v,R){const I=$(v);this.a.add(I);const w=await R(I.token);return this.a.delete(I),w}d(){this.a.forEach(v=>v.cancel())}}e.$wec=A;function $(E){const v=new C.$Xd;return E.onCancellationRequested(()=>v.cancel()),v}}),define(De[364],Ce([1,0,29,155,154]),function($e,e,C,T,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;class L{constructor(E){this.a=E}search(E,v,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(y){R({message:y})}},w=new d.$tec(this.a,new T.$mec(I),C);return new Promise((y,k)=>w.search(p=>{v(p.map(A))},E).then(p=>y({limitHit:p.limitHit,type:"success",stats:p.stats}),k))}}e.$uec=L;function A($){return{path:$.resource&&$.resource.fsPath,results:$.results,numMatches:($.results||[]).reduce((E,v)=>{if(v.ranges){const R=v;return E+(Array.isArray(R.ranges)?R.ranges.length:1)}else return E+1},0)}}}),define(De[365],Ce([1,0,19,9,8,4,127,16,37,2,30,36,360,364]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=void 0;class k{static{this.a=512}constructor(m="searchProcess"){this.d=m,this.b=Object.create(null)}fileSearch(m){let h;const t=c(m),n=new L.$Nd({onDidAddFirstListener:()=>{h=(0,T.$Hg)(a=>this.doFileSearchWithEngine(w.$lec,t,i=>n.fire(i),a)),h.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{h.cancel()}});return n.event}textSearch(m){let h;const t=c(m),n=new L.$Nd({onDidAddFirstListener:()=>{h=(0,T.$Hg)(a=>this.f(t,i=>n.fire(i),a)),h.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{h.cancel()}});return n.event}f(m,h,t){return m.maxFileSize=this.g().maxFileSize,new y.$uec(m).search(t,h,h)}g(){return{maxFileSize:process.arch==="ia32"?300*R.$Fk.MB:16*R.$Fk.GB}}doFileSearch(m,h,t){return this.doFileSearchWithEngine(w.$lec,m,h,t)}doFileSearchWithEngine(m,h,t,n,a=k.a){let i=0;const s=D=>{Array.isArray(D)?(i+=D.length,t(D.map(S=>this.h(S)))):D.relativePath?(i++,t(this.h(D))):t(D)};if(h.sortByScore){let D=this.l(h,s,n);if(!D){const S=h.maxResults?Object.assign({},h,{maxResults:null}):h,b=new m(S);D=this.j(b,h,t,s,n)}return new Promise((S,b)=>{D.then(([f,g])=>{const P=g.map(N=>this.h(N));this.o(P,t,a),S(f)},b)})}const l=new m(h);return this.r(l,s,a,n).then(D=>({limitHit:D.limitHit,type:"success",stats:{detailStats:D.stats,type:this.d,fromCache:!1,resultCount:i,sortingTime:void 0}}))}h(m){return{path:m.base?(0,$.$jc)(m.base,m.relativePath):m.relativePath}}j(m,h,t,n,a){const i=new L.$Nd;let s=(0,T.$Hg)(D=>{let S=[];const b=f=>{Array.isArray(f)?S=f:(n(f),i.fire(f))};return this.r(m,b,-1,D).then(f=>[f,S])}),l;if(h.cacheKey){l=this.k(h.cacheKey);const D={promise:s,event:i.event,resolved:!1};l.resultsToSearchCache[h.filePattern||""]=D,s.then(()=>{D.resolved=!0},S=>{delete l.resultsToSearchCache[h.filePattern||""]}),s=this.s(s)}return s.then(([D,S])=>{const b=l?l.scorerCache:Object.create(null),f=(typeof h.maxResults!="number"||h.maxResults>0)&&E.$Jd.create(!1);return this.n(h,S,b,a).then(g=>{const P=f?f.elapsed():-1;return[{type:"success",stats:{detailStats:D.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:h.folderQueries.length,resultCount:g.length},messages:D.messages,limitHit:D.limitHit||typeof h.maxResults=="number"&&S.length>h.maxResults},g]})})}k(m){const h=this.b[m];return h||(this.b[m]=new p)}l(m,h,t){const n=m.cacheKey&&this.b[m.cacheKey];if(!n)return;const a=this.q(n,m.filePattern||"",h,t);if(a)return a.then(([i,s,l])=>{const D=E.$Jd.create(!1);return this.n(m,s,n.scorerCache,t).then(S=>{const b=D.elapsed(),f={fromCache:!0,detailStats:l,type:this.d,resultCount:s.length,sortingTime:b};return[{type:"success",limitHit:i.limitHit||typeof m.maxResults=="number"&&s.length>m.maxResults,stats:f},S]})})}n(m,h,t,n){const a=(0,A.$wq)(m.filePattern||""),i=(l,D)=>(0,A.$vq)(l,D,a,!0,u,t),s=typeof m.maxResults=="number"?m.maxResults:Number.MAX_VALUE;return C.$Gb(h,i,s,1e4,n)}o(m,h,t){if(t&&t>0)for(let n=0;n<m.length;n+=t)h(m.slice(n,n+t));else h(m)}q(m,h,t,n){const a=E.$Jd.create(!1),i=h.indexOf($.sep)>=0;let s;for(const b in m.resultsToSearchCache)if(h.startsWith(b)){if(i&&b.indexOf($.sep)<0&&b!=="")continue;const f=m.resultsToSearchCache[b];s={promise:this.s(f.promise),event:f.event,resolved:f.resolved};break}if(!s)return null;const l=a.elapsed(),D=E.$Jd.create(!1),S=s.event(t);return n&&n.onCancellationRequested(()=>{S.dispose()}),s.promise.then(([b,f])=>{if(n&&n.isCancellationRequested)throw(0,d.$6)();const g=[],P=(0,A.$wq)(h).normalizedLowercase;for(const N of f)(0,I.$UI)(N,P)&&g.push(N);return[b,g,{cacheWasResolved:s.resolved,cacheLookupTime:l,cacheFilterTime:D.elapsed(),cacheEntryCount:f.length}]})}r(m,h,t,n){return new Promise((a,i)=>{let s=[];n?.onCancellationRequested(()=>m.cancel()),m.search(l=>{l&&(t?(s.push(l),t>0&&s.length>=t&&(h(s),s=[])):h(l))},l=>{h(l)},(l,D)=>{s.length&&h(s),l?i(l):a(D)})})}clearCache(m){return delete this.b[m],Promise.resolve(void 0)}s(m){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(h,t){return m.then(h,t)}catch(h){return this.then(void 0,h)}finally(h){return m.finally(h)}}}}e.$vec=k;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const u=new class{getItemLabel(o){return(0,$.$nc)(o.relativePath)}getItemDescription(o){return(0,$.$mc)(o.relativePath)}getItemPath(o){return o.relativePath}};function c(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(r),extraFileResources:o.extraFileResources&&o.extraFileResources.map(m=>v.URI.revive(m))}}function r(o){return{...o,folder:v.URI.revive(o.folder)}}}),define(De[366],Ce([1,0,3,18,2,29,14,27,20,95,67,36,365,363,116,154]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;let u=class extends v.$mdc{constructor(r,o,m,h){super(r,m,h),this.s=L,this.t=-1,this.v=null,this.w=!1,this.x=new C.$Rc;const t=new k.$gec("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.vscodeUserData,new y.$wec(t))),o.remote.isRemote&&o.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const r=new k.$gec("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.file,new y.$wec(r))),this.x.add(this.z(T.Schemas.file,new w.$vec("fileSearchProvider")))}z(r,o){const m=this.d++;return this.v=o,this.t=m,this.c.$registerFileSearchProvider(m,this.o(r)),(0,C.$Qc)(()=>{this.v=null,this.c.$unregisterProvider(m)})}$provideFileSearchResults(r,o,m,h){const t=(0,v.$ndc)(m);return r===this.t?this.A(r,o,t,h):super.$provideFileSearchResults(r,o,m,h)}A(r,o,m,h){const t=n=>{if((0,I.$TI)(n)&&(n=[n]),Array.isArray(n)){this.c.$handleFileMatch(r,o,n.map(a=>d.URI.file(a.path)));return}n.message&&this.n.debug("ExtHostSearch",n.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(m,t,h)}$clearCache(r){return this.v?.clearCache(r),super.$clearCache(r)}q(r,o){return new p.$tec(r,o,void 0,"textSearchProvider")}};e.$xec=u,e.$xec=u=He([Be(0,E.$dM),Be(1,$.$tM),Be(2,R.$5bc),Be(3,A.$9i)],u)}),define(De[117],Ce([1,0,380,60,63,381,22,8,4,3,16,12,31,81,82]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;class p{traceSocketEvent(f,g){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,g)}constructor(f,g=""){this.f=!0,this.debugLabel=g,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,$.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const g=P=>{this.traceSocketEvent("read",P),f(A.$be.wrap(P))};return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(f){const g=P=>{f({type:0,hadError:P,error:void 0})};return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(f){const g=()=>{f()};return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,g=>{if(g){if(g.code==="EPIPE")return;(0,$.$1)(g)}})}catch(g){if(g.code==="EPIPE")return;(0,$.$1)(g)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,g)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$Dh=p;var u;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(u||(u={}));var c;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(c||(c={}));class r extends v.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,g){this.socket.traceSocketEvent(f,g)}constructor(f,g,P,N){super(),this.f=this.B(new E.$Nd),this.g=this.B(new E.$Nd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:g,inflateBytesLength:P?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new o(this,g,P,N,this.f,(O,M)=>this.m(O,M))),this.B(this.a.onError(O=>{console.error(O),(0,$.$1)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new k.$yh,this.B(this.socket.onData(O=>this.n(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let g=0;for(;g<f.byteLength;)this.a.writeMessage(f.slice(g,Math.min(g+262144,f.byteLength)),{compressed:!0,opcode:2}),g+=262144}m(f,{compressed:g,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let N=2;f.byteLength<126?N+=0:f.byteLength<2**16?N+=2:N+=8;const O=A.$be.alloc(N),M=g?64:0,j=P&15;if(O.writeUInt8(128|M|j,0),f.byteLength<126)O.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){O.writeUInt8(126,1);let z=1;O.writeUInt8(f.byteLength>>>8&255,++z),O.writeUInt8(f.byteLength>>>0&255,++z)}else{O.writeUInt8(127,1);let z=1;O.writeUInt8(0,++z),O.writeUInt8(0,++z),O.writeUInt8(0,++z),O.writeUInt8(0,++z),O.writeUInt8(f.byteLength>>>24&255,++z),O.writeUInt8(f.byteLength>>>16&255,++z),O.writeUInt8(f.byteLength>>>8&255,++z),O.writeUInt8(f.byteLength>>>0&255,++z)}this.socket.write(A.$be.concat([O,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const g=this.b.peek(this.j.readLen),P=g.readUInt8(0),N=(P&128)>>>7,O=(P&64)>>>6,M=P&15,j=g.readUInt8(1),z=(j&128)>>>7,F=j&127;this.j.state=2,this.j.readLen=2+(z?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!O),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const g=this.b.read(this.j.readLen),P=g.readUInt8(1),N=(P&128)>>>7;let O=P&127,M=1;O===126?O=g.readUInt8(++M)*2**8+g.readUInt8(++M):O===127&&(O=g.readUInt8(++M)*0+g.readUInt8(++M)*0+g.readUInt8(++M)*0+g.readUInt8(++M)*0+g.readUInt8(++M)*2**24+g.readUInt8(++M)*2**16+g.readUInt8(++M)*2**8+g.readUInt8(++M));let j=0;N&&(j=g.readUInt8(++M)*2**24+g.readUInt8(++M)*2**16+g.readUInt8(++M)*2**8+g.readUInt8(++M)),this.j.state=3,this.j.readLen=O,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const g=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",g),t(g,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",g),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(g,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(g,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Eh=r;class o extends v.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$be.alloc(0)}constructor(f,g,P,N,O,M){super(),this.n=f,this.r=O,this.s=M,this.a=this.B(new E.$Nd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$Nd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new E.$Nd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,g?(this.b=this.B(new m(this.n,N,P,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(f,g){this.g.push({data:f,options:g}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:f,options:g}=this.g.shift();if(this.f&&g.compressed){const P=await this.w(this.f,f);this.s(P,g)}else this.s(f,{...g,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,g){return new Promise((P,N)=>{f.write(g),f.flush(O=>P(O))})}acceptFrame(f,g,P){this.h.push({data:f,isCompressed:g,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const g=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire(g)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,g,P){return new Promise((N,O)=>{f.write(g),P&&f.write(A.$be.fromByteArray([0,0,255,255])),f.flush(M=>N(M))})}}class m extends v.$Sc{get recordedInflateBytes(){return this.j?A.$be.concat(this.f):A.$be.alloc(0)}constructor(f,g,P,N){super(),this.h=f,this.j=g,this.a=this.B(new E.$Nd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(N),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(A.$be.wrap(O))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const g=A.$be.concat(this.g);this.g.length=0,f(g)})}}class h extends v.$Sc{constructor(f,g){super(),this.g=f,this.a=this.B(new E.$Nd),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(A.$be.wrap(P))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let g=A.$be.concat(this.f);this.f.length=0,g=g.slice(0,g.byteLength-4),f(g)})}}function t(b,f){if(f===0)return;const g=b.byteLength>>>2;for(let z=0;z<g;z++){const F=b.readUInt32BE(z*4);b.writeUInt32BE(F^f,z*4)}const P=g*4,N=b.byteLength-P,O=f>>>24&255,M=f>>>16&255,j=f>>>8&255;N>=1&&b.writeUInt8(b.readUInt8(P)^O,P),N>=2&&b.writeUInt8(b.readUInt8(P+1)^M,P+1),N>=3&&b.writeUInt8(b.readUInt8(P+2)^j,P+2)}e.$Fh=process.env.XDG_RUNTIME_DIR;const n={[2]:107,[1]:103};function a(){const b=(0,w.$eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const f=process.platform!=="darwin"&&e.$Fh?e.$Fh:(0,d.tmpdir)(),g=(0,R.$jc)(f,`vscode-ipc-${b}.sock`);return s(g),g}e.$Gh=a;function i(b,f,g){const P=(0,C.createHash)("md5").update(b).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${g}-${f}-sock`;const N=g.substr(0,4),O=f.substr(0,6),M=P.substr(0,8);let j;return process.platform!=="darwin"&&e.$Fh&&!process.env.VSCODE_PORTABLE?j=(0,R.$jc)(e.$Fh,`vscode-${M}-${N}-${O}.sock`):j=(0,R.$jc)(b,`${N}-${O}.sock`),s(j),j}e.$Hh=i;function s(b){const f=n[I.$u];typeof f=="number"&&b.length>=f&&console.warn(`WARNING: IPC handle "${b}" is longer than ${f} chars, try a shorter --user-data-dir`)}class l extends y.$sh{static b(f){const g=E.Event.fromNodeEventEmitter(f,"connection");return E.Event.map(g,P=>({protocol:new k.$zh(new p(P,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(P,"close"))}))}constructor(f){super(l.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ih=l;function D(b){return new Promise((f,g)=>{const P=(0,T.createServer)();P.on("error",g),P.listen(b,()=>{P.removeListener("error",g),f(new l(P))})})}e.$Jh=D;function S(b,f){return new Promise((g,P)=>{const N=(0,T.createConnection)(b,()=>{N.removeListener("error",P),g(k.$Ah.fromSocket(new p(N,`ipc-client${f}`),f))});N.once("error",P)})}e.$Kh=S}),define(De[367],Ce([1,0,60,63,163,117,9,3,12,50,14,135,247,248,106,86,22]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$57b=e.$47b=e.$37b=e.$27b=void 0;async function c(t,n,a,i,s){let l;for(let D=3;D&&(l?.dispose(),l=await new r(t,n,a,i,s).waitForReady(),!(s&&d.$hg[s]||!d.$hg[l.tunnelLocalPort]));D--);return l}class r extends $.$Sc{constructor(n,a,i,s,l){super(),this.m=a,this.n=l,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=n,this.b=C.createServer(),this.c=new A.$Sg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=D=>this.r(D),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(a=>{a()})}async waitForReady(){const n=this.n??this.tunnelRemotePort,a=(0,p.$av)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,d.$ig)(n,2,1e3,a),s=null;return this.b.listen(i,this.m),await this.c.wait(),s=this.b.address(),s||(i=0,this.b.listen(i,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(n){n.pause();const a=(0,p.$$u)(this.tunnelRemoteHost)||(0,p.$av)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,w.$5k)(this.a,a,this.tunnelRemotePort),s=i.getSocket(),l=i.readEntireBuffer();i.dispose(),l.byteLength>0&&n.write(l.buffer),n.on("end",()=>{n.localAddress&&this.j.delete(n.localAddress),s.end()}),n.on("close",()=>s.end()),n.on("error",()=>{n.localAddress&&this.j.delete(n.localAddress),s instanceof L.$Dh?s.socket.destroy():s.end()}),s instanceof L.$Dh?this.t(n,s):this.s(n,s),n.localAddress&&this.j.set(n.localAddress,()=>{n.end(),s.end()})}s(n,a){a.onClose(()=>n.destroy()),a.onEnd(()=>n.end()),a.onData(i=>n.write(i.buffer)),n.on("data",i=>a.write(u.$be.wrap(i))),n.resume()}t(n,a){const i=a.socket;i.on("end",()=>n.end()),i.on("close",()=>n.end()),i.on("error",()=>{n.destroy()}),i.pipe(n),n.pipe(i)}}e.$27b=r;let o=class extends p.$dv{constructor(n,a,i,s,l){super(a,l),this.u=n,this.v=i,this.w=s}isPortPrivileged(n){return(0,p.$bv)(n,this.l,E.OS,T.release())}s(n,a,i,s,l,D,S,b){const f=this.r(a,i);if(f)return++f.refcount,f.value;if((0,p.$8u)(n))return this.t(n,a,i,l,D,S,b);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${i} on local port ${l}.`);const g={commit:this.w.commit,quality:this.w.quality,addressProvider:n,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},P=c(g,s,a,i,l);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(a,i,P),P}}};e.$37b=o,e.$37b=o=He([Be(0,y.$Yk),Be(1,R.$9i),Be(2,k.$2k),Be(3,I.$oj),Be(4,v.$ii)],o);let m=class extends o{constructor(n,a,i,s,l){super(n,a,i,s,l)}};e.$47b=m,e.$47b=m=He([Be(0,y.$Yk),Be(1,R.$9i),Be(2,k.$2k),Be(3,I.$oj),Be(4,v.$ii)],m);let h=class extends $.$Sc{constructor(n,a,i,s,l){super(),this.b=n,this.c=a,this.f=i,this.g=s,this.h=l,this.a=new Map}async openTunnel(n,a,i,s,l,D,S,b,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${s} on local port ${D}.`),!this.a.has(n)){const g=new m(this.b,this.c,this.g,this.f,this.h);this.B(g),this.a.set(n,g),g.onTunnelClosed(async()=>{(await g.tunnels).length===0&&(g.dispose(),this.a.delete(n))})}return this.a.get(n).openTunnel(a,i,s,l,D,S,b,f)}};e.$57b=h,e.$57b=h=He([Be(0,y.$Yk),Be(1,R.$9i),Be(2,I.$oj),Be(3,k.$2k),Be(4,v.$ii)],h)}),define(De[368],Ce([1,0,117,267,53,33,2,14,44]),function($e,e,C,T,d,L,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=void 0;class v{constructor(w,y,k){this.b=w,this.c=y,this.f=k,this.a=T.createServer((p,u)=>this.h(p,u)),this.g().catch(p=>(y.error(p),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,y){const k=(u,c)=>{y.writeHead(u,{"content-type":"application/json"}),y.end(JSON.stringify(c||null),r=>r&&this.c.error(r))},p=[];w.setEncoding("utf8"),w.on("data",u=>p.push(u)),w.on("end",async()=>{try{const u=JSON.parse(p.join(""));let c;switch(u.type){case"open":c=await this.i(u);break;case"openExternal":c=await this.j(u);break;case"status":c=await this.l(u);break;case"extensionManagement":c=await this.k(u);break;default:k(404,`Unknown message type: ${u.type}`);break}k(200,c)}catch(u){const c=u instanceof Error?u.message:JSON.stringify(u);k(500,c),this.c.error("Error while processing pipe request",u)}})}async i(w){const{fileURIs:y,folderURIs:k,forceNewWindow:p,diffMode:u,mergeMode:c,addMode:r,forceReuseWindow:o,gotoLineMode:m,waitMarkerFilePath:h,remoteAuthority:t}=w,n=[];if(Array.isArray(k))for(const l of k)try{n.push({folderUri:A.URI.parse(l)})}catch{}if(Array.isArray(y))for(const l of y)try{(0,E.$hi)(l)?n.push({workspaceUri:A.URI.parse(l)}):n.push({fileUri:A.URI.parse(l)})}catch{}const a=h?A.URI.file(h):void 0,s={forceNewWindow:p,diffMode:u,mergeMode:c,addMode:r,gotoLineMode:m,forceReuseWindow:o,preferNewWindow:!o&&!a&&!r,waitMarkerFileURI:a,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",n,s)}async j(w){for(const y of w.uris){const k=A.URI.parse(y),p=k.scheme==="file"?k:y;await this.b.executeCommand("_remoteCLI.openExternal",p)}}async k(w){const y=p=>p?.map(u=>/\.vsix$/i.test(u)?A.URI.parse(u):u),k={list:w.list,install:y(w.install),uninstall:y(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",k)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&d.existsSync(this.f)&&d.unlinkSync(this.f)}}e.$EM=v;let R=class extends v{constructor(w,y){super(w,y,(0,C.$Gh)())}};e.$FM=R,e.$FM=R=He([Be(0,L.$zM),Be(1,$.$9i)],R)}),define(De[369],Ce([1,0,54,356,351,266,46,339,2,18,7,368,100,337,338]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=void 0;class p extends d.$4dc{j(){const r=this,o=globalThis._VSCODE_NODE_MODULES.module,m=o._load;o._load=function(a,i,s){return a=t(a),r.a.has(a)?r.a.get(a).load(a,E.URI.file((0,w.$6p)(i.filename)),l=>m.apply(this,[l,i,s])):m.apply(this,arguments)};const h=o._resolveLookupPaths;o._resolveLookupPaths=(n,a)=>h.call(this,t(n),a);const t=n=>{for(const a of r.b){const i=a(n);if(i){n=i;break}}return n}}}class u extends A.$Ccc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async tb(){this.h.createInstance(y.$Aec);const r=this.h.invokeFunction(T.$Zdc);if(this.h.createInstance($.$zec),this.f.remote.isRemote&&this.f.remote.authority){const h=this.h.createInstance(I.$FM);process.env.VSCODE_IPC_HOOK_CLI=h.ipcHandlePath}this.h.createInstance(k.$Bec),await this.h.createInstance(p,r,{mine:this.J,all:this.L}).install(),C.mark("code/extHost/didInitAPI");const m=await this.m.getConfigProvider();await(0,L.$yec)(this.j,m,this,this.s,this.z,this.f),C.mark("code/extHost/didInitProxyResolver")}ub(r){return r.main}async vb(r,o,m){if(o.scheme!==v.Schemas.file)throw new Error(`Cannot load URI: '${o}', must be of file-scheme`);let h=null;m.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${o.toString(!0)}`),this.s.flush();const t=r?.identifier.value;r&&await this.w.initializeLocalizedMessages(r);try{t&&C.mark(`code/extHost/willLoadExtensionCode/${t}`),h=$e.__$__nodeRequire(o.fsPath)}finally{t&&C.mark(`code/extHost/didLoadExtensionCode/${t}`),m.codeLoadingStop()}return h}async $setRemoteEnvironment(r){if(this.f.remote.isRemote)for(const o in r){const m=r[o];m===null?delete process.env[o]:process.env[o]=m}}}e.$Cec=u}),define(De[370],Ce([1,0,49,22,4,3,120,12,23,2,29,14,246,65,106,86,367,27,20,73,347]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r,o,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=e.$Jec=e.$Iec=e.$Hec=e.$Gec=e.$Fec=e.$Eec=e.$Dec=void 0;function h(f){const g=f.trim().split(`
`),P=[];return g.forEach(O=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(O);M&&M.length>=3&&P.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),P.reduce((O,M)=>(O[M.socket]=M,O),{})}e.$Dec=h;function t(...f){const g=[].concat(...f.map(a));return[...new Map(g.filter(P=>P.st==="0A").map(P=>{const N=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:n(N[0]),port:parseInt(N[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$Eec=t;function n(f){let g="";if(f.length===8)for(let P=f.length-2;P>=0;P-=2)g+=parseInt(f.substr(P,2),16),P!==0&&(g+=".");else for(let P=0;P<f.length;P+=8){const N=f.substring(P,P+8);let O="";for(let M=8;M>=2;M-=2)O+=N.substring(M-2,M),(M===6||M===2)&&(O=parseInt(O,16).toString(16),g+=`${O}`,O="",P+M!==f.length-6&&(g+=":"))}return g}e.$Fec=n;function a(f){const g=f.trim().split(`
`),P=g.shift().trim().split(/\s+/).filter(O=>O!=="rx_queue"&&O!=="tm->when");return g.map(O=>O.trim().split(/\s+/).reduce((M,j,z)=>(M[P[z]||z]=j,M),{}))}e.$Gec=a;function i(f){return!!f.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||f.indexOf("out/server-main.js")!==-1||f.indexOf("_productName=VSCode")!==-1}function s(f){const g=f.trim().split(`
`),P=[];return g.forEach(N=>{const O=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);O&&O.length>=4&&P.push({pid:parseInt(O[1],10),ppid:parseInt(O[2]),cmd:O[3]})}),P}e.$Hec=s;async function l(f,g,P){const N=P.reduce((M,j)=>(M[j.pid]=j,M),{}),O=[];return f.forEach(({socket:M,ip:j,port:z})=>{const F=g[M]?g[M].pid:void 0,K=F?N[F]?.cmd:void 0;F&&K&&!i(K)&&O.push({host:j,port:z,detail:K,pid:F})}),O}e.$Iec=l;function D(f,g,P){const N=new Map,O=s(g);for(const M of f){const j=P.get(M.port);if(j){N.set(M.port,j);continue}const z=O.find(F=>F.cmd.includes(`${M.port}`));if(z){let F=z,K;do K=O.find(V=>V.ppid===F.pid),K&&(F=K);while(K);N.set(M.port,{host:M.ip,port:M.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else N.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return N}e.$Jec=D;let S=class extends o.$3vb{constructor(g,P,N,O){super(g,P,N),this.D=P,this.F=O,this.y=void 0,this.z=new Map,this.C=!1,$.$l&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(g){if(g&&this.C)return;this.C=g;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new A.$Pl;let O=0;for(;this.C;){const M=new Date().getTime(),j=(await this.I()).filter(K=>(0,p.$$u)(K.host)||(0,p.$av)(K.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(K=>K.port).join(", ")}`);const z=new Date().getTime()-M;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${z} ms.`),O++>3&&N.update(z),(!P||JSON.stringify(P)!==JSON.stringify(j))&&(P=j,await this.a.$onFoundNewCandidates(P));const F=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(K=>setTimeout(()=>K(),F))}}G(g){return Math.max(g*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(g=>g.port).join(", ")}`)}async I(){let g="",P="";try{g=await R.Promises.readFile("/proc/net/tcp","utf8"),P=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(g,P),O=await new Promise(Z=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,X,oe)=>{Z(X)})}),M=h(O),j=await R.Promises.readdir("/proc"),z=[];for(const Z of j)try{const Q=Number(Z),X=E.$vg(v.URI.file("/proc"),Z);if((await R.Promises.stat(X.fsPath)).isDirectory()&&!isNaN(Q)){const x=await R.Promises.readlink(E.$vg(X,"cwd").fsPath),ae=await R.Promises.readFile(E.$vg(X,"cmdline").fsPath,"utf8");z.push({pid:Q,cwd:x,cmd:ae})}}catch{}const F=[],K=N.filter(Z=>{const Q=M[Z.socket];return Q||F.push(Z),Q}),V=l(K,M,z);let fe;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const Z=await new Promise(Q=>{(0,C.exec)("ps -F -A -l | grep root",(X,oe,x)=>{Q(oe)})});this.z=D(F,Z,this.z),fe=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${fe.map(Q=>Q.port).join(", ")}`)}return V.then(Z=>fe?Z.concat(fe):Z)}w(g){return async P=>{const N=new u.$27b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(M,j,z,F){const K=await g.makeConnection();return b.connect(K,j,z,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Pk(0),connectionToken:g.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await N.waitForReady();const O=new d.$Nd;return{localAddress:(0,m.$CJ)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:O.event,dispose:()=>{N.dispose(),O.fire(),O.dispose()}}}}};e.$Kec=S,e.$Kec=S=He([Be(0,r.$dM),Be(1,c.$tM),Be(2,I.$9i),Be(3,k.$2k)],S);class b extends w.$ykb{static connect(g,P,N,O){const M=new L.$Rc,j={onClose:M.add(new d.$Nd),onData:M.add(new d.$Nd),onEnd:M.add(new d.$Nd)};M.add(g.onDidReceiveMessage(F=>j.onData.fire(T.$be.wrap(F)))),M.add(g.onDidEnd(()=>j.onEnd.fire())),M.add(g.onDidClose(F=>j.onClose.fire({type:0,error:F,hadError:!!F})));const z=new b(g,O,j);return z.B(M),(0,w.$xkb)(z,P,N,O,j)}constructor(g,P,N){super(P,N),this.n=g}write(g){this.n.send(g.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(De[371],Ce([1,0,103,342,354,353,366,369,370,94,46,95,93,45,73,90,341,340,14,355,56,261,102,106,138]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c,r,o,m,h,t,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$ur)(R.$Dcc,$.$Cec,0),(0,C.$ur)(r.$0i,c.$Mec,1),(0,C.$ur)(r.$9i,new t.$Lh(h.$3dc,[!1],!0)),(0,C.$ur)(n.$2k,a.$77b,1),(0,C.$ur)(p.$occ,u.$Lec,0),(0,C.$ur)(v.$bdc,L.$dec,0),(0,C.$ur)(I.$ldc,A.$xec,0),(0,C.$ur)(w.$9cc,d.$8dc,0),(0,C.$ur)(y.$qcc,T.$7dc,0),(0,C.$ur)(k.$2vb,E.$Kec,0),(0,C.$ur)(m.$_cc,o.$Nec,0)}),define(De[382],Ce([1,0,60,383,54,8,82,117,244,111,352,22,29,100,9,130,268,285,357,371]),function($e,e,C,T,d,L,A,$,E,v,R,I,w,y,k,p,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const r=T(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const s=globalThis._VSCODE_NODE_MODULES.module,l=s._load;s._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return l.apply(this,arguments)}})();const o=process.exit.bind(process);function m(s){process.exit=function(l){if(s)o(l);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let h=function(s){o()};function t(){const s=(0,c.$zm)(process.env);if(s.type===3)return new Promise((l,D)=>{const S=b=>{const f=b[0],g=new A.$Bh;f.on("message",P=>g.fire(I.$be.wrap(P.data))),f.on("close",()=>{h("renderer closed the MessagePort")}),f.start(),l({onMessage:g.event,send:P=>f.postMessage(P.buffer)})};process.parentPort.on("message",b=>S(b.ports))});if(s.type===2)return new Promise((l,D)=>{let S=null;const b=setTimeout(()=>{h("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),f=108e5,g=3e5,P=new k.$7g(()=>h("renderer disconnected for too long (1)"),f),N=new k.$7g(()=>h("renderer disconnected for too long (2)"),g);process.on("message",(M,j)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const z=I.$be.wrap(Buffer.from(M.initialDataChunk,"base64"));let F;if(M.skipWebSocketFrames)F=new $.$Dh(j,"extHost-socket");else{const K=I.$be.wrap(Buffer.from(M.inflateBytes,"base64"));F=new $.$Eh(new $.$Dh(j,"extHost-socket"),M.permessageDeflate,K,!1)}S?(P.cancel(),N.cancel(),S.beginAcceptReconnection(F,z),S.endAcceptReconnection(),S.sendResume()):(clearTimeout(b),S=new A.$Ch({socket:F,initialChunk:z}),S.sendResume(),S.onDidDispose(()=>h("renderer disconnected")),l(S),S.onSocketClose(()=>{P.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;P.isScheduled()&&N.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(O)});{const l=s.pipeName;return new Promise((D,S)=>{const b=C.createConnection(l,()=>{b.removeListener("error",S);const f=new A.$Ch({socket:new $.$Dh(b,"extHost-renderer")});f.sendResume(),D(f)});b.once("error",S),b.on("close",()=>{h("renderer closed the socket")})})}}async function n(){const s=await t();return new class{constructor(){this.a=new A.$Bh,this.onMessage=this.a.event,this.b=!1,s.onMessage(l=>{(0,v.$am)(l,2)?(this.b=!0,h("received terminate message from renderer")):this.a.fire(l)})}send(l){this.b||s.send(l)}async drain(){if(s.drain)return s.drain()}}}function a(s){return new Promise(l=>{const D=s.onMessage(S=>{D.dispose();const b=JSON.parse(S.toString()),f=b.commit,g=E.default.commit;if(f&&g&&f!==g&&o(55),b.parentPid){let P=0;setInterval(function(){try{process.kill(b.parentPid,0),P=0}catch(O){O&&O.code==="EPERM"?(P++,P>=3&&h(`parent process ${b.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):h(`parent process ${b.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(b.parentPid)}catch(O){(0,L.$1)(O)}}s.send((0,v.$_l)(0)),l({protocol:s,initData:b})});s.send((0,v.$_l)(1))})}async function i(){const s=[];process.on("unhandledRejection",(P,N)=>{s.push(N),setTimeout(()=>{const O=s.indexOf(N);O>=0&&N.catch(M=>{s.splice(O,1),(0,L.$4)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),P&&(0,L.$1)(P))})},1e3)}),process.on("rejectionHandled",P=>{const N=s.indexOf(P);N>=0&&s.splice(N,1)}),process.on("uncaughtException",function(P){(0,L.$Z)(P)||(0,L.$1)(P)}),d.mark("code/extHost/willConnectToRenderer");const l=await n();d.mark("code/extHost/didConnectToRenderer");const D=await a(l);d.mark("code/extHost/didWaitForInitData");const{initData:S}=D;m(!!S.environment.extensionTestsLocationURI),S.environment.useHostProxy=r.useHostProxy!==void 0?r.useHostProxy!=="false":void 0,S.environment.skipWorkspaceStorageLock=(0,p.boolean)(r.skipWorkspaceStorageLock,!1);const b=new class{constructor(){this.pid=process.pid}exit(N){o(N)}fsExists(N){return w.Promises.exists(N)}fsRealpath(N){return(0,y.$5p)(N)}};let f=null;S.remote.authority&&r.transformURIs&&(f=(0,u.$yr)(S.remote.authority));const g=new R.$6dc(D.protocol,S,b,f);h=P=>g.terminate(P)}i().catch(s=>console.log(s))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9bb94efbe279580856897b63cc9417a3e875e405/core/vs/workbench/api/node/extensionHostProcess.js.map
