/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(be){for(var e=[],y=0,M=be.length;y<M;y++)e[y]=Ae[be[y]];return e};define(Ae[65],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=e.$hh=e.$gh=void 0;function y(A){return(l,D,g)=>{let R=null,k=null;if(typeof g.value=="function"?(R="value",k=g.value):typeof g.get=="function"&&(R="get",k=g.get),!k)throw new Error("not supported");g[R]=A(k,D)}}function M(A,l,D){let g=null,R=null;if(typeof D.value=="function"?(g="value",R=D.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(g="get",R=D.get),!R)throw new Error("not supported");const k=`$memoize$${l}`;D[g]=function(...a){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,a)}),this[k]}}e.$gh=M;function C(A,l,D){return y((g,R)=>{const k=`$debounce$${R}`,a=`$debounce$result$${R}`;return function(...p){this[a]||(this[a]=D?D():void 0),clearTimeout(this[k]),l&&(this[a]=l(this[a],...p),p=[this[a]]),this[k]=setTimeout(()=>{g.apply(this,p),this[a]=D?D():void 0},A)}})}e.$hh=C;function T(A,l,D){return y((g,R)=>{const k=`$throttle$timer$${R}`,a=`$throttle$result$${R}`,p=`$throttle$lastRun$${R}`,$=`$throttle$pending$${R}`;return function(...f){if(this[a]||(this[a]=D?D():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),l&&(this[a]=l(this[a],...f)),this[$])return;const t=this[p]+A;t<=Date.now()?(this[p]=Date.now(),g.apply(this,[this[a]]),this[a]=D?D():void 0):(this[$]=!0,this[k]=setTimeout(()=>{this[$]=!1,this[p]=Date.now(),g.apply(this,[this[a]]),this[a]=D?D():void 0},t-Date.now()))}})}e.$ih=T}),define(Ae[88],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=e.$iM=void 0;class y{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$iM=y,e.$jM=new y("id#")}),define(Ae[115],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var M;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var C;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var T;(function(n){n.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function A(n,r=!1){let s=0;const o=n.length;let w="",h=0,I=16,S=0;function u(B){let O=0,N=0;for(;O<B;){const te=n.charCodeAt(s);if(te>=48&&te<=57)N=N*16+te-48;else if(te>=65&&te<=70)N=N*16+te-65+10;else if(te>=97&&te<=102)N=N*16+te-97+10;else break;s++,O++}return O<B&&(N=-1),N}function m(B){s=B,w="",h=0,I=16,S=0}function d(){const B=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&g(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&g(n.charCodeAt(s)))for(s++;s<n.length&&g(n.charCodeAt(s));)s++;else return S=3,n.substring(B,s);let O=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&g(n.charCodeAt(s))){for(s++;s<n.length&&g(n.charCodeAt(s));)s++;O=s}else S=3;return n.substring(B,O)}function P(){let B="",O=s;for(;;){if(s>=o){B+=n.substring(O,s),S=2;break}const N=n.charCodeAt(s);if(N===34){B+=n.substring(O,s),s++;break}if(N===92){if(B+=n.substring(O,s),s++,s>=o){S=2;break}switch(n.charCodeAt(s++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const Y=u(4);Y>=0?B+=String.fromCharCode(Y):S=4;break}default:S=5}O=s;continue}if(N>=0&&N<=31)if(D(N)){B+=n.substring(O,s),S=2;break}else S=6;s++}return B}function W(){if(w="",S=0,h=s,s>=o)return h=o,I=17;let B=n.charCodeAt(s);if(l(B)){do s++,w+=String.fromCharCode(B),B=n.charCodeAt(s);while(l(B));return I=15}if(D(B))return s++,w+=String.fromCharCode(B),B===13&&n.charCodeAt(s)===10&&(s++,w+=`
`),I=14;switch(B){case 123:return s++,I=1;case 125:return s++,I=2;case 91:return s++,I=3;case 93:return s++,I=4;case 58:return s++,I=6;case 44:return s++,I=5;case 34:return s++,w=P(),I=10;case 47:{const O=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<o&&!D(n.charCodeAt(s));)s++;return w=n.substring(O,s),I=12}if(n.charCodeAt(s+1)===42){s+=2;const N=o-1;let te=!1;for(;s<N;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,te=!0;break}s++}return te||(s++,S=1),w=n.substring(O,s),I=13}return w+=String.fromCharCode(B),s++,I=16}case 45:if(w+=String.fromCharCode(B),s++,s===o||!g(n.charCodeAt(s)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=d(),I=11;default:for(;s<o&&K(B);)s++,B=n.charCodeAt(s);if(h!==s){switch(w=n.substring(h,s),w){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return w+=String.fromCharCode(B),s++,I=16}}function K(B){if(l(B)||D(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let B;do B=W();while(B>=12&&B<=15);return B}return{setPosition:m,getPosition:()=>s,scan:r?U:W,getToken:()=>I,getTokenValue:()=>w,getTokenOffset:()=>h,getTokenLength:()=>s-h,getTokenError:()=>S}}e.$Rm=A;function l(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function D(n){return n===10||n===13||n===8232||n===8233}function g(n){return n>=48&&n<=57}var R;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(R||(R={}));function k(n,r){const s=[],o=new Object;let w;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function S(u,m,d,P){h.value=u,h.offset=m,h.length=d,h.type=P,h.colonOffset=void 0,w=h}try{b(n,{onObjectBegin:(u,m)=>{if(r<=u)throw o;w=void 0,I=r>u,s.push("")},onObjectProperty:(u,m,d)=>{if(r<m||(S(u,m,d,"property"),s[s.length-1]=u,r<=m+d))throw o},onObjectEnd:(u,m)=>{if(r<=u)throw o;w=void 0,s.pop()},onArrayBegin:(u,m)=>{if(r<=u)throw o;w=void 0,s.push(0)},onArrayEnd:(u,m)=>{if(r<=u)throw o;w=void 0,s.pop()},onLiteralValue:(u,m,d)=>{if(r<m||(S(u,m,d,v(u)),r<=m+d))throw o},onSeparator:(u,m,d)=>{if(r<=m)throw o;if(u===":"&&w&&w.type==="property")w.colonOffset=m,I=!1,w=void 0;else if(u===","){const P=s[s.length-1];typeof P=="number"?s[s.length-1]=P+1:(I=!0,s[s.length-1]=""),w=void 0}}})}catch(u){if(u!==o)throw u}return{path:s,previousNode:w,isAtPropertyKey:I,matches:u=>{let m=0;for(let d=0;m<u.length&&d<s.length;d++)if(u[m]===s[d]||u[m]==="*")m++;else if(u[m]!=="**")return!1;return m===u.length}}}e.$Sm=k;function a(n,r=[],s=T.DEFAULT){let o=null,w=[];const h=[];function I(u){Array.isArray(w)?w.push(u):o!==null&&(w[o]=u)}return b(n,{onObjectBegin:()=>{const u={};I(u),h.push(w),w=u,o=null},onObjectProperty:u=>{o=u},onObjectEnd:()=>{w=h.pop()},onArrayBegin:()=>{const u=[];I(u),h.push(w),w=u,o=null},onArrayEnd:()=>{w=h.pop()},onLiteralValue:I,onError:(u,m,d)=>{r.push({error:u,offset:m,length:d})}},s),w[0]}e.$Tm=a;function p(n,r=[],s=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(u){o.type==="property"&&(o.length=u-o.offset,o=o.parent)}function h(u){return o.children.push(u),u}b(n,{onObjectBegin:u=>{o=h({type:"object",offset:u,length:-1,parent:o,children:[]})},onObjectProperty:(u,m,d)=>{o=h({type:"property",offset:m,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:u,offset:m,length:d,parent:o})},onObjectEnd:(u,m)=>{o.length=u+m-o.offset,o=o.parent,w(u+m)},onArrayBegin:(u,m)=>{o=h({type:"array",offset:u,length:-1,parent:o,children:[]})},onArrayEnd:(u,m)=>{o.length=u+m-o.offset,o=o.parent,w(u+m)},onLiteralValue:(u,m,d)=>{h({type:v(u),offset:m,length:d,parent:o,value:u}),w(m+d)},onSeparator:(u,m,d)=>{o.type==="property"&&(u===":"?o.colonOffset=m:u===","&&w(m))},onError:(u,m,d)=>{r.push({error:u,offset:m,length:d})}},s);const S=o.children[0];return S&&delete S.parent,S}e.$Um=p;function $(n,r){if(!n)return;let s=n;for(const o of r)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let w=!1;for(const h of s.children)if(Array.isArray(h.children)&&h.children[0].value===o){s=h.children[1],w=!0;break}if(!w)return}else{const w=o;if(s.type!=="array"||w<0||!Array.isArray(s.children)||w>=s.children.length)return;s=s.children[w]}return s}e.$Vm=$;function f(n){if(!n.parent||!n.parent.children)return[];const r=f(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;r.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&r.push(s)}return r}e.$Wm=f;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const r=Object.create(null);for(const s of n.children){const o=s.children[1];o&&(r[s.children[0].value]=t(o))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$Xm=t;function i(n,r,s=!1){return r>=n.offset&&r<n.offset+n.length||s&&r===n.offset+n.length}e.$Ym=i;function c(n,r,s=!1){if(i(n,r,s)){const o=n.children;if(Array.isArray(o))for(let w=0;w<o.length&&o[w].offset<=r;w++){const h=c(o[w],r,s);if(h)return h}return n}}e.$Zm=c;function b(n,r,s=T.DEFAULT){const o=A(n,!1);function w(ce){return ce?()=>ce(o.getTokenOffset(),o.getTokenLength()):()=>!0}function h(ce){return ce?se=>ce(se,o.getTokenOffset(),o.getTokenLength()):()=>!0}const I=w(r.onObjectBegin),S=h(r.onObjectProperty),u=w(r.onObjectEnd),m=w(r.onArrayBegin),d=w(r.onArrayEnd),P=h(r.onLiteralValue),W=h(r.onSeparator),K=w(r.onComment),U=h(r.onError),B=s&&s.disallowComments,O=s&&s.allowTrailingComma;function N(){for(;;){const ce=o.scan();switch(o.getTokenError()){case 4:te(14);break;case 5:te(15);break;case 3:te(13);break;case 1:B||te(11);break;case 2:te(12);break;case 6:te(16);break}switch(ce){case 12:case 13:B?te(10):K();break;case 16:te(1);break;case 15:case 14:break;default:return ce}}}function te(ce,se=[],$e=[]){if(U(ce),se.length+$e.length>0){let x=o.getToken();for(;x!==17;){if(se.indexOf(x)!==-1){N();break}else if($e.indexOf(x)!==-1)break;x=N()}}}function Y(ce){const se=o.getTokenValue();return ce?P(se):S(se),N(),!0}function Ee(){switch(o.getToken()){case 11:{let ce=0;try{ce=JSON.parse(o.getTokenValue()),typeof ce!="number"&&(te(2),ce=0)}catch{te(2)}P(ce);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return N(),!0}function Se(){return o.getToken()!==10?(te(3,[],[2,5]),!1):(Y(!1),o.getToken()===6?(W(":"),N(),me()||te(4,[],[2,5])):te(5,[],[2,5]),!0)}function Pe(){I(),N();let ce=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ce||te(4,[],[]),W(","),N(),o.getToken()===2&&O)break}else ce&&te(6,[],[]);Se()||te(4,[],[2,5]),ce=!0}return u(),o.getToken()!==2?te(7,[2],[]):N(),!0}function ge(){m(),N();let ce=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ce||te(4,[],[]),W(","),N(),o.getToken()===4&&O)break}else ce&&te(6,[],[]);me()||te(4,[],[4,5]),ce=!0}return d(),o.getToken()!==4?te(8,[4],[]):N(),!0}function me(){switch(o.getToken()){case 3:return ge();case 1:return Pe();case 10:return Y(!0);default:return Ee()}}return N(),o.getToken()===17?s.allowEmptyContent?!0:(te(4,[],[]),!1):me()?(o.getToken()!==17&&te(9,[],[]),!0):(te(4,[],[]),!1)}e.$1m=b;function E(n,r){const s=A(n),o=[];let w,h=0,I;do switch(I=s.getPosition(),w=s.scan(),w){case 12:case 13:case 17:h!==I&&o.push(n.substring(h,I)),r!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,r)),h=s.getPosition();break}while(w!==17);return o.join("")}e.$2m=E;function v(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$3m=v}),function(be,e){typeof define=="function"&&define.amd?define(Ae[116],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(we,pe){for(var De=0;De<pe.length;De++){var ne=pe[De];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(we,ne.key,ne)}}function y(we,pe,De){return pe&&e(we.prototype,pe),De&&e(we,De),Object.defineProperty(we,"prototype",{writable:!1}),we}function M(we,pe){if(we){if(typeof we=="string")return C(we,pe);var De=Object.prototype.toString.call(we).slice(8,-1);if(De==="Object"&&we.constructor&&(De=we.constructor.name),De==="Map"||De==="Set")return Array.from(we);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return C(we,pe)}}function C(we,pe){(pe==null||pe>we.length)&&(pe=we.length);for(var De=0,ne=new Array(pe);De<pe;De++)ne[De]=we[De];return ne}function T(we,pe){var De=typeof Symbol<"u"&&we[Symbol.iterator]||we["@@iterator"];if(De)return(De=De.call(we)).next.bind(De);if(Array.isArray(we)||(De=M(we))||pe&&we&&typeof we.length=="number"){De&&(we=De);var ne=0;return function(){return ne>=we.length?{done:!0}:{done:!1,value:we[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=A();function l(we){be.defaults=we}var D=/[&<>"']/,g=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(pe){return a[pe]};function $(we,pe){if(pe){if(D.test(we))return we.replace(g,p)}else if(R.test(we))return we.replace(k,p);return we}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(we){return we.replace(f,function(pe,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var i=/(^|[^\[])\^/g;function c(we,pe){we=typeof we=="string"?we:we.source,pe=pe||"";var De={replace:function(le,re){return re=re.source||re,re=re.replace(i,"$1"),we=we.replace(le,re),De},getRegex:function(){return new RegExp(we,pe)}};return De}var b=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(we,pe,De){if(we){var ne;try{ne=decodeURIComponent(t(De)).replace(b,"").toLowerCase()}catch{return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}pe&&!E.test(De)&&(De=w(pe,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var n={},r=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(we,pe){n[" "+we]||(r.test(we)?n[" "+we]=we+"/":n[" "+we]=u(we,"/",!0)),we=n[" "+we];var De=we.indexOf(":")===-1;return pe.substring(0,2)==="//"?De?pe:we.replace(s,"$1")+pe:pe.charAt(0)==="/"?De?pe:we.replace(o,"$1")+pe:we+pe}var h={exec:function(){}};function I(we){for(var pe=1,De,ne;pe<arguments.length;pe++){De=arguments[pe];for(ne in De)Object.prototype.hasOwnProperty.call(De,ne)&&(we[ne]=De[ne])}return we}function S(we,pe){var De=we.replace(/\|/g,function(re,oe,he){for(var Ie=!1,F=oe;--F>=0&&he[F]==="\\";)Ie=!Ie;return Ie?"|":" |"}),ne=De.split(/ \|/),le=0;if(ne[0].trim()||ne.shift(),ne.length>0&&!ne[ne.length-1].trim()&&ne.pop(),ne.length>pe)ne.splice(pe);else for(;ne.length<pe;)ne.push("");for(;le<ne.length;le++)ne[le]=ne[le].trim().replace(/\\\|/g,"|");return ne}function u(we,pe,De){var ne=we.length;if(ne===0)return"";for(var le=0;le<ne;){var re=we.charAt(ne-le-1);if(re===pe&&!De)le++;else if(re!==pe&&De)le++;else break}return we.slice(0,ne-le)}function m(we,pe){if(we.indexOf(pe[1])===-1)return-1;for(var De=we.length,ne=0,le=0;le<De;le++)if(we[le]==="\\")le++;else if(we[le]===pe[0])ne++;else if(we[le]===pe[1]&&(ne--,ne<0))return le;return-1}function d(we){we&&we.sanitize&&!we.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(we,pe){if(pe<1)return"";for(var De="";pe>1;)pe&1&&(De+=we),pe>>=1,we+=we;return De+we}function W(we,pe,De,ne){var le=pe.href,re=pe.title?$(pe.title):null,oe=we[1].replace(/\\([\[\]])/g,"$1");if(we[0].charAt(0)!=="!"){ne.state.inLink=!0;var he={type:"link",raw:De,href:le,title:re,text:oe,tokens:ne.inlineTokens(oe)};return ne.state.inLink=!1,he}return{type:"image",raw:De,href:le,title:re,text:$(oe)}}function K(we,pe){var De=we.match(/^(\s+)(?:```)/);if(De===null)return pe;var ne=De[1];return pe.split(`
`).map(function(le){var re=le.match(/^\s+/);if(re===null)return le;var oe=re[0];return oe.length>=ne.length?le.slice(ne.length):le}).join(`
`)}var U=function(){function we(De){this.options=De||be.defaults}var pe=we.prototype;return pe.space=function(ne){var le=this.rules.block.newline.exec(ne);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},pe.code=function(ne){var le=this.rules.block.code.exec(ne);if(le){var re=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?re:u(re,`
`)}}},pe.fences=function(ne){var le=this.rules.block.fences.exec(ne);if(le){var re=le[0],oe=K(re,le[3]||"");return{type:"code",raw:re,lang:le[2]?le[2].trim():le[2],text:oe}}},pe.heading=function(ne){var le=this.rules.block.heading.exec(ne);if(le){var re=le[2].trim();if(/#$/.test(re)){var oe=u(re,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(re=oe.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:re,tokens:this.lexer.inline(re)}}},pe.hr=function(ne){var le=this.rules.block.hr.exec(ne);if(le)return{type:"hr",raw:le[0]}},pe.blockquote=function(ne){var le=this.rules.block.blockquote.exec(ne);if(le){var re=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(re,[]),text:re}}},pe.list=function(ne){var le=this.rules.block.list.exec(ne);if(le){var re,oe,he,Ie,F,q,J,Q,H,_,ae,Ne,Ue=le[1].trim(),Qe=Ue.length>1,Ge={type:"list",raw:"",ordered:Qe,start:Qe?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Qe?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Qe?Ue:"[*+-]");for(var _e=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");ne&&(Ne=!1,!(!(le=_e.exec(ne))||this.rules.block.hr.test(ne)));){if(re=le[0],ne=ne.substring(re.length),Q=le[2].split(`
`,1)[0],H=ne.split(`
`,1)[0],this.options.pedantic?(Ie=2,ae=Q.trimLeft()):(Ie=le[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ae=Q.slice(Ie),Ie+=le[1].length),q=!1,!Q&&/^ *$/.test(H)&&(re+=H+`
`,ne=ne.substring(H.length+1),Ne=!0),!Ne)for(var Ze=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");ne&&(_=ne.split(`
`,1)[0],Q=_,this.options.pedantic&&(Q=Q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Q)||tt.test(Q)||Ze.test(Q)||xe.test(ne)));){if(Q.search(/[^ ]/)>=Ie||!Q.trim())ae+=`
`+Q.slice(Ie);else if(!q)ae+=`
`+Q;else break;!q&&!Q.trim()&&(q=!0),re+=_+`
`,ne=ne.substring(_.length+1)}Ge.loose||(J?Ge.loose=!0:/\n *\n *$/.test(re)&&(J=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ae),oe&&(he=oe[0]!=="[ ] ",ae=ae.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:re,task:!!oe,checked:he,loose:!1,text:ae}),Ge.raw+=re}Ge.items[Ge.items.length-1].raw=re.trimRight(),Ge.items[Ge.items.length-1].text=ae.trimRight(),Ge.raw=Ge.raw.trimRight();var ze=Ge.items.length;for(F=0;F<ze;F++){this.lexer.state.top=!1,Ge.items[F].tokens=this.lexer.blockTokens(Ge.items[F].text,[]);var st=Ge.items[F].tokens.filter(function(X){return X.type==="space"}),Z=st.every(function(X){for(var ve=X.raw.split(""),Be=0,Oe=T(ve),Xe;!(Xe=Oe()).done;){var nt=Xe.value;if(nt===`
`&&(Be+=1),Be>1)return!0}return!1});!Ge.loose&&st.length&&Z&&(Ge.loose=!0,Ge.items[F].loose=!0)}return Ge}},pe.html=function(ne){var le=this.rules.block.html.exec(ne);if(le){var re={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]);re.type="paragraph",re.text=oe,re.tokens=this.lexer.inline(oe)}return re}},pe.def=function(ne){var le=this.rules.block.def.exec(ne);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var re=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:re,raw:le[0],href:le[2],title:le[3]}}},pe.table=function(ne){var le=this.rules.block.table.exec(ne);if(le){var re={type:"table",header:S(le[1]).map(function(J){return{text:J}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(re.header.length===re.align.length){re.raw=le[0];var oe=re.align.length,he,Ie,F,q;for(he=0;he<oe;he++)/^ *-+: *$/.test(re.align[he])?re.align[he]="right":/^ *:-+: *$/.test(re.align[he])?re.align[he]="center":/^ *:-+ *$/.test(re.align[he])?re.align[he]="left":re.align[he]=null;for(oe=re.rows.length,he=0;he<oe;he++)re.rows[he]=S(re.rows[he],re.header.length).map(function(J){return{text:J}});for(oe=re.header.length,Ie=0;Ie<oe;Ie++)re.header[Ie].tokens=this.lexer.inline(re.header[Ie].text);for(oe=re.rows.length,Ie=0;Ie<oe;Ie++)for(q=re.rows[Ie],F=0;F<q.length;F++)q[F].tokens=this.lexer.inline(q[F].text);return re}}},pe.lheading=function(ne){var le=this.rules.block.lheading.exec(ne);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},pe.paragraph=function(ne){var le=this.rules.block.paragraph.exec(ne);if(le){var re=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:re,tokens:this.lexer.inline(re)}}},pe.text=function(ne){var le=this.rules.block.text.exec(ne);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},pe.escape=function(ne){var le=this.rules.inline.escape.exec(ne);if(le)return{type:"escape",raw:le[0],text:$(le[1])}},pe.tag=function(ne){var le=this.rules.inline.tag.exec(ne);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]):le[0]}},pe.link=function(ne){var le=this.rules.inline.link.exec(ne);if(le){var re=le[2].trim();if(!this.options.pedantic&&/^</.test(re)){if(!/>$/.test(re))return;var oe=u(re.slice(0,-1),"\\");if((re.length-oe.length)%2===0)return}else{var he=m(le[2],"()");if(he>-1){var Ie=le[0].indexOf("!")===0?5:4,F=Ie+le[1].length+he;le[2]=le[2].substring(0,he),le[0]=le[0].substring(0,F).trim(),le[3]=""}}var q=le[2],J="";if(this.options.pedantic){var Q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);Q&&(q=Q[1],J=Q[3])}else J=le[3]?le[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(re)?q=q.slice(1):q=q.slice(1,-1)),W(le,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:J&&J.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},pe.reflink=function(ne,le){var re;if((re=this.rules.inline.reflink.exec(ne))||(re=this.rules.inline.nolink.exec(ne))){var oe=(re[2]||re[1]).replace(/\s+/g," ");if(oe=le[oe.toLowerCase()],!oe||!oe.href){var he=re[0].charAt(0);return{type:"text",raw:he,text:he}}return W(re,oe,re[0],this.lexer)}},pe.emStrong=function(ne,le,re){re===void 0&&(re="");var oe=this.rules.inline.emStrong.lDelim.exec(ne);if(oe&&!(oe[3]&&re.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var he=oe[1]||oe[2]||"";if(!he||he&&(re===""||this.rules.inline.punctuation.exec(re))){var Ie=oe[0].length-1,F,q,J=Ie,Q=0,H=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,le=le.slice(-1*ne.length+Ie);(oe=H.exec(le))!=null;)if(F=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!F){if(q=F.length,oe[3]||oe[4]){J+=q;continue}else if((oe[5]||oe[6])&&Ie%3&&!((Ie+q)%3)){Q+=q;continue}if(J-=q,!(J>0)){if(q=Math.min(q,q+J+Q),Math.min(Ie,q)%2){var _=ne.slice(1,Ie+oe.index+q);return{type:"em",raw:ne.slice(0,Ie+oe.index+q+1),text:_,tokens:this.lexer.inlineTokens(_)}}var ae=ne.slice(2,Ie+oe.index+q-1);return{type:"strong",raw:ne.slice(0,Ie+oe.index+q+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}}}}},pe.codespan=function(ne){var le=this.rules.inline.code.exec(ne);if(le){var re=le[2].replace(/\n/g," "),oe=/[^ ]/.test(re),he=/^ /.test(re)&&/ $/.test(re);return oe&&he&&(re=re.substring(1,re.length-1)),re=$(re,!0),{type:"codespan",raw:le[0],text:re}}},pe.br=function(ne){var le=this.rules.inline.br.exec(ne);if(le)return{type:"br",raw:le[0]}},pe.del=function(ne){var le=this.rules.inline.del.exec(ne);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},pe.autolink=function(ne,le){var re=this.rules.inline.autolink.exec(ne);if(re){var oe,he;return re[2]==="@"?(oe=$(this.options.mangle?le(re[1]):re[1]),he="mailto:"+oe):(oe=$(re[1]),he=oe),{type:"link",raw:re[0],text:oe,href:he,tokens:[{type:"text",raw:oe,text:oe}]}}},pe.url=function(ne,le){var re;if(re=this.rules.inline.url.exec(ne)){var oe,he;if(re[2]==="@")oe=$(this.options.mangle?le(re[0]):re[0]),he="mailto:"+oe;else{var Ie;do Ie=re[0],re[0]=this.rules.inline._backpedal.exec(re[0])[0];while(Ie!==re[0]);oe=$(re[0]),re[1]==="www."?he="http://"+oe:he=oe}return{type:"link",raw:re[0],text:oe,href:he,tokens:[{type:"text",raw:oe,text:oe}]}}},pe.inlineText=function(ne,le){var re=this.rules.inline.text.exec(ne);if(re){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):$(re[0]):re[0]:oe=$(this.options.smartypants?le(re[0]):re[0]),{type:"text",raw:re[0],text:oe}}},we}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=c(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=c(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=c(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=c(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=c(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=c(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=I({},B),B.gfm=I({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=c(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=c(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=I({},B.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:c(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=c(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=c(B._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=c(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=c(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=c(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=c(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=c(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=c(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=c(O.reflink).replace("label",O._label).replace("ref",B._label).getRegex(),O.nolink=c(O.nolink).replace("ref",B._label).getRegex(),O.reflinkSearch=c(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=I({},O),O.pedantic=I({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=I({},O.normal,{escape:c(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=c(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=I({},O.gfm,{br:c(O.br).replace("{2,}","*").getRegex(),text:c(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(we){return we.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function te(we){var pe="",De,ne,le=we.length;for(De=0;De<le;De++)ne=we.charCodeAt(De),Math.random()>.5&&(ne="x"+ne.toString(16)),pe+="&#"+ne+";";return pe}var Y=function(){function we(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||be.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:B.normal,inline:O.normal};this.options.pedantic?(ne.block=B.pedantic,ne.inline=O.pedantic):this.options.gfm&&(ne.block=B.gfm,this.options.breaks?ne.inline=O.breaks:ne.inline=O.gfm),this.tokenizer.rules=ne}we.lex=function(ne,le){var re=new we(le);return re.lex(ne)},we.lexInline=function(ne,le){var re=new we(le);return re.inlineTokens(ne)};var pe=we.prototype;return pe.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`),this.blockTokens(ne,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},pe.blockTokens=function(ne,le){var re=this;le===void 0&&(le=[]),this.options.pedantic?ne=ne.replace(/\t/g,"    ").replace(/^ +$/gm,""):ne=ne.replace(/^( *)(\t+)/gm,function(J,Q,H){return Q+"    ".repeat(H.length)});for(var oe,he,Ie,F;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(J){return(oe=J.call({lexer:re},ne,le))?(ne=ne.substring(oe.raw.length),le.push(oe),!0):!1}))){if(oe=this.tokenizer.space(ne)){ne=ne.substring(oe.raw.length),oe.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(oe);continue}if(oe=this.tokenizer.code(ne)){ne=ne.substring(oe.raw.length),he=le[le.length-1],he&&(he.type==="paragraph"||he.type==="text")?(he.raw+=`
`+oe.raw,he.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=he.text):le.push(oe);continue}if(oe=this.tokenizer.fences(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.heading(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.hr(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.blockquote(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.list(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.html(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.def(ne)){ne=ne.substring(oe.raw.length),he=le[le.length-1],he&&(he.type==="paragraph"||he.type==="text")?(he.raw+=`
`+oe.raw,he.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=he.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.lheading(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(Ie=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var J=1/0,Q=ne.slice(1),H=void 0;re.options.extensions.startBlock.forEach(function(_){H=_.call({lexer:this},Q),typeof H=="number"&&H>=0&&(J=Math.min(J,H))}),J<1/0&&J>=0&&(Ie=ne.substring(0,J+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Ie))){he=le[le.length-1],F&&he.type==="paragraph"?(he.raw+=`
`+oe.raw,he.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=he.text):le.push(oe),F=Ie.length!==ne.length,ne=ne.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(ne)){ne=ne.substring(oe.raw.length),he=le[le.length-1],he&&he.type==="text"?(he.raw+=`
`+oe.raw,he.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=he.text):le.push(oe);continue}if(ne){var q="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,le},pe.inline=function(ne,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:ne,tokens:le}),le},pe.inlineTokens=function(ne,le){var re=this;le===void 0&&(le=[]);var oe,he,Ie,F=ne,q,J,Q;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(F))!=null;)H.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(F=F.slice(0,q.index)+"["+P("a",q[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(F))!=null;)F=F.slice(0,q.index)+"["+P("a",q[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(F))!=null;)F=F.slice(0,q.index)+"++"+F.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(J||(Q=""),J=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(oe=ae.call({lexer:re},ne,le))?(ne=ne.substring(oe.raw.length),le.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.tag(ne)){ne=ne.substring(oe.raw.length),he=le[le.length-1],he&&oe.type==="text"&&he.type==="text"?(he.raw+=oe.raw,he.text+=oe.text):le.push(oe);continue}if(oe=this.tokenizer.link(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(oe.raw.length),he=le[le.length-1],he&&oe.type==="text"&&he.type==="text"?(he.raw+=oe.raw,he.text+=oe.text):le.push(oe);continue}if(oe=this.tokenizer.emStrong(ne,F,Q)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.codespan(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.br(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.del(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.autolink(ne,te)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(ne,te))){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(Ie=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=1/0,Ne=ne.slice(1),Ue=void 0;re.options.extensions.startInline.forEach(function(Qe){Ue=Qe.call({lexer:this},Ne),typeof Ue=="number"&&Ue>=0&&(ae=Math.min(ae,Ue))}),ae<1/0&&ae>=0&&(Ie=ne.substring(0,ae+1))}(),oe=this.tokenizer.inlineText(Ie,N)){ne=ne.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(Q=oe.raw.slice(-1)),J=!0,he=le[le.length-1],he&&he.type==="text"?(he.raw+=oe.raw,he.text+=oe.text):le.push(oe);continue}if(ne){var _="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(_);break}else throw new Error(_)}}return le},y(we,null,[{key:"rules",get:function(){return{block:B,inline:O}}}]),we}(),Ee=function(){function we(De){this.options=De||be.defaults}var pe=we.prototype;return pe.code=function(ne,le,re){var oe=(le||"").match(/\S*/)[0];if(this.options.highlight){var he=this.options.highlight(ne,oe);he!=null&&he!==ne&&(re=!0,ne=he)}return ne=ne.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+$(oe,!0)+'">'+(re?ne:$(ne,!0))+`</code></pre>
`:"<pre><code>"+(re?ne:$(ne,!0))+`</code></pre>
`},pe.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},pe.html=function(ne){return ne},pe.heading=function(ne,le,re,oe){if(this.options.headerIds){var he=this.options.headerPrefix+oe.slug(re);return"<h"+le+' id="'+he+'">'+ne+"</h"+le+`>
`}return"<h"+le+">"+ne+"</h"+le+`>
`},pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},pe.list=function(ne,le,re){var oe=le?"ol":"ul",he=le&&re!==1?' start="'+re+'"':"";return"<"+oe+he+`>
`+ne+"</"+oe+`>
`},pe.listitem=function(ne){return"<li>"+ne+`</li>
`},pe.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},pe.paragraph=function(ne){return"<p>"+ne+`</p>
`},pe.table=function(ne,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+le+`</table>
`},pe.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},pe.tablecell=function(ne,le){var re=le.header?"th":"td",oe=le.align?"<"+re+' align="'+le.align+'">':"<"+re+">";return oe+ne+("</"+re+`>
`)},pe.strong=function(ne){return"<strong>"+ne+"</strong>"},pe.em=function(ne){return"<em>"+ne+"</em>"},pe.codespan=function(ne){return"<code>"+ne+"</code>"},pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},pe.del=function(ne){return"<del>"+ne+"</del>"},pe.link=function(ne,le,re){if(ne=v(this.options.sanitize,this.options.baseUrl,ne),ne===null)return re;var oe='<a href="'+$(ne)+'"';return le&&(oe+=' title="'+le+'"'),oe+=">"+re+"</a>",oe},pe.image=function(ne,le,re){if(ne=v(this.options.sanitize,this.options.baseUrl,ne),ne===null)return re;var oe='<img src="'+ne+'" alt="'+re+'"';return le&&(oe+=' title="'+le+'"'),oe+=this.options.xhtml?"/>":">",oe},pe.text=function(ne){return ne},we}(),Se=function(){function we(){}var pe=we.prototype;return pe.strong=function(ne){return ne},pe.em=function(ne){return ne},pe.codespan=function(ne){return ne},pe.del=function(ne){return ne},pe.html=function(ne){return ne},pe.text=function(ne){return ne},pe.link=function(ne,le,re){return""+re},pe.image=function(ne,le,re){return""+re},pe.br=function(){return""},we}(),Pe=function(){function we(){this.seen={}}var pe=we.prototype;return pe.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},pe.getNextSafeSlug=function(ne,le){var re=ne,oe=0;if(this.seen.hasOwnProperty(re)){oe=this.seen[ne];do oe++,re=ne+"-"+oe;while(this.seen.hasOwnProperty(re))}return le||(this.seen[ne]=oe,this.seen[re]=0),re},pe.slug=function(ne,le){le===void 0&&(le={});var re=this.serialize(ne);return this.getNextSafeSlug(re,le.dryrun)},we}(),ge=function(){function we(De){this.options=De||be.defaults,this.options.renderer=this.options.renderer||new Ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Se,this.slugger=new Pe}we.parse=function(ne,le){var re=new we(le);return re.parse(ne)},we.parseInline=function(ne,le){var re=new we(le);return re.parseInline(ne)};var pe=we.prototype;return pe.parse=function(ne,le){le===void 0&&(le=!0);var re="",oe,he,Ie,F,q,J,Q,H,_,ae,Ne,Ue,Qe,Ge,_e,Ze,xe,it,tt,ze=ne.length;for(oe=0;oe<ze;oe++){if(ae=ne[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(tt=this.options.extensions.renderers[ae.type].call({parser:this},ae),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){re+=tt||"";continue}switch(ae.type){case"space":continue;case"hr":{re+=this.renderer.hr();continue}case"heading":{re+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,t(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{re+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(H="",Q="",F=ae.header.length,he=0;he<F;he++)Q+=this.renderer.tablecell(this.parseInline(ae.header[he].tokens),{header:!0,align:ae.align[he]});for(H+=this.renderer.tablerow(Q),_="",F=ae.rows.length,he=0;he<F;he++){for(J=ae.rows[he],Q="",q=J.length,Ie=0;Ie<q;Ie++)Q+=this.renderer.tablecell(this.parseInline(J[Ie].tokens),{header:!1,align:ae.align[Ie]});_+=this.renderer.tablerow(Q)}re+=this.renderer.table(H,_);continue}case"blockquote":{_=this.parse(ae.tokens),re+=this.renderer.blockquote(_);continue}case"list":{for(Ne=ae.ordered,Ue=ae.start,Qe=ae.loose,F=ae.items.length,_="",he=0;he<F;he++)_e=ae.items[he],Ze=_e.checked,xe=_e.task,Ge="",_e.task&&(it=this.renderer.checkbox(Ze),Qe?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=it+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=it+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:it}):Ge+=it),Ge+=this.parse(_e.tokens,Qe),_+=this.renderer.listitem(Ge,xe,Ze);re+=this.renderer.list(_,Ne,Ue);continue}case"html":{re+=this.renderer.html(ae.text);continue}case"paragraph":{re+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(_=ae.tokens?this.parseInline(ae.tokens):ae.text;oe+1<ze&&ne[oe+1].type==="text";)ae=ne[++oe],_+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);re+=le?this.renderer.paragraph(_):_;continue}default:{var st='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return re},pe.parseInline=function(ne,le){le=le||this.renderer;var re="",oe,he,Ie,F=ne.length;for(oe=0;oe<F;oe++){if(he=ne[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]&&(Ie=this.options.extensions.renderers[he.type].call({parser:this},he),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(he.type))){re+=Ie||"";continue}switch(he.type){case"escape":{re+=le.text(he.text);break}case"html":{re+=le.html(he.text);break}case"link":{re+=le.link(he.href,he.title,this.parseInline(he.tokens,le));break}case"image":{re+=le.image(he.href,he.title,he.text);break}case"strong":{re+=le.strong(this.parseInline(he.tokens,le));break}case"em":{re+=le.em(this.parseInline(he.tokens,le));break}case"codespan":{re+=le.codespan(he.text);break}case"br":{re+=le.br();break}case"del":{re+=le.del(this.parseInline(he.tokens,le));break}case"text":{re+=le.text(he.text);break}default:{var q='Token with "'+he.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return re},we}();function me(we,pe,De){if(typeof we>"u"||we===null)throw new Error("marked(): input parameter is undefined or null");if(typeof we!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(we)+", string expected");if(typeof pe=="function"&&(De=pe,pe=null),pe=I({},me.defaults,pe||{}),d(pe),De){var ne=pe.highlight,le;try{le=Y.lex(we,pe)}catch(F){return De(F)}var re=function(q){var J;if(!q)try{pe.walkTokens&&me.walkTokens(le,pe.walkTokens),J=ge.parse(le,pe)}catch(Q){q=Q}return pe.highlight=ne,q?De(q):De(null,J)};if(!ne||ne.length<3||(delete pe.highlight,!le.length))return re();var oe=0;me.walkTokens(le,function(F){F.type==="code"&&(oe++,setTimeout(function(){ne(F.text,F.lang,function(q,J){if(q)return re(q);J!=null&&J!==F.text&&(F.text=J,F.escaped=!0),oe--,oe===0&&re()})},0))}),oe===0&&re();return}function he(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+$(F.message+"",!0)+"</pre>";throw F}try{var Ie=Y.lex(we,pe);if(pe.walkTokens){if(pe.async)return Promise.all(me.walkTokens(Ie,pe.walkTokens)).then(function(){return ge.parse(Ie,pe)}).catch(he);me.walkTokens(Ie,pe.walkTokens)}return ge.parse(Ie,pe)}catch(F){he(F)}}me.options=me.setOptions=function(we){return I(me.defaults,we),l(me.defaults),me},me.getDefaults=A,me.defaults=be.defaults,me.use=function(){for(var we=arguments.length,pe=new Array(we),De=0;De<we;De++)pe[De]=arguments[De];var ne=I.apply(void 0,[{}].concat(pe)),le=me.defaults.extensions||{renderers:{},childTokens:{}},re;pe.forEach(function(oe){if(oe.extensions&&(re=!0,oe.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var F=le.renderers?le.renderers[Ie.name]:null;F?le.renderers[Ie.name]=function(){for(var q=arguments.length,J=new Array(q),Q=0;Q<q;Q++)J[Q]=arguments[Q];var H=Ie.renderer.apply(this,J);return H===!1&&(H=F.apply(this,J)),H}:le.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[Ie.level]?le[Ie.level].unshift(Ie.tokenizer):le[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?le.startBlock?le.startBlock.push(Ie.start):le.startBlock=[Ie.start]:Ie.level==="inline"&&(le.startInline?le.startInline.push(Ie.start):le.startInline=[Ie.start]))}Ie.childTokens&&(le.childTokens[Ie.name]=Ie.childTokens)})),oe.renderer&&function(){var Ie=me.defaults.renderer||new Ee,F=function(Q){var H=Ie[Q];Ie[Q]=function(){for(var _=arguments.length,ae=new Array(_),Ne=0;Ne<_;Ne++)ae[Ne]=arguments[Ne];var Ue=oe.renderer[Q].apply(Ie,ae);return Ue===!1&&(Ue=H.apply(Ie,ae)),Ue}};for(var q in oe.renderer)F(q);ne.renderer=Ie}(),oe.tokenizer&&function(){var Ie=me.defaults.tokenizer||new U,F=function(Q){var H=Ie[Q];Ie[Q]=function(){for(var _=arguments.length,ae=new Array(_),Ne=0;Ne<_;Ne++)ae[Ne]=arguments[Ne];var Ue=oe.tokenizer[Q].apply(Ie,ae);return Ue===!1&&(Ue=H.apply(Ie,ae)),Ue}};for(var q in oe.tokenizer)F(q);ne.tokenizer=Ie}(),oe.walkTokens){var he=me.defaults.walkTokens;ne.walkTokens=function(Ie){var F=[];return F.push(oe.walkTokens.call(this,Ie)),he&&(F=F.concat(he.call(this,Ie))),F}}re&&(ne.extensions=le),me.setOptions(ne)})},me.walkTokens=function(we,pe){for(var De=[],ne=function(){var he=re.value;switch(De=De.concat(pe.call(me,he)),he.type){case"table":{for(var Ie=T(he.header),F;!(F=Ie()).done;){var q=F.value;De=De.concat(me.walkTokens(q.tokens,pe))}for(var J=T(he.rows),Q;!(Q=J()).done;)for(var H=Q.value,_=T(H),ae;!(ae=_()).done;){var Ne=ae.value;De=De.concat(me.walkTokens(Ne.tokens,pe))}break}case"list":{De=De.concat(me.walkTokens(he.items,pe));break}default:me.defaults.extensions&&me.defaults.extensions.childTokens&&me.defaults.extensions.childTokens[he.type]?me.defaults.extensions.childTokens[he.type].forEach(function(Ue){De=De.concat(me.walkTokens(he[Ue],pe))}):he.tokens&&(De=De.concat(me.walkTokens(he.tokens,pe)))}},le=T(we),re;!(re=le()).done;)ne();return De},me.parseInline=function(we,pe){if(typeof we>"u"||we===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof we!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(we)+", string expected");pe=I({},me.defaults,pe||{}),d(pe);try{var De=Y.lexInline(we,pe);return pe.walkTokens&&me.walkTokens(De,pe.walkTokens),ge.parseInline(De,pe)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+$(ne.message+"",!0)+"</pre>";throw ne}},me.Parser=ge,me.parser=ge.parse,me.Renderer=Ee,me.TextRenderer=Se,me.Lexer=Y,me.lexer=Y.lex,me.Tokenizer=U,me.Slugger=Pe,me.parse=me;var ce=me.options,se=me.setOptions,$e=me.use,x=me.walkTokens,z=me.parseInline,V=me,ue=ge.parse,ye=Y.lex;be.Lexer=Y,be.Parser=ge,be.Renderer=Ee,be.Slugger=Pe,be.TextRenderer=Se,be.Tokenizer=U,be.getDefaults=A,be.lexer=ye,be.marked=me,be.options=ce,be.parse=V,be.parseInline=z,be.parser=ue,be.setOptions=se,be.use=$e,be.walkTokens=x,Object.defineProperty(be,"__esModule",{value:!0})}),define(Ae[117],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ol=e.rot=e.$Ml=void 0;function y(l,D,g){return Math.min(Math.max(l,D),g)}e.$Ml=y;function M(l,D){return(D+l%D)%D}e.rot=M;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Ol=C;class T{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Pl=T;class A{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const g=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ql=A}),function(){function be(C){const T=[];typeof C=="number"&&T.push("code/timeOrigin",C);function A(D){T.push(D,Date.now())}function l(){const D=[];for(let g=0;g<T.length;g+=2)D.push({name:T[g],startTime:T[g+1]});return D}return{mark:A,getMarks:l}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(C+A.startTime)});return T}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function y(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=y(M))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var M in y)(typeof exports=="object"?exports:be)[M]=y[M]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function y(M){if(e[M])return e[M].exports;var C=e[M]={i:M,l:!1,exports:{}};return be[M].call(C.exports,C,C.exports,y),C.l=!0,C.exports}return y.m=be,y.c=e,y.d=function(M,C,T){y.o(M,C)||Object.defineProperty(M,C,{enumerable:!0,get:T})},y.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},y.t=function(M,C){if(1&C&&(M=y(M)),8&C||4&C&&typeof M=="object"&&M&&M.__esModule)return M;var T=Object.create(null);if(y.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:M}),2&C&&typeof M!="string")for(var A in M)y.d(T,A,function(l){return M[l]}.bind(null,A));return T},y.n=function(M){var C=M&&M.__esModule?function(){return M.default}:function(){return M};return y.d(C,"a",C),C},y.o=function(M,C){return Object.prototype.hasOwnProperty.call(M,C)},y.p="",y(y.s=0)}([function(be,e,y){(function(M){var C;e=be.exports=$e,C=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,l=e.re=[],D=e.src=[],g=0,R=g++;D[R]="0|[1-9]\\d*";var k=g++;D[k]="[0-9]+";var a=g++;D[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=g++;D[p]="("+D[R]+")\\.("+D[R]+")\\.("+D[R]+")";var $=g++;D[$]="("+D[k]+")\\.("+D[k]+")\\.("+D[k]+")";var f=g++;D[f]="(?:"+D[R]+"|"+D[a]+")";var t=g++;D[t]="(?:"+D[k]+"|"+D[a]+")";var i=g++;D[i]="(?:-("+D[f]+"(?:\\."+D[f]+")*))";var c=g++;D[c]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var b=g++;D[b]="[0-9A-Za-z-]+";var E=g++;D[E]="(?:\\+("+D[b]+"(?:\\."+D[b]+")*))";var v=g++,n="v?"+D[p]+D[i]+"?"+D[E]+"?";D[v]="^"+n+"$";var r="[v=\\s]*"+D[$]+D[c]+"?"+D[E]+"?",s=g++;D[s]="^"+r+"$";var o=g++;D[o]="((?:<|>)?=?)";var w=g++;D[w]=D[k]+"|x|X|\\*";var h=g++;D[h]=D[R]+"|x|X|\\*";var I=g++;D[I]="[v=\\s]*("+D[h]+")(?:\\.("+D[h]+")(?:\\.("+D[h]+")(?:"+D[i]+")?"+D[E]+"?)?)?";var S=g++;D[S]="[v=\\s]*("+D[w]+")(?:\\.("+D[w]+")(?:\\.("+D[w]+")(?:"+D[c]+")?"+D[E]+"?)?)?";var u=g++;D[u]="^"+D[o]+"\\s*"+D[I]+"$";var m=g++;D[m]="^"+D[o]+"\\s*"+D[S]+"$";var d=g++;D[d]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=g++;D[P]="(?:~>?)";var W=g++;D[W]="(\\s*)"+D[P]+"\\s+",l[W]=new RegExp(D[W],"g");var K=g++;D[K]="^"+D[P]+D[I]+"$";var U=g++;D[U]="^"+D[P]+D[S]+"$";var B=g++;D[B]="(?:\\^)";var O=g++;D[O]="(\\s*)"+D[B]+"\\s+",l[O]=new RegExp(D[O],"g");var N=g++;D[N]="^"+D[B]+D[I]+"$";var te=g++;D[te]="^"+D[B]+D[S]+"$";var Y=g++;D[Y]="^"+D[o]+"\\s*("+r+")$|^$";var Ee=g++;D[Ee]="^"+D[o]+"\\s*("+n+")$|^$";var Se=g++;D[Se]="(\\s*)"+D[o]+"\\s*("+r+"|"+D[I]+")",l[Se]=new RegExp(D[Se],"g");var Pe=g++;D[Pe]="^\\s*("+D[I]+")\\s+-\\s+("+D[I]+")\\s*$";var ge=g++;D[ge]="^\\s*("+D[S]+")\\s+-\\s+("+D[S]+")\\s*$";var me=g++;D[me]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)C(ce,D[ce]),l[ce]||(l[ce]=new RegExp(D[ce]));function se(H,_){if(H instanceof $e)return H;if(typeof H!="string"||H.length>T||!(_?l[s]:l[v]).test(H))return null;try{return new $e(H,_)}catch{return null}}function $e(H,_){if(H instanceof $e){if(H.loose===_)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof $e))return new $e(H,_);C("SemVer",H,_),this.loose=_;var ae=H.trim().match(_?l[s]:l[v]);if(!ae)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Ue=+Ne;if(Ue>=0&&Ue<A)return Ue}return Ne}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=se,e.valid=function(H,_){var ae=se(H,_);return ae?ae.version:null},e.clean=function(H,_){var ae=se(H.trim().replace(/^[=v]+/,""),_);return ae?ae.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(H){return C("SemVer.compare",this.version,this.loose,H),H instanceof $e||(H=new $e(H,this.loose)),this.compareMain(H)||this.comparePre(H)},$e.prototype.compareMain=function(H){return H instanceof $e||(H=new $e(H,this.loose)),z(this.major,H.major)||z(this.minor,H.minor)||z(this.patch,H.patch)},$e.prototype.comparePre=function(H){if(H instanceof $e||(H=new $e(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var _=0;do{var ae=this.prerelease[_],Ne=H.prerelease[_];if(C("prerelease compare",_,ae,Ne),ae===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ae===void 0)return-1;if(ae!==Ne)return z(ae,Ne)}while(++_)},$e.prototype.inc=function(H,_){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",_);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",_);break;case"prepatch":this.prerelease.length=0,this.inc("patch",_),this.inc("pre",_);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",_),this.inc("pre",_);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}_&&(this.prerelease[0]===_?isNaN(this.prerelease[1])&&(this.prerelease=[_,0]):this.prerelease=[_,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,_,ae,Ne){typeof ae=="string"&&(Ne=ae,ae=void 0);try{return new $e(H,ae).inc(_,Ne).version}catch{return null}},e.diff=function(H,_){if(we(H,_))return null;var ae=se(H),Ne=se(_);if(ae.prerelease.length||Ne.prerelease.length){for(var Ue in ae)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ae[Ue]!==Ne[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ae)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ae[Ue]!==Ne[Ue])return Ue},e.compareIdentifiers=z;var x=/^[0-9]+$/;function z(H,_){var ae=x.test(H),Ne=x.test(_);return ae&&Ne&&(H=+H,_=+_),ae&&!Ne?-1:Ne&&!ae?1:H<_?-1:H>_?1:0}function V(H,_,ae){return new $e(H,ae).compare(new $e(_,ae))}function ue(H,_,ae){return V(H,_,ae)>0}function ye(H,_,ae){return V(H,_,ae)<0}function we(H,_,ae){return V(H,_,ae)===0}function pe(H,_,ae){return V(H,_,ae)!==0}function De(H,_,ae){return V(H,_,ae)>=0}function ne(H,_,ae){return V(H,_,ae)<=0}function le(H,_,ae,Ne){var Ue;switch(_){case"===":typeof H=="object"&&(H=H.version),typeof ae=="object"&&(ae=ae.version),Ue=H===ae;break;case"!==":typeof H=="object"&&(H=H.version),typeof ae=="object"&&(ae=ae.version),Ue=H!==ae;break;case"":case"=":case"==":Ue=we(H,ae,Ne);break;case"!=":Ue=pe(H,ae,Ne);break;case">":Ue=ue(H,ae,Ne);break;case">=":Ue=De(H,ae,Ne);break;case"<":Ue=ye(H,ae,Ne);break;case"<=":Ue=ne(H,ae,Ne);break;default:throw new TypeError("Invalid operator: "+_)}return Ue}function re(H,_){if(H instanceof re){if(H.loose===_)return H;H=H.value}if(!(this instanceof re))return new re(H,_);C("comparator",H,_),this.loose=_,this.parse(H),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(H,_){return z(_,H)},e.major=function(H,_){return new $e(H,_).major},e.minor=function(H,_){return new $e(H,_).minor},e.patch=function(H,_){return new $e(H,_).patch},e.compare=V,e.compareLoose=function(H,_){return V(H,_,!0)},e.rcompare=function(H,_,ae){return V(_,H,ae)},e.sort=function(H,_){return H.sort(function(ae,Ne){return e.compare(ae,Ne,_)})},e.rsort=function(H,_){return H.sort(function(ae,Ne){return e.rcompare(ae,Ne,_)})},e.gt=ue,e.lt=ye,e.eq=we,e.neq=pe,e.gte=De,e.lte=ne,e.cmp=le,e.Comparator=re;var oe={};function he(H,_){if(H instanceof he)return H.loose===_?H:new he(H.raw,_);if(H instanceof re)return new he(H.value,_);if(!(this instanceof he))return new he(H,_);if(this.loose=_,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function Ie(H){return!H||H.toLowerCase()==="x"||H==="*"}function F(H,_,ae,Ne,Ue,Qe,Ge,_e,Ze,xe,it,tt,ze){return((_=Ie(ae)?"":Ie(Ne)?">="+ae+".0.0":Ie(Ue)?">="+ae+"."+Ne+".0":">="+_)+" "+(_e=Ie(Ze)?"":Ie(xe)?"<"+(+Ze+1)+".0.0":Ie(it)?"<"+Ze+"."+(+xe+1)+".0":tt?"<="+Ze+"."+xe+"."+it+"-"+tt:"<="+_e)).trim()}function q(H,_){for(var ae=0;ae<H.length;ae++)if(!H[ae].test(_))return!1;if(_.prerelease.length){for(ae=0;ae<H.length;ae++)if(C(H[ae].semver),H[ae].semver!==oe&&H[ae].semver.prerelease.length>0){var Ne=H[ae].semver;if(Ne.major===_.major&&Ne.minor===_.minor&&Ne.patch===_.patch)return!0}return!1}return!0}function J(H,_,ae){try{_=new he(_,ae)}catch{return!1}return _.test(H)}function Q(H,_,ae,Ne){var Ue,Qe,Ge,_e,Ze;switch(H=new $e(H,Ne),_=new he(_,Ne),ae){case">":Ue=ue,Qe=ne,Ge=ye,_e=">",Ze=">=";break;case"<":Ue=ye,Qe=De,Ge=ue,_e="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(J(H,_,Ne))return!1;for(var xe=0;xe<_.set.length;++xe){var it=_.set[xe],tt=null,ze=null;if(it.forEach(function(st){st.semver===oe&&(st=new re(">=0.0.0")),tt=tt||st,ze=ze||st,Ue(st.semver,tt.semver,Ne)?tt=st:Ge(st.semver,ze.semver,Ne)&&(ze=st)}),tt.operator===_e||tt.operator===Ze||(!ze.operator||ze.operator===_e)&&Qe(H,ze.semver)||ze.operator===Ze&&Ge(H,ze.semver))return!1}return!0}re.prototype.parse=function(H){var _=this.loose?l[Y]:l[Ee],ae=H.match(_);if(!ae)throw new TypeError("Invalid comparator: "+H);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new $e(ae[2],this.loose):this.semver=oe},re.prototype.toString=function(){return this.value},re.prototype.test=function(H){return C("Comparator.test",H,this.loose),this.semver===oe||(typeof H=="string"&&(H=new $e(H,this.loose)),le(H,this.operator,this.semver,this.loose))},re.prototype.intersects=function(H,_){if(!(H instanceof re))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new he(H.value,_),J(this.value,ae,_);if(H.operator==="")return ae=new he(this.value,_),J(H.semver,ae,_);var Ne=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Qe=this.semver.version===H.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),_e=le(this.semver,"<",H.semver,_)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),Ze=le(this.semver,">",H.semver,_)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return Ne||Ue||Qe&&Ge||_e||Ze},e.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(H){var _=this.loose;H=H.trim(),C("range",H,_);var ae=_?l[ge]:l[Pe];H=H.replace(ae,F),C("hyphen replace",H),H=H.replace(l[Se],"$1$2$3"),C("comparator trim",H,l[Se]),H=(H=(H=H.replace(l[W],"$1~")).replace(l[O],"$1^")).split(/\s+/).join(" ");var Ne=_?l[Y]:l[Ee],Ue=H.split(" ").map(function(Qe){return function(Ge,_e){return C("comp",Ge),Ge=function(Ze,xe){return Ze.trim().split(/\s+/).map(function(it){return function(tt,ze){C("caret",tt,ze);var st=ze?l[te]:l[N];return tt.replace(st,function(Z,X,ve,Be,Oe){var Xe;return C("caret",tt,Z,X,ve,Be,Oe),Ie(X)?Xe="":Ie(ve)?Xe=">="+X+".0.0 <"+(+X+1)+".0.0":Ie(Be)?Xe=X==="0"?">="+X+"."+ve+".0 <"+X+"."+(+ve+1)+".0":">="+X+"."+ve+".0 <"+(+X+1)+".0.0":Oe?(C("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Xe=X==="0"?ve==="0"?">="+X+"."+ve+"."+Be+Oe+" <"+X+"."+ve+"."+(+Be+1):">="+X+"."+ve+"."+Be+Oe+" <"+X+"."+(+ve+1)+".0":">="+X+"."+ve+"."+Be+Oe+" <"+(+X+1)+".0.0"):(C("no pr"),Xe=X==="0"?ve==="0"?">="+X+"."+ve+"."+Be+" <"+X+"."+ve+"."+(+Be+1):">="+X+"."+ve+"."+Be+" <"+X+"."+(+ve+1)+".0":">="+X+"."+ve+"."+Be+" <"+(+X+1)+".0.0"),C("caret return",Xe),Xe})}(it,xe)}).join(" ")}(Ge,_e),C("caret",Ge),Ge=function(Ze,xe){return Ze.trim().split(/\s+/).map(function(it){return function(tt,ze){var st=ze?l[U]:l[K];return tt.replace(st,function(Z,X,ve,Be,Oe){var Xe;return C("tilde",tt,Z,X,ve,Be,Oe),Ie(X)?Xe="":Ie(ve)?Xe=">="+X+".0.0 <"+(+X+1)+".0.0":Ie(Be)?Xe=">="+X+"."+ve+".0 <"+X+"."+(+ve+1)+".0":Oe?(C("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Xe=">="+X+"."+ve+"."+Be+Oe+" <"+X+"."+(+ve+1)+".0"):Xe=">="+X+"."+ve+"."+Be+" <"+X+"."+(+ve+1)+".0",C("tilde return",Xe),Xe})}(it,xe)}).join(" ")}(Ge,_e),C("tildes",Ge),Ge=function(Ze,xe){return C("replaceXRanges",Ze,xe),Ze.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var st=ze?l[m]:l[u];return tt.replace(st,function(Z,X,ve,Be,Oe,Xe){C("xRange",tt,Z,X,ve,Be,Oe,Xe);var nt=Ie(ve),ft=nt||Ie(Be),wt=ft||Ie(Oe);return X==="="&&wt&&(X=""),nt?Z=X===">"||X==="<"?"<0.0.0":"*":X&&wt?(ft&&(Be=0),wt&&(Oe=0),X===">"?(X=">=",ft?(ve=+ve+1,Be=0,Oe=0):wt&&(Be=+Be+1,Oe=0)):X==="<="&&(X="<",ft?ve=+ve+1:Be=+Be+1),Z=X+ve+"."+Be+"."+Oe):ft?Z=">="+ve+".0.0 <"+(+ve+1)+".0.0":wt&&(Z=">="+ve+"."+Be+".0 <"+ve+"."+(+Be+1)+".0"),C("xRange return",Z),Z})}(it,xe)}).join(" ")}(Ge,_e),C("xrange",Ge),Ge=function(Ze,xe){return C("replaceStars",Ze,xe),Ze.trim().replace(l[me],"")}(Ge,_e),C("stars",Ge),Ge}(Qe,_)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Qe){return!!Qe.match(Ne)})),Ue=Ue.map(function(Qe){return new re(Qe,_)})},he.prototype.intersects=function(H,_){if(!(H instanceof he))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(Ne){return H.set.some(function(Ue){return Ue.every(function(Qe){return Ne.intersects(Qe,_)})})})})},e.toComparators=function(H,_){return new he(H,_).set.map(function(ae){return ae.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},he.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new $e(H,this.loose));for(var _=0;_<this.set.length;_++)if(q(this.set[_],H))return!0;return!1},e.satisfies=J,e.maxSatisfying=function(H,_,ae){var Ne=null,Ue=null;try{var Qe=new he(_,ae)}catch{return null}return H.forEach(function(Ge){Qe.test(Ge)&&(Ne&&Ue.compare(Ge)!==-1||(Ue=new $e(Ne=Ge,ae)))}),Ne},e.minSatisfying=function(H,_,ae){var Ne=null,Ue=null;try{var Qe=new he(_,ae)}catch{return null}return H.forEach(function(Ge){Qe.test(Ge)&&(Ne&&Ue.compare(Ge)!==1||(Ue=new $e(Ne=Ge,ae)))}),Ne},e.validRange=function(H,_){try{return new he(H,_).range||"*"}catch{return null}},e.ltr=function(H,_,ae){return Q(H,_,"<",ae)},e.gtr=function(H,_,ae){return Q(H,_,">",ae)},e.outside=Q,e.prerelease=function(H,_){var ae=se(H,_);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(H,_,ae){return H=new he(H,ae),_=new he(_,ae),H.intersects(_)},e.coerce=function(H){if(H instanceof $e)return H;if(typeof H!="string")return null;var _=H.match(l[d]);return _==null?null:se((_[1]||"0")+"."+(_[2]||"0")+"."+(_[3]||"0"))}}).call(this,y(1))},function(be,e){var y,M,C=be.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function l(t){if(y===setTimeout)return setTimeout(t,0);if((y===T||!y)&&setTimeout)return y=setTimeout,setTimeout(t,0);try{return y(t,0)}catch{try{return y.call(null,t,0)}catch{return y.call(this,t,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:T}catch{y=T}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch{M=A}})();var D,g=[],R=!1,k=-1;function a(){R&&D&&(R=!1,D.length?g=D.concat(g):k=-1,g.length&&p())}function p(){if(!R){var t=l(a);R=!0;for(var i=g.length;i;){for(D=g,g=[];++k<i;)D&&D[k].run();k=-1,i=g.length}D=null,R=!1,function(c){if(M===clearTimeout)return clearTimeout(c);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(c);try{M(c)}catch{try{return M.call(null,c)}catch{return M.call(this,c)}}}(t)}}function $(t,i){this.fun=t,this.array=i}function f(){}C.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)i[c-1]=arguments[c];g.push(new $(t,i)),g.length!==1||R||l(p)},$.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=f,C.addListener=f,C.once=f,C.off=f,C.removeListener=f,C.removeAllListeners=f,C.emit=f,C.prependListener=f,C.prependOnceListener=f,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ae[118],Re([1,0,9,6]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function C(E){const v=E;return v?typeof v.read=="function":!1}e.$Yd=C;function T(E){const v=E;return v?[v.on,v.pause,v.resume,v.destroy].every(n=>typeof n=="function"):!1}e.$Zd=T;function A(E){const v=E;return v?T(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.$1d=A;function l(E,v){return new D(E,v)}e.$2d=l;class D{constructor(v,n){this.e=v,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(n=>n(v))}h(v){this.c.error.length===0?(0,y.$1)(v):this.c.error.slice(0).forEach(n=>n(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,n){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(v,n){if(this.a.destroyed)return;let r;switch(v){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const s=r.indexOf(n);s>=0&&r.splice(s,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(E,v){const n=[];let r;for(;(r=E.read())!==null;)n.push(r);return v(n)}e.$3d=g;function R(E,v,n){const r=[];let s;for(;(s=E.read())!==null&&r.length<n;)r.push(s);return s===null&&r.length>0?v(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s<"u"){const o=s;return s=void 0,o}return E.read()}}}e.$4d=R;function k(E,v){return new Promise((n,r)=>{const s=[];a(E,{onData:o=>{v&&s.push(o)},onError:o=>{v?r(o):n(void 0)},onEnd:()=>{n(v?v(s):void 0)}})})}e.$5d=k;function a(E,v,n){E.on("error",r=>{n?.isCancellationRequested||v.onError(r)}),E.on("end",()=>{n?.isCancellationRequested||v.onEnd()}),E.on("data",r=>{n?.isCancellationRequested||v.onData(r)})}e.$6d=a;function p(E,v){return new Promise((n,r)=>{const s=new M.$Rc,o=[],w=S=>{if(o.push(S),o.length>v)return s.dispose(),E.pause(),n({stream:E,buffer:o,ended:!1})},h=S=>(s.dispose(),r(S)),I=()=>(s.dispose(),n({stream:E,buffer:o,ended:!0}));s.add((0,M.$Qc)(()=>E.removeListener("error",h))),E.on("error",h),s.add((0,M.$Qc)(()=>E.removeListener("end",I))),E.on("end",I),s.add((0,M.$Qc)(()=>E.removeListener("data",w))),E.on("data",w)})}e.$7d=p;function $(E,v){const n=l(v);return n.end(E),n}e.$8d=$;function f(){const E=l(()=>{throw new Error("not supported")});return E.end(),E}e.$9d=f;function t(E){let v=!1;return{read:()=>v?null:(v=!0,E)}}e.$0d=t;function i(E,v,n){const r=l(n);return a(E,{onData:s=>r.write(v.data(s)),onError:s=>r.error(v.error?v.error(s):s),onEnd:()=>r.end()}),r}e.$$d=i;function c(E,v,n){let r=!1;return{read:()=>{const s=v.read();return r?s:(r=!0,s!==null?n([E,s]):E)}}}e.$_d=c;function b(E,v,n){let r=!1;const s=l(n);return a(v,{onData:o=>r?s.write(o):(r=!0,s.write(n([E,o]))),onError:o=>s.error(o),onEnd:()=>{r||(r=!0,s.write(E)),s.end()}}),s}e.$ae=b}),define(Ae[26],Re([1,0,41,118]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const C=typeof Buffer<"u",T=new y.$V(()=>new Uint8Array(256));let A,l;class D{static alloc(d){return C?new D(Buffer.allocUnsafe(d)):new D(new Uint8Array(d))}static wrap(d){return C&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new D(d)}static fromString(d,P){return!(P?.dontUseNodeBuffer||!1)&&C?new D(Buffer.from(d)):(A||(A=new TextEncoder),new D(A.encode(d)))}static fromByteArray(d){const P=D.alloc(d.length);for(let W=0,K=d.length;W<K;W++)P.buffer[W]=d[W];return P}static concat(d,P){if(typeof P>"u"){P=0;for(let U=0,B=d.length;U<B;U++)P+=d[U].byteLength}const W=D.alloc(P);let K=0;for(let U=0,B=d.length;U<B;U++){const O=d[U];W.set(O,K),K+=O.byteLength}return W}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=D.alloc(this.byteLength);return d.set(this),d}toString(){return C?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(d,P){return new D(this.buffer.subarray(d,P))}set(d,P){if(d instanceof D)this.buffer.set(d.buffer,P);else if(d instanceof Uint8Array)this.buffer.set(d,P);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),P);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return a(this.buffer,d)}writeUInt32BE(d,P){p(this.buffer,d,P)}readUInt32LE(d){return $(this.buffer,d)}writeUInt32LE(d,P){f(this.buffer,d,P)}readUInt8(d){return t(this.buffer,d)}writeUInt8(d,P){i(this.buffer,d,P)}indexOf(d,P=0){return g(this.buffer,d instanceof D?d.buffer:d,P)}}e.$be=D;function g(m,d,P=0){const W=d.byteLength,K=m.byteLength;if(W===0)return 0;if(W===1)return m.indexOf(d[0]);if(W>K-P)return-1;const U=T.value;U.fill(d.length);for(let te=0;te<d.length;te++)U[d[te]]=d.length-te-1;let B=P+d.length-1,O=B,N=-1;for(;B<K;)if(m[B]===d[O]){if(O===0){N=B;break}B--,O--}else B+=Math.max(d.length-O,U[m[B]]),O=d.length-1;return N}e.$ce=g;function R(m,d){return m[d+0]<<0>>>0|m[d+1]<<8>>>0}e.$de=R;function k(m,d,P){m[P+0]=d&255,d=d>>>8,m[P+1]=d&255}e.$ee=k;function a(m,d){return m[d]*2**24+m[d+1]*2**16+m[d+2]*2**8+m[d+3]}e.$fe=a;function p(m,d,P){m[P+3]=d,d=d>>>8,m[P+2]=d,d=d>>>8,m[P+1]=d,d=d>>>8,m[P]=d}e.$ge=p;function $(m,d){return m[d+0]<<0>>>0|m[d+1]<<8>>>0|m[d+2]<<16>>>0|m[d+3]<<24>>>0}e.$he=$;function f(m,d,P){m[P+0]=d&255,d=d>>>8,m[P+1]=d&255,d=d>>>8,m[P+2]=d&255,d=d>>>8,m[P+3]=d&255}e.$ie=f;function t(m,d){return m[d]}e.$je=t;function i(m,d,P){m[P]=d}e.$ke=i;function c(m){return M.$3d(m,d=>D.concat(d))}e.$le=c;function b(m){return M.$0d(m)}e.$me=b;function E(m){return M.$5d(m,d=>D.concat(d))}e.$ne=E;async function v(m){return m.ended?D.concat(m.buffer):D.concat([...m.buffer,await E(m.stream)])}e.$oe=v;function n(m){return M.$8d(m,d=>D.concat(d))}e.$pe=n;function r(m){return M.$$d(m,{data:d=>typeof d=="string"?D.fromString(d):D.wrap(d)},d=>D.concat(d))}e.$qe=r;function s(m){return M.$2d(d=>D.concat(d),m)}e.$re=s;function o(m,d){return M.$_d(m,d,P=>D.concat(P))}e.$se=o;function w(m,d){return M.$ae(m,d,P=>D.concat(P))}e.$te=w;function h(m){let d=0,P=0,W=0;const K=new Uint8Array(Math.floor(m.length/4*3)),U=O=>{switch(P){case 3:K[W++]=d|O,P=0;break;case 2:K[W++]=d|O>>>2,d=O<<6,P=3;break;case 1:K[W++]=d|O>>>4,d=O<<4,P=2;break;default:d=O<<2,P=1}};for(let O=0;O<m.length;O++){const N=m.charCodeAt(O);if(N>=65&&N<=90)U(N-65);else if(N>=97&&N<=122)U(N-97+26);else if(N>=48&&N<=57)U(N-48+52);else if(N===43||N===45)U(62);else if(N===47||N===95)U(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${m[O]}`)}}const B=W;for(;P>0;)U(0);return D.wrap(K).slice(0,B)}e.$ue=h;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:m},d=!0,P=!1){const W=P?S:I;let K="";const U=m.byteLength%3;let B=0;for(;B<m.byteLength-U;B+=3){const O=m[B+0],N=m[B+1],te=m[B+2];K+=W[O>>>2],K+=W[(O<<4|N>>>4)&63],K+=W[(N<<2|te>>>6)&63],K+=W[te&63]}if(U===1){const O=m[B+0];K+=W[O>>>2],K+=W[O<<4&63],d&&(K+="==")}else if(U===2){const O=m[B+0],N=m[B+1];K+=W[O>>>2],K+=W[(O<<4|N>>>4)&63],K+=W[N<<2&63],d&&(K+="=")}return K}e.$ve=u}),define(Ae[119],Re([1,0,28,16]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.FuzzyScore=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.or=void 0;function C(...re){return function(oe,he){for(let Ie=0,F=re.length;Ie<F;Ie++){const q=re[Ie](oe,he);if(q)return q}return null}}e.or=C,e.$Bj=T.bind(void 0,!1),e.$Cj=T.bind(void 0,!0);function T(re,oe,he){if(!he||he.length<oe.length)return null;let Ie;return re?Ie=M.$3e(he,oe):Ie=he.indexOf(oe)===0,Ie?oe.length>0?[{start:0,end:oe.length}]:[]:null}function A(re,oe){const he=oe.toLowerCase().indexOf(re.toLowerCase());return he===-1?null:[{start:he,end:he+re.length}]}e.$Dj=A;function l(re,oe){return D(re.toLowerCase(),oe.toLowerCase(),0,0)}e.$Ej=l;function D(re,oe,he,Ie){if(he===re.length)return[];if(Ie===oe.length)return null;if(re[he]===oe[Ie]){let F=null;return(F=D(re,oe,he+1,Ie+1))?i({start:Ie,end:Ie+1},F):null}return D(re,oe,he,Ie+1)}function g(re){return 97<=re&&re<=122}function R(re){return 65<=re&&re<=90}e.$Fj=R;function k(re){return 48<=re&&re<=57}function a(re){return re===32||re===9||re===10||re===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(re=>p.add(re.charCodeAt(0)));function $(re){return a(re)||p.has(re)}function f(re,oe){return re===oe||$(re)&&$(oe)}function t(re){return g(re)||R(re)||k(re)}function i(re,oe){return oe.length===0?oe=[re]:re.end===oe[0].start?oe[0].start=re.start:oe.unshift(re),oe}function c(re,oe){for(let he=oe;he<re.length;he++){const Ie=re.charCodeAt(he);if(R(Ie)||k(Ie)||he>0&&!t(re.charCodeAt(he-1)))return he}return re.length}function b(re,oe,he,Ie){if(he===re.length)return[];if(Ie===oe.length)return null;if(re[he]!==oe[Ie].toLowerCase())return null;{let F=null,q=Ie+1;for(F=b(re,oe,he+1,Ie+1);!F&&(q=c(oe,q))<oe.length;)F=b(re,oe,he+1,q),q++;return F===null?null:i({start:Ie,end:Ie+1},F)}}function E(re){let oe=0,he=0,Ie=0,F=0,q=0;for(let ae=0;ae<re.length;ae++)q=re.charCodeAt(ae),R(q)&&oe++,g(q)&&he++,t(q)&&Ie++,k(q)&&F++;const J=oe/re.length,Q=he/re.length,H=Ie/re.length,_=F/re.length;return{upperPercent:J,lowerPercent:Q,alphaPercent:H,numericPercent:_}}function v(re){const{upperPercent:oe,lowerPercent:he}=re;return he===0&&oe>.6}function n(re){const{upperPercent:oe,lowerPercent:he,alphaPercent:Ie,numericPercent:F}=re;return he>.2&&oe<.8&&Ie>.6&&F<.2}function r(re){let oe=0,he=0,Ie=0,F=0;for(let q=0;q<re.length;q++)Ie=re.charCodeAt(q),R(Ie)&&oe++,g(Ie)&&he++,a(Ie)&&F++;return(oe===0||he===0)&&F===0?re.length<=30:oe<=5}function s(re,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!r(re)||oe.length>60)return null;const he=E(oe);if(!n(he)){if(!v(he))return null;oe=oe.toLowerCase()}let Ie=null,F=0;for(re=re.toLowerCase();F<oe.length&&(Ie=b(re,oe,0,F))===null;)F=c(oe,F+1);return Ie}e.$Gj=s;function o(re,oe,he=!1){if(!oe||oe.length===0)return null;let Ie=null,F=0;for(re=re.toLowerCase(),oe=oe.toLowerCase();F<oe.length&&(Ie=w(re,oe,0,F,he))===null;)F=h(oe,F+1);return Ie}e.$Hj=o;function w(re,oe,he,Ie,F){if(he===re.length)return[];if(Ie===oe.length)return null;if(f(re.charCodeAt(he),oe.charCodeAt(Ie))){let q=null,J=Ie+1;if(q=w(re,oe,he+1,Ie+1,F),!F)for(;!q&&(J=h(oe,J))<oe.length;)q=w(re,oe,he+1,J,F),J++;return q?re.charCodeAt(he)!==oe.charCodeAt(Ie)?q:i({start:Ie,end:Ie+1},q):null}else return null}function h(re,oe){for(let he=oe;he<re.length;he++)if($(re.charCodeAt(he))||he>0&&$(re.charCodeAt(he-1)))return he;return re.length}const I=C(e.$Cj,s,A),S=C(e.$Cj,s,l),u=new y.$Dc(1e4);function m(re,oe,he=!1){if(typeof re!="string"||typeof oe!="string")return null;let Ie=u.get(re);Ie||(Ie=new RegExp(M.$Le(re),"i"),u.set(re,Ie));const F=Ie.exec(oe);return F?[{start:F.index,end:F.index+F[0].length}]:he?S(re,oe):I(re,oe)}e.$Ij=m;function d(re,oe){const he=ue(re,re.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return he?W(he):null}e.$Jj=d;function P(re,oe,he,Ie,F,q){const J=Math.min(13,re.length);for(;he<J;he++){const Q=ue(re,oe,he,Ie,F,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,q]}e.$Kj=P;function W(re){if(typeof re>"u")return[];const oe=[],he=re[1];for(let Ie=re.length-1;Ie>1;Ie--){const F=re[Ie]+he,q=oe[oe.length-1];q&&q.end===F?q.end=F+1:oe.push({start:F,end:F+1})}return oe}e.$Lj=W;const K=128;function U(){const re=[],oe=[];for(let he=0;he<=K;he++)oe[he]=0;for(let he=0;he<=K;he++)re.push(oe.slice(0));return re}function B(re){const oe=[];for(let he=0;he<=re;he++)oe[he]=0;return oe}const O=B(2*K),N=B(2*K),te=U(),Y=U(),Ee=U(),Se=!1;function Pe(re,oe,he,Ie,F){function q(Q,H,_=" "){for(;Q.length<H;)Q=_+Q;return Q}let J=` |   |${Ie.split("").map(Q=>q(Q,3)).join("|")}
`;for(let Q=0;Q<=he;Q++)Q===0?J+=" |":J+=`${oe[Q-1]}|`,J+=re[Q].slice(0,F+1).map(H=>q(H.toString(),3)).join("|")+`
`;return J}function ge(re,oe,he,Ie){re=re.substr(oe),he=he.substr(Ie),console.log(Pe(Y,re,re.length,he,he.length)),console.log(Pe(Ee,re,re.length,he,he.length)),console.log(Pe(te,re,re.length,he,he.length))}function me(re,oe){if(oe<0||oe>=re.length)return!1;const he=re.codePointAt(oe);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$if(he)}}function ce(re,oe){if(oe<0||oe>=re.length)return!1;switch(re.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function se(re,oe,he){return oe[re]!==he[re]}function $e(re,oe,he,Ie,F,q,J=!1){for(;oe<he&&F<q;)re[oe]===Ie[F]&&(J&&(O[oe]=F),oe+=1),F+=1;return oe===he}e.$Mj=$e;var x;(function(re){re[re.Diag=1]="Diag",re[re.Left=2]="Left",re[re.LeftLeft=3]="LeftLeft"})(x||(x={}));var z;(function(re){re.Default=[-100,0];function oe(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}re.isDefault=oe})(z||(e.FuzzyScore=z={}));class V{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,he){this.firstMatchCanBeWeak=oe,this.boostFullMatch=he}}e.$Nj=V;function ue(re,oe,he,Ie,F,q,J=V.default){const Q=re.length>K?K:re.length,H=Ie.length>K?K:Ie.length;if(he>=Q||q>=H||Q-he>H-q||!$e(oe,he,Q,F,q,H,!0))return;ye(Q,H,he,q,oe,F);let _=1,ae=1,Ne=he,Ue=q;const Qe=[!1];for(_=1,Ne=he;Ne<Q;_++,Ne++){const it=O[Ne],tt=N[Ne],ze=Ne+1<Q?N[Ne+1]:H;for(ae=it-q+1,Ue=it;Ue<ze;ae++,Ue++){let st=Number.MIN_SAFE_INTEGER,Z=!1;Ue<=tt&&(st=we(re,oe,Ne,he,Ie,F,Ue,H,q,te[_-1][ae-1]===0,Qe));let X=0;st!==Number.MAX_SAFE_INTEGER&&(Z=!0,X=st+Y[_-1][ae-1]);const ve=Ue>it,Be=ve?Y[_][ae-1]+(te[_][ae-1]>0?-5:0):0,Oe=Ue>it+1&&te[_][ae-1]>0,Xe=Oe?Y[_][ae-2]+(te[_][ae-2]>0?-5:0):0;if(Oe&&(!ve||Xe>=Be)&&(!Z||Xe>=X))Y[_][ae]=Xe,Ee[_][ae]=3,te[_][ae]=0;else if(ve&&(!Z||Be>=X))Y[_][ae]=Be,Ee[_][ae]=2,te[_][ae]=0;else if(Z)Y[_][ae]=X,Ee[_][ae]=1,te[_][ae]=te[_-1][ae-1]+1;else throw new Error("not possible")}}if(Se&&ge(re,he,Ie,q),!Qe[0]&&!J.firstMatchCanBeWeak)return;_--,ae--;const Ge=[Y[_][ae],q];let _e=0,Ze=0;for(;_>=1;){let it=ae;do{const tt=Ee[_][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);_e>1&&oe[he+_-1]===F[q+ae-1]&&!se(it+q-1,Ie,F)&&_e+1>te[_][it]&&(it=ae),it===ae?_e++:_e=1,Ze||(Ze=it),_--,ae=it-1,Ge.push(ae)}H===Q&&J.boostFullMatch&&(Ge[0]+=2);const xe=Ze-Q;return Ge[0]-=xe,Ge}e.$Oj=ue;function ye(re,oe,he,Ie,F,q){let J=re-1,Q=oe-1;for(;J>=he&&Q>=Ie;)F[J]===q[Q]&&(N[J]=Q,J--),Q--}function we(re,oe,he,Ie,F,q,J,Q,H,_,ae){if(oe[he]!==q[J])return Number.MIN_SAFE_INTEGER;let Ne=1,Ue=!1;return J===he-Ie?Ne=re[he]===F[J]?7:5:se(J,F,q)&&(J===0||!se(J-1,F,q))?(Ne=re[he]===F[J]?7:5,Ue=!0):me(q,J)&&(J===0||!me(q,J-1))?Ne=5:(me(q,J-1)||ce(q,J-1))&&(Ne=5,Ue=!0),Ne>1&&he===Ie&&(ae[0]=!0),Ue||(Ue=se(J,F,q)||me(q,J-1)||ce(q,J-1)),he===Ie?J>H&&(Ne-=Ue?3:5):_?Ne+=Ue?2:0:Ne+=Ue?0:1,J+1===Q&&(Ne-=Ue?3:5),Ne}function pe(re,oe,he,Ie,F,q,J){return ne(re,oe,he,Ie,F,q,!0,J)}e.$Pj=pe;function De(re,oe,he,Ie,F,q,J){return ne(re,oe,he,Ie,F,q,!1,J)}e.$Qj=De;function ne(re,oe,he,Ie,F,q,J,Q){let H=ue(re,oe,he,Ie,F,q,Q);if(H&&!J)return H;if(re.length>=3){const _=Math.min(7,re.length-1);for(let ae=he+1;ae<_;ae++){const Ne=le(re,ae);if(Ne){const Ue=ue(Ne,Ne.toLowerCase(),he,Ie,F,q,Q);Ue&&(Ue[0]-=3,(!H||Ue[0]>H[0])&&(H=Ue))}}}return H}function le(re,oe){if(oe+1>=re.length)return;const he=re[oe],Ie=re[oe+1];if(he!==Ie)return re.slice(0,oe)+Ie+he+re.slice(oe+2)}}),define(Ae[29],Re([1,0,16]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(M||(M={})),function(C){const T="error",A="warning",l="warn",D="info",g="ignore";function R(a){return a?y.$2e(T,a)?C.Error:y.$2e(A,a)||y.$2e(l,a)?C.Warning:y.$2e(D,a)?C.Info:C.Ignore:C.Ignore}C.fromValue=R;function k(a){switch(a){case C.Error:return T;case C.Warning:return A;case C.Info:return D;default:return g}}C.toString=k}(M||(M={})),e.default=M}),define(Ae[120],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(Ae[49],Re([1,0,18,16]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=void 0;class C{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const $=p.charCodeAt(0),f=this.b.charCodeAt(this.c);return $-f}value(){return this.b[this.c]}}e.$Qh=C;class T{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,M.$Ve)(p,this.b,0,p.length,this.c,this.d):(0,M.$Xe)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Rh=T;class A{constructor(p=!0,$=!0){this.f=p,this.g=$}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let $=p.length-1;$>=0;$--,this.c--){const f=this.b.charCodeAt($);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,M.$Ve)(p,this.b,0,p.length,this.d,this.e):(0,M.$Xe)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Sh=A;var l;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(l||(l={}));class D{constructor(p,$){this.f=p,this.g=$,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,M.$We)(p,this.c.scheme);if(this.d[this.e]===2)return(0,M.$We)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,M.$Ue)(p,this.c.query);if(this.d[this.e]===5)return(0,M.$Ue)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Th=D;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(R||(R={}));class k{static forUris(p=()=>!1,$=()=>!1){return new k(new D(p,$))}static forPaths(p=!1){return new k(new A(void 0,!p))}static forStrings(){return new k(new C)}static forConfigKeys(){return new k(new T)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,$){if($){const f=$.slice(0);(0,y.$Xb)(f);for(const t of f)this.set(t,p)}else{const f=p.slice(0);(0,y.$Xb)(f);for(const t of f)this.set(t[0],t[1])}}set(p,$){const f=this.b.reset(p);let t;this.c||(this.c=new g,this.c.segment=f.value());const i=[];for(t=this.c;;){const b=f.cmp(t.segment);if(b>0)t.left||(t.left=new g,t.left.segment=f.value()),i.push([-1,t]),t=t.left;else if(b<0)t.right||(t.right=new g,t.right.segment=f.value()),i.push([1,t]),t=t.right;else if(f.hasNext())f.next(),t.mid||(t.mid=new g,t.mid.segment=f.value()),i.push([0,t]),t=t.mid;else break}const c=t.value;t.value=$,t.key=p;for(let b=i.length-1;b>=0;b--){const E=i[b][1];E.updateHeight();const v=E.balanceFactor();if(v<-1||v>1){const n=i[b][0],r=i[b+1][0];if(n===1&&r===1)i[b][1]=E.rotateLeft();else if(n===-1&&r===-1)i[b][1]=E.rotateRight();else if(n===1&&r===-1)E.right=i[b+1][1]=i[b+1][1].rotateRight(),i[b][1]=E.rotateLeft();else if(n===-1&&r===1)E.left=i[b+1][1]=i[b+1][1].rotateLeft(),i[b][1]=E.rotateRight();else throw new Error;if(b>0)switch(i[b-1][0]){case-1:i[b-1][1].left=i[b][1];break;case 1:i[b-1][1].right=i[b][1];break;case 0:i[b-1][1].mid=i[b][1];break}else this.c=i[0][1]}}return c}get(p){return this.d(p)?.value}d(p){const $=this.b.reset(p);let f=this.c;for(;f;){const t=$.cmp(f.segment);if(t>0)f=f.left;else if(t<0)f=f.right;else if($.hasNext())$.next(),f=f.mid;else break}return f}has(p){const $=this.d(p);return!($?.value===void 0&&$?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,$){const f=this.b.reset(p),t=[];let i=this.c;for(;i;){const c=f.cmp(i.segment);if(c>0)t.push([-1,i]),i=i.left;else if(c<0)t.push([1,i]),i=i.right;else if(f.hasNext())f.next(),t.push([0,i]),i=i.mid;else break}if(i){if($?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const c=this.f(i.right);if(c.key){const{key:b,value:E,segment:v}=c;this.e(c.key,!1),i.key=b,i.value=E,i.segment=v}}else{const c=i.left??i.right;if(t.length>0){const[b,E]=t[t.length-1];switch(b){case-1:E.left=c;break;case 0:E.mid=c;break;case 1:E.right=c;break}}else this.c=c}for(let c=t.length-1;c>=0;c--){const b=t[c][1];b.updateHeight();const E=b.balanceFactor();if(E>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),t[c][1]=b.rotateLeft()):E<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),t[c][1]=b.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this.c=t[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const $=this.b.reset(p);let f=this.c,t;for(;f;){const i=$.cmp(f.segment);if(i>0)f=f.left;else if(i<0)f=f.right;else if($.hasNext())$.next(),t=f.value||t,f=f.mid;else break}return f&&f.value||t}findSuperstr(p){return this.g(p,!1)}g(p,$){const f=this.b.reset(p);let t=this.c;for(;t;){const i=f.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.h(t.mid):$?t.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[$,f]of this)p(f,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const $=[];return this.j(p,$),$[Symbol.iterator]()}j(p,$){p&&(p.left&&this.j(p.left,$),p.value&&$.push([p.key,p.value]),p.mid&&this.j(p.mid,$),p.right&&this.j(p.right,$))}_isBalanced(){const p=$=>{if(!$)return!0;const f=$.balanceFactor();return f<-1||f>1?!1:p($.left)&&p($.right)};return p(this.c)}}e.$Uh=k}),define(Ae[42],Re([1,0,89]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Uj=e.ThemeColor=void 0;var M;(function(A){function l(D){return D&&typeof D=="object"&&typeof D.id=="string"}A.isThemeColor=l})(M||(e.ThemeColor=M={}));function C(A){return{id:A}}e.$Uj=C;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const l=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function D(c){const b=l.exec(c.id);if(!b)return D(y.$Tj.error);const[,E,v]=b,n=["codicon","codicon-"+E];return v&&n.push("codicon-modifier-"+v.substring(1)),n}A.asClassNameArray=D;function g(c){return D(c).join(" ")}A.asClassName=g;function R(c){return"."+D(c).join(".")}A.asCSSSelector=R;function k(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||M.isThemeColor(c.color))}A.isThemeIcon=k;const a=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function p(c){const b=a.exec(c);if(!b)return;const[,E]=b;return{id:E}}A.fromString=p;function $(c){return{id:c}}A.fromId=$;function f(c,b){let E=c.id;const v=E.lastIndexOf("~");return v!==-1&&(E=E.substring(0,v)),b&&(E=`${E}~${b}`),{id:E}}A.modify=f;function t(c){const b=c.id.lastIndexOf("~");if(b!==-1)return c.id.substring(b+1)}A.getModifier=t;function i(c,b){return c.id===b.id&&c.color?.id===b.color?.id}A.isEqual=i})(T||(e.ThemeIcon=T={}))}),define(Ae[121],Re([1,0,119,16,42]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=void 0;const T="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),l=new RegExp(`(\\\\)?${A.source}`,"g");function D(i){return i.replace(l,(c,b)=>b?c:`\\${c}`)}e.$Vj=D;const g=new RegExp(`\\\\${A.source}`,"g");function R(i){return i.replace(g,c=>`\\${c}`)}e.$Wj=R;const k=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function a(i){return i.indexOf(T)===-1?i:i.replace(k,(c,b,E,v)=>E?c:b||v||"")}e.$Xj=a;function p(i){return i?i.replace(/\$\((.*?)\)/g,(c,b)=>` ${b} `).trim():""}e.$Yj=p;const $=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(i){$.lastIndex=0;let c="";const b=[];let E=0;for(;;){const v=$.lastIndex,n=$.exec(i),r=i.substring(v,n?.index);if(r.length>0){c+=r;for(let s=0;s<r.length;s++)b.push(E)}if(!n)break;E+=n[0].length}return{text:c,iconOffsets:b}}e.$Zj=f;function t(i,c,b=!1){const{text:E,iconOffsets:v}=c;if(!v||v.length===0)return(0,y.$Ij)(i,E,b);const n=(0,M.$Je)(E," "),r=E.length-n.length,s=(0,y.$Ij)(i,n,b);if(s)for(const o of s){const w=v[o.start+r]+r;o.start+=w,o.end+=w}return s}e.$1j=t}),define(Ae[36],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return y.test(C)}e.$dg=M,e.$eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(l){for(let D=0;D<l.length;D++)l[D]=Math.floor(Math.random()*256);return l};const T=new Uint8Array(16),A=[];for(let l=0;l<256;l++)A.push(l.toString(16).padStart(2,"0"));return function(){C(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let D=0,g="";return g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g+="-",g+=A[T[D++]],g+=A[T[D++]],g+="-",g+=A[T[D++]],g+=A[T[D++]],g+="-",g+=A[T[D++]],g+=A[T[D++]],g+="-",g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g+=A[T[D++]],g}}()}),define(Ae[122],Re([1,0,18,66,36]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.$Ys=e.$Xs=e.$Ws=e.$Vs=void 0;function T(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$Vs=T;function A(k,a,p){const $={id:(0,C.$eg)(),name:k,uri:a,data:p};return{asString:async()=>"",asFile:()=>$,value:void 0}}e.$Ws=A;class l{constructor(){this.a=new Map}get size(){let a=0;for(const p of this.a)a++;return a}has(a){return this.a.has(this.b(a))}matches(a){const p=[...this.a.keys()];return M.Iterable.some(this,([$,f])=>f.asFile())&&p.push("files"),R(D(a),p)}get(a){return this.a.get(this.b(a))?.[0]}append(a,p){const $=this.a.get(a);$?$.push(p):this.a.set(this.b(a),[p])}replace(a,p){this.a.set(this.b(a),[p])}delete(a){this.a.delete(this.b(a))}*[Symbol.iterator](){for(const[a,p]of this.a)for(const $ of p)yield[a,$]}b(a){return D(a)}}e.$Xs=l;function D(k){return k.toLowerCase()}function g(k,a){return R(D(k),a.map(D))}e.$Ys=g;function R(k,a){if(k==="*/*")return a.length>0;if(a.includes(k))return!0;const p=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[$,f,t]=p;return t==="*"?a.some(i=>i.startsWith(f+"/")):!1}e.$Zs=Object.freeze({create:k=>(0,y.$Mb)(k.map(a=>a.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$Zs.split(k).filter(a=>!a.startsWith("#"))})}),define(Ae[123],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=void 0,e.$1r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[124],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.$mt=e.IndentAction=void 0;var y;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class M{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let D=0,g=l.notIn.length;D<g;D++)switch(l.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(l,D){if(l.getTokenCount()===0)return!0;const g=l.findTokenIndexAtOffset(D-2),R=l.getStandardTokenType(g);return this.isOK(R)}g(l,D){for(let g=l;g<=D;g++){const R=String.fromCharCode(g);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$mt=M;class C{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of l)T(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),T(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),T(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),T(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&T(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.$nt=C;function T(A,l,D){A.has(l)?A.get(l).push(D):A.set(l,[D])}}),define(Ae[125],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J7=e.$I7=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const A=this.a.get(T);return this.a.delete(T),A}}addDragOperationTransfer(T,A){this.a.set(T,A)}}e.$I7=y;class M{constructor(T){this.identifier=T}}e.$J7=M}),define(Ae[126],Re([10,11]),function(be,e){return be.create("vs/base/common/actions",e)}),define(Ae[127],Re([1,0,5,6,126]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=void 0;class T extends M.$Sc{constructor(a,p="",$="",f=!0,t){super(),this.h=this.B(new y.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=a,this.m=p,this.u=$,this.w=f,this.C=t}get id(){return this.j}get label(){return this.m}set label(a){this.D(a)}D(a){this.m!==a&&(this.m=a,this.h.fire({label:a}))}get tooltip(){return this.n||""}set tooltip(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.h.fire({tooltip:a}))}get class(){return this.u}set class(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.h.fire({class:a}))}get enabled(){return this.w}set enabled(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.h.fire({enabled:a}))}get checked(){return this.z}set checked(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.h.fire({checked:a}))}async run(a,p){this.C&&await this.C(a)}}e.$ti=T;class A extends M.$Sc{constructor(){super(...arguments),this.f=this.B(new y.$Nd),this.onWillRun=this.f.event,this.m=this.B(new y.$Nd),this.onDidRun=this.m.event}async run(a,p){if(!a.enabled)return;this.f.fire({action:a});let $;try{await this.u(a,p)}catch(f){$=f}this.m.fire({action:a,error:$})}async u(a,p){await a.run(p)}}e.$ui=A;class l{constructor(){this.id=l.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let p=[];for(const $ of a)$.length&&(p.length?p=[...p,new l,...$]:p=$);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$vi=l;class D{get actions(){return this.a}constructor(a,p,$,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=p,this.class=f,this.a=$}async run(){}}e.$wi=D;class g extends T{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,C.localize(0,null),void 0,!1)}}e.$xi=g;function R(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...a)=>k.run(...a),tooltip:k.label}}e.$yi=R}),define(Ae[128],Re([10,11]),function(be,e){return be.create("vs/base/common/date",e)}),define(Ae[129],Re([1,0,128]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=e.$bm=void 0;const M=60,C=M*60,T=C*24,A=T*7,l=T*30,D=T*365;function g(k,a,p,$){typeof k!="number"&&(k=k.getTime());const f=Math.round((new Date().getTime()-k)/1e3);if(f<-30)return(0,y.localize)(0,null,g(new Date().getTime()+f*1e3,!1));if(!$&&f<30)return(0,y.localize)(1,null);let t;return f<M?(t=f,a?t===1?p?(0,y.localize)(2,null,t):(0,y.localize)(3,null,t):p?(0,y.localize)(4,null,t):(0,y.localize)(5,null,t):t===1?p?(0,y.localize)(6,null,t):(0,y.localize)(7,null,t):p?(0,y.localize)(8,null,t):(0,y.localize)(9,null,t)):f<C?(t=Math.floor(f/M),a?t===1?p?(0,y.localize)(10,null,t):(0,y.localize)(11,null,t):p?(0,y.localize)(12,null,t):(0,y.localize)(13,null,t):t===1?p?(0,y.localize)(14,null,t):(0,y.localize)(15,null,t):p?(0,y.localize)(16,null,t):(0,y.localize)(17,null,t)):f<T?(t=Math.floor(f/C),a?t===1?p?(0,y.localize)(18,null,t):(0,y.localize)(19,null,t):p?(0,y.localize)(20,null,t):(0,y.localize)(21,null,t):t===1?p?(0,y.localize)(22,null,t):(0,y.localize)(23,null,t):p?(0,y.localize)(24,null,t):(0,y.localize)(25,null,t)):f<A?(t=Math.floor(f/T),a?t===1?(0,y.localize)(26,null,t):(0,y.localize)(27,null,t):t===1?(0,y.localize)(28,null,t):(0,y.localize)(29,null,t)):f<l?(t=Math.floor(f/A),a?t===1?p?(0,y.localize)(30,null,t):(0,y.localize)(31,null,t):p?(0,y.localize)(32,null,t):(0,y.localize)(33,null,t):t===1?p?(0,y.localize)(34,null,t):(0,y.localize)(35,null,t):p?(0,y.localize)(36,null,t):(0,y.localize)(37,null,t)):f<D?(t=Math.floor(f/l),a?t===1?p?(0,y.localize)(38,null,t):(0,y.localize)(39,null,t):p?(0,y.localize)(40,null,t):(0,y.localize)(41,null,t):t===1?p?(0,y.localize)(42,null,t):(0,y.localize)(43,null,t):p?(0,y.localize)(44,null,t):(0,y.localize)(45,null,t)):(t=Math.floor(f/D),a?t===1?p?(0,y.localize)(46,null,t):(0,y.localize)(47,null,t):p?(0,y.localize)(48,null,t):(0,y.localize)(49,null,t):t===1?p?(0,y.localize)(50,null,t):(0,y.localize)(51,null,t):p?(0,y.localize)(52,null,t):(0,y.localize)(53,null,t))}e.$bm=g;function R(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$cm=R}),define(Ae[130],Re([10,11]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(Ae[37],Re([1,0,18,15,130]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=e.$zi=void 0;function T(k,a){return a&&(k.stack||k.stacktrace)?C.localize(0,null,l(k),A(k.stack)||A(k.stacktrace)):l(k)}function A(k){return Array.isArray(k)?k.join(`
`):k}function l(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?C.localize(1,null,k.message):k.message||C.localize(2,null)}function D(k=null,a=!1){if(!k)return C.localize(3,null);if(Array.isArray(k)){const p=y.$Hb(k),$=D(p[0],a);return p.length>1?C.localize(4,null,$,p.length):$}if(M.$yf(k))return k;if(k.detail){const p=k.detail;if(p.error)return T(p.error,a);if(p.exception)return T(p.exception,a)}return k.stack?T(k,a):k.message?k.message:C.localize(5,null)}e.$zi=D;function g(k){const a=k;return a instanceof Error&&Array.isArray(a.actions)}e.$Ai=g;function R(k,a){let p;return typeof k=="string"?p=new Error(k):p=k,p.actions=a,p}e.$Bi=R}),define(Ae[131],Re([1,0,41,19]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=void 0;const C=new y.$V(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),T=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function l(S,u,m=!1){const d=S||"",P=u||"",W=C.value.collator.compare(d,P);return C.value.collatorIsNumeric&&W===0&&d!==P?d<P?-1:1:W}e.$fq=l;function D(S,u){const m=T.value.collator;return S=S||"",u=u||"",E(m,S,u)}e.$gq=D;function g(S,u){const m=T.value.collator;return S=S||"",u=u||"",s(S,u)||E(m,S,u)}e.$hq=g;function R(S,u){const m=T.value.collator;return S=S||"",u=u||"",r(S,u)||E(m,S,u)}e.$iq=R;function k(S,u){return S=S||"",u=u||"",S===u?0:S<u?-1:1}e.$jq=k;function a(S,u){const[m,d]=c(S),[P,W]=c(u);let K=C.value.collator.compare(d,W);if(K===0){if(C.value.collatorIsNumeric&&d!==W)return d<W?-1:1;if(K=C.value.collator.compare(m,P),C.value.collatorIsNumeric&&K===0&&m!==P)return m<P?-1:1}return K}e.$kq=a;function p(S,u){S=S||"",u=u||"";const m=b(S),d=b(u),P=T.value.collator,W=A.value.collator;return E(W,m,d)||E(P,S,u)}e.$lq=p;function $(S,u){S=S||"",u=u||"";const m=b(S),d=b(u),P=T.value.collator,W=A.value.collator;return E(W,m,d)||s(S,u)||E(P,S,u)}e.$mq=$;function f(S,u){S=S||"",u=u||"";const m=b(S),d=b(u),P=T.value.collator,W=A.value.collator;return E(W,m,d)||r(S,u)||E(P,S,u)}e.$nq=f;function t(S,u){S=S||"",u=u||"";const m=b(S).toLowerCase(),d=b(u).toLowerCase();return m!==d?m<d?-1:1:S!==u?S<u?-1:1:0}e.$oq=t;const i=/^(.*?)(\.([^.]*))?$/;function c(S,u=!1){const m=S?i.exec(S):[];let d=[m&&m[1]||"",m&&m[3]||""];return u&&(!d[0]&&d[1]||d[0]&&d[0].charAt(0)===".")&&(d=[d[0]+"."+d[1],""]),d}function b(S){const u=S?i.exec(S):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function E(S,u,m){const d=S.compare(u,m);return d!==0?d:u.length!==m.length?u.length<m.length?-1:1:0}function v(S){const u=S.charAt(0);return u.toLocaleUpperCase()!==u}function n(S){const u=S.charAt(0);return u.toLocaleLowerCase()!==u}function r(S,u){return v(S)&&n(u)?-1:n(S)&&v(u)?1:0}function s(S,u){return n(S)&&v(u)?-1:v(S)&&n(u)?1:0}function o(S,u,m=!1){return m||(S=S&&S.toLowerCase(),u=u&&u.toLowerCase()),S===u?0:S<u?-1:1}function w(S,u,m=!1){const d=S.split(M.sep),P=u.split(M.sep),W=d.length-1,K=P.length-1;let U,B;for(let O=0;;O++){if(U=W===O,B=K===O,U&&B)return l(d[O],P[O],m);if(U)return-1;if(B)return 1;const N=o(d[O],P[O],m);if(N!==0)return N}}e.$pq=w;function h(S,u,m){const d=S.toLowerCase(),P=u.toLowerCase(),W=I(S,u,m);if(W)return W;const K=d.endsWith(m),U=P.endsWith(m);if(K!==U)return K?-1:1;const B=l(d,P);return B!==0?B:d.localeCompare(P)}e.$qq=h;function I(S,u,m){const d=S.toLowerCase(),P=u.toLowerCase(),W=d.startsWith(m),K=P.startsWith(m);if(W!==K)return W?-1:1;if(W&&K){if(d.length<P.length)return-1;if(d.length>P.length)return 1}return 0}e.$rq=I}),define(Ae[43],Re([1,0,19,22,16,15]),function(be,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function A(h){return h===47||h===92}e.$Qf=A;function l(h){return h.replace(/[\\/]/g,y.$gc.sep)}e.$Rf=l;function D(h){return h.indexOf("/")===-1&&(h=l(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Sf=D;function g(h,I=y.$gc.sep){if(!h)return"";const S=h.length,u=h.charCodeAt(0);if(A(u)){if(A(h.charCodeAt(1))&&!A(h.charCodeAt(2))){let d=3;const P=d;for(;d<S&&!A(h.charCodeAt(d));d++);if(P!==d&&!A(h.charCodeAt(d+1))){for(d+=1;d<S;d++)if(A(h.charCodeAt(d)))return h.slice(0,d+1).replace(/[\\/]/g,I)}}return I}else if(i(u)&&h.charCodeAt(1)===58)return A(h.charCodeAt(2))?h.slice(0,2)+I:h.slice(0,2);let m=h.indexOf("://");if(m!==-1){for(m+=3;m<S;m++)if(A(h.charCodeAt(m)))return h.slice(0,m+1)}return""}e.$Tf=g;function R(h){if(!M.$j||!h||h.length<5)return!1;let I=h.charCodeAt(0);if(I!==92||(I=h.charCodeAt(1),I!==92))return!1;let S=2;const u=S;for(;S<h.length&&(I=h.charCodeAt(S),I!==92);S++);return!(u===S||(I=h.charCodeAt(S+1),isNaN(I)||I===92))}e.$Uf=R;const k=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(h,I=M.$j){const S=I?k:a;return!(!h||h.length===0||/^\s+$/.test(h)||(S.lastIndex=0,S.test(h))||I&&p.test(h)||h==="."||h===".."||I&&h[h.length-1]==="."||I&&h.length!==h.trim().length||h.length>255)}e.$Vf=$;function f(h,I,S){const u=h===I;return!S||u?u:!h||!I?!1:(0,C.$2e)(h,I)}e.$Wf=f;function t(h,I,S,u=y.sep){if(h===I)return!0;if(!h||!I||I.length>h.length)return!1;if(S){if(!(0,C.$3e)(h,I))return!1;if(I.length===h.length)return!0;let d=I.length;return I.charAt(I.length-1)===u&&d--,h.charAt(d)===u}return I.charAt(I.length-1)!==u&&(I+=u),h.indexOf(I)===0}e.$Xf=t;function i(h){return h>=65&&h<=90||h>=97&&h<=122}e.$Yf=i;function c(h,I){return M.$j&&h.endsWith(":")&&(h+=y.sep),(0,y.$ic)(h)||(h=(0,y.$jc)(I,h)),h=(0,y.$hc)(h),M.$j?(h=(0,C.$Ke)(h,y.sep),h.endsWith(":")&&(h+=y.sep)):(h=(0,C.$Ke)(h,y.sep),h||(h=y.sep)),h}e.$Zf=c;function b(h){const I=(0,y.$hc)(h);return M.$j?h.length>3?!1:E(I)&&(h.length===2||I.charCodeAt(2)===92):I===y.$gc.sep}e.$1f=b;function E(h,I=M.$j){return I?i(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$2f=E;function v(h,I=M.$j){return E(h,I)?h[0]:void 0}e.$3f=v;function n(h,I,S){return I.length>h.length?-1:h===I?0:(S&&(h=h.toLowerCase(),I=I.toLowerCase()),h.indexOf(I))}e.$4f=n;function r(h){const I=h.split(":");let S,u,m;for(const d of I){const P=Number(d);(0,T.$Cf)(P)?u===void 0?u=P:m===void 0&&(m=P):S=S?[S,d].join(":"):d}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:u!==void 0?u:void 0,column:m!==void 0?m:u!==void 0?1:void 0}}e.$5f=r;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(h,I,S=8){let u="";for(let d=0;d<S;d++){let P;d===0&&M.$j&&!I&&(S===3||S===4)?P=o:P=s,u+=P.charAt(Math.floor(Math.random()*P.length))}let m;return I?m=`${I}-${u}`:m=u,h?(0,y.$jc)(h,m):m}e.$6f=w}),define(Ae[67],Re([1,0,19]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=e.$Pr=e.$Or=e.$Nr=void 0,e.$Nr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(R){const k=(0,y.$oc)(R),a=M[k.toLowerCase()];return a!==void 0?a:A(R)}e.$Or=T;function A(R){const k=(0,y.$oc)(R);return C[k.toLowerCase()]}e.$Pr=A;function l(R){for(const k in C)if(C[k]===R)return k}e.$Qr=l;const D=/^(.+)\/(.+?)(;.+)?$/;function g(R,k){const a=D.exec(R);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:k?void 0:R}e.$Rr=g}),define(Ae[68],Re([1,0,26,2]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=e.$kh=e.$jh=void 0;function C(D){return JSON.stringify(D,A)}e.$jh=C;function T(D){let g=JSON.parse(D);return g=l(g),g}e.$kh=T;function A(D,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function l(D,g=0){if(!D||g>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return M.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 17:return new Date(D.source)}if(D instanceof y.$be||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let R=0;R<D.length;++R)D[R]=l(D[R],g+1);else for(const R in D)Object.hasOwnProperty.call(D,R)&&(D[R]=l(D[R],g+1))}return D}e.$lh=l}),define(Ae[13],Re([1,0,9,22,2]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var T;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(T||(e.Schemas=T={})),e.$7f="vscode-tkn",e.$8f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${T.vscodeRemoteResource}`}set(R,k,a){this.a[R]=k,this.b[R]=a}setConnectionToken(R,k){this.c[R]=k}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(t){return y.$1(t),R}const k=R.authority;let a=this.a[k];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const p=this.b[k],$=this.c[k];let f=`path=${encodeURIComponent(R.path)}`;return typeof $=="string"&&(f+=`&${e.$8f}=${encodeURIComponent($)}`),C.URI.from({scheme:M.$p?this.d:T.vscodeRemoteResource,authority:`${a}:${p}`,path:this.f,query:f})}}e.$9f=new A,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class l{static{this.a=e.$bg}asBrowserUri(R){const k=this.b(R,be);return this.uriToBrowserUri(k)}uriToBrowserUri(R){return R.scheme===T.vscodeRemote?e.$9f.rewrite(R):R.scheme===T.file&&(M.$n||M.$q&&M.$h.origin===`${T.vscodeFileResource}://${l.a}`)?R.with({scheme:T.vscodeFileResource,authority:R.authority||l.a,query:null,fragment:null}):R}asFileUri(R){const k=this.b(R,be);return this.uriToFileUri(k)}uriToFileUri(R){return R.scheme===T.vscodeFileResource?R.with({scheme:T.file,authority:R.authority!==l.a?R.authority:null,query:null,fragment:null}):R}b(R,k){return C.URI.isUri(R)?R:C.URI.parse(k.toUrl(R))}}e.$cg=new l;var D;(function(g){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(R.get("3"));const k="vscode-coi";function a($){let f;typeof $=="string"?f=new URL($).searchParams:$ instanceof URL?f=$.searchParams:C.URI.isUri($)&&(f=new URL($.toString(!0)).searchParams);const t=f?.get(k);if(t)return R.get(t)}g.getHeadersFromQuery=a;function p($,f,t){if(!globalThis.crossOriginIsolated)return;const i=f&&t?"3":t?"2":"1";$ instanceof URLSearchParams?$.set(k,i):$[k]=i}g.addSearchParam=p})(D||(e.COI=D={}))}),define(Ae[23],Re([1,0,43,13,19,22,16,2]),function(be,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function D(p){return(0,l.$wc)(p,!0)}e.$jg=D;class g{constructor($){this.a=$}compare($,f,t=!1){return $===f?0:(0,A.$Ue)(this.getComparisonKey($,t),this.getComparisonKey(f,t))}isEqual($,f,t=!1){return $===f?!0:!$||!f?!1:this.getComparisonKey($,t)===this.getComparisonKey(f,t)}getComparisonKey($,f=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,f,t=!1){if($.scheme===f.scheme){if($.scheme===M.Schemas.file)return y.$Xf(D($),D(f),this.a($))&&$.query===f.query&&(t||$.fragment===f.fragment);if((0,e.$Ag)($.authority,f.authority))return y.$Xf($.path,f.path,this.a($),"/")&&$.query===f.query&&(t||$.fragment===f.fragment)}return!1}joinPath($,...f){return l.URI.joinPath($,...f)}basenameOrAuthority($){return(0,e.$sg)($)||$.authority}basename($){return C.$gc.basename($.path)}extname($){return C.$gc.extname($.path)}dirname($){if($.path.length===0)return $;let f;return $.scheme===M.Schemas.file?f=l.URI.file(C.$mc(D($))).path:(f=C.$gc.dirname($.path),$.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),f="/")),$.with({path:f})}normalizePath($){if(!$.path.length)return $;let f;return $.scheme===M.Schemas.file?f=l.URI.file(C.$hc(D($))).path:f=C.$gc.normalize($.path),$.with({path:f})}relativePath($,f){if($.scheme!==f.scheme||!(0,e.$Ag)($.authority,f.authority))return;if($.scheme===M.Schemas.file){const c=C.$lc(D($),D(f));return T.$j?y.$Rf(c):c}let t=$.path||"/";const i=f.path||"/";if(this.a($)){let c=0;for(const b=Math.min(t.length,i.length);c<b&&!(t.charCodeAt(c)!==i.charCodeAt(c)&&t.charAt(c).toLowerCase()!==i.charAt(c).toLowerCase());c++);t=i.substr(0,c)+t.substr(c)}return C.$gc.relative(t,i)}resolvePath($,f){if($.scheme===M.Schemas.file){const t=l.URI.file(C.$kc(D($),f));return $.with({authority:t.authority,path:t.path})}return f=y.$Sf(f),$.with({path:C.$gc.resolve($.path,f)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,f){return $===f||$!==void 0&&f!==void 0&&(0,A.$2e)($,f)}hasTrailingPathSeparator($,f=C.sep){if($.scheme===M.Schemas.file){const t=D($);return t.length>y.$Tf(t).length&&t[t.length-1]===f}else{const t=$.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,f=C.sep){return(0,e.$Bg)($,f)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,f=C.sep){let t=!1;if($.scheme===M.Schemas.file){const i=D($);t=i!==void 0&&i.length===y.$Tf(i).length&&i[i.length-1]===f}else{f="/";const i=$.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Bg)($,f)?$.with({path:$.path+"/"}):$}}e.$kg=g,e.$lg=new g(()=>!1),e.$mg=new g(p=>p.scheme===M.Schemas.file?!T.$l:!0),e.$ng=new g(p=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function R(p,$){const f=[];for(let t=0;t<p.length;t++){const i=$(p[t]);p.some((c,b)=>b===t?!1:(0,e.$pg)(i,$(c)))||f.push(p[t])}return f}e.$Eg=R;var k;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function $(f){const t=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(b=>{const[E,v]=b.split(":");E&&v&&t.set(E,v)});const c=f.path.substring(0,f.path.indexOf(";"));return c&&t.set(p.META_DATA_MIME,c),t}p.parseMetaData=$})(k||(e.DataUri=k={}));function a(p,$,f){if($){let t=p.path;return t&&t[0]!==C.$gc.sep&&(t=C.$gc.sep+t),p.with({scheme:f,authority:$,path:t})}return p.with({scheme:f})}e.$Fg=a}),define(Ae[12],Re([1,0,20,9,5,6,23,22,120]),function(be,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function g(z){return!!z&&typeof z.then=="function"}e.$Gg=g;function R(z){const V=new y.$Xd,ue=z(V.token),ye=new Promise((we,pe)=>{const De=V.token.onCancellationRequested(()=>{De.dispose(),V.dispose(),pe(new M.$5)});Promise.resolve(ue).then(ne=>{De.dispose(),V.dispose(),we(ne)},ne=>{De.dispose(),V.dispose(),pe(ne)})});return new class{cancel(){V.cancel()}then(we,pe){return ye.then(we,pe)}catch(we){return this.then(void 0,we)}finally(we){return ye.finally(we)}}}e.$Hg=R;function k(z,V,ue){return new Promise((ye,we)=>{const pe=V.onCancellationRequested(()=>{pe.dispose(),ye(ue)});z.then(ye,we).finally(()=>pe.dispose())})}e.$Ig=k;function a(z,V){return new Promise((ue,ye)=>{const we=V.onCancellationRequested(()=>{we.dispose(),ye(new M.$5)});z.then(ue,ye).finally(()=>we.dispose())})}e.$Jg=a;async function p(z){let V=-1;const ue=z.map((ye,we)=>ye.then(pe=>(V=we,pe)));try{return await Promise.race(ue)}finally{z.forEach((ye,we)=>{we!==V&&ye.cancel()})}}e.$Kg=p;function $(z,V,ue){let ye;const we=setTimeout(()=>{ye?.(void 0),ue?.()},V);return Promise.race([z.finally(()=>clearTimeout(we)),new Promise(pe=>ye=pe)])}e.$Lg=$;function f(z){return new Promise((V,ue)=>{const ye=z();g(ye)?ye.then(V,ue):V(ye)})}e.$Mg=f;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(V){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=V,!this.b){const ue=()=>{if(this.b=null,this.f)return;const ye=this.queue(this.d);return this.d=null,ye};this.b=new Promise(ye=>{this.a.then(ue,ue).then(ye)})}return new Promise((ue,ye)=>{this.b.then(ue,ye)})}return this.a=V(),new Promise((ue,ye)=>{this.a.then(we=>{this.a=null,ue(we)},we=>{this.a=null,ye(we)})})}dispose(){this.f=!0}}e.$Ng=t;class i{constructor(){this.a=Promise.resolve(null)}queue(V){return this.a=this.a.then(()=>V(),()=>V())}}e.$Og=i;class c{constructor(){this.a=new Map}queue(V,ue){const we=(this.a.get(V)??Promise.resolve()).catch(()=>{}).then(ue).finally(()=>{this.a.get(V)===we&&this.a.delete(V)});return this.a.set(V,we),we}}e.$Pg=c;const b=(z,V)=>{let ue=!0;const ye=setTimeout(()=>{ue=!1,V()},z);return{isTriggered:()=>ue,dispose:()=>{clearTimeout(ye),ue=!1}}},E=z=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,z())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class v{constructor(V){this.defaultDelay=V,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(V,ue=this.defaultDelay){this.g=V,this.h(),this.b||(this.b=new Promise((we,pe)=>{this.d=we,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const ye=()=>{this.a=null,this.d?.(null)};return this.a=ue===D.$Kd?E(ye):b(ue,ye),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=v;class n{constructor(V){this.a=new v(V),this.b=new t}trigger(V,ue){return this.a.trigger(()=>this.b.queue(V),ue)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=n;class r{constructor(){this.a=!1,this.b=new Promise((V,ue)=>{this.d=V})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=r;class s extends r{constructor(V){super(),this.f=setTimeout(()=>this.open(),V)}open(){clearTimeout(this.f),super.open()}}e.$Tg=s;function o(z,V){return V?new Promise((ue,ye)=>{const we=setTimeout(()=>{pe.dispose(),ue()},z),pe=V.onCancellationRequested(()=>{clearTimeout(we),pe.dispose(),ye(new M.$5)})}):R(ue=>o(z,ue))}e.$Ug=o;function w(z,V=0,ue){const ye=setTimeout(()=>{z(),ue&&we.dispose()},V),we=(0,T.$Qc)(()=>{clearTimeout(ye),ue?.deleteAndLeak(we)});return ue?.add(we),we}e.$Vg=w;function h(z){const V=[];let ue=0;const ye=z.length;function we(){return ue<ye?z[ue++]():null}function pe(De){De!=null&&V.push(De);const ne=we();return ne?ne.then(pe):Promise.resolve(V)}return Promise.resolve(null).then(pe)}e.$Wg=h;function I(z,V=ye=>!!ye,ue=null){let ye=0;const we=z.length,pe=()=>{if(ye>=we)return Promise.resolve(ue);const De=z[ye++];return Promise.resolve(De()).then(le=>V(le)?Promise.resolve(le):pe())};return pe()}e.$Xg=I;function S(z,V=ye=>!!ye,ue=null){if(z.length===0)return Promise.resolve(ue);let ye=z.length;const we=()=>{ye=-1;for(const pe of z)pe.cancel?.()};return new Promise((pe,De)=>{for(const ne of z)ne.then(le=>{--ye>=0&&V(le)?(we(),pe(le)):ye===0&&pe(ue)}).catch(le=>{--ye>=0&&(we(),De(le))})})}e.$Yg=S;class u{constructor(V){this.a=0,this.d=V,this.f=[],this.b=0,this.g=new C.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(V){return this.a++,new Promise((ue,ye)=>{this.f.push({factory:V,c:ue,e:ye}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const V=this.f.shift();this.b++;const ue=V.factory();ue.then(V.c,V.e),ue.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=u;class m extends u{constructor(){super(1)}}e.$1g=m;class d{constructor(){this.a=new Ee,this.b=0}queue(V){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,V())):this.a.run(this.b++,V())}}e.$2g=d;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const V=new ge;return this.b.add(V),V.p}g(){for(const[,V]of this.a)if(V.size>0)return!1;return!0}queueFor(V,ue=A.$lg){const ye=ue.getComparisonKey(V);let we=this.a.get(ye);if(!we){we=new m;const pe=this.f++,De=C.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(ye),this.h(),this.d?.deleteAndDispose(pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$1c),this.d.set(pe,De),this.a.set(ye,we)}return we}h(){this.g()&&this.j()}j(){for(const V of this.b)V.complete();this.b.clear()}dispose(){for(const[,V]of this.a)V.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=P;class W{constructor(V,ue){this.a=-1,typeof V=="function"&&typeof ue=="number"&&this.setIfNotSet(V,ue)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(V,ue){this.cancel(),this.a=setTimeout(()=>{this.a=-1,V()},ue)}setIfNotSet(V,ue){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,V()},ue))}}e.$4g=W;class K{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(V,ue){this.cancel(),this.a=setInterval(()=>{V()},ue)}}e.$5g=K;class U{constructor(V,ue){this.b=-1,this.a=V,this.d=ue,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(V=this.d){this.cancel(),this.b=setTimeout(this.f,V)}get delay(){return this.d}set delay(V){this.d=V}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=U;class B{constructor(V,ue){ue%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ue}ms is not a multiple of 1000ms.`),this.a=V,this.b=ue,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(V=this.b){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(V/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=B;class O extends U{constructor(V,ue){super(V,ue),this.j=[]}work(V){this.j.push(V),this.isScheduled()||this.schedule()}h(){const V=this.j;this.j=[],this.a?.(V)}dispose(){this.j=[],super.dispose()}}e.$8g=O;class N extends T.$Sc{constructor(V,ue){super(),this.g=V,this.h=ue,this.a=[],this.b=this.B(new T.$Tc),this.f=!1}get pending(){return this.a.length}work(V){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+V.length>this.g.maxBufferedWork)return!1}else if(this.pending+V.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ue of V)this.a.push(ue);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=z=>{(0,l.$B)(()=>{if(V)return;const ue=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.$0g=(z,V)=>{const ue=requestIdleCallback(z,typeof V=="number"?{timeout:V}:void 0);let ye=!1;return{dispose(){ye||(ye=!0,cancelIdleCallback(ue))}}}}();class te{constructor(V){this.d=!1,this.a=()=>{try{this.f=V()}catch(ue){this.g=ue}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=te;async function Y(z,V,ue){let ye;for(let we=0;we<ue;we++)try{return await z()}catch(pe){ye=pe,await o(V)}throw ye}e.$_g=Y;class Ee{isRunning(V){return typeof V=="number"?this.a?.taskId===V:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(V,ue,ye){return this.a={taskId:V,cancel:()=>ye?.(),promise:ue},ue.then(()=>this.d(V),()=>this.d(V)),ue}d(V){this.a&&V===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const V=this.b;this.b=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}queue(V){if(this.b)this.b.run=V;else{let ue,ye;const we=new Promise((pe,De)=>{ue=pe,ye=De});this.b={run:V,promise:we,promiseResolve:ue,promiseReject:ye}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=Ee;class Se{constructor(V,ue=()=>Date.now()){this.d=V,this.f=ue,this.a=0,this.b=0}increment(){const V=this.f();return V-this.a>this.d&&(this.a=V,this.b=0),this.b++,this.b}}e.$bh=Se;var Pe;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(Pe||(Pe={}));class ge{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((V,ue)=>{this.a=V,this.b=ue})}complete(V){return new Promise(ue=>{this.a(V),this.d={outcome:0,value:V},ue()})}error(V){return new Promise(ue=>{this.b(V),this.d={outcome:1,value:V},ue()})}cancel(){return this.error(new M.$5)}}e.$ch=ge;var me;(function(z){async function V(ye){let we;const pe=await Promise.all(ye.map(De=>De.then(ne=>ne,ne=>{we||(we=ne)})));if(typeof we<"u")throw we;return pe}z.settled=V;function ue(ye){return new Promise(async(we,pe)=>{try{await ye(we,pe)}catch(De){pe(De)}})}z.withAsyncBody=ue})(me||(e.Promises=me={}));var ce;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(ce||(ce={}));class se{static fromArray(V){return new se(ue=>{ue.emitMany(V)})}static fromPromise(V){return new se(async ue=>{ue.emitMany(await V)})}static fromPromises(V){return new se(async ue=>{await Promise.all(V.map(async ye=>ue.emitOne(await ye)))})}static merge(V){return new se(async ue=>{await Promise.all(V.map(async ye=>{for await(const we of ye)ue.emitOne(we)}))})}static{this.EMPTY=se.fromArray([])}constructor(V){this.a=0,this.b=[],this.d=null,this.f=new C.$Nd,queueMicrotask(async()=>{const ue={emitOne:ye=>this.g(ye),emitMany:ye=>this.h(ye),reject:ye=>this.k(ye)};try{await Promise.resolve(V(ue)),this.j()}catch(ye){this.k(ye)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(V<this.b.length)return{done:!1,value:this.b[V++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(V,ue){return new se(async ye=>{for await(const we of V)ye.emitOne(ue(we))})}map(V){return se.map(this,V)}static filter(V,ue){return new se(async ye=>{for await(const we of V)ue(we)&&ye.emitOne(we)})}filter(V){return se.filter(this,V)}static coalesce(V){return se.filter(V,ue=>!!ue)}coalesce(){return se.coalesce(this)}static async toPromise(V){const ue=[];for await(const ye of V)ue.push(ye);return ue}toPromise(){return se.toPromise(this)}g(V){this.a===0&&(this.b.push(V),this.f.fire())}h(V){this.a===0&&(this.b=this.b.concat(V),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(V){this.a===0&&(this.a=2,this.d=V,this.f.fire())}}e.$dh=se;class $e extends se{constructor(V,ue){super(ue),this.l=V}cancel(){this.l.cancel()}}e.$eh=$e;function x(z){const V=new y.$Xd,ue=z(V.token);return new $e(V,async ye=>{const we=V.token.onCancellationRequested(()=>{we.dispose(),V.dispose(),ye.reject(new M.$5)});try{for await(const pe of ue){if(V.token.isCancellationRequested)return;ye.emitOne(pe)}we.dispose(),V.dispose()}catch(pe){we.dispose(),V.dispose(),ye.reject(pe)}})}e.$fh=x}),define(Ae[38],Re([1,0,18,12,43,28,19,22,16]),function(be,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=void 0;function g(){return Object.create(null)}e.$qj=g,e.$rj="**",e.$sj="/";const R="[/\\\\]",k="[^/\\\\]",a=/\//g;function p(Ee,Se){switch(Ee){case 0:return"";case 1:return`${k}*?`;default:return`(?:${R}|${k}+${R}${Se?`|${R}${k}+`:""})*?`}}function $(Ee,Se){if(!Ee)return[];const Pe=[];let ge=!1,me=!1,ce="";for(const se of Ee){switch(se){case Se:if(!ge&&!me){Pe.push(ce),ce="";continue}break;case"{":ge=!0;break;case"}":ge=!1;break;case"[":me=!0;break;case"]":me=!1;break}ce+=se}return ce&&Pe.push(ce),Pe}e.$tj=$;function f(Ee){if(!Ee)return"";let Se="";const Pe=$(Ee,e.$sj);if(Pe.every(ge=>ge===e.$rj))Se=".*";else{let ge=!1;Pe.forEach((me,ce)=>{if(me===e.$rj){if(ge)return;Se+=p(2,ce===Pe.length-1)}else{let se=!1,$e="",x=!1,z="";for(const V of me){if(V!=="}"&&se){$e+=V;continue}if(x&&(V!=="]"||!z)){let ue;V==="-"?ue=V:(V==="^"||V==="!")&&!z?ue="^":V===e.$sj?ue="":ue=(0,D.$Fe)(V),z+=ue;continue}switch(V){case"{":se=!0;continue;case"[":x=!0;continue;case"}":{const ye=`(?:${$($e,",").map(we=>f(we)).join("|")})`;Se+=ye,se=!1,$e="";break}case"]":{Se+="["+z+"]",x=!1,z="";break}case"?":Se+=k;continue;case"*":Se+=p(1);continue;default:Se+=(0,D.$Fe)(V)}}ce<Pe.length-1&&(Pe[ce+1]!==e.$rj||ce+2<Pe.length)&&(Se+=R)}ge=me===e.$rj})}return Se}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new T.$Dc(1e4),r=function(){return!1},s=function(){return null};function o(Ee,Se){if(!Ee)return s;let Pe;typeof Ee!="string"?Pe=Ee.pattern:Pe=Ee,Pe=Pe.trim();const ge=`${Pe}_${!!Se.trimForExclusions}`;let me=n.get(ge);if(me)return w(me,Ee);let ce;return t.test(Pe)?me=I(Pe.substr(4),Pe):(ce=i.exec(h(Pe,Se)))?me=S(ce[1],Pe):(Se.trimForExclusions?b:c).test(Pe)?me=u(Pe,Se):(ce=E.exec(h(Pe,Se)))?me=m(ce[1].substr(1),Pe,!0):(ce=v.exec(h(Pe,Se)))?me=m(ce[1],Pe,!1):me=d(Pe),n.set(ge,me),w(me,Ee)}function w(Ee,Se){if(typeof Se=="string")return Ee;const Pe=function(ge,me){return(0,C.$Xf)(ge,Se.base,!l.$l)?Ee((0,D.$Je)(ge.substr(Se.base.length),A.sep),me):null};return Pe.allBasenames=Ee.allBasenames,Pe.allPaths=Ee.allPaths,Pe.basenames=Ee.basenames,Pe.patterns=Ee.patterns,Pe}function h(Ee,Se){return Se.trimForExclusions&&Ee.endsWith("/**")?Ee.substr(0,Ee.length-2):Ee}function I(Ee,Se){return function(Pe,ge){return typeof Pe=="string"&&Pe.endsWith(Ee)?Se:null}}function S(Ee,Se){const Pe=`/${Ee}`,ge=`\\${Ee}`,me=function(se,$e){return typeof se!="string"?null:$e?$e===Ee?Se:null:se===Ee||se.endsWith(Pe)||se.endsWith(ge)?Se:null},ce=[Ee];return me.basenames=ce,me.patterns=[Se],me.allBasenames=ce,me}function u(Ee,Se){const Pe=te(Ee.slice(1,-1).split(",").map($e=>o($e,Se)).filter($e=>$e!==s),Ee),ge=Pe.length;if(!ge)return s;if(ge===1)return Pe[0];const me=function($e,x){for(let z=0,V=Pe.length;z<V;z++)if(Pe[z]($e,x))return Ee;return null},ce=Pe.find($e=>!!$e.allBasenames);ce&&(me.allBasenames=ce.allBasenames);const se=Pe.reduce(($e,x)=>x.allPaths?$e.concat(x.allPaths):$e,[]);return se.length&&(me.allPaths=se),me}function m(Ee,Se,Pe){const ge=A.sep===A.$gc.sep,me=ge?Ee:Ee.replace(a,A.sep),ce=A.sep+me,se=A.$gc.sep+Ee;let $e;return Pe?$e=function(x,z){return typeof x=="string"&&(x===me||x.endsWith(ce)||!ge&&(x===Ee||x.endsWith(se)))?Se:null}:$e=function(x,z){return typeof x=="string"&&(x===me||!ge&&x===Ee)?Se:null},$e.allPaths=[(Pe?"*/":"./")+Ee],$e}function d(Ee){try{const Se=new RegExp(`^${f(Ee)}$`);return function(Pe){return Se.lastIndex=0,typeof Pe=="string"&&Se.test(Pe)?Ee:null}}catch{return s}}function P(Ee,Se,Pe){return!Ee||typeof Se!="string"?!1:W(Ee)(Se,void 0,Pe)}e.$uj=P;function W(Ee,Se={}){if(!Ee)return r;if(typeof Ee=="string"||K(Ee)){const Pe=o(Ee,Se);if(Pe===s)return r;const ge=function(me,ce){return!!Pe(me,ce)};return Pe.allBasenames&&(ge.allBasenames=Pe.allBasenames),Pe.allPaths&&(ge.allPaths=Pe.allPaths),ge}return O(Ee,Se)}e.$vj=W;function K(Ee){const Se=Ee;return Se?typeof Se.base=="string"&&typeof Se.pattern=="string":!1}e.$wj=K;function U(Ee){return Ee.allBasenames||[]}e.$xj=U;function B(Ee){return Ee.allPaths||[]}e.$yj=B;function O(Ee,Se){const Pe=te(Object.getOwnPropertyNames(Ee).map($e=>N($e,Ee[$e],Se)).filter($e=>$e!==s)),ge=Pe.length;if(!ge)return s;if(!Pe.some($e=>!!$e.requiresSiblings)){if(ge===1)return Pe[0];const $e=function(V,ue){let ye;for(let we=0,pe=Pe.length;we<pe;we++){const De=Pe[we](V,ue);if(typeof De=="string")return De;(0,M.$Gg)(De)&&(ye||(ye=[]),ye.push(De))}return ye?(async()=>{for(const we of ye){const pe=await we;if(typeof pe=="string")return pe}return null})():null},x=Pe.find(V=>!!V.allBasenames);x&&($e.allBasenames=x.allBasenames);const z=Pe.reduce((V,ue)=>ue.allPaths?V.concat(ue.allPaths):V,[]);return z.length&&($e.allPaths=z),$e}const me=function($e,x,z){let V,ue;for(let ye=0,we=Pe.length;ye<we;ye++){const pe=Pe[ye];pe.requiresSiblings&&z&&(x||(x=(0,A.$nc)($e)),V||(V=x.substr(0,x.length-(0,A.$oc)($e).length)));const De=pe($e,x,V,z);if(typeof De=="string")return De;(0,M.$Gg)(De)&&(ue||(ue=[]),ue.push(De))}return ue?(async()=>{for(const ye of ue){const we=await ye;if(typeof we=="string")return we}return null})():null},ce=Pe.find($e=>!!$e.allBasenames);ce&&(me.allBasenames=ce.allBasenames);const se=Pe.reduce(($e,x)=>x.allPaths?$e.concat(x.allPaths):$e,[]);return se.length&&(me.allPaths=se),me}function N(Ee,Se,Pe){if(Se===!1)return s;const ge=o(Ee,Pe);if(ge===s)return s;if(typeof Se=="boolean")return ge;if(Se){const me=Se.when;if(typeof me=="string"){const ce=(se,$e,x,z)=>{if(!z||!ge(se,$e))return null;const V=me.replace("$(basename)",()=>x),ue=z(V);return(0,M.$Gg)(ue)?ue.then(ye=>ye?Ee:null):ue?Ee:null};return ce.requiresSiblings=!0,ce}}return ge}function te(Ee,Se){const Pe=Ee.filter($e=>!!$e.basenames);if(Pe.length<2)return Ee;const ge=Pe.reduce(($e,x)=>{const z=x.basenames;return z?$e.concat(z):$e},[]);let me;if(Se){me=[];for(let $e=0,x=ge.length;$e<x;$e++)me.push(Se)}else me=Pe.reduce(($e,x)=>{const z=x.patterns;return z?$e.concat(z):$e},[]);const ce=function($e,x){if(typeof $e!="string")return null;if(!x){let V;for(V=$e.length;V>0;V--){const ue=$e.charCodeAt(V-1);if(ue===47||ue===92)break}x=$e.substr(V)}const z=ge.indexOf(x);return z!==-1?me[z]:null};ce.basenames=ge,ce.patterns=me,ce.allBasenames=ge;const se=Ee.filter($e=>!$e.basenames);return se.push(ce),se}function Y(Ee,Se){return(0,y.$ub)(Ee,Se,(Pe,ge)=>typeof Pe=="string"&&typeof ge=="string"?Pe===ge:typeof Pe!="string"&&typeof ge!="string"?Pe.base===ge.base&&Pe.pattern===ge.pattern:!1)}e.$zj=Y}),define(Ae[50],Re([1,0,9,121,23,16,2]),function(be,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.MarkdownStringTextNewlineStyle=void 0;var l;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(l||(e.MarkdownStringTextNewlineStyle=l={}));class D{constructor(i="",c=!1){if(this.value=i,typeof this.value!="string")throw(0,y.$7)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(i,c=0){return this.value+=a(this.supportThemeIcons?(0,M.$Vj)(i):i).replace(/([ \t]+)/g,(b,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,c){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(i,c,b){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(i),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(i,c){const b=new RegExp((0,T.$Fe)(c),"g");return i.replace(b,(E,v)=>i.charAt(v-1)!=="\\"?`\\${E}`:E)}}e.$2j=D;function g(t){return R(t)?!t.value:Array.isArray(t)?t.every(g):!0}e.$3j=g;function R(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$4j=R;function k(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,C.$og)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$5j=k;function a(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$6j=a;function p(t){return t.replace(/"/g,"&quot;")}e.$7j=p;function $(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$8j=$;function f(t){const i=[],c=t.split("|").map(E=>E.trim());t=c[0];const b=c[1];if(b){const E=/height=(\d+)/.exec(b),v=/width=(\d+)/.exec(b),n=E?E[1]:"",r=v?v[1]:"",s=isFinite(parseInt(r)),o=isFinite(parseInt(n));s&&i.push(`width="${r}"`),o&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.$9j=f}),define(Ae[90],Re([1,0,18,43,19,22,23,16]),function(be,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=void 0;function D(o,w){const{os:h,tildify:I,relative:S}=w;if(S){const d=g(o,S,h);if(typeof d=="string")return d}let u=o.fsPath;if(h===1&&!T.$j?u=u.replace(/\//g,"\\"):h!==1&&T.$j&&(u=u.replace(/\\/g,"/")),h!==1&&I?.userHome){const d=I.userHome.fsPath;let P;o.scheme!==I.userHome.scheme&&o.path.startsWith(C.$gc.sep)?P=I.userHome.with({path:o.path}).fsPath:P=o.fsPath,u=a(P,d,h)}return(h===1?C.$fc:C.$gc).normalize(R(u,h===1))}e.$nv=D;function g(o,w,h){const I=h===1?C.$fc:C.$gc,S=h===3?A.$lg:A.$ng,u=w.getWorkspace(),m=(0,y.$Ob)(u.folders);if(!m)return;o.scheme!==m.uri.scheme&&o.path.startsWith(C.$gc.sep)&&(o=m.uri.with({path:o.path}));const d=w.getWorkspaceFolder(o);if(!d)return;let P;if(S.isEqual(d.uri,o)?P="":P=S.relativePath(d.uri,o)??"",P&&(P=I.normalize(P)),u.folders.length>1&&!w.noPrefix){const W=d.name?d.name:S.basenameOrAuthority(d.uri);P=P?`${W} \u2022 ${P}`:W}return P}function R(o,w=T.$j){return(0,M.$2f)(o,w)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$ov=R;let k=Object.create(null);function a(o,w,h=T.OS){if(h===1||!o||!w)return o;let I=k.original===w?k.normalized:void 0;I||(I=w,T.$j&&(I=(0,M.$Rf)(I)),I=`${(0,l.$Ke)(I,C.$gc.sep)}${C.$gc.sep}`,k={original:w,normalized:I});let S=o;return T.$j&&(S=(0,M.$Rf)(S)),(h===3?S.startsWith(I):(0,l.$3e)(S,I))?`~/${S.substr(I.length)}`:o}e.$pv=a;function p(o,w){return o.replace(/^~($|\/|\\)/,`${w}$1`)}e.$qv=p;const $="\u2026",f="\\\\",t="~";function i(o,w=C.sep){const h=new Array(o.length);let I=!1;for(let S=0;S<o.length;S++){const u=o[S];if(u===""){h[S]=`.${w}`;continue}if(!u){h[S]=u;continue}I=!0;let m="",d=u;d.indexOf(f)===0?(m=d.substr(0,d.indexOf(f)+f.length),d=d.substr(d.indexOf(f)+f.length)):d.indexOf(w)===0?(m=d.substr(0,d.indexOf(w)+w.length),d=d.substr(d.indexOf(w)+w.length)):d.indexOf(t)===0&&(m=d.substr(0,d.indexOf(t)+t.length),d=d.substr(d.indexOf(t)+t.length));const P=d.split(w);for(let W=1;I&&W<=P.length;W++)for(let K=P.length-W;I&&K>=0;K--){I=!1;let U=P.slice(K,K+W).join(w);for(let B=0;!I&&B<o.length;B++)if(B!==S&&o[B]&&o[B].indexOf(U)>-1){const O=K+W===P.length,N=K>0&&o[B].indexOf(w)>-1?w+U:U,te=o[B].endsWith(N);I=!O||te}if(!I){let B="";(P[0].endsWith(":")||m!=="")&&(K===1&&(K=0,W++,U=P[0]+w+U),K>0&&(B=P[0]+w),B=m+B),K>0&&(B=B+$+w),B=B+U,K+W<P.length&&(B=B+w+$),h[S]=B}}I&&(h[S]=u)}return h}e.$rv=i;var c;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function b(o,w=Object.create(null)){const h=[];let I=!1,S="";for(const u of o)if(u==="$"||I&&u==="{")S&&h.push({value:S,type:c.TEXT}),S="",I=!0;else if(u==="}"&&I){const m=w[S];if(typeof m=="string")m.length&&h.push({value:m,type:c.VARIABLE});else if(m){const d=h[h.length-1];(!d||d.type!==c.SEPARATOR)&&h.push({value:m.label,type:c.SEPARATOR})}S="",I=!1}else S+=u;return S&&!I&&h.push({value:S,type:c.TEXT}),h.filter((u,m)=>{if(u.type===c.SEPARATOR){const d=h[m-1],P=h[m+1];return[d,P].every(W=>W&&(W.type===c.VARIABLE||W.type===c.TEXT)&&W.value.length>0)}return!0}).map(u=>u.value).join("")}e.$sv=b;function E(o,w){return T.$k||w?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.$k?"&":"&&"):o.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$tv=E;function v(o,w){return T.$k||w?o.replace(/\(&&\w\)|&&/g,""):T.$j?o.replace(/&&|&/g,h=>h==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$uv=v;function n(o){return o.replace(/&/g,"&&")}e.$vv=n;function r(o){if(o.endsWith("]")){const w=o.lastIndexOf(" [",o.length-2);if(w!==-1){const h=s(o.substring(0,w));return{name:h.name,parentPath:h.parentPath+o.substring(w)}}}return s(o)}e.$wv=r;function s(o){const w=o.indexOf("/")!==-1?C.$gc:C.$fc,h=w.basename(o),I=w.dirname(o);return h.length?{name:h,parentPath:I}:{name:I,parentPath:""}}}),define(Ae[132],Re([1,0,26,2]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=void 0;function C(k){return k.toJSON()}class T{constructor(a){this.a=a}transformIncoming(a){const p=this.a.transformIncoming(a);return p===a?a:C(M.URI.from(p))}transformOutgoing(a){const p=this.a.transformOutgoing(a);return p===a?a:C(M.URI.from(p))}transformOutgoingURI(a){const p=this.a.transformOutgoing(a);return p===a?a:M.URI.from(p)}transformOutgoingScheme(a){return this.a.transformOutgoingScheme(a)}}e.$Jm=T,e.$Km=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function A(k,a,p){if(!k||p>200)return null;if(typeof k=="object"){if(k instanceof M.URI)return a.transformOutgoing(k);for(const $ in k)if(Object.hasOwnProperty.call(k,$)){const f=A(k[$],a,p+1);f!==null&&(k[$]=f)}}return null}function l(k,a){const p=A(k,a,0);return p===null?k:p}e.$Lm=l;function D(k,a,p,$){if(!k||$>200)return null;if(typeof k=="object"){if(k.$mid===1)return p?M.URI.revive(a.transformIncoming(k)):a.transformIncoming(k);if(k instanceof y.$be)return null;for(const f in k)if(Object.hasOwnProperty.call(k,f)){const t=D(k[f],a,p,$+1);t!==null&&(k[f]=t)}}return null}function g(k,a){const p=D(k,a,!1,0);return p===null?k:p}e.$Mm=g;function R(k,a){const p=D(k,a,!0,0);return p===null?k:p}e.$Nm=R}),define(Ae[133],Re([1,0,38,19]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oE=void 0;function C(T,A,l,D,g,R){if(Array.isArray(T)){let k=0;for(const a of T){const p=C(a,A,l,D,g,R);if(p===10)return p;p>k&&(k=p)}return k}else{if(typeof T=="string")return D?T==="*"?5:T===l?10:0:0;if(T){const{language:k,pattern:a,scheme:p,hasAccessToAllModels:$,notebookType:f}=T;if(!D&&!$)return 0;f&&g&&(A=g);let t=0;if(p)if(p===A.scheme)t=10;else if(p==="*")t=5;else return 0;if(k)if(k===l)t=10;else if(k==="*")t=Math.max(t,5);else return 0;if(f)if(f===R)t=10;else if(f==="*"&&R!==void 0)t=Math.max(t,5);else return 0;if(a){let i;if(typeof a=="string"?i=a:i={...a,base:(0,M.$hc)(a.base)},i===A.fsPath||(0,y.$uj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$oE=C}),define(Ae[91],Re([1,0,26,22]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T0=e.$S0=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function T(k){for(let a=0,p=k.length;a<p;a+=4){const $=k[a+0],f=k[a+1],t=k[a+2],i=k[a+3];k[a+0]=i,k[a+1]=t,k[a+2]=f,k[a+3]=$}}function A(k){const a=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return M.$D()||T(a),y.$be.wrap(a)}function l(k){const a=k.buffer;if(M.$D()||T(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const p=new Uint8Array(a.byteLength);return p.set(a),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function D(k){const a=new Uint32Array(g(k));let p=0;if(a[p++]=k.id,k.type==="full")a[p++]=1,a[p++]=k.data.length,a.set(k.data,p),p+=k.data.length;else{a[p++]=2,a[p++]=k.deltas.length;for(const $ of k.deltas)a[p++]=$.start,a[p++]=$.deleteCount,$.data?(a[p++]=$.data.length,a.set($.data,p),p+=$.data.length):a[p++]=0}return A(a)}e.$S0=D;function g(k){let a=0;if(a+=1+1,k.type==="full")a+=1+k.data.length;else{a+=1,a+=(1+1+1)*k.deltas.length;for(const p of k.deltas)p.data&&(a+=p.data.length)}return a}function R(k){const a=l(k);let p=0;const $=a[p++];if(a[p++]===1){const c=a[p++],b=a.subarray(p,p+c);return p+=c,{id:$,type:"full",data:b}}const t=a[p++],i=[];for(let c=0;c<t;c++){const b=a[p++],E=a[p++],v=a[p++];let n;v>0&&(n=a.subarray(p,p+v),p+=v),i[c]={start:b,deleteCount:E,data:n}}return{id:$,type:"delta",deltas:i}}e.$T0=R}),define(Ae[134],Re([10,11]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(Ae[135],Re([1,0,18,24,22,123,136,134]),function(be,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=g;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class k{constructor(X,ve,Be,Oe){this.id=X,this.name=ve,this.defaultValue=Be,this.schema=Oe}applyUpdate(X,ve){return p(X,ve)}compute(X,ve,Be){return Be}}class a{constructor(X,ve){this.newValue=X,this.didChange=ve}}e.ApplyUpdateResult=a;function p(Z,X){if(typeof Z!="object"||typeof X!="object"||!Z||!X)return new a(X,Z!==X);if(Array.isArray(Z)||Array.isArray(X)){const Be=Array.isArray(Z)&&Array.isArray(X)&&y.$ub(Z,X);return new a(X,!Be)}let ve=!1;for(const Be in X)if(X.hasOwnProperty(Be)){const Oe=p(Z[Be],X[Be]);Oe.didChange&&(Z[Be]=Oe.newValue,ve=!0)}return new a(Z,ve)}class ${constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,ve){return p(X,ve)}validate(X){return this.defaultValue}}class f{constructor(X,ve,Be,Oe){this.id=X,this.name=ve,this.defaultValue=Be,this.schema=Oe}applyUpdate(X,ve){return p(X,ve)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,ve,Be){return Be}}function t(Z,X){return typeof Z>"u"?X:Z==="false"?!1:!!Z}e.boolean=t;class i extends f{constructor(X,ve,Be,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=Be),super(X,ve,Be,Oe)}validate(X){return t(X,this.defaultValue)}}function c(Z,X,ve,Be){if(typeof Z>"u")return X;let Oe=parseInt(Z,10);return isNaN(Oe)?X:(Oe=Math.max(ve,Oe),Oe=Math.min(Be,Oe),Oe|0)}e.clampedInt=c;class b extends f{static clampedInt(X,ve,Be,Oe){return c(X,ve,Be,Oe)}constructor(X,ve,Be,Oe,Xe,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Be,nt.minimum=Oe,nt.maximum=Xe),super(X,ve,Be,nt),this.minimum=Oe,this.maximum=Xe}validate(X){return b.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function E(Z,X,ve,Be){if(typeof Z>"u")return X;const Oe=v.float(Z,X);return v.clamp(Oe,ve,Be)}e.clampedFloat=E;class v extends f{static clamp(X,ve,Be){return X<ve?ve:X>Be?Be:X}static float(X,ve){if(typeof X=="number")return X;if(typeof X>"u")return ve;const Be=parseFloat(X);return isNaN(Be)?ve:Be}constructor(X,ve,Be,Oe,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Be),super(X,ve,Be,Xe),this.validationFn=Oe}validate(X){return this.validationFn(v.float(X,this.defaultValue))}}class n extends f{static string(X,ve){return typeof X!="string"?ve:X}constructor(X,ve,Be,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=Be),super(X,ve,Be,Oe)}validate(X){return n.string(X,this.defaultValue)}}function r(Z,X,ve,Be){return typeof Z!="string"?X:Be&&Z in Be?Be[Z]:ve.indexOf(Z)===-1?X:Z}e.stringSet=r;class s extends f{constructor(X,ve,Be,Oe,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Oe,Xe.default=Be),super(X,ve,Be,Xe),this.c=Oe}validate(X){return r(X,this.defaultValue,this.c)}}class o extends k{constructor(X,ve,Be,Oe,Xe,nt,ft=void 0){typeof ft<"u"&&(ft.type="string",ft.enum=Xe,ft.default=Oe),super(X,ve,Be,ft),this.c=Xe,this.d=nt}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function w(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ve,Be){return Be===0?X.accessibilitySupport:Be}}class I extends k{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:l.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{insertSpace:t(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function u(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(m||(e.TextEditorCursorStyle=m={}));function d(Z){switch(Z){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function P(Z){switch(Z){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class W extends ${constructor(){super(140)}compute(X,ve,Be){const Oe=["monaco-editor"];return ve.get(39)&&Oe.push(ve.get(39)),X.extraEditorClassName&&Oe.push(X.extraEditorClassName),ve.get(73)==="default"?Oe.push("mouse-default"):ve.get(73)==="copy"&&Oe.push("mouse-copy"),ve.get(110)&&Oe.push("showUnused"),ve.get(138)&&Oe.push("showDeprecated"),Oe.join(" ")}}class K extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(X,ve,Be){return Be&&X.emptySelectionClipboard}}class U extends k{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:l.localize(16,null),included:C.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:l.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{cursorMoveOnType:t(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":r(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":r(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(ve.loop,this.defaultValue.loop)}}}class B extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?B.OFF:X==="true"?B.ON:X:X?B.ON:B.OFF}}e.EditorFontLigatures=B;class O extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?O.OFF:X==="true"?O.TRANSLATE:X:X?O.TRANSLATE:O.OFF}compute(X,ve,Be){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class N extends ${constructor(){super(50)}compute(X,ve,Be){return X.fontInfo}}class te extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(X){const ve=v.float(X,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(ve,6,100)}compute(X,ve,Be){return X.fontInfo.fontSize}}class Y extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.d,maximum:Y.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(b.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.d,Y.e))}}class Ee extends k{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...ve},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...ve},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Be,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Be,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Be,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Be,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Be,description:l.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{multiple:r(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??r(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??r(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??r(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??r(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??r(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Se extends k{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:l.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),delay:b.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:t(ve.sticky,this.defaultValue.sticky),hidingDelay:b.clampedInt(ve.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(ve.above,this.defaultValue.above)}}}var Pe;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class ge extends ${constructor(){super(143)}compute(X,ve,Be){return ge.computeLayout(ve,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const ve=X.height/X.lineHeight,Be=Math.floor(X.paddingTop/X.lineHeight);let Oe=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Oe=Math.max(Oe,ve-1));const Xe=(Be+X.viewLineCount+Oe)/(X.pixelRatio*X.height),nt=Math.floor(X.viewLineCount/Xe);return{typicalViewportLineCount:ve,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Oe,desiredRatio:Xe,minimapLineCount:nt}}static c(X,ve){const Be=X.outerWidth,Oe=X.outerHeight,Xe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const nt=ve.stableMinimapLayoutInput,ft=nt&&X.outerHeight===nt.outerHeight&&X.lineHeight===nt.lineHeight&&X.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&X.pixelRatio===nt.pixelRatio&&X.scrollBeyondLastLine===nt.scrollBeyondLastLine&&X.paddingTop===nt.paddingTop&&X.paddingBottom===nt.paddingBottom&&X.minimap.enabled===nt.minimap.enabled&&X.minimap.side===nt.minimap.side&&X.minimap.size===nt.minimap.size&&X.minimap.showSlider===nt.minimap.showSlider&&X.minimap.renderCharacters===nt.minimap.renderCharacters&&X.minimap.maxColumn===nt.minimap.maxColumn&&X.minimap.scale===nt.minimap.scale&&X.verticalScrollbarWidth===nt.verticalScrollbarWidth&&X.isViewportWrapping===nt.isViewportWrapping,wt=X.lineHeight,Pt=X.typicalHalfwidthCharacterWidth,Yt=X.scrollBeyondLastLine,Gt=X.minimap.renderCharacters;let pt=Xe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const jt=X.minimap.maxColumn,Nt=X.minimap.size,Bt=X.minimap.side,At=X.verticalScrollbarWidth,Rt=X.viewLineCount,Ot=X.remainingWidth,Wt=X.isViewportWrapping,Jt=Gt?2:3;let Kt=Math.floor(Xe*Oe);const Vt=Kt/Xe;let Mt=!1,ut=!1,ht=Jt*pt,Lt=pt/Xe,qt=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:fe,desiredRatio:G,minimapLineCount:Fe}=ge.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Yt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Oe,lineHeight:wt,pixelRatio:Xe});if(Rt/Fe>1)Mt=!0,ut=!0,pt=1,ht=1,Lt=pt/Xe;else{let Je=!1,Ve=pt+1;if(Nt==="fit"){const et=Math.ceil((Me+Rt+fe)*ht);Wt&&ft&&Ot<=ve.stableFitRemainingWidth?(Je=!0,Ve=ve.stableFitMaxMinimapScale):Je=et>Kt}if(Nt==="fill"||Je){Mt=!0;const et=pt;ht=Math.min(wt*Xe,Math.max(1,Math.floor(1/G))),Wt&&ft&&Ot<=ve.stableFitRemainingWidth&&(Ve=ve.stableFitMaxMinimapScale),pt=Math.min(Ve,Math.max(1,Math.floor(ht/Jt))),pt>et&&(qt=Math.min(2,pt/et)),Lt=pt/Xe/qt,Kt=Math.ceil(Math.max(Ce,Me+Rt+fe)*ht),Wt?(ve.stableMinimapLayoutInput=X,ve.stableFitRemainingWidth=Ot,ve.stableFitMaxMinimapScale=pt):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const kt=Math.floor(jt*Lt),at=Math.min(kt,Math.max(0,Math.floor((Ot-At-2)*Lt/(Pt+Lt)))+e.MINIMAP_GUTTER_WIDTH);let vt=Math.floor(Xe*at);const Ht=vt/Xe;vt=Math.floor(vt*qt);const Ct=Gt?1:2,We=Bt==="left"?0:Be-at-At;return{renderMinimap:Ct,minimapLeft:We,minimapWidth:at,minimapHeightIsEditorHeight:Mt,minimapIsSampling:ut,minimapScale:pt,minimapLineHeight:ht,minimapCanvasInnerWidth:vt,minimapCanvasInnerHeight:Kt,minimapCanvasOuterWidth:Ht,minimapCanvasOuterHeight:Vt}}static computeLayout(X,ve){const Be=ve.outerWidth|0,Oe=ve.outerHeight|0,Xe=ve.lineHeight|0,nt=ve.lineNumbersDigitCount|0,ft=ve.typicalHalfwidthCharacterWidth,wt=ve.maxDigitWidth,Pt=ve.pixelRatio,Yt=ve.viewLineCount,Gt=X.get(135),pt=Gt==="inherit"?X.get(134):Gt,jt=pt==="inherit"?X.get(130):pt,Nt=X.get(133),Bt=ve.isDominatedByLongLines,At=X.get(57),Rt=X.get(67).renderType!==0,Ot=X.get(68),Wt=X.get(104),Jt=X.get(83),Kt=X.get(72),Vt=X.get(102),Mt=Vt.verticalScrollbarSize,ut=Vt.verticalHasArrows,ht=Vt.arrowSize,Lt=Vt.horizontalScrollbarSize,qt=X.get(43),kt=X.get(109)!=="never";let at=X.get(65);qt&&kt&&(at+=16);let vt=0;if(Rt){const zt=Math.max(nt,Ot);vt=Math.round(zt*wt)}let Ht=0;At&&(Ht=Xe*ve.glyphMarginDecorationLaneCount);let Ct=0,We=Ct+Ht,Ce=We+vt,Me=Ce+at;const fe=Be-Ht-vt-at;let G=!1,Fe=!1,je=-1;pt==="inherit"&&Bt?(G=!0,Fe=!0):jt==="on"||jt==="bounded"?Fe=!0:jt==="wordWrapColumn"&&(je=Nt);const Je=ge.c({outerWidth:Be,outerHeight:Oe,lineHeight:Xe,typicalHalfwidthCharacterWidth:ft,pixelRatio:Pt,scrollBeyondLastLine:Wt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Kt,verticalScrollbarWidth:Mt,viewLineCount:Yt,remainingWidth:fe,isViewportWrapping:Fe},ve.memory||new R);Je.renderMinimap!==0&&Je.minimapLeft===0&&(Ct+=Je.minimapWidth,We+=Je.minimapWidth,Ce+=Je.minimapWidth,Me+=Je.minimapWidth);const Ve=fe-Je.minimapWidth,et=Math.max(1,Math.floor((Ve-Mt-2)/ft)),bt=ut?ht:0;return Fe&&(je=Math.max(1,et),jt==="bounded"&&(je=Math.min(je,Nt))),{width:Be,height:Oe,glyphMarginLeft:Ct,glyphMarginWidth:Ht,glyphMarginDecorationLaneCount:ve.glyphMarginDecorationLaneCount,lineNumbersLeft:We,lineNumbersWidth:vt,decorationsLeft:Ce,decorationsWidth:at,contentLeft:Me,contentWidth:Ve,minimap:Je,viewportColumn:et,isWordWrapMinified:G,isViewportWrapping:Fe,wrappingColumn:je,verticalScrollbarWidth:Mt,horizontalScrollbarHeight:Lt,overviewRuler:{top:bt,width:Mt,height:Oe-2*bt,right:0}}}}e.EditorLayoutInfoComputer=ge;class me extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(X){return r(X,"simple",["simple","advanced"])}compute(X,ve,Be){return ve.get(2)===2?"advanced":Be}}class ce extends k{constructor(){const X={enabled:!0};super(64,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:l.localize(50,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:t(X.enabled,this.defaultValue.enabled)}}}class se extends k{constructor(){const X={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:l.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:l.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:l.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:l.localize(54,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(ve.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(ve.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(ve.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class $e extends k{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:l.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(56,null),l.localize(57,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),l.localize(58,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),l.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:l.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:l.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:l.localize(62,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return typeof ve.enabled=="boolean"&&(ve.enabled=ve.enabled?"on":"off"),{enabled:r(ve.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(ve.fontFamily,this.defaultValue.fontFamily),padding:t(ve.padding,this.defaultValue.padding)}}}class x extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):b.clampedInt(X,this.defaultValue,0,1e3)}compute(X,ve,Be){return Be<0?b.clampedInt(-Be*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class z extends v{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>v.clamp(X,0,150),{markdownDescription:l.localize(63,null)})}compute(X,ve,Be){return X.fontInfo.lineHeight}}class V extends k{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:l.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:l.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(66,null),l.localize(67,null),l.localize(68,null)],default:X.size,description:l.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:l.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:l.localize(71,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:l.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:l.localize(74,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),autohide:t(ve.autohide,this.defaultValue.autohide),size:r(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(ve.side,this.defaultValue.side,["right","left"]),showSlider:r(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(ve.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(ve.scale,1,1,3),maxColumn:b.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ue(Z){return Z==="ctrlCmd"?C.$k?"metaKey":"ctrlKey":"altKey"}class ye extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(76,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{top:b.clampedInt(ve.top,0,0,1e3),bottom:b.clampedInt(ve.bottom,0,0,1e3)}}}class we extends k{constructor(){const X={enabled:!0,cycle:!0};super(85,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:l.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:l.localize(78,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),cycle:t(ve.cycle,this.defaultValue.cycle)}}}class pe extends ${constructor(){super(141)}compute(X,ve,Be){return X.pixelRatio}}class De extends k{constructor(){const X={other:"on",comments:"off",strings:"off"},ve=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(79,null),l.localize(80,null),l.localize(81,null)]}];super(88,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ve,default:X.strings,description:l.localize(82,null)},comments:{anyOf:ve,default:X.comments,description:l.localize(83,null)},other:{anyOf:ve,default:X.other,description:l.localize(84,null)}},default:X,markdownDescription:l.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Pt=X?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!X||typeof X!="object")return this.defaultValue;const{other:ve,comments:Be,strings:Oe}=X,Xe=["on","inline","off"];let nt,ft,wt;return typeof ve=="boolean"?nt=ve?"on":"off":nt=r(ve,this.defaultValue.other,Xe),typeof Be=="boolean"?ft=Be?"on":"off":ft=r(Be,this.defaultValue.comments,Xe),typeof Oe=="boolean"?wt=Oe?"on":"off":wt=r(Oe,this.defaultValue.strings,Xe),{other:nt,comments:ft,strings:wt}}}var ne;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(ne||(e.RenderLineNumbersType=ne={}));class le extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null),l.localize(89,null)],default:"on",description:l.localize(90,null)})}validate(X){let ve=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(ve=4,Be=X):X==="interval"?ve=3:X==="relative"?ve=2:X==="on"?ve=1:ve=0),{renderType:ve,renderFn:Be}}}function re(Z){const X=Z.get(97);return X==="editable"?Z.get(90):X!=="on"}e.filterValidationDecorations=re;class oe extends k{constructor(){const X=[],ve={type:"number",description:l.localize(91,null)};super(101,"rulers",X,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:l.localize(92,null),format:"color-hex"}}}]},default:X,description:l.localize(93,null)})}validate(X){if(Array.isArray(X)){const ve=[];for(const Be of X)if(typeof Be=="number")ve.push({column:b.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Oe=Be;ve.push({column:b.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return ve.sort((Be,Oe)=>Be.column-Oe.column),ve}return this.defaultValue}}class he extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Ie(Z,X){if(typeof Z!="string")return X;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends k{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"auto",description:l.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(98,null),l.localize(99,null),l.localize(100,null)],default:"auto",description:l.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:l.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:l.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:l.localize(104,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X,Be=b.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=b.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(ve.vertical,this.defaultValue.vertical),horizontal:Ie(ve.horizontal,this.defaultValue.horizontal),useShadows:t(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:b.clampedInt(ve.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:b.clampedInt(ve.verticalSliderSize,Oe,0,1e3),scrollByPage:t(ve.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends k{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:l.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:l.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:l.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:l.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:l.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:l.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:l.localize(111,null)}})}applyUpdate(X,ve){let Be=!1;ve.allowedCharacters&&X&&(M.$8m(X.allowedCharacters,ve.allowedCharacters)||(X={...X,allowedCharacters:ve.allowedCharacters},Be=!0)),ve.allowedLocales&&X&&(M.$8m(X.allowedLocales,ve.allowedLocales)||(X={...X,allowedLocales:ve.allowedLocales},Be=!0));const Oe=super.applyUpdate(X,ve);return Be?new a(Oe.newValue,!0):Oe}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{nonBasicASCII:_(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,ve){if(typeof X!="object"||!X)return ve;const Be={};for(const[Oe,Xe]of Object.entries(X))Xe===!0&&(Be[Oe]=!0);return Be}}class J extends k{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:l.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[l.localize(113,null),l.localize(114,null)],description:l.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:l.localize(116,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),mode:r(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(ve.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(ve.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Q extends k{constructor(){const X={enabled:T.$1r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$1r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:l.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:l.localize(118,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(ve.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends k{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(119,null),l.localize(120,null),l.localize(121,null)],default:X.bracketPairs,description:l.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(123,null),l.localize(124,null),l.localize(125,null)],default:X.bracketPairsHorizontal,description:l.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:l.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:l.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(129,null),l.localize(130,null),l.localize(131,null)],default:X.highlightActiveIndentation,description:l.localize(132,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{bracketPairs:_(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:_(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _(Z,X,ve){const Be=ve.indexOf(Z);return Be===-1?X:ve[Be]}class ae extends k{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(133,null),l.localize(134,null)],default:X.insertMode,description:l.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:l.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:l.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:l.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(139,null),l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:X.selectionMode,markdownDescription:l.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:l.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:l.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:l.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:l.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:l.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{insertMode:r(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(ve.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(ve.showIcons,this.defaultValue.showIcons),showStatusBar:t(ve.showStatusBar,this.defaultValue.showStatusBar),preview:t(ve.preview,this.defaultValue.preview),previewMode:r(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(ve.showMethods,this.defaultValue.showMethods),showFunctions:t(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:t(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(ve.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(ve.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(ve.showFields,this.defaultValue.showFields),showVariables:t(ve.showVariables,this.defaultValue.showVariables),showClasses:t(ve.showClasses,this.defaultValue.showClasses),showStructs:t(ve.showStructs,this.defaultValue.showStructs),showInterfaces:t(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:t(ve.showModules,this.defaultValue.showModules),showProperties:t(ve.showProperties,this.defaultValue.showProperties),showEvents:t(ve.showEvents,this.defaultValue.showEvents),showOperators:t(ve.showOperators,this.defaultValue.showOperators),showUnits:t(ve.showUnits,this.defaultValue.showUnits),showValues:t(ve.showValues,this.defaultValue.showValues),showConstants:t(ve.showConstants,this.defaultValue.showConstants),showEnums:t(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:t(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(ve.showKeywords,this.defaultValue.showKeywords),showWords:t(ve.showWords,this.defaultValue.showWords),showColors:t(ve.showColors,this.defaultValue.showColors),showFiles:t(ve.showFiles,this.defaultValue.showFiles),showReferences:t(ve.showReferences,this.defaultValue.showReferences),showFolders:t(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:t(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(ve.showSnippets,this.defaultValue.showSnippets),showUsers:t(ve.showUsers,this.defaultValue.showUsers),showIssues:t(ve.showIssues,this.defaultValue.showIssues)}}}class Ne extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(182,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(X.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Qe extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(183,null),l.localize(184,null),l.localize(185,null),l.localize(186,null)],description:l.localize(187,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,ve,Be){return ve.get(2)===2?0:Be}}class Ge extends ${constructor(){super(144)}compute(X,ve,Be){const Oe=ve.get(143);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class _e extends k{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:l.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(190,null),l.localize(191,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),showDropSelector:r(ve.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ze extends k{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:l.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(194,null),l.localize(195,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:t(ve.enabled,this.defaultValue.enabled),showPasteSelector:r(ve.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const xe="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$k?it:C.$l?tt:xe,fontWeight:"normal",fontSize:C.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var st;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.letterSpacing=63]="letterSpacing",Z[Z.lightbulb=64]="lightbulb",Z[Z.lineDecorationsWidth=65]="lineDecorationsWidth",Z[Z.lineHeight=66]="lineHeight",Z[Z.lineNumbers=67]="lineNumbers",Z[Z.lineNumbersMinChars=68]="lineNumbersMinChars",Z[Z.linkedEditing=69]="linkedEditing",Z[Z.links=70]="links",Z[Z.matchBrackets=71]="matchBrackets",Z[Z.minimap=72]="minimap",Z[Z.mouseStyle=73]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=75]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=77]="multiCursorModifier",Z[Z.multiCursorPaste=78]="multiCursorPaste",Z[Z.multiCursorLimit=79]="multiCursorLimit",Z[Z.occurrencesHighlight=80]="occurrencesHighlight",Z[Z.overviewRulerBorder=81]="overviewRulerBorder",Z[Z.overviewRulerLanes=82]="overviewRulerLanes",Z[Z.padding=83]="padding",Z[Z.pasteAs=84]="pasteAs",Z[Z.parameterHints=85]="parameterHints",Z[Z.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=88]="quickSuggestions",Z[Z.quickSuggestionsDelay=89]="quickSuggestionsDelay",Z[Z.readOnly=90]="readOnly",Z[Z.readOnlyMessage=91]="readOnlyMessage",Z[Z.renameOnType=92]="renameOnType",Z[Z.renderControlCharacters=93]="renderControlCharacters",Z[Z.renderFinalNewline=94]="renderFinalNewline",Z[Z.renderLineHighlight=95]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=97]="renderValidationDecorations",Z[Z.renderWhitespace=98]="renderWhitespace",Z[Z.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Z[Z.roundedSelection=100]="roundedSelection",Z[Z.rulers=101]="rulers",Z[Z.scrollbar=102]="scrollbar",Z[Z.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=104]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=105]="scrollPredominantAxis",Z[Z.selectionClipboard=106]="selectionClipboard",Z[Z.selectionHighlight=107]="selectionHighlight",Z[Z.selectOnLineNumbers=108]="selectOnLineNumbers",Z[Z.showFoldingControls=109]="showFoldingControls",Z[Z.showUnused=110]="showUnused",Z[Z.snippetSuggestions=111]="snippetSuggestions",Z[Z.smartSelect=112]="smartSelect",Z[Z.smoothScrolling=113]="smoothScrolling",Z[Z.stickyScroll=114]="stickyScroll",Z[Z.stickyTabStops=115]="stickyTabStops",Z[Z.stopRenderingLineAfter=116]="stopRenderingLineAfter",Z[Z.suggest=117]="suggest",Z[Z.suggestFontSize=118]="suggestFontSize",Z[Z.suggestLineHeight=119]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Z[Z.suggestSelection=121]="suggestSelection",Z[Z.tabCompletion=122]="tabCompletion",Z[Z.tabIndex=123]="tabIndex",Z[Z.unicodeHighlighting=124]="unicodeHighlighting",Z[Z.unusualLineTerminators=125]="unusualLineTerminators",Z[Z.useShadowDOM=126]="useShadowDOM",Z[Z.useTabStops=127]="useTabStops",Z[Z.wordBreak=128]="wordBreak",Z[Z.wordSeparators=129]="wordSeparators",Z[Z.wordWrap=130]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=133]="wordWrapColumn",Z[Z.wordWrapOverride1=134]="wordWrapOverride1",Z[Z.wordWrapOverride2=135]="wordWrapOverride2",Z[Z.wrappingIndent=136]="wrappingIndent",Z[Z.wrappingStrategy=137]="wrappingStrategy",Z[Z.showDeprecated=138]="showDeprecated",Z[Z.inlayHints=139]="inlayHints",Z[Z.editorClassName=140]="editorClassName",Z[Z.pixelRatio=141]="pixelRatio",Z[Z.tabFocusMode=142]="tabFocusMode",Z[Z.layoutInfo=143]="layoutInfo",Z[Z.wrappingInfo=144]="wrappingInfo",Z[Z.defaultColorDecorators=145]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(196,null)})),acceptSuggestionOnEnter:ze(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(197,null),""],markdownDescription:l.localize(198,null)})),accessibilitySupport:ze(new h),accessibilityPageSize:ze(new b(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(199,null),tags:["accessibility"]})),ariaLabel:ze(new n(4,"ariaLabel",l.localize(200,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:ze(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(202,null),l.localize(203,null),""],description:l.localize(204,null)})),autoClosingComments:ze(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(205,null),l.localize(206,null),""],description:l.localize(207,null)})),autoClosingDelete:ze(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(208,null),""],description:l.localize(209,null)})),autoClosingOvertype:ze(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(210,null),""],description:l.localize(211,null)})),autoClosingQuotes:ze(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(212,null),l.localize(213,null),""],description:l.localize(214,null)})),autoIndent:ze(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[l.localize(215,null),l.localize(216,null),l.localize(217,null),l.localize(218,null),l.localize(219,null)],description:l.localize(220,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(221,null),l.localize(222,null),l.localize(223,null),""],description:l.localize(224,null)})),bracketPairColorization:ze(new Q),bracketPairGuides:ze(new H),stickyTabStops:ze(new i(115,"stickyTabStops",!1,{description:l.localize(225,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:l.localize(226,null)})),codeLensFontFamily:ze(new n(18,"codeLensFontFamily","",{description:l.localize(227,null)})),codeLensFontSize:ze(new b(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(228,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:l.localize(229,null)})),colorDecoratorActivatedOn:ze(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(230,null),l.localize(231,null),l.localize(232,null)],description:l.localize(233,null)})),colorDecoratorsLimit:ze(new b(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(234,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:l.localize(235,null)})),comments:ze(new I),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:l.localize(236,null)})),cursorBlinking:ze(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:l.localize(237,null)})),cursorSmoothCaretAnimation:ze(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(238,null),l.localize(239,null),l.localize(240,null)],description:l.localize(241,null)})),cursorStyle:ze(new o(28,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:l.localize(242,null)})),cursorSurroundingLines:ze(new b(29,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(243,null)})),cursorSurroundingLinesStyle:ze(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(244,null),l.localize(245,null)],markdownDescription:l.localize(246,null)})),cursorWidth:ze(new b(31,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(247,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:l.localize(248,null)})),emptySelectionClipboard:ze(new K),dropIntoEditor:ze(new _e),stickyScroll:ze(new se),experimentalWhitespaceRendering:ze(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),extraEditorClassName:ze(new n(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new v(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:l.localize(253,null)})),find:ze(new U),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:l.localize(254,null)})),foldingStrategy:ze(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(255,null),l.localize(256,null)],description:l.localize(257,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:l.localize(258,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:l.localize(259,null)})),foldingMaximumRegions:ze(new b(47,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(260,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(261,null)})),fontFamily:ze(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(262,null)})),fontInfo:ze(new N),fontLigatures2:ze(new B),fontSize:ze(new te),fontWeight:ze(new Y),fontVariations:ze(new O),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:l.localize(263,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:l.localize(264,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:l.localize(265,null)})),gotoLocation:ze(new Ee),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:l.localize(266,null)})),hover:ze(new Se),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new v(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>v.clamp(Z,-5,20),{description:l.localize(267,null)})),lightbulb:ze(new ce),lineDecorationsWidth:ze(new x),lineHeight:ze(new z),lineNumbers:ze(new le),lineNumbersMinChars:ze(new b(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:l.localize(268,null)})),links:ze(new i(70,"links",!0,{description:l.localize(269,null)})),matchBrackets:ze(new s(71,"matchBrackets","always",["always","near","never"],{description:l.localize(270,null)})),minimap:ze(new V),mouseStyle:ze(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new v(74,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:l.localize(271,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:l.localize(272,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:l.localize(273,null)})),multiCursorModifier:ze(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[l.localize(274,null),l.localize(275,null)],markdownDescription:l.localize(276,null)})),multiCursorPaste:ze(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(277,null),l.localize(278,null)],markdownDescription:l.localize(279,null)})),multiCursorLimit:ze(new b(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(280,null)})),occurrencesHighlight:ze(new i(80,"occurrencesHighlight",!0,{description:l.localize(281,null)})),overviewRulerBorder:ze(new i(81,"overviewRulerBorder",!0,{description:l.localize(282,null)})),overviewRulerLanes:ze(new b(82,"overviewRulerLanes",3,0,3)),padding:ze(new ye),pasteAs:ze(new Ze),parameterHints:ze(new we),peekWidgetDefaultFocus:ze(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(283,null),l.localize(284,null)],description:l.localize(285,null)})),definitionLinkOpensInPeek:ze(new i(87,"definitionLinkOpensInPeek",!1,{description:l.localize(286,null)})),quickSuggestions:ze(new De),quickSuggestionsDelay:ze(new b(89,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(287,null)})),readOnly:ze(new i(90,"readOnly",!1)),readOnlyMessage:ze(new he),renameOnType:ze(new i(92,"renameOnType",!1,{description:l.localize(288,null),markdownDeprecationMessage:l.localize(289,null)})),renderControlCharacters:ze(new i(93,"renderControlCharacters",!0,{description:l.localize(290,null),restricted:!0})),renderFinalNewline:ze(new s(94,"renderFinalNewline",C.$l?"dimmed":"on",["off","on","dimmed"],{description:l.localize(291,null)})),renderLineHighlight:ze(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(292,null)],description:l.localize(293,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(294,null)})),renderValidationDecorations:ze(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(295,null),l.localize(296,null),l.localize(297,null),""],description:l.localize(298,null)})),revealHorizontalRightPadding:ze(new b(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(100,"roundedSelection",!0,{description:l.localize(299,null)})),rulers:ze(new oe),scrollbar:ze(new F),scrollBeyondLastColumn:ze(new b(103,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(300,null)})),scrollBeyondLastLine:ze(new i(104,"scrollBeyondLastLine",!0,{description:l.localize(301,null)})),scrollPredominantAxis:ze(new i(105,"scrollPredominantAxis",!0,{description:l.localize(302,null)})),selectionClipboard:ze(new i(106,"selectionClipboard",!0,{description:l.localize(303,null),included:C.$l})),selectionHighlight:ze(new i(107,"selectionHighlight",!0,{description:l.localize(304,null)})),selectOnLineNumbers:ze(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(305,null),l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),showUnused:ze(new i(110,"showUnused",!0,{description:l.localize(309,null)})),showDeprecated:ze(new i(138,"showDeprecated",!0,{description:l.localize(310,null)})),inlayHints:ze(new $e),snippetSuggestions:ze(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(311,null),l.localize(312,null),l.localize(313,null),l.localize(314,null)],description:l.localize(315,null)})),smartSelect:ze(new Ne),smoothScrolling:ze(new i(113,"smoothScrolling",!1,{description:l.localize(316,null)})),stopRenderingLineAfter:ze(new b(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ae),inlineSuggest:ze(new J),inlineCompletionsAccessibilityVerbose:ze(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(317,null)})),suggestFontSize:ze(new b(118,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new b(119,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(120,"suggestOnTriggerCharacters",!0,{description:l.localize(320,null)})),suggestSelection:ze(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(321,null),l.localize(322,null),l.localize(323,null)],description:l.localize(324,null)})),tabCompletion:ze(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(325,null),l.localize(326,null),l.localize(327,null)],description:l.localize(328,null)})),tabIndex:ze(new b(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new q),unusualLineTerminators:ze(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(329,null),l.localize(330,null),l.localize(331,null)],description:l.localize(332,null)})),useShadowDOM:ze(new i(126,"useShadowDOM",!0)),useTabStops:ze(new i(127,"useTabStops",!0,{description:l.localize(333,null)})),wordBreak:ze(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(334,null),l.localize(335,null)],description:l.localize(336,null)})),wordSeparators:ze(new n(129,"wordSeparators",A.$2r,{description:l.localize(337,null)})),wordWrap:ze(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(338,null),l.localize(339,null),l.localize(340,null),l.localize(341,null)],description:l.localize(342,null)})),wordWrapBreakAfterCharacters:ze(new n(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new n(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new b(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(343,null)})),wordWrapOverride1:ze(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new W),defaultColorDecorators:ze(new i(145,"defaultColorDecorators",!1,{markdownDescription:l.localize(344,null)})),pixelRatio:ze(new pe),tabFocusMode:ze(new i(142,"tabFocusMode",!1,{markdownDescription:l.localize(345,null)})),layoutInfo:ze(new ge),wrappingInfo:ze(new Ge),wrappingIndent:ze(new Qe),wrappingStrategy:ze(new me)}}),define(Ae[137],Re([10,11]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[138],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[139],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[140],Re([10,11]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[141],Re([10,11]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[142],Re([10,11]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(Ae[143],Re([10,11]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(Ae[144],Re([10,11]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[145],Re([10,11]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(Ae[146],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[147],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[148],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[149],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[150],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[151],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[152],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[153],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[154],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[155],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[156],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[157],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[158],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[159],Re([10,11]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(Ae[160],Re([10,11]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(Ae[161],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[162],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[163],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[164],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[165],Re([10,11]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[166],Re([10,11]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[167],Re([10,11]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[168],Re([1,0,9,139]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.TokenType=void 0;var C;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(C||(e.TokenType=C={}));function T(...g){switch(g.length){case 1:return(0,M.localize)(0,null,g[0]);case 2:return(0,M.localize)(1,null,g[0],g[1]);case 3:return(0,M.localize)(2,null,g[0],g[1],g[2]);default:return}}const A=(0,M.localize)(3,null),l=(0,M.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(T("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(T("&&"));break;case 124:this.h(124)?this.k(16):this.l(T("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const k=this.d,a=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:a};this.g.push({offset:k,lexeme:a,additionalInfo:R}),this.f.push(p)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const k=this.c.substring(this.d,this.e),a=D.b.get(k);a?this.k(a):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,k=!1,a=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(l);return}const $=this.c.charCodeAt(R);if(k)k=!1;else if($===47&&!a){R++;break}else $===91?a=!0:$===92?k=!0:$===93&&(a=!1);R++}for(;R<this.c.length&&D.a.has(this.c.charCodeAt(R));)R++;this.e=R;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ji=D}),define(Ae[169],Re([1,0,23,29,141,278]),function(be,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function D(i){return i=i.trim(),i==="*"||A.test(i)}e.$Jo=D;function g(i){if(!D(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=i.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$Ko=g;function R(i){if(!i)return null;const c=i.majorBase,b=i.majorMustEqual,E=i.minorBase;let v=i.minorMustEqual;const n=i.patchBase;let r=i.patchMustEqual;i.hasCaret&&(c===0||(v=!1),r=!1);let s=0;if(i.preRelease){const o=l.exec(i.preRelease);if(o){const[,w,h,I]=o;s=Date.UTC(Number(w),Number(h)-1,Number(I))}}return{majorBase:c,majorMustEqual:b,minorBase:E,minorMustEqual:v,patchBase:n,patchMustEqual:r,isMinimum:i.hasGreaterEquals,notBefore:s}}e.$Lo=R;function k(i,c,b){let E;typeof i=="string"?E=R(g(i)):E=i;let v;c instanceof Date?v=c.getTime():typeof c=="string"&&(v=new Date(c).getTime());let n;if(typeof b=="string"?n=R(g(b)):n=b,!E||!n)return!1;const r=E.majorBase,s=E.minorBase,o=E.patchBase;let w=n.majorBase,h=n.minorBase,I=n.patchBase;const S=n.notBefore;let u=n.majorMustEqual,m=n.minorMustEqual,d=n.patchMustEqual;return n.isMinimum?r>w?!0:r<w?!1:s>h?!0:s<h||v&&v<S?!1:o>=I:(r===1&&w===0&&(!u||!m||!d)&&(w=1,h=0,I=0,u=!0,m=!1,d=!1),r<w?!1:r>w?!u:s<h?!1:s>h?!m:o<I?!1:o>I?!d:!(v&&v<S))}e.$Mo=k;function a(i,c,b,E,v){const n=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return n.push([M.default.Error,C.localize(0,null)]),n;if(typeof E.name!="string")return n.push([M.default.Error,C.localize(1,null,"name")]),n;if(typeof E.version!="string")return n.push([M.default.Error,C.localize(2,null,"version")]),n;if(!E.engines)return n.push([M.default.Error,C.localize(3,null,"engines")]),n;if(typeof E.engines.vscode!="string")return n.push([M.default.Error,C.localize(4,null,"engines.vscode")]),n;if(typeof E.extensionDependencies<"u"&&!t(E.extensionDependencies))return n.push([M.default.Error,C.localize(5,null,"extensionDependencies")]),n;if(typeof E.activationEvents<"u"){if(!t(E.activationEvents))return n.push([M.default.Error,C.localize(6,null,"activationEvents")]),n;if(typeof E.main>"u"&&typeof E.browser>"u")return n.push([M.default.Error,C.localize(7,null,"activationEvents","main","browser")]),n}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&n.push([M.default.Warning,C.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return n.push([M.default.Error,C.localize(9,null,"main")]),n;{const o=(0,y.$vg)(b,E.main);(0,y.$pg)(o,b)||n.push([M.default.Warning,C.localize(10,null,o.path,b.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return n.push([M.default.Error,C.localize(11,null,"browser")]),n;{const o=(0,y.$vg)(b,E.browser);(0,y.$pg)(o,b)||n.push([M.default.Warning,C.localize(12,null,o.path,b.path)])}}if(!T.valid(E.version))return n.push([M.default.Error,C.localize(13,null)]),n;const r=[];if(!p(i,c,E,v,r))for(const o of r)n.push([M.default.Error,o]);return n}e.$No=a;function p(i,c,b,E,v){return E||typeof b.main>"u"&&typeof b.browser>"u"?!0:f(i,c,b.engines.vscode,v)}e.$Oo=p;function $(i,c,b){return i==="*"||f(c,b,i)}e.$Po=$;function f(i,c,b,E=[]){const v=R(g(b));if(!v)return E.push(C.localize(14,null,b)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return E.push(C.localize(15,null,b)),!1}else if(!v.majorMustEqual)return E.push(C.localize(16,null,b)),!1;return k(i,c,v)?!0:(E.push(C.localize(17,null,i,b)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let c=0,b=i.length;c<b;c++)if(typeof i[c]!="string")return!1;return!0}}),define(Ae[69],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class y{constructor(C,T=[],A=!1){this.ctor=C,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.$Lh=y}),define(Ae[70],Re([1,0,69]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.InstantiationType=void 0;const M=[];var C;(function(l){l[l.Eager=0]="Eager",l[l.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function T(l,D,g){D instanceof y.$Lh||(D=new y.$Lh(D,[],!!g)),M.push([l,D])}e.$ur=T;function A(){return M}e.$vr=A}),define(Ae[170],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;class y{constructor(T,A){this.key=T,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$_p=y;class M{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const A of this.a.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const l=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(A);l.outgoing.set(D.key,D),D.incoming.set(l.key,l)}removeNode(T){const A=this.b(T);this.a.delete(A);for(const l of this.a.values())l.outgoing.delete(A),l.incoming.delete(A)}lookupOrInsertNode(T){const A=this.b(T);let l=this.a.get(A);return l||(l=new y(A,T),this.a.set(A,l)),l}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[A,l]of this.a)T.push(`${A}
	(-> incoming)[${[...l.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...l.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,A]of this.a){const l=new Set([T]),D=this.c(A,l);if(D)return D}}c(T,A){for(const[l,D]of T.outgoing){if(A.has(l))return[...A,l].join(" -> ");A.add(l);const g=this.c(D,A);if(g)return g;A.delete(l)}}}e.$aq=M}),define(Ae[4],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=e._util=void 0;var y;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function l(D){return D[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=l})(y||(e._util=y={})),e.$Nh=C("instantiationService");function M(A,l,D){l[y.DI_TARGET]===l?l[y.DI_DEPENDENCIES].push({id:A,index:D}):(l[y.DI_DEPENDENCIES]=[{id:A,index:D}],l[y.DI_TARGET]=l)}function C(A){if(y.serviceIds.has(A))return y.serviceIds.get(A);const l=function(D,g,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(l,D,R)};return l.toString=()=>A,y.serviceIds.set(A,l),l}e.$Oh=C;function T(A){return A}e.$Ph=T}),define(Ae[44],Re([1,0,15,2,4]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.ConfigurationTarget=e.$ki=e.$ji=e.$ii=void 0,e.$ii=(0,C.$Oh)("configurationService");function T(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof M.URI)}e.$ji=T;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof M.URI)}e.$ki=A;var l;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(l||(e.ConfigurationTarget=l={}));function D(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$li=D;function g(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$mi=g;function R(i,c){const b=Object.create(null);for(const E in i)k(b,E,i[E],c);return b}e.$ni=R;function k(i,c,b,E){const v=c.split("."),n=v.pop();let r=i;for(let s=0;s<v.length;s++){const o=v[s];let w=r[o];switch(typeof w){case"undefined":w=r[o]=Object.create(null);break;case"object":break;default:E(`Ignoring ${c} as ${v.slice(0,s+1).join(".")} is ${JSON.stringify(w)}`);return}r=w}if(typeof r=="object"&&r!==null)try{r[n]=b}catch{E(`Ignoring ${c} as ${v.join(".")} is ${JSON.stringify(r)}`)}else E(`Ignoring ${c} as ${v.join(".")} is ${JSON.stringify(r)}`)}e.$oi=k;function a(i,c){const b=c.split(".");p(i,b)}e.$pi=a;function p(i,c){const b=c.shift();if(c.length===0){delete i[b];return}if(Object.keys(i).indexOf(b)!==-1){const E=i[b];typeof E=="object"&&!Array.isArray(E)&&(p(E,c),Object.keys(E).length===0&&delete i[b])}}function $(i,c,b){function E(r,s){let o=r;for(const w of s){if(typeof o!="object"||o===null)return;o=o[w]}return o}const v=c.split("."),n=E(i,v);return typeof n>"u"?b:n}e.$qi=$;function f(i,c,b){Object.keys(c).forEach(E=>{E!=="__proto__"&&(E in i?y.$Af(i[E])&&y.$Af(c[E])?f(i[E],c[E],b):b&&(i[E]=c[E]):i[E]=c[E])})}e.$ri=f;function t(i){return i.replace(/[\[\]]/g,"")}e.$si=t}),define(Ae[32],Re([1,0,22,16,168,4,138,9]),function(be,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.ContextKeyExprType=e.$Ki=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",y.$k),D.set("isLinux",y.$l),D.set("isWindows",y.$j),D.set("isWeb",y.$p),D.set("isMacNative",y.$k&&!y.$p),D.set("isEdge",y.$H),D.set("isFirefox",y.$F),D.set("isChrome",y.$E),D.set("isSafari",y.$G);function g(x,z){if(D.get(x)!==void 0)throw(0,l.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(x,z)}e.$Ki=g;const R=Object.prototype.hasOwnProperty;var k;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const a={regexParsingWithErrorRecovery:!0},p=(0,A.localize)(0,null),$=(0,A.localize)(1,null),f=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),c=(0,A.localize)(5,null),b=(0,A.localize)(6,null),E=(0,A.localize)(7,null);class v{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=a){this.k=z,this.d=new C.$Ji,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const V=this.l();if(!this.E()){const ue=this.D(),ye=ue.type===17?c:void 0;throw this.h.push({message:i,offset:ue.offset,lexeme:C.$Ji.getLexeme(ue),additionalInfo:ye}),v.c}return V}catch(V){if(V!==v.c)throw V;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const V=this.o();z.push(V)}return z.length===1?z[0]:n.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const V=this.s();z.push(V)}return z.length===1?z[0]:n.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const V=this.l();return this.A(1,t),V?.negate()}case 17:return this.z(),P.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const V=this.l();return this.A(1,t),V}case 17:{const V=z.lexeme;if(this.z(),this.y(9)){const ye=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ye.type!==10)throw this.B("REGEX",ye);const we=ye.lexeme,pe=we.lastIndexOf("/"),De=pe===we.length-1?void 0:this.w(we.substring(pe+1));let ne;try{ne=new RegExp(we.substring(1,pe),De)}catch{throw this.B("REGEX",ye)}return N.create(V,ne)}switch(ye.type){case 10:case 19:{const we=[ye.lexeme];this.z();let pe=this.D(),De=0;for(let he=0;he<ye.lexeme.length;he++)ye.lexeme.charCodeAt(he)===40?De++:ye.lexeme.charCodeAt(he)===41&&De--;for(;!this.E()&&pe.type!==15&&pe.type!==16;){switch(pe.type){case 0:De++;break;case 1:De--;break;case 10:case 18:for(let he=0;he<pe.lexeme.length;he++)pe.lexeme.charCodeAt(he)===40?De++:ye.lexeme.charCodeAt(he)===41&&De--}if(De<0)break;we.push(C.$Ji.getLexeme(pe)),this.z(),pe=this.D()}const ne=we.join(""),le=ne.lastIndexOf("/"),re=le===ne.length-1?void 0:this.w(ne.substring(le+1));let oe;try{oe=new RegExp(ne.substring(1,le),re)}catch{throw this.B("REGEX",ye)}return n.regex(V,oe)}case 18:{const we=ye.lexeme;this.z();let pe=null;if(!(0,M.$Be)(we)){const De=we.indexOf("/"),ne=we.lastIndexOf("/");if(De!==ne&&De>=0){const le=we.slice(De+1,ne),re=we[ne+1]==="i"?"i":"";try{pe=new RegExp(le,re)}catch{throw this.B("REGEX",ye)}}}if(pe===null)throw this.B("REGEX",ye);return N.create(V,pe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,f);const ye=this.u();return n.notIn(V,ye)}switch(this.D().type){case 3:{this.z();const ye=this.u();if(this.x().type===18)return n.equals(V,ye);switch(ye){case"true":return n.has(V);case"false":return n.not(V);default:return n.equals(V,ye)}}case 4:{this.z();const ye=this.u();if(this.x().type===18)return n.notEquals(V,ye);switch(ye){case"true":return n.not(V);case"false":return n.has(V);default:return n.notEquals(V,ye)}}case 5:return this.z(),B.create(V,this.u());case 6:return this.z(),O.create(V,this.u());case 7:return this.z(),K.create(V,this.u());case 8:return this.z(),U.create(V,this.u());case 13:return this.z(),n.in(V,this.u());default:return n.has(V)}}case 20:throw this.h.push({message:b,offset:z.offset,lexeme:"",additionalInfo:E}),v.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,V){if(this.C(z))return this.z();throw this.B(V,this.D())}B(z,V,ue){const ye=(0,A.localize)(8,null,z,C.$Ji.getLexeme(V)),we=V.offset,pe=C.$Ji.getLexeme(V);return this.h.push({message:ye,offset:we,lexeme:pe,additionalInfo:ue}),v.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Li=v;class n{static false(){return w.INSTANCE}static true(){return h.INSTANCE}static has(z){return I.create(z)}static equals(z,V){return S.create(z,V)}static notEquals(z,V){return d.create(z,V)}static regex(z,V){return N.create(z,V)}static in(z,V){return u.create(z,V)}static notIn(z,V){return m.create(z,V)}static not(z){return P.create(z)}static and(...z){return Ee.create(z,null,!0)}static or(...z){return Se.create(z,null,!0)}static greater(z,V){return K.create(z,V)}static greaterEquals(z,V){return U.create(z,V)}static smaller(z,V){return B.create(z,V)}static smallerEquals(z,V){return O.create(z,V)}static{this.c=new v({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$Mi=n;function r(x){const z=new v({regexParsingWithErrorRecovery:!1});return x.map(V=>(z.parse(V),z.lexingErrors.length>0?z.lexingErrors.map(ue=>({errorMessage:ue.additionalInfo?(0,A.localize)(9,null,ue.additionalInfo):(0,A.localize)(10,null),offset:ue.offset,length:ue.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(ue=>({errorMessage:ue.additionalInfo?`${ue.message}. ${ue.additionalInfo}`:ue.message,offset:ue.offset,length:ue.lexeme.length})):[]))}e.$Ni=r;function s(x,z){const V=x?x.substituteConstants():void 0,ue=z?z.substituteConstants():void 0;return!V&&!ue?!0:!V||!ue?!1:V.equals(ue)}e.$Oi=s;function o(x,z){return x.cmp(z)}class w{static{this.INSTANCE=new w}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return h.INSTANCE}}e.$Pi=w;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return w.INSTANCE}}e.$Qi=h;class I{static create(z,V=null){const ue=D.get(z);return typeof ue=="boolean"?ue?h.INSTANCE:w.INSTANCE:new I(z,V)}constructor(z,V){this.key=z,this.c=V,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:ge(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=D.get(this.key);return typeof z=="boolean"?z?h.INSTANCE:w.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Ri=I;class S{static create(z,V,ue=null){if(typeof V=="boolean")return V?I.create(z,ue):P.create(z,ue);const ye=D.get(z);return typeof ye=="boolean"?V===(ye?"true":"false")?h.INSTANCE:w.INSTANCE:new S(z,V,ue)}constructor(z,V,ue){this.c=z,this.d=V,this.f=ue,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=D.get(this.c);if(typeof z=="boolean"){const V=z?"true":"false";return this.d===V?h.INSTANCE:w.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.$Si=S;class u{static create(z,V){return new u(z,V)}constructor(z,V){this.d=z,this.f=V,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:me(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const V=z.getValue(this.f),ue=z.getValue(this.d);return Array.isArray(V)?V.includes(ue):typeof ue=="string"&&typeof V=="object"&&V!==null?R.call(V,ue):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.$Ti=u;class m{static create(z,V){return new m(z,V)}constructor(z,V){this.d=z,this.f=V,this.type=11,this.c=u.create(z,V)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ui=m;class d{static create(z,V,ue=null){if(typeof V=="boolean")return V?P.create(z,ue):I.create(z,ue);const ye=D.get(z);return typeof ye=="boolean"?V===(ye?"true":"false")?w.INSTANCE:h.INSTANCE:new d(z,V,ue)}constructor(z,V,ue){this.c=z,this.d=V,this.f=ue,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=D.get(this.c);if(typeof z=="boolean"){const V=z?"true":"false";return this.d===V?w.INSTANCE:h.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Vi=d;class P{static create(z,V=null){const ue=D.get(z);return typeof ue=="boolean"?ue?w.INSTANCE:h.INSTANCE:new P(z,V)}constructor(z,V){this.c=z,this.d=V,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:ge(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=D.get(this.c);return typeof z=="boolean"?z?w.INSTANCE:h.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Wi=P;function W(x,z){if(typeof x=="string"){const V=parseFloat(x);isNaN(V)||(x=V)}return typeof x=="string"||typeof x=="number"?z(x):w.INSTANCE}class K{static create(z,V,ue=null){return W(V,ye=>new K(z,ye,ue))}constructor(z,V,ue){this.c=z,this.d=V,this.f=ue,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Xi=K;class U{static create(z,V,ue=null){return W(V,ye=>new U(z,ye,ue))}constructor(z,V,ue){this.c=z,this.d=V,this.f=ue,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Yi=U;class B{static create(z,V,ue=null){return W(V,ye=>new B(z,ye,ue))}constructor(z,V,ue){this.c=z,this.d=V,this.f=ue,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Zi=B;class O{static create(z,V,ue=null){return W(V,ye=>new O(z,ye,ue))}constructor(z,V,ue){this.c=z,this.d=V,this.f=ue,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$1i=O;class N{static create(z,V){return new N(z,V)}constructor(z,V){this.d=z,this.f=V,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const V=this.f?this.f.source:"",ue=z.f?z.f.source:"";return V<ue?-1:V>ue?1:0}equals(z){if(z.type===this.type){const V=this.f?this.f.source:"",ue=z.f?z.f.source:"";return this.d===z.d&&V===ue}return!1}substituteConstants(){return this}evaluate(z){const V=z.getValue(this.d);return this.f?this.f.test(V):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=te.create(this)),this.c}}e.$2i=N;class te{static create(z){return new te(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new te(this.c.map(z))}negate(){return this.c}}e.$3i=te;function Y(x){let z=null;for(let V=0,ue=x.length;V<ue;V++){const ye=x[V].substituteConstants();if(x[V]!==ye&&z===null){z=[];for(let we=0;we<V;we++)z[we]=x[we]}z!==null&&(z[V]=ye)}return z===null?x:z}class Ee{static create(z,V,ue){return Ee.d(z,V,ue)}constructor(z,V){this.expr=z,this.c=V,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let V=0,ue=this.expr.length;V<ue;V++){const ye=o(this.expr[V],z.expr[V]);if(ye!==0)return ye}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let V=0,ue=this.expr.length;V<ue;V++)if(!this.expr[V].equals(z.expr[V]))return!1;return!0}return!1}substituteConstants(){const z=Y(this.expr);return z===this.expr?this:Ee.create(z,this.c,!1)}evaluate(z){for(let V=0,ue=this.expr.length;V<ue;V++)if(!this.expr[V].evaluate(z))return!1;return!0}static d(z,V,ue){const ye=[];let we=!1;for(const pe of z)if(pe){if(pe.type===1){we=!0;continue}if(pe.type===0)return w.INSTANCE;if(pe.type===6){ye.push(...pe.expr);continue}ye.push(pe)}if(ye.length===0&&we)return h.INSTANCE;if(ye.length!==0){if(ye.length===1)return ye[0];ye.sort(o);for(let pe=1;pe<ye.length;pe++)ye[pe-1].equals(ye[pe])&&(ye.splice(pe,1),pe--);if(ye.length===1)return ye[0];for(;ye.length>1;){const pe=ye[ye.length-1];if(pe.type!==9)break;ye.pop();const De=ye.pop(),ne=ye.length===0,le=Se.create(pe.expr.map(re=>Ee.create([re,De],null,ue)),null,ne);le&&(ye.push(le),ye.sort(o))}if(ye.length===1)return ye[0];if(ue){for(let pe=0;pe<ye.length;pe++)for(let De=pe+1;De<ye.length;De++)if(ye[pe].negate().equals(ye[De]))return w.INSTANCE;if(ye.length===1)return ye[0]}return new Ee(ye,V)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const V of this.expr)z.push(...V.keys());return z}map(z){return new Ee(this.expr.map(V=>V.map(z)),null)}negate(){if(!this.c){const z=[];for(const V of this.expr)z.push(V.negate());this.c=Se.create(z,this,!0)}return this.c}}e.$4i=Ee;class Se{static create(z,V,ue){return Se.d(z,V,ue)}constructor(z,V){this.expr=z,this.c=V,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let V=0,ue=this.expr.length;V<ue;V++){const ye=o(this.expr[V],z.expr[V]);if(ye!==0)return ye}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let V=0,ue=this.expr.length;V<ue;V++)if(!this.expr[V].equals(z.expr[V]))return!1;return!0}return!1}substituteConstants(){const z=Y(this.expr);return z===this.expr?this:Se.create(z,this.c,!1)}evaluate(z){for(let V=0,ue=this.expr.length;V<ue;V++)if(this.expr[V].evaluate(z))return!0;return!1}static d(z,V,ue){let ye=[],we=!1;if(z){for(let pe=0,De=z.length;pe<De;pe++){const ne=z[pe];if(ne){if(ne.type===0){we=!0;continue}if(ne.type===1)return h.INSTANCE;if(ne.type===9){ye=ye.concat(ne.expr);continue}ye.push(ne)}}if(ye.length===0&&we)return w.INSTANCE;ye.sort(o)}if(ye.length!==0){if(ye.length===1)return ye[0];for(let pe=1;pe<ye.length;pe++)ye[pe-1].equals(ye[pe])&&(ye.splice(pe,1),pe--);if(ye.length===1)return ye[0];if(ue){for(let pe=0;pe<ye.length;pe++)for(let De=pe+1;De<ye.length;De++)if(ye[pe].negate().equals(ye[De]))return h.INSTANCE;if(ye.length===1)return ye[0]}return new Se(ye,V)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const V of this.expr)z.push(...V.keys());return z}map(z){return new Se(this.expr.map(V=>V.map(z)),null)}negate(){if(!this.c){const z=[];for(const V of this.expr)z.push(V.negate());for(;z.length>1;){const V=z.shift(),ue=z.shift(),ye=[];for(const we of $e(V))for(const pe of $e(ue))ye.push(Ee.create([we,pe],null,!1));z.unshift(Se.create(ye,null,!1))}this.c=Se.create(z,this,!0)}return this.c}}e.$5i=Se;class Pe extends I{static{this.d=[]}static all(){return Pe.d.values()}constructor(z,V,ue){super(z,null),this.f=V,typeof ue=="object"?Pe.d.push({...ue,key:z}):ue!==!0&&Pe.d.push({key:z,description:ue,type:V!=null?typeof V:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return S.create(this.key,z)}notEqualsTo(z){return d.create(this.key,z)}}e.$6i=Pe,e.$7i=(0,T.$Oh)("contextKeyService");function ge(x,z){return x<z?-1:x>z?1:0}function me(x,z,V,ue){return x<V?-1:x>V?1:z<ue?-1:z>ue?1:0}function ce(x,z){if(x.type===0||z.type===1)return!0;if(x.type===9)return z.type===9?se(x.expr,z.expr):!1;if(z.type===9){for(const V of z.expr)if(ce(x,V))return!0;return!1}if(x.type===6){if(z.type===6)return se(z.expr,x.expr);for(const V of x.expr)if(ce(V,z))return!0;return!1}return x.equals(z)}e.$8i=ce;function se(x,z){let V=0,ue=0;for(;V<x.length&&ue<z.length;){const ye=x[V].cmp(z[ue]);if(ye<0)return!1;ye===0&&V++,ue++}return V===x.length}function $e(x){return x.type===9?x.expr:[x]}}),define(Ae[171],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=void 0,e.$Vh=(0,y.$Oh)("environmentService"),e.$Wh=(0,y.$Ph)(e.$Vh)}),define(Ae[92],Re([1,0,140,4]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$8n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=void 0,e.$Un="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Vn=new RegExp(e.$Un),e.$Wn="__web_extension",e.$Xn="skipWalkthrough",e.$Yn="extensionsSync",e.$Zn="dependecyOrPackExtensionInstall";function C(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$1n=C;function T(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$2n=T;function A(c,b){switch(c){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$3n=A;function l(c,b){return b==="web"&&!c.includes("web")}e.$4n=l;function D(c,b,E){return l(b,E)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===E?!0:g(E).includes(c)}e.$5n=D;function g(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$6n=g;function R(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$7n=R;var k;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var a;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var p;(function(c){c.Install="install",c.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var $;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$8n=(0,M.$Oh)("extensionGalleryService");var f;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var t;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor(b,E){super(b),this.code=E,this.name=E}}e.$9n=i,e.$0n=(0,M.$Oh)("extensionManagementService"),e.$$n="extensionsIdentifiers/disabled",e.$_n="extensionsIdentifiers/enabled",e.$ao=(0,M.$Oh)("IGlobalExtensionEnablementService"),e.$bo=(0,M.$Oh)("IExtensionTipsService"),e.$co=(0,y.localize)(0,null),e.$do={value:e.$co,original:"Extensions"},e.$eo={value:(0,y.localize)(1,null),original:"Preferences"}}),define(Ae[39],Re([1,0,49,19,16,15,2,142,4,22,13,41]),function(be,e,y,M,C,T,A,l,D,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileKind=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileOperationResult=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileChangeType=e.$pk=e.FileOperation=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.FileSystemProviderErrorCode=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.FileSystemProviderCapabilities=e.$_j=e.FilePermission=e.FileType=e.$$j=e.$0j=void 0,e.$0j=(0,D.$Oh)("fileService");function a(ce){return ce.create===!0}e.$$j=a;var p;(function(ce){ce[ce.Unknown=0]="Unknown",ce[ce.File=1]="File",ce[ce.Directory=2]="Directory",ce[ce.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var $;(function(ce){ce[ce.Readonly=1]="Readonly",ce[ce.Locked=2]="Locked"})($||(e.FilePermission=$={}));function f(ce){const se=ce;return!!se&&typeof se.onDidChange=="function"}e.$_j=f;var t;(function(ce){ce[ce.None=0]="None",ce[ce.FileReadWrite=2]="FileReadWrite",ce[ce.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ce[ce.FileReadStream=16]="FileReadStream",ce[ce.FileFolderCopy=8]="FileFolderCopy",ce[ce.PathCaseSensitive=1024]="PathCaseSensitive",ce[ce.Readonly=2048]="Readonly",ce[ce.Trash=4096]="Trash",ce[ce.FileWriteUnlock=8192]="FileWriteUnlock",ce[ce.FileAtomicRead=16384]="FileAtomicRead",ce[ce.FileAtomicWrite=32768]="FileAtomicWrite",ce[ce.FileAtomicDelete=65536]="FileAtomicDelete",ce[ce.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(ce){return!!(ce.capabilities&2)}e.$ak=i;function c(ce){return!!(ce.capabilities&8)}e.$bk=c;function b(ce){return!!(ce.capabilities&131072)}e.$ck=b;function E(ce){return!!(ce.capabilities&4)}e.$dk=E;function v(ce){return!!(ce.capabilities&16)}e.$ek=v;function n(ce){return i(ce)?!!(ce.capabilities&16384):!1}e.$fk=n;function r(ce){return i(ce)?!!(ce.capabilities&32768):!1}e.$gk=r;function s(ce){return!!(ce.capabilities&65536)}e.$hk=s;function o(ce){return!!(ce.capabilities&2048)}e.$ik=o;var w;(function(ce){ce.FileExists="EntryExists",ce.FileNotFound="EntryNotFound",ce.FileNotADirectory="EntryNotADirectory",ce.FileIsADirectory="EntryIsADirectory",ce.FileExceedsStorageQuota="EntryExceedsStorageQuota",ce.FileTooLarge="EntryTooLarge",ce.FileWriteLocked="EntryWriteLocked",ce.NoPermissions="NoPermissions",ce.Unavailable="Unavailable",ce.Unknown="Unknown"})(w||(e.FileSystemProviderErrorCode=w={}));class h extends Error{static create(se,$e){const x=new h(se.toString(),$e);return u(x,$e),x}constructor(se,$e){super(se),this.code=$e}}e.$jk=h;function I(ce,se){return h.create(ce,se)}e.$kk=I;function S(ce){return ce||I((0,l.localize)(0,null),w.Unknown)}e.$lk=S;function u(ce,se){return ce.name=se?`${se} (FileSystemError)`:"FileSystemError",ce}e.$mk=u;function m(ce){if(!ce)return w.Unknown;if(ce instanceof h)return ce.code;const se=/^(.+) \(FileSystemError\)$/.exec(ce.name);if(!se)return w.Unknown;switch(se[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.$nk=m;function d(ce){if(ce instanceof O)return ce.fileOperationResult;switch(m(ce)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 9;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileTooLarge:return 7;default:return 10}}e.$ok=d;var P;(function(ce){ce[ce.CREATE=0]="CREATE",ce[ce.DELETE=1]="DELETE",ce[ce.MOVE=2]="MOVE",ce[ce.COPY=3]="COPY",ce[ce.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class W{constructor(se,$e,x){this.resource=se,this.operation=$e,this.target=x}isOperation(se){return this.operation===se}}e.$pk=W;var K;(function(ce){ce[ce.UPDATED=0]="UPDATED",ce[ce.ADDED=1]="ADDED",ce[ce.DELETED=2]="DELETED"})(K||(e.FileChangeType=K={}));class U{static{this.a=null}constructor(se,$e){this.c=$e,this.b=void 0,this.d=new k.$V(()=>{const x=y.$Uh.forUris(()=>this.c);return x.fill(this.rawAdded.map(z=>[z,!0])),x}),this.f=new k.$V(()=>{const x=y.$Uh.forUris(()=>this.c);return x.fill(this.rawUpdated.map(z=>[z,!0])),x}),this.g=new k.$V(()=>{const x=y.$Uh.forUris(()=>this.c);return x.fill(this.rawDeleted.map(z=>[z,!0])),x}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const x of se){switch(x.type){case 1:this.rawAdded.push(x.resource);break;case 0:this.rawUpdated.push(x.resource);break;case 2:this.rawDeleted.push(x.resource);break}this.b!==U.a&&(typeof x.cId=="number"?this.b===void 0?this.b=x.cId:this.b!==x.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(se,...$e){return this.h(se,{includeChildren:!1},...$e)}affects(se,...$e){return this.h(se,{includeChildren:!0},...$e)}h(se,$e,...x){if(!se)return!1;const z=x.length>0;return!!((!z||x.includes(1))&&(this.d.value.get(se)||$e.includeChildren&&this.d.value.findSuperstr(se))||(!z||x.includes(0))&&(this.f.value.get(se)||$e.includeChildren&&this.f.value.findSuperstr(se))||(!z||x.includes(2))&&(this.g.value.findSubstr(se)||$e.includeChildren&&this.g.value.findSuperstr(se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(se){return this.b===se}hasCorrelation(){return typeof this.b=="number"}}e.$qk=U;function B(ce,se,$e){return!ce||!se||ce===se||se.length>ce.length?!1:(se.charAt(se.length-1)!==M.sep&&(se+=M.sep),$e?(0,C.$3e)(ce,se):ce.indexOf(se)===0)}e.$rk=B;class O extends Error{constructor(se,$e,x){super(se),this.fileOperationResult=$e,this.options=x}}e.$sk=O;class N extends O{constructor(se,$e,x,z){super(se,$e,z),this.fileOperationResult=$e,this.size=x}}e.$tk=N;class te extends O{constructor(se,$e,x){super(se,2,x),this.stat=$e}}e.$uk=te;var Y;(function(ce){ce[ce.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ce[ce.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ce[ce.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ce[ce.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ce[ce.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ce[ce.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ce[ce.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ce[ce.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ce[ce.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ce[ce.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ce[ce.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$vk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$wk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$xk="files.associations",e.$yk="files.exclude",e.$zk="files.readonlyInclude",e.$Ak="files.readonlyExclude",e.$Bk="files.readonlyFromPermissions";var Ee;(function(ce){ce[ce.FILE=0]="FILE",ce[ce.FOLDER=1]="FOLDER",ce[ce.ROOT_FOLDER=2]="ROOT_FOLDER"})(Ee||(e.FileKind=Ee={})),e.$Ck="";function Se(ce){if(!(typeof ce.size!="number"||typeof ce.mtime!="number"))return ce.mtime.toString(29)+ce.size.toString(31)}e.$Dk=Se;async function Pe(ce,se){if(!se.hasProvider(A.URI.from({scheme:ce.scheme})))return new Promise($e=>{const x=se.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===ce.scheme&&z.added&&(x.dispose(),$e())})})}e.$Ek=Pe;class ge{static{this.KB=1024}static{this.MB=ge.KB*ge.KB}static{this.GB=ge.MB*ge.KB}static{this.TB=ge.GB*ge.KB}static formatSize(se){return(0,T.$Cf)(se)||(se=0),se<ge.KB?(0,l.localize)(1,null,se.toFixed(0)):se<ge.MB?(0,l.localize)(2,null,(se/ge.KB).toFixed(2)):se<ge.GB?(0,l.localize)(3,null,(se/ge.MB).toFixed(2)):se<ge.TB?(0,l.localize)(4,null,(se/ge.GB).toFixed(2)):(0,l.localize)(5,null,(se/ge.TB).toFixed(2))}}e.$Fk=ge;function me(ce){const se=typeof ce=="string"||ce?.scheme===R.Schemas.vscodeRemote;return typeof ce!="string"&&ce?.scheme===R.Schemas.file?1024*ge.MB:se?10*ge.MB:g.$p?50*ge.MB:1024*ge.MB}e.$Gk=me}),define(Ae[71],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=void 0;class y{constructor(...C){this.a=new Map;for(const[T,A]of C)this.set(T,A)}set(C,T){const A=this.a.get(C);return this.a.set(C,T),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Mh=y}),define(Ae[172],Re([1,0,12,9,6,69,170,4,71,173]),function(be,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;const R=!1;class k extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class a{constructor(t=new D.$Mh,i=!1,c,b=R){this.f=t,this.g=i,this.h=c,this.i=b,this.o=new Set,this.f.set(l.$Nh,this),this._globalGraph=b?c?._globalGraph??new A.$aq(E=>E):void 0}createChild(t){return new a(t,this.g,this,this.i)}invokeFunction(t,...i){const c=$.traceInvocation(this.i,t);let b=!1;try{return t({get:v=>{if(b)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const n=this.m(v,c);if(!n)throw new Error(`[invokeFunction] unknown service '${v}'`);return n}},...i)}finally{b=!0,c.stop()}}createInstance(t,...i){let c,b;return t instanceof T.$Lh?(c=$.traceCreation(this.i,t.ctor),b=this.j(t.ctor,t.staticArguments.concat(i),c)):(c=$.traceCreation(this.i,t),b=this.j(t,i,c)),c.stop(),b}j(t,i=[],c){const b=l._util.getServiceDependencies(t).sort((n,r)=>n.index-r.index),E=[];for(const n of b){const r=this.m(n.id,c);r||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),E.push(r)}const v=b.length>0?b[0].index:i.length;if(i.length!==v){console.trace(`[createInstance] First service dependency of ${t.name} at position ${v+1} conflicts with ${i.length} static arguments`);const n=v-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,v)}return Reflect.construct(t,i.concat(E))}k(t,i){if(this.f.get(t)instanceof T.$Lh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const c=this.l(t);return c instanceof T.$Lh?this.q(t,c,i.branch(t,!0)):(i.branch(t,!1),c)}q(t,i,c){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,c)}finally{this.o.delete(t)}}r(t,i,c){const b=new A.$aq(n=>n.id.toString());let E=0;const v=[{id:t,desc:i,_trace:c}];for(;v.length;){const n=v.pop();if(b.lookupOrInsertNode(n),E++>1e3)throw new k(b);for(const r of l._util.getServiceDependencies(n.desc.ctor)){const s=this.l(r.id);if(s||this.u(`[createInstance] ${t} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),s instanceof T.$Lh){const o={id:r.id,desc:s,_trace:n._trace.branch(r.id,!0)};b.insertEdge(n,o),v.push(o)}}}for(;;){const n=b.roots();if(n.length===0){if(!b.isEmpty())throw new k(b);break}for(const{data:r}of n){if(this.l(r.id)instanceof T.$Lh){const o=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,o)}b.removeNode(r)}}return this.l(t)}s(t,i,c=[],b,E){if(this.f.get(t)instanceof T.$Lh)return this.t(t,i,c,b,E);if(this.h)return this.h.s(t,i,c,b,E);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,c=[],b,E){if(b){const v=new a(void 0,this.g,this,this.i);v.c=String(t);const n=new Map,r=new y.$$g(()=>{const s=v.j(i,c,E);for(const[o,w]of n){const h=s[o];if(typeof h=="function")for(const I of w)h.apply(s,I)}return n.clear(),s});return new Proxy(Object.create(null),{get(s,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let I=n.get(o);return I||(I=new g.$2c,n.set(o,I)),(u,m,d)=>{const P=I.push([u,m,d]);return(0,C.$Qc)(P)}}if(o in s)return s[o];const w=r.value;let h=w[o];return typeof h!="function"||(h=h.bind(w),s[o]=h),h},set(s,o,w){return r.value[o]=w,!0},getPrototypeOf(s){return i.prototype}})}else return this.j(i,c,E)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$bq=a;var p;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(p||(p={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new $(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(t,i){return t?new $(1,i.name):$.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const c=new $(3,t.toString());return this.h.push([t,i,c]),c}stop(){const t=Date.now()-this.g;$.f+=t;let i=!1;function c(E,v){const n=[],r=new Array(E+1).join("	");for(const[s,o,w]of v.h)if(o&&w){i=!0,n.push(`${r}CREATES -> ${s}`);const h=c(E+1,w);h&&n.push(h)}else n.push(`${r}uses -> ${s}`);return n.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(t>2||i)&&$.all.add(b.join(`
`))}}e.$cq=$}),define(Ae[14],Re([1,0,37,5,93,6,28,22,23,15,2,32,4]),function(be,e,y,M,C,T,A,l,D,g,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.log=e.$_i=e.LogLevel=e.$$i=e.$0i=e.$9i=void 0,e.$9i=(0,a.$Oh)("logService"),e.$0i=(0,a.$Oh)("loggerService");function p(){return new Date().toISOString()}function $(u){return(0,g.$Cf)(u)}e.$$i=$;var f;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$_i=f.Info;function t(u,m,d){switch(m){case f.Trace:u.trace(d);break;case f.Debug:u.debug(d);break;case f.Info:u.info(d);break;case f.Warning:u.warn(d);break;case f.Error:u.error(d);break;case f.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=t;function i(u,m=!1){let d="";for(let P=0;P<u.length;P++){let W=u[P];if(W instanceof Error&&(W=(0,y.$zi)(W,m)),typeof W=="object")try{W=JSON.stringify(W)}catch{}d+=(P>0?" ":"")+W}return d}class c extends T.$Sc{constructor(){super(...arguments),this.b=e.$_i,this.c=this.B(new M.$Nd),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==f.Off&&this.b<=m}}e.$bj=c;class b extends c{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...d){this.f(f.Trace)&&this.g(f.Trace,i([m,...d],!0))}debug(m,...d){this.f(f.Debug)&&this.g(f.Debug,i([m,...d]))}info(m,...d){this.f(f.Info)&&this.g(f.Info,i([m,...d]))}warn(m,...d){this.f(f.Warning)&&this.g(f.Warning,i([m,...d]))}error(m,...d){if(this.f(f.Error))if(m instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=m.stack,this.g(f.Error,i(P))}else this.g(f.Error,i([m,...d]))}flush(){}}e.$cj=b;class E extends c{constructor(m=e.$_i){super(),this.setLevel(m),this.g=!l.$j}trace(m,...d){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,m,...d):console.log(`[main ${p()}]`,m,...d))}debug(m,...d){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,m,...d):console.log(`[main ${p()}]`,m,...d))}info(m,...d){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,m,...d):console.log(`[main ${p()}]`,m,...d))}warn(m,...d){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,m,...d):console.warn(`[main ${p()}]`,m,...d))}error(m,...d){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,m,...d):console.error(`[main ${p()}]`,m,...d))}dispose(){}flush(){}}e.$dj=E;class v extends c{constructor(m=e.$_i,d=!0){super(),this.g=d,this.setLevel(m)}trace(m,...d){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",m,...d):console.log(m,...d))}debug(m,...d){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",m,...d):console.log(m,...d))}info(m,...d){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",m,...d):console.log(m,...d))}warn(m,...d){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",m,...d):console.log(m,...d))}error(m,...d){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",m,...d):console.error(m,...d))}dispose(){}flush(){}}e.$ej=v;class n extends c{constructor(m,d=e.$_i){super(),this.g=m,this.setLevel(d)}trace(m,...d){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(m),...d])}debug(m,...d){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(m),...d])}info(m,...d){this.f(f.Info)&&this.g.log(f.Info,[this.h(m),...d])}warn(m,...d){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(m),...d])}error(m,...d){this.f(f.Error)&&this.g.log(f.Error,[this.h(m),...d])}h(m){return typeof m=="string"?m:(0,y.$zi)(m,this.f(f.Trace))}dispose(){}flush(){}}e.$fj=n;class r extends c{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const d of this.g)d.setLevel(m);super.setLevel(m)}trace(m,...d){for(const P of this.g)P.trace(m,...d)}debug(m,...d){for(const P of this.g)P.debug(m,...d)}info(m,...d){for(const P of this.g)P.info(m,...d)}warn(m,...d){for(const P of this.g)P.warn(m,...d)}error(m,...d){for(const P of this.g)P.error(m,...d)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose()}}e.$gj=r;class s extends T.$Sc{constructor(m,d,P){if(super(),this.h=m,this.j=d,this.b=new A.$Ac,this.c=this.B(new M.$Nd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Nd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Nd),this.onDidChangeVisibility=this.g.event,P)for(const W of P)this.b.set(W.resource,{logger:void 0,info:W})}m(m){return(0,g.$yf)(m)?[...this.b.values()].find(d=>d.info.id===m):this.b.get(m)}getLogger(m){return this.m(m)?.logger}createLogger(m,d){const P=this.n(m),W=(0,g.$yf)(m)?m:d?.id??(0,C.$Ci)(P.toString()).toString(16);let K=this.b.get(P)?.logger;const U=d?.logLevel==="always"?f.Trace:d?.logLevel;K||(K=this.s(P,U??this.getLogLevel(P)??this.h,{...d,id:W}));const B={logger:K,info:{resource:P,id:W,logLevel:U,name:d?.name,hidden:d?.hidden,extensionId:d?.extensionId,when:d?.when}};return this.registerLogger(B.info),this.b.set(P,B),K}n(m){return(0,g.$yf)(m)?(0,D.$vg)(this.j,`${m}.log`):m}setLogLevel(m,d){if(R.URI.isUri(m)){const P=m,W=d,K=this.b.get(P);K&&W!==K.info.logLevel&&(K.info.logLevel=W===this.h?void 0:W,K.logger?.setLevel(W),this.b.set(K.info.resource,K),this.f.fire([P,W]))}else{this.h=m;for(const[P,W]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,d){const P=this.m(m);P&&d!==!P.info.hidden&&(P.info.hidden=!d,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,d]))}getLogLevel(m){let d;return m&&(d=this.b.get(m)?.info.logLevel),d??this.h}registerLogger(m){const d=this.b.get(m.resource);d?d.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const d=this.b.get(m);d&&(d.logger&&d.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[d.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.$hj=s;class o{constructor(){this.onDidChangeLogLevel=new M.$Nd().event}setLevel(m){}getLevel(){return f.Info}trace(m,...d){}debug(m,...d){}info(m,...d){}warn(m,...d){}error(m,...d){}critical(m,...d){}dispose(){}flush(){}}e.$ij=o;class w extends o{}e.$jj=w;function h(u){if(u.verbose)return f.Trace;if(typeof u.logLevel=="string"){const m=S(u.logLevel.toLowerCase());if(m!==void 0)return m}return e.$_i}e.$kj=h;function I(u){switch(u){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.$lj=I;function S(u){switch(u){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$mj=S,e.$nj=new k.$6i("logLevel",I(f.Info))}),define(Ae[174],Re([1,0,6,14]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=void 0;class C extends y.$Sc{constructor(A,l=[]){super(),this.a=new M.$gj([A,...l]),this.B(A.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...l){this.a.trace(A,...l)}debug(A,...l){this.a.debug(A,...l)}info(A,...l){this.a.info(A,...l)}warn(A,...l){this.a.warn(A,...l)}error(A,...l){this.a.error(A,...l)}flush(){this.a.flush()}}e.$AN=C}),define(Ae[94],Re([1,0,29,143,4]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var A;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(D){function g($,f){return f-$}D.compare=g;const R=Object.create(null);R[D.Error]=(0,M.localize)(0,null),R[D.Warning]=(0,M.localize)(1,null),R[D.Info]=(0,M.localize)(2,null);function k($){return R[$]||""}D.toString=k;function a($){switch($){case y.default.Error:return D.Error;case y.default.Warning:return D.Warning;case y.default.Info:return D.Info;case y.default.Ignore:return D.Hint}}D.fromSeverity=a;function p($){switch($){case D.Error:return y.default.Error;case D.Warning:return y.default.Warning;case D.Info:return y.default.Info;case D.Hint:return y.default.Ignore}}D.toSeverity=p}(A||(e.MarkerSeverity=A={}));var l;(function(D){const g="";function R(a){return k(a,!0)}D.makeKey=R;function k(a,p){const $=[g];return a.source?$.push(a.source.replace("\xA6","\\\xA6")):$.push(g),a.code?typeof a.code=="string"?$.push(a.code.replace("\xA6","\\\xA6")):$.push(a.code.value.replace("\xA6","\\\xA6")):$.push(g),a.severity!==void 0&&a.severity!==null?$.push(A.toString(a.severity)):$.push(g),a.message&&p?$.push(a.message.replace("\xA6","\\\xA6")):$.push(g),a.startLineNumber!==void 0&&a.startLineNumber!==null?$.push(a.startLineNumber.toString()):$.push(g),a.startColumn!==void 0&&a.startColumn!==null?$.push(a.startColumn.toString()):$.push(g),a.endLineNumber!==void 0&&a.endLineNumber!==null?$.push(a.endLineNumber.toString()):$.push(g),a.endColumn!==void 0&&a.endColumn!==null?$.push(a.endColumn.toString()):$.push(g),$.push(g),$.join("\xA6")}D.makeKeyOptionalMessage=k})(l||(e.IMarkerData=l={})),e.$9s=(0,C.$Oh)("markerService")}),define(Ae[175],Re([1,0,5,29,4]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yu=e.$Xu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Wu=e.Severity=void 0,e.Severity=M.default,e.$Wu=(0,C.$Oh)("notificationService");var T;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var l;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(l||(e.NotificationsFilter=l={}));class D{constructor(){this.progress=new g,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.$Xu=D;class g{infinite(){}done(){}total(k){}worked(k){}}e.$Yu=g}),define(Ae[95],Re([1,0,16,2,4]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cU=e.$bU=e.$aU=e.$_T=e.$$T=void 0,e.$$T=(0,C.$Oh)("openerService");function T(g,R){return M.URI.isUri(g)?(0,y.$2e)(g.scheme,R):(0,y.$3e)(g,R+":")}e.$_T=T;function A(g,...R){return R.some(k=>T(g,k))}e.$aU=A;function l(g,R){return g.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.$bU=l;function D(g){let R;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return k&&(R={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},g=g.with({fragment:""})),{selection:R,uri:g}}e.$cU=D}),define(Ae[176],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=void 0,e.$oj=(0,y.$Oh)("productService"),e.$pj="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(be,e,y,M){var C=arguments.length,T=C<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,y):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(be,e,y,M);else for(var l=be.length-1;l>=0;l--)(A=be[l])&&(T=(C<3?A(T):C>3?A(e,y,T):A(e,y))||T);return C>3&&T&&Object.defineProperty(e,y,T),T},Ke=this&&this.__param||function(be,e){return function(y,M){e(y,M,be)}};define(Ae[51],Re([1,0,12,20,6,4]),function(be,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5u=e.$4u=e.$3u=e.$2u=e.$1u=e.ProgressLocation=e.$Zu=void 0,e.$Zu=(0,T.$Oh)("progressService");var A;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$1u=Object.freeze({total(){},worked(){},done(){}});class l{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(k,a){this.e=k,this.report=a?.async?this.g.bind(this):this.f.bind(this)}f(k){this.a=k,this.e(this.a)}g(k){this.b?this.b.push(k):this.b=[k],this.h()}async h(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const k=this.b.shift();this.a=k,await this.e(this.a)}}finally{this.c=!1;const k=this.d;this.d=void 0,k?.()}}drain(){return this.c?new Promise(k=>{const a=this.d;this.d=()=>{a?.(),k()}}):Promise.resolve()}}e.$2u=l;let D=class extends C.$Sc{constructor(k,a){super(),this.a=new y.$ch,a.withProgress(k,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,C.$Qc)(()=>this.a.complete()))}report(k){this.b?this.b.report(k):this.c=k}};e.$3u=D,e.$3u=D=qe([Ke(1,e.$Zu)],D);class g extends C.$Sc{constructor(k){super(),this.g=k,this.a=0,this.b=this.B(new C.$Rc)}start(k){this.stop();const a=++this.a,p=new M.$Xd;return this.f=setTimeout(()=>{a===this.a&&(this.c=this.g.show(!0))},k),this.b.add((0,C.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Qc)(()=>p.cancel())),this.b.add((0,C.$Qc)(()=>this.c?this.c.done():void 0)),{id:a,token:p.token,stop:()=>this.h(a),isCurrent:()=>this.a===a}}stop(){this.h(this.a)}h(k){this.a===k&&this.b.clear()}}e.$4u=g,e.$5u=(0,T.$Oh)("editorProgressService")}),define(Ae[30],Re([1,0,52,15]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=void 0;class C{constructor(){this.a=new Map}add(A,l){y.ok(M.$yf(A)),y.ok(M.$Af(l)),y.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,l)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$dn=new C}),define(Ae[72],Re([1,0,5,30]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=void 0,e.$en={JSONContribution:"base.contributions.json"};function C(l){return l.length>0&&l.charAt(l.length-1)==="#"?l.substring(0,l.length-1):l}class T{constructor(){this.b=new y.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,g){this.a[C(D)]=g,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const A=new T;M.$dn.add(e.$en.JSONContribution,A)}),define(Ae[96],Re([1,0,18,5,15,137,44,72,30]),function(be,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.ConfigurationScope=e.$in=e.EditPresentationTypes=void 0;var g;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$in={Configuration:"base.contributions.configuration"};var R;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$jn={properties:{},patternProperties:{}},e.$kn={properties:{},patternProperties:{}},e.$ln={properties:{},patternProperties:{}},e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on={properties:{},patternProperties:{}},e.$pn="vscode://schemas/settings/resourceLanguage",e.$qn="vscode://schemas/settings/configurationDefaults";const k=D.$dn.as(l.$en.JSONContribution);class a{constructor(){this.h=new Set,this.i=new M.$Nd,this.onDidSchemaChange=this.i.event,this.j=new M.$Nd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$pn,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const s=new Set;this.n(n,r,s),k.registerSchema(e.$pn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(n){const r=new Set;this.o(n,r),k.registerSchema(e.$pn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const s=new Set;this.o(r,s),this.n(n,!1,s),k.registerSchema(e.$pn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const s=[];for(const{overrides:o,source:w}of n)for(const h in o)if(r.add(h),e.$sn.test(h)){const I=this.a.get(h),S=I?.valuesSources??new Map;if(w)for(const P of Object.keys(o[h]))S.set(P,w);const u={...I?.value||{},...o[h]};this.a.set(h,{source:w,value:u,valuesSources:S});const m=(0,A.$si)(h),d={type:"object",default:u,description:T.localize(1,null,m),$ref:e.$pn,defaultDefaultValue:u,source:C.$yf(w)?void 0:w,defaultValueSource:w};s.push(...f(h)),this.d[h]=d,this.b.properties[h]=d}else{this.a.set(h,{value:o[h],source:w});const I=this.d[h];I&&(this.w(h,I),this.r(h,I))}this.m(s)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:s,source:o}of n)for(const w in s){const h=this.a.get(w),I=C.$yf(o)?o:o?.id,S=C.$yf(h?.source)?h?.source:h?.source?.id;if(I===S)if(r.add(w),this.a.delete(w),e.$sn.test(w))delete this.d[w],delete this.b.properties[w];else{const u=this.d[w];u&&(this.w(w,u),this.r(w,u))}}this.u()}deltaConfiguration(n){let r=!1;const s=new Set;n.removedDefaults&&(this.l(n.removedDefaults,s),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,s),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,s),n.addedConfigurations&&this.n(n.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,s){n.forEach(o=>{this.p(o,r,o.extensionInfo,o.restrictedProperties,void 0,s),this.c.push(o),this.q(o)})}o(n,r){const s=o=>{if(o.properties)for(const w in o.properties){r.add(w);const h=this.d[w];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[w],this.s(w,o.properties[w])}o.allOf?.forEach(w=>s(w))};for(const o of n){s(o);const w=this.c.indexOf(o);w!==-1&&this.c.splice(w,1)}}p(n,r=!0,s,o,w=3,h){w=C.$Hf(n.scope)?w:n.scope;const I=n.properties;if(I)for(const u in I){const m=I[u];if(r&&b(u,m)){delete I[u];continue}if(m.source=s,m.defaultDefaultValue=I[u].default,this.w(u,m),e.$sn.test(u)?m.scope=void 0:(m.scope=C.$Hf(m.scope)?w:m.scope,m.restricted=C.$Hf(m.restricted)?!!o?.includes(u):m.restricted),I[u].hasOwnProperty("included")&&!I[u].included){this.f[u]=I[u],delete I[u];continue}else this.d[u]=I[u],I[u].policy?.name&&this.e.set(I[u].policy.name,u);!I[u].deprecationMessage&&I[u].markdownDeprecationMessage&&(I[u].deprecationMessage=I[u].markdownDeprecationMessage),h.add(u)}const S=n.allOf;if(S)for(const u of S)this.p(u,r,s,o,w,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=s=>{const o=s.properties;if(o)for(const h in o)this.r(h,o[h]);s.allOf?.forEach(r)};r(n)}r(n,r){switch(e.$jn.properties[n]=r,r.scope){case 1:e.$kn.properties[n]=r;break;case 2:e.$ln.properties[n]=r;break;case 6:e.$mn.properties[n]=r;break;case 3:e.$nn.properties[n]=r;break;case 4:e.$on.properties[n]=r;break;case 5:e.$on.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.$jn.properties[n],r.scope){case 1:delete e.$kn.properties[n];break;case 2:delete e.$ln.properties[n];break;case 6:delete e.$mn.properties[n];break;case 3:delete e.$nn.properties[n];break;case 4:case 5:delete e.$on.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,s={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.$pn};this.w(r,s),e.$jn.properties[r]=s,e.$kn.properties[r]=s,e.$ln.properties[r]=s,e.$mn.properties[r]=s,e.$nn.properties[r]=s,e.$on.properties[r]=s}}v(){const n={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.$pn};e.$jn.patternProperties[e.$rn]=n,e.$kn.patternProperties[e.$rn]=n,e.$ln.patternProperties[e.$rn]=n,e.$mn.patternProperties[e.$rn]=n,e.$nn.patternProperties[e.$rn]=n,e.$on.patternProperties[e.$rn]=n,this.i.fire()}w(n,r){const s=this.a.get(n);let o=s?.value,w=s?.source;C.$Ff(o)&&(o=r.defaultDefaultValue,w=void 0),C.$Ff(o)&&(o=i(r.type)),r.default=o,r.defaultValueSource=w}}const p="\\[([^\\]]+)\\]",$=new RegExp(p,"g");e.$rn=`^(${p})+$`,e.$sn=new RegExp(e.$rn);function f(v){const n=[];if(e.$sn.test(v)){let r=$.exec(v);for(;r?.length;){const s=r[1].trim();s&&n.push(s),r=$.exec(v)}}return(0,y.$Mb)(n)}e.$tn=f;function t(v){return v.reduce((n,r)=>`${n}[${r}]`,"")}e.$un=t;function i(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$vn=i;const c=new a;D.$dn.add(e.$in.Configuration,c);function b(v,n){return v.trim()?e.$sn.test(v)?T.localize(7,null,v):c.getConfigurationProperties()[v]!==void 0?T.localize(8,null,v):n.policy?.name&&c.getPolicyConfigurations().get(n.policy?.name)!==void 0?T.localize(9,null,v,n.policy?.name,c.getPolicyConfigurations().get(n.policy?.name)):null:T.localize(6,null)}e.$wn=b;function E(){const v=[],n=c.getConfigurationProperties();for(const r of Object.keys(n))v.push([r,n[r].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.$xn=E}),define(Ae[177],Re([1,0,18,5,115,6,28,24,15,2,44,96,30]),function(be,e,y,M,C,T,A,l,D,g,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=void 0;function p(r){return Object.isFrozen(r)?r:l.$5m(r)}class ${constructor(s={},o=[],w=[],h){this.b=s,this.c=o,this.d=w,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(o=>{if(o instanceof $)return o;const w=new f("");return w.parseRaw(o),w.configurationModel});this.f=s.reduce((o,w)=>w===o?w:o.merge(w),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,R.$qi)(this.contents,s):this.contents}inspect(s,o){const w=this.rawConfiguration.getValue(s),h=o?this.rawConfiguration.getOverrideValue(s,o):void 0,I=o?this.rawConfiguration.override(o).getValue(s):w;return{value:w,override:h,merged:I}}getOverrideValue(s,o){const w=this.i(o);return w?s?(0,R.$qi)(w,s):w:void 0}getKeysForOverrideIdentifier(s){const o=[];for(const w of this.overrides)w.identifiers.includes(s)&&o.push(...w.keys);return y.$Mb(o)}getAllOverrideIdentifiers(){const s=[];for(const o of this.overrides)s.push(...o.identifiers);return y.$Mb(s)}override(s){let o=this.a.get(s);return o||(o=this.g(s),this.a.set(s,o)),o}merge(...s){const o=l.$4m(this.contents),w=l.$4m(this.overrides),h=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const S of s)if(I.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(o,S.contents);for(const u of S.overrides){const[m]=w.filter(d=>y.$ub(d.identifiers,u.identifiers));m?(this.h(m.contents,u.contents),m.keys.push(...u.keys),m.keys=y.$Mb(m.keys)):w.push(l.$4m(u))}for(const u of S.keys)h.indexOf(u)===-1&&h.push(u)}return new $(o,h,w,I.every(S=>S instanceof $)?void 0:I)}g(s){const o=this.i(s);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const w={};for(const h of y.$Mb([...Object.keys(this.contents),...Object.keys(o)])){let I=this.contents[h];const S=o[h];S&&(typeof I=="object"&&typeof S=="object"?(I=l.$4m(I),this.h(I,S)):I=S),w[h]=I}return new $(w,this.keys,this.overrides)}h(s,o){for(const w of Object.keys(o)){if(w in s&&D.$Af(s[w])&&D.$Af(o[w])){this.h(s[w],o[w]);continue}s[w]=l.$4m(o[w])}}i(s){let o=null,w=null;const h=I=>{I&&(w?this.h(w,I):w=l.$4m(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===s?o=I.contents:I.identifiers.includes(s)&&h(I.contents);return h(o),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,o){this.j(s,o,!0)}setValue(s,o){this.j(s,o,!1)}removeValue(s){const o=this.keys.indexOf(s);o!==-1&&(this.keys.splice(o,1),(0,R.$pi)(this.contents,s),k.$sn.test(s)&&this.overrides.splice(this.overrides.findIndex(w=>y.$ub(w.identifiers,(0,k.$tn)(s))),1))}j(s,o,w){(0,R.$oi)(this.contents,s,o,h=>console.error(h)),w=w||this.keys.indexOf(s)===-1,w&&this.keys.push(s),k.$sn.test(s)&&this.overrides.push({identifiers:(0,k.$tn)(s),keys:Object.keys(this.contents[s]),contents:(0,R.$ni)(this.contents[s],h=>console.error(h))})}}e.$yn=$;class f{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,o){if(!D.$Hf(s)){const w=this.g(s);this.parseRaw(w,o)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,o){this.a=s;const{contents:w,keys:h,overrides:I,restricted:S,hasExcludedProperties:u}=this.h(s,o);this.b=new $(w,h,I,u?[s]:void 0),this.c=S||[]}g(s){let o={},w=null,h=[];const I=[],S=[];function u(d){Array.isArray(h)?h.push(d):w!==null&&(h[w]=d)}const m={onObjectBegin:()=>{const d={};u(d),I.push(h),h=d,w=null},onObjectProperty:d=>{w=d},onObjectEnd:()=>{h=I.pop()},onArrayBegin:()=>{const d=[];u(d),I.push(h),h=d,w=null},onArrayEnd:()=>{h=I.pop()},onLiteralValue:u,onError:(d,P,W)=>{S.push({error:d,offset:P,length:W})}};if(s)try{C.$1m(s,m),o=h[0]||{}}catch(d){console.error(`Error while parsing settings file ${this.f}: ${d}`),this.d=[d]}return o}h(s,o){const w=a.$dn.as(k.$in.Configuration).getConfigurationProperties(),h=this.i(s,w,!0,o);s=h.raw;const I=(0,R.$ni)(s,m=>console.error(`Conflict in settings file ${this.f}: ${m}`)),S=Object.keys(s),u=this.j(s,m=>console.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:I,keys:S,overrides:u,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(s,o,w,h){let I=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:I};const S={},u=[];for(const m in s)if(k.$sn.test(m)&&w){const d=this.i(s[m],o,!1,h);S[m]=d.raw,I=I||d.hasExcludedProperties,u.push(...d.restricted)}else{const d=o[m],P=d?typeof d.scope<"u"?d.scope:3:void 0;d?.restricted&&u.push(m),!h.exclude?.includes(m)&&(h.include?.includes(m)||(P===void 0||h.scopes===void 0||h.scopes.includes(P))&&!(h.skipRestricted&&d?.restricted))?S[m]=s[m]:I=!0}return{raw:S,restricted:u,hasExcludedProperties:I}}j(s,o){const w=[];for(const h of Object.keys(s))if(k.$sn.test(h)){const I={};for(const S in s[h])I[S]=s[h][S];w.push({identifiers:(0,k.$tn)(h),keys:Object.keys(I),contents:(0,R.$ni)(I,o)})}return w}}e.$zn=f;class t extends T.$Sc{constructor(s,o,w,h){super(),this.c=s,this.f=o,this.g=h,this.b=this.B(new M.$Nd),this.onDidChange=this.b.event,this.a=new f(this.c.toString()),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&w.isEqual(I.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$An=t;class i{constructor(s,o,w,h,I,S,u,m,d,P,W,K,U){this.a=s,this.b=o,this.c=w,this.overrideIdentifiers=h,this.d=I,this.f=S,this.g=u,this.h=m,this.i=d,this.j=P,this.k=W,this.l=K,this.m=U}get value(){return p(this.c)}n(s,o,w){const h=s.inspect(o,w);return{get value(){return p(h.value)},get override(){return p(h.override)},get merged(){return p(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(s,o,w,h,I=new $,S=new $,u=new A.$Ac,m=new $,d=new A.$Ac){this.c=s,this.d=o,this.f=w,this.g=h,this.h=I,this.i=S,this.j=u,this.l=m,this.m=d,this.a=null,this.b=new A.$Ac,this.n=null}getValue(s,o,w){return this.q(s,o,w).getValue(s)}updateValue(s,o,w={}){let h;w.resource?(h=this.m.get(w.resource),h||(h=new $,this.m.set(w.resource,h))):h=this.l,o===void 0?h.removeValue(s):h.setValue(s,o),w.resource||(this.a=null)}inspect(s,o,w){const h=this.q(s,o,w),I=this.u(o.resource,w),S=o.resource?this.m.get(o.resource)||this.l:this.l,u=new Set;for(const m of h.overrides)for(const d of m.identifiers)h.getOverrideValue(s,d)!==void 0&&u.add(d);return new i(s,o,h.getValue(s),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.i:void 0,I||void 0,S)}keys(s){const o=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,o){this.j.set(s,o),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,o){const w=[];if(!o){const{added:h,updated:I,removed:S}=v(this.c,s);o=[...h,...I,...S]}for(const h of o)for(const I of(0,k.$tn)(h)){const S=this.c.getKeysForOverrideIdentifier(I),u=s.getKeysForOverrideIdentifier(I),m=[...u.filter(d=>S.indexOf(d)===-1),...S.filter(d=>u.indexOf(d)===-1),...S.filter(d=>!l.$8m(this.c.override(I).getValue(d),s.override(I).getValue(d)))];w.push([I,m])}return this.updateDefaultConfiguration(s),{keys:o,overrides:w}}compareAndUpdatePolicyConfiguration(s){const{added:o,updated:w,removed:h}=v(this.d,s),I=[...o,...w,...h];return I.length&&this.updatePolicyConfiguration(s),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:o,updated:w,removed:h,overrides:I}=v(this.applicationConfiguration,s),S=[...o,...w,...h];return S.length&&this.updateApplicationConfiguration(s),{keys:S,overrides:I}}compareAndUpdateLocalUserConfiguration(s){const{added:o,updated:w,removed:h,overrides:I}=v(this.localUserConfiguration,s),S=[...o,...w,...h];return S.length&&this.updateLocalUserConfiguration(s),{keys:S,overrides:I}}compareAndUpdateRemoteUserConfiguration(s){const{added:o,updated:w,removed:h,overrides:I}=v(this.remoteUserConfiguration,s),S=[...o,...w,...h];return S.length&&this.updateRemoteUserConfiguration(s),{keys:S,overrides:I}}compareAndUpdateWorkspaceConfiguration(s){const{added:o,updated:w,removed:h,overrides:I}=v(this.workspaceConfiguration,s),S=[...o,...w,...h];return S.length&&this.updateWorkspaceConfiguration(s),{keys:S,overrides:I}}compareAndUpdateFolderConfiguration(s,o){const w=this.p.get(s),{added:h,updated:I,removed:S,overrides:u}=v(w,o),m=[...h,...I,...S];return(m.length||!w)&&this.updateFolderConfiguration(s,o),{keys:m,overrides:u}}compareAndDeleteFolderConfiguration(s){const o=this.p.get(s);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:w,updated:h,removed:I,overrides:S}=v(o,void 0);return{keys:[...w,...h,...I],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,o,w){let h=this.r(o,w);return o.overrideIdentifier&&(h=h.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(h=h.merge(this.d)),h}r({resource:s},o){let w=this.s();if(o&&s){const h=o.getFolder(s);h&&(w=this.t(h.uri)||w);const I=this.m.get(s);I&&(w=w.merge(I))}return w}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let o=this.b.get(s);if(!o){const w=this.s(),h=this.j.get(s);h?(o=w.merge(h),this.b.set(s,o)):o=w}return o}u(s,o){if(o&&s){const w=o.getFolder(s);if(w)return this.j.get(w.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,o)=>{const{contents:w,overrides:h,keys:I}=this.j.get(o);return s.push([o,{contents:w,overrides:h,keys:I}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(o=>s.add(o)),this.userConfiguration.keys.forEach(o=>s.add(o)),this.i.keys.forEach(o=>s.add(o)),this.j.forEach(o=>o.keys.forEach(w=>s.add(w))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(w=>s.add(w))),[...s.values()]}w(s){const o=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(w=>o.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(w=>o.add(w)),this.i.getKeysForOverrideIdentifier(s).forEach(w=>o.add(w)),this.j.forEach(w=>w.getKeysForOverrideIdentifier(s).forEach(h=>o.add(h))),[...o.values()]}static parse(s){const o=this.x(s.defaults),w=this.x(s.policy),h=this.x(s.application),I=this.x(s.user),S=this.x(s.workspace),u=s.folders.reduce((m,d)=>(m.set(g.URI.revive(d[0]),this.x(d[1])),m),new A.$Ac);return new c(o,w,h,I,new $,S,u,new $,new A.$Ac)}static x(s){return new $(s.contents,s.keys,s.overrides)}}e.$Bn=c;function b(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,o=new Map;for(const h of r)h.keys.forEach(I=>s.add(I)),h.overrides.forEach(([I,S])=>{const u=(0,A.$xc)(o,I,new Set);S.forEach(m=>u.add(m))});const w=[];return o.forEach((h,I)=>w.push([I,[...h.values()]])),{keys:[...s.values()],overrides:w}}e.$Cn=b;class E{constructor(s,o,w,h){this.change=s,this.f=o,this.g=w,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of s.keys)this.affectedKeys.add(I);for(const[,I]of s.overrides)for(const S of I)this.affectedKeys.add(S);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(s,o){const w=this.a+s,h=this.d.indexOf(w);if(h<0)return!1;const I=h+w.length;if(I>=this.d.length)return!1;const S=this.d.charCodeAt(I);if(S!==this.b&&S!==this.c)return!1;if(o){const u=this.previousConfiguration?this.previousConfiguration.getValue(s,o,this.f?.workspace):void 0,m=this.g.getValue(s,o,this.h);return!l.$8m(u,m)}return!0}}e.$Dn=E;function v(r,s){const{added:o,removed:w,updated:h}=n(s?.rawConfiguration,r?.rawConfiguration),I=[],S=r?.getAllOverrideIdentifiers()||[],u=s?.getAllOverrideIdentifiers()||[];if(s){const m=u.filter(d=>!S.includes(d));for(const d of m)I.push([d,s.getKeysForOverrideIdentifier(d)])}if(r){const m=S.filter(d=>!u.includes(d));for(const d of m)I.push([d,r.getKeysForOverrideIdentifier(d)])}if(s&&r){for(const m of S)if(u.includes(m)){const d=n({contents:r.getOverrideValue(void 0,m)||{},keys:r.getKeysForOverrideIdentifier(m)},{contents:s.getOverrideValue(void 0,m)||{},keys:s.getKeysForOverrideIdentifier(m)});I.push([m,[...d.added,...d.removed,...d.updated]])}}return{added:o,removed:w,updated:h,overrides:I}}function n(r,s){const o=r?s?r.keys.filter(I=>s.keys.indexOf(I)===-1):[...r.keys]:[],w=s?r?s.keys.filter(I=>r.keys.indexOf(I)===-1):[...s.keys]:[],h=[];if(r&&s){for(const I of s.keys)if(r.keys.indexOf(I)!==-1){const S=(0,R.$qi)(s.contents,I),u=(0,R.$qi)(r.contents,I);l.$8m(S,u)||h.push(I)}}return{added:o,removed:w,updated:h}}}),define(Ae[97],Re([1,0,9,4]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.RemoteAuthorityResolverErrorCode=e.$Qk=e.$Pk=e.RemoteConnectionType=e.$Ok=void 0,e.$Ok=(0,M.$Oh)("remoteAuthorityResolverService");var C;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class T{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Pk=T;class A{constructor(k,a){this.host=k,this.port=a,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Qk=A;var l;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class D extends y.$bb{static isNotAvailable(k){return k instanceof D&&k._code===l.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===l.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===l.NoResolverFound}static isInvalidAuthority(k){return k instanceof D&&k._code===l.InvalidAuthority}static isHandled(k){return k instanceof D&&k.isHandled}constructor(k,a=l.Unknown,p){super(k),this._message=k,this._code=a,this._detail=p,this.isHandled=a===l.NotAvailable&&p===!0,Object.setPrototypeOf(this,D.prototype)}}e.$Rk=D;function g(R){const k=R.indexOf("+");return k===-1?R:R.substring(0,k)}e.$Sk=g}),define(Ae[53],Re([1,0,13]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=void 0;function M(g){return g.scheme===y.Schemas.vscodeRemote?g.authority:void 0}e.$Tk=M;function C(g){if(!g)return;const R=g.indexOf("+");return R<0?g:g.substr(0,R)}e.$Uk=C;function T(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Vk=T;function A(g){const{host:R,port:k}=D(g);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:k}}e.$Wk=A;function l(g,R){let{host:k,port:a}=D(g);return typeof a>"u"&&(a=R),{host:k,port:a}}e.$Xk=l;function D(g){const R=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const k=g.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const a=g.match(/(.*):(\d+)$/);return a?{host:a[1],port:parseInt(a[2],10)}:{host:g,port:void 0}}}),define(Ae[21],Re([1,0,16,4,53]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.TargetPlatform=e.ExtensionType=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=void 0,e.$Xl="extensions.user.cache",e.$Yl="extensions.builtin.cache",e.$Zl="undefined_publisher",e.$1l=["ui","workspace","web"];function T(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$2l=T,e.$3l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A||(e.ExtensionType=A={}));var l;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(l||(e.TargetPlatform=l={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const c=typeof t=="string"?t:t.value,b=typeof i=="string"?i:i.value;return y.$2e(c,b)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$4l=D;class g{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(D.toKey(t))}delete(t){return this.c.delete(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}}e.$5l=g;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(D.toKey(t))}get(t){return this.c.get(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}set(t,i){this.c.set(D.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$6l=R;function k(f){return a(f)}e.$7l=k;function a(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.$8l=a;function p(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.$9l=p;function $(f,t){if(t){const i=`onResolveRemoteAuthority:${(0,C.$Uk)(t)}`;return!!f.activationEvents?.includes(i)}return!1}e.$0l=$,e.$$l=(0,M.$Oh)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,9,21]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RE=e.$QE=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,l){this.a.set(A,l)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const l=Object.create(null);for(const D of A){const g=this.readActivationEvents(D);g.length>0&&(l[M.$4l.toKey(D.identifier)]=g)}return l}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const l=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return l;for(const D in A.contributes){const g=this.a.get(D);if(!g)continue;const R=A.contributes[D],k=Array.isArray(R)?R:[R];try{g(k,l)}catch(a){(0,y.$1)(a)}}return l}}e.$QE=C,e.$RE=new C}),define(Ae[178],Re([1,0,22,73,36]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=void 0;function T(D){if(y.$u===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function A(D,g,R,k,a,p,$,f){const t=Object.create(null);t["common.machineId"]=p,t.sessionID=(0,C.$eg)()+Date.now(),t.commitHash=k,t.version=a,t["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,y.$i)(y.$u),t["common.nodePlatform"]=M.$dc,t["common.nodeArch"]=R,t["common.product"]=f||"desktop",$&&(t["common.msftInternal"]=$);let i=0;const c=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),y.$m&&(t["common.snap"]="true");const b=T(g);return b&&(t["common.platformDetail"]=b),t}e.$fo=A;function l(D){const g=M.env.USERDNSDOMAIN;if(!g)return!1;const R=g.toLowerCase();return D.some(k=>R===k)}e.$go=l}),define(Ae[179],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=void 0,e.$bl=(0,y.$Oh)("telemetryService"),e.$cl=(0,y.$Oh)("customEndpointTelemetryService"),e.$dl="telemetry.currentSessionDate",e.$el="telemetry.firstSessionDate",e.$fl="telemetry.lastSessionDate",e.$gl="telemetry.machineId",e.$hl="telemetry",e.$il="telemetry.telemetryLevel",e.$jl="telemetry.enableCrashReporter",e.$kl="telemetry.enableTelemetry";var M;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var C;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ae[54],Re([1,0,24,15,5,44,53,178,179]),function(be,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=void 0;class g{constructor(w){this.value=w,this.isTrustedTelemetryValue=!0}}e.$ho=g;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$io=R,e.$jo=new R;class k{async publicLog(w,h,I){}async publicLogError(w,h,I){}}e.$ko=k,e.$lo="telemetry",e.$mo="extensionTelemetryLog",e.$no={log:()=>null,flush:()=>Promise.resolve(null)};function a(o,w){return C.Event.debounce(w.onDidChangeConfiguration,(I,S)=>{const u=I?new Set([...I.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:u}},1e3,!0)(I=>{I.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,T.$li)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$oo=a;function p(o,w){return!w.isBuilt&&!w.disableTelemetry?!0:!(w.disableTelemetry||!o.enableTelemetry)}e.$po=p;function $(o,w){return w.extensionTestsLocationURI?!0:!(w.isBuilt||w.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$qo=$;function f(o){const w=o.getValue(D.$il),h=o.getValue(D.$jl);if(o.getValue(D.$kl)===!1||h===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$ro=f;function t(o){const w={},h={},I={};b(o,I);for(let S in I){S=S.length>150?S.substr(S.length-149):S;const u=I[S];typeof u=="number"?h[S]=u:typeof u=="boolean"?h[S]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${u.length}`),w[S]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(w[S]=u)}return{properties:w,measurements:h}}e.$so=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(o){if(!o)return"none";const w=(0,A.$Uk)(o);return i.has(w)?w:"other"}e.$to=c;function b(o,w,h=0,I){if(o)for(const S of Object.getOwnPropertyNames(o)){const u=o[S],m=I?I+S:S;Array.isArray(u)?w[m]=(0,y.$9m)(u):u instanceof Date?w[m]=u.toISOString():(0,M.$Af)(u)?h<2?b(u,w,h+1,m+"."):w[m]=(0,y.$9m)(u):w[m]=u}}function E(o,w){const h=o.msftInternalDomains||[],I=w.getValue("telemetry.internalTesting");return(0,l.$go)(h)||I}e.$uo=E;function v(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$vo=v;function n(o,w){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let h=o;const I=[];for(const d of w)for(;;){const P=d.exec(o);if(!P)break;I.push([P.index,d.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(h="";;){const d=u.exec(o);if(!d)break;const P=I.some(([W,K])=>d.index<K&&W<u.lastIndex);!S.test(d[0])&&!P&&(h+=o.substring(m,d.index)+"<REDACTED: user-file-path>",m=u.lastIndex)}return m<o.length&&(h+=o.substr(m)),h}function r(o){if(!o)return o;const w=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of w)if(h.regex.test(o))return`<REDACTED: ${h.label}>`;return o}function s(o,w){return(0,y.$6m)(o,h=>{if(h instanceof g||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let I=h.replaceAll("%20"," ");I=n(I,w);for(const S of w)I=I.replace(S,"");return I=r(I),I}})}e.$wo=s}),define(Ae[180],Re([1,0,16,92,21,22,2,9,73,54]),function(be,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=void 0;function R(s,o){return s.uuid&&o.uuid?s.uuid===o.uuid:s.id===o.id?!0:(0,y.$We)(s.id,o.id)===0}e.$xo=R;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(o){const w=o.manifest?o.manifest.version:o.version,h=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new a(o.identifier,w,h)}static parse(o){const w=k.exec(o);return w&&w[1]&&w[2]?new a({id:w[1]},w[2],w[4]||void 0):null}constructor(o,w,h="undefined"){this.version=w,this.targetPlatform=h,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof a?R(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$yo=a;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(s){const o=p.exec(s);return o&&o[1]?[t(o[1]),o[2]]:[t(s),void 0]}e.$zo=$;function f(s,o){return`${s}.${o}`}e.$Ao=f;function t(s){return s.toLowerCase()}e.$Bo=t;function i(s,o){return t(f(s??C.$Zl,o))}e.$Co=i;function c(s,o){const w=[],h=I=>{for(const S of w)if(S.some(u=>R(o(u),o(I))))return S;return null};for(const I of s){const S=h(I);S?S.push(I):w.push([I])}return w}e.$Do=c;function b(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$Eo=b;function E(s){return{id:new g.$ho(s.identifier.id),name:new g.$ho(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Fo=E,e.$Go=new C.$4l("pprice.better-merge");function v(s,o){const w=[],h=o.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const I=h.shift();if(I&&w.every(S=>!R(S.identifier,{id:I}))){const S=s.filter(u=>R(u.identifier,{id:I}));S.length===1&&(w.push(S[0]),h.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.$Ho=v;async function n(s,o){if(!T.$l)return!1;let w;try{w=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){o.debug("Error while getting the os-release file.",(0,l.$0)(I))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(s,o){const w=await n(s,o),h=(0,M.$3n)(w?"alpine":T.$u,D.$ec);return o.debug("ComputeTargetPlatform:",h),h}e.$Io=r}),define(Ae[181],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.$lr=e.$kr=e.$jr=e.$ir=void 0;function y(D){return[...D.entries()]}e.$ir=y;function M(D){return D?[...D.entries()]:[]}e.$jr=M;function C(D){return new Map(D)}e.$kr=C;function T(D){return new Map(D??[])}e.$lr=T;function A(D){return Array.from(D.entries()).map(g=>[g[0],y(g[1].map),M(g[1].descriptionMap)])}e.$mr=A;function l(D){return new Map(D.map(g=>[g[0],{map:C(g[1]),descriptionMap:T(g[2])}]))}e.$nr=l}),define(Ae[182],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkb=void 0;class y{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,T,A=5){const l=T(D=>{const g=typeof D=="string"?D:D.data;let R=this.a.get(C);if(R){R.data.push(g);return}const k=setTimeout(()=>this.flushBuffer(C),A);R={data:[g],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),l.dispose()}},this.a.set(C,R)});return l}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const T=this.a.get(C);T&&(this.a.delete(C),this.b(C,T.data.join("")))}}e.$Pkb=y}),define(Ae[183],Re([1,0,12,89,42,5,15,2,144,72,30]),function(be,e,y,M,C,T,A,l,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9v=e.$8v=e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.IconFontDefinition=e.IconContribution=e.$1v=void 0,e.$1v={IconContribution:"base.contributions.icons"};var k;(function(E){function v(n,r){let s=n.defaults;for(;C.ThemeIcon.isThemeIcon(s);){const o=$.getIcon(s.id);if(!o)return;s=o.defaults}return s}E.getDefinition=v})(k||(e.IconContribution=k={}));var a;(function(E){function v(r){return{weight:r.weight,style:r.style,src:r.src.map(s=>({format:s.format,location:s.location.toString()}))}}E.toJSONObject=v;function n(r){const s=o=>(0,A.$yf)(o)?o:void 0;if(r&&Array.isArray(r.src)&&r.src.every(o=>(0,A.$yf)(o.format)&&(0,A.$yf)(o.location)))return{weight:s(r.weight),style:s(r.style),src:r.src.map(o=>({format:o.format,location:l.URI.parse(o.location)}))}}E.fromJSONObject=n})(a||(e.IconFontDefinition=a={}));class p{constructor(){this.a=new T.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,n,r,s){const o=this.b[v];if(o){if(r&&!o.description){o.description=r,this.d.properties[v].markdownDescription=`${r} $(${v})`;const I=this.e.enum.indexOf(v);I!==-1&&(this.e.enumDescriptions[I]=r),this.a.fire()}return o}const w={id:v,description:r,defaults:n,deprecationMessage:s};this.b[v]=w;const h={$ref:"#/definitions/icons"};return s&&(h.deprecationMessage=s),r&&(h.markdownDescription=`${r}: $(${v})`),this.d.properties[v]=h,this.e.enum.push(v),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const n=this.e.enum.indexOf(v);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,n){const r=this.f[v];return r||(this.f[v]=n,this.a.fire(),n)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(o,w)=>o.id.localeCompare(w.id),n=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(o=>this.b[o]);for(const o of s.filter(w=>!!w.description).sort(v))r.push(`|<i class="${n(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const o of s.filter(w=>!C.ThemeIcon.isThemeIcon(w.defaults)).sort(v))r.push(`|<i class="${n(o)}"></i>|${o.id}|`);return r.join(`
`)}}const $=new p;R.$dn.add(e.$1v.IconContribution,$);function f(E,v,n,r){return $.registerIcon(E,v,n,r)}e.$2v=f;function t(){return $}e.$3v=t;function i(){const E=(0,M.$Rj)();for(const v in E){const n="\\"+E[v].toString(16);$.registerIcon(v,{fontCharacter:n})}}i(),e.$4v="vscode://schemas/icons";const c=R.$dn.as(g.$en.JSONContribution);c.registerSchema(e.$4v,$.getIconSchema());const b=new y.$6g(()=>c.notifySchemaChanged(e.$4v),200);$.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.$5v=f("widget-close",M.$Tj.close,(0,D.localize)(2,null)),e.$6v=f("goto-previous-location",M.$Tj.arrowUp,(0,D.localize)(3,null)),e.$7v=f("goto-next-location",M.$Tj.arrowDown,(0,D.localize)(4,null)),e.$8v=C.ThemeIcon.modify(M.$Tj.sync,"spin"),e.$9v=C.ThemeIcon.modify(M.$Tj.loading,"spin")}),define(Ae[184],Re([1,0,5,44,4,14]),function(be,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dv=e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.ProvidedOnAutoForward=e.$8u=e.TunnelPrivacyId=e.TunnelProtocol=e.$7u=e.$6u=void 0,e.$6u=(0,C.$Oh)("tunnelService"),e.$7u=(0,C.$Oh)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var l;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(l||(e.TunnelPrivacyId=l={}));function D(t){return!!t.forwardPort}e.$8u=D;var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function R(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$9u=R,e.$0u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(t){return e.$0u.indexOf(t)>=0}e.$$u=k,e.$_u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(t){return e.$_u.indexOf(t)>=0}e.$av=a;function p(t,i,c,b){if(c===1)return!1;if(c===2&&a(i)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(E?.length===4&&parseInt(E[1])>=18)return!1}return t<1024}e.$bv=p;class ${constructor(i,c,b){this.remoteAddress=i,this.localAddress=c,this.b=b,this.a=new y.$Nd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$cv=$;let f=class{constructor(i,c){this.j=i,this.k=c,this.a=new y.$Nd,this.onTunnelOpened=this.a.event,this.b=new y.$Nd,this.onTunnelClosed=this.b.event,this.c=new y.$Nd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],c=Array.from(this.e.values());for(const b of c){const E=Array.from(b.values());for(const v of E){const n=await v.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:c}of i.values())await c.then(b=>typeof b!="string"?b?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,c,b,E,v){this.p(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:b,privacy:E,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(a(i)||k(i))&&(i=e.$0u[0]);const b=this.r(i,c);if(b)return++b.refcount,b.value}openTunnel(i,c,b,E,v,n=!1,r,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${b} on local port ${v}.`);const o=this.f??i;if(!o)return;if(c||(c="localhost"),E||(E=this.l),this.f&&this.i.has(b)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const w=this.s(o,c,b,E,v,n,r,s);return w?w.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(c,b),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(c,b);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(h);return(h.tunnelRemoteHost!==c||h.tunnelRemotePort!==b)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&h.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),w)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.e.get(i.tunnelRemoteHost);if(c){const b=c.get(i.tunnelRemotePort);b&&(b.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,b))}}}}async o(i,c,b){if(b.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const E=b.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(c),E}}async closeTunnel(i,c){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const b=this.e.get(i);if(b&&b.has(c)){const E=b.get(c);E.refcount=0,await this.o(i,c,E)}}p(i,c,b){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(c,{refcount:1,value:b})}async q(i,c){const b=this.e.get(i);if(b){const E=b.get(c),v=E?await E.value:void 0;(!v||typeof v=="string")&&b.delete(c),b.size===0&&this.e.delete(i)}}r(i,c){const b=[i];k(i)?(b.push(...e.$0u),b.push(...e.$_u)):a(i)&&b.push(...e.$_u);const E=b.map(v=>this.e.get(v));for(const v of E){const n=v?.get(c);if(n)return n}}canTunnel(i){return!!R(i)}t(i,c,b,E,v,n,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${b} on local port ${E}.`);const s=b;this.i.add(s);const o=E===void 0?b:E,w={elevationRequired:v?this.isPortPrivileged(o):!1},h={remoteAddress:{host:c,port:b},localAddressPort:E,privacy:n,public:n?n!==l.Private:void 0,protocol:r},I=i.forwardPort(h,w);return I?(this.p(c,b,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),I}};e.$dv=f,e.$dv=f=qe([Ke(0,T.$9i),Ke(1,M.$ii)],f)}),define(Ae[185],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ev=void 0,e.$ev=(0,y.$Oh)("editSessionIdentityService");var M;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Ae[186],Re([1,0,13]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=void 0;function M(D){return D.scheme!==y.Schemas.file&&D.scheme!==y.Schemas.vscodeRemote}e.$LJ=M;function C(D){if(D.folders.length)return D.folders.every(g=>M(g.uri))?D.folders[0].uri:void 0;if(D.configuration&&M(D.configuration))return D.configuration}e.$MJ=C;function T(D){return C(D)?.scheme}e.$NJ=T;function A(D){return C(D)?.authority}e.$OJ=A;function l(D){return C(D)!==void 0}e.$PJ=l}),define(Ae[55],Re([1,0,145,19,49,23,2,4,13]),function(be,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.WorkbenchState=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=void 0,e.$Xh=(0,l.$Oh)("contextService");function g(o){const w=o;return typeof w?.id=="string"&&A.URI.isUri(w.uri)}e.$Yh=g;function R(o){return typeof o?.id=="string"&&!g(o)&&!a(o)}e.$Zh=R,e.$1h={id:"ext-dev"},e.$2h={id:"empty-window"};function k(o,w){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,M.$nc)(o)}:w?e.$1h:e.$2h;const h=o;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$3h=k;function a(o){const w=o;return typeof w?.id=="string"&&A.URI.isUri(w.configPath)}e.$4h=a;function p(o){const w=o;if(w?.uri)return{id:w.id,uri:A.URI.revive(w.uri)};const h=o;if(h?.configPath)return{id:h.id,configPath:A.URI.revive(h.configPath)};if(o?.id)return{id:o.id}}e.$5h=p;var $;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function f(o){const w=o;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.$6h=f;function t(o){const w=o;return!!(w&&typeof w=="object"&&A.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.$7h=t;class i{constructor(w,h,I,S,u){this.h=w,this.j=I,this.k=S,this.l=u,this.c=C.$Uh.forUris(this.l,()=>!0),this.folders=h}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=C.$Uh.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$8h=i;class c{constructor(w,h){this.raw=h,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,T.$vg)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$9h=c;function b(o){return new c({uri:o,index:0,name:(0,T.$rg)(o)},{uri:o.toString()})}e.$0h=b,e.$$h="code-workspace",e.$_h=`.${e.$$h}`,e.$ai=[{name:(0,y.localize)(0,null),extensions:[e.$$h]}],e.$bi="workspace.json";function E(o,w){return T.$mg.isEqualOrParent(o,w.untitledWorkspacesHome)}e.$ci=E;function v(o){let w;return A.URI.isUri(o)?w=o:w=o.configuration,w?.scheme===D.Schemas.tmp}e.$di=v,e.$ei="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(o){return o.id===e.$ei}e.$fi=n;function r(o,w){return!E(o,w)&&!v(o)}e.$gi=r;function s(o){return(typeof o=="string"?(0,M.$oc)(o):(0,T.$tg)(o))===e.$_h}e.$hi=s}),define(Ae[74],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;class y{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const T=this.c++;return this.b.set(T,C),this.e(),T}get(C,T){return this.b.has(C)?this.b.get(C)[T]:void 0}delete(C){this.b.delete(C),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Rbc=y}),define(Ae[40],Re([1,0,13,23,4]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=e.$Tbc=void 0;class T{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new M.$kg(l=>{const D=this.b.get(l.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(l,D){D===null?this.b.delete(l.scheme):this.b.set(l.scheme,D)}isFreeScheme(l){return!this.b.has(l)&&!this.a.has(l)}getCapabilities(l){return this.b.get(l)}}e.$Tbc=T,e.$Ubc=(0,C.$Oh)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tM=void 0,e.$tM=(0,y.$Oh)("IExtHostInitDataService")}),define(Ae[187],Re([1,0,150,14,174,27]),function(be,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;let A=class extends C.$AN{constructor(D,g,R){const k=R.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",a=R.remote.isRemote?(0,y.localize)(0,null):D?(0,y.localize)(1,null):(0,y.localize)(2,null);super(g.createLogger(k,{name:a}))}};e.$3dc=A,e.$3dc=A=qe([Ke(1,M.$0i),Ke(2,T.$tM)],A)}),define(Ae[188],Re([1,0,12]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=e.$kcc=void 0;class M{constructor(A,l,D){this.h=new Map,this.a=A,this.b=l,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new y.$6g(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of g.values())R.complete()}catch(R){for(const k of g.values())k.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,l){let D=this.f[A];return typeof D>"u"&&(D=l),D}update(A,l){this.f[A]=l;const D=this.h.get(A);if(D!==void 0)return D.p;const g=new y.$ch;return this.h.set(A,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$kcc=M;class C extends M{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,l){super(A.identifier.value,!0,l),this.j=A}}e.$lcc=C}),define(Ae[189],Re([1,0,5,2]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;class C{constructor(A){this.c=A,this.a=new y.$Nd,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$Nd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,l,D,g){const k=this.c.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(l.value,D,g);this.b.fire(k)}$acceptDirtyStateChanged(A,l){this.c.getNotebookDocument(M.URI.revive(A)).acceptDirty(l)}$acceptModelSaved(A){const l=this.c.getNotebookDocument(M.URI.revive(A));this.a.fire(l.apiNotebook)}}e.$Jdc=C}),define(Ae[17],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eM=e.$dM=void 0,e.$dM=(0,y.$Oh)("IExtHostRpcService");class M{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.$eM=M}),define(Ae[190],Re([1,0,21,5]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;class C{#e;constructor(A,l){this.b=new M.$Nd,this.onDidChange=this.b.event,this.a=y.$4l.toKey(A.identifier),this.#e=l,this.#e.onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(A){return this.#e.get(this.a,A)}store(A,l){return this.#e.store(this.a,A,l)}delete(A){return this.#e.delete(this.a,A)}}e.$wcc=C}),define(Ae[56],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=e.$5bc=void 0,e.$5bc=(0,y.$Oh)("IURITransformerService");class M{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$6bc=M}),define(Ae[191],Re([1,0,26]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcb=e.$vcb=void 0;class M{constructor(){this.buffers=[]}add(D){let g=this.buffers.indexOf(D);return g<0&&(g=this.buffers.length,this.buffers.push(D)),g}}function C(l,D){if(D.serializeBuffersForPostMessage){const g=new M,k=JSON.stringify(l,(p,$)=>{if($ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add($)};if(ArrayBuffer.isView($)){const f=T($);if(f)return{$$vscode_array_buffer_reference$$:!0,index:g.add($.buffer),view:{type:f,byteLength:$.byteLength,byteOffset:$.byteOffset}}}return $}),a=g.buffers.map(p=>{const $=new Uint8Array(p);return y.$be.wrap($)});return{message:k,buffers:a}}else return{message:JSON.stringify(l),buffers:[]}}e.$vcb=C;function T(l){switch(l.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(l,D){const g=D.map(a=>{const p=new ArrayBuffer(a.byteLength);return new Uint8Array(p).set(a.buffer),p}),R=D.length?(a,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const $=p,{index:f}=$,t=g[f];if($.view)switch($.view.type){case 1:return new Int8Array(t,$.view.byteOffset,$.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,$.view.byteOffset,$.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,$.view.byteOffset,$.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,$.view.byteOffset,$.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,$.view.byteOffset,$.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,$.view.byteOffset,$.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,$.view.byteOffset,$.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,$.view.byteOffset,$.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,$.view.byteOffset,$.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,$.view.byteOffset,$.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,$.view.byteOffset,$.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return p}:void 0;return{message:JSON.parse(l,R),arrayBuffers:g}}e.$wcb=A}),define(Ae[99],Re([1,0,159,15,2,6,4,30,39,13,37,127,29]),function(be,e,y,M,C,T,A,l,D,g,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cE=e.$bE=e.$aE=e.EditorsOrder=e.$_D=e.CloseDirection=e.$$D=e.$0D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$9D=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=e.$3D=e.$2D=e.EditorInputCapabilities=e.$1D=e.SaveReason=e.Verbosity=e.$ZD=e.$YD=e.$XD=e.$WD=e.$VD=e.$UD=e.$TD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$SD=e.$RD=e.$QD=e.$PD=e.$OD=void 0,e.$OD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$PD={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$QD="workbench.editor.sidebysideEditor",e.$RD="workbench.editors.textDiffEditor",e.$SD="workbench.editors.binaryResourceDiffEditor";var p;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var $;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function f(se){const $e=se;return!!$e&&typeof $e.getSelection=="function"&&!!$e.onDidChangeSelection}e.$TD=f;function t(se,$e,x){for(const z of x.visibleEditorPanes)if(z.group.id===$e&&se.matches(z.input))return z.getViewState()}e.$UD=t;function i(se){if(h(se))return!1;const $e=se;return C.URI.isUri($e?.resource)}e.$VD=i;function c(se){if(h(se))return!1;const $e=se;return $e?.original!==void 0&&$e.modified!==void 0}e.$WD=c;function b(se){if(h(se)||c(se))return!1;const $e=se;return $e?.primary!==void 0&&$e.secondary!==void 0}e.$XD=b;function E(se){if(h(se))return!1;const $e=se;return $e?$e.resource===void 0||$e.resource.scheme===g.Schemas.untitled||$e.forceUntitled===!0:!1}e.$YD=E;function v(se){if(h(se))return!1;const $e=se;return C.URI.isUri($e?.base?.resource)&&C.URI.isUri($e?.input1?.resource)&&C.URI.isUri($e?.input2?.resource)&&C.URI.isUri($e?.result?.resource)}e.$ZD=v;var n;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var r;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class s{constructor(){this.a=new Map}registerSource($e,x){let z=this.a.get($e);return z||(z={source:$e,label:x},this.a.set($e,z)),z.source}getSourceLabel($e){return this.a.get($e)?.label??$e}}e.$1D=new s;var o;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class w extends T.$Sc{}e.$2D=w;function h(se){return se instanceof w}e.$3D=h;function I(se){const $e=se;return C.URI.isUri($e?.preferredResource)}function S(se){const $e=se;return h($e?.primary)&&h($e?.secondary)}e.$4D=S;function u(se){const $e=se;return h($e?.modified)&&h($e?.original)}e.$5D=u;function m(se,$e,x,z,V){return ce(z,[(0,k.$yi)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const ue={...x,limits:{size:Number.MAX_VALUE}};se.openEditor($e,ue)}}),(0,k.$yi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>V.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}e.$6D=m;function d(se){return h(se?.editor)}e.$7D=d;function P(se){const $e=se;return d(se)&&$e?.group!==void 0}e.$8D=P;function W(se){const $e=se;return typeof $e?.groupId=="number"&&h($e.editor)}e.$9D=W;var K;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(K||(e.EditorCloseContext=K={}));var U;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LOCKED=2]="GROUP_LOCKED",se[se.EDITOR_OPEN=3]="EDITOR_OPEN",se[se.EDITOR_CLOSE=4]="EDITOR_CLOSE",se[se.EDITOR_MOVE=5]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=7]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=9]="EDITOR_PIN",se[se.EDITOR_STICKY=10]="EDITOR_STICKY",se[se.EDITOR_DIRTY=11]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var B;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class O{getOriginalUri($e,x){if(!$e)return;if(v($e))return e.$$D.getOriginalUri($e.result,x);if(x?.supportSideBySide){const{primary:V,secondary:ue}=this.a($e);if(V&&ue){if(x?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(V,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(ue,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===B.ANY)return this.getOriginalUri(V,{filterByScheme:x.filterByScheme})??this.getOriginalUri(ue,{filterByScheme:x.filterByScheme});$e=x.supportSideBySide===B.PRIMARY?V:ue}}if(c($e)||b($e)||v($e))return;const z=I($e)?$e.preferredResource:$e.resource;return!z||!x||!x.filterByScheme?z:this.b(z,x.filterByScheme)}a($e){return S($e)||b($e)?{primary:$e.primary,secondary:$e.secondary}:u($e)||c($e)?{primary:$e.modified,secondary:$e.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($e,x){if(!$e)return;if(v($e))return e.$$D.getCanonicalUri($e.result,x);if(x?.supportSideBySide){const{primary:V,secondary:ue}=this.a($e);if(V&&ue){if(x?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(V,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(ue,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===B.ANY)return this.getCanonicalUri(V,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(ue,{filterByScheme:x.filterByScheme});$e=x.supportSideBySide===B.PRIMARY?V:ue}}if(c($e)||b($e)||v($e))return;const z=$e.resource;return!z||!x||!x.filterByScheme?z:this.b(z,x.filterByScheme)}b($e,x){if(Array.isArray(x)){if(x.some(z=>$e.scheme===z))return $e}else if(x===$e.scheme)return $e}}var N;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(N||(e.EditorCloseMethod=N={}));function te(se,$e,x,z){if(!se.isSticky($e))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return x===N.MOUSE||x===N.KEYBOARD;case"mouse":return x===N.MOUSE;case"keyboard":return x===N.KEYBOARD}return!1}e.$0D=te,e.$$D=new O;var Y;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(Y||(e.CloseDirection=Y={}));class Ee{constructor(){this.c=new Map,this.d=new Map}start($e){const x=this.a=$e.get(A.$Nh);for(const[z,V]of this.c)this.e(z,V,x);this.c.clear()}e($e,x,z){const V=z.createInstance(x);this.d.set($e,V)}registerFileEditorFactory($e){if(this.b)throw new Error("Can only register one file editor factory.");this.b=$e}getFileEditorFactory(){return(0,M.$Jf)(this.b)}registerEditorSerializer($e,x){if(this.c.has($e)||this.d.has($e))throw new Error(`A editor serializer with type ID '${$e}' was already registered.`);return this.a?this.e($e,x,this.a):this.c.set($e,x),(0,T.$Qc)(()=>{this.c.delete($e),this.d.delete($e)})}getEditorSerializer($e){return this.d.get(typeof $e=="string"?$e:$e.typeId)}}l.$dn.add(e.$OD.EditorFactory,new Ee);async function Se(se,$e,x){return!se||!se.length?[]:await Promise.all(se.map(async z=>{const V=C.URI.revive(z.fileUri);if(!V){x.info("Cannot resolve the path because it is not valid.",z);return}if(!await $e.canHandleResource(V)){x.info("Cannot resolve the path because it cannot be handled",z);return}let ye=z.exists,we=z.type;if(typeof ye!="boolean"||typeof we!="number")try{we=(await $e.stat(V)).isDirectory?D.FileType.Directory:D.FileType.Unknown,ye=!0}catch(De){x.error(De),ye=!1}if(!ye&&z.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",z);return}if(we===D.FileType.Directory){x.info("Cannot resolve the path because it is a directory",z);return}const pe={...z.options,pinned:!0};return ye?{resource:V,options:pe}:{resource:V,options:pe,forceUntitled:!0}}))}e.$_D=Se;var Pe;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function ge(se){const $e=se;if(!$e)return!1;const x=$e;if(x.modified)return ge(x.modified);const z=$e;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.$aE=ge;function me(se){return(0,R.$Ai)(se)}e.$bE=me;function ce(se,$e,x){const z=(0,R.$Bi)(se,$e);return z.forceMessage=x?.forceMessage,z.forceSeverity=x?.forceSeverity,z.allowDialog=x?.allowDialog,z}e.$cE=ce}),define(Ae[192],Re([1,0,5,160,4,6,28,30,18,24,89,183]),function(be,e,y,M,C,T,A,l,D,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nE=e.$mE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$lE=e.$kE=e.ViewContentGroups=e.$jE=e.$iE=e.ViewContainerLocation=e.Extensions=e.$hE=e.$gE=e.$fE=void 0,e.$fE="views",e.$gE=(0,M.localize)(0,null),e.$hE=(0,k.$2v)("default-view-icon",R.$Tj.window,(0,M.localize)(1,null));var a;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(a||(e.Extensions=a={}));var p;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$iE=[0,1,2];function $(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$jE=$;class f extends T.$Sc{constructor(){super(...arguments),this.c=this.B(new y.$Nd),this.onDidRegister=this.c.event,this.f=this.B(new y.$Nd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.$Rb)([...this.g.values()])}registerViewContainer(s,o,w){const h=this.get(s.id);if(h)return h;const I=s;return I.openCommandActionDescriptor=w?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.$xc)(this.g,o,[]).push(I),w?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:o}),I}deregisterViewContainer(s){for(const o of this.g.keys()){const w=this.g.get(o),h=w?.indexOf(s);if(h!==-1){w?.splice(h,1),w.length===0&&this.g.delete(o),this.f.fire({viewContainer:s,viewContainerLocation:o});return}}}get(s){return this.all.filter(o=>o.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(w=>w?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(o=>this.getViewContainerLocation(o)===s)}}l.$dn.add(a.ViewContainersRegistry,new f);var t;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(r,s){const o=r.group??t.More,w=s.group??t.More;return o!==w?o.localeCompare(w):(r.order??5)-(s.order??5)}class c extends T.$Sc{constructor(){super(...arguments),this.c=this.B(new y.$Nd),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$Nd),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$Nd),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$Nd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(s,o){this.registerViews2([{views:s,viewContainer:o}])}registerViews2(s){s.forEach(({views:o,viewContainer:w})=>this.r(o,w)),this.c.fire(s)}deregisterViews(s,o){const w=this.s(s,o);w.length&&this.f.fire({views:w,viewContainer:o})}moveViews(s,o){for(const w of this.m.keys())if(w!==o){const h=this.s(s,w);h.length&&(this.r(h,o),this.g.fire({views:h,from:w,to:o}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const o of this.j){const w=(this.m.get(o)||[]).filter(h=>h.id===s)[0];if(w)return w}return null}getViewContainer(s){for(const o of this.j)if((this.m.get(o)||[]).filter(h=>h.id===s)[0])return o;return null}registerViewWelcomeContent(s,o){return this.n.add(s,o),this.h.fire(s),(0,T.$Qc)(()=>{this.n.delete(s,o),this.h.fire(s)})}registerViewWelcomeContent2(s,o){const w=new Map;for(const[h,I]of o)this.n.add(s,I),w.set(h,(0,T.$Qc)(()=>{this.n.delete(s,I),this.h.fire(s)}));return this.h.fire(s),w}getViewWelcomeContent(s){const o=[];return this.n.forEach(s,w=>o.push(w)),o.sort(i)}r(s,o){let w=this.m.get(o);w||(w=[],this.m.set(o,w),this.j.push(o));for(const h of s){if(this.getView(h.id)!==null)throw new Error((0,M.localize)(2,null,h.id));w.push(h)}}s(s,o){const w=this.m.get(o);if(!w)return[];const h=[],I=[];for(const S of w)s.includes(S)?h.push(S):I.push(S);return h.length&&(I.length?this.m.set(o,I):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),h}}l.$dn.add(a.ViewsRegistry,new c),e.$kE=(0,C.$Oh)("viewsService"),e.$lE=(0,C.$Oh)("viewDescriptorService");var b;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(b||(e.ViewVisibilityState=b={}));var E;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(E||(e.TreeItemCollapsibleState=E={}));class v{constructor(s,o){this.c=!1,this.d=!1,(0,g.$7m)(this,s),this.d=!!o,this.resolve=async w=>{if(o&&!this.c){const h=await o(w);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}w.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$mE=v;class n extends Error{constructor(s){super((0,M.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$nE=n}),define(Ae[193],Re([1,0,5,12,161]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2cb=void 0;class T{constructor(){this.f=new Map,this.k=[],this.m=new y.$Nd,this.n=new y.$Nd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(l){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=l}onEvent(l){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=l}onRequest(l){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=l}sendResponse(l){l.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${l.command}`)):this.s("response",l)}sendRequest(l,D,g,R){const k={command:l};if(D&&Object.keys(D).length>0&&(k.arguments=D),this.s("request",k),typeof R=="number"){const a=setTimeout(()=>{clearTimeout(a);const p=this.f.get(k.seq);if(p){this.f.delete(k.seq);const $={type:"response",seq:0,request_seq:k.seq,success:!1,command:l,message:(0,C.localize)(0,null,R,l)};p($)}},R)}return g&&this.f.set(k.seq,g),k.seq}acceptMessage(l){this.j?this.j(l):(this.k.push(l),this.k.length===1&&this.q())}o(l,D){return l.type!=="event"||D.type!=="event"}async q(){let l;for(;this.k.length;){if((!l||this.o(this.k[0],l))&&await(0,M.$Ug)(0),l=this.k.shift(),!l)return;switch(l.type){case"event":this.i?.(l);break;case"request":this.g?.(l);break;case"response":{const D=l,g=this.f.get(D.request_seq);g&&(this.f.delete(D.request_seq),g(D));break}}}}s(l,D){D.type=l,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const l=new Map;this.f.forEach((D,g)=>l.set(g,D)),await(0,M.$Ug)(500),l.forEach((D,g)=>{D({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$2cb=T}),define(Ae[194],Re([1,0,162,32,4]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$ZG=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$YG=e.MemoryRangeType=e.$XG=e.State=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=void 0,e.$VF="workbench.view.debug",e.$WF="workbench.debug.variablesView",e.$XF="workbench.debug.watchExpressionsView",e.$YF="workbench.debug.callStackView",e.$ZF="workbench.debug.loadedScriptsView",e.$1F="workbench.debug.breakPointsView",e.$2F="workbench.debug.disassemblyView",e.$3F="workbench.panel.repl",e.$4F="workbench.panel.repl.view",e.$5F=new M.$6i("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$6F=new M.$6i("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$7F=new M.$6i("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$8F="debugUx",e.$9F=new M.$6i(e.$8F,"default",{type:"string",description:y.localize(3,null)}),e.$0F=new M.$6i("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$$F=new M.$6i("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$_F=new M.$6i("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$aG=new M.$6i("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$bG=new M.$6i("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$cG=new M.$6i("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$dG=new M.$6i("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$eG=new M.$6i("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$fG=new M.$6i("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$gG=new M.$6i("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$hG=new M.$6i("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$iG=new M.$6i("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$jG=new M.$6i("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$kG=new M.$6i("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$lG=new M.$6i("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$mG=new M.$6i("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$nG=new M.$6i("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$oG=new M.$6i("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$pG=new M.$6i("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$qG=new M.$6i("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$rG=new M.$6i("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$sG=new M.$6i("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$tG=new M.$6i("stepBackSupported",!1,{type:"boolean",description:y.localize(26,null)}),e.$uG=new M.$6i("restartFrameSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$vG=new M.$6i("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(28,null)}),e.$wG=new M.$6i("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(29,null)}),e.$xG=new M.$6i("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$yG=new M.$6i("breakpointsExist",!1,{type:"boolean",description:y.localize(31,null)}),e.$zG=new M.$6i("debuggersAvailable",!1,{type:"boolean",description:y.localize(32,null)}),e.$AG=new M.$6i("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(33,null)}),e.$BG=new M.$6i("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(34,null)}),e.$CG=new M.$6i("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(35,null)}),e.$DG=new M.$6i("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$EG=new M.$6i("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$FG=new M.$6i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$GG=new M.$6i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$HG=new M.$6i("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$IG=new M.$6i("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$JG=new M.$6i("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(42,null)}),e.$KG=new M.$6i("variableIsReadonly",!1,{type:"boolean",description:y.localize(43,null)}),e.$LG=new M.$6i("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(44,null)}),e.$MG=new M.$6i("multiSessionRepl",!1,{type:"boolean",description:y.localize(45,null)}),e.$NG=new M.$6i("multiSessionDebug",!1,{type:"boolean",description:y.localize(46,null)}),e.$OG=new M.$6i("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(47,null)}),e.$PG=new M.$6i("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(48,null)}),e.$QG=new M.$6i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(49,null)}),e.$RG=new M.$6i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(50,null)});const T=a=>y.localize(51,null,a);e.$SG=T,e.$TG="editor.contrib.debug",e.$UG="editor.contrib.breakpoint",e.$VG="debug",e.$WG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(52,null)};var A;(function(a){a[a.Inactive=0]="Inactive",a[a.Initializing=1]="Initializing",a[a.Stopped=2]="Stopped",a[a.Running=3]="Running"})(A||(e.State=A={}));function l(a){switch(a){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$XG=l;var D;(function(a){a[a.Valid=0]="Valid",a[a.Unreadable=1]="Unreadable",a[a.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$YG="vscode-debug-memory";var g;(function(a){a[a.Initial=1]="Initial",a[a.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var R;(function(a){a.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$ZG=(0,C.$Oh)("debugService");var k;(function(a){a[a.CONDITION=0]="CONDITION",a[a.HIT_COUNT=1]="HIT_COUNT",a[a.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Ae[195],Re([1,0,16,2,19,24,13,45,20,18]),function(be,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=void 0;const R=/{([^}]+)}/g;function k(S,u,m){return S.replace(R,function(d,P){return u&&P.length>0&&P[0]!=="_"?d:m&&m.hasOwnProperty(P)?m[P]:d})}e.$kF=k;function a(S){const u={};for(const m of Object.keys(S))m.startsWith("!")||(u[m]=S[m]);return u}e.$lF=a;function p(S){return S.configuration.request==="attach"&&!$(S)&&(!S.parentSession||p(S.parentSession))}e.$mF=p;function $(S){let u=S.configuration.type;if(u)return u==="vslsShare"&&(u=S.configuration.adapterProxy.configuration.type),(0,y.$2e)(u,"extensionhost")||(0,y.$2e)(u,"pwa-extensionhost")?S:S.parentSession?$(S.parentSession):void 0}e.$nF=$;function f(S){return S.type&&(S.label||S.program||S.runtime)}e.$oF=f;function t(S,u,m){let d,P=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let K=null;for(;K=W.exec(S);){const U=K.index+1,B=U+K[0].length;if(U<=u&&B>=m){d=K[0],P=U;break}}if(d){const U=/\w+/g;let B=null;for(;(B=U.exec(d))&&!(B.index+1+P+B[0].length>=m););B&&(d=d.substring(0,U.lastIndex))}return d?{start:P,end:P+d.length-1}:{start:0,end:0}}e.$pF=t;async function i(S,u,m,d){if(S.evaluatableExpressionProvider.has(u)){const P=S.evaluatableExpressionProvider.ordered(u),W=(0,g.$Hb)(await Promise.all(P.map(async K=>{try{return await K.provideEvaluatableExpression(u,m,d??D.CancellationToken.None)}catch{return}})));if(W.length>0){let K=W[0].expression;const U=W[0].range;return K||(K=u.getLineContent(m.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:K}}}else{const P=u.getLineContent(m.lineNumber),{start:W,end:K}=t(P,m.column,m.column),U=P.substring(W-1,K);return{matchingExpression:U,range:new l.$qs(m.lineNumber,W,m.lineNumber,W+U.length)}}return null}e.$qF=i;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(S){return!!(S&&S.match(c))}e.$rF=b;function E(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(b(S.path))return M.URI.parse(S.path);if((0,C.$ic)(S.path))return M.URI.file(S.path)}return S.path}function v(S){if(typeof S.path=="object"){const u=M.URI.revive(S.path);if(u)return u.scheme===A.Schemas.file?u.fsPath:u.toString()}return S.path}function n(S,u){const m=u?E:v,d=(0,T.$4m)(S);return s(d,(P,W)=>{P&&W&&(W.path=m(W))}),d}e.$sF=n;function r(S,u){const m=u?E:v,d=(0,T.$4m)(S);return s(d,(P,W)=>{!P&&W&&(W.path=m(W))}),d}e.$tF=r;function s(S,u){switch(S.type){case"event":{const m=S;switch(m.event){case"output":u(!1,m.body.source);break;case"loadedSource":u(!1,m.body.source);break;case"breakpoint":u(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=S;switch(m.command){case"setBreakpoints":u(!0,m.arguments.source);break;case"breakpointLocations":u(!0,m.arguments.source);break;case"source":u(!0,m.arguments.source);break;case"gotoTargets":u(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(d=>u(!1,d));break;default:break}break}case"response":{const m=S;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(d=>u(!1,d.source));break;case"loadedSources":m.body.sources.forEach(d=>u(!1,d));break;case"scopes":m.body.scopes.forEach(d=>u(!1,d.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(d=>u(!1,d.source));break;case"setBreakpoints":m.body.breakpoints.forEach(d=>u(!1,d.source));break;case"disassemble":m.body?.instructions.forEach(P=>u(!1,P.location));break;default:break}break}}}function o(S){return S.filter(u=>!u.presentation?.hidden).sort((u,m)=>u.presentation?m.presentation?u.presentation.group?m.presentation.group?u.presentation.group!==m.presentation.group?u.presentation.group.localeCompare(m.presentation.group):w(u.presentation.order,m.presentation.order):-1:m.presentation.group?1:w(u.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.$uF=o;function w(S,u){return typeof S!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:S-u}async function h(S,u){const m=S.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(m!=="none"&&(await u.saveAll(),m==="allEditorsInActiveGroup")){const d=u.activeEditorPane;d&&d.input.resource?.scheme===A.Schemas.untitled&&await u.save({editor:d.input,groupId:d.group.id})}await S.reloadConfiguration()}e.$vF=h;const I=(S,u)=>!S||!u?S===u:S.name===u.name&&S.path===u.path&&S.sourceReference===u.sourceReference;e.$wF=I}),define(Ae[75],Re([1,0,26,38,66,67,13,19,22,32]),function(be,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oI=e.$nI=e.$mI=e.$lI=e.CellStatusbarAlignment=e.$kI=e.$jI=e.$iI=e.NotebookEditorPriority=e.$hI=e.$gI=e.$fI=e.$eI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$dI=e.$cI=e.$bI=e.$aI=e.CellKind=e.$_H=e.$$H=e.$0H=void 0,e.$0H="workbench.editor.notebook",e.$$H="workbench.editor.notebookTextDiffEditor",e.$_H="workbench.editor.interactive";var R;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(R||(e.CellKind=R={})),e.$aI=["application/json","application/javascript","text/html","image/svg+xml",T.$Nr.latex,T.$Nr.markdown,"image/png","image/jpeg",T.$Nr.text],e.$bI=[T.$Nr.latex,T.$Nr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.$Nr.text],e.$cI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$dI="_notAvailable";var k;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var a;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(a||(e.NotebookCellExecutionState=a={}));var p;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var $;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})($||(e.NotebookRendererMatch=$={}));var f;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var c;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var b;(function(N){N.scheme=A.Schemas.vscodeNotebookCell;const te=["W","X","Y","Z","a","b","c","d","e","f"],Y=new RegExp(`^[${te.join("")}]+`),Ee=7;function Se($e,x){const z=x.toString(Ee),ue=`${z.length<te.length?te[z.length-1]:"z"}${z}s${(0,y.$ve)(y.$be.fromString($e.scheme),!0,!0)}`;return $e.with({scheme:N.scheme,fragment:ue})}N.generate=Se;function Pe($e){if($e.scheme!==N.scheme)return;const x=$e.fragment.indexOf("s");if(x<0)return;const z=parseInt($e.fragment.substring(0,x).replace(Y,""),Ee),V=(0,y.$ue)($e.fragment.substring(x+1)).toString();if(!isNaN(z))return{handle:z,notebook:$e.with({scheme:V,fragment:null})}}N.parse=Pe;function ge($e,x){return $e.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${x??""},${$e.scheme!==A.Schemas.file?$e.scheme:""}`})}N.generateCellOutputUri=ge;function me($e){if($e.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const x=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!x)return;const z=x[1]&&x[1]!==""?x[1]:void 0,V=x[2];return{outputId:z,notebook:$e.with({scheme:V||A.Schemas.file,fragment:null})}}N.parseCellOutputUri=me;function ce($e,x,z){return N.generate($e,x).with({scheme:z})}N.generateCellPropertyUri=ce;function se($e,x){if($e.scheme===x)return N.parse($e.with({scheme:N.scheme}))}N.parseCellPropertyUri=se})(b||(e.CellUri=b={}));const E=N=>D.$j?N.replace(/\//g,"\\"):N;class v{constructor(te=[],Y=e.$aI){this.e=Y,this.d=[...new Set(te)].map(Ee=>({pattern:Ee,matches:M.$vj(E(Ee))}))}sort(te){const Y=new Map(C.Iterable.map(te,Se=>[Se,E(Se)]));let Ee=[];for(const{matches:Se}of this.d)for(const[Pe,ge]of Y)if(Se(ge)){Ee.push(Pe),Y.delete(Pe);break}return Y.size&&(Ee=Ee.concat([...Y.keys()].sort((Se,Pe)=>this.e.indexOf(Se)-this.e.indexOf(Pe)))),Ee}prioritize(te,Y){const Ee=this.f(te);if(Ee===-1){this.d.unshift({pattern:te,matches:M.$vj(E(te))});return}const Se=new Set(Y.map(ge=>this.f(ge,Ee)));Se.delete(-1);const Pe=Array.from(Se).sort();this.d.splice(Ee+1,0,...Pe.map(ge=>this.d[ge]));for(let ge=Pe.length-1;ge>=0;ge--)this.d.splice(Pe[ge],1)}toArray(){return this.d.map(te=>te.pattern)}f(te,Y=this.d.length){const Ee=E(te);for(let Se=0;Se<Y;Se++)if(this.d[Se].matches(Ee))return Se;return-1}}e.$eI=v;function n(N,te,Y,Ee=(Se,Pe)=>Se===Pe){const Se=[];function Pe(ce,se,$e){if(se===0&&$e.length===0)return;const x=Se[Se.length-1];x&&x.start+x.deleteCount===ce?(x.deleteCount+=se,x.toInsert.push(...$e)):Se.push({start:ce,deleteCount:se,toInsert:$e})}let ge=0,me=0;for(;;){if(ge===N.length){Pe(ge,0,te.slice(me));break}if(me===te.length){Pe(ge,N.length-ge,[]);break}const ce=N[ge],se=te[me];if(Ee(ce,se)){ge+=1,me+=1;continue}Y(se)?(Pe(ge,1,[]),ge+=1):(Pe(ge,0,[se]),me+=1)}return Se}e.$fI=n,e.$gI=new g.$6i("notebookEditorCursorAtBoundary","none"),e.$hI=new g.$6i("notebookEditorCursorAtLineBoundary","none");var r;(function(N){N.default="default",N.option="option"})(r||(e.NotebookEditorPriority=r={}));function s(N){const te=N;return!!((typeof te.include=="string"||M.$wj(te.include))&&(typeof te.exclude=="string"||M.$wj(te.exclude)))}e.$iI=s;function o(N,te,Y){if(Array.isArray(N.viewType)&&N.viewType.indexOf(te)>=0||N.viewType===te)return!0;if(N.filenamePattern){const Ee=s(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,Se=s(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(M.$uj(Ee,(0,l.$nc)(Y.fsPath).toLowerCase()))return!(Se&&M.$uj(Se,(0,l.$nc)(Y.fsPath).toLowerCase()))}return!1}e.$jI=o,e.$kI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var w;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class h{static{this.d="notebook/"}static create(te){return`${h.d}${te}`}static parse(te){if(te.startsWith(h.d))return te.substring(h.d.length)}}e.$lI=h;function I(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$mI=I;const S=new TextDecoder;function u(N){const te=[];let Y=!1;for(const ge of N)(te.length===0||Y)&&(te.push(ge),Y=!0);let Ee=P(te);const Se=y.$be.concat(te.map(ge=>y.$be.wrap(ge))),Pe=O(Se);return Ee=Ee||Pe.byteLength!==Se.byteLength,{data:Pe,didCompression:Ee}}e.$nI=u,e.$oI=`${String.fromCharCode(27)}[A`;const m=e.$oI.split("").map(N=>N.charCodeAt(0)),d=10;function P(N){let te=!1;return N.forEach((Y,Ee)=>{if(Ee===0||Y.length<e.$oI.length)return;const Se=N[Ee-1],Pe=Y.subarray(0,e.$oI.length);if(Pe[0]===m[0]&&Pe[1]===m[1]&&Pe[2]===m[2]){const ge=Se.lastIndexOf(d);if(ge===-1)return;te=!0,N[Ee-1]=Se.subarray(0,ge),N[Ee]=Y.subarray(e.$oI.length)}}),te}function W(N){let te=N;do N=te,te=N.replace(/[^\n]\x08/gm,"");while(te.length<N.length);return N}function K(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const te=N.match(/^(.*)\r+/m)[1];let Y=N.match(/\r+(.*)$/m)[1];Y=Y+te.slice(Y.length,te.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return N}const U="\b".charCodeAt(0),B="\r".charCodeAt(0);function O(N){return!N.buffer.includes(U)&&!N.buffer.includes(B)?N:y.$be.fromString(K(W(S.decode(N.buffer))))}}),define(Ae[7],Re([1,0,18,9,50,28,67,16,15,2,36,21,39,97,75]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$){"use strict";var f,t,i,c,b,E,v,n,r,s,o,w,h,I,S,u,m,d;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.$5L=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.TestRunProfileKind=e.TestResultState=e.$LL=e.$KL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$JL=e.$IL=e.$HL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$GL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.ColorThemeKind=e.$AL=e.$zL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$yL=e.DebugConsoleMode=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$sL=e.$rL=e.FileChangeType=e.$qL=e.$pL=e.$oL=e.$nL=e.InlineCompletionTriggerKind=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.ConfigurationTarget=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$3K=e.ViewBadge=e.ProgressLocation=e.$2K=e.$1K=e.TaskScope=e.ShellQuoting=e.$ZK=e.$YK=e.$XK=e.TaskPanelKind=e.TaskRevealKind=e.$WK=e.TerminalLocation=e.$VK=e.$UK=e.$TK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$SK=e.$RK=e.$QK=e.$PK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$OK=e.StatusBarAlignment=e.ViewColumn=e.$NK=e.$MK=e.$LK=e.$KK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$JK=e.$IK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.LanguageStatusSeverity=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.CodeActionTriggerKind=e.$wK=e.$vK=e.SymbolTag=e.SymbolKind=e.$uK=e.DocumentHighlightKind=e.$tK=e.$sK=e.$rK=e.$qK=e.DiagnosticSeverity=e.DiagnosticTag=e.$pK=e.$oK=e.FileEditType=e.$nK=e.$mK=e.$lK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(j){return Object.assign(j,{apply:function(...ie){if(ie.length===0)return Reflect.construct(j,[]);{const ke=ie.length===1?[]:ie[1];return Reflect.construct(j,ke,ie[0].constructor)}},call:function(...ie){if(ie.length===0)return Reflect.construct(j,[]);{const[ke,...He]=ie;return Reflect.construct(j,He,ke.constructor)}}})}var W;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var K;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(K||(e.TerminalQuickFixType=K={}));let U=f=class{static from(...L){let ie=L;return new f(function(){if(ie){for(const ke of ie)ke&&typeof ke.dispose=="function"&&ke.dispose();ie=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$eK=U,e.$eK=U=f=qe([P],U);let B=t=class{static Min(...L){if(L.length===0)throw new TypeError;let ie=L[0];for(let ke=1;ke<L.length;ke++){const He=L[ke];He.isBefore(ie)&&(ie=He)}return ie}static Max(...L){if(L.length===0)throw new TypeError;let ie=L[0];for(let ke=1;ke<L.length;ke++){const He=L[ke];He.isAfter(ie)&&(ie=He)}return ie}static isPosition(L){if(!L)return!1;if(L instanceof t)return!0;const{line:ie,character:ke}=L;return typeof ie=="number"&&typeof ke=="number"}static of(L){if(L instanceof t)return L;if(this.isPosition(L))return new t(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,ie){if(L<0)throw(0,M.$7)("line must be non-negative");if(ie<0)throw(0,M.$7)("character must be non-negative");this.c=L,this.e=ie}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,ie=0){if(L===null||ie===null)throw(0,M.$7)();let ke;return typeof L>"u"?ke=0:typeof L=="number"?ke=L:(ke=typeof L.lineDelta=="number"?L.lineDelta:0,ie=typeof L.characterDelta=="number"?L.characterDelta:0),ke===0&&ie===0?this:new t(this.line+ke,this.character+ie)}with(L,ie=this.character){if(L===null||ie===null)throw(0,M.$7)();let ke;return typeof L>"u"?ke=this.line:typeof L=="number"?ke=L:(ke=typeof L.line=="number"?L.line:this.line,ie=typeof L.character=="number"?L.character:this.character),ke===this.line&&ie===this.character?this:new t(ke,ie)}toJSON(){return{line:this.line,character:this.character}}};e.$fK=B,e.$fK=B=t=qe([P],B);let O=i=class{static isRange(L){return L instanceof i?!0:L?B.isPosition(L.start)&&B.isPosition(L.end):!1}static of(L){if(L instanceof i)return L;if(this.isRange(L))return new i(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,ie,ke,He){let Ye,ot;if(typeof L=="number"&&typeof ie=="number"&&typeof ke=="number"&&typeof He=="number"?(Ye=new B(L,ie),ot=new B(ke,He)):B.isPosition(L)&&B.isPosition(ie)&&(Ye=B.of(L),ot=B.of(ie)),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this.c=Ye,this.e=ot):(this.c=ot,this.e=Ye)}contains(L){return i.isRange(L)?this.contains(L.start)&&this.contains(L.end):B.isPosition(L)?!(B.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const ie=B.Max(L.start,this.c),ke=B.Min(L.end,this.e);if(!ie.isAfter(ke))return new i(ie,ke)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ie=B.Min(L.start,this.c),ke=B.Max(L.end,this.end);return new i(ie,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,ie=this.end){if(L===null||ie===null)throw(0,M.$7)();let ke;return L?B.isPosition(L)?ke=L:(ke=L.start||this.start,ie=L.end||this.end):ke=this.start,ke.isEqual(this.c)&&ie.isEqual(this.end)?this:new i(ke,ie)}toJSON(){return[this.start,this.end]}};e.$gK=O,e.$gK=O=i=qe([P],O);let N=c=class extends O{static isSelection(L){return L instanceof c?!0:L?O.isRange(L)&&B.isPosition(L.anchor)&&B.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,ie,ke,He){let Ye,ot;if(typeof L=="number"&&typeof ie=="number"&&typeof ke=="number"&&typeof He=="number"?(Ye=new B(L,ie),ot=new B(ke,He)):B.isPosition(L)&&B.isPosition(ie)&&(Ye=B.of(L),ot=B.of(ie)),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot),this.f=Ye,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$hK=N,e.$hK=N=c=qe([P],N);const te=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,M.$7)("connectionToken")};class Y{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ie,ke){if(typeof L!="string"||L.length===0)throw(0,M.$7)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,M.$7)("port");typeof ke<"u"&&te(ke),this.host=L,this.port=Math.round(ie),this.connectionToken=ke}}e.$iK=Y;class Ee{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ie){this.makeConnection=L,this.connectionToken=ie,typeof ie<"u"&&te(ie)}}e.$jK=Ee;class Se extends Error{static NotAvailable(L,ie){return new Se(L,p.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(L){return new Se(L,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,ie=p.RemoteAuthorityResolverErrorCode.Unknown,ke){super(L),this._message=L,this._code=ie,this._detail=ke,Object.setPrototypeOf(this,Se.prototype)}}e.$kK=Se;var Pe;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var ge;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(ge||(e.EnvironmentVariableMutatorType=ge={}));let me=b=class{static isTextEdit(L){return L instanceof b?!0:L?O.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ie){return new b(L,ie)}static insert(L,ie){return b.replace(new O(L,L),ie)}static delete(L){return b.replace(L,"")}static setEndOfLine(L){const ie=new b(new O(new B(0,0),new B(0,0)),"");return ie.newEol=L,ie}get range(){return this.c}set range(L){if(L&&!O.isRange(L))throw(0,M.$7)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,M.$7)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,M.$7)("newEol");this.f=L}constructor(L,ie){this.c=L,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$lK=me,e.$lK=me=b=qe([P],me);let ce=E=class{static isNotebookCellEdit(L){return L instanceof E?!0:L?_t.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,ie){return new E(L,ie)}static insertCells(L,ie){return new E(new _t(L,L),ie)}static deleteCells(L){return new E(L,[])}static updateCellMetadata(L,ie){const ke=new E(new _t(L,L),[]);return ke.newCellMetadata=ie,ke}static updateNotebookMetadata(L){const ie=new E(new _t(0,0),[]);return ie.newNotebookMetadata=L,ie}constructor(L,ie){this.range=L,this.newCells=ie}};e.$mK=ce,e.$mK=ce=E=qe([P],ce);class se{static isSnippetTextEdit(L){return L instanceof se?!0:L?O.isRange(L.range)&&z.isSnippetString(L.snippet):!1}static replace(L,ie){return new se(L,ie)}static insert(L,ie){return se.replace(new O(L,L),ie)}constructor(L,ie){this.range=L,this.snippet=ie}}e.$nK=se;var $e;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let x=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,ie,ke,He){this.c.push({_type:1,from:L,to:ie,options:ke,metadata:He})}createFile(L,ie,ke){this.c.push({_type:1,from:void 0,to:L,options:ie,metadata:ke})}deleteFile(L,ie,ke){this.c.push({_type:1,from:L,to:void 0,options:ie,metadata:ke})}e(L,ie,ke){this.c.push({_type:3,metadata:ke,uri:L,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(L,ie,ke,He){const Ye=ie.start,ot=ie.end;(Ye!==ot||ke.length>0)&&this.c.push({_type:5,uri:L,index:Ye,count:ot-Ye,cells:ke,metadata:He})}g(L,ie,ke,He){this.c.push({_type:3,metadata:He,uri:L,edit:{editType:3,index:ie,metadata:ke}})}replace(L,ie,ke,He){this.c.push({_type:2,uri:L,edit:new me(ie,ke),metadata:He})}insert(L,ie,ke,He){this.replace(L,new O(ie,ie),ke,He)}delete(L,ie,ke){this.replace(L,ie,"",ke)}has(L){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===L.toString())}set(L,ie){if(ie)for(const ke of ie){if(!ke)continue;let He,Ye;Array.isArray(ke)?(He=ke[0],Ye=ke[1]):He=ke,ce.isNotebookCellEdit(He)?He.newCellMetadata?this.g(L,He.range.start,He.newCellMetadata,Ye):He.newNotebookMetadata?this.e(L,He.newNotebookMetadata,Ye):this.f(L,He.range,He.newCells,Ye):se.isSnippetTextEdit(He)?this.c.push({_type:6,uri:L,range:He.range,edit:He.snippet,metadata:Ye}):this.c.push({_type:2,uri:L,edit:He,metadata:Ye})}else{for(let ke=0;ke<this.c.length;ke++){const He=this.c[ke];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===L.toString()&&(this.c[ke]=void 0);break}}(0,y.$Ib)(this.c)}}get(L){const ie=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===L.toString()&&ie.push(ke.edit);return ie}entries(){const L=new T.$Ac;for(const ie of this.c)if(ie._type===2){let ke=L.get(ie.uri);ke||(ke=[ie.uri,[]],L.set(ie.uri,ke)),ke[1].push(ie.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$oK=x,e.$oK=x=qe([P],x);let z=v=class{static isSnippetString(L){return L instanceof v?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=v.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ie=this.e++){if(typeof L=="function"){const ke=new v;ke.e=this.e,L(ke),this.e=ke.e,L=ke.value}else L=v.c(L);return this.value+="${",this.value+=ie,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ie=this.e++){const ke=L.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(L,ie){if(typeof ie=="function"){const ke=new v;ke.e=this.e,ie(ke),this.e=ke.e,ie=ke.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};e.$pK=z,e.$pK=z=v=qe([P],z);var V;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ue;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(ue||(e.DiagnosticSeverity=ue={}));let ye=n=class{static isLocation(L){return L instanceof n?!0:L?O.isRange(L.range)&&g.URI.isUri(L.uri):!1}constructor(L,ie){if(this.uri=L,ie)if(O.isRange(ie))this.range=O.of(ie);else if(B.isPosition(ie))this.range=new O(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$qK=ye,e.$qK=ye=n=qe([P],ye);let we=class{static is(L){return L?typeof L.message=="string"&&L.location&&O.isRange(L.location.range)&&g.URI.isUri(L.location.uri):!1}constructor(L,ie){this.location=L,this.message=ie}static isEqual(L,ie){return L===ie?!0:!L||!ie?!1:L.message===ie.message&&L.location.range.isEqual(ie.location.range)&&L.location.uri.toString()===ie.location.uri.toString()}};e.$rK=we,e.$rK=we=qe([P],we);let pe=class{constructor(L,ie,ke=ue.Error){if(!O.isRange(L))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=L,this.message=ie,this.severity=ke}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ie){return L===ie?!0:!L||!ie?!1:L.message===ie.message&&L.severity===ie.severity&&L.code===ie.code&&L.severity===ie.severity&&L.source===ie.source&&L.range.isEqual(ie.range)&&(0,y.$ub)(L.tags,ie.tags)&&(0,y.$ub)(L.relatedInformation,ie.relatedInformation,we.isEqual)}};e.$sK=pe,e.$sK=pe=qe([P],pe);let De=class{constructor(L,ie){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ie}};e.$tK=De,e.$tK=De=qe([P],De);var ne;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(ne||(e.DocumentHighlightKind=ne={}));let le=class{constructor(L,ie=ne.Text){this.range=L,this.kind=ie}toJSON(){return{range:this.range,kind:ne[this.kind]}}};e.$uK=le,e.$uK=le=qe([P],le);var re;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(re||(e.SymbolKind=re={}));var oe;(function(j){j[j.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let he=r=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,ie,ke,He,Ye){this.name=L,this.kind=ie,this.containerName=Ye,typeof ke=="string"&&(this.containerName=ke),He instanceof ye?this.location=He:ke instanceof O&&(this.location=new ye(He,ke)),r.validate(this)}toJSON(){return{name:this.name,kind:re[this.kind],location:this.location,containerName:this.containerName}}};e.$vK=he,e.$vK=he=r=qe([P],he);let Ie=s=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(s.validate)}constructor(L,ie,ke,He,Ye){this.name=L,this.detail=ie,this.kind=ke,this.range=He,this.selectionRange=Ye,this.children=[],s.validate(this)}};e.$wK=Ie,e.$wK=Ie=s=qe([P],Ie);var F;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(F||(e.CodeActionTriggerKind=F={}));let q=class{constructor(L,ie){this.title=L,this.kind=ie}};e.$xK=q,e.$xK=q=qe([P],q);let J=class{static{o=this}static{this.c="."}constructor(L){this.value=L}append(L){return new o(this.value?this.value+o.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+o.c)}};e.$yK=J,e.$yK=J=o=qe([P],J),J.Empty=new J(""),J.QuickFix=J.Empty.append("quickfix"),J.Refactor=J.Empty.append("refactor"),J.RefactorExtract=J.Refactor.append("extract"),J.RefactorInline=J.Refactor.append("inline"),J.RefactorMove=J.Refactor.append("move"),J.RefactorRewrite=J.Refactor.append("rewrite"),J.Source=J.Empty.append("source"),J.SourceOrganizeImports=J.Source.append("organizeImports"),J.SourceFixAll=J.Source.append("fixAll"),J.Notebook=J.Empty.append("notebook");let Q=class{constructor(L,ie){if(this.range=L,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$zK=Q,e.$zK=Q=qe([P],Q);class H{constructor(L,ie,ke,He,Ye,ot){this.kind=L,this.name=ie,this.detail=ke,this.uri=He,this.range=Ye,this.selectionRange=ot}}e.$AK=H;class _{constructor(L,ie){this.fromRanges=ie,this.from=L}}e.$BK=_;class ae{constructor(L,ie){this.fromRanges=ie,this.to=L}}e.$CK=ae;var Ne;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let Ue=class{constructor(L,ie){this.range=L,this.command=ie}get isResolved(){return!!this.command}};e.$DK=Ue,e.$DK=Ue=qe([P],Ue);let Qe=w=class{#e;static isMarkdownString(L){return L instanceof w?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,ie=!1){this.#e=new C.$2j(L,{supportThemeIcons:ie})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,ie){return this.#e.appendCodeblock(ie??"",L),this}};e.$EK=Qe,e.$EK=Qe=w=qe([P],Qe);let Ge=class{constructor(L,ie){this.label=L,this.documentation=ie}};e.$FK=Ge,e.$FK=Ge=qe([P],Ge);let _e=class{constructor(L,ie){this.label=L,this.documentation=ie,this.parameters=[]}};e.$GK=_e,e.$GK=_e=qe([P],_e);let Ze=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$HK=Ze,e.$HK=Ze=qe([P],Ze);var xe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(xe||(e.SignatureHelpTriggerKind=xe={}));var it;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(L){this.value=L}};e.$IK=tt,e.$IK=tt=qe([P],tt);let ze=class{constructor(L,ie,ke){this.position=L,this.label=ie,this.kind=ke}};e.$JK=ze,e.$JK=ze=qe([P],ze);var st;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var Z;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Z||(e.CompletionItemKind=Z={}));var X;(function(j){j[j.Deprecated=1]="Deprecated"})(X||(e.CompletionItemTag=X={}));let ve=class{constructor(L,ie){this.label=L,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Z[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$KK=ve,e.$KK=ve=qe([P],ve);let Be=class{constructor(L=[],ie=!1){this.items=L,this.isIncomplete=ie}};e.$LK=Be,e.$LK=Be=qe([P],Be);let Oe=class{constructor(L,ie,ke){this.insertText=L,this.range=ie,this.command=ke}};e.$MK=Oe,e.$MK=Oe=qe([P],Oe);let Xe=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$NK=Xe,e.$NK=Xe=qe([P],Xe);var nt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var ft;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(ft||(e.StatusBarAlignment=ft={}));function wt(j,L){return`${k.$4l.toKey(j)}.${L}`}e.$OK=wt;var Pt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Yt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Yt||(e.TextDocumentSaveReason=Yt={}));var Gt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Gt||(e.TextEditorRevealType=Gt={}));var pt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(pt||(e.TextEditorSelectionChangeKind=pt={}));var jt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Nt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(j){function L(ie){switch(ie){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=L}(pt||(e.TextEditorSelectionChangeKind=pt={}));var Bt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(j){function L(ie){switch(ie){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=L}(Bt||(e.SyntaxTokenType=Bt={}));let At=class{constructor(L,ie){if(ie&&!g.URI.isUri(ie))throw(0,M.$7)("target");if(!O.isRange(L)||L.isEmpty)throw(0,M.$7)("range");this.range=L,this.target=ie}};e.$PK=At,e.$PK=At=qe([P],At);let Rt=class{constructor(L,ie,ke,He){this.red=L,this.green=ie,this.blue=ke,this.alpha=He}};e.$QK=Rt,e.$QK=Rt=qe([P],Rt);let Ot=class{constructor(L,ie){if(ie&&!(ie instanceof Rt))throw(0,M.$7)("color");if(!O.isRange(L)||L.isEmpty)throw(0,M.$7)("range");this.range=L,this.color=ie}};e.$RK=Ot,e.$RK=Ot=qe([P],Ot);let Wt=class{constructor(L){if(!L||typeof L!="string")throw(0,M.$7)("label");this.label=L}};e.$SK=Wt,e.$SK=Wt=qe([P],Wt);var Jt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Kt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var Vt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Vt||(e.TerminalExitReason=Vt={}));class Mt{constructor(L,ie,ke){if(this.startIndex=L,this.length=ie,this.tooltip=ke,typeof L!="number"||L<0)throw(0,M.$7)("startIndex");if(typeof ie!="number"||ie<1)throw(0,M.$7)("length");if(ke!==void 0&&typeof ke!="string")throw(0,M.$7)("tooltip")}}e.$TK=Mt;class ut{constructor(L){this.uri=L}}e.$UK=ut;class ht{constructor(L){this.terminalCommand=L}}e.$VK=ht;var Lt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Lt||(e.TerminalLocation=Lt={}));class qt{constructor(L){if(this.options=L,typeof L!="object")throw(0,M.$7)("options")}}e.$WK=qt;var kt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(kt||(e.TaskRevealKind=kt={}));var at;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(at||(e.TaskPanelKind=at={}));let vt=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(L){switch(L){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(L,ie){if(this.label=ie,typeof L!="string"||typeof ie!="string")throw(0,M.$7)("name");this.c=L}get id(){return this.c}};e.$XK=vt,e.$XK=vt=h=qe([P],vt);function Ht(j){let L="";for(let ie=0;ie<j.length;ie++)L+=j[ie].replace(/,/g,",,")+",";return L}let Ct=class{constructor(L,ie,ke){if(typeof L!="string")throw(0,M.$7)("process");this.e=[],this.c=L,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=ke):this.f=ie)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,M.$7)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)L.push(ie);return Ht(L)}};e.$YK=Ct,e.$YK=Ct=qe([P],Ct);let We=class{constructor(L,ie,ke){if(this.f=[],Array.isArray(ie)){if(!L)throw(0,M.$7)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.$7)("command");this.e=L,this.f=ie,this.g=ke}else{if(typeof L!="string")throw(0,M.$7)("commandLine");this.c=L,this.g=ie}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,M.$7)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.$7)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)L.push(typeof ie=="string"?ie:ie.value);return Ht(L)}};e.$ZK=We,e.$ZK=We=qe([P],We);var Ce;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Ce||(e.ShellQuoting=Ce={}));var Me;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Me||(e.TaskScope=Me={}));class fe{constructor(L){this.c=L}computeId(){return"customExecution"+(0,R.$eg)()}set callback(L){this.c=L}get callback(){return this.c}}e.$1K=fe;let G=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,ie,ke,He,Ye,ot){this.j=!1,this.k=this.definition=L;let dt;typeof ie=="string"?(this.m=this.name=ie,this.t=this.source=ke,this.execution=He,dt=Ye,this.j=!0):ie===Me.Global||ie===Me.Workspace?(this.target=ie,this.m=this.name=ke,this.t=this.source=He,this.execution=Ye,dt=ot):(this.target=ie,this.m=this.name=ke,this.t=this.source=He,this.execution=Ye,dt=ot),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(L){this.h=L}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ct?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof We?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof fe?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,R.$eg)()}}get definition(){return this.k}set definition(L){if(L==null)throw(0,M.$7)("Kind can't be undefined or null");this.z(),this.k=L}get scope(){return this.l}set target(L){this.z(),this.l=L}get name(){return this.m}set name(L){if(typeof L!="string")throw(0,M.$7)("name");this.z(),this.m=L}get execution(){return this.n}set execution(L){L===null&&(L=void 0),this.z(),this.n=L;const ie=this.k.type;(I.g===ie||I.e===ie||I.f===ie||I.c===ie)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(L){if(Array.isArray(L))this.z(),this.o=L,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.z(),this.r=L}get source(){return this.t}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.$7)("source must be a string of length > 0");this.z(),this.t=L}get group(){return this.u}set group(L){L===null&&(L=void 0),this.z(),this.u=L}get detail(){return this.y}set detail(L){L===null&&(L=void 0),this.y=L}get presentationOptions(){return this.w}set presentationOptions(L){L==null&&(L=Object.create(null)),this.z(),this.w=L}get runOptions(){return this.x}set runOptions(L){L==null&&(L=Object.create(null)),this.z(),this.x=L}};e.$2K=G,e.$2K=G=I=qe([P],G);var Fe;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Fe||(e.ProgressLocation=Fe={}));var je;(function(j){function L(ie){const ke=ie;return(0,D.$Cf)(ke.value)?ke.tooltip&&!(0,D.$yf)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}j.isViewBadge=L})(je||(e.ViewBadge=je={}));let Je=S=class{static isTreeItem(L,ie){const ke=L;if(ke.checkboxState!==void 0){const He=(0,D.$Cf)(ke.checkboxState)?ke.checkboxState:(0,D.$Af)(ke.checkboxState)&&(0,D.$Cf)(ke.checkboxState.state)?ke.checkboxState.state:void 0,Ye=!(0,D.$Cf)(ke.checkboxState)&&(0,D.$Af)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(He===void 0||He!==et.Checked&&He!==et.Unchecked||Ye!==void 0&&!(0,D.$yf)(Ye))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(L instanceof S)return!0;if(ke.label!==void 0&&!(0,D.$yf)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,D.$yf)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,D.$yf)(ke.iconPath)&&!g.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,D.$yf)(ke.iconPath.id))){const He=ke.iconPath;if(!He||!(0,D.$yf)(He.light)&&!g.URI.isUri(He.light)&&!(0,D.$yf)(He.dark)&&!g.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,D.$yf)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!g.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,D.$yf)(ke.tooltip)&&!(ke.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Ve.None&&ke.collapsibleState>Ve.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,D.$yf)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(L,ie=Ve.None){this.collapsibleState=ie,g.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$3K=Je,e.$3K=Je=S=qe([P],Je);var Ve;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Ve||(e.TreeItemCollapsibleState=Ve={}));var et;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(et||(e.TreeItemCheckboxState=et={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$4K=bt,e.$4K=bt=qe([P],bt);class zt extends bt{}e.$5K=zt;class Dt extends zt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$6K=Dt;class lt{constructor(L,ie,ke,He){this.name=L,this.uri=ie,this._itemId=ke,this.c=He}data(){return this.c()}}e.$7K=lt;let gt=class{#e=new Map;constructor(L){for(const[ie,ke]of L??[]){const He=this.#e.get(this.#t(ie));He?He.push(ke):this.#e.set(this.#t(ie),[ke])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,ie){this.#e.set(this.#t(L),[ie])}forEach(L,ie){for(const[ke,He]of this.#e)for(const Ye of He)L.call(ie,Ye,ke,this)}*[Symbol.iterator](){for(const[L,ie]of this.#e)for(const ke of ie)yield[L,ke]}#t(L){return L.toLowerCase()}};e.$8K=gt,e.$8K=gt=qe([P],gt);let yt=class{constructor(L){this.insertText=L}};e.$9K=yt,e.$9K=yt=qe([P],yt);let mi=class{constructor(L,ie){this.label=ie,this.insertText=L}};e.$0K=mi,e.$0K=mi=qe([P],mi);let St=class{constructor(L,ie){this.id=L,this.color=ie}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$$K=St,e.$$K=St=qe([P],St),St.File=new St("file"),St.Folder=new St("folder");let Si=class{constructor(L){this.id=L}};e.$_K=Si,e.$_K=Si=qe([P],Si);var ui;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(ui||(e.ConfigurationTarget=ui={}));let $i=class{get base(){return this.c}set base(L){this.c=L,this.e=g.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,ie){if(typeof L!="string"&&(!L||!g.URI.isUri(L)&&!g.URI.isUri(L.uri)))throw(0,M.$7)("base");if(typeof ie!="string")throw(0,M.$7)("pattern");typeof L=="string"?this.baseUri=g.URI.file(L):g.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$aL=$i,e.$aL=$i=qe([P],$i);const It=new WeakMap;function fn(j,L){It.set(j,L)}e.$bL=fn;let ri=class{constructor(L,ie,ke,He){this.enabled=typeof L=="boolean"?L:!0,typeof ie=="string"&&(this.condition=ie),typeof ke=="string"&&(this.hitCondition=ke),typeof He=="string"&&(this.logMessage=He)}get id(){return this.c||(this.c=It.get(this)??(0,R.$eg)()),this.c}};e.$cL=ri,e.$cL=ri=qe([P],ri);let Et=class extends ri{constructor(L,ie,ke,He,Ye){if(super(ie,ke,He,Ye),L===null)throw(0,M.$7)("location");this.location=L}};e.$dL=Et,e.$dL=Et=qe([P],Et);let pi=class extends ri{constructor(L,ie,ke,He,Ye){super(ie,ke,He,Ye),this.functionName=L}};e.$eL=pi,e.$eL=pi=qe([P],pi);let vi=class extends ri{constructor(L,ie,ke,He,Ye,ot,dt){if(super(He,Ye,ot,dt),!ie)throw(0,M.$7)("dataId");this.label=L,this.dataId=ie,this.canPersist=ke}};e.$fL=vi,e.$fL=vi=qe([P],vi);let si=class{constructor(L,ie,ke){this.command=L,this.args=ie||[],this.options=ke}};e.$gL=si,e.$gL=si=qe([P],si);let Ii=class{constructor(L,ie){this.port=L,this.host=ie}};e.$hL=Ii,e.$hL=Ii=qe([P],Ii);let Ci=class{constructor(L){this.path=L}};e.$iL=Ci,e.$iL=Ci=qe([P],Ci);let Ft=class{constructor(L){this.implementation=L}};e.$jL=Ft,e.$jL=Ft=qe([P],Ft);let bi=class{constructor(L,ie,ke){this.session=L,this.threadId=ie,this.frameId=ke}};e.$kL=bi,e.$kL=bi=qe([P],bi);let Pi=class{constructor(L,ie){this.session=L,this.threadId=ie}};e.$lL=Pi,e.$lL=Pi=qe([P],Pi);let oi=class{constructor(L,ie){this.range=L,this.expression=ie}};e.$mL=oi,e.$mL=oi=qe([P],oi);var li;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(li||(e.InlineCompletionTriggerKind=li={}));let ct=class{constructor(L,ie){this.range=L,this.text=ie}};e.$nL=ct,e.$nL=ct=qe([P],ct);let Ai=class{constructor(L,ie,ke=!0){this.range=L,this.variableName=ie,this.caseSensitiveLookup=ke}};e.$oL=Ai,e.$oL=Ai=qe([P],Ai);let Zt=class{constructor(L,ie){this.range=L,this.expression=ie}};e.$pL=Zt,e.$pL=Zt=qe([P],Zt);let ii=class{constructor(L,ie){this.frameId=L,this.stoppedLocation=ie}};e.$qL=ii,e.$qL=ii=qe([P],ii);var Ri;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Mi=u=class extends Error{static FileExists(L){return new u(L,a.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(L){return new u(L,a.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(L){return new u(L,a.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(L){return new u(L,a.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(L){return new u(L,a.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(L){return new u(L,a.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}constructor(L,ie=a.FileSystemProviderErrorCode.Unknown,ke){super(g.URI.isUri(L)?L.toString(!0):L),this.code=ke?.name??"Unknown",(0,a.$mk)(this,ie),Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$rL=Mi,e.$rL=Mi=u=qe([P],Mi);let Fi=class{constructor(L,ie,ke){this.start=L,this.end=ie,this.kind=ke}};e.$sL=Fi,e.$sL=Fi=qe([P],Fi);var Xi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Xi||(e.FoldingRangeKind=Xi={}));var Ti;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Ti||(e.CommentThreadCollapsibleState=Ti={}));var Yi;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Yi||(e.CommentMode=Yi={}));var Li;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Li||(e.CommentState=Li={}));var ai;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class gn{constructor(L,ie=[]){this.tokenTypes=L,this.tokenModifiers=ie}}e.$tL=gn;function Ni(j){return typeof j>"u"||(0,D.$zf)(j)}class di{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,L){this.l=!0;for(let ie=0,ke=L.tokenTypes.length;ie<ke;ie++)this.j.set(L.tokenTypes[ie],ie);for(let ie=0,ke=L.tokenModifiers.length;ie<ke;ie++)this.k.set(L.tokenModifiers[ie],ie)}}push(L,ie,ke,He,Ye){if(typeof L=="number"&&typeof ie=="number"&&typeof ke=="number"&&typeof He=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(L,ie,ke,He,Ye);if(O.isRange(L)&&typeof ie=="string"&&Ni(ke))return this.m(L,ie,ke);throw(0,M.$7)()}m(L,ie,ke){if(!this.l)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ie))throw new Error("`tokenType` is not in the provided legend");const He=L.start.line,Ye=L.start.character,ot=L.end.character-L.start.character,dt=this.j.get(ie);let Ut=0;if(ke)for(const Xt of ke){if(!this.k.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Xt);Ut|=1<<ei>>>0}this.n(He,Ye,ot,dt,Ut)}n(L,ie,ke,He,Ye){if(this.f&&(L<this.c||L===this.c&&ie<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Xt=0,ei=0;for(let ti=0;ti<Ut;ti++){let ni=this.g[5*ti],Ji=this.g[5*ti+1];ni===0?(ni=Xt,Ji+=ei):ni+=Xt,this.g[5*ti]=ni,this.g[5*ti+1]=Ji,Xt=ni,ei=Ji}}let ot=L,dt=ie;this.f&&this.h>0&&(ot-=this.c,ot===0&&(dt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=dt,this.g[this.h++]=ke,this.g[this.h++]=He,this.g[this.h++]=Ye,this.c=L,this.e=ie}static o(L){const ie=[],ke=L.length/5|0;for(let dt=0;dt<ke;dt++)ie[dt]=dt;ie.sort((dt,Ut)=>{const Xt=L[5*dt],ei=L[5*Ut];if(Xt===ei){const ti=L[5*dt+1],ni=L[5*Ut+1];return ti-ni}return Xt-ei});const He=new Uint32Array(L.length);let Ye=0,ot=0;for(let dt=0;dt<ke;dt++){const Ut=5*ie[dt],Xt=L[Ut+0],ei=L[Ut+1],ti=L[Ut+2],ni=L[Ut+3],Ji=L[Ut+4],In=Xt-Ye,Fn=In===0?ei-ot:ei,Qi=5*dt;He[Qi+0]=In,He[Qi+1]=Fn,He[Qi+2]=ti,He[Qi+3]=ni,He[Qi+4]=Ji,Ye=Xt,ot=ei}return He}build(L){return this.f?new Oi(new Uint32Array(this.g),L):new Oi(di.o(this.g),L)}}e.$uL=di;class Oi{constructor(L,ie){this.resultId=ie,this.data=L}}e.$vL=Oi;class mn{constructor(L,ie,ke){this.start=L,this.deleteCount=ie,this.data=ke}}e.$wL=mn;class hi{constructor(L,ie){this.resultId=ie,this.edits=L}}e.$xL=hi;var Zi;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));let zi=class{static{this.Back={iconPath:new St("arrow-left")}}constructor(){}};e.$yL=zi,e.$yL=zi=qe([P],zi);var _i;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(_i||(e.QuickPickItemKind=_i={}));var fi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(fi||(e.InputBoxValidationSeverity=fi={}));var xi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(xi||(e.ExtensionKind=xi={}));class $n{static validate(L){if(typeof L.badge=="string"){let ie=(0,l.$_e)(L.badge,0);if(ie<L.badge.length&&(ie+=(0,l.$_e)(L.badge,ie)),L.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!St.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,ie,ke){this.badge=L,this.tooltip=ie,this.color=ke}}e.$zL=$n;let Ui=class{constructor(L){this.kind=L}};e.$AL=Ui,e.$AL=Ui=qe([P],Ui);var gi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(gi||(e.ColorThemeKind=gi={}));class _t{static isNotebookRange(L){return L instanceof _t?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,ie){if(L<0)throw(0,M.$7)("start must be positive");if(ie<0)throw(0,M.$7)("end must be positive");L<=ie?(this.c=L,this.e=ie):(this.c=ie,this.e=L)}with(L){let ie=this.c,ke=this.e;return L.start!==void 0&&(ie=L.start),L.end!==void 0&&(ke=L.end),ie===this.c&&ke===this.e?this:new _t(ie,ke)}}e.$BL=_t;class wi{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ie=>wi.isNotebookCellData(ie))}static isNotebookCellData(L){return!0}constructor(L,ie,ke,He,Ye,ot,dt){this.kind=L,this.value=ie,this.languageId=ke,this.mime=He,this.outputs=Ye??[],this.metadata=ot,this.executionSummary=dt,wi.validate(this)}}e.$CL=wi;class pn{constructor(L){this.cells=L}}e.$DL=pn;class Qt{static isNotebookCellOutputItem(L){return L instanceof Qt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ie={name:L.name,message:L.message,stack:L.stack};return Qt.json(ie,"application/vnd.code.notebook.error")}static stdout(L){return Qt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Qt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ie="application/octet-stream"){return new Qt(L,ie)}static#e=new TextEncoder;static text(L,ie=A.$Nr.text){const ke=Qt.#e.encode(String(L));return new Qt(ke,ie)}static json(L,ie="text/x-json"){const ke=JSON.stringify(L,void 0,"	");return Qt.text(ke,ie)}constructor(L,ie){this.data=L,this.mime=ie;const ke=(0,A.$Rr)(ie,!0);if(!ke)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$EL=Qt;class yi{static isNotebookCellOutput(L){return L instanceof yi?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,ie=!1){const ke=new Set,He=new Set;for(let Ye=0;Ye<L.length;Ye++){const ot=L[Ye],dt=(0,A.$Rr)(ot.mime);if(!ke.has(dt)||(0,$.$mI)(dt)){ke.add(dt);continue}He.add(Ye),ie&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return He.size===0?L:L.filter((Ye,ot)=>!He.has(ot))}constructor(L,ie,ke){this.items=yi.ensureUniqueMimeTypes(L,!0),typeof ie=="string"?(this.id=ie,this.metadata=ke):(this.id=(0,R.$eg)(),this.metadata=ie??ke)}}e.$FL=yi;var en;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(en||(e.NotebookCellKind=en={}));var tn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(tn||(e.NotebookCellExecutionState=tn={}));var nn;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(nn||(e.NotebookCellStatusBarAlignment=nn={}));var Ei;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class rn{constructor(L,ie){this.text=L,this.alignment=ie}}e.$GL=rn;var Le;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Le||(e.NotebookControllerAffinity=Le={}));var xt;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(xt||(e.NotebookControllerAffinity2=xt={}));class sn{constructor(L,ie=[]){this.uri=L,this.provides=(0,y.$3b)(ie)}}e.$HL=sn;class mt{constructor(L){this.label=L}}e.$IL=mt;let ji=class{constructor(L,ie){this.label=L,this.timestamp=ie}};e.$JL=ji,e.$JL=ji=qe([P],ji);var on;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var Bi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var an;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class Di{constructor(L,ie){this.ranges=L,this.wordPattern=ie}}e.$KL=Di;class vn{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$LL=vn;var cn;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let ki=class{constructor(L=void 0,ie=void 0,ke=void 0,He=!1){this.include=L,this.exclude=ie,this.profile=ke,this.continuous=He}};e.$ML=ki,e.$ML=ki=qe([P],ki);let Wi=m=class{static diff(L,ie,ke){const He=new m(L);return He.expectedOutput=ie,He.actualOutput=ke,He}constructor(L){this.message=L}};e.$NL=Wi,e.$NL=Wi=m=qe([P],Wi);let Ki=class{constructor(L){this.id=L}};e.$OL=Ki,e.$OL=Ki=qe([P],Ki);let ci=class{constructor(L,ie){this.covered=L,this.total=ie}};e.$PL=ci,e.$PL=ci=qe([P],ci);let Vi=d=class{static fromDetails(L,ie){const ke=new ci(0,0),He=new ci(0,0),Ye=new ci(0,0);for(const dt of ie)if("branches"in dt){ke.total+=1,ke.covered+=dt.executionCount>0?1:0;for(const Ut of dt.branches)He.total+=1,He.covered+=Ut.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const ot=new d(L,ke,He.total>0?He:void 0,Ye.total>0?Ye:void 0);return ot.detailedCoverage=ie,ot}constructor(L,ie,ke,He){this.uri=L,this.statementCoverage=ie,this.branchCoverage=ke,this.functionCoverage=He}};e.$QL=Vi,e.$QL=Vi=d=qe([P],Vi);let qi=class{constructor(L,ie,ke=[]){this.executionCount=L,this.location=ie,this.branches=ke}};e.$RL=qi,e.$RL=qi=qe([P],qi);let Hi=class{constructor(L,ie){this.executionCount=L,this.location=ie}};e.$SL=Hi,e.$SL=Hi=qe([P],Hi);let Gi=class{constructor(L,ie){this.executionCount=L,this.location=ie}};e.$TL=Gi,e.$TL=Gi=qe([P],Gi);var ln;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(ln||(e.ExternalUriOpenerPriority=ln={}));var dn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(dn||(e.WorkspaceTrustState=dn={}));var hn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(hn||(e.PortAutoForwardAction=hn={}));class ee{constructor(L,ie,ke,He,Ye,ot){this.kind=L,this.name=ie,this.detail=ke,this.uri=He,this.range=Ye,this.selectionRange=ot}}e.$UL=ee;class de{constructor(L){this.uri=L}}e.$VL=de;class Te{constructor(L,ie){this.original=L,this.modified=ie}}e.$WL=Te;class rt{constructor(L,ie,ke,He){this.base=L,this.input1=ie,this.input2=ke,this.result=He}}e.$XL=rt;class $t{constructor(L,ie){this.uri=L,this.viewType=ie}}e.$YL=$t;class Tt{constructor(L){this.viewType=L}}e.$ZL=Tt;class Cn{constructor(L,ie){this.uri=L,this.notebookType=ie}}e.$1L=Cn;class Pn{constructor(L,ie,ke){this.original=L,this.modified=ie,this.notebookType=ke}}e.$2L=Pn;class An{constructor(){}}e.$3L=An;class Rn{constructor(L,ie){this.uri=L,this.inputBoxUri=ie}}e.$4L=Rn;var bn;(function(j){j[j.Up=1]="Up",j[j.Down=2]="Down"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var wn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(wn||(e.InteractiveSessionCopyKind=wn={}));var yn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var Dn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Mn{constructor(L,ie){this.role=L,this.content=ie}}e.$5L=Mn;var kn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Sn;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}))}),define(Ae[100],Re([1,0,52,13,16,279,136,7,18]),function(be,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=e.$gM=e.$fM=void 0;const g=new Map;function R($,f){f?g.set($,f):g.delete($)}e.$fM=R;function k($){return g.get($)}class a extends T.$Su{constructor(f,t,i,c,b,E,v,n){super(t,i,c,b),this.c=f,this.m=E,this.q=v,this.notebook=n,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,D.$ub)(this.f,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.d},get fileName(){return f.d.fsPath},get isUntitled(){return f.d.scheme===M.Schemas.untitled},get languageId(){return f.m},get version(){return f.h},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(t){return t?f.s(t):f.getText()},get eol(){return f.g===`
`?l.EndOfLine.LF:l.EndOfLine.CRLF},get lineCount(){return f.f.length},lineAt(t){return f.t(t)},offsetAt(t){return f.u(t)},positionAt(t){return f.v(t)},validateRange(t){return f.w(t)},validatePosition(t){return f.x(t)},getWordRangeAtPosition(t,i){return f.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,y.ok)(!this.b),this.m=f}_acceptIsDirty(f){(0,y.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(f){const t=this.w(f);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,c=t.start.line,b=t.end.line,E=[];E.push(this.f[c].substring(t.start.character));for(let v=c+1;v<b;v++)E.push(this.f[v]);return E.push(this.f[b].substring(0,t.end.character)),E.join(i)}t(f){let t;if(f instanceof l.$fK?t=f.line:typeof f=="number"&&(t=f),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new p(t,this.f[t],t===this.f.length-1)}u(f){return f=this.x(f),this.l(),this.j.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.l();const t=this.j.getIndexOf(f),i=this.f[t.index].length;return new l.$fK(t.index,Math.min(t.remainder,i))}w(f){if(!(f instanceof l.$gK))throw new Error("Invalid argument");const t=this.x(f.start),i=this.x(f.end);return t===f.start&&i===f.end?f:new l.$gK(t.line,t.character,i.line,i.character)}x(f){if(!(f instanceof l.$fK))throw new Error("Invalid argument");if(this.f.length===0)return f.with(0,0);let{line:t,character:i}=f,c=!1;if(t<0)t=0,i=0,c=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,c=!0;else{const b=this.f[t].length;i<0?(i=0,c=!0):i>b&&(i=b,c=!0)}return c?new l.$fK(t,i):f}y(f,t){const i=this.x(f);if(!t)t=k(this.m);else if((0,C.$Oe)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,A.$6r)(i.character+1,(0,A.$4r)(t),this.f[i.line],0);if(c)return new l.$gK(i.line,c.startColumn-1,i.line,c.endColumn-1)}}e.$gM=a;class p{constructor(f,t,i){this.a=f,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new l.$gK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new l.$gK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$hM=p}),define(Ae[196],Re([1,0,7,17,5]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;let T=class{constructor(l){this.a=new y.$AL(y.ColorThemeKind.Dark),this.b=new C.$Nd}get activeColorTheme(){return this.a}$onColorThemeChange(l){let D;switch(l){case"light":D=y.ColorThemeKind.Light;break;case"hcDark":D=y.ColorThemeKind.HighContrast;break;case"hcLight":D=y.ColorThemeKind.HighContrastLight;break;default:D=y.ColorThemeKind.Dark}this.a=new y.$AL(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$sdc=T,e.$sdc=T=qe([Ke(0,M.$dM)],T)}),define(Ae[197],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qI=e.CellExecutionUpdateType=void 0;var M;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$qI=(0,y.$Oh)("INotebookExecutionService")}),define(Ae[46],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8I=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(T){T.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var M;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class C{static fromExtHostTestItem(A,l,D=A.parent){if(A._isRoot)return new C([l]);const g=[A.id];for(let R=D;R&&R.id!==l;R=R.parent)g.push(R.id);return g.push(l),new C(g.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const l=A.indexOf("\0");return l===-1?A:A.slice(0,l)}static fromString(A){return new C(A.split("\0"))}static join(A,l){return new C([...A.path,l])}static joinToString(A,l){return A.toString()+"\0"+l}static parentId(A){const l=A.lastIndexOf("\0");return l===-1?void 0:A.slice(0,l)}static localId(A){const l=A.lastIndexOf("\0");return l===-1?A:A.slice(l+1)}static isChild(A,l){return l.startsWith(A)&&l[A.length]==="\0"}static compare(A,l){return A===l?0:C.isChild(A,l)?2:C.isChild(l,A)?3:1}constructor(A,l=A.length){if(this.path=A,this.d=l,A.length===0||l<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let l=0;l<A.d&&l<this.d;l++)if(A.path[l]!==this.path[l])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$8I=C}),define(Ae[57],Re([1,0,2,45,46]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$bJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$aJ=e.$_I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$$I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$0I=e.$9I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var T;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(T||(e.TestResultState=T={}));var A;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var l;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})(l||(e.TestRunProfileBitset=l={})),e.$9I=[2,4,8,16,32,64];const D=S=>"runId"in S;e.$0I=D;var g;(function(S){S.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),S.deserialize=u=>({range:M.$qs.lift(u.range),uri:y.URI.revive(u.uri)})})(g||(e.IRichLocation=g={}));var R;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(R||(e.TestMessageType=R={}));var k;(function(S){S.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&g.serialize(u.location)}),S.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&g.deserialize(u.location)})})(k||(e.ITestErrorMessage=k={}));const a=(S,u)=>`${u?"s":"e"}${S}`;e.$$I=a;var p;(function(S){S.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&g.serialize(u.location)}),S.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&g.deserialize(u.location)})})(p||(e.ITestOutputMessage=p={}));var $;(function(S){S.serialize=u=>u.type===0?k.serialize(u):p.serialize(u),S.deserialize=u=>u.type===0?k.deserialize(u):p.deserialize(u)})($||(e.ITestMessage=$={}));var f;(function(S){S.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),S.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map($.serialize)}),S.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map($.deserialize)})})(f||(e.ITestTaskState=f={}));const t="\0",i=(S,u)=>S+t+u;e.$_I=i;const c=S=>{const u=S.indexOf(t);return{ctrlId:S.slice(0,u),tagId:S.slice(u+1)}};e.$aJ=c;var b;(function(S){S.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),S.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?y.URI.revive(u.uri):void 0,range:u.range?M.$qs.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(b||(e.ITestItem=b={}));var E;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(E||(e.TestItemExpandState=E={}));var v;(function(S){S.serialize=u=>({expand:u.expand,item:b.serialize(u.item)}),S.deserialize=u=>({controllerId:C.$8I.root(u.item.extId),expand:u.expand,item:b.deserialize(u.item)})})(v||(e.InternalTestItem=v={}));var n;(function(S){S.serialize=u=>{let m;return u.item&&(m={},u.item.label!==void 0&&(m.label=u.item.label),u.item.tags!==void 0&&(m.tags=u.item.tags),u.item.busy!==void 0&&(m.busy=u.item.busy),u.item.uri!==void 0&&(m.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(m.range=u.item.range?.toJSON()),u.item.description!==void 0&&(m.description=u.item.description),u.item.error!==void 0&&(m.error=u.item.error),u.item.sortText!==void 0&&(m.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:m}},S.deserialize=u=>{let m;return u.item&&(m={},u.item.label!==void 0&&(m.label=u.item.label),u.item.tags!==void 0&&(m.tags=u.item.tags),u.item.busy!==void 0&&(m.busy=u.item.busy),u.item.range!==void 0&&(m.range=u.item.range?M.$qs.lift(u.item.range):null),u.item.description!==void 0&&(m.description=u.item.description),u.item.error!==void 0&&(m.error=u.item.error),u.item.sortText!==void 0&&(m.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:m}}})(n||(e.ITestItemUpdate=n={}));const r=(S,u)=>{u.expand!==void 0&&(S.expand=u.expand),u.item!==void 0&&(S.item=S.item?Object.assign(S.item,u.item):u.item)};e.$bJ=r;var s;(function(S){S.serializeWithoutMessages=u=>({...v.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.serializeWithoutMessages)}),S.serialize=u=>({...v.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.serialize)}),S.deserialize=u=>({...v.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var o;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(o||(e.DetailType=o={}));var w;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(w||(e.TestDiffOpType=w={}));var h;(function(S){S.deserialize=u=>u.op===0?{op:u.op,item:v.deserialize(u.item)}:u.op===1?{op:u.op,item:n.deserialize(u.item)}:u.op===2?{op:u.op,uri:y.URI.revive(u.uri),docv:u.docv}:u,S.serialize=u=>u.op===0?{op:u.op,item:v.serialize(u.item)}:u.op===1?{op:u.op,item:n.serialize(u.item)}:u})(h||(e.TestsDiffOp=h={}));class I{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(u){const m=this.p();for(const d of u)switch(d.op){case 0:this.k(v.deserialize(d.item),m);break;case 1:this.l(n.deserialize(d.item),m);break;case 3:this.m(d.itemId,m);break;case 5:this.o(d.itemId);break;case 4:this.updatePendingRoots(d.amount);break;case 6:this.d.set(d.tag.id,d.tag);break;case 7:this.d.delete(d.id);break}m.complete?.()}k(u,m){const d=C.$8I.parentId(u.item.extId)?.toString();let P;if(!d)P=this.q(u),this.g.add(P),this.f.set(u.item.extId,P);else if(this.f.has(d)){const W=this.f.get(d);W.children.add(u.item.extId),P=this.q(u,W),this.f.set(u.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return m.add?.(P),u.expand===2&&this.h++,P}l(u,m){const d=this.f.get(u.extId);if(d)return u.expand!==void 0&&(d.expand===2&&this.h--,u.expand===2&&this.h++),(0,e.$bJ)(d,u),m.update?.(d),d}m(u,m){const d=this.f.get(u);if(!d)return;const P=C.$8I.parentId(d.item.extId)?.toString();P?this.f.get(P).children.delete(d.item.extId):this.g.delete(d);const W=[[u]];for(;W.length;)for(const K of W.pop()){const U=this.f.get(K);U&&(W.push(U.children),this.f.delete(K),m.remove?.(U,U!==d),U.expand===2&&this.h--)}}o(u){}updatePendingRoots(u){this.j+=u}p(){return{}}}e.$cJ=I}),define(Ae[76],Re([1,0,12,5,6,52,57,46]),function(be,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.TestItemEventOp=void 0;var D;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const g=(c,b)=>c===b,k=Object.entries({range:(c,b)=>c===b?!0:!c||!b?!1:c.equalsRange(b),busy:g,label:g,description:g,error:g,sortText:g,tags:(c,b)=>!(c.length!==b.length||c.some(E=>!b.includes(E)))}),a=(c,b)=>{let E;for(const[v,n]of k)n(c[v],b[v])||(E?E[v]=b[v]:E={[v]:b[v]});return E};class p extends C.$Sc{get root(){return this.s.root}constructor(b){super(),this.s=b,this.f=this.B(new y.$6g(()=>this.flushDiff(),200)),this.g=this.B(new M.$Nd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(b){this.h=b;for(const E of this.tree.values())this.I(E)}get resolveHandler(){return this.h}collectDiff(){const b=this.m;return this.m=[],b}pushDiff(b){switch(b.op){case 2:{for(const E of this.m)if(E.op===2&&E.uri===b.uri){E.docv=b.docv;return}break}case 1:{const E=this.m[this.m.length-1];if(E){if(E.op===1&&E.item.extId===b.item.extId){(0,A.$bJ)(E.item,b.item);return}if(E.op===0&&E.item.item.extId===b.item.extId){(0,A.$bJ)(E.item,b.item);return}}break}}this.m.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,E){const v=this.tree.get(b);if(v){if((v.expandLevels===void 0||E>v.expandLevels)&&(v.expandLevels=E),v.expand===1){const n=this.L(v);return n.isOpen()?this.J(v,E-1):n.wait().then(()=>this.J(v,E-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.J(v,E-1)):this.J(v,E-1)}}dispose(){for(const b of this.tree.values())this.s.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(b,E){switch(E.op){case 3:this.N(l.$8I.joinToString(b.fullId,E.id));break;case 0:this.y(E.item,b);break;case 5:for(const v of E.ops)this.u(b,v);break;case 1:this.z(E.new,E.old,b.fullId.toString());break;case 2:this.I(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:E.update}});break;case 6:this.w(b.actual.uri);break;default:(0,T.$4c)(E)}}w(b){b&&this.pushDiff({op:2,uri:b,docv:this.s.getDocumentVersion(b)})}y(b,E){const v=l.$8I.fromExtHostTestItem(b,this.root.id,E?.actual),n=this.s.getApiFor(b);n.parent&&n.parent!==E?.actual&&this.s.getChildren(n.parent).delete(b.id);let r=this.tree.get(v.toString());if(!r){r={fullId:v,actual:b,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},b.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(b,E),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(b)}}),this.H(b,r,E);return}if(r.actual===b){this.G(b,r,E);return}if(r.actual.uri?.toString()!==b.uri?.toString())return this.N(v.toString()),this.y(b,E);const s=this.s.getChildren(r.actual),o=r.actual,w=a(this.s.toITestItem(o),this.s.toITestItem(b));this.s.getApiFor(o).listener=void 0,r.actual=b,r.expand=0,w&&(w.hasOwnProperty("tags")&&(this.z(b.tags,o.tags,v.toString()),delete w.tags),this.u(r,{op:4,update:w})),this.H(b,r,E);for(const[h,I]of s)this.s.getChildren(b).get(I.id)||this.N(l.$8I.joinToString(v,I.id));this.w(r.actual.uri)}z(b,E,v){const n=new Set(E.map(r=>r.id));for(const r of b)n.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:v,item:{tags:b.map(r=>(0,A.$_I)(this.s.controllerId,r.id))}}}),n.forEach(this.D,this)}C(b){const E=this.j.get(b.id);E?E.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$_I)(this.s.controllerId,b.id)}}))}D(b){const E=this.j.get(b);E&&!--E.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,A.$_I)(this.s.controllerId,b)}))}F(b,E){this.s.getApiFor(b).parent=E&&E.actual!==this.root?E.actual:void 0}G(b,E,v){this.F(b,v);const n=this.s.getApiFor(b);n.parent=v?.actual,n.listener=r=>this.u(E,r),this.I(E)}H(b,E,v){this.G(b,E,v);for(const[n,r]of this.s.getChildren(b))this.y(r,E)}I(b){let E;this.h?b.resolveBarrier?E=b.resolveBarrier.isOpen()?3:2:E=b.actual.canResolveChildren?1:0:E=0,E!==b.expand&&(b.expand=E,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:E}}),E===1&&b.expandLevels!==void 0&&this.L(b))}J(b,E){if(E<0)return;const v=[];for(const[n,r]of this.s.getChildren(b.actual)){const s=this.expand(l.$8I.joinToString(b.fullId,r.id),E);(0,y.$Gg)(s)&&v.push(s)}if(v.length)return Promise.all(v).then(()=>{})}L(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const r=new y.$Sg;return r.open(),r}b.expand=2,this.M(b);const E=b.resolveBarrier=new y.$Sg,v=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let n;try{n=this.h(b.actual===this.root?void 0:b.actual)}catch(r){v(r)}return(0,y.$Gg)(n)?n.catch(v).then(()=>{E.open(),this.I(b)}):(E.open(),this.I(b)),b.resolveBarrier}M(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}N(b){const E=this.tree.get(b);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const v=[E];for(;v.length;){const n=v.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const r of n.actual.tags)this.D(r.id);this.tree.delete(n.fullId.toString());for(const[r,s]of this.s.getChildren(n.actual))v.push(this.tree.get(l.$8I.joinToString(n.fullId,s.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.$6L=p;class $ extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.$7L=$;class f extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$8L=f;class t extends Error{constructor(b,E,v){super(`TestItem with ID "${b}" is from controller "${E}" and cannot be added as a child of an item from controller "${v}".`)}}e.$9L=t;const i=(c,b,E)=>{let v=new Map;return{get size(){return v.size},forEach(n,r){for(const s of v.values())n.call(r,s,this)},[Symbol.iterator](){return v.entries()},replace(n){const r=new Map,s=new Set(v.keys()),o={op:5,ops:[]};for(const w of n){if(!(w instanceof E))throw new f(w.id);const h=b(w).controllerId;if(h!==c.controllerId)throw new t(w.id,h,c.controllerId);if(r.has(w.id))throw new $(w.id);r.set(w.id,w),s.delete(w.id),o.ops.push({op:0,item:w})}for(const w of s.keys())o.ops.push({op:3,id:w});c.listener?.(o),v=r},add(n){if(!(n instanceof E))throw new f(n.id);v.set(n.id,n),c.listener?.({op:0,item:n})},delete(n){v.delete(n)&&c.listener?.({op:3,id:n})},get(n){return v.get(n)},toJSON(){return Array.from(v.values())}}};e.$0L=i}),define(Ae[101],Re([1,0,76]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=void 0;const M=new WeakMap,C=(A,l)=>{const D={controllerId:l};return M.set(A,D),D};e.$$L=C;const T=A=>{const l=M.get(A);if(!l)throw new y.$8L(A?.id||"<unknown>");return l};e.$_L=T}),define(Ae[77],Re([1,0,13,2]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ob=e.$5ob=e.$4ob=e.$3ob=e.$2ob=void 0,e.$2ob="vscode-cdn.net",e.$3ob=`vscode-resource.${e.$2ob}`,e.$4ob=`'self' https://*.${e.$2ob}`;function C(l,D){return l.scheme===y.Schemas.http||l.scheme===y.Schemas.https?l:(D&&D.authority&&D.isRemote&&l.scheme===y.Schemas.file&&(l=M.URI.from({scheme:y.Schemas.vscodeRemote,authority:D.authority,path:l.path})),M.URI.from({scheme:y.Schemas.https,authority:`${l.scheme}+${T(l.authority)}.${e.$3ob}`,path:l.path,fragment:l.fragment,query:l.query}))}e.$5ob=C;function T(l){return l.replace(/./g,D=>{const g=D.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?D:"-"+g.toString(16).padStart(4,"0")})}function A(l){return l.replace(/-([0-9a-f]{4})/g,(D,g)=>String.fromCharCode(parseInt(g,16)))}e.$6ob=A}),define(Ae[198],Re([1,0,5,6,77]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=void 0;class T{constructor(l,D,g){this.d=l,this.e=D,this.f=g,this.a=0,this.b=new M.$Rc,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const R=D.getVisibleTextEditors();for(const k of this.c.values())R.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(l=>l.inset.dispose()),this.b.dispose()}createWebviewEditorInset(l,D,g,R,k){let a;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===l){a=b;break}if(!a)throw new Error("not a visible editor");const p=this,$=this.a++,f=new y.$Nd,t=new y.$Nd,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,C.$5ob)(b,p.f)}get cspSource(){return C.$4ob}set options(b){this.b=b,p.d.$setOptions($,b)}get options(){return this.b}set html(b){this.a=b,p.d.$setHtml($,b)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(b){return p.d.$postMessage($,b)}},c=new class{constructor(){this.editor=l,this.line=D,this.height=g,this.webview=i,this.onDidDispose=t.event}dispose(){p.c.has($)&&(p.c.delete($),p.d.$disposeEditorInset($),t.fire(),t.dispose(),f.dispose())}};return this.d.$createEditorInset($,a.id,a.value.document.uri,D+1,g,R||{},k.identifier,k.extensionLocation),this.c.set($,{editor:l,inset:c,onDidReceiveMessage:f}),c}$onDidDispose(l){const D=this.c.get(l);D&&D.inset.dispose()}$onDidReceiveMessage(l,D){this.c.get(l)?.onDidReceiveMessage.fire(D)}}e.$3cc=T}),define(Ae[199],Re([1,0,4]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3M=e.VariableKind=e.$2M=void 0,e.$2M=(0,y.$Oh)("configurationResolverService");var M;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator"})(M||(e.VariableKind=M={}));class C extends Error{constructor(A,l){super(l),this.variable=A}}e.$3M=C}),define(Ae[200],Re([1,0,19,73,15,24,22,90,165,199,16]),function(be,e,y,M,C,T,A,l,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,$,f,t){this.h=new Map,this.a=p,this.b=$,this.g=f,t&&(this.c=t.then(i=>this.i(i)))}i(p){if(A.$j){const $=Object.create(null);return Object.keys(p).forEach(f=>{$[f.toLowerCase()]=p[f]}),$}return p}resolveWithEnvironment(p,$,f){return this.l({env:this.i(p),userHome:void 0},$?$.uri:void 0,f)}async resolveAsync(p,$){const f={env:await this.c,userHome:await this.g};return this.l(f,p?p.uri:void 0,$)}async j(p,$,f,t){const i=T.$4m($);A.$j&&i.windows?Object.keys(i.windows).forEach(b=>i[b]=i.windows[b]):A.$k&&i.osx?Object.keys(i.osx).forEach(b=>i[b]=i.osx[b]):A.$l&&i.linux&&Object.keys(i.linux).forEach(b=>i[b]=i.linux[b]),delete i.windows,delete i.osx,delete i.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,p?p.uri:void 0,i,f,t)}async resolveAnyAsync(p,$,f){return this.j(p,$,f)}async resolveAnyMap(p,$,f){const t=new Map;return{newConfig:await this.j(p,$,f,t),resolvedVariables:t}}resolveWithInteractionReplace(p,$,f,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,$,f,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,$){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,$)}async l(p,$,f,t,i){if(C.$yf(f))return this.m(p,$,f,t,i);if(Array.isArray(f))return Promise.all(f.map(c=>this.l(p,$,c,t,i)));if(C.$Af(f)){const c=Object.create(null),b=await Promise.all(Object.keys(f).map(async E=>[await this.m(p,$,E,t,i),await this.l(p,$,f[E],t,i)]));for(const[E,v]of b)c[E]=v;return c}return f}m(p,$,f,t,i){return(0,R.$Te)(f,k.VARIABLE_REGEXP,async(c,b)=>{if(b.includes(k.VARIABLE_LHS))return c;let E=await this.o(p,c,b,$,t);return i?.set(b,E),E!==c&&C.$yf(E)&&E.match(k.VARIABLE_REGEXP)&&(E=await this.m(p,$,E,t,i)),E})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,$,f,t,i){let c;const b=f.split(":");b.length>1&&(f=b[0],c=b[1]);const E=r=>{const s=this.a.getFilePath();if(s)return(0,l.$ov)(s);throw new g.$3M(r,(0,D.localize)(0,null,$))},v=r=>{const s=E(r);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,l.$ov)(o)}throw new g.$3M(r,(0,D.localize)(1,null,$,y.$nc(s)))},n=r=>{if(c){const s=this.a.getFolderUri(c);if(s)return s;throw new g.$3M(r,(0,D.localize)(2,null,$,c))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new g.$3M(r,(0,D.localize)(3,null,$)):new g.$3M(r,(0,D.localize)(4,null,$))};switch(f){case"env":if(c){if(p.env){const r=p.env[A.$j?c.toLowerCase():c];if(C.$yf(r))return r}return""}throw new g.$3M(g.VariableKind.Env,(0,D.localize)(5,null,$));case"config":if(c){const r=this.a.getConfigurationValue(t,c);if(C.$Hf(r))throw new g.$3M(g.VariableKind.Config,(0,D.localize)(6,null,$,c));if(C.$Af(r))throw new g.$3M(g.VariableKind.Config,(0,D.localize)(7,null,$,c));return r}throw new g.$3M(g.VariableKind.Config,(0,D.localize)(8,null,$));case"command":return this.p(g.VariableKind.Command,$,c,i,"command");case"input":return this.p(g.VariableKind.Input,$,c,i,"input");case"extensionInstallFolder":if(c){const r=await this.a.getExtension(c);if(!r)throw new g.$3M(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,$,c));return this.n(r.extensionLocation)}throw new g.$3M(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,$));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,l.$ov)(this.n(n(g.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,l.$ov)(this.n(n(g.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,l.$ov)(y.$nc(this.n(n(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new g.$3M(g.VariableKind.UserHome,(0,D.localize)(11,null,$))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new g.$3M(g.VariableKind.LineNumber,(0,D.localize)(12,null,$))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new g.$3M(g.VariableKind.SelectedText,(0,D.localize)(13,null,$))}case"file":return E(g.VariableKind.File);case"fileWorkspaceFolder":return v(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?y.$lc(this.n(n(g.VariableKind.RelativeFile)),E(g.VariableKind.RelativeFile)):E(g.VariableKind.RelativeFile);case"relativeFileDirname":{const r=y.$mc(E(g.VariableKind.RelativeFileDirname));if(t||c){const s=y.$lc(this.n(n(g.VariableKind.RelativeFileDirname)),r);return s.length===0?".":s}return r}case"fileDirname":return y.$mc(E(g.VariableKind.FileDirname));case"fileExtname":return y.$oc(E(g.VariableKind.FileExtname));case"fileBasename":return y.$nc(E(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=y.$nc(E(g.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-y.$oc(r).length)}case"fileDirnameBasename":return y.$nc(y.$mc(E(g.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||$}case"execInstallFolder":{const r=this.a.getAppRoot();return r||$}case"pathSeparator":return y.sep;default:try{const r=c?`${f}:${c}`:f;return this.p(g.VariableKind.Unknown,$,r,i,void 0)}catch{return $}}}}p(p,$,f,t,i){if(f&&t){const c=i===void 0?t[f]:t[i+":"+f];if(typeof c=="string")return c;throw new g.$3M(p,(0,D.localize)(14,null,$))}return $}}e.$eN=k}),define(Ae[102],Re([1,0,4,99]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=e.$cC=e.OpenEditorContext=e.GroupsOrder=e.$bC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$aC=void 0,e.$aC=(0,y.$Oh)("editorGroupsService");var C;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var T;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var A;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var l;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EVEN=1]="EVEN",$[$.TOGGLE=2]="TOGGLE"})(l||(e.GroupsArrangement=l={}));var D;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function g($){const f=$;return(0,M.$3D)(f?.editor)&&(0,M.$3D)(f?.replacement)}e.$bC=g;var R;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var k;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function a($){const f=$;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.$cC=a;function p($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$dC=p}),define(Ae[201],Re([1,0,4,102]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hC=e.$gC=e.$fC=e.$eC=void 0,e.$eC=(0,y.$Oh)("editorService"),e.$fC=-1,e.$gC=-2;function C(T){const A=T;return typeof T=="number"||(0,M.$cC)(A)}e.$hC=C}),define(Ae[8],Re([1,0,18,26,122,202,50,28,116,68,67,24,15,2,45,78,94,101,99,75,46,57,201,7]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f,t,i,c,b,E,v,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$cM=e.$bM=e.MarkdownString=e.$aM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Ce){function Me(G){const{selectionStartLineNumber:Fe,selectionStartColumn:je,positionLineNumber:Je,positionColumn:Ve}=G,et=new r.$fK(Fe-1,je-1),bt=new r.$fK(Je-1,Ve-1);return new r.$hK(et,bt)}Ce.to=Me;function fe(G){const{anchor:Fe,active:je}=G;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}Ce.from=fe})(s||(e.Selection=s={}));var o;(function(Ce){function Me(G){if(!G)return;const{start:Fe,end:je}=G;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}Ce.from=Me;function fe(G){if(!G)return;const{startLineNumber:Fe,startColumn:je,endLineNumber:Je,endColumn:Ve}=G;return new r.$gK(Fe-1,je-1,Je-1,Ve-1)}Ce.to=fe})(o||(e.Range=o={}));var w;(function(Ce){function Me(fe){switch(fe){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Ce.to=Me})(w||(e.TokenType=w={}));var h;(function(Ce){function Me(G){return new r.$fK(G.lineNumber-1,G.column-1)}Ce.to=Me;function fe(G){return{lineNumber:G.line+1,column:G.character+1}}Ce.from=fe})(h||(e.Position=h={}));var I;(function(Ce){function Me(Fe,je,Je){return(0,y.$Hb)((0,y.$3b)(Fe).map(Ve=>fe(Ve,je,Je)))}Ce.from=Me;function fe(Fe,je,Je){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:Je?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:G(Fe.scheme,je),pattern:st.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:Je?.isBuiltin}}function G(Fe,je){return je&&typeof Fe=="string"?je.transformOutgoingScheme(Fe):Fe}})(I||(e.DocumentSelector=I={}));var S;(function(Ce){function Me(G){switch(G){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Ce.from=Me;function fe(G){switch(G){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Ce.to=fe})(S||(e.DiagnosticTag=S={}));var u;(function(Ce){function Me(G){let Fe;return G.code&&((0,a.$yf)(G.code)||(0,a.$Cf)(G.code)?Fe=String(G.code):Fe={value:String(G.code.value),target:G.code.target}),{...o.from(G.range),message:G.message,source:G.source,code:Fe,severity:d.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(m.from),tags:Array.isArray(G.tags)?(0,y.$Hb)(G.tags.map(S.from)):void 0}}Ce.from=Me;function fe(G){const Fe=new r.$sK(o.to(G),G.message,d.to(G.severity));return Fe.source=G.source,Fe.code=(0,a.$yf)(G.code)?G.code:G.code?.value,Fe.relatedInformation=G.relatedInformation&&G.relatedInformation.map(m.to),Fe.tags=G.tags&&(0,y.$Hb)(G.tags.map(S.to)),Fe}Ce.to=fe})(u||(e.Diagnostic=u={}));var m;(function(Ce){function Me(G){return{...o.from(G.location.range),message:G.message,resource:G.location.uri}}Ce.from=Me;function fe(G){return new r.$rK(new r.$qK(G.resource,o.to(G)),G.message)}Ce.to=fe})(m||(e.DiagnosticRelatedInformation=m={}));var d;(function(Ce){function Me(G){switch(G){case r.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Me;function fe(G){switch(G){case t.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Ce.to=fe})(d||(e.DiagnosticSeverity=d={}));var P;(function(Ce){function Me(G){return typeof G=="number"&&G>=r.ViewColumn.One?G-1:G===r.ViewColumn.Beside?n.$gC:n.$fC}Ce.from=Me;function fe(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=fe})(P||(e.ViewColumn=P={}));function W(Ce){return typeof Ce.range<"u"}function K(Ce){return Ce.length===0?!0:!!W(Ce[0])}e.$aM=K;var U;(function(Ce){function Me(Ve){return Ve.map(Ce.from)}Ce.fromMany=Me;function fe(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function G(Ve){let et;if(fe(Ve)){const{language:lt,value:gt}=Ve;et={value:"```"+lt+`
`+gt+"\n```\n"}}else r.$EK.isMarkdownString(Ve)?et={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?et={value:Ve}:et={value:""};const bt=Object.create(null);et.uris=bt;const zt=lt=>{try{let gt=p.URI.parse(lt,!0);gt=gt.with({query:Fe(gt.query,bt)}),bt[lt]=gt}catch{}return""},Dt=new D.marked.Renderer;return Dt.link=zt,Dt.image=lt=>typeof lt=="string"?zt(A.$9j(lt).href):"",(0,D.marked)(et.value,{renderer:Dt}),et}Ce.from=G;function Fe(Ve,et){if(!Ve)return Ve;let bt;try{bt=(0,g.$kh)(Ve)}catch{}if(!bt)return Ve;let zt=!1;return bt=(0,k.$6m)(bt,Dt=>{if(p.URI.isUri(Dt)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[lt]=Dt,zt=!0,lt}else return}),zt?JSON.stringify(bt):Ve}function je(Ve){const et=new r.$EK(Ve.value,Ve.supportThemeIcons);return et.isTrusted=Ve.isTrusted,et.supportHtml=Ve.supportHtml,et.baseUri=Ve.baseUri?p.URI.from(Ve.baseUri):void 0,et}Ce.to=je;function Je(Ve){if(Ve)return typeof Ve=="string"?Ve:Ce.from(Ve)}Ce.fromStrict=Je})(U||(e.MarkdownString=U={}));function B(Ce){return K(Ce)?Ce.map(Me=>({range:o.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?U.fromMany(Me.hoverMessage):Me.hoverMessage?U.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ce.map(Me=>({range:o.from(Me)}))}e.$bM=B;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?p.URI.file(Ce):Ce}e.$cM=O;var N;(function(Ce){function Me(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?O(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Ce.from=Me})(N||(e.ThemableDecorationAttachmentRenderOptions=N={}));var te;(function(Ce){function Me(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?O(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?N.from(fe.before):void 0,after:fe.after?N.from(fe.after):void 0}}Ce.from=Me})(te||(e.ThemableDecorationRenderOptions=te={}));var Y;(function(Ce){function Me(fe){if(typeof fe>"u")return fe;switch(fe){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Me})(Y||(e.DecorationRangeBehavior=Y={}));var Ee;(function(Ce){function Me(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?Y.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?te.from(fe.light):void 0,dark:fe.dark?te.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?O(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?N.from(fe.before):void 0,after:fe.after?N.from(fe.after):void 0}}Ce.from=Me})(Ee||(e.DecorationRenderOptions=Ee={}));var Se;(function(Ce){function Me(G){return{text:G.newText,eol:G.newEol&&Ze.from(G.newEol),range:o.from(G.range)}}Ce.from=Me;function fe(G){const Fe=new r.$lK(o.to(G.range),G.text);return Fe.newEol=typeof G.eol>"u"?void 0:Ze.to(G.eol),Fe}Ce.to=fe})(Se||(e.TextEdit=Se={}));var Pe;(function(Ce){function Me(G,Fe){const je={edits:[]};if(G instanceof r.$oK){const Je=new l.$Bc;for(const Ve of G._allEntries())Ve._type===1&&p.URI.isUri(Ve.to)&&Ve.from===void 0&&Je.add(Ve.to);for(const Ve of G._allEntries())if(Ve._type===1){let et;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?et={type:"base64",value:(0,M.$ve)(M.$be.wrap(Ve.options.contents))}:et={type:"dataTransferItem",id:Ve.options.contents._itemId}),je.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:et},metadata:Ve.metadata})}else Ve._type===2?je.edits.push({resource:Ve.uri,textEdit:Se.from(Ve.edit),versionId:Je.has(Ve.uri)?void 0:Fe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?je.edits.push({resource:Ve.uri,textEdit:{range:o.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Je.has(Ve.uri)?void 0:Fe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?je.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&je.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(ft.from)}})}return je}Ce.from=Me;function fe(G){const Fe=new r.$oK,je=new l.$Ac;for(const Je of G.edits)if(Je.textEdit){const Ve=Je,et=p.URI.revive(Ve.resource),bt=o.to(Ve.textEdit.range),zt=Ve.textEdit.text,Dt=Ve.textEdit.insertAsSnippet;let lt;Dt?lt=r.$nK.replace(bt,new r.$pK(zt)):lt=r.$lK.replace(bt,zt);const gt=je.get(et);gt?gt.push(lt):je.set(et,[lt])}else Fe.renameFile(p.URI.revive(Je.oldResource),p.URI.revive(Je.newResource),Je.options);for(const[Je,Ve]of je)Fe.set(Je,Ve);return Fe}Ce.to=fe})(Pe||(e.WorkspaceEdit=Pe={}));var ge;(function(Ce){const Me=Object.create(null);Me[r.SymbolKind.File]=0,Me[r.SymbolKind.Module]=1,Me[r.SymbolKind.Namespace]=2,Me[r.SymbolKind.Package]=3,Me[r.SymbolKind.Class]=4,Me[r.SymbolKind.Method]=5,Me[r.SymbolKind.Property]=6,Me[r.SymbolKind.Field]=7,Me[r.SymbolKind.Constructor]=8,Me[r.SymbolKind.Enum]=9,Me[r.SymbolKind.Interface]=10,Me[r.SymbolKind.Function]=11,Me[r.SymbolKind.Variable]=12,Me[r.SymbolKind.Constant]=13,Me[r.SymbolKind.String]=14,Me[r.SymbolKind.Number]=15,Me[r.SymbolKind.Boolean]=16,Me[r.SymbolKind.Array]=17,Me[r.SymbolKind.Object]=18,Me[r.SymbolKind.Key]=19,Me[r.SymbolKind.Null]=20,Me[r.SymbolKind.EnumMember]=21,Me[r.SymbolKind.Struct]=22,Me[r.SymbolKind.Event]=23,Me[r.SymbolKind.Operator]=24,Me[r.SymbolKind.TypeParameter]=25;function fe(Fe){return typeof Me[Fe]=="number"?Me[Fe]:6}Ce.from=fe;function G(Fe){for(const je in Me)if(Me[je]===Fe)return Number(je);return r.SymbolKind.Property}Ce.to=G})(ge||(e.SymbolKind=ge={}));var me;(function(Ce){function Me(G){switch(G){case r.SymbolTag.Deprecated:return 1}}Ce.from=Me;function fe(G){switch(G){case 1:return r.SymbolTag.Deprecated}}Ce.to=fe})(me||(e.SymbolTag=me={}));var ce;(function(Ce){function Me(G){return{name:G.name,kind:ge.from(G.kind),tags:G.tags&&G.tags.map(me.from),containerName:G.containerName,location:V.from(G.location)}}Ce.from=Me;function fe(G){const Fe=new r.$vK(G.name,ge.to(G.kind),G.containerName,V.to(G.location));return Fe.tags=G.tags&&G.tags.map(me.to),Fe}Ce.to=fe})(ce||(e.WorkspaceSymbol=ce={}));var se;(function(Ce){function Me(G){const Fe={name:G.name||"!!MISSING: name!!",detail:G.detail,range:o.from(G.range),selectionRange:o.from(G.selectionRange),kind:ge.from(G.kind),tags:G.tags?.map(me.from)??[]};return G.children&&(Fe.children=G.children.map(Me)),Fe}Ce.from=Me;function fe(G){const Fe=new r.$wK(G.name,G.detail,ge.to(G.kind),o.to(G.range),o.to(G.selectionRange));return(0,y.$Lb)(G.tags)&&(Fe.tags=G.tags.map(me.to)),G.children&&(Fe.children=G.children.map(fe)),Fe}Ce.to=fe})(se||(e.DocumentSymbol=se={}));var $e;(function(Ce){function Me(G){const Fe=new r.$AK(ge.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),o.to(G.range),o.to(G.selectionRange));return Fe._sessionId=G._sessionId,Fe._itemId=G._itemId,Fe}Ce.to=Me;function fe(G,Fe,je){if(Fe=Fe??G._sessionId,je=je??G._itemId,Fe===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:je,name:G.name,detail:G.detail,kind:ge.from(G.kind),uri:G.uri,range:o.from(G.range),selectionRange:o.from(G.selectionRange),tags:G.tags?.map(me.from)}}Ce.from=fe})($e||(e.CallHierarchyItem=$e={}));var x;(function(Ce){function Me(fe){return new r.$BK($e.to(fe.from),fe.fromRanges.map(G=>o.to(G)))}Ce.to=Me})(x||(e.CallHierarchyIncomingCall=x={}));var z;(function(Ce){function Me(fe){return new r.$CK($e.to(fe.to),fe.fromRanges.map(G=>o.to(G)))}Ce.to=Me})(z||(e.CallHierarchyOutgoingCall=z={}));var V;(function(Ce){function Me(G){return{range:G.range&&o.from(G.range),uri:G.uri}}Ce.from=Me;function fe(G){return new r.$qK(p.URI.revive(G.uri),o.to(G.range))}Ce.to=fe})(V||(e.location=V={}));var ue;(function(Ce){function Me(G){const Fe=G,je=G;return{originSelectionRange:Fe.originSelectionRange?o.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:je.uri,range:o.from(Fe.targetRange?Fe.targetRange:je.range),targetSelectionRange:Fe.targetSelectionRange?o.from(Fe.targetSelectionRange):void 0}}Ce.from=Me;function fe(G){return{targetUri:p.URI.revive(G.uri),targetRange:o.to(G.range),targetSelectionRange:G.targetSelectionRange?o.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?o.to(G.originSelectionRange):void 0}}Ce.to=fe})(ue||(e.DefinitionLink=ue={}));var ye;(function(Ce){function Me(G){return{range:o.from(G.range),contents:U.fromMany(G.contents)}}Ce.from=Me;function fe(G){return new r.$tK(G.contents.map(U.to),o.to(G.range))}Ce.to=fe})(ye||(e.Hover=ye={}));var we;(function(Ce){function Me(G){return{range:o.from(G.range),expression:G.expression}}Ce.from=Me;function fe(G){return new r.$mL(o.to(G.range),G.expression)}Ce.to=fe})(we||(e.EvaluatableExpression=we={}));var pe;(function(Ce){function Me(G){if(G instanceof r.$nL)return{type:"text",range:o.from(G.range),text:G.text};if(G instanceof r.$oL)return{type:"variable",range:o.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof r.$pL)return{type:"expression",range:o.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Me;function fe(G){switch(G.type){case"text":return{range:o.to(G.range),text:G.text};case"variable":return{range:o.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:o.to(G.range),expression:G.expression}}}Ce.to=fe})(pe||(e.InlineValue=pe={}));var De;(function(Ce){function Me(G){return{frameId:G.frameId,stoppedLocation:o.from(G.stoppedLocation)}}Ce.from=Me;function fe(G){return new r.$qL(G.frameId,o.to(G.stoppedLocation))}Ce.to=fe})(De||(e.InlineValueContext=De={}));var ne;(function(Ce){function Me(G){return{range:o.from(G.range),kind:G.kind}}Ce.from=Me;function fe(G){return new r.$uK(o.to(G.range),G.kind)}Ce.to=fe})(ne||(e.DocumentHighlight=ne={}));var le;(function(Ce){function Me(fe){switch(fe){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Ce.to=Me})(le||(e.CompletionTriggerKind=le={}));var re;(function(Ce){function Me(fe){return{triggerKind:le.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Ce.to=Me})(re||(e.CompletionContext=re={}));var oe;(function(Ce){function Me(G){switch(G){case r.CompletionItemTag.Deprecated:return 1}}Ce.from=Me;function fe(G){switch(G){case 1:return r.CompletionItemTag.Deprecated}}Ce.to=fe})(oe||(e.CompletionItemTag=oe={}));var he;(function(Ce){const Me=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function fe(je){return Me.get(je)??9}Ce.from=fe;const G=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Fe(je){return G.get(je)??r.CompletionItemKind.Property}Ce.to=Fe})(he||(e.CompletionItemKind=he={}));var Ie;(function(Ce){function Me(fe,G){const Fe=new r.$KK(fe.label);return Fe.insertText=fe.insertText,Fe.kind=he.to(fe.kind),Fe.tags=fe.tags?.map(oe.to),Fe.detail=fe.detail,Fe.documentation=A.$4j(fe.documentation)?U.to(fe.documentation):fe.documentation,Fe.sortText=fe.sortText,Fe.filterText=fe.filterText,Fe.preselect=fe.preselect,Fe.commitCharacters=fe.commitCharacters,$.$qs.isIRange(fe.range)?Fe.range=o.to(fe.range):typeof fe.range=="object"&&(Fe.range={inserting:o.to(fe.range.insert),replacing:o.to(fe.range.replace)}),Fe.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Fe.insertText=new r.$pK(fe.insertText):(Fe.insertText=fe.insertText,Fe.textEdit=Fe.range instanceof r.$gK?new r.$lK(Fe.range,Fe.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Fe.additionalTextEdits=fe.additionalTextEdits.map(je=>Se.to(je))),Fe.command=G&&fe.command?G.fromInternal(fe.command):void 0,Fe}Ce.to=Me})(Ie||(e.CompletionItem=Ie={}));var F;(function(Ce){function Me(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:U.fromStrict(G.documentation)}}Ce.from=Me;function fe(G){return{label:G.label,documentation:A.$4j(G.documentation)?U.to(G.documentation):G.documentation}}Ce.to=fe})(F||(e.ParameterInformation=F={}));var q;(function(Ce){function Me(G){return{label:G.label,documentation:U.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(F.from):[],activeParameter:G.activeParameter}}Ce.from=Me;function fe(G){return{label:G.label,documentation:A.$4j(G.documentation)?U.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(F.to):[],activeParameter:G.activeParameter}}Ce.to=fe})(q||(e.SignatureInformation=q={}));var J;(function(Ce){function Me(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(q.from):[]}}Ce.from=Me;function fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(q.to):[]}}Ce.to=fe})(J||(e.SignatureHelp=J={}));var Q;(function(Ce){function Me(fe,G){const Fe=new r.$JK(h.to(G.position),typeof G.label=="string"?G.label:G.label.map(H.to.bind(void 0,fe)),G.kind&&_.to(G.kind));return Fe.textEdits=G.textEdits&&G.textEdits.map(Se.to),Fe.tooltip=A.$4j(G.tooltip)?U.to(G.tooltip):G.tooltip,Fe.paddingLeft=G.paddingLeft,Fe.paddingRight=G.paddingRight,Fe}Ce.to=Me})(Q||(e.InlayHint=Q={}));var H;(function(Ce){function Me(fe,G){const Fe=new r.$IK(G.label);return Fe.tooltip=A.$4j(G.tooltip)?U.to(G.tooltip):G.tooltip,f.Command.is(G.command)&&(Fe.command=fe.fromInternal(G.command)),G.location&&(Fe.location=V.to(G.location)),Fe}Ce.to=Me})(H||(e.InlayHintLabelPart=H={}));var _;(function(Ce){function Me(G){return G}Ce.from=Me;function fe(G){return G}Ce.to=fe})(_||(e.InlayHintKind=_={}));var ae;(function(Ce){function Me(G){return{range:o.from(G.range),url:G.target,tooltip:G.tooltip}}Ce.from=Me;function fe(G){let Fe;if(G.url)try{Fe=typeof G.url=="string"?p.URI.parse(G.url,!0):p.URI.revive(G.url)}catch{}return new r.$PK(o.to(G.range),Fe)}Ce.to=fe})(ae||(e.DocumentLink=ae={}));var Ne;(function(Ce){function Me(G){const Fe=new r.$SK(G.label);return G.textEdit&&(Fe.textEdit=Se.to(G.textEdit)),G.additionalTextEdits&&(Fe.additionalTextEdits=G.additionalTextEdits.map(je=>Se.to(je))),Fe}Ce.to=Me;function fe(G){return{label:G.label,textEdit:G.textEdit?Se.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Fe=>Se.from(Fe)):void 0}}Ce.from=fe})(Ne||(e.ColorPresentation=Ne={}));var Ue;(function(Ce){function Me(G){return new r.$QK(G[0],G[1],G[2],G[3])}Ce.to=Me;function fe(G){return[G.red,G.green,G.blue,G.alpha]}Ce.from=fe})(Ue||(e.Color=Ue={}));var Qe;(function(Ce){function Me(G){return{range:o.from(G.range)}}Ce.from=Me;function fe(G){return new r.$zK(o.to(G.range))}Ce.to=fe})(Qe||(e.SelectionRange=Qe={}));var Ge;(function(Ce){function Me(fe){switch(fe){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Ce.to=Me})(Ge||(e.TextDocumentSaveReason=Ge={}));var _e;(function(Ce){function Me(G){switch(G){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Me;function fe(G){switch(G){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Ce.to=fe})(_e||(e.TextEditorLineNumbersStyle=_e={}));var Ze;(function(Ce){function Me(G){if(G===r.EndOfLine.CRLF)return 1;if(G===r.EndOfLine.LF)return 0}Ce.from=Me;function fe(G){if(G===1)return r.EndOfLine.CRLF;if(G===0)return r.EndOfLine.LF}Ce.to=fe})(Ze||(e.EndOfLine=Ze={}));var xe;(function(Ce){function Me(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Me})(xe||(e.ProgressLocation=xe={}));var it;(function(Ce){function Me(G){const Fe={start:G.start+1,end:G.end+1};return G.kind&&(Fe.kind=tt.from(G.kind)),Fe}Ce.from=Me;function fe(G){const Fe={start:G.start-1,end:G.end-1};return G.kind&&(Fe.kind=tt.to(G.kind)),Fe}Ce.to=fe})(it||(e.FoldingRange=it={}));var tt;(function(Ce){function Me(G){if(G)switch(G){case r.FoldingRangeKind.Comment:return f.$ft.Comment;case r.FoldingRangeKind.Imports:return f.$ft.Imports;case r.FoldingRangeKind.Region:return f.$ft.Region}}Ce.from=Me;function fe(G){if(G)switch(G.value){case f.$ft.Comment.value:return r.FoldingRangeKind.Comment;case f.$ft.Imports.value:return r.FoldingRangeKind.Imports;case f.$ft.Region.value:return r.FoldingRangeKind.Region}}Ce.to=fe})(tt||(e.FoldingRangeKind=tt={}));var ze;(function(Ce){function Me(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?o.from(fe.selection):void 0,override:typeof fe.override=="boolean"?c.$PD.id:void 0}}Ce.from=Me})(ze||(e.TextEditorOpenOptions=ze={}));var st;(function(Ce){function Me(je){return je instanceof r.$aL?je.toJSON():typeof je=="string"?je:fe(je)||G(je)?new r.$aL(je.baseUri??je.base,je.pattern).toJSON():je}Ce.from=Me;function fe(je){const Je=je;return Je?p.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function G(je){const Je=je;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Fe(je){return typeof je=="string"?je:new r.$aL(p.URI.revive(je.baseUri),je.pattern)}Ce.to=Fe})(st||(e.GlobPattern=st={}));var Z;(function(Ce){function Me(fe){if(fe){if(Array.isArray(fe))return fe.map(Me);if(typeof fe=="string")return fe;{const G=fe;return{language:G.language,scheme:G.scheme,pattern:st.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Ce.from=Me})(Z||(e.LanguageSelector=Z={}));var X;(function(Ce){function Me(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(je=>je&&typeof je=="object"&&"uri"in je&&p.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Je=>Je instanceof r.$gK)))}Ce.is=Me;function fe(G){return{documents:G.documents.map(Fe=>Fe.map(je=>({uri:p.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Je=>o.from(Je))})))}}Ce.from=fe})(X||(e.MappedEditsContext=X={}));var ve;(function(Ce){function Me(G){return{start:G.start,end:G.end}}Ce.from=Me;function fe(G){return new r.$BL(G.start,G.end)}Ce.to=fe})(ve||(e.NotebookRange=ve={}));var Be;(function(Ce){function Me(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Ce.to=Me;function fe(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Ce.from=fe})(Be||(e.NotebookCellExecutionSummary=Be={}));var Oe;(function(Ce){function Me(fe){if(fe===b.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(fe===b.NotebookCellExecutionState.Pending)return;if(fe===b.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Ce.to=Me})(Oe||(e.NotebookCellExecutionState=Oe={}));var Xe;(function(Ce){function Me(G){switch(G){case r.NotebookCellKind.Markup:return b.CellKind.Markup;case r.NotebookCellKind.Code:default:return b.CellKind.Code}}Ce.from=Me;function fe(G){switch(G){case b.CellKind.Markup:return r.NotebookCellKind.Markup;case b.CellKind.Code:default:return r.NotebookCellKind.Code}}Ce.to=fe})(Xe||(e.NotebookCellKind=Xe={}));var nt;(function(Ce){function Me(G){const Fe={metadata:G.metadata??Object.create(null),cells:[]};for(const je of G.cells)r.$CL.validate(je),Fe.cells.push(ft.from(je));return Fe}Ce.from=Me;function fe(G){const Fe=new r.$DL(G.cells.map(ft.to));return(0,a.$Lf)(G.metadata)||(Fe.metadata=G.metadata),Fe}Ce.to=fe})(nt||(e.NotebookData=nt={}));var ft;(function(Ce){function Me(G){return{cellKind:Xe.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Be.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Pt.from):[]}}Ce.from=Me;function fe(G){return new r.$CL(Xe.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Pt.to):void 0,G.metadata,G.internalMetadata?Be.to(G.internalMetadata):void 0)}Ce.to=fe})(ft||(e.NotebookCellData=ft={}));var wt;(function(Ce){function Me(G){return{mime:G.mime,valueBytes:M.$be.wrap(G.data)}}Ce.from=Me;function fe(G){return new r.$EL(G.valueBytes.buffer,G.mime)}Ce.to=fe})(wt||(e.NotebookCellOutputItem=wt={}));var Pt;(function(Ce){function Me(G){return{outputId:G.id,items:G.items.map(wt.from),metadata:G.metadata}}Ce.from=Me;function fe(G){const Fe=G.items.map(wt.to);return new r.$FL(Fe,G.outputId,G.metadata)}Ce.to=fe})(Pt||(e.NotebookCellOutput=Pt={}));var Yt;(function(Ce){function Me(Fe){return G(Fe)?{include:st.from(Fe.include)??void 0,exclude:st.from(Fe.exclude)??void 0}:st.from(Fe)??void 0}Ce.from=Me;function fe(Fe){return G(Fe)?{include:st.to(Fe.include),exclude:st.to(Fe.exclude)}:st.to(Fe)}Ce.to=fe;function G(Fe){const je=Fe;return je?!(0,a.$Hf)(je.include)&&!(0,a.$Hf)(je.exclude):!1}})(Yt||(e.NotebookExclusiveDocumentPattern=Yt={}));var Gt;(function(Ce){function Me(fe,G,Fe){const je=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(je,Fe),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Ce.from=Me})(Gt||(e.NotebookStatusBarItem=Gt={}));var pt;(function(Ce){function Me(fe,G,Fe){const je=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:G.toInternal(je,Fe),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}Ce.from=Me})(pt||(e.NotebookKernelSourceAction=pt={}));var jt;(function(Ce){function Me(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Ce.from=Me})(jt||(e.NotebookDocumentContentOptions=jt={}));var Nt;(function(Ce){function Me(G){return{uri:G.uri,provides:G.provides}}Ce.from=Me;function fe(G){return new r.$HL(p.URI.revive(G.uri),G.provides)}Ce.to=fe})(Nt||(e.NotebookRendererScript=Nt={}));var Bt;(function(Ce){function Me(G){return{message:U.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:o.from(G.location.range),uri:G.location.uri}}}Ce.from=Me;function fe(G){const Fe=new r.$NL(typeof G.message=="string"?G.message:U.to(G.message));return Fe.actualOutput=G.actual,Fe.expectedOutput=G.expected,Fe.contextValue=G.contextValue,Fe.location=G.location?V.to(G.location):void 0,Fe}Ce.to=fe})(Bt||(e.TestMessage=Bt={}));var At;(function(Ce){Ce.namespace=v.$_I,Ce.denamespace=v.$aJ})(At||(e.TestTag=At={}));var Rt;(function(Ce){function Me(G){const Fe=(0,i.$_L)(G).controllerId;return{extId:E.$8I.fromExtHostTestItem(G,Fe).toString(),label:G.label,uri:p.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(je=>At.namespace(Fe,je.id)),range:$.$qs.lift(o.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&U.fromStrict(G.error)||null}}Ce.from=Me;function fe(G){return{parent:void 0,error:void 0,id:E.$8I.fromString(G.extId).localId,label:G.label,uri:p.URI.revive(G.uri),tags:(G.tags||[]).map(Fe=>{const{tagId:je}=At.denamespace(Fe);return new r.$OL(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Ce.toPlain=fe})(Rt||(e.TestItem=Rt={})),function(Ce){function Me(G){return{id:G.id}}Ce.from=Me;function fe(G){return new r.$OL(G.id)}Ce.to=fe}(At||(e.TestTag=At={}));var Ot;(function(Ce){const Me=(G,Fe)=>{const je=[];for(const[Ve,et]of Fe)E.$8I.compare(et.item.extId,Ve)===2&&(Fe.delete(Ve),je.push(et));const Je={...Rt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(et=>et.type===0).map(Bt.to)})),children:je.map(Ve=>Me(Ve,Fe))};for(const Ve of Je.children)Ve.parent=Je;return Je};function fe(G){const Fe=[],je=new Map;for(const Je of G.items){je.set(Je.item.extId,Je);const Ve=E.$8I.root(Je.item.extId);G.request.targets.some(et=>et.controllerId===Ve&&et.testIds.includes(Je.item.extId))&&Fe.push(Je)}return{completedAt:G.completedAt,results:Fe.map(Je=>Me(Je,je))}}Ce.to=fe})(Ot||(e.TestResults=Ot={}));var Wt;(function(Ce){function Me(je){return{covered:je.covered,total:je.covered}}function fe(je){return"line"in je?h.from(je):o.from(je)}function G(je){return"branches"in je?{count:je.executionCount,location:fe(je.location),type:1,branches:je.branches.length?je.branches.map(Je=>({count:Je.executionCount,location:Je.location&&fe(Je.location)})):void 0}:{type:0,count:je.executionCount,location:fe(je.location)}}Ce.fromDetailed=G;function Fe(je){return{uri:je.uri,statement:Me(je.statementCoverage),branch:je.branchCoverage&&Me(je.branchCoverage),function:je.functionCoverage&&Me(je.functionCoverage),details:je.detailedCoverage?.map(G)}}Ce.fromFile=Fe})(Wt||(e.TestCoverage=Wt={}));var Jt;(function(Ce){function Me(fe){switch(fe){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Ce.to=Me})(Jt||(e.CodeActionTriggerKind=Jt={}));var Kt;(function(Ce){function Me(G){const Fe=new r.$UL(ge.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),o.to(G.range),o.to(G.selectionRange));return Fe._sessionId=G._sessionId,Fe._itemId=G._itemId,Fe}Ce.to=Me;function fe(G,Fe,je){if(Fe=Fe??G._sessionId,je=je??G._itemId,Fe===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:je,kind:ge.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:o.from(G.range),selectionRange:o.from(G.selectionRange),tags:G.tags?.map(me.from)}}Ce.from=fe})(Kt||(e.TypeHierarchyItem=Kt={}));var Vt;(function(Ce){function Me(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}Ce.from=Me})(Vt||(e.ViewBadge=Vt={}));var Mt;(function(Ce){function Me(je,Je,Ve){const et=Je.fileData;return et?new r.$6K(new r.$7K(et.name,p.URI.revive(et.uri),et.id,(0,T.$db)(()=>Ve(et.id)))):je===R.$Nr.uriList&&Je.uriListData?new r.$5K(Fe(Je.uriListData)):new r.$5K(Je.asString)}Ce.to=Me;async function fe(je,Je){const Ve=await Je.asString();if(je===R.$Nr.uriList)return{asString:Ve,fileData:void 0,uriListData:G(Ve)};const et=Je.asFile();return{asString:Ve,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Ce.from=fe;function G(je){return C.$Zs.split(je).map(Je=>{if(Je.startsWith("#"))return Je;try{return p.URI.parse(Je)}catch{}return Je})}function Fe(je){return C.$Zs.create(je.map(Je=>typeof Je=="string"?Je:p.URI.revive(Je)))}})(Mt||(e.DataTransferItem=Mt={}));var ut;(function(Ce){function Me(G,Fe){const je=G.items.map(([Je,Ve])=>[Je,Mt.to(Je,Ve,Fe)]);return new r.$8K(je)}Ce.toDataTransfer=Me;async function fe(G){const Fe={items:[]},je=[];for(const[Je,Ve]of G)je.push((async()=>{Fe.items.push([Je,await Mt.from(Je,Ve)])})());return await Promise.all(je),Fe}Ce.from=fe})(ut||(e.DataTransfer=ut={}));var ht;(function(Ce){function Me(G){return{message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Ce.to=Me;function fe(G){return{kind:"reply",message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Ce.from=fe})(ht||(e.ChatReplyFollowup=ht={}));var Lt;(function(Ce){function Me(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:ht.from(fe)}Ce.from=Me})(Lt||(e.ChatFollowup=Lt={}));var qt;(function(Ce){function Me(G){const Fe=new r.$5L(kt.to(G.role),G.content);return Fe.name=G.name,Fe}Ce.to=Me;function fe(G){return{role:kt.from(G.role),content:G.content,name:G.name}}Ce.from=fe})(qt||(e.ChatMessage=qt={}));var kt;(function(Ce){function Me(G){switch(G){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Ce.to=Me;function fe(G){switch(G){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Ce.from=fe})(kt||(e.ChatMessageRole=kt={}));var at;(function(Ce){function Me(G){return{level:vt.to(G.level),value:G.value,description:G.description}}Ce.to=Me;function fe(G){return{level:vt.from(G.level),value:G.value,description:G.description}}Ce.from=fe})(at||(e.ChatVariable=at={}));var vt;(function(Ce){function Me(G){switch(G){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Ce.to=Me;function fe(G){switch(G){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Ce.from=fe})(vt||(e.ChatVariableLevel=vt={}));var Ht;(function(Ce){function Me(fe){switch(fe){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Me})(Ht||(e.InteractiveEditorResponseFeedbackKind=Ht={}));var Ct;(function(Ce){function Me(fe){return"placeholder"in fe&&"resolvedContent"in fe?{placeholder:fe.placeholder}:"responseId"in fe?{requestId:fe.responseId}:"content"in fe?{content:typeof fe.content=="string"?fe.content:U.from(fe.content)}:"documents"in fe?{documents:fe.documents.map(G=>({uri:G.uri,version:G.version,ranges:G.ranges.map(Fe=>o.from(Fe))}))}:"reference"in fe?{reference:"uri"in fe.reference?{uri:fe.reference.uri,range:o.from(fe.reference.range)}:fe.reference}:"inlineReference"in fe?{inlineReference:"uri"in fe.inlineReference?{uri:fe.inlineReference.uri,range:o.from(fe.inlineReference.range)}:fe.inlineReference,title:fe.title}:fe}Ce.from=Me})(Ct||(e.ChatResponseProgress=Ct={}));var We;(function(Ce){function Me(fe,G,Fe){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand}:"uri"in fe?{uri:fe.uri}:G.toInternal(fe,Fe)}Ce.from=Me})(We||(e.TerminalQuickFix=We={}))}),define(Ae[203],Re([1,0,2,9,7,8,173]),function(be,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=void 0;class l{constructor(g,R,k,a={timeout:1500,errors:3}){this.c=g,this.d=R,this.f=k,this.g=a,this.a=new A.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(R,k,a)=>{const $={dispose:this.a.push([R,k,g])};return Array.isArray(a)&&a.push($),$}}async $participateInSave(g,R){const k=y.URI.revive(g);let a=!1;const p=setTimeout(()=>a=!0,this.g.timeout),$=[];try{for(const f of[...this.a]){if(a)break;const t=this.d.getDocument(k),i=await this.h(f,{document:t,reason:T.TextDocumentSaveReason.to(R)});$.push(i)}}finally{clearTimeout(p)}return $}h([g,R,k],a){const p=this.b.get(g);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(k,g,R,a).then(()=>!0,$=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error($),!($ instanceof Error)||$.message!=="concurrent_edits"){const f=this.b.get(g);this.b.set(g,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,R,k,a){const p=[],$=Date.now(),{document:f,reason:t}=a,{version:i}=f,c=Object.freeze({document:f,reason:t,waitUntil(b){if(Object.isFrozen(p))throw(0,M.$8)("waitUntil can not be called async");p.push(Promise.resolve(b))}});try{R.apply(k,[c])}catch(b){return Promise.reject(b)}return Object.freeze(p),new Promise((b,E)=>{const v=setTimeout(()=>E(new Error("timeout")),this.g.timeout);return Promise.all(p).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-$}ms`),clearTimeout(v),b(n)}).catch(n=>{clearTimeout(v),E(n)})}).then(b=>{const E={edits:[]};for(const v of b)if(Array.isArray(v)&&v.every(n=>n instanceof C.$lK))for(const{newText:n,newEol:r,range:s}of v)E.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:s&&T.Range.from(s),text:n,eol:r&&T.EndOfLine.from(r)}});if(E.edits.length!==0)return i===f.version?this.f.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.$bcc=l}),define(Ae[204],Re([1,0,13,2,8,7,75]),function(be,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=e.$odc=void 0;class l{constructor(k,a,p,$){this.start=k,this.deletedCount=a,this.deletedItems=p,this.items=$}asApiEvent(){return{range:new T.$BL(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(k,a){return{EOL:a.eol,lines:a.source,languageId:a.language,uri:a.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,a,p){this.notebook=k,this.h=a,this.j=p,this.handle=p.handle,this.uri=M.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(C.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,a=this.h.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:a.document,get mime(){return k.g},set mime($){k.g=$},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(p)}return this.f}setOutputs(k){this.a=k.map(C.NotebookCellOutput.to)}setOutputItems(k,a,p){const $=p.map(C.NotebookCellOutputItem.to),f=this.a.find(t=>t.id===k);if(f&&(a||(f.items.length=0),f.items.push(...$),f.items.length>1&&f.items.every(t=>A.$mI(t.mime)))){const t=new Map,i=[];f.items.forEach(c=>{let b;t.has(c.mime)?b=t.get(c.mime):(b=[],t.set(c.mime,b),i.push(c.mime)),b.push(c.data)}),f.items.length=0,i.forEach(c=>{const b=A.$nI(t.get(c));f.items.push({mime:c,data:b.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$odc=D;class g{static{this.a=0}constructor(k,a,p,$,f){this.k=k,this.l=a,this.m=p,this.uri=$,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,a={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===y.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(p){return p=k.n(p),k.b[p].apiCell},getCells(p){return(p?k.p(p):k.b).map(f=>f.apiCell)},save(){return k.q()}};this.e=Object.freeze(a)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,a,p){this.g=k.versionId,this.h=a,this.acceptDocumentPropertiesChanged({metadata:p});const $={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},f=[];for(const i of k.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,$.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,$.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),f.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),f.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<f.length;i++){const c=f[i],b=t.get(c.cell);if(b===void 0){const E=$.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,E-1)}else $.cellChanges[b]={...$.cellChanges[b],...c}}return Object.freeze($),Object.freeze($.cellChanges),Object.freeze($.contentChanges),$}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let a=k.start|0,p=k.end|0;return a<0&&(a=0),p>this.b.length&&(p=this.b.length),k.with({start:a,end:p})}p(k){k=this.o(k);const a=[];for(let p=k.start;p<k.end;p++)a.push(this.b[p]);return a}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,a,p){if(this.j)return;const $=[],f=[],t=[];if(k.reverse().forEach(i=>{const b=i[2].map(n=>{const r=new D(this,this.l,n);return a||f.push(D.asModelAddData(this.apiNotebook,n)),r}),E=new l(i[0],i[1],[],b),v=this.b.splice(i[0],i[1],...b);for(const n of v)t.push(n.uri),E.deletedItems.push(n.apiCell);$.push(E)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:t}),p)for(const i of $)p.push(i.asApiEvent())}s(k,a,p,$){const f=this.b.splice(k,a);this.b.splice(p,0,...f);const t=[new l(k,a,f.map(i=>i.apiCell),[]),new l(p,0,[],f)];for(const i of t)$.push(i.asApiEvent())}t(k,a){this.b[k].setOutputs(a)}u(k,a,p,$){this.b[k].setOutputItems(a,p,$)}v(k,a){const p=this.b[k];p.apiCell.document.languageId!==a&&this.m.$acceptModelLanguageChanged(p.uri,a)}w(k,a){const p=this.b[k];p.apiCell.mime=a}x(k,a){this.b[k].setMetadata(a)}y(k,a){this.b[k].setInternalMetadata(a)}getCellFromApiCell(k){return this.b.find(a=>a.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(a=>a.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$pdc=g}),define(Ae[205],Re([1,0,5,2,8,7]),function(be,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;class A{constructor(D,g,R,k={timeout:1500,errors:3}){this.b=D,this.c=g,this.d=R,this.f=k,this.a=new y.$Pd}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(g,R,k)=>{const a=function($){g.call(R,$)};return a.extension=D,this.a.event(a,void 0,k)}}async $participateInSave(D,g,R){const k=M.URI.revive(D),a=this.c.getNotebookDocument(k);if(!a)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:a.apiNotebook,reason:C.TextDocumentSaveReason.to(g)},R,async(f,t)=>{const i=Date.now(),c=await await Promise.resolve(f);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!R.isCancellationRequested&&c&&(c instanceof T.$oK?p.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(p.length===0)return!0;const $={edits:[]};for(const f of p){const{edits:t}=C.WorkspaceEdit.from(f);$.edits=$.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit($)}}e.$Pdc=A}),define(Ae[103],Re([1,0,9,8,7]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;class T{static{this.apiEditorsToExtHost=new WeakMap}constructor(l,D,g,R,k,a){this.id=l,this.f=D,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=R,this.c=a}get apiEditor(){if(!this.e){const l=this;this.e={get notebook(){return l.notebookData.apiNotebook},get selection(){return l.a[0]},set selection(D){this.selections=[D]},get selections(){return l.a},set selections(D){if(!Array.isArray(D)||!D.every(C.$BL.isNotebookRange))throw(0,y.$7)("selections");l.a=D,l.g(D)},get visibleRanges(){return l.b},revealRange(D,g){l.f.$tryRevealRange(l.id,M.NotebookRange.from(D),g??C.NotebookEditorRevealType.Default)},get viewColumn(){return l.c}},T.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(l){this.d=l}_acceptVisibleRanges(l){this.b=l}_acceptSelections(l){this.a=l}g(l){this.f.$trySetSelections(this.id,l.map(M.NotebookRange.from))}_acceptViewColumn(l){this.c=l}}e.$qdc=T}),define(Ae[206],Re([1,0,9,5,14,8]),function(be,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;let A=class{constructor(D,g){this.c=D,this.d=g,this.a=new M.$Nd({onListenerError:y.$2}),this.b=new M.$Nd({onListenerError:y.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,g);const R=this.d.getEditorById(D);g.visibleRanges&&R._acceptVisibleRanges(g.visibleRanges.ranges.map(T.NotebookRange.to)),g.selections&&R._acceptSelections(g.selections.selections.map(T.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const g in D)this.d.getEditorById(g)._acceptViewColumn(T.ViewColumn.to(D[g]))}};e.$Idc=A,e.$Idc=A=qe([Ke(0,C.$9i)],A)}),define(Ae[207],Re([1,0,8,51,152,20,65,9]),function(be,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class D{constructor(a){this.b=0,this.c=new Map,this.a=a}async withProgress(a,p,$){const f=this.b++,{title:t,location:i,cancellable:c}=p,b={label:(0,C.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this.a.$startProgress(f,{location:y.ProgressLocation.from(i),title:t,source:b,cancellable:c},a.isUnderDevelopment?void 0:a.identifier.value).catch(l.$2),this.d(f,$,!!c)}d(a,p,$){let f;$&&(f=new T.$Xd,this.c.set(a,f));const t=c=>{this.a.$progressEnd(c),this.c.delete(c),f?.dispose()};let i;try{i=p(new R(this.a,a),$&&f?f.token:T.CancellationToken.None)}catch(c){throw t(a),c}return i.then(c=>t(a),c=>t(a)),i}$acceptProgressCanceled(a){const p=this.c.get(a);p&&(p.cancel(),this.c.delete(a))}}e.$Mcc=D;function g(k,a){return k.message=a.message,typeof a.increment=="number"&&(typeof k.increment=="number"?k.increment+=a.increment:k.increment=a.increment),k}class R extends M.$2u{constructor(a,p){super($=>this.throttledReport($)),this.i=a,this.j=p}throttledReport(a){this.i.$progressReport(this.j,a)}}qe([(0,A.$ih)(100,(k,a)=>g(k,a),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ae[104],Re([1,0,45,101,46,76,57,8,2]),function(be,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=e.$qM=e.$pM=void 0;const g=(b,E,v,n)=>{let r=E;return{enumerable:!0,configurable:!1,get(){return r},set(s){if(!v(r,s)){const o=r;r=s,b.listener?.(n(s,o))}}}},R=(b,E)=>b===E,k={range:(b,E)=>b===E?!0:!b||!E?!1:b.isEqual(E),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(b,E)=>!(b.length!==E.length||b.some(v=>!E.find(n=>v.id===n.id)))},a=b=>E=>({op:4,update:b(E)}),p=(b,E)=>({range:(()=>{let v;const n=a(r=>({range:y.$qs.lift(l.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return v},set(r){b.listener?.({op:6}),k.range(v,r)||(v=r,b.listener?.(n(r)))}}})(),label:g(b,E,k.label,a(v=>({label:v}))),description:g(b,void 0,k.description,a(v=>({description:v}))),sortText:g(b,void 0,k.sortText,a(v=>({sortText:v}))),canResolveChildren:g(b,!1,k.canResolveChildren,v=>({op:2,state:v})),busy:g(b,!1,k.busy,a(v=>({busy:v}))),error:g(b,void 0,k.error,a(v=>({error:l.MarkdownString.fromStrict(v)||null}))),tags:g(b,[],k.tags,(v,n)=>({op:1,new:v.map(l.TestTag.from),old:n.map(l.TestTag.from)}))}),$=b=>{const E=C.$8I.fromString(b.extId),v=new t(E.controllerId,E.localId,b.label,D.URI.revive(b.uri)||void 0);return v.range=l.Range.to(b.range||void 0),v.description=b.description||void 0,v.sortText=b.sortText||void 0,v.tags=b.tags.map(n=>l.TestTag.to({id:(0,A.$aJ)(n).tagId})),v},f=b=>{let E;for(const v of b.tests){const n=$(v.item);(0,M.$_L)(n).parent=E,E=n}return E};e.$pM=f;class t{constructor(E,v,n,r){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const s=(0,M.$$L)(this,E);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof i?void 0:s.parent}},children:{value:(0,T.$0L)(s,M.$_L,t),enumerable:!0,writable:!1},...p(s,n)})}}e.$qM=t;class i extends t{constructor(E,v){super(E,E,v,void 0),this._isRoot=!0}}e.$rM=i;class c extends T.$6L{constructor(E,v,n){super({controllerId:E,getDocumentVersion:r=>r&&n.getDocument(r)?.version,getApiFor:M.$_L,getChildren:r=>r.children,root:new i(E,v),toITestItem:l.TestItem.from})}}e.$sM=c}),define(Ae[105],Re([1,0,52,9,88,8,7]),function(be,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=e.$kM=void 0;class l{static{this.c=new C.$iM("TextEditorDecorationType")}constructor(a,p,$){const f=l.c.nextId();a.$registerTextEditorDecorationType(p.identifier,f,T.DecorationRenderOptions.from($)),this.value=Object.freeze({key:f,dispose(){a.$removeTextEditorDecorationType(f)}})}}e.$kM=l;class D{constructor(a,p){this.g=[],this.h=void 0,this.j=!1,this.c=a,this.d=a.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(a,p){this.k();let $=null;if(a instanceof A.$fK)$=new A.$gK(a,a);else if(a instanceof A.$gK)$=a;else throw new Error("Unrecognized location");this.l($,p,!1)}insert(a,p){this.k(),this.l(new A.$gK(a,a),p,!0)}delete(a){this.k();let p=null;if(a instanceof A.$gK)p=a;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(a,p,$){const f=this.c.validateRange(a);this.g.push({range:f,text:p,forceMoveMarkers:$})}setEndOfLine(a){if(this.k(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=a}}class g{constructor(a,p,$,f){this.c=a,this.d=p,this._accept($),this.e=f;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(a){this.f=a.tabSize,this.g=a.indentSize,this.h=a.insertSpaces,this.j=a.cursorStyle,this.k=T.TextEditorLineNumbersStyle.to(a.lineNumbers)}l(a){if(a==="auto")return"auto";if(typeof a=="number"){const p=Math.floor(a);return p>0?p:null}if(typeof a=="string"){const p=parseInt(a,10);return isNaN(p)?null:p>0?p:null}return null}m(a){const p=this.l(a);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const p=Math.floor(a);return p>0?p:null}if(typeof a=="string"){const p=parseInt(a,10);return isNaN(p)?null:p>0?p:null}return null}o(a){const p=this.n(a);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(a){return a==="auto"?"auto":a==="false"?!1:!!a}q(a){const p=this.p(a);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(a){this.j!==a&&(this.j=a,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:a})))}t(a){this.k!==a&&(this.k=a,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:T.TextEditorLineNumbersStyle.from(a)})))}assign(a){const p={};let $=!1;if(typeof a.tabSize<"u"){const f=this.l(a.tabSize);f==="auto"?($=!0,p.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,$=!0,p.tabSize=f)}if(typeof a.indentSize<"u"){const f=this.n(a.indentSize);f==="tabSize"?($=!0,p.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,$=!0,p.indentSize=f)}if(typeof a.insertSpaces<"u"){const f=this.p(a.insertSpaces);f==="auto"?($=!0,p.insertSpaces=f):this.h!==f&&(this.h=f,$=!0,p.insertSpaces=f)}typeof a.cursorStyle<"u"&&this.j!==a.cursorStyle&&(this.j=a.cursorStyle,$=!0,p.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this.k!==a.lineNumbers&&(this.k=a.lineNumbers,$=!0,p.lineNumbers=T.TextEditorLineNumbersStyle.from(a.lineNumbers)),$&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(a,p){p.catch($=>{this.e.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this.e.warn($)})}}e.$lM=g;class R{constructor(a,p,$,f,t,i,c,b){this.id=a,this.j=p,this.k=$,this.g=!1,this.h=new Set,this.c=t,this.d=new g(this.j,this.id,i,$),this.e=c,this.f=b;const E=this;this.value=Object.freeze({get document(){return f.value},set document(v){throw new M.$9("document")},get selection(){return E.c&&E.c[0]},set selection(v){if(!(v instanceof A.$hK))throw(0,M.$7)("selection");E.c=[v],E.l()},get selections(){return E.c},set selections(v){if(!Array.isArray(v)||v.some(n=>!(n instanceof A.$hK)))throw(0,M.$7)("selections");E.c=v,E.l()},get visibleRanges(){return E.e},set visibleRanges(v){throw new M.$9("visibleRanges")},get options(){return E.d.value},set options(v){E.g||E.d.assign(v)},get viewColumn(){return E.f},set viewColumn(v){throw new M.$9("viewColumn")},edit(v,n={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new D(f.value,n);return v(r),E.m(r)},insertSnippet(v,n,r={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!n||Array.isArray(n)&&n.length===0)s=E.c.map(o=>T.Range.from(o));else if(n instanceof A.$fK){const{lineNumber:o,column:w}=T.Position.from(n);s=[{startLineNumber:o,startColumn:w,endLineNumber:o,endColumn:w}]}else if(n instanceof A.$gK)s=[T.Range.from(n)];else{s=[];for(const o of n)if(o instanceof A.$gK)s.push(T.Range.from(o));else{const{lineNumber:w,column:h}=T.Position.from(o);s.push({startLineNumber:w,startColumn:h,endLineNumber:w,endColumn:h})}}return p.$tryInsertSnippet(a,f.value.version,v.value,s,r)},setDecorations(v,n){const r=n.length===0;r&&!E.h.has(v.key)||(r?E.h.delete(v.key):E.h.add(v.key),E.n(()=>{if(T.$aM(n))return p.$trySetDecorations(a,v.key,T.$bM(n));{const s=new Array(4*n.length);for(let o=0,w=n.length;o<w;o++){const h=n[o];s[4*o]=h.start.line+1,s[4*o+1]=h.start.character+1,s[4*o+2]=h.end.line+1,s[4*o+3]=h.end.character+1}return p.$trySetDecorationsFast(a,v.key,s)}}))},revealRange(v,n){E.n(()=>p.$tryRevealRange(a,T.Range.from(v),n||A.TextEditorRevealType.Default))},show(v){p.$tryShowEditor(a,T.ViewColumn.from(v))},hide(){p.$tryHideEditor(a)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(a){(0,y.ok)(!this.g),this.d._accept(a)}_acceptVisibleRanges(a){(0,y.ok)(!this.g),this.e=a}_acceptViewColumn(a){(0,y.ok)(!this.g),this.f=a}_acceptSelections(a){(0,y.ok)(!this.g),this.c=a}async l(){const a=this.c.map(T.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,a)),this.value}m(a){const p=a.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const $=p.edits.map(t=>t.range);$.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=$.length-1;t<i;t++){const c=$[t].end;if($[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=p.edits.map(t=>({range:T.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,f,{setEndOfLine:typeof p.setEndOfLine=="number"?T.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(a){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$mM=R}),define(Ae[208],Re([1,0,4,171]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zJ=void 0,e.$zJ=(0,y.$Ph)(M.$Vh)}),define(Ae[106],Re([1,0,21,5,19,6]),function(be,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i4b=e.$h4b=e.$g4b=e.$f4b=e.$e4b=e.$d4b=void 0;class A{constructor(i,c){this.versionId=i,this.removedDueToLooping=c}}e.$d4b=A;class l{static isHostExtension(i,c,b){if(c.getExtensionDescription(i))return!1;const E=b.getExtensionDescription(i);return E?!!((E.main||E.browser)&&E.api==="none"):!1}constructor(i,c){this.j=i,this.c=new M.$Nd,this.onDidChange=this.c.event,this.d=0,this.e=c,this.k()}k(){this.e.sort($),this.f=new y.$6l,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const c=this.j.readActivationEvents(i);if(Array.isArray(c))for(let b of c)b==="onUri"&&(b=`onUri:${y.$4l.toKey(i.identifier)}`),this.h.has(b)||this.h.set(b,[]),this.h.get(b).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,c){this.e=f(this.e,c),this.e=this.e.concat(i);const b=l.l(this.e);return this.e=f(this.e,b.map(E=>E.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,b)}static l(i){const c=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,s){this.addNode(r),this.addNode(s),this.c.has(r)?this.c.get(r).push(s):this.c.set(r,[s])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,s){const o=c.getArcs(r);for(let w=0;w<o.length;w++)if(!s.has(o[w]))return!1;return!0}getNodes(){return this.e}},b=new y.$6l;for(const r of i)if(b.set(r.identifier,r),r.extensionDependencies)for(const s of r.extensionDependencies)c.addArc(y.$4l.toKey(r.identifier),y.$4l.toKey(s));const E=new Set;c.getNodes().filter(r=>c.getArcs(r).length===0).forEach(r=>E.add(r));const v=c.getNodes().filter(r=>!E.has(r));let n;do{n=!1;for(let r=0;r<v.length;r++){const s=v[r];c.hasOnlyGoodArcs(s,E)&&(v.splice(r,1),r--,E.add(s),n=!0)}}while(n);return v.map(r=>b.get(r))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const c=this.h.get(i);return c?c.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const c=this.f.get(i);return c||void 0}getExtensionDescriptionByUUID(i){for(const c of this.g)if(c.uuid===i)return c}getExtensionDescriptionByIdOrUUID(i,c){return this.getExtensionDescription(i)??(c?this.getExtensionDescriptionByUUID(c):void 0)}}e.$e4b=l;class D{constructor(i,c){this.versionId=i,this.extensions=c}}e.$f4b=D,e.$g4b={readActivationEvents:t=>t.activationEvents};class g{constructor(i){this.d=new a,this.c=new l(i,[])}async acquireLock(i){const c=await this.d.acquire(i);return new R(this,c)}deltaExtensions(i,c,b){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(c,b)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,c){return this.c.getExtensionDescriptionByIdOrUUID(i,c)}}e.$h4b=g;class R extends T.$Sc{constructor(i,c){super(),this.f=i,this.c=!1,this.B(c)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$i4b=R;class k{constructor(i){this.name=i,this.promise=new Promise((c,b)=>{this.c=c})}resolve(i){this.c(i)}}class a{constructor(){this.c=[],this.d=!1}async acquire(i){const c=new k(i);return this.c.push(c),this.e(),c.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let c=!0;const b=setTimeout(()=>{c&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),E=()=>{c&&(clearTimeout(b),c=!1,this.d=!1,this.e())};i.resolve((0,T.$Qc)(E))}}var p;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(p||(p={}));function $(t,i){const c=t.isBuiltin?0:t.isUnderDevelopment?2:1,b=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(c!==b)return c-b;const E=C.$gc.basename(t.extensionLocation.path),v=C.$gc.basename(i.extensionLocation.path);return E<v?-1:E>v?1:0}function f(t,i){const c=new y.$5l(i);return t.filter(b=>!c.has(b.identifier))}}),define(Ae[79],Re([1,0,26]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$am=e.$_l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(M||(e.UIKind=M={}));var C;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var T;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function A(g){const R=y.$be.alloc(1);switch(g){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$_l=A;function l(g,R){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$am=l;var D;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Ae[58],Re([1,0,4,5,14,27,79,53,54,24,2,6,154]),function(be,e,y,M,C,T,A,l,D,g,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=e.$vM=e.$uM=void 0;let p=class extends k.$Sc{constructor(i,c){super(),this.s=i,this.t=c,this.a=this.B(new M.$Nd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Nd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=c.createLogger(this.m,{id:D.$mo,name:(0,a.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(b=>{(0,C.$$i)(b)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,c,b){const E=this.getTelemetryDetails(),v=new $(c,b,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}),n=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...n,v]),v.apiTelemetryLogger}$initializeTelemetryLevel(i,c,b){this.f=i,this.g=c,this.c=b??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const c=Object.create(null);switch(c["common.extname"]=`${i.publisher}.${i.name}`,c["common.extversion"]=i.version,c["common.vscodemachineid"]=this.s.telemetryInfo.machineId,c["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,c["common.vscodeversion"]=this.s.version,c["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),c["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:c["common.uikind"]="web";break;case A.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,l.$Uk)((0,D.$to)(this.s.remote.authority)),c}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const c=this.getTelemetryDetails();this.r.forEach((b,E)=>{const v=b.filter(n=>!n.isDisposed);v.length===0?this.r.delete(E):this.r.set(E,v)}),this.r.forEach(b=>{for(const E of b)E.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,c){const E=this.r.get(i.value)?.filter(n=>!n.isDisposed);if(!E)return this.r.delete(i.value),!1;let v=!1;for(const n of E)n.ignoreUnhandledExtHostErrors||(n.logError(c),v=!0);return v}};e.$uM=p,e.$uM=p=qe([Ke(0,T.$tM),Ke(1,C.$0i)],p);class ${static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,c,b,E,v,n,r){this.g=b,this.h=E,this.i=v,this.j=n,this.a=new M.$Nd,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(i,c){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let c="properties"in i?i.properties??{}:i;return c=(0,D.$wo)(c,[]),this.c&&(c=(0,g.$7m)(c,this.c)),this.b||(c=(0,g.$7m)(c,this.j)),"properties"in i?i.properties=c:i=c,i}k(i,c){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(i,c),this.h.trace(i,c))}logUsage(i,c){this.d.isUsageEnabled&&this.k(i,c)}logError(i,c){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,c);else{const b={name:i.name,message:i.message,stack:i.stack,cause:i.cause},E=(0,D.$wo)(b,[]),v=new Error(E.message,{cause:E.cause});v.stack=E.stack,v.name=E.name,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f.sendErrorData(v,c),this.h.trace("exception",c)}}get apiTelemetryLogger(){if(!this.e){const i=this,c={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$vM=$;function f(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$wM=f,e.$xM=(0,y.$Oh)("IExtHostTelemetry")}),define(Ae[25],Re([1,0,5,2,180,98,21,4]),function(be,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fF=e.$eF=e.$dF=e.ActivationKind=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=e.ExtensionHostStartup=e.$0E=e.$9E=e.$8E=e.$7E=void 0,e.$7E=Object.freeze({identifier:new A.$4l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$8E="extensions.webWorker",e.$9E=(0,l.$Oh)("extensionService");class D{constructor(v){this.dependency=v}}e.$0E=D;var g;(function(E){E[E.EagerAutoStart=1]="EagerAutoStart",E[E.EagerManualStart=2]="EagerManualStart",E[E.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(v,n,r){this.c=v,this.d=n.slice(0),this.e=r.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:T.$RE.createActivationEventsMap(this.d)}}set(v,n,r){if(this.c>v)throw new Error(`ExtensionHostExtensions: invalid versionId ${v} (current: ${this.c})`);const s=[],o=[],w=[],h=[],I=k(this.d),S=k(n),u=(K,U)=>K.extensionLocation.toString()===U.extensionLocation.toString()||K.isBuiltin===U.isBuiltin||K.isUserBuiltin===U.isUserBuiltin||K.isUnderDevelopment===U.isUnderDevelopment;for(const K of this.d){const U=S.get(K.identifier);if(!U){s.push(K.identifier),I.delete(K.identifier);continue}if(!u(K,U)){s.push(K.identifier),I.delete(K.identifier);continue}}for(const K of n){const U=I.get(K.identifier);if(!U){o.push(K);continue}if(!u(U,K)){s.push(U.identifier),I.delete(U.identifier);continue}}const m=new A.$5l(this.e),d=new A.$5l(r);for(const K of this.e)d.has(K)||w.push(K);for(const K of r)m.has(K)||h.push(K);const P=T.$RE.createActivationEventsMap(o),W={versionId:v,toRemove:s,toAdd:o,addActivationEvents:P,myToRemove:w,myToAdd:h};return this.delta(W),W}delta(v){if(this.c>=v.versionId)return null;const{toRemove:n,toAdd:r,myToRemove:s,myToAdd:o}=v,w=new A.$5l(n),h=new A.$5l(s);for(let I=0;I<this.d.length;I++)w.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)h.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of r)this.d.push(I);for(const I of o)this.e.push(I);return v}containsExtension(v){for(const n of this.e)if(A.$4l.equals(n,v))return!0;return!1}}e.$$E=R;function k(E){const v=new A.$6l;for(const n of E)v.set(n.identifier,n);return v}function a(E,v){return E.enabledApiProposals?E.enabledApiProposals.includes(v):!1}e.$_E=a;function p(E,v){if(!a(E,v))throw new Error(`Extension '${E.identifier.value}' CANNOT use API proposal: ${v}.
Its package.json#enabledApiProposals-property declares: ${E.enabledApiProposals?.join(", ")??"[]"} but NOT ${v}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.$aF=p;class ${constructor(v,n,r,s){this.codeLoadingTime=v,this.activateCallTime=n,this.activateResolvedTime=r,this.activationReason=s}}e.$bF=$;class f{constructor(v,n){this.description=v,this.value=n}}e.$cF=f;var t;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,C.$Co)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation,targetPlatform:E.targetPlatform,validations:[],isValid:!0}}e.$dF=i;function c(E,v){return{identifier:new A.$4l((0,C.$Ao)(E.manifest.publisher,E.manifest.name)),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!v,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid,targetPlatform:E.targetPlatform}}e.$eF=c;class b{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(v){return Promise.resolve(void 0)}activationEventIsDone(v){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(v,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$fF=b}),define(Ae[209],Re([1,0,9,106,21,25,14,12]),function(be,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=e.$gcc=e.$fcc=e.$ecc=e.$dcc=e.$ccc=void 0;class D{static{this.NONE=new D(!1,-1,-1,-1)}constructor(i,c,b,E){this.startup=i,this.codeLoadingTime=c,this.activateCallTime=b,this.activateResolvedTime=E}}e.$ccc=D;class g{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,c){return i===-1||c===-1?-1:c-i}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$dcc=g;class R{constructor(i,c,b,E,v,n){this.activationFailed=i,this.activationFailedError=c,this.activationTimes=b,this.module=E,this.exports=v,this.subscriptions=n}}e.$ecc=R;class k extends R{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$fcc=k;class a extends R{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$gcc=a;class p extends R{constructor(i){super(!0,i,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let $=class{constructor(i,c,b,E){this.g=E,this.a=i,this.b=c,this.c=b,this.d=new C.$6l,this.f=Object.create(null)}dispose(){for(const[i,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const i=[];for(const[c,b]of this.d)i.push(b.wait());await Promise.all(i)}isActivated(i){const c=this.d.get(i);return!!(c&&c.value)}getActivatedExtension(i){const c=this.d.get(i);if(!c||!c.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return c.value}async activateByEvent(i,c){if(this.f[i])return;const b=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(b.map(E=>({id:E.identifier,reason:{startup:c,extensionId:E.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,c){const b=this.a.getExtensionDescription(i);if(!b)throw new Error(`Extension '${i}' is not known`);return this.h([{id:b.identifier,reason:c}])}async h(i){const c=i.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(c.map(b=>b.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const c=this.a.getExtensionDescription(i.id);if(!c){const v=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this.k(i,null,[],new p(v));return this.c.onExtensionActivationError(i.id,v,new T.$0E(i.id.value)),n}const b=[],E=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const v of E){if(this.m(v))continue;const n=this.d.get(v);if(n){b.push(n);continue}if(this.l(v)){b.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:i.reason}));continue}const r=this.a.getExtensionDescription(v);if(r){if(!r.main&&!r.browser)continue;b.push(this.j({id:r.identifier,reason:i.reason}));continue}const s=c.displayName||c.identifier.value,o=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${v}'`),w=this.k(i,c.displayName,[],new p(o));return this.c.onExtensionActivationError(c.identifier,o,new T.$0E(v)),w}return this.k(i,c.displayName,b,null)}k(i,c,b,E){const v=new f(i.id,c,i.reason,b,E,this.c,this.g);return this.d.set(i.id,v),v}l(i){return M.$e4b.isHostExtension(i,this.a,this.b)}m(i){const c=this.b.getExtensionDescription(i);return c?!c.main&&!c.browser:!1}};e.$hcc=$,e.$hcc=$=qe([Ke(3,A.$9i)],$);let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,c,b,E,v,n,r){this.c=i,this.d=c,this.f=b,this.g=E,this.h=v,this.j=n,this.k=r,this.a=new l.$Sg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const c=this.g[i];if(c.value&&!c.value.activationFailed){this.g.splice(i,1),i--;continue}if(c.value&&c.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);b.detail=c.value.activationFailedError,this.h=new p(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const c=new Error;if(i&&i.name&&(c.name=i.name),i&&i.message?c.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(c.stack=i.stack),this.h=new p(c),this.b&&y.$4(i))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};f=qe([Ke(6,A.$9i)],f)}),define(Ae[210],Re([1,0,156,23,2,5,6,192,12,7,15,18,8,50,20,125,25]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=void 0;function i(E,v){if((0,R.$yf)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let n;return Array.isArray(E.highlights)&&(n=E.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),n=n.length?n:void 0),{label:E.label,highlights:n}}}class c extends A.$Sc{constructor(v,n,r){super(),this.f=v,this.g=n,this.h=r,this.a=new Map,this.b=new f.$I7;function s(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:o=>s(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(w=>s(w)?this.r(w):w):o})}registerTreeDataProvider(v,n,r){const s=this.createTreeView(v,{treeDataProvider:n},r);return{dispose:()=>s.dispose()}}createTreeView(v,n,r){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=n.dragAndDropController?.dropMimeTypes??[],o=n.dragAndDropController?.dragMimeTypes??[],w=!!n.dragAndDropController?.handleDrag,h=!!n.dragAndDropController?.handleDrop,I=this.m(v,n,r),S={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:s,dragMimeTypes:o,hasHandleDrag:w,hasHandleDrop:h,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},u=this.f.$registerTreeViewDataProvider(v,S),m={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$aF)(r,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$aF)(r,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(d){(0,p.$4j)(d)&&(0,t.$aF)(r,"treeViewMarkdownMessage"),I.message=d},get title(){return I.title},set title(d){I.title=d},get description(){return I.description},set description(d){I.description=d},get badge(){return I.badge},set badge(d){d!==void 0&&g.ViewBadge.isViewBadge(d)?I.badge={value:Math.floor(Math.abs(d.value)),tooltip:d.tooltip}:d===void 0&&(I.badge=void 0)},reveal:(d,P)=>I.reveal(d,P),dispose:async()=>{await u,this.a.delete(v),I.dispose()}};return this.B(m),m}$getChildren(v,n){const r=this.a.get(v);return r?r.getChildren(n):Promise.reject(new l.$nE(v))}async $handleDrop(v,n,r,s,o,w,h,I){const S=this.a.get(v);if(!S)return Promise.reject(new l.$nE(v));const u=a.DataTransfer.toDataTransfer(r,async m=>(await this.f.$resolveDropFileData(v,n,m)).buffer);return h===v&&I&&await this.j(u,S,I,o,w),S.onDrop(u,s,o)}async j(v,n,r,s,o){const w=this.b.removeDragOperationTransfer(o);if(w)(await w)?.forEach((h,I)=>{h&&v.set(I,h)});else if(o&&n.handleDrag){const h=n.handleDrag(r,v,s);this.b.addDragOperationTransfer(o,h),await h}return v}async $handleDrag(v,n,r,s){const o=this.a.get(v);if(!o)return Promise.reject(new l.$nE(v));const w=await this.j(new g.$8K,o,n,s,r);if(!(!w||s.isCancellationRequested))return a.DataTransfer.from(w)}async $hasResolve(v){const n=this.a.get(v);if(!n)throw new l.$nE(v);return n.hasResolve}$resolve(v,n,r){const s=this.a.get(v);if(!s)throw new l.$nE(v);return s.resolveTreeItem(n,r)}$setExpanded(v,n,r){const s=this.a.get(v);if(!s)throw new l.$nE(v);s.setExpanded(n,r)}$setSelectionAndFocus(v,n,r){const s=this.a.get(v);if(!s)throw new l.$nE(v);s.setSelectionAndFocus(n,r)}$setVisible(v,n){const r=this.a.get(v);if(!r){if(!n)return;throw new l.$nE(v)}r.setVisible(n)}$changeCheckboxState(v,n){const r=this.a.get(v);if(!r)throw new l.$nE(v);r.setCheckboxState(n)}m(v,n,r){const s=this.B(new b(v,n,this.f,this.g.converter,this.h,r));return this.a.set(v,s),s}r(v){const n=this.a.get(v.$treeViewId);return n&&"$treeItemHandle"in v?n.getExtensionElement(v.$treeItemHandle):n&&"$focusedTreeItem"in v&&v.$focusedTreeItem?n.focusedElement:null}}e.$Tcc=c;class b extends A.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(v=>this.getExtensionElement(v)).filter(v=>!(0,R.$Hf)(v))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(v,n,r,s,o,w){if(super(),this.I=v,this.J=r,this.L=s,this.M=o,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new T.$Nd),this.onDidExpandElement=this.u.event,this.w=this.B(new T.$Nd),this.onDidCollapseElement=this.w.event,this.y=this.B(new T.$Nd),this.onDidChangeSelection=this.y.event,this.z=this.B(new T.$Nd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new T.$Nd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new T.$Nd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new T.$Nd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new $.$Xd,w.contributes&&w.contributes.views)for(const u in w.contributes.views)for(const m of w.contributes.views[u])m.id===v&&(this.P=m.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.F.fire({message:!1,element:u})));let h,I;const S=T.Event.debounce(this.F.event,(u,m)=>(u||(u={message:!1,elements:[]}),m.element!==!1&&(h||(h=new Promise(d=>I=d),this.G=this.G.then(()=>h)),Array.isArray(m.element)?u.elements.push(...m.element):u.elements.push(m.element)),m.message&&(u.message=!0),u),200,!0);this.B(S(({message:u,elements:m})=>{m.length&&(this.H=this.H.then(()=>{const d=I;return h=null,this.$(m).then(()=>d())})),u&&this.J.$setMessage(this.I,a.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(v){const n=v?this.getExtensionElement(v):void 0;if(v&&!n)return this.M.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let r=this.X(v);return r||(r=await this.Y(n)),r?r.map(s=>s.item):void 0}getExtensionElement(v){return this.j.get(v)}reveal(v,n){n=n||{select:!0,focus:!1};const r=(0,R.$Hf)(n.select)?!0:n.select,s=(0,R.$Hf)(n.focus)?!1:n.focus,o=(0,R.$Hf)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.G.then(()=>this.S(v)).then(w=>this.W(v,w[w.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:w.map(I=>I.item)},{select:r,focus:s,expand:o})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:r,focus:s,expand:o})}get message(){return this.O}set message(v){this.O=v,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(v){this.P=v,this.J.$setTitle(this.I,v,this.Q)}get description(){return this.Q}set description(v){this.Q=v,this.J.$setTitle(this.I,this.P,v)}get badge(){return this.R}set badge(v){this.R?.value===v?.value&&this.R?.tooltip===v?.tooltip||(this.R=a.ViewBadge.from(v),this.J.$setBadge(this.I,v))}setExpanded(v,n){const r=this.getExtensionElement(v);r&&(n?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(v,n){const r=!(0,k.$ub)(this.s,v);this.s=v;const s=this.t!==n;this.t=n,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(v){v!==this.r&&(this.r=v,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(v){const n=(await Promise.all(v.map(async r=>{const s=this.getExtensionElement(r.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:r.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);n.forEach(r=>{r.treeItem.checkboxState=r.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:n.map(r=>[r.extensionItem,r.newState])})}async handleDrag(v,n,r){const s=[];for(const o of v){const w=this.getExtensionElement(o);w&&s.push(w)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,n,r),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,n,r){const s=n?this.getExtensionElement(n):void 0;if(!(!s&&n||!this.g?.handleDrop))return(0,D.$Mg)(()=>this.g?.handleDrop?this.g.handleDrop(s,v,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,n){if(!this.f.resolveTreeItem)return;const r=this.j.get(v);if(r){const s=this.m.get(r);if(s){const o=await this.f.resolveTreeItem(s.extensionItem,r,n)??s.extensionItem;return this.hb(o),s.item.tooltip=this.eb(o.tooltip),s.item.command=this.fb(s.disposableStore,o.command),s.item}}}S(v){return this.U(v).then(n=>n?this.S(n).then(r=>this.W(n,r[r.length-1]).then(s=>(r.push(s),r))):Promise.resolve([]))}U(v){const n=this.m.get(v);return n?Promise.resolve(n.parent?this.j.get(n.parent.item.handle):void 0):(0,D.$Mg)(()=>this.f.getParent(v))}W(v,n){const r=this.m.get(v);return r?Promise.resolve(r):(0,D.$Mg)(()=>this.f.getTreeItem(v)).then(s=>this.kb(v,s,n,!0)).then(s=>this.getChildren(n?n.item.handle:void 0).then(()=>{const o=this.getExtensionElement(s);if(o){const w=this.m.get(o);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(v){if(v){let n;if(typeof v=="string"){const r=this.getExtensionElement(v);n=r?this.m.get(r):void 0}else n=v;return n&&n.children||void 0}return this.h}async Y(v){this.rb(v);const n=new $.$Xd(this.Z.token);try{const r=v?this.m.get(v):void 0,s=await this.f.getChildren(v);if(n.token.isCancellationRequested)return;const o=await Promise.all((0,k.$Hb)(s||[]).map(async w=>{const h=await this.f.getTreeItem(w);return h&&!n.token.isCancellationRequested?this.db(w,h,r):null}));return n.token.isCancellationRequested?void 0:(0,k.$Hb)(o)}finally{n.dispose()}}$(v){if(v.some(r=>!r))return this.Z.dispose(!0),this.Z=new $.$Xd,this.tb(),this.J.$refresh(this.I);{const r=this.ab(v);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(v){const n=new Set,r=v.map(o=>this.m.get(o));for(const o of r)if(o&&!n.has(o.item.handle)){let w=o;for(;w&&w.parent&&r.findIndex(h=>w&&w.parent&&h&&h.item.handle===w.parent.item.handle)===-1;){const h=this.j.get(w.parent.item.handle);w=h?this.m.get(h):void 0}w&&!w.parent&&n.add(o.item.handle)}const s=[];return n.forEach(o=>{const w=this.j.get(o);if(w){const h=this.m.get(w);h&&(!h.parent||!n.has(h.parent.item.handle))&&s.push(o)}}),s}bb(v){const n={};return Promise.all(v.map(r=>this.cb(r).then(s=>{s&&(n[r]=s.item)}))).then(()=>Object.keys(n).length?this.J.$refresh(this.I,n):void 0)}cb(v){const n=this.getExtensionElement(v);if(n){const r=this.m.get(n);if(r)return this.rb(n),(0,D.$Mg)(()=>this.f.getTreeItem(n)).then(s=>{if(s){const o=this.ib(n,s,r.parent);return this.pb(n,o,r,r.parent),r.dispose(),o}return null})}return Promise.resolve(null)}db(v,n,r){const s=this.ib(v,n,r);if(n.id&&this.j.has(s.item.handle))throw new Error((0,y.localize)(0,null,n.id));return this.ob(v,s),this.qb(s,r),s}eb(v){return g.$EK.isMarkdownString(v)?a.MarkdownString.from(v):v}fb(v,n){return n?{...this.L.toInternal(n,v),originalId:n.command}:void 0}gb(v){if(v.checkboxState===void 0)return;let n,r,s;return typeof v.checkboxState=="number"?n=v.checkboxState:(n=v.checkboxState.state,r=v.checkboxState.tooltip,s=v.checkboxState.accessibilityInformation),{isChecked:n===g.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:s}}hb(v){if(!g.$3K.isTreeItem(v,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(v,n,r){this.hb(n);const s=this.B(new A.$Rc),o=this.kb(v,n,r),w=this.lb(n);return{item:{handle:o,parentHandle:r?r.item.handle:void 0,label:i(n.label,this.N),description:n.description,resourceUri:n.resourceUri,tooltip:this.eb(n.tooltip),command:this.fb(s,n.command),contextValue:n.contextValue,icon:w,iconDark:this.mb(n)||w,themeIcon:this.jb(n),collapsibleState:(0,R.$Hf)(n.collapsibleState)?g.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.gb(n)},extensionItem:n,parent:r,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(v){return v.iconPath instanceof g.$$K?v.iconPath:void 0}kb(v,{id:n,label:r,resourceUri:s},o,w){if(n)return`${b.b}/${n}`;const h=i(r,this.N),I=o?o.item.handle:b.a;let S=h?h.label:s?(0,M.$sg)(s):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const u=this.m.has(v)?this.m.get(v).item.handle:void 0,m=this.X(o)||[];let d,P=0;do{if(d=`${I}/${P}:${S}`,w||!this.j.has(d)||u===d)break;P++}while(P<=m.length);return d}lb(v){if(v.iconPath&&!(v.iconPath instanceof g.$$K))return typeof v.iconPath=="string"||C.URI.isUri(v.iconPath)?this.nb(v.iconPath):this.nb(v.iconPath.light)}mb(v){if(v.iconPath&&!(v.iconPath instanceof g.$$K)&&v.iconPath.dark)return this.nb(v.iconPath.dark)}nb(v){return C.URI.isUri(v)?v:C.URI.file(v)}ob(v,n){this.j.set(n.item.handle,v),this.m.set(v,n)}pb(v,n,r,s){this.j.delete(n.item.handle),this.m.delete(v),n.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(v,n);const o=this.X(s)||[],w=o.filter(h=>h.item.handle===r.item.handle)[0];w&&o.splice(o.indexOf(w),1,n)}qb(v,n){n?(n.children||(n.children=[]),n.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}rb(v){if(v){const n=this.m.get(v);if(n){if(n.children)for(const r of n.children){const s=this.j.get(r.item.handle);s&&this.sb(s)}n.children=void 0}}else this.tb()}sb(v){const n=this.m.get(v);if(n){if(n.children)for(const r of n.children){const s=this.j.get(r.item.handle);s&&this.sb(s)}this.m.delete(v),this.j.delete(n.item.handle),n.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(v=>v.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[211],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[212],Re([1,0,166,9,29,92,72,30,21,211,176,98]),function(be,e,y,M,C,T,A,l,D,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=void 0;const a=l.$dn.as(A.$en.JSONContribution);class p{constructor(v,n,r){this.a=v,this.b=n,this.c=r}d(v,n){this.a({type:v,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(C.default.Error,v)}warn(v){this.d(C.default.Warning,v)}info(v){this.d(C.default.Info,v)}}e.$1E=p;class ${static a(v){const n=new D.$5l;for(let r=0,s=v.length;r<s;r++)n.add(v[r].description.identifier);return n}static compute(v,n){if(!v||!v.length)return new $(n,[]);if(!n||!n.length)return new $([],v);const r=this.a(v),s=this.a(n),o=n.filter(h=>!r.has(h.description.identifier)),w=v.filter(h=>!s.has(h.description.identifier));return new $(o,w)}constructor(v,n){this.added=v,this.removed=n}}e.$2E=$;class f{constructor(v,n){this.name=v,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=$.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,M.$1)(v)}}}e.$3E=f;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$4E={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.$3l},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"*",description:y.localize(42,null),body:"*"}]}},badges:{type:"array",description:y.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(44,null)},href:{type:"string",description:y.localize(45,null)},description:{type:"string",description:y.localize(46,null)}}}},markdown:{type:"string",description:y.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$Un}},extensionPack:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$Un}},extensionKind:{description:y.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(52,null)},{body:["workspace"],description:y.localize(53,null)},{body:["ui","workspace"],description:y.localize(54,null)},{body:["workspace","ui"],description:y.localize(55,null)},{body:[],description:y.localize(56,null)}]},capabilities:{description:y.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(60,null),y.localize(61,null),y.localize(62,null)]},description:{type:"string",markdownDescription:y.localize(63,null)}}},untrustedWorkspaces:{description:y.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(66,null),y.localize(67,null),y.localize(68,null)]},restrictedConfigurations:{description:y.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(70,null)}}}}},sponsor:{description:y.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(73,null),type:"string"},"vscode:uninstall":{description:y.localize(74,null),type:"string"}}},icon:{type:"string",description:y.localize(75,null)},l10n:{type:"string",description:y.localize(76,null)},pricing:{type:"string",markdownDescription:y.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const n=new f(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,n),v.activationEventsGenerator&&k.$RE.register(v.extensionPoint,v.activationEventsGenerator),e.$4E.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,a.registerSchema(i,e.$4E),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$5E=c;const b={ExtensionsRegistry:"ExtensionsRegistry"};l.$dn.add(b.ExtensionsRegistry,new c),e.$6E=l.$dn.as(b.ExtensionsRegistry),a.registerSchema(i,e.$4E),a.registerSchema(R.$pj,{properties:{extensionEnabledApiProposals:{description:y.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Ae[213],Re([1,0,163,15,24,212,32,5]),function(be,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KF=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var g;(function(a){function p($,f,t){if(!$)return;const i=M.$yf($.type)?$.type:void 0;if(!i||i.length===0){t.error(y.localize(3,null));return}const c=[];if(Array.isArray($.required))for(const b of $.required)M.$yf(b)&&c.push(b);return{extensionId:f.value,taskType:i,required:c,properties:$.properties?C.$4m($.properties):{},when:$.when?A.$Mi.deserialize($.when):void 0}}a.from=p})(g||(g={}));const R=T.$6E.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,p)=>{for(const $ of a)$.type&&p.push(`onTaskType:${$.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:D}});class k{constructor(){this.d=new l.$Nd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,$)=>{R.setHandler((f,t)=>{this.c=void 0;try{for(const i of t.removed){const c=i.value;for(const b of c)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const i of t.added){const c=i.value;for(const b of c){const E=g.from(b,i.description.identifier,i.collector);E&&(this.a[E.taskType]=E)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const $ of this.all()){const f={type:"object",additionalProperties:!1};$.required.length>0&&(f.required=$.required.slice(0)),$.properties!==void 0?f.properties=C.$4m($.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[$.taskType]},p.push(f)}this.c={oneOf:p}}return this.c}}e.$KF=new k}),define(Ae[214],Re([1,0,164,15,23,24,32,213]),function(be,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$UF=e.JsonSchemaVersion=e.ExecutionEngine=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$OF=e.ShellQuoting=e.$NF=e.$MF=e.$LF=void 0,e.$LF="settings",e.$MF=new A.$6i("taskRunning",!1,y.localize(0,null)),e.$NF={value:y.localize(1,null),original:"Tasks"};var D;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.$OF="$customized",function(O){function N(te){if(!te)return O.Strong;switch(te.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=N}(D||(e.ShellQuoting=D={}));var g;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var R;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(R||(e.RevealKind=R={})),function(O){function N(te){switch(te.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=N}(R||(e.RevealKind=R={}));var k;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(O){function N(te){switch(te.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=N}(k||(e.RevealProblemKind=k={}));var a;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(a||(e.PanelKind=a={})),function(O){function N(te){switch(te.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=N}(a||(e.PanelKind=a={}));var p;(function(O){O.defaults={echo:!0,reveal:R.Always,revealProblems:k.Never,focus:!1,panel:a.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var $;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})($||(e.RuntimeType=$={})),function(O){function N(Y){switch(Y.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=N;function te(Y){switch(Y){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=te}($||(e.RuntimeType=$={}));var f;(function(O){function N(te){return M.$yf(te)?te:te.value}O.value=N})(f||(e.CommandString=f={}));var t;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function N(Y){return Y===O.Clean._id||Y===O.Build._id||Y===O.Rebuild._id||Y===O.Test._id}O.is=N;function te(Y){if(Y!==void 0)return M.$yf(Y)?N(Y)?{_id:Y,isDefault:!1}:void 0:Y}O.from=te})(t||(e.TaskGroup=t={}));var i;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var c;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function N(te){switch(te){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=N})(c||(e.TaskSourceKind=c={}));var b;(function(O){O.parallel="parallel",O.sequence="sequence"})(b||(e.DependsOrder=b={}));var E;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(E||(e.RunOnOptions=E={}));var v;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:E.default,instanceLimit:1}})(v||(e.RunOptions=v={}));class n{constructor(N,te,Y,Ee,Se,Pe){this._label="",this._id=N,te&&(this._label=te),Y&&(this.type=Y),this.runOptions=Ee,this.configurationProperties=Se,this._source=Pe}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,te=!1){if(N===void 0)return!1;if(M.$yf(N))return N===this._label||N===this.configurationProperties.identifier||te&&N===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$PF=n;class r extends n{constructor(N,te,Y,Ee,Se,Pe,ge,me){super(N,Y,void 0,ge,me,te),this.command={},this._source=te,this.hasDefinedMatchers=Pe,Se&&(this.command=Se)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let te;switch(this.command?this.command.runtime:void 0){case $.Shell:te="shell";break;case $.Process:te="process";break;case $.CustomExecution:te="customExecution";break;case void 0:te="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:te,_key:this._id,id:this._id}}}static is(N){return N instanceof r}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$LF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let te=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(te+=this._source.kind);const Y={type:e.$OF,folder:N,id:te};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new r(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$QF=r;class s extends n{constructor(N,te,Y,Ee,Se,Pe,ge){super(N,Y,Ee,Pe,ge,te),this._source=te,this.configures=Se}static is(N){return N instanceof s}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$LF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let te=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(te+=this._source.kind);const Y={type:e.$OF,folder:N,id:te};return JSON.stringify(Y)}}e.$RF=s;class o extends n{constructor(N,te,Y,Ee,Se,Pe,ge,me,ce){super(N,Y,Ee,me,ce,te),this.defines=Se,this.hasDefinedMatchers=ge,this.command=Pe,this.icon=ce.icon,this.hide=ce.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof o}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new o(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$SF=o;class w extends n{constructor(N,te,Y,Ee,Se,Pe){super(N,Y,Ee,Se,Pe,te),this._source=te}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new w(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$TF=w;var h;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(O){O._default=O.Terminal}(h||(e.ExecutionEngine=h={}));var I;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class S{constructor(N){this.c=new Map;for(let te=0;te<N.length;te++)this.c.set(N[te].uri.toString(),te)}compare(N,te){const Y=N.getWorkspaceFolder(),Ee=te.getWorkspaceFolder();if(Y&&Ee){let Se=this.c.get(Y.uri.toString());Se=Se===void 0?0:Se+1;let Pe=this.c.get(Ee.uri.toString());return Pe=Pe===void 0?0:Pe+1,Se===Pe?N._label.localeCompare(te._label):Se-Pe}else return!Y&&Ee?-1:Y&&!Ee?1:0}}e.$UF=S;var u;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(u||(e.TaskEventKind=u={}));var m;(function(O){O.SingleRun="singleRun",O.Background="background"})(m||(e.TaskRunType=m={}));var d;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(d||(e.TaskRunSource=d={}));var P;(function(O){function N(me){return{taskId:me._id,taskName:me.configurationProperties.name,runType:me.configurationProperties.isBackground?"background":"singleRun",group:me.configurationProperties.group,__task:me}}function te(me,ce,se){return{...N(me),kind:"start",terminalId:ce,resolvedVariables:se}}O.start=te;function Y(me,ce,se){return{...N(me),kind:"processStarted",terminalId:ce,processId:se}}O.processStarted=Y;function Ee(me,ce,se){return{...N(me),kind:"processEnded",terminalId:ce,exitCode:se}}O.processEnded=Ee;function Se(me,ce,se){return{...N(me),kind:"terminated",exitReason:se,terminalId:ce}}O.terminated=Se;function Pe(me,ce,se){return{...N(ce),kind:me,terminalId:se}}O.general=Pe;function ge(){return{kind:"changed"}}O.changed=ge})(P||(e.TaskEvent=P={}));var W;(function(O){function N(Y){const Ee=Object.keys(Y).sort();let Se="";for(const Pe of Ee){let ge=Y[Pe];ge instanceof Object?ge=N(ge):typeof ge=="string"&&(ge=ge.replace(/,/g,",,")),Se+=Pe+","+ge+","}return Se}function te(Y){const Se={_key:N(Y),type:Y.taskType};return Object.assign(Se,Y),Se}O.create=te})(W||(e.KeyedTaskIdentifier=W={}));var K;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(K||(e.TaskSettingId=K={}));var U;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var B;(function(O){function N(te,Y){const Ee=l.$KF.get(te.type);if(Ee===void 0){const me=T.$4m(te);return delete me._key,W.create(me)}const Se=Object.create(null);Se.type=Ee.taskType;const Pe=new Set;Ee.required.forEach(me=>Pe.add(me));const ge=Ee.properties;for(const me of Object.keys(ge)){const ce=te[me];if(ce!=null)Se[me]=ce;else if(Pe.has(me)){const se=ge[me];if(se.default!==void 0)Se[me]=T.$4m(se.default);else switch(se.type){case"boolean":Se[me]=!1;break;case"number":case"integer":Se[me]=0;break;case"string":Se[me]="";break;default:Y.error(y.localize(2,null,JSON.stringify(te,void 0,0),me));return}}}return W.create(Se)}O.createTaskIdentifier=N})(B||(e.TaskDefinition=B={}))}),define(Ae[215],Re([1,0,9]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k4b=e.$j4b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,l)=>{this.b=A,this.d=l,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,y.$1)(A))}then(A,l){return this.j().then(A,l)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$j4b=M;class C extends M{constructor(){super(),this.h=!0,this.i=new y.$5}}e.$k4b=C}),define(Ae[47],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mv=e.$lv=e.$kv=e.$jv=void 0;class y{static{this.count=0}constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++y.count}}e.$jv=y;const M=[];function C(l){const D=new y(l);return M[D.nid]=D,D}e.$kv=C;function T(l){return M[l].sid}e.$lv=T;class A{constructor(D){this.value=D}}e.$mv=A}),define(Ae[3],Re([1,0,47]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.$cK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$bK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var C;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var T;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var A;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var l;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(l||(e.WebviewMessageArrayBufferViewType=l={}));var D;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var g;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var R;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class k{static{this.a=0}static mixin(t){return t._id=k.a++,t}}e.$bK=k;var a;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var p;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var $;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$cK={MainThreadAuthentication:(0,y.$kv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$kv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$kv)("MainThreadChatProvider"),MainThreadChatAgents:(0,y.$kv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,y.$kv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$kv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$kv)("MainThreadClipboard"),MainThreadCommands:(0,y.$kv)("MainThreadCommands"),MainThreadComments:(0,y.$kv)("MainThreadComments"),MainThreadConfiguration:(0,y.$kv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$kv)("MainThreadConsole"),MainThreadDebugService:(0,y.$kv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$kv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$kv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$kv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$kv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$kv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$kv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$kv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$kv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$kv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$kv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$kv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$kv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$kv)("MainThreadLanguages"),MainThreadLogger:(0,y.$kv)("MainThreadLogger"),MainThreadMessageService:(0,y.$kv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$kv)("MainThreadOutputService"),MainThreadProgress:(0,y.$kv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$kv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$kv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$kv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$kv)("MainThreadSecretState"),MainThreadStorage:(0,y.$kv)("MainThreadStorage"),MainThreadSpeech:(0,y.$kv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$kv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$kv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$kv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$kv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$kv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$kv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$kv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$kv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$kv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$kv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$kv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$kv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$kv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$kv)("MainThreadSCM"),MainThreadSearch:(0,y.$kv)("MainThreadSearch"),MainThreadShare:(0,y.$kv)("MainThreadShare"),MainThreadTask:(0,y.$kv)("MainThreadTask"),MainThreadWindow:(0,y.$kv)("MainThreadWindow"),MainThreadLabelService:(0,y.$kv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$kv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$kv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$kv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$kv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$kv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$kv)("MainThreadInteractive"),MainThreadChat:(0,y.$kv)("MainThreadChat"),MainThreadInlineChat:(0,y.$kv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$kv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$kv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$kv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$kv)("MainThreadTimeline"),MainThreadTesting:(0,y.$kv)("MainThreadTesting"),MainThreadLocalization:(0,y.$kv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$kv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$kv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$kv)("MainThreadIssueReporter")},e.$dK={ExtHostCommands:(0,y.$kv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$kv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$kv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$kv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$kv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$kv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$kv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$kv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$kv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$kv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$kv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$kv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$kv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$kv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$kv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$kv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$kv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$kv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$kv)("ExtHostStatusBar"),ExtHostShare:(0,y.$kv)("ExtHostShare"),ExtHostExtensionService:(0,y.$kv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$kv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$kv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$kv)("ExtHostSCM"),ExtHostSearch:(0,y.$kv)("ExtHostSearch"),ExtHostTask:(0,y.$kv)("ExtHostTask"),ExtHostWorkspace:(0,y.$kv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$kv)("ExtHostWindow"),ExtHostWebviews:(0,y.$kv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$kv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$kv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$kv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$kv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$kv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$kv)("ExtHostProgress"),ExtHostComments:(0,y.$kv)("ExtHostComments"),ExtHostSecretState:(0,y.$kv)("ExtHostSecretState"),ExtHostStorage:(0,y.$kv)("ExtHostStorage"),ExtHostUrls:(0,y.$kv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$kv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$kv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$kv)("ExtHostOutputService"),ExtHosLabelService:(0,y.$kv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$kv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$kv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$kv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$kv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$kv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$kv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$kv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$kv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$kv)("ExtHostChat"),ExtHostChatAgents:(0,y.$kv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,y.$kv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$kv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$kv)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$kv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$kv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$kv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$kv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$kv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$kv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$kv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$kv)("ExtHostTimeline"),ExtHostTesting:(0,y.$kv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$kv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$kv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$kv)("ExtHostIssueReporter")}}),define(Ae[216],Re([1,0,3,7]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$cK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,l,D){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(A);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation(l,D)??[]}getRelatedInformation(A,l,D){return this.c.$getAiRelatedInformation(l,D)}registerRelatedInformationProvider(A,l,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiRelatedInformationProvider(g,l),new M.$eK(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$Vdc=C}),define(Ae[80],Re([1,0,4,14,3,17]),function(be,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=e.$Xbc=void 0,e.$Xbc=(0,y.$Oh)("IExtHostApiDeprecationService");let A=class{constructor(D,g){this.c=g,this.a=new Set,this.b=D.getProxy(C.$cK.MainThreadTelemetry)}report(D,g,R){const k=this.d(D,g);this.a.has(k)||(this.a.add(k),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:D}))}d(D,g){return`${D}-${g.identifier.value}`}};e.$Ybc=A,e.$Ybc=A=qe([Ke(0,T.$dM),Ke(1,M.$9i)],A),e.$Zbc=Object.freeze(new class{report(l,D,g){}})}),define(Ae[217],Re([1,0,5,3,7,21]),function(be,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class A{constructor(g){this.b=new Map,this.c=[],this.d=new y.$Nd,this.onDidChangeSessions=this.d.event,this.f=new l,this.g=new l,this.a=g.getProxy(M.$cK.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,R,k,a={}){const p=T.$4l.toKey(g.identifier),$=[...k].sort().join(" ");return await this.f.getOrCreate(`${p} ${R} ${$}`,async()=>{await this.a.$ensureProvider(R);const f=g.displayName||g.name;return this.a.$getSession(R,k,p,f,a)})}async getSessions(g,R,k){const a=T.$4l.toKey(g.identifier),p=[...k].sort().join(" ");return await this.g.getOrCreate(`${a} ${p}`,async()=>{await this.a.$ensureProvider(R);const $=g.displayName||g.name;return this.a.$getSessions(R,k,a,$)})}async removeSession(g,R){const k=this.b.get(g);return k?k.provider.removeSession(R):this.a.$removeSession(g,R)}registerAuthenticationProvider(g,R,k,a){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:R,provider:k,options:a??{supportsMultipleAccounts:!1}}),this.c.find($=>$.id===g)||this.c.push({id:g,label:R});const p=k.onDidChangeSessions($=>{this.a.$sendDidChangeSessions(g,{added:$.added??[],changed:$.changed??[],removed:$.removed??[]})});return this.a.$registerAuthenticationProvider(g,R,a?.supportsMultipleAccounts??!1),new C.$eK(()=>{p.dispose(),this.b.delete(g);const $=this.c.findIndex(f=>f.id===g);$>-1&&this.c.splice($),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,R,k){const a=this.b.get(g);if(a)return Promise.resolve(a.provider.createSession(R,k));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,R){const k=this.b.get(g);if(k)return Promise.resolve(k.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,R){const k=this.b.get(g);if(k)return Promise.resolve(k.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,R){return this.d.fire({provider:{id:g,label:R}}),Promise.resolve()}}e.$tdc=A;class l{constructor(){this.a=new Map}getOrCreate(g,R){const k=this.a.get(g);if(k)return k;const a=R().finally(()=>this.a.delete(g));return this.a.set(g,a),a}}}),define(Ae[218],Re([1,0,3,17,8]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;let T=class{constructor(l,D){this.a=l.getProxy(y.$cK.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>D.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(l,D,g){const R=C.WorkspaceEdit.from(l,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,g?.isRefactoring??!1)}};e.$zdc=T,e.$zdc=T=qe([Ke(0,M.$dM)],T)}),define(Ae[219],Re([1,0,12,5,66,6,59,146,3,8]),function(be,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;class R{static{this.a=0}constructor(p,$){this.extension=p,this.provider=$,this.handle=R.a++}}class k{static{this.a=0}constructor(p,$){this.h=$,this.b=new Map,this.d=new Map,this.e=new M.$Nd,this.onDidPerformUserAction=this.e.event,this.g=p.getProxy(D.$cK.MainThreadChat)}registerChatProvider(p,$,f){const t=new R(p,f);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,$),(0,T.$Qc)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(p,$){const f=C.Iterable.find(this.d.keys(),t=>this.d.get(t)===p)??0;typeof f=="number"&&this.g.$transferChatSession(f,$)}sendInteractiveRequestToProvider(p,$){this.g.$sendRequestToProvider(p,$)}async $prepareChat(p,$,f){const t=this.b.get(p);if(!t)return;const i=await t.provider.prepareSession($,f);if(!i)return;const c=k.a++;return this.d.set(c,i),{id:c,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $provideWelcomeMessage(p,$){const f=this.b.get(p);if(!f||!f.provider.provideWelcomeMessage)return;const t=await f.provider.provideWelcomeMessage($);if(t)return t.map(i=>typeof i=="string"?i:i.map(c=>g.ChatReplyFollowup.from(c)))}async $provideFollowups(p,$,f){const t=this.b.get(p);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,f))?.map(b=>g.ChatFollowup.from(b))}async $provideSampleQuestions(p,$){const f=this.b.get(p);if(!f||!f.provider.provideSampleQuestions)return;const t=await f.provider.provideSampleQuestions($);if(t)return t?.map(i=>g.ChatReplyFollowup.from(i))}$removeRequest(p,$,f){const t=this.b.get(p);if(!t)return;const i=this.d.get($);i&&t.provider.removeRequest&&t.provider.removeRequest(i,f)}async $provideReply(p,$,f,t){const i=this.b.get(p);if(!i)return;const c=this.d.get($);if(!c)return;const b={session:c,message:typeof f.message=="string"?f.message:g.ChatReplyFollowup.to(f.message),variables:{}};if(f.variables)for(const o of Object.keys(f.variables))b.variables[o]=f.variables[o].map(g.ChatVariable.to);const E=A.$Jd.create(!1);let v;const n={report:o=>{if(t.isCancellationRequested)return;typeof v>"u"&&(v=E.elapsed());const w=g.ChatResponseProgress.from(o);if("placeholder"in o&&"resolvedContent"in o){const h=Promise.all([this.g.$acceptResponseProgress(p,$,w),o.resolvedContent]);(0,y.$Ig)(h,t).then(I=>{if(!I)return;const[S,u]=I;this.g.$acceptResponseProgress(p,$,u,S??void 0)})}else this.g.$acceptResponseProgress(p,$,w)}};let r;try{r=await i.provider.provideResponseWithProgress(b,n,t),r||(r={errorDetails:{message:(0,l.localize)(0,null)}})}catch(o){r={errorDetails:{message:(0,l.localize)(1,null,o.message),responseIsIncomplete:!0}},this.h.error(o)}try{if(c.saveState&&this.d.has($)){const o=c.saveState();this.g.$acceptChatState($,o)}}catch(o){this.h.warn(o)}const s={firstProgress:v??0,totalElapsed:E.elapsed()};return{errorDetails:r.errorDetails,timings:s}}async $provideSlashCommands(p,$,f){const t=this.b.get(p);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,f))?.map(b=>({...b,kind:g.CompletionItemKind.from(b.kind)}))}$releaseSession(p){this.d.delete(p)}async $onDidPerformUserAction(p){this.e.fire(p)}}e.$Ndc=k}),define(Ae[220],Re([1,0,12,6,51,3,8,7]),function(be,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=void 0;class D{static{this.a=0}constructor(k,a,p){this.d=a,this.e=p,this.b=new Map,this.c=k.getProxy(T.$cK.MainThreadChatAgents)}registerAgent(k,a,p,$){const f=D.a++;return this.b.set(f,{extension:k,agent:p}),this.c.$registerAgent(f,a,$),(0,M.$Qc)(()=>{this.c.$unregisterAgent(f),this.b.delete(f)})}async $invokeAgent(k,a,p,$,f){const t=this.b.get(k);if(!t){this.e.warn(`[CHAT](${k}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function c(){if(i)throw new Error("Only valid while executing the command")}const b=new y.$ch;f.onCancellationRequested(()=>b.complete()),setTimeout(()=>b.complete(),10*1e3),this.d.allowListExtensionWhile(t.extension,b.p);const E=t.agent({role:l.ChatMessageRole.User,content:p},{history:$.history.map(A.ChatMessage.to)},new C.$2u(v=>{c(),this.c.$handleProgressChunk(a,{content:g(v.message)?v.message:v.message.value})}),f);try{return await(0,y.$Ig)(Promise.resolve(E).then(v=>{if(v&&"followUp"in v)return{followUp:v?.followUp?.map(r=>A.ChatFollowup.from(r))}}),f)}finally{i=!0,b.complete()}}}e.$Xdc=D;function g(R){return!!R&&typeof R=="object"&&"treeData"in R}}),define(Ae[221],Re([1,0,12,20,37,15,51,3,8]),function(be,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;class g{static{this.a=0}constructor(a,p,$){this.g=p,this.h=$,this.b=new Map,this.d=a.getProxy(l.$cK.MainThreadChatAgents2)}createChatAgent(a,p,$){const f=g.a++,t=new R(a,p,this.d,f,$);return this.b.set(f,t),this.d.$registerAgent(f,p,{}),t.apiAgent}async $invokeAgent(a,p,$,f,t){const i=this.b.get(a);if(!i)throw new Error(`[CHAT](${a}) CANNOT invoke agent because the agent is not registered`);let c=!1;function b(){if(c)throw new Error("Only valid while executing the command")}const E=new y.$ch;t.onCancellationRequested(()=>E.complete()),setTimeout(()=>E.complete(),3*1e3),this.g.allowListExtensionWhile(i.extension,E.p);const v=$.command?await i.validateSlashCommand($.command):void 0;try{const n=i.invoke({prompt:$.message,variables:{},slashCommand:v},{history:f.history.map(D.ChatMessage.to)},new A.$2u(r=>{b();const s=D.ChatResponseProgress.from(r);this.d.$handleProgressChunk(p,s)}),t);return await(0,y.$Ig)(Promise.resolve(n).then(r=>{if(r)return{errorDetails:r.errorDetails}}),t)}catch(n){return this.h.error(n,i.extension),{errorDetails:{message:(0,C.$zi)(n)}}}finally{c=!0,E.complete()}}async $provideSlashCommands(a,p){const $=this.b.get(a);return $?$.provideSlashCommand(p):[]}async $provideFollowups(a,p,$){const f=this.b.get(a);return f?f.provideFollowups(null,$):[]}}e.$Ydc=g;class R{constructor(a,p,$,f,t){this.extension=a,this.j=p,this.k=$,this.l=f,this.m=t}async validateSlashCommand(a){this.b||(await this.provideSlashCommand(M.CancellationToken.None),(0,T.$If)(this.b));const p=this.b.find($=>$.name===a);if(!p)throw new Error(`Unknown slashCommand: ${a}`);return p}async provideSlashCommand(a){if(!this.a)return[];const p=await this.a.provideSlashCommands(a);return p?(this.b=p,p.map($=>({name:$.name,description:$.description}))):[]}async provideFollowups(a,p){if(!this.d)return[];const $=await this.d.provideFollowups(a,p);return $?$.map(f=>D.ChatFollowup.from(f)):[]}get apiAgent(){let a=!1;const p=()=>{a||(a=!0,queueMicrotask(()=>{this.k.$updateAgent(this.l,{description:this.g??"",fullName:this.h,icon:this.i,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0}),a=!1}))},$=this;return{get name(){return $.j},get description(){return $.g??""},set description(f){$.g=f,p()},get fullName(){return $.h??$.extension.value},set fullName(f){$.h=f,p()},get iconPath(){return $.i},set iconPath(f){$.i=f,p()},get slashCommandProvider(){return $.a},set slashCommandProvider(f){$.a=f,p()},get followupProvider(){return $.d},set followupProvider(f){$.d=f,p()},dispose(){$.k.$unregisterAgent($.l)}}}invoke(a,p,$,f){return this.m(a,p,$,f)}}}),define(Ae[222],Re([1,0,6,3,8,51,21]),function(be,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class l{static{this.a=1}constructor(g,R){this.d=R,this.c=new Map,this.e=new Map,this.f=new A.$6l,this.b=g.getProxy(M.$cK.MainThreadChatProvider)}registerProvider(g,R,k,a){const p=l.a++;return this.c.set(p,{extension:g,provider:k}),this.b.$registerProvider(p,R,{extension:g,displayName:a.name??g.value}),(0,y.$Qc)(()=>{this.b.$unregisterProvider(p),this.c.delete(p)})}async $provideChatResponse(g,R,k,a,p){const $=this.c.get(g);if(!$)return;const f=new T.$2u(async t=>{if(p.isCancellationRequested){this.d.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(R,{index:t.index,part:t.part})},{async:!0});return $.provider.provideChatResponse(k.map(C.ChatMessage.to),a,f,p)}allowListExtensionWhile(g,R){this.f.set(g,R),R.finally(()=>this.f.delete(g))}async requestChatResponseProvider(g,R){if(!this.f.has(g))throw new Error("Extension is NOT allowed to make chat requests");const k=this;return{get isRevoked(){return!k.f.has(g)},async makeRequest(a,p,$,f){if(!k.f.has(g))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;k.e.set(t,$);try{await k.b.$fetchResponse(g,R,t,a.map(C.ChatMessage.from),p,f)}finally{k.e.delete(t)}}}}async $handleResponseFragment(g,R){this.e.get(g)?.report(R)}}e.$Sdc=l}),define(Ae[223],Re([1,0,6,3,9,8]),function(be,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;class A{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(M.$cK.MainThreadChatVariables)}async $resolveVariable(D,g,R){const k=this.b.get(D);if(k)try{const a=await k.resolver.resolve(k.data.name,{message:g},R);if(a)return a.map(T.ChatVariable.from)}catch(a){(0,C.$2)(a)}}registerVariableResolver(D,g,R,k){const a=A.a++;return this.b.set(a,{extension:D.identifier,data:{name:g,description:R},resolver:k}),this.c.$registerVariable(a,{name:g,description:R}),(0,y.$Qc)(()=>{this.b.delete(a),this.c.$unregisterVariable(a)})}}e.$Udc=A}),define(Ae[224],Re([1,0,3]),function(be,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=void 0;class M{constructor(T){const A=T.getProxy(y.$cK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(l){return A.$writeText(l)}})}}e.$3bc=M}),define(Ae[31],Re([1,0,15,7,8,24,3,18,14,68,45,280,2,6,4,17,104,26,47,37,59,54,58]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f,t,i,c,b,E,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=void 0;let r=class{#e;#t;#i;constructor(S,u,m){this.b=new Map,this.c=new Map,this.#e=S.getProxy(A.$cK.MainThreadCommands),this.d=u,this.#i=m,this.#t=S.getProxy(A.$cK.MainThreadTelemetry),this.converter=new s(this,d=>{const P=this.c.get(d);return P?.result===w.Void?P:void 0},u),this.f=[{processArgument(d){return(0,g.$lh)(d)}},{processArgument(d){return(0,T.$6m)(d,function(P){if(R.$qs.isIRange(P))return C.Range.to(P);if(k.$ps.isIPosition(P))return C.Position.to(P);if(R.$qs.isIRange(P.range)&&a.URI.isUri(P.uri))return C.location.to(P);if(P instanceof i.$be)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const u=this.registerCommand(!1,S.id,async(...m)=>{const d=S.args.map((W,K)=>{if(!W.validate(m[K]))throw new Error(`Invalid argument '${W.name}' when running '${S.id}', received: ${typeof m[K]=="object"?JSON.stringify(m[K],null,"	"):m[K]} `);return W.convert(m[K])}),P=await this.executeCommand(S.internalId,...d);return S.result.convert(P,m,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new M.$eK(()=>{u.dispose(),this.c.delete(S.id)})}registerCommand(S,u,m,d,P,W){if(this.d.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this.b.has(u))throw new Error(`command '${u}' already exists`);return this.b.set(u,{callback:m,thisArg:d,metadata:P,extension:W}),S&&this.#e.$registerCommand(u),new M.$eK(()=>{this.b.delete(u)&&S&&this.#e.$unregisterCommand(u)})}executeCommand(S,...u){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,u,!0)}async g(S,u,m){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,u,!1);{let d=!1;const P=(0,T.$6m)(u,function(W){if(W instanceof M.$fK)return C.Position.from(W);if(W instanceof M.$gK)return C.Range.from(W);if(W instanceof M.$qK)return C.location.from(W);if(M.$BL.isNotebookRange(W))return C.NotebookRange.from(W);if(W instanceof ArrayBuffer)return d=!0,i.$be.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return d=!0,i.$be.wrap(W);if(W instanceof i.$be)return d=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(S,d?new c.$mv(P):P,m);return(0,g.$lh)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(S,u,!1);throw W}}}async h(S,u,m){const d=this.b.get(S);if(!d)throw new Error("Unknown command");const{callback:P,thisArg:W,metadata:K}=d;if(K?.args)for(let B=0;B<K.args.length;B++)try{(0,y.$Pf)(u[B],K.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${K.args[B].name}' - ${K.args[B].description}`)}const U=E.$Jd.create();try{return await P.apply(W,u)}catch(B){if(S===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...u);O&&(S=O.command)}if(this.d.error(B,S,d.extension?.identifier),!m)throw B;if(d.extension?.identifier){const O=this.#i.onExtensionError(d.extension.identifier,B);this.d.trace("forwarded error to extension?",O,d.extension?.identifier)}throw new class extends Error{constructor(){super((0,b.$zi)(B)),this.id=S,this.source=d.extension?.displayName??d.extension?.name}}}finally{this.j(d,S,U.elapsed())}}j(S,u,m){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new v.$ho(u),duration:m})}$executeContributedCommand(S,...u){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const m=this.b.get(S);return m?(u=u.map(d=>this.f.reduce((P,W)=>W.processArgument(P,m.extension?.identifier),d)),this.h(S,u,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(u=>(S&&(u=u.filter(m=>m[0]!=="_")),u))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[u,m]of this.b){const{metadata:d}=m;d&&(S[u]=d)}return Promise.resolve(S)}};e.$yM=r,e.$yM=r=qe([Ke(0,f.$dM),Ke(1,D.$9i),Ke(2,n.$xM)],r),e.$zM=(0,$.$Oh)("IExtHostCommands");class s{constructor(S,u,m){this.d=S,this.f=u,this.g=m,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,u){if(!S)return;const m={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return m;const d=this.f(S.command);if(d)m.id=d.internalId,m.arguments=d.args.map((P,W)=>P.convert(S.arguments&&S.arguments[W]));else if((0,l.$Lb)(S.arguments)){const P=`${S.command} /${++this.c}`;this.b.set(P,S),u.add((0,p.$Qc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),m.$ident=P,m.id=this.delegatingCommandId,m.arguments=[P],this.g.trace("CommandsConverter#CREATE",S.command,P)}return m}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const u=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],u?u.command:"MISSING"),u?this.d.executeCommand(u.command,...u.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$AM=s;class o{static{this.Uri=new o("uri","Uri of a text document",S=>a.URI.isUri(S),S=>S)}static{this.Position=new o("position","A position in a text document",S=>M.$fK.isPosition(S),C.Position.from)}static{this.Range=new o("range","A range in a text document",S=>M.$gK.isRange(S),C.Range.from)}static{this.Selection=new o("selection","A selection in a text document",S=>M.$hK.isSelection(S),C.Selection.from)}static{this.Number=new o("number","",S=>typeof S=="number",S=>S)}static{this.String=new o("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=o.Arr(o.String)}static Arr(S){return new o(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,u=>Array.isArray(u)&&u.every(m=>S.validate(m)),u=>u.map(m=>S.convert(m)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",S=>S instanceof M.$AK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",S=>S instanceof M.$UL,C.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",S=>S instanceof t.$qM,C.TestItem.from)}constructor(S,u,m,d){this.name=S,this.description=u,this.validate=m,this.convert=d}optional(){return new o(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,u){return new o(S??this.name,u??this.description,this.validate,this.convert)}}e.$BM=o;class w{static{this.Void=new w("no result",S=>S)}constructor(S,u){this.description=S,this.convert=u}}e.$CM=w;class h{constructor(S,u,m,d,P){this.id=S,this.internalId=u,this.description=m,this.args=d,this.result=P}}e.$DM=h}),define(Ae[225],Re([1,0,18,13,2,78,91,32,95,31,8,7]),function(be,e,y,M,C,T,A,l,D,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=void 0;const a=[new g.$DM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$BM.Uri,g.$BM.Position],new g.$CM("A promise that resolves to an array of DocumentHighlight-instances.",$(R.DocumentHighlight.to))),new g.$DM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$BM.Uri],new g.$CM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,y.$Kb)(t))return;class c extends k.$vK{static to(E){const v=new c(E.name,R.SymbolKind.to(E.kind),E.containerName||"",new k.$qK(i[0],R.Range.to(E.range)));return v.detail=E.detail,v.range=v.location.range,v.selectionRange=R.Range.to(E.selectionRange),v.children=E.children?E.children.map(c.to):[],v}}return t.map(c.to)})),new g.$DM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$BM.Uri,new g.$BM("options","Formatting options",t=>!0,t=>t)],new g.$CM("A promise that resolves to an array of TextEdits.",$(R.TextEdit.to))),new g.$DM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$BM.Uri,g.$BM.Range,new g.$BM("options","Formatting options",t=>!0,t=>t)],new g.$CM("A promise that resolves to an array of TextEdits.",$(R.TextEdit.to))),new g.$DM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$BM.Uri,g.$BM.Position,new g.$BM("ch","Trigger character",t=>typeof t=="string",t=>t),new g.$BM("options","Formatting options",t=>!0,t=>t)],new g.$CM("A promise that resolves to an array of TextEdits.",$(R.TextEdit.to))),new g.$DM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$BM.Uri,g.$BM.Position],new g.$CM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$DM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$BM.Uri,g.$BM.Position],new g.$CM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$DM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$BM.Uri,g.$BM.Position],new g.$CM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$DM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$BM.Uri,g.$BM.Position],new g.$CM("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$DM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$BM.Uri,g.$BM.Position],new g.$CM("A promise that resolves to an array of Location-instances.",$(R.location.to))),new g.$DM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$BM.Uri,g.$BM.Position],new g.$CM("A promise that resolves to an array of Hover-instances.",$(R.Hover.to))),new g.$DM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$BM.Uri,new g.$BM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>k.$fK.isPosition(i)),t=>t.map(R.Position.from))],new g.$CM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let c;for(const b of i.reverse())c=new k.$zK(R.Range.to(b),c);return c}))),new g.$DM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$BM.String.with("query","Search string")],new g.$CM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(R.WorkspaceSymbol.to))),new g.$DM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$BM.Uri,g.$BM.Position],new g.$CM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(R.CallHierarchyItem.to))),new g.$DM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$BM.CallHierarchyItem],new g.$CM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(R.CallHierarchyIncomingCall.to))),new g.$DM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$BM.CallHierarchyItem],new g.$CM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(R.CallHierarchyOutgoingCall.to))),new g.$DM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$BM.Uri,g.$BM.Position],new g.$CM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:R.Range.to(t.range),placeholder:t.text}})),new g.$DM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$BM.Uri,g.$BM.Position,g.$BM.String.with("newName","The new symbol name")],new g.$CM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return R.WorkspaceEdit.to(t)}})),new g.$DM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$BM.Uri,g.$BM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$CM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(R.DocumentLink.to))),new g.$DM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$BM.Uri],new g.$CM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$tL(t.tokenTypes,t.tokenModifiers)})),new g.$DM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$BM.Uri],new g.$CM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$T0)(t);if(i.type==="full")return new k.$vL(i.data,void 0)})),new g.$DM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$BM.Uri,g.$BM.Range.optional()],new g.$CM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$tL(t.tokenTypes,t.tokenModifiers)})),new g.$DM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$BM.Uri,g.$BM.Range],new g.$CM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$T0)(t);if(i.type==="full")return new k.$vL(i.data,void 0)})),new g.$DM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$BM.Uri,g.$BM.Position,g.$BM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$BM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$CM("A promise that resolves to a CompletionList-instance.",(t,i,c)=>{if(!t)return new k.$LK([]);const b=t.suggestions.map(E=>R.CompletionItem.to(E,c));return new k.$LK(b,t.incomplete)})),new g.$DM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$BM.Uri,g.$BM.Position,g.$BM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$CM("A promise that resolves to SignatureHelp.",t=>{if(t)return R.SignatureHelp.to(t)})),new g.$DM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$BM.Uri,g.$BM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$CM("A promise that resolves to an array of CodeLens-instances.",(t,i,c)=>$(b=>new k.$DK(R.Range.to(b.range),b.command&&c.fromInternal(b.command)))(t))),new g.$DM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$BM.Uri,new g.$BM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>k.$gK.isRange(t),t=>k.$hK.isSelection(t)?R.Selection.from(t):R.Range.from(t)),g.$BM.String.with("kind","Code action kind to return code actions for").optional(),g.$BM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$CM("A promise that resolves to an array of Command-instances.",(t,i,c)=>$(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(b.command)}else{const E=new k.$xK(b.title,b.kind?new k.$yK(b.kind):void 0);return b.edit&&(E.edit=R.WorkspaceEdit.to(b.edit)),b.command&&(E.command=c.fromInternal(b.command)),E.isPreferred=b.isPreferred,E}})(t))),new g.$DM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$BM.Uri],new g.$CM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new k.$RK(R.Range.to(i.range),R.Color.to(i.color))):[])),new g.$DM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$BM("color","The color to show and insert",t=>t instanceof k.$QK,R.Color.from),new g.$BM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:R.Range.from(t.range)}))],new g.$CM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(R.ColorPresentation.to):[])),new g.$DM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$BM.Uri,g.$BM.Range],new g.$CM("A promise that resolves to an array of Inlay objects",(t,i,c)=>t.map(R.InlayHint.to.bind(void 0,c)))),new g.$DM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$BM.Uri],new g.$CM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(R.FoldingRange.to)})),new g.$DM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$CM("A promise that resolves to an array of NotebookContentProvider static info objects.",$(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>R.NotebookExclusiveDocumentPattern.to(i))})))),new g.$DM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$BM.Uri,g.$BM.Range,new g.$BM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof k.$gK,t=>R.InlineValueContext.from(t))],new g.$CM("A promise that resolves to an array of InlineValue objects",t=>t.map(R.InlineValue.to))),new g.$DM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$BM("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,D.$aU)(t,M.Schemas.http,M.Schemas.https),t=>t),new g.$BM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional(),g.$BM.String.with("label","").optional()],g.$CM.Void),new g.$DM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$BM.Uri.with("resource","Resource to open"),g.$BM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$BM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional()],g.$CM.Void),new g.$DM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$BM.Uri.with("left","Left-hand side resource of the diff editor"),g.$BM.Uri.with("right","Right-hand side resource of the diff editor"),g.$BM.String.with("title","Human readable title for the diff editor").optional(),new g.$BM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)]).optional()],g.$CM.Void),new g.$DM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$BM.Uri,g.$BM.Position],new g.$CM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new g.$DM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$BM.TypeHierarchyItem],new g.$CM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new g.$DM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$BM.TypeHierarchyItem],new g.$CM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new g.$DM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$BM.TestItem],g.$CM.Void),new g.$DM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$BM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$CM.Void),new g.$DM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$BM.String.with("name","The context key name"),new g.$BM("value","The context key value",()=>!0,t=>t)],g.$CM.Void),new g.$DM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$BM.Uri,g.$BM.StringArray,new g.$BM("MappedEditsContext","Mapped Edits Context",t=>R.MappedEditsContext.is(t),t=>R.MappedEditsContext.from(t))],new g.$CM("A promise that resolves to a workspace edit or null",t=>t?R.WorkspaceEdit.to(t):null))];class p{static register(i){a.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",l.$Ni)}}e.$2bc=p;function $(t){return i=>{if(Array.isArray(i))return i.map(t)}}function f(t){if(!Array.isArray(t))return;const i=[];for(const c of t)T.$bt(c)?i.push(R.DefinitionLink.to(c)):i.push(R.location.to(c));return i}}),define(Ae[226],Re([1,0,12,65,5,6,2,78,21,8,7,3,25]),function(be,e,y,M,C,T,A,l,D,g,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=void 0;function p($,f,t){const i=$.getProxy(k.$cK.MainThreadComments);class c{static{this.a=0}constructor(){this.b=new Map,this.c=new D.$6l,f.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const I=this.b.get(h.handle);return I?I.value:h}else if(h&&h.$mid===7){const I=this.b.get(h.commentControlHandle);if(!I)return h;const S=I.getCommentThread(h.commentThreadHandle);return S?S.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const I=this.b.get(h.thread.commentControlHandle);if(!I)return h;const S=I.getCommentThread(h.thread.commentThreadHandle);return S?h.$mid===8?S.value:{thread:S.value,text:h.text}:h}else if(h&&h.$mid===10){const I=this.b.get(h.thread.commentControlHandle);if(!I)return h;const S=I.getCommentThread(h.thread.commentThreadHandle);if(!S)return h;const u=h.commentUniqueId,m=S.getCommentByUniqueId(u);return m||h}else if(h&&h.$mid===11){const I=this.b.get(h.thread.commentControlHandle);if(!I)return h;const S=I.getCommentThread(h.thread.commentThreadHandle);if(!S)return h;const u=h.text,m=h.commentUniqueId,d=S.getCommentByUniqueId(m);return d?(typeof d.body=="string"?d.body=u:d.body=new R.$EK(u),d):h}return h}})}createCommentController(h,I,S){const u=c.a++,m=new E(h,u,I,S);this.b.set(m.handle,m);const d=this.c.get(h.identifier)||[];return d.push(m),this.c.set(h.identifier,d),m.value}async $createCommentThreadTemplate(h,I,S){const u=this.b.get(h);u&&u.$createCommentThreadTemplate(I,S)}async $updateCommentThreadTemplate(h,I,S){const u=this.b.get(h);u&&u.$updateCommentThreadTemplate(I,S)}$deleteCommentThread(h,I){this.b.get(h)?.$deleteCommentThread(I)}$provideCommentingRanges(h,I,S){const u=this.b.get(h);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const m=t.getDocument(A.URI.revive(I));return(0,y.$Mg)(async()=>{const d=await u.commentingRangeProvider.provideCommentingRanges(m,S);let P;return Array.isArray(d)?P={ranges:d,fileComments:!1}:d?P={ranges:d.ranges||[],fileComments:d.fileComments||!1}:P=d??void 0,P}).then(d=>{let P;return d&&(P={ranges:d.ranges.map(W=>g.Range.from(W)),fileComments:d.fileComments}),P})}$toggleReaction(h,I,S,u,m){const d=this.b.get(h);return!d||!d.reactionHandler?Promise.resolve(void 0):(0,y.$Mg)(()=>{const P=d.getCommentThread(I);if(P){const W=P.getCommentByUniqueId(u.uniqueIdInThread);if(d!==void 0&&W&&d.reactionHandler)return d.reactionHandler(W,r(m))}return Promise.resolve(void 0)})}}class b{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,I,S,u,m,d,P,W){this.m=I,this.n=S,this.o=u,this.p=m,this.q=d,this.extensionDescription=P,this.r=W,this.handle=b.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Nd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new T.$Tc,this.l.value=new T.$Rc,this.n===void 0&&(this.n=`${h}.${this.handle}`),i.$createCommentThread(I,this.handle,this.n,this.o,g.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=d,this.i.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const K=this;this.value={get uri(){return K.uri},get range(){return K.range},set range(U){K.range=U},get comments(){return K.comments},set comments(U){K.comments=U},get collapsibleState(){return K.collapsibleState},set collapsibleState(U){K.collapsibleState=U},get canReply(){return K.canReply},set canReply(U){K.canReply=U},get contextValue(){return K.contextValue},set contextValue(U){K.contextValue=U},get label(){return K.label},set label(U){K.label=U},get state(){return K.state},set state(U){K.state=U},dispose:()=>{K.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new T.$Rc);const h=S=>Object.prototype.hasOwnProperty.call(this.b,S),I={};h("range")&&(I.range=g.Range.from(this.p)),h("label")&&(I.label=this.label),h("contextValue")&&(I.contextValue=this.contextValue??null),h("comments")&&(I.comments=this.q.map(S=>v(this,S,this.k,this.extensionDescription))),h("collapsibleState")&&(I.collapseState=s(this.g)),h("canReply")&&(I.canReply=this.canReply),h("state")&&(I.state=o(this.h)),h("isTemplate")&&(I.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(h){for(const I of this.k){const S=I[0],u=I[1];if(h===u)return S}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}qe([(0,M.$hh)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,I,S,u){this.f=h,this.g=I,this.h=S,this.i=u,this.a=new Map,i.$registerCommentController(this.handle,S,u,this.f.identifier.value);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(d){m.options=d},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(d){m.commentingRangeProvider=d},get reactionHandler(){return m.reactionHandler},set reactionHandler(d){m.reactionHandler=d},createCommentThread(d,P,W){return m.createCommentThread(d,P,W).value},dispose:()=>{m.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(h,I,S){I===void 0&&(0,a.$aF)(this.f,"fileComments");const u=new b(this.id,this.handle,void 0,h,I,S,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(h,I){const S=new b(this.id,this.handle,void 0,A.URI.revive(h),g.Range.to(I),[],this.f,!0);return S.collapsibleState=l.CommentThreadCollapsibleState.Expanded,this.a.set(S.handle,S),S}$updateCommentThreadTemplate(h,I){const S=this.a.get(h);S&&(S.range=g.Range.to(I))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function v(w,h,I,S){let u=I.get(h);return u||(u=++w.commentHandle,I.set(h,u)),h.state!==void 0&&(0,a.$aF)(S,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:u,body:typeof h.body=="string"?h.body:g.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(m=>n(m)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function n(w){return{label:w.label,iconPath:w.iconPath?g.$cM(w.iconPath):void 0,count:w.count,hasReacted:w.authorHasReacted}}function r(w){return{label:w.label||"",count:w.count||0,iconPath:w.iconPath?A.URI.revive(w.iconPath):"",authorHasReacted:w.hasReacted||!1}}function s(w){if(w!==void 0)switch(w){case R.CommentThreadCollapsibleState.Expanded:return l.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return l.CommentThreadCollapsibleState.Collapsed}return l.CommentThreadCollapsibleState.Collapsed}function o(w){if(w!==void 0)switch(w){case R.CommentThreadState.Unresolved:return l.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return l.CommentThreadState.Resolved}return l.CommentThreadState.Unresolved}return new c}e.$4bc=p}),define(Ae[227],Re([1,0,24,3,27,17]),function(be,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;let A=class{constructor(R,k){this.a=R.getProxy(M.$cK.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,k){const a=this,p=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){a.e(R,k,p,arguments)}})}e(R,k,a,p){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:D(p,this.b)}),this.c&&this.f(R,a,p)}};e.$2dc=A,e.$2dc=A=qe([Ke(0,T.$dM),Ke(1,C.$tM)],A);const l=1e5;function D(g,R){const k=[];if(g.length)for(let a=0;a<g.length;a++){let p=g[a];if(typeof p>"u")p="undefined";else if(p instanceof Error){const $=p;$.stack?p=$.stack:p=$.toString()}k.push(p)}if(R){const a=new Error().stack;a&&k.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,y.$9m)(k);return a.length>l?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Ae[107],Re([1,0,2,3,7,4,17,14,18,16,19,25]),function(be,e,y,M,C,T,A,l,D,g,R,k){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=e.$5cc=void 0;let p=class{static{a=this}static{this.c=0}static{this.d=250}constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(M.$cK.MainThreadDecorations)}registerFileDecorationProvider(f,t){const i=a.c++;this.f.set(i,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const c=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(b=>{if(!b){this.g.$onDidChange(i,null);return}const E=(0,D.$3b)(b);if(E.length<=a.d){this.g.$onDidChange(i,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,E.length);const v=E.map(s=>({uri:s,rank:(0,g.$Ge)(s.path,"/")})),n=(0,D.$zb)(v,(s,o)=>s.rank-o.rank||(0,g.$Ue)(s.uri.path,o.uri.path)),r=[];e:for(const s of n){let o;for(const w of s){const h=(0,R.$mc)(w.uri.path);if(o!==h&&(o=h,r.push(w.uri)>=a.d))break e}}this.g.$onDidChange(i,r)});return new C.$eK(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(f,t,i){if(!this.f.has(f))return Object.create(null);const c=Object.create(null),{provider:b,extensionDescription:E}=this.f.get(f);return await Promise.all(t.map(async v=>{try{const{uri:n,id:r}=v,s=await Promise.resolve(b.provideFileDecoration(y.URI.revive(n),i));if(!s)return;try{C.$zL.validate(s),s.badge&&typeof s.badge!="string"&&(0,k.$aF)(E,"codiconDecoration"),c[r]=[s.propagate,s.tooltip,s.badge,s.color]}catch(o){this.h.warn(`INVALID decoration from extension '${E.identifier.value}': ${o}`)}}catch(n){this.h.error(n)}})),c}};e.$5cc=p,e.$5cc=p=a=qe([Ke(0,A.$dM),Ke(1,l.$9i)],p),e.$6cc=(0,T.$Oh)("IExtHostDecorations")}),define(Ae[228],Re([1,0,147,94,2,3,7,8,5,14,28,40]),function(be,e,y,M,C,T,A,l,D,g,R,k){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=e.$Vbc=void 0;class p{#e;#t;#i;constructor(t,i,c,b,E,v,n,r){this.d=t,this.e=i,this.f=c,this.g=b,this.h=E,this.c=!1,this.f=Math.max(b,c),this.#i=new R.$Ac(s=>v.getComparisonKey(s)),this.#e=n,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let c=[];if(C.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),c=[t]}else if(Array.isArray(t)){c=[];let v;t=[...t].sort(p.k);for(const n of t){const[r,s]=n;if((!v||r.toString()!==v.toString())&&(v&&this.#i.get(v).length===0&&this.#i.delete(v),v=r,c.push(r),this.#i.set(r,[])),s)this.#i.get(r)?.push(...s);else{const o=this.#i.get(r);o&&(o.length=0)}}}if(this.#t.fire(c),!this.#e)return;const b=[];let E=0;for(const v of c){let n=[];const r=this.#i.get(v);if(r)if(r.length>this.g){n=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const w of r)if(w.severity===s[o]&&n.push({...l.Diagnostic.from(w),modelVersionId:this.h(v)})===this.g)break e;n.push({severity:M.MarkerSeverity.Info,message:(0,y.localize)(0,null,r.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=r.map(s=>({...l.Diagnostic.from(s),modelVersionId:this.h(v)}));if(b.push([v,n]),E+=n.length,E>this.f)break}this.#e.$changeMany(this.e,b)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[c,b]of this)t.call(i,c,b,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$Vbc=p;let $=class{static{a=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*a.d}static _mapper(t){const i=new R.$Ac;for(const c of t)i.set(c,c);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,c,b){this.j=i,this.k=c,this.l=b,this.g=new Map,this.h=new D.$Rd({merge:E=>E.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.h.event,a._mapper),this.f=t.getProxy(T.$cK.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:c,f:b,h:E,j:v,k:n,l:r}=this,s=new class{$changeMany(h,I){b.$changeMany(h,I),v.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,h,I.length===0?"CLEARING":I)}$clear(h){b.$clear(h),v.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,h)}dispose(){b.dispose()}};let o;if(!i)i="_generated_diagnostic_collection_name_#"+a.c++,o=i;else if(!c.has(i))o=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do o=i+a.c++;while(c.has(o))}return new class extends p{constructor(){super(i,o,a.e,a.d,h=>r.getDocument(h)?.version,n.extUri,s,E),c.set(o,this)}dispose(){super.dispose(),c.delete(o)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,c=[];for(const b of this.g.values())b.forEach((E,v)=>{let n=i.get(E.toString());typeof n>"u"&&(n=c.length,i.set(E.toString(),n),c.push([E,[]])),c[n][1]=c[n][1].concat(...v)});return c}}m(t){let i=[];for(const c of this.g.values())c.has(t)&&(i=i.concat(c.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",c=new p(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,b=>{},this.k.extUri,void 0,this.h);this.g.set(i,c),this.n=c}for(const[i,c]of t)this.n.set(C.URI.revive(i),c.map(l.Diagnostic.to))}};e.$Wbc=$,e.$Wbc=$=a=qe([Ke(1,g.$9i),Ke(2,k.$Ubc)],$)}),define(Ae[229],Re([1,0,2,3,25]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=void 0;class T{constructor(l){this.a=l.getProxy(M.$cK.MainThreadDialogs)}showOpenDialog(l,D){return D?.allowUIResources&&(0,C.$aF)(l,"showLocal"),this.a.$showOpenDialog(D).then(g=>g?g.map(R=>y.URI.revive(R)):void 0)}showSaveDialog(l){return this.a.$showSaveDialog(l).then(D=>D?y.URI.revive(D):void 0)}}e.$_bc=T}),define(Ae[230],Re([1,0,9,2,7,3,13,20,16]),function(be,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=void 0;class g{static{this.a=0}constructor(k,a,p){this.d=a,this.e=p,this.b=new Map,this.c=k.getProxy(T.$cK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,a){if(Object.keys(A.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const p=g.a++;this.b.set(p,a),this.c.$registerTextContentProvider(p,k);let $;return typeof a.onDidChange=="function"&&($=a.onDidChange(f=>{if(f.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(p,f).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(f);if(!i)return;const c=(0,D.$Pe)(t);if(!i.equalLines(c))return this.c.$onVirtualDocumentChange(f,t)},y.$1)})),new C.$eK(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),$&&($.dispose(),$=void 0)})}$provideTextDocumentContent(k,a){const p=this.b.get(k);return p?Promise.resolve(p.provideTextDocumentContent(M.URI.revive(a),l.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.$acc=g}),define(Ae[231],Re([1,0,5,6,2,3,100,8,15,24,7,9]),function(be,e,y,M,C,T,A,l,D,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;class a{constructor($,f){this.a=new y.$Nd({onListenerError:k.$2}),this.b=new y.$Nd({onListenerError:k.$2}),this.c=new y.$Nd({onListenerError:k.$2}),this.d=new y.$Nd({onListenerError:k.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Rc,this.h=new Map,this.f=$.getProxy(T.$cK.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData($){if(!$)return;const f=this.g.getDocument($);if(f)return f}getDocument($){const f=this.getDocumentData($);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${$}'`);return f.document}ensureDocumentData($){const f=this.g.getDocument($);if(f)return Promise.resolve(f);let t=this.h.get($.toString());return t||(t=this.f.$tryOpenDocument($).then(i=>{this.h.delete($.toString());const c=C.URI.revive(i);return(0,D.$Jf)(this.g.getDocument(c))},i=>(this.h.delete($.toString()),Promise.reject(i))),this.h.set($.toString(),t)),t}createDocumentData($){return this.f.$tryCreateDocument($).then(f=>C.URI.revive(f))}$acceptModelLanguageChanged($,f){const t=C.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(f),this.a.fire(i.document)}$acceptModelSaved($){const f=C.URI.revive($),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged($,!1),this.d.fire(t.document)}$acceptDirtyStateChanged($,f){const t=C.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(f),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged($,f,t){const i=C.URI.revive($),c=this.g.getDocument(i);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(f);let b;f.isUndoing?b=R.TextDocumentChangeReason.Undo:f.isRedoing&&(b=R.TextDocumentChangeReason.Redo),this.c.fire((0,g.$5m)({document:c.document,contentChanges:f.changes.map(E=>({range:l.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:b}))}setWordDefinitionFor($,f){(0,A.$fM)($,f)}}e.$Sbc=a}),define(Ae[60],Re([1,0,52,5,6,2,4,3,100,17,105,8,14,28,13,66,41]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oM=e.$nM=void 0;class i{constructor(E){this.value=E,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(E,v){this.h=E,this.i=v,this.a=null,this.b=new Map,this.c=new p.$Ac,this.d=new M.$Nd,this.e=new M.$Nd,this.f=new M.$Nd,this.g=new M.$Nd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const v=[],n=[],r=[];if(E.removedDocuments)for(const s of E.removedDocuments){const o=T.URI.revive(s),w=this.c.get(o);w?.unref()&&(this.c.delete(o),v.push(w.value))}if(E.addedDocuments)for(const s of E.addedDocuments){const o=T.URI.revive(s.uri);let w=this.c.get(o);if(w&&o.scheme!==$.Schemas.vscodeNotebookCell&&o.scheme!==$.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);w||(w=new i(new D.$gM(this.h.getProxy(l.$cK.MainThreadDocuments),o,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(o,w),n.push(w.value)),w.ref()}if(E.removedEditors)for(const s of E.removedEditors){const o=this.b.get(s);this.b.delete(s),o&&r.push(o)}if(E.addedEditors)for(const s of E.addedEditors){const o=T.URI.revive(s.documentUri);y.ok(this.c.has(o),`document '${o}' does not exist`),y.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const w=this.c.get(o).value,h=new R.$mM(s.id,this.h.getProxy(l.$cK.MainThreadTextEditors),this.i,new t.$V(()=>w.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(I=>k.Range.to(I)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,h)}E.newActiveEditor!==void 0&&(y.ok(E.newActiveEditor===null||this.b.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this.a=E.newActiveEditor),(0,C.$Nc)(v),(0,C.$Nc)(r),E.removedDocuments&&this.e.fire(v),E.addedDocuments&&this.d.fire(n),(E.removedEditors||E.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),E.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(E){return this.c.get(E)?.value}allDocuments(){return f.Iterable.map(this.c.values(),E=>E.value)}getEditor(E){return this.b.get(E)}activeEditor(E){if(!this.a)return;const v=this.b.get(this.a);return E?v:v?.value}allEditors(){return[...this.b.values()]}};e.$nM=c,e.$nM=c=qe([Ke(0,g.$dM),Ke(1,a.$9i)],c),e.$oM=(0,A.$Oh)("IExtHostDocumentsAndEditors")}),define(Ae[61],Re([1,0,8,3,2,5,4,7,17,15,232]),function(be,e,y,M,C,T,A,l,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=e.$0cc=void 0,e.$0cc=(0,A.$Oh)("IExtHostEditorTabs");class k{constructor(t,i,c){this.e=c,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new l.$VL(C.URI.revive(this.b.input.uri));case 2:return new l.$WL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new l.$XL(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new l.$YL(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new l.$ZL(this.b.input.viewType);case 4:return new l.$1L(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new l.$2L(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new l.$3L;case 9:return new l.$4L(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class a{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const c of t.tabs)c.isActive&&(this.d=c.id),this.c.push(new k(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return y.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(c=>c.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(c=>c.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const c=new k(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,c),t.tabDto.isActive&&(this.d=c.tabId),c}else if(t.kind===1){const c=this.c.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,c),c}const i=this.c.find(c=>c.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let p=class{constructor(t){this.b=new T.$Nd,this.c=new T.$Nd,this.e=[],this.a=t.getProxy(M.$cK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(c=>c.apiObject))},get activeTabGroup(){const c=t.d;return(0,g.$Jf)(t.e.find(E=>E.groupId===c)?.apiObject)},close:async(c,b)=>{const E=Array.isArray(c)?c:[c];return E.length?$(E[0])?this.j(E,b):this.i(E,b):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(s=>s.groupId)),c=new Set(t.map(s=>s.groupId)),b=(0,R.$K)(i,c),E=this.e.filter(s=>b.removed.includes(s.groupId)).map(s=>s.apiObject),v=[],n=[];this.e=t.map(s=>{const o=new a(s,()=>this.d);return b.added.includes(o.groupId)?v.push(o.apiObject):n.push(o.apiObject),o});const r=(0,g.$Jf)(t.find(s=>s.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:v,closed:E,changed:n}))}$acceptTabGroupUpdate(t){const i=this.e.find(c=>c.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(b=>b.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const c=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(t){for(const i of this.e)for(const c of i.tabs)if(c.apiObject===t)return c}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const c=[];for(const b of t){const E=this.g(b);if(!E)throw new Error("Tab close: Invalid tab not found!");c.push(E.tabId)}return this.a.$closeTab(c,i)}async j(t,i){const c=[];for(const b of t){const E=this.h(b);if(!E)throw new Error("Group close: Invalid group not found!");c.push(E.groupId)}return this.a.$closeGroup(c,i)}};e.$$cc=p,e.$$cc=p=qe([Ke(0,D.$dM)],p);function $(f){return f.tabs!==void 0}}),define(Ae[233],Re([1,0,3,7]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$cK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,l,D){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(A);if(!g)throw new Error("Embedding vector provider not found");const R=await g.provideEmbeddingVector(l,D);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,l,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiEmbeddingVectorProvider(l,g),new M.$eK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$Wdc=C}),define(Ae[234],Re([1,0,2,3,6,7,8,281,16,26,25,50]),function(be,e,y,M,C,T,A,l,D,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=void 0;class a{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let i,c,b=14,E=14;for(const v of f){let n=i?(0,D.$4e)(i,v):0;for(n===0?c=1:c=E;n<v.length;n++)n+1===v.length?(b=E,E=9):E+=1,t.push([c,v.toUpperCase().charCodeAt(n),E]),t.push([c,v.toLowerCase().charCodeAt(n),E]),c=E;i=v,E=b}t.push([9,58,10]),t.push([10,47,12]),this.b=new l.$VY(t)}}provideDocumentLinks(f){this.c();const t=[],i=l.$WY.computeLinks({getLineContent(c){return f.lineAt(c-1).text},getLineCount(){return f.lineCount}},this.b);for(const c of i){const b=A.DocumentLink.to(c);b.target&&t.push(b)}return t}}class p{constructor(f,t){this.i=t,this.b=new a,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(M.$cK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,i,c={}){if(p.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const b=this.h++;this.b.add(t),this.d.add(t),this.c.set(b,i);let E=2;c.isCaseSensitive&&(E+=1024),c.isReadonly&&(E+=2048),typeof i.copy=="function"&&(E+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,R.$aF)(f,"fsChunks"),E+=4);let v;c.isReadonly&&(0,k.$4j)(c.isReadonly)&&((0,R.$aF)(f,"readonlyMessage"),v={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(b,t,E,v).catch(r=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(r)});const n=i.onDidChangeFile(r=>{const s=[];for(const o of r){const{uri:w,type:h}=o;if(w.scheme!==t)continue;let I;switch(h){case T.FileChangeType.Changed:I=0;break;case T.FileChangeType.Created:I=1;break;case T.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:w,type:I})}this.a.$onFileSystemChange(b,s)});return(0,C.$Qc)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(b),this.a.$unregisterProvider(b)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:t,ctime:i,mtime:c,size:b,permissions:E}=f;return{type:t,ctime:i,mtime:c,size:b,permissions:E}}$stat(f,t){return Promise.resolve(this.l(f).stat(y.URI.revive(t))).then(i=>p.k(i))}$readdir(f,t){return Promise.resolve(this.l(f).readDirectory(y.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.l(f).readFile(y.URI.revive(t))).then(i=>g.$be.wrap(i))}$writeFile(f,t,i,c){return Promise.resolve(this.l(f).writeFile(y.URI.revive(t),i.buffer,c))}$delete(f,t,i){return Promise.resolve(this.l(f).delete(y.URI.revive(t),i))}$rename(f,t,i,c){return Promise.resolve(this.l(f).rename(y.URI.revive(t),y.URI.revive(i),c))}$copy(f,t,i,c){const b=this.l(f);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(y.URI.revive(t),y.URI.revive(i),c))}$mkdir(f,t){return Promise.resolve(this.l(f).createDirectory(y.URI.revive(t)))}$watch(f,t,i,c){const b=this.l(f).watch(y.URI.revive(i),c);this.f.set(t,b)}$unwatch(f,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(f,t,i){const c=this.l(f);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(y.URI.revive(t),i))}$close(f,t){const i=this.l(f);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(f,t,i,c){const b=this.l(f);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const E=g.$be.alloc(c);return Promise.resolve(b.read(t,i,E.buffer,0,c)).then(v=>E.slice(0,v))}$write(f,t,i,c){const b=this.l(f);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(t,i,c.buffer,0,c.byteLength))}l(f){const t=this.c.get(f);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$Gcc=p}),define(Ae[62],Re([1,0,3,39,7,26,4,17,40,6,12,23,13]),function(be,e,y,M,C,T,A,l,D,g,R,k,a){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=e.$mcc=void 0;let $=p=class{constructor(t,i){this.b=new Map,this.c=new R.$3g,this.a=t.getProxy(y.$cK.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(b){try{let E;const v=c.b.get(b.scheme);return v?(await c.a.$ensureActivation(b.scheme),E=await v.impl.stat(b)):E=await c.a.$stat(b),{type:E.type,ctime:E.ctime,mtime:E.mtime,size:E.size,permissions:E.permissions===M.FilePermission.Readonly?1:void 0}}catch(E){p.e(E)}},async readDirectory(b){try{const E=c.b.get(b.scheme);return E?(await c.a.$ensureActivation(b.scheme),(await E.impl.readDirectory(b)).slice()):await c.a.$readdir(b)}catch(E){return p.e(E)}},async createDirectory(b){try{const E=c.b.get(b.scheme);return E&&!E.isReadonly?(await c.a.$ensureActivation(b.scheme),await c.d(E.impl,E.extUri,b)):await c.a.$mkdir(b)}catch(E){return p.e(E)}},async readFile(b){try{const E=c.b.get(b.scheme);return E?(await c.a.$ensureActivation(b.scheme),(await E.impl.readFile(b)).slice()):(await c.a.$readFile(b)).buffer}catch(E){return p.e(E)}},async writeFile(b,E){try{const v=c.b.get(b.scheme);return v&&!v.isReadonly?(await c.a.$ensureActivation(b.scheme),await c.d(v.impl,v.extUri,v.extUri.dirname(b)),await c.c.queueFor(b).queue(()=>Promise.resolve(v.impl.writeFile(b,E,{create:!0,overwrite:!0})))):await c.a.$writeFile(b,T.$be.wrap(E))}catch(v){return p.e(v)}},async delete(b,E){try{const v=c.b.get(b.scheme);return v&&!v.isReadonly?(await c.a.$ensureActivation(b.scheme),await v.impl.delete(b,{recursive:!1,...E})):await c.a.$delete(b,{recursive:!1,useTrash:!1,atomic:!1,...E})}catch(v){return p.e(v)}},async rename(b,E,v){try{return await c.a.$rename(b,E,{overwrite:!1,...v})}catch(n){return p.e(n)}},async copy(b,E,v){try{return await c.a.$copy(b,E,{overwrite:!1,...v})}catch(n){return p.e(n)}},isWritableFileSystem(b){const E=i.getCapabilities(b);if(typeof E=="number")return!(E&2048)}})}async d(t,i,c){const b=[];for(;!i.isEqual(c,i.dirname(c));)try{if(!((await t.stat(c)).type&M.FileType.Directory))throw C.$rL.FileExists(`Unable to create folder '${c.scheme===a.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(E){if(M.$nk(E)!==M.FileSystemProviderErrorCode.FileNotFound)throw E;b.push(i.basename(c)),c=i.dirname(c)}for(let E=b.length-1;E>=0;E--){c=i.joinPath(c,b[E]);try{await t.createDirectory(c)}catch(v){if(M.$nk(v)!==M.FileSystemProviderErrorCode.FileExists)throw v}}}static e(t){if(t instanceof C.$rL)throw t;if(t instanceof M.$jk)switch(t.code){case M.FileSystemProviderErrorCode.FileExists:throw C.$rL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$rL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$rL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$rL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$rL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$rL.Unavailable(t.message);default:throw new C.$rL(t.message,t.name)}if(!(t instanceof Error))throw new C.$rL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw C.$rL.Unavailable(t.message);switch(t.name){case M.FileSystemProviderErrorCode.FileExists:throw C.$rL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$rL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$rL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$rL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$rL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$rL.Unavailable(t.message);default:throw new C.$rL(t.message,t.name)}}addFileSystemProvider(t,i,c){return this.b.set(t,{impl:i,extUri:c?.isCaseSensitive?k.$lg:k.$ng,isReadonly:!!c?.isReadonly}),(0,g.$Qc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??k.$lg}};e.$mcc=$,e.$mcc=$=p=qe([Ke(0,l.$dM),Ke(1,D.$Ubc)],$),e.$ncc=(0,A.$Oh)("IExtHostConsumerFileSystem")}),define(Ae[235],Re([1,0,5,38,2,3,8,7,41]),function(be,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;class g{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,$,f,t,i,c){this.a=Math.random(),this.b=new y.$Nd,this.c=new y.$Nd,this.d=new y.$Nd,this.h=0,c?.ignoreCreateEvents&&(this.h+=1),c?.ignoreChangeEvents&&(this.h+=2),c?.ignoreDeleteEvents&&(this.h+=4);const b=(0,M.$vj)(i),E=typeof i=="string",v=t(n=>{if(!(typeof n.session=="number"&&n.session!==this.a)){if(!c?.ignoreCreateEvents)for(const r of n.created){const s=C.URI.revive(r);b(s.fsPath)&&(!E||$.getWorkspaceFolder(s))&&this.b.fire(s)}if(!c?.ignoreChangeEvents)for(const r of n.changed){const s=C.URI.revive(r);b(s.fsPath)&&(!E||$.getWorkspaceFolder(s))&&this.c.fire(s)}if(!c?.ignoreDeleteEvents)for(const r of n.deleted){const s=C.URI.revive(r);b(s.fsPath)&&(!E||$.getWorkspaceFolder(s))&&this.d.fire(s)}}});this.g=l.$eK.from(this.i(p,f,i,c),this.b,this.c,this.d,v)}i(p,$,f,t){const i=l.$eK.from();if(typeof f=="string")return i;const c=p.getProxy(T.$cK.MainThreadFileSystemEventService);let b=!1;return(f.pattern.includes(M.$rj)||f.pattern.includes(M.$sj))&&(b=!0),c.$watch($.identifier.value,this.a,f.baseUri,{recursive:b,excludes:t?.excludes??[]}),l.$eK.from({dispose:()=>c.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(p){this.a=p,this.session=this.a.session,this.b=new D.$V(()=>this.a.created.map(C.URI.revive)),this.c=new D.$V(()=>this.a.changed.map(C.URI.revive)),this.d=new D.$V(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(p,$,f){this.j=p,this.k=$,this.l=f,this.a=new y.$Nd,this.b=new y.$Nd,this.c=new y.$Nd,this.d=new y.$Nd,this.g=new y.$Pd,this.h=new y.$Pd,this.i=new y.$Pd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,$,f,t){return new g(this.j,p,$,this.a.event,A.GlobPattern.from(f),t)}$onFileEvent(p){this.a.fire(new R(p))}$onDidRunFileOperation(p,$){switch(p){case 2:this.b.fire(Object.freeze({files:$.map(f=>({oldUri:C.URI.revive(f.source),newUri:C.URI.revive(f.target)}))}));break;case 1:this.d.fire(Object.freeze({files:$.map(f=>C.URI.revive(f.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:$.map(f=>C.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,$){return(f,t,i)=>{const c=function(E){f.call(t,E)};return c.extension=p,$.event(c,void 0,i)}}async $onWillRunFileOperation(p,$,f,t){switch(p){case 2:return await this.n(this.g,{files:$.map(i=>({oldUri:C.URI.revive(i.source),newUri:C.URI.revive(i.target)}))},f,t);case 1:return await this.n(this.i,{files:$.map(i=>C.URI.revive(i.target))},f,t);case 0:case 3:return await this.n(this.h,{files:$.map(i=>C.URI.revive(i.target))},f,t)}}async n(p,$,f,t){const i=new Set,c=[];if(await p.fireAsync($,t,async(E,v)=>{const n=Date.now(),r=await Promise.resolve(E);r instanceof l.$oK&&(c.push([v.extension,r]),i.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-n>f&&this.k.warn("SLOW file-participant",v.extension.identifier)}),t.isCancellationRequested||c.length===0)return;const b={edits:[]};for(const[,E]of c){const{edits:v}=A.WorkspaceEdit.from(E,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});b.edits=b.edits.concat(v)}return{edit:b,extensionNames:Array.from(i)}}}e.$Hcc=k}),define(Ae[236],Re([1,0,6,2,3,8,7,31,12]),function(be,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class g{static{this.a=0}constructor(p,$){this.extension=p,this.provider=$,this.handle=g.a++}}class R{constructor(p){this.session=p,this.responses=[]}}class k{static{this.a=0}constructor(p,$,f,t){this.f=f,this.g=t,this.b=new Map,this.d=new Map,this.e=p.getProxy(C.$cK.MainThreadInlineChat),$.registerApiCommand(new l.$DM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new l.$BM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?T.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?T.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?T.Position.from(i.position):void 0}})],l.$CM.Void))}registerProvider(p,$,f){const t=new g(p,$);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,f.label,p.identifier.value,typeof $.handleInteractiveEditorResponseFeedback=="function"),(0,y.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(p,$,f,t){const i=this.b.get(p);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const c=this.f.getDocument(M.URI.revive($)),b=T.Selection.to(f),E=await i.provider.prepareInteractiveEditorSession({document:c,selection:b},t);if(!E)return;if(E.wholeRange&&!E.wholeRange.contains(b))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const v=k.a++;return this.d.set(v,new R(E)),{id:v,placeholder:E.placeholder,slashCommands:E.slashCommands?.map(n=>({command:n.command,detail:n.detail,refer:n.refer,executeImmediately:n.executeImmediately})),wholeRange:T.Range.from(E.wholeRange),message:E.message}}async $provideResponse(p,$,f,t){const i=this.b.get(p);if(!i)return;const c=this.d.get($.id);if(!c)return;const b={prompt:f.prompt,selection:T.Selection.to(f.selection),wholeRange:T.Range.to(f.wholeRange),attempt:f.attempt,live:f.live};let E=!1;const v={report:async h=>{if(!f.live)throw new Error("Progress reporting is only supported for live sessions");E||t.isCancellationRequested||await this.e.$handleProgressChunk(f.requestId,{message:h.message,edits:h.edits?.map(T.TextEdit.from),slashCommand:h.slashCommand?.command})}},n=Promise.resolve(i.provider.provideInteractiveEditorResponse(c.session,b,v,t));let r;try{r=await(0,D.$Ig)(n,t)}finally{E=!0}if(!r)return;const s=c.responses.push(r)-1,o={wholeRange:T.Range.from(r.wholeRange),placeholder:r.placeholder};if(k.h(r))return{...o,id:s,type:"message",message:T.MarkdownString.from(r.contents)};const{edits:w}=r;return w instanceof A.$oK?{...o,id:s,type:"bulkEdit",edits:T.WorkspaceEdit.from(w)}:{...o,id:s,type:"editorEdit",edits:w.map(T.TextEdit.from)}}$handleFeedback(p,$,f,t){const i=this.b.get(p),c=this.d.get($),b=c?.responses[f];if(i&&b){const E=T.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(c.session,b,E)}}$releaseSession(p,$){}static h(p){return typeof p=="object"&&typeof p.contents=="object"}}e.$Odc=k}),define(Ae[237],Re([1,0,2,31]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class C{constructor(A,l,D,g,R){this.a=l,this.b=D,this.c=g;const k=new M.$DM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$BM("showOptions","Show Options",a=>!0,a=>a),new M.$BM("resource","Interactive resource Uri",a=>!0,a=>a),new M.$BM("controllerId","Notebook controller Id",a=>!0,a=>a),new M.$BM("title","Interactive editor title",a=>!0,a=>a)],new M.$CM("Notebook and input URI",a=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const p=this.a.getEditorById(a.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:y.URI.revive(a.notebookUri),inputUri:y.URI.revive(a.inputUri),notebookEditor:p.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:y.URI.revive(a.notebookUri),inputUri:y.URI.revive(a.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(A,l,D,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:l,lines:[""],languageId:D,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,l){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Kdc=C}),define(Ae[238],Re([1,0,3,7]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;class C{constructor(A){this.a=new Map,this.b=A.getProxy(y.$cK.MainThreadIssueReporter)}async $getIssueReporterUri(A,l){if(this.a.size===0)throw new Error("No issue request handlers registered");const D=this.a.get(A);if(!D)throw new Error("Issue request handler not found");const g=await D.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}registerIssueUriRequestHandler(A,l){const D=A.identifier.value;return this.a.set(D,l),this.b.$registerIssueUriRequestHandler(D),new M.$eK(()=>{this.b.$unregisterIssueUriRequestHandler(D),this.a.delete(D)})}}e.$Qdc=C}),define(Ae[239],Re([1,0,6,3]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(M.$cK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const l=this.b++;return this.a.$registerResourceLabelFormatter(l,A),(0,y.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(l)})}}e.$4cc=C}),define(Ae[240],Re([1,0,2,24,8,7,78,3,16,45,18,15,282,20,21,6,91,88,74,59,9,12,25,149]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f,t,i,c,b,E,v,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=void 0;class s{constructor(F,q){this.d=F,this.e=q}async provideDocumentSymbols(F,q){const J=this.d.getDocument(F),Q=await this.e.provideDocumentSymbols(J,q);if(!(0,R.$Kb)(Q))return Q[0]instanceof T.$wK?Q.map(C.DocumentSymbol.from):s.f(Q)}static f(F){F=F.slice(0).sort((Q,H)=>{let _=Q.location.range.start.compareTo(H.location.range.start);return _===0&&(_=H.location.range.end.compareTo(Q.location.range.end)),_});const q=[],J=[];for(const Q of F){const H={name:Q.name||"!!MISSING: name!!",kind:C.SymbolKind.from(Q.kind),tags:Q.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:C.Range.from(Q.location.range),selectionRange:C.Range.from(Q.location.range),children:[]};for(;;){if(J.length===0){J.push(H),q.push(H);break}const _=J[J.length-1];if(g.$qs.containsRange(_.range,H.range)&&!g.$qs.equalsRange(_.range,H.range)){_.children?.push(H),J.push(H);break}J.pop()}}return q}}class o{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(F,q,J){this.g=F,this.h=q,this.j=J,this.e=new c.$Rbc("CodeLens"),this.f=new Map}async provideCodeLenses(F,q){const J=this.g.getDocument(F),Q=await this.j.provideCodeLenses(J,q);if(!Q||q.isCancellationRequested)return;const H=this.e.add(Q),_=new f.$Rc;this.f.set(H,_);const ae={cacheId:H,lenses:[]};for(let Ne=0;Ne<Q.length;Ne++)ae.lenses.push({cacheId:[H,Ne],range:C.Range.from(Q[Ne].range),command:this.h.toInternal(Q[Ne].command,_)});return ae}async resolveCodeLens(F,q){const J=F.cacheId&&this.e.get(...F.cacheId);if(!J)return;let Q;if(typeof this.j.resolveCodeLens!="function"||J.isResolved?Q=J:Q=await this.j.resolveCodeLens(J,q),Q||(Q=J),q.isCancellationRequested)return;const H=F.cacheId&&this.f.get(F.cacheId[0]);if(H)return F.command=this.h.toInternal(Q.command??o.d,H),F}releaseCodeLenses(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}}function w(Ie){return Array.isArray(Ie)?Ie.map(C.DefinitionLink.from):Ie?[C.DefinitionLink.from(Ie)]:[]}class h{constructor(F,q){this.d=F,this.e=q}async provideDefinition(F,q,J){const Q=this.d.getDocument(F),H=C.Position.to(q),_=await this.e.provideDefinition(Q,H,J);return w(_)}}class I{constructor(F,q){this.d=F,this.e=q}async provideDeclaration(F,q,J){const Q=this.d.getDocument(F),H=C.Position.to(q),_=await this.e.provideDeclaration(Q,H,J);return w(_)}}class S{constructor(F,q){this.d=F,this.e=q}async provideImplementation(F,q,J){const Q=this.d.getDocument(F),H=C.Position.to(q),_=await this.e.provideImplementation(Q,H,J);return w(_)}}class u{constructor(F,q){this.d=F,this.e=q}async provideTypeDefinition(F,q,J){const Q=this.d.getDocument(F),H=C.Position.to(q),_=await this.e.provideTypeDefinition(Q,H,J);return w(_)}}class m{constructor(F,q){this.d=F,this.e=q}async provideHover(F,q,J){const Q=this.d.getDocument(F),H=C.Position.to(q),_=await this.e.provideHover(Q,H,J);if(!(!_||(0,R.$Kb)(_.contents)))return _.range||(_.range=Q.getWordRangeAtPosition(H)),_.range||(_.range=new T.$gK(H,H)),C.Hover.from(_)}}class d{constructor(F,q){this.d=F,this.e=q}async provideEvaluatableExpression(F,q,J){const Q=this.d.getDocument(F),H=C.Position.to(q),_=await this.e.provideEvaluatableExpression(Q,H,J);if(_)return C.EvaluatableExpression.from(_)}}class P{constructor(F,q){this.d=F,this.e=q}async provideInlineValues(F,q,J,Q){const H=this.d.getDocument(F),_=await this.e.provideInlineValues(H,C.Range.to(q),C.InlineValueContext.to(J),Q);if(Array.isArray(_))return _.map(ae=>C.InlineValue.from(ae))}}class W{constructor(F,q){this.d=F,this.e=q}async provideDocumentHighlights(F,q,J){const Q=this.d.getDocument(F),H=C.Position.to(q),_=await this.e.provideDocumentHighlights(Q,H,J);if(Array.isArray(_))return _.map(C.DocumentHighlight.from)}}class K{constructor(F,q){this.d=F,this.e=q}async provideLinkedEditingRanges(F,q,J){const Q=this.d.getDocument(F),H=C.Position.to(q),_=await this.e.provideLinkedEditingRanges(Q,H,J);if(_&&Array.isArray(_.ranges))return{ranges:(0,R.$Hb)(_.ranges.map(C.Range.from)),wordPattern:_.wordPattern}}}class U{constructor(F,q){this.d=F,this.e=q}async provideReferences(F,q,J,Q){const H=this.d.getDocument(F),_=C.Position.to(q),ae=await this.e.provideReferences(H,_,J,Q);if(Array.isArray(ae))return ae.map(C.location.from)}}class B{static{this.d=1e3}constructor(F,q,J,Q,H,_,ae){this.g=F,this.h=q,this.j=J,this.k=Q,this.l=H,this.m=_,this.n=ae,this.e=new c.$Rbc("CodeAction"),this.f=new Map}async provideCodeActions(F,q,J,Q){const H=this.g.getDocument(F),_=a.$ss.isISelection(q)?C.Selection.to(q):C.Range.to(q),ae=[];for(const Ze of this.j.getDiagnostics(F))if(_.intersection(Ze.range)&&ae.push(Ze)>B.d)break;const Ne={diagnostics:ae,only:J.only?new T.$yK(J.only):void 0,triggerKind:C.CodeActionTriggerKind.to(J.trigger)},Ue=await this.k.provideCodeActions(H,_,Ne,Q);if(!(0,R.$Lb)(Ue)||Q.isCancellationRequested)return;const Qe=this.e.add(Ue),Ge=new f.$Rc;this.f.set(Qe,Ge);const _e=[];for(let Ze=0;Ze<Ue.length;Ze++){const xe=Ue[Ze];xe&&(B.o(xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:xe.title,command:this.h.toInternal(xe,Ge)})):(Ne.only&&(xe.kind?Ne.only.contains(xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),_e.push({cacheId:[Qe,Ze],title:xe.title,command:xe.command&&this.h.toInternal(xe.command,Ge),diagnostics:xe.diagnostics&&xe.diagnostics.map(C.Diagnostic.from),edit:xe.edit&&C.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,isAI:(0,n.$_E)(this.m,"codeActionAI")?xe.isAI:!1,disabled:xe.disabled?.reason})))}return{cacheId:Qe,actions:_e}}async resolveCodeAction(F,q){const[J,Q]=F,H=this.e.get(J,Q);if(!H||B.o(H))return{};if(!this.k.resolveCodeAction)return{};const _=await this.k.resolveCodeAction(H,q)??H;let ae;_.edit&&(ae=C.WorkspaceEdit.from(_.edit,void 0));let Ne;if(_.command){const Ue=this.f.get(J);Ue&&(Ne=this.h.toInternal(_.command,Ue))}return{edit:ae,command:Ne}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}class O{static toInternalProviderId(F,q){return F+"."+q}constructor(F,q,J,Q,H){this.d=F,this.e=q,this.f=J,this.g=Q,this.h=H}async prepareDocumentPaste(F,q,J,Q){if(!this.f.prepareDocumentPaste)return;const H=this.e.getDocument(F),_=q.map(Ue=>C.Range.to(Ue)),ae=C.DataTransfer.toDataTransfer(J,()=>{throw new E.$$});if(await this.f.prepareDocumentPaste(H,_,ae,Q),Q.isCancellationRequested)return;const Ne=Array.from(ae).filter(([,Ue])=>!(Ue instanceof T.$5K));return C.DataTransfer.from(Ne)}async providePasteEdits(F,q,J,Q,H){if(!this.f.provideDocumentPasteEdits)return;const _=this.e.getDocument(q),ae=J.map(Qe=>C.Range.to(Qe)),Ne=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolvePasteFileData(this.g,F,Qe)).buffer),Ue=await this.f.provideDocumentPasteEdits(_,ae,Ne,H);if(Ue)return{label:Ue.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:O.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class N{constructor(F,q){this.d=F,this.e=q}async provideDocumentFormattingEdits(F,q,J){const Q=this.d.getDocument(F),H=await this.e.provideDocumentFormattingEdits(Q,q,J);if(Array.isArray(H))return H.map(C.TextEdit.from)}}class te{constructor(F,q){this.d=F,this.e=q}async provideDocumentRangeFormattingEdits(F,q,J,Q){const H=this.d.getDocument(F),_=C.Range.to(q),ae=await this.e.provideDocumentRangeFormattingEdits(H,_,J,Q);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,q,J,Q){(0,k.$If)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const H=this.d.getDocument(F),_=q.map(C.Range.to),ae=await this.e.provideDocumentRangesFormattingEdits(H,_,J,Q);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}}class Y{constructor(F,q){this.d=F,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,q,J,Q,H){const _=this.d.getDocument(F),ae=C.Position.to(q),Ne=await this.e.provideOnTypeFormattingEdits(_,ae,J,Q,H);if(Array.isArray(Ne))return Ne.map(C.TextEdit.from)}}class Ee{constructor(F,q){this.e=F,this.f=q,this.d=new c.$Rbc("WorkspaceSymbols")}async provideWorkspaceSymbols(F,q){const J=await this.e.provideWorkspaceSymbols(F,q);if(!(0,R.$Lb)(J))return{symbols:[]};const Q=this.d.add(J),H={cacheId:Q,symbols:[]};for(let _=0;_<J.length;_++){const ae=J[_];if(!ae||!ae.name){this.f.warn("INVALID SymbolInformation",ae);continue}H.symbols.push({...C.WorkspaceSymbol.from(ae),cacheId:[Q,_]})}return H}async resolveWorkspaceSymbol(F,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const J=this.d.get(...F.cacheId);if(J){const Q=await this.e.resolveWorkspaceSymbol(J,q);return Q&&(0,M.$7m)(F,C.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class Se{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,q,J){this.d=F,this.e=q,this.f=J}async provideRenameEdits(F,q,J,Q){const H=this.d.getDocument(F),_=C.Position.to(q);try{const ae=await this.e.provideRenameEdits(H,_,J,Q);return ae?C.WorkspaceEdit.from(ae):void 0}catch(ae){const Ne=Se.g(ae);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(ae)}}async resolveRenameLocation(F,q,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(F),H=C.Position.to(q);try{const _=await this.e.prepareRename(Q,H,J);let ae,Ne;if(T.$gK.isRange(_)?(ae=_,Ne=Q.getText(_)):(0,k.$Af)(_)&&(ae=_.range,Ne=_.placeholder),!ae||!Ne)return;if(ae.start.line>H.line||ae.end.line<H.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ae),text:Ne}}catch(_){const ae=Se.g(_);return ae?{rejectReason:ae,range:void 0,text:void 0}:Promise.reject(_)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class Pe{constructor(F,q){this.resultId=F,this.tokens=q}}class ge{constructor(F,q){this.f=F,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,q,J){const Q=this.f.getDocument(F),H=q!==0?this.d.get(q):null;let _=typeof H?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,H.resultId,J):await this.g.provideDocumentSemanticTokens(Q,J);return H&&this.d.delete(q),_?(_=ge.h(_),this.o(ge.n(H,_),_)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return ge.j(F)?ge.k(F)?F:new T.$vL(new Uint32Array(F.data),F.resultId):ge.l(F)?ge.m(F)?F:new T.$xL(F.edits.map(q=>new T.$wL(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const q of F.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(F,q){if(!ge.j(q)||!F||!F.tokens)return q;const J=F.tokens,Q=J.length,H=q.data,_=H.length;let ae=0;const Ne=Math.min(Q,_);for(;ae<Ne&&J[ae]===H[ae];)ae++;if(ae===Q&&ae===_)return new T.$xL([],q.resultId);let Ue=0;const Qe=Ne-ae;for(;Ue<Qe&&J[Q-Ue-1]===H[_-Ue-1];)Ue++;return new T.$xL([{start:ae,deleteCount:Q-ae-Ue,data:H.subarray(ae,_-Ue)}],q.resultId)}o(F,q){if(ge.j(F)){const J=this.e++;return this.d.set(J,new Pe(F.resultId,F.data)),(0,t.$S0)({id:J,type:"full",data:F.data})}if(ge.l(F)){const J=this.e++;return ge.j(q)?this.d.set(J,new Pe(q.resultId,q.data)):this.d.set(J,new Pe(F.resultId)),(0,t.$S0)({id:J,type:"delta",deltas:(F.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class me{constructor(F,q){this.d=F,this.e=q}async provideDocumentRangeSemanticTokens(F,q,J){const Q=this.d.getDocument(F),H=await this.e.provideDocumentRangeSemanticTokens(Q,C.Range.to(q),J);return H?this.f(H):null}f(F){return(0,t.$S0)({id:0,type:"full",data:F.data})}}class ce{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,q,J,Q,H){this.f=F,this.g=q,this.h=J,this.j=Q,this.k=H,this.d=new c.$Rbc("CompletionItem"),this.e=new Map}async provideCompletionItems(F,q,J,Q){const H=this.f.getDocument(F),_=C.Position.to(q),ae=H.getWordRangeAtPosition(_)||new T.$gK(_,_),Ne=ae.with({end:_}),Ue=new b.$Jd,Qe=await this.h.provideCompletionItems(H,_,Q,C.CompletionContext.to(J));if(!Qe||Q.isCancellationRequested)return;const Ge=Array.isArray(Qe)?new T.$LK(Qe):Qe,_e=ce.supportsResolving(this.h)?this.d.add(Ge.items):this.d.add([]),Ze=new f.$Rc;this.e.set(_e,Ze);const xe=[],it={x:_e,b:xe,a:{replace:C.Range.from(ae),insert:C.Range.from(Ne)},c:Ge.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<Ge.items.length;tt++){const ze=Ge.items[tt],st=this.l(ze,[_e,tt],Ne,ae);xe.push(st)}return it}async resolveCompletionItem(F,q){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...F);if(!J)return;const Q=this.l(J,F),H=await this.h.resolveCompletionItem(J,q);if(!H)return;const _=this.l(H,F);return(Q.h!==_.h||Q.i!==_.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==_.n||Q.o!==_.o||!(0,M.$8m)(Q.p,_.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:_.d,c:_.c,l:_.l,h:_.h,i:_.i,n:_.n,o:_.o,p:_.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,q,J,Q){const H=this.e.get(q[0]);if(!H)throw Error("DisposableStore is missing...");const _=this.g.toInternal(F.command,H),ae={x:q,a:F.label,b:F.kind!==void 0?C.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(C.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:C.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(C.TextEdit.from),n:_?.$ident,o:_?.id,p:_?.$ident?void 0:_?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=F.textEdit.newText):typeof F.insertText=="string"?ae.h=F.insertText:F.insertText instanceof T.$pK&&(ae.h=F.insertText.value,ae.i|=4);let Ne;return F.textEdit?Ne=F.textEdit.range:F.range&&(Ne=F.range),T.$gK.isRange(Ne)?ae.j=C.Range.from(Ne):Ne&&(!J?.isEqual(Ne.inserting)||!Q?.isEqual(Ne.replacing))&&(ae.j={insert:C.Range.from(Ne.inserting),replace:C.Range.from(Ne.replacing)}),ae}}class se{async provideInlineCompletions(F,q,J,Q){}disposeCompletions(F){}handleDidShowCompletionItem(F,q,J){}handlePartialAccept(F,q,J){}}class $e extends se{constructor(F,q,J,Q){super(),this.f=F,this.g=q,this.h=J,this.j=Q,this.d=new x,this.e=(0,n.$_E)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:T.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:T.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$_E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,q,J,Q){const H=this.g.getDocument(F),_=C.Position.to(q),ae=await this.h.provideInlineCompletionItems(H,_,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:C.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},Q);if(!ae||Q.isCancellationRequested)return;const Ne=Array.isArray(ae)?ae:ae.items,Ue=this.e?Array.isArray(ae)?[]:ae.commands||[]:[],Qe=this.e&&!Array.isArray(ae)?ae.enableForwardStability:void 0;let Ge;return{pid:this.d.createReferenceId({dispose(){Ge?.dispose()},items:Ne}),items:Ne.map((Ze,xe)=>{let it;Ze.command&&(Ge||(Ge=new f.$Rc),it=this.j.toInternal(Ze.command,Ge));const tt=Ze.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ze.filterText,range:Ze.range?C.Range.from(Ze.range):void 0,command:it,idx:xe,completeBracketPairs:this.e?Ze.completeBracketPairs:!1}}),commands:Ue.map(Ze=>(Ge||(Ge=new f.$Rc),this.j.toInternal(Ze,Ge))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,q,J){const Q=this.d.get(F)?.items[q];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,J)}handlePartialAccept(F,q,J){const Q=this.d.get(F)?.items[q];Q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Q,J)}}class x{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const q=this.e++;return this.d.set(q,F),q}disposeReferenceId(F){const q=this.d.get(F);return this.d.delete(F),q}get(F){return this.d.get(F)}}class z{constructor(F,q){this.e=F,this.f=q,this.d=new c.$Rbc("SignatureHelp")}async provideSignatureHelp(F,q,J,Q){const H=this.e.getDocument(F),_=C.Position.to(q),ae=this.g(J),Ne=await this.f.provideSignatureHelp(H,_,Q,ae);if(Ne){const Ue=this.d.add([Ne]);return{...C.SignatureHelp.from(Ne),id:Ue}}}g(F){let q;if(F.activeSignatureHelp){const J=C.SignatureHelp.to(F.activeSignatureHelp),Q=this.d.get(F.activeSignatureHelp.id,0);Q?(q=Q,q.activeSignature=J.activeSignature,q.activeParameter=J.activeParameter):q=J}return{...F,activeSignatureHelp:q}}releaseSignatureHelp(F){this.d.delete(F)}}class V{constructor(F,q,J,Q,H){this.f=F,this.g=q,this.h=J,this.j=Q,this.k=H,this.d=new c.$Rbc("InlayHints"),this.e=new Map}async provideInlayHints(F,q,J){const Q=this.f.getDocument(F),H=C.Range.to(q),_=await this.h.provideInlayHints(Q,H,J);if(!Array.isArray(_)||_.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${q}`);return}if(J.isCancellationRequested)return;const ae=this.d.add(_);this.e.set(ae,new f.$Rc);const Ne={hints:[],cacheId:ae};for(let Ue=0;Ue<_.length;Ue++)this.l(_[Ue],H)&&Ne.hints.push(this.m(_[Ue],[ae,Ue]));return this.j.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this.k.identifier.value}' for ${q}`),Ne}async resolveInlayHint(F,q){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...F);if(!J)return;const Q=await this.h.resolveInlayHint(J,q);if(Q&&this.l(Q))return this.m(Q,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,q){return F.label.length===0||Array.isArray(F.label)&&F.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(q&&!q.contains(F.position))}m(F,q){const J=this.e.get(q[0]);if(!J)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:q,tooltip:C.MarkdownString.fromStrict(F.tooltip),position:C.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(C.TextEdit.from),kind:F.kind&&C.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?Q.label=F.label:Q.label=F.label.map(H=>{const _={label:H.value};return _.tooltip=C.MarkdownString.fromStrict(H.tooltip),T.$qK.isLocation(H.location)&&(_.location=C.location.from(H.location)),H.command&&(_.command=this.g.toInternal(H.command,J)),_}),Q}}class ue{constructor(F,q){this.e=F,this.f=q,this.d=new c.$Rbc("DocumentLink")}async provideLinks(F,q){const J=this.e.getDocument(F),Q=await this.f.provideDocumentLinks(J,q);if(!(!Array.isArray(Q)||Q.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(ue.g).map(C.DocumentLink.from)};{const H=this.d.add(Q),_={links:[],cacheId:H};for(let ae=0;ae<Q.length;ae++){if(!ue.g(Q[ae]))continue;const Ne=C.DocumentLink.from(Q[ae]);Ne.cacheId=[H,ae],_.links.push(Ne)}return _}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,q){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...F);if(!J)return;const Q=await this.f.resolveDocumentLink(J,q);if(!(!Q||!ue.g(Q)))return C.DocumentLink.from(Q)}releaseLinks(F){this.d.delete(F)}}class ye{constructor(F,q){this.d=F,this.e=q}async provideColors(F,q){const J=this.d.getDocument(F),Q=await this.e.provideDocumentColors(J,q);return Array.isArray(Q)?Q.map(_=>({color:C.Color.from(_.color),range:C.Range.from(_.range)})):[]}async provideColorPresentations(F,q,J){const Q=this.d.getDocument(F),H=C.Range.to(q.range),_=C.Color.to(q.color),ae=await this.e.provideColorPresentations(_,{document:Q,range:H},J);if(Array.isArray(ae))return ae.map(C.ColorPresentation.from)}}class we{constructor(F,q){this.d=F,this.e=q}async provideFoldingRanges(F,q,J){const Q=this.d.getDocument(F),H=await this.e.provideFoldingRanges(Q,q,J);if(Array.isArray(H))return H.map(C.FoldingRange.from)}}class pe{constructor(F,q,J){this.d=F,this.e=q,this.f=J}async provideSelectionRanges(F,q,J){const Q=this.d.getDocument(F),H=q.map(C.Position.to),_=await this.e.provideSelectionRanges(Q,H,J);if(!(0,R.$Lb)(_))return[];if(_.length!==H.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ae=[];for(let Ne=0;Ne<H.length;Ne++){const Ue=[];ae.push(Ue);let Qe=H[Ne],Ge=_[Ne];for(;;){if(!Ge.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(C.SelectionRange.from(Ge)),!Ge.parent)break;Qe=Ge.range,Ge=Ge.parent}}return ae}}class De{constructor(F,q){this.f=F,this.g=q,this.d=new i.$iM(""),this.e=new Map}async prepareSession(F,q,J){const Q=this.f.getDocument(F),H=C.Position.to(q),_=await this.g.prepareCallHierarchy(Q,H,J);if(!_)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(_)?_.map(Ne=>this.h(ae,Ne)):[this.h(ae,_)]}async provideCallsTo(F,q,J){const Q=this.j(F,q);if(!Q)throw new Error("missing call hierarchy item");const H=await this.g.provideCallHierarchyIncomingCalls(Q,J);if(H)return H.map(_=>({from:this.h(F,_.from),fromRanges:_.fromRanges.map(ae=>C.Range.from(ae))}))}async provideCallsFrom(F,q,J){const Q=this.j(F,q);if(!Q)throw new Error("missing call hierarchy item");const H=await this.g.provideCallHierarchyOutgoingCalls(Q,J);if(H)return H.map(_=>({to:this.h(F,_.to),fromRanges:_.fromRanges.map(ae=>C.Range.from(ae))}))}releaseSession(F){this.e.delete(F)}h(F,q){const J=this.e.get(F),Q=C.CallHierarchyItem.from(q,F,J.size.toString(36));return J.set(Q._itemId,q),Q}j(F,q){return this.e.get(F)?.get(q)}}class ne{constructor(F,q){this.f=F,this.g=q,this.d=new i.$iM(""),this.e=new Map}async prepareSession(F,q,J){const Q=this.f.getDocument(F),H=C.Position.to(q),_=await this.g.prepareTypeHierarchy(Q,H,J);if(!_)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(_)?_.map(Ne=>this.h(ae,Ne)):[this.h(ae,_)]}async provideSupertypes(F,q,J){const Q=this.j(F,q);if(!Q)throw new Error("missing type hierarchy item");const H=await this.g.provideTypeHierarchySupertypes(Q,J);if(H)return H.map(_=>this.h(F,_))}async provideSubtypes(F,q,J){const Q=this.j(F,q);if(!Q)throw new Error("missing type hierarchy item");const H=await this.g.provideTypeHierarchySubtypes(Q,J);if(H)return H.map(_=>this.h(F,_))}releaseSession(F){this.e.delete(F)}h(F,q){const J=this.e.get(F),Q=C.TypeHierarchyItem.from(q,F,J.size.toString(36));return J.set(Q._itemId,q),Q}j(F,q){return this.e.get(F)?.get(q)}}class le{static toInternalProviderId(F,q){return F+"."+q}constructor(F,q,J,Q,H){this.d=F,this.e=q,this.f=J,this.g=Q,this.h=H}async provideDocumentOnDropEdits(F,q,J,Q,H){const _=this.e.getDocument(q),ae=C.Position.to(J),Ne=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Qe)).buffer),Ue=await this.f.provideDocumentDropEdits(_,ae,Ne,H);if(Ue)return{label:Ue.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:le.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?C.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class re{constructor(F,q){this.d=F,this.e=q}async provideMappedEdits(F,q,J,Q){const H=y.URI.revive(F),_=this.d.getDocument(H),ae=J.documents.map(Qe=>Qe.map(Ge=>({uri:y.URI.revive(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(_e=>C.Range.to(_e))}))),Ne={documents:ae,selections:ae[0]?.[0]?.ranges??[]},Ue=await this.e.provideMappedEdits(_,q,Ne,Q);return Ue?C.WorkspaceEdit.from(Ue):null}}class oe{constructor(F,q){this.adapter=F,this.extension=q}}class he{static{this.d=0}constructor(F,q,J,Q,H,_,ae,Ne){this.g=q,this.h=J,this.j=Q,this.k=H,this.l=_,this.m=ae,this.n=Ne,this.f=new Map,this.e=F.getProxy(l.$cK.MainThreadLanguageFeatures)}o(F,q){return C.DocumentSelector.from(F,this.g,q)}p(F){return new T.$eK(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return he.d++}async s(F,q,J,Q,H,_=!1){const ae=this.f.get(F);if(!ae||!(ae.adapter instanceof q))return Q;const Ne=Date.now();_||this.l.trace(`[${ae.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Ue=J(ae.adapter,ae.extension);return Promise.resolve(Ue).catch(Qe=>{(0,E.$4)(Qe)||(this.l.error(`[${ae.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ae.extension.identifier,Qe))}).finally(()=>{_||this.l.trace(`[${ae.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),p.CancellationToken.isCancellationToken(H)?(0,v.$Jg)(Ue,H):Ue}t(F,q){const J=this.q();return this.f.set(J,new oe(F,q)),J}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,q,J,Q){const H=this.t(new s(this.h,J),F),_=Q&&Q.label||he.u(F);return this.e.$registerDocumentSymbolProvider(H,this.o(q,F),_),this.p(H)}$provideDocumentSymbols(F,q,J){return this.s(F,s,Q=>Q.provideDocumentSymbols(y.URI.revive(q),J),void 0,J)}registerCodeLensProvider(F,q,J){const Q=this.q(),H=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new oe(new o(this.h,this.j.converter,J),F)),this.e.$registerCodeLensSupport(Q,this.o(q,F),H);let _=this.p(Q);if(H!==void 0){const ae=J.onDidChangeCodeLenses(Ne=>this.e.$emitCodeLensEvent(H));_=T.$eK.from(_,ae)}return _}$provideCodeLenses(F,q,J){return this.s(F,o,Q=>Q.provideCodeLenses(y.URI.revive(q),J),void 0,J)}$resolveCodeLens(F,q,J){return this.s(F,o,Q=>Q.resolveCodeLens(q,J),void 0,void 0)}$releaseCodeLenses(F,q){this.s(F,o,J=>Promise.resolve(J.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(F,q,J){const Q=this.t(new h(this.h,J),F);return this.e.$registerDefinitionSupport(Q,this.o(q,F)),this.p(Q)}$provideDefinition(F,q,J,Q){return this.s(F,h,H=>H.provideDefinition(y.URI.revive(q),J,Q),[],Q)}registerDeclarationProvider(F,q,J){const Q=this.t(new I(this.h,J),F);return this.e.$registerDeclarationSupport(Q,this.o(q,F)),this.p(Q)}$provideDeclaration(F,q,J,Q){return this.s(F,I,H=>H.provideDeclaration(y.URI.revive(q),J,Q),[],Q)}registerImplementationProvider(F,q,J){const Q=this.t(new S(this.h,J),F);return this.e.$registerImplementationSupport(Q,this.o(q,F)),this.p(Q)}$provideImplementation(F,q,J,Q){return this.s(F,S,H=>H.provideImplementation(y.URI.revive(q),J,Q),[],Q)}registerTypeDefinitionProvider(F,q,J){const Q=this.t(new u(this.h,J),F);return this.e.$registerTypeDefinitionSupport(Q,this.o(q,F)),this.p(Q)}$provideTypeDefinition(F,q,J,Q){return this.s(F,u,H=>H.provideTypeDefinition(y.URI.revive(q),J,Q),[],Q)}registerHoverProvider(F,q,J,Q){const H=this.t(new m(this.h,J),F);return this.e.$registerHoverProvider(H,this.o(q,F)),this.p(H)}$provideHover(F,q,J,Q){return this.s(F,m,H=>H.provideHover(y.URI.revive(q),J,Q),void 0,Q)}registerEvaluatableExpressionProvider(F,q,J,Q){const H=this.t(new d(this.h,J),F);return this.e.$registerEvaluatableExpressionProvider(H,this.o(q,F)),this.p(H)}$provideEvaluatableExpression(F,q,J,Q){return this.s(F,d,H=>H.provideEvaluatableExpression(y.URI.revive(q),J,Q),void 0,Q)}registerInlineValuesProvider(F,q,J,Q){const H=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,_=this.t(new P(this.h,J),F);this.e.$registerInlineValuesProvider(_,this.o(q,F),H);let ae=this.p(_);if(H!==void 0){const Ne=J.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(H));ae=T.$eK.from(ae,Ne)}return ae}$provideInlineValues(F,q,J,Q,H){return this.s(F,P,_=>_.provideInlineValues(y.URI.revive(q),J,Q,H),void 0,H)}registerDocumentHighlightProvider(F,q,J){const Q=this.t(new W(this.h,J),F);return this.e.$registerDocumentHighlightProvider(Q,this.o(q,F)),this.p(Q)}$provideDocumentHighlights(F,q,J,Q){return this.s(F,W,H=>H.provideDocumentHighlights(y.URI.revive(q),J,Q),void 0,Q)}registerLinkedEditingRangeProvider(F,q,J){const Q=this.t(new K(this.h,J),F);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(q,F)),this.p(Q)}$provideLinkedEditingRanges(F,q,J,Q){return this.s(F,K,async H=>{const _=await H.provideLinkedEditingRanges(y.URI.revive(q),J,Q);if(_)return{ranges:_.ranges,wordPattern:_.wordPattern?he.w(_.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(F,q,J){const Q=this.t(new U(this.h,J),F);return this.e.$registerReferenceSupport(Q,this.o(q,F)),this.p(Q)}$provideReferences(F,q,J,Q,H){return this.s(F,U,_=>_.provideReferences(y.URI.revive(q),J,Q,H),void 0,H)}registerCodeActionProvider(F,q,J,Q){const H=new f.$Rc,_=this.t(new B(this.h,this.j.converter,this.k,J,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(_,this.o(q,F),{providedKinds:Q?.providedCodeActionKinds?.map(ae=>ae.value),documentation:Q?.documentation?.map(ae=>({kind:ae.kind.value,command:this.j.converter.toInternal(ae.command,H)}))},he.u(F),!!J.resolveCodeAction),H.add(this.p(_)),H}$provideCodeActions(F,q,J,Q,H){return this.s(F,B,_=>_.provideCodeActions(y.URI.revive(q),J,Q,H),void 0,H)}$resolveCodeAction(F,q,J){return this.s(F,B,Q=>Q.resolveCodeAction(q,J),{},void 0)}$releaseCodeActions(F,q){this.s(F,B,J=>Promise.resolve(J.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(F,q,J){const Q=this.t(new N(this.h,J),F);return this.e.$registerDocumentFormattingSupport(Q,this.o(q,F),F.identifier,F.displayName||F.name),this.p(Q)}$provideDocumentFormattingEdits(F,q,J,Q){return this.s(F,N,H=>H.provideDocumentFormattingEdits(y.URI.revive(q),J,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(F,q,J){const Q=typeof J.provideDocumentRangesFormattingEdits=="function",H=this.t(new te(this.h,J),F);return this.e.$registerRangeFormattingSupport(H,this.o(q,F),F.identifier,F.displayName||F.name,Q),this.p(H)}$provideDocumentRangeFormattingEdits(F,q,J,Q,H){return this.s(F,te,_=>_.provideDocumentRangeFormattingEdits(y.URI.revive(q),J,Q,H),void 0,H)}$provideDocumentRangesFormattingEdits(F,q,J,Q,H){return this.s(F,te,_=>_.provideDocumentRangesFormattingEdits(y.URI.revive(q),J,Q,H),void 0,H)}registerOnTypeFormattingEditProvider(F,q,J,Q){const H=this.t(new Y(this.h,J),F);return this.e.$registerOnTypeFormattingSupport(H,this.o(q,F),Q,F.identifier),this.p(H)}$provideOnTypeFormattingEdits(F,q,J,Q,H,_){return this.s(F,Y,ae=>ae.provideOnTypeFormattingEdits(y.URI.revive(q),J,Q,H,_),void 0,_)}registerWorkspaceSymbolProvider(F,q){const J=this.t(new Ee(q,this.l),F);return this.e.$registerNavigateTypeSupport(J,typeof q.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(F,q,J){return this.s(F,Ee,Q=>Q.provideWorkspaceSymbols(q,J),{symbols:[]},J)}$resolveWorkspaceSymbol(F,q,J){return this.s(F,Ee,Q=>Q.resolveWorkspaceSymbol(q,J),void 0,void 0)}$releaseWorkspaceSymbols(F,q){this.s(F,Ee,J=>J.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(F,q,J){const Q=this.t(new Se(this.h,J,this.l),F);return this.e.$registerRenameSupport(Q,this.o(q,F),Se.supportsResolving(J)),this.p(Q)}$provideRenameEdits(F,q,J,Q,H){return this.s(F,Se,_=>_.provideRenameEdits(y.URI.revive(q),J,Q,H),void 0,H)}$resolveRenameLocation(F,q,J,Q){return this.s(F,Se,H=>H.resolveRenameLocation(y.URI.revive(q),J,Q),void 0,Q)}registerDocumentSemanticTokensProvider(F,q,J,Q){const H=this.t(new ge(this.h,J),F),_=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(H,this.o(q,F),Q,_);let ae=this.p(H);if(_){const Ne=J.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(_));ae=T.$eK.from(ae,Ne)}return ae}$provideDocumentSemanticTokens(F,q,J,Q){return this.s(F,ge,H=>H.provideDocumentSemanticTokens(y.URI.revive(q),J,Q),null,Q)}$releaseDocumentSemanticTokens(F,q){this.s(F,ge,J=>J.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,q,J,Q){const H=this.t(new me(this.h,J),F);return this.e.$registerDocumentRangeSemanticTokensProvider(H,this.o(q,F),Q),this.p(H)}$provideDocumentRangeSemanticTokens(F,q,J,Q){return this.s(F,me,H=>H.provideDocumentRangeSemanticTokens(y.URI.revive(q),J,Q),null,Q)}registerCompletionItemProvider(F,q,J,Q){const H=this.t(new ce(this.h,this.j.converter,J,this.m,F),F);return this.e.$registerCompletionsProvider(H,this.o(q,F),Q,ce.supportsResolving(J),F.identifier),this.p(H)}$provideCompletionItems(F,q,J,Q,H){return this.s(F,ce,_=>_.provideCompletionItems(y.URI.revive(q),J,Q,H),void 0,H)}$resolveCompletionItem(F,q,J){return this.s(F,ce,Q=>Q.resolveCompletionItem(q,J),void 0,J)}$releaseCompletionItems(F,q){this.s(F,ce,J=>J.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(F,q,J,Q){const H=new $e(F,this.h,J,this.j.converter),_=this.t(H,F);return this.e.$registerInlineCompletionsSupport(_,this.o(q,F),H.supportsHandleEvents,$.$4l.toKey(F.identifier.value),Q?.yieldTo?.map(ae=>$.$4l.toKey(ae))||[]),this.p(_)}$provideInlineCompletions(F,q,J,Q,H){return this.s(F,se,_=>_.provideInlineCompletions(y.URI.revive(q),J,Q,H),void 0,H)}$handleInlineCompletionDidShow(F,q,J,Q){this.s(F,se,async H=>{H.handleDidShowCompletionItem(q,J,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,q,J,Q){this.s(F,se,async H=>{H.handlePartialAccept(q,J,Q)},void 0,void 0)}$freeInlineCompletionsList(F,q){this.s(F,se,async J=>{J.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(F,q,J,Q){const H=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,_=this.t(new z(this.h,J),F);return this.e.$registerSignatureHelpProvider(_,this.o(q,F),H),this.p(_)}$provideSignatureHelp(F,q,J,Q,H){return this.s(F,z,_=>_.provideSignatureHelp(y.URI.revive(q),J,Q,H),void 0,H)}$releaseSignatureHelp(F,q){this.s(F,z,J=>J.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(F,q,J){const Q=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,H=this.t(new V(this.h,this.j.converter,J,this.l,F),F);this.e.$registerInlayHintsProvider(H,this.o(q,F),typeof J.resolveInlayHint=="function",Q,he.u(F));let _=this.p(H);if(Q!==void 0){const ae=J.onDidChangeInlayHints(Ne=>this.e.$emitInlayHintsEvent(Q));_=T.$eK.from(_,ae)}return _}$provideInlayHints(F,q,J,Q){return this.s(F,V,H=>H.provideInlayHints(y.URI.revive(q),J,Q),void 0,Q)}$resolveInlayHint(F,q,J){return this.s(F,V,Q=>Q.resolveInlayHint(q,J),void 0,J)}$releaseInlayHints(F,q){this.s(F,V,J=>J.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(F,q,J){const Q=this.t(new ue(this.h,J),F);return this.e.$registerDocumentLinkProvider(Q,this.o(q,F),typeof J.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(F,q,J){return this.s(F,ue,Q=>Q.provideLinks(y.URI.revive(q),J),void 0,J,q.scheme==="output")}$resolveDocumentLink(F,q,J){return this.s(F,ue,Q=>Q.resolveLink(q,J),void 0,void 0,!0)}$releaseDocumentLinks(F,q){this.s(F,ue,J=>J.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(F,q,J){const Q=this.t(new ye(this.h,J),F);return this.e.$registerDocumentColorProvider(Q,this.o(q,F)),this.p(Q)}$provideDocumentColors(F,q,J){return this.s(F,ye,Q=>Q.provideColors(y.URI.revive(q),J),[],J)}$provideColorPresentations(F,q,J,Q){return this.s(F,ye,H=>H.provideColorPresentations(y.URI.revive(q),J,Q),void 0,Q)}registerFoldingRangeProvider(F,q,J){const Q=this.q(),H=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new oe(new we(this.h,J),F)),this.e.$registerFoldingRangeProvider(Q,this.o(q,F),F.identifier,H);let _=this.p(Q);if(H!==void 0){const ae=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(H));_=T.$eK.from(_,ae)}return _}$provideFoldingRanges(F,q,J,Q){return this.s(F,we,H=>H.provideFoldingRanges(y.URI.revive(q),J,Q),void 0,Q)}registerSelectionRangeProvider(F,q,J){const Q=this.t(new pe(this.h,J,this.l),F);return this.e.$registerSelectionRangeProvider(Q,this.o(q,F)),this.p(Q)}$provideSelectionRanges(F,q,J,Q){return this.s(F,pe,H=>H.provideSelectionRanges(y.URI.revive(q),J,Q),[],Q)}registerCallHierarchyProvider(F,q,J){const Q=this.t(new De(this.h,J),F);return this.e.$registerCallHierarchyProvider(Q,this.o(q,F)),this.p(Q)}$prepareCallHierarchy(F,q,J,Q){return this.s(F,De,H=>Promise.resolve(H.prepareSession(y.URI.revive(q),J,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(F,q,J,Q){return this.s(F,De,H=>H.provideCallsTo(q,J,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(F,q,J,Q){return this.s(F,De,H=>H.provideCallsFrom(q,J,Q),void 0,Q)}$releaseCallHierarchy(F,q){this.s(F,De,J=>Promise.resolve(J.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(F,q,J){const Q=this.t(new ne(this.h,J),F);return this.e.$registerTypeHierarchyProvider(Q,this.o(q,F)),this.p(Q)}$prepareTypeHierarchy(F,q,J,Q){return this.s(F,ne,H=>Promise.resolve(H.prepareSession(y.URI.revive(q),J,Q)),void 0,Q)}$provideTypeHierarchySupertypes(F,q,J,Q){return this.s(F,ne,H=>H.provideSupertypes(q,J,Q),void 0,Q)}$provideTypeHierarchySubtypes(F,q,J,Q){return this.s(F,ne,H=>H.provideSubtypes(q,J,Q),void 0,Q)}$releaseTypeHierarchy(F,q){this.s(F,ne,J=>Promise.resolve(J.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(F,q,J,Q){const H=this.q();this.f.set(H,new oe(new le(this.e,this.h,J,H,F),F));const _=(0,n.$_E)(F,"dropMetadata")&&Q?le.toInternalProviderId(F.identifier.value,Q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(H,this.o(q,F),_,(0,n.$_E)(F,"dropMetadata")?Q:void 0),this.p(H)}$provideDocumentOnDropEdits(F,q,J,Q,H,_){return this.s(F,le,ae=>Promise.resolve(ae.provideDocumentOnDropEdits(q,y.URI.revive(J),Q,H,_)),void 0,void 0)}registerMappedEditsProvider(F,q,J){const Q=this.t(new re(this.h,J),F);return this.e.$registerMappedEditsProvider(Q,this.o(q,F)),this.p(Q)}$provideMappedEdits(F,q,J,Q,H){return this.s(F,re,_=>Promise.resolve(_.provideMappedEdits(q,J,Q,H)),null,H)}registerDocumentPasteEditProvider(F,q,J,Q){const H=this.q();this.f.set(H,new oe(new O(this.e,this.h,J,H,F),F));const _=O.toInternalProviderId(F.identifier.value,Q.id);return this.e.$registerPasteEditProvider(H,this.o(q,F),_,{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(H)}$prepareDocumentPaste(F,q,J,Q,H){return this.s(F,O,_=>_.prepareDocumentPaste(y.URI.revive(q),J,Q,H),void 0,H)}$providePasteEdits(F,q,J,Q,H,_){return this.s(F,O,ae=>ae.providePasteEdits(q,y.URI.revive(J),Q,H,_),void 0,_)}static w(F){return{pattern:F.source,flags:F.flags}}static y(F){return{decreaseIndentPattern:he.w(F.decreaseIndentPattern),increaseIndentPattern:he.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?he.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?he.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:he.w(F.beforeText),afterText:F.afterText?he.w(F.afterText):void 0,previousLineText:F.previousLineText?he.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(he.z)}static C(F){return{open:F.open,close:F.close,notIn:F.notIn?F.notIn.map(q=>T.SyntaxTokenType.toString(q)):void 0}}static D(F){return F.map(he.C)}setLanguageConfiguration(F,q,J){const{wordPattern:Q}=J;if(Q&&(0,D.$Oe)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(q,Q):this.h.setWordDefinitionFor(q,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const H=this.q(),_={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?he.w(J.wordPattern):void 0,indentationRules:J.indentationRules?he.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?he.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?he.D(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(H,q,_),this.p(H)}$setWordDefinitions(F){for(const q of F)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$1bc=he}),define(Ae[241],Re([1,0,3,8,7,29,12,6,25]),function(be,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=void 0;class g{constructor(k,a,p,$){this.c=a,this.d=p,this.e=$,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(y.$cK.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,a){await this.a.$changeLanguage(k,a);const p=this.c.getDocumentData(k);if(!p)throw new Error(`document '${k.toString()}' NOT found`);return p.document}async tokenAtPosition(k,a){const p=k.version,$=M.Position.from(a),f=await this.a.$tokensAtPosition(k.uri,$),t={type:C.StandardTokenType.Other,range:k.getWordRangeAtPosition(a)??new C.$gK(a.line,a.character,a.line,a.character)};if(!f)return t;const i={range:M.Range.to(f.range),type:M.TokenType.to(f.type)};return!i.range.contains(a)||p!==k.version?t:i}createLanguageStatusItem(k,a,p){const $=this.f++,f=this.a,t=this.g,i=`${k.identifier.value}/${a}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${a}' ALREADY exists`);t.add(i);const c={selector:p,id:a,name:k.displayName??k.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b;const E=new l.$Rc,v=()=>{if(b?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${a}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}b=(0,A.$Vg)(()=>{E.clear(),this.a.$setLanguageStatus($,{id:i,name:c.name??k.displayName??k.name,source:k.displayName??k.name,selector:M.DocumentSelector.from(c.selector,this.e),label:c.text,detail:c.detail??"",severity:c.severity===C.LanguageStatusSeverity.Error?T.default.Error:c.severity===C.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:c.command&&this.d.toInternal(c.command,E),accessibilityInfo:c.accessibilityInformation,busy:c.busy})},0)},n={dispose(){E.dispose(),b?.dispose(),f.$removeLanguageStatus($),t.delete(i)},get id(){return c.id},get name(){return c.name},set name(r){c.name=r,v()},get selector(){return c.selector},set selector(r){c.selector=r,v()},get text(){return c.text},set text(r){c.text=r,v()},set text2(r){(0,D.$aF)(k,"languageStatusText"),c.text=r,v()},get text2(){return(0,D.$aF)(k,"languageStatusText"),c.text},get detail(){return c.detail},set detail(r){c.detail=r,v()},get severity(){return c.severity},set severity(r){c.severity=r,v()},get accessibilityInformation(){return c.accessibilityInformation},set accessibilityInformation(r){c.accessibilityInformation=r,v()},get command(){return c.command},set command(r){c.command=r,v()},get busy(){return c.busy},set busy(r){c.busy=r,v()}};return v(),n}}e.$Icc=g}),define(Ae[81],Re([1,0,22,16,2,4,14,3,27,17]),function(be,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=e.$xcc=void 0;let R=class{constructor(a,p,$){this.f=$,this.d=new Map,this.a=p.getProxy(l.$cK.MainThreadLocalization),this.b=a.environment.appLanguage,this.c=this.b===y.$g}getMessage(a,p){const{message:$,args:f,comment:t}=p;if(this.c)return(0,M.$De)($,f??{});let i=$;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.d.get(a)?.contents[i];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,M.$De)(c??$,f??{})}getBundle(a){return this.d.get(a)?.contents}getBundleUri(a){return this.d.get(a)?.uri}async initializeLocalizedMessages(a){if(this.c||!a.l10n&&!a.isBuiltin||this.d.has(a.identifier.value))return;let p;const $=await this.g(a);if(!$){this.f.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents($),t=JSON.parse(f);p=a.isBuiltin?t.contents?.bundle:t}catch(f){this.f.error(`Failed to load translations for ${a.identifier.value} from ${$}: ${f.message}`);return}p&&this.d.set(a.identifier.value,{contents:p,uri:$})}async g(a){if(a.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(a.identifier.value,this.b);return C.URI.revive(p)}return a.l10n?C.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$xcc=R,e.$xcc=R=qe([Ke(0,D.$tM),Ke(1,g.$dM),Ke(2,A.$9i)],R),e.$ycc=(0,T.$Oh)("IExtHostLocalizationService")}),define(Ae[242],Re([1,0,14,3,27,17,2,68]),function(be,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;let D=class extends y.$hj{constructor(k,a){super(a.logLevel,a.logsLocation,a.loggers.map(p=>(0,l.$lh)(p))),this.r=k.getProxy(M.$cK.MainThreadLogger)}$setLogLevel(k,a){a?this.setLogLevel(A.URI.revive(a),k):this.setLogLevel(k)}setVisibility(k,a){super.setVisibility(k,a),this.r.$setVisibility(k,a)}s(k,a,p){return new g(this.r,k,a,p)}};e.$1dc=D,e.$1dc=D=qe([Ke(0,T.$dM),Ke(1,C.$tM)],D);class g extends y.$cj{constructor(k,a,p,$){super($?.logLevel==="always"),this.r=k,this.s=a,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(a,$).then(()=>{this.u(this.n),this.m=!0})}g(k,a){const p=[[k,a]];this.m?this.u(p):this.n.push(...p)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Ae[82],Re([1,0,3,4,6,17,26]),function(be,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=e.$zcc=void 0,e.$zcc=(0,M.$Oh)("IExtHostManagedSockets");let l=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(y.$cK.MainThreadManagedSockets)}setFactory(k,a){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new D(k,a),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const a=++this.b,p=await this.c.makeConnection(),$=new C.$Rc;return this.d.set(a,new g(a,p,$)),$.add((0,C.$Qc)(()=>this.d.delete(a))),$.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(a),$.dispose()})),$.add(p.onDidClose(f=>{this.a.$onDidManagedSocketClose(a,f?.stack??f?.message),$.dispose()})),$.add(p.onDidReceiveMessage(f=>this.a.$onDidManagedSocketHaveData(a,A.$be.wrap(f)))),a}$remoteSocketWrite(k,a){this.d.get(k)?.actual.send(a.buffer)}$remoteSocketEnd(k){const a=this.d.get(k);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$Acc=l,e.$Acc=l=qe([Ke(0,T.$dM)],l);class D{constructor(k,a){this.socketFactoryId=k,this.makeConnection=a}}class g extends C.$Sc{constructor(k,a,p){super(),this.socketId=k,this.actual=a,this.B(p)}}}),define(Ae[243],Re([1,0,3,14,25]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=void 0;function T(l){return l&&l.title}let A=class{constructor(D,g){this.b=g,this.a=D.getProxy(y.$cK.MainThreadMessageService)}showMessage(D,g,R,k,a){const p={source:{identifier:D.identifier,label:D.displayName||D.name}};let $;typeof k=="string"||T(k)?$=[k,...a]:(p.modal=k?.modal,p.useCustom=k?.useCustom,p.detail=k?.detail,$=a),p.useCustom&&(0,C.$aF)(D,"resolvers");const f=[];for(let t=0;t<$.length;t++){const i=$[t];if(typeof i=="string")f.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:c,isCloseAffordance:b}=i;f.push({title:c,isCloseAffordance:!!b,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(g,R,p,f).then(t=>{if(typeof t=="number")return $[t]})}};e.$Jcc=A,e.$Jcc=A=qe([Ke(1,M.$9i)],A)}),define(Ae[244],Re([1,0,151,26,5,6,28,16,15,2,39,74,3,31,8,7,47,204,103,9,24,13]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f,t,i,c,b,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;class n{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(s=>s.apiEditor)}constructor(s,o,w,h,I){this.q=w,this.r=h,this.s=I,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new C.$Nd({onListenerError:b.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Nd({onListenerError:b.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Nd({onListenerError:b.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Nd({onListenerError:b.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$Rbc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=s.getProxy(a.$cK.MainThreadNotebook),this.c=s.getProxy(a.$cK.MainThreadNotebookDocuments),this.d=s.getProxy(a.$cK.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const u=S.notebookEditor?.notebookUri,m=S.cell.handle,P=this.g.get(u)?.getCell(m);if(P)return P.apiCell}if(S&&S.$mid===14){const u=S.uri,m=this.g.get(u);if(m)return m.apiNotebook}return S}}),n.A(o)}getEditorById(s){const o=this.h.get(s);if(!o)throw new Error(`unknown text editor: ${s}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(s){for(const[o,w]of this.h)if(w.apiEditor===s)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(s,o){const w=this.g.get(s);if(!w&&!o)throw new Error(`NO notebook document for '${s}'`);return w}static t(s,o){if(!o)return;const w=o.filenamePattern.map(h=>$.NotebookExclusiveDocumentPattern.from(h)).filter(h=>h!==void 0);if(o.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:o.displayName,filenamePattern:w,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,o,w){const h=n.a++,I=typeof w.onDidChangeCellStatusBarItems=="function"?n.a++:void 0;this.f.set(h,w),this.b.$registerNotebookCellStatusBarItemProvider(h,I,o);let S;return I!==void 0&&(S=w.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(I))),new f.$eK(()=>{this.f.delete(h),this.b.$unregisterNotebookCellStatusBarItemProvider(h,I),S?.dispose()})}async createNotebookDocument(s){const o=await this.c.$tryCreateNotebook({viewType:s.viewType,content:s.content&&$.NotebookData.from(s.content)});return g.URI.revive(o)}async openNotebookDocument(s){const o=this.g.get(s);if(o)return o.apiNotebook;const w=await this.c.$tryOpenNotebook(s),h=this.g.get(g.URI.revive(w));return(0,D.$Jf)(h?.apiNotebook)}async showNotebookDocument(s,o){g.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let w;typeof o=="object"?w={position:$.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map($.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:w={preserveFocus:!1};const h=await this.d.$tryShowNotebookDocument(s.uri,s.notebookType,w),I=h&&this.h.get(h)?.apiEditor;if(I)return I;throw h?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,o,w,h){const I=this.f.get(s),S=g.URI.revive(o),u=this.g.get(S);if(!u||!I)return;const m=u.getCellFromIndex(w);if(!m)return;const d=await I.provideCellStatusBarItems(m.apiCell,h);if(!d)return;const P=new T.$Rc,W=this.p.add([P]),U=(Array.isArray(d)?d:[d]).map(B=>$.NotebookStatusBarItem.from(B,this.i,P));return{cacheId:W,items:U}}$releaseNotebookCellStatusBarItems(s){this.p.delete(s)}registerNotebookSerializer(s,o,w,h,I){if((0,l.$Be)(o))throw new Error("viewType cannot be empty or just whitespace");const S=this.u++;return this.w.set(S,{viewType:o,serializer:w,options:h}),this.b.$registerNotebookSerializer(S,{id:s.identifier,location:s.extensionLocation},o,$.NotebookDocumentContentOptions.from(h),n.t(s,I)),(0,T.$Qc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(s,o,w){const h=this.w.get(s);if(!h)throw new Error("NO serializer found");const I=await h.serializer.deserializeNotebook(o.buffer,w);return new t.$mv($.NotebookData.from(I))}async $notebookToData(s,o,w){const h=this.w.get(s);if(!h)throw new Error("NO serializer found");const I=await h.serializer.serializeNotebook($.NotebookData.to(o.value),w);return M.$be.wrap(I)}async $saveNotebook(s,o,w,h,I){const S=g.URI.revive(o),u=this.w.get(s);if(!u)throw new Error("NO serializer found");const m=this.g.get(S);if(!m)throw new Error("Document NOT found");if(m.versionId!==w)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new R.$sk((0,y.localize)(0,null,this.y(S)),6);await this.x(S,h);const d={metadata:(0,E.$_m)(m.apiNotebook.metadata,B=>!(u.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of m.apiNotebook.getCells()){const O=new f.$CL(B.kind,B.document.getText(),B.document.languageId,B.mime,u.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);O.metadata=(0,E.$_m)(B.metadata,N=>!(u.options?.transientCellMetadata??{})[N]),d.cells.push(O)}const P=await u.serializer.serializeNotebook(d,I);await this.s.value.writeFile(S,P);const W=this.s.getFileSystemProviderExtUri(S.scheme),K=await this.s.value.stat(S);return{name:W.basename(S),isFile:(K.type&R.FileType.File)!==0,isDirectory:(K.type&R.FileType.Directory)!==0,isSymbolicLink:(K.type&R.FileType.SymbolicLink)!==0,mtime:K.mtime,ctime:K.ctime,size:K.size,readonly:!!((K.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((K.permissions??0)&R.FilePermission.Locked),etag:R.$Dk({mtime:K.mtime,size:K.size}),children:void 0}}async x(s,o){const w=await this.s.value.stat(s);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==R.$Ck&&typeof w.mtime=="number"&&typeof w.size=="number"&&o.mtime<w.mtime&&o.etag!==R.$Dk({mtime:o.mtime,size:w.size}))throw new R.$sk((0,y.localize)(1,null),3,o)}y(s){return s.scheme===v.Schemas.file?s.fsPath:s.toString()}z(s,o,w){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const h=new c.$qdc(o,this.d,s,w.visibleRanges.map($.NotebookRange.to),w.selections.map($.NotebookRange.to),typeof w.viewColumn=="number"?$.ViewColumn.to(w.viewColumn):void 0);this.h.set(o,h)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const w of s.value.removedDocuments){const h=g.URI.revive(w),I=this.g.get(h);I&&(I.dispose(),this.g.delete(h),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(I.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===h.toString()&&this.h.delete(S.id)}if(s.value.addedDocuments){const w=[];for(const h of s.value.addedDocuments){const I=g.URI.revive(h.uri);if(this.g.has(I))throw new Error(`adding EXISTING notebook ${I} `);const S=new i.$pdc(this.c,this.q,this.r,I,h);w.push(...h.cells.map(u=>i.$odc.asModelAddData(S.apiNotebook,u))),this.g.get(I)?.dispose(),this.g.set(I,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(S.apiNotebook)}}if(s.value.addedEditors)for(const w of s.value.addedEditors){if(this.h.has(w.id))return;const h=g.URI.revive(w.documentUri),I=this.g.get(h);I&&this.z(I,w.id,w)}const o=[];if(s.value.removedEditors)for(const w of s.value.removedEditors){const h=this.h.get(w);h&&(this.h.delete(w),this.k?.id===h.id&&(this.k=void 0),o.push(h))}if(s.value.visibleEditors){this.l=s.value.visibleEditors.map(h=>this.h.get(h)).filter(h=>!!h);const w=new Set;this.l.forEach(h=>w.add(h.id));for(const h of this.h.values()){const I=w.has(h.id);h._acceptVisibility(I)}this.l=[...this.h.values()].map(h=>h).filter(h=>h.visible),this.o.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this.k=void 0:s.value.newActiveEditor&&(this.h.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this.k=this.h.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(s){const o=p.$BM.String.with("notebookType","A notebook type"),w=new p.$DM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new p.$BM("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>M.$be.wrap(I))],new p.$CM("Notebook Data",I=>$.NotebookData.to(I.value))),h=new p.$DM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new p.$BM("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new t.$mv($.NotebookData.from(I)))],new p.$CM("Bytes",I=>I.buffer));s.registerApiCommand(w),s.registerApiCommand(h)}}e.$rdc=n}),define(Ae[245],Re([1,0,18,12,20,5,6,28,2,21,14,3,31,8,7,77,197,25,47]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=e.$Fdc=void 0;let b=class{constructor(h,I,S,u,m){this.l=I,this.m=S,this.n=u,this.o=m,this.b=new l.$Ac,this.c=new l.$Ac,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new T.$Nd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=h.getProxy(k.$cK.MainThreadNotebookKernels);const d=new a.$DM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.$BM("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const W=this.m.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:W}}else if(P&&"notebookEditor"in P){const W=this.m.getIdByEditor(P.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return P})],a.$CM.Void);this.n.registerApiCommand(d)}createNotebookController(h,I,S,u,m,d){for(const me of this.i.values())if(me.controller.id===I&&g.$4l.equals(h.identifier,me.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const P=this.j++,W=this;this.o.trace(`NotebookController[${P}], CREATED by ${h.identifier.value}, ${I}`);const K=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${h.identifier}'`);let U=!1;const B=new T.$Nd,O=new T.$Nd,N={id:o(h.identifier,I),notebookType:S,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:u||h.identifier.value,preloads:d?d.map(p.NotebookRendererScript.from):[]};let te=m??K,Y;this.a.$addKernel(P,N).catch(me=>{console.log(me),U=!0});let Ee=0;const Se=()=>{if(U)return;const me=++Ee;Promise.resolve().then(()=>{me===Ee&&this.a.$updateKernel(P,N)})},Pe=new l.$Ac,ge={get id(){return I},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return N.label},set label(me){N.label=me??h.displayName??h.name,Se()},get detail(){return N.detail??""},set detail(me){N.detail=me,Se()},get description(){return N.description??""},set description(me){N.description=me,Se()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(me){N.supportedLanguages=me,Se()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(me){N.supportsExecutionOrder=me,Se()},get rendererScripts(){return N.preloads?N.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return te},set executeHandler(me){te=me??K},get interruptHandler(){return Y},set interruptHandler(me){Y=me,N.supportsInterrupt=!!me,Se()},createNotebookCellExecution(me){if(U)throw new Error("notebook controller is DISPOSED");if(!Pe.has(me.notebook.uri))throw W.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${me.notebook.uri.toString()}`);return W._createNotebookCellExecution(me,o(h.identifier,this.id))},createNotebookExecution(me){if((0,i.$aF)(h,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!Pe.has(me.uri))throw W.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${me.uri.toString()}`);return W._createNotebookExecution(me,o(h.identifier,this.id))},dispose:()=>{U||(this.o.trace(`NotebookController[${P}], DISPOSED`),U=!0,this.i.delete(P),B.dispose(),O.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(me,ce){ce===$.NotebookControllerAffinity2.Hidden&&(0,i.$aF)(h,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(P,me.uri,ce)},onDidReceiveMessage:O.event,postMessage(me,ce){return(0,i.$aF)(h,"notebookMessaging"),W.a.$postMessage(P,ce&&W.m.getIdByEditor(ce),me)},asWebviewUri(me){return(0,i.$aF)(h,"notebookMessaging"),(0,f.$5ob)(me,W.l.remote)}};return this.i.set(P,{extensionId:h.identifier,controller:ge,onDidReceiveMessage:O,onDidChangeSelection:B,associatedNotebooks:Pe}),ge}getIdByController(h){for(const[I,S]of this.i)if(S.controller===h)return o(S.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,I){const S=this.f++,u=this;this.o.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(S,I);const m={dispose:()=>{this.e.delete(S),u.a.$removeKernelDetectionTask(S)}};return this.e.set(S,m),m}registerKernelSourceActionProvider(h,I,S){const u=this.h++,m=typeof S.onDidChangeNotebookKernelSourceActions=="function"?u:void 0,d=this;this.g.set(u,S),this.o.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider(u,u,I);let P;return m!==void 0&&(P=S.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this.g.delete(u),d.a.$removeKernelSourceActionProvider(u,u),P?.dispose()}}}async $provideKernelSourceActions(h,I){const S=this.g.get(h);if(S){const u=new A.$Rc;return(await S.provideNotebookKernelSourceActions(I)??[]).map(d=>p.NotebookKernelSourceAction.from(d,this.n.converter,u))}return[]}$acceptNotebookAssociation(h,I,S){const u=this.i.get(h);if(u){const m=this.m.getNotebookDocument(D.URI.revive(I));S?u.associatedNotebooks.set(m.uri,!0):u.associatedNotebooks.delete(m.uri),this.o.trace(`NotebookController[${h}] ASSOCIATE notebook`,m.uri.toString(),S),u.onDidChangeSelection.fire({selected:S,notebook:m.apiNotebook})}}async $executeCells(h,I,S){const u=this.i.get(h);if(!u)return;const m=this.m.getNotebookDocument(D.URI.revive(I)),d=[];for(const P of S){const W=m.getCell(P);W&&d.push(W.apiCell)}try{this.o.trace(`NotebookController[${h}] EXECUTE cells`,m.uri.toString(),d.length),await u.controller.executeHandler.call(u.controller,d,m.apiNotebook,u.controller)}catch(P){this.o.error(`NotebookController[${h}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(h,I,S){const u=this.i.get(h);if(!u)return;const m=this.m.getNotebookDocument(D.URI.revive(I));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,m.apiNotebook);else for(const d of S){const P=m.getCell(d);P&&this.b.get(P.uri)?.cancel()}if(u.controller.interruptHandler){const d=this.c.get(m.uri);S.length&&Array.isArray(d)&&d.length&&d.forEach(P=>P.dispose())}}$acceptKernelMessageFromRenderer(h,I,S){const u=this.i.get(h);if(!u)return;const m=this.m.getEditorById(I);u.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:S}))}$cellExecutionChanged(h,I,S){const m=this.m.getNotebookDocument(D.URI.revive(h)).getCell(I);if(m){const d=S?p.NotebookCellExecutionState.to(S):$.NotebookCellExecutionState.Idle;d!==void 0&&this.k.fire({cell:m.apiCell,state:d})}}_createNotebookCellExecution(h,I){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.m.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const m=new v(I,u,this.a);this.b.set(u.uri,m);const d=m.onDidChangeState(()=>{m.state===E.Resolved&&(m.dispose(),d.dispose(),this.b.delete(u.uri))});return m.asApiObject()}_createNotebookExecution(h,I){const S=this.m.getNotebookDocument(h.uri),u=h.getCells().find(P=>{const W=S.getCellFromApiCell(P);return W&&this.b.has(W.uri)});if(u)throw new Error(`duplicate cell execution for ${u.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const m=new r(I,S,this.a),d=m.onDidChangeState(()=>{m.state===n.Resolved&&(m.dispose(),d.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[m,d]),m.asApiObject()}};e.$Fdc=b,e.$Fdc=b=qe([Ke(4,R.$9i)],b);var E;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(E||(E={}));class v extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(h,I,S){super(),this.m=I,this.n=S,this.b=v.a++,this.c=new T.$Nd,this.onDidChangeState=this.c.event,this.f=E.Init,this.g=this.B(new C.$Xd),this.h=new s(10,u=>this.s(u)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const I=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new c.$mv(I))}t(){if(this.f===E.Init)throw new Error("Must call start before modifying cell output");if(this.f===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let I=this.m;if(h&&(I=this.m.notebook.getCellFromApiCell(h)),!I)throw new Error("INVALID cell");return I.handle}y(h){return h.map(I=>{const S=$.$FL.ensureUniqueMimeTypes(I.items,!0);return S===I.items?p.NotebookCellOutput.from(I):p.NotebookCellOutput.from({items:S,id:I.id,metadata:I.metadata})})}async z(h,I,S){const u=this.w(I),m=this.y((0,y.$3b)(h));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:u,append:S,outputs:m})}async C(h,I,S){return h=$.$FL.ensureUniqueMimeTypes((0,y.$3b)(h),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:h.map(p.NotebookCellOutputItem.from),outputId:I.id,append:S})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(S){h.j=S,h.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(S){if(h.f===E.Resolved||h.f===E.Started)throw new Error("Cannot call start again");h.f=E.Started,h.c.fire(),h.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,u){if(h.f===E.Resolved)throw new Error("Cannot call resolve twice");h.f=E.Resolved,h.c.fire(),h.h.flush(),h.n.$completeExecution(h.b,new c.$mv({runEndTime:u,lastRunSuccess:S}))},clearOutput(S){return h.t(),h.z([],S,!1)},appendOutput(S,u){return h.t(),h.z(S,u,!0)},replaceOutput(S,u){return h.t(),h.z(S,u,!1)},appendOutputItems(S,u){return h.t(),h.C(S,u,!0)},replaceOutputItems(S,u){return h.t(),h.C(S,u,!1)}})}}var n;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(n||(n={}));class r extends A.$Sc{static{this.a=0}get state(){return this.f}constructor(h,I,S){super(),this.h=I,this.j=S,this.b=r.a++,this.c=new T.$Nd,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new C.$Xd),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class s{constructor(h,I){this.e=h,this.f=I,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new M.$ch,this.b=Date.now(),(0,M.$Ug)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>h.complete())}}function o(w,h){return`${w.value}/${h}`}e.$Gdc=o}),define(Ae[246],Re([1,0,5,3,103]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class T{constructor(l,D){this.c=D,this.a=new Map,this.b=l.getProxy(M.$cK.MainThreadNotebookRenderers)}$postRendererMessage(l,D,g){const R=this.c.getEditorById(l);this.a.get(D)?.fire({editor:R.apiEditor,message:g})}createRendererMessaging(l,D){if(!l.contributes?.notebookRenderer?.some(R=>R.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(R,k,a)=>this.d(D).event(R,k,a),postMessage:(R,k)=>{C.$qdc.apiEditorsToExtHost.has(R)&&([R,k]=[k,R]);const a=k&&C.$qdc.apiEditorsToExtHost.get(k);return this.b.$postMessage(a?.id,D,R)}}}d(l){let D=this.a.get(l);return D||(D=new y.$Nd({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete(l)}}),this.a.set(l,D),D)}}e.$Hdc=T}),define(Ae[247],Re([1,0,6,15,2,25,3]),function(be,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0;class l{constructor(g){this.b=new Map,this.a=g.getProxy(A.$cK.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,R,k){if((0,T.$aF)(g,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,k),this.a.$registerProfileContentHandler(R,k.name,k.description,g.identifier.value),(0,y.$Qc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(g,R,k,a){const p=this.b.get(g);if(!p)throw new Error(`Unknown handler with id: ${g}`);return p.saveProfile(R,k,a)}async $readProfile(g,R,k){const a=this.b.get(g);if(!a)throw new Error(`Unknown handler with id: ${g}`);return a.readProfile((0,M.$yf)(R)?R:C.URI.revive(R),k)}}e.$Ldc=l}),define(Ae[248],Re([1,0,2,3,12,8]),function(be,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=void 0;class A{static{this.a=0}constructor(D,g){this.d=g,this.c=new Map,this.b=D.getProxy(M.$cK.MainThreadQuickDiff)}$provideOriginalResource(D,g,R){const k=y.URI.revive(g),a=this.c.get(D);return a?(0,C.$Mg)(()=>a.provideOriginalResource(k,R)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(D,g,R,k){const a=A.a++;return this.c.set(a,g),this.b.$registerQuickDiffProvider(a,T.DocumentSelector.from(D,this.d),R,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(a),this.c.delete(a)}}}}e.$Mdc=A}),define(Ae[249],Re([1,0,20,5,6,3,2,7,9,18,29,42,25,8]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;function $(f,t,i){const c=f.getProxy(T.$cK.MainThreadQuickOpen);class b{constructor(I,S){this.e=new Map,this.f=0,this.a=I,this.b=S}showQuickPick(I,S,u,m=y.CancellationToken.None){this.c=void 0;const d=Promise.resolve(S),P=++this.f,W=c.$show(P,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},m),K={},U=W.then(()=>K);return Promise.race([U,d]).then(B=>{if(B===K)return;const O=(0,a.$_E)(I,"quickPickItemTooltip");return d.then(N=>{const te=[];for(let Y=0;Y<N.length;Y++){const Ee=N[Y];if(typeof Ee=="string")te.push({label:Ee,handle:Y});else if(Ee.kind===l.QuickPickItemKind.Separator)te.push({type:"separator",label:Ee.label});else{Ee.tooltip&&!O&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const Se=Ee.iconPath?s(Ee.iconPath):void 0;te.push({label:Ee.label,iconPath:Se?.iconPath,iconClass:Se?.iconClass,description:Ee.description,detail:Ee.detail,picked:Ee.picked,alwaysShow:Ee.alwaysShow,tooltip:O?p.MarkdownString.fromStrict(Ee.tooltip):void 0,handle:Y})}}return u&&typeof u.onDidSelectItem=="function"&&(this.c=Y=>{u.onDidSelectItem(N[Y])}),c.$setItems(P,te),W.then(Y=>{if(typeof Y=="number")return N[Y];if(Array.isArray(Y))return Y.map(Ee=>N[Ee])})})}).then(void 0,B=>{if(!(0,D.$4)(B))return c.$setError(P,B),Promise.reject(B)})}$onItemSelected(I){this.c?.(I)}showInput(I,S=y.CancellationToken.None){return this.d=I?.validateInput,c.$input(I,typeof this.d=="function",S).then(void 0,u=>{if(!(0,D.$4)(u))return Promise.reject(u)})}async $validateInput(I){if(!this.d)return;const S=await this.d(I);if(!S||typeof S=="string")return S;let u;switch(S.severity){case l.InputBoxValidationSeverity.Info:u=R.default.Info;break;case l.InputBoxValidationSeverity.Warning:u=R.default.Warning;break;case l.InputBoxValidationSeverity.Error:u=R.default.Error;break;default:u=S.message?R.default.Error:R.default.Ignore;break}return{content:S.message,severity:u}}async showWorkspaceFolderPick(I,S=y.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!u)return;const m=await this.a.getWorkspaceFolders2();if(m)return m.find(d=>d.uri.toString()===u.uri.toString())}createQuickPick(I){const S=new o(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(I){const S=new w(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(I,S){this.e.get(I)?._fireDidChangeValue(S)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,S){const u=this.e.get(I);u instanceof o&&u._fireDidChangeActive(S)}$onDidChangeSelection(I,S){const u=this.e.get(I);u instanceof o&&u._fireDidChangeSelection(S)}$onDidTriggerButton(I,S){this.e.get(I)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(I,S,u){const m=this.e.get(I);m instanceof o&&m._fireDidTriggerItemButton(S,u)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class E{static{this.a=1}constructor(I,S){this.x=I,this.y=S,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Nd,this.q=new M.$Nd,this.r=new M.$Nd,this.s=new M.$Nd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((S,u)=>{const m=S===l.$yL.Back?-1:u;this.o.set(m,S)}),this.z({buttons:I.map((S,u)=>({...s(S.iconPath),tooltip:S.tooltip,handle:S===l.$yL.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const S=this.o.get(I);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(I){if(!this.v){for(const S of Object.keys(I)){const u=I[S];this.u[S]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}function v(h){if(h instanceof l.$$K)return{id:h.id};const I=r(h),S=n(h);return{dark:typeof I=="string"?A.URI.file(I):I,light:typeof S=="string"?A.URI.file(S):S}}function n(h){return typeof h=="object"&&"light"in h?h.light:h}function r(h){return typeof h=="object"&&"dark"in h?h.dark:h}function s(h){const I=v(h);let S,u;return"id"in I?u=k.ThemeIcon.asClassName(I):S=I,{iconPath:S,iconClass:u}}class o extends E{constructor(I,S){super(I.identifier,S),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Nd,this.L=[],this.M=new M.$Nd,this.N=new M.$Nd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((m,d)=>{this.C.set(d,m),this.D.set(m,d)});const S=(0,a.$_E)(this.O,"quickPickItemTooltip"),u=[];for(let m=0;m<I.length;m++){const d=I[m];if(d.kind===l.QuickPickItemKind.Separator)u.push({type:"separator",label:d.label});else{d.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=d.iconPath?s(d.iconPath):void 0;u.push({handle:m,label:d.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:d.description,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,tooltip:S?p.MarkdownString.fromStrict(d.tooltip):void 0,buttons:d.buttons?.map((W,K)=>({...s(W.iconPath),tooltip:W.tooltip,handle:K}))})}}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(I){const S=(0,g.$Hb)(I.map(u=>this.C.get(u)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(I){const S=(0,g.$Hb)(I.map(u=>this.C.get(u)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(I,S){const u=this.C.get(I);if(!u||!u.buttons||!u.buttons.length)return;const m=u.buttons[S];m&&this.N.fire({button:m,item:u})}}class w extends E{constructor(I,S){super(I.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:R.default.Error}):this.z({validationMessage:I.message,severity:I.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new b(t,i)}e.$Ncc=$}),define(Ae[250],Re([1,0,2,5,65,6,12,3,18,131,14,21,42,8,25,13]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=e.$Occ=void 0;function i(m){if(m)return typeof m.iconPath=="string"?y.URI.file(m.iconPath):y.URI.isUri(m.iconPath)||a.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function c(m){if(m.icon){if(y.URI.isUri(m.icon))return m.icon;if(a.ThemeIcon.isThemeIcon(m.icon))return m.icon;{const d=m.icon;return{light:d.light,dark:d.dark}}}else return}function b(m,d){if(!m.iconPath&&!d.iconPath)return 0;if(m.iconPath){if(!d.iconPath)return 1}else return-1;const P=typeof m.iconPath=="string"?m.iconPath:y.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,W=typeof d.iconPath=="string"?d.iconPath:y.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,g.$pq)(P,W)}function E(m,d){let P=0;if(m.strikeThrough!==d.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==d.faded)return m.faded?1:-1;if(m.tooltip!==d.tooltip)return(m.tooltip||"").localeCompare(d.tooltip||"");if(P=b(m,d),P!==0)return P;if(m.light&&d.light)P=b(m.light,d.light);else{if(m.light)return 1;if(d.light)return-1}if(P!==0)return P;if(m.dark&&d.dark)P=b(m.dark,d.dark);else{if(m.dark)return 1;if(d.dark)return-1}return P}function v(m,d){if(m.command!==d.command)return m.command<d.command?-1:1;if(m.title!==d.title)return m.title<d.title?-1:1;if(m.tooltip!==d.tooltip){if(m.tooltip!==void 0&&d.tooltip!==void 0)return m.tooltip<d.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(m.arguments===d.arguments)return 0;if(m.arguments)if(d.arguments){if(m.arguments.length!==d.arguments.length)return m.arguments.length-d.arguments.length}else return 1;else return-1;for(let P=0;P<m.arguments.length;P++){const W=m.arguments[P],K=d.arguments[P];if(W!==K)return W<K?-1:1}return 0}function n(m,d){let P=(0,g.$pq)(m.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(P!==0)return P;if(m.command&&d.command)P=v(m.command,d.command);else{if(m.command)return 1;if(d.command)return-1}if(P!==0)return P;if(m.decorations&&d.decorations)P=E(m.decorations,d.decorations);else{if(m.decorations)return 1;if(d.decorations)return-1}return P}function r(m,d){for(let P=0;P<m.length;P++)if(m[P]!==d[P])return!1;return!0}function s(m,d){return m.command===d.command&&m.title===d.title&&m.tooltip===d.tooltip&&(m.arguments&&d.arguments?r(m.arguments,d.arguments):m.arguments===d.arguments)}function o(m,d){return(0,D.$ub)(m,d,s)}function w(m,d){return m===d?!0:!m||!d?!1:m.id===d.id&&m.label===d.label&&m.upstream?.id===d.upstream?.id&&m.upstream?.label===d.upstream?.label}class h{#e;#t;get value(){return this.d}set value(d){d=d??"",this.#e.$setInputBoxValue(this.l,d),this.n(d)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(d){this.#e.$setInputBoxPlaceholder(this.l,d),this.f=d}get validateInput(){return(0,$.$aF)(this.k,"scmValidation"),this.g}set validateInput(d){if((0,$.$aF)(this.k,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=d,this.#e.$setValidationProviderIsEnabled(this.l,!!d)}get enabled(){return this.h}set enabled(d){d=!!d,this.h!==d&&(this.h=d,this.#e.$setInputBoxEnablement(this.l,d))}get visible(){return this.j}set visible(d){d=!!d,this.j!==d&&(this.j=d,this.#e.$setInputBoxVisibility(this.l,d))}get document(){return(0,$.$aF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(d,P,W,K,U){this.k=d,this.l=K,this.m=U,this.d="",this.e=new M.$Nd,this.f="",this.h=!0,this.j=!0,this.#t=P,this.#e=W}showValidationMessage(d,P){(0,$.$aF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,d,P)}$onInputBoxValueChange(d){this.n(d)}n(d){this.d=d,this.e.fire(d)}}e.$Occ=h;class I{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(d){this.v=d,this.q.$updateGroupLabel(this.t,this.handle,d)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(d){this.p=d,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(d){this.f=[...d],this.k.fire()}constructor(d,P,W,K,U){this.q=d,this.s=P,this.t=W,this.u=K,this.v=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Nd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Nd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=I.d++}getResourceState(d){return this.g.get(d)}$executeResourceCommand(d,P){const W=this.h.get(d);return W?(0,A.$Mg)(()=>this.s.executeCommand(W.command,...W.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this.f].sort(n),W=(0,D.$Db)(this.o,d,n).map(B=>{const O=B.toInsert.map(N=>{const te=this.e++;this.g.set(te,N);const Y=N.resourceUri;let Ee;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const V=new T.$Rc;Ee=this.s.converter.toInternal(N.command,V),this.j.set(te,V)}else this.h.set(te,N.command);const Se=i(N.decorations),Pe=N.decorations&&i(N.decorations.light)||Se,ge=N.decorations&&i(N.decorations.dark)||Se,me=[Pe,ge],ce=N.decorations&&N.decorations.tooltip||"",se=N.decorations&&!!N.decorations.strikeThrough,$e=N.decorations&&!!N.decorations.faded,x=N.contextValue||"";return{rawResource:[te,Y,me,ce,se,$e,x,Ee],handle:te}});return{start:B.start,deleteCount:B.deleteCount,toInsert:O}}),K=W.map(({start:B,deleteCount:O,toInsert:N})=>[B,O,N.map(te=>te.rawResource)]),U=W.reverse();for(const{start:B,deleteCount:O,toInsert:N}of U){const te=N.map(Ee=>Ee.handle),Y=this.n.splice(B,O,...te);for(const Ee of Y)this.g.delete(Ee),this.h.delete(Ee),this.j.get(Ee)?.dispose(),this.j.delete(Ee)}return this.o=d,K}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(d){this.g!==d&&(this.g=d,this.#e.$updateSourceControl(this.x,{count:d}))}get quickDiffProvider(){return this.h}set quickDiffProvider(d){this.h=d;let P;(0,$.$_E)(this.y,"quickDiffProvider")&&(P=d?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!d,quickDiffLabel:P})}get historyProvider(){return(0,$.$aF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(d){(0,$.$aF)(this.y,"scmHistoryProvider"),this.j=d,this.k.value=new T.$Rc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!d}),d&&(this.k.value.add(d.onDidChangeCurrentHistoryItemGroup(()=>{w(this.l,d?.currentHistoryItemGroup)||(this.l=d?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(d.onDidChangeActionButton(()=>{(0,$.$aF)(this.y,"scmActionButton"),this.m.value=new T.$Rc;const P=d.actionButton!==void 0?{command:this.z.converter.toInternal(d.actionButton.command,this.m.value),description:d.actionButton.description,enabled:d.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,P??null)})))}get commitTemplate(){return this.n}set commitTemplate(d){d!==this.n&&(this.n=d,this.#e.$updateSourceControl(this.x,{commitTemplate:d}))}get acceptInputCommand(){return this.p}set acceptInputCommand(d){this.o.value=new T.$Rc,this.p=d;const P=this.z.converter.toInternal(d,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:P})}get actionButton(){return(0,$.$aF)(this.y,"scmActionButton"),this.s}set actionButton(d){(0,$.$aF)(this.y,"scmActionButton"),this.q.value=new T.$Rc,this.s=d;const P=d!==void 0?{command:this.z.converter.toInternal(d.command,this.q.value),secondaryCommands:d.secondaryCommands?.map(W=>W.map(K=>this.z.converter.toInternal(K,this.q.value))),description:d.description,enabled:d.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:P??null})}get statusBarCommands(){return this.u}set statusBarCommands(d){if(this.u&&d&&o(this.u,d))return;this.t.value=new T.$Rc,this.u=d;const P=(d||[]).map(W=>this.z.converter.toInternal(W,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:P})}get selected(){return this.v}constructor(d,P,W,K,U,B,O){this.y=d,this.z=K,this.A=U,this.B=B,this.C=O,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new T.$Tc,this.m=new T.$Tc,this.n=void 0,this.o=new T.$Tc,this.p=void 0,this.q=new T.$Tc,this.t=new T.$Tc,this.u=void 0,this.v=!1,this.w=new M.$Nd,this.onDidChangeSelection=this.w.event,this.x=S.d++,this.D=new Map,this.E=new Set,this.#e=W;const N=y.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${U}/scm${this.x}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new h(d,P,this.#e,this.x,N),this.#e.$registerSourceControl(this.x,U,B,O,N)}createResourceGroup(d,P){const W=new I(this.#e,this.z,this.x,d,P),K=M.Event.once(W.onDidDispose)(()=>this.D.delete(W));return this.D.set(W,K),this.eventuallyAddResourceGroups(),W}eventuallyAddResourceGroups(){const d=[],P=[];for(const[W,K]of this.D){K.dispose();const U=W.onDidUpdateResourceStates(()=>{this.E.add(W),this.eventuallyUpdateResourceStates()});M.Event.once(W.onDidDispose)(()=>{this.E.delete(W),U.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.x,W.handle)}),d.push([W.handle,W.id,W.label,W.features]);const B=W._takeResourceStateSnapshot();B.length>0&&P.push([W.handle,B]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.x,d,P),this.D.clear()}eventuallyUpdateResourceStates(){const d=[];this.E.forEach(P=>{const W=P._takeResourceStateSnapshot();W.length!==0&&d.push([P.handle,W])}),d.length>0&&this.#e.$spliceResourceStates(this.x,d),this.E.clear()}getResourceGroup(d){return this.e.get(d)}setSelectionState(d){this.v=d,this.w.fire(d)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(d=>d.dispose()),this.#e.$unregisterSourceControl(this.x)}}qe([(0,C.$hh)(100)],S.prototype,"eventuallyAddResourceGroups",null),qe([(0,C.$hh)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let u=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(d,P,W,K){this.l=P,this.m=W,this.n=K,this.g=new Map,this.h=new k.$6l,this.j=new M.$Nd,this.e=d.getProxy(l.$cK.MainThreadSCM),this.f=d.getProxy(l.$cK.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const B=this.g.get(U.sourceControlHandle);if(!B)return U;const O=B.getResourceGroup(U.groupHandle);return O?O.getResourceState(U.handle):U}else if(U&&U.$mid===4){const B=this.g.get(U.sourceControlHandle);return B?B.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const B=this.g.get(U.handle);return B||U}return U}})}createSourceControl(d,P,W,K){this.n.trace("ExtHostSCM#createSourceControl",d.identifier.value,P,W,K),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const U=t.d++,B=new S(d,this.m,this.e,this.l,P,W,K);this.g.set(U,B);const O=this.h.get(d.identifier)||[];return O.push(B),this.h.set(d.identifier,O),B}getLastInputBox(d){this.n.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const P=this.h.get(d.identifier),W=P&&P[P.length-1];return W&&W.inputBox}$provideOriginalResource(d,P,W){const K=y.URI.revive(P);this.n.trace("ExtHostSCM#$provideOriginalResource",d,K.toString());const U=this.g.get(d);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Mg)(()=>U.quickDiffProvider.provideOriginalResource(K,W)).then(B=>B||null)}$onInputBoxValueChange(d,P){this.n.trace("ExtHostSCM#$onInputBoxValueChange",d);const W=this.g.get(d);return W&&W.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(d,P,W,K){this.n.trace("ExtHostSCM#$executeResourceCommand",d,P,W);const U=this.g.get(d);if(!U)return Promise.resolve(void 0);const B=U.getResourceGroup(P);return B?B.$executeResourceCommand(W,K):Promise.resolve(void 0)}$validateInput(d,P,W){this.n.trace("ExtHostSCM#$validateInput",d);const K=this.g.get(d);return!K||!K.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Mg)(()=>K.inputBox.validateInput(P,W)).then(U=>{if(!U)return Promise.resolve(void 0);const B=p.MarkdownString.fromStrict(U.message);return B?Promise.resolve([B,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this.g.get(d)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=d,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(d,P,W){return await this.g.get(d)?.historyProvider?.resolveHistoryItemGroupBase(P,W)??void 0}async $resolveHistoryItemGroupCommonAncestor(d,P,W,K){return await this.g.get(d)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(P,W,K)??void 0}async $provideHistoryItems(d,P,W,K){return(await this.g.get(d)?.historyProvider?.provideHistoryItems(P,W,K))?.map(O=>({id:O.id,parentIds:O.parentIds,label:O.label,description:O.description,icon:c(O),timestamp:O.timestamp}))??void 0}async $provideHistoryItemChanges(d,P,W){return await this.g.get(d)?.historyProvider?.provideHistoryItemChanges(P,W)??void 0}};e.$Pcc=u,e.$Pcc=u=t=qe([Ke(3,R.$9i)],u)}),define(Ae[83],Re([1,0,3,5,4]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=e.$ucc=void 0;class T{constructor(l){this.b=new M.$Nd,this.onDidChangePassword=this.b.event,this.a=l.getProxy(y.$cK.MainThreadSecretState)}async $onDidChangePassword(l){this.b.fire(l)}get(l,D){return this.a.$getPassword(l,D)}store(l,D,g){return this.a.$setPassword(l,D,g)}delete(l,D){return this.a.$deletePassword(l,D)}}e.$ucc=T,e.$vcc=(0,C.$Oh)("IExtHostSecretState")}),define(Ae[251],Re([1,0,3,8,2]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;class T{static{this.a=0}constructor(l,D){this.d=D,this.c=new Map,this.b=l.getProxy(y.$cK.MainThreadShare)}async $provideShare(l,D,g){return await this.c.get(l)?.provideShare({selection:M.Range.to(D.selection),resourceUri:C.URI.revive(D.resourceUri)},g)??void 0}registerShareProvider(l,D){const g=T.a++;return this.c.set(g,D),this.b.$registerShareProvider(g,M.DocumentSelector.from(l,this.d),D.id,D.label,D.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$Rdc=T}),define(Ae[252],Re([1,0,6,3]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class C{static{this.a=1}constructor(A){this.c=new Map,this.b=A.getProxy(M.$cK.MainThreadSpeech)}async $createSpeechToTextSession(A,l,D){const g=this.c.get(A);if(!g)return;const R=g.provideSpeechToTextSession(D);if(D.isCancellationRequested)return;const k=R.onDidChange(a=>{D.isCancellationRequested||this.b.$emitSpeechToTextEvent(l,a)});D.onCancellationRequested(()=>{k.dispose(),R.dispose()})}registerProvider(A,l,D){const g=C.a++;return this.c.set(g,D),this.b.$registerProvider(g,l,{extension:A,displayName:A.value}),(0,y.$Qc)(()=>{this.b.$unregisterProvider(g),this.c.delete(g)})}}e.$Tdc=C}),define(Ae[253],Re([1,0,7,3,153,6,8,15]),function(be,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=void 0;class D{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$_K("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$_K("statusBarItem.warningForeground")]])}#e;#t;constructor(a,p,$,f,t,i=y.StatusBarAlignment.Left,c){if(this.i=!1,this.k="",this.q=new T.$Rc,this.#e=a,this.#t=p,t&&f){this.c=(0,y.$OK)(f.identifier,t);const b=$.get(this.c);b&&(i=b.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,c=b.priority,this.j=!0,this.name=b.name,this.text=b.text,this.tooltip=b.tooltip,this.command=b.command,this.accessibilityInformation=b.accessibilityInformation)}else this.c=String(D.a++);this.e=f,this.f=t,this.g=i,this.h=this.u(c)}u(a){if((0,l.$Cf)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(a){this.k=a,this.v()}set name(a){this.m=a,this.v()}set tooltip(a){this.l=a,this.v()}set color(a){this.n=a,this.v()}set backgroundColor(a){a&&!D.b.has(a.id)&&(a=void 0),this.o=a,this.v()}set command(a){this.r?.fromApi!==a&&(this.p&&this.q.add(this.p),this.p=new T.$Rc,typeof a=="string"?this.r={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this.p)}:a?this.r={fromApi:a,internal:this.#t.toInternal(a,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(a){this.t=a,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let a;this.e?this.f?a=`${this.e.identifier.value}.${this.f}`:a=this.e.identifier.value:a=this.f;let p;this.m?p=this.m:p=(0,C.localize)(0,null,this.e.displayName||this.e.name);let $=this.n;this.o&&($=D.b.get(this.o.id));const f=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,a,this.e?.identifier.value,p,this.k,f,this.r?.internal,$,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Qcc=D;class g{constructor(a){this.b=[],this.a=a.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(a){const p={message:a};return this.b.unshift(p),this.c(),new y.$eK(()=>{const $=this.b.indexOf(p);$>=0&&(this.b.splice($,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(a,p){this.e=new Map,this.a=a.getProxy(M.$cK.MainThreadStatusBar),this.b=p,this.c=new g(this)}$acceptStaticEntries(a){for(const p of a)this.e.set(p.entryId,p)}createStatusBarEntry(a,p,$,f){return new D(this.a,this.b,this.e,a,p,$,f)}setStatusBarMessage(a,p){const $=this.c.setMessage(a);let f;return typeof p=="number"?f=setTimeout(()=>$.dispose(),p):typeof p<"u"&&p.then(()=>$.dispose(),()=>$.dispose()),new y.$eK(()=>{$.dispose(),clearTimeout(f)})}}e.$Rcc=R}),define(Ae[84],Re([1,0,3,5,4]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=e.$icc=void 0;class T{constructor(l,D){this.c=D,this.b=new M.$Nd,this.onDidChangeStorage=this.b.event,this.a=l.getProxy(y.$cK.MainThreadStorage)}registerExtensionStorageKeysToSync(l,D){this.a.$registerExtensionStorageKeysToSync(l,D)}async initializeExtensionStorage(l,D,g){const R=await this.a.$initializeExtensionStorage(l,D);let k;return R&&(k=this.d(l,D,R)),k||g}setValue(l,D,g){return this.a.$setValue(l,D,g)}$acceptValue(l,D,g){const R=this.d(l,D,g);R&&this.b.fire({shared:l,key:D,value:R})}d(l,D,g){try{return JSON.parse(g)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${l}): ${R}`)}}}e.$icc=T,e.$jcc=(0,C.$Oh)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,62,2]),function(be,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=e.$occ=void 0,e.$occ=(0,y.$Oh)("IExtensionStoragePaths");let l=class{constructor(g,R,k){this.d=R,this.f=k,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(a=>this.c=a)}async g(g){return A.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,R=await this.g(g);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(g){if(this.c)return A.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return A.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$pcc=l,e.$pcc=l=qe([Ke(0,M.$tM),Ke(1,C.$9i),Ke(2,T.$ncc)],l)}),define(Ae[63],Re([1,0,5,3,4,2,17,6,7,155,9,181,20,36,182,42,12,8,31]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=e.$scc=e.$rcc=e.$qcc=void 0,e.$qcc=(0,C.$Oh)("IExtHostTerminalService");class b{constructor(u,m,d,P){this.l=u,this._id=m,this.m=d,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(K=>this.f=K);const W=this;this.value={get name(){return W.n||""},get processId(){return W.b},get creationOptions(){return W.m},get exitStatus(){return W.h},get state(){return W.j},get selection(){return W.k},sendText(K,U=!0){W.q(),W.l.$sendText(W._id,K,U)},show(K){W.q(),W.l.$show(W._id,K)},hide(){W.q(),W.l.$hide(W._id)},dispose(){W.a||(W.a=!0,W.l.$dispose(W._id))},get dimensions(){if(!(W.d===void 0||W.g===void 0))return{columns:W.d,rows:W.g}}}}async create(u,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:u.name,shellPath:u.shellPath??void 0,shellArgs:u.shellArgs??void 0,cwd:u.cwd??void 0,env:u.env??void 0,icon:w(u.iconPath)??void 0,color:f.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:u.message??void 0,strictEnv:u.strictEnv??void 0,hideFromUser:u.hideFromUser??void 0,isFeatureTerminal:m?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:m?.useShellEnvironment??void 0,location:m?.location||this.o(u.location,m?.resolvedExtHostIdentifier),isTransient:u.isTransient??void 0})}async createExtensionTerminal(u,m,d,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:d,color:f.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o(u,m),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(u,m){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in u?{viewColumn:i.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.n=u}setExitStatus(u,m){this.h=Object.freeze({code:u,reason:m})}setDimensions(u,m){return u===this.d&&m===this.g||u===0||m===0?!1:(this.d=u,this.g=m,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(u){this.k=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(m=>{m!==u&&(this.b=Promise.resolve(u))})}}e.$rcc=b;class E{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new y.$Nd,this.onProcessData=this.a.event,this.b=new y.$Nd,this.d=new y.$Nd,this.onDidChangeProperty=this.d.event,this.f=new y.$Nd,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,m){this.g.setDimensions?.({columns:u,rows:m})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let v=1,n=class extends l.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}constructor(u,m,d){super(),this.Q=m,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new l.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$Nd,this.onDidCloseTerminal=this.H.event,this.I=new y.$Nd,this.onDidOpenTerminal=this.I.event,this.J=new y.$Nd,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$Nd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$Nd,this.onDidChangeTerminalState=this.M.event,this.N=new y.$Nd,this.onDidChangeShell=this.N.event,this.O=new y.$Nd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$Nd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=d.getProxy(M.$cK.MainThreadTerminalService),this.y=new $.$Pkb(this.a.$sendProcessData),this.a.$registerProcessSupport(u),this.Q.registerArgumentProcessor({processArgument:P=>{const W=K=>{const U=K;return this.W(U.instanceId)?.value};switch(P?.$mid){case 15:return W(P);default:{if(Array.isArray(P))for(let K=0;K<P.length&&P[K].$mid===15;K++)P[K]=W(P[K]);return P}}}}),this.B({dispose:()=>{for(const[P,W]of this.g)W.shutdown(!0)}})}getDefaultShell(u){return(u?this.u:this.s)?.path||""}getDefaultShellArgs(u){return(u?this.u:this.s)?.args||[]}createExtensionTerminal(u,m){const d=new b(this.a,(0,p.$eg)(),u,u.name),P=new E(u.pty);return d.createExtensionTerminal(u.location,this.R(u,m).resolvedExtHostIdentifier,w(u.iconPath),h(u.color)).then(W=>{const K=this.S(W,P);this.h[W]=K}),this.f.push(d),d.value}R(u,m){if(m=m||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const d=u.location.parentTerminal;if(d){const P=this.f.find(W=>W.value===d);P&&(m.resolvedExtHostIdentifier=P._id)}}else u.location&&typeof u.location!="object"?m.location=u.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(u,m){if(!this.W(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const P=new E(m),W=this.S(u,P);this.h[u]=W}async $acceptActiveTerminalChanged(u){const m=this.b;if(u===null){this.b=void 0,m!==this.b&&this.J.fire(this.b);return}const d=this.W(u);d&&(this.b=d,m!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(u,m){const d=this.W(u);d&&this.O.fire({terminal:d.value,data:m})}async $acceptTerminalDimensions(u,m,d){const P=this.W(u);P&&P.setDimensions(m,d)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(u,m){const d=this.W(u);d&&this.P.fire({terminal:d.value,...m})}async $acceptTerminalMaximumDimensions(u,m,d){this.g.get(u)?.resize(m,d)}async $acceptTerminalTitleChange(u,m){const d=this.W(u);d&&(d.name=m)}async $acceptTerminalClosed(u,m,d){const P=this.Y(this.f,u);if(P!==null){const W=this.f.splice(P,1)[0];W.setExitStatus(m,d),this.H.fire(W.value)}}$acceptTerminalOpened(u,m,d,P){if(m){const U=this.Y(this.f,m);if(U!==null){this.f[U]._id=u,this.I.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const W={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:T.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},K=new b(this.a,u,W,d);this.f.push(K),this.I.fire(K.value),K.isOpen=!0}async $acceptTerminalProcessId(u,m){this.W(u)?._setProcessId(m)}async $startExtensionTerminal(u,m){const d=this.W(u);if(!d)return{message:(0,g.localize)(0,null,u)};d.isOpen||await new Promise(W=>{const K=this.onDidOpenTerminal(async U=>{U===d.value&&(K.dispose(),W())})});const P=this.g.get(u);P?P.startSendingEvents(m):this.j[u]={initialDimensions:m}}S(u,m){const d=new l.$Rc;d.add(m.onProcessReady(W=>this.a.$sendProcessReady(u,W.pid,W.cwd,W.windowsPty))),d.add(m.onDidChangeProperty(W=>this.a.$sendProcessProperty(u,W))),this.y.startBuffering(u,m.onProcessData),d.add(m.onProcessExit(W=>this.U(u,W))),this.g.set(u,m);const P=this.j[u];return P&&m instanceof E&&(m.startSendingEvents(P.initialDimensions),delete this.j[u]),d}$acceptProcessAckDataEvent(u,m){this.g.get(u)?.acknowledgeDataEvent(m)}$acceptProcessInput(u,m){this.g.get(u)?.input(m)}$acceptTerminalInteraction(u){const m=this.W(u);m?.setInteractedWith()&&this.M.fire(m.value)}$acceptTerminalSelection(u,m){this.W(u)?.setSelection(m)}$acceptProcessResize(u,m,d){try{this.g.get(u)?.resize(m,d)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(u,m){this.g.get(u)?.shutdown(m)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(m=>this.a.$sendProcessProperty(u,{type:"cwd",value:m}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.z.add(u),this.z.size===1&&this.a.$startLinkProvider(),new D.$eK(()=>{this.z.delete(u),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,m,d){if(this.C.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.C.set(m,d),this.a.$registerProfileProvider(m,u.identifier.value),new D.$eK(()=>{this.C.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(u,m,d){if(this.D.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.D.set(u,d),this.a.$registerQuickFixProvider(u,m),new D.$eK(()=>{this.D.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,m){const d=new a.$Xd().token;if(d.isCancellationRequested)return;const P=this.D.get(u);if(!P)return;const W=await P.provideTerminalQuickFixes(m,d);if(W===null||Array.isArray(W)&&W.length===0)return;const K=new l.$Rc;if(this.w.value=K,!Array.isArray(W))return W?i.TerminalQuickFix.from(W,this.Q.converter,K):void 0;const U=[];for(const B of W){const O=i.TerminalQuickFix.from(B,this.Q.converter,K);O&&U.push(O)}return U}async $createContributedProfileTerminal(u,m){const d=new a.$Xd().token;let P=await this.C.get(u)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,m);return}this.createTerminalFromOptions(P.options,m)}}async $provideLinks(u,m){const d=this.W(u);if(!d)return[];this.F.delete(u),this.G.get(u)?.dispose(!0);const W=new a.$Xd;this.G.set(u,W);const K=[],U={terminal:d.value,line:m},B=[];for(const te of this.z)B.push(t.Promises.withAsyncBody(async Y=>{W.token.onCancellationRequested(()=>Y({provider:te,links:[]}));const Ee=await te.provideTerminalLinks(U,W.token)||[];W.token.isCancellationRequested||Y({provider:te,links:Ee})}));const O=await Promise.all(B);if(W.token.isCancellationRequested)return[];const N=new Map;for(const te of O)te&&te.links.length>0&&K.push(...te.links.map(Y=>{const Ee={id:v++,startIndex:Y.startIndex,length:Y.length,label:Y.tooltip};return N.set(Ee.id,{provider:te.provider,link:Y}),Ee}));return this.F.set(u,N),K}$activateLink(u,m){const d=this.F.get(u)?.get(m);d&&d.provider.handleTerminalLink(d.link)}U(u,m){this.y.stopBuffering(u),this.g.delete(u),delete this.j[u];const d=this.h[u];d&&(d.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,m)}W(u){return this.X(this.f,u)}X(u,m){const d=this.Y(u,m);return d!==null?u[d]:null}Y(u,m){const d=u.findIndex(P=>P._id===m);return d===-1?null:d}getEnvironmentVariableCollection(u){let m=this.n.get(u.identifier.value);return m||(m=new r,this.$(u.identifier.value,m)),m.getScopedEnvironmentVariableCollection(void 0)}Z(u,m){const d=(0,k.$ir)(m.map),P=(0,k.$jr)(m.descriptionMap);this.a.$setEnvironmentVariableCollection(u,m.persistent,d.length===0?void 0:d,P)}$initEnvironmentVariableCollections(u){u.forEach(m=>{const d=m[0],P=new r(m[1]);this.$(d,P)})}$acceptDefaultProfile(u,m){const d=this.s;this.s=u,this.u=m,d?.path!==u.path&&this.N.fire(u.path)}$(u,m){this.n.set(u,m),m.onDidChangeCollection(()=>{this.Z(u,m)})}};e.$scc=n,e.$scc=n=qe([Ke(1,c.$zM),Ke(2,A.$dM)],n);class r{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$Nd,this.map=new Map(u)}getScopedEnvironmentVariableCollection(u){const m=this.h(u);let d=this.a.get(m);return d||(d=new s(this,u),this.a.set(m,d),d.onDidChangeCollection(()=>this.d.fire())),d}replace(u,m,d,P){this.f(u,{value:m,type:D.EnvironmentVariableMutatorType.Replace,options:d??{applyAtProcessCreation:!0},scope:P})}append(u,m,d,P){this.f(u,{value:m,type:D.EnvironmentVariableMutatorType.Append,options:d??{applyAtProcessCreation:!0},scope:P})}prepend(u,m,d,P){this.f(u,{value:m,type:D.EnvironmentVariableMutatorType.Prepend,options:d??{applyAtProcessCreation:!0},scope:P})}f(u,m){if(m.options&&m.options.applyAtProcessCreation===!1&&!m.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const d=this.g(u,m.scope),P=this.map.get(d),W=m.options?{applyAtProcessCreation:m.options.applyAtProcessCreation??!1,applyAtShellIntegration:m.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==m.value||P.type!==m.type||P.options?.applyAtProcessCreation!==W.applyAtProcessCreation||P.options?.applyAtShellIntegration!==W.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const K=this.g(u,m.scope),U={variable:u,...m,options:W};this.map.set(K,U),this.d.fire()}}get(u,m){const d=this.g(u,m),P=this.map.get(d);return P?I(P):void 0}g(u,m){const d=this.h(m);return d.length?`${u}:::${d}`:u}h(u){return this.j(u?.workspaceFolder)??""}j(u){return u?u.uri.toString():void 0}getVariableMap(u){const m=new Map;for(const[d,P]of this.map)this.h(P.scope)===this.h(u)&&m.set(P.variable,I(P));return m}delete(u,m){const d=this.g(u,m);this.map.delete(d),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[m,d]of this.map)d.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(m);this.k(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,m){const d=this.h(m),P=this.descriptionMap.get(d);if(!P||P.description!==u){let W;typeof u=="string"?W=u:W=u?.value.split(`

`)[0];const K={description:W,scope:m};this.descriptionMap.set(d,K),this.d.fire()}}getDescription(u){const m=this.h(u);return this.descriptionMap.get(m)?.description}k(u){const m=this.h(u);this.descriptionMap.delete(m)}}class s{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,m){this.b=u,this.d=m,this.a=new y.$Nd}getScoped(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,m,d){this.b.replace(u,m,d,this.d)}append(u,m,d){this.b.append(u,m,d,this.d)}prepend(u,m,d){this.b.prepend(u,m,d,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,m){this.b.getVariableMap(this.d).forEach((d,P)=>u.call(m,P,d,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends n{constructor(u,m){super(!1,u,m)}createTerminal(u,m,d){throw new R.$_}createTerminalFromOptions(u,m){throw new R.$_}};e.$tcc=o,e.$tcc=o=qe([Ke(0,c.$zM),Ke(1,A.$dM)],o);function w(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function h(S){return f.ThemeColor.isThemeColor(S)?S:void 0}function I(S){const u={...S};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(Ae[254],Re([1,0,283,12,26,20,5,202,93,6,24,15,36,3,17,104,8,7,46,76,57,25]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f,t,i,c,b,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=e.$Cdc=e.$Bdc=e.$Adc=void 0;let n=class{constructor(U,B,O){this.k=O,this.d=new A.$Nd,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=U.getProxy(p.$cK.MainThreadTesting),this.j=new d(this.g),this.h=new w(this.g),B.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const te=N,Y=te.tests[te.tests.length-1].item.extId;return this.f.get(c.$8I.root(Y))?.collection.tree.get(Y)?.actual??(0,f.$pM)(N)}case 18:{const{extId:te,message:Y}=N;return{test:this.f.get(c.$8I.root(te))?.collection.tree.get(te)?.actual,message:t.TestMessage.to(Y)}}default:return N}}}),B.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await B.executeCommand("_testing.getExplorerSelection"),te=Y=>{const Ee=this.f.get(c.$8I.root(Y));if(Ee)return c.$8I.isRoot(Y)?Ee.controller:Ee.collection.tree.get(Y)?.actual};return{include:N?.include.map(te).filter(k.$Gf)||[],exclude:N?.exclude.map(te).filter(k.$Gf)||[]}})}createTestController(U,B,O,N){if(this.f.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const te=new g.$Rc,Y=te.add(new f.$sM(B,O,this.k));Y.root.label=O;const Ee=new Map,Se=this.g,Pe={items:Y.root.children,get label(){return O},set label(me){O=me,Y.root.label=me,Se.$updateController(B,{label:O})},get refreshHandler(){return N},set refreshHandler(me){N=me,Se.$updateController(B,{canRefresh:!!me})},get id(){return B},createRunProfile:(me,ce,se,$e,x,z)=>{let V=(0,D.$Ci)(me);for(;Ee.has(V);)V++;return new P(this.g,Ee,B,V,me,ce,se,$e,x,z)},createTestItem(me,ce,se){return new f.$qM(B,me,ce,se)},createTestRun:(me,ce,se=!0)=>this.h.createTestRun(U,B,Y,me,ce,se),invalidateTestResults:me=>{if(me===void 0)this.g.$markTestRetired(void 0);else{const ce=me instanceof Array?me:[me];this.g.$markTestRetired(ce.map(se=>c.$8I.fromExtHostTestItem(se,B).toString()))}},set resolveHandler(me){Y.resolveHandler=me},get resolveHandler(){return Y.resolveHandler},dispose:()=>{te.dispose()}};Se.$registerTestController(B,O,!!N),te.add((0,g.$Qc)(()=>Se.$unregisterTestController(B)));const ge={controller:Pe,collection:Y,profiles:Ee,extension:U};return this.f.set(B,ge),te.add((0,g.$Qc)(()=>this.f.delete(B))),te.add(Y.onDidGenerateDiff(me=>Se.$publishDiff(B,me.map(E.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.j.checkout()}async runTests(U,B=T.CancellationToken.None){const O=h(U);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.f.get(O.controllerId);if(!N)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(te=>c.$8I.fromExtHostTestItem(te,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:W[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:U.exclude?.map(te=>te.id)},B)}$syncTests(){for(const{collection:U}of this.f.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,B,O){return(0,y.$rb)(this.h.trackers,te=>te.id===U?te.getCoverage(B):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(U,B,O,N){return(0,y.$rb)(this.h.trackers,Y=>Y.id===U?Y.getCoverage(B):void 0)?.resolveFileCoverage(O,N)??Promise.resolve([])}$configureRunProfile(U,B){this.f.get(U)?.profiles.get(B)?.configureHandler?.()}async $refreshTests(U,B){await this.f.get(U)?.controller.refreshHandler?.(B)}$publishTestResults(U){this.results=Object.freeze(U.map(B=>(0,R.$5m)(t.TestResults.to(B))).concat(this.results).sort((B,O)=>O.completedAt-B.completedAt).slice(0,32)),this.d.fire()}async $expandTest(U,B){const O=this.f.get(c.$8I.fromString(U).controllerId)?.collection;O&&(await O.expand(U,B<0?1/0:B),O.flushDiff())}$acceptDiff(U){this.j.applyDiff(U.map(E.TestsDiffOp.deserialize))}async $runControllerTests(U,B){return Promise.all(U.map(O=>this.l(O,!1,B)))}async $startContinuousRun(U,B){const O=new T.$Xd(B),N=await Promise.all(U.map(te=>this.l(te,!0,O.token)));return!B.isCancellationRequested&&!N.some(te=>te.error)&&await new Promise(te=>B.onCancellationRequested(te)),O.dispose(!0),N}async l(U,B,O){const N=this.f.get(U.controllerId);if(!N)return{};const{collection:te,profiles:Y,extension:Ee}=N,Se=Y.get(U.profileId);if(!Se)return{};const Pe=U.testIds.map(se=>te.tree.get(se)).filter(k.$Gf),ge=U.excludeExtIds.map(se=>N.collection.tree.get(se)).filter(k.$Gf).filter(se=>Pe.some($e=>$e.fullId.compare(se.fullId)===2));if(!Pe.length)return{};const me=new i.$ML(Pe.some(se=>se.actual instanceof f.$rM)?void 0:Pe.map(se=>se.actual),ge.map(se=>se.actual),Se,B),ce=(0,E.$0I)(U)&&this.h.prepareForMainThreadTestRun(me,I.fromInternal(U,N.collection),Ee,O);try{return await Se.runHandler(me,O),{}}catch(se){return{error:String(se)}}finally{ce&&(ce.hasRunningTasks&&!O.isCancellationRequested&&await A.Event.toPromise(ce.onEnd),ce.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.h.cancelAllRuns():this.h.cancelRunById(U)}};e.$Adc=n,e.$Adc=n=qe([Ke(0,$.$dM)],n);const r=1e4;var s;(function(K){K[K.Running=0]="Running",K[K.Cancelling=1]="Cancelling",K[K.Ended=2]="Ended"})(s||(s={}));class o extends g.$Sc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(U,B,O,N){super(),this.s=U,this.u=B,this.w=O,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$Nd),this.onEnd=this.m.event,this.j=this.B(new T.$Xd(N));const te=this.B(new M.$6g(()=>this.y(),r));this.B(this.j.token.onCancellationRequested(()=>te.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(U){return this.g.get(U)?.coverage}createRun(U){const B=this.s.id,O=this.s.controllerId,N=(0,a.$eg)(),te=new S(this.u,B,N),Y=ge=>(me,...ce)=>{if(Se){console.warn(`Setting the state of test "${me.id}" is a no-op after the run ends.`);return}this.s.isIncluded(me)&&(this.C(me),ge(me,...ce))},Ee=(ge,me)=>{const ce=me instanceof Array?me.map(t.TestMessage.from):[t.TestMessage.from(me)];if(ce.some(se=>se.contextValue!==void 0)&&(0,v.$aF)(this.w,"testMessageContextValue"),ge.uri&&ge.range){const se={range:t.Range.from(ge.range),uri:ge.uri};for(const $e of ce)$e.location=$e.location||se}this.u.$appendTestMessagesInRun(B,N,c.$8I.fromExtHostTestItem(ge,O).toString(),ce)};let Se=!1;const Pe={isPersisted:this.s.isPersisted,token:this.j.token,name:U,get coverageProvider(){return te.coverageProvider},set coverageProvider(ge){te.coverageProvider=ge},enqueued:Y(ge=>{this.u.$updateTestStateInRun(B,N,c.$8I.fromExtHostTestItem(ge,O).toString(),1)}),skipped:Y(ge=>{this.u.$updateTestStateInRun(B,N,c.$8I.fromExtHostTestItem(ge,O).toString(),5)}),started:Y(ge=>{this.u.$updateTestStateInRun(B,N,c.$8I.fromExtHostTestItem(ge,O).toString(),2)}),errored:Y((ge,me,ce)=>{Ee(ge,me),this.u.$updateTestStateInRun(B,N,c.$8I.fromExtHostTestItem(ge,O).toString(),6,ce)}),failed:Y((ge,me,ce)=>{Ee(ge,me),this.u.$updateTestStateInRun(B,N,c.$8I.fromExtHostTestItem(ge,O).toString(),4,ce)}),passed:Y((ge,me)=>{this.u.$updateTestStateInRun(B,N,c.$8I.fromExtHostTestItem(ge,this.s.controllerId).toString(),3,me)}),appendOutput:(ge,me,ce)=>{Se||(ce&&(this.s.isIncluded(ce)?this.C(ce):ce=void 0),this.u.$appendOutputToRun(B,N,C.$be.fromString(ge),me&&t.location.from(me),ce&&c.$8I.fromExtHostTestItem(ce,O).toString()))},end:()=>{Se||(Se=!0,this.u.$finishedTestRunTask(B,N),this.g.delete(N),this.g.size||this.z())}};return this.g.set(N,{run:Pe,coverage:te}),this.u.$startedTestRunTask(B,{id:N,name:U,running:!0}),Pe}y(){for(const{run:U}of this.g.values())U.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(U){if(!(U instanceof f.$qM))throw new b.$8L(U.id);if(this.h.has(c.$8I.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const B=[],O=this.s.colllection.root;for(;;){const N=t.TestItem.from(U);if(B.unshift(N),this.h.has(N.extId)||(this.h.add(N.extId),U===O))break;U=U.parent||O}this.u.$addTestsToRun(this.s.controllerId,this.s.id,B)}dispose(){this.z(),super.dispose()}}class w{get trackers(){return this.d.values()}constructor(U){this.f=U,this.d=new Map}prepareForMainThreadTestRun(U,B,O,N){return this.g(U,B,O,N)}cancelRunById(U){for(const B of this.d.values())if(B.id===U){B.cancel();return}}cancelAllRuns(){for(const U of this.d.values())U.cancel()}createTestRun(U,B,O,N,te,Y){const Ee=this.d.get(N);if(Ee)return Ee.createRun(te);const Se=I.fromPublic(B,O,N,Y),Pe=h(N);this.f.$startedExtensionTestRun({controllerId:B,continuous:!!N.continuous,profile:Pe&&{group:W[Pe.kind],id:Pe.profileId},exclude:N.exclude?.map(me=>c.$8I.fromExtHostTestItem(me,O.root.id).toString())??[],id:Se.id,include:N.include?.map(me=>c.$8I.fromExtHostTestItem(me,O.root.id).toString())??[O.root.id],persist:Y});const ge=this.g(N,Se,U);return A.Event.once(ge.onEnd)(()=>{this.f.$finishedExtensionTestRun(Se.id),ge.dispose()}),ge.createRun(te)}g(U,B,O,N){const te=new o(B,this.f,O,N);return this.d.set(U,te),A.Event.once(te.onEnd)(()=>this.d.delete(U)),te}}e.$Bdc=w;const h=K=>{if(K.profile){if(!(K.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return K.profile}};class I{static fromPublic(U,B,O,N){return new I(U,(0,a.$eg)(),O.include?.map(te=>c.$8I.fromExtHostTestItem(te,U).toString())??[U],O.exclude?.map(te=>c.$8I.fromExtHostTestItem(te,U).toString())??[],N,B)}static fromInternal(U,B){return new I(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,B)}constructor(U,B,O,N,te,Y){this.controllerId=U,this.id=B,this.isPersisted=te,this.colllection=Y,this.d=O.map(Ee=>Ee+"\0"),this.f=N.map(Ee=>Ee+"\0")}isIncluded(U){const B=c.$8I.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const O of this.f)if(B===O||B.startsWith(O))return!1;for(const O of this.d)if(B===O||B.startsWith(O))return!0;return!1}}e.$Cdc=I;class S{set coverageProvider(U){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this.d=U,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(U,B,O){this.g=U,this.h=B,this.j=O}async provideFileCoverage(U){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(U))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(B){throw this.f=void 0,B}}async resolveFileCoverage(U,B){const O=await this.f;let N=O?.[U];return!this.d||!O||!N?[]:(N.detailedCoverage||(N=O[U]=await this.d.resolveFileCoverage?.(N,B)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class u{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.d.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.d.has(U)||this.f.add(U)}remove(U){if(this.d.has(U)){this.d.delete(U);return}this.f.delete(U);const B=c.$8I.parentId(U.item.extId);if(B&&this.h.has(B.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{d:U,f:B,g:O}=this;return{get added(){return[...U].map(N=>N.revived)},get updated(){return[...B].map(N=>N.revived)},get removed(){return[...O].map(N=>N.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class m extends E.$cJ{constructor(){super(...arguments),this.s=new A.$Nd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}q(U,B){return{...U,revived:t.TestItem.toPlain(U.item),depth:B?B.depth+1:0,children:new Set}}p(){return new u(this.s)}}class d{constructor(U){this.f=U}checkout(){this.d||(this.d=this.g());const U=this.d;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(B=>B.revived)},dispose:(0,l.$db)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(U){return this.d?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.d?.tests.apply(U)}g(){const U=new m;return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}class P{#e;#t;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(U){U!==this.h&&(this.h=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.g}set isDefault(U){U!==this.g&&(this.g=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.d}set configureHandler(U){U!==this.d&&(this.d=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,B,O,N,te,Y,Ee,Se=!1,Pe=void 0,ge=!1){this.controllerId=O,this.profileId=N,this.f=te,this.kind=Y,this.runHandler=Ee,this.g=Se,this._tag=Pe,this.h=ge,this.#e=U,this.#t=B,B.set(N,this);const me=W[Y];if(typeof me!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);this.#e.$publishTestRunProfile({profileId:N,controllerId:O,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:te,group:me,isDefault:Se,hasConfigurationHandler:!1,supportsContinuousRun:ge})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Ddc=P;const W={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[255],Re([1,0,18,9,5,3,105,8,7]),function(be,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;class g{constructor(k,a){this.i=a,this.a=new C.$Nd({onListenerError:M.$2}),this.b=new C.$Nd({onListenerError:M.$2}),this.c=new C.$Nd({onListenerError:M.$2}),this.d=new C.$Nd({onListenerError:M.$2}),this.f=new C.$Nd({onListenerError:M.$2}),this.g=new C.$Nd({onListenerError:M.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(T.$cK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const a=this.i.allEditors();return k?a:a.map(p=>p.value)}async showTextDocument(k,a,p){let $;typeof a=="number"?$={position:l.ViewColumn.from(a),preserveFocus:p}:typeof a=="object"?$={position:l.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?l.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:$={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(k.uri,$),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,a){return new A.$kM(this.h,k,a).value}$acceptEditorPropertiesChanged(k,a){const p=this.i.getEditor(k);if(!p)throw new Error("unknown text editor");if(a.options&&p._acceptOptions(a.options),a.selections){const $=a.selections.selections.map(l.Selection.to);p._acceptSelections($)}if(a.visibleRanges){const $=y.$Hb(a.visibleRanges.map(l.Range.to));p._acceptVisibleRanges($)}if(a.options&&this.b.fire({textEditor:p.value,options:{...a.options,lineNumbers:l.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const $=D.TextEditorSelectionChangeKind.fromValue(a.selections.source),f=a.selections.selections.map(l.Selection.to);this.a.fire({textEditor:p.value,selections:f,kind:$})}if(a.visibleRanges){const $=y.$Hb(a.visibleRanges.map(l.Range.to));this.c.fire({textEditor:p.value,visibleRanges:$})}}$acceptEditorPositionData(k){for(const a in k){const p=this.i.getEditor(a);if(!p)throw new Error("Unknown text editor");const $=l.ViewColumn.to(k[a]);p.value.viewColumn!==$&&(p._acceptViewColumn($),this.d.fire({textEditor:p.value,viewColumn:$}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.$Scc=g}),define(Ae[256],Re([1,0,2,4,3,6,7,8,21,15]),function(be,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=e.$udc=void 0,e.$udc=(0,M.$Oh)("IExtHostTimeline");class R{constructor(p,$){this.b=new Map,this.c=new Map,this.a=p.getProxy(C.$cK.MainThreadTimeline),$.registerArgumentProcessor({processArgument:(f,t)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&D.$4l.equals(t,this.b.get(f.source)?.extension)){const i=f.uri===void 0?void 0:y.URI.revive(f.uri);return this.c.get(f.source)?.get(k(i))?.get(f.handle)}else return;return f}})}async $getTimeline(p,$,f,t){return this.b.get(p)?.provider.provideTimeline(y.URI.revive($),f,t)}registerTimelineProvider(p,$,f,t){const i=new T.$Rc,c=this.d($.id,t,i).bind(this);let b;$.onDidChange&&(b=$.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:$.id}),this));const E=this.c;return this.f({...$,scheme:p,onDidChange:void 0,async provideTimeline(v,n,r){n?.resetCache&&(i.clear(),E.get($.id)?.clear());const s=await $.provideTimeline(v,n,r);if(s==null)return;const o=c(v,n);return{...s,source:$.id,items:s.items.map(o)}},dispose(){for(const v of E.values())v.get($.id)?.clear();b?.dispose(),i.dispose()}},f)}d(p,$,f){return(t,i)=>{let c;if(i?.cacheResults){let b=this.c.get(p);b===void 0&&(b=new Map,this.c.set(p,b));const E=k(t);c=b.get(E),c===void 0&&(c=new Map,b.set(E,c))}return b=>{const{iconPath:E,...v}=b,n=`${p}|${b.id??b.timestamp}`;c?.set(n,b);let r,s,o;b.iconPath&&(E instanceof A.$$K?o={id:E.id,color:E.color}:y.URI.isUri(E)?(r=E,s=E):{light:r,dark:s}=E);let w;return A.$EK.isMarkdownString(v.tooltip)?w=l.MarkdownString.from(v.tooltip):(0,g.$yf)(v.tooltip)?w=v.tooltip:A.$EK.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=l.MarkdownString.from(v.detail)):(0,g.$yf)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=v.detail),{...v,id:v.id??void 0,handle:n,source:p,command:b.command?$.toInternal(b.command,f):void 0,icon:r,iconDark:s,themeIcon:o,tooltip:w,accessibilityInformation:b.accessibilityInformation}}}}f(p,$){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:$}),(0,T.$Qc)(()=>{for(const t of this.c.values())t.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$vdc=R;function k(a){return a?.toString()}}),define(Ae[86],Re([1,0,20,5,6,157,4,14,184,3,27,17,7]),function(be,e,y,M,C,T,A,l,D,g,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3vb=e.$2vb=e.TunnelDtoConverter=void 0;class p extends D.$cv{}var $;(function(t){function i(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:b.protocol}}t.fromApiTunnel=i;function c(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==D.TunnelPrivacyId.ConstantPrivate&&b.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}t.fromServiceTunnel=c})($||(e.TunnelDtoConverter=$={})),e.$2vb=(0,A.$Oh)("IExtHostTunnelService");let f=class extends C.$Sc{constructor(i,c,b){super(),this.s=b,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Nd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(g.$cK.MainThreadTunnelService)}async openTunnel(i,c){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const b=await this.a.$openTunnel(c,i.displayName);if(b){const E=new p(b.remoteAddress,b.localAddress,()=>this.a.$closeTunnel(b.remoteAddress));return this.B(E),E}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,c){const b=this.u();return this.r.set(b,{selector:i,provider:c}),this.a.$registerPortsAttributesProvider(i,b),new a.$eK(()=>{this.r.delete(b),this.a.$unregisterPortsAttributesProvider(b)})}async $providePortAttributes(i,c,b,E,v){const n=[];for(const s of i){const o=this.r.get(s);if(!o)return[];n.push(...await Promise.all(c.map(async w=>{let h;try{h=await o.provider.providePortAttributes({port:w,pid:b,commandLine:E},v)}catch{h=await o.provider.providePortAttributes(w,b,E,v)}return{providedAttributes:h,port:w}})))}const r=n.filter(s=>!!s.providedAttributes);return r.length>0?r.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(E,v)=>await i.provideTunnel(E,v,new y.$Xd().token)??void 0;const b=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(b),Promise.resolve((0,C.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,c){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const b=i.tunnelFactory??(c?this.w(c):void 0);if(b){this.b=b;let E=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&E.length===0&&(E=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const v=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:E}:void 0;this.a.$setTunnelProvider(v)}}else this.b=void 0;return(0,C.$Qc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,c){if(this.g.has(i.host)){const b=this.g.get(i.host);b.has(i.port)&&(c&&b.get(i.port).disposeListener.dispose(),await b.get(i.port).tunnel.dispose(),b.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,c){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const b=this.b(i,c);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),b!==void 0){const E=await b;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),E===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const v=this.B(E.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(E.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:E,disposeListener:v}),$.fromApiTunnel(E)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(b){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),b instanceof Error)return b.message}}async $applyCandidateFilter(i){const c=await Promise.all(i.map(E=>this.f(E.host,E.port,E.detail??""))),b=i.filter((E,v)=>c[v]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(E=>E.port).join(", ")} to ${b.map(E=>E.port).join(", ")}`),b}};e.$3vb=f,e.$3vb=f=qe([Ke(0,k.$dM),Ke(1,R.$tM),Ke(2,l.$9i)],f)}),define(Ae[257],Re([1,0,6,13,2,3]),function(be,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;class A{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(D){this.c=new Map,this.b=D.getProxy(T.$cK.MainThreadUriOpeners)}registerExternalUriOpener(D,g,R,k){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const a=k.schemes.find(p=>!A.a.has(p));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this.c.set(g,R),this.b.$registerUriOpener(g,k.schemes,D,k.label),(0,y.$Qc)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(D,g,R){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener with id: ${D}`);const a=C.URI.revive(g);return k.canOpenExternalUri(a,R)}async $openUri(D,g,R){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener id: '${D}'`);return k.openExternalUri(C.URI.revive(g.resolvedUri),{sourceUri:C.URI.revive(g.sourceUri)},R)}}e.$Edc=A}),define(Ae[258],Re([1,0,3,2,6,9,21]),function(be,e,y,M,C,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;class l{static{this.a=0}constructor(g){this.c=new A.$5l,this.d=new Map,this.b=g.getProxy(y.$cK.MainThreadUrls)}registerUriHandler(g,R){const k=g.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const a=l.a++;return this.c.add(k),this.d.set(a,R),this.b.$registerUriHandler(a,k,g.displayName||g.name),(0,C.$Qc)(()=>{this.c.delete(k),this.d.delete(a),this.b.$unregisterUriHandler(a)})}$handleExternalUri(g,R){const k=this.d.get(g);if(!k)return Promise.resolve(void 0);try{k.handleUri(M.URI.revive(R))}catch(a){(0,T.$1)(a)}return Promise.resolve(void 0)}async createAppUri(g){return M.URI.revive(await this.b.$createAppUri(g))}}e.$Ucc=l}),define(Ae[64],Re([1,0,5,6,13,24,2,169,191,77,3]),function(be,e,y,M,C,T,A,l,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=e.$Ycc=e.$Xcc=e.$Wcc=e.$Vcc=void 0;class k{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#h;constructor(E,v,n,r,s,o,w){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new y.$Nd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#d=new y.$Nd,this._onDidDispose=this.#d.event,this.#e=E,this.#t=v,this.#r=n,this.#l=r,this.#u=s,this.#n=o,this.#c=a(o),this.#h=p(o),this.#i=w}#d;dispose(){this.#o=!0,this.#d.fire(),this.#d.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(E){return this.#a=!0,(0,g.$5ob)(E,this.#l)}get cspSource(){const E=this.#n.extensionLocation;if(E.scheme===C.Schemas.https||E.scheme===C.Schemas.http){let v=E.toString();return v.endsWith("/")||(v+="/"),v+" "+g.$4ob}return g.$4ob}get html(){return this.a(),this.#s}set html(E){this.a(),this.#s!==E&&(this.#s=E,this.#h&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(E)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(E)))}get options(){return this.a(),this.#r}set options(E){this.a(),T.$8m(this.#r,E)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,E)),this.#r=E}async postMessage(E){if(this.#o)return!1;const v=(0,D.$vcb)(E,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,v.message,...v.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(E){if(!this.#h)return E;const v=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,n=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return E.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,s,o,w,h,I)=>{const S=A.URI.from({scheme:w||"file",path:decodeURIComponent(h)}),u=(0,g.$5ob)(S,{isRemote:v,authority:n}).toString();return`${s}${u}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,s,o,w,h,I)=>{const S=A.URI.from({scheme:w||"file",path:decodeURIComponent(h)}),u=(0,g.$5ob)(S,{isRemote:v,authority:n}).toString();return`${s}${u}${I}`})}}e.$Vcc=k;function a(b){try{const E=(0,l.$Lo)((0,l.$Ko)(b.engines.vscode));return!!E&&E.majorBase>=1&&E.minorBase>=57}catch{return!1}}e.$Wcc=a;function p(b){try{const E=(0,l.$Lo)((0,l.$Ko)(b.engines.vscode));return E?E.majorBase<1||E.majorBase===1&&E.minorBase<60:!1}catch{return!1}}class $ extends M.$Sc{constructor(E,v,n,r,s){super(),this.c=v,this.f=n,this.g=r,this.h=s,this.b=new Map,this.a=E.getProxy(R.$cK.MainThreadWebviews)}dispose(){super.dispose();for(const E of this.b.values())E.dispose();this.b.clear()}$onMessage(E,v,n){const r=this.j(E);if(r){const{message:s}=(0,D.$wcb)(v,n.value);r._onMessageEmitter.fire(s)}}$onMissingCsp(E,v){this.g.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(E,v,n){const r=new k(E,this.a,i(v),this.c,this.f,n,this.h);this.b.set(E,r);const s=r._onDidDispose(()=>{s.dispose(),this.deleteWebview(E)});return r}deleteWebview(E){this.b.delete(E)}j(E){return this.b.get(E)}}e.$Xcc=$;function f(b){return{id:b.identifier,location:b.extensionLocation}}e.$Ycc=f;function t(b,E,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||c(b,E)}}e.$Zcc=t;function i(b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots?.map(E=>A.URI.from(E))}}function c(b,E){return[...(E?.getWorkspaceFolders()||[]).map(v=>v.uri),b.extensionLocation]}}),define(Ae[259],Re([1,0,20,93,6,13,23,2,8,64,74,3,7]),function(be,e,y,M,C,T,A,l,D,g,R,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;class p{constructor(r,s){this.document=r,this.b=s,this.a=1,this.c=new R.$Rbc("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,s){await this.f(r).undo(),s||this.disposeBackup()}async redo(r,s){await this.f(r).redo(),s||this.disposeBackup()}disposeEdits(r){for(const s of r)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=v(this.document.uri)+this.a++;return(0,A.$vg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const s=this.c.get(r,0);if(!s)throw new Error("No edit found");return s}}class ${constructor(){this.a=new Map}get(r,s){return this.a.get(this.b(r,s))}add(r,s,o){const w=this.b(r,s.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${r} resource:${s.uri}`);const h=new p(s,o);return this.a.set(w,h),h}delete(r,s){const o=this.b(r,s.uri);this.a.delete(o)}b(r,s){return`${r}@@@${s}`}}var f;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(f||(f={}));class t{constructor(){this.a=new Map}addTextProvider(r,s,o){return this.b(0,r,s,o)}addCustomProvider(r,s,o){return this.b(1,r,s,o)}get(r){return this.a.get(r)}b(r,s,o,w){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:r,extension:o,provider:w}),new a.$eK(()=>this.a.delete(s))}}class i{constructor(r,s,o,w,h){this.d=s,this.f=o,this.g=w,this.h=h,this.b=new t,this.c=new $,this.a=r.getProxy(k.$cK.MainThreadCustomEditors)}registerCustomEditorProvider(r,s,o,w){const h=new C.$Rc;return b(o)?(h.add(this.b.addTextProvider(s,r,o)),this.a.$registerTextEditorProvider((0,g.$Ycc)(r),s,w.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,g.$Wcc)(r))):(h.add(this.b.addCustomProvider(s,r,o)),c(o)&&h.add(o.onDidChangeCustomDocument(I=>{const S=this.i(s,I.document.uri);if(E(I)){const u=S.addEdit(I);this.a.$onDidEdit(I.document.uri,s,u,I.label)}else this.a.$onContentChange(I.document.uri,s)})),this.a.$registerCustomEditorProvider((0,g.$Ycc)(r),s,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,g.$Wcc)(r))),a.$eK.from(h,new a.$eK(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(r,s,o,w,h){const I=this.b.get(s);if(!I)throw new Error(`No provider found for '${s}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${s}'`);const S=l.URI.revive(r),u=await I.provider.openCustomDocument(S,{backupId:o,untitledDocumentData:w?.buffer},h);let m;return c(I.provider)&&this.f&&(m=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(s,u,m),{editable:c(I.provider)}}async $disposeCustomDocument(r,s){const o=this.b.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${s}'`);const w=l.URI.revive(r),{document:h}=this.i(s,w);this.c.delete(s,h),h.dispose()}async $resolveCustomEditor(r,s,o,w,h,I){const S=this.b.get(o);if(!S)throw new Error(`No provider found for '${o}'`);const u=D.ViewColumn.to(h),m=this.g.createNewWebview(s,w.contentOptions,S.extension),d=this.h.createNewWebviewPanel(s,o,w.title,u,w.options,m,w.active),P=l.URI.revive(r);switch(S.type){case 1:{const{document:W}=this.i(o,P);return S.provider.resolveCustomEditor(W,d,I)}case 0:{const W=this.d.getDocument(P);return S.provider.resolveCustomTextEditor(W,d,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,s,o){this.i(s,r).disposeEdits(o)}async $onMoveCustomEditor(r,s,o){const w=this.b.get(o);if(!w)throw new Error(`No provider found for '${o}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const h=this.h.getWebviewPanel(r);if(!h)throw new Error("No webview found");const I=l.URI.revive(s),S=this.d.getDocument(I);await w.provider.moveCustomTextEditor(S,h,y.CancellationToken.None)}async $undo(r,s,o,w){return this.i(s,r).undo(o,w)}async $redo(r,s,o,w){return this.i(s,r).redo(o,w)}async $revert(r,s,o){const w=this.i(s,r);await this.j(s).revertCustomDocument(w.document,o),w.disposeBackup()}async $onSave(r,s,o){const w=this.i(s,r);await this.j(s).saveCustomDocument(w.document,o),w.disposeBackup()}async $onSaveAs(r,s,o,w){const h=this.i(s,r);return this.j(s).saveCustomDocumentAs(h.document,l.URI.revive(o),w)}async $backup(r,s,o){const w=this.i(s,r),I=await this.j(s).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},o);return w.updateBackup(I),I.id}i(r,s){const o=this.c.get(r,l.URI.revive(s));if(!o)throw new Error("No custom document found");return o}j(r){const o=this.b.get(r)?.provider;if(!o||!c(o))throw new Error("Custom document is not editable");return o}}e.$ydc=i;function c(n){return!!n.onDidChangeCustomDocument}function b(n){return typeof n.resolveCustomTextEditor=="function"}function E(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function v(n){const r=n.scheme===T.Schemas.file||n.scheme===T.Schemas.untitled?n.fsPath:n.toString();return(0,M.$Ci)(r)+""}}),define(Ae[260],Re([1,0,5,6,2,36,8,64,3,7]),function(be,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;class R extends M.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#h;#d;constructor($,f,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#h=this.B(new y.$Nd),this.onDidDispose=this.#h.event,this.#d=this.B(new y.$Nd),this.onDidChangeViewState=this.#d.event,this.#e=$,this.#t=f,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#h.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title($){this.c(),this.#n!==$&&(this.#n=$,this.#t.$setTitle(this.#e,$))}get iconPath(){return this.c(),this.#s}set iconPath($){this.c(),this.#s!==$&&(this.#s=$,this.#t.$setIconPath(this.#e,C.URI.isUri($)?{light:$,dark:$}:$))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState($){this.#c||(this.active!==$.active||this.visible!==$.visible||this.viewColumn!==$.viewColumn)&&(this.#a=$.active,this.#o=$.visible,this.#r=$.viewColumn,this.#d.fire({webviewPanel:this}))}reveal($,f){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof $>"u"?void 0:A.ViewColumn.from($),preserveFocus:!!f})}c(){if(this.#c)throw new Error("Webview is disposed")}}class k extends M.$Sc{static c(){return(0,T.$eg)()}constructor($,f,t){super(),this.j=f,this.m=t,this.g=new Map,this.h=new Map,this.f=$.getProxy(D.$cK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach($=>$.dispose()),this.g.clear()}createWebviewPanel($,f,t,i,c={}){const b=typeof i=="object"?i.viewColumn:i,E={viewColumn:A.ViewColumn.from(b),preserveFocus:typeof i=="object"&&!!i.preserveFocus},v=(0,l.$Wcc)($),n=k.c();this.f.$createWebviewPanel((0,l.$Ycc)($),n,f,{title:t,panelOptions:a(c),webviewOptions:(0,l.$Zcc)($,this.m,c),serializeBuffersForPostMessage:v},E);const r=this.j.createNewWebview(n,c,$);return this.createNewWebviewPanel(n,f,t,b,c,r,!0)}$onDidChangeWebviewPanelViewStates($){const f=Object.keys($);f.sort((t,i)=>{const c=$[t],b=$[i];return c.active?1:b.active?-1:+c.visible-+b.visible});for(const t of f){const i=this.getWebviewPanel(t);if(!i)continue;const c=$[t];i._updateViewState({active:c.active,visible:c.visible,viewColumn:A.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel($){this.getWebviewPanel($)?.dispose(),this.g.delete($),this.j.deleteWebview($)}registerWebviewPanelSerializer($,f,t){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:t,extension:$}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,l.$Wcc)($)}),new g.$eK(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel($,f,t,i){const c=this.h.get(f);if(!c)throw new Error(`No serializer found for '${f}'`);const{serializer:b,extension:E}=c,v=this.j.createNewWebview($,t.webviewOptions,E),n=this.createNewWebviewPanel($,f,t.title,i,t.panelOptions,v,t.active);await b.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel($,f,t,i,c,b,E){const v=new R($,this.f,b,{viewType:f,title:t,viewColumn:i,panelOptions:c,active:E});return this.g.set($,v),v}getWebviewPanel($){return this.g.get($)}}e.$xdc=k;function a(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Ae[261],Re([1,0,5,6,64,8,3,7]),function(be,e,y,M,C,T,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class D extends M.$Sc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(k,a,p,$,f,t){super(),this.#u=!1,this.#a=this.B(new y.$Nd),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new y.$Nd),this.onDidDispose=this.#c.event,this.#i=p,this.#s=$,this.#e=k,this.#t=a,this.#l=f,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#r}set description(k){this.a(),this.#r!==k&&(this.#r=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#u||(this.#n=k,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(k){this.a(),!(k?.value===this.#o?.value&&k?.tooltip===this.#o?.tooltip)&&(this.#o=T.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#u)throw new Error("Webview is disposed")}}class g{constructor(k,a){this.d=a,this.b=new Map,this.c=new Map,this.a=k.getProxy(A.$cK.MainThreadWebviewViews)}registerWebviewViewProvider(k,a,p,$){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:p,extension:k}),this.a.$registerWebviewViewProvider((0,C.$Ycc)(k),a,{retainContextWhenHidden:$?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Wcc)(k)}),new l.$eK(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(k,a,p,$,f){const t=this.b.get(a);if(!t)throw new Error(`No view provider found for '${a}'`);const{provider:i,extension:c}=t,b=this.d.createNewWebview(k,{},c),E=new D(k,this.a,a,p,b,!0);this.c.set(k,E),await i.resolveWebviewView(E,{state:$},f)}async $onDidChangeWebviewViewVisibility(k,a){this.e(k)._setVisible(a)}async $disposeWebviewView(k){const a=this.e(k);this.c.delete(k),a.dispose(),this.d.deleteWebview(k)}e(k){const a=this.c.get(k);if(!a)throw new Error("No webview found");return a}}e.$wdc=g}),define(Ae[108],Re([1,0,5,3,2,13,16,4,17,25]),function(be,e,y,M,C,T,A,l,D,g){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$2cc=e.$1cc=void 0;let k=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(p){const $=this.d;return{get focused(){return $.focused},get active(){return(0,g.$aF)(p,"windowActivity"),$.active}}}constructor(p){this.c=new y.$Nd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=p.getProxy(M.$cK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:$,isActive:f})=>{this.onDidChangeWindowProperty("focused",$),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,$){$!==this.d[p]&&(this.d={...this.d,[p]:$},this.c.fire(this.d))}openUri(p,$){let f;if(typeof p=="string"){f=p;try{p=C.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,A.$Be)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,f,$)}async asExternalUri(p,$){if((0,A.$Be)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(p,$);return C.URI.from(f)}};e.$1cc=k,e.$1cc=k=R=qe([Ke(0,D.$dM)],k),e.$2cc=(0,l.$Oh)("IExtHostWindow")}),define(Ae[262],Re([1,0,227,27,17]),function(be,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0;let T=class extends y.$2dc{constructor(l,D){super(l,D)}f(l,D,g){D.apply(console,g)}};e.$9fc=T,e.$9fc=T=qe([Ke(0,C.$dM),Ke(1,M.$tM)],T)}),define(Ae[263],Re([1,0,12,26,20,9,5,6,132,215,47]),function(be,e,y,M,C,T,A,l,D,g,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$n4b=e.ResponsiveState=e.RequestInitiator=e.$m4b=e.$l4b=void 0;function a(d,P){try{return JSON.stringify(d,P)}catch{return"null"}}const p="$$ref$$",$={[p]:-1};class f{constructor(P,W){this.jsonString=P,this.referencedBuffers=W}}function t(d,P=null,W=!1){const K=[];return{jsonString:(W?a:JSON.stringify)(d,(B,O)=>{if(typeof O>"u")return $;if(typeof O=="object"){if(O instanceof M.$be){const N=K.push(O)-1;return{[p]:N}}if(P)return P(B,O)}return O}),referencedBuffers:K}}e.$l4b=t;function i(d,P,W){return JSON.parse(d,(K,U)=>{if(U){const B=U[p];if(typeof B=="number")return P[B];if(W&&U.$mid===1)return W.transformIncoming(U)}return U})}e.$m4b=i;function c(d,P){return JSON.stringify(d,P)}function b(d){return d?(P,W)=>W&&W.$mid===1?d.transformOutgoing(W):W:null}var E;(function(d){d[d.LocalSide=0]="LocalSide",d[d.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));var v;(function(d){d[d.Responsive=0]="Responsive",d[d.Unresponsive=1]="Unresponsive"})(v||(e.ResponsiveState=v={}));const n=()=>{},r=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class o extends l.$Sc{static{k=r}static{this.a=3*1e3}constructor(P,W=null,K=null){super(),this[k]=!0,this.b=this.B(new A.$Nd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=W,this.g=K,this.h=b(this.g),this.j=!1,this.m=[],this.s=[];for(let U=0,B=R.$jv.count;U<B;U++)this.m[U]=null,this.s[U]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new y.$6g(()=>this.H(),1e3)),this.c.onMessage(U=>this.L(U))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const W=this.w[P];delete this.w[P],W.resolveErr(T.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,D.$Mm)(P,this.g):P}getProxy(P){const{nid:W,sid:K}=P;return this.s[W]||(this.s[W]=this.J(W,K)),this.s[W]}J(P,W){const K={get:(U,B)=>(typeof B=="string"&&!U[B]&&B.charCodeAt(0)===36&&(U[B]=(...O)=>this.U(P,B,O)),B===s?W:U[B])};return new Proxy(Object.create(null),K)}set(P,W){return this.m[P.nid]=W,W}assertRegistered(P){for(let W=0,K=P.length;W<K;W++){const U=P[W];if(!this.m[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}L(P){if(this.j)return;const W=P.byteLength,K=h.read(P,0),U=K.readUInt8(),B=K.readUInt32();switch(U){case 1:case 2:{let{rpcId:O,method:N,args:te}=S.deserializeRequestJSONArgs(K);this.g&&(te=(0,D.$Mm)(te,this.g)),this.M(W,B,O,N,te,U===2);break}case 3:case 4:{let{rpcId:O,method:N,args:te}=S.deserializeRequestMixedArgs(K);this.g&&(te=(0,D.$Mm)(te,this.g)),this.M(W,B,O,N,te,U===4);break}case 5:{this.f?.logIncoming(W,B,0,"ack"),this.G(B);break}case 6:{this.N(W,B);break}case 7:{this.O(W,B,void 0);break}case 9:{let O=S.deserializeReplyOKJSON(K);this.g&&(O=(0,D.$Mm)(O,this.g)),this.O(W,B,O);break}case 10:{const O=S.deserializeReplyOKJSONWithBuffers(K,this.g);this.O(W,B,O);break}case 8:{const O=S.deserializeReplyOKVSBuffer(K);this.O(W,B,O);break}case 11:{let O=S.deserializeReplyErrError(K);this.g&&(O=(0,D.$Mm)(O,this.g)),this.P(W,B,O);break}case 12:{this.P(W,B,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,W,K,U,B,O){this.f?.logIncoming(P,W,1,`receiveRequest ${(0,R.$lv)(K)}.${U}(`,B);const N=String(W);let te,Y;if(O){const Se=new C.$Xd;B.push(Se.token),te=this.Q(K,U,B),Y=()=>Se.cancel()}else te=this.Q(K,U,B),Y=n;this.u[N]=Y;const Ee=S.serializeAcknowledged(W);this.f?.logOutgoing(Ee.byteLength,W,1,"ack"),this.c.send(Ee),te.then(Se=>{delete this.u[N];const Pe=S.serializeReplyOK(W,Se,this.h);this.f?.logOutgoing(Pe.byteLength,W,1,"reply:",Se),this.c.send(Pe)},Se=>{delete this.u[N];const Pe=S.serializeReplyErr(W,Se);this.f?.logOutgoing(Pe.byteLength,W,1,"replyErr:",Se),this.c.send(Pe)})}N(P,W){this.f?.logIncoming(P,W,1,"receiveCancel");const K=String(W);this.u[K]?.()}O(P,W,K){this.f?.logIncoming(P,W,0,"receiveReply:",K);const U=String(W);if(!this.w.hasOwnProperty(U))return;const B=this.w[U];delete this.w[U],B.resolveOk(K)}P(P,W,K){this.f?.logIncoming(P,W,0,"receiveReplyErr:",K);const U=String(W);if(!this.w.hasOwnProperty(U))return;const B=this.w[U];delete this.w[U];let O;K&&(K.$isError?(O=new Error,O.name=K.name,O.message=K.message,O.stack=K.stack):O=K),B.resolveErr(O)}Q(P,W,K){try{return Promise.resolve(this.S(P,W,K))}catch(U){return Promise.reject(U)}}S(P,W,K){const U=this.m[P];if(!U)throw new Error("Unknown actor "+(0,R.$lv)(P));const B=U[W];if(typeof B!="function")throw new Error("Unknown method "+W+" on actor "+(0,R.$lv)(P));return B.apply(U,K)}U(P,W,K){if(this.j)return new g.$k4b;let U=null;if(K.length>0&&C.CancellationToken.isCancellationToken(K[K.length-1])&&(U=K.pop()),U&&U.isCancellationRequested)return Promise.reject(T.$6());const B=S.serializeRequestArguments(K,this.h),O=++this.t,N=String(O),te=new g.$j4b,Y=new l.$Rc;U&&Y.add(U.onCancellationRequested(()=>{const Se=S.serializeCancel(O);this.f?.logOutgoing(Se.byteLength,O,0,"cancel"),this.c.send(S.serializeCancel(O))})),this.w[N]=new w(te,Y),this.F(O);const Ee=S.serializeRequest(O,P,W,B,!!U);return this.f?.logOutgoing(Ee.byteLength,O,0,`request: ${(0,R.$lv)(P)}.${W}(`,K),this.c.send(Ee),te}}e.$n4b=o;class w{constructor(P,W){this.a=P,this.b=W}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class h{static alloc(P,W,K){const U=new h(M.$be.alloc(K+1+4),0);return U.writeUInt8(P),U.writeUInt32(W),U}static read(P,W){return new h(P,W)}get buffer(){return this.a}constructor(P,W){this.a=P,this.b=W}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const K=this.a.slice(this.b,this.b+P).toString();return this.b+=P,K}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+P).toString();return this.b+=P,K}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+P);return this.b+=P,W}static sizeMixedArray(P){let W=0;W+=1;for(let K=0,U=P.length;K<U;K++){const B=P[K];switch(W+=1,B.type){case 1:W+=this.sizeLongString(B.value);break;case 2:W+=this.sizeVSBuffer(B.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(B.value);for(let O=0;O<B.buffers.length;++O)W+=this.sizeVSBuffer(B.buffers[O]);break;case 4:break}}return W}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let W=0,K=P.length;W<K;W++){const U=P[W];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let B=0;B<U.buffers.length;++B)this.writeBuffer(U.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const W=new Array(P);for(let K=0;K<P;K++)switch(this.readUInt8()){case 1:W[K]=this.readLongString();break;case 2:W[K]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),O=this.readLongString(),N=[];for(let te=0;te<B;++te)N.push(this.readVSBuffer());W[K]=new R.$mv(i(O,N,null));break}case 4:W[K]=void 0;break}return W}}var I;(function(d){d[d.Simple=0]="Simple",d[d.Mixed=1]="Mixed"})(I||(I={}));class S{static a(P){for(let W=0,K=P.length;W<K;W++)if(P[W]instanceof M.$be||P[W]instanceof R.$mv||typeof P[W]>"u")return!0;return!1}static serializeRequestArguments(P,W){if(this.a(P)){const K=[];for(let U=0,B=P.length;U<B;U++){const O=P[U];if(O instanceof M.$be)K[U]={type:2,value:O};else if(typeof O>"u")K[U]={type:4};else if(O instanceof R.$mv){const{jsonString:N,referencedBuffers:te}=t(O.value,W);K[U]={type:3,value:M.$be.fromString(N),buffers:te}}else K[U]={type:1,value:M.$be.fromString(c(O,W))}}return{type:1,args:K}}return{type:0,args:c(P,W)}}static serializeRequest(P,W,K,U,B){switch(U.type){case 0:return this.b(P,W,K,U.args,B);case 1:return this.c(P,W,K,U.args,B)}}static b(P,W,K,U,B){const O=M.$be.fromString(K),N=M.$be.fromString(U);let te=0;te+=h.sizeUInt8(),te+=h.sizeShortString(O),te+=h.sizeLongString(N);const Y=h.alloc(B?2:1,P,te);return Y.writeUInt8(W),Y.writeShortString(O),Y.writeLongString(N),Y.buffer}static deserializeRequestJSONArgs(P){const W=P.readUInt8(),K=P.readShortString(),U=P.readLongString();return{rpcId:W,method:K,args:JSON.parse(U)}}static c(P,W,K,U,B){const O=M.$be.fromString(K);let N=0;N+=h.sizeUInt8(),N+=h.sizeShortString(O),N+=h.sizeMixedArray(U);const te=h.alloc(B?4:3,P,N);return te.writeUInt8(W),te.writeShortString(O),te.writeMixedArray(U),te.buffer}static deserializeRequestMixedArgs(P){const W=P.readUInt8(),K=P.readShortString(),U=P.readMixedArray(),B=new Array(U.length);for(let O=0,N=U.length;O<N;O++){const te=U[O];typeof te=="string"?B[O]=JSON.parse(te):B[O]=te}return{rpcId:W,method:K,args:B}}static serializeAcknowledged(P){return h.alloc(5,P,0).buffer}static serializeCancel(P){return h.alloc(6,P,0).buffer}static serializeReplyOK(P,W,K){if(typeof W>"u")return this.d(P);if(W instanceof M.$be)return this.e(P,W);if(W instanceof R.$mv){const{jsonString:U,referencedBuffers:B}=t(W.value,K,!0);return this.g(P,U,B)}else return this.f(P,a(W,K))}static d(P){return h.alloc(7,P,0).buffer}static e(P,W){let K=0;K+=h.sizeVSBuffer(W);const U=h.alloc(8,P,K);return U.writeVSBuffer(W),U.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,W){const K=M.$be.fromString(W);let U=0;U+=h.sizeLongString(K);const B=h.alloc(9,P,U);return B.writeLongString(K),B.buffer}static g(P,W,K){const U=M.$be.fromString(W);let B=0;B+=h.sizeUInt32,B+=h.sizeLongString(U);for(const N of K)B+=h.sizeVSBuffer(N);const O=h.alloc(10,P,B);O.writeUInt32(K.length),O.writeLongString(U);for(const N of K)O.writeBuffer(N);return O.buffer}static deserializeReplyOKJSON(P){const W=P.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(P,W){const K=P.readUInt32(),U=P.readLongString(),B=[];for(let O=0;O<K;++O)B.push(P.readVSBuffer());return new R.$mv(i(U,B,W))}static serializeReplyErr(P,W){const K=W?a(T.$3(W),null):void 0;if(typeof K!="string")return this.h(P);const U=M.$be.fromString(K);let B=0;B+=h.sizeLongString(U);const O=h.alloc(11,P,B);return O.writeLongString(U),O.buffer}static deserializeReplyErrError(P){const W=P.readLongString();return JSON.parse(W)}static h(P){return h.alloc(12,P,0).buffer}}var u;(function(d){d[d.RequestJSONArgs=1]="RequestJSONArgs",d[d.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",d[d.RequestMixedArgs=3]="RequestMixedArgs",d[d.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",d[d.Acknowledged=5]="Acknowledged",d[d.Cancel=6]="Cancel",d[d.ReplyOKEmpty=7]="ReplyOKEmpty",d[d.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",d[d.ReplyOKJSON=9]="ReplyOKJSON",d[d.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",d[d.ReplyErrError=11]="ReplyErrError",d[d.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var m;(function(d){d[d.String=1]="String",d[d.VSBuffer=2]="VSBuffer",d[d.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",d[d.Undefined=4]="Undefined"})(m||(m={}))}),define(Ae[264],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=void 0;const y=function(T){const A=l=>{globalThis.removeEventListener("message",A);const D=l.data;Object.defineProperties(globalThis,{postMessage:{value(g,R){D.postMessage(g,R)}},onmessage:{get(){return D.onmessage},set(g){D.onmessage=g}}}),D.addEventListener("message",g=>{globalThis.dispatchEvent(new MessageEvent("message",{data:g.data,ports:g.ports?[...g.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};globalThis.addEventListener("message",A)}.toString();class M extends EventTarget{constructor(T,A,l){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${y})('${A}'))`,g=new Blob([D],{type:"application/javascript"}),R=URL.createObjectURL(g),k=new MessageChannel,a=R,p={type:"_newWorker",id:a,port:k.port2,url:R,options:l};T(p,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{T({type:"_terminateWorker",id:a}),URL.revokeObjectURL(R),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set($){k.port1.onmessage=$}},onmessageerror:{get(){return k.port1.onmessageerror},set($){k.port1.onmessageerror=$}}}),k.port1.addEventListener("messageerror",$=>{const f=new MessageEvent("messageerror",{data:$.data});this.dispatchEvent(f)}),k.port1.addEventListener("message",$=>{const f=new MessageEvent("message",{data:$.data});this.dispatchEvent(f)}),k.port1.start()}}e.$$fc=M}),define(Ae[265],Re([1,0,5,30,32,4]),function(be,e,y,M,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yJ=e.$xJ=e.OutputChannelUpdateMode=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=void 0,e.$nJ="text/x-code-output",e.$oJ="output",e.$pJ="Log",e.$qJ="text/x-code-log-output",e.$rJ="log",e.$sJ="workbench.panel.output",e.$tJ=new C.$6i("inOutput",!1),e.$uJ=new C.$6i("activeLogOutput",!1),e.$vJ=new C.$6i("outputView.scrollLock",!1),e.$wJ=(0,T.$Oh)("outputService");var A;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$xJ={OutputChannels:"workbench.contributions.outputChannels"};class l{constructor(){this.a=new Map,this.b=new y.$Nd,this.onDidRegisterChannel=this.b.event,this.c=new y.$Nd,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(R=>g.push(R)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}M.$dn.add(e.$xJ.OutputChannels,new l),e.$yJ=new C.$6i("activeOutputChannel","")}),define(Ae[109],Re([1,0,3,4,17,21,14,265,62,27,40,129,26,15,39,5,6]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=e.$Kcc=void 0;class i extends A.$cj{get disposed(){return this.n}constructor(v,n,r,s,o){super(),this.id=v,this.name=n,this.r=r,this.s=s,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.m;this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Clear,v)}replace(v){const n=this.m;this.info(v),this.s.$update(this.id,l.OutputChannelUpdateMode.Replace,n),this.visible&&this.r.flush()}show(v,n){this.r.flush(),this.s.$reveal(this.id,!!(typeof v=="boolean"?v:n))}hide(){this.s.$close(this.id)}g(v,n){this.m+=a.$be.fromString(n).byteLength,(0,A.log)(this.r,v,n),this.visible&&(this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class c extends i{appendLine(v){this.append(v)}}let b=class{constructor(v,n,r,s,o,w){this.i=n,this.j=r,this.k=s,this.l=o,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(y.$cK.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,k.$cm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[n,r]of this.g)r.visible=n===this.h}createOutputChannel(v,n,r){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const s=typeof n=="object"&&n.log,o=(0,p.$yf)(n)?n:void 0;if((0,p.$yf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const h=this.i.environment.extensionLogLevel?.find(([S])=>T.$4l.equals(r.identifier,S))?.[1];h&&(w=(0,A.$mj)(h));const I=s?this.o(v,w,r):this.n(v,o,r);return I.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),s?this.r(v,w??this.m.getLevel(),I):this.q(v,I)}async n(v,n,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,o=this.k.extUri.joinPath(s,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(v,o,n,r.identifier.value);return new i(h,v,w,this.a,r)}async o(v,n,r){const s=await this.p(r),o=v.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(s,`${o}.log`),h=`${r.identifier.value}.${o}`,I=this.l.createLogger(w,{id:h,name:v,logLevel:n,extensionId:r.identifier.value});return new c(h,v,I,this.a,r)}p(v){let n=this.d.get(v.identifier.value);if(!n){const r=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(r)}catch(s){if((0,$.$nk)(s)!==$.FileSystemProviderErrorCode.FileExists)throw s}return r})())}return n}q(v,n){let r=!1;const s=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return v},append(o){s(),n.then(w=>w.append(o))},appendLine(o){s(),n.then(w=>w.appendLine(o))},clear(){s(),n.then(o=>o.clear())},replace(o){s(),n.then(w=>w.replace(o))},show(o,w){s(),n.then(h=>h.show(o,w))},hide(){s(),n.then(o=>o.hide())},dispose(){r=!0,n.then(o=>o.dispose())}}}r(v,n,r){const s=new t.$Rc,o=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},w=s.add(new f.$Nd);function h(I){n=I,w.fire(I)}return r.then(I=>{s.add(I),I.logLevel!==n&&h(I.logLevel),s.add(I.onDidChangeLogLevel(S=>h(S)))}),{...this.q(v,r),get logLevel(){return n},onDidChangeLogLevel:w.event,trace(I,...S){o(),r.then(u=>u.trace(I,...S))},debug(I,...S){o(),r.then(u=>u.debug(I,...S))},info(I,...S){o(),r.then(u=>u.info(I,...S))},warn(I,...S){o(),r.then(u=>u.warn(I,...S))},error(I,...S){o(),r.then(u=>u.error(I,...S))},dispose(){s.dispose()}}}};e.$Kcc=b,e.$Kcc=b=qe([Ke(0,C.$dM),Ke(1,g.$tM),Ke(2,D.$ncc),Ke(3,R.$Ubc),Ke(4,A.$0i),Ke(5,A.$9i)],b),e.$Lcc=(0,M.$Oh)("IExtHostOutputService")}),define(Ae[266],Re([1,0,4,12]),function(be,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=void 0,e.$rm=(0,y.$Oh)("remoteAgentService"),e.$sm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let T=1/0;for(let l=0;l<this.maxSampleCount;l++){const D=await C.getRoundTripTime();if(D===void 0)return;T=Math.min(T,D/2),await(0,M.$Ug)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(T):A=this.initial.reduce((l,D)=>l+D,0)/this.initial.length,this.lastMeasurement={initial:A,current:T,average:this.average.reduce((l,D)=>l+D,0)/this.average.length,high:(()=>typeof A>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[267],Re([1,0,43,13,19,22,23,2,4,186,55,208,266]),function(be,e,y,M,C,T,A,l,D,g,R,k,a){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$RJ=e.$QJ=void 0,e.$QJ=(0,D.$Oh)("pathService");let $=p=class{constructor(t,i,c,b){this.d=t,this.e=i,this.f=c,this.g=b,this.a=(async()=>(await this.e.getEnvironment())?.os||T.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??t})()}hasValidBasename(t,i,c){return typeof i=="string"||typeof i>"u"?this.a.then(b=>this.h(t,b,i)):this.h(t,i,c)}h(t,i,c){return t.scheme===M.Schemas.file||t.scheme===M.Schemas.vscodeRemote?(0,y.$Vf)(c??(0,A.$sg)(t),i===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return M.Schemas.vscodeRemote;const c=(0,g.$NJ)(i.getWorkspace());if(c)return c;const b=i.getWorkspace().folders[0];if(b)return b.uri.scheme;const E=i.getWorkspace().configuration;return E?E.scheme:M.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?C.$fc:C.$gc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const b=t.indexOf("/",2);b===-1?(i=t.substring(2),t="/"):(i=t.substring(2,b),t=t.substring(b)||"/")}return l.URI.from({scheme:M.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$RJ=$,e.$RJ=$=p=qe([Ke(1,a.$rm),Ke(2,k.$zJ),Ke(3,R.$Xh)],$)}),define(Ae[110],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$yI=e.$xI=void 0;class y{constructor(A,l){this.line=A,this.character=l}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,l){return new y(0,0)}with(A){return new y(0,0)}}e.$xI=y;class M{constructor(A,l,D,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(A,l),this.end=new y(D,g)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.$yI=M;var C;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ae[48],Re([1,0,18,38,24,43,16,4,19,9,110,12]),function(be,e,y,M,C,T,A,l,D,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.SearchErrorCode=e.$NI=e.$MI=e.SearchSortOrder=e.ViewMode=e.$LI=e.$KI=e.$JI=e.$II=e.SearchCompletionExitCode=e.$HI=e.$GI=e.$FI=e.QueryType=e.SearchProviderType=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$zI="workbench.view.search",e.$AI="workbench.panel.search",e.$BI="workbench.view.search",e.$CI="search-result",e.$DI="search.exclude";const a="\u27EA ",p=" characters skipped \u27EB",$=(a.length+p.length+5)*2;e.$EI=(0,l.$Oh)("searchService");var f;(function(ge){ge[ge.file=0]="file",ge[ge.text=1]="text"})(f||(e.SearchProviderType=f={}));var t;(function(ge){ge[ge.File=1]="File",ge[ge.Text=2]="Text"})(t||(e.QueryType=t={}));function i(ge){return!!ge.preview}e.$FI=i;function c(ge){return!!ge.resource}e.$GI=c;function b(ge){return!!ge.message}e.$HI=b;var E;(function(ge){ge[ge.Normal=0]="Normal",ge[ge.NewSearchStarted=1]="NewSearchStarted"})(E||(e.SearchCompletionExitCode=E={}));class v{constructor(me){this.resource=me,this.results=[]}}e.$II=v;class n{constructor(me,ce,se,$e){this.ranges=ce,this.webviewIndex=$e;const x=Array.isArray(ce)?ce:[ce];if(se&&se.matchLines===1&&r(x)){me=(0,A.$rf)(me,se.matchLines);let z="",V=0,ue=0;const ye=Math.floor(se.charsPerLine/5),we=[];for(const pe of x){const De=Math.max(pe.startColumn-ye,0),ne=pe.startColumn+se.charsPerLine;if(De>ue+ye+$){const le=a+(De-ue)+p;z+=le+me.slice(De,ne),V+=De-(ue+le.length)}else z+=me.slice(ue,ne);we.push(new o(0,pe.startColumn-V,pe.endColumn-V)),ue=ne}this.preview={text:z,matches:Array.isArray(this.ranges)?we:we[0]}}else{const z=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:me,matches:(0,y.$2b)(ce,V=>new s(V.startLineNumber-z,V.startColumn,V.endLineNumber-z,V.endColumn))}}}}e.$JI=n;function r(ge){const me=ge[0].startLineNumber;for(const ce of ge)if(ce.startLineNumber!==me||ce.endLineNumber!==me)return!1;return!0}class s{constructor(me,ce,se,$e){this.startLineNumber=me,this.startColumn=ce,this.endLineNumber=se,this.endColumn=$e}}e.$KI=s;class o extends s{constructor(me,ce,se){super(me,ce,me,se)}}e.$LI=o;var w;(function(ge){ge.List="list",ge.Tree="tree"})(w||(e.ViewMode=w={}));var h;(function(ge){ge.Default="default",ge.FileNames="fileNames",ge.Type="type",ge.Modified="modified",ge.CountDescending="countDescending",ge.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function I(ge,me=!0){const ce=ge&&ge.files&&ge.files.exclude,se=me&&ge&&ge.search&&ge.search.exclude;if(!ce&&!se)return;if(!ce||!se)return ce||se;let $e=Object.create(null);return $e=C.$7m($e,C.$4m(ce)),$e=C.$7m($e,C.$4m(se),!0),$e}e.$MI=I;function S(ge,me){return ge.excludePattern&&M.$uj(ge.excludePattern,me)?!1:ge.includePattern||ge.usingSearchPaths?ge.includePattern&&M.$uj(ge.includePattern,me)?!0:ge.usingSearchPaths?!!ge.folderQueries&&ge.folderQueries.some(ce=>{const se=ce.folder.fsPath;if(T.$Xf(me,se)){const $e=D.$lc(se,me);return!ce.includePattern||!!M.$uj(ce.includePattern,$e)}else return!1}):!1:!0}e.$NI=S;var u;(function(ge){ge[ge.unknownEncoding=1]="unknownEncoding",ge[ge.regexParseError=2]="regexParseError",ge[ge.globParseError=3]="globParseError",ge[ge.invalidLiteral=4]="invalidLiteral",ge[ge.rgProcessError=5]="rgProcessError",ge[ge.other=6]="other",ge[ge.canceled=7]="canceled"})(u||(e.SearchErrorCode=u={}));class m extends Error{constructor(me,ce){super(me),this.code=ce}}e.$OI=m;function d(ge){const me=ge.message;if((0,g.$4)(ge))return new m(me,u.canceled);try{const ce=JSON.parse(me);return new m(ce.message,ce.code)}catch{return new m(me,u.other)}}e.$PI=d;function P(ge){const me={message:ge.message,code:ge.code};return new Error(JSON.stringify(me))}e.$QI=P;function W(ge){return ge.type==="error"?!0:ge.type==="success"}e.$RI=W;function K(ge){return ge.type==="success"}e.$SI=K;function U(ge){return!!ge.path}e.$TI=U;function B(ge,me){const ce=ge.searchPath?ge.searchPath:ge.relativePath;return(0,A.$of)(ce,me)}e.$UI=B;class O{constructor(me){this.path=me,this.results=[]}addMatch(me){this.results.push(me)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$VI=O;function N(ge,me){const ce={...ge||{},...me||{}};return Object.keys(ce).filter(se=>{const $e=ce[se];return typeof $e=="boolean"&&$e})}e.$WI=N;class te{constructor(me,ce){this.c=null,this.a={...me.excludePattern||{},...ce.excludePattern||{}},this.b=M.$vj(this.a);let se=me.includePattern;ce.includePattern&&(se?se={...se,...ce.includePattern}:se=ce.includePattern),se&&(this.c=M.$vj(se))}matchesExcludesSync(me,ce,se){return!!(this.b&&this.b(me,ce,se))}includedInQuerySync(me,ce,se){return!(this.b&&this.b(me,ce,se)||this.c&&!this.c(me,ce,se))}includedInQuery(me,ce,se){const $e=this.b(me,ce,se),x=()=>this.c?!!this.c(me,ce,se):!0;return(0,k.$Gg)($e)?$e.then(z=>z?!1:x()):x()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$XI=te;function Y(ge){for(const me in ge)if(typeof ge[me]!="boolean")return!0;return!1}function Ee(ge){if(!ge)return;let me;return ce=>(me||(me=(ge()||Promise.resolve([])).then(se=>se?Pe(se):{})),me.then(se=>!!se[ce]))}e.$YI=Ee;function Se(ge){if(!ge)return;let me;return ce=>{if(!me){const se=ge();me=se?Pe(se):{}}return!!me[ce]}}e.$ZI=Se;function Pe(ge){const me={};for(const ce of ge)me[ce]=!0;return me}}),define(Ae[33],Re([1,0,18,12,20,5,6,49,13,117,23,16,2,158,4,14,175,55,40,27,17,8,7,56,48,3]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f,t,i,c,b,E,v,n,r,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=e.$7bc=void 0;function w(W,K,U){return new R.$kg(B=>u(B,U)).isEqual(W,K)}function h(W,K,U){return w(W.uri,K.uri,U)?0:(0,k.$Ue)(W.uri.toString(),K.uri.toString())}function I(W,K,U){return W.index!==K.index?W.index<K.index?-1:1:w(W.uri,K.uri,U)?(0,k.$Ue)(W.name,K.name):(0,k.$Ue)(W.uri.toString(),K.uri.toString())}function S(W,K,U,B){const O=W.slice(0).sort((te,Y)=>U(te,Y,B)),N=K.slice(0).sort((te,Y)=>U(te,Y,B));return(0,y.$Eb)(O,N,(te,Y)=>U(te,Y,B))}function u(W,K){const U=K.getCapabilities(W.scheme);return!(U&&U&1024)}class m extends i.$8h{static toExtHostWorkspace(K,U,B,O){if(!K)return{workspace:null,added:[],removed:[]};const{id:N,name:te,folders:Y,configuration:Ee,transient:Se,isUntitled:Pe}=K,ge=[],me=U;U?Y.forEach((x,z)=>{const V=a.URI.revive(x.uri),ue=m.o(B||U,V,O);ue?(ue.name=x.name,ue.index=x.index,ge.push(ue)):ge.push({uri:V,name:x.name,index:z})}):ge.push(...Y.map(({uri:x,name:z,index:V})=>({uri:a.URI.revive(x),name:z,index:V}))),ge.sort((x,z)=>x.index<z.index?-1:1);const ce=new m(N,te,ge,!!Se,Ee?a.URI.revive(Ee):null,!!Pe,x=>u(x,O)),{added:se,removed:$e}=S(me?me.workspaceFolders:[],ce.workspaceFolders,h,O);return{workspace:ce,added:se,removed:$e}}static o(K,U,B){for(let O=0;O<K.folders.length;O++){const N=K.workspaceFolders[O];if(w(N.uri,U,B))return N}}constructor(K,U,B,O,N,te,Y){super(K,B.map(Ee=>new i.$9h(Ee)),O,N,Y),this.t=U,this.u=te,this.q=[],this.s=l.$Uh.forUris(Y),B.forEach(Ee=>{this.q.push(Ee),this.s.set(Ee.uri,Ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(K,U){return U&&this.s.get(K)&&(K=(0,R.$ug)(K)),this.s.findSubstr(K)}resolveWorkspaceFolder(K){return this.s.get(K)}}let d=class{constructor(K,U,B,O,N){this.c=new T.$Nd,this.onDidChangeWorkspace=this.c.event,this.g=new T.$Nd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new T.$Pd,this.B=new Map,this.h=O,this.s=B,this.t=N,this.j=new g.$Ol,this.k=new M.$Sg,this.o=K.getProxy(o.$cK.MainThreadWorkspace),this.q=K.getProxy(o.$cK.MainThreadMessageService);const te=U.workspace;this.l=te?new m(te.id,te.name,[],!!te.transient,te.configuration?a.URI.revive(te.configuration):null,!!te.isUntitled,Y=>u(Y,B)):void 0}$initializeWorkspace(K,U){this.v=U,this.$acceptWorkspaceData(K),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?a.URI.from({scheme:D.Schemas.untitled,path:(0,R.$sg)((0,R.$ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(K,U,B,...O){const N=[];if(Array.isArray(O)&&O.forEach(Pe=>{a.URI.isUri(Pe.uri)&&!N.some(ge=>w(ge.uri,Pe.uri,this.s))&&N.push({uri:Pe.uri,name:Pe.name||(0,R.$rg)(Pe.uri)})}),this.n||[U,B].some(Pe=>typeof Pe!="number"||Pe<0)||B===0&&N.length===0)return!1;const te=this.x?this.x.workspaceFolders:[];if(U+B>te.length)return!1;const Y=te.slice(0);Y.splice(U,B,...N.map(Pe=>({uri:Pe.uri,name:Pe.name||(0,R.$rg)(Pe.uri),index:void 0})));for(let Pe=0;Pe<Y.length;Pe++){const ge=Y[Pe];if(Y.some((me,ce)=>ce!==Pe&&w(ge.uri,me.uri,this.s)))return!1}Y.forEach((Pe,ge)=>Pe.index=ge);const{added:Ee,removed:Se}=S(te,Y,I,this.s);if(Ee.length===0&&Se.length===0)return!1;if(this.o){const Pe=K.displayName||K.name;this.o.$updateWorkspaceFolders(Pe,U,B,N).then(void 0,ge=>{this.n=void 0;const me={source:{identifier:K.identifier,label:K.displayName||K.name}};this.q.$showMessage(t.Severity.Error,(0,p.localize)(0,null,Pe,ge.toString()),me,[])})}return this.y(Y),!0}getWorkspaceFolder(K,U){if(this.x)return this.x.getWorkspaceFolder(K,U)}async getWorkspaceFolder2(K,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(K,U)}async resolveWorkspaceFolder(K){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(K)}getPath(){if(!this.x)return;const{folders:K}=this.x;if(K.length!==0)return K[0].uri.fsPath}getRelativePath(K,U){let B,O="";if(typeof K=="string"?(B=a.URI.file(K),O=K):typeof K<"u"&&(B=K,O=K.fsPath),!B)return O;const N=this.getWorkspaceFolder(B,!0);if(!N)return O;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let te=(0,R.$xg)(N.uri,B);return U&&N.name&&(te=`${N.name}/${te}`),te}y(K){this.x&&(this.n=m.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:K,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(K){const{workspace:U,added:B,removed:O}=m.toExtHostWorkspace(K,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:B,removed:O}))}findFiles(K,U,B,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let te;if(U===null?te=!1:U&&(typeof U=="string"?te=U:te=U.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:Y,folder:Ee}=P(v.GlobPattern.from(K));return this.o.$startFileSearch(Y??null,Ee??null,te??null,B??null,N).then(Se=>Array.isArray(Se)?Se.map(Pe=>a.URI.revive(Pe)):[])}async findTextInFiles(K,U,B,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const te=this.j.getNext(),Y=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:Ee,folder:Se}=P(v.GlobPattern.from(U.include)),Pe=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ge={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:Y,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:Ee,excludePattern:Pe},me=!1;if(this.u[te]=ce=>{if(me)return;const se=a.URI.revive(ce.resource);ce.results.forEach($e=>{(0,s.$FI)($e)?B({uri:se,preview:{text:$e.preview.text,matches:(0,y.$2b)($e.preview.matches,x=>new n.$gK(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,y.$2b)($e.ranges,x=>new n.$gK(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):B({uri:se,text:$e.text,lineNumber:$e.lineNumber})})},N.isCancellationRequested)return{};try{const ce=await this.o.$startTextSearch(K,Se??null,ge,te,N);return delete this.u[te],ce||{}}catch(ce){throw delete this.u[te],ce}}$handleTextSearchResult(K,U){this.u[U]?.(K)}async save(K){const U=await this.o.$save(K,{saveAs:!1});return a.URI.revive(U)}async saveAs(K){const U=await this.o.$save(K,{saveAs:!0});return a.URI.revive(U)}saveAll(K){return this.o.$saveAll(K)}resolveProxy(K){return this.o.$resolveProxy(K)}get trusted(){return this.v}requestWorkspaceTrust(K){return this.o.$requestWorkspaceTrust(K)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(K,U){if(this.w.has(K))throw new Error(`A provider has already been registered for scheme ${K}`);this.w.set(K,U);const B=this.t.transformOutgoingScheme(K),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,B),(0,A.$Qc)(()=>{this.w.delete(K),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(K,U){this.h.info("Getting edit session identifier for workspaceFolder",K);const B=await this.resolveWorkspaceFolder(a.URI.revive(K));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const O=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!O),!O)return;const N=await O.provideEditSessionIdentity(B,U);if(this.h.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(K,U,B,O){this.h.info("Getting edit session identifier for workspaceFolder",K);const N=await this.resolveWorkspaceFolder(a.URI.revive(K));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const te=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!te),!te)return;const Y=await te.provideEditSessionIdentityMatch?.(U,B,O);if(this.h.info("Provider returned edit session identifier match result: ",Y),!!Y)return Y}getOnWillCreateEditSessionIdentityEvent(K){return(U,B,O)=>{const N=function(Y){U.call(B,Y)};return N.extension=K,this.A.event(N,void 0,O)}}async $onWillCreateEditSessionIdentity(K,U,B){const O=await this.resolveWorkspaceFolder(a.URI.revive(K));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},U,async(N,te)=>{const Y=Date.now();await Promise.resolve(N),Date.now()-Y>B&&this.h.warn("SLOW edit session create-participant",te.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(K,U){if(this.B.has(K))throw new Error(`A provider has already been registered for scheme ${K}`);this.B.set(K,U);const B=this.t.transformOutgoingScheme(K),O=this.z++;return this.o.$registerCanonicalUriProvider(O,B),(0,A.$Qc)(()=>{this.B.delete(K),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(K,U,B){const O=this.B.get(K.scheme);if(!O)return;const N=await O.provideCanonicalUri?.(a.URI.revive(K),U,B);if(N)return N}async $provideCanonicalUri(K,U,B){return this.provideCanonicalUri(a.URI.revive(K),{targetScheme:U},B)}};e.$7bc=d,e.$7bc=d=qe([Ke(0,E.$dM),Ke(1,b.$tM),Ke(2,c.$Ubc),Ke(3,f.$9i),Ke(4,r.$5bc)],d),e.$8bc=(0,$.$Oh)("IExtHostWorkspace");function P(W){let K,U;return W&&(typeof W=="string"?K=W:(K=W.pattern,U=a.URI.revive(W.baseUri))),{includePattern:K,folder:U}}}),define(Ae[34],Re([1,0,24,5,33,3,7,177,96,15,12,4,17,14,2]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=e.$0bc=e.$9bc=void 0;function f(r,s){if(s){const o=s.split(".");let w=r;for(let h=0;w&&h<o.length;h++)w=w[o[h]];return w}}function t(r){return r instanceof $.URI}function i(r){return r&&r.uri instanceof $.URI&&r.languageId&&typeof r.languageId=="string"}function c(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function b(r){return r&&r.uri instanceof $.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function E(r){if(t(r))return{resource:r};if(i(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(c(r))return{overrideIdentifier:r.languageId};if(b(r))return{resource:r.uri};if(r===null)return{resource:null}}let v=class{constructor(s,o,w){this.a=s.getProxy(T.$cK.MainThreadConfiguration),this.c=o,this.b=w,this.d=new R.$Sg,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new n(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,o){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(s,o))}};e.$9bc=v,e.$9bc=v=qe([Ke(0,a.$dM),Ke(1,C.$8bc),Ke(2,p.$9i)],v);class n{constructor(s,o,w,h){this.a=new M.$Nd,this.b=s,this.f=h,this.c=o,this.e=l.$Bn.parse(w),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,o){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=l.$Bn.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(o,w))}getConfiguration(s,o,w){const h=E(o)||{},I=this.g(s?f(this.e.getValue(void 0,h,this.c.workspace),s):this.e.getValue(void 0,h,this.c.workspace));s&&this.h(s,h,w?.identifier);function S(m){if(m==null)return null;if(typeof m=="boolean")return m?2:5;switch(m){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(m){return typeof f(I,m)<"u"},get:(m,d)=>{this.h(s?`${s}.${m}`:m,h,w?.identifier);let P=f(I,m);if(typeof P>"u")P=d;else{let W;const K=(U,B)=>{if((0,g.$Af)(U)){let O;const N=()=>{W=W||(0,y.$4m)(I),O=O||f(W,B)};return new Proxy(U,{get:(te,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return N(),()=>O;if(W)return O=O||f(W,B),O[Y];const Ee=te[Y];return typeof Y=="string"?K(Ee,`${B}.${Y}`):Ee},set:(te,Y,Ee)=>(N(),O&&(O[Y]=Ee),!0),deleteProperty:(te,Y)=>(N(),O&&delete O[Y],!0),defineProperty:(te,Y,Ee)=>(N(),O&&Object.defineProperty(O,Y,Ee),!0)})}return Array.isArray(U)?(0,y.$4m)(U):U};P=K(P,m)}return P},update:(m,d,P,W)=>{m=s?`${s}.${m}`:m;const K=S(P);return d!==void 0?this.b.$updateConfigurationOption(K,m,d,h,W):this.b.$removeConfigurationOption(K,m,h,W)},inspect:m=>{m=s?`${s}.${m}`:m;const d=this.e.inspect(m,h,this.c.workspace);if(d)return{key:m,defaultValue:(0,y.$4m)(d.policy?.value??d.default?.value),globalValue:(0,y.$4m)(d.user?.value??d.application?.value),workspaceValue:(0,y.$4m)(d.workspace?.value),workspaceFolderValue:(0,y.$4m)(d.workspaceFolder?.value),defaultLanguageValue:(0,y.$4m)(d.default?.override),globalLanguageValue:(0,y.$4m)(d.user?.override??d.application?.override),workspaceLanguageValue:(0,y.$4m)(d.workspace?.override),workspaceFolderLanguageValue:(0,y.$4m)(d.workspaceFolder?.override),languageIds:(0,y.$4m)(d.overrideIdentifiers)}}};return typeof I=="object"&&(0,y.$7m)(u,I,!1),Object.freeze(u)}g(s){const o=w=>(0,g.$Af)(w)?new Proxy(w,{get:(h,I)=>o(h[I]),set:(h,I,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(h,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(h,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return o(s)}h(s,o,w){const h=D.$sn.test(s)?4:this.d.get(s),I=w?`[${w.value}] `:"";if(h===4){typeof o?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){o?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,o){const w=new l.$Dn(s,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,I)=>w.affectsConfiguration(h,E(I))})}k(s){return s.reduce((o,w)=>(o.set(w[0],w[1]),o),new Map)}}e.$0bc=n,e.$$bc=(0,k.$Oh)("IExtHostConfiguration")}),define(Ae[111],Re([1,0,2,12,5,3,7,33,60,34,20,63,17,27,4,13,22,14,80,214,9]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f,t,i,c,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.$8cc=e.$7cc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var v;(function(K){function U(O){if(O!=null)return O}K.from=U;function B(O){if(O!=null)return O}K.to=B})(v||(v={}));var n;(function(K){function U(O){if(O!=null)return O}K.from=U;function B(O){if(O!=null)return O}K.to=B})(n||(n={}));var r;(function(K){function U(O){if(O!=null)return O}K.from=U;function B(O){if(O!=null)return O}K.to=B})(r||(r={}));var s;(function(K){function U(N){if(N){const te=N;return te&&!!te.process}else return!1}K.is=U;function B(N){if(N==null)return;const te={process:N.process,args:N.args};return N.options&&(te.options=r.from(N.options)),te}K.from=B;function O(N){if(N!=null)return new A.$YK(N.process,N.args,N.options)}K.to=O})(s||(s={}));var o;(function(K){function U(O){if(O!=null)return O}K.from=U;function B(O){if(O!=null)return O}K.to=B})(o||(o={}));var w;(function(K){function U(N){if(N){const te=N;return te&&(!!te.commandLine||!!te.command)}else return!1}K.is=U;function B(N){if(N==null)return;const te={};return N.commandLine!==void 0?te.commandLine=N.commandLine:(te.command=N.command,te.args=N.args),N.options&&(te.options=o.from(N.options)),te}K.from=B;function O(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.$ZK(N.commandLine,N.options):new A.$ZK(N.command,N.args?N.args:[],N.options)}K.to=O})(w||(w={}));var h;(function(K){function U(N){if(N){const te=N;return te&&te.customExecution==="customExecution"}else return!1}K.is=U;function B(N){return{customExecution:"customExecution"}}K.from=B;function O(N,te){return te.get(N)}K.to=O})(h||(e.CustomExecutionDTO=h={}));var I;(function(K){function U(B,O){let N;return B.scope!==void 0&&typeof B.scope!="number"?N=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===A.TaskScope.Workspace&&O&&O.workspaceFile?N=O.workspaceFile:N=b.$LF),{id:B._id,workspaceFolder:N}}K.from=U})(I||(e.TaskHandleDTO=I={}));var S;(function(K){function U(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}K.from=U})(S||(S={}));var u;(function(K){function U(N,te){if(N==null)return[];const Y=[];for(const Ee of N){const Se=B(Ee,te);Se&&Y.push(Se)}return Y}K.fromMany=U;function B(N,te){if(N==null)return;let Y;N.execution instanceof A.$YK?Y=s.from(N.execution):N.execution instanceof A.$ZK?Y=w.from(N.execution):N.execution&&N.execution instanceof A.$1K&&(Y=h.from(N.execution));const Ee=v.from(N.definition);let Se;return N.scope?typeof N.scope=="number"?Se=N.scope:Se=N.scope.uri:Se=A.TaskScope.Workspace,!Ee||!Se?void 0:{_id:N._id,definition:Ee,name:N.name,source:{extensionId:te.identifier.value,label:N.source,scope:Se},execution:Y,isBackground:N.isBackground,group:S.from(N.group),presentationOptions:n.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}K.from=B;async function O(N,te,Y){if(N==null)return;let Ee;s.is(N.execution)?Ee=s.to(N.execution):w.is(N.execution)?Ee=w.to(N.execution):h.is(N.execution)&&(Ee=h.to(N._id,Y));const Se=v.to(N.definition);let Pe;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Pe=N.source.scope:Pe=await te.resolveWorkspaceFolder(y.URI.revive(N.source.scope)):Pe=A.TaskScope.Workspace),!Se||!Pe)return;const ge=new A.$2K(Se,Pe,N.name,N.source.label,Ee,N.problemMatchers);return N.isBackground!==void 0&&(ge.isBackground=N.isBackground),N.group!==void 0&&(ge.group=A.$XK.from(N.group._id),ge.group&&N.group.isDefault&&(ge.group=new A.$XK(ge.group.id,ge.group.label),N.group.isDefault===!0&&(ge.group.isDefault=N.group.isDefault))),N.presentationOptions&&(ge.presentationOptions=n.to(N.presentationOptions)),N._id&&(ge._id=N._id),N.detail&&(ge.detail=N.detail),ge}K.to=O})(u||(e.TaskDTO=u={}));var m;(function(K){function U(O){return O}K.from=U;function B(O){if(O)return Object.assign(Object.create(null),O)}K.to=B})(m||(m={}));class d{#e;constructor(U,B,O){this._id=B,this.a=O,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let P=class{constructor(U,B,O,N,te,Y,Ee,Se){this.q=new C.$Nd,this.r=new C.$Nd,this.s=new C.$Nd,this.t=new C.$Nd,this.a=U.getProxy(T.$cK.MainThreadTask),this.b=O,this.c=N,this.d=te,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Ee,this.g=Se,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,B,O){if(!O)return new A.$eK(()=>{});const N=this.w();return this.j.set(N,{type:B,provider:O,extension:U}),this.a.$registerTaskProvider(N,B),new A.$eK(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(U,B){this.a.$registerTaskSystem(U,B)}fetchTasks(U){return this.a.$fetchTasks(m.from(U)).then(async B=>{const O=[];for(const N of B){const te=await u.to(N,this.b,this.m);te&&O.push(te)}return O})}get taskExecutions(){const U=[];return this.k.forEach(B=>U.push(B)),U}terminateTask(U){if(!(U instanceof d))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,B,O){const N=this.m.get(U.id);N&&(this.o.set(U.id,N),this.e.attachPtyToTerminal(B,await N.callback(O))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const B=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:B})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const B=await this.y(U.id);this.s.fire({execution:B,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const B=await this.y(U.id);this.t.fire({execution:B,exitCode:U.exitCode})}$provideTasks(U,B){const O=this.j.get(U);if(!O)return Promise.reject(new Error("no handler found"));const N=[],te=(0,M.$Mg)(()=>O.provider.provideTasks(R.CancellationToken.None)).then(Y=>this.u(B,N,O,Y));return new Promise(Y=>{te.then(Ee=>{Promise.all(N).then(()=>{Y(Ee)})})})}async $resolveTask(U,B){const O=this.j.get(U);if(!O)return Promise.reject(new Error("no handler found"));if(B.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${O.type}].`);const N=await u.to(B,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const te=await O.provider.resolveTask(N,R.CancellationToken.None);if(!te)return;this.z(te,O);const Y=u.from(te,O.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(te.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(Y.execution)&&await this.x(Y,te,!0),await this.v(Y)}w(){return this.h++}async x(U,B,O){const N=await this.a.$createTaskId(U);!O&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,B.execution)),this.m.set(N,B.execution)}async y(U,B){if(typeof U=="string"){const te=this.l.get(U);if(!te)throw new E.$bb("Unexpected: The specified task is missing an execution");return te}const O=this.l.get(U.id);if(O)return O;const N=new Promise((te,Y)=>{function Ee(Se,Pe,ge){ge?te(new d(Se,Pe.id,ge)):Y("Unexpected: Task does not exist.")}B?Ee(this,U,B):u.to(U.task,this.b,this.m).then(Se=>Ee(this,U,Se))});return this.l.set(U.id,N),N.then(te=>(this.k.set(U.id,te),te),te=>Promise.reject(te))}z(U,B){U._deprecated&&this.g.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const O=this.n.values();let N=O.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=O.next()}};e.$7cc=P,e.$7cc=P=qe([Ke(0,a.$dM),Ke(1,p.$tM),Ke(2,l.$8bc),Ke(3,D.$oM),Ke(4,g.$$bc),Ke(5,k.$qcc),Ke(6,i.$9i),Ke(7,c.$Xbc)],P);let W=class extends P{constructor(U,B,O,N,te,Y,Ee,Se){super(U,B,O,N,te,Y,Ee,Se),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:t.$i(0)})}async executeTask(U,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const O=u.from(B,U);if(O===void 0)throw new Error("Task is not valid");if(h.is(O.execution))await this.x(O,B,!1);else throw new E.$_;const N=await this.y(await this.a.$getTaskExecution(O),B);return this.a.$executeTask(O).catch(te=>{throw new Error(te)}),N}u(U,B,O,N){const te=[];if(N)for(const Y of N){this.z(Y,O),(!Y.definition||!U[Y.definition.type])&&this.f.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const Ee=u.from(Y,O.extension);Ee&&h.is(Ee.execution)?(te.push(Ee),B.push(this.x(Ee,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:te,extension:O.extension}}async v(U){if(h.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,B,O){}};e.$8cc=W,e.$8cc=W=qe([Ke(0,a.$dM),Ke(1,p.$tM),Ke(2,l.$8bc),Ke(3,D.$oM),Ke(4,g.$$bc),Ke(5,k.$qcc),Ke(6,i.$9i),Ke(7,c.$Xbc)],W),e.$9cc=(0,$.$Oh)("IExtHostTask")}),define(Ae[268],Re([1,0,19,20,37,38,23,59,48]),function(be,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=void 0;class g{constructor(a,p,$){this.k=a,this.l=p,this.o=$,this.e=!1,this.f=0,this.g=!1,this.a=a.filePattern,this.b=a.includePattern&&T.$vj(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.h=new Set,this.j=a.excludePattern&&T.$vj(a.excludePattern)}cancel(){this.g=!0,this.h.forEach(a=>a.cancel()),this.h=new Set}search(a){const p=this.k.folderQueries||[];return new Promise(($,f)=>{const t=i=>{this.f++,a(i)};if(this.g)return $({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const c=i.toString(),b=y.$nc(c);this.j&&this.j(c,b)||this.v(t,{base:i,basename:b})}),Promise.all(p.map(i=>this.p(i,t))).then(i=>{$({limitHit:this.e,stats:i[0]||void 0})},i=>{f(new Error((0,C.$zi)(i)))})})}async p(a,p){const $=new M.$Xd,f=this.q(a),t=this.r(),i=new D.$XI(this.k,a),c=!i.hasSiblingExcludeClauses();let b;try{this.h.add($),b=l.$Jd.create();const E=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,$.token),v=b.elapsed(),n=l.$Jd.create();return this.g&&!this.e||(E&&E.forEach(r=>{const s=y.$gc.relative(a.folder.path,r.path);if(c){const o=y.$nc(r.path);this.v(p,{base:a.folder,relativePath:s,basename:o});return}this.s(t,a.folder,s,p)}),this.g&&!this.e)?null:(this.u(t,i,p),{providerTime:v,postProcessTime:n.elapsed()})}finally{$.dispose(),this.h.delete($)}}q(a){const p=(0,D.$WI)(this.k.includePattern,a.includePattern),$=(0,D.$WI)(this.k.excludePattern,a.excludePattern);return{folder:a.folder,excludes:$,includes:p,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}s({pathToEntries:a},p,$,f){if($===this.a){const i=y.$nc(this.a);this.v(f,{base:p,relativePath:this.a,basename:i})}function t(i){const c=y.$nc(i),b=y.$mc(i);let E=a[b];E||(E=a[b]=[],t(b)),E.push({base:p,relativePath:i,basename:c})}t($)}u({rootEntries:a,pathToEntries:p},$,f){const t=this,i=this.a;function c(b){const E=(0,D.$ZI)(()=>b.map(v=>v.basename));for(let v=0,n=b.length;v<n;v++){const r=b[v],{relativePath:s,basename:o}=r;if($.matchesExcludesSync(s,o,i!==o?E:void 0))continue;const w=p[s];if(w)c(w);else{if(s===i)continue;t.v(f,r)}if(t.e)break}}c(a)}v(a,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||a(p))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(a,p,$,f){const t=this.c(a.cacheKey),i=new g(a,p,t&&t.token);let c=0;const b=E=>{c+=E.length,$(E.map(v=>this.d(v)))};return this.e(i,R.a,b,f).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:E.stats}}))}clearCache(a){this.c(a)?.cancel()}c(a){if(a)return this.b.has(a)||this.b.set(a,new M.$Xd),this.b.get(a)}d(a){return a.relativePath?{resource:A.$vg(a.base,a.relativePath)}:{resource:a.base}}e(a,p,$,f){const t=f.onCancellationRequested(()=>{a.cancel()}),i=b=>{b&&(c.push(b),p>0&&c.length>=p&&($(c),c=[]))};let c=[];return a.search(i).then(b=>(c.length&&$(c),t.dispose(),b),b=>(c.length&&$(c),t.dispose(),Promise.reject(b)))}}e.$gdc=R}),define(Ae[269],Re([1,0,18,232,38,90,28,13,19,23,16,15,2,284,167,44,14,55,102,267,48]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f,t,i,c,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=e.$SJ=void 0;let v=class{constructor(m,d,P,W,K){this.a=m,this.b=d,this.c=P,this.d=W,this.e=K}text(m,d,P={}){m=this.f(m,P);const W=this.a.getValue(),K=d&&d.some(B=>!this.a.getValue({resource:B}).search.useRipgrep);return{...this.h(d?.map(i.$0h),P),type:2,contentPattern:m,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:W.search.usePCRE2||K||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(m,d){const P=this.a.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const W={...m,wordSeparators:P.editor.wordSeparators};return this.j(m,d)&&(W.isCaseSensitive=!0),this.k(m)&&(W.isMultiline=!0),d.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=d.notebookSearchConfig.includeMarkupInput),d.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=d.notebookSearchConfig.includeMarkupPreview),d.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=d.notebookSearchConfig.includeCodeInput),d.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=d.notebookSearchConfig.includeOutput),W}file(m,d={}){return{...this.h(m,d),type:1,filePattern:d.filePattern?d.filePattern.trim():d.filePattern,exists:d.exists,sortByScore:d.sortByScore,cacheKey:d.cacheKey}}g(m,d){return m?(m=Array.isArray(m)?m.map(w):w(m),d?this.parseSearchPaths(m):{pattern:r(...Array.isArray(m)?m:[m])}):{}}h(m=[],d={}){const P=this.g(d.includePattern,d.expandPatterns),W=this.g(d.excludePattern,d.expandPatterns),K=m.length>1,U=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(N=>this.q(N,d,W)):m.map(N=>this.r(N,d,W,K))).filter(N=>!!N),B={_reason:d._reason,folderQueries:U,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:d.extraFileResources,excludePattern:W.pattern,includePattern:P.pattern,onlyOpenEditors:d.onlyOpenEditors,maxResults:d.maxResults};if(d.onlyOpenEditors){const N=y.$Hb(y.$Rb(this.c.groups.map(Ee=>Ee.editors.map(Se=>Se.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const te=N.filter(Ee=>(0,E.$NI)(B,Ee.fsPath)),Y=this.i(te);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...B,...Y}}const O=d.extraFileResources&&d.extraFileResources.filter(N=>(0,E.$NI)(B,N.fsPath));return B.extraFileResources=O&&O.length?O:void 0,B}i(m){const d=[],P=new A.$Ac,W={};let K=!1;return m.forEach(U=>{if(U.scheme===l.Schemas.walkThrough)return;if((0,g.$zg)(U)){const O=this.b.getWorkspaceFolder(U)?.uri??U.with({path:D.$mc(U.fsPath)});let N=P.get(O);N||(K=!0,N={folder:O,includePattern:{}},d.push(N),P.set(O,N));const te=D.$lc(O.fsPath,U.fsPath);(0,k.$Jf)(N.includePattern)[te.replace(/\\/g,"/")]=!0}else U.fsPath&&(K=!0,W[U.fsPath]=!0)}),{folderQueries:d,includePattern:W,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(m,d){if(d.isSmartCase){if(m.isRegExp){if(R.$pf(m.pattern,!0))return!0}else if(R.$pf(m.pattern))return!0}return!!m.isCaseSensitive}k(m){return m.isMultiline||m.isRegExp&&(0,p.$qB)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const d=Y=>D.$ic(Y)||/^\.\.?([\/\\]|$)/.test(Y),W=(Array.isArray(m)?m:s(m)).map(Y=>{const Ee=this.e.resolvedUserHome;return Ee?(0,T.$qv)(Y,Ee.scheme===l.Schemas.file?Ee.fsPath:Ee.path):Y}),K=M.$J(W,Y=>d(Y)?"searchPaths":"exprSegments"),U=(K.exprSegments||[]).map(Y=>R.$Ke(Y,"/")).map(Y=>R.$Ke(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),o(Y))),B={},O=this.m(K.searchPaths||[]);O&&O.length&&(B.searchPaths=O);const N=y.$Rb(U),te=r(...N);return te&&(B.pattern=te),B}l(m,d){return d.disregardExcludeSettings?void 0:(0,E.$MI)(m,!d.disregardSearchExcludeSettings)}m(m){if(!m||!m.length)return[];const d=m.flatMap(W=>{let{pathPortion:K,globPortion:U}=n(W);return U&&(U=h(U)),this.n(K).flatMap(O=>this.o(O,U))}),P=new Map;return d.forEach(W=>{const K=W.searchPath.toString(),U=P.get(K);U?W.pattern&&(U.pattern=U.pattern||{},U.pattern[W.pattern]=!0):P.set(K,{searchPath:W.searchPath,pattern:W.pattern?r(W.pattern):void 0})}),Array.from(P.values())}n(m){if(D.$ic(m)){const d=this.b.getWorkspace().folders;return d[0]&&d[0].uri.scheme!==l.Schemas.file?[{searchPath:d[0].uri.with({path:m})}]:[{searchPath:a.URI.file(D.$hc(m))}]}if(this.b.getWorkbenchState()===2){const d=this.b.getWorkspace().folders[0].uri;if(m=w(m),m.startsWith("../")||m===".."){const W=D.$gc.resolve(d.path,m);return[{searchPath:d.with({path:W})}]}const P=h(m);return[{searchPath:d,pattern:P}]}else{if(m==="./"||m===".\\")return[];{const d=m.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(K=>{const U=d.match(new RegExp(`^${R.$Fe(K.name)}(?:/(.*)|$)`));return U?{match:U,folder:K}:null}).filter(k.$Gf);if(W.length)return W.map(K=>{const U=K.match[1];return{searchPath:K.folder.uri,pattern:U&&h(U)}});{const K=m.match(/\.[\/\\](.+)[\/\\]?/),U=K?K[1]:m,B=$.localize(0,null,U);throw new Error(B)}}}}o(m,d){const P=m.pattern&&d?`${m.pattern}/${d}`:m.pattern||d,W=[{searchPath:m.searchPath,pattern:P}];return P&&!P.endsWith("**")&&W.push({searchPath:m.searchPath,pattern:P+"/**"}),W}q(m,d,P){const W=this.r((0,i.$0h)(m.searchPath),d,P,!1);return W?{...W,includePattern:m.pattern}:null}r(m,d,P,W){let K;const U=a.URI.isUri(m)?m:m.uri;if(P.searchPaths){const Y=P.searchPaths.filter(Ee=>(0,g.$og)(Ee.searchPath,U))[0];if(Y&&!Y.pattern)return null;Y&&(K=Y.pattern)}const B=this.a.getValue({resource:U}),N={...this.l(B,d)||{},...K||{}},te=a.URI.isUri(m)?(0,g.$sg)(m):m.name;return{folder:U,folderName:W?te:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof d.disregardIgnoreFiles=="boolean"?d.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof d.disregardGlobalIgnoreFiles=="boolean"?d.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof d.disregardParentIgnoreFiles=="boolean"?d.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof d.ignoreSymlinks=="boolean"?d.ignoreSymlinks:!B.search.followSymlinks}}};e.$SJ=v,e.$SJ=v=qe([Ke(0,f.$ii),Ke(1,i.$Xh),Ke(2,c.$aC),Ke(3,t.$9i),Ke(4,b.$QJ)],v);function n(u){const m=u.match(/[\*\{\}\(\)\[\]\?]/);if(m){const d=m.index,P=u.substr(0,d).match(/[/|\\][^/\\]*$/);if(P){let W=u.substr(0,P.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:u.substr((P.index||0)+1)}}}return{pathPortion:u}}function r(...u){return u.length?u.reduce((m,d)=>(m[d]=!0,m),Object.create(null)):void 0}function s(u){return C.$tj(u,",").map(m=>m.trim()).filter(m=>!!m.length)}function o(u){return[`**/${u}/**`,`**/${u}`].map(d=>d.replace(/\*\*\/\*\*/g,"**"))}function w(u){return u.replace(/\\/g,"/")}function h(u){return w(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(u){return u.replace(/([?*[\]])/g,"[$1]")}function S(u,m){u=y.$Mb(u,W=>W.toString());const d=[],P=m.getWorkspace();return u&&u.forEach(W=>{let K;if(m.getWorkbenchState()===2)K=(0,g.$xg)(P.folders[0].uri,W),K&&K!=="."&&(K="./"+K);else{const U=m.getWorkspaceFolder(W);if(U){const B=U.name;if(P.folders.filter(N=>N.name===B).length===1){const N=(0,g.$xg)(U.uri,W);N===""?K=`./${U.name}`:K=`./${U.name}/${N}`}else K=W.fsPath}}K&&d.push(I(K))}),d}e.$TJ=S}),define(Ae[270],Re([1,0,23,2,20,9,4,269,48,55]),function(be,e,y,M,C,T,A,l,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wlb=e.$vlb=void 0;const R=7e3;function k(f,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const c=[],b=[];for(const o of i)if(/^workspaceContains:/.test(o)){const w=o.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||f.forceUsingSearch?b.push(w):c.push(w)}if(c.length===0&&b.length===0)return Promise.resolve(void 0);let E;const v=new Promise((o,w)=>{E=o}),n=o=>E({activationEvent:o}),r=Promise.all(c.map(o=>a(f,o,n))).then(()=>{}),s=p(f,t.identifier,b,n);return Promise.all([r,s]).then(()=>{E(void 0)}),v}e.$vlb=k;async function a(f,t,i){for(const c of f.folders)if(await f.exists(y.$vg(M.URI.revive(c),t))){i(`workspaceContains:${t}`);return}}async function p(f,t,i,c){if(i.length===0)return Promise.resolve(void 0);const b=new C.$Xd,E=f.checkExists(f.folders,i,b.token),v=setTimeout(async()=>{b.cancel(),f.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},R);let n=!1;try{n=await E}catch(r){T.$4(r)||T.$1(r)}b.dispose(),clearTimeout(v),n&&c(`workspaceContains:${i.join(",")}`)}function $(f,t,i,c){const b=f.get(A.$Nh),E=f.get(D.$EI),n=b.createInstance(l.$SJ).file(t.map(r=>(0,g.$0h)(M.URI.revive(r))),{_reason:"checkExists",includePattern:i,exists:!0});return E.fileSearch(n,c).then(r=>!!r.limitHit,r=>T.$4(r)?!1:Promise.reject(r))}e.$wlb=$}),define(Ae[35],Re([1,0,148,19,87,23,12,6,49,2,14,3,34,209,84,33,25,106,9,21,26,188,7,97,4,27,85,17,71,86,63,5,270,83,190,13,81,59,22,82]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f,t,i,c,b,E,v,n,r,s,o,w,h,I,S,u,m,d,P,W,K,U,B,O,N){"use strict";var te;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=e.$Ecc=e.$Dcc=e.$Ccc=e.$Bcc=void 0,e.$Bcc=(0,s.$Oh)("IHostUtils");let Y=te=class extends l.$Sc{constructor(x,z,V,ue,ye,we,pe,De,ne,le,re,oe){super(),this.X=oe,this.a=this.B(new m.$Nd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=z,this.g=V,this.f=pe,this.j=ue,this.m=ye,this.s=we,this.t=ne,this.u=le,this.w=re,this.y=this.g.getProxy(k.$cK.MainThreadWorkspace),this.z=this.g.getProxy(k.$cK.MainThreadTelemetry),this.C=this.g.getProxy(k.$cK.MainThreadExtensionService),this.D=new A.$Sg,this.F=new A.$Sg,this.G=new A.$Sg,this.H=new A.$Sg,this.I=new se(this.f.extensions.activationEvents),this.L=new i.$e4b(this.I,this.f.extensions.allExtensions);const he=new b.$5l(this.f.extensions.myExtensions);this.J=new i.$e4b(this.I,me(this.L,he)),O.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Pe(this.J)}`)),this.M=new $.$icc(this.g,this.s),this.N=new P.$ucc(this.g),this.O=De,this.h=x.createChild(new I.$Mh([$.$jcc,this.M],[P.$vcc,this.N])),this.P=this.B(new p.$hcc(this.J,this.L,{onExtensionActivationError:(Ie,F,q)=>{this.C.$onExtensionActivationError(Ie,c.$3(F),q)},actualActivateExtension:async(Ie,F)=>{if(i.$e4b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,F),new p.$gcc;const q=this.J.getExtensionDescription(Ie);return this.db(q,F)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(x){c.$1(x)}}async Y(){this.O.onWillDeactivateAll();let x=[];try{x=this.J.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this.cb(ye))}catch{}await Promise.all(x)}terminate(x,z=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${x}`),this.s.flush(),this.u.dispose(),this.P.dispose(),c.setUnexpectedErrorHandler(ue=>{this.s.error(ue)}),this.g.dispose();const V=this.Y();Promise.race([(0,A.$Ug)(5e3),V]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${z}`):this.s.info(`Extension host exiting with code ${z}`),this.s.flush(),this.s.dispose(),this.c.exit(z)})}isActivated(x){return this.G.isOpen()?this.P.isActivated(x):!1}async getExtension(x){const z=await this.C.$getExtension(x);return z&&{...z,identifier:new b.$4l(z.identifier.value),extensionLocation:g.URI.revive(z.extensionLocation)}}Z(x,z){return this.P.activateByEvent(x,z)}$(x,z){return this.P.activateById(x,z)}activateByIdWithErrors(x,z){return this.$(x,z).then(()=>{const V=this.P.getActivatedExtension(x);if(V.activationFailed)return Promise.reject(V.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(x=>this.J)}getExtensionExports(x){if(this.G.isOpen())return this.P.getActivatedExtension(x).exports;try{return this.P.getActivatedExtension(x).exports}catch{return null}}async ab(x){if(x.scheme===K.Schemas.file&&this.c.fsRealpath){const z=await this.c.fsRealpath(x.fsPath);return g.URI.file(z)}return x}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(x=>new ce(x))),this.Q}async bb(x){const z=D.$Uh.forUris(V=>T.$mg.ignorePathCasing(V));return await Promise.all(x.map(async V=>{if(this.ub(V)){const ue=await this.ab(V.extensionLocation);z.set(ue,V)}})),z}cb(x){let z=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(x))return z;const V=this.P.getActivatedExtension(x);if(!V)return z;try{typeof V.module.deactivate=="function"&&(z=Promise.resolve(V.module.deactivate()).then(void 0,ue=>(this.s.error(ue),Promise.resolve(void 0))))}catch(ue){this.s.error(`An error occurred when deactivating the extension '${x.value}':`),this.s.error(ue)}try{(0,l.$Nc)(V.subscriptions)}catch(ue){this.s.error(`An error occurred when deactivating the subscriptions for extension '${x.value}':`),this.s.error(ue)}return z}async db(x,z){return this.f.remote.isRemote?this.C.$onWillActivateExtension(x.identifier):await this.C.$onWillActivateExtension(x.identifier),this.fb(x,z).then(V=>{const ue=V.activationTimes;return this.C.$onDidActivateExtension(x.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,z),this.eb(x,z,"success",ue),V},V=>{throw this.eb(x,z,"failure"),V})}eb(x,z,V,ue){const ye=Se(x,z);this.z.$publicLog2("extensionActivationTimes",{...ye,...ue||{},outcome:V})}fb(x,z){const V=Se(x,z);this.z.$publicLog2("activatePlugin",V);const ue=this.ub(x);if(!ue)return Promise.resolve(new p.$fcc(p.$ccc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${x.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${x.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this.s.flush();const ye=new p.$dcc(z.startup);return Promise.all([this.vb(x,(0,T.$vg)(x.extensionLocation,ue),ye),this.gb(x)]).then(we=>(C.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),te.hb(this.s,x.identifier,we[0],we[1],ye))).then(we=>(C.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),we))}gb(x){const z=new v.$lcc(x,this.M),V=new v.$kcc(x.identifier.value,!1,this.M),ue=new W.$wcc(x,this.N),ye=x.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,we=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([z.whenReady,V.whenReady,this.O.whenReady]).then(()=>{const pe=this;let De,ne;const le=(0,t.$_E)(x,"ipc")?this.f.messagePorts?.get(b.$4l.toKey(x.identifier)):void 0;return Object.freeze({globalState:z,workspaceState:V,secrets:ue,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(re){return M.$jc(x.extensionLocation.fsPath,re)},get storagePath(){return pe.O.workspaceValue(x)?.fsPath},get globalStoragePath(){return pe.O.globalValue(x).fsPath},get logPath(){return M.$jc(pe.f.logsLocation.fsPath,x.identifier.value)},get logUri(){return g.URI.joinPath(pe.f.logsLocation,x.identifier.value)},get storageUri(){return pe.O.workspaceValue(x)},get globalStorageUri(){return pe.O.globalValue(x)},get extensionMode(){return ye},get extension(){return De===void 0&&(De=new ge(pe,x.identifier,x,we,!1)),De},get extensionRuntime(){return(0,t.$aF)(x,"extensionRuntime"),pe.extensionRuntime},get environmentVariableCollection(){return pe.u.getEnvironmentVariableCollection(x)},get messagePassingProtocol(){if(!ne){if(!le)return;const re=m.Event.buffer(m.Event.fromDOMEventEmitter(le,"message",oe=>oe.data));le.start(),ne={onDidReceiveMessage:re,postMessage:le.postMessage.bind(le)}}return ne}})})}static hb(x,z,V,ue,ye){return V=V||{activate:void 0,deactivate:void 0},this.ib(x,z,V,ue,ye).then(we=>new p.$ecc(!1,null,ye.build(),V,we,ue.subscriptions))}static ib(x,z,V,ue,ye){if(typeof V.activate=="function")try{ye.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${z.value}`);const we=typeof global=="object"?global:self,pe=V.activate.apply(we,[ue]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve(pe).then(De=>(ye.activateResolveStop(),De))}catch(we){return Promise.reject(we)}else return Promise.resolve(V)}jb(x,z){this.$(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:z}).then(void 0,V=>{this.s.error(V)})}kb(x,z=0){const ue=Date.now();(0,O.$B)(()=>{for(let ye=z;ye<x.length;ye+=1){const we=x[ye];for(const pe of we.activationEvents??[])if(pe==="onStartupFinished")if(Date.now()-ue>50){this.kb(x,ye);break}else this.jb(we,pe)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(x=>{const z=x.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),V=this.J.getAllExtensionDescriptions();if(z)this.kb(V);else for(const ue of V)if(ue.activationEvents)for(const ye of ue.activationEvents)ye==="onStartupFinished"&&this.jb(ue,ye)})}mb(){const x=this.Z("*",!0).then(void 0,we=>{this.s.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.nb(we.added)));const z=this.j.workspace?this.j.workspace.folders:[],V=this.nb(z),ue=this.pb(),ye=Promise.all([ue,x,V]).then(()=>{});return Promise.race([ye,(0,A.$Ug)(1e4)]).then(()=>{this.lb()}),ye}nb(x){return x.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(z=>this.ob(x,z))).then(()=>{})}async ob(x,z){if(this.isActivated(z.identifier))return;const V=!this.f.remote.isRemote&&!!this.f.remote.authority,ue={logService:this.s,folders:x.map(we=>we.uri),forceUsingSearch:V||!this.c.fsExists,exists:we=>this.c.fsExists(we.fsPath),checkExists:(we,pe,De)=>this.y.$checkExists(we,pe,De)},ye=await(0,d.$vlb)(ue,z);if(ye)return this.$(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:ye.activationEvent}).then(void 0,we=>this.s.error(we))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(x){throw console.error(x),x}}async qb(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:z}=this.f.environment;if(!x||!z)throw new Error(y.localize(0,null));const V=await this.vb(null,z,new p.$dcc(!1));if(!V||typeof V.run!="function")throw new Error(y.localize(1,null,z.toString()));return new Promise((ue,ye)=>{const we=(ne,le)=>{ne?(O.$t&&this.s.error("Test runner called back with error",ne),ye(ne)):(O.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),ue(typeof le=="number"&&le>0?1:0))},pe=(0,T.$jg)(z),De=V.run(pe,we);De&&De.then&&De.then(()=>{O.$t&&this.s.info("Test runner finished successfully."),ue(0)}).catch(ne=>{O.$t&&this.s.error("Test runner finished with error",ne),ye(ne instanceof Error&&ne.stack?ne.stack:String(ne))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Ug)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(x,z){return this.R[x]=z,(0,l.$Qc)(()=>{delete this.R[x]})}async getRemoteExecServer(x){const{resolver:z}=await this.sb(x);return z?.resolveExecServer?.(x,{resolveAttempt:0})}async sb(x){const z=x.indexOf("+");if(z===-1)throw new n.$kK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const V=x.substr(0,z);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${V}`,!1),{authorityPrefix:V,resolver:this.R[V]}}async $resolveAuthority(x,z){const V=B.$Jd.create(!1),ue=()=>`[resolveAuthority(${(0,r.$Sk)(x)},${z})][${V.elapsed()}ms] `,ye=Q=>this.s.info(`${ue()}${Q}`),we=Q=>this.s.warn(`${ue()}${Q}`),pe=(Q,H=void 0)=>this.s.error(`${ue()}${Q}`,H),De=Q=>{if(Q instanceof n.$kK)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q},ne=async Q=>{ye(`activating resolver for ${Q}...`);const{resolver:H,authorityPrefix:_}=await this.sb(Q);if(!H)throw pe(`no resolver for ${_}`),new n.$kK(`No remote extension installed to resolve ${_}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:_,remoteAuthority:Q}},le=x.split(/@|%40/g).reverse();ye(`activating remote resolvers ${le.join(" -> ")}`);let re;try{re=await Promise.all(le.map(ne)).catch(async Q=>{if(!(Q instanceof n.$kK)||Q._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Q;return we(`resolving nested authorities failed: ${Q.message}`),[await ne(x)]})}catch(Q){return De(Q)}const oe=new A.$5g;oe.cancelAndSet(()=>ye("waiting..."),1e3);let he,Ie;for(const[Q,{authorityPrefix:H,resolver:_,remoteAuthority:ae}]of re.entries())try{if(Q===re.length-1)ye("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${H}`),he=await _.resolve(ae,{resolveAttempt:z,execServer:Ie}),C.mark(`code/extHost/didResolveAuthorityOK/${H}`),ye("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(_,n.$jK.isManagedResolvedAuthority(he)?he:void 0));else{if(ye(`invoking resolveExecServer() for ${ae}`),C.mark(`code/extHost/willResolveExecServer/${H}`),Ie=await _.resolveExecServer?.(ae,{resolveAttempt:z,execServer:Ie}),!Ie)throw new n.$kK(`Exec server was not available for ${ae}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(Ne){return C.mark(`code/extHost/didResolveAuthorityError/${H}`),pe("returned an error",Ne),oe.dispose(),De(Ne)}oe.dispose();const F={environmentTunnels:he.environmentTunnels,features:he.tunnelFeatures},q={extensionHostEnv:he.extensionHostEnv,isTrusted:he.isTrusted,authenticationSession:he.authenticationSessionForInitializingExtensions?{id:he.authenticationSessionForInitializingExtensions.id,providerId:he.authenticationSessionForInitializingExtensions.providerId}:void 0};ye(`returned ${n.$jK.isManagedResolvedAuthority(he)?"managed authority":`${he.host}:${he.port}`}`);let J;if(n.$jK.isManagedResolvedAuthority(he)){const Q=z;this.X.setFactory(Q,he.makeConnection),J={authority:x,connectTo:new r.$Pk(Q),connectionToken:he.connectionToken}}else J={authority:x,connectTo:new r.$Qk(he.host,he.port),connectionToken:he.connectionToken};return{type:"ok",value:{authority:J,options:q,tunnelInformation:F}}}async $getCanonicalURI(x,z){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$Sk)(x)})`);const{resolver:V}=await this.sb(x);if(!V)return null;const ue=g.URI.revive(z);if(typeof V.getCanonicalURI>"u")return ue;const ye=await(0,A.$Mg)(()=>V.getCanonicalURI(ue));return ye||ue}$startExtensionHost(x){x.toAdd.forEach(ue=>ue.extensionLocation=g.URI.revive(ue.extensionLocation));const{globalRegistry:z,myExtensions:V}=Ee(this.I,this.L,this.J,x);return this.L.set(z.getAllExtensionDescriptions()),this.J.set(V),O.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Pe(this.J)}`)),this.rb()}$activateByEvent(x,z){return z===1?this.D.wait().then(V=>this.Z(x,!1)):this.G.wait().then(V=>this.Z(x,!1))}async $activate(x,z){return await this.G.wait(),this.J.getExtensionDescription(x)?(await this.$(x,z),!0):!1}async $deltaExtensions(x){x.toAdd.forEach(we=>we.extensionLocation=g.URI.revive(we.extensionLocation));const{globalRegistry:z,myExtensions:V}=Ee(this.I,this.L,this.J,x),ue=await this.bb(V);return(await this.getExtensionPathIndex()).setSearchTree(ue),this.L.set(z.getAllExtensionDescriptions()),this.J.set(V),O.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){const z=E.$be.alloc(x),V=Math.random()%256;for(let ue=0;ue<x;ue++)z.writeUInt8(V,ue);return z}async $updateRemoteConnectionData(x){this.W=x,this.a.fire()}};e.$Ccc=Y,e.$Ccc=Y=te=qe([Ke(0,s.$Nh),Ke(1,e.$Bcc),Ke(2,h.$dM),Ke(3,f.$8bc),Ke(4,a.$$bc),Ke(5,R.$9i),Ke(6,o.$tM),Ke(7,w.$occ),Ke(8,S.$2vb),Ke(9,u.$qcc),Ke(10,U.$ycc),Ke(11,N.$zcc)],Y);function Ee($e,x,z,V){$e.addActivationEvents(V.addActivationEvents);const ue=new i.$e4b($e,x.getAllExtensionDescriptions());ue.deltaExtensions(V.toAdd,V.toRemove);const ye=new b.$5l(z.getAllExtensionDescriptions().map(pe=>pe.identifier));for(const pe of V.myToRemove)ye.delete(pe);for(const pe of V.myToAdd)ye.add(pe);const we=me(ue,ye);return{globalRegistry:ue,myExtensions:we}}function Se($e,x){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}function Pe($e){return $e.getAllExtensionDescriptions().map(x=>x.identifier.value).join(",")}e.$Dcc=(0,s.$Oh)("IExtHostExtensionService");class ge{#e;#t;#i;constructor(x,z,V,ue,ye){this.#e=x,this.#t=z,this.#i=V.identifier,this.id=V.identifier.value,this.extensionUri=V.extensionLocation,this.extensionPath=M.$hc((0,T.$jg)(V.extensionLocation)),this.packageJSON=V,this.extensionKind=ue,this.isFromDifferentExtensionHost=ye}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Ecc=ge;function me($e,x){return $e.getAllExtensionDescriptions().filter(z=>x.has(z.identifier))}class ce{constructor(x){this.a=x}setSearchTree(x){this.a=x}findSubstr(x){return this.a.findSubstr(x)}forEach(x){return this.a.forEach(x)}}e.$Fcc=ce;class se{constructor(x){this.a=new b.$6l,this.addActivationEvents(x)}readActivationEvents(x){return this.a.get(x.identifier)}addActivationEvents(x){for(const z of Object.keys(x))this.a.set(z,x[z])}}}),define(Ae[271],Re([1,0,87,2,3,34,25,21,17,27,4,35,14,16]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=void 0;let f=class{constructor(E,v,n,r,s,o,w){this.c=E,this.d=v,this.e=n,this.f=r,this.g=s,this.h=o,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const E=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const v=await this.g.getExtensionPathIndex();this.register(new i(this.c,v,this.d,E,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(c,v,this.h.environment.appUriScheme))}register(E){if("nodeModuleName"in E)if(Array.isArray(E.nodeModuleName))for(const v of E.nodeModuleName)this.a.set(v,E);else this.a.set(E.nodeModuleName,E);typeof E.alternativeModuleName=="function"&&this.b.push(v=>E.alternativeModuleName(v))}};e.$4dc=f,e.$4dc=f=qe([Ke(2,R.$Nh),Ke(3,T.$$bc),Ke(4,k.$Dcc),Ke(5,g.$tM),Ke(6,a.$9i)],f);let t=class{static{$=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(E){if(E.environment.appRoot&&$.a.size){const v=(0,p.$Fe)(this.c(E.environment.appRoot.fsPath)),n="[a-z0-9_.-]",r=`@${n}+\\/${n}+|${n}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${v}/${s}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(E){if(!this.b)return;const v=this.b.exec(this.c(E));if(!v)return;const[,n,r,s]=v,o=$.a.get(r);if(o!==void 0)return console.warn(`${r} as been renamed to ${o}, please update your imports`),n+o+s}c(E){return E.replace(/\\/g,"/")}};t=$=qe([Ke(0,g.$tM)],t);class i{constructor(E,v,n,r,s){this.c=E,this.d=v,this.e=n,this.f=r,this.g=s,this.nodeModuleName="vscode",this.a=new l.$6l}load(E,v){const n=this.d.findSubstr(v);if(n){let r=this.a.get(n.identifier);return r||(r=this.c(n,this.e,this.f),this.a.set(n.identifier,r)),r}if(!this.b){let r="";this.d.forEach((s,o)=>r+=`	${o} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${v}. These are the extension path mappings: 
${r}`),this.b=this.c(A.$7E,this.e,this.f)}return this.b}}let c=class{constructor(E,v,n){this.e=E,this.f=v,this.nodeModuleName=["open","opn"],this.d=n.getProxy(C.$cK.MainThreadTelemetry);const r=n.getProxy(C.$cK.MainThreadWindow);this.c=(s,o)=>{const w=M.URI.parse(s);return o?this.g(s,o):w.scheme==="http"||w.scheme==="https"?r.$openUri(w,s,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?r.$openUri(w,s,{}):this.g(s,o)}}load(E,v,n){const r=this.e.findSubstr(v);return r&&(this.a=r.identifier.value,this.h()),this.b=n(E),this.c}g(E,v){return this.i(),this.b(E,v)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};c=qe([Ke(2,D.$dM)],c)}),define(Ae[112],Re([1,0,41,6,19,73,4,60,61,35,7,33,200,34]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.$_cc=void 0,e.$_cc=(0,A.$Oh)("IExtHostVariableResolverProvider");class $ extends a.$eN{constructor(i,c,b,E,v,n,r){function s(){if(b){const o=b.activeEditor();if(o)return o.document.uri;const w=E.tabGroups.all.find(h=>h.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof R.$WL||w.input instanceof R.$2L)return w.input.modified;if(w.input instanceof R.$VL||w.input instanceof R.$1L||w.input instanceof R.$YL)return w.input.uri}}}super({getFolderUri:o=>{const w=n.folders.filter(h=>h.name===o);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(o,w)=>v.getConfiguration(void 0,o).get(w),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=s();if(o)return C.$hc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const o=s();if(o){const w=c.getWorkspaceFolder(o);if(w)return C.$hc(w.uri.fsPath)}}},getSelectedText:()=>{if(b){const o=b.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(b){const o=b.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>i.getExtension(o)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(T.env))}}let f=class extends M.$Sc{constructor(i,c,b,E,v){super(),this.b=i,this.c=c,this.g=b,this.h=E,this.j=v,this.a=new y.$V(async()=>{const n=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new $(this.b,this.c,this.g,this.j,n,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$adc=f,e.$adc=f=qe([Ke(0,g.$Dcc),Ke(1,k.$8bc),Ke(2,l.$oM),Ke(3,p.$$bc),Ke(4,D.$0cc)],f)}),define(Ae[113],Re([1,0,12,5,2,4,3,61,35,17,7,33,193,195,34,112]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=e.$ddc=e.$cdc=e.$bdc=void 0,e.$bdc=(0,T.$Oh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,s,o,w,h,I){this.E=s,this.F=o,this.G=w,this.H=h,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$Nd,this.n=new M.$Nd,this.o=new M.$Nd,this.u=new M.$Nd,this.k=r.getProxy(A.$cK.MainThreadDebugService),this.y=new M.$Nd,this.A=new M.$Nd,this.v=new c(this.k),this.w=new Map,this.F.getExtensionRegistry().then(S=>{S.onDidChange(u=>{this.J(S)}),this.J(S)})}asDebugSourceUri(r,s){const o=r;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let w=`debug:${encodeURIComponent(o.path||"")}`,h="?";return s&&(w+=`${h}session=${encodeURIComponent(s.id)}`,h="&"),w+=`${h}ref=${o.sourceReference}`,C.URI.parse(w)}else{if(o.path)return C.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const s=[];for(const o of r.getAllExtensionDescriptions())if(o.contributes){const w=o.contributes.debuggers;if(w&&w.length>0)for(const h of w)(0,p.$oF)(h)&&s.push(h.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(s=>r.push(s)),r}addBreakpoints(r){const s=r.filter(h=>{const I=h.id;return this.w.has(I)?!1:(this.w.set(I,h),!0)});this.U(s,[],[]);const o=[],w=new Map;for(const h of s)if(h instanceof R.$dL){let I=w.get(h.location.uri.toString());I||(I={type:"sourceMulti",uri:h.location.uri,lines:[]},w.set(h.location.uri.toString(),I),o.push(I)),I.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof R.$eL&&o.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(r){const s=r.filter(I=>this.w.delete(I.id));this.U([],s,[]);const o=s.filter(I=>I instanceof R.$dL).map(I=>I.id),w=s.filter(I=>I instanceof R.$eL).map(I=>I.id),h=s.filter(I=>I instanceof R.$fL).map(I=>I.id);return this.k.$unregisterBreakpoints(o,w,h)}startDebugging(r,s,o){return this.k.$startDebugging(r?r.uri:void 0,s,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,o){if(!s)return new R.$eK(()=>{});const w=this.d++;return this.f.push({type:r,handle:w,provider:s}),this.k.$registerDebugConfigurationProvider(r,o,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,w),new R.$eK(()=>{this.f=this.f.filter(h=>h.provider!==s),this.k.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(r,s,o){if(!o)return new R.$eK(()=>{});if(!this.Q(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.N(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:s,handle:w,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(s,w),new R.$eK(()=>{this.h=this.h.filter(h=>h.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new R.$eK(()=>{});const o=this.i++;return this.j.push({type:r,handle:o,factory:s}),new R.$eK(()=>{this.j=this.j.filter(w=>w.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let o;const w=await this.W(r);return w&&(o={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,s)}K(r,s){if(r.type==="implementation")return new E(r.implementation)}L(){}async $startDASession(r,s){const o=this,w=await this.V(s);return this.S(this.N(w.type),w).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const I=this.M(h),S=this.K(I,w);if(!S)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const u=S;return this.B.set(r,u),this.R(w).then(m=>(m&&this.C.set(r,m),u.onMessage(async d=>{if(d.type==="request"&&d.command==="handshake"){const P=d,W={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const K=await this.D.sign(P.arguments.value);W.body={signature:K},u.sendResponse(W)}else throw new Error("no signer")}catch(K){W.success=!1,W.message=K.message,u.sendResponse(W)}}else m&&m.onDidSendMessage&&m.onDidSendMessage(d),d=(0,p.$tF)(d,!0),o.k.$acceptDAMessage(r,d)}),u.onError(d=>{m&&m.onError&&m.onError(d),this.k.$acceptDAError(r,d.name,d.message,d.stack)}),u.onExit(d=>{m&&m.onExit&&m.onExit(d??void 0,void 0),this.k.$acceptDAExit(r,d??void 0,void 0)}),m&&m.onWillStartSession&&m.onWillStartSession(),u.startSession()))})}$sendDAMessage(r,s){s=(0,p.$sF)(s,!1);const o=this.C.get(r);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(s),this.B.get(r)?.sendMessage(s)}$stopDASession(r){const s=this.C.get(r);this.C.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const o=this.B.get(r);return this.B.delete(r),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],o=[],w=[];if(r.added)for(const h of r.added){const I=h.id;if(I&&!this.w.has(I)){let S;if(h.type==="function")S=new R.$eL(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")S=new R.$fL(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const u=C.URI.revive(h.uri);S=new R.$dL(new R.$qK(u,new R.$fK(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,R.$bL)(S,I),this.w.set(I,S),s.push(S)}}if(r.removed)for(const h of r.removed){const I=this.w.get(h);I&&(this.w.delete(h),o.push(I))}if(r.changed){for(const h of r.changed)if(h.id){const I=this.w.get(h.id);if(I){if(I instanceof R.$eL&&h.type==="function"){const S=I;S.enabled=h.enabled,S.condition=h.condition,S.hitCondition=h.hitCondition,S.logMessage=h.logMessage,S.functionName=h.functionName}else if(I instanceof R.$dL&&h.type==="source"){const S=I;S.enabled=h.enabled,S.condition=h.condition,S.hitCondition=h.hitCondition,S.logMessage=h.logMessage,S.location=new R.$qK(C.URI.revive(h.uri),new R.$fK(h.line,h.character))}w.push(I)}}}this.U(s,o,w)}async $acceptStackFrameFocus(r){let s;const o=r.sessionId?await this.V(r.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?s=new R.$lL(o,r.threadId):s=new R.$kL(o,r.threadId,r.frameId),this.z=s,this.A.fire(this.z)}$provideDebugConfigurations(r,s,o){return(0,y.$Mg)(async()=>{const w=this.P(r);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(s);return w.provideDebugConfigurations(h,o)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(r,s,o,w){return(0,y.$Mg)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(s);return h.resolveDebugConfiguration(I,o,w)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,o,w){return(0,y.$Mg)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(s);return h.resolveDebugConfigurationWithSubstitutedVariables(I,o,w)})}async $provideDebugAdapter(r,s){const o=this.O(r);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.V(s);return this.S(o,w).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(r){const s=await this.V(r);this.m.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.V(r);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,s){(await this.V(r))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const w={session:await this.V(r),event:s.event,body:s.body};this.u.fire(w)}M(r){if(r instanceof R.$gL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof R.$hL)return{type:"server",port:r.port,host:r.host};if(r instanceof R.$iL)return{type:"pipeServer",path:r.path};if(r instanceof R.$jL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const s=this.h.filter(o=>o.type===r);if(s.length>0)return s[0].factory}O(r){const s=this.h.filter(o=>o.handle===r);if(s.length>0)return s[0].factory}P(r){const s=this.f.filter(o=>o.handle===r);if(s.length>0)return s[0].provider}Q(r,s){if(r.contributes){const o=r.contributes.debuggers;if(o&&o.length>0){for(const w of o)if(w.label&&w.type&&w.type===s)return!0}}return!1}R(r){const o=r.configuration.type,w=this.j.filter(h=>h.type===o||h.type==="*").map(h=>(0,y.$Mg)(()=>h.factory.createDebugAdapterTracker(r)).then(I=>I,I=>null));return Promise.race([Promise.all(w).then(h=>{const I=h.filter(S=>!!S);if(I.length>0)return new b(I)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(r,s){const o=s.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new R.$hL(o));if(r){const h=await this.F.getExtensionRegistry();return(0,y.$Mg)(()=>r.createDebugAdapterDescriptor(s,this.T(s,h))).then(I=>{if(I)return I})}const w=await this.F.getExtensionRegistry();return Promise.resolve(this.T(s,w))}T(r,s){}U(r,s,o){(r.length>0||s.length>0||o.length>0)&&this.y.fire(Object.freeze({added:r,removed:s,changed:o}))}async V(r){if(r)if(typeof r=="string"){const s=this.l.get(r);if(s)return s}else{let s=this.l.get(r.id);if(!s){const o=await this.W(r.folderUri),w=r.parent?this.l.get(r.parent):void 0;s=new i(this.k,r.id,r.type,r.name,o,r.configuration,w),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}W(r){if(r){const s=C.URI.revive(r);return this.E.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$cdc=t,e.$cdc=t=qe([Ke(0,g.$dM),Ke(1,k.$8bc),Ke(2,D.$Dcc),Ke(3,$.$$bc),Ke(4,l.$0cc),Ke(5,f.$_cc)],t);class i{constructor(r,s,o,w,h,I,S){this.d=r,this.f=s,this.g=o,this.h=w,this.i=h,this.j=I,this.k=S}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,s){return this.d.$customDebugAdapterRequest(this.f,r,s)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$ddc=i;class c{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$edc=c;class b{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.d.forEach(o=>o.onExit?o.onExit(r,s):void 0)}}class E extends a.$2cb{constructor(r){super(),this.h=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let v=class extends t{constructor(r,s,o,w,h,I){super(r,s,o,w,h,I)}};e.$fdc=v,e.$fdc=v=qe([Ke(0,g.$dM),Ke(1,k.$8bc),Ke(2,D.$Dcc),Ke(3,$.$$bc),Ke(4,l.$0cc),Ke(5,f.$_cc)],v)}),define(Ae[272],Re([1,0,9,87,2,3,263,14,70,71,27,172,17,56,35,58]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=e.$5dc=void 0;class t{static async installEarlyHandler(b){Error.stackTraceLimit=100;const E=b.get(l.$9i),n=b.get(a.$dM).getProxy(T.$cK.MainThreadErrors);y.setUnexpectedErrorHandler(r=>{E.error(r);const s=y.$3(r);n.$onUnexpectedError(s)})}static async installFullHandler(b){const E=b.get(l.$9i),v=b.get(a.$dM),n=b.get($.$Dcc),r=b.get(f.$xM),s=v.getProxy(T.$cK.MainThreadExtensionService),o=v.getProxy(T.$cK.MainThreadErrors),w=await n.getExtensionPathIndex(),h=new WeakMap;function I(m,d){if(h.has(m))return h.get(m).stack;let P="",W,K;for(const B of d)P+=`
	at ${B.toString()}`,K=B.getFileName(),!W&&K&&(W=w.findSubstr(C.URI.file(K)));const U=`${m.name||"Error"}: ${m.message||""}${P}`;return h.set(m,{extensionIdentifier:W?.identifier,stack:U}),U}const S=Symbol("prepareStackTrace wrapped");let u=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(m){if(m===I||!m||m[S]){u=m||I;return}u=function(d,P){return I(d,P),m.call(Error,d,P)},Object.assign(u,{[S]:!0})}}),y.setUnexpectedErrorHandler(m=>{E.error(m);const d=y.$3(m),P=h.get(m);if(!P?.extensionIdentifier){o.$onUnexpectedError(d);return}s.$onExtensionRuntimeError(P.extensionIdentifier,d);const W=r.onExtensionError(P.extensionIdentifier,m);E.trace("forwarded error to extension?",W,P)})}}e.$5dc=t;class i{constructor(b,E,v,n,r){this.a=v,this.b=new A.$n4b(b,null,n),E=i.e(E,this.b);const s=new g.$Mh(...(0,D.$vr)());s.set(R.$tM,{_serviceBrand:void 0,...E,messagePorts:r}),s.set(a.$dM,new a.$eM(this.b)),s.set(p.$5bc,new p.$6bc(n)),s.set($.$Bcc,v);const o=new k.$bq(s,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(w=>w.get(l.$9i)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",E),this.c=o.invokeFunction(w=>w.get($.$Dcc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(b){const E=this.b.getProxy(T.$cK.MainThreadExtensionService);return C.URI.revive(await E.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,E){b.extensions.allExtensions.forEach(n=>{n.extensionLocation=C.URI.revive(E.transformIncomingURIs(n.extensionLocation))}),b.environment.appRoot=C.URI.revive(E.transformIncomingURIs(b.environment.appRoot));const v=b.environment.extensionDevelopmentLocationURI;return v&&(b.environment.extensionDevelopmentLocationURI=v.map(n=>C.URI.revive(E.transformIncomingURIs(n)))),b.environment.extensionTestsLocationURI=C.URI.revive(E.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=C.URI.revive(E.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=C.URI.revive(E.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=C.URI.revive(E.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=C.URI.revive(E.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=C.URI.revive(E.transformIncomingURIs(b.logsLocation)),b.workspace=E.transformIncomingURIs(b.workspace),b}}e.$6dc=i}),define(Ae[273],Re([1,0,18,12,20,37,13,19,23,2,48]),function(be,e,y,M,C,T,A,l,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=e.$jdc=e.$idc=e.$hdc=void 0;class k{constructor(c,b,E,v){this.d=c,this.e=b,this.f=E,this.g=v,this.a=null,this.b=!1,this.c=0}search(c,b){const E=this.d.folderQueries||[],v=new C.$Xd(b);return new Promise((n,r)=>{this.a=new p(c);let s=!1;const o=(w,h)=>{if(!s&&!this.b){const I=this.h(w);f(w)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,s=!0,v.cancel(),w=this.j(w,this.d.maxResults-this.c));const S=this.h(w);this.c+=S,(S>0||!f(w))&&this.a.add(w,h)}};Promise.all(E.map((w,h)=>this.k(w,I=>o(I,h),v.token))).then(w=>{v.dispose(),this.a.flush();const h=w.some(I=>!!I&&!!I.limitHit);n({limitHit:this.b||h,messages:(0,y.$Rb)(w.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},w=>{v.dispose();const h=(0,T.$zi)(w);r(new Error(h))})})}h(c){return f(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,b){const E=Array.isArray(c.ranges)?c.ranges:[c.ranges],v=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:E.slice(0,b),preview:{matches:v.slice(0,b),text:c.preview.text},uri:c.uri}}async k(c,b,E){const v=new R.$XI(this.d,c),n=[],r={report:w=>{if(!this.l(w))return;const h=c.folder.scheme===A.Schemas.file?(0,R.$YI)(()=>this.f.readdir(D.$ug(w.uri))):void 0,I=D.$xg(c.folder,w.uri);if(I){const S=v.includedInQuery(I,l.$nc(I),h);(0,M.$Gg)(S)?n.push(S.then(u=>{u&&b(w)})):S&&b(w)}}},s=this.n(c),o=await this.e.provideTextSearchResults(a(this.d.contentPattern),s,r,E);return n.length&&await Promise.all(n),o}l(c){if(f(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const b=(0,R.$WI)(this.d.includePattern,c.includePattern),E=(0,R.$WI)(this.d.excludePattern,c.excludePattern),v={folder:g.URI.from(c.folder),excludes:E,includes:b,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.$hdc=k;function a(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class p{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new t(512,b=>this.g(b))}add(c,b){this.d&&(this.b!==b||!D.$og(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:c.uri,results:[]}),this.d.results.push($(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$idc=p;function $(i){return f(i)?{preview:{matches:(0,y.$2b)(i.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:i.preview.text},ranges:(0,y.$2b)(i.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function f(i){return!!i.preview}e.$jdc=f;class t{static{this.a=4e3}static{this.b=50}constructor(c,b){this.g=c,this.h=b,this.c=0,this.d=[],this.e=0}addItem(c,b){c&&this.j(c,b)}addItems(c,b){c&&this.k(c,b)}j(c,b){this.d.push(c),this.e+=b,this.l()}k(c,b){this.d=this.d.concat(c),this.e+=b,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$kdc=t}),define(Ae[114],Re([1,0,6,3,4,268,17,56,14,2,273]),function(be,e,y,M,C,T,A,l,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=e.$mdc=e.$ldc=void 0,e.$ldc=(0,C.$Oh)("IExtHostSearch");let k=class{constructor(f,t,i){this.k=f,this.l=t,this.n=i,this.c=this.k.getProxy(M.$cK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new T.$gdc}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,t){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(f)),(0,y.$Qc)(()=>{this.g.delete(f),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(f,t){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(f)),(0,y.$Qc)(()=>{this.i.delete(f),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(f,t,i,c){const b=a(i),E=this.h.get(f);if(E)return this.j.fileSearch(b,E,v=>{this.c.$handleFileMatch(f,t,v.map(n=>n.resource))},c);throw new Error("unknown provider: "+f)}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,t,i,c){const b=this.e.get(f);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const E=a(i);return this.q(E,b).search(n=>this.c.$handleTextMatch(f,t,n),c)}$enableExtensionHostSearch(){}q(f,t){return new R.$hdc(f,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$mdc=k,e.$mdc=k=qe([Ke(0,A.$dM),Ke(1,l.$5bc),Ke(2,D.$9i)],k);function a($){return{...$,folderQueries:$.folderQueries&&$.folderQueries.map(p),extraFileResources:$.extraFileResources&&$.extraFileResources.map(f=>g.URI.revive(f))}}e.$ndc=a;function p($){return{...$,folder:g.URI.revive($.folder)}}}),define(Ae[274],Re([1,0,20,9,5,29,2,135,285,124,133,39,3,79,225,224,31,226,34,228,229,230,203,231,60,35,234,235,240,241,243,109,207,249,250,253,84,63,255,210,8,7,54,258,64,108,33,21,198,239,53,107,111,113,114,14,56,17,27,244,196,86,80,217,256,85,62,261,259,260,218,40,254,257,83,61,58,245,110,246,13,95,206,189,237,6,25,194,81,185,247,248,219,236,205,238,82,251,222,252,223,216,233,220,221]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f,t,i,c,b,E,v,n,r,s,o,w,h,I,S,u,m,d,P,W,K,U,B,O,N,te,Y,Ee,Se,Pe,ge,me,ce,se,$e,x,z,V,ue,ye,we,pe,De,ne,le,re,oe,he,Ie,F,q,J,Q,H,_,ae,Ne,Ue,Qe,Ge,_e,Ze,xe,it,tt,ze,st,Z,X,ve,Be,Oe,Xe,nt,ft,wt,Pt,Yt,Gt,pt,jt,Nt,Bt,At,Rt,Ot,Wt,Jt,Kt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;function Mt(ut){const ht=ut.get(ne.$tM),Lt=ut.get(Ne.$Ubc),qt=ut.get(J.$ncc),kt=ut.get(o.$Dcc),at=ut.get(me.$8bc),vt=ut.get(Ze.$xM),Ht=ut.get(c.$$bc),Ct=ut.get(pe.$5bc),We=ut.get(De.$dM),Ce=ut.get(U.$jcc),Me=ut.get(q.$occ),fe=ut.get(we.$0i),G=ut.get(we.$9i),Fe=ut.get(oe.$2vb),je=ut.get(he.$Xbc),Je=ut.get(ge.$2cc),Ve=ut.get(Ge.$vcc),et=ut.get(_e.$0cc),bt=ut.get(Nt.$zcc);We.set(a.$dK.ExtHostFileSystemInfo,Lt),We.set(a.$dK.ExtHostLogLevelServiceShape,fe),We.set(a.$dK.ExtHostWorkspace,at),We.set(a.$dK.ExtHostConfiguration,Ht),We.set(a.$dK.ExtHostExtensionService,kt),We.set(a.$dK.ExtHostStorage,Ce),We.set(a.$dK.ExtHostTunnelService,Fe),We.set(a.$dK.ExtHostWindow,Je),We.set(a.$dK.ExtHostSecretState,Ve),We.set(a.$dK.ExtHostTelemetry,vt),We.set(a.$dK.ExtHostEditorTabs,et),We.set(a.$dK.ExtHostManagedSockets,bt);const zt=We.set(a.$dK.ExtHostDecorations,ut.get(z.$6cc)),Dt=We.set(a.$dK.ExtHostDocumentsAndEditors,ut.get(s.$oM)),lt=We.set(a.$dK.ExtHostCommands,ut.get(t.$zM)),gt=We.set(a.$dK.ExtHostTerminalService,ut.get(B.$qcc)),yt=We.set(a.$dK.ExtHostDebugService,ut.get(ue.$bdc)),mi=We.set(a.$dK.ExtHostSearch,ut.get(ye.$ldc)),St=We.set(a.$dK.ExtHostTask,ut.get(V.$9cc)),Si=We.set(a.$dK.ExtHostOutputService,ut.get(m.$Lcc)),ui=We.set(a.$dK.ExtHostLocalization,ut.get(nt.$ycc)),$i=We.set(a.$dK.ExtHostUrls,new Se.$Ucc(We)),It=We.set(a.$dK.ExtHostDocuments,new r.$Sbc(We,Dt)),fn=We.set(a.$dK.ExtHostDocumentContentProviders,new v.$acc(We,Dt,G)),ri=We.set(a.$dK.ExtHostDocumentSaveParticipant,new n.$bcc(G,It,We.getProxy(a.$cK.MainThreadBulkEdits))),Et=We.set(a.$dK.ExtHostNotebook,new le.$rdc(We,lt,Dt,It,qt)),pi=We.set(a.$dK.ExtHostNotebookDocuments,new X.$Jdc(Et)),vi=We.set(a.$dK.ExtHostNotebookEditors,new Z.$Idc(G,Et)),si=We.set(a.$dK.ExtHostNotebookKernels,new xe.$Fdc(We,ht,Et,lt,G)),Ii=We.set(a.$dK.ExtHostNotebookRenderers,new tt.$Hdc(We,Et)),Ci=We.set(a.$dK.ExtHostNotebookDocumentSaveParticipant,new pt.$Pdc(G,Et,We.getProxy(a.$cK.MainThreadBulkEdits))),Ft=We.set(a.$dK.ExtHostEditors,new O.$Scc(We,Dt)),bi=We.set(a.$dK.ExtHostTreeViews,new N.$Tcc(We.getProxy(a.$cK.MainThreadTreeViews),lt,G)),Pi=We.set(a.$dK.ExtHostEditorInsets,new se.$3cc(We.getProxy(a.$cK.MainThreadEditorInsets),Ft,ht.remote)),oi=We.set(a.$dK.ExtHostDiagnostics,new b.$Wbc(We,G,Lt,Dt)),li=We.set(a.$dK.ExtHostLanguages,new S.$Icc(We,It,lt.converter,Ct)),ct=We.set(a.$dK.ExtHostLanguageFeatures,new I.$1bc(We,Ct,It,lt,oi,G,je,vt)),Ai=We.set(a.$dK.ExtHostFileSystem,new w.$Gcc(We,ct)),Zt=We.set(a.$dK.ExtHostFileSystemEventService,new h.$Hcc(We,G,Dt)),ii=We.set(a.$dK.ExtHostQuickOpen,(0,P.$Ncc)(We,at,lt)),Ri=We.set(a.$dK.ExtHostSCM,new W.$Pcc(We,lt,It,G)),Mi=We.set(a.$dK.ExtHostQuickDiff,new Pt.$Mdc(We,Ct)),Fi=We.set(a.$dK.ExtHostShare,new Bt.$Rdc(We,Ct)),Xi=We.set(a.$dK.ExtHostComments,(0,i.$4bc)(We,lt,It)),Ti=We.set(a.$dK.ExtHostProgress,new d.$Mcc(We.getProxy(a.$cK.MainThreadProgress))),Yi=We.set(a.$dK.ExtHosLabelService,new $e.$4cc(We)),Li=We.set(a.$dK.ExtHostTheming,new re.$sdc(We)),ai=We.set(a.$dK.ExtHostAuthentication,new Ie.$tdc(We)),gn=We.set(a.$dK.ExtHostTimeline,new F.$vdc(We,lt)),Ni=We.set(a.$dK.ExtHostWebviews,new Pe.$Xcc(We,ht.remote,at,G,je)),di=We.set(a.$dK.ExtHostWebviewPanels,new _.$xdc(We,Ni,at)),Oi=We.set(a.$dK.ExtHostCustomEditors,new H.$ydc(We,It,Me,Ni,di)),mn=We.set(a.$dK.ExtHostWebviewViews,new Q.$wdc(We,Ni)),hi=We.set(a.$dK.ExtHostTesting,new Ue.$Adc(We,lt,Dt)),Zi=We.set(a.$dK.ExtHostUriOpeners,new Qe.$Edc(We)),zi=We.set(a.$dK.ExtHostProfileContentHandlers,new wt.$Ldc(We));We.set(a.$dK.ExtHostInteractive,new ve.$Kdc(We,Et,Dt,lt,G));const _i=We.set(a.$dK.ExtHostInlineChat,new Gt.$Odc(We,lt,It,G)),fi=We.set(a.$dK.ExtHostChatProvider,new At.$Sdc(We,G)),xi=We.set(a.$dK.ExtHostChatAgents,new Kt.$Xdc(We,fi,G)),$n=We.set(a.$dK.ExtHostChatAgents2,new Vt.$Ydc(We,fi,G)),Ui=We.set(a.$dK.ExtHostChatVariables,new Ot.$Udc(We)),gi=We.set(a.$dK.ExtHostChat,new Yt.$Ndc(We,G)),_t=We.set(a.$dK.ExtHostAiRelatedInformation,new Wt.$Vdc(We)),wi=We.set(a.$dK.ExtHostAiEmbeddingVector,new Jt.$Wdc(We)),pn=We.set(a.$dK.ExtHostIssueReporter,new jt.$Qdc(We)),Qt=We.set(a.$dK.ExtHostStatusBar,new K.$Rcc(We,lt.converter)),yi=We.set(a.$dK.ExtHostSpeech,new Rt.$Tdc(We)),en=Object.values(a.$dK);We.assertRegistered(en);const tn=new ae.$zdc(We,Dt),nn=new f.$3bc(We),Ei=new u.$Jcc(We,G),rn=new E.$_bc(We);return $.$2bc.register(lt),function(Le,xt,sn){const mt=function(){let ee=!Le.isUnderDevelopment;function de(){ee||(G.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Te(rt){if(Array.isArray(rt))rt.forEach(Te);else if(typeof rt=="string")de();else{const $t=rt;typeof $t.scheme>"u"&&de(),typeof $t.exclusive=="boolean"&&(0,Oe.$aF)(Le,"documentFiltersExclusive")}return rt}}(),ji={getSession(ee,de,Te){return ai.getSession(Le,ee,de,Te)},getSessions(ee,de){return(0,Oe.$aF)(Le,"authGetSessions"),ai.getSessions(Le,ee,de)},async hasSession(ee,de){return(0,Oe.$aF)(Le,"authSession"),!!await ai.getSession(Le,ee,de,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(ee,de,Te,rt){return ai.registerAuthenticationProvider(ee,de,Te,rt)}},on={registerCommand(ee,de,Te){return lt.registerCommand(!0,ee,de,Te,void 0,Le)},registerTextEditorCommand(ee,de,Te){return lt.registerCommand(!0,ee,(...rt)=>{const $t=Ft.getActiveTextEditor();if(!$t){G.warn("Cannot execute "+ee+" because there is no active text editor.");return}return $t.edit(Tt=>{de.apply(Te,[$t,Tt,...rt])}).then(Tt=>{Tt||G.warn("Edits from command "+ee+" were not applied.")},Tt=>{G.warn("An error occurred while running command "+ee,Tt)})},void 0,void 0,Le)},registerDiffInformationCommand:(ee,de,Te)=>((0,Oe.$aF)(Le,"diffCommand"),lt.registerCommand(!0,ee,async(...rt)=>{const $t=Dt.activeEditor(!0);if(!$t){G.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation($t.id);de.apply(Te,[Tt,...rt])},void 0,void 0,Le)),executeCommand(ee,...de){return lt.executeCommand(ee,...de)},getCommands(ee=!1){return lt.getCommands(ee)}},Bi={get machineId(){return ht.telemetryInfo.machineId},get sessionId(){return ht.telemetryInfo.sessionId},get language(){return ht.environment.appLanguage},get appName(){return ht.environment.appName},get appRoot(){return ht.environment.appRoot?.fsPath??""},get appHost(){return ht.environment.appHost},get uriScheme(){return ht.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return gt.onDidChangeShell},get isTelemetryEnabled(){return vt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return vt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Oe.$aF)(Le,"telemetry"),vt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Oe.$aF)(Le,"telemetry"),vt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ze.$wM)(ht.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,de){return Ze.$vM.validateSender(ee),vt.instantiateLogger(Le,ee,de)},openExternal(ee,de){return Je.openUri(ee,{allowTunneling:!!ht.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===ht.environment.appUriScheme)return $i.createAppUri(ee);try{return await Je.asExternalUri(ee,{allowTunneling:!!ht.remote.authority})}catch(de){if((0,st.$_T)(ee,ze.Schemas.http)||(0,st.$_T)(ee,ze.Schemas.https))return ee;throw de}},get remoteName(){return(0,x.$Uk)(ht.remote.authority)},get remoteAuthority(){return(0,Oe.$aF)(Le,"resolvers"),ht.remote.authority},get uiKind(){return ht.uiKind},get logLevel(){return G.getLevel()},get onDidChangeLogLevel(){return G.onDidChangeLogLevel},registerIssueUriRequestHandler(ee){return(0,Oe.$aF)(Le,"handleIssueUri"),pn.registerIssueUriRequestHandler(Le,ee)},get appQuality(){return(0,Oe.$aF)(Le,"resolvers"),ht.quality},get appCommit(){return(0,Oe.$aF)(Le,"resolvers"),ht.commit}};ht.environment.extensionTestsLocationURI||Object.freeze(Bi);const an={createTestController(ee,de,Te){return hi.createTestController(Le,ee,de,Te)},createTestObserver(){return(0,Oe.$aF)(Le,"testObserver"),hi.createTestObserver()},runTests(ee){return(0,Oe.$aF)(Le,"testObserver"),hi.runTests(ee)},get onDidChangeTestResults(){return(0,Oe.$aF)(Le,"testObserver"),hi.onResultsChanged},get testResults(){return(0,Oe.$aF)(Le,"testObserver"),hi.results}},Di=ht.remote.isRemote?Y.ExtensionKind.Workspace:Y.ExtensionKind.UI,vn={getExtension(ee,de){(0,Oe.$_E)(Le,"extensionsAny")||(de=!1);const Te=xt.mine.getExtensionDescription(ee);if(Te)return new o.$Ecc(kt,Le.identifier,Te,Di,!1);if(de){const rt=xt.all.getExtensionDescription(ee);if(rt)return new o.$Ecc(kt,Le.identifier,rt,Di,!0)}},get all(){const ee=[];for(const de of xt.mine.getAllExtensionDescriptions())ee.push(new o.$Ecc(kt,Le.identifier,de,Di,!1));return ee},get allAcrossExtensionHosts(){(0,Oe.$aF)(Le,"extensionsAny");const ee=new ce.$5l(xt.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),de=[];for(const Te of xt.all.getAllExtensionDescriptions()){const rt=!ee.has(Te.identifier);de.push(new o.$Ecc(kt,Le.identifier,Te,Di,rt))}return de},get onDidChange(){return(0,Oe.$_E)(Le,"extensionsAny")?C.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},cn={createDiagnosticCollection(ee){return oi.createDiagnosticCollection(Le.identifier,ee)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:ee=>oi.getDiagnostics(ee),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(ee,de){return li.changeLanguage(ee.uri,de)},match(ee,de){const Te=It.getDocumentData(de.uri)?.notebook;return(0,R.$oE)(te.LanguageSelector.from(ee),de.uri,de.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(ee,de,Te){return ct.registerCodeActionProvider(Le,mt(ee),de,Te)},registerDocumentPasteEditProvider(ee,de,Te){return(0,Oe.$aF)(Le,"documentPaste"),ct.registerDocumentPasteEditProvider(Le,mt(ee),de,Te)},registerCodeLensProvider(ee,de){return ct.registerCodeLensProvider(Le,mt(ee),de)},registerDefinitionProvider(ee,de){return ct.registerDefinitionProvider(Le,mt(ee),de)},registerDeclarationProvider(ee,de){return ct.registerDeclarationProvider(Le,mt(ee),de)},registerImplementationProvider(ee,de){return ct.registerImplementationProvider(Le,mt(ee),de)},registerTypeDefinitionProvider(ee,de){return ct.registerTypeDefinitionProvider(Le,mt(ee),de)},registerHoverProvider(ee,de){return ct.registerHoverProvider(Le,mt(ee),de,Le.identifier)},registerEvaluatableExpressionProvider(ee,de){return ct.registerEvaluatableExpressionProvider(Le,mt(ee),de,Le.identifier)},registerInlineValuesProvider(ee,de){return ct.registerInlineValuesProvider(Le,mt(ee),de,Le.identifier)},registerDocumentHighlightProvider(ee,de){return ct.registerDocumentHighlightProvider(Le,mt(ee),de)},registerLinkedEditingRangeProvider(ee,de){return ct.registerLinkedEditingRangeProvider(Le,mt(ee),de)},registerReferenceProvider(ee,de){return ct.registerReferenceProvider(Le,mt(ee),de)},registerRenameProvider(ee,de){return ct.registerRenameProvider(Le,mt(ee),de)},registerDocumentSymbolProvider(ee,de,Te){return ct.registerDocumentSymbolProvider(Le,mt(ee),de,Te)},registerWorkspaceSymbolProvider(ee){return ct.registerWorkspaceSymbolProvider(Le,ee)},registerDocumentFormattingEditProvider(ee,de){return ct.registerDocumentFormattingEditProvider(Le,mt(ee),de)},registerDocumentRangeFormattingEditProvider(ee,de){return ct.registerDocumentRangeFormattingEditProvider(Le,mt(ee),de)},registerOnTypeFormattingEditProvider(ee,de,Te,...rt){return ct.registerOnTypeFormattingEditProvider(Le,mt(ee),de,[Te].concat(rt))},registerDocumentSemanticTokensProvider(ee,de,Te){return ct.registerDocumentSemanticTokensProvider(Le,mt(ee),de,Te)},registerDocumentRangeSemanticTokensProvider(ee,de,Te){return ct.registerDocumentRangeSemanticTokensProvider(Le,mt(ee),de,Te)},registerSignatureHelpProvider(ee,de,Te,...rt){return typeof Te=="object"?ct.registerSignatureHelpProvider(Le,mt(ee),de,Te):ct.registerSignatureHelpProvider(Le,mt(ee),de,typeof Te>"u"?[]:[Te,...rt])},registerCompletionItemProvider(ee,de,...Te){return ct.registerCompletionItemProvider(Le,mt(ee),de,Te)},registerInlineCompletionItemProvider(ee,de,Te){return de.handleDidShowCompletionItem&&(0,Oe.$aF)(Le,"inlineCompletionsAdditions"),de.handleDidPartiallyAcceptCompletionItem&&(0,Oe.$aF)(Le,"inlineCompletionsAdditions"),Te&&(0,Oe.$aF)(Le,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Le,mt(ee),de,Te)},registerDocumentLinkProvider(ee,de){return ct.registerDocumentLinkProvider(Le,mt(ee),de)},registerColorProvider(ee,de){return ct.registerColorProvider(Le,mt(ee),de)},registerFoldingRangeProvider(ee,de){return ct.registerFoldingRangeProvider(Le,mt(ee),de)},registerSelectionRangeProvider(ee,de){return ct.registerSelectionRangeProvider(Le,ee,de)},registerCallHierarchyProvider(ee,de){return ct.registerCallHierarchyProvider(Le,ee,de)},registerTypeHierarchyProvider(ee,de){return ct.registerTypeHierarchyProvider(Le,ee,de)},setLanguageConfiguration:(ee,de)=>ct.setLanguageConfiguration(Le,ee,de),getTokenInformationAtPosition(ee,de){return(0,Oe.$aF)(Le,"tokenInformation"),li.tokenAtPosition(ee,de)},registerInlayHintsProvider(ee,de){return ct.registerInlayHintsProvider(Le,ee,de)},createLanguageStatusItem(ee,de){return li.createLanguageStatusItem(Le,ee,de)},registerDocumentDropEditProvider(ee,de,Te){return ct.registerDocumentOnDropEditProvider(Le,ee,de,(0,Oe.$_E)(Le,"dropMetadata")?Te:void 0)}},un={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(ee,de,Te){const rt=await(A.URI.isUri(ee)?Promise.resolve(ki.openTextDocument(ee)):Promise.resolve(ee));return Ft.showTextDocument(rt,de,Te)},createTextEditorDecorationType(ee){return Ft.createTextEditorDecorationType(Le,ee)},onDidChangeActiveTextEditor(ee,de,Te){return Ft.onDidChangeActiveTextEditor(ee,de,Te)},onDidChangeVisibleTextEditors(ee,de,Te){return Ft.onDidChangeVisibleTextEditors(ee,de,Te)},onDidChangeTextEditorSelection(ee,de,Te){return Ft.onDidChangeTextEditorSelection(ee,de,Te)},onDidChangeTextEditorOptions(ee,de,Te){return Ft.onDidChangeTextEditorOptions(ee,de,Te)},onDidChangeTextEditorVisibleRanges(ee,de,Te){return Ft.onDidChangeTextEditorVisibleRanges(ee,de,Te)},onDidChangeTextEditorViewColumn(ee,de,Te){return Ft.onDidChangeTextEditorViewColumn(ee,de,Te)},onDidCloseTerminal(ee,de,Te){return gt.onDidCloseTerminal(ee,de,Te)},onDidOpenTerminal(ee,de,Te){return gt.onDidOpenTerminal(ee,de,Te)},onDidChangeActiveTerminal(ee,de,Te){return gt.onDidChangeActiveTerminal(ee,de,Te)},onDidChangeTerminalDimensions(ee,de,Te){return(0,Oe.$aF)(Le,"terminalDimensions"),gt.onDidChangeTerminalDimensions(ee,de,Te)},onDidChangeTerminalState(ee,de,Te){return gt.onDidChangeTerminalState(ee,de,Te)},onDidWriteTerminalData(ee,de,Te){return(0,Oe.$aF)(Le,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(ee,de,Te)},onDidExecuteTerminalCommand(ee,de,Te){return(0,Oe.$aF)(Le,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(ee,de,Te)},get state(){return Je.getState(Le)},onDidChangeWindowState(ee,de,Te){return Je.onDidChangeWindowState(ee,de,Te)},showInformationMessage(ee,...de){return Ei.showMessage(Le,T.default.Info,ee,de[0],de.slice(1))},showWarningMessage(ee,...de){return Ei.showMessage(Le,T.default.Warning,ee,de[0],de.slice(1))},showErrorMessage(ee,...de){return Ei.showMessage(Le,T.default.Error,ee,de[0],de.slice(1))},showQuickPick(ee,de,Te){return ii.showQuickPick(Le,ee,de,Te)},showWorkspaceFolderPick(ee){return ii.showWorkspaceFolderPick(ee)},showInputBox(ee,de){return ii.showInput(ee,de)},showOpenDialog(ee){return rn.showOpenDialog(Le,ee)},showSaveDialog(ee){return rn.showSaveDialog(ee)},createStatusBarItem(ee,de,Te){let rt,$t,Tt;return typeof ee=="string"?(rt=ee,$t=de,Tt=Te):($t=ee,Tt=de),Qt.createStatusBarEntry(Le,rt,$t,Tt)},setStatusBarMessage(ee,de){return Qt.setStatusBarMessage(ee,de)},withScmProgress(ee){return je.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Ti.withProgress(Le,{location:Y.ProgressLocation.SourceControl},(de,Te)=>ee({report(rt){}}))},withProgress(ee,de){return Ti.withProgress(Le,ee,de)},createOutputChannel(ee,de){return Si.createOutputChannel(ee,de,Le)},createWebviewPanel(ee,de,Te,rt){return di.createWebviewPanel(Le,ee,de,Te,rt)},createWebviewTextEditorInset(ee,de,Te,rt){return(0,Oe.$aF)(Le,"editorInsets"),Pi.createWebviewEditorInset(ee,de,Te,rt,Le)},createTerminal(ee,de,Te){return typeof ee=="object"?"pty"in ee?gt.createExtensionTerminal(ee):gt.createTerminalFromOptions(ee):gt.createTerminal(ee,de,Te)},registerTerminalLinkProvider(ee){return gt.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,de){return gt.registerProfileProvider(Le,ee,de)},registerTerminalQuickFixProvider(ee,de){return(0,Oe.$aF)(Le,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(ee,Le.identifier.value,de)},registerTreeDataProvider(ee,de){return bi.registerTreeDataProvider(ee,de,Le)},createTreeView(ee,de){return bi.createTreeView(ee,de,Le)},registerWebviewPanelSerializer:(ee,de)=>di.registerWebviewPanelSerializer(Le,ee,de),registerCustomEditorProvider:(ee,de,Te={})=>Oi.registerCustomEditorProvider(Le,ee,de,Te),registerFileDecorationProvider(ee){return zt.registerFileDecorationProvider(ee,Le)},registerUriHandler(ee){return $i.registerUriHandler(Le,ee)},createQuickPick(){return ii.createQuickPick(Le)},createInputBox(){return ii.createInputBox(Le)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(ee,de,Te){return Li.onDidChangeActiveColorTheme(ee,de,Te)},registerWebviewViewProvider(ee,de,Te){return mn.registerWebviewViewProvider(Le,ee,de,Te?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,de,Te){return Et.onDidChangeActiveNotebookEditor(ee,de,Te)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,de,Te){return vi.onDidChangeNotebookEditorSelection(ee,de,Te)},onDidChangeNotebookEditorVisibleRanges(ee,de,Te){return vi.onDidChangeNotebookEditorVisibleRanges(ee,de,Te)},showNotebookDocument(ee,de){return Et.showNotebookDocument(ee,de)},registerExternalUriOpener(ee,de,Te){return(0,Oe.$aF)(Le,"externalUriOpener"),Zi.registerExternalUriOpener(Le.identifier,ee,de,Te)},registerProfileContentHandler(ee,de){return(0,Oe.$aF)(Le,"profileContentHandlers"),zi.registrProfileContentHandler(Le,ee,de)},registerQuickDiffProvider(ee,de,Te,rt){return(0,Oe.$aF)(Le,"quickDiffProvider"),Mi.registerQuickDiffProvider(mt(ee),de,Te,rt)},get tabGroups(){return et.tabGroups},registerShareProvider(ee,de){return(0,Oe.$aF)(Le,"shareProvider"),Fi.registerShareProvider(mt(ee),de)}},ki={get rootPath(){return je.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),at.getPath()},set rootPath(ee){throw new M.$9("rootPath")},getWorkspaceFolder(ee){return at.getWorkspaceFolder(ee)},get workspaceFolders(){return at.getWorkspaceFolders()},get name(){return at.name},set name(ee){throw new M.$9("name")},get workspaceFile(){return at.workspaceFile},set workspaceFile(ee){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(ee,de,...Te)=>at.updateWorkspaceFolders(Le,ee,de||0,...Te),onDidChangeWorkspaceFolders:function(ee,de,Te){return at.onDidChangeWorkspace(ee,de,Te)},asRelativePath:(ee,de)=>at.getRelativePath(ee,de),findFiles:(ee,de,Te,rt)=>at.findFiles(ee,de,Te,Le.identifier,rt),findTextInFiles:(ee,de,Te,rt)=>{(0,Oe.$aF)(Le,"findTextInFiles");let $t,Tt;return typeof de=="object"?($t=de,Tt=Te):($t={},Tt=de,rt=Te),at.findTextInFiles(ee,$t||{},Tt,Le.identifier,rt)},save:ee=>((0,Oe.$aF)(Le,"saveEditor"),at.save(ee)),saveAs:ee=>((0,Oe.$aF)(Le,"saveEditor"),at.saveAs(ee)),saveAll:ee=>at.saveAll(ee),applyEdit(ee,de){return tn.applyWorkspaceEdit(ee,Le,de)},createFileSystemWatcher:(ee,de,Te,rt)=>{let $t;return typeof de=="boolean"?$t={ignoreCreateEvents:!!de,ignoreChangeEvents:!!Te,ignoreDeleteEvents:!!rt}:de&&((0,Oe.$aF)(Le,"createFileSystemWatcher"),$t=de),Zt.createFileSystemWatcher(at,Le,ee,$t)},get textDocuments(){return It.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new M.$9("textDocuments")},openTextDocument(ee){let de;const Te=ee;if(typeof ee=="string")de=Promise.resolve(A.URI.file(ee));else if(A.URI.isUri(ee))de=Promise.resolve(ee);else if(!Te||typeof Te=="object")de=It.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(rt=>It.ensureDocumentData(rt).then($t=>$t.document))},onDidOpenTextDocument:(ee,de,Te)=>It.onDidAddDocument(ee,de,Te),onDidCloseTextDocument:(ee,de,Te)=>It.onDidRemoveDocument(ee,de,Te),onDidChangeTextDocument:(ee,de,Te)=>It.onDidChangeDocument(ee,de,Te),onDidSaveTextDocument:(ee,de,Te)=>It.onDidSaveDocument(ee,de,Te),onWillSaveTextDocument:(ee,de,Te)=>ri.getOnWillSaveTextDocumentEvent(Le)(ee,de,Te),get notebookDocuments(){return Et.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,de){let Te;if(A.URI.isUri(ee))Te=ee,await Et.openNotebookDocument(ee);else if(typeof ee=="string")Te=A.URI.revive(await Et.createNotebookDocument({viewType:ee,content:de}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(ee,de,Te){return pi.onDidSaveNotebookDocument(ee,de,Te)},onDidChangeNotebookDocument(ee,de,Te){return pi.onDidChangeNotebookDocument(ee,de,Te)},onWillSaveNotebookDocument(ee,de,Te){return Ci.getOnWillSaveNotebookDocumentEvent(Le)(ee,de,Te)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ee,de,Te,rt){return Et.registerNotebookSerializer(Le,ee,de,Te,(0,Oe.$_E)(Le,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ee,de,Te)=>sn.onDidChangeConfiguration(ee,de,Te),getConfiguration(ee,de){return de=arguments.length===1?void 0:de,sn.getConfiguration(ee,de,Le)},registerTextDocumentContentProvider(ee,de){return fn.registerTextDocumentContentProvider(ee,de)},registerTaskProvider:(ee,de)=>(je.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Le,ee,de)),registerFileSystemProvider(ee,de,Te){return(0,Be.$Pc)(Ai.registerFileSystemProvider(Le,ee,de,Te),qt.addFileSystemProvider(ee,de,Te))},get fs(){return qt.value},registerFileSearchProvider:(ee,de)=>((0,Oe.$aF)(Le,"fileSearchProvider"),mi.registerFileSearchProvider(ee,de)),registerTextSearchProvider:(ee,de)=>((0,Oe.$aF)(Le,"textSearchProvider"),mi.registerTextSearchProvider(ee,de)),registerRemoteAuthorityResolver:(ee,de)=>((0,Oe.$aF)(Le,"resolvers"),kt.registerRemoteAuthorityResolver(ee,de)),registerResourceLabelFormatter:ee=>((0,Oe.$aF)(Le,"resolvers"),Yi.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Oe.$aF)(Le,"resolvers"),kt.getRemoteExecServer(ee)),onDidCreateFiles:(ee,de,Te)=>Zt.onDidCreateFile(ee,de,Te),onDidDeleteFiles:(ee,de,Te)=>Zt.onDidDeleteFile(ee,de,Te),onDidRenameFiles:(ee,de,Te)=>Zt.onDidRenameFile(ee,de,Te),onWillCreateFiles:(ee,de,Te)=>Zt.getOnWillCreateFileEvent(Le)(ee,de,Te),onWillDeleteFiles:(ee,de,Te)=>Zt.getOnWillDeleteFileEvent(Le)(ee,de,Te),onWillRenameFiles:(ee,de,Te)=>Zt.getOnWillRenameFileEvent(Le)(ee,de,Te),openTunnel:ee=>((0,Oe.$aF)(Le,"tunnels"),Fe.openTunnel(Le,ee).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Oe.$aF)(Le,"tunnels"),Fe.getTunnels()},onDidChangeTunnels:(ee,de,Te)=>((0,Oe.$aF)(Le,"tunnels"),Fe.onDidChangeTunnels(ee,de,Te)),registerPortAttributesProvider:(ee,de)=>((0,Oe.$aF)(Le,"portsAttributes"),Fe.registerPortsAttributesProvider(ee,de)),registerTunnelProvider:(ee,de)=>((0,Oe.$aF)(Le,"tunnelFactory"),Fe.registerTunnelProvider(ee,de)),registerTimelineProvider:(ee,de)=>((0,Oe.$aF)(Le,"timeline"),gn.registerTimelineProvider(ee,de,Le.identifier,lt.converter)),get isTrusted(){return at.trusted},requestWorkspaceTrust:ee=>((0,Oe.$aF)(Le,"workspaceTrust"),at.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,de,Te)=>at.onDidGrantWorkspaceTrust(ee,de,Te),registerEditSessionIdentityProvider:(ee,de)=>((0,Oe.$aF)(Le,"editSessionIdentityProvider"),at.registerEditSessionIdentityProvider(ee,de)),onWillCreateEditSessionIdentity:(ee,de,Te)=>((0,Oe.$aF)(Le,"editSessionIdentityProvider"),at.getOnWillCreateEditSessionIdentityEvent(Le)(ee,de,Te)),registerCanonicalUriProvider:(ee,de)=>((0,Oe.$aF)(Le,"canonicalUriProvider"),at.registerCanonicalUriProvider(ee,de)),getCanonicalUri:(ee,de,Te)=>((0,Oe.$aF)(Le,"canonicalUriProvider"),at.provideCanonicalUri(ee,de,Te))},Wi={get inputBox(){return je.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(Le)},createSourceControl(ee,de,Te){return Ri.createSourceControl(Le,ee,de,Te)}},Ki={createCommentController(ee,de){return Xi.createCommentController(Le,ee,de)}},ci={get activeDebugSession(){return yt.activeDebugSession},get activeDebugConsole(){return yt.activeDebugConsole},get breakpoints(){return yt.breakpoints},get stackFrameFocus(){return yt.stackFrameFocus},onDidStartDebugSession(ee,de,Te){return yt.onDidStartDebugSession(ee,de,Te)},onDidTerminateDebugSession(ee,de,Te){return yt.onDidTerminateDebugSession(ee,de,Te)},onDidChangeActiveDebugSession(ee,de,Te){return yt.onDidChangeActiveDebugSession(ee,de,Te)},onDidReceiveDebugSessionCustomEvent(ee,de,Te){return yt.onDidReceiveDebugSessionCustomEvent(ee,de,Te)},onDidChangeBreakpoints(ee,de,Te){return yt.onDidChangeBreakpoints(ee,de,Te)},onDidChangeStackFrameFocus(ee,de,Te){return(0,Oe.$aF)(Le,"debugFocus"),yt.onDidChangeStackFrameFocus(ee,de,Te)},registerDebugConfigurationProvider(ee,de,Te){return yt.registerDebugConfigurationProvider(ee,de,Te||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,de){return yt.registerDebugAdapterDescriptorFactory(Le,ee,de)},registerDebugAdapterTrackerFactory(ee,de){return yt.registerDebugAdapterTrackerFactory(ee,de)},startDebugging(ee,de,Te){return!Te||typeof Te=="object"&&"configuration"in Te?yt.startDebugging(ee,de,{parentSession:Te}):yt.startDebugging(ee,de,Te||{})},stopDebugging(ee){return yt.stopDebugging(ee)},addBreakpoints(ee){return yt.addBreakpoints(ee)},removeBreakpoints(ee){return yt.removeBreakpoints(ee)},asDebugSourceUri(ee,de){return yt.asDebugSourceUri(ee,de)}},Vi={registerTaskProvider:(ee,de)=>St.registerTaskProvider(Le,ee,de),fetchTasks:ee=>St.fetchTasks(ee),executeTask:ee=>St.executeTask(Le,ee),get taskExecutions(){return St.taskExecutions},onDidStartTask:(ee,de,Te)=>St.onDidStartTask(ee,de,Te),onDidEndTask:(ee,de,Te)=>St.onDidEndTask(ee,de,Te),onDidStartTaskProcess:(ee,de,Te)=>St.onDidStartTaskProcess(ee,de,Te),onDidEndTaskProcess:(ee,de,Te)=>St.onDidEndTaskProcess(ee,de,Te)},qi={createNotebookController(ee,de,Te,rt,$t){return si.createNotebookController(Le,ee,de,Te,rt,(0,Oe.$_E)(Le,"notebookMessaging")?$t:void 0)},registerNotebookCellStatusBarItemProvider:(ee,de)=>Et.registerNotebookCellStatusBarItemProvider(Le,ee,de),createRendererMessaging(ee){return Ii.createRendererMessaging(Le,ee)},createNotebookControllerDetectionTask(ee){return(0,Oe.$aF)(Le,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Le,ee)},registerKernelSourceActionProvider(ee,de){return(0,Oe.$aF)(Le,"notebookKernelSource"),si.registerKernelSourceActionProvider(Le,ee,de)},onDidChangeNotebookCellExecutionState(ee,de,Te){return(0,Oe.$aF)(Le,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(ee,de,Te)}},Hi={t(...ee){if(typeof ee[0]=="string"){const de=ee.shift(),Te=!ee||typeof ee[0]!="object"?ee:ee[0];return ui.getMessage(Le.identifier.value,{message:de,args:Te})}return ui.getMessage(Le.identifier.value,ee[0])},get bundle(){return ui.getBundle(Le.identifier.value)},get uri(){return ui.getBundleUri(Le.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(ee,de){return(0,Oe.$aF)(Le,"interactive"),_i.registerProvider(Le,ee,de={label:de?.label??Le.displayName??Le.name})},registerInteractiveSessionProvider(ee,de){return(0,Oe.$aF)(Le,"interactive"),gi.registerChatProvider(Le,ee,de)},sendInteractiveRequestToProvider(ee,de){return(0,Oe.$aF)(Le,"interactive"),gi.sendInteractiveRequestToProvider(ee,de)},get onDidPerformUserAction(){return(0,Oe.$aF)(Le,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(ee,de){return(0,Oe.$aF)(Le,"interactive"),gi.transferChatSession(ee,de)}},ln={getRelatedInformation(ee,de){return(0,Oe.$aF)(Le,"aiRelatedInformation"),_t.getRelatedInformation(Le,ee,de)},registerRelatedInformationProvider(ee,de){return(0,Oe.$aF)(Le,"aiRelatedInformation"),_t.registerRelatedInformationProvider(Le,ee,de)},registerEmbeddingVectorProvider(ee,de){return(0,Oe.$aF)(Le,"aiRelatedInformation"),wi.registerEmbeddingVectorProvider(Le,ee,de)}},dn={registerChatResponseProvider(ee,de,Te){return(0,Oe.$aF)(Le,"chatProvider"),fi.registerProvider(Le.identifier,ee,de,Te)},requestChatAccess(ee){return(0,Oe.$aF)(Le,"chatRequestAccess"),fi.requestChatResponseProvider(Le.identifier,ee)},registerVariable(ee,de,Te){return(0,Oe.$aF)(Le,"chatVariables"),Ui.registerVariableResolver(Le,ee,de,Te)},registerMappedEditsProvider(ee,de){return(0,Oe.$aF)(Le,"mappedEditsProvider"),ct.registerMappedEditsProvider(Le,ee,de)},createChatAgent(ee,de){return(0,Oe.$aF)(Le,"chatAgents2"),$n.createChatAgent(Le.identifier,ee,de)},registerAgent(ee,de,Te){return(0,Oe.$aF)(Le,"chatAgents"),xi.registerAgent(Le.identifier,ee,de,Te)}},hn={registerSpeechProvider(ee,de){return(0,Oe.$aF)(Le,"speech"),yi.registerProvider(Le.identifier,ee,de)}};return{version:ht.version,ai:ln,authentication:ji,commands:on,comments:Ki,chat:dn,debug:ci,env:Bi,extensions:vn,interactive:Gi,l10n:Hi,languages:cn,notebooks:qi,scm:Wi,speech:hn,tasks:Vi,tests:an,window:un,workspace:ki,Breakpoint:Y.$cL,TerminalOutputAnchor:Y.TerminalOutputAnchor,ChatMessage:Y.$5L,ChatMessageRole:Y.ChatMessageRole,ChatVariableLevel:Y.ChatVariableLevel,CallHierarchyIncomingCall:Y.$BK,CallHierarchyItem:Y.$AK,CallHierarchyOutgoingCall:Y.$CK,CancellationError:M.$5,CancellationTokenSource:y.$Xd,CandidatePortSource:a.CandidatePortSource,CodeAction:Y.$xK,CodeActionKind:Y.$yK,CodeActionTriggerKind:Y.CodeActionTriggerKind,CodeLens:Y.$DK,Color:Y.$QK,ColorInformation:Y.$RK,ColorPresentation:Y.$SK,ColorThemeKind:Y.ColorThemeKind,CommentMode:Y.CommentMode,CommentState:Y.CommentState,CommentThreadCollapsibleState:Y.CommentThreadCollapsibleState,CommentThreadState:Y.CommentThreadState,CompletionItem:Y.$KK,CompletionItemKind:Y.CompletionItemKind,CompletionItemTag:Y.CompletionItemTag,CompletionList:Y.$LK,CompletionTriggerKind:Y.CompletionTriggerKind,ConfigurationTarget:Y.ConfigurationTarget,CustomExecution:Y.$1K,DebugAdapterExecutable:Y.$gL,DebugAdapterInlineImplementation:Y.$jL,DebugAdapterNamedPipeServer:Y.$iL,DebugAdapterServer:Y.$hL,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Y.DebugConsoleMode,DecorationRangeBehavior:Y.DecorationRangeBehavior,Diagnostic:Y.$sK,DiagnosticRelatedInformation:Y.$rK,DiagnosticSeverity:Y.DiagnosticSeverity,DiagnosticTag:Y.DiagnosticTag,Disposable:Y.$eK,DocumentHighlight:Y.$uK,DocumentHighlightKind:Y.DocumentHighlightKind,DocumentLink:Y.$PK,DocumentSymbol:Y.$wK,EndOfLine:Y.EndOfLine,EnvironmentVariableMutatorType:Y.EnvironmentVariableMutatorType,EvaluatableExpression:Y.$mL,InlineValueText:Y.$nL,InlineValueVariableLookup:Y.$oL,InlineValueEvaluatableExpression:Y.$pL,InlineCompletionTriggerKind:Y.InlineCompletionTriggerKind,EventEmitter:C.$Nd,ExtensionKind:Y.ExtensionKind,ExtensionMode:Y.ExtensionMode,ExternalUriOpenerPriority:Y.ExternalUriOpenerPriority,FileChangeType:Y.FileChangeType,FileDecoration:Y.$zL,FileDecoration2:Y.$zL,FileSystemError:Y.$rL,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:Y.$sL,FoldingRangeKind:Y.FoldingRangeKind,FunctionBreakpoint:Y.$eL,InlineCompletionItem:Y.$MK,InlineCompletionList:Y.$NK,Hover:Y.$tK,IndentAction:g.IndentAction,Location:Y.$qK,MarkdownString:Y.$EK,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:Y.$FK,PortAutoForwardAction:Y.PortAutoForwardAction,Position:Y.$fK,ProcessExecution:Y.$YK,ProgressLocation:Y.ProgressLocation,QuickInputButtons:Y.$yL,Range:Y.$gK,RelativePattern:Y.$aL,Selection:Y.$hK,SelectionRange:Y.$zK,SemanticTokens:Y.$vL,SemanticTokensBuilder:Y.$uL,SemanticTokensEdit:Y.$wL,SemanticTokensEdits:Y.$xL,SemanticTokensLegend:Y.$tL,ShellExecution:Y.$ZK,ShellQuoting:Y.ShellQuoting,SignatureHelp:Y.$HK,SignatureHelpTriggerKind:Y.SignatureHelpTriggerKind,SignatureInformation:Y.$GK,SnippetString:Y.$pK,SourceBreakpoint:Y.$dL,StandardTokenType:Y.StandardTokenType,StatusBarAlignment:Y.StatusBarAlignment,SymbolInformation:Y.$vK,SymbolKind:Y.SymbolKind,SymbolTag:Y.SymbolTag,Task:Y.$2K,TaskGroup:Y.$XK,TaskPanelKind:Y.TaskPanelKind,TaskRevealKind:Y.TaskRevealKind,TaskScope:Y.TaskScope,TerminalLink:Y.$TK,TerminalQuickFixExecuteTerminalCommand:Y.$VK,TerminalQuickFixOpener:Y.$UK,TerminalLocation:Y.TerminalLocation,TerminalProfile:Y.$WK,TerminalExitReason:Y.TerminalExitReason,TextDocumentSaveReason:Y.TextDocumentSaveReason,TextEdit:Y.$lK,SnippetTextEdit:Y.$nK,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:Y.TextEditorLineNumbersStyle,TextEditorRevealType:Y.TextEditorRevealType,TextEditorSelectionChangeKind:Y.TextEditorSelectionChangeKind,SyntaxTokenType:Y.SyntaxTokenType,TextDocumentChangeReason:Y.TextDocumentChangeReason,ThemeColor:Y.$_K,ThemeIcon:Y.$$K,TreeItem:Y.$3K,TreeItemCheckboxState:Y.TreeItemCheckboxState,TreeItemCollapsibleState:Y.TreeItemCollapsibleState,TypeHierarchyItem:Y.$UL,UIKind:p.UIKind,Uri:A.URI,ViewColumn:Y.ViewColumn,WorkspaceEdit:Y.$oK,DocumentDropEdit:Y.$9K,DocumentPasteEdit:Y.$0K,InlayHint:Y.$JK,InlayHintLabelPart:Y.$IK,InlayHintKind:Y.InlayHintKind,RemoteAuthorityResolverError:Y.$kK,ResolvedAuthority:Y.$iK,ManagedResolvedAuthority:Y.$jK,SourceControlInputBoxValidationType:Y.SourceControlInputBoxValidationType,ExtensionRuntime:Y.ExtensionRuntime,TimelineItem:Y.$JL,NotebookRange:Y.$BL,NotebookCellKind:Y.NotebookCellKind,NotebookCellExecutionState:Y.NotebookCellExecutionState,NotebookCellData:Y.$CL,NotebookData:Y.$DL,NotebookRendererScript:Y.$HL,NotebookCellStatusBarAlignment:Y.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Y.NotebookEditorRevealType,NotebookCellOutput:Y.$FL,NotebookCellOutputItem:Y.$EL,NotebookCellStatusBarItem:Y.$GL,NotebookControllerAffinity:Y.NotebookControllerAffinity,NotebookControllerAffinity2:Y.NotebookControllerAffinity2,NotebookEdit:Y.$mK,NotebookKernelSourceAction:Y.$IL,PortAttributes:Y.$LL,LinkedEditingRanges:Y.$KL,TestResultState:Y.TestResultState,TestRunRequest:Y.$ML,TestMessage:Y.$NL,TestMessage2:Y.$NL,TestTag:Y.$OL,TestRunProfileKind:Y.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:Y.$8K,DataTransferItem:Y.$4K,CoveredCount:Y.$PL,FileCoverage:Y.$QL,StatementCoverage:Y.$RL,BranchCoverage:Y.$SL,FunctionCoverage:Y.$TL,WorkspaceTrustState:Y.WorkspaceTrustState,LanguageStatusSeverity:Y.LanguageStatusSeverity,QuickPickItemKind:Y.QuickPickItemKind,InputBoxValidationSeverity:Y.InputBoxValidationSeverity,TabInputText:Y.$VL,TabInputTextDiff:Y.$WL,TabInputTextMerge:Y.$XL,TabInputCustom:Y.$YL,TabInputNotebook:Y.$1L,TabInputNotebookDiff:Y.$2L,TabInputWebview:Y.$ZL,TabInputTerminal:Y.$3L,TabInputInteractiveWindow:Y.$4L,TelemetryTrustedValue:Ee.$ho,LogLevel:we.LogLevel,EditSessionIdentityMatch:ft.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Y.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Y.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Y.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Y.$kL,ThreadFocus:Y.$lL,RelatedInformationType:Y.RelatedInformationType,SpeechToTextStatus:Y.SpeechToTextStatus}}}e.$Zdc=Mt}),define(Ae[275],Re([1,0,70,109,33,107,34,31,60,63,111,113,114,84,86,80,108,62,40,83,58,61,242,14,112,81,82]),function(be,e,y,M,C,T,A,l,D,g,R,k,a,p,$,f,t,i,c,b,E,v,n,r,s,o,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$ur)(o.$ycc,o.$xcc,1),(0,y.$ur)(r.$0i,n.$1dc,1),(0,y.$ur)(f.$Xbc,f.$Ybc,1),(0,y.$ur)(l.$zM,l.$yM,0),(0,y.$ur)(A.$$bc,A.$9bc,0),(0,y.$ur)(i.$ncc,i.$mcc,0),(0,y.$ur)(k.$bdc,k.$fdc,0),(0,y.$ur)(T.$6cc,T.$5cc,0),(0,y.$ur)(D.$oM,D.$nM,0),(0,y.$ur)(w.$zcc,w.$Acc,0),(0,y.$ur)(c.$Ubc,c.$Tbc,0),(0,y.$ur)(M.$Lcc,M.$Kcc,1),(0,y.$ur)(a.$ldc,a.$mdc,0),(0,y.$ur)(p.$jcc,p.$icc,0),(0,y.$ur)(R.$9cc,R.$8cc,0),(0,y.$ur)(g.$qcc,g.$tcc,0),(0,y.$ur)($.$2vb,$.$3vb,0),(0,y.$ur)(t.$2cc,t.$1cc,0),(0,y.$ur)(C.$8bc,C.$7bc,0),(0,y.$ur)(b.$vcc,b.$ucc,0),(0,y.$ur)(E.$xM,E.$uM,0),(0,y.$ur)(v.$0cc,v.$$cc,0),(0,y.$ur)(s.$_cc,s.$adc,0)}),define(Ae[276],Re([1,0,274,35,2,271,7,12,262]),function(be,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0;class g extends T.$4dc{j(){}getModule(p,$){for(const f of this.b){const t=f(p);if(t){p=t;break}}if(this.a.has(p))return this.a.get(p).load(p,$,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends M.$Ccc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(D.$9fc);const p=this.h.invokeFunction(y.$Zdc);this.r=this.h.createInstance(g,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,$,f){$=$.with({path:k($.path,".js")});const t=p?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=C.URI.revive(await this.C.$asBrowserUri($)),c=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const b=await c.text(),E=`${$.toString(!0)}#vscode-extension`,v=`${b}
//# sourceURL=${E}`;let n;try{n=new Function("module","exports","require",v)}catch(w){throw console.error(t?`Loading code for extension ${t} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${$.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}p&&await this.w.initializeLocalizedMessages(p);const r={},s={exports:r},o=w=>{const h=this.r.getModule(w,$);if(h===void 0)throw new Error(`Cannot load module '${w}'`);return h};try{return f.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(s,r,o),s.exports!==r?s.exports:r}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),f.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const $=Date.now()+p;for(;Date.now()<$&&!("__jsDebugIsReady"in globalThis);)await(0,l.$Ug)(10)}}e.$0fc=R;function k(a,p){return a.endsWith(p)?a:a+p}}),define(Ae[277],Re([1,0,69,70,14,35,187,85,276]),function(be,e,y,M,C,T,A,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$ur)(C.$9i,new y.$Lh(A.$3dc,[!0],!0)),(0,M.$ur)(T.$Dcc,D.$0fc,0),(0,M.$ur)(l.$occ,l.$pcc,0)}),define(Ae[286],Re([1,0,26,5,79,272,264,19,87,13,2,275,277]),function(be,e,y,M,C,T,A,l,D,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(n){return/^(file|vscode-remote):/i.test(n)}const $=fetch.bind(self);function f(n){self.fetch=async function(r,s){return r instanceof Request||p(String(r))&&(r=(await n(R.URI.parse(String(r)))).toString(!0)),$(r,s)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,s,o,w,h){(async()=>(p(s.toString())&&(s=(await n(R.URI.parse(s.toString()))).toString(!0)),super.open(r,s,o??!0,w,h)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(r,s){if(/^file:/i.test(r.toString()))r=g.$cg.uriToBrowserUri(R.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(u){function m(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const d=fetch.bind(self);self.fetch=function(W,K){return W instanceof Request?d(W,K):d(m(W),K)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,K,U,B,O){return super.open(W,m(K),U??!0,B,O)}};const P=importScripts.bind(self);self.importScripts=(...W)=>{P(...W.map(m))},P(u)}.toString()}('${r}'))`;s=s||{},s.name=s.name||l.$nc(r.toString());const h=new Blob([w],{type:"application/javascript"}),I=URL.createObjectURL(h);return new n(I,s)}}else self.Worker=class extends A.$$fc{constructor(n,r){super(a,n,{name:l.$nc(n.toString()),...r})}};const t=new class{constructor(){this.pid=void 0}exit(n){k()}};class i{constructor(){const r=new MessageChannel,s=new M.$Nd;let o=!1;a(r.port2,[r.port2]),r.port1.onmessage=w=>{const{data:h}=w;if(!(h instanceof ArrayBuffer)){console.warn("UNKNOWN data received",h);return}const I=y.$be.wrap(new Uint8Array(h,0,h.byteLength));if((0,C.$am)(I,2)){o=!0,b("received terminate message from renderer");return}s.fire(I)},this.protocol={onMessage:s.event,send:w=>{if(!o){const h=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);r.port1.postMessage(h,[h])}}}}}function c(n){return new Promise(r=>{const s=n.onMessage(o=>{s.dispose();const w=JSON.parse(o.toString());n.send((0,C.$_l)(0)),r({protocol:n,initData:w})});n.send((0,C.$_l)(1))})}let b=n=>k();function E(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function v(){D.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(r){E(r)&&c(n.protocol).then(s=>{D.mark("code/extHost/didWaitForInitData");const o=new T.$6dc(s.protocol,s.initData,t,null,r.data);f(w=>o.asBrowserUri(w)),b=w=>o.terminate(w)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9bb94efbe279580856897b63cc9417a3e875e405/core/vs/workbench/api/worker/extensionHostWorker.js.map
