/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],K=function(z){for(var e=[],C=0,k=z.length;C<k;C++)e[C]=q[z[C]];return e};define(q[21],K([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class C{static get(){const y=new Map,O=new Map,s=new Map,d=new Map;function t(u,n){u.has(n.detail)||u.set(n.detail,-n.timestamp)}function r(u,n){const i=u.get(n.detail);i&&(i>=0||u.set(n.detail,i+n.timestamp))}let o=[];typeof z=="function"&&typeof z.getStats=="function"&&(o=z.getStats().slice(0).sort((u,n)=>u.timestamp-n.timestamp));for(const u of o)switch(u.type){case 10:t(y,u);break;case 11:case 12:r(y,u);break;case 21:t(O,u);break;case 22:r(O,u);break;case 33:t(s,u);break;case 34:r(s,u);break;case 31:t(d,u);break;case 32:r(d,u);break}let h=0;s.forEach(u=>h+=u);function g(u){const n=[];return u.forEach((i,a)=>n.push([a,i])),n}return{amdLoad:g(y),amdInvoke:g(O),nodeRequire:g(s),nodeEval:g(d),nodeRequireTotal:h}}static toMarkdownTable(y,O){let s="";const d=[];return y.forEach((t,r)=>{d[r]=t.length}),O.forEach(t=>{t.forEach((r,o)=>{typeof r>"u"&&(r=t[o]="-");const h=r.toString().length;d[o]=Math.max(h,d[o])})}),y.forEach((t,r)=>{s+=`| ${t+" ".repeat(d[r]-t.toString().length)} `}),s+=`|
`,y.forEach((t,r)=>{s+=`| ${"-".repeat(d[r])} `}),s+=`|
`,O.forEach(t=>{t.forEach((r,o)=>{typeof r<"u"&&(s+=`| ${r+" ".repeat(d[o]-r.toString().length)} `)}),s+=`|
`}),s}}e.$U=C}),define(q[4],K([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rd=e.$qd=e.$pd=void 0;let C;function k(i){C=i}e.$pd=k;function y(){return C}e.$qd=y;class O{constructor(){this.a=0,this.d=new WeakMap}b(a){return s([d(u("|  ",this.a)),a])}c(a){return a.hadValue?a.didChange?[d(" "),r(o(a.oldValue,70),{color:"red",strikeThrough:!0}),d(" "),r(o(a.newValue,60),{color:"green"})]:[d(" (unchanged)")]:[d(" "),r(o(a.newValue,60),{color:"green"}),d(" (initial)")]}handleObservableChanged(a,v){console.log(...this.b([t("observable value changed"),r(a.debugName,{color:"BlueViolet"}),...this.c(v)]))}formatChanges(a){if(a.size!==0)return r(" (changed deps: "+[...a].map(v=>v.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(a){const v=a.handleChange;this.d.set(a,new Set),a.handleChange=(A,B)=>(this.d.get(a).add(A),v.apply(a,[A,B]))}handleDerivedRecomputed(a,v){const A=this.d.get(a);console.log(...this.b([t("derived recomputed"),r(a.debugName,{color:"BlueViolet"}),...this.c(v),this.formatChanges(A),{data:[{fn:a._computeFn}]}])),A.clear()}handleFromEventObservableTriggered(a,v){console.log(...this.b([t("observable from event triggered"),r(a.debugName,{color:"BlueViolet"}),...this.c(v),{data:[{fn:a._getValue}]}]))}handleAutorunCreated(a){const v=a.handleChange;this.d.set(a,new Set),a.handleChange=(A,B)=>(this.d.get(a).add(A),v.apply(a,[A,B]))}handleAutorunTriggered(a){const v=this.d.get(a);console.log(...this.b([t("autorun"),r(a.debugName,{color:"BlueViolet"}),this.formatChanges(v),{data:[{fn:a._runFn}]}])),v.clear(),this.a++}handleAutorunFinished(a){this.a--}handleBeginTransaction(a){let v=a.getDebugName();v===void 0&&(v=""),console.log(...this.b([t("transaction"),r(v,{color:"BlueViolet"}),{data:[{fn:a._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$rd=O;function s(i){const a=new Array,v=[];let A="";function B(T){if("length"in T)for(const $ of T)$&&B($);else"text"in T?(A+=`%c${T.text}`,a.push(T.style),T.data&&v.push(...T.data)):"data"in T&&v.push(...T.data)}B(i);const L=[A,...a];return L.push(...v),L}function d(i){return r(i,{color:"black"})}function t(i){return r(n(`${i}: `,10),{color:"black",bold:!0})}function r(i,a={color:"black"}){function v(B){return Object.entries(B).reduce((L,[T,$])=>`${L}${T}:${$};`,"")}const A={color:a.color};return a.strikeThrough&&(A["text-decoration"]="line-through"),a.bold&&(A["font-weight"]="bold"),{text:i,style:v(A)}}function o(i,a){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=a?`"${i}"`:`"${i.substr(0,a-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?h(i,a):g(i,a);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function h(i,a){let v="[ ",A=!0;for(const B of i){if(A||(v+=", "),v.length-5>a){v+="...";break}A=!1,v+=`${o(B,a-v.length)}`}return v+=" ]",v}function g(i,a){let v="{ ",A=!0;for(const[B,L]of Object.entries(i)){if(A||(v+=", "),v.length-5>a){v+="...";break}A=!1,v+=`${B}: ${o(L,a-v.length)}`}return v+=" }",v}function u(i,a){let v="";for(let A=1;A<=a;A++)v+=i;return v}function n(i,a){for(;i.length<a;)i+=" ";return i}}),define(q[5],K([0,1,4]),function(z,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=void 0;let k;function y(m){k=m}e.$xd=y;class O{get TChange(){return null}reportChanges(){this.get()}read(c){return c?c.readObservable(this):this.get()}map(c,w){const M=w===void 0?void 0:c,f=w===void 0?c:w;return k({owner:M,debugName:()=>{const S=A(f);if(S!==void 0)return S;const F=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(f.toString());if(F)return`${this.debugName}.${F[2]}`;if(!M)return`${this.debugName} (mapped)`}},S=>f(this.read(S),S))}}e.$yd=O;class s extends O{constructor(){super(...arguments),this.c=new Set}addObserver(c){const w=this.c.size;this.c.add(c),w===0&&this.f()}removeObserver(c){this.c.delete(c)&&this.c.size===0&&this.g()}f(){}g(){}}e.$zd=s;function d(m,c){const w=new r(m,c);try{m(w)}finally{w.finish()}}e.$Ad=d;function t(m,c,w){m?c(m):d(c,w)}e.$Bd=t;class r{constructor(c,w){this._fn=c,this.b=w,this.a=[],(0,C.$qd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():A(this._fn)}updateObserver(c,w){this.a.push({observer:c,observable:w}),c.beginUpdate(w)}finish(){const c=this.a;this.a=null;for(const{observer:w,observable:M}of c)w.endUpdate(M);(0,C.$qd)()?.handleEndTransaction()}}e.$Cd=r;const o=new Map,h=new WeakMap;function g(m,c,w,M,f){const S=h.get(m);if(S)return S;const P=u(m,c,w,M,f);if(P){let F=o.get(P)??0;F++,o.set(P,F);const I=F===1?P:`${P}#${F}`;return h.set(m,I),I}}e.$Dd=g;function u(m,c,w,M,f){const S=h.get(m);if(S)return S;const P=M?a(M)+".":"";let F;if(c!==void 0)if(typeof c=="function"){if(F=c(),F!==void 0)return P+F}else return P+c;if(w!==void 0&&(F=A(w),F!==void 0))return P+F;if(M!==void 0){for(const I in M)if(M[I]===f)return P+I}}const n=new Map,i=new WeakMap;function a(m){const c=i.get(m);if(c)return c;const w=v(m);let M=n.get(w)??0;M++,n.set(w,M);const f=M===1?w:`${w}#${M}`;return i.set(m,f),f}function v(m){const c=m.constructor;return c?c.name:"Object"}function A(m){const c=m.toString(),M=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(c);return(M?M[1]:void 0)?.trim()}e.$Ed=A;function B(m,c){return typeof m=="string"?new L(void 0,m,c):new L(m,void 0,c)}e.$Fd=B;class L extends s{get debugName(){return g(this,this.d,void 0,this.b,this)??"ObservableValue"}constructor(c,w,M){super(),this.b=c,this.d=w,this.a=M}get(){return this.a}set(c,w,M){if(this.a===c)return;let f;w||(w=f=new r(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.a;this.e(c),(0,C.$qd)()?.handleObservableChanged(this,{oldValue:S,newValue:c,change:M,didChange:!0,hadValue:!0});for(const P of this.c)w.updateObserver(P,this),P.handleChange(this,M)}finally{f&&f.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(c){this.a=c}}e.$Gd=L;function T(m,c){return typeof m=="string"?new $(void 0,m,c):new $(m,void 0,c)}e.$Hd=T;class $ extends L{e(c){this.a!==c&&(this.a&&this.a.dispose(),this.a=c)}dispose(){this.a?.dispose()}}e.$Id=$}),define(q[9],K([0,1,42,2,5,4]),function(z,e,C,k,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=void 0;function s(n,i){return new g(n.debugName,i,void 0,void 0)}e.$8c=s;function d(n){return new g(void 0,n,void 0,void 0)}e.$9c=d;function t(n,i){return new g(n.debugName,i,n.createEmptyChangeSummary,n.handleChange)}e.$0c=t;function r(n,i){const a=new k.$Rc,v=t({debugName:n.debugName??(()=>(0,y.$Ed)(i)),createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(A,B)=>{a.clear(),i(A,B,a)});return(0,k.$Qc)(()=>{v.dispose(),a.dispose()})}e.$$c=r;function o(n){const i=new k.$Rc,a=s({debugName:()=>(0,y.$Ed)(n)||"(anonymous)"},v=>{i.clear(),n(v,i)});return(0,k.$Qc)(()=>{a.dispose(),i.dispose()})}e.$_c=o;var h;(function(n){n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(h||(h={}));class g{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const a=this.h();if(a!==void 0)return a}const i=(0,y.$Ed)(this._runFn);return i!==void 0?i:"(anonymous)"}constructor(i,a,v,A){this.h=i,this._runFn=a,this.i=v,this.j=A,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,O.$qd)()?.handleAutorunCreated(this),this.k(),(0,k.$Jc)(this)}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear(),(0,k.$Kc)(this)}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3;try{if(!this.c){(0,O.$qd)()?.handleAutorunTriggered(this);const a=this.g;this.g=this.i?.(),this._runFn(this,a)}}finally{(0,O.$qd)()?.handleAutorunFinished(this);for(const a of this.f)a.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,C.$6c)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,a){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:a,didChange:A=>A===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const a=i.get();return this.e.add(i),this.f.delete(i),a}}e.$ad=g,function(n){n.Observer=g}(d||(e.$9c=d={}));function u(n,i){let a;return s({debugName:()=>(0,y.$Ed)(i)},v=>{const A=n.read(v),B=a;a=A,i({lastValue:B,newValue:A})})}e.$bd=u}),define(q[10],K([0,1,6,2,5,4]),function(z,e,C,k,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wd=e.$vd=e.$ud=e.$td=e.$sd=void 0;const s=(u,n)=>u===n;function d(u,n){return n!==void 0?new g(u,void 0,n,void 0,void 0,void 0,s):new g(void 0,void 0,u,void 0,void 0,void 0,s)}e.$sd=d;function t(u,n){return new g(u.owner,u.debugName,n,void 0,void 0,void 0,u.equalityComparer??s)}e.$td=t;function r(u,n){return new g(u.owner,u.debugName,n,u.createEmptyChangeSummary,u.handleChange,void 0,u.equalityComparer??s)}e.$ud=r;function o(u,n){let i,a;n===void 0?(i=u,a=void 0):(a=u,i=n);const v=new k.$Rc;return new g(a,()=>(0,y.$Ed)(i)??"(anonymous)",A=>(v.clear(),i(A,v)),void 0,void 0,()=>v.dispose(),s)}e.$vd=o,(0,y.$xd)(t);var h;(function(u){u[u.initial=0]="initial",u[u.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",u[u.stale=2]="stale",u[u.upToDate=3]="upToDate"})(h||(h={}));class g extends y.$zd{get debugName(){return(0,y.$Dd)(this,this.n,this._computeFn,this.m,this)??"(anonymous)"}constructor(n,i,a,v,A,B=void 0,L){super(),this.m=n,this.n=i,this._computeFn=a,this.p=v,this.q=A,this.s=B,this.t=L,this.e=0,this.h=void 0,this.i=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.p?.(),(0,O.$qd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.j)n.removeObserver(this);this.j.clear(),this.s?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.p?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.j)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const n=this.k;this.k=this.j,this.j=n;const i=this.e!==0,a=this.h;this.e=3;const v=this.l;this.l=this.p?.();try{this.h=this._computeFn(this,v)}finally{for(const B of this.k)B.removeObserver(this);this.k.clear()}const A=i&&!this.t(a,this.h);if((0,O.$qd)()?.handleDerivedRecomputed(this,{oldValue:a,newValue:this.h,change:void 0,didChange:A,hadValue:i}),A)for(const B of this.c)B.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.i++;const i=this.i===1;if(this.e===3&&(this.e=1,!i))for(const a of this.c)a.handlePossibleChange(this);if(i)for(const a of this.c)a.beginUpdate(this)}endUpdate(n){if(this.i--,this.i===0){const i=[...this.c];for(const a of i)a.endUpdate(this)}if(this.i<0)throw new C.$cb}handlePossibleChange(n){if(this.e===3&&this.j.has(n)&&!this.k.has(n)){this.e=1;for(const i of this.c)i.handlePossibleChange(this)}}handleChange(n,i){if(this.j.has(n)&&!this.k.has(n)){const a=this.q?this.q({changedObservable:n,change:i,didChange:A=>A===n},this.l):!0,v=this.e===3;if(a&&(this.e===1||v)&&(this.e=2,v))for(const A of this.c)A.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const i=n.get();return this.j.add(n),this.k.delete(n),i}addObserver(n){const i=!this.c.has(n)&&this.i>0;super.addObserver(n),i&&n.beginUpdate(this)}removeObserver(n){const i=this.c.has(n)&&this.i>0;super.removeObserver(n),i&&n.endUpdate(this)}}e.$wd=g}),define(q[22],K([0,1,2,9,5,10,4]),function(z,e,C,k,y,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=void 0;function d(c){return new t(c)}e.$cd=d;class t extends y.$yd{constructor(w){super(),this.a=w}get debugName(){return this.toString()}get(){return this.a}addObserver(w){}removeObserver(w){}toString(){return`Const: ${this.a}`}}function r(c){const w=(0,y.$Fd)("promiseValue",{});return c.then(M=>{w.set({value:M},void 0)}),w}e.$dd=r;function o(c,w){return new Promise(M=>{let f=!1,S=!1;const P=(0,k.$9c)(F=>{const I=c.read(F);w(I)&&(f?P.dispose():S=!0,M(I))});f=!0,S&&P.dispose()})}e.$ed=o;function h(c,w){return new g(c,w)}e.$fd=h;class g extends y.$zd{constructor(w,M){super(),this.h=w,this._getValue=M,this.b=!1,this.k=f=>{const S=this._getValue(f),P=!this.b||this.a!==S;(0,s.$qd)()?.handleFromEventObservableTriggered(this,{oldValue:this.a,newValue:S,change:void 0,didChange:P,hadValue:this.b}),P&&(this.a=S,this.b&&(0,y.$Ad)(F=>{for(const I of this.c)F.updateObserver(I,this),I.handleChange(this,void 0)},()=>{const F=this.i();return"Event fired"+(F?`: ${F}`:"")}),this.b=!0)}}i(){return(0,y.$Ed)(this._getValue)}get debugName(){const w=this.i();return"From Event"+(w?`: ${w}`:"")}f(){this.e=this.h(this.k)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.k(void 0),this.a):this._getValue(void 0)}}e.$gd=g,function(c){c.Observer=g}(h||(e.$fd=h={}));function u(c,w){return new n(c,w)}e.$hd=u;class n extends y.$zd{constructor(w,M){super(),this.debugName=w,this.b=M,this.h=()=>{(0,y.$Ad)(f=>{for(const S of this.c)f.updateObserver(S,this),S.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function i(c){return typeof c=="string"?new a(c):new a(void 0,c)}e.$id=i;class a extends y.$zd{get debugName(){return(0,y.$Dd)(this,this.a,void 0,this.b,this)??"Observable Signal"}constructor(w,M){super(),this.a=w,this.b=M}trigger(w,M){if(!w){(0,y.$Ad)(f=>{this.trigger(f,M)},()=>`Trigger signal ${this.debugName}`);return}for(const f of this.c)w.updateObserver(f,this),f.handleChange(this,M)}get(){}}function v(c,w,M){const f=(0,y.$Fd)("debounced",void 0);let S;return M.add((0,k.$9c)(P=>{const F=c.read(P);S&&clearTimeout(S),S=setTimeout(()=>{(0,y.$Ad)(I=>{f.set(F,I)})},w)})),f}e.$jd=v;function A(c,w,M){const f=(0,y.$Fd)("triggeredRecently",!1);let S;return M.add(c(()=>{f.set(!0,void 0),S&&clearTimeout(S),S=setTimeout(()=>{f.set(!1,void 0)},w)})),f}e.$kd=A;function B(c){const w=new T(!1);return c.addObserver(w),(0,C.$Qc)(()=>{c.removeObserver(w)})}e.$ld=B;function L(c){const w=new T(!0);return c.addObserver(w),c.reportChanges(),(0,C.$Qc)(()=>{c.removeObserver(w)})}e.$md=L;class T{constructor(w){this.b=w,this.a=0}beginUpdate(w){this.a++}endUpdate(w){this.a--,this.a===0&&this.b&&w.reportChanges()}handlePossibleChange(w){}handleChange(w,M){}}function $(c){let w;return(0,O.$sd)(f=>(w=c(f,w),w))}e.$nd=$;function m(c,w){let M;const f=(0,y.$Fd)("derivedObservableWithWritableCache.counter",0),S=(0,O.$sd)(c,P=>(f.read(P),M=w(P,M),M));return Object.assign(S,{clearCache:P=>{M=void 0,f.set(f.get()+1,P)}})}e.$od=m}),define(q[11],K([0,1,5,10,9,22,4]),function(z,e,C,k,y,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return C.$Fd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return C.$Hd}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return C.$Ad}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return C.$Bd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return k.$sd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return k.$td}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return k.$ud}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return k.$vd}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return y.$9c}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return y.$bd}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return y.$0c}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return y.$_c}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return y.$8c}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return y.$$c}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return O.$cd}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return O.$jd}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return O.$nd}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return O.$od}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return O.$ld}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return O.$md}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return O.$fd}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return O.$dd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return O.$id}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return O.$hd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return O.$ed}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return O.$kd}}),!1&&(0,s.$pd)(new s.$rd)}),define(q[23],K([0,1,6,2]),function(z,e,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=void 0;function y(L){const T=L;return T?typeof T.read=="function":!1}e.$Yd=y;function O(L){const T=L;return T?[T.on,T.pause,T.resume,T.destroy].every($=>typeof $=="function"):!1}e.$Zd=O;function s(L){const T=L;return T?O(T.stream)&&Array.isArray(T.buffer)&&typeof T.ended=="boolean":!1}e.$1d=s;function d(L,T){return new t(L,T)}e.$2d=d;class t{constructor(T,$){this.e=T,this.f=$,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(T){if(!this.a.destroyed){if(this.a.flowing)this.g(T);else if(this.b.data.push(T),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise($=>this.d.push($))}}error(T){this.a.destroyed||(this.a.flowing?this.h(T):this.b.error.push(T))}end(T){this.a.destroyed||(typeof T<"u"&&this.write(T),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(T){this.c.data.slice(0).forEach($=>$(T))}h(T){this.c.error.length===0?(0,C.$1)(T):this.c.error.slice(0).forEach($=>$(T))}i(){this.c.end.slice(0).forEach(T=>T())}on(T,$){if(!this.a.destroyed)switch(T){case"data":this.c.data.push($),this.resume();break;case"end":this.c.end.push($),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push($),this.a.flowing&&this.k();break}}removeListener(T,$){if(this.a.destroyed)return;let m;switch(T){case"data":m=this.c.data;break;case"end":m=this.c.end;break;case"error":m=this.c.error;break}if(m){const c=m.indexOf($);c>=0&&m.splice(c,1)}}j(){if(this.b.data.length>0){const T=this.e(this.b.data);this.g(T),this.b.data.length=0;const $=[...this.d];this.d.length=0,$.forEach(m=>m())}}k(){if(this.c.error.length>0){for(const T of this.b.error)this.h(T);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(L,T){const $=[];let m;for(;(m=L.read())!==null;)$.push(m);return T($)}e.$3d=r;function o(L,T,$){const m=[];let c;for(;(c=L.read())!==null&&m.length<$;)m.push(c);return c===null&&m.length>0?T(m):{read:()=>{if(m.length>0)return m.shift();if(typeof c<"u"){const w=c;return c=void 0,w}return L.read()}}}e.$4d=o;function h(L,T){return new Promise(($,m)=>{const c=[];g(L,{onData:w=>{T&&c.push(w)},onError:w=>{T?m(w):$(void 0)},onEnd:()=>{$(T?T(c):void 0)}})})}e.$5d=h;function g(L,T,$){L.on("error",m=>{$?.isCancellationRequested||T.onError(m)}),L.on("end",()=>{$?.isCancellationRequested||T.onEnd()}),L.on("data",m=>{$?.isCancellationRequested||T.onData(m)})}e.$6d=g;function u(L,T){return new Promise(($,m)=>{const c=new k.$Rc,w=[],M=P=>{if(w.push(P),w.length>T)return c.dispose(),L.pause(),$({stream:L,buffer:w,ended:!1})},f=P=>(c.dispose(),m(P)),S=()=>(c.dispose(),$({stream:L,buffer:w,ended:!0}));c.add((0,k.$Qc)(()=>L.removeListener("error",f))),L.on("error",f),c.add((0,k.$Qc)(()=>L.removeListener("end",S))),L.on("end",S),c.add((0,k.$Qc)(()=>L.removeListener("data",M))),L.on("data",M)})}e.$7d=u;function n(L,T){const $=d(T);return $.end(L),$}e.$8d=n;function i(){const L=d(()=>{throw new Error("not supported")});return L.end(),L}e.$9d=i;function a(L){let T=!1;return{read:()=>T?null:(T=!0,L)}}e.$0d=a;function v(L,T,$){const m=d($);return g(L,{onData:c=>m.write(T.data(c)),onError:c=>m.error(T.error?T.error(c):c),onEnd:()=>m.end()}),m}e.$$d=v;function A(L,T,$){let m=!1;return{read:()=>{const c=T.read();return m?c:(m=!0,c!==null?$([L,c]):L)}}}e.$_d=A;function B(L,T,$){let m=!1;const c=d($);return g(T,{onData:w=>m?c.write(w):(m=!0,c.write($([L,w]))),onError:w=>c.error(w),onEnd:()=>{m||(m=!0,c.write(L)),c.end()}}),c}e.$ae=B}),define(q[12],K([0,1,43,23]),function(z,e,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;const y=typeof Buffer<"u",O=new C.$V(()=>new Uint8Array(256));let s,d;class t{static alloc(b){return y?new t(Buffer.allocUnsafe(b)):new t(new Uint8Array(b))}static wrap(b){return y&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new t(b)}static fromString(b,U){return!(U?.dontUseNodeBuffer||!1)&&y?new t(Buffer.from(b)):(s||(s=new TextEncoder),new t(s.encode(b)))}static fromByteArray(b){const U=t.alloc(b.length);for(let W=0,G=b.length;W<G;W++)U.buffer[W]=b[W];return U}static concat(b,U){if(typeof U>"u"){U=0;for(let V=0,H=b.length;V<H;V++)U+=b[V].byteLength}const W=t.alloc(U);let G=0;for(let V=0,H=b.length;V<H;V++){const p=b[V];W.set(p,G),G+=p.byteLength}return W}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=t.alloc(this.byteLength);return b.set(this),b}toString(){return y?this.buffer.toString():(d||(d=new TextDecoder),d.decode(this.buffer))}slice(b,U){return new t(this.buffer.subarray(b,U))}set(b,U){if(b instanceof t)this.buffer.set(b.buffer,U);else if(b instanceof Uint8Array)this.buffer.set(b,U);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),U);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),U);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return g(this.buffer,b)}writeUInt32BE(b,U){u(this.buffer,b,U)}readUInt32LE(b){return n(this.buffer,b)}writeUInt32LE(b,U){i(this.buffer,b,U)}readUInt8(b){return a(this.buffer,b)}writeUInt8(b,U){v(this.buffer,b,U)}indexOf(b,U=0){return r(this.buffer,b instanceof t?b.buffer:b,U)}}e.$be=t;function r(I,b,U=0){const W=b.byteLength,G=I.byteLength;if(W===0)return 0;if(W===1)return I.indexOf(b[0]);if(W>G-U)return-1;const V=O.value;V.fill(b.length);for(let X=0;X<b.length;X++)V[b[X]]=b.length-X-1;let H=U+b.length-1,p=H,_=-1;for(;H<G;)if(I[H]===b[p]){if(p===0){_=H;break}H--,p--}else H+=Math.max(b.length-p,V[I[H]]),p=b.length-1;return _}e.$ce=r;function o(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0}e.$de=o;function h(I,b,U){I[U+0]=b&255,b=b>>>8,I[U+1]=b&255}e.$ee=h;function g(I,b){return I[b]*2**24+I[b+1]*2**16+I[b+2]*2**8+I[b+3]}e.$fe=g;function u(I,b,U){I[U+3]=b,b=b>>>8,I[U+2]=b,b=b>>>8,I[U+1]=b,b=b>>>8,I[U]=b}e.$ge=u;function n(I,b){return I[b+0]<<0>>>0|I[b+1]<<8>>>0|I[b+2]<<16>>>0|I[b+3]<<24>>>0}e.$he=n;function i(I,b,U){I[U+0]=b&255,b=b>>>8,I[U+1]=b&255,b=b>>>8,I[U+2]=b&255,b=b>>>8,I[U+3]=b&255}e.$ie=i;function a(I,b){return I[b]}e.$je=a;function v(I,b,U){I[U]=b}e.$ke=v;function A(I){return k.$3d(I,b=>t.concat(b))}e.$le=A;function B(I){return k.$0d(I)}e.$me=B;function L(I){return k.$5d(I,b=>t.concat(b))}e.$ne=L;async function T(I){return I.ended?t.concat(I.buffer):t.concat([...I.buffer,await L(I.stream)])}e.$oe=T;function $(I){return k.$8d(I,b=>t.concat(b))}e.$pe=$;function m(I){return k.$$d(I,{data:b=>typeof b=="string"?t.fromString(b):t.wrap(b)},b=>t.concat(b))}e.$qe=m;function c(I){return k.$2d(b=>t.concat(b),I)}e.$re=c;function w(I,b){return k.$_d(I,b,U=>t.concat(U))}e.$se=w;function M(I,b){return k.$ae(I,b,U=>t.concat(U))}e.$te=M;function f(I){let b=0,U=0,W=0;const G=new Uint8Array(Math.floor(I.length/4*3)),V=p=>{switch(U){case 3:G[W++]=b|p,U=0;break;case 2:G[W++]=b|p>>>2,b=p<<6,U=3;break;case 1:G[W++]=b|p>>>4,b=p<<4,U=2;break;default:b=p<<2,U=1}};for(let p=0;p<I.length;p++){const _=I.charCodeAt(p);if(_>=65&&_<=90)V(_-65);else if(_>=97&&_<=122)V(_-97+26);else if(_>=48&&_<=57)V(_-48+52);else if(_===43||_===45)V(62);else if(_===47||_===95)V(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${I[p]}`)}}const H=W;for(;U>0;)V(0);return t.wrap(G).slice(0,H)}e.$ue=f;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function F({buffer:I},b=!0,U=!1){const W=U?P:S;let G="";const V=I.byteLength%3;let H=0;for(;H<I.byteLength-V;H+=3){const p=I[H+0],_=I[H+1],X=I[H+2];G+=W[p>>>2],G+=W[(p<<4|_>>>4)&63],G+=W[(_<<2|X>>>6)&63],G+=W[X&63]}if(V===1){const p=I[H+0];G+=W[p>>>2],G+=W[p<<4&63],b&&(G+="==")}else if(V===2){const p=I[H+0],_=I[H+1];G+=W[p>>>2],G+=W[(p<<4|_>>>4)&63],G+=W[_<<2&63],b&&(G+="=")}return G}e.$ve=F}),define(q[24],K([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Kd=Symbol("MicrotaskDelay")}),define(q[13],K([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.StringEOL=void 0;var C;(function(y){y[y.Unknown=0]="Unknown",y[y.Invalid=3]="Invalid",y[y.LF=1]="LF",y[y.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function k(y){let O=0,s=0,d=0,t=0;for(let r=0,o=y.length;r<o;r++){const h=y.charCodeAt(r);h===13?(O===0&&(s=r),O++,r+1<o&&y.charCodeAt(r+1)===10?(t|=2,r++):t|=3,d=r+1):h===10&&(t|=1,O===0&&(s=r),O++,d=r+1)}return O===0&&(s=y.length),[O,s,y.length-d,t]}e.$3s=k}),define(q[14],K([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var C;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(C||(e.LanguageId=C={}));var k;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(k||(e.FontStyle=k={}));var y;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(y||(e.ColorId=y={}));var O;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(O||(e.StandardTokenType=O={}));var s;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class d{static getLanguageId(r){return(r&255)>>>0}static getTokenType(r){return(r&768)>>>8}static containsBalancedBrackets(r){return(r&1024)!==0}static getFontStyle(r){return(r&30720)>>>11}static getForeground(r){return(r&16744448)>>>15}static getBackground(r){return(r&4278190080)>>>24}static getClassNameFromMetadata(r){let h="mtk"+this.getForeground(r);const g=this.getFontStyle(r);return g&1&&(h+=" mtki"),g&2&&(h+=" mtkb"),g&4&&(h+=" mtku"),g&8&&(h+=" mtks"),h}static getInlineStyleFromMetadata(r,o){const h=this.getForeground(r),g=this.getFontStyle(r);let u=`color: ${o[h]};`;g&1&&(u+="font-style: italic;"),g&2&&(u+="font-weight: bold;");let n="";return g&4&&(n+=" underline"),g&8&&(n+=" line-through"),n&&(u+=`text-decoration:${n};`),u}static getPresentationFromMetadata(r){const o=this.getForeground(r),h=this.getFontStyle(r);return{foreground:o,italic:!!(h&1),bold:!!(h&2),underline:!!(h&4),strikethrough:!!(h&8)}}}e.$1s=d}),define(q[25],K([0,1,26]),function(z,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FB=void 0;class k{constructor(s){this.b=s,this.a=[]}get(s){return s<this.a.length?this.a[s]:this.b}set(s,d){for(;s>=this.a.length;)this.a[this.a.length]=this.b;this.a[s]=d}replace(s,d,t){if(s>=this.a.length)return;if(d===0){this.insert(s,t);return}else if(t===0){this.delete(s,d);return}const r=this.a.slice(0,s),o=this.a.slice(s+d),h=y(t,this.b);this.a=r.concat(h,o)}delete(s,d){d===0||s>=this.a.length||this.a.splice(s,d)}insert(s,d){if(d===0||s>=this.a.length)return;const t=[];for(let r=0;r<d;r++)t[r]=this.b;this.a=(0,C.$Wb)(this.a,s,t)}}e.$FB=k;function y(O,s){const d=[];for(let t=0;t<O;t++)d[t]=s;return d}}),define(q[7],K([0,1,14]),function(z,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0;class k{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(s,d){const t=k.defaultTokenMetadata,r=new Uint32Array(2);return r[0]=s.length,r[1]=t,new k(r,s,d)}constructor(s,d,t){this._lineTokensBrand=void 0,this.a=s,this.b=this.a.length>>>1,this.c=d,this.d=t}equals(s){return s instanceof k?this.slicedEquals(s,0,this.b):!1}slicedEquals(s,d,t){if(this.c!==s.c||this.b!==s.b)return!1;const r=d<<1,o=r+(t<<1);for(let h=r;h<o;h++)if(this.a[h]!==s.a[h])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(s){return s>0?this.a[s-1<<1]:0}getMetadata(s){return this.a[(s<<1)+1]}getLanguageId(s){const d=this.a[(s<<1)+1],t=C.$1s.getLanguageId(d);return this.d.decodeLanguageId(t)}getStandardTokenType(s){const d=this.a[(s<<1)+1];return C.$1s.getTokenType(d)}getForeground(s){const d=this.a[(s<<1)+1];return C.$1s.getForeground(d)}getClassName(s){const d=this.a[(s<<1)+1];return C.$1s.getClassNameFromMetadata(d)}getInlineStyle(s,d){const t=this.a[(s<<1)+1];return C.$1s.getInlineStyleFromMetadata(t,d)}getPresentation(s){const d=this.a[(s<<1)+1];return C.$1s.getPresentationFromMetadata(d)}getEndOffset(s){return this.a[s<<1]}findTokenIndexAtOffset(s){return k.findIndexInTokensArray(this.a,s)}inflate(){return this}sliceAndInflate(s,d,t){return new y(this,s,d,t)}static convertToEndOffset(s,d){const r=(s.length>>>1)-1;for(let o=0;o<r;o++)s[o<<1]=s[o+1<<1];s[r<<1]=d}static findIndexInTokensArray(s,d){if(s.length<=2)return 0;let t=0,r=(s.length>>>1)-1;for(;t<r;){const o=t+Math.floor((r-t)/2),h=s[o<<1];if(h===d)return o+1;h<d?t=o+1:h>d&&(r=o)}return t}withInserted(s){if(s.length===0)return this;let d=0,t=0,r="";const o=new Array;let h=0;for(;;){const g=d<this.b?this.a[d<<1]:-1,u=t<s.length?s[t]:null;if(g!==-1&&(u===null||g<=u.offset)){r+=this.c.substring(h,g);const n=this.a[(d<<1)+1];o.push(r.length,n),d++,h=g}else if(u){if(u.offset>h){r+=this.c.substring(h,u.offset);const n=this.a[(d<<1)+1];o.push(r.length,n),h=u.offset}r+=u.text,o.push(r.length,u.tokenMetadata),t++}else break}return new k(new Uint32Array(o),r,this.d)}}e.$4s=k;class y{constructor(s,d,t,r){this.a=s,this.b=d,this.c=t,this.d=r,this.e=s.findTokenIndexAtOffset(d),this.f=0;for(let o=this.e,h=s.getCount();o<h&&!(s.getStartOffset(o)>=t);o++)this.f++}getMetadata(s){return this.a.getMetadata(this.e+s)}getLanguageId(s){return this.a.getLanguageId(this.e+s)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(s){return s instanceof y?this.b===s.b&&this.c===s.c&&this.d===s.d&&this.a.slicedEquals(s.a,this.e,this.f):!1}getCount(){return this.f}getForeground(s){return this.a.getForeground(this.e+s)}getEndOffset(s){const d=this.a.getEndOffset(this.e+s);return Math.min(this.c,d)-this.b+this.d}getClassName(s){return this.a.getClassName(this.e+s)}getInlineStyle(s,d){return this.a.getInlineStyle(this.e+s,d)}getPresentation(s){return this.a.getPresentation(this.e+s)}findTokenIndexAtOffset(s){return this.a.findTokenIndexAtOffset(s+this.b-this.d)-this.e}}}),define(q[27],K([0,1,7]),function(z,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=e.$6s=e.$5s=void 0,e.$5s=new Uint32Array(0).buffer;class k{static deleteBeginning(s,d){return s===null||s===e.$5s?s:k.delete(s,0,d)}static deleteEnding(s,d){if(s===null||s===e.$5s)return s;const t=y(s),r=t[t.length-2];return k.delete(s,d,r)}static delete(s,d,t){if(s===null||s===e.$5s||d===t)return s;const r=y(s),o=r.length>>>1;if(d===0&&r[r.length-2]===t)return e.$5s;const h=C.$4s.findIndexInTokensArray(r,d),g=h>0?r[h-1<<1]:0,u=r[h<<1];if(t<u){const A=t-d;for(let B=h;B<o;B++)r[B<<1]-=A;return s}let n,i;g!==d?(r[h<<1]=d,n=h+1<<1,i=d):(n=h<<1,i=g);const a=t-d;for(let A=h+1;A<o;A++){const B=r[A<<1]-a;B>i&&(r[n++]=B,r[n++]=r[(A<<1)+1],i=B)}if(n===r.length)return s;const v=new Uint32Array(n);return v.set(r.subarray(0,n),0),v.buffer}static append(s,d){if(d===e.$5s)return s;if(s===e.$5s)return d;if(s===null)return s;if(d===null)return null;const t=y(s),r=y(d),o=r.length>>>1,h=new Uint32Array(t.length+r.length);h.set(t,0);let g=t.length;const u=t[t.length-2];for(let n=0;n<o;n++)h[g++]=r[n<<1]+u,h[g++]=r[(n<<1)+1];return h.buffer}static insert(s,d,t){if(s===null||s===e.$5s)return s;const r=y(s),o=r.length>>>1;let h=C.$4s.findIndexInTokensArray(r,d);h>0&&r[h-1<<1]===d&&h--;for(let g=h;g<o;g++)r[g<<1]+=t;return s}}e.$6s=k;function y(O){return O instanceof Uint32Array?O:new Uint32Array(O)}e.$7s=y}),define(q[28],K([0,1,26,12,44,13,27,15]),function(z,e,C,k,y,O,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=void 0;class t{static deserialize(o,h,g){const u=new Uint32Array(o.buffer),n=(0,k.$fe)(o,h);h+=4;const i=(0,k.$fe)(o,h);h+=4;const a=[];for(let v=0;v<i;v++){const A=(0,k.$fe)(o,h);h+=4,a.push(u.subarray(h/4,h/4+A/4)),h+=A}return g.push(new t(n,a)),h}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(o,h){this.a=o,this.b=h}getLineRange(){return new d.$zs(this.a,this.a+this.b.length)}getLineTokens(o){return this.b[o-this.a]}appendLineTokens(o){this.b.push(o)}serializeSize(){let o=0;o+=4,o+=4;for(let h=0;h<this.b.length;h++){const g=this.b[h];if(!(g instanceof Uint32Array))throw new Error("Not supported!");o+=4,o+=g.byteLength}return o}serialize(o,h){(0,k.$ge)(o,this.a,h),h+=4,(0,k.$ge)(o,this.b.length,h),h+=4;for(let g=0;g<this.b.length;g++){const u=this.b[g];if(!(u instanceof Uint32Array))throw new Error("Not supported!");(0,k.$ge)(o,u.byteLength,h),h+=4,o.set(new Uint8Array(u.buffer),h),h+=u.byteLength}return h}applyEdit(o,h){const[g,u]=(0,O.$3s)(h);this.c(o),this.d(new y.$ps(o.startLineNumber,o.startColumn),g,u)}c(o){if(o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn)return;const h=o.startLineNumber-this.a,g=o.endLineNumber-this.a;if(g<0){const u=g-h;this.a-=u;return}if(!(h>=this.b.length)){if(h<0&&g>=this.b.length){this.a=0,this.b=[];return}if(h===g){this.b[h]=s.$6s.delete(this.b[h],o.startColumn-1,o.endColumn-1);return}if(h>=0)if(this.b[h]=s.$6s.deleteEnding(this.b[h],o.startColumn-1),g<this.b.length){const u=s.$6s.deleteBeginning(this.b[g],o.endColumn-1);this.b[h]=s.$6s.append(this.b[h],u),this.b.splice(h+1,g-h)}else this.b[h]=s.$6s.append(this.b[h],null),this.b=this.b.slice(0,h+1);else{const u=-h;this.a-=u,this.b[g]=s.$6s.deleteBeginning(this.b[g],o.endColumn-1),this.b=this.b.slice(g)}}}d(o,h,g){if(h===0&&g===0)return;const u=o.lineNumber-this.a;if(u<0){this.a+=h;return}if(!(u>=this.b.length)){if(h===0){this.b[u]=s.$6s.insert(this.b[u],o.column-1,g);return}this.b[u]=s.$6s.deleteEnding(this.b[u],o.column-1),this.b[u]=s.$6s.insert(this.b[u],o.column-1,g),this.e(o.lineNumber,h)}}e(o,h){if(h===0)return;const g=[];for(let u=0;u<h;u++)g[u]=null;this.b=C.$Wb(this.b,o,g)}}e.$8s=t}),define(q[16],K([0,1,12,28]),function(z,e,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GB=void 0;class y{static deserialize(s){let d=0;const t=(0,C.$fe)(s,d);d+=4;const r=[];for(let o=0;o<t;o++)d=k.$8s.deserialize(s,d,r);return r}constructor(){this.a=[]}add(s,d){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===s){t.appendLineTokens(d);return}}this.a.push(new k.$8s(s,[d]))}finalize(){return this.a}serialize(){const s=this.b(),d=new Uint8Array(s);return this.c(d),d}b(){let s=0;s+=4;for(let d=0;d<this.a.length;d++)s+=this.a[d].serializeSize();return s}c(s){let d=0;(0,C.$ge)(s,this.a.length,d),d+=4;for(let t=0;t<this.a.length;t++)d=this.a[t].serialize(s,d)}}e.$GB=y}),define(q[29],K([0,1,30,3,31,45]),function(z,e,C,k,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function s(f){return f===47||f===92}e.$Qf=s;function d(f){return f.replace(/[\\/]/g,C.$gc.sep)}e.$Rf=d;function t(f){return f.indexOf("/")===-1&&(f=d(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$Sf=t;function r(f,S=C.$gc.sep){if(!f)return"";const P=f.length,F=f.charCodeAt(0);if(s(F)){if(s(f.charCodeAt(1))&&!s(f.charCodeAt(2))){let b=3;const U=b;for(;b<P&&!s(f.charCodeAt(b));b++);if(U!==b&&!s(f.charCodeAt(b+1))){for(b+=1;b<P;b++)if(s(f.charCodeAt(b)))return f.slice(0,b+1).replace(/[\\/]/g,S)}}return S}else if(v(F)&&f.charCodeAt(1)===58)return s(f.charCodeAt(2))?f.slice(0,2)+S:f.slice(0,2);let I=f.indexOf("://");if(I!==-1){for(I+=3;I<P;I++)if(s(f.charCodeAt(I)))return f.slice(0,I+1)}return""}e.$Tf=r;function o(f){if(!k.$j||!f||f.length<5)return!1;let S=f.charCodeAt(0);if(S!==92||(S=f.charCodeAt(1),S!==92))return!1;let P=2;const F=P;for(;P<f.length&&(S=f.charCodeAt(P),S!==92);P++);return!(F===P||(S=f.charCodeAt(P+1),isNaN(S)||S===92))}e.$Uf=o;const h=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(f,S=k.$j){const P=S?h:g;return!(!f||f.length===0||/^\s+$/.test(f)||(P.lastIndex=0,P.test(f))||S&&u.test(f)||f==="."||f===".."||S&&f[f.length-1]==="."||S&&f.length!==f.trim().length||f.length>255)}e.$Vf=n;function i(f,S,P){const F=f===S;return!P||F?F:!f||!S?!1:(0,y.$2e)(f,S)}e.$Wf=i;function a(f,S,P,F=C.sep){if(f===S)return!0;if(!f||!S||S.length>f.length)return!1;if(P){if(!(0,y.$3e)(f,S))return!1;if(S.length===f.length)return!0;let b=S.length;return S.charAt(S.length-1)===F&&b--,f.charAt(b)===F}return S.charAt(S.length-1)!==F&&(S+=F),f.indexOf(S)===0}e.$Xf=a;function v(f){return f>=65&&f<=90||f>=97&&f<=122}e.$Yf=v;function A(f,S){return k.$j&&f.endsWith(":")&&(f+=C.sep),(0,C.$ic)(f)||(f=(0,C.$jc)(S,f)),f=(0,C.$hc)(f),k.$j?(f=(0,y.$Ke)(f,C.sep),f.endsWith(":")&&(f+=C.sep)):(f=(0,y.$Ke)(f,C.sep),f||(f=C.sep)),f}e.$Zf=A;function B(f){const S=(0,C.$hc)(f);return k.$j?f.length>3?!1:L(S)&&(f.length===2||S.charCodeAt(2)===92):S===C.$gc.sep}e.$1f=B;function L(f,S=k.$j){return S?v(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$2f=L;function T(f,S=k.$j){return L(f,S)?f[0]:void 0}e.$3f=T;function $(f,S,P){return S.length>f.length?-1:f===S?0:(P&&(f=f.toLowerCase(),S=S.toLowerCase()),f.indexOf(S))}e.$4f=$;function m(f){const S=f.split(":");let P,F,I;for(const b of S){const U=Number(b);(0,O.$Cf)(U)?F===void 0?F=U:I===void 0&&(I=U):P=P?[P,b].join(":"):b}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:F!==void 0?F:void 0,column:I!==void 0?I:F!==void 0?1:void 0}}e.$5f=m;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",w="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function M(f,S,P=8){let F="";for(let b=0;b<P;b++){let U;b===0&&k.$j&&!S&&(P===3||P===4)?U=w:U=c,F+=U.charAt(Math.floor(Math.random()*U.length))}let I;return S?I=`${S}-${F}`:I=F,f?(0,C.$jc)(f,I):I}e.$6f=M}),define(q[17],K([0,1,6,3,8]),function(z,e,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.Schemas=void 0;var O;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.vscodeManagedRemoteResource="vscode-managed-remote-resource",r.vscodeUserData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeInteractiveInput="vscode-interactive-input",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.vscodeChatSesssion="vscode-chat-editor",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp",r.vsls="vsls",r.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.$7f="vscode-tkn",e.$8f="tkn";class s{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(o){this.d=o}setDelegate(o){this.e=o}setServerRootPath(o){this.f=`${o}/${O.vscodeRemoteResource}`}set(o,h,g){this.a[o]=h,this.b[o]=g}setConnectionToken(o,h){this.c[o]=h}getPreferredWebSchema(){return this.d}rewrite(o){if(this.e)try{return this.e(o)}catch(a){return C.$1(a),o}const h=o.authority;let g=this.a[h];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const u=this.b[h],n=this.c[h];let i=`path=${encodeURIComponent(o.path)}`;return typeof n=="string"&&(i+=`&${e.$8f}=${encodeURIComponent(n)}`),y.URI.from({scheme:k.$p?this.d:O.vscodeRemoteResource,authority:`${g}:${u}`,path:this.f,query:i})}}e.$9f=new s,e.$0f="vs/../../extensions",e.$$f="vs/../../node_modules",e.$_f="vs/../../node_modules.asar",e.$ag="vs/../../node_modules.asar.unpacked",e.$bg="vscode-app";class d{static{this.a=e.$bg}asBrowserUri(o){const h=this.b(o,z);return this.uriToBrowserUri(h)}uriToBrowserUri(o){return o.scheme===O.vscodeRemote?e.$9f.rewrite(o):o.scheme===O.file&&(k.$n||k.$q&&k.$h.origin===`${O.vscodeFileResource}://${d.a}`)?o.with({scheme:O.vscodeFileResource,authority:o.authority||d.a,query:null,fragment:null}):o}asFileUri(o){const h=this.b(o,z);return this.uriToFileUri(h)}uriToFileUri(o){return o.scheme===O.vscodeFileResource?o.with({scheme:O.file,authority:o.authority!==d.a?o.authority:null,query:null,fragment:null}):o}b(o,h){return y.URI.isUri(o)?o:y.URI.parse(h.toUrl(o))}}e.$cg=new d;var t;(function(r){const o=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);r.CoopAndCoep=Object.freeze(o.get("3"));const h="vscode-coi";function g(n){let i;typeof n=="string"?i=new URL(n).searchParams:n instanceof URL?i=n.searchParams:y.URI.isUri(n)&&(i=new URL(n.toString(!0)).searchParams);const a=i?.get(h);if(a)return o.get(a)}r.getHeadersFromQuery=g;function u(n,i,a){if(!globalThis.crossOriginIsolated)return;const v=i&&a?"3":a?"2":"1";n instanceof URLSearchParams?n.set(h,v):n[h]=v}r.addSearchParam=u})(t||(e.COI=t={}))}),define(q[32],K([0,1,21,17,3,8]),function(z,e,C,k,y,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iC=void 0;class s{constructor(g,u,n){this.id=g,this.dependencies=u,this.callback=n}}class d{static{this.INSTANCE=new d}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,u,n)=>{typeof g!="string"&&(n=u,u=g,g=null),(typeof u!="object"||!Array.isArray(u))&&(n=u,u=null),this.c.push(new s(g,u,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const u=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!u)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}h(g){return new Promise((u,n)=>{const i=document.createElement("script");i.setAttribute("async","async"),i.setAttribute("type","text/javascript");const a=()=>{i.removeEventListener("load",v),i.removeEventListener("error",A)},v=B=>{a(),u(this.c.pop())},A=B=>{a(),n(B)};i.addEventListener("load",v),i.addEventListener("error",A),this.f&&(g=this.f.createScriptURL(g)),i.setAttribute("src",g),document.getElementsByTagName("head")[0].appendChild(i)})}i(g){return new Promise((u,n)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),u(this.c.pop())}catch(i){n(i)}})}async j(g){try{const u=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,i=globalThis._VSCODE_NODE_MODULES.module,a=O.URI.parse(g).fsPath,v=u.readFileSync(a).toString(),A=i.wrap(v.replace(/^#!.*/,""));return new n.Script(A).runInThisContext().apply(),this.c.pop()}catch(u){throw u}}}const t=new Map;let r={};typeof globalThis.require=="object"&&(r=globalThis.require.paths??{});async function o(h,g,u){if(C.$T){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),r[h]&&(h=r[h]);const n=`${h}/${g}`;if(t.has(n))return t.get(n);let i;if(/^\w[\w\d+.-]*:\/\//.test(n))i=n;else{const B=`${u&&!y.$p?k.$_f:k.$$f}/${n}`;i=k.$cg.asBrowserUri(B).toString(!0)}const a=d.INSTANCE.load(i);return t.set(n,a),a}else return await new Promise((n,i)=>{z([h],n,i)})}e.$iC=o}),define(q[18],K([0,1,29,17,30,3,31,8]),function(z,e,C,k,y,O,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fg=e.DataUri=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=void 0;function t(u){return(0,d.$wc)(u,!0)}e.$jg=t;class r{constructor(n){this.a=n}compare(n,i,a=!1){return n===i?0:(0,s.$Ue)(this.getComparisonKey(n,a),this.getComparisonKey(i,a))}isEqual(n,i,a=!1){return n===i?!0:!n||!i?!1:this.getComparisonKey(n,a)===this.getComparisonKey(i,a)}getComparisonKey(n,i=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,i,a=!1){if(n.scheme===i.scheme){if(n.scheme===k.Schemas.file)return C.$Xf(t(n),t(i),this.a(n))&&n.query===i.query&&(a||n.fragment===i.fragment);if((0,e.$Ag)(n.authority,i.authority))return C.$Xf(n.path,i.path,this.a(n),"/")&&n.query===i.query&&(a||n.fragment===i.fragment)}return!1}joinPath(n,...i){return d.URI.joinPath(n,...i)}basenameOrAuthority(n){return(0,e.$sg)(n)||n.authority}basename(n){return y.$gc.basename(n.path)}extname(n){return y.$gc.extname(n.path)}dirname(n){if(n.path.length===0)return n;let i;return n.scheme===k.Schemas.file?i=d.URI.file(y.$mc(t(n))).path:(i=y.$gc.dirname(n.path),n.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),i="/")),n.with({path:i})}normalizePath(n){if(!n.path.length)return n;let i;return n.scheme===k.Schemas.file?i=d.URI.file(y.$hc(t(n))).path:i=y.$gc.normalize(n.path),n.with({path:i})}relativePath(n,i){if(n.scheme!==i.scheme||!(0,e.$Ag)(n.authority,i.authority))return;if(n.scheme===k.Schemas.file){const A=y.$lc(t(n),t(i));return O.$j?C.$Rf(A):A}let a=n.path||"/";const v=i.path||"/";if(this.a(n)){let A=0;for(const B=Math.min(a.length,v.length);A<B&&!(a.charCodeAt(A)!==v.charCodeAt(A)&&a.charAt(A).toLowerCase()!==v.charAt(A).toLowerCase());A++);a=v.substr(0,A)+a.substr(A)}return y.$gc.relative(a,v)}resolvePath(n,i){if(n.scheme===k.Schemas.file){const a=d.URI.file(y.$kc(t(n),i));return n.with({authority:a.authority,path:a.path})}return i=C.$Sf(i),n.with({path:y.$gc.resolve(n.path,i)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,i){return n===i||n!==void 0&&i!==void 0&&(0,s.$2e)(n,i)}hasTrailingPathSeparator(n,i=y.sep){if(n.scheme===k.Schemas.file){const a=t(n);return a.length>C.$Tf(a).length&&a[a.length-1]===i}else{const a=n.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,i=y.sep){return(0,e.$Bg)(n,i)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,i=y.sep){let a=!1;if(n.scheme===k.Schemas.file){const v=t(n);a=v!==void 0&&v.length===C.$Tf(v).length&&v[v.length-1]===i}else{i="/";const v=n.path;a=v.length===1&&v.charCodeAt(v.length-1)===47}return!a&&!(0,e.$Bg)(n,i)?n.with({path:n.path+"/"}):n}}e.$kg=r,e.$lg=new r(()=>!1),e.$mg=new r(u=>u.scheme===k.Schemas.file?!O.$l:!0),e.$ng=new r(u=>!0),e.$og=e.$lg.isEqual.bind(e.$lg),e.$pg=e.$lg.isEqualOrParent.bind(e.$lg),e.$qg=e.$lg.getComparisonKey.bind(e.$lg),e.$rg=e.$lg.basenameOrAuthority.bind(e.$lg),e.$sg=e.$lg.basename.bind(e.$lg),e.$tg=e.$lg.extname.bind(e.$lg),e.$ug=e.$lg.dirname.bind(e.$lg),e.$vg=e.$lg.joinPath.bind(e.$lg),e.$wg=e.$lg.normalizePath.bind(e.$lg),e.$xg=e.$lg.relativePath.bind(e.$lg),e.$yg=e.$lg.resolvePath.bind(e.$lg),e.$zg=e.$lg.isAbsolutePath.bind(e.$lg),e.$Ag=e.$lg.isEqualAuthority.bind(e.$lg),e.$Bg=e.$lg.hasTrailingPathSeparator.bind(e.$lg),e.$Cg=e.$lg.removeTrailingPathSeparator.bind(e.$lg),e.$Dg=e.$lg.addTrailingPathSeparator.bind(e.$lg);function o(u,n){const i=[];for(let a=0;a<u.length;a++){const v=n(u[a]);u.some((A,B)=>B===a?!1:(0,e.$pg)(v,n(A)))||i.push(u[a])}return i}e.$Eg=o;var h;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function n(i){const a=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(B=>{const[L,T]=B.split(":");L&&T&&a.set(L,T)});const A=i.path.substring(0,i.path.indexOf(";"));return A&&a.set(u.META_DATA_MIME,A),a}u.parseMetaData=n})(h||(e.DataUri=h={}));function g(u,n,i){if(n){let a=u.path;return a&&a[0]!==y.$gc.sep&&(a=y.$gc.sep+a),u.with({scheme:i,authority:n,path:a})}return u.with({scheme:i})}e.$Fg=g}),define(q[19],K([0,1,46,6,33,2,18,3,24]),function(z,e,C,k,y,O,s,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fh=e.$eh=e.$dh=e.Promises=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=void 0;function r(j){return!!j&&typeof j.then=="function"}e.$Gg=r;function o(j){const l=new C.$Xd,E=j(l.token),N=new Promise((R,D)=>{const Y=l.token.onCancellationRequested(()=>{Y.dispose(),l.dispose(),D(new k.$5)});Promise.resolve(E).then(Q=>{Y.dispose(),l.dispose(),R(Q)},Q=>{Y.dispose(),l.dispose(),D(Q)})});return new class{cancel(){l.cancel()}then(R,D){return N.then(R,D)}catch(R){return this.then(void 0,R)}finally(R){return N.finally(R)}}}e.$Hg=o;function h(j,l,E){return new Promise((N,R)=>{const D=l.onCancellationRequested(()=>{D.dispose(),N(E)});j.then(N,R).finally(()=>D.dispose())})}e.$Ig=h;function g(j,l){return new Promise((E,N)=>{const R=l.onCancellationRequested(()=>{R.dispose(),N(new k.$5)});j.then(E,N).finally(()=>R.dispose())})}e.$Jg=g;async function u(j){let l=-1;const E=j.map((N,R)=>N.then(D=>(l=R,D)));try{return await Promise.race(E)}finally{j.forEach((N,R)=>{R!==l&&N.cancel()})}}e.$Kg=u;function n(j,l,E){let N;const R=setTimeout(()=>{N?.(void 0),E?.()},l);return Promise.race([j.finally(()=>clearTimeout(R)),new Promise(D=>N=D)])}e.$Lg=n;function i(j){return new Promise((l,E)=>{const N=j();r(N)?N.then(l,E):l(N)})}e.$Mg=i;class a{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(l){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=l,!this.b){const E=()=>{if(this.b=null,this.f)return;const N=this.queue(this.d);return this.d=null,N};this.b=new Promise(N=>{this.a.then(E,E).then(N)})}return new Promise((E,N)=>{this.b.then(E,N)})}return this.a=l(),new Promise((E,N)=>{this.a.then(R=>{this.a=null,E(R)},R=>{this.a=null,N(R)})})}dispose(){this.f=!0}}e.$Ng=a;class v{constructor(){this.a=Promise.resolve(null)}queue(l){return this.a=this.a.then(()=>l(),()=>l())}}e.$Og=v;class A{constructor(){this.a=new Map}queue(l,E){const R=(this.a.get(l)??Promise.resolve()).catch(()=>{}).then(E).finally(()=>{this.a.get(l)===R&&this.a.delete(l)});return this.a.set(l,R),R}}e.$Pg=A;const B=(j,l)=>{let E=!0;const N=setTimeout(()=>{E=!1,l()},j);return{isTriggered:()=>E,dispose:()=>{clearTimeout(N),E=!1}}},L=j=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,j())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class T{constructor(l){this.defaultDelay=l,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(l,E=this.defaultDelay){this.g=l,this.h(),this.b||(this.b=new Promise((R,D)=>{this.d=R,this.f=D}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const N=()=>{this.a=null,this.d?.(null)};return this.a=E===t.$Kd?L(N):B(E,N),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Qg=T;class ${constructor(l){this.a=new T(l),this.b=new a}trigger(l,E){return this.a.trigger(()=>this.b.queue(l),E)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Rg=$;class m{constructor(){this.a=!1,this.b=new Promise((l,E)=>{this.d=l})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Sg=m;class c extends m{constructor(l){super(),this.f=setTimeout(()=>this.open(),l)}open(){clearTimeout(this.f),super.open()}}e.$Tg=c;function w(j,l){return l?new Promise((E,N)=>{const R=setTimeout(()=>{D.dispose(),E()},j),D=l.onCancellationRequested(()=>{clearTimeout(R),D.dispose(),N(new k.$5)})}):o(E=>w(j,E))}e.$Ug=w;function M(j,l=0,E){const N=setTimeout(()=>{j(),E&&R.dispose()},l),R=(0,O.$Qc)(()=>{clearTimeout(N),E?.deleteAndLeak(R)});return E?.add(R),R}e.$Vg=M;function f(j){const l=[];let E=0;const N=j.length;function R(){return E<N?j[E++]():null}function D(Y){Y!=null&&l.push(Y);const Q=R();return Q?Q.then(D):Promise.resolve(l)}return Promise.resolve(null).then(D)}e.$Wg=f;function S(j,l=N=>!!N,E=null){let N=0;const R=j.length,D=()=>{if(N>=R)return Promise.resolve(E);const Y=j[N++];return Promise.resolve(Y()).then(J=>l(J)?Promise.resolve(J):D())};return D()}e.$Xg=S;function P(j,l=N=>!!N,E=null){if(j.length===0)return Promise.resolve(E);let N=j.length;const R=()=>{N=-1;for(const D of j)D.cancel?.()};return new Promise((D,Y)=>{for(const Q of j)Q.then(J=>{--N>=0&&l(J)?(R(),D(J)):N===0&&D(E)}).catch(J=>{--N>=0&&(R(),Y(J))})})}e.$Yg=P;class F{constructor(l){this.a=0,this.d=l,this.f=[],this.b=0,this.g=new y.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(l){return this.a++,new Promise((E,N)=>{this.f.push({factory:l,c:E,e:N}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const l=this.f.shift();this.b++;const E=l.factory();E.then(l.c,l.e),E.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Zg=F;class I extends F{constructor(){super(1)}}e.$1g=I;class b{constructor(){this.a=new x,this.b=0}queue(l){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,l())):this.a.run(this.b++,l())}}e.$2g=b;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const l=new te;return this.b.add(l),l.p}g(){for(const[,l]of this.a)if(l.size>0)return!1;return!0}queueFor(l,E=s.$lg){const N=E.getComparisonKey(l);let R=this.a.get(N);if(!R){R=new I;const D=this.f++,Y=y.Event.once(R.onDrained)(()=>{R?.dispose(),this.a.delete(N),this.h(),this.d?.deleteAndDispose(D),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$1c),this.d.set(D,Y),this.a.set(N,R)}return R}h(){this.g()&&this.j()}j(){for(const l of this.b)l.complete();this.b.clear()}dispose(){for(const[,l]of this.a)l.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$3g=U;class W{constructor(l,E){this.a=-1,typeof l=="function"&&typeof E=="number"&&this.setIfNotSet(l,E)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(l,E){this.cancel(),this.a=setTimeout(()=>{this.a=-1,l()},E)}setIfNotSet(l,E){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,l()},E))}}e.$4g=W;class G{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(l,E){this.cancel(),this.a=setInterval(()=>{l()},E)}}e.$5g=G;class V{constructor(l,E){this.b=-1,this.a=l,this.d=E,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(l=this.d){this.cancel(),this.b=setTimeout(this.f,l)}get delay(){return this.d}set delay(l){this.d=l}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$6g=V;class H{constructor(l,E){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.a=l,this.b=E,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(l=this.b){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(l/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$7g=H;class p extends V{constructor(l,E){super(l,E),this.j=[]}work(l){this.j.push(l),this.isScheduled()||this.schedule()}h(){const l=this.j;this.j=[],this.a?.(l)}dispose(){this.j=[],super.dispose()}}e.$8g=p;class _ extends O.$Sc{constructor(l,E){super(),this.g=l,this.h=E,this.a=[],this.b=this.B(new O.$Tc),this.f=!1}get pending(){return this.a.length}work(l){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+l.length>this.g.maxBufferedWork)return!1}else if(this.pending+l.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const E of l)this.a.push(E);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$9g=_,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$0g=j=>{(0,d.$B)(()=>{if(l)return;const E=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,E-Date.now())}}))});let l=!1;return{dispose(){l||(l=!0)}}}:e.$0g=(j,l)=>{const E=requestIdleCallback(j,typeof l=="number"?{timeout:l}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(E))}}}}();class X{constructor(l){this.d=!1,this.a=()=>{try{this.f=l()}catch(E){this.g=E}finally{this.d=!0}},this.b=(0,e.$0g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$$g=X;async function re(j,l,E){let N;for(let R=0;R<E;R++)try{return await j()}catch(D){N=D,await w(l)}throw N}e.$_g=re;class x{isRunning(l){return typeof l=="number"?this.a?.taskId===l:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(l,E,N){return this.a={taskId:l,cancel:()=>N?.(),promise:E},E.then(()=>this.d(l),()=>this.d(l)),E}d(l){this.a&&l===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const l=this.b;this.b=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}queue(l){if(this.b)this.b.run=l;else{let E,N;const R=new Promise((D,Y)=>{E=D,N=Y});this.b={run:l,promise:R,promiseResolve:E,promiseReject:N}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ah=x;class ae{constructor(l,E=()=>Date.now()){this.d=l,this.f=E,this.a=0,this.b=0}increment(){const l=this.f();return l-this.a>this.d&&(this.a=l,this.b=0),this.b++,this.b}}e.$bh=ae;var ee;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(ee||(ee={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((l,E)=>{this.a=l,this.b=E})}complete(l){return new Promise(E=>{this.a(l),this.d={outcome:0,value:l},E()})}error(l){return new Promise(E=>{this.b(l),this.d={outcome:1,value:l},E()})}cancel(){return this.error(new k.$5)}}e.$ch=te;var ne;(function(j){async function l(N){let R;const D=await Promise.all(N.map(Y=>Y.then(Q=>Q,Q=>{R||(R=Q)})));if(typeof R<"u")throw R;return D}j.settled=l;function E(N){return new Promise(async(R,D)=>{try{await N(R,D)}catch(Y){D(Y)}})}j.withAsyncBody=E})(ne||(e.Promises=ne={}));var ie;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(ie||(ie={}));class Z{static fromArray(l){return new Z(E=>{E.emitMany(l)})}static fromPromise(l){return new Z(async E=>{E.emitMany(await l)})}static fromPromises(l){return new Z(async E=>{await Promise.all(l.map(async N=>E.emitOne(await N)))})}static merge(l){return new Z(async E=>{await Promise.all(l.map(async N=>{for await(const R of N)E.emitOne(R)}))})}static{this.EMPTY=Z.fromArray([])}constructor(l){this.a=0,this.b=[],this.d=null,this.f=new y.$Nd,queueMicrotask(async()=>{const E={emitOne:N=>this.g(N),emitMany:N=>this.h(N),reject:N=>this.k(N)};try{await Promise.resolve(l(E)),this.j()}catch(N){this.k(N)}finally{E.emitOne=void 0,E.emitMany=void 0,E.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(l<this.b.length)return{done:!1,value:this.b[l++]};if(this.a===1)return{done:!0,value:void 0};await y.Event.toPromise(this.f.event)}while(!0)}}}static map(l,E){return new Z(async N=>{for await(const R of l)N.emitOne(E(R))})}map(l){return Z.map(this,l)}static filter(l,E){return new Z(async N=>{for await(const R of l)E(R)&&N.emitOne(R)})}filter(l){return Z.filter(this,l)}static coalesce(l){return Z.filter(l,E=>!!E)}coalesce(){return Z.coalesce(this)}static async toPromise(l){const E=[];for await(const N of l)E.push(N);return E}toPromise(){return Z.toPromise(this)}g(l){this.a===0&&(this.b.push(l),this.f.fire())}h(l){this.a===0&&(this.b=this.b.concat(l),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(l){this.a===0&&(this.a=2,this.d=l,this.f.fire())}}e.$dh=Z;class se extends Z{constructor(l,E){super(E),this.l=l}cancel(){this.l.cancel()}}e.$eh=se;function he(j){const l=new C.$Xd,E=j(l.token);return new se(l,async N=>{const R=l.token.onCancellationRequested(()=>{R.dispose(),l.dispose(),N.reject(new k.$5)});try{for await(const D of E){if(l.token.isCancellationRequested)return;N.emitOne(D)}R.dispose(),l.dispose()}catch(D){R.dispose(),l.dispose(),N.reject(D)}})}e.$fh=he}),define(q[20],K([0,1,34]),function(z,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EB=e.$DB=e.$CB=void 0,e.$CB=new class{clone(){return this}equals(O){return this===O}};function k(O,s){return new C.$$s([new C.$0s(0,"",O)],s)}e.$DB=k;function y(O,s){const d=new Uint32Array(2);return d[0]=0,d[1]=(O<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new C.$_s(d,s===null?e.$CB:s)}e.$EB=y}),define(q[35],K([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(z,e,C,k,y,O,s,d,t,r,o,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MB=e.$LB=e.$KB=e.$JB=e.$IB=e.$HB=void 0;var u;(function(T){T[T.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(u||(u={}));class n{constructor($,m){this.tokenizationSupport=m,this.a=this.tokenizationSupport.getInitialState(),this.store=new a($)}getStartState($){return this.store.getStartState($,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$HB=n;class i extends n{constructor($,m,c,w){super($,m),this._textModel=c,this._languageIdCodec=w}updateTokensUntilLine($,m){const c=this._textModel.getLanguageId();for(;;){const w=this.getFirstInvalidLine();if(!w||w.lineNumber>m)break;const M=this._textModel.getLineContent(w.lineNumber),f=B(this._languageIdCodec,c,this.tokenizationSupport,M,!0,w.startState);$.add(w.lineNumber,f.tokens),this.store.setEndState(w.lineNumber,f.endState)}}getTokenTypeIfInsertingCharacter($,m){const c=this.getStartState($.lineNumber);if(!c)return 0;const w=this._textModel.getLanguageId(),M=this._textModel.getLineContent($.lineNumber),f=M.substring(0,$.column-1)+m+M.substring($.column-1),S=B(this._languageIdCodec,w,this.tokenizationSupport,f,!0,c),P=new g.$4s(S.tokens,f,this._languageIdCodec);if(P.getCount()===0)return 0;const F=P.findTokenIndexAtOffset($.column-1);return P.getStandardTokenType(F)}tokenizeLineWithEdit($,m,c){const w=$.lineNumber,M=$.column,f=this.getStartState(w);if(!f)return null;const S=this._textModel.getLineContent(w),P=S.substring(0,M-1)+c+S.substring(M-1+m),F=this._textModel.getLanguageIdAtPosition(w,0),I=B(this._languageIdCodec,F,this.tokenizationSupport,P,!0,f);return new g.$4s(I.tokens,P,this._languageIdCodec)}isCheapToTokenize($){const m=this.store.getFirstInvalidEndStateLineNumberOrMax();return $<m||$===m&&this._textModel.getLineLength($)<2048}tokenizeHeuristically($,m,c){if(c<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine($,c),{heuristicTokens:!1};let w=this.b(m);const M=this._textModel.getLanguageId();for(let f=m;f<=c;f++){const S=this._textModel.getLineContent(f),P=B(this._languageIdCodec,M,this.tokenizationSupport,S,!0,w);$.add(f,P.tokens),w=P.endState}return{heuristicTokens:!0}}b($){let m=this._textModel.getLineFirstNonWhitespaceColumn($);const c=[];let w=null;for(let S=$-1;m>1&&S>=1;S--){const P=this._textModel.getLineFirstNonWhitespaceColumn(S);if(P!==0&&P<m&&(c.push(this._textModel.getLineContent(S)),m=P,w=this.getStartState(S),w))break}w||(w=this.tokenizationSupport.getInitialState()),c.reverse();const M=this._textModel.getLanguageId();let f=w;for(const S of c)f=B(this._languageIdCodec,M,this.tokenizationSupport,S,!1,f).endState;return f}}e.$IB=i;class a{constructor($){this.d=$,this.a=new v,this.b=new A,this.b.addRange(new t.$xs(1,$+1))}getEndState($){return this.a.getEndState($)}setEndState($,m){if(!m)throw new k.$cb("Cannot set null/undefined state");this.b.delete($);const c=this.a.setEndState($,m);return c&&$<this.d&&this.b.addRange(new t.$xs($+1,$+2)),c}acceptChange($,m){this.d+=m-$.length,this.a.acceptChange($,m),this.b.addRangeAndResize(new t.$xs($.startLineNumber,$.endLineNumberExclusive),m)}acceptChanges($){for(const m of $){const[c]=(0,s.$3s)(m.text);this.acceptChange(new d.$zs(m.range.startLineNumber,m.range.endLineNumber+1),c+1)}}invalidateEndStateRange($){this.b.addRange(new t.$xs($.startLineNumber,$.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState($,m){return $===1?m:this.getEndState($-1)}getFirstInvalidLine($){const m=this.getFirstInvalidEndStateLineNumber();if(m===null)return null;const c=this.getStartState(m,$);if(!c)throw new k.$cb("Start state must be defined");return{lineNumber:m,startState:c}}}e.$JB=a;class v{constructor(){this.a=new o.$FB(null)}getEndState($){return this.a.get($)}setEndState($,m){const c=this.a.get($);return c&&c.equals(m)?!1:(this.a.set($,m),!0)}acceptChange($,m){let c=$.length;m>0&&c>0&&(c--,m--),this.a.replace($.startLineNumber,c,m)}acceptChanges($){for(const m of $){const[c]=(0,s.$3s)(m.text);this.acceptChange(new d.$zs(m.range.startLineNumber,m.range.endLineNumber+1),c+1)}}}e.$KB=v;class A{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const $=this.a[0];return $.start+1===$.endExclusive?this.a.shift():this.a[0]=new t.$xs($.start+1,$.endExclusive),$.start}delete($){const m=this.a.findIndex(c=>c.contains($));if(m!==-1){const c=this.a[m];c.start===$?c.endExclusive===$+1?this.a.splice(m,1):this.a[m]=new t.$xs($+1,c.endExclusive):c.endExclusive===$+1?this.a[m]=new t.$xs(c.start,$):this.a.splice(m,1,new t.$xs(c.start,$),new t.$xs($+1,c.endExclusive))}}addRange($){t.$xs.addRange($,this.a)}addRangeAndResize($,m){let c=0;for(;!(c>=this.a.length||$.start<=this.a[c].endExclusive);)c++;let w=c;for(;!(w>=this.a.length||$.endExclusive<this.a[w].start);)w++;const M=m-$.length;for(let f=w;f<this.a.length;f++)this.a[f]=this.a[f].delta(M);if(c===w){const f=new t.$xs($.start,$.start+m);f.isEmpty||this.a.splice(c,0,f)}else{const f=Math.min($.start,this.a[c].start),S=Math.max($.endExclusive,this.a[w-1].endExclusive),P=new t.$xs(f,S+M);P.isEmpty?this.a.splice(c,w-c):this.a.splice(c,w-c,P)}}toString(){return this.a.map($=>$.toString()).join(" + ")}}e.$LB=A;function B(T,$,m,c,w,M){let f=null;if(m)try{f=m.tokenizeEncoded(c,w,M.clone())}catch(S){(0,k.$1)(S)}return f||(f=(0,r.$EB)(T.encodeLanguageId($),M)),g.$4s.convertToEndOffset(f.tokens,c.length),f}class L{constructor($,m){this.b=$,this.d=m,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,C.$0g)($=>{this.f=!1,this.h($)}))}h($){const m=Date.now()+$.timeRemaining(),c=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<m?(0,y.$B)(c):this.g())};c()}j(){const $=this.b._textModel.getLineCount(),m=new h.$GB,c=O.$Jd.create(!1);do if(c.elapsed()>1||this.l(m)>=$)break;while(this.k());this.d.setTokens(m.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l($){const m=this.b?.getFirstInvalidLine();return m?(this.b.updateTokensUntilLine($,m.lineNumber),m.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens($,m){this.b.store.invalidateEndStateRange(new d.$zs($,m))}}e.$MB=L}),define(q[37],K([0,1,33,2,36,14,34]),function(z,e,C,k,y,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kEb=void 0;class d extends k.$Sc{constructor(r,o,h,g,u,n,i){super(),this.c=r,this.f=o,this.g=h,this.h=g,this.j=u,this.m=n,this.n=i,this.a=[],this.b=this.B(new C.$Nd),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(r,o,h){throw new Error("Not supported!")}createBackgroundTokenizer(r,o){if(this.h)return this.h(r,o)}tokenizeEncoded(r,o,h){const g=Math.random()*1e4<1,u=this.n||g,n=u?new y.$Jd(!0):void 0,i=this.c.tokenizeLine2(r,h,500);if(u){const v=n.elapsed();(g||v>32)&&this.m(v,r.length,g)}if(i.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${r.substring(0,100)}`),new s.$_s(i.tokens,h);if(this.g){const v=this.a,A=i.tokens;for(let B=0,L=A.length>>>1;B<L;B++){const T=A[(B<<1)+1],$=O.$1s.getLanguageId(T);v[$]||(v[$]=!0,this.b.fire($))}}let a;return h.equals(i.ruleStack)?a=h:a=i.ruleStack,new s.$_s(i.tokens,a)}}e.$kEb=d}),define(q[38],K([0,1,20,2,11]),function(z,e,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lEb=void 0;class O extends k.$Sc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(d,t,r){super(),this.a=d,this.b=t,this.c=r,this.B((0,y.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(d,t,r){throw new Error("Not supported!")}tokenizeEncoded(d,t,r){return d.length>=this.c.get()?(0,C.$EB)(this.a,r):this.b.tokenizeEncoded(d,t,r)}createBackgroundTokenizer(d,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(d,t)}}e.$lEb=O}),define(q[39],K([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(z,e,C,k,y,O,s,d,t,r,o,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qEb=void 0;class u extends d.$Su{constructor(a,v,A,B,L,T,$,m){super(a,v,A,B),this.s=L,this.t=T,this.u=$,this.a=null,this.b=!1,this.c=(0,y.observableValue)(this,-1),this.q=new k.$6g(()=>this.w(),10),this.c.set(m,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(a,v){this.t=a,this.u=v,this.v()}onEvents(a){super.onEvents(a),this.a?.store.acceptChanges(a.changes),this.q.schedule()}acceptMaxTokenizationLineLength(a){this.c.set(a,void 0)}retokenize(a,v){this.a&&(this.a.store.invalidateEndStateRange(new s.$zs(a,v)),this.q.schedule())}async v(){this.a=null;const a=this.t,v=this.u,A=await this.s.getOrCreateGrammar(a,v);if(!(this.b||a!==this.t||v!==this.u||!A)){if(A.grammar){const B=new g.$lEb(this.u,new h.$kEb(A.grammar,A.initialState,!1,void 0,()=>!1,(L,T,$)=>{this.s.reportTokenizationTime(L,a,A.sourceExtensionId,T,$)},!1),this.c);this.a=new t.$HB(this.f.length,B)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:v}=await(0,C.$iC)("vscode-textmate","release/main.js");this.m=v}const a=new Date().getTime();for(;;){let v=0;const A=new r.$GB,B=new n;for(;;){const $=this.a.getFirstInvalidLine();if($===null||v>200)break;v++;const m=this.f[$.lineNumber-1],c=this.a.tokenizationSupport.tokenizeEncoded(m,!0,$.startState);if(this.a.store.setEndState($.lineNumber,c.endState)){const M=this.m($.startState,c.endState);B.setState($.lineNumber,M)}else B.setState($.lineNumber,null);if(o.$4s.convertToEndOffset(c.tokens,m.length),A.add($.lineNumber,c.tokens),new Date().getTime()-a>20)break}if(v===0)break;const L=B.getStateDeltas();if(this.s.setTokensAndStates(this.h,A.serialize(),L),new Date().getTime()-a>20){(0,O.$B)(()=>this.w());return}}}}e.$qEb=u;class n{constructor(){this.a=-1,this.b=[]}setState(a,v){a===this.a+1?this.b[this.b.length-1].stateDeltas.push(v):this.b.push({startLineNumber:a,stateDeltas:[v]}),this.a=a}getStateDeltas(){return this.b}}}),define(q[40],K([0,1,18]),function(z,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nEb=void 0;class k{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(O){if(this.a[O.scopeName]){const s=this.a[O.scopeName];C.$og(s.location,O.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${O.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${O.location.toString()}`)}this.a[O.scopeName]=O}getGrammarDefinition(O){return this.a[O]||null}}e.$nEb=k}),define(q[41],K([0,1,2,40]),function(z,e,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pEb=e.$oEb=void 0,e.$oEb="No TM Grammar registered for this language.";class y extends C.$Sc{constructor(s,d,t,r){super(),this.a=s,this.b=t.INITIAL,this.c=new k.$nEb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:r,loadGrammar:async o=>{const h=this.c.getGrammarDefinition(o);if(!h)return this.a.logTrace(`No grammar found for scope ${o}`),null;const g=h.location;try{const u=await this.a.readFile(g);return t.parseRawGrammar(u,g.path)}catch(u){return this.a.logError(`Unable to load and parse grammar for scope ${o} from ${g}`,u),null}},getInjections:o=>{const h=o.split(".");let g=[];for(let u=1;u<=h.length;u++){const n=h.slice(0,u).join(".");g=[...g,...this.f[n]||[]]}return g}}));for(const o of d){if(this.c.register(o),o.injectTo){for(const h of o.injectTo){let g=this.f[h];g||(this.f[h]=g=[]),g.push(o.scopeName)}if(o.embeddedLanguages)for(const h of o.injectTo){let g=this.g[h];g||(this.g[h]=g=[]),g.push(o.embeddedLanguages)}}o.language&&this.h.set(o.language,o.scopeName)}}has(s){return this.h.has(s)}setTheme(s,d){this.j.setTheme(s,d)}getColorMap(){return this.j.getColorMap()}async createGrammar(s,d){const t=this.h.get(s);if(typeof t!="string")throw new Error(e.$oEb);const r=this.c.getGrammarDefinition(t);if(!r)throw new Error(e.$oEb);const o=r.embeddedLanguages;if(this.g[t]){const u=this.g[t];for(const n of u)for(const i of Object.keys(n))o[i]=n[i]}const h=Object.keys(o).length>0;let g;try{g=await this.j.loadGrammarWithConfiguration(t,d,{embeddedLanguages:o,tokenTypes:r.tokenTypes,balancedBracketSelectors:r.balancedBracketSelectors,unbalancedBracketSelectors:r.unbalancedBracketSelectors})}catch(u){throw u.message&&u.message.startsWith("No grammar provided for")?new Error(e.$oEb):u}return{languageId:s,grammar:g,initialState:this.b,containsEmbeddedLanguages:h,sourceExtensionId:r.sourceExtensionId}}}e.$pEb=y}),define(q[49],K([0,1,8,41,39]),function(z,e,C,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function O(d,t){return new s(d,t)}e.create=O;class s{constructor(t,r){this.f=r,this.b=new Map,this.c=[],this.a=t.host;const o=r.grammarDefinitions.map(h=>({location:C.URI.revive(h.location),language:h.language,scopeName:h.scopeName,embeddedLanguages:h.embeddedLanguages,tokenTypes:h.tokenTypes,injectTo:h.injectTo,balancedBracketSelectors:h.balancedBracketSelectors,unbalancedBracketSelectors:h.unbalancedBracketSelectors,sourceExtensionId:h.sourceExtensionId}));this.d=this.g(o)}async g(t){const r=this.f.textmateMainUri,o=await new Promise((i,a)=>{z([r],i,a)}),h=await new Promise((i,a)=>{z([this.f.onigurumaMainUri],i,a)}),u=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await h.loadWASM(u);const n=Promise.resolve({createOnigScanner:i=>h.createOnigScanner(i),createOnigString:i=>h.createOnigString(i)});return new k.$pEb({logTrace:i=>{},logError:(i,a)=>console.error(i,a),readFile:i=>this.a.readFile(i)},t,o,n)}acceptNewModel(t){const r=C.URI.revive(t.uri),o=this;this.b.set(t.controllerId,new y.$qEb(r,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(h,g){const u=await o.d;return u?(o.c[g]||(o.c[g]=u.createGrammar(h,g)),o.c[g]):Promise.resolve(null)},setTokensAndStates(h,g,u){o.a.setTokensAndStates(t.controllerId,h,g,u)},reportTokenizationTime(h,g,u,n,i){o.a.reportTokenizationTime(h,g,u,n,i)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,r){this.b.get(t).onEvents(r)}retokenize(t,r,o){this.b.get(t).retokenize(r,o)}acceptModelLanguageChanged(t,r,o){this.b.get(t).onLanguageId(r,o)}acceptRemovedModel(t){const r=this.b.get(t);r&&(r.dispose(),this.b.delete(t))}async acceptTheme(t,r){(await this.d)?.setTheme(t,r)}acceptMaxTokenizationLineLength(t,r){this.b.get(t).acceptMaxTokenizationLineLength(r)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9bb94efbe279580856897b63cc9417a3e875e405/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
